/*===========================================================================*/
/*   (Engine/heap.scm)                                                       */
/*   Bigloo (4.0a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jan 24 17:03:30 CET 2013        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/4.0a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Engine/heap.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
		bool_t BgL_boundzd2checkzd2;
		bool_t BgL_typezd2checkzd2;
		bool_t BgL_typedzd2funcallzd2;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_tclassz00_bgl
	{
		obj_t BgL_itszd2superzd2;
		obj_t BgL_slotsz00;
		struct BgL_globalz00_bgl *BgL_holderz00;
		obj_t BgL_wideningz00;
		long BgL_depthz00;
		bool_t BgL_finalzf3zf3;
		obj_t BgL_constructorz00;
		obj_t BgL_virtualzd2slotszd2numberz00;
		bool_t BgL_abstractzf3zf3;
		obj_t BgL_widezd2typezd2;
	}                *BgL_tclassz00_bglt;


	extern obj_t BGl_initializa7ezd2Tenvz12z67zztype_envz00();
	extern obj_t BGl_setzd2genvz12zc0zzast_envz00(obj_t);
	extern obj_t BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00(obj_t);
	BGL_IMPORT obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t,
		obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzengine_heapz00 = BUNSPEC;
	static obj_t BGl_dumpzd2Genvzd2zzengine_heapz00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_dumpzd2heapszd2zzengine_heapz00(obj_t);
	BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
	extern obj_t BGl_tclassz00zzobject_classz00;
	extern obj_t BGl_za2targetzd2languageza2zd2zzengine_paramz00;
	extern obj_t BGl_sfunz00zzast_varz00;
	extern obj_t BGl_setzd2backendz12zc0zzbackend_backendz00(obj_t);
	static obj_t BGl_z62dumpzd2heapszb0zzengine_heapz00(obj_t, obj_t);
	extern obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31610ze3ze1zzengine_heapz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t input_obj(obj_t);
	static obj_t BGl_genericzd2initzd2zzengine_heapz00();
	static obj_t BGl_objectzd2initzd2zzengine_heapz00();
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	extern obj_t BGl_addzd2genvz12zc0zzast_envz00(obj_t);
	BGL_IMPORT obj_t BGl_valzd2fromzd2exitzf3zf3zz__bexitz00(obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2binaryzd2filezd2zz__binaryz00(obj_t);
	static obj_t BGl_z62zc3anonymousza31541ze3ze1zzengine_heapz00(obj_t, obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl_dumpzd2Tenvzd2zzengine_heapz00(obj_t);
	static obj_t BGl_methodzd2initzd2zzengine_heapz00();
	extern obj_t BGl_initializa7ezd2Genvz12z67zzast_envz00();
	BGL_IMPORT obj_t close_binary_port(obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31582ze3ze1zzengine_heapz00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzengine_heapz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_pragmaz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzheap_restorez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzread_jvmz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__binaryz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__hashz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(obj_t,
		obj_t);
	extern obj_t BGl_cfunz00zzast_varz00;
	BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31559ze3ze1zzengine_heapz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_setzd2tenvz12zc0zztype_envz00(obj_t);
	extern obj_t BGl_za2libzd2dirza2zd2zzengine_paramz00;
	static obj_t BGl_zc3exitza31527ze3z83zzengine_heapz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31747ze3ze1zzengine_heapz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_cnstzd2initzd2zzengine_heapz00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzengine_heapz00();
	static obj_t BGl_importedzd2moduleszd2initz00zzengine_heapz00();
	BGL_IMPORT obj_t BGl_hashtablezd2forzd2eachz00zz__hashz00(obj_t, obj_t);
	static obj_t BGl_dumpzd2heapzd2zzengine_heapz00(obj_t);
	BGL_IMPORT obj_t BGl_findzd2filezf2pathz20zz__osz00(obj_t, obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	extern obj_t BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_heapzd2modulezd2listz00zzheap_restorez00(obj_t);
	static obj_t __cnst[14];


	   
		 
		DEFINE_STRING(BGl_string1900z00zzengine_heapz00,
		BgL_bgl_string1900za700za7za7e1903za7,
		"type class super jvm-type-name inline sifun qualified-type name module id variable native function dump-heap ",
		109);
	      DEFINE_STRING(BGl_string1882z00zzengine_heapz00,
		BgL_bgl_string1882za700za7za7e1904za7, "Cannot open heap file ~s", 24);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_dumpzd2heapszd2envz00zzengine_heapz00,
		BgL_bgl_za762dumpza7d2heapsza71905za7,
		BGl_z62dumpzd2heapszb0zzengine_heapz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string1883z00zzengine_heapz00,
		BgL_bgl_string1883za700za7za7e1906za7, "Corrupted heap", 14);
	      DEFINE_STRING(BGl_string1886z00zzengine_heapz00,
		BgL_bgl_string1886za700za7za7e1907za7, "(heap \"", 7);
	      DEFINE_STRING(BGl_string1887z00zzengine_heapz00,
		BgL_bgl_string1887za700za7za7e1908za7, "\"", 1);
	      DEFINE_STRING(BGl_string1888z00zzengine_heapz00,
		BgL_bgl_string1888za700za7za7e1909za7, " (variables", 11);
	      DEFINE_STRING(BGl_string1889z00zzengine_heapz00,
		BgL_bgl_string1889za700za7za7e1910za7, " )\n", 3);
	      DEFINE_STRING(BGl_string1890z00zzengine_heapz00,
		BgL_bgl_string1890za700za7za7e1911za7, " (types", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1884z00zzengine_heapz00,
		BgL_bgl_za762za7c3anonymousza71912za7,
		BGl_z62zc3anonymousza31541ze3ze1zzengine_heapz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string1891z00zzengine_heapz00,
		BgL_bgl_string1891za700za7za7e1913za7, " )", 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1885z00zzengine_heapz00,
		BgL_bgl_za762za7c3anonymousza71914za7,
		BGl_z62zc3anonymousza31559ze3ze1zzengine_heapz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string1892z00zzengine_heapz00,
		BgL_bgl_string1892za700za7za7e1915za7, " (includes", 10);
	      DEFINE_STRING(BGl_string1893z00zzengine_heapz00,
		BgL_bgl_string1893za700za7za7e1916za7, ")\n", 2);
	      DEFINE_STRING(BGl_string1895z00zzengine_heapz00,
		BgL_bgl_string1895za700za7za7e1917za7, "   ", 3);
	      DEFINE_STRING(BGl_string1896z00zzengine_heapz00,
		BgL_bgl_string1896za700za7za7e1918za7, "\n    ", 5);
	      DEFINE_STRING(BGl_string1897z00zzengine_heapz00,
		BgL_bgl_string1897za700za7za7e1919za7, "", 0);
	      DEFINE_STRING(BGl_string1899z00zzengine_heapz00,
		BgL_bgl_string1899za700za7za7e1920za7, "engine_heap", 11);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1894z00zzengine_heapz00,
		BgL_bgl_za762za7c3anonymousza71921za7,
		BGl_z62zc3anonymousza31610ze3ze1zzengine_heapz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1898z00zzengine_heapz00,
		BgL_bgl_za762za7c3anonymousza71922za7,
		BGl_z62zc3anonymousza31747ze3ze1zzengine_heapz00, 0L, BUNSPEC, 2);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzengine_heapz00(long
		BgL_checksumz00_1565, char *BgL_fromz00_1566)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzengine_heapz00))
				{
					BGl_requirezd2initializa7ationz75zzengine_heapz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzengine_heapz00();
					BGl_cnstzd2initzd2zzengine_heapz00();
					BGl_importedzd2moduleszd2initz00zzengine_heapz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzengine_heapz00()
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 15 */
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"engine_heap");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"engine_heap");
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__binaryz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"engine_heap");
			BGl_modulezd2initializa7ationz75zz__hashz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"engine_heap");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"engine_heap");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"engine_heap");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzengine_heapz00()
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 15 */
			{	/* Engine/heap.scm 15 */
				obj_t BgL_cportz00_1557;

				BgL_cportz00_1557 =
					bgl_open_input_string(BGl_string1900z00zzengine_heapz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_1558;

					BgL_iz00_1558 = ((long) 13);
				BgL_loopz00_1559:
					if ((BgL_iz00_1558 == ((long) -1)))
						{	/* Engine/heap.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Engine/heap.scm 15 */
							{	/* Engine/heap.scm 15 */
								obj_t BgL_arg1902z00_1561;

								{	/* Engine/heap.scm 15 */

									{	/* Engine/heap.scm 15 */
										obj_t BgL_locationz00_1563;

										BgL_locationz00_1563 = BBOOL(((bool_t) 0));
										{	/* Engine/heap.scm 15 */

											BgL_arg1902z00_1561 =
												BGl_readz00zz__readerz00(BgL_cportz00_1557,
												BgL_locationz00_1563);
										}
									}
								}
								{	/* Engine/heap.scm 15 */
									int BgL_auxz00_1592;

									BgL_auxz00_1592 = (int) (BgL_iz00_1558);
									CNST_TABLE_SET(BgL_auxz00_1592, BgL_arg1902z00_1561);
							}}
							{	/* Engine/heap.scm 15 */
								int BgL_auxz00_1564;

								BgL_auxz00_1564 = (int) ((BgL_iz00_1558 - ((long) 1)));
								{
									long BgL_iz00_1597;

									BgL_iz00_1597 = (long) (BgL_auxz00_1564);
									BgL_iz00_1558 = BgL_iz00_1597;
									goto BgL_loopz00_1559;
								}
							}
						}
				}
			}
		}
	}



/* dump-heaps */
	BGL_EXPORTED_DEF obj_t BGl_dumpzd2heapszd2zzengine_heapz00(obj_t
		BgL_namesz00_3)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 33 */
			BGl_setzd2backendz12zc0zzbackend_backendz00
				(BGl_za2targetzd2languageza2zd2zzengine_paramz00);
			BGl_initializa7ezd2Genvz12z67zzast_envz00();
			BGl_initializa7ezd2Tenvz12z67zztype_envz00();
			{
				obj_t BgL_l1473z00_733;

				{	/* Engine/heap.scm 40 */
					bool_t BgL_auxz00_1602;

					BgL_l1473z00_733 = BgL_namesz00_3;
				BgL_zc3anonymousza31508ze3z83_734:
					if (PAIRP(BgL_l1473z00_733))
						{	/* Engine/heap.scm 40 */
							BGl_dumpzd2heapzd2zzengine_heapz00(CAR(BgL_l1473z00_733));
							{
								obj_t BgL_l1473z00_1607;

								BgL_l1473z00_1607 = CDR(BgL_l1473z00_733);
								BgL_l1473z00_733 = BgL_l1473z00_1607;
								goto BgL_zc3anonymousza31508ze3z83_734;
							}
						}
					else
						{	/* Engine/heap.scm 40 */
							BgL_auxz00_1602 = ((bool_t) 1);
						}
					return BBOOL(BgL_auxz00_1602);
				}
			}
		}
	}



/* &dump-heaps */
	obj_t BGl_z62dumpzd2heapszb0zzengine_heapz00(obj_t BgL_envz00_1531,
		obj_t BgL_namesz00_1532)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 33 */
			return BGl_dumpzd2heapszd2zzengine_heapz00(BgL_namesz00_1532);
		}
	}



/* dump-heap */
	obj_t BGl_dumpzd2heapzd2zzengine_heapz00(obj_t BgL_heapz00_4)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 45 */
			{	/* Engine/heap.scm 46 */
				obj_t BgL_fnamez00_739;

				BgL_fnamez00_739 =
					BGl_findzd2filezf2pathz20zz__osz00(BgL_heapz00_4,
					BGl_za2libzd2dirza2zd2zzengine_paramz00);
				if (STRINGP(BgL_fnamez00_739))
					{	/* Engine/heap.scm 48 */
						obj_t BgL_portz00_741;

						BgL_portz00_741 =
							BGl_openzd2inputzd2binaryzd2filezd2zz__binaryz00
							(BgL_fnamez00_739);
						if (BINARY_PORTP(BgL_portz00_741))
							{	/* Engine/heap.scm 53 */
								obj_t BgL_val1063z00_743;

								BgL_val1063z00_743 =
									BGl_zc3exitza31527ze3z83zzengine_heapz00(BgL_heapz00_4,
									BgL_portz00_741);
								close_binary_port(BgL_portz00_741);
								if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
										(BgL_val1063z00_743)))
									{	/* Engine/heap.scm 113 */
										return
											BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
											(BgL_val1063z00_743), CDR(BgL_val1063z00_743));
									}
								else
									{	/* Engine/heap.scm 113 */
										return BgL_val1063z00_743;
									}
							}
						else
							{	/* Engine/heap.scm 51 */
								obj_t BgL_arg1602z00_808;

								{	/* Engine/heap.scm 51 */
									obj_t BgL_list1603z00_809;

									BgL_list1603z00_809 = MAKE_PAIR(BgL_fnamez00_739, BNIL);
									BgL_arg1602z00_808 =
										BGl_formatz00zz__r4_output_6_10_3z00
										(BGl_string1882z00zzengine_heapz00, BgL_list1603z00_809);
								}
								return
									BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 0)),
									BgL_arg1602z00_808, BGl_za2libzd2dirza2zd2zzengine_paramz00);
					}}
				else
					{	/* Engine/heap.scm 114 */
						obj_t BgL_mz00_810;

						{	/* Engine/heap.scm 114 */
							obj_t BgL_list1604z00_811;

							BgL_list1604z00_811 = MAKE_PAIR(BgL_heapz00_4, BNIL);
							BgL_mz00_810 =
								BGl_formatz00zz__r4_output_6_10_3z00
								(BGl_string1882z00zzengine_heapz00, BgL_list1604z00_811);
						}
						BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 0)), BgL_mz00_810,
							BGl_za2libzd2dirza2zd2zzengine_paramz00);
						return BFALSE;
					}
			}
		}
	}



/* <exit:1527> */
	obj_t BGl_zc3exitza31527ze3z83zzengine_heapz00(obj_t BgL_heapz00_1555,
		obj_t BgL_portz00_1554)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 113 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1064z00_748;

			if (SET_EXIT(BgL_an_exit1064z00_748))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1064z00_748 = (void *) jmpbuf;
					{	/* Engine/heap.scm 113 */

						PUSH_EXIT(BgL_an_exit1064z00_748, ((long) 0));
						{	/* Engine/heap.scm 54 */
							obj_t BgL_val1065z00_749;

							{	/* Engine/heap.scm 54 */
								obj_t BgL_envsz00_750;

								BgL_envsz00_750 = input_obj(BgL_portz00_1554);
								{	/* Engine/heap.scm 54 */
									obj_t BgL__z00_751;

									{	/* Engine/heap.scm 55 */
										bool_t BgL_testz00_1637;

										{	/* Engine/heap.scm 55 */
											bool_t BgL_testz00_1638;

											{	/* Engine/heap.scm 55 */
												obj_t BgL_v1475z00_807;

												BgL_v1475z00_807 = create_vector((int) (((long) 1)));
												VECTOR_SET(BgL_v1475z00_807,
													(int) (((long) 0)), BgL_envsz00_750);
												BgL_testz00_1638 = ((bool_t) 1);
											}
											if (BgL_testz00_1638)
												{	/* Engine/heap.scm 56 */
													bool_t BgL__ortest_1066z00_804;

													{	/* Engine/heap.scm 56 */
														int BgL_arg1599z00_806;

														BgL_arg1599z00_806 = VECTOR_LENGTH(BgL_envsz00_750);
														BgL__ortest_1066z00_804 =
															((long) (BgL_arg1599z00_806) == ((long) 5));
													}
													if (BgL__ortest_1066z00_804)
														{	/* Engine/heap.scm 56 */
															BgL_testz00_1637 = BgL__ortest_1066z00_804;
														}
													else
														{	/* Engine/heap.scm 57 */
															int BgL_arg1596z00_805;

															BgL_arg1596z00_805 =
																VECTOR_LENGTH(BgL_envsz00_750);
															BgL_testz00_1637 =
																((long) (BgL_arg1596z00_805) == ((long) 6));
												}}
											else
												{	/* Engine/heap.scm 55 */
													BgL_testz00_1637 = ((bool_t) 0);
												}
										}
										if (BgL_testz00_1637)
											{	/* Engine/heap.scm 55 */
												BgL__z00_751 = BFALSE;
											}
										else
											{	/* Engine/heap.scm 55 */
												BgL__z00_751 =
													BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 0)),
													BGl_string1883z00zzengine_heapz00, BgL_heapz00_1555);
									}}
									{	/* Engine/heap.scm 55 */
										obj_t BgL_targetz00_752;

										BgL_targetz00_752 =
											VECTOR_REF(BgL_envsz00_750, (int) (((long) 0)));
										{	/* Engine/heap.scm 59 */
											obj_t BgL_versionz00_753;

											BgL_versionz00_753 =
												VECTOR_REF(BgL_envsz00_750, (int) (((long) 1)));
											{	/* Engine/heap.scm 60 */
												obj_t BgL_specificz00_754;

												BgL_specificz00_754 =
													VECTOR_REF(BgL_envsz00_750, (int) (((long) 2)));
												{	/* Engine/heap.scm 61 */
													obj_t BgL_genvz00_755;

													BgL_genvz00_755 =
														VECTOR_REF(BgL_envsz00_750, (int) (((long) 3)));
													{	/* Engine/heap.scm 62 */
														obj_t BgL_tenvz00_756;

														BgL_tenvz00_756 =
															VECTOR_REF(BgL_envsz00_750, (int) (((long) 4)));
														{	/* Engine/heap.scm 63 */
															obj_t BgL_includesz00_757;

															{	/* Engine/heap.scm 64 */
																bool_t BgL_testz00_1662;

																{	/* Engine/heap.scm 64 */
																	int BgL_arg1587z00_801;

																	BgL_arg1587z00_801 =
																		VECTOR_LENGTH(BgL_envsz00_750);
																	BgL_testz00_1662 =
																		((long) (BgL_arg1587z00_801) == ((long) 6));
																}
																if (BgL_testz00_1662)
																	{	/* Engine/heap.scm 64 */
																		BgL_includesz00_757 =
																			VECTOR_REF(BgL_envsz00_750,
																			(int) (((long) 5)));
																	}
																else
																	{	/* Engine/heap.scm 64 */
																		BgL_includesz00_757 = BNIL;
																	}
															}
															{	/* Engine/heap.scm 64 */

																{	/* Engine/heap.scm 76 */
																	bool_t BgL_testz00_1668;

																	{	/* Engine/heap.scm 76 */
																		int BgL_arg1536z00_759;

																		BgL_arg1536z00_759 =
																			VECTOR_LENGTH(BgL_envsz00_750);
																		BgL_testz00_1668 =
																			(
																			(long) (BgL_arg1536z00_759) ==
																			((long) 6));
																	}
																	if (BgL_testz00_1668)
																		{	/* Engine/heap.scm 76 */
																			BGl_addzd2genvz12zc0zzast_envz00
																				(BgL_genvz00_755);
																		}
																	else
																		{	/* Engine/heap.scm 76 */
																			BGl_setzd2tenvz12zc0zztype_envz00
																				(BgL_tenvz00_756);
																			BGl_setzd2genvz12zc0zzast_envz00
																				(BgL_genvz00_755);
																		}
																}
																{	/* Engine/heap.scm 85 */
																	bool_t BgL_testz00_1675;

																	{	/* Engine/heap.scm 85 */
																		obj_t BgL_arg1553z00_770;

																		BgL_arg1553z00_770 =
																			BGl_thezd2backendzd2zzbackend_backendz00
																			();
																		BgL_testz00_1675 =
																			(((BgL_backendz00_bglt)
																				CREF(((BgL_backendz00_bglt)
																						BgL_arg1553z00_770)))->
																			BgL_qualifiedzd2typeszd2);
																	}
																	if (BgL_testz00_1675)
																		{	/* Engine/heap.scm 85 */
																			BGl_forzd2eachzd2globalz12z12zzast_envz00
																				(BGl_proc1884z00zzengine_heapz00, BNIL);
																		}
																	else
																		{	/* Engine/heap.scm 85 */
																			BFALSE;
																		}
																}
																BGl_hashtablezd2forzd2eachz00zz__hashz00
																	(BgL_genvz00_755,
																	BGl_proc1885z00zzengine_heapz00);
																{	/* Engine/heap.scm 99 */
																	obj_t BgL_arg1578z00_786;

																	{	/* Engine/heap.scm 99 */
																		obj_t BgL_res1853z00_1399;

																		{	/* Ieee/port.scm 591 */
																			obj_t BgL_auxz00_1681;

																			BgL_auxz00_1681 =
																				BGL_CURRENT_DYNAMIC_ENV();
																			BgL_res1853z00_1399 =
																				BGL_ENV_CURRENT_ERROR_PORT
																				(BgL_auxz00_1681);
																		}
																		BgL_arg1578z00_786 = BgL_res1853z00_1399;
																	}
																	{	/* Engine/heap.scm 101 */
																		obj_t BgL_zc3anonymousza31582ze3z83_1533;

																		BgL_zc3anonymousza31582ze3z83_1533 =
																			MAKE_FX_PROCEDURE
																			(BGl_z62zc3anonymousza31582ze3ze1zzengine_heapz00,
																			(int) (((long) 0)), (int) (((long) 4)));
																		PROCEDURE_SET
																			(BgL_zc3anonymousza31582ze3z83_1533,
																			(int) (((long) 0)), BgL_heapz00_1555);
																		PROCEDURE_SET
																			(BgL_zc3anonymousza31582ze3z83_1533,
																			(int) (((long) 1)), BgL_genvz00_755);
																		PROCEDURE_SET
																			(BgL_zc3anonymousza31582ze3z83_1533,
																			(int) (((long) 2)), BgL_tenvz00_756);
																		PROCEDURE_SET
																			(BgL_zc3anonymousza31582ze3z83_1533,
																			(int) (((long) 3)), BgL_includesz00_757);
																		BgL_val1065z00_749 =
																			BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00
																			(BgL_arg1578z00_786,
																			BgL_zc3anonymousza31582ze3z83_1533);
							}}}}}}}}}}}
							POP_EXIT();
							return BgL_val1065z00_749;
						}
					}
				}
		}
	}



/* &<anonymous:1582> */
	obj_t BGl_z62zc3anonymousza31582ze3ze1zzengine_heapz00(obj_t BgL_envz00_1536)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 100 */
			{	/* Engine/heap.scm 101 */
				obj_t BgL_heapz00_1537;
				obj_t BgL_genvz00_1538;
				obj_t BgL_tenvz00_1539;
				obj_t BgL_includesz00_1540;

				BgL_heapz00_1537 = PROCEDURE_REF(BgL_envz00_1536, (int) (((long) 0)));
				BgL_genvz00_1538 = PROCEDURE_REF(BgL_envz00_1536, (int) (((long) 1)));
				BgL_tenvz00_1539 = PROCEDURE_REF(BgL_envz00_1536, (int) (((long) 2)));
				BgL_includesz00_1540 =
					PROCEDURE_REF(BgL_envz00_1536, (int) (((long) 3)));
				{

					{	/* Engine/heap.scm 101 */
						obj_t BgL_port1479z00_789;

						{	/* Engine/heap.scm 101 */
							obj_t BgL_res1854z00_1401;

							{	/* Ieee/port.scm 585 */
								obj_t BgL_auxz00_1705;

								BgL_auxz00_1705 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res1854z00_1401 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1705);
							}
							BgL_port1479z00_789 = BgL_res1854z00_1401;
						}
						bgl_display_string(BGl_string1886z00zzengine_heapz00,
							BgL_port1479z00_789);
						bgl_display_obj(BgL_heapz00_1537, BgL_port1479z00_789);
						bgl_display_string(BGl_string1887z00zzengine_heapz00,
							BgL_port1479z00_789);
						bgl_display_char(((unsigned char) '\n'), BgL_port1479z00_789);
					}
					{	/* Engine/heap.scm 102 */
						obj_t BgL_port1480z00_790;

						{	/* Engine/heap.scm 102 */
							obj_t BgL_res1855z00_1408;

							{	/* Ieee/port.scm 585 */
								obj_t BgL_auxz00_1712;

								BgL_auxz00_1712 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res1855z00_1408 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1712);
							}
							BgL_port1480z00_790 = BgL_res1855z00_1408;
						}
						bgl_display_string(BGl_string1888z00zzengine_heapz00,
							BgL_port1480z00_790);
						bgl_display_char(((unsigned char) '\n'), BgL_port1480z00_790);
					}
					BGl_dumpzd2Genvzd2zzengine_heapz00(BgL_genvz00_1538);
					{	/* Engine/heap.scm 104 */
						obj_t BgL_port1481z00_791;

						{	/* Engine/heap.scm 104 */
							obj_t BgL_res1856z00_1413;

							{	/* Ieee/port.scm 585 */
								obj_t BgL_auxz00_1718;

								BgL_auxz00_1718 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res1856z00_1413 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1718);
							}
							BgL_port1481z00_791 = BgL_res1856z00_1413;
						}
						bgl_display_string(BGl_string1889z00zzengine_heapz00,
							BgL_port1481z00_791);
						bgl_display_char(((unsigned char) '\n'), BgL_port1481z00_791);
					}
					{	/* Engine/heap.scm 105 */
						obj_t BgL_port1482z00_792;

						{	/* Engine/heap.scm 105 */
							obj_t BgL_res1857z00_1418;

							{	/* Ieee/port.scm 585 */
								obj_t BgL_auxz00_1723;

								BgL_auxz00_1723 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res1857z00_1418 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1723);
							}
							BgL_port1482z00_792 = BgL_res1857z00_1418;
						}
						bgl_display_string(BGl_string1890z00zzengine_heapz00,
							BgL_port1482z00_792);
						bgl_display_char(((unsigned char) '\n'), BgL_port1482z00_792);
					}
					BGl_dumpzd2Tenvzd2zzengine_heapz00(BgL_tenvz00_1539);
					{	/* Engine/heap.scm 107 */
						obj_t BgL_port1483z00_793;

						{	/* Engine/heap.scm 107 */
							obj_t BgL_res1858z00_1423;

							{	/* Ieee/port.scm 585 */
								obj_t BgL_auxz00_1729;

								BgL_auxz00_1729 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res1858z00_1423 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1729);
							}
							BgL_port1483z00_793 = BgL_res1858z00_1423;
						}
						bgl_display_string(BGl_string1891z00zzengine_heapz00,
							BgL_port1483z00_793);
						bgl_display_char(((unsigned char) '\n'), BgL_port1483z00_793);
					}
					if (PAIRP(BgL_includesz00_1540))
						{	/* Engine/heap.scm 108 */
							{	/* Engine/heap.scm 109 */
								obj_t BgL_port1484z00_795;

								{	/* Engine/heap.scm 109 */
									obj_t BgL_res1860z00_1430;

									{	/* Ieee/port.scm 585 */
										obj_t BgL_auxz00_1736;

										BgL_auxz00_1736 = BGL_CURRENT_DYNAMIC_ENV();
										BgL_res1860z00_1430 =
											BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1736);
									}
									BgL_port1484z00_795 = BgL_res1860z00_1430;
								}
								bgl_display_string(BGl_string1892z00zzengine_heapz00,
									BgL_port1484z00_795);
								bgl_display_char(((unsigned char) '\n'), BgL_port1484z00_795);
							}
							{	/* Engine/heap.scm 110 */
								obj_t BgL_port1485z00_796;

								{	/* Engine/heap.scm 110 */
									obj_t BgL_res1861z00_1435;

									{	/* Ieee/port.scm 585 */
										obj_t BgL_auxz00_1741;

										BgL_auxz00_1741 = BGL_CURRENT_DYNAMIC_ENV();
										BgL_res1861z00_1435 =
											BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1741);
									}
									BgL_port1485z00_796 = BgL_res1861z00_1435;
								}
								bgl_display_obj(BgL_includesz00_1540, BgL_port1485z00_796);
								bgl_display_char(((unsigned char) '\n'), BgL_port1485z00_796);
							}
							{	/* Engine/heap.scm 111 */
								obj_t BgL_port1486z00_797;

								{	/* Engine/heap.scm 111 */
									obj_t BgL_res1862z00_1438;

									{	/* Ieee/port.scm 585 */
										obj_t BgL_auxz00_1746;

										BgL_auxz00_1746 = BGL_CURRENT_DYNAMIC_ENV();
										BgL_res1862z00_1438 =
											BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1746);
									}
									BgL_port1486z00_797 = BgL_res1862z00_1438;
								}
								bgl_display_string(BGl_string1891z00zzengine_heapz00,
									BgL_port1486z00_797);
								bgl_display_char(((unsigned char) '\n'), BgL_port1486z00_797);
						}}
					else
						{	/* Engine/heap.scm 108 */
							BFALSE;
						}
					{	/* Engine/heap.scm 112 */
						obj_t BgL_port1487z00_798;

						{	/* Engine/heap.scm 112 */
							obj_t BgL_res1863z00_1443;

							{	/* Ieee/port.scm 585 */
								obj_t BgL_auxz00_1751;

								BgL_auxz00_1751 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res1863z00_1443 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1751);
							}
							BgL_port1487z00_798 = BgL_res1863z00_1443;
						}
						bgl_display_string(BGl_string1893z00zzengine_heapz00,
							BgL_port1487z00_798);
						return bgl_display_char(((unsigned char) '\n'),
							BgL_port1487z00_798);
		}}}}
	}



/* &<anonymous:1559> */
	obj_t BGl_z62zc3anonymousza31559ze3ze1zzengine_heapz00(obj_t BgL_envz00_1541,
		obj_t BgL_kz00_1542, obj_t BgL_bucketz00_1543)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 95 */
			{
				obj_t BgL_kz00_772;
				obj_t BgL_bucketz00_773;

				{	/* Engine/heap.scm 96 */
					bool_t BgL_auxz00_1756;

					BgL_kz00_772 = BgL_kz00_1542;
					BgL_bucketz00_773 = BgL_bucketz00_1543;
					{	/* Engine/heap.scm 96 */
						obj_t BgL_g1478z00_775;

						BgL_g1478z00_775 = CDR(BgL_bucketz00_773);
						{
							obj_t BgL_l1476z00_777;

							BgL_l1476z00_777 = BgL_g1478z00_775;
						BgL_zc3anonymousza31560ze3z83_778:
							if (PAIRP(BgL_l1476z00_777))
								{	/* Engine/heap.scm 98 */
									{	/* Engine/heap.scm 97 */
										obj_t BgL_newz00_780;

										BgL_newz00_780 = CAR(BgL_l1476z00_777);
										{	/* Engine/heap.scm 97 */
											obj_t BgL_arg1570z00_781;

											BgL_arg1570z00_781 =
												(((BgL_globalz00_bglt) CREF(
														((BgL_globalz00_bglt) BgL_newz00_780)))->
												BgL_modulez00);
											{	/* Engine/heap.scm 97 */
												obj_t BgL_list1571z00_782;

												BgL_list1571z00_782 =
													MAKE_PAIR(BgL_arg1570z00_781, BNIL);
												BGl_heapzd2modulezd2listz00zzheap_restorez00
													(BgL_list1571z00_782);
											}
										}
									}
									{
										obj_t BgL_l1476z00_1765;

										BgL_l1476z00_1765 = CDR(BgL_l1476z00_777);
										BgL_l1476z00_777 = BgL_l1476z00_1765;
										goto BgL_zc3anonymousza31560ze3z83_778;
									}
								}
							else
								{	/* Engine/heap.scm 98 */
									BgL_auxz00_1756 = ((bool_t) 1);
								}
						}
					}
					return BBOOL(BgL_auxz00_1756);
				}
			}
		}
	}



/* &<anonymous:1541> */
	obj_t BGl_z62zc3anonymousza31541ze3ze1zzengine_heapz00(obj_t BgL_envz00_1544,
		obj_t BgL_newz00_1545)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 87 */
			{
				obj_t BgL_newz00_763;

				BgL_newz00_763 = BgL_newz00_1545;
				{	/* Engine/heap.scm 89 */
					obj_t BgL_arg1543z00_765;
					obj_t BgL_arg1546z00_766;
					obj_t BgL_arg1548z00_767;

					BgL_arg1543z00_765 =
						(((BgL_globalz00_bglt) CREF(
								((BgL_globalz00_bglt) BgL_newz00_763)))->BgL_modulez00);
					BgL_arg1546z00_766 =
						(((BgL_globalz00_bglt) CREF(
								((BgL_globalz00_bglt) BgL_newz00_763)))->
						BgL_jvmzd2typezd2namez00);
					BgL_arg1548z00_767 = BGl_shapez00zztools_shapez00(BgL_newz00_763);
					{	/* Engine/heap.scm 88 */
						obj_t BgL_list1549z00_768;

						BgL_list1549z00_768 = MAKE_PAIR(BgL_arg1548z00_767, BNIL);
						return
							BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(BgL_arg1543z00_765,
							BgL_arg1546z00_766, BgL_list1549z00_768);
					}
				}
			}
		}
	}



/* dump-Genv */
	obj_t BGl_dumpzd2Genvzd2zzengine_heapz00(obj_t BgL_genvz00_5)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 121 */
			return
				BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_genvz00_5,
				BGl_proc1894z00zzengine_heapz00);
		}
	}



/* &<anonymous:1610> */
	obj_t BGl_z62zc3anonymousza31610ze3ze1zzengine_heapz00(obj_t BgL_envz00_1547,
		obj_t BgL_kz00_1548, obj_t BgL_bucketz00_1549)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 152 */
			{
				obj_t BgL_kz00_814;
				obj_t BgL_bucketz00_815;

				{	/* Engine/heap.scm 152 */
					bool_t BgL_auxz00_1776;

					BgL_kz00_814 = BgL_kz00_1548;
					BgL_bucketz00_815 = BgL_bucketz00_1549;
					{
						obj_t BgL_newz00_826;

						{	/* Engine/heap.scm 152 */
							obj_t BgL_g1491z00_817;

							BgL_g1491z00_817 = CDR(BgL_bucketz00_815);
							{
								obj_t BgL_l1489z00_819;

								BgL_l1489z00_819 = BgL_g1491z00_817;
							BgL_zc3anonymousza31611ze3z83_820:
								if (PAIRP(BgL_l1489z00_819))
									{	/* Engine/heap.scm 152 */
										BgL_newz00_826 = CAR(BgL_l1489z00_819);
										{	/* Engine/heap.scm 123 */
											obj_t BgL_modulez00_828;

											BgL_modulez00_828 =
												(((BgL_globalz00_bglt) CREF(
														((BgL_globalz00_bglt) BgL_newz00_826)))->
												BgL_modulez00);
											{	/* Engine/heap.scm 123 */
												obj_t BgL_idz00_829;

												BgL_idz00_829 =
													(((BgL_variablez00_bglt) CREF(
															((BgL_variablez00_bglt)
																((BgL_globalz00_bglt) BgL_newz00_826))))->
													BgL_idz00);
												{	/* Engine/heap.scm 124 */
													obj_t BgL_qtz00_830;

													BgL_qtz00_830 =
														BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00
														(BgL_modulez00_828);
													{	/* Engine/heap.scm 125 */
														obj_t BgL_jtz00_831;

														BgL_jtz00_831 =
															(((BgL_globalz00_bglt) CREF(
																	((BgL_globalz00_bglt) BgL_newz00_826)))->
															BgL_jvmzd2typezd2namez00);
														{	/* Engine/heap.scm 126 */
															BgL_valuez00_bglt BgL_valz00_832;

															BgL_valz00_832 =
																(((BgL_variablez00_bglt) CREF(
																		((BgL_variablez00_bglt)
																			((BgL_globalz00_bglt) BgL_newz00_826))))->
																BgL_valuez00);
															{	/* Engine/heap.scm 127 */
																obj_t BgL_kindz00_833;

																{	/* Engine/heap.scm 129 */
																	bool_t BgL_testz00_1791;

																	{	/* Engine/heap.scm 129 */
																		bool_t BgL_res1868z00_1463;

																		{	/* Engine/heap.scm 129 */
																			obj_t BgL_objz00_1462;

																			BgL_objz00_1462 =
																				((obj_t) BgL_valz00_832);
																			BgL_res1868z00_1463 =
																				BGl_isazf3zf3zz__objectz00
																				(BgL_objz00_1462,
																				BGl_sfunz00zzast_varz00);
																		}
																		BgL_testz00_1791 = BgL_res1868z00_1463;
																	}
																	if (BgL_testz00_1791)
																		{	/* Engine/heap.scm 129 */
																			BgL_kindz00_833 =
																				CNST_TABLE_REF(((long) 1));
																		}
																	else
																		{	/* Engine/heap.scm 130 */
																			bool_t BgL_testz00_1795;

																			{	/* Engine/heap.scm 130 */
																				bool_t BgL_res1869z00_1465;

																				{	/* Engine/heap.scm 130 */
																					obj_t BgL_objz00_1464;

																					BgL_objz00_1464 =
																						((obj_t) BgL_valz00_832);
																					BgL_res1869z00_1465 =
																						BGl_isazf3zf3zz__objectz00
																						(BgL_objz00_1464,
																						BGl_cfunz00zzast_varz00);
																				}
																				BgL_testz00_1795 = BgL_res1869z00_1465;
																			}
																			if (BgL_testz00_1795)
																				{	/* Engine/heap.scm 130 */
																					BgL_kindz00_833 =
																						CNST_TABLE_REF(((long) 2));
																				}
																			else
																				{	/* Engine/heap.scm 130 */
																					BgL_kindz00_833 =
																						CNST_TABLE_REF(((long) 3));
																}}}
																{	/* Engine/heap.scm 128 */

																	{	/* Engine/heap.scm 132 */
																		obj_t BgL_port1488z00_834;

																		{	/* Engine/heap.scm 132 */
																			obj_t BgL_res1870z00_1467;

																			{	/* Ieee/port.scm 585 */
																				obj_t BgL_auxz00_1800;

																				BgL_auxz00_1800 =
																					BGL_CURRENT_DYNAMIC_ENV();
																				BgL_res1870z00_1467 =
																					BGL_ENV_CURRENT_OUTPUT_PORT
																					(BgL_auxz00_1800);
																			}
																			BgL_port1488z00_834 = BgL_res1870z00_1467;
																		}
																		bgl_display_string
																			(BGl_string1895z00zzengine_heapz00,
																			BgL_port1488z00_834);
																		{	/* Engine/heap.scm 133 */
																			obj_t BgL_arg1626z00_835;

																			{	/* Engine/heap.scm 133 */
																				obj_t BgL_arg1632z00_836;

																				{	/* Engine/heap.scm 133 */
																					obj_t BgL_arg1633z00_837;
																					obj_t BgL_arg1638z00_838;

																					BgL_arg1633z00_837 =
																						BGl_shapez00zztools_shapez00
																						(BgL_newz00_826);
																					{	/* Engine/heap.scm 135 */
																						obj_t BgL_arg1640z00_839;

																						{	/* Engine/heap.scm 135 */
																							obj_t BgL_arg1641z00_840;
																							obj_t BgL_arg1647z00_841;

																							{	/* Engine/heap.scm 135 */
																								obj_t BgL_arg1648z00_842;

																								BgL_arg1648z00_842 =
																									MAKE_PAIR(BgL_idz00_829,
																									BNIL);
																								BgL_arg1641z00_840 =
																									MAKE_PAIR(CNST_TABLE_REF((
																											(long) 4)),
																									BgL_arg1648z00_842);
																							}
																							{	/* Engine/heap.scm 137 */
																								obj_t BgL_arg1649z00_843;

																								{	/* Engine/heap.scm 137 */
																									obj_t BgL_arg1653z00_844;
																									obj_t BgL_arg1661z00_845;

																									{	/* Engine/heap.scm 137 */
																										obj_t BgL_arg1664z00_846;

																										BgL_arg1664z00_846 =
																											MAKE_PAIR
																											(BgL_modulez00_828, BNIL);
																										BgL_arg1653z00_844 =
																											MAKE_PAIR(CNST_TABLE_REF((
																													(long) 5)),
																											BgL_arg1664z00_846);
																									}
																									{	/* Engine/heap.scm 139 */
																										obj_t BgL_arg1670z00_847;

																										{	/* Engine/heap.scm 139 */
																											obj_t BgL_arg1676z00_848;
																											obj_t BgL_arg1677z00_849;

																											{	/* Engine/heap.scm 139 */
																												obj_t
																													BgL_arg1678z00_850;
																												{	/* Engine/heap.scm 139 */
																													obj_t
																														BgL_arg1679z00_851;
																													BgL_arg1679z00_851 =
																														(((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt) ((BgL_globalz00_bglt) BgL_newz00_826))))->BgL_namez00);
																													BgL_arg1678z00_850 =
																														MAKE_PAIR
																														(BgL_arg1679z00_851,
																														BNIL);
																												}
																												BgL_arg1676z00_848 =
																													MAKE_PAIR
																													(CNST_TABLE_REF((
																															(long) 6)),
																													BgL_arg1678z00_850);
																											}
																											{	/* Engine/heap.scm 141 */
																												obj_t
																													BgL_arg1688z00_852;
																												{	/* Engine/heap.scm 141 */
																													obj_t
																														BgL_arg1689z00_853;
																													obj_t
																														BgL_arg1690z00_854;
																													{	/* Engine/heap.scm 141 */
																														obj_t
																															BgL_arg1708z00_855;
																														BgL_arg1708z00_855 =
																															MAKE_PAIR
																															(BgL_qtz00_830,
																															BNIL);
																														BgL_arg1689z00_853 =
																															MAKE_PAIR
																															(CNST_TABLE_REF((
																																	(long) 7)),
																															BgL_arg1708z00_855);
																													}
																													{	/* Engine/heap.scm 142 */
																														obj_t
																															BgL_arg1711z00_856;
																														obj_t
																															BgL_arg1716z00_857;
																														{	/* Engine/heap.scm 142 */
																															bool_t
																																BgL_testz00_1820;
																															{	/* Engine/heap.scm 142 */
																																bool_t
																																	BgL_testz00_1821;
																																{	/* Engine/heap.scm 142 */
																																	bool_t
																																		BgL_res1871z00_1473;
																																	{	/* Engine/heap.scm 142 */
																																		obj_t
																																			BgL_objz00_1472;
																																		BgL_objz00_1472
																																			=
																																			((obj_t)
																																			BgL_valz00_832);
																																		BgL_res1871z00_1473
																																			=
																																			BGl_isazf3zf3zz__objectz00
																																			(BgL_objz00_1472,
																																			BGl_sfunz00zzast_varz00);
																																	}
																																	BgL_testz00_1821
																																		=
																																		BgL_res1871z00_1473;
																																}
																																if (BgL_testz00_1821)
																																	{	/* Engine/heap.scm 142 */
																																		BgL_testz00_1820
																																			=
																																			((((BgL_sfunz00_bglt) CREF(((BgL_sfunz00_bglt) BgL_valz00_832)))->BgL_classz00) == CNST_TABLE_REF(((long) 8)));
																																	}
																																else
																																	{	/* Engine/heap.scm 142 */
																																		BgL_testz00_1820
																																			=
																																			((bool_t)
																																			0);
																																	}
																															}
																															if (BgL_testz00_1820)
																																{	/* Engine/heap.scm 142 */
																																	BgL_arg1711z00_856
																																		=
																																		BGl_string1896z00zzengine_heapz00;
																																}
																															else
																																{	/* Engine/heap.scm 142 */
																																	BgL_arg1711z00_856
																																		=
																																		BGl_string1897z00zzengine_heapz00;
																																}
																														}
																														{	/* Engine/heap.scm 145 */
																															obj_t
																																BgL_arg1727z00_861;
																															obj_t
																																BgL_arg1732z00_862;
																															{	/* Engine/heap.scm 145 */
																																bool_t
																																	BgL_testz00_1828;
																																{	/* Engine/heap.scm 145 */
																																	bool_t
																																		BgL_testz00_1829;
																																	{	/* Engine/heap.scm 145 */
																																		bool_t
																																			BgL_res1872z00_1477;
																																		{	/* Engine/heap.scm 145 */
																																			obj_t
																																				BgL_objz00_1476;
																																			BgL_objz00_1476
																																				=
																																				((obj_t)
																																				BgL_valz00_832);
																																			BgL_res1872z00_1477
																																				=
																																				BGl_isazf3zf3zz__objectz00
																																				(BgL_objz00_1476,
																																				BGl_sfunz00zzast_varz00);
																																		}
																																		BgL_testz00_1829
																																			=
																																			BgL_res1872z00_1477;
																																	}
																																	if (BgL_testz00_1829)
																																		{	/* Engine/heap.scm 145 */
																																			BgL_testz00_1828
																																				=
																																				((((BgL_sfunz00_bglt) CREF(((BgL_sfunz00_bglt) BgL_valz00_832)))->BgL_classz00) == CNST_TABLE_REF(((long) 8)));
																																		}
																																	else
																																		{	/* Engine/heap.scm 145 */
																																			BgL_testz00_1828
																																				=
																																				(
																																				(bool_t)
																																				0);
																																		}
																																}
																																if (BgL_testz00_1828)
																																	{	/* Engine/heap.scm 146 */
																																		obj_t
																																			BgL_arg1734z00_864;
																																		{	/* Engine/heap.scm 146 */
																																			obj_t
																																				BgL_arg1735z00_865;
																																			{	/* Engine/heap.scm 146 */
																																				obj_t
																																					BgL_arg1736z00_866;
																																				BgL_arg1736z00_866
																																					=
																																					(((BgL_sfunz00_bglt) CREF(((BgL_sfunz00_bglt) BgL_valz00_832)))->BgL_bodyz00);
																																				BgL_arg1735z00_865
																																					=
																																					BGl_shapez00zztools_shapez00
																																					(BgL_arg1736z00_866);
																																			}
																																			BgL_arg1734z00_864
																																				=
																																				MAKE_PAIR
																																				(BgL_arg1735z00_865,
																																				BNIL);
																																		}
																																		BgL_arg1727z00_861
																																			=
																																			MAKE_PAIR
																																			(CNST_TABLE_REF
																																			(((long)
																																					9)),
																																			BgL_arg1734z00_864);
																																	}
																																else
																																	{	/* Engine/heap.scm 145 */
																																		BgL_arg1727z00_861
																																			=
																																			BGl_string1897z00zzengine_heapz00;
																																	}
																															}
																															{	/* Engine/heap.scm 149 */
																																obj_t
																																	BgL_arg1741z00_869;
																																{	/* Engine/heap.scm 149 */
																																	obj_t
																																		BgL_arg1742z00_870;
																																	{	/* Engine/heap.scm 149 */
																																		obj_t
																																			BgL_arg1743z00_871;
																																		BgL_arg1743z00_871
																																			=
																																			MAKE_PAIR
																																			(BgL_jtz00_831,
																																			BNIL);
																																		BgL_arg1742z00_870
																																			=
																																			MAKE_PAIR
																																			(CNST_TABLE_REF
																																			(((long)
																																					10)),
																																			BgL_arg1743z00_871);
																																	}
																																	BgL_arg1741z00_869
																																		=
																																		MAKE_PAIR
																																		(BgL_arg1742z00_870,
																																		BNIL);
																																}
																																BgL_arg1732z00_862
																																	=
																																	MAKE_PAIR
																																	(BGl_string1896z00zzengine_heapz00,
																																	BgL_arg1741z00_869);
																															}
																															BgL_arg1716z00_857
																																=
																																MAKE_PAIR
																																(BgL_arg1727z00_861,
																																BgL_arg1732z00_862);
																														}
																														BgL_arg1690z00_854 =
																															MAKE_PAIR
																															(BgL_arg1711z00_856,
																															BgL_arg1716z00_857);
																													}
																													BgL_arg1688z00_852 =
																														MAKE_PAIR
																														(BgL_arg1689z00_853,
																														BgL_arg1690z00_854);
																												}
																												BgL_arg1677z00_849 =
																													MAKE_PAIR
																													(BGl_string1896z00zzengine_heapz00,
																													BgL_arg1688z00_852);
																											}
																											BgL_arg1670z00_847 =
																												MAKE_PAIR
																												(BgL_arg1676z00_848,
																												BgL_arg1677z00_849);
																										}
																										BgL_arg1661z00_845 =
																											MAKE_PAIR
																											(BGl_string1896z00zzengine_heapz00,
																											BgL_arg1670z00_847);
																									}
																									BgL_arg1649z00_843 =
																										MAKE_PAIR
																										(BgL_arg1653z00_844,
																										BgL_arg1661z00_845);
																								}
																								BgL_arg1647z00_841 =
																									MAKE_PAIR
																									(BGl_string1896z00zzengine_heapz00,
																									BgL_arg1649z00_843);
																							}
																							BgL_arg1640z00_839 =
																								MAKE_PAIR(BgL_arg1641z00_840,
																								BgL_arg1647z00_841);
																						}
																						BgL_arg1638z00_838 =
																							MAKE_PAIR
																							(BGl_string1896z00zzengine_heapz00,
																							BgL_arg1640z00_839);
																					}
																					BgL_arg1632z00_836 =
																						MAKE_PAIR(BgL_arg1633z00_837,
																						BgL_arg1638z00_838);
																				}
																				BgL_arg1626z00_835 =
																					MAKE_PAIR(BgL_kindz00_833,
																					BgL_arg1632z00_836);
																			}
																			bgl_display_obj(BgL_arg1626z00_835,
																				BgL_port1488z00_834);
																		}
																		bgl_display_char(((unsigned char) '\n'),
																			BgL_port1488z00_834);
										}}}}}}}}
										{
											obj_t BgL_l1489z00_1862;

											BgL_l1489z00_1862 = CDR(BgL_l1489z00_819);
											BgL_l1489z00_819 = BgL_l1489z00_1862;
											goto BgL_zc3anonymousza31611ze3z83_820;
										}
									}
								else
									{	/* Engine/heap.scm 152 */
										BgL_auxz00_1776 = ((bool_t) 1);
									}
							}
						}
					}
					return BBOOL(BgL_auxz00_1776);
				}
			}
		}
	}



/* dump-Tenv */
	obj_t BGl_dumpzd2Tenvzd2zzengine_heapz00(obj_t BgL_tenvz00_6)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 157 */
			return
				BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_tenvz00_6,
				BGl_proc1898z00zzengine_heapz00);
		}
	}



/* &<anonymous:1747> */
	obj_t BGl_z62zc3anonymousza31747ze3ze1zzengine_heapz00(obj_t BgL_envz00_1551,
		obj_t BgL_kz00_1552, obj_t BgL_newz00_1553)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 159 */
			{
				obj_t BgL_kz00_876;
				obj_t BgL_newz00_877;

				BgL_kz00_876 = BgL_kz00_1552;
				BgL_newz00_877 = BgL_newz00_1553;
				{	/* Engine/heap.scm 160 */
					obj_t BgL_idz00_879;

					BgL_idz00_879 =
						(((BgL_typez00_bglt) CREF(
								((BgL_typez00_bglt) BgL_newz00_877)))->BgL_idz00);
					{	/* Engine/heap.scm 160 */
						obj_t BgL_namez00_880;

						BgL_namez00_880 =
							(((BgL_typez00_bglt) CREF(
									((BgL_typez00_bglt) BgL_newz00_877)))->BgL_namez00);
						{	/* Engine/heap.scm 161 */

							if (BGl_isazf3zf3zz__objectz00(BgL_newz00_877,
									BGl_tclassz00zzobject_classz00))
								{	/* Engine/heap.scm 163 */
									BgL_typez00_bglt BgL_i1067z00_882;

									BgL_i1067z00_882 = ((BgL_typez00_bglt) BgL_newz00_877);
									{	/* Engine/heap.scm 164 */
										obj_t BgL_port1498z00_883;

										{	/* Engine/heap.scm 164 */
											obj_t BgL_res1876z00_1496;

											{	/* Ieee/port.scm 585 */
												obj_t BgL_auxz00_1873;

												BgL_auxz00_1873 = BGL_CURRENT_DYNAMIC_ENV();
												BgL_res1876z00_1496 =
													BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1873);
											}
											BgL_port1498z00_883 = BgL_res1876z00_1496;
										}
										bgl_display_string(BGl_string1895z00zzengine_heapz00,
											BgL_port1498z00_883);
										{	/* Engine/heap.scm 165 */
											obj_t BgL_arg1749z00_884;

											{	/* Engine/heap.scm 165 */
												obj_t BgL_arg1750z00_885;

												{	/* Engine/heap.scm 165 */
													obj_t BgL_arg1751z00_886;
													obj_t BgL_arg1753z00_887;

													BgL_arg1751z00_886 =
														BGl_shapez00zztools_shapez00(BgL_newz00_877);
													{	/* Engine/heap.scm 166 */
														obj_t BgL_arg1755z00_888;
														obj_t BgL_arg1763z00_889;

														{	/* Engine/heap.scm 166 */
															obj_t BgL_arg1764z00_890;

															{	/* Engine/heap.scm 166 */
																obj_t BgL_arg1766z00_891;

																{	/* Engine/heap.scm 166 */
																	obj_t BgL_arg1768z00_892;

																	{
																		BgL_tclassz00_bglt BgL_auxz00_1878;

																		{
																			obj_t BgL_auxz00_1879;

																			{	/* Engine/heap.scm 166 */
																				BgL_objectz00_bglt BgL_auxz00_1880;

																				BgL_auxz00_1880 =
																					((BgL_objectz00_bglt)
																					BgL_i1067z00_882);
																				BgL_auxz00_1879 =
																					BGL_OBJECT_WIDENING(BgL_auxz00_1880);
																			}
																			BgL_auxz00_1878 =
																				((BgL_tclassz00_bglt) BgL_auxz00_1879);
																		}
																		BgL_arg1768z00_892 =
																			(((BgL_tclassz00_bglt)
																				CREF(BgL_auxz00_1878))->
																			BgL_itszd2superzd2);
																	}
																	BgL_arg1766z00_891 =
																		BGl_shapez00zztools_shapez00
																		(BgL_arg1768z00_892);
																}
																BgL_arg1764z00_890 =
																	MAKE_PAIR(BgL_arg1766z00_891, BNIL);
															}
															BgL_arg1755z00_888 =
																MAKE_PAIR(CNST_TABLE_REF(((long) 11)),
																BgL_arg1764z00_890);
														}
														{	/* Engine/heap.scm 167 */
															obj_t BgL_arg1769z00_893;

															{	/* Engine/heap.scm 167 */
																obj_t BgL_l1492z00_894;

																{
																	BgL_tclassz00_bglt BgL_auxz00_1889;

																	{
																		obj_t BgL_auxz00_1890;

																		{	/* Engine/heap.scm 167 */
																			BgL_objectz00_bglt BgL_auxz00_1891;

																			BgL_auxz00_1891 =
																				((BgL_objectz00_bglt) BgL_i1067z00_882);
																			BgL_auxz00_1890 =
																				BGL_OBJECT_WIDENING(BgL_auxz00_1891);
																		}
																		BgL_auxz00_1889 =
																			((BgL_tclassz00_bglt) BgL_auxz00_1890);
																	}
																	BgL_l1492z00_894 =
																		(((BgL_tclassz00_bglt)
																			CREF(BgL_auxz00_1889))->BgL_slotsz00);
																}
																if (NULLP(BgL_l1492z00_894))
																	{	/* Engine/heap.scm 167 */
																		BgL_arg1769z00_893 = BNIL;
																	}
																else
																	{	/* Engine/heap.scm 167 */
																		obj_t BgL_head1494z00_896;

																		{	/* Engine/heap.scm 167 */
																			obj_t BgL_arg1784z00_908;

																			BgL_arg1784z00_908 =
																				BGl_shapez00zztools_shapez00(CAR
																				(BgL_l1492z00_894));
																			{	/* Engine/heap.scm 167 */
																				obj_t BgL_res1878z00_1504;

																				BgL_res1878z00_1504 =
																					MAKE_PAIR(BgL_arg1784z00_908, BNIL);
																				BgL_head1494z00_896 =
																					BgL_res1878z00_1504;
																			}
																		}
																		{	/* Engine/heap.scm 167 */
																			obj_t BgL_g1497z00_897;

																			BgL_g1497z00_897 = CDR(BgL_l1492z00_894);
																			{
																				obj_t BgL_l1492z00_899;
																				obj_t BgL_tail1495z00_900;

																				BgL_l1492z00_899 = BgL_g1497z00_897;
																				BgL_tail1495z00_900 =
																					BgL_head1494z00_896;
																			BgL_zc3anonymousza31771ze3z83_901:
																				if (NULLP(BgL_l1492z00_899))
																					{	/* Engine/heap.scm 167 */
																						BgL_arg1769z00_893 =
																							BgL_head1494z00_896;
																					}
																				else
																					{	/* Engine/heap.scm 167 */
																						obj_t BgL_newtail1496z00_903;

																						{	/* Engine/heap.scm 167 */
																							obj_t BgL_arg1776z00_905;

																							BgL_arg1776z00_905 =
																								BGl_shapez00zztools_shapez00(CAR
																								(BgL_l1492z00_899));
																							{	/* Engine/heap.scm 167 */
																								obj_t BgL_res1880z00_1511;

																								BgL_res1880z00_1511 =
																									MAKE_PAIR(BgL_arg1776z00_905,
																									BNIL);
																								BgL_newtail1496z00_903 =
																									BgL_res1880z00_1511;
																							}
																						}
																						SET_CDR(BgL_tail1495z00_900,
																							BgL_newtail1496z00_903);
																						{
																							obj_t BgL_tail1495z00_1910;
																							obj_t BgL_l1492z00_1908;

																							BgL_l1492z00_1908 =
																								CDR(BgL_l1492z00_899);
																							BgL_tail1495z00_1910 =
																								BgL_newtail1496z00_903;
																							BgL_tail1495z00_900 =
																								BgL_tail1495z00_1910;
																							BgL_l1492z00_899 =
																								BgL_l1492z00_1908;
																							goto
																								BgL_zc3anonymousza31771ze3z83_901;
																						}
																					}
																			}
																		}
																	}
															}
															BgL_arg1763z00_889 =
																BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																(BgL_arg1769z00_893, BNIL);
														}
														BgL_arg1753z00_887 =
															MAKE_PAIR(BgL_arg1755z00_888, BgL_arg1763z00_889);
													}
													BgL_arg1750z00_885 =
														MAKE_PAIR(BgL_arg1751z00_886, BgL_arg1753z00_887);
												}
												BgL_arg1749z00_884 =
													MAKE_PAIR(CNST_TABLE_REF(((long) 12)),
													BgL_arg1750z00_885);
											}
											bgl_display_obj(BgL_arg1749z00_884, BgL_port1498z00_883);
										}
										return
											bgl_display_char(((unsigned char) '\n'),
											BgL_port1498z00_883);
								}}
							else
								{	/* Engine/heap.scm 168 */
									obj_t BgL_port1499z00_910;

									{	/* Engine/heap.scm 168 */
										obj_t BgL_res1881z00_1517;

										{	/* Ieee/port.scm 585 */
											obj_t BgL_auxz00_1918;

											BgL_auxz00_1918 = BGL_CURRENT_DYNAMIC_ENV();
											BgL_res1881z00_1517 =
												BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1918);
										}
										BgL_port1499z00_910 = BgL_res1881z00_1517;
									}
									bgl_display_string(BGl_string1895z00zzengine_heapz00,
										BgL_port1499z00_910);
									{	/* Engine/heap.scm 168 */
										obj_t BgL_arg1791z00_911;

										{	/* Engine/heap.scm 168 */
											obj_t BgL_arg1794z00_912;

											{	/* Engine/heap.scm 168 */
												obj_t BgL_arg1800z00_913;

												{	/* Engine/heap.scm 168 */
													obj_t BgL_arg1801z00_914;

													{	/* Engine/heap.scm 168 */
														obj_t BgL_arg1802z00_915;

														BgL_arg1802z00_915 =
															MAKE_PAIR(BgL_namez00_880, BNIL);
														BgL_arg1801z00_914 =
															MAKE_PAIR(CNST_TABLE_REF(((long) 6)),
															BgL_arg1802z00_915);
													}
													BgL_arg1800z00_913 =
														MAKE_PAIR(BgL_arg1801z00_914, BNIL);
												}
												BgL_arg1794z00_912 =
													MAKE_PAIR(BgL_idz00_879, BgL_arg1800z00_913);
											}
											BgL_arg1791z00_911 =
												MAKE_PAIR(CNST_TABLE_REF(((long) 13)),
												BgL_arg1794z00_912);
										}
										bgl_display_obj(BgL_arg1791z00_911, BgL_port1499z00_910);
									}
									return
										bgl_display_char(((unsigned char) '\n'),
										BgL_port1499z00_910);
		}}}}}}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzengine_heapz00()
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 15 */
			return BUNSPEC;
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzengine_heapz00()
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 15 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzengine_heapz00()
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 15 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzengine_heapz00()
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 15 */
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 462549608),
				BSTRING_TO_STRING(BGl_string1899z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 57787772),
				BSTRING_TO_STRING(BGl_string1899z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string1899z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string1899z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string1899z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 481724379),
				BSTRING_TO_STRING(BGl_string1899z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 296457443),
				BSTRING_TO_STRING(BGl_string1899z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzread_jvmz00(((long) 261574382),
				BSTRING_TO_STRING(BGl_string1899z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string1899z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzheap_restorez00(((long) 147989063),
				BSTRING_TO_STRING(BGl_string1899z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long) 158397907),
				BSTRING_TO_STRING(BGl_string1899z00zzengine_heapz00));
			return
				BGl_modulezd2initializa7ationz75zzmodule_pragmaz00(((long) 433305536),
				BSTRING_TO_STRING(BGl_string1899z00zzengine_heapz00));
		}
	}

#ifdef __cplusplus
}
#endif
