/*===========================================================================*/
/*   (Heap/restore.scm)                                                      */
/*   Bigloo (4.0a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jan 24 17:03:30 CET 2013        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/4.0a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Heap/restore.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
		bool_t BgL_boundzd2checkzd2;
		bool_t BgL_typezd2checkzd2;
		bool_t BgL_typedzd2funcallzd2;
	}                 *BgL_backendz00_bglt;


	BGL_IMPORT obj_t BGl_putpropz12z12zz__r4_symbols_6_4z00(obj_t, obj_t, obj_t);
	extern obj_t BGl_setzd2genvz12zc0zzast_envz00(obj_t);
	static obj_t BGl_z62restorezd2heapzb0zzheap_restorez00(obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzheap_restorez00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t
		BGl_restorezd2additionalzd2heapsz00zzheap_restorez00();
	BGL_IMPORT bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
	static obj_t BGl_z62heapzd2modulezd2listz62zzheap_restorez00(obj_t, obj_t);
	static obj_t BGl_toplevelzd2initzd2zzheap_restorez00();
	BGL_EXPORTED_DECL obj_t
		BGl_restorezd2additionalzd2heapz00zzheap_restorez00(obj_t);
	extern obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t input_obj(obj_t);
	BGL_IMPORT obj_t bgl_reverse(obj_t);
	static obj_t BGl_genericzd2initzd2zzheap_restorez00();
	static obj_t BGl_z62zc3anonymousza31611ze3ze1zzheap_restorez00(obj_t, obj_t);
	static obj_t BGl_objectzd2initzd2zzheap_restorez00();
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	extern obj_t BGl_addzd2genvz12zc0zzast_envz00(obj_t);
	BGL_IMPORT obj_t BGl_valzd2fromzd2exitzf3zf3zz__bexitz00(obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2binaryzd2filezd2zz__binaryz00(obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl_unbindzd2callzf2ccz12z32zzheap_restorez00();
	static obj_t BGl_appendzd221011zd2zzheap_restorez00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzheap_restorez00();
	extern obj_t BGl_za2additionalzd2includezd2foreignza2z00zzengine_paramz00;
	extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
	static obj_t BGl_z62zc3anonymousza31634ze3ze1zzheap_restorez00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3exitza31431ze3z83zzheap_restorez00(obj_t);
	BGL_IMPORT obj_t close_binary_port(obj_t);
	BGL_IMPORT obj_t string_append(obj_t, obj_t);
	static obj_t BGl_za2heapzd2modulezd2listza2z00zzheap_restorez00 = BUNSPEC;
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31458ze3ze1zzheap_restorez00(obj_t, obj_t);
	extern obj_t BGl_unbindzd2globalz12zc0zzast_envz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31483ze3ze1zzheap_restorez00(obj_t, obj_t);
	extern obj_t BGl_za2bigloozd2versionza2zd2zzengine_paramz00;
	BGL_EXPORTED_DECL obj_t BGl_restorezd2heapzd2zzheap_restorez00();
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzheap_restorez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzread_jvmz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzinit_mainz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_enginez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__binaryz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__hashz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_za2heapzd2nameza2zd2zzengine_paramz00;
	BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	extern obj_t BGl_za2additionalzd2heapzd2namesza2z00zzengine_paramz00;
	extern obj_t BGl_setzd2tenvz12zc0zztype_envz00(obj_t);
	extern obj_t BGl_za2libzd2dirza2zd2zzengine_paramz00;
	static obj_t BGl_z62restorezd2additionalzd2heapz62zzheap_restorez00(obj_t,
		obj_t);
	static obj_t BGl_cnstzd2initzd2zzheap_restorez00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzheap_restorez00();
	extern obj_t BGl_za2unsafezd2heapza2zd2zzengine_paramz00;
	static obj_t BGl_importedzd2moduleszd2initz00zzheap_restorez00();
	BGL_IMPORT obj_t BGl_hashtablezd2forzd2eachz00zz__hashz00(obj_t, obj_t);
	extern obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
	static obj_t BGl_z62restorezd2additionalzd2heapsz62zzheap_restorez00(obj_t);
	BGL_IMPORT obj_t BGl_getpropz00zz__r4_symbols_6_4z00(obj_t, obj_t);
	extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
	extern obj_t BGl_za2callzf2cczf3za2z01zzengine_paramz00;
	BGL_IMPORT obj_t BGl_findzd2filezf2pathz20zz__osz00(obj_t, obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	extern obj_t BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_addzd2tenvz12zc0zztype_envz00(obj_t);
	extern obj_t BGl_za2bigloozd2specificzd2versionza2z00zzengine_paramz00;
	static obj_t BGl_zc3exitza31559ze3z83zzheap_restorez00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_heapzd2modulezd2listz00zzheap_restorez00(obj_t);
	extern obj_t BGl_compilerzd2exitzd2zzinit_mainz00(obj_t);
	extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
	static bool_t BGl_backendzd2heapzd2compatiblezf3zf3zzheap_restorez00(obj_t);
	static obj_t BGl_za2heapzd2markza2zd2zzheap_restorez00 = BUNSPEC;
	static obj_t __cnst[7];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_restorezd2additionalzd2heapszd2envzd2zzheap_restorez00,
		BgL_bgl_za762restoreza7d2add1774z00,
		BGl_z62restorezd2additionalzd2heapsz62zzheap_restorez00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_heapzd2modulezd2listzd2envzd2zzheap_restorez00,
		BgL_bgl_za762heapza7d2module1775z00, va_generic_entry,
		BGl_z62heapzd2modulezd2listz62zzheap_restorez00, BUNSPEC, -1);
	      DEFINE_STRING(BGl_string1750z00zzheap_restorez00,
		BgL_bgl_string1750za700za7za7h1776za7, "Heap", 4);
	      DEFINE_STRING(BGl_string1751z00zzheap_restorez00,
		BgL_bgl_string1751za700za7za7h1777za7, "   . ", 5);
	      DEFINE_STRING(BGl_string1752z00zzheap_restorez00,
		BgL_bgl_string1752za700za7za7h1778za7, "failure during prelude hook", 27);
	      DEFINE_STRING(BGl_string1753z00zzheap_restorez00,
		BgL_bgl_string1753za700za7za7h1779za7, "]", 1);
	      DEFINE_STRING(BGl_string1754z00zzheap_restorez00,
		BgL_bgl_string1754za700za7za7h1780za7, "      [reading ", 15);
	      DEFINE_STRING(BGl_string1755z00zzheap_restorez00,
		BgL_bgl_string1755za700za7za7h1781za7, "Cannot open heap file ~s", 24);
	      DEFINE_STRING(BGl_string1756z00zzheap_restorez00,
		BgL_bgl_string1756za700za7za7h1782za7, "Corrupted heap", 14);
	      DEFINE_STRING(BGl_string1757z00zzheap_restorez00,
		BgL_bgl_string1757za700za7za7h1783za7, "~a vs. ~a", 9);
	      DEFINE_STRING(BGl_string1758z00zzheap_restorez00,
		BgL_bgl_string1758za700za7za7h1784za7, "Target language mismatch", 24);
	      DEFINE_STRING(BGl_string1759z00zzheap_restorez00,
		BgL_bgl_string1759za700za7za7h1785za7, "Heap is `~a', Bigloo is `~a'", 28);
	      DEFINE_STRING(BGl_string1760z00zzheap_restorez00,
		BgL_bgl_string1760za700za7za7h1786za7, "Release mismatch", 16);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_restorezd2heapzd2envz00zzheap_restorez00,
		BgL_bgl_za762restoreza7d2hea1787z00,
		BGl_z62restorezd2heapzb0zzheap_restorez00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string1761z00zzheap_restorez00,
		BgL_bgl_string1761za700za7za7h1788za7, "Specific version mismatch", 25);
	      DEFINE_STRING(BGl_string1764z00zzheap_restorez00,
		BgL_bgl_string1764za700za7za7h1789za7, ".", 1);
	      DEFINE_STRING(BGl_string1765z00zzheap_restorez00,
		BgL_bgl_string1765za700za7za7h1790za7, "Library", 7);
	      DEFINE_STRING(BGl_string1766z00zzheap_restorez00,
		BgL_bgl_string1766za700za7za7h1791za7, "restore-additional-heap", 23);
	      DEFINE_STRING(BGl_string1769z00zzheap_restorez00,
		BgL_bgl_string1769za700za7za7h1792za7, "heap_restore", 12);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1762z00zzheap_restorez00,
		BgL_bgl_za762za7c3anonymousza71793za7,
		BGl_z62zc3anonymousza31458ze3ze1zzheap_restorez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1763z00zzheap_restorez00,
		BgL_bgl_za762za7c3anonymousza71794za7,
		BGl_z62zc3anonymousza31483ze3ze1zzheap_restorez00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string1770z00zzheap_restorez00,
		BgL_bgl_string1770za700za7za7h1795za7,
		"restore-additional-heap call-with-current-continuation __r4_control_features_6_9 call/cc restore-heap pass-started heap-mark ",
		125);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1767z00zzheap_restorez00,
		BgL_bgl_za762za7c3anonymousza71796za7,
		BGl_z62zc3anonymousza31611ze3ze1zzheap_restorez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1768z00zzheap_restorez00,
		BgL_bgl_za762za7c3anonymousza71797za7,
		BGl_z62zc3anonymousza31634ze3ze1zzheap_restorez00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_restorezd2additionalzd2heapzd2envzd2zzheap_restorez00,
		BgL_bgl_za762restoreza7d2add1798z00,
		BGl_z62restorezd2additionalzd2heapz62zzheap_restorez00, 0L, BUNSPEC, 1);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzheap_restorez00(long
		BgL_checksumz00_1145, char *BgL_fromz00_1146)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzheap_restorez00))
				{
					BGl_requirezd2initializa7ationz75zzheap_restorez00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzheap_restorez00();
					BGl_cnstzd2initzd2zzheap_restorez00();
					BGl_importedzd2moduleszd2initz00zzheap_restorez00();
					BGl_toplevelzd2initzd2zzheap_restorez00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 15 */
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"heap_restore");
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long) 0),
				"heap_restore");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"heap_restore");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"heap_restore");
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 0), "heap_restore");
			BGl_modulezd2initializa7ationz75zz__binaryz00(((long) 0), "heap_restore");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "heap_restore");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "heap_restore");
			BGl_modulezd2initializa7ationz75zz__hashz00(((long) 0), "heap_restore");
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 0), "heap_restore");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"heap_restore");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"heap_restore");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"heap_restore");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 15 */
			{	/* Heap/restore.scm 15 */
				obj_t BgL_cportz00_1137;

				BgL_cportz00_1137 =
					bgl_open_input_string(BGl_string1770z00zzheap_restorez00,
					(int) (((long) 0)));
				{
					long BgL_iz00_1138;

					BgL_iz00_1138 = ((long) 6);
				BgL_loopz00_1139:
					if ((BgL_iz00_1138 == ((long) -1)))
						{	/* Heap/restore.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Heap/restore.scm 15 */
							{	/* Heap/restore.scm 15 */
								obj_t BgL_arg1773z00_1141;

								{	/* Heap/restore.scm 15 */

									{	/* Heap/restore.scm 15 */
										obj_t BgL_locationz00_1143;

										BgL_locationz00_1143 = BBOOL(((bool_t) 0));
										{	/* Heap/restore.scm 15 */

											BgL_arg1773z00_1141 =
												BGl_readz00zz__readerz00(BgL_cportz00_1137,
												BgL_locationz00_1143);
										}
									}
								}
								{	/* Heap/restore.scm 15 */
									int BgL_auxz00_1173;

									BgL_auxz00_1173 = (int) (BgL_iz00_1138);
									CNST_TABLE_SET(BgL_auxz00_1173, BgL_arg1773z00_1141);
							}}
							{	/* Heap/restore.scm 15 */
								int BgL_auxz00_1144;

								BgL_auxz00_1144 = (int) ((BgL_iz00_1138 - ((long) 1)));
								{
									long BgL_iz00_1178;

									BgL_iz00_1178 = (long) (BgL_auxz00_1144);
									BgL_iz00_1138 = BgL_iz00_1178;
									goto BgL_loopz00_1139;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 15 */
			BGl_za2heapzd2modulezd2listza2z00zzheap_restorez00 = BNIL;
			return (BGl_za2heapzd2markza2zd2zzheap_restorez00 =
				CNST_TABLE_REF(((long) 0)), BUNSPEC);
		}
	}



/* append-21011 */
	obj_t BGl_appendzd221011zd2zzheap_restorez00(obj_t BgL_l1z00_1,
		obj_t BgL_l2z00_2)
	{
		AN_OBJECT;
		{
			{
				obj_t BgL_headz00_493;

				BgL_headz00_493 = MAKE_PAIR(BNIL, BgL_l2z00_2);
				{
					obj_t BgL_prevz00_494;
					obj_t BgL_tailz00_495;

					BgL_prevz00_494 = BgL_headz00_493;
					BgL_tailz00_495 = BgL_l1z00_1;
				BgL_loopz00_496:
					if (PAIRP(BgL_tailz00_495))
						{
							obj_t BgL_newzd2prevzd2_498;

							BgL_newzd2prevzd2_498 =
								MAKE_PAIR(CAR(BgL_tailz00_495), BgL_l2z00_2);
							SET_CDR(BgL_prevz00_494, BgL_newzd2prevzd2_498);
							{
								obj_t BgL_tailz00_1188;
								obj_t BgL_prevz00_1187;

								BgL_prevz00_1187 = BgL_newzd2prevzd2_498;
								BgL_tailz00_1188 = CDR(BgL_tailz00_495);
								BgL_tailz00_495 = BgL_tailz00_1188;
								BgL_prevz00_494 = BgL_prevz00_1187;
								goto BgL_loopz00_496;
							}
						}
					else
						{
							BNIL;
						}
					return CDR(BgL_headz00_493);
				}
			}
		}
	}



/* backend-heap-compatible? */
	bool_t BGl_backendzd2heapzd2compatiblezf3zf3zzheap_restorez00(obj_t
		BgL_targetz00_3)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 36 */
			{	/* Heap/restore.scm 37 */
				BgL_backendz00_bglt BgL_i1063z00_501;

				BgL_i1063z00_501 =
					((BgL_backendz00_bglt) BGl_thezd2backendzd2zzbackend_backendz00());
				{	/* Heap/restore.scm 38 */
					bool_t BgL__ortest_1064z00_502;

					BgL__ortest_1064z00_502 =
						(BgL_targetz00_3 ==
						(((BgL_backendz00_bglt) CREF(BgL_i1063z00_501))->BgL_languagez00));
					if (BgL__ortest_1064z00_502)
						{	/* Heap/restore.scm 38 */
							return BgL__ortest_1064z00_502;
						}
					else
						{	/* Heap/restore.scm 38 */
							return
								(BgL_targetz00_3 ==
								(((BgL_backendz00_bglt) CREF(BgL_i1063z00_501))->
									BgL_heapzd2compatiblezd2));
						}
				}
			}
		}
	}



/* restore-heap */
	BGL_EXPORTED_DEF obj_t BGl_restorezd2heapzd2zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 43 */
			if (STRINGP(BGl_za2heapzd2nameza2zd2zzengine_paramz00))
				{	/* Heap/restore.scm 44 */
					{	/* Heap/restore.scm 45 */
						obj_t BgL_list1375z00_506;

						{	/* Heap/restore.scm 45 */
							obj_t BgL_arg1389z00_507;

							{	/* Heap/restore.scm 45 */
								obj_t BgL_arg1390z00_508;

								BgL_arg1390z00_508 =
									MAKE_PAIR(BCHAR(((unsigned char) '\n')), BNIL);
								BgL_arg1389z00_507 =
									MAKE_PAIR(BGl_string1750z00zzheap_restorez00,
									BgL_arg1390z00_508);
							}
							BgL_list1375z00_506 =
								MAKE_PAIR(BGl_string1751z00zzheap_restorez00,
								BgL_arg1389z00_507);
						}
						BGl_verbosez00zztools_speekz00(BINT(((long) 1)),
							BgL_list1375z00_506);
					}
					BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 =
						BINT(((long) 0));
					BGl_za2currentzd2passza2zd2zzengine_passz00 =
						BGl_string1750z00zzheap_restorez00;
					{
						obj_t BgL_hooksz00_512;
						obj_t BgL_hnamesz00_513;

						BgL_hooksz00_512 = BNIL;
						BgL_hnamesz00_513 = BNIL;
					BgL_zc3anonymousza31391ze3z83_514:
						if (NULLP(BgL_hooksz00_512))
							{	/* Heap/restore.scm 45 */
								CNST_TABLE_REF(((long) 1));
							}
						else
							{	/* Heap/restore.scm 45 */
								bool_t BgL_testz00_1210;

								{	/* Heap/restore.scm 45 */
									obj_t BgL_fun1407z00_520;

									BgL_fun1407z00_520 = CAR(BgL_hooksz00_512);
									BgL_testz00_1210 =
										CBOOL(PROCEDURE_ENTRY(BgL_fun1407z00_520)
										(BgL_fun1407z00_520, BEOA));
								}
								if (BgL_testz00_1210)
									{
										obj_t BgL_hnamesz00_1218;
										obj_t BgL_hooksz00_1216;

										BgL_hooksz00_1216 = CDR(BgL_hooksz00_512);
										BgL_hnamesz00_1218 = CDR(BgL_hnamesz00_513);
										BgL_hnamesz00_513 = BgL_hnamesz00_1218;
										BgL_hooksz00_512 = BgL_hooksz00_1216;
										goto BgL_zc3anonymousza31391ze3z83_514;
									}
								else
									{	/* Heap/restore.scm 45 */
										BGl_internalzd2errorzd2zztools_errorz00
											(BGl_string1750z00zzheap_restorez00,
											BGl_string1752z00zzheap_restorez00,
											CAR(BgL_hnamesz00_513));
									}
							}
					}
					{	/* Heap/restore.scm 46 */
						obj_t BgL_fnamez00_523;

						BgL_fnamez00_523 =
							BGl_findzd2filezf2pathz20zz__osz00
							(BGl_za2heapzd2nameza2zd2zzengine_paramz00,
							BGl_za2libzd2dirza2zd2zzengine_paramz00);
						if (STRINGP(BgL_fnamez00_523))
							{	/* Heap/restore.scm 48 */
								obj_t BgL_portz00_525;

								BgL_portz00_525 =
									BGl_openzd2inputzd2binaryzd2filezd2zz__binaryz00
									(BgL_fnamez00_523);
								if (BINARY_PORTP(BgL_portz00_525))
									{	/* Heap/restore.scm 49 */
										{	/* Heap/restore.scm 54 */
											obj_t BgL_list1412z00_527;

											{	/* Heap/restore.scm 54 */
												obj_t BgL_arg1415z00_528;

												{	/* Heap/restore.scm 54 */
													obj_t BgL_arg1418z00_529;

													{	/* Heap/restore.scm 54 */
														obj_t BgL_arg1421z00_530;

														BgL_arg1421z00_530 =
															MAKE_PAIR(BCHAR(((unsigned char) '\n')), BNIL);
														BgL_arg1418z00_529 =
															MAKE_PAIR(BGl_string1753z00zzheap_restorez00,
															BgL_arg1421z00_530);
													}
													BgL_arg1415z00_528 =
														MAKE_PAIR(BgL_fnamez00_523, BgL_arg1418z00_529);
												}
												BgL_list1412z00_527 =
													MAKE_PAIR(BGl_string1754z00zzheap_restorez00,
													BgL_arg1415z00_528);
											}
											BGl_verbosez00zztools_speekz00(BINT(((long) 2)),
												BgL_list1412z00_527);
										}
										{	/* Heap/restore.scm 55 */
											obj_t BgL_val1071z00_531;

											BgL_val1071z00_531 =
												BGl_zc3exitza31431ze3z83zzheap_restorez00
												(BgL_portz00_525);
											close_binary_port(BgL_portz00_525);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1071z00_531)))
												{	/* Heap/restore.scm 109 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1071z00_531), CDR(BgL_val1071z00_531));
												}
											else
												{	/* Heap/restore.scm 109 */
													return BgL_val1071z00_531;
												}
										}
									}
								else
									{	/* Heap/restore.scm 50 */
										obj_t BgL_mz00_580;

										{	/* Heap/restore.scm 50 */
											obj_t BgL_list1495z00_581;

											BgL_list1495z00_581 = MAKE_PAIR(BgL_fnamez00_523, BNIL);
											BgL_mz00_580 =
												BGl_formatz00zz__r4_output_6_10_3z00
												(BGl_string1755z00zzheap_restorez00,
												BgL_list1495z00_581);
										}
										BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 2)),
											BgL_mz00_580, BGl_za2libzd2dirza2zd2zzengine_paramz00);
										return BGl_compilerzd2exitzd2zzinit_mainz00(BINT(((long)
													5)));
							}}
						else
							{	/* Heap/restore.scm 110 */
								obj_t BgL_mz00_582;

								{	/* Heap/restore.scm 110 */
									obj_t BgL_list1496z00_583;

									BgL_list1496z00_583 =
										MAKE_PAIR(BGl_za2heapzd2nameza2zd2zzengine_paramz00, BNIL);
									BgL_mz00_582 =
										BGl_formatz00zz__r4_output_6_10_3z00
										(BGl_string1755z00zzheap_restorez00, BgL_list1496z00_583);
								}
								BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 2)),
									BgL_mz00_582, BGl_za2libzd2dirza2zd2zzengine_paramz00);
								return BGl_compilerzd2exitzd2zzinit_mainz00(BINT(((long) 5)));
				}}}
			else
				{	/* Heap/restore.scm 44 */
					return BFALSE;
				}
		}
	}



/* <exit:1431> */
	obj_t BGl_zc3exitza31431ze3z83zzheap_restorez00(obj_t BgL_portz00_1135)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 109 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1072z00_536;

			if (SET_EXIT(BgL_an_exit1072z00_536))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1072z00_536 = (void *) jmpbuf;
					{	/* Heap/restore.scm 109 */

						PUSH_EXIT(BgL_an_exit1072z00_536, ((long) 0));
						{	/* Heap/restore.scm 56 */
							bool_t BgL_val1073z00_537;

							{	/* Heap/restore.scm 56 */
								obj_t BgL_envsz00_538;

								BgL_envsz00_538 = input_obj(BgL_portz00_1135);
								{	/* Heap/restore.scm 56 */
									obj_t BgL__z00_539;

									{	/* Heap/restore.scm 57 */
										bool_t BgL_testz00_1259;

										if (VECTORP(BgL_envsz00_538))
											{	/* Heap/restore.scm 58 */
												int BgL_arg1494z00_579;

												BgL_arg1494z00_579 = VECTOR_LENGTH(BgL_envsz00_538);
												BgL_testz00_1259 =
													((long) (BgL_arg1494z00_579) == ((long) 5));
											}
										else
											{	/* Heap/restore.scm 57 */
												BgL_testz00_1259 = ((bool_t) 0);
											}
										if (BgL_testz00_1259)
											{	/* Heap/restore.scm 57 */
												BgL__z00_539 = BFALSE;
											}
										else
											{	/* Heap/restore.scm 57 */
												BgL__z00_539 =
													BGl_errorz00zz__errorz00
													(BGl_za2heapzd2nameza2zd2zzengine_paramz00,
													BGl_string1756z00zzheap_restorez00, BgL_envsz00_538);
											}
									}
									{	/* Heap/restore.scm 57 */
										obj_t BgL_targetz00_540;

										BgL_targetz00_540 =
											VECTOR_REF(BgL_envsz00_538, (int) (((long) 0)));
										{	/* Heap/restore.scm 62 */
											obj_t BgL_versionz00_541;

											BgL_versionz00_541 =
												VECTOR_REF(BgL_envsz00_538, (int) (((long) 1)));
											{	/* Heap/restore.scm 63 */
												obj_t BgL_specificz00_542;

												BgL_specificz00_542 =
													VECTOR_REF(BgL_envsz00_538, (int) (((long) 2)));
												{	/* Heap/restore.scm 64 */
													obj_t BgL_genvz00_543;

													BgL_genvz00_543 =
														VECTOR_REF(BgL_envsz00_538, (int) (((long) 3)));
													{	/* Heap/restore.scm 65 */
														obj_t BgL_tenvz00_544;

														BgL_tenvz00_544 =
															VECTOR_REF(BgL_envsz00_538, (int) (((long) 4)));
														{	/* Heap/restore.scm 66 */

															if (BGl_backendzd2heapzd2compatiblezf3zf3zzheap_restorez00(BgL_targetz00_540))
																{	/* Heap/restore.scm 68 */
																	BFALSE;
																}
															else
																{	/* Heap/restore.scm 73 */
																	obj_t BgL_arg1434z00_546;

																	{	/* Heap/restore.scm 73 */
																		obj_t BgL_arg1437z00_547;

																		{	/* Heap/restore.scm 73 */
																			obj_t BgL_arg1442z00_550;

																			BgL_arg1442z00_550 =
																				BGl_thezd2backendzd2zzbackend_backendz00
																				();
																			BgL_arg1437z00_547 =
																				(((BgL_backendz00_bglt)
																					CREF(((BgL_backendz00_bglt)
																							BgL_arg1442z00_550)))->
																				BgL_languagez00);
																		}
																		{	/* Heap/restore.scm 71 */
																			obj_t BgL_list1438z00_548;

																			{	/* Heap/restore.scm 71 */
																				obj_t BgL_arg1439z00_549;

																				BgL_arg1439z00_549 =
																					MAKE_PAIR(BgL_arg1437z00_547, BNIL);
																				BgL_list1438z00_548 =
																					MAKE_PAIR(BgL_targetz00_540,
																					BgL_arg1439z00_549);
																			}
																			BgL_arg1434z00_546 =
																				BGl_formatz00zz__r4_output_6_10_3z00
																				(BGl_string1757z00zzheap_restorez00,
																				BgL_list1438z00_548);
																		}
																	}
																	BGl_errorz00zz__errorz00
																		(BGl_za2heapzd2nameza2zd2zzengine_paramz00,
																		BGl_string1758z00zzheap_restorez00,
																		BgL_arg1434z00_546);
																}
															{	/* Heap/restore.scm 74 */
																bool_t BgL_testz00_1285;

																if (CBOOL
																	(BGl_za2unsafezd2heapza2zd2zzengine_paramz00))
																	{	/* Heap/restore.scm 74 */
																		BgL_testz00_1285 = ((bool_t) 1);
																	}
																else
																	{	/* Heap/restore.scm 74 */
																		BgL_testz00_1285 =
																			BGl_equalzf3zf3zz__r4_equivalence_6_2z00
																			(BgL_versionz00_541,
																			BGl_za2bigloozd2versionza2zd2zzengine_paramz00);
																	}
																if (BgL_testz00_1285)
																	{	/* Heap/restore.scm 74 */
																		BFALSE;
																	}
																else
																	{	/* Heap/restore.scm 78 */
																		obj_t BgL_arg1446z00_552;

																		{	/* Heap/restore.scm 78 */
																			obj_t BgL_list1447z00_553;

																			{	/* Heap/restore.scm 78 */
																				obj_t BgL_arg1448z00_554;

																				BgL_arg1448z00_554 =
																					MAKE_PAIR
																					(BGl_za2bigloozd2versionza2zd2zzengine_paramz00,
																					BNIL);
																				BgL_list1447z00_553 =
																					MAKE_PAIR(BgL_versionz00_541,
																					BgL_arg1448z00_554);
																			}
																			BgL_arg1446z00_552 =
																				BGl_formatz00zz__r4_output_6_10_3z00
																				(BGl_string1759z00zzheap_restorez00,
																				BgL_list1447z00_553);
																		}
																		BGl_errorz00zz__errorz00
																			(BGl_za2heapzd2nameza2zd2zzengine_paramz00,
																			BGl_string1760z00zzheap_restorez00,
																			BgL_arg1446z00_552);
																	}
															}
															{	/* Heap/restore.scm 81 */
																bool_t BgL_testz00_1293;

																if (CBOOL
																	(BGl_za2unsafezd2heapza2zd2zzengine_paramz00))
																	{	/* Heap/restore.scm 81 */
																		BgL_testz00_1293 = ((bool_t) 1);
																	}
																else
																	{	/* Heap/restore.scm 81 */
																		BgL_testz00_1293 =
																			BGl_equalzf3zf3zz__r4_equivalence_6_2z00
																			(BgL_specificz00_542,
																			BGl_za2bigloozd2specificzd2versionza2z00zzengine_paramz00);
																	}
																if (BgL_testz00_1293)
																	{	/* Heap/restore.scm 81 */
																		BFALSE;
																	}
																else
																	{	/* Heap/restore.scm 85 */
																		obj_t BgL_arg1450z00_556;

																		{	/* Heap/restore.scm 85 */
																			obj_t BgL_list1451z00_557;

																			{	/* Heap/restore.scm 85 */
																				obj_t BgL_arg1454z00_558;

																				BgL_arg1454z00_558 =
																					MAKE_PAIR
																					(BGl_za2bigloozd2specificzd2versionza2z00zzengine_paramz00,
																					BNIL);
																				BgL_list1451z00_557 =
																					MAKE_PAIR(BgL_specificz00_542,
																					BgL_arg1454z00_558);
																			}
																			BgL_arg1450z00_556 =
																				BGl_formatz00zz__r4_output_6_10_3z00
																				(BGl_string1759z00zzheap_restorez00,
																				BgL_list1451z00_557);
																		}
																		BGl_errorz00zz__errorz00
																			(BGl_za2heapzd2nameza2zd2zzengine_paramz00,
																			BGl_string1761z00zzheap_restorez00,
																			BgL_arg1450z00_556);
																	}
															}
															BGl_setzd2genvz12zc0zzast_envz00(BgL_genvz00_543);
															BGl_setzd2tenvz12zc0zztype_envz00
																(BgL_tenvz00_544);
															if (CBOOL
																(BGl_za2callzf2cczf3za2z01zzengine_paramz00))
																{	/* Heap/restore.scm 93 */
																	BFALSE;
																}
															else
																{	/* Heap/restore.scm 93 */
																	BGl_unbindzd2callzf2ccz12z32zzheap_restorez00
																		();
																}
															{	/* Heap/restore.scm 96 */
																bool_t BgL_testz00_1306;

																{	/* Heap/restore.scm 96 */
																	obj_t BgL_arg1479z00_569;

																	BgL_arg1479z00_569 =
																		BGl_thezd2backendzd2zzbackend_backendz00();
																	BgL_testz00_1306 =
																		(((BgL_backendz00_bglt) CREF(
																				((BgL_backendz00_bglt)
																					BgL_arg1479z00_569)))->
																		BgL_qualifiedzd2typeszd2);
																}
																if (BgL_testz00_1306)
																	{	/* Heap/restore.scm 96 */
																		BGl_forzd2eachzd2globalz12z12zzast_envz00
																			(BGl_proc1762z00zzheap_restorez00, BNIL);
																		BgL_genvz00_543;
																	}
																else
																	{	/* Heap/restore.scm 96 */
																		BFALSE;
																	}
															}
															BGl_forzd2eachzd2globalz12z12zzast_envz00
																(BGl_proc1763z00zzheap_restorez00, BNIL);
															BgL_val1073z00_537 = ((bool_t) 1);
														}
													}
												}
											}
										}
									}
								}
							}
							POP_EXIT();
							return BBOOL(BgL_val1073z00_537);
						}
					}
				}
		}
	}



/* &restore-heap */
	obj_t BGl_z62restorezd2heapzb0zzheap_restorez00(obj_t BgL_envz00_1116)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 43 */
			return BGl_restorezd2heapzd2zzheap_restorez00();
		}
	}



/* &<anonymous:1483> */
	obj_t BGl_z62zc3anonymousza31483ze3ze1zzheap_restorez00(obj_t BgL_envz00_1117,
		obj_t BgL_newz00_1118)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 106 */
			{
				obj_t BgL_newz00_572;

				BgL_newz00_572 = BgL_newz00_1118;
				{	/* Heap/restore.scm 107 */
					obj_t BgL_arg1486z00_1032;

					BgL_arg1486z00_1032 =
						(((BgL_globalz00_bglt) CREF(
								((BgL_globalz00_bglt) BgL_newz00_572)))->BgL_modulez00);
					{	/* Heap/restore.scm 107 */
						obj_t BgL_list1487z00_1033;

						BgL_list1487z00_1033 = MAKE_PAIR(BgL_arg1486z00_1032, BNIL);
						return
							BGl_heapzd2modulezd2listz00zzheap_restorez00
							(BgL_list1487z00_1033);
					}
				}
			}
		}
	}



/* &<anonymous:1458> */
	obj_t BGl_z62zc3anonymousza31458ze3ze1zzheap_restorez00(obj_t BgL_envz00_1119,
		obj_t BgL_newz00_1120)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 98 */
			{
				obj_t BgL_newz00_562;

				BgL_newz00_562 = BgL_newz00_1120;
				{	/* Heap/restore.scm 100 */
					obj_t BgL_arg1473z00_564;
					obj_t BgL_arg1474z00_565;
					obj_t BgL_arg1476z00_566;

					BgL_arg1473z00_564 =
						(((BgL_globalz00_bglt) CREF(
								((BgL_globalz00_bglt) BgL_newz00_562)))->BgL_modulez00);
					BgL_arg1474z00_565 =
						(((BgL_globalz00_bglt) CREF(
								((BgL_globalz00_bglt) BgL_newz00_562)))->
						BgL_jvmzd2typezd2namez00);
					BgL_arg1476z00_566 = BGl_shapez00zztools_shapez00(BgL_newz00_562);
					{	/* Heap/restore.scm 99 */
						obj_t BgL_list1477z00_567;

						BgL_list1477z00_567 = MAKE_PAIR(BgL_arg1476z00_566, BNIL);
						return
							BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(BgL_arg1473z00_564,
							BgL_arg1474z00_565, BgL_list1477z00_567);
					}
				}
			}
		}
	}



/* unbind-call/cc! */
	obj_t BGl_unbindzd2callzf2ccz12z32zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 117 */
			if (CBOOL(BGl_findzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long)
								3)), CNST_TABLE_REF(((long) 4)))))
				{	/* Heap/restore.scm 118 */
					BGl_unbindzd2globalz12zc0zzast_envz00(CNST_TABLE_REF(((long) 3)),
						CNST_TABLE_REF(((long) 4)));
				}
			else
				{	/* Heap/restore.scm 118 */
					BFALSE;
				}
			if (CBOOL(BGl_findzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long)
								5)), CNST_TABLE_REF(((long) 4)))))
				{	/* Heap/restore.scm 120 */
					return
						BGl_unbindzd2globalz12zc0zzast_envz00(CNST_TABLE_REF(((long) 5)),
						CNST_TABLE_REF(((long) 4)));
				}
			else
				{	/* Heap/restore.scm 120 */
					return BFALSE;
				}
		}
	}



/* restore-additional-heaps */
	BGL_EXPORTED_DEF obj_t BGl_restorezd2additionalzd2heapsz00zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 128 */
			if (PAIRP(BGl_za2additionalzd2heapzd2namesza2z00zzengine_paramz00))
				{	/* Heap/restore.scm 130 */
					obj_t BgL_sufz00_587;

					{	/* Heap/restore.scm 130 */
						obj_t BgL_arg1536z00_614;

						{	/* Heap/restore.scm 130 */
							obj_t BgL_arg1537z00_615;

							BgL_arg1537z00_615 = BGl_thezd2backendzd2zzbackend_backendz00();
							BgL_arg1536z00_614 =
								(((BgL_backendz00_bglt) CREF(
										((BgL_backendz00_bglt) BgL_arg1537z00_615)))->
								BgL_heapzd2suffixzd2);
						}
						BgL_sufz00_587 =
							string_append(BGl_string1764z00zzheap_restorez00,
							BgL_arg1536z00_614);
					}
					{	/* Heap/restore.scm 131 */
						obj_t BgL_list1501z00_588;

						{	/* Heap/restore.scm 131 */
							obj_t BgL_arg1506z00_589;

							{	/* Heap/restore.scm 131 */
								obj_t BgL_arg1507z00_590;

								BgL_arg1507z00_590 =
									MAKE_PAIR(BCHAR(((unsigned char) '\n')), BNIL);
								BgL_arg1506z00_589 =
									MAKE_PAIR(BGl_string1765z00zzheap_restorez00,
									BgL_arg1507z00_590);
							}
							BgL_list1501z00_588 =
								MAKE_PAIR(BGl_string1751z00zzheap_restorez00,
								BgL_arg1506z00_589);
						}
						BGl_verbosez00zztools_speekz00(BINT(((long) 1)),
							BgL_list1501z00_588);
					}
					BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 =
						BINT(((long) 0));
					BGl_za2currentzd2passza2zd2zzengine_passz00 =
						BGl_string1765z00zzheap_restorez00;
					{
						obj_t BgL_hooksz00_594;
						obj_t BgL_hnamesz00_595;

						BgL_hooksz00_594 = BNIL;
						BgL_hnamesz00_595 = BNIL;
					BgL_zc3anonymousza31508ze3z83_596:
						if (NULLP(BgL_hooksz00_594))
							{	/* Heap/restore.scm 131 */
								CNST_TABLE_REF(((long) 1));
							}
						else
							{	/* Heap/restore.scm 131 */
								bool_t BgL_testz00_1358;

								{	/* Heap/restore.scm 131 */
									obj_t BgL_fun1522z00_602;

									BgL_fun1522z00_602 = CAR(BgL_hooksz00_594);
									BgL_testz00_1358 =
										CBOOL(PROCEDURE_ENTRY(BgL_fun1522z00_602)
										(BgL_fun1522z00_602, BEOA));
								}
								if (BgL_testz00_1358)
									{
										obj_t BgL_hnamesz00_1366;
										obj_t BgL_hooksz00_1364;

										BgL_hooksz00_1364 = CDR(BgL_hooksz00_594);
										BgL_hnamesz00_1366 = CDR(BgL_hnamesz00_595);
										BgL_hnamesz00_595 = BgL_hnamesz00_1366;
										BgL_hooksz00_594 = BgL_hooksz00_1364;
										goto BgL_zc3anonymousza31508ze3z83_596;
									}
								else
									{	/* Heap/restore.scm 131 */
										BGl_internalzd2errorzd2zztools_errorz00
											(BGl_string1765z00zzheap_restorez00,
											BGl_string1752z00zzheap_restorez00,
											CAR(BgL_hnamesz00_595));
									}
							}
					}
					{	/* Heap/restore.scm 132 */
						obj_t BgL_g1358z00_605;

						BgL_g1358z00_605 =
							bgl_reverse
							(BGl_za2additionalzd2heapzd2namesza2z00zzengine_paramz00);
						{
							obj_t BgL_l1356z00_607;

							{	/* Heap/restore.scm 134 */
								bool_t BgL_auxz00_1371;

								BgL_l1356z00_607 = BgL_g1358z00_605;
							BgL_zc3anonymousza31524ze3z83_608:
								if (PAIRP(BgL_l1356z00_607))
									{	/* Heap/restore.scm 134 */
										{	/* Heap/restore.scm 133 */
											obj_t BgL_hz00_610;

											BgL_hz00_610 = CAR(BgL_l1356z00_607);
											BGl_restorezd2additionalzd2heapz00zzheap_restorez00
												(string_append(BgL_hz00_610, BgL_sufz00_587));
										}
										{
											obj_t BgL_l1356z00_1377;

											BgL_l1356z00_1377 = CDR(BgL_l1356z00_607);
											BgL_l1356z00_607 = BgL_l1356z00_1377;
											goto BgL_zc3anonymousza31524ze3z83_608;
										}
									}
								else
									{	/* Heap/restore.scm 134 */
										BgL_auxz00_1371 = ((bool_t) 1);
									}
								return BBOOL(BgL_auxz00_1371);
							}
						}
					}
				}
			else
				{	/* Heap/restore.scm 129 */
					return BFALSE;
				}
		}
	}



/* &restore-additional-heaps */
	obj_t BGl_z62restorezd2additionalzd2heapsz62zzheap_restorez00(obj_t
		BgL_envz00_1121)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 128 */
			return BGl_restorezd2additionalzd2heapsz00zzheap_restorez00();
		}
	}



/* restore-additional-heap */
	BGL_EXPORTED_DEF obj_t
		BGl_restorezd2additionalzd2heapz00zzheap_restorez00(obj_t BgL_heapz00_4)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 139 */
			{	/* Heap/restore.scm 140 */
				obj_t BgL_fnamez00_616;

				BgL_fnamez00_616 =
					BGl_findzd2filezf2pathz20zz__osz00(BgL_heapz00_4,
					BGl_za2libzd2dirza2zd2zzengine_paramz00);
				if (STRINGP(BgL_fnamez00_616))
					{	/* Heap/restore.scm 142 */
						obj_t BgL_portz00_618;

						BgL_portz00_618 =
							BGl_openzd2inputzd2binaryzd2filezd2zz__binaryz00
							(BgL_fnamez00_616);
						if (BINARY_PORTP(BgL_portz00_618))
							{	/* Heap/restore.scm 143 */
								{	/* Heap/restore.scm 148 */
									obj_t BgL_list1540z00_620;

									{	/* Heap/restore.scm 148 */
										obj_t BgL_arg1543z00_621;

										{	/* Heap/restore.scm 148 */
											obj_t BgL_arg1546z00_622;

											{	/* Heap/restore.scm 148 */
												obj_t BgL_arg1548z00_623;

												BgL_arg1548z00_623 =
													MAKE_PAIR(BCHAR(((unsigned char) '\n')), BNIL);
												BgL_arg1546z00_622 =
													MAKE_PAIR(BGl_string1753z00zzheap_restorez00,
													BgL_arg1548z00_623);
											}
											BgL_arg1543z00_621 =
												MAKE_PAIR(BgL_fnamez00_616, BgL_arg1546z00_622);
										}
										BgL_list1540z00_620 =
											MAKE_PAIR(BGl_string1754z00zzheap_restorez00,
											BgL_arg1543z00_621);
									}
									BGl_verbosez00zztools_speekz00(BINT(((long) 2)),
										BgL_list1540z00_620);
								}
								{	/* Heap/restore.scm 149 */
									obj_t BgL_val1076z00_624;

									BgL_val1076z00_624 =
										BGl_zc3exitza31559ze3z83zzheap_restorez00(BgL_heapz00_4,
										BgL_portz00_618);
									close_binary_port(BgL_portz00_618);
									if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
											(BgL_val1076z00_624)))
										{	/* Heap/restore.scm 212 */
											return
												BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
												(BgL_val1076z00_624), CDR(BgL_val1076z00_624));
										}
									else
										{	/* Heap/restore.scm 212 */
											return BgL_val1076z00_624;
										}
								}
							}
						else
							{	/* Heap/restore.scm 144 */
								obj_t BgL_mz00_683;

								{	/* Heap/restore.scm 144 */
									obj_t BgL_list1648z00_684;

									BgL_list1648z00_684 = MAKE_PAIR(BgL_fnamez00_616, BNIL);
									BgL_mz00_683 =
										BGl_formatz00zz__r4_output_6_10_3z00
										(BGl_string1755z00zzheap_restorez00, BgL_list1648z00_684);
								}
								BGl_errorz00zz__errorz00(BGl_string1766z00zzheap_restorez00,
									BgL_mz00_683, BGl_za2libzd2dirza2zd2zzengine_paramz00);
								return BGl_compilerzd2exitzd2zzinit_mainz00(BINT(((long) 6)));
					}}
				else
					{	/* Heap/restore.scm 213 */
						obj_t BgL_mz00_685;

						{	/* Heap/restore.scm 213 */
							obj_t BgL_list1649z00_686;

							BgL_list1649z00_686 = MAKE_PAIR(BgL_heapz00_4, BNIL);
							BgL_mz00_685 =
								BGl_formatz00zz__r4_output_6_10_3z00
								(BGl_string1755z00zzheap_restorez00, BgL_list1649z00_686);
						}
						BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 6)), BgL_mz00_685,
							BGl_za2libzd2dirza2zd2zzengine_paramz00);
						return BGl_compilerzd2exitzd2zzinit_mainz00(BINT(((long) 6)));
		}}}
	}



/* <exit:1559> */
	obj_t BGl_zc3exitza31559ze3z83zzheap_restorez00(obj_t BgL_heapz00_1134,
		obj_t BgL_portz00_1133)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 212 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1077z00_629;

			if (SET_EXIT(BgL_an_exit1077z00_629))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1077z00_629 = (void *) jmpbuf;
					{	/* Heap/restore.scm 212 */

						PUSH_EXIT(BgL_an_exit1077z00_629, ((long) 0));
						{	/* Heap/restore.scm 150 */
							bool_t BgL_val1078z00_630;

							{	/* Heap/restore.scm 150 */
								obj_t BgL_envsz00_631;

								BgL_envsz00_631 = input_obj(BgL_portz00_1133);
								{	/* Heap/restore.scm 150 */
									obj_t BgL__z00_632;

									{	/* Heap/restore.scm 151 */
										bool_t BgL_testz00_1417;

										{	/* Heap/restore.scm 151 */
											bool_t BgL_testz00_1418;

											{	/* Heap/restore.scm 151 */
												obj_t BgL_v1359z00_682;

												BgL_v1359z00_682 = create_vector((int) (((long) 1)));
												VECTOR_SET(BgL_v1359z00_682,
													(int) (((long) 0)), BgL_envsz00_631);
												BgL_testz00_1418 = ((bool_t) 1);
											}
											if (BgL_testz00_1418)
												{	/* Heap/restore.scm 152 */
													int BgL_arg1647z00_681;

													BgL_arg1647z00_681 = VECTOR_LENGTH(BgL_envsz00_631);
													BgL_testz00_1417 =
														((long) (BgL_arg1647z00_681) == ((long) 6));
												}
											else
												{	/* Heap/restore.scm 151 */
													BgL_testz00_1417 = ((bool_t) 0);
												}
										}
										if (BgL_testz00_1417)
											{	/* Heap/restore.scm 151 */
												BgL__z00_632 = BFALSE;
											}
										else
											{	/* Heap/restore.scm 151 */
												BgL__z00_632 =
													BGl_errorz00zz__errorz00(BgL_heapz00_1134,
													BGl_string1756z00zzheap_restorez00, BgL_envsz00_631);
											}
									}
									{	/* Heap/restore.scm 151 */
										obj_t BgL_targetz00_633;

										BgL_targetz00_633 =
											VECTOR_REF(BgL_envsz00_631, (int) (((long) 0)));
										{	/* Heap/restore.scm 154 */
											obj_t BgL_versionz00_634;

											BgL_versionz00_634 =
												VECTOR_REF(BgL_envsz00_631, (int) (((long) 1)));
											{	/* Heap/restore.scm 155 */
												obj_t BgL_specificz00_635;

												BgL_specificz00_635 =
													VECTOR_REF(BgL_envsz00_631, (int) (((long) 2)));
												{	/* Heap/restore.scm 156 */
													obj_t BgL_genvz00_636;

													BgL_genvz00_636 =
														VECTOR_REF(BgL_envsz00_631, (int) (((long) 3)));
													{	/* Heap/restore.scm 157 */
														obj_t BgL_tenvz00_637;

														BgL_tenvz00_637 =
															VECTOR_REF(BgL_envsz00_631, (int) (((long) 4)));
														{	/* Heap/restore.scm 158 */
															obj_t BgL_includesz00_638;

															BgL_includesz00_638 =
																VECTOR_REF(BgL_envsz00_631, (int) (((long) 5)));
															{	/* Heap/restore.scm 159 */

																if (BGl_backendzd2heapzd2compatiblezf3zf3zzheap_restorez00(BgL_targetz00_633))
																	{	/* Heap/restore.scm 161 */
																		BFALSE;
																	}
																else
																	{	/* Heap/restore.scm 166 */
																		obj_t BgL_arg1570z00_640;

																		{	/* Heap/restore.scm 166 */
																			obj_t BgL_arg1572z00_641;

																			{	/* Heap/restore.scm 166 */
																				obj_t BgL_arg1581z00_644;

																				BgL_arg1581z00_644 =
																					BGl_thezd2backendzd2zzbackend_backendz00
																					();
																				BgL_arg1572z00_641 =
																					(((BgL_backendz00_bglt)
																						CREF(((BgL_backendz00_bglt)
																								BgL_arg1581z00_644)))->
																					BgL_languagez00);
																			}
																			{	/* Heap/restore.scm 164 */
																				obj_t BgL_list1573z00_642;

																				{	/* Heap/restore.scm 164 */
																					obj_t BgL_arg1578z00_643;

																					BgL_arg1578z00_643 =
																						MAKE_PAIR(BgL_arg1572z00_641, BNIL);
																					BgL_list1573z00_642 =
																						MAKE_PAIR(BgL_targetz00_633,
																						BgL_arg1578z00_643);
																				}
																				BgL_arg1570z00_640 =
																					BGl_formatz00zz__r4_output_6_10_3z00
																					(BGl_string1757z00zzheap_restorez00,
																					BgL_list1573z00_642);
																			}
																		}
																		BGl_errorz00zz__errorz00(BgL_heapz00_1134,
																			BGl_string1758z00zzheap_restorez00,
																			BgL_arg1570z00_640);
																	}
																if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00
																	(BgL_versionz00_634,
																		BGl_za2bigloozd2versionza2zd2zzengine_paramz00))
																	{	/* Heap/restore.scm 167 */
																		BFALSE;
																	}
																else
																	{	/* Heap/restore.scm 170 */
																		obj_t BgL_arg1587z00_646;

																		{	/* Heap/restore.scm 170 */
																			obj_t BgL_list1588z00_647;

																			{	/* Heap/restore.scm 170 */
																				obj_t BgL_arg1596z00_648;

																				BgL_arg1596z00_648 =
																					MAKE_PAIR
																					(BGl_za2bigloozd2versionza2zd2zzengine_paramz00,
																					BNIL);
																				BgL_list1588z00_647 =
																					MAKE_PAIR(BgL_versionz00_634,
																					BgL_arg1596z00_648);
																			}
																			BgL_arg1587z00_646 =
																				BGl_formatz00zz__r4_output_6_10_3z00
																				(BGl_string1759z00zzheap_restorez00,
																				BgL_list1588z00_647);
																		}
																		BGl_errorz00zz__errorz00
																			(BGl_za2heapzd2nameza2zd2zzengine_paramz00,
																			BGl_string1760z00zzheap_restorez00,
																			BgL_arg1587z00_646);
																	}
																if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00
																	(BgL_specificz00_635,
																		BGl_za2bigloozd2specificzd2versionza2z00zzengine_paramz00))
																	{	/* Heap/restore.scm 173 */
																		BFALSE;
																	}
																else
																	{	/* Heap/restore.scm 176 */
																		obj_t BgL_arg1599z00_650;

																		{	/* Heap/restore.scm 176 */
																			obj_t BgL_list1600z00_651;

																			{	/* Heap/restore.scm 176 */
																				obj_t BgL_arg1602z00_652;

																				BgL_arg1602z00_652 =
																					MAKE_PAIR
																					(BGl_za2bigloozd2specificzd2versionza2z00zzengine_paramz00,
																					BNIL);
																				BgL_list1600z00_651 =
																					MAKE_PAIR(BgL_specificz00_635,
																					BgL_arg1602z00_652);
																			}
																			BgL_arg1599z00_650 =
																				BGl_formatz00zz__r4_output_6_10_3z00
																				(BGl_string1759z00zzheap_restorez00,
																				BgL_list1600z00_651);
																		}
																		BGl_errorz00zz__errorz00
																			(BGl_za2heapzd2nameza2zd2zzengine_paramz00,
																			BGl_string1761z00zzheap_restorez00,
																			BgL_arg1599z00_650);
																	}
																BGl_addzd2tenvz12zc0zztype_envz00
																	(BgL_tenvz00_637);
																BGl_addzd2genvz12zc0zzast_envz00
																	(BgL_genvz00_636);
																{	/* Heap/restore.scm 192 */
																	bool_t BgL_testz00_1462;

																	{	/* Heap/restore.scm 192 */
																		obj_t BgL_arg1632z00_663;

																		BgL_arg1632z00_663 =
																			BGl_thezd2backendzd2zzbackend_backendz00
																			();
																		BgL_testz00_1462 =
																			(((BgL_backendz00_bglt)
																				CREF(((BgL_backendz00_bglt)
																						BgL_arg1632z00_663)))->
																			BgL_qualifiedzd2typeszd2);
																	}
																	if (BgL_testz00_1462)
																		{	/* Heap/restore.scm 192 */
																			BGl_forzd2eachzd2globalz12z12zzast_envz00
																				(BGl_proc1767z00zzheap_restorez00,
																				BNIL);
																		}
																	else
																		{	/* Heap/restore.scm 192 */
																			BFALSE;
																		}
																}
																BGl_hashtablezd2forzd2eachz00zz__hashz00
																	(BgL_genvz00_636,
																	BGl_proc1768z00zzheap_restorez00);
																BGl_za2additionalzd2includezd2foreignza2z00zzengine_paramz00
																	=
																	BGl_appendzd221011zd2zzheap_restorez00
																	(BGl_za2additionalzd2includezd2foreignza2z00zzengine_paramz00,
																	BgL_includesz00_638);
																BgL_val1078z00_630 = ((bool_t) 1);
															}
														}
													}
												}
											}
										}
									}
								}
							}
							POP_EXIT();
							return BBOOL(BgL_val1078z00_630);
						}
					}
				}
		}
	}



/* &restore-additional-heap */
	obj_t BGl_z62restorezd2additionalzd2heapz62zzheap_restorez00(obj_t
		BgL_envz00_1124, obj_t BgL_heapz00_1125)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 139 */
			return
				BGl_restorezd2additionalzd2heapz00zzheap_restorez00(BgL_heapz00_1125);
		}
	}



/* &<anonymous:1634> */
	obj_t BGl_z62zc3anonymousza31634ze3ze1zzheap_restorez00(obj_t BgL_envz00_1126,
		obj_t BgL_kz00_1127, obj_t BgL_bucketz00_1128)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 202 */
			{
				obj_t BgL_kz00_665;
				obj_t BgL_bucketz00_666;

				{	/* Heap/restore.scm 203 */
					bool_t BgL_auxz00_1472;

					BgL_kz00_665 = BgL_kz00_1127;
					BgL_bucketz00_666 = BgL_bucketz00_1128;
					{	/* Heap/restore.scm 203 */
						obj_t BgL_g1362z00_668;

						BgL_g1362z00_668 = CDR(BgL_bucketz00_666);
						{
							obj_t BgL_l1360z00_670;

							BgL_l1360z00_670 = BgL_g1362z00_668;
						BgL_zc3anonymousza31635ze3z83_671:
							if (PAIRP(BgL_l1360z00_670))
								{	/* Heap/restore.scm 206 */
									{	/* Heap/restore.scm 204 */
										obj_t BgL_newz00_673;

										BgL_newz00_673 = CAR(BgL_l1360z00_670);
										{	/* Heap/restore.scm 205 */
											obj_t BgL_arg1638z00_674;

											BgL_arg1638z00_674 =
												(((BgL_globalz00_bglt) CREF(
														((BgL_globalz00_bglt) BgL_newz00_673)))->
												BgL_modulez00);
											{	/* Heap/restore.scm 204 */
												obj_t BgL_list1639z00_675;

												BgL_list1639z00_675 =
													MAKE_PAIR(BgL_arg1638z00_674, BNIL);
												BGl_heapzd2modulezd2listz00zzheap_restorez00
													(BgL_list1639z00_675);
											}
										}
									}
									{
										obj_t BgL_l1360z00_1481;

										BgL_l1360z00_1481 = CDR(BgL_l1360z00_670);
										BgL_l1360z00_670 = BgL_l1360z00_1481;
										goto BgL_zc3anonymousza31635ze3z83_671;
									}
								}
							else
								{	/* Heap/restore.scm 206 */
									BgL_auxz00_1472 = ((bool_t) 1);
								}
						}
					}
					return BBOOL(BgL_auxz00_1472);
				}
			}
		}
	}



/* &<anonymous:1611> */
	obj_t BGl_z62zc3anonymousza31611ze3ze1zzheap_restorez00(obj_t BgL_envz00_1129,
		obj_t BgL_newz00_1130)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 194 */
			{
				obj_t BgL_newz00_656;

				BgL_newz00_656 = BgL_newz00_1130;
				{	/* Heap/restore.scm 196 */
					obj_t BgL_arg1615z00_658;
					obj_t BgL_arg1624z00_659;
					obj_t BgL_arg1625z00_660;

					BgL_arg1615z00_658 =
						(((BgL_globalz00_bglt) CREF(
								((BgL_globalz00_bglt) BgL_newz00_656)))->BgL_modulez00);
					BgL_arg1624z00_659 =
						(((BgL_globalz00_bglt) CREF(
								((BgL_globalz00_bglt) BgL_newz00_656)))->
						BgL_jvmzd2typezd2namez00);
					BgL_arg1625z00_660 = BGl_shapez00zztools_shapez00(BgL_newz00_656);
					{	/* Heap/restore.scm 195 */
						obj_t BgL_list1626z00_661;

						BgL_list1626z00_661 = MAKE_PAIR(BgL_arg1625z00_660, BNIL);
						return
							BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(BgL_arg1615z00_658,
							BgL_arg1624z00_659, BgL_list1626z00_661);
					}
				}
			}
		}
	}



/* heap-module-list */
	BGL_EXPORTED_DEF obj_t BGl_heapzd2modulezd2listz00zzheap_restorez00(obj_t
		BgL_argsz00_5)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 233 */
			if (NULLP(BgL_argsz00_5))
				{	/* Heap/restore.scm 235 */
					return BGl_za2heapzd2modulezd2listza2z00zzheap_restorez00;
				}
			else
				{	/* Heap/restore.scm 235 */
					if (CBOOL(BGl_getpropz00zz__r4_symbols_6_4z00(CAR(BgL_argsz00_5),
								CNST_TABLE_REF(((long) 0)))))
						{	/* Heap/restore.scm 237 */
							return BFALSE;
						}
					else
						{	/* Heap/restore.scm 237 */
							{	/* Heap/restore.scm 238 */
								obj_t BgL_arg1653z00_689;

								BgL_arg1653z00_689 = CAR(BgL_argsz00_5);
								BGl_putpropz12z12zz__r4_symbols_6_4z00(BgL_arg1653z00_689,
									CNST_TABLE_REF(((long) 0)), BTRUE);
							}
							{	/* Heap/restore.scm 239 */
								obj_t BgL_arg1661z00_690;

								BgL_arg1661z00_690 = CAR(BgL_argsz00_5);
								return (BGl_za2heapzd2modulezd2listza2z00zzheap_restorez00 =
									MAKE_PAIR(BgL_arg1661z00_690,
										BGl_za2heapzd2modulezd2listza2z00zzheap_restorez00),
									BUNSPEC);
							}
						}
				}
		}
	}



/* &heap-module-list */
	obj_t BGl_z62heapzd2modulezd2listz62zzheap_restorez00(obj_t BgL_envz00_1131,
		obj_t BgL_argsz00_1132)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 233 */
			return BGl_heapzd2modulezd2listz00zzheap_restorez00(BgL_argsz00_1132);
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 15 */
			return BUNSPEC;
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 15 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 15 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 15 */
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 61247943),
				BSTRING_TO_STRING(BGl_string1769z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string1769z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zzengine_passz00(((long) 373082237),
				BSTRING_TO_STRING(BGl_string1769z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 462549608),
				BSTRING_TO_STRING(BGl_string1769z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zzengine_enginez00(((long) 373986149),
				BSTRING_TO_STRING(BGl_string1769z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zzinit_mainz00(((long) 288050968),
				BSTRING_TO_STRING(BGl_string1769z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string1769z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string1769z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 296457443),
				BSTRING_TO_STRING(BGl_string1769z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string1769z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zzread_jvmz00(((long) 261574382),
				BSTRING_TO_STRING(BGl_string1769z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string1769z00zzheap_restorez00));
			return
				BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 57787772),
				BSTRING_TO_STRING(BGl_string1769z00zzheap_restorez00));
		}
	}

#ifdef __cplusplus
}
#endif
