/*===========================================================================*/
/*   (Eval/evaluate.scm)                                                     */
/*   Bigloo (4.0a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jan 24 17:03:30 CET 2013        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -srfi enable-gmp -srfi bigloo-unsafe -O3 -fcfa-arithmetic -q +rm -lib-dir /users/serrano/prgm/project/bigloo/lib/4.0a -mklib -cc gcc -fsharing -q -no-hello -copt -fPIC -unsafe -safee -O4 -c Eval/evaluate.scm -indent -o objs/obj_u/Eval/evaluate.c)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_ev_exprz00_bgl
	{
		header_t header;
		obj_t widening;
	}                 *BgL_ev_exprz00_bglt;

	typedef struct BgL_ev_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_namez00;
		obj_t BgL_effz00;
		obj_t BgL_typez00;
	}                *BgL_ev_varz00_bglt;

	typedef struct BgL_ev_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                   *BgL_ev_globalz00_bglt;

	typedef struct BgL_ev_littz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_valuez00;
	}                 *BgL_ev_littz00_bglt;

	typedef struct BgL_ev_ifz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_pz00;
		struct BgL_ev_exprz00_bgl *BgL_tz00;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}               *BgL_ev_ifz00_bglt;

	typedef struct BgL_ev_listz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                 *BgL_ev_listz00_bglt;

	typedef struct BgL_ev_orz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}               *BgL_ev_orz00_bglt;

	typedef struct BgL_ev_andz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                *BgL_ev_andz00_bglt;

	typedef struct BgL_ev_prog2z00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_e1z00;
		struct BgL_ev_exprz00_bgl *BgL_e2z00;
	}                  *BgL_ev_prog2z00_bglt;

	typedef struct BgL_ev_hookz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_hookz00_bglt;

	typedef struct BgL_ev_trapz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_trapz00_bglt;

	typedef struct BgL_ev_setlocalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_varz00_bgl *BgL_vz00;
	}                     *BgL_ev_setlocalz00_bglt;

	typedef struct BgL_ev_setglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_setglobalz00_bglt;

	typedef struct BgL_ev_defglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_defglobalz00_bglt;

	typedef struct BgL_ev_bindzd2exitzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_varz00_bgl *BgL_varz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                        *BgL_ev_bindzd2exitzd2_bglt;

	typedef struct BgL_ev_unwindzd2protectzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                             *BgL_ev_unwindzd2protectzd2_bglt;

	typedef struct BgL_ev_withzd2handlerzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_handlerz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                           *BgL_ev_withzd2handlerzd2_bglt;

	typedef struct BgL_ev_synchroniza7eza7_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_mutexz00;
		struct BgL_ev_exprz00_bgl *BgL_prelockz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                          *BgL_ev_synchroniza7eza7_bglt;

	typedef struct BgL_ev_binderz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_binderz00_bglt;

	typedef struct BgL_ev_letz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_letz00_bglt;

	typedef struct BgL_ev_letza2za2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_letza2za2_bglt;

	typedef struct BgL_ev_letrecz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_letrecz00_bglt;

	typedef struct BgL_ev_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_tailzf3zf3;
	}                *BgL_ev_appz00_bglt;

	typedef struct BgL_ev_absz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_wherez00;
		obj_t BgL_arityz00;
		obj_t BgL_varsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		int BgL_siza7eza7;
		obj_t BgL_bindz00;
		obj_t BgL_freez00;
		obj_t BgL_innerz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_absz00_bglt;


	static obj_t BGl_symbol2641z00zz__evaluatez00 = BUNSPEC;
	static BgL_ev_appz00_bglt
		BGl_makezd2classzd2fieldzd2setzd2zz__evaluatez00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_keyword2691z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_ev_defglobalz00zz__evaluate_typesz00;
	static obj_t BGl_symbol2650z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2653z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2655z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_convzd2beginzd2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, bool_t);
	extern obj_t BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
	static obj_t BGl_symbol2657z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2659z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_requirezd2initializa7ationz75zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2661z00zz__evaluatez00 = BUNSPEC;
	extern bool_t BGl_classzd2fieldzf3z21zz__objectz00(obj_t);
	static obj_t BGl_symbol2663z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2665z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2667z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2669z00zz__evaluatez00 = BUNSPEC;
	extern BgL_ev_exprz00_bglt
		BGl_extractzd2loopszd2zz__evaluate_fsiza7eza7(BgL_ev_exprz00_bglt);
	BGL_EXPORTED_DECL obj_t
		BGl_setzd2evaluationzd2contextz12z12zz__evaluatez00(obj_t);
	static obj_t BGl_symbol2671z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_getzd2locationzd2zz__evaluatez00(obj_t, obj_t);
	static obj_t BGl_symbol2673z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2675z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2677z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2679z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_ev_letrecz00zz__evaluate_typesz00;
	static obj_t BGl_symbol2681z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2683z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2685z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2687z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2689z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(obj_t);
	extern obj_t BGl_ev_letz00zz__evaluate_typesz00;
	extern obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	static obj_t BGl_symbol2693z00zz__evaluatez00 = BUNSPEC;
	extern obj_t bgl_reverse(obj_t);
	static obj_t BGl_genericzd2initzd2zz__evaluatez00();
	extern obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	extern obj_t BGl_classzd2existszd2zz__objectz00(obj_t);
	extern obj_t BGl_ev_prog2z00zz__evaluate_typesz00;
	extern int BGl_framezd2siza7ez75zz__evaluate_fsiza7eza7(BgL_ev_exprz00_bglt);
	static obj_t BGl_objectzd2initzd2zz__evaluatez00();
	extern bool_t BGl_classzd2fieldzd2mutablezf3zf3zz__objectz00(obj_t);
	extern obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00;
	extern bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
	static obj_t BGl_convzd2fieldzd2refz00zz__evaluatez00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, bool_t);
	static obj_t BGl_z62getzd2evaluationzd2contextz62zz__evaluatez00(obj_t);
	extern obj_t bgl_reverse_bang(obj_t);
	extern obj_t BGl_valzd2fromzd2exitzf3zf3zz__bexitz00(obj_t);
	static obj_t BGl_zc3exitza31321ze3z83zz__evaluatez00(obj_t, obj_t);
	extern obj_t BGl_findzd2classzd2fieldz00zz__objectz00(obj_t, obj_t);
	extern obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00;
	extern obj_t BGl_ppz00zz__ppz00(obj_t, obj_t);
	extern obj_t bstring_to_symbol(obj_t);
	extern bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t BGl_convzd2fieldzd2setz00zz__evaluatez00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, bool_t);
	extern obj_t BGl_classzd2fieldzd2mutatorz00zz__objectz00(obj_t);
	extern obj_t make_vector(int, obj_t);
	extern obj_t BGl_ev_letza2za2zz__evaluate_typesz00;
	static obj_t BGl_convzd2varzd2zz__evaluatez00(obj_t, obj_t);
	static obj_t BGl_appendzd221011zd2zz__evaluatez00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zz__evaluatez00();
	extern obj_t BGl_ev_absz00zz__evaluate_typesz00;
	extern obj_t BGl_ev_trapz00zz__evaluate_typesz00;
	static BgL_ev_absz00_bglt BGl_convzd2lambdazd2zz__evaluatez00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_ev_setglobalz00zz__evaluate_typesz00;
	extern obj_t string_append(obj_t, obj_t);
	extern obj_t BGl_classzd2fieldzd2accessorz00zz__objectz00(obj_t);
	extern obj_t BGl_ev_ifz00zz__evaluate_typesz00;
	extern obj_t BGl_analysezd2varszd2zz__evaluate_avarz00(BgL_ev_exprz00_bglt);
	extern obj_t BGl_substringz00zz__r4_strings_6_7z00(obj_t, long, long);
	extern obj_t BGl_findzd2statezd2zz__evaluate_compz00();
	extern obj_t BGl_evmodulez00zz__evmodulez00(obj_t, obj_t);
	static obj_t BGl_untypezd2identzd2zz__evaluatez00(obj_t);
	extern obj_t BGl_classzd2fieldzd2typez00zz__objectz00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__evaluatez00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_fsiza7eza7(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_avarz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evmodulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__everrorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evcompilez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evenvz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__expandz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__prognz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__ppz00(long, char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
	extern obj_t BGl_expandz00zz__expandz00(obj_t);
	static obj_t BGl_z62setzd2evaluationzd2contextz12z70zz__evaluatez00(obj_t,
		obj_t);
	extern obj_t BGl_ev_globalz00zz__evaluate_typesz00;
	extern obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	extern bool_t BGl_classzf3zf3zz__objectz00(obj_t);
	extern int bgl_debug();
	extern obj_t BGl_ev_littz00zz__evaluate_typesz00;
	extern obj_t BGl_ev_orz00zz__evaluate_typesz00;
	extern obj_t BGl_ev_varz00zz__evaluate_typesz00;
	extern obj_t BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t string_to_symbol(char *);
	static obj_t BGl_z62evaluate2z62zz__evaluatez00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_cnstzd2initzd2zz__evaluatez00();
	static obj_t BGl_importedzd2moduleszd2initz00zz__evaluatez00();
	extern obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00;
	extern obj_t BGl_ev_andz00zz__evaluate_typesz00;
	static obj_t BGl_convzd2valszd2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern bool_t BGl_evmodulezf3zf3zz__evmodulez00(obj_t);
	extern obj_t BGl_getzd2sourcezd2locationz00zz__readerz00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_evaluate2z00zz__evaluatez00(obj_t, obj_t, obj_t);
	extern obj_t BGl_ev_appz00zz__evaluate_typesz00;
	extern obj_t
		BGl_dssslzd2formalszd2ze3schemezd2typedzd2formalsze3zz__dssslz00(obj_t,
		obj_t, bool_t);
	extern obj_t c_substring(obj_t, long, long);
	extern obj_t BGl_evalzd2findzd2modulez00zz__evmodulez00(obj_t);
	static obj_t BGl_uconvzf2loczf2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_loopz00zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_evcompilezd2errorzd2zz__evcompilez00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00;
	extern obj_t BGl_uncompilez00zz__evaluate_uncompz00(BgL_ev_exprz00_bglt);
	extern obj_t bstring_to_keyword(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_getzd2evaluationzd2contextz00zz__evaluatez00();
	static BgL_ev_appz00_bglt
		BGl_makezd2classzd2fieldzd2refzd2zz__evaluatez00(obj_t, BgL_ev_exprz00_bglt,
		obj_t, obj_t);
	extern obj_t BGl_ev_setlocalz00zz__evaluate_typesz00;
	static obj_t BGl_convz00zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t, bool_t);
	static obj_t *__cnst;


	   
		 
		DEFINE_STRING(BGl_string2640z00zz__evaluatez00,
		BgL_bgl_string2640za700za7za7_2696za7, "", 0);
	      DEFINE_STRING(BGl_string2642z00zz__evaluatez00,
		BgL_bgl_string2642za700za7za7_2697za7, "toplevel", 8);
	      DEFINE_STRING(BGl_string2643z00zz__evaluatez00,
		BgL_bgl_string2643za700za7za7_2698za7, "eval", 4);
	      DEFINE_STRING(BGl_string2644z00zz__evaluatez00,
		BgL_bgl_string2644za700za7za7_2699za7, "bad syntax", 10);
	      DEFINE_STRING(BGl_string2645z00zz__evaluatez00,
		BgL_bgl_string2645za700za7za7_2700za7, "Class \"~a\" has no field \"~a\"",
		28);
	      DEFINE_STRING(BGl_string2646z00zz__evaluatez00,
		BgL_bgl_string2646za700za7za7_2701za7, "Static type not a class", 23);
	      DEFINE_STRING(BGl_string2647z00zz__evaluatez00,
		BgL_bgl_string2647za700za7za7_2702za7, "Variable unbound", 16);
	      DEFINE_STRING(BGl_string2648z00zz__evaluatez00,
		BgL_bgl_string2648za700za7za7_2703za7, "Field read-only", 15);
	      DEFINE_STRING(BGl_string2649z00zz__evaluatez00,
		BgL_bgl_string2649za700za7za7_2704za7, "Illegal form", 12);
	      DEFINE_STRING(BGl_string2651z00zz__evaluatez00,
		BgL_bgl_string2651za700za7za7_2705za7, " ", 1);
	      DEFINE_STRING(BGl_string2652z00zz__evaluatez00,
		BgL_bgl_string2652za700za7za7_2706za7,
		"Illegal non toplevel module declaration", 39);
	      DEFINE_STRING(BGl_string2654z00zz__evaluatez00,
		BgL_bgl_string2654za700za7za7_2707za7, "module", 6);
	      DEFINE_STRING(BGl_string2656z00zz__evaluatez00,
		BgL_bgl_string2656za700za7za7_2708za7, "@", 1);
	      DEFINE_STRING(BGl_string2658z00zz__evaluatez00,
		BgL_bgl_string2658za700za7za7_2709za7, "->", 2);
	      DEFINE_STRING(BGl_string2660z00zz__evaluatez00,
		BgL_bgl_string2660za700za7za7_2710za7, "trap", 4);
	      DEFINE_STRING(BGl_string2662z00zz__evaluatez00,
		BgL_bgl_string2662za700za7za7_2711za7, "quote", 5);
	      DEFINE_STRING(BGl_string2664z00zz__evaluatez00,
		BgL_bgl_string2664za700za7za7_2712za7, "if", 2);
	      DEFINE_STRING(BGl_string2666z00zz__evaluatez00,
		BgL_bgl_string2666za700za7za7_2713za7, "or", 2);
	      DEFINE_STRING(BGl_string2668z00zz__evaluatez00,
		BgL_bgl_string2668za700za7za7_2714za7, "and", 3);
	      DEFINE_STRING(BGl_string2670z00zz__evaluatez00,
		BgL_bgl_string2670za700za7za7_2715za7, "begin", 5);
	      DEFINE_STRING(BGl_string2672z00zz__evaluatez00,
		BgL_bgl_string2672za700za7za7_2716za7, "let", 3);
	      DEFINE_STRING(BGl_string2674z00zz__evaluatez00,
		BgL_bgl_string2674za700za7za7_2717za7, "let*", 4);
	      DEFINE_STRING(BGl_string2676z00zz__evaluatez00,
		BgL_bgl_string2676za700za7za7_2718za7, "letrec", 6);
	      DEFINE_STRING(BGl_string2678z00zz__evaluatez00,
		BgL_bgl_string2678za700za7za7_2719za7, "set!", 4);
	      DEFINE_STRING(BGl_string2680z00zz__evaluatez00,
		BgL_bgl_string2680za700za7za7_2720za7, "define", 6);
	      DEFINE_STRING(BGl_string2682z00zz__evaluatez00,
		BgL_bgl_string2682za700za7za7_2721za7, "lambda", 6);
	      DEFINE_STRING(BGl_string2684z00zz__evaluatez00,
		BgL_bgl_string2684za700za7za7_2722za7, "bind-exit", 9);
	      DEFINE_STRING(BGl_string2686z00zz__evaluatez00,
		BgL_bgl_string2686za700za7za7_2723za7, "unwind-protect", 14);
	      DEFINE_STRING(BGl_string2688z00zz__evaluatez00,
		BgL_bgl_string2688za700za7za7_2724za7, "with-handler", 12);
	      DEFINE_STRING(BGl_string2690z00zz__evaluatez00,
		BgL_bgl_string2690za700za7za7_2725za7, "synchronize", 11);
	      DEFINE_STRING(BGl_string2692z00zz__evaluatez00,
		BgL_bgl_string2692za700za7za7_2726za7, "prelock", 7);
	      DEFINE_STRING(BGl_string2694z00zz__evaluatez00,
		BgL_bgl_string2694za700za7za7_2727za7, "\\@", 2);
	      DEFINE_STRING(BGl_string2695z00zz__evaluatez00,
		BgL_bgl_string2695za700za7za7_2728za7, "__evaluate", 10);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_setzd2evaluationzd2contextz12zd2envzc0zz__evaluatez00,
		BgL_bgl_za762setza7d2evaluat2729z00,
		BGl_z62setzd2evaluationzd2contextz12z70zz__evaluatez00, 0L, BUNSPEC, 1);
	extern obj_t BGl_errorzd2envzd2zz__errorz00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_getzd2evaluationzd2contextzd2envzd2zz__evaluatez00,
		BgL_bgl_za762getza7d2evaluat2730z00,
		BGl_z62getzd2evaluationzd2contextz62zz__evaluatez00, 0L, BUNSPEC, 0);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_evaluate2zd2envzd2zz__evaluatez00,
		BgL_bgl_za762evaluate2za762za72731za7, BGl_z62evaluate2z62zz__evaluatez00,
		0L, BUNSPEC, 3);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__evaluatez00(long
		BgL_checksumz00_4138, char *BgL_fromz00_4139)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zz__evaluatez00))
				{
					BGl_requirezd2initializa7ationz75zz__evaluatez00 =
						BBOOL(((bool_t) 0));
					BGl_cnstzd2initzd2zz__evaluatez00();
					BGl_importedzd2moduleszd2initz00zz__evaluatez00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zz__evaluatez00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 15 */
			BGl_symbol2641z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2642z00zz__evaluatez00);
			BGl_symbol2650z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2651z00zz__evaluatez00);
			BGl_symbol2653z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2654z00zz__evaluatez00);
			BGl_symbol2655z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2656z00zz__evaluatez00);
			BGl_symbol2657z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2658z00zz__evaluatez00);
			BGl_symbol2659z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2660z00zz__evaluatez00);
			BGl_symbol2661z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2662z00zz__evaluatez00);
			BGl_symbol2663z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2664z00zz__evaluatez00);
			BGl_symbol2665z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2666z00zz__evaluatez00);
			BGl_symbol2667z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2668z00zz__evaluatez00);
			BGl_symbol2669z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2670z00zz__evaluatez00);
			BGl_symbol2671z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2672z00zz__evaluatez00);
			BGl_symbol2673z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2674z00zz__evaluatez00);
			BGl_symbol2675z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2676z00zz__evaluatez00);
			BGl_symbol2677z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2678z00zz__evaluatez00);
			BGl_symbol2679z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2680z00zz__evaluatez00);
			BGl_symbol2681z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2682z00zz__evaluatez00);
			BGl_symbol2683z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2684z00zz__evaluatez00);
			BGl_symbol2685z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2686z00zz__evaluatez00);
			BGl_symbol2687z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2688z00zz__evaluatez00);
			BGl_symbol2689z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2690z00zz__evaluatez00);
			BGl_keyword2691z00zz__evaluatez00 =
				bstring_to_keyword(BGl_string2692z00zz__evaluatez00);
			return (BGl_symbol2693z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2694z00zz__evaluatez00), BUNSPEC);
		}
	}



/* append-21011 */
	obj_t BGl_appendzd221011zd2zz__evaluatez00(obj_t BgL_l1z00_1,
		obj_t BgL_l2z00_2)
	{
		AN_OBJECT;
		{
			{
				obj_t BgL_headz00_672;

				BgL_headz00_672 = MAKE_PAIR(BNIL, BgL_l2z00_2);
				{
					obj_t BgL_prevz00_2236;
					obj_t BgL_tailz00_2237;

					BgL_prevz00_2236 = BgL_headz00_672;
					BgL_tailz00_2237 = BgL_l1z00_1;
				BgL_loopz00_2235:
					if (PAIRP(BgL_tailz00_2237))
						{
							obj_t BgL_newzd2prevzd2_2243;

							BgL_newzd2prevzd2_2243 =
								MAKE_PAIR(CAR(BgL_tailz00_2237), BgL_l2z00_2);
							SET_CDR(BgL_prevz00_2236, BgL_newzd2prevzd2_2243);
							{
								obj_t BgL_tailz00_4175;
								obj_t BgL_prevz00_4174;

								BgL_prevz00_4174 = BgL_newzd2prevzd2_2243;
								BgL_tailz00_4175 = CDR(BgL_tailz00_2237);
								BgL_tailz00_2237 = BgL_tailz00_4175;
								BgL_prevz00_2236 = BgL_prevz00_4174;
								goto BgL_loopz00_2235;
							}
						}
					else
						{
							BNIL;
						}
				}
				return CDR(BgL_headz00_672);
			}
		}
	}



/* untype-ident */
	obj_t BGl_untypezd2identzd2zz__evaluatez00(obj_t BgL_idz00_3)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 71 */
			{	/* Eval/evaluate.scm 72 */
				obj_t BgL_stringz00_680;

				{	/* Eval/evaluate.scm 72 */
					obj_t BgL_res2344z00_2255;

					{	/* Ieee/symbol.scm 135 */
						obj_t BgL_arg2268z00_2254;

						BgL_arg2268z00_2254 = SYMBOL_TO_STRING(BgL_idz00_3);
						BgL_res2344z00_2255 =
							BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg2268z00_2254);
					}
					BgL_stringz00_680 = BgL_res2344z00_2255;
				}
				{	/* Eval/evaluate.scm 72 */
					long BgL_lenz00_681;

					BgL_lenz00_681 = STRING_LENGTH(BgL_stringz00_680);
					{	/* Eval/evaluate.scm 73 */

						{
							long BgL_walkerz00_683;

							BgL_walkerz00_683 = ((long) 0);
						BgL_zc3anonymousza31265ze3z83_684:
							if ((BgL_walkerz00_683 == BgL_lenz00_681))
								{	/* Eval/evaluate.scm 76 */
									return MAKE_PAIR(BgL_idz00_3, BFALSE);
								}
							else
								{	/* Eval/evaluate.scm 78 */
									bool_t BgL_testz00_4184;

									if (
										(STRING_REF(BgL_stringz00_680,
												BgL_walkerz00_683) == ((unsigned char) ':')))
										{	/* Eval/evaluate.scm 78 */
											if ((BgL_walkerz00_683 < (BgL_lenz00_681 - ((long) 1))))
												{	/* Eval/evaluate.scm 79 */
													BgL_testz00_4184 =
														(STRING_REF(BgL_stringz00_680,
															(BgL_walkerz00_683 + ((long) 1))) ==
														((unsigned char) ':'));
												}
											else
												{	/* Eval/evaluate.scm 79 */
													BgL_testz00_4184 = ((bool_t) 0);
												}
										}
									else
										{	/* Eval/evaluate.scm 78 */
											BgL_testz00_4184 = ((bool_t) 0);
										}
									if (BgL_testz00_4184)
										{	/* Eval/evaluate.scm 81 */
											obj_t BgL_arg1268z00_687;
											obj_t BgL_arg1273z00_688;

											{	/* Eval/evaluate.scm 81 */
												obj_t BgL_arg1279z00_689;

												BgL_arg1279z00_689 =
													c_substring(BgL_stringz00_680, ((long) 0),
													BgL_walkerz00_683);
												BgL_arg1268z00_687 =
													string_to_symbol(BSTRING_TO_STRING
													(BgL_arg1279z00_689));
											}
											{	/* Eval/evaluate.scm 82 */
												obj_t BgL_arg1280z00_690;

												{	/* Eval/evaluate.scm 82 */
													long BgL_arg1281z00_691;

													BgL_arg1281z00_691 = (BgL_walkerz00_683 + ((long) 2));
													{	/* Ieee/string.scm 179 */
														long BgL_endz00_694;

														BgL_endz00_694 = STRING_LENGTH(BgL_stringz00_680);
														{	/* Ieee/string.scm 179 */

															BgL_arg1280z00_690 =
																BGl_substringz00zz__r4_strings_6_7z00
																(BgL_stringz00_680, BgL_arg1281z00_691,
																BgL_endz00_694);
												}}}
												BgL_arg1273z00_688 =
													string_to_symbol(BSTRING_TO_STRING
													(BgL_arg1280z00_690));
											}
											return MAKE_PAIR(BgL_arg1268z00_687, BgL_arg1273z00_688);
										}
									else
										{
											long BgL_walkerz00_4203;

											BgL_walkerz00_4203 = (BgL_walkerz00_683 + ((long) 1));
											BgL_walkerz00_683 = BgL_walkerz00_4203;
											goto BgL_zc3anonymousza31265ze3z83_684;
										}
								}
						}
					}
				}
			}
		}
	}



/* get-evaluation-context */
	BGL_EXPORTED_DEF obj_t BGl_getzd2evaluationzd2contextz00zz__evaluatez00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 89 */
			{	/* Eval/evaluate.scm 90 */
				obj_t BgL_sz00_703;

				BgL_sz00_703 = BGl_findzd2statezd2zz__evaluate_compz00();
				{	/* Eval/evaluate.scm 91 */
					obj_t BgL_bpz00_704;

					BgL_bpz00_704 = VECTOR_REF(BgL_sz00_703, (int) (((long) 0)));
					{	/* Eval/evaluate.scm 92 */
						obj_t BgL_rz00_705;

						BgL_rz00_705 =
							make_vector(CINT(BgL_bpz00_704),
							BGl_string2640z00zz__evaluatez00);
						{
							long BgL_iz00_2312;

							BgL_iz00_2312 = ((long) 0);
						BgL_recz00_2311:
							if ((BgL_iz00_2312 < (long) CINT(BgL_bpz00_704)))
								{	/* Eval/evaluate.scm 94 */
									VECTOR_SET(BgL_rz00_705,
										(int) (BgL_iz00_2312),
										VECTOR_REF(BgL_sz00_703, (int) (BgL_iz00_2312)));
									{
										long BgL_iz00_4217;

										BgL_iz00_4217 = (BgL_iz00_2312 + ((long) 1));
										BgL_iz00_2312 = BgL_iz00_4217;
										goto BgL_recz00_2311;
									}
								}
							else
								{	/* Eval/evaluate.scm 94 */
									((bool_t) 0);
								}
						}
						return BgL_rz00_705;
					}
				}
			}
		}
	}



/* &get-evaluation-context */
	obj_t BGl_z62getzd2evaluationzd2contextz62zz__evaluatez00(obj_t
		BgL_envz00_4088)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 89 */
			return BGl_getzd2evaluationzd2contextz00zz__evaluatez00();
		}
	}



/* set-evaluation-context! */
	BGL_EXPORTED_DEF obj_t
		BGl_setzd2evaluationzd2contextz12z12zz__evaluatez00(obj_t BgL_vz00_4)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 102 */
			{	/* Eval/evaluate.scm 103 */
				obj_t BgL_sz00_713;

				BgL_sz00_713 = BGl_findzd2statezd2zz__evaluate_compz00();
				{	/* Eval/evaluate.scm 104 */
					obj_t BgL_bpz00_714;

					BgL_bpz00_714 = VECTOR_REF(BgL_vz00_4, (int) (((long) 0)));
					{
						long BgL_iz00_2341;

						{	/* Eval/evaluate.scm 105 */
							bool_t BgL_auxz00_4223;

							BgL_iz00_2341 = ((long) 0);
						BgL_recz00_2340:
							if ((BgL_iz00_2341 < (long) CINT(BgL_bpz00_714)))
								{	/* Eval/evaluate.scm 106 */
									VECTOR_SET(BgL_sz00_713,
										(int) (BgL_iz00_2341),
										VECTOR_REF(BgL_vz00_4, (int) (BgL_iz00_2341)));
									{
										long BgL_iz00_4231;

										BgL_iz00_4231 = (BgL_iz00_2341 + ((long) 1));
										BgL_iz00_2341 = BgL_iz00_4231;
										goto BgL_recz00_2340;
									}
								}
							else
								{	/* Eval/evaluate.scm 106 */
									BgL_auxz00_4223 = ((bool_t) 0);
								}
							return BBOOL(BgL_auxz00_4223);
						}
					}
				}
			}
		}
	}



/* &set-evaluation-context! */
	obj_t BGl_z62setzd2evaluationzd2contextz12z70zz__evaluatez00(obj_t
		BgL_envz00_4089, obj_t BgL_vz00_4090)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 102 */
			return BGl_setzd2evaluationzd2contextz12z12zz__evaluatez00(BgL_vz00_4090);
		}
	}



/* evaluate2 */
	BGL_EXPORTED_DEF obj_t BGl_evaluate2z00zz__evaluatez00(obj_t BgL_sexpz00_5,
		obj_t BgL_envz00_6, obj_t BgL_locz00_7)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 113 */
			{	/* Eval/evaluate.scm 114 */
				BgL_ev_exprz00_bglt BgL_astz00_722;

				{	/* Eval/evaluate.scm 114 */
					obj_t BgL_arg1322z00_738;

					BgL_arg1322z00_738 =
						BGl_convz00zz__evaluatez00(BgL_sexpz00_5, BNIL, BgL_envz00_6,
						BFALSE, BGl_symbol2641z00zz__evaluatez00, BgL_locz00_7,
						((bool_t) 1));
					BgL_astz00_722 =
						BGl_extractzd2loopszd2zz__evaluate_fsiza7eza7(((BgL_ev_exprz00_bglt)
							BgL_arg1322z00_738));
				}
				{	/* Eval/evaluate.scm 115 */
					bool_t BgL_testz00_4238;

					{	/* Eval/evaluate.scm 115 */
						int BgL_arg1316z00_726;

						BgL_arg1316z00_726 = bgl_debug();
						BgL_testz00_4238 =
							BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1316z00_726),
							BINT(((long) 10)));
					}
					if (BgL_testz00_4238)
						{	/* Eval/evaluate.scm 115 */
							BGl_ppz00zz__ppz00(BGl_uncompilez00zz__evaluate_uncompz00
								(BgL_astz00_722), BNIL);
						}
					else
						{	/* Eval/evaluate.scm 115 */
							BFALSE;
						}
				}
				BGl_analysezd2varszd2zz__evaluate_avarz00(BgL_astz00_722);
				{	/* Eval/evaluate.scm 117 */
					int BgL_nz00_727;

					BgL_nz00_727 =
						BGl_framezd2siza7ez75zz__evaluate_fsiza7eza7(BgL_astz00_722);
					{	/* Eval/evaluate.scm 118 */
						obj_t BgL_fz00_728;

						BgL_fz00_728 = BGl_compilez00zz__evaluate_compz00(BgL_astz00_722);
						{	/* Eval/evaluate.scm 119 */
							obj_t BgL_sz00_729;

							BgL_sz00_729 = BGl_findzd2statezd2zz__evaluate_compz00();
							{	/* Eval/evaluate.scm 120 */
								obj_t BgL_bpz00_730;

								BgL_bpz00_730 = VECTOR_REF(BgL_sz00_729, (int) (((long) 0)));
								{	/* Eval/evaluate.scm 121 */
									obj_t BgL_val1064z00_731;

									BgL_val1064z00_731 =
										BGl_zc3exitza31321ze3z83zz__evaluatez00(BgL_sz00_729,
										BgL_fz00_728);
									VECTOR_SET(BgL_sz00_729, (int) (((long) 0)), BgL_bpz00_730);
									if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
											(BgL_val1064z00_731)))
										{	/* Eval/evaluate.scm 123 */
											return
												BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
												(BgL_val1064z00_731), CDR(BgL_val1064z00_731));
										}
									else
										{	/* Eval/evaluate.scm 123 */
											return BgL_val1064z00_731;
										}
								}
							}
						}
					}
				}
			}
		}
	}



/* <exit:1321> */
	obj_t BGl_zc3exitza31321ze3z83zz__evaluatez00(obj_t BgL_sz00_4117,
		obj_t BgL_fz00_4116)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 123 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1065z00_736;

			if (SET_EXIT(BgL_an_exit1065z00_736))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1065z00_736 = (void *) jmpbuf;
					{	/* Eval/evaluate.scm 123 */

						PUSH_EXIT(BgL_an_exit1065z00_736, ((long) 0));
						{	/* Eval/evaluate.scm 122 */
							obj_t BgL_val1066z00_737;

							BgL_val1066z00_737 =
								PROCEDURE_ENTRY(BgL_fz00_4116) (BgL_fz00_4116, BgL_sz00_4117,
								BEOA);
							POP_EXIT();
							return BgL_val1066z00_737;
						}
					}
				}
		}
	}



/* &evaluate2 */
	obj_t BGl_z62evaluate2z62zz__evaluatez00(obj_t BgL_envz00_4091,
		obj_t BgL_sexpz00_4092, obj_t BgL_envz00_4093, obj_t BgL_locz00_4094)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 113 */
			return
				BGl_evaluate2z00zz__evaluatez00(BgL_sexpz00_4092, BgL_envz00_4093,
				BgL_locz00_4094);
		}
	}



/* get-location */
	obj_t BGl_getzd2locationzd2zz__evaluatez00(obj_t BgL_expz00_8,
		obj_t BgL_locz00_9)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 128 */
			{	/* Eval/evaluate.scm 129 */
				obj_t BgL__ortest_1067z00_2366;

				BgL__ortest_1067z00_2366 =
					BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_expz00_8);
				if (CBOOL(BgL__ortest_1067z00_2366))
					{	/* Eval/evaluate.scm 129 */
						return BgL__ortest_1067z00_2366;
					}
				else
					{	/* Eval/evaluate.scm 129 */
						return BgL_locz00_9;
					}
			}
		}
	}



/* conv-var */
	obj_t BGl_convzd2varzd2zz__evaluatez00(obj_t BgL_vz00_16,
		obj_t BgL_localsz00_17)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 148 */
			{
				obj_t BgL_lz00_743;

				BgL_lz00_743 = BgL_localsz00_17;
			BgL_zc3anonymousza31323ze3z83_744:
				if (NULLP(BgL_lz00_743))
					{	/* Eval/evaluate.scm 150 */
						return BFALSE;
					}
				else
					{	/* Eval/evaluate.scm 152 */
						obj_t BgL_rvz00_746;

						BgL_rvz00_746 = CAR(BgL_lz00_743);
						if (
							(BgL_vz00_16 ==
								(((BgL_ev_varz00_bglt) CREF(
											((BgL_ev_varz00_bglt) BgL_rvz00_746)))->BgL_namez00)))
							{	/* Eval/evaluate.scm 154 */
								return BgL_rvz00_746;
							}
						else
							{
								obj_t BgL_lz00_4279;

								BgL_lz00_4279 = CDR(BgL_lz00_743);
								BgL_lz00_743 = BgL_lz00_4279;
								goto BgL_zc3anonymousza31323ze3z83_744;
							}
					}
			}
		}
	}



/* conv-begin */
	obj_t BGl_convzd2beginzd2zz__evaluatez00(obj_t BgL_lz00_18,
		obj_t BgL_localsz00_19, obj_t BgL_globalsz00_20, obj_t BgL_tailzf3zf3_21,
		obj_t BgL_wherez00_22, obj_t BgL_locz00_23, bool_t BgL_topzf3zf3_24)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 161 */
			{	/* Eval/evaluate.scm 162 */
				obj_t BgL_locz00_752;

				{	/* Eval/evaluate.scm 129 */
					obj_t BgL__ortest_1067z00_2375;

					BgL__ortest_1067z00_2375 =
						BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_lz00_18);
					if (CBOOL(BgL__ortest_1067z00_2375))
						{	/* Eval/evaluate.scm 129 */
							BgL_locz00_752 = BgL__ortest_1067z00_2375;
						}
					else
						{	/* Eval/evaluate.scm 129 */
							BgL_locz00_752 = BgL_locz00_23;
						}
				}
				{
					obj_t BgL_e1z00_756;
					obj_t BgL_rz00_757;

					if (NULLP(BgL_lz00_18))
						{
							BgL_ev_littz00_bglt BgL_auxz00_4286;

							{	/* Eval/evaluate.scm 165 */
								BgL_ev_littz00_bglt BgL_new1072z00_768;

								{	/* Eval/evaluate.scm 165 */
									BgL_ev_littz00_bglt BgL_new1071z00_769;

									BgL_new1071z00_769 =
										((BgL_ev_littz00_bglt) BREF(GC_MALLOC(sizeof(struct
													BgL_ev_littz00_bgl))));
									{	/* Eval/evaluate.scm 165 */
										long BgL_arg1336z00_770;

										{	/* Eval/evaluate.scm 165 */
											long BgL_res2365z00_2377;

											BgL_res2365z00_2377 =
												BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00);
											BgL_arg1336z00_770 = BgL_res2365z00_2377;
										}
										{	/* Eval/evaluate.scm 165 */
											BgL_objectz00_bglt BgL_objz00_2378;

											BgL_objz00_2378 =
												((BgL_objectz00_bglt) BgL_new1071z00_769);
											BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2378,
												BgL_arg1336z00_770);
									}}
									{	/* Eval/evaluate.scm 165 */
										BgL_objectz00_bglt BgL_auxz00_4291;

										BgL_auxz00_4291 = ((BgL_objectz00_bglt) BgL_new1071z00_769);
										BGL_OBJECT_WIDENING_SET(BgL_auxz00_4291, BFALSE);
									}
									BgL_new1072z00_768 = BgL_new1071z00_769;
								}
								((((BgL_ev_littz00_bglt) CREF(BgL_new1072z00_768))->
										BgL_valuez00) = ((obj_t) BUNSPEC), BUNSPEC);
								BgL_auxz00_4286 = BgL_new1072z00_768;
							}
							return ((obj_t) BgL_auxz00_4286);
						}
					else
						{	/* Eval/evaluate.scm 163 */
							if (PAIRP(BgL_lz00_18))
								{	/* Eval/evaluate.scm 163 */
									if (NULLP(CDR(BgL_lz00_18)))
										{	/* Eval/evaluate.scm 163 */
											obj_t BgL_arg1332z00_764;

											BgL_arg1332z00_764 = CAR(BgL_lz00_18);
											{	/* Eval/evaluate.scm 168 */
												obj_t BgL_arg1337z00_2400;

												{	/* Eval/evaluate.scm 129 */
													obj_t BgL__ortest_1067z00_2403;

													BgL__ortest_1067z00_2403 =
														BGl_getzd2sourcezd2locationz00zz__readerz00
														(BgL_arg1332z00_764);
													if (CBOOL(BgL__ortest_1067z00_2403))
														{	/* Eval/evaluate.scm 129 */
															BgL_arg1337z00_2400 = BgL__ortest_1067z00_2403;
														}
													else
														{	/* Eval/evaluate.scm 129 */
															BgL_arg1337z00_2400 = BgL_locz00_752;
														}
												}
												return
													BGl_convz00zz__evaluatez00(BgL_arg1332z00_764,
													BgL_localsz00_19, BgL_globalsz00_20,
													BgL_tailzf3zf3_21, BgL_wherez00_22,
													BgL_arg1337z00_2400, BgL_topzf3zf3_24);
											}
										}
									else
										{	/* Eval/evaluate.scm 163 */
											obj_t BgL_arg1333z00_765;
											obj_t BgL_arg1334z00_766;

											BgL_arg1333z00_765 = CAR(BgL_lz00_18);
											BgL_arg1334z00_766 = CDR(BgL_lz00_18);
											{
												BgL_ev_prog2z00_bglt BgL_auxz00_4308;

												BgL_e1z00_756 = BgL_arg1333z00_765;
												BgL_rz00_757 = BgL_arg1334z00_766;
												{	/* Eval/evaluate.scm 170 */
													BgL_ev_prog2z00_bglt BgL_new1074z00_772;

													{	/* Eval/evaluate.scm 170 */
														BgL_ev_prog2z00_bglt BgL_new1073z00_774;

														BgL_new1073z00_774 =
															((BgL_ev_prog2z00_bglt)
															BREF(GC_MALLOC(sizeof(struct
																		BgL_ev_prog2z00_bgl))));
														{	/* Eval/evaluate.scm 170 */
															long BgL_arg1339z00_775;

															{	/* Eval/evaluate.scm 170 */
																long BgL_res2366z00_2385;

																BgL_res2366z00_2385 =
																	BGL_CLASS_INDEX
																	(BGl_ev_prog2z00zz__evaluate_typesz00);
																BgL_arg1339z00_775 = BgL_res2366z00_2385;
															}
															{	/* Eval/evaluate.scm 170 */
																BgL_objectz00_bglt BgL_objz00_2386;

																BgL_objz00_2386 =
																	((BgL_objectz00_bglt) BgL_new1073z00_774);
																BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2386,
																	BgL_arg1339z00_775);
														}}
														{	/* Eval/evaluate.scm 170 */
															BgL_objectz00_bglt BgL_auxz00_4313;

															BgL_auxz00_4313 =
																((BgL_objectz00_bglt) BgL_new1073z00_774);
															BGL_OBJECT_WIDENING_SET(BgL_auxz00_4313, BFALSE);
														}
														BgL_new1074z00_772 = BgL_new1073z00_774;
													}
													{
														BgL_ev_exprz00_bglt BgL_auxz00_4316;

														{	/* Eval/evaluate.scm 171 */
															obj_t BgL_arg1338z00_773;

															{	/* Eval/evaluate.scm 129 */
																obj_t BgL__ortest_1067z00_2390;

																BgL__ortest_1067z00_2390 =
																	BGl_getzd2sourcezd2locationz00zz__readerz00
																	(BgL_e1z00_756);
																if (CBOOL(BgL__ortest_1067z00_2390))
																	{	/* Eval/evaluate.scm 129 */
																		BgL_arg1338z00_773 =
																			BgL__ortest_1067z00_2390;
																	}
																else
																	{	/* Eval/evaluate.scm 129 */
																		BgL_arg1338z00_773 = BgL_locz00_752;
																	}
															}
															BgL_auxz00_4316 =
																((BgL_ev_exprz00_bglt)
																BGl_convz00zz__evaluatez00(BgL_e1z00_756,
																	BgL_localsz00_19, BgL_globalsz00_20, BFALSE,
																	BgL_wherez00_22, BgL_arg1338z00_773,
																	BgL_topzf3zf3_24));
														}
														((((BgL_ev_prog2z00_bglt)
																	CREF(BgL_new1074z00_772))->BgL_e1z00) =
															((BgL_ev_exprz00_bglt) BgL_auxz00_4316), BUNSPEC);
													}
													((((BgL_ev_prog2z00_bglt) CREF(BgL_new1074z00_772))->
															BgL_e2z00) =
														((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt)
																BGl_convzd2beginzd2zz__evaluatez00(BgL_rz00_757,
																	BgL_localsz00_19, BgL_globalsz00_20,
																	BgL_tailzf3zf3_21, BgL_wherez00_22,
																	BgL_locz00_752, BgL_topzf3zf3_24))), BUNSPEC);
													BgL_auxz00_4308 = BgL_new1074z00_772;
												}
												return ((obj_t) BgL_auxz00_4308);
											}
										}
								}
							else
								{	/* Eval/evaluate.scm 163 */
									return
										BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_752,
										BGl_string2643z00zz__evaluatez00,
										BGl_string2644z00zz__evaluatez00, BgL_lz00_18);
								}
						}
				}
			}
		}
	}



/* conv-field-ref */
	obj_t BGl_convzd2fieldzd2refz00zz__evaluatez00(obj_t BgL_ez00_25,
		obj_t BgL_localsz00_26, obj_t BgL_globalsz00_27, obj_t BgL_tailzf3zf3_28,
		obj_t BgL_wherez00_29, obj_t BgL_locz00_30, bool_t BgL_topzf3zf3_31)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 179 */
			{	/* Eval/evaluate.scm 180 */
				obj_t BgL_lz00_776;

				BgL_lz00_776 = CDR(BgL_ez00_25);
				{	/* Eval/evaluate.scm 180 */
					obj_t BgL_vz00_777;

					BgL_vz00_777 =
						BGl_convzd2varzd2zz__evaluatez00(CAR(BgL_lz00_776),
						BgL_localsz00_26);
					{	/* Eval/evaluate.scm 181 */

						if (BGl_isazf3zf3zz__objectz00(BgL_vz00_777,
								BGl_ev_varz00zz__evaluate_typesz00))
							{	/* Eval/evaluate.scm 183 */
								BgL_ev_varz00_bglt BgL_i1075z00_779;

								BgL_i1075z00_779 = ((BgL_ev_varz00_bglt) BgL_vz00_777);
								{	/* Eval/evaluate.scm 184 */
									obj_t BgL_g1077z00_780;
									obj_t BgL_g1078z00_781;

									BgL_g1077z00_780 =
										BGl_classzd2existszd2zz__objectz00(
										(((BgL_ev_varz00_bglt) CREF(BgL_i1075z00_779))->
											BgL_typez00));
									BgL_g1078z00_781 = CDR(BgL_lz00_776);
									{
										BgL_ev_exprz00_bglt BgL_nodez00_783;
										obj_t BgL_klassz00_784;
										obj_t BgL_fieldsz00_785;

										BgL_nodez00_783 =
											((BgL_ev_exprz00_bglt)
											((BgL_ev_varz00_bglt) BgL_vz00_777));
										BgL_klassz00_784 = BgL_g1077z00_780;
										BgL_fieldsz00_785 = BgL_g1078z00_781;
									BgL_zc3anonymousza31341ze3z83_786:
										if (NULLP(BgL_fieldsz00_785))
											{	/* Eval/evaluate.scm 188 */
												return ((obj_t) BgL_nodez00_783);
											}
										else
											{	/* Eval/evaluate.scm 188 */
												if (BGl_classzf3zf3zz__objectz00(BgL_klassz00_784))
													{	/* Eval/evaluate.scm 191 */
														obj_t BgL_fieldz00_789;

														BgL_fieldz00_789 =
															BGl_findzd2classzd2fieldz00zz__objectz00
															(BgL_klassz00_784, CAR(BgL_fieldsz00_785));
														if (BGl_classzd2fieldzf3z21zz__objectz00
															(BgL_fieldz00_789))
															{	/* Eval/evaluate.scm 193 */
																BgL_ev_appz00_bglt BgL_nodez00_791;

																BgL_nodez00_791 =
																	BGl_makezd2classzd2fieldzd2refzd2zz__evaluatez00
																	(BgL_fieldz00_789, BgL_nodez00_783,
																	BgL_locz00_30, BgL_tailzf3zf3_28);
																{	/* Eval/evaluate.scm 196 */
																	obj_t BgL_arg1345z00_792;
																	obj_t BgL_arg1346z00_793;

																	BgL_arg1345z00_792 =
																		BGl_classzd2fieldzd2typez00zz__objectz00
																		(BgL_fieldz00_789);
																	BgL_arg1346z00_793 = CDR(BgL_fieldsz00_785);
																	{
																		obj_t BgL_fieldsz00_4352;
																		obj_t BgL_klassz00_4351;
																		BgL_ev_exprz00_bglt BgL_nodez00_4349;

																		BgL_nodez00_4349 =
																			((BgL_ev_exprz00_bglt) BgL_nodez00_791);
																		BgL_klassz00_4351 = BgL_arg1345z00_792;
																		BgL_fieldsz00_4352 = BgL_arg1346z00_793;
																		BgL_fieldsz00_785 = BgL_fieldsz00_4352;
																		BgL_klassz00_784 = BgL_klassz00_4351;
																		BgL_nodez00_783 = BgL_nodez00_4349;
																		goto BgL_zc3anonymousza31341ze3z83_786;
																	}
																}
															}
														else
															{	/* Eval/evaluate.scm 198 */
																obj_t BgL_arg1347z00_794;
																obj_t BgL_arg1348z00_795;

																BgL_arg1347z00_794 =
																	(((BgL_ev_varz00_bglt)
																		CREF(BgL_i1075z00_779))->BgL_typez00);
																{	/* Eval/evaluate.scm 199 */
																	obj_t BgL_arg1349z00_796;
																	obj_t BgL_arg1350z00_797;

																	BgL_arg1349z00_796 =
																		(((BgL_ev_varz00_bglt)
																			CREF(BgL_i1075z00_779))->BgL_typez00);
																	BgL_arg1350z00_797 = CAR(BgL_fieldsz00_785);
																	{	/* Eval/evaluate.scm 199 */
																		obj_t BgL_list1351z00_798;

																		{	/* Eval/evaluate.scm 199 */
																			obj_t BgL_arg1352z00_799;

																			BgL_arg1352z00_799 =
																				MAKE_PAIR(BgL_arg1350z00_797, BNIL);
																			BgL_list1351z00_798 =
																				MAKE_PAIR(BgL_arg1349z00_796,
																				BgL_arg1352z00_799);
																		}
																		BgL_arg1348z00_795 =
																			BGl_formatz00zz__r4_output_6_10_3z00
																			(BGl_string2645z00zz__evaluatez00,
																			BgL_list1351z00_798);
																	}
																}
																return
																	BGl_evcompilezd2errorzd2zz__evcompilez00
																	(BgL_locz00_30, BgL_arg1347z00_794,
																	BgL_arg1348z00_795, BgL_ez00_25);
															}
													}
												else
													{	/* Eval/evaluate.scm 202 */
														obj_t BgL_arg1354z00_801;

														{	/* Eval/evaluate.scm 202 */
															obj_t BgL__ortest_1079z00_802;

															BgL__ortest_1079z00_802 =
																(((BgL_ev_varz00_bglt) CREF(BgL_i1075z00_779))->
																BgL_typez00);
															if (CBOOL(BgL__ortest_1079z00_802))
																{	/* Eval/evaluate.scm 202 */
																	BgL_arg1354z00_801 = BgL__ortest_1079z00_802;
																}
															else
																{	/* Eval/evaluate.scm 202 */
																	BgL_arg1354z00_801 =
																		(((BgL_ev_varz00_bglt)
																			CREF(BgL_i1075z00_779))->BgL_namez00);
																}
														}
														return
															BGl_evcompilezd2errorzd2zz__evcompilez00
															(BgL_locz00_30, BgL_arg1354z00_801,
															BGl_string2646z00zz__evaluatez00, BgL_ez00_25);
													}
											}
									}
								}
							}
						else
							{	/* Eval/evaluate.scm 204 */
								obj_t BgL_arg1356z00_805;

								{	/* Eval/evaluate.scm 204 */
									obj_t BgL_pairz00_2414;

									BgL_pairz00_2414 = BgL_ez00_25;
									BgL_arg1356z00_805 = CAR(CDR(BgL_pairz00_2414));
								}
								return
									BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_30,
									BgL_arg1356z00_805, BGl_string2647z00zz__evaluatez00,
									BgL_ez00_25);
							}
					}
				}
			}
		}
	}



/* conv-field-set */
	obj_t BGl_convzd2fieldzd2setz00zz__evaluatez00(obj_t BgL_lz00_32,
		obj_t BgL_e2z00_33, obj_t BgL_ez00_34, obj_t BgL_localsz00_35,
		obj_t BgL_globalsz00_36, obj_t BgL_tailzf3zf3_37, obj_t BgL_wherez00_38,
		obj_t BgL_locz00_39, bool_t BgL_topzf3zf3_40)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 209 */
			{	/* Eval/evaluate.scm 210 */
				obj_t BgL_vz00_807;

				BgL_vz00_807 =
					BGl_convzd2varzd2zz__evaluatez00(CAR(BgL_lz00_32), BgL_localsz00_35);
				{	/* Eval/evaluate.scm 210 */
					obj_t BgL_e2z00_808;

					BgL_e2z00_808 =
						BGl_convz00zz__evaluatez00(BgL_e2z00_33, BgL_localsz00_35,
						BgL_globalsz00_36, BFALSE, BgL_wherez00_38, BgL_locz00_39,
						((bool_t) 0));
					{	/* Eval/evaluate.scm 211 */

						if (BGl_isazf3zf3zz__objectz00(BgL_vz00_807,
								BGl_ev_varz00zz__evaluate_typesz00))
							{	/* Eval/evaluate.scm 213 */
								BgL_ev_varz00_bglt BgL_i1080z00_810;

								BgL_i1080z00_810 = ((BgL_ev_varz00_bglt) BgL_vz00_807);
								{	/* Eval/evaluate.scm 214 */
									obj_t BgL_g1081z00_811;
									obj_t BgL_g1082z00_812;

									BgL_g1081z00_811 =
										BGl_classzd2existszd2zz__objectz00(
										(((BgL_ev_varz00_bglt) CREF(BgL_i1080z00_810))->
											BgL_typez00));
									BgL_g1082z00_812 = CDR(BgL_lz00_32);
									{
										BgL_ev_exprz00_bglt BgL_nodez00_814;
										obj_t BgL_klassz00_815;
										obj_t BgL_fieldsz00_816;

										BgL_nodez00_814 =
											((BgL_ev_exprz00_bglt)
											((BgL_ev_varz00_bglt) BgL_vz00_807));
										BgL_klassz00_815 = BgL_g1081z00_811;
										BgL_fieldsz00_816 = BgL_g1082z00_812;
									BgL_zc3anonymousza31359ze3z83_817:
										if (NULLP(BgL_fieldsz00_816))
											{	/* Eval/evaluate.scm 218 */
												return ((obj_t) BgL_nodez00_814);
											}
										else
											{	/* Eval/evaluate.scm 218 */
												if (BGl_classzf3zf3zz__objectz00(BgL_klassz00_815))
													{	/* Eval/evaluate.scm 221 */
														obj_t BgL_fieldz00_820;

														BgL_fieldz00_820 =
															BGl_findzd2classzd2fieldz00zz__objectz00
															(BgL_klassz00_815, CAR(BgL_fieldsz00_816));
														if (BGl_classzd2fieldzf3z21zz__objectz00
															(BgL_fieldz00_820))
															{	/* Eval/evaluate.scm 222 */
																if (NULLP(CDR(BgL_fieldsz00_816)))
																	{	/* Eval/evaluate.scm 223 */
																		if (BGl_classzd2fieldzd2mutablezf3zf3zz__objectz00(BgL_fieldz00_820))
																			{	/* Eval/evaluate.scm 226 */
																				obj_t BgL_arg1365z00_824;

																				{	/* Eval/evaluate.scm 226 */
																					obj_t BgL_list1366z00_825;

																					{	/* Eval/evaluate.scm 226 */
																						obj_t BgL_arg1367z00_826;

																						BgL_arg1367z00_826 =
																							MAKE_PAIR(BgL_e2z00_808, BNIL);
																						BgL_list1366z00_825 =
																							MAKE_PAIR(
																							((obj_t) BgL_nodez00_814),
																							BgL_arg1367z00_826);
																					}
																					BgL_arg1365z00_824 =
																						BgL_list1366z00_825;
																				}
																				return
																					((obj_t)
																					BGl_makezd2classzd2fieldzd2setzd2zz__evaluatez00
																					(BgL_fieldz00_820, BgL_arg1365z00_824,
																						BgL_locz00_39, BgL_tailzf3zf3_37));
																			}
																		else
																			{	/* Eval/evaluate.scm 224 */
																				return
																					BGl_evcompilezd2errorzd2zz__evcompilez00
																					(BgL_locz00_39,
																					CAR(BgL_fieldsz00_816),
																					BGl_string2648z00zz__evaluatez00,
																					BgL_ez00_34);
																			}
																	}
																else
																	{	/* Eval/evaluate.scm 230 */
																		BgL_ev_appz00_bglt BgL_nodez00_828;

																		BgL_nodez00_828 =
																			BGl_makezd2classzd2fieldzd2refzd2zz__evaluatez00
																			(BgL_fieldz00_820, BgL_nodez00_814,
																			BgL_locz00_39, BgL_tailzf3zf3_37);
																		{	/* Eval/evaluate.scm 233 */
																			obj_t BgL_arg1369z00_829;
																			obj_t BgL_arg1370z00_830;

																			BgL_arg1369z00_829 =
																				BGl_classzd2fieldzd2typez00zz__objectz00
																				(BgL_fieldz00_820);
																			BgL_arg1370z00_830 =
																				CDR(BgL_fieldsz00_816);
																			{
																				obj_t BgL_fieldsz00_4406;
																				obj_t BgL_klassz00_4405;
																				BgL_ev_exprz00_bglt BgL_nodez00_4403;

																				BgL_nodez00_4403 =
																					((BgL_ev_exprz00_bglt)
																					BgL_nodez00_828);
																				BgL_klassz00_4405 = BgL_arg1369z00_829;
																				BgL_fieldsz00_4406 = BgL_arg1370z00_830;
																				BgL_fieldsz00_816 = BgL_fieldsz00_4406;
																				BgL_klassz00_815 = BgL_klassz00_4405;
																				BgL_nodez00_814 = BgL_nodez00_4403;
																				goto BgL_zc3anonymousza31359ze3z83_817;
																			}
																		}
																	}
															}
														else
															{	/* Eval/evaluate.scm 235 */
																obj_t BgL_arg1373z00_832;
																obj_t BgL_arg1376z00_833;

																BgL_arg1373z00_832 =
																	(((BgL_ev_varz00_bglt)
																		CREF(BgL_i1080z00_810))->BgL_typez00);
																{	/* Eval/evaluate.scm 236 */
																	obj_t BgL_arg1377z00_834;
																	obj_t BgL_arg1378z00_835;

																	BgL_arg1377z00_834 =
																		(((BgL_ev_varz00_bglt)
																			CREF(BgL_i1080z00_810))->BgL_typez00);
																	BgL_arg1378z00_835 = CAR(BgL_fieldsz00_816);
																	{	/* Eval/evaluate.scm 236 */
																		obj_t BgL_list1379z00_836;

																		{	/* Eval/evaluate.scm 236 */
																			obj_t BgL_arg1380z00_837;

																			BgL_arg1380z00_837 =
																				MAKE_PAIR(BgL_arg1378z00_835, BNIL);
																			BgL_list1379z00_836 =
																				MAKE_PAIR(BgL_arg1377z00_834,
																				BgL_arg1380z00_837);
																		}
																		BgL_arg1376z00_833 =
																			BGl_formatz00zz__r4_output_6_10_3z00
																			(BGl_string2645z00zz__evaluatez00,
																			BgL_list1379z00_836);
																	}
																}
																return
																	BGl_evcompilezd2errorzd2zz__evcompilez00
																	(BgL_locz00_39, BgL_arg1373z00_832,
																	BgL_arg1376z00_833, BgL_ez00_34);
															}
													}
												else
													{	/* Eval/evaluate.scm 240 */
														obj_t BgL_arg1384z00_839;

														{	/* Eval/evaluate.scm 240 */
															obj_t BgL__ortest_1083z00_840;

															BgL__ortest_1083z00_840 =
																(((BgL_ev_varz00_bglt) CREF(BgL_i1080z00_810))->
																BgL_typez00);
															if (CBOOL(BgL__ortest_1083z00_840))
																{	/* Eval/evaluate.scm 240 */
																	BgL_arg1384z00_839 = BgL__ortest_1083z00_840;
																}
															else
																{	/* Eval/evaluate.scm 240 */
																	BgL_arg1384z00_839 =
																		(((BgL_ev_varz00_bglt)
																			CREF(BgL_i1080z00_810))->BgL_namez00);
																}
														}
														return
															BGl_evcompilezd2errorzd2zz__evcompilez00
															(BgL_locz00_39, BgL_arg1384z00_839,
															BGl_string2646z00zz__evaluatez00, BgL_ez00_34);
													}
											}
									}
								}
							}
						else
							{	/* Eval/evaluate.scm 212 */
								return
									BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_39,
									CAR(BgL_lz00_32), BGl_string2647z00zz__evaluatez00,
									BgL_ez00_34);
							}
					}
				}
			}
		}
	}



/* make-class-field-ref */
	BgL_ev_appz00_bglt BGl_makezd2classzd2fieldzd2refzd2zz__evaluatez00(obj_t
		BgL_fieldz00_41, BgL_ev_exprz00_bglt BgL_argz00_42, obj_t BgL_locz00_43,
		obj_t BgL_tailzf3zf3_44)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 246 */
			{	/* Eval/evaluate.scm 247 */
				obj_t BgL_getz00_845;

				BgL_getz00_845 =
					BGl_classzd2fieldzd2accessorz00zz__objectz00(BgL_fieldz00_41);
				{	/* Eval/evaluate.scm 248 */
					BgL_ev_appz00_bglt BgL_new1085z00_846;

					{	/* Eval/evaluate.scm 248 */
						BgL_ev_appz00_bglt BgL_new1084z00_851;

						BgL_new1084z00_851 =
							((BgL_ev_appz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_appz00_bgl))));
						{	/* Eval/evaluate.scm 248 */
							long BgL_arg1390z00_852;

							{	/* Eval/evaluate.scm 248 */
								long BgL_res2374z00_2433;

								BgL_res2374z00_2433 =
									BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00);
								BgL_arg1390z00_852 = BgL_res2374z00_2433;
							}
							{	/* Eval/evaluate.scm 248 */
								BgL_objectz00_bglt BgL_objz00_2434;

								BgL_objz00_2434 = ((BgL_objectz00_bglt) BgL_new1084z00_851);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2434, BgL_arg1390z00_852);
						}}
						{	/* Eval/evaluate.scm 248 */
							BgL_objectz00_bglt BgL_auxz00_4428;

							BgL_auxz00_4428 = ((BgL_objectz00_bglt) BgL_new1084z00_851);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4428, BFALSE);
						}
						BgL_new1085z00_846 = BgL_new1084z00_851;
					}
					((((BgL_ev_appz00_bglt) CREF(BgL_new1085z00_846))->BgL_locz00) =
						((obj_t) BgL_locz00_43), BUNSPEC);
					{
						BgL_ev_exprz00_bglt BgL_auxz00_4432;

						{	/* Eval/evaluate.scm 250 */
							BgL_ev_littz00_bglt BgL_new1087z00_847;

							{	/* Eval/evaluate.scm 250 */
								BgL_ev_littz00_bglt BgL_new1086z00_848;

								BgL_new1086z00_848 =
									((BgL_ev_littz00_bglt) BREF(GC_MALLOC(sizeof(struct
												BgL_ev_littz00_bgl))));
								{	/* Eval/evaluate.scm 250 */
									long BgL_arg1388z00_849;

									{	/* Eval/evaluate.scm 250 */
										long BgL_res2375z00_2437;

										{	/* Eval/evaluate.scm 250 */
											obj_t BgL_classz00_2436;

											BgL_classz00_2436 = BGl_ev_littz00zz__evaluate_typesz00;
											BgL_res2375z00_2437 = BGL_CLASS_INDEX(BgL_classz00_2436);
										}
										BgL_arg1388z00_849 = BgL_res2375z00_2437;
									}
									{	/* Eval/evaluate.scm 250 */
										BgL_objectz00_bglt BgL_objz00_2438;

										BgL_objz00_2438 = ((BgL_objectz00_bglt) BgL_new1086z00_848);
										BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2438,
											BgL_arg1388z00_849);
								}}
								{	/* Eval/evaluate.scm 250 */
									BgL_objectz00_bglt BgL_auxz00_4437;

									BgL_auxz00_4437 = ((BgL_objectz00_bglt) BgL_new1086z00_848);
									BGL_OBJECT_WIDENING_SET(BgL_auxz00_4437, BFALSE);
								}
								BgL_new1087z00_847 = BgL_new1086z00_848;
							}
							((((BgL_ev_littz00_bglt) CREF(BgL_new1087z00_847))->
									BgL_valuez00) = ((obj_t) BgL_getz00_845), BUNSPEC);
							BgL_auxz00_4432 = ((BgL_ev_exprz00_bglt) BgL_new1087z00_847);
						}
						((((BgL_ev_appz00_bglt) CREF(BgL_new1085z00_846))->BgL_funz00) =
							((BgL_ev_exprz00_bglt) BgL_auxz00_4432), BUNSPEC);
					}
					{
						obj_t BgL_auxz00_4443;

						{	/* Eval/evaluate.scm 251 */
							obj_t BgL_list1389z00_850;

							BgL_list1389z00_850 = MAKE_PAIR(((obj_t) BgL_argz00_42), BNIL);
							BgL_auxz00_4443 = BgL_list1389z00_850;
						}
						((((BgL_ev_appz00_bglt) CREF(BgL_new1085z00_846))->BgL_argsz00) =
							((obj_t) BgL_auxz00_4443), BUNSPEC);
					}
					((((BgL_ev_appz00_bglt) CREF(BgL_new1085z00_846))->BgL_tailzf3zf3) =
						((obj_t) BgL_tailzf3zf3_44), BUNSPEC);
					return BgL_new1085z00_846;
				}
			}
		}
	}



/* make-class-field-set */
	BgL_ev_appz00_bglt BGl_makezd2classzd2fieldzd2setzd2zz__evaluatez00(obj_t
		BgL_fieldz00_45, obj_t BgL_argsz00_46, obj_t BgL_locz00_47,
		obj_t BgL_tailzf3zf3_48)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 257 */
			{	/* Eval/evaluate.scm 258 */
				obj_t BgL_setz00_853;

				BgL_setz00_853 =
					BGl_classzd2fieldzd2mutatorz00zz__objectz00(BgL_fieldz00_45);
				{	/* Eval/evaluate.scm 259 */
					BgL_ev_appz00_bglt BgL_new1089z00_854;

					{	/* Eval/evaluate.scm 259 */
						BgL_ev_appz00_bglt BgL_new1088z00_858;

						BgL_new1088z00_858 =
							((BgL_ev_appz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_appz00_bgl))));
						{	/* Eval/evaluate.scm 259 */
							long BgL_arg1392z00_859;

							{	/* Eval/evaluate.scm 259 */
								long BgL_res2377z00_2443;

								BgL_res2377z00_2443 =
									BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00);
								BgL_arg1392z00_859 = BgL_res2377z00_2443;
							}
							{	/* Eval/evaluate.scm 259 */
								BgL_objectz00_bglt BgL_objz00_2444;

								BgL_objz00_2444 = ((BgL_objectz00_bglt) BgL_new1088z00_858);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2444, BgL_arg1392z00_859);
						}}
						{	/* Eval/evaluate.scm 259 */
							BgL_objectz00_bglt BgL_auxz00_4453;

							BgL_auxz00_4453 = ((BgL_objectz00_bglt) BgL_new1088z00_858);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4453, BFALSE);
						}
						BgL_new1089z00_854 = BgL_new1088z00_858;
					}
					((((BgL_ev_appz00_bglt) CREF(BgL_new1089z00_854))->BgL_locz00) =
						((obj_t) BgL_locz00_47), BUNSPEC);
					{
						BgL_ev_exprz00_bglt BgL_auxz00_4457;

						{	/* Eval/evaluate.scm 261 */
							BgL_ev_littz00_bglt BgL_new1091z00_855;

							{	/* Eval/evaluate.scm 261 */
								BgL_ev_littz00_bglt BgL_new1090z00_856;

								BgL_new1090z00_856 =
									((BgL_ev_littz00_bglt) BREF(GC_MALLOC(sizeof(struct
												BgL_ev_littz00_bgl))));
								{	/* Eval/evaluate.scm 261 */
									long BgL_arg1391z00_857;

									{	/* Eval/evaluate.scm 261 */
										long BgL_res2378z00_2447;

										{	/* Eval/evaluate.scm 261 */
											obj_t BgL_classz00_2446;

											BgL_classz00_2446 = BGl_ev_littz00zz__evaluate_typesz00;
											BgL_res2378z00_2447 = BGL_CLASS_INDEX(BgL_classz00_2446);
										}
										BgL_arg1391z00_857 = BgL_res2378z00_2447;
									}
									{	/* Eval/evaluate.scm 261 */
										BgL_objectz00_bglt BgL_objz00_2448;

										BgL_objz00_2448 = ((BgL_objectz00_bglt) BgL_new1090z00_856);
										BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2448,
											BgL_arg1391z00_857);
								}}
								{	/* Eval/evaluate.scm 261 */
									BgL_objectz00_bglt BgL_auxz00_4462;

									BgL_auxz00_4462 = ((BgL_objectz00_bglt) BgL_new1090z00_856);
									BGL_OBJECT_WIDENING_SET(BgL_auxz00_4462, BFALSE);
								}
								BgL_new1091z00_855 = BgL_new1090z00_856;
							}
							((((BgL_ev_littz00_bglt) CREF(BgL_new1091z00_855))->
									BgL_valuez00) = ((obj_t) BgL_setz00_853), BUNSPEC);
							BgL_auxz00_4457 = ((BgL_ev_exprz00_bglt) BgL_new1091z00_855);
						}
						((((BgL_ev_appz00_bglt) CREF(BgL_new1089z00_854))->BgL_funz00) =
							((BgL_ev_exprz00_bglt) BgL_auxz00_4457), BUNSPEC);
					}
					((((BgL_ev_appz00_bglt) CREF(BgL_new1089z00_854))->BgL_argsz00) =
						((obj_t) BgL_argsz00_46), BUNSPEC);
					((((BgL_ev_appz00_bglt) CREF(BgL_new1089z00_854))->BgL_tailzf3zf3) =
						((obj_t) BgL_tailzf3zf3_48), BUNSPEC);
					return BgL_new1089z00_854;
				}
			}
		}
	}



/* conv */
	obj_t BGl_convz00zz__evaluatez00(obj_t BgL_ez00_49, obj_t BgL_localsz00_50,
		obj_t BgL_globalsz00_51, obj_t BgL_tailzf3zf3_52, obj_t BgL_wherez00_53,
		obj_t BgL_locz00_54, bool_t BgL_topzf3zf3_55)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 268 */
		BGl_convz00zz__evaluatez00:
			{
				obj_t BgL_xz00_866;
				obj_t BgL_bahz00_868;
				obj_t BgL_lz00_873;
				obj_t BgL_funz00_875;
				obj_t BgL_argsz00_876;
				obj_t BgL_ez00_878;
				obj_t BgL_pz00_882;
				obj_t BgL_tz00_883;
				obj_t BgL_oz00_884;
				obj_t BgL_pz00_886;
				obj_t BgL_tz00_887;
				obj_t BgL_argsz00_889;
				obj_t BgL_argsz00_891;
				obj_t BgL_bindsz00_895;
				obj_t BgL_bodyz00_896;
				obj_t BgL_bindsz00_898;
				obj_t BgL_bodyz00_899;
				obj_t BgL_bindsz00_901;
				obj_t BgL_bodyz00_902;
				obj_t BgL_lz00_908;
				obj_t BgL_e2z00_909;
				obj_t BgL_vz00_911;
				obj_t BgL_ez00_912;
				obj_t BgL_gvz00_915;
				obj_t BgL_formalsz00_916;
				obj_t BgL_bodyz00_917;
				obj_t BgL_gvz00_919;
				obj_t BgL_gez00_920;
				obj_t BgL_vz00_922;
				obj_t BgL_bodyz00_923;
				obj_t BgL_ez00_925;
				obj_t BgL_bodyz00_926;
				obj_t BgL_hz00_928;
				obj_t BgL_bodyz00_929;
				obj_t BgL_mz00_935;
				obj_t BgL_bodyz00_936;
				obj_t BgL_fz00_941;
				obj_t BgL_argsz00_942;

				if (PAIRP(BgL_ez00_49))
					{	/* Eval/evaluate.scm 319 */
						if ((CAR(BgL_ez00_49) == BGl_symbol2653z00zz__evaluatez00))
							{	/* Eval/evaluate.scm 319 */
								BgL_bahz00_868 = CDR(BgL_ez00_49);
								if (BgL_topzf3zf3_55)
									{	/* Eval/evaluate.scm 331 */
										obj_t BgL_arg1976z00_1634;

										{	/* Eval/evaluate.scm 331 */
											obj_t BgL_arg1977z00_1635;

											{	/* Eval/evaluate.scm 331 */
												obj_t BgL_arg1978z00_1636;

												{	/* Eval/evaluate.scm 129 */
													obj_t BgL__ortest_1067z00_2526;

													BgL__ortest_1067z00_2526 =
														BGl_getzd2sourcezd2locationz00zz__readerz00
														(BgL_ez00_49);
													if (CBOOL(BgL__ortest_1067z00_2526))
														{	/* Eval/evaluate.scm 129 */
															BgL_arg1978z00_1636 = BgL__ortest_1067z00_2526;
														}
													else
														{	/* Eval/evaluate.scm 129 */
															BgL_arg1978z00_1636 = BgL_locz00_54;
														}
												}
												BgL_arg1977z00_1635 =
													BGl_evmodulez00zz__evmodulez00(BgL_ez00_49,
													BgL_arg1978z00_1636);
											}
											BgL_arg1976z00_1634 =
												BGl_expandz00zz__expandz00(BgL_arg1977z00_1635);
										}
										{
											bool_t BgL_topzf3zf3_4484;
											obj_t BgL_wherez00_4483;
											obj_t BgL_tailzf3zf3_4482;
											obj_t BgL_ez00_4481;

											BgL_ez00_4481 = BgL_arg1976z00_1634;
											BgL_tailzf3zf3_4482 = BgL_wherez00_53;
											BgL_wherez00_4483 = BFALSE;
											BgL_topzf3zf3_4484 = ((bool_t) 1);
											BgL_topzf3zf3_55 = BgL_topzf3zf3_4484;
											BgL_wherez00_53 = BgL_wherez00_4483;
											BgL_tailzf3zf3_52 = BgL_tailzf3zf3_4482;
											BgL_ez00_49 = BgL_ez00_4481;
											goto BGl_convz00zz__evaluatez00;
										}
									}
								else
									{	/* Eval/evaluate.scm 330 */
										return
											BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_54,
											BGl_string2643z00zz__evaluatez00,
											BGl_string2652z00zz__evaluatez00, BgL_ez00_49);
									}
							}
						else
							{	/* Eval/evaluate.scm 319 */
								obj_t BgL_cdrzd2231zd2_949;

								BgL_cdrzd2231zd2_949 = CDR(BgL_ez00_49);
								if ((CAR(BgL_ez00_49) == BGl_symbol2655z00zz__evaluatez00))
									{	/* Eval/evaluate.scm 319 */
										if (PAIRP(BgL_cdrzd2231zd2_949))
											{	/* Eval/evaluate.scm 319 */
												obj_t BgL_carzd2234zd2_952;
												obj_t BgL_cdrzd2235zd2_953;

												BgL_carzd2234zd2_952 = CAR(BgL_cdrzd2231zd2_949);
												BgL_cdrzd2235zd2_953 = CDR(BgL_cdrzd2231zd2_949);
												if (SYMBOLP(BgL_carzd2234zd2_952))
													{	/* Eval/evaluate.scm 319 */
														if (PAIRP(BgL_cdrzd2235zd2_953))
															{	/* Eval/evaluate.scm 319 */
																obj_t BgL_carzd2239zd2_956;

																BgL_carzd2239zd2_956 =
																	CAR(BgL_cdrzd2235zd2_953);
																if (SYMBOLP(BgL_carzd2239zd2_956))
																	{	/* Eval/evaluate.scm 319 */
																		if (NULLP(CDR(BgL_cdrzd2235zd2_953)))
																			{	/* Eval/evaluate.scm 319 */
																				obj_t BgL_idz00_3017;
																				obj_t BgL_modnamez00_3018;

																				BgL_idz00_3017 = BgL_carzd2234zd2_952;
																				BgL_modnamez00_3018 =
																					BgL_carzd2239zd2_956;
																				{	/* Eval/evaluate.scm 334 */
																					BgL_ev_globalz00_bglt
																						BgL_new1105z00_3019;
																					{	/* Eval/evaluate.scm 334 */
																						BgL_ev_globalz00_bglt
																							BgL_new1104z00_3020;
																						BgL_new1104z00_3020 =
																							((BgL_ev_globalz00_bglt)
																							BREF(GC_MALLOC(sizeof(struct
																										BgL_ev_globalz00_bgl))));
																						{	/* Eval/evaluate.scm 334 */
																							long BgL_arg1979z00_3021;

																							{	/* Eval/evaluate.scm 334 */
																								long BgL_res2461z00_3023;

																								BgL_res2461z00_3023 =
																									BGL_CLASS_INDEX
																									(BGl_ev_globalz00zz__evaluate_typesz00);
																								BgL_arg1979z00_3021 =
																									BgL_res2461z00_3023;
																							}
																							{	/* Eval/evaluate.scm 334 */
																								BgL_objectz00_bglt
																									BgL_objz00_3024;
																								BgL_objz00_3024 =
																									((BgL_objectz00_bglt)
																									BgL_new1104z00_3020);
																								BGL_OBJECT_CLASS_NUM_SET
																									(BgL_objz00_3024,
																									BgL_arg1979z00_3021);
																						}}
																						{	/* Eval/evaluate.scm 334 */
																							BgL_objectz00_bglt
																								BgL_auxz00_4509;
																							BgL_auxz00_4509 =
																								((BgL_objectz00_bglt)
																								BgL_new1104z00_3020);
																							BGL_OBJECT_WIDENING_SET
																								(BgL_auxz00_4509, BFALSE);
																						}
																						BgL_new1105z00_3019 =
																							BgL_new1104z00_3020;
																					}
																					((((BgL_ev_globalz00_bglt)
																								CREF(BgL_new1105z00_3019))->
																							BgL_locz00) =
																						((obj_t) BgL_locz00_54), BUNSPEC);
																					((((BgL_ev_globalz00_bglt)
																								CREF(BgL_new1105z00_3019))->
																							BgL_namez00) =
																						((obj_t) BgL_idz00_3017), BUNSPEC);
																					((((BgL_ev_globalz00_bglt)
																								CREF(BgL_new1105z00_3019))->
																							BgL_modz00) =
																						((obj_t)
																							BGl_evalzd2findzd2modulez00zz__evmodulez00
																							(BgL_modnamez00_3018)), BUNSPEC);
																					return ((obj_t) BgL_new1105z00_3019);
																				}
																			}
																		else
																			{	/* Eval/evaluate.scm 319 */
																				obj_t BgL_carzd2284zd2_959;

																				BgL_carzd2284zd2_959 = CAR(BgL_ez00_49);
																				if (SYMBOLP(BgL_carzd2284zd2_959))
																					{	/* Eval/evaluate.scm 319 */
																						if (CBOOL
																							(BGl_convzd2varzd2zz__evaluatez00
																								(BgL_carzd2284zd2_959,
																									BgL_localsz00_50)))
																							{
																								BgL_ev_appz00_bglt
																									BgL_auxz00_4523;
																								BgL_funz00_875 =
																									BgL_carzd2284zd2_959;
																								BgL_argsz00_876 =
																									BgL_cdrzd2231zd2_949;
																							BgL_tagzd2134zd2_877:
																								{	/* Eval/evaluate.scm 346 */
																									obj_t BgL_funz00_1653;
																									obj_t BgL_argsz00_1654;

																									{	/* Eval/evaluate.scm 280 */
																										obj_t BgL_arg2097z00_2546;

																										{	/* Eval/evaluate.scm 129 */
																											obj_t
																												BgL__ortest_1067z00_2549;
																											BgL__ortest_1067z00_2549 =
																												BGl_getzd2sourcezd2locationz00zz__readerz00
																												(BgL_funz00_875);
																											if (CBOOL
																												(BgL__ortest_1067z00_2549))
																												{	/* Eval/evaluate.scm 129 */
																													BgL_arg2097z00_2546 =
																														BgL__ortest_1067z00_2549;
																												}
																											else
																												{	/* Eval/evaluate.scm 129 */
																													BgL_arg2097z00_2546 =
																														BgL_locz00_54;
																												}
																										}
																										BgL_funz00_1653 =
																											BGl_convz00zz__evaluatez00
																											(BgL_funz00_875,
																											BgL_localsz00_50,
																											BgL_globalsz00_51, BFALSE,
																											BgL_wherez00_53,
																											BgL_arg2097z00_2546,
																											((bool_t) 0));
																									}
																									BgL_argsz00_1654 =
																										BGl_loopz00zz__evaluatez00
																										(BgL_wherez00_53,
																										BgL_globalsz00_51,
																										BgL_localsz00_50,
																										BgL_locz00_54,
																										BgL_argsz00_876);
																									{	/* Eval/evaluate.scm 347 */
																										BgL_ev_appz00_bglt
																											BgL_new1107z00_1655;
																										{	/* Eval/evaluate.scm 347 */
																											BgL_ev_appz00_bglt
																												BgL_new1106z00_1656;
																											BgL_new1106z00_1656 =
																												((BgL_ev_appz00_bglt)
																												BREF(GC_MALLOC(sizeof
																														(struct
																															BgL_ev_appz00_bgl))));
																											{	/* Eval/evaluate.scm 347 */
																												long
																													BgL_arg1988z00_1657;
																												{	/* Eval/evaluate.scm 347 */
																													long
																														BgL_res2400z00_2553;
																													BgL_res2400z00_2553 =
																														BGL_CLASS_INDEX
																														(BGl_ev_appz00zz__evaluate_typesz00);
																													BgL_arg1988z00_1657 =
																														BgL_res2400z00_2553;
																												}
																												{	/* Eval/evaluate.scm 347 */
																													BgL_objectz00_bglt
																														BgL_objz00_2554;
																													BgL_objz00_2554 =
																														(
																														(BgL_objectz00_bglt)
																														BgL_new1106z00_1656);
																													BGL_OBJECT_CLASS_NUM_SET
																														(BgL_objz00_2554,
																														BgL_arg1988z00_1657);
																											}}
																											{	/* Eval/evaluate.scm 347 */
																												BgL_objectz00_bglt
																													BgL_auxz00_4533;
																												BgL_auxz00_4533 =
																													((BgL_objectz00_bglt)
																													BgL_new1106z00_1656);
																												BGL_OBJECT_WIDENING_SET
																													(BgL_auxz00_4533,
																													BFALSE);
																											}
																											BgL_new1107z00_1655 =
																												BgL_new1106z00_1656;
																										}
																										((((BgL_ev_appz00_bglt)
																													CREF
																													(BgL_new1107z00_1655))->
																												BgL_locz00) =
																											((obj_t) BgL_locz00_54),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													CREF
																													(BgL_new1107z00_1655))->
																												BgL_funz00) =
																											((BgL_ev_exprz00_bglt) (
																													(BgL_ev_exprz00_bglt)
																													BgL_funz00_1653)),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													CREF
																													(BgL_new1107z00_1655))->
																												BgL_argsz00) =
																											((obj_t)
																												BgL_argsz00_1654),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													CREF
																													(BgL_new1107z00_1655))->
																												BgL_tailzf3zf3) =
																											((obj_t)
																												BgL_tailzf3zf3_52),
																											BUNSPEC);
																										BgL_auxz00_4523 =
																											BgL_new1107z00_1655;
																								}}
																								return
																									((obj_t) BgL_auxz00_4523);
																							}
																						else
																							{
																								BgL_ev_appz00_bglt
																									BgL_auxz00_4542;
																								BgL_fz00_941 =
																									BgL_carzd2284zd2_959;
																								BgL_argsz00_942 =
																									BgL_cdrzd2231zd2_949;
																							BgL_tagzd2157zd2_943:
																								{	/* Eval/evaluate.scm 484 */
																									obj_t BgL_funz00_1866;
																									obj_t BgL_argsz00_1867;

																									{	/* Eval/evaluate.scm 280 */
																										obj_t BgL_arg2097z00_2987;

																										{	/* Eval/evaluate.scm 129 */
																											obj_t
																												BgL__ortest_1067z00_2990;
																											BgL__ortest_1067z00_2990 =
																												BGl_getzd2sourcezd2locationz00zz__readerz00
																												(BgL_fz00_941);
																											if (CBOOL
																												(BgL__ortest_1067z00_2990))
																												{	/* Eval/evaluate.scm 129 */
																													BgL_arg2097z00_2987 =
																														BgL__ortest_1067z00_2990;
																												}
																											else
																												{	/* Eval/evaluate.scm 129 */
																													BgL_arg2097z00_2987 =
																														BgL_locz00_54;
																												}
																										}
																										BgL_funz00_1866 =
																											BGl_convz00zz__evaluatez00
																											(BgL_fz00_941,
																											BgL_localsz00_50,
																											BgL_globalsz00_51, BFALSE,
																											BgL_wherez00_53,
																											BgL_arg2097z00_2987,
																											((bool_t) 0));
																									}
																									BgL_argsz00_1867 =
																										BGl_loopz00zz__evaluatez00
																										(BgL_wherez00_53,
																										BgL_globalsz00_51,
																										BgL_localsz00_50,
																										BgL_locz00_54,
																										BgL_argsz00_942);
																									{	/* Eval/evaluate.scm 485 */
																										BgL_ev_appz00_bglt
																											BgL_new1158z00_1868;
																										{	/* Eval/evaluate.scm 485 */
																											BgL_ev_appz00_bglt
																												BgL_new1157z00_1869;
																											BgL_new1157z00_1869 =
																												((BgL_ev_appz00_bglt)
																												BREF(GC_MALLOC(sizeof
																														(struct
																															BgL_ev_appz00_bgl))));
																											{	/* Eval/evaluate.scm 485 */
																												long
																													BgL_arg2091z00_1870;
																												{	/* Eval/evaluate.scm 485 */
																													long
																														BgL_res2454z00_2994;
																													BgL_res2454z00_2994 =
																														BGL_CLASS_INDEX
																														(BGl_ev_appz00zz__evaluate_typesz00);
																													BgL_arg2091z00_1870 =
																														BgL_res2454z00_2994;
																												}
																												{	/* Eval/evaluate.scm 485 */
																													BgL_objectz00_bglt
																														BgL_objz00_2995;
																													BgL_objz00_2995 =
																														(
																														(BgL_objectz00_bglt)
																														BgL_new1157z00_1869);
																													BGL_OBJECT_CLASS_NUM_SET
																														(BgL_objz00_2995,
																														BgL_arg2091z00_1870);
																											}}
																											{	/* Eval/evaluate.scm 485 */
																												BgL_objectz00_bglt
																													BgL_auxz00_4552;
																												BgL_auxz00_4552 =
																													((BgL_objectz00_bglt)
																													BgL_new1157z00_1869);
																												BGL_OBJECT_WIDENING_SET
																													(BgL_auxz00_4552,
																													BFALSE);
																											}
																											BgL_new1158z00_1868 =
																												BgL_new1157z00_1869;
																										}
																										((((BgL_ev_appz00_bglt)
																													CREF
																													(BgL_new1158z00_1868))->
																												BgL_locz00) =
																											((obj_t) BgL_locz00_54),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													CREF
																													(BgL_new1158z00_1868))->
																												BgL_funz00) =
																											((BgL_ev_exprz00_bglt) (
																													(BgL_ev_exprz00_bglt)
																													BgL_funz00_1866)),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													CREF
																													(BgL_new1158z00_1868))->
																												BgL_argsz00) =
																											((obj_t)
																												BgL_argsz00_1867),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													CREF
																													(BgL_new1158z00_1868))->
																												BgL_tailzf3zf3) =
																											((obj_t)
																												BgL_tailzf3zf3_52),
																											BUNSPEC);
																										BgL_auxz00_4542 =
																											BgL_new1158z00_1868;
																								}}
																								return
																									((obj_t) BgL_auxz00_4542);
																							}
																					}
																				else
																					{
																						BgL_ev_appz00_bglt BgL_auxz00_4561;

																						{
																							obj_t BgL_argsz00_4563;
																							obj_t BgL_fz00_4562;

																							BgL_fz00_4562 =
																								BgL_carzd2284zd2_959;
																							BgL_argsz00_4563 =
																								BgL_cdrzd2231zd2_949;
																							BgL_argsz00_942 =
																								BgL_argsz00_4563;
																							BgL_fz00_941 = BgL_fz00_4562;
																							goto BgL_tagzd2157zd2_943;
																						}
																						return ((obj_t) BgL_auxz00_4561);
																					}
																			}
																	}
																else
																	{	/* Eval/evaluate.scm 319 */
																		obj_t BgL_carzd2987zd2_969;

																		BgL_carzd2987zd2_969 = CAR(BgL_ez00_49);
																		if (SYMBOLP(BgL_carzd2987zd2_969))
																			{	/* Eval/evaluate.scm 319 */
																				if (CBOOL
																					(BGl_convzd2varzd2zz__evaluatez00
																						(BgL_carzd2987zd2_969,
																							BgL_localsz00_50)))
																					{
																						BgL_ev_appz00_bglt BgL_auxz00_4571;

																						{
																							obj_t BgL_argsz00_4573;
																							obj_t BgL_funz00_4572;

																							BgL_funz00_4572 =
																								BgL_carzd2987zd2_969;
																							BgL_argsz00_4573 =
																								BgL_cdrzd2231zd2_949;
																							BgL_argsz00_876 =
																								BgL_argsz00_4573;
																							BgL_funz00_875 = BgL_funz00_4572;
																							goto BgL_tagzd2134zd2_877;
																						}
																						return ((obj_t) BgL_auxz00_4571);
																					}
																				else
																					{
																						BgL_ev_appz00_bglt BgL_auxz00_4575;

																						{
																							obj_t BgL_argsz00_4577;
																							obj_t BgL_fz00_4576;

																							BgL_fz00_4576 =
																								BgL_carzd2987zd2_969;
																							BgL_argsz00_4577 =
																								BgL_cdrzd2231zd2_949;
																							BgL_argsz00_942 =
																								BgL_argsz00_4577;
																							BgL_fz00_941 = BgL_fz00_4576;
																							goto BgL_tagzd2157zd2_943;
																						}
																						return ((obj_t) BgL_auxz00_4575);
																					}
																			}
																		else
																			{
																				BgL_ev_appz00_bglt BgL_auxz00_4579;

																				{
																					obj_t BgL_argsz00_4581;
																					obj_t BgL_fz00_4580;

																					BgL_fz00_4580 = BgL_carzd2987zd2_969;
																					BgL_argsz00_4581 =
																						BgL_cdrzd2231zd2_949;
																					BgL_argsz00_942 = BgL_argsz00_4581;
																					BgL_fz00_941 = BgL_fz00_4580;
																					goto BgL_tagzd2157zd2_943;
																				}
																				return ((obj_t) BgL_auxz00_4579);
																			}
																	}
															}
														else
															{	/* Eval/evaluate.scm 319 */
																obj_t BgL_carzd21690zd2_978;

																BgL_carzd21690zd2_978 = CAR(BgL_ez00_49);
																if (SYMBOLP(BgL_carzd21690zd2_978))
																	{	/* Eval/evaluate.scm 319 */
																		if (CBOOL(BGl_convzd2varzd2zz__evaluatez00
																				(BgL_carzd21690zd2_978,
																					BgL_localsz00_50)))
																			{
																				BgL_ev_appz00_bglt BgL_auxz00_4589;

																				{
																					obj_t BgL_argsz00_4591;
																					obj_t BgL_funz00_4590;

																					BgL_funz00_4590 =
																						BgL_carzd21690zd2_978;
																					BgL_argsz00_4591 =
																						BgL_cdrzd2231zd2_949;
																					BgL_argsz00_876 = BgL_argsz00_4591;
																					BgL_funz00_875 = BgL_funz00_4590;
																					goto BgL_tagzd2134zd2_877;
																				}
																				return ((obj_t) BgL_auxz00_4589);
																			}
																		else
																			{
																				BgL_ev_appz00_bglt BgL_auxz00_4593;

																				{
																					obj_t BgL_argsz00_4595;
																					obj_t BgL_fz00_4594;

																					BgL_fz00_4594 = BgL_carzd21690zd2_978;
																					BgL_argsz00_4595 =
																						BgL_cdrzd2231zd2_949;
																					BgL_argsz00_942 = BgL_argsz00_4595;
																					BgL_fz00_941 = BgL_fz00_4594;
																					goto BgL_tagzd2157zd2_943;
																				}
																				return ((obj_t) BgL_auxz00_4593);
																			}
																	}
																else
																	{
																		BgL_ev_appz00_bglt BgL_auxz00_4597;

																		{
																			obj_t BgL_argsz00_4599;
																			obj_t BgL_fz00_4598;

																			BgL_fz00_4598 = BgL_carzd21690zd2_978;
																			BgL_argsz00_4599 = BgL_cdrzd2231zd2_949;
																			BgL_argsz00_942 = BgL_argsz00_4599;
																			BgL_fz00_941 = BgL_fz00_4598;
																			goto BgL_tagzd2157zd2_943;
																		}
																		return ((obj_t) BgL_auxz00_4597);
																	}
															}
													}
												else
													{	/* Eval/evaluate.scm 319 */
														obj_t BgL_carzd22393zd2_987;

														BgL_carzd22393zd2_987 = CAR(BgL_ez00_49);
														if (SYMBOLP(BgL_carzd22393zd2_987))
															{	/* Eval/evaluate.scm 319 */
																if (CBOOL(BGl_convzd2varzd2zz__evaluatez00
																		(BgL_carzd22393zd2_987, BgL_localsz00_50)))
																	{
																		BgL_ev_appz00_bglt BgL_auxz00_4607;

																		{
																			obj_t BgL_argsz00_4609;
																			obj_t BgL_funz00_4608;

																			BgL_funz00_4608 = BgL_carzd22393zd2_987;
																			BgL_argsz00_4609 = BgL_cdrzd2231zd2_949;
																			BgL_argsz00_876 = BgL_argsz00_4609;
																			BgL_funz00_875 = BgL_funz00_4608;
																			goto BgL_tagzd2134zd2_877;
																		}
																		return ((obj_t) BgL_auxz00_4607);
																	}
																else
																	{
																		BgL_ev_appz00_bglt BgL_auxz00_4611;

																		{
																			obj_t BgL_argsz00_4613;
																			obj_t BgL_fz00_4612;

																			BgL_fz00_4612 = BgL_carzd22393zd2_987;
																			BgL_argsz00_4613 = BgL_cdrzd2231zd2_949;
																			BgL_argsz00_942 = BgL_argsz00_4613;
																			BgL_fz00_941 = BgL_fz00_4612;
																			goto BgL_tagzd2157zd2_943;
																		}
																		return ((obj_t) BgL_auxz00_4611);
																	}
															}
														else
															{
																BgL_ev_appz00_bglt BgL_auxz00_4615;

																{
																	obj_t BgL_argsz00_4617;
																	obj_t BgL_fz00_4616;

																	BgL_fz00_4616 = BgL_carzd22393zd2_987;
																	BgL_argsz00_4617 = BgL_cdrzd2231zd2_949;
																	BgL_argsz00_942 = BgL_argsz00_4617;
																	BgL_fz00_941 = BgL_fz00_4616;
																	goto BgL_tagzd2157zd2_943;
																}
																return ((obj_t) BgL_auxz00_4615);
															}
													}
											}
										else
											{	/* Eval/evaluate.scm 319 */
												obj_t BgL_carzd23096zd2_996;

												BgL_carzd23096zd2_996 = CAR(BgL_ez00_49);
												if (SYMBOLP(BgL_carzd23096zd2_996))
													{	/* Eval/evaluate.scm 319 */
														if (CBOOL(BGl_convzd2varzd2zz__evaluatez00
																(BgL_carzd23096zd2_996, BgL_localsz00_50)))
															{
																BgL_ev_appz00_bglt BgL_auxz00_4625;

																{
																	obj_t BgL_argsz00_4627;
																	obj_t BgL_funz00_4626;

																	BgL_funz00_4626 = BgL_carzd23096zd2_996;
																	BgL_argsz00_4627 = BgL_cdrzd2231zd2_949;
																	BgL_argsz00_876 = BgL_argsz00_4627;
																	BgL_funz00_875 = BgL_funz00_4626;
																	goto BgL_tagzd2134zd2_877;
																}
																return ((obj_t) BgL_auxz00_4625);
															}
														else
															{
																BgL_ev_appz00_bglt BgL_auxz00_4629;

																{
																	obj_t BgL_argsz00_4631;
																	obj_t BgL_fz00_4630;

																	BgL_fz00_4630 = BgL_carzd23096zd2_996;
																	BgL_argsz00_4631 = BgL_cdrzd2231zd2_949;
																	BgL_argsz00_942 = BgL_argsz00_4631;
																	BgL_fz00_941 = BgL_fz00_4630;
																	goto BgL_tagzd2157zd2_943;
																}
																return ((obj_t) BgL_auxz00_4629);
															}
													}
												else
													{
														BgL_ev_appz00_bglt BgL_auxz00_4633;

														{
															obj_t BgL_argsz00_4635;
															obj_t BgL_fz00_4634;

															BgL_fz00_4634 = BgL_carzd23096zd2_996;
															BgL_argsz00_4635 = BgL_cdrzd2231zd2_949;
															BgL_argsz00_942 = BgL_argsz00_4635;
															BgL_fz00_941 = BgL_fz00_4634;
															goto BgL_tagzd2157zd2_943;
														}
														return ((obj_t) BgL_auxz00_4633);
													}
											}
									}
								else
									{	/* Eval/evaluate.scm 319 */
										if ((CAR(BgL_ez00_49) == BGl_symbol2657z00zz__evaluatez00))
											{	/* Eval/evaluate.scm 319 */
												BgL_lz00_873 = BgL_cdrzd2231zd2_949;
												{	/* Eval/evaluate.scm 339 */
													bool_t BgL_testz00_4640;

													if (PAIRP(BgL_lz00_873))
														{	/* Eval/evaluate.scm 339 */
															bool_t BgL_testz00_4643;

															{	/* Ieee/pairlist.scm 214 */
																obj_t BgL_auxz00_4644;

																BgL_auxz00_4644 = CDR(BgL_lz00_873);
																BgL_testz00_4643 = PAIRP(BgL_auxz00_4644);
															}
															if (BgL_testz00_4643)
																{
																	obj_t BgL_l1190z00_1644;

																	BgL_l1190z00_1644 = BgL_lz00_873;
																BgL_zc3anonymousza31983ze3z83_1645:
																	if (NULLP(BgL_l1190z00_1644))
																		{	/* Eval/evaluate.scm 339 */
																			BgL_testz00_4640 = ((bool_t) 1);
																		}
																	else
																		{	/* Eval/evaluate.scm 339 */
																			bool_t BgL_testz00_4649;

																			{	/* Ieee/symbol.scm 129 */
																				obj_t BgL_auxz00_4650;

																				BgL_auxz00_4650 =
																					CAR(BgL_l1190z00_1644);
																				BgL_testz00_4649 =
																					SYMBOLP(BgL_auxz00_4650);
																			}
																			if (BgL_testz00_4649)
																				{
																					obj_t BgL_l1190z00_4653;

																					BgL_l1190z00_4653 =
																						CDR(BgL_l1190z00_1644);
																					BgL_l1190z00_1644 = BgL_l1190z00_4653;
																					goto
																						BgL_zc3anonymousza31983ze3z83_1645;
																				}
																			else
																				{	/* Eval/evaluate.scm 339 */
																					BgL_testz00_4640 = ((bool_t) 0);
																				}
																		}
																}
															else
																{	/* Eval/evaluate.scm 339 */
																	BgL_testz00_4640 = ((bool_t) 0);
																}
														}
													else
														{	/* Eval/evaluate.scm 339 */
															BgL_testz00_4640 = ((bool_t) 0);
														}
													if (BgL_testz00_4640)
														{	/* Eval/evaluate.scm 339 */
															return
																BGl_convzd2fieldzd2refz00zz__evaluatez00
																(BgL_ez00_49, BgL_localsz00_50,
																BgL_globalsz00_51, BgL_tailzf3zf3_52,
																BgL_wherez00_53, BgL_locz00_54,
																BgL_topzf3zf3_55);
														}
													else
														{	/* Eval/evaluate.scm 339 */
															return
																BGl_evcompilezd2errorzd2zz__evcompilez00
																(BgL_locz00_54,
																BGl_string2643z00zz__evaluatez00,
																BGl_string2649z00zz__evaluatez00, BgL_ez00_49);
														}
												}
											}
										else
											{	/* Eval/evaluate.scm 319 */
												obj_t BgL_carzd23802zd2_1007;

												BgL_carzd23802zd2_1007 = CAR(BgL_ez00_49);
												if (SYMBOLP(BgL_carzd23802zd2_1007))
													{	/* Eval/evaluate.scm 319 */
														if (CBOOL(BGl_convzd2varzd2zz__evaluatez00
																(BgL_carzd23802zd2_1007, BgL_localsz00_50)))
															{
																BgL_ev_appz00_bglt BgL_auxz00_4663;

																{
																	obj_t BgL_argsz00_4665;
																	obj_t BgL_funz00_4664;

																	BgL_funz00_4664 = BgL_carzd23802zd2_1007;
																	BgL_argsz00_4665 = BgL_cdrzd2231zd2_949;
																	BgL_argsz00_876 = BgL_argsz00_4665;
																	BgL_funz00_875 = BgL_funz00_4664;
																	goto BgL_tagzd2134zd2_877;
																}
																return ((obj_t) BgL_auxz00_4663);
															}
														else
															{	/* Eval/evaluate.scm 319 */
																if (
																	(BgL_carzd23802zd2_1007 ==
																		BGl_symbol2659z00zz__evaluatez00))
																	{	/* Eval/evaluate.scm 319 */
																		if (PAIRP(BgL_cdrzd2231zd2_949))
																			{	/* Eval/evaluate.scm 319 */
																				if (NULLP(CDR(BgL_cdrzd2231zd2_949)))
																					{	/* Eval/evaluate.scm 319 */
																						obj_t BgL_arg1453z00_1015;

																						BgL_arg1453z00_1015 =
																							CAR(BgL_cdrzd2231zd2_949);
																						{
																							BgL_ev_trapz00_bglt
																								BgL_auxz00_4675;
																							BgL_ez00_878 =
																								BgL_arg1453z00_1015;
																						BgL_tagzd2135zd2_879:
																							{	/* Eval/evaluate.scm 353 */
																								BgL_ev_trapz00_bglt
																									BgL_new1109z00_1658;
																								{	/* Eval/evaluate.scm 353 */
																									BgL_ev_trapz00_bglt
																										BgL_new1108z00_1659;
																									BgL_new1108z00_1659 =
																										((BgL_ev_trapz00_bglt)
																										BREF(GC_MALLOC(sizeof(struct
																													BgL_ev_trapz00_bgl))));
																									{	/* Eval/evaluate.scm 353 */
																										long BgL_arg1989z00_1660;

																										{	/* Eval/evaluate.scm 353 */
																											long BgL_res2401z00_2557;

																											BgL_res2401z00_2557 =
																												BGL_CLASS_INDEX
																												(BGl_ev_trapz00zz__evaluate_typesz00);
																											BgL_arg1989z00_1660 =
																												BgL_res2401z00_2557;
																										}
																										{	/* Eval/evaluate.scm 353 */
																											BgL_objectz00_bglt
																												BgL_objz00_2558;
																											BgL_objz00_2558 =
																												((BgL_objectz00_bglt)
																												BgL_new1108z00_1659);
																											BGL_OBJECT_CLASS_NUM_SET
																												(BgL_objz00_2558,
																												BgL_arg1989z00_1660);
																									}}
																									{	/* Eval/evaluate.scm 353 */
																										BgL_objectz00_bglt
																											BgL_auxz00_4680;
																										BgL_auxz00_4680 =
																											((BgL_objectz00_bglt)
																											BgL_new1108z00_1659);
																										BGL_OBJECT_WIDENING_SET
																											(BgL_auxz00_4680, BFALSE);
																									}
																									BgL_new1109z00_1658 =
																										BgL_new1108z00_1659;
																								}
																								{
																									BgL_ev_exprz00_bglt
																										BgL_auxz00_4683;
																									{	/* Eval/evaluate.scm 280 */
																										obj_t BgL_arg2097z00_2561;

																										{	/* Eval/evaluate.scm 129 */
																											obj_t
																												BgL__ortest_1067z00_2564;
																											BgL__ortest_1067z00_2564 =
																												BGl_getzd2sourcezd2locationz00zz__readerz00
																												(BgL_ez00_878);
																											if (CBOOL
																												(BgL__ortest_1067z00_2564))
																												{	/* Eval/evaluate.scm 129 */
																													BgL_arg2097z00_2561 =
																														BgL__ortest_1067z00_2564;
																												}
																											else
																												{	/* Eval/evaluate.scm 129 */
																													BgL_arg2097z00_2561 =
																														BgL_locz00_54;
																												}
																										}
																										BgL_auxz00_4683 =
																											((BgL_ev_exprz00_bglt)
																											BGl_convz00zz__evaluatez00
																											(BgL_ez00_878,
																												BgL_localsz00_50,
																												BgL_globalsz00_51,
																												BFALSE, BgL_wherez00_53,
																												BgL_arg2097z00_2561,
																												((bool_t) 0)));
																									}
																									((((BgL_ev_hookz00_bglt) CREF(
																													((BgL_ev_hookz00_bglt)
																														BgL_new1109z00_1658)))->
																											BgL_ez00) =
																										((BgL_ev_exprz00_bglt)
																											BgL_auxz00_4683),
																										BUNSPEC);
																								}
																								BgL_auxz00_4675 =
																									BgL_new1109z00_1658;
																							}
																							return ((obj_t) BgL_auxz00_4675);
																						}
																					}
																				else
																					{	/* Eval/evaluate.scm 319 */
																						obj_t BgL_arg1454z00_1016;
																						obj_t BgL_arg1455z00_1017;

																						BgL_arg1454z00_1016 =
																							CAR(BgL_ez00_49);
																						BgL_arg1455z00_1017 =
																							CDR(BgL_ez00_49);
																						{
																							BgL_ev_appz00_bglt
																								BgL_auxz00_4694;
																							{
																								obj_t BgL_argsz00_4696;
																								obj_t BgL_fz00_4695;

																								BgL_fz00_4695 =
																									BgL_arg1454z00_1016;
																								BgL_argsz00_4696 =
																									BgL_arg1455z00_1017;
																								BgL_argsz00_942 =
																									BgL_argsz00_4696;
																								BgL_fz00_941 = BgL_fz00_4695;
																								goto BgL_tagzd2157zd2_943;
																							}
																							return ((obj_t) BgL_auxz00_4694);
																						}
																					}
																			}
																		else
																			{	/* Eval/evaluate.scm 319 */
																				obj_t BgL_arg1457z00_1019;
																				obj_t BgL_arg1459z00_1020;

																				BgL_arg1457z00_1019 = CAR(BgL_ez00_49);
																				BgL_arg1459z00_1020 = CDR(BgL_ez00_49);
																				{
																					BgL_ev_appz00_bglt BgL_auxz00_4700;

																					{
																						obj_t BgL_argsz00_4702;
																						obj_t BgL_fz00_4701;

																						BgL_fz00_4701 = BgL_arg1457z00_1019;
																						BgL_argsz00_4702 =
																							BgL_arg1459z00_1020;
																						BgL_argsz00_942 = BgL_argsz00_4702;
																						BgL_fz00_941 = BgL_fz00_4701;
																						goto BgL_tagzd2157zd2_943;
																					}
																					return ((obj_t) BgL_auxz00_4700);
																				}
																			}
																	}
																else
																	{	/* Eval/evaluate.scm 319 */
																		obj_t BgL_cdrzd24471zd2_1021;

																		BgL_cdrzd24471zd2_1021 = CDR(BgL_ez00_49);
																		if (
																			(CAR(BgL_ez00_49) ==
																				BGl_symbol2661z00zz__evaluatez00))
																			{	/* Eval/evaluate.scm 319 */
																				if (PAIRP(BgL_cdrzd24471zd2_1021))
																					{	/* Eval/evaluate.scm 319 */
																						if (NULLP(CDR
																								(BgL_cdrzd24471zd2_1021)))
																							{	/* Eval/evaluate.scm 319 */
																								obj_t BgL_arg1463z00_1025;

																								BgL_arg1463z00_1025 =
																									CAR(BgL_cdrzd24471zd2_1021);
																								{	/* Eval/evaluate.scm 356 */
																									BgL_ev_littz00_bglt
																										BgL_new1111z00_3093;
																									{	/* Eval/evaluate.scm 356 */
																										BgL_ev_littz00_bglt
																											BgL_new1110z00_3094;
																										BgL_new1110z00_3094 =
																											((BgL_ev_littz00_bglt)
																											BREF(GC_MALLOC(sizeof
																													(struct
																														BgL_ev_littz00_bgl))));
																										{	/* Eval/evaluate.scm 356 */
																											long BgL_arg1991z00_3095;

																											{	/* Eval/evaluate.scm 356 */
																												long
																													BgL_res2472z00_3097;
																												BgL_res2472z00_3097 =
																													BGL_CLASS_INDEX
																													(BGl_ev_littz00zz__evaluate_typesz00);
																												BgL_arg1991z00_3095 =
																													BgL_res2472z00_3097;
																											}
																											{	/* Eval/evaluate.scm 356 */
																												BgL_objectz00_bglt
																													BgL_objz00_3098;
																												BgL_objz00_3098 =
																													((BgL_objectz00_bglt)
																													BgL_new1110z00_3094);
																												BGL_OBJECT_CLASS_NUM_SET
																													(BgL_objz00_3098,
																													BgL_arg1991z00_3095);
																										}}
																										{	/* Eval/evaluate.scm 356 */
																											BgL_objectz00_bglt
																												BgL_auxz00_4718;
																											BgL_auxz00_4718 =
																												((BgL_objectz00_bglt)
																												BgL_new1110z00_3094);
																											BGL_OBJECT_WIDENING_SET
																												(BgL_auxz00_4718,
																												BFALSE);
																										}
																										BgL_new1111z00_3093 =
																											BgL_new1110z00_3094;
																									}
																									((((BgL_ev_littz00_bglt)
																												CREF
																												(BgL_new1111z00_3093))->
																											BgL_valuez00) =
																										((obj_t)
																											BgL_arg1463z00_1025),
																										BUNSPEC);
																									return ((obj_t)
																										BgL_new1111z00_3093);
																								}
																							}
																						else
																							{	/* Eval/evaluate.scm 319 */
																								obj_t BgL_arg1465z00_1026;

																								BgL_arg1465z00_1026 =
																									CAR(BgL_ez00_49);
																								{
																									BgL_ev_appz00_bglt
																										BgL_auxz00_4724;
																									{
																										obj_t BgL_argsz00_4726;
																										obj_t BgL_fz00_4725;

																										BgL_fz00_4725 =
																											BgL_arg1465z00_1026;
																										BgL_argsz00_4726 =
																											BgL_cdrzd24471zd2_1021;
																										BgL_argsz00_942 =
																											BgL_argsz00_4726;
																										BgL_fz00_941 =
																											BgL_fz00_4725;
																										goto BgL_tagzd2157zd2_943;
																									}
																									return
																										((obj_t) BgL_auxz00_4724);
																								}
																							}
																					}
																				else
																					{	/* Eval/evaluate.scm 319 */
																						obj_t BgL_arg1469z00_1029;

																						BgL_arg1469z00_1029 =
																							CAR(BgL_ez00_49);
																						{
																							BgL_ev_appz00_bglt
																								BgL_auxz00_4729;
																							{
																								obj_t BgL_argsz00_4731;
																								obj_t BgL_fz00_4730;

																								BgL_fz00_4730 =
																									BgL_arg1469z00_1029;
																								BgL_argsz00_4731 =
																									BgL_cdrzd24471zd2_1021;
																								BgL_argsz00_942 =
																									BgL_argsz00_4731;
																								BgL_fz00_941 = BgL_fz00_4730;
																								goto BgL_tagzd2157zd2_943;
																							}
																							return ((obj_t) BgL_auxz00_4729);
																						}
																					}
																			}
																		else
																			{	/* Eval/evaluate.scm 319 */
																				if (
																					(CAR(BgL_ez00_49) ==
																						BGl_symbol2663z00zz__evaluatez00))
																					{	/* Eval/evaluate.scm 319 */
																						if (PAIRP(BgL_cdrzd24471zd2_1021))
																							{	/* Eval/evaluate.scm 319 */
																								obj_t BgL_cdrzd25081zd2_1034;

																								BgL_cdrzd25081zd2_1034 =
																									CDR(BgL_cdrzd24471zd2_1021);
																								if (PAIRP
																									(BgL_cdrzd25081zd2_1034))
																									{	/* Eval/evaluate.scm 319 */
																										obj_t
																											BgL_cdrzd25086zd2_1036;
																										BgL_cdrzd25086zd2_1036 =
																											CDR
																											(BgL_cdrzd25081zd2_1034);
																										if (PAIRP
																											(BgL_cdrzd25086zd2_1036))
																											{	/* Eval/evaluate.scm 319 */
																												if (NULLP(CDR
																														(BgL_cdrzd25086zd2_1036)))
																													{	/* Eval/evaluate.scm 319 */
																														obj_t
																															BgL_arg1476z00_1039;
																														obj_t
																															BgL_arg1477z00_1040;
																														obj_t
																															BgL_arg1478z00_1041;
																														BgL_arg1476z00_1039
																															=
																															CAR
																															(BgL_cdrzd24471zd2_1021);
																														BgL_arg1477z00_1040
																															=
																															CAR
																															(BgL_cdrzd25081zd2_1034);
																														BgL_arg1478z00_1041
																															=
																															CAR
																															(BgL_cdrzd25086zd2_1036);
																														{
																															BgL_ev_ifz00_bglt
																																BgL_auxz00_4750;
																															BgL_pz00_882 =
																																BgL_arg1476z00_1039;
																															BgL_tz00_883 =
																																BgL_arg1477z00_1040;
																															BgL_oz00_884 =
																																BgL_arg1478z00_1041;
																														BgL_tagzd2137zd2_885:
																															{	/* Eval/evaluate.scm 359 */
																																BgL_ev_ifz00_bglt
																																	BgL_new1114z00_1664;
																																{	/* Eval/evaluate.scm 359 */
																																	BgL_ev_ifz00_bglt
																																		BgL_new1113z00_1668;
																																	BgL_new1113z00_1668
																																		=
																																		(
																																		(BgL_ev_ifz00_bglt)
																																		BREF
																																		(GC_MALLOC
																																			(sizeof
																																				(struct
																																					BgL_ev_ifz00_bgl))));
																																	{	/* Eval/evaluate.scm 359 */
																																		long
																																			BgL_arg1995z00_1669;
																																		{	/* Eval/evaluate.scm 359 */
																																			long
																																				BgL_res2403z00_2575;
																																			BgL_res2403z00_2575
																																				=
																																				BGL_CLASS_INDEX
																																				(BGl_ev_ifz00zz__evaluate_typesz00);
																																			BgL_arg1995z00_1669
																																				=
																																				BgL_res2403z00_2575;
																																		}
																																		{	/* Eval/evaluate.scm 359 */
																																			BgL_objectz00_bglt
																																				BgL_objz00_2576;
																																			BgL_objz00_2576
																																				=
																																				(
																																				(BgL_objectz00_bglt)
																																				BgL_new1113z00_1668);
																																			BGL_OBJECT_CLASS_NUM_SET
																																				(BgL_objz00_2576,
																																				BgL_arg1995z00_1669);
																																	}}
																																	{	/* Eval/evaluate.scm 359 */
																																		BgL_objectz00_bglt
																																			BgL_auxz00_4755;
																																		BgL_auxz00_4755
																																			=
																																			(
																																			(BgL_objectz00_bglt)
																																			BgL_new1113z00_1668);
																																		BGL_OBJECT_WIDENING_SET
																																			(BgL_auxz00_4755,
																																			BFALSE);
																																	}
																																	BgL_new1114z00_1664
																																		=
																																		BgL_new1113z00_1668;
																																}
																																{
																																	BgL_ev_exprz00_bglt
																																		BgL_auxz00_4758;
																																	{	/* Eval/evaluate.scm 360 */
																																		obj_t
																																			BgL_arg1992z00_1665;
																																		{	/* Eval/evaluate.scm 129 */
																																			obj_t
																																				BgL__ortest_1067z00_2580;
																																			BgL__ortest_1067z00_2580
																																				=
																																				BGl_getzd2sourcezd2locationz00zz__readerz00
																																				(BgL_pz00_882);
																																			if (CBOOL
																																				(BgL__ortest_1067z00_2580))
																																				{	/* Eval/evaluate.scm 129 */
																																					BgL_arg1992z00_1665
																																						=
																																						BgL__ortest_1067z00_2580;
																																				}
																																			else
																																				{	/* Eval/evaluate.scm 129 */
																																					BgL_arg1992z00_1665
																																						=
																																						BgL_locz00_54;
																																				}
																																		}
																																		BgL_auxz00_4758
																																			=
																																			(
																																			(BgL_ev_exprz00_bglt)
																																			BGl_convz00zz__evaluatez00
																																			(BgL_pz00_882,
																																				BgL_localsz00_50,
																																				BgL_globalsz00_51,
																																				BFALSE,
																																				BgL_wherez00_53,
																																				BgL_arg1992z00_1665,
																																				((bool_t) 0)));
																																	}
																																	((((BgL_ev_ifz00_bglt) CREF(BgL_new1114z00_1664))->BgL_pz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4758), BUNSPEC);
																																}
																																{
																																	BgL_ev_exprz00_bglt
																																		BgL_auxz00_4765;
																																	{	/* Eval/evaluate.scm 361 */
																																		obj_t
																																			BgL_arg1993z00_1666;
																																		{	/* Eval/evaluate.scm 129 */
																																			obj_t
																																				BgL__ortest_1067z00_2585;
																																			BgL__ortest_1067z00_2585
																																				=
																																				BGl_getzd2sourcezd2locationz00zz__readerz00
																																				(BgL_tz00_883);
																																			if (CBOOL
																																				(BgL__ortest_1067z00_2585))
																																				{	/* Eval/evaluate.scm 129 */
																																					BgL_arg1993z00_1666
																																						=
																																						BgL__ortest_1067z00_2585;
																																				}
																																			else
																																				{	/* Eval/evaluate.scm 129 */
																																					BgL_arg1993z00_1666
																																						=
																																						BgL_locz00_54;
																																				}
																																		}
																																		BgL_auxz00_4765
																																			=
																																			(
																																			(BgL_ev_exprz00_bglt)
																																			BGl_convz00zz__evaluatez00
																																			(BgL_tz00_883,
																																				BgL_localsz00_50,
																																				BgL_globalsz00_51,
																																				BgL_tailzf3zf3_52,
																																				BgL_wherez00_53,
																																				BgL_arg1993z00_1666,
																																				((bool_t) 0)));
																																	}
																																	((((BgL_ev_ifz00_bglt) CREF(BgL_new1114z00_1664))->BgL_tz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4765), BUNSPEC);
																																}
																																{
																																	BgL_ev_exprz00_bglt
																																		BgL_auxz00_4772;
																																	{	/* Eval/evaluate.scm 362 */
																																		obj_t
																																			BgL_arg1994z00_1667;
																																		{	/* Eval/evaluate.scm 129 */
																																			obj_t
																																				BgL__ortest_1067z00_2590;
																																			BgL__ortest_1067z00_2590
																																				=
																																				BGl_getzd2sourcezd2locationz00zz__readerz00
																																				(BgL_oz00_884);
																																			if (CBOOL
																																				(BgL__ortest_1067z00_2590))
																																				{	/* Eval/evaluate.scm 129 */
																																					BgL_arg1994z00_1667
																																						=
																																						BgL__ortest_1067z00_2590;
																																				}
																																			else
																																				{	/* Eval/evaluate.scm 129 */
																																					BgL_arg1994z00_1667
																																						=
																																						BgL_locz00_54;
																																				}
																																		}
																																		BgL_auxz00_4772
																																			=
																																			(
																																			(BgL_ev_exprz00_bglt)
																																			BGl_convz00zz__evaluatez00
																																			(BgL_oz00_884,
																																				BgL_localsz00_50,
																																				BgL_globalsz00_51,
																																				BgL_tailzf3zf3_52,
																																				BgL_wherez00_53,
																																				BgL_arg1994z00_1667,
																																				((bool_t) 0)));
																																	}
																																	((((BgL_ev_ifz00_bglt) CREF(BgL_new1114z00_1664))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4772), BUNSPEC);
																																}
																																BgL_auxz00_4750
																																	=
																																	BgL_new1114z00_1664;
																															}
																															return
																																((obj_t)
																																BgL_auxz00_4750);
																														}
																													}
																												else
																													{	/* Eval/evaluate.scm 319 */
																														obj_t
																															BgL_arg1479z00_1042;
																														obj_t
																															BgL_arg1480z00_1043;
																														BgL_arg1479z00_1042
																															=
																															CAR(BgL_ez00_49);
																														BgL_arg1480z00_1043
																															=
																															CDR(BgL_ez00_49);
																														{
																															BgL_ev_appz00_bglt
																																BgL_auxz00_4782;
																															{
																																obj_t
																																	BgL_argsz00_4784;
																																obj_t
																																	BgL_fz00_4783;
																																BgL_fz00_4783 =
																																	BgL_arg1479z00_1042;
																																BgL_argsz00_4784
																																	=
																																	BgL_arg1480z00_1043;
																																BgL_argsz00_942
																																	=
																																	BgL_argsz00_4784;
																																BgL_fz00_941 =
																																	BgL_fz00_4783;
																																goto
																																	BgL_tagzd2157zd2_943;
																															}
																															return
																																((obj_t)
																																BgL_auxz00_4782);
																														}
																													}
																											}
																										else
																											{	/* Eval/evaluate.scm 319 */
																												obj_t
																													BgL_cdrzd25384zd2_1045;
																												BgL_cdrzd25384zd2_1045 =
																													CDR(BgL_ez00_49);
																												{	/* Eval/evaluate.scm 319 */
																													obj_t
																														BgL_cdrzd25390zd2_1046;
																													BgL_cdrzd25390zd2_1046
																														=
																														CDR
																														(BgL_cdrzd25384zd2_1045);
																													if (NULLP(CDR
																															(BgL_cdrzd25390zd2_1046)))
																														{	/* Eval/evaluate.scm 319 */
																															obj_t
																																BgL_arg1484z00_1048;
																															obj_t
																																BgL_arg1486z00_1049;
																															BgL_arg1484z00_1048
																																=
																																CAR
																																(BgL_cdrzd25384zd2_1045);
																															BgL_arg1486z00_1049
																																=
																																CAR
																																(BgL_cdrzd25390zd2_1046);
																															{
																																BgL_ev_ifz00_bglt
																																	BgL_auxz00_4793;
																																BgL_pz00_886 =
																																	BgL_arg1484z00_1048;
																																BgL_tz00_887 =
																																	BgL_arg1486z00_1049;
																															BgL_tagzd2138zd2_888:
																																{	/* Eval/evaluate.scm 364 */
																																	BgL_ev_ifz00_bglt
																																		BgL_new1116z00_1670;
																																	{	/* Eval/evaluate.scm 364 */
																																		BgL_ev_ifz00_bglt
																																			BgL_new1115z00_1674;
																																		BgL_new1115z00_1674
																																			=
																																			(
																																			(BgL_ev_ifz00_bglt)
																																			BREF
																																			(GC_MALLOC
																																				(sizeof
																																					(struct
																																						BgL_ev_ifz00_bgl))));
																																		{	/* Eval/evaluate.scm 364 */
																																			long
																																				BgL_arg1999z00_1675;
																																			{	/* Eval/evaluate.scm 364 */
																																				long
																																					BgL_res2404z00_2594;
																																				BgL_res2404z00_2594
																																					=
																																					BGL_CLASS_INDEX
																																					(BGl_ev_ifz00zz__evaluate_typesz00);
																																				BgL_arg1999z00_1675
																																					=
																																					BgL_res2404z00_2594;
																																			}
																																			{	/* Eval/evaluate.scm 364 */
																																				BgL_objectz00_bglt
																																					BgL_objz00_2595;
																																				BgL_objz00_2595
																																					=
																																					(
																																					(BgL_objectz00_bglt)
																																					BgL_new1115z00_1674);
																																				BGL_OBJECT_CLASS_NUM_SET
																																					(BgL_objz00_2595,
																																					BgL_arg1999z00_1675);
																																		}}
																																		{	/* Eval/evaluate.scm 364 */
																																			BgL_objectz00_bglt
																																				BgL_auxz00_4798;
																																			BgL_auxz00_4798
																																				=
																																				(
																																				(BgL_objectz00_bglt)
																																				BgL_new1115z00_1674);
																																			BGL_OBJECT_WIDENING_SET
																																				(BgL_auxz00_4798,
																																				BFALSE);
																																		}
																																		BgL_new1116z00_1670
																																			=
																																			BgL_new1115z00_1674;
																																	}
																																	{
																																		BgL_ev_exprz00_bglt
																																			BgL_auxz00_4801;
																																		{	/* Eval/evaluate.scm 365 */
																																			obj_t
																																				BgL_arg1996z00_1671;
																																			{	/* Eval/evaluate.scm 129 */
																																				obj_t
																																					BgL__ortest_1067z00_2599;
																																				BgL__ortest_1067z00_2599
																																					=
																																					BGl_getzd2sourcezd2locationz00zz__readerz00
																																					(BgL_pz00_886);
																																				if (CBOOL(BgL__ortest_1067z00_2599))
																																					{	/* Eval/evaluate.scm 129 */
																																						BgL_arg1996z00_1671
																																							=
																																							BgL__ortest_1067z00_2599;
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 129 */
																																						BgL_arg1996z00_1671
																																							=
																																							BgL_locz00_54;
																																					}
																																			}
																																			BgL_auxz00_4801
																																				=
																																				(
																																				(BgL_ev_exprz00_bglt)
																																				BGl_convz00zz__evaluatez00
																																				(BgL_pz00_886,
																																					BgL_localsz00_50,
																																					BgL_globalsz00_51,
																																					BFALSE,
																																					BgL_wherez00_53,
																																					BgL_arg1996z00_1671,
																																					((bool_t) 0)));
																																		}
																																		((((BgL_ev_ifz00_bglt) CREF(BgL_new1116z00_1670))->BgL_pz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4801), BUNSPEC);
																																	}
																																	{
																																		BgL_ev_exprz00_bglt
																																			BgL_auxz00_4808;
																																		{	/* Eval/evaluate.scm 366 */
																																			obj_t
																																				BgL_arg1997z00_1672;
																																			{	/* Eval/evaluate.scm 129 */
																																				obj_t
																																					BgL__ortest_1067z00_2604;
																																				BgL__ortest_1067z00_2604
																																					=
																																					BGl_getzd2sourcezd2locationz00zz__readerz00
																																					(BgL_tz00_887);
																																				if (CBOOL(BgL__ortest_1067z00_2604))
																																					{	/* Eval/evaluate.scm 129 */
																																						BgL_arg1997z00_1672
																																							=
																																							BgL__ortest_1067z00_2604;
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 129 */
																																						BgL_arg1997z00_1672
																																							=
																																							BgL_locz00_54;
																																					}
																																			}
																																			BgL_auxz00_4808
																																				=
																																				(
																																				(BgL_ev_exprz00_bglt)
																																				BGl_convz00zz__evaluatez00
																																				(BgL_tz00_887,
																																					BgL_localsz00_50,
																																					BgL_globalsz00_51,
																																					BgL_tailzf3zf3_52,
																																					BgL_wherez00_53,
																																					BgL_arg1997z00_1672,
																																					((bool_t) 0)));
																																		}
																																		((((BgL_ev_ifz00_bglt) CREF(BgL_new1116z00_1670))->BgL_tz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4808), BUNSPEC);
																																	}
																																	{
																																		BgL_ev_exprz00_bglt
																																			BgL_auxz00_4815;
																																		{	/* Eval/evaluate.scm 367 */
																																			obj_t
																																				BgL_arg1998z00_1673;
																																			{	/* Eval/evaluate.scm 129 */
																																				obj_t
																																					BgL__ortest_1067z00_2609;
																																				BgL__ortest_1067z00_2609
																																					=
																																					BGl_getzd2sourcezd2locationz00zz__readerz00
																																					(BFALSE);
																																				if (CBOOL(BgL__ortest_1067z00_2609))
																																					{	/* Eval/evaluate.scm 129 */
																																						BgL_arg1998z00_1673
																																							=
																																							BgL__ortest_1067z00_2609;
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 129 */
																																						BgL_arg1998z00_1673
																																							=
																																							BgL_locz00_54;
																																					}
																																			}
																																			BgL_auxz00_4815
																																				=
																																				(
																																				(BgL_ev_exprz00_bglt)
																																				BGl_convz00zz__evaluatez00
																																				(BgL_ez00_49,
																																					BgL_localsz00_50,
																																					BgL_globalsz00_51,
																																					BgL_tailzf3zf3_52,
																																					BgL_wherez00_53,
																																					BgL_arg1998z00_1673,
																																					((bool_t) 0)));
																																		}
																																		((((BgL_ev_ifz00_bglt) CREF(BgL_new1116z00_1670))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4815), BUNSPEC);
																																	}
																																	BgL_auxz00_4793
																																		=
																																		BgL_new1116z00_1670;
																																}
																																return
																																	((obj_t)
																																	BgL_auxz00_4793);
																															}
																														}
																													else
																														{	/* Eval/evaluate.scm 319 */
																															obj_t
																																BgL_arg1487z00_1050;
																															BgL_arg1487z00_1050
																																=
																																CAR
																																(BgL_ez00_49);
																															{
																																BgL_ev_appz00_bglt
																																	BgL_auxz00_4824;
																																{
																																	obj_t
																																		BgL_argsz00_4826;
																																	obj_t
																																		BgL_fz00_4825;
																																	BgL_fz00_4825
																																		=
																																		BgL_arg1487z00_1050;
																																	BgL_argsz00_4826
																																		=
																																		BgL_cdrzd25384zd2_1045;
																																	BgL_argsz00_942
																																		=
																																		BgL_argsz00_4826;
																																	BgL_fz00_941 =
																																		BgL_fz00_4825;
																																	goto
																																		BgL_tagzd2157zd2_943;
																																}
																																return
																																	((obj_t)
																																	BgL_auxz00_4824);
																															}
																														}
																												}
																											}
																									}
																								else
																									{	/* Eval/evaluate.scm 319 */
																										obj_t BgL_arg1490z00_1053;
																										obj_t BgL_arg1491z00_1054;

																										BgL_arg1490z00_1053 =
																											CAR(BgL_ez00_49);
																										BgL_arg1491z00_1054 =
																											CDR(BgL_ez00_49);
																										{
																											BgL_ev_appz00_bglt
																												BgL_auxz00_4830;
																											{
																												obj_t BgL_argsz00_4832;
																												obj_t BgL_fz00_4831;

																												BgL_fz00_4831 =
																													BgL_arg1490z00_1053;
																												BgL_argsz00_4832 =
																													BgL_arg1491z00_1054;
																												BgL_argsz00_942 =
																													BgL_argsz00_4832;
																												BgL_fz00_941 =
																													BgL_fz00_4831;
																												goto
																													BgL_tagzd2157zd2_943;
																											}
																											return
																												((obj_t)
																												BgL_auxz00_4830);
																										}
																									}
																							}
																						else
																							{	/* Eval/evaluate.scm 319 */
																								obj_t BgL_arg1492z00_1055;
																								obj_t BgL_arg1493z00_1056;

																								BgL_arg1492z00_1055 =
																									CAR(BgL_ez00_49);
																								BgL_arg1493z00_1056 =
																									CDR(BgL_ez00_49);
																								{
																									BgL_ev_appz00_bglt
																										BgL_auxz00_4836;
																									{
																										obj_t BgL_argsz00_4838;
																										obj_t BgL_fz00_4837;

																										BgL_fz00_4837 =
																											BgL_arg1492z00_1055;
																										BgL_argsz00_4838 =
																											BgL_arg1493z00_1056;
																										BgL_argsz00_942 =
																											BgL_argsz00_4838;
																										BgL_fz00_941 =
																											BgL_fz00_4837;
																										goto BgL_tagzd2157zd2_943;
																									}
																									return
																										((obj_t) BgL_auxz00_4836);
																								}
																							}
																					}
																				else
																					{	/* Eval/evaluate.scm 319 */
																						if (
																							(CAR(BgL_ez00_49) ==
																								BGl_symbol2665z00zz__evaluatez00))
																							{	/* Eval/evaluate.scm 319 */
																								obj_t BgL_arg1495z00_1058;

																								BgL_arg1495z00_1058 =
																									CDR(BgL_ez00_49);
																								{
																									BgL_ev_orz00_bglt
																										BgL_auxz00_4844;
																									BgL_argsz00_889 =
																										BgL_arg1495z00_1058;
																								BgL_tagzd2139zd2_890:
																									{	/* Eval/evaluate.scm 369 */
																										BgL_ev_orz00_bglt
																											BgL_new1118z00_1676;
																										{	/* Eval/evaluate.scm 369 */
																											BgL_ev_orz00_bglt
																												BgL_new1117z00_1677;
																											BgL_new1117z00_1677 =
																												((BgL_ev_orz00_bglt)
																												BREF(GC_MALLOC(sizeof
																														(struct
																															BgL_ev_orz00_bgl))));
																											{	/* Eval/evaluate.scm 369 */
																												long
																													BgL_arg2000z00_1678;
																												{	/* Eval/evaluate.scm 369 */
																													long
																														BgL_res2405z00_2613;
																													BgL_res2405z00_2613 =
																														BGL_CLASS_INDEX
																														(BGl_ev_orz00zz__evaluate_typesz00);
																													BgL_arg2000z00_1678 =
																														BgL_res2405z00_2613;
																												}
																												{	/* Eval/evaluate.scm 369 */
																													BgL_objectz00_bglt
																														BgL_objz00_2614;
																													BgL_objz00_2614 =
																														(
																														(BgL_objectz00_bglt)
																														BgL_new1117z00_1677);
																													BGL_OBJECT_CLASS_NUM_SET
																														(BgL_objz00_2614,
																														BgL_arg2000z00_1678);
																											}}
																											{	/* Eval/evaluate.scm 369 */
																												BgL_objectz00_bglt
																													BgL_auxz00_4849;
																												BgL_auxz00_4849 =
																													((BgL_objectz00_bglt)
																													BgL_new1117z00_1677);
																												BGL_OBJECT_WIDENING_SET
																													(BgL_auxz00_4849,
																													BFALSE);
																											}
																											BgL_new1118z00_1676 =
																												BgL_new1117z00_1677;
																										}
																										((((BgL_ev_listz00_bglt)
																													CREF((
																															(BgL_ev_listz00_bglt)
																															BgL_new1118z00_1676)))->
																												BgL_argsz00) =
																											((obj_t)
																												BGl_loopz00zz__evaluatez00
																												(BgL_wherez00_53,
																													BgL_globalsz00_51,
																													BgL_localsz00_50,
																													BgL_locz00_54,
																													BgL_argsz00_889)),
																											BUNSPEC);
																										BgL_auxz00_4844 =
																											BgL_new1118z00_1676;
																									}
																									return
																										((obj_t) BgL_auxz00_4844);
																								}
																							}
																						else
																							{	/* Eval/evaluate.scm 319 */
																								if (
																									(CAR(BgL_ez00_49) ==
																										BGl_symbol2667z00zz__evaluatez00))
																									{	/* Eval/evaluate.scm 319 */
																										obj_t BgL_arg1497z00_1060;

																										BgL_arg1497z00_1060 =
																											CDR(BgL_ez00_49);
																										{
																											BgL_ev_andz00_bglt
																												BgL_auxz00_4860;
																											BgL_argsz00_891 =
																												BgL_arg1497z00_1060;
																										BgL_tagzd2140zd2_892:
																											{	/* Eval/evaluate.scm 372 */
																												BgL_ev_andz00_bglt
																													BgL_new1120z00_1679;
																												{	/* Eval/evaluate.scm 372 */
																													BgL_ev_andz00_bglt
																														BgL_new1119z00_1680;
																													BgL_new1119z00_1680 =
																														(
																														(BgL_ev_andz00_bglt)
																														BREF(GC_MALLOC
																															(sizeof(struct
																																	BgL_ev_andz00_bgl))));
																													{	/* Eval/evaluate.scm 372 */
																														long
																															BgL_arg2001z00_1681;
																														{	/* Eval/evaluate.scm 372 */
																															long
																																BgL_res2406z00_2617;
																															BgL_res2406z00_2617
																																=
																																BGL_CLASS_INDEX
																																(BGl_ev_andz00zz__evaluate_typesz00);
																															BgL_arg2001z00_1681
																																=
																																BgL_res2406z00_2617;
																														}
																														{	/* Eval/evaluate.scm 372 */
																															BgL_objectz00_bglt
																																BgL_objz00_2618;
																															BgL_objz00_2618 =
																																(
																																(BgL_objectz00_bglt)
																																BgL_new1119z00_1680);
																															BGL_OBJECT_CLASS_NUM_SET
																																(BgL_objz00_2618,
																																BgL_arg2001z00_1681);
																													}}
																													{	/* Eval/evaluate.scm 372 */
																														BgL_objectz00_bglt
																															BgL_auxz00_4865;
																														BgL_auxz00_4865 =
																															(
																															(BgL_objectz00_bglt)
																															BgL_new1119z00_1680);
																														BGL_OBJECT_WIDENING_SET
																															(BgL_auxz00_4865,
																															BFALSE);
																													}
																													BgL_new1120z00_1679 =
																														BgL_new1119z00_1680;
																												}
																												((((BgL_ev_listz00_bglt)
																															CREF((
																																	(BgL_ev_listz00_bglt)
																																	BgL_new1120z00_1679)))->
																														BgL_argsz00) =
																													((obj_t)
																														BGl_loopz00zz__evaluatez00
																														(BgL_wherez00_53,
																															BgL_globalsz00_51,
																															BgL_localsz00_50,
																															BgL_locz00_54,
																															BgL_argsz00_891)),
																													BUNSPEC);
																												BgL_auxz00_4860 =
																													BgL_new1120z00_1679;
																											}
																											return
																												((obj_t)
																												BgL_auxz00_4860);
																										}
																									}
																								else
																									{	/* Eval/evaluate.scm 319 */
																										if (
																											(CAR(BgL_ez00_49) ==
																												BGl_symbol2669z00zz__evaluatez00))
																											{	/* Eval/evaluate.scm 319 */
																												return
																													BGl_convzd2beginzd2zz__evaluatez00
																													(CDR(BgL_ez00_49),
																													BgL_localsz00_50,
																													BgL_globalsz00_51,
																													BgL_tailzf3zf3_52,
																													BgL_wherez00_53,
																													BgL_locz00_54,
																													BgL_topzf3zf3_55);
																											}
																										else
																											{	/* Eval/evaluate.scm 319 */
																												obj_t
																													BgL_cdrzd26283zd2_1063;
																												BgL_cdrzd26283zd2_1063 =
																													CDR(BgL_ez00_49);
																												if ((CAR(BgL_ez00_49) ==
																														BGl_symbol2671z00zz__evaluatez00))
																													{	/* Eval/evaluate.scm 319 */
																														if (PAIRP
																															(BgL_cdrzd26283zd2_1063))
																															{	/* Eval/evaluate.scm 319 */
																																obj_t
																																	BgL_arg1503z00_1066;
																																obj_t
																																	BgL_arg1504z00_1067;
																																BgL_arg1503z00_1066
																																	=
																																	CAR
																																	(BgL_cdrzd26283zd2_1063);
																																BgL_arg1504z00_1067
																																	=
																																	CDR
																																	(BgL_cdrzd26283zd2_1063);
																																{
																																	BgL_ev_letz00_bglt
																																		BgL_auxz00_4885;
																																	BgL_bindsz00_895
																																		=
																																		BgL_arg1503z00_1066;
																																	BgL_bodyz00_896
																																		=
																																		BgL_arg1504z00_1067;
																																BgL_tagzd2142zd2_897:
																																	{	/* Eval/evaluate.scm 377 */
																																		obj_t
																																			BgL_varsz00_1682;
																																		if (NULLP
																																			(BgL_bindsz00_895))
																																			{	/* Eval/evaluate.scm 377 */
																																				BgL_varsz00_1682
																																					=
																																					BNIL;
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 377 */
																																				obj_t
																																					BgL_head1195z00_1705;
																																				{	/* Eval/evaluate.scm 377 */
																																					obj_t
																																						BgL_res2408z00_2624;
																																					BgL_res2408z00_2624
																																						=
																																						MAKE_PAIR
																																						(BNIL,
																																						BNIL);
																																					BgL_head1195z00_1705
																																						=
																																						BgL_res2408z00_2624;
																																				}
																																				{
																																					obj_t
																																						BgL_l1193z00_1707;
																																					obj_t
																																						BgL_tail1196z00_1708;
																																					BgL_l1193z00_1707
																																						=
																																						BgL_bindsz00_895;
																																					BgL_tail1196z00_1708
																																						=
																																						BgL_head1195z00_1705;
																																				BgL_zc3anonymousza32012ze3z83_1709:
																																					if (NULLP(BgL_l1193z00_1707))
																																						{	/* Eval/evaluate.scm 377 */
																																							BgL_varsz00_1682
																																								=
																																								CDR
																																								(BgL_head1195z00_1705);
																																						}
																																					else
																																						{	/* Eval/evaluate.scm 377 */
																																							obj_t
																																								BgL_newtail1197z00_1711;
																																							{	/* Eval/evaluate.scm 377 */
																																								BgL_ev_varz00_bglt
																																									BgL_arg2015z00_1713;
																																								{	/* Eval/evaluate.scm 377 */
																																									obj_t
																																										BgL_bz00_1714;
																																									BgL_bz00_1714
																																										=
																																										CAR
																																										(BgL_l1193z00_1707);
																																									{	/* Eval/evaluate.scm 378 */
																																										obj_t
																																											BgL_iz00_1715;
																																										BgL_iz00_1715
																																											=
																																											BGl_untypezd2identzd2zz__evaluatez00
																																											(CAR
																																											(BgL_bz00_1714));
																																										{	/* Eval/evaluate.scm 379 */
																																											BgL_ev_varz00_bglt
																																												BgL_new1122z00_1716;
																																											{	/* Eval/evaluate.scm 379 */
																																												BgL_ev_varz00_bglt
																																													BgL_new1121z00_1717;
																																												BgL_new1121z00_1717
																																													=
																																													(
																																													(BgL_ev_varz00_bglt)
																																													BREF
																																													(GC_MALLOC
																																														(sizeof
																																															(struct
																																																BgL_ev_varz00_bgl))));
																																												{	/* Eval/evaluate.scm 379 */
																																													long
																																														BgL_arg2016z00_1718;
																																													{	/* Eval/evaluate.scm 379 */
																																														long
																																															BgL_res2410z00_2631;
																																														BgL_res2410z00_2631
																																															=
																																															BGL_CLASS_INDEX
																																															(BGl_ev_varz00zz__evaluate_typesz00);
																																														BgL_arg2016z00_1718
																																															=
																																															BgL_res2410z00_2631;
																																													}
																																													{	/* Eval/evaluate.scm 379 */
																																														BgL_objectz00_bglt
																																															BgL_objz00_2632;
																																														BgL_objz00_2632
																																															=
																																															(
																																															(BgL_objectz00_bglt)
																																															BgL_new1121z00_1717);
																																														BGL_OBJECT_CLASS_NUM_SET
																																															(BgL_objz00_2632,
																																															BgL_arg2016z00_1718);
																																												}}
																																												{	/* Eval/evaluate.scm 379 */
																																													BgL_objectz00_bglt
																																														BgL_auxz00_4899;
																																													BgL_auxz00_4899
																																														=
																																														(
																																														(BgL_objectz00_bglt)
																																														BgL_new1121z00_1717);
																																													BGL_OBJECT_WIDENING_SET
																																														(BgL_auxz00_4899,
																																														BFALSE);
																																												}
																																												BgL_new1122z00_1716
																																													=
																																													BgL_new1121z00_1717;
																																											}
																																											((((BgL_ev_varz00_bglt) CREF(BgL_new1122z00_1716))->BgL_namez00) = ((obj_t) CAR(BgL_iz00_1715)), BUNSPEC);
																																											((((BgL_ev_varz00_bglt) CREF(BgL_new1122z00_1716))->BgL_effz00) = ((obj_t) BFALSE), BUNSPEC);
																																											((((BgL_ev_varz00_bglt) CREF(BgL_new1122z00_1716))->BgL_typez00) = ((obj_t) CDR(BgL_iz00_1715)), BUNSPEC);
																																											BgL_arg2015z00_1713
																																												=
																																												BgL_new1122z00_1716;
																																								}}}
																																								{	/* Eval/evaluate.scm 377 */
																																									obj_t
																																										BgL_res2411z00_2638;
																																									{	/* Eval/evaluate.scm 377 */
																																										obj_t
																																											BgL_obj1z00_2636;
																																										BgL_obj1z00_2636
																																											=
																																											(
																																											(obj_t)
																																											BgL_arg2015z00_1713);
																																										BgL_res2411z00_2638
																																											=
																																											MAKE_PAIR
																																											(BgL_obj1z00_2636,
																																											BNIL);
																																									}
																																									BgL_newtail1197z00_1711
																																										=
																																										BgL_res2411z00_2638;
																																							}}
																																							SET_CDR
																																								(BgL_tail1196z00_1708,
																																								BgL_newtail1197z00_1711);
																																							{
																																								obj_t
																																									BgL_tail1196z00_4912;
																																								obj_t
																																									BgL_l1193z00_4910;
																																								BgL_l1193z00_4910
																																									=
																																									CDR
																																									(BgL_l1193z00_1707);
																																								BgL_tail1196z00_4912
																																									=
																																									BgL_newtail1197z00_1711;
																																								BgL_tail1196z00_1708
																																									=
																																									BgL_tail1196z00_4912;
																																								BgL_l1193z00_1707
																																									=
																																									BgL_l1193z00_4910;
																																								goto
																																									BgL_zc3anonymousza32012ze3z83_1709;
																																							}
																																						}
																																				}
																																			}
																																		{	/* Eval/evaluate.scm 383 */
																																			obj_t
																																				BgL_blocz00_1683;
																																			{	/* Eval/evaluate.scm 129 */
																																				obj_t
																																					BgL__ortest_1067z00_2644;
																																				BgL__ortest_1067z00_2644
																																					=
																																					BGl_getzd2sourcezd2locationz00zz__readerz00
																																					(BgL_bindsz00_895);
																																				if (CBOOL(BgL__ortest_1067z00_2644))
																																					{	/* Eval/evaluate.scm 129 */
																																						BgL_blocz00_1683
																																							=
																																							BgL__ortest_1067z00_2644;
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 129 */
																																						BgL_blocz00_1683
																																							=
																																							BgL_locz00_54;
																																					}
																																			}
																																			{	/* Eval/evaluate.scm 384 */
																																				BgL_ev_letz00_bglt
																																					BgL_new1125z00_1684;
																																				{	/* Eval/evaluate.scm 384 */
																																					BgL_ev_letz00_bglt
																																						BgL_new1123z00_1701;
																																					BgL_new1123z00_1701
																																						=
																																						(
																																						(BgL_ev_letz00_bglt)
																																						BREF
																																						(GC_MALLOC
																																							(sizeof
																																								(struct
																																									BgL_ev_letz00_bgl))));
																																					{	/* Eval/evaluate.scm 384 */
																																						long
																																							BgL_arg2010z00_1702;
																																						{	/* Eval/evaluate.scm 384 */
																																							long
																																								BgL_res2412z00_2646;
																																							BgL_res2412z00_2646
																																								=
																																								BGL_CLASS_INDEX
																																								(BGl_ev_letz00zz__evaluate_typesz00);
																																							BgL_arg2010z00_1702
																																								=
																																								BgL_res2412z00_2646;
																																						}
																																						{	/* Eval/evaluate.scm 384 */
																																							BgL_objectz00_bglt
																																								BgL_objz00_2647;
																																							BgL_objz00_2647
																																								=
																																								(
																																								(BgL_objectz00_bglt)
																																								BgL_new1123z00_1701);
																																							BGL_OBJECT_CLASS_NUM_SET
																																								(BgL_objz00_2647,
																																								BgL_arg2010z00_1702);
																																					}}
																																					{	/* Eval/evaluate.scm 384 */
																																						BgL_objectz00_bglt
																																							BgL_auxz00_4920;
																																						BgL_auxz00_4920
																																							=
																																							(
																																							(BgL_objectz00_bglt)
																																							BgL_new1123z00_1701);
																																						BGL_OBJECT_WIDENING_SET
																																							(BgL_auxz00_4920,
																																							BFALSE);
																																					}
																																					BgL_new1125z00_1684
																																						=
																																						BgL_new1123z00_1701;
																																				}
																																				((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt) BgL_new1125z00_1684)))->BgL_varsz00) = ((obj_t) BgL_varsz00_1682), BUNSPEC);
																																				{
																																					obj_t
																																						BgL_auxz00_4925;
																																					if (NULLP(BgL_bindsz00_895))
																																						{	/* Eval/evaluate.scm 386 */
																																							BgL_auxz00_4925
																																								=
																																								BNIL;
																																						}
																																					else
																																						{	/* Eval/evaluate.scm 386 */
																																							obj_t
																																								BgL_head1200z00_1687;
																																							{	/* Eval/evaluate.scm 386 */
																																								obj_t
																																									BgL_res2414z00_2653;
																																								BgL_res2414z00_2653
																																									=
																																									MAKE_PAIR
																																									(BNIL,
																																									BNIL);
																																								BgL_head1200z00_1687
																																									=
																																									BgL_res2414z00_2653;
																																							}
																																							{
																																								obj_t
																																									BgL_l1198z00_1689;
																																								obj_t
																																									BgL_tail1201z00_1690;
																																								BgL_l1198z00_1689
																																									=
																																									BgL_bindsz00_895;
																																								BgL_tail1201z00_1690
																																									=
																																									BgL_head1200z00_1687;
																																							BgL_zc3anonymousza32003ze3z83_1691:
																																								if (NULLP(BgL_l1198z00_1689))
																																									{	/* Eval/evaluate.scm 386 */
																																										BgL_auxz00_4925
																																											=
																																											CDR
																																											(BgL_head1200z00_1687);
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 386 */
																																										obj_t
																																											BgL_newtail1202z00_1693;
																																										{	/* Eval/evaluate.scm 386 */
																																											obj_t
																																												BgL_arg2007z00_1695;
																																											{	/* Eval/evaluate.scm 386 */
																																												obj_t
																																													BgL_bz00_1696;
																																												{	/* Eval/evaluate.scm 386 */
																																													obj_t
																																														BgL_pairz00_2657;
																																													BgL_pairz00_2657
																																														=
																																														BgL_l1198z00_1689;
																																													BgL_bz00_1696
																																														=
																																														CAR
																																														(BgL_pairz00_2657);
																																												}
																																												{	/* Eval/evaluate.scm 387 */
																																													obj_t
																																														BgL_locz00_1697;
																																													{	/* Eval/evaluate.scm 129 */
																																														obj_t
																																															BgL__ortest_1067z00_2660;
																																														BgL__ortest_1067z00_2660
																																															=
																																															BGl_getzd2sourcezd2locationz00zz__readerz00
																																															(BgL_bz00_1696);
																																														if (CBOOL(BgL__ortest_1067z00_2660))
																																															{	/* Eval/evaluate.scm 129 */
																																																BgL_locz00_1697
																																																	=
																																																	BgL__ortest_1067z00_2660;
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 129 */
																																																BgL_locz00_1697
																																																	=
																																																	BgL_blocz00_1683;
																																															}
																																													}
																																													{	/* Eval/evaluate.scm 388 */
																																														obj_t
																																															BgL_arg2008z00_1698;
																																														{	/* Eval/evaluate.scm 388 */
																																															obj_t
																																																BgL_pairz00_2661;
																																															BgL_pairz00_2661
																																																=
																																																BgL_bz00_1696;
																																															{	/* Ieee/pairlist.scm 270 */
																																																obj_t
																																																	BgL_pairz00_2664;
																																																BgL_pairz00_2664
																																																	=
																																																	CDR
																																																	(BgL_pairz00_2661);
																																																BgL_arg2008z00_1698
																																																	=
																																																	CAR
																																																	(BgL_pairz00_2664);
																																															}
																																														}
																																														BgL_arg2007z00_1695
																																															=
																																															BGl_convz00zz__evaluatez00
																																															(BgL_arg2008z00_1698,
																																															BgL_localsz00_50,
																																															BgL_globalsz00_51,
																																															BFALSE,
																																															BgL_wherez00_53,
																																															BgL_locz00_1697,
																																															((bool_t) 0));
																																													}
																																												}
																																											}
																																											{	/* Eval/evaluate.scm 386 */
																																												obj_t
																																													BgL_res2416z00_2669;
																																												BgL_res2416z00_2669
																																													=
																																													MAKE_PAIR
																																													(BgL_arg2007z00_1695,
																																													BNIL);
																																												BgL_newtail1202z00_1693
																																													=
																																													BgL_res2416z00_2669;
																																											}
																																										}
																																										SET_CDR
																																											(BgL_tail1201z00_1690,
																																											BgL_newtail1202z00_1693);
																																										{	/* Eval/evaluate.scm 386 */
																																											obj_t
																																												BgL_arg2005z00_1694;
																																											{	/* Eval/evaluate.scm 386 */
																																												obj_t
																																													BgL_pairz00_2672;
																																												BgL_pairz00_2672
																																													=
																																													BgL_l1198z00_1689;
																																												BgL_arg2005z00_1694
																																													=
																																													CDR
																																													(BgL_pairz00_2672);
																																											}
																																											{
																																												obj_t
																																													BgL_tail1201z00_4944;
																																												obj_t
																																													BgL_l1198z00_4943;
																																												BgL_l1198z00_4943
																																													=
																																													BgL_arg2005z00_1694;
																																												BgL_tail1201z00_4944
																																													=
																																													BgL_newtail1202z00_1693;
																																												BgL_tail1201z00_1690
																																													=
																																													BgL_tail1201z00_4944;
																																												BgL_l1198z00_1689
																																													=
																																													BgL_l1198z00_4943;
																																												goto
																																													BgL_zc3anonymousza32003ze3z83_1691;
																																											}
																																										}
																																									}
																																							}
																																						}
																																					((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt) BgL_new1125z00_1684)))->BgL_valsz00) = ((obj_t) BgL_auxz00_4925), BUNSPEC);
																																				}
																																				{
																																					BgL_ev_exprz00_bglt
																																						BgL_auxz00_4946;
																																					{	/* Eval/evaluate.scm 390 */
																																						obj_t
																																							BgL_arg2009z00_1700;
																																						BgL_arg2009z00_1700
																																							=
																																							BGl_appendzd221011zd2zz__evaluatez00
																																							(BgL_varsz00_1682,
																																							BgL_localsz00_50);
																																						BgL_auxz00_4946
																																							=
																																							(
																																							(BgL_ev_exprz00_bglt)
																																							BGl_convzd2beginzd2zz__evaluatez00
																																							(BgL_bodyz00_896,
																																								BgL_arg2009z00_1700,
																																								BgL_globalsz00_51,
																																								BgL_tailzf3zf3_52,
																																								BgL_wherez00_53,
																																								BgL_locz00_54,
																																								((bool_t) 0)));
																																					}
																																					((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt) BgL_new1125z00_1684)))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4946), BUNSPEC);
																																				}
																																				((((BgL_ev_letz00_bglt) CREF(BgL_new1125z00_1684))->BgL_boxesz00) = ((obj_t) BNIL), BUNSPEC);
																																				BgL_auxz00_4885
																																					=
																																					BgL_new1125z00_1684;
																																			}
																																		}
																																	}
																																	return
																																		((obj_t)
																																		BgL_auxz00_4885);
																																}
																															}
																														else
																															{	/* Eval/evaluate.scm 319 */
																																obj_t
																																	BgL_arg1505z00_1068;
																																BgL_arg1505z00_1068
																																	=
																																	CAR
																																	(BgL_ez00_49);
																																{
																																	BgL_ev_appz00_bglt
																																		BgL_auxz00_4955;
																																	{
																																		obj_t
																																			BgL_argsz00_4957;
																																		obj_t
																																			BgL_fz00_4956;
																																		BgL_fz00_4956
																																			=
																																			BgL_arg1505z00_1068;
																																		BgL_argsz00_4957
																																			=
																																			BgL_cdrzd26283zd2_1063;
																																		BgL_argsz00_942
																																			=
																																			BgL_argsz00_4957;
																																		BgL_fz00_941
																																			=
																																			BgL_fz00_4956;
																																		goto
																																			BgL_tagzd2157zd2_943;
																																	}
																																	return
																																		((obj_t)
																																		BgL_auxz00_4955);
																																}
																															}
																													}
																												else
																													{	/* Eval/evaluate.scm 319 */
																														if (
																															(CAR(BgL_ez00_49)
																																==
																																BGl_symbol2673z00zz__evaluatez00))
																															{	/* Eval/evaluate.scm 319 */
																																if (PAIRP
																																	(BgL_cdrzd26283zd2_1063))
																																	{	/* Eval/evaluate.scm 319 */
																																		obj_t
																																			BgL_arg1509z00_1073;
																																		obj_t
																																			BgL_arg1510z00_1074;
																																		BgL_arg1509z00_1073
																																			=
																																			CAR
																																			(BgL_cdrzd26283zd2_1063);
																																		BgL_arg1510z00_1074
																																			=
																																			CDR
																																			(BgL_cdrzd26283zd2_1063);
																																		{
																																			BgL_ev_letza2za2_bglt
																																				BgL_auxz00_4966;
																																			BgL_bindsz00_898
																																				=
																																				BgL_arg1509z00_1073;
																																			BgL_bodyz00_899
																																				=
																																				BgL_arg1510z00_1074;
																																		BgL_tagzd2143zd2_900:
																																			{	/* Eval/evaluate.scm 398 */
																																				obj_t
																																					BgL_varsz00_1722;
																																				obj_t
																																					BgL_blocz00_1723;
																																				if (NULLP(BgL_bindsz00_898))
																																					{	/* Eval/evaluate.scm 398 */
																																						BgL_varsz00_1722
																																							=
																																							BNIL;
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 398 */
																																						obj_t
																																							BgL_head1205z00_1731;
																																						{	/* Eval/evaluate.scm 398 */
																																							obj_t
																																								BgL_res2420z00_2731;
																																							BgL_res2420z00_2731
																																								=
																																								MAKE_PAIR
																																								(BNIL,
																																								BNIL);
																																							BgL_head1205z00_1731
																																								=
																																								BgL_res2420z00_2731;
																																						}
																																						{
																																							obj_t
																																								BgL_l1203z00_1733;
																																							obj_t
																																								BgL_tail1206z00_1734;
																																							BgL_l1203z00_1733
																																								=
																																								BgL_bindsz00_898;
																																							BgL_tail1206z00_1734
																																								=
																																								BgL_head1205z00_1731;
																																						BgL_zc3anonymousza32022ze3z83_1735:
																																							if (NULLP(BgL_l1203z00_1733))
																																								{	/* Eval/evaluate.scm 398 */
																																									BgL_varsz00_1722
																																										=
																																										CDR
																																										(BgL_head1205z00_1731);
																																								}
																																							else
																																								{	/* Eval/evaluate.scm 398 */
																																									obj_t
																																										BgL_newtail1207z00_1737;
																																									{	/* Eval/evaluate.scm 398 */
																																										BgL_ev_varz00_bglt
																																											BgL_arg2025z00_1739;
																																										{	/* Eval/evaluate.scm 398 */
																																											obj_t
																																												BgL_bz00_1740;
																																											BgL_bz00_1740
																																												=
																																												CAR
																																												(BgL_l1203z00_1733);
																																											{	/* Eval/evaluate.scm 399 */
																																												obj_t
																																													BgL_iz00_1741;
																																												BgL_iz00_1741
																																													=
																																													BGl_untypezd2identzd2zz__evaluatez00
																																													(CAR
																																													(BgL_bz00_1740));
																																												{	/* Eval/evaluate.scm 400 */
																																													BgL_ev_varz00_bglt
																																														BgL_new1127z00_1742;
																																													{	/* Eval/evaluate.scm 400 */
																																														BgL_ev_varz00_bglt
																																															BgL_new1126z00_1743;
																																														BgL_new1126z00_1743
																																															=
																																															(
																																															(BgL_ev_varz00_bglt)
																																															BREF
																																															(GC_MALLOC
																																																(sizeof
																																																	(struct
																																																		BgL_ev_varz00_bgl))));
																																														{	/* Eval/evaluate.scm 400 */
																																															long
																																																BgL_arg2026z00_1744;
																																															{	/* Eval/evaluate.scm 400 */
																																																long
																																																	BgL_res2422z00_2738;
																																																BgL_res2422z00_2738
																																																	=
																																																	BGL_CLASS_INDEX
																																																	(BGl_ev_varz00zz__evaluate_typesz00);
																																																BgL_arg2026z00_1744
																																																	=
																																																	BgL_res2422z00_2738;
																																															}
																																															{	/* Eval/evaluate.scm 400 */
																																																BgL_objectz00_bglt
																																																	BgL_objz00_2739;
																																																BgL_objz00_2739
																																																	=
																																																	(
																																																	(BgL_objectz00_bglt)
																																																	BgL_new1126z00_1743);
																																																BGL_OBJECT_CLASS_NUM_SET
																																																	(BgL_objz00_2739,
																																																	BgL_arg2026z00_1744);
																																														}}
																																														{	/* Eval/evaluate.scm 400 */
																																															BgL_objectz00_bglt
																																																BgL_auxz00_4980;
																																															BgL_auxz00_4980
																																																=
																																																(
																																																(BgL_objectz00_bglt)
																																																BgL_new1126z00_1743);
																																															BGL_OBJECT_WIDENING_SET
																																																(BgL_auxz00_4980,
																																																BFALSE);
																																														}
																																														BgL_new1127z00_1742
																																															=
																																															BgL_new1126z00_1743;
																																													}
																																													((((BgL_ev_varz00_bglt) CREF(BgL_new1127z00_1742))->BgL_namez00) = ((obj_t) CAR(BgL_iz00_1741)), BUNSPEC);
																																													((((BgL_ev_varz00_bglt) CREF(BgL_new1127z00_1742))->BgL_effz00) = ((obj_t) BFALSE), BUNSPEC);
																																													((((BgL_ev_varz00_bglt) CREF(BgL_new1127z00_1742))->BgL_typez00) = ((obj_t) CDR(BgL_iz00_1741)), BUNSPEC);
																																													BgL_arg2025z00_1739
																																														=
																																														BgL_new1127z00_1742;
																																										}}}
																																										{	/* Eval/evaluate.scm 398 */
																																											obj_t
																																												BgL_res2423z00_2745;
																																											{	/* Eval/evaluate.scm 398 */
																																												obj_t
																																													BgL_obj1z00_2743;
																																												BgL_obj1z00_2743
																																													=
																																													(
																																													(obj_t)
																																													BgL_arg2025z00_1739);
																																												BgL_res2423z00_2745
																																													=
																																													MAKE_PAIR
																																													(BgL_obj1z00_2743,
																																													BNIL);
																																											}
																																											BgL_newtail1207z00_1737
																																												=
																																												BgL_res2423z00_2745;
																																									}}
																																									SET_CDR
																																										(BgL_tail1206z00_1734,
																																										BgL_newtail1207z00_1737);
																																									{
																																										obj_t
																																											BgL_tail1206z00_4993;
																																										obj_t
																																											BgL_l1203z00_4991;
																																										BgL_l1203z00_4991
																																											=
																																											CDR
																																											(BgL_l1203z00_1733);
																																										BgL_tail1206z00_4993
																																											=
																																											BgL_newtail1207z00_1737;
																																										BgL_tail1206z00_1734
																																											=
																																											BgL_tail1206z00_4993;
																																										BgL_l1203z00_1733
																																											=
																																											BgL_l1203z00_4991;
																																										goto
																																											BgL_zc3anonymousza32022ze3z83_1735;
																																									}
																																								}
																																						}
																																					}
																																				{	/* Eval/evaluate.scm 129 */
																																					obj_t
																																						BgL__ortest_1067z00_2751;
																																					BgL__ortest_1067z00_2751
																																						=
																																						BGl_getzd2sourcezd2locationz00zz__readerz00
																																						(BgL_bindsz00_898);
																																					if (CBOOL(BgL__ortest_1067z00_2751))
																																						{	/* Eval/evaluate.scm 129 */
																																							BgL_blocz00_1723
																																								=
																																								BgL__ortest_1067z00_2751;
																																						}
																																					else
																																						{	/* Eval/evaluate.scm 129 */
																																							BgL_blocz00_1723
																																								=
																																								BgL_locz00_54;
																																						}
																																				}
																																				{	/* Eval/evaluate.scm 405 */
																																					BgL_ev_letza2za2_bglt
																																						BgL_new1130z00_1724;
																																					{	/* Eval/evaluate.scm 405 */
																																						BgL_ev_letza2za2_bglt
																																							BgL_new1129z00_1727;
																																						BgL_new1129z00_1727
																																							=
																																							(
																																							(BgL_ev_letza2za2_bglt)
																																							BREF
																																							(GC_MALLOC
																																								(sizeof
																																									(struct
																																										BgL_ev_letza2za2_bgl))));
																																						{	/* Eval/evaluate.scm 405 */
																																							long
																																								BgL_arg2020z00_1728;
																																							{	/* Eval/evaluate.scm 405 */
																																								long
																																									BgL_res2424z00_2753;
																																								BgL_res2424z00_2753
																																									=
																																									BGL_CLASS_INDEX
																																									(BGl_ev_letza2za2zz__evaluate_typesz00);
																																								BgL_arg2020z00_1728
																																									=
																																									BgL_res2424z00_2753;
																																							}
																																							{	/* Eval/evaluate.scm 405 */
																																								BgL_objectz00_bglt
																																									BgL_objz00_2754;
																																								BgL_objz00_2754
																																									=
																																									(
																																									(BgL_objectz00_bglt)
																																									BgL_new1129z00_1727);
																																								BGL_OBJECT_CLASS_NUM_SET
																																									(BgL_objz00_2754,
																																									BgL_arg2020z00_1728);
																																						}}
																																						{	/* Eval/evaluate.scm 405 */
																																							BgL_objectz00_bglt
																																								BgL_auxz00_5001;
																																							BgL_auxz00_5001
																																								=
																																								(
																																								(BgL_objectz00_bglt)
																																								BgL_new1129z00_1727);
																																							BGL_OBJECT_WIDENING_SET
																																								(BgL_auxz00_5001,
																																								BFALSE);
																																						}
																																						BgL_new1130z00_1724
																																							=
																																							BgL_new1129z00_1727;
																																					}
																																					((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt) BgL_new1130z00_1724)))->BgL_varsz00) = ((obj_t) BgL_varsz00_1722), BUNSPEC);
																																					((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt) BgL_new1130z00_1724)))->BgL_valsz00) = ((obj_t) BGl_convzd2valszd2zz__evaluatez00(BgL_wherez00_53, BgL_globalsz00_51, BgL_bindsz00_898, BgL_varsz00_1722, BgL_localsz00_50, BgL_blocz00_1723)), BUNSPEC);
																																					{
																																						BgL_ev_exprz00_bglt
																																							BgL_auxz00_5009;
																																						{	/* Eval/evaluate.scm 408 */
																																							obj_t
																																								BgL_arg2018z00_1725;
																																							{	/* Eval/evaluate.scm 408 */
																																								obj_t
																																									BgL_arg2019z00_1726;
																																								BgL_arg2019z00_1726
																																									=
																																									bgl_reverse
																																									(BgL_varsz00_1722);
																																								BgL_arg2018z00_1725
																																									=
																																									BGl_appendzd221011zd2zz__evaluatez00
																																									(BgL_arg2019z00_1726,
																																									BgL_localsz00_50);
																																							}
																																							BgL_auxz00_5009
																																								=
																																								(
																																								(BgL_ev_exprz00_bglt)
																																								BGl_convzd2beginzd2zz__evaluatez00
																																								(BgL_bodyz00_899,
																																									BgL_arg2018z00_1725,
																																									BgL_globalsz00_51,
																																									BgL_tailzf3zf3_52,
																																									BgL_wherez00_53,
																																									BgL_locz00_54,
																																									((bool_t) 0)));
																																						}
																																						((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt) BgL_new1130z00_1724)))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5009), BUNSPEC);
																																					}
																																					((((BgL_ev_letza2za2_bglt) CREF(BgL_new1130z00_1724))->BgL_boxesz00) = ((obj_t) BNIL), BUNSPEC);
																																					BgL_auxz00_4966
																																						=
																																						BgL_new1130z00_1724;
																																			}}
																																			return
																																				((obj_t)
																																				BgL_auxz00_4966);
																																		}
																																	}
																																else
																																	{	/* Eval/evaluate.scm 319 */
																																		obj_t
																																			BgL_arg1511z00_1075;
																																		obj_t
																																			BgL_arg1513z00_1076;
																																		BgL_arg1511z00_1075
																																			=
																																			CAR
																																			(BgL_ez00_49);
																																		BgL_arg1513z00_1076
																																			=
																																			CDR
																																			(BgL_ez00_49);
																																		{
																																			BgL_ev_appz00_bglt
																																				BgL_auxz00_5020;
																																			{
																																				obj_t
																																					BgL_argsz00_5022;
																																				obj_t
																																					BgL_fz00_5021;
																																				BgL_fz00_5021
																																					=
																																					BgL_arg1511z00_1075;
																																				BgL_argsz00_5022
																																					=
																																					BgL_arg1513z00_1076;
																																				BgL_argsz00_942
																																					=
																																					BgL_argsz00_5022;
																																				BgL_fz00_941
																																					=
																																					BgL_fz00_5021;
																																				goto
																																					BgL_tagzd2157zd2_943;
																																			}
																																			return
																																				((obj_t)
																																				BgL_auxz00_5020);
																																		}
																																	}
																															}
																														else
																															{	/* Eval/evaluate.scm 319 */
																																obj_t
																																	BgL_cdrzd26677zd2_1077;
																																BgL_cdrzd26677zd2_1077
																																	=
																																	CDR
																																	(BgL_ez00_49);
																																if ((CAR
																																		(BgL_ez00_49)
																																		==
																																		BGl_symbol2675z00zz__evaluatez00))
																																	{	/* Eval/evaluate.scm 319 */
																																		if (PAIRP
																																			(BgL_cdrzd26677zd2_1077))
																																			{	/* Eval/evaluate.scm 319 */
																																				obj_t
																																					BgL_arg1516z00_1080;
																																				obj_t
																																					BgL_arg1517z00_1081;
																																				BgL_arg1516z00_1080
																																					=
																																					CAR
																																					(BgL_cdrzd26677zd2_1077);
																																				BgL_arg1517z00_1081
																																					=
																																					CDR
																																					(BgL_cdrzd26677zd2_1077);
																																				{
																																					BgL_ev_letrecz00_bglt
																																						BgL_auxz00_5032;
																																					BgL_bindsz00_901
																																						=
																																						BgL_arg1516z00_1080;
																																					BgL_bodyz00_902
																																						=
																																						BgL_arg1517z00_1081;
																																				BgL_tagzd2144zd2_903:
																																					{	/* Eval/evaluate.scm 410 */
																																						obj_t
																																							BgL_varsz00_1763;
																																						if (NULLP(BgL_bindsz00_901))
																																							{	/* Eval/evaluate.scm 410 */
																																								BgL_varsz00_1763
																																									=
																																									BNIL;
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 410 */
																																								obj_t
																																									BgL_head1210z00_1791;
																																								{	/* Eval/evaluate.scm 410 */
																																									obj_t
																																										BgL_res2427z00_2800;
																																									BgL_res2427z00_2800
																																										=
																																										MAKE_PAIR
																																										(BNIL,
																																										BNIL);
																																									BgL_head1210z00_1791
																																										=
																																										BgL_res2427z00_2800;
																																								}
																																								{
																																									obj_t
																																										BgL_l1208z00_1793;
																																									obj_t
																																										BgL_tail1211z00_1794;
																																									BgL_l1208z00_1793
																																										=
																																										BgL_bindsz00_901;
																																									BgL_tail1211z00_1794
																																										=
																																										BgL_head1210z00_1791;
																																								BgL_zc3anonymousza32055ze3z83_1795:
																																									if (NULLP(BgL_l1208z00_1793))
																																										{	/* Eval/evaluate.scm 410 */
																																											BgL_varsz00_1763
																																												=
																																												CDR
																																												(BgL_head1210z00_1791);
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 410 */
																																											obj_t
																																												BgL_newtail1212z00_1797;
																																											{	/* Eval/evaluate.scm 410 */
																																												BgL_ev_varz00_bglt
																																													BgL_arg2058z00_1799;
																																												{	/* Eval/evaluate.scm 410 */
																																													obj_t
																																														BgL_bz00_1800;
																																													BgL_bz00_1800
																																														=
																																														CAR
																																														(BgL_l1208z00_1793);
																																													{	/* Eval/evaluate.scm 411 */
																																														obj_t
																																															BgL_iz00_1801;
																																														BgL_iz00_1801
																																															=
																																															BGl_untypezd2identzd2zz__evaluatez00
																																															(CAR
																																															(BgL_bz00_1800));
																																														{	/* Eval/evaluate.scm 412 */
																																															BgL_ev_varz00_bglt
																																																BgL_new1132z00_1802;
																																															{	/* Eval/evaluate.scm 412 */
																																																BgL_ev_varz00_bglt
																																																	BgL_new1131z00_1803;
																																																BgL_new1131z00_1803
																																																	=
																																																	(
																																																	(BgL_ev_varz00_bglt)
																																																	BREF
																																																	(GC_MALLOC
																																																		(sizeof
																																																			(struct
																																																				BgL_ev_varz00_bgl))));
																																																{	/* Eval/evaluate.scm 412 */
																																																	long
																																																		BgL_arg2059z00_1804;
																																																	{	/* Eval/evaluate.scm 412 */
																																																		long
																																																			BgL_res2429z00_2807;
																																																		BgL_res2429z00_2807
																																																			=
																																																			BGL_CLASS_INDEX
																																																			(BGl_ev_varz00zz__evaluate_typesz00);
																																																		BgL_arg2059z00_1804
																																																			=
																																																			BgL_res2429z00_2807;
																																																	}
																																																	{	/* Eval/evaluate.scm 412 */
																																																		BgL_objectz00_bglt
																																																			BgL_objz00_2808;
																																																		BgL_objz00_2808
																																																			=
																																																			(
																																																			(BgL_objectz00_bglt)
																																																			BgL_new1131z00_1803);
																																																		BGL_OBJECT_CLASS_NUM_SET
																																																			(BgL_objz00_2808,
																																																			BgL_arg2059z00_1804);
																																																}}
																																																{	/* Eval/evaluate.scm 412 */
																																																	BgL_objectz00_bglt
																																																		BgL_auxz00_5046;
																																																	BgL_auxz00_5046
																																																		=
																																																		(
																																																		(BgL_objectz00_bglt)
																																																		BgL_new1131z00_1803);
																																																	BGL_OBJECT_WIDENING_SET
																																																		(BgL_auxz00_5046,
																																																		BFALSE);
																																																}
																																																BgL_new1132z00_1802
																																																	=
																																																	BgL_new1131z00_1803;
																																															}
																																															((((BgL_ev_varz00_bglt) CREF(BgL_new1132z00_1802))->BgL_namez00) = ((obj_t) CAR(BgL_iz00_1801)), BUNSPEC);
																																															((((BgL_ev_varz00_bglt) CREF(BgL_new1132z00_1802))->BgL_effz00) = ((obj_t) BFALSE), BUNSPEC);
																																															((((BgL_ev_varz00_bglt) CREF(BgL_new1132z00_1802))->BgL_typez00) = ((obj_t) CDR(BgL_iz00_1801)), BUNSPEC);
																																															BgL_arg2058z00_1799
																																																=
																																																BgL_new1132z00_1802;
																																												}}}
																																												{	/* Eval/evaluate.scm 410 */
																																													obj_t
																																														BgL_res2430z00_2814;
																																													{	/* Eval/evaluate.scm 410 */
																																														obj_t
																																															BgL_obj1z00_2812;
																																														BgL_obj1z00_2812
																																															=
																																															(
																																															(obj_t)
																																															BgL_arg2058z00_1799);
																																														BgL_res2430z00_2814
																																															=
																																															MAKE_PAIR
																																															(BgL_obj1z00_2812,
																																															BNIL);
																																													}
																																													BgL_newtail1212z00_1797
																																														=
																																														BgL_res2430z00_2814;
																																											}}
																																											SET_CDR
																																												(BgL_tail1211z00_1794,
																																												BgL_newtail1212z00_1797);
																																											{
																																												obj_t
																																													BgL_tail1211z00_5059;
																																												obj_t
																																													BgL_l1208z00_5057;
																																												BgL_l1208z00_5057
																																													=
																																													CDR
																																													(BgL_l1208z00_1793);
																																												BgL_tail1211z00_5059
																																													=
																																													BgL_newtail1212z00_1797;
																																												BgL_tail1211z00_1794
																																													=
																																													BgL_tail1211z00_5059;
																																												BgL_l1208z00_1793
																																													=
																																													BgL_l1208z00_5057;
																																												goto
																																													BgL_zc3anonymousza32055ze3z83_1795;
																																											}
																																										}
																																								}
																																							}
																																						{	/* Eval/evaluate.scm 410 */
																																							obj_t
																																								BgL_localsz00_1764;
																																							BgL_localsz00_1764
																																								=
																																								BGl_appendzd221011zd2zz__evaluatez00
																																								(BgL_varsz00_1763,
																																								BgL_localsz00_50);
																																							{	/* Eval/evaluate.scm 416 */
																																								obj_t
																																									BgL_blocz00_1765;
																																								{	/* Eval/evaluate.scm 129 */
																																									obj_t
																																										BgL__ortest_1067z00_2820;
																																									BgL__ortest_1067z00_2820
																																										=
																																										BGl_getzd2sourcezd2locationz00zz__readerz00
																																										(BgL_bindsz00_901);
																																									if (CBOOL(BgL__ortest_1067z00_2820))
																																										{	/* Eval/evaluate.scm 129 */
																																											BgL_blocz00_1765
																																												=
																																												BgL__ortest_1067z00_2820;
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 129 */
																																											BgL_blocz00_1765
																																												=
																																												BgL_locz00_54;
																																										}
																																								}
																																								{	/* Eval/evaluate.scm 417 */

																																									{	/* Eval/evaluate.scm 418 */
																																										BgL_ev_letrecz00_bglt
																																											BgL_new1134z00_1766;
																																										{	/* Eval/evaluate.scm 418 */
																																											BgL_ev_letrecz00_bglt
																																												BgL_new1133z00_1787;
																																											BgL_new1133z00_1787
																																												=
																																												(
																																												(BgL_ev_letrecz00_bglt)
																																												BREF
																																												(GC_MALLOC
																																													(sizeof
																																														(struct
																																															BgL_ev_letrecz00_bgl))));
																																											{	/* Eval/evaluate.scm 418 */
																																												long
																																													BgL_arg2053z00_1788;
																																												{	/* Eval/evaluate.scm 418 */
																																													long
																																														BgL_res2431z00_2822;
																																													BgL_res2431z00_2822
																																														=
																																														BGL_CLASS_INDEX
																																														(BGl_ev_letrecz00zz__evaluate_typesz00);
																																													BgL_arg2053z00_1788
																																														=
																																														BgL_res2431z00_2822;
																																												}
																																												{	/* Eval/evaluate.scm 418 */
																																													BgL_objectz00_bglt
																																														BgL_objz00_2823;
																																													BgL_objz00_2823
																																														=
																																														(
																																														(BgL_objectz00_bglt)
																																														BgL_new1133z00_1787);
																																													BGL_OBJECT_CLASS_NUM_SET
																																														(BgL_objz00_2823,
																																														BgL_arg2053z00_1788);
																																											}}
																																											{	/* Eval/evaluate.scm 418 */
																																												BgL_objectz00_bglt
																																													BgL_auxz00_5068;
																																												BgL_auxz00_5068
																																													=
																																													(
																																													(BgL_objectz00_bglt)
																																													BgL_new1133z00_1787);
																																												BGL_OBJECT_WIDENING_SET
																																													(BgL_auxz00_5068,
																																													BFALSE);
																																											}
																																											BgL_new1134z00_1766
																																												=
																																												BgL_new1133z00_1787;
																																										}
																																										((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt) BgL_new1134z00_1766)))->BgL_varsz00) = ((obj_t) BgL_varsz00_1763), BUNSPEC);
																																										{
																																											obj_t
																																												BgL_auxz00_5073;
																																											if (NULLP(BgL_bindsz00_901))
																																												{	/* Eval/evaluate.scm 420 */
																																													BgL_auxz00_5073
																																														=
																																														BNIL;
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 420 */
																																													obj_t
																																														BgL_head1215z00_1769;
																																													{	/* Eval/evaluate.scm 420 */
																																														obj_t
																																															BgL_res2433z00_2829;
																																														BgL_res2433z00_2829
																																															=
																																															MAKE_PAIR
																																															(BNIL,
																																															BNIL);
																																														BgL_head1215z00_1769
																																															=
																																															BgL_res2433z00_2829;
																																													}
																																													{
																																														obj_t
																																															BgL_l1213z00_1771;
																																														obj_t
																																															BgL_tail1216z00_1772;
																																														BgL_l1213z00_1771
																																															=
																																															BgL_bindsz00_901;
																																														BgL_tail1216z00_1772
																																															=
																																															BgL_head1215z00_1769;
																																													BgL_zc3anonymousza32042ze3z83_1773:
																																														if (NULLP(BgL_l1213z00_1771))
																																															{	/* Eval/evaluate.scm 420 */
																																																BgL_auxz00_5073
																																																	=
																																																	CDR
																																																	(BgL_head1215z00_1769);
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 420 */
																																																obj_t
																																																	BgL_newtail1217z00_1775;
																																																{	/* Eval/evaluate.scm 420 */
																																																	obj_t
																																																		BgL_arg2045z00_1777;
																																																	{	/* Eval/evaluate.scm 420 */
																																																		obj_t
																																																			BgL_bz00_1778;
																																																		{	/* Eval/evaluate.scm 420 */
																																																			obj_t
																																																				BgL_pairz00_2833;
																																																			BgL_pairz00_2833
																																																				=
																																																				BgL_l1213z00_1771;
																																																			BgL_bz00_1778
																																																				=
																																																				CAR
																																																				(BgL_pairz00_2833);
																																																		}
																																																		{	/* Eval/evaluate.scm 421 */
																																																			obj_t
																																																				BgL_arg2046z00_1779;
																																																			obj_t
																																																				BgL_arg2047z00_1780;
																																																			obj_t
																																																				BgL_arg2048z00_1781;
																																																			{	/* Eval/evaluate.scm 421 */
																																																				obj_t
																																																					BgL_pairz00_2834;
																																																				BgL_pairz00_2834
																																																					=
																																																					BgL_bz00_1778;
																																																				{	/* Ieee/pairlist.scm 270 */
																																																					obj_t
																																																						BgL_pairz00_2837;
																																																					BgL_pairz00_2837
																																																						=
																																																						CDR
																																																						(BgL_pairz00_2834);
																																																					BgL_arg2046z00_1779
																																																						=
																																																						CAR
																																																						(BgL_pairz00_2837);
																																																				}
																																																			}
																																																			{	/* Eval/evaluate.scm 421 */
																																																				obj_t
																																																					BgL_arg2049z00_1782;
																																																				{	/* Eval/evaluate.scm 421 */
																																																					obj_t
																																																						BgL_pairz00_2838;
																																																					BgL_pairz00_2838
																																																						=
																																																						BgL_bz00_1778;
																																																					BgL_arg2049z00_1782
																																																						=
																																																						CAR
																																																						(BgL_pairz00_2838);
																																																				}
																																																				{	/* Eval/evaluate.scm 421 */
																																																					obj_t
																																																						BgL_list2050z00_1783;
																																																					{	/* Eval/evaluate.scm 421 */
																																																						obj_t
																																																							BgL_arg2051z00_1784;
																																																						{	/* Eval/evaluate.scm 421 */
																																																							obj_t
																																																								BgL_arg2052z00_1785;
																																																							BgL_arg2052z00_1785
																																																								=
																																																								MAKE_PAIR
																																																								(BgL_wherez00_53,
																																																								BNIL);
																																																							BgL_arg2051z00_1784
																																																								=
																																																								MAKE_PAIR
																																																								(BGl_symbol2650z00zz__evaluatez00,
																																																								BgL_arg2052z00_1785);
																																																						}
																																																						BgL_list2050z00_1783
																																																							=
																																																							MAKE_PAIR
																																																							(BgL_arg2049z00_1782,
																																																							BgL_arg2051z00_1784);
																																																					}
																																																					BgL_arg2047z00_1780
																																																						=
																																																						BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
																																																						(BgL_list2050z00_1783);
																																																				}
																																																			}
																																																			{	/* Eval/evaluate.scm 129 */
																																																				obj_t
																																																					BgL__ortest_1067z00_2841;
																																																				BgL__ortest_1067z00_2841
																																																					=
																																																					BGl_getzd2sourcezd2locationz00zz__readerz00
																																																					(BgL_bz00_1778);
																																																				if (CBOOL(BgL__ortest_1067z00_2841))
																																																					{	/* Eval/evaluate.scm 129 */
																																																						BgL_arg2048z00_1781
																																																							=
																																																							BgL__ortest_1067z00_2841;
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 129 */
																																																						BgL_arg2048z00_1781
																																																							=
																																																							BgL_blocz00_1765;
																																																					}
																																																			}
																																																			BgL_arg2045z00_1777
																																																				=
																																																				BGl_convz00zz__evaluatez00
																																																				(BgL_arg2046z00_1779,
																																																				BgL_localsz00_1764,
																																																				BgL_globalsz00_51,
																																																				BFALSE,
																																																				BgL_arg2047z00_1780,
																																																				BgL_arg2048z00_1781,
																																																				((bool_t) 0));
																																																		}
																																																	}
																																																	{	/* Eval/evaluate.scm 420 */
																																																		obj_t
																																																			BgL_res2435z00_2844;
																																																		BgL_res2435z00_2844
																																																			=
																																																			MAKE_PAIR
																																																			(BgL_arg2045z00_1777,
																																																			BNIL);
																																																		BgL_newtail1217z00_1775
																																																			=
																																																			BgL_res2435z00_2844;
																																																	}
																																																}
																																																SET_CDR
																																																	(BgL_tail1216z00_1772,
																																																	BgL_newtail1217z00_1775);
																																																{	/* Eval/evaluate.scm 420 */
																																																	obj_t
																																																		BgL_arg2044z00_1776;
																																																	{	/* Eval/evaluate.scm 420 */
																																																		obj_t
																																																			BgL_pairz00_2847;
																																																		BgL_pairz00_2847
																																																			=
																																																			BgL_l1213z00_1771;
																																																		BgL_arg2044z00_1776
																																																			=
																																																			CDR
																																																			(BgL_pairz00_2847);
																																																	}
																																																	{
																																																		obj_t
																																																			BgL_tail1216z00_5097;
																																																		obj_t
																																																			BgL_l1213z00_5096;
																																																		BgL_l1213z00_5096
																																																			=
																																																			BgL_arg2044z00_1776;
																																																		BgL_tail1216z00_5097
																																																			=
																																																			BgL_newtail1217z00_1775;
																																																		BgL_tail1216z00_1772
																																																			=
																																																			BgL_tail1216z00_5097;
																																																		BgL_l1213z00_1771
																																																			=
																																																			BgL_l1213z00_5096;
																																																		goto
																																																			BgL_zc3anonymousza32042ze3z83_1773;
																																																	}
																																																}
																																															}
																																													}
																																												}
																																											((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt) BgL_new1134z00_1766)))->BgL_valsz00) = ((obj_t) BgL_auxz00_5073), BUNSPEC);
																																										}
																																										((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt) BgL_new1134z00_1766)))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_bodyz00_902, BgL_localsz00_1764, BgL_globalsz00_51, BgL_tailzf3zf3_52, BgL_wherez00_53, BgL_locz00_54, ((bool_t) 0)))), BUNSPEC);
																																										BgL_auxz00_5032
																																											=
																																											BgL_new1134z00_1766;
																																									}
																																								}
																																							}
																																						}
																																					}
																																					return
																																						(
																																						(obj_t)
																																						BgL_auxz00_5032);
																																				}
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 319 */
																																				obj_t
																																					BgL_arg1518z00_1082;
																																				BgL_arg1518z00_1082
																																					=
																																					CAR
																																					(BgL_ez00_49);
																																				{
																																					BgL_ev_appz00_bglt
																																						BgL_auxz00_5105;
																																					{
																																						obj_t
																																							BgL_argsz00_5107;
																																						obj_t
																																							BgL_fz00_5106;
																																						BgL_fz00_5106
																																							=
																																							BgL_arg1518z00_1082;
																																						BgL_argsz00_5107
																																							=
																																							BgL_cdrzd26677zd2_1077;
																																						BgL_argsz00_942
																																							=
																																							BgL_argsz00_5107;
																																						BgL_fz00_941
																																							=
																																							BgL_fz00_5106;
																																						goto
																																							BgL_tagzd2157zd2_943;
																																					}
																																					return
																																						(
																																						(obj_t)
																																						BgL_auxz00_5105);
																																				}
																																			}
																																	}
																																else
																																	{	/* Eval/evaluate.scm 319 */
																																		if (
																																			(CAR
																																				(BgL_ez00_49)
																																				==
																																				BGl_symbol2677z00zz__evaluatez00))
																																			{	/* Eval/evaluate.scm 319 */
																																				if (PAIRP(BgL_cdrzd26677zd2_1077))
																																					{	/* Eval/evaluate.scm 319 */
																																						obj_t
																																							BgL_carzd26851zd2_1087;
																																						obj_t
																																							BgL_cdrzd26852zd2_1088;
																																						BgL_carzd26851zd2_1087
																																							=
																																							CAR
																																							(BgL_cdrzd26677zd2_1077);
																																						BgL_cdrzd26852zd2_1088
																																							=
																																							CDR
																																							(BgL_cdrzd26677zd2_1077);
																																						if (PAIRP(BgL_carzd26851zd2_1087))
																																							{	/* Eval/evaluate.scm 319 */
																																								obj_t
																																									BgL_cdrzd26856zd2_1090;
																																								BgL_cdrzd26856zd2_1090
																																									=
																																									CDR
																																									(BgL_carzd26851zd2_1087);
																																								if ((CAR(BgL_carzd26851zd2_1087) == BGl_symbol2655z00zz__evaluatez00))
																																									{	/* Eval/evaluate.scm 319 */
																																										if (PAIRP(BgL_cdrzd26856zd2_1090))
																																											{	/* Eval/evaluate.scm 319 */
																																												obj_t
																																													BgL_carzd26859zd2_1093;
																																												obj_t
																																													BgL_cdrzd26860zd2_1094;
																																												BgL_carzd26859zd2_1093
																																													=
																																													CAR
																																													(BgL_cdrzd26856zd2_1090);
																																												BgL_cdrzd26860zd2_1094
																																													=
																																													CDR
																																													(BgL_cdrzd26856zd2_1090);
																																												if (SYMBOLP(BgL_carzd26859zd2_1093))
																																													{	/* Eval/evaluate.scm 319 */
																																														if (PAIRP(BgL_cdrzd26860zd2_1094))
																																															{	/* Eval/evaluate.scm 319 */
																																																obj_t
																																																	BgL_carzd26864zd2_1097;
																																																BgL_carzd26864zd2_1097
																																																	=
																																																	CAR
																																																	(BgL_cdrzd26860zd2_1094);
																																																if (SYMBOLP(BgL_carzd26864zd2_1097))
																																																	{	/* Eval/evaluate.scm 319 */
																																																		if (NULLP(CDR(BgL_cdrzd26860zd2_1094)))
																																																			{	/* Eval/evaluate.scm 319 */
																																																				if (PAIRP(BgL_cdrzd26852zd2_1088))
																																																					{	/* Eval/evaluate.scm 319 */
																																																						if (NULLP(CDR(BgL_cdrzd26852zd2_1088)))
																																																							{	/* Eval/evaluate.scm 319 */
																																																								obj_t
																																																									BgL_arg1532z00_1102;
																																																								BgL_arg1532z00_1102
																																																									=
																																																									CAR
																																																									(BgL_cdrzd26852zd2_1088);
																																																								{	/* Eval/evaluate.scm 319 */
																																																									obj_t
																																																										BgL_idz00_3196;
																																																									obj_t
																																																										BgL_modnamez00_3197;
																																																									BgL_idz00_3196
																																																										=
																																																										BgL_carzd26859zd2_1093;
																																																									BgL_modnamez00_3197
																																																										=
																																																										BgL_carzd26864zd2_1097;
																																																									{	/* Eval/evaluate.scm 424 */
																																																										BgL_ev_setglobalz00_bglt
																																																											BgL_new1136z00_3199;
																																																										{	/* Eval/evaluate.scm 424 */
																																																											BgL_ev_setglobalz00_bglt
																																																												BgL_new1135z00_3200;
																																																											BgL_new1135z00_3200
																																																												=
																																																												(
																																																												(BgL_ev_setglobalz00_bglt)
																																																												BREF
																																																												(GC_MALLOC
																																																													(sizeof
																																																														(struct
																																																															BgL_ev_setglobalz00_bgl))));
																																																											{	/* Eval/evaluate.scm 424 */
																																																												long
																																																													BgL_arg2062z00_3201;
																																																												{	/* Eval/evaluate.scm 424 */
																																																													long
																																																														BgL_res2490z00_3203;
																																																													BgL_res2490z00_3203
																																																														=
																																																														BGL_CLASS_INDEX
																																																														(BGl_ev_setglobalz00zz__evaluate_typesz00);
																																																													BgL_arg2062z00_3201
																																																														=
																																																														BgL_res2490z00_3203;
																																																												}
																																																												{	/* Eval/evaluate.scm 424 */
																																																													BgL_objectz00_bglt
																																																														BgL_objz00_3204;
																																																													BgL_objz00_3204
																																																														=
																																																														(
																																																														(BgL_objectz00_bglt)
																																																														BgL_new1135z00_3200);
																																																													BGL_OBJECT_CLASS_NUM_SET
																																																														(BgL_objz00_3204,
																																																														BgL_arg2062z00_3201);
																																																											}}
																																																											{	/* Eval/evaluate.scm 424 */
																																																												BgL_objectz00_bglt
																																																													BgL_auxz00_5146;
																																																												BgL_auxz00_5146
																																																													=
																																																													(
																																																													(BgL_objectz00_bglt)
																																																													BgL_new1135z00_3200);
																																																												BGL_OBJECT_WIDENING_SET
																																																													(BgL_auxz00_5146,
																																																													BFALSE);
																																																											}
																																																											BgL_new1136z00_3199
																																																												=
																																																												BgL_new1135z00_3200;
																																																										}
																																																										{
																																																											BgL_ev_exprz00_bglt
																																																												BgL_auxz00_5149;
																																																											{	/* Eval/evaluate.scm 280 */
																																																												obj_t
																																																													BgL_arg2097z00_3207;
																																																												BgL_arg2097z00_3207
																																																													=
																																																													BGl_getzd2locationzd2zz__evaluatez00
																																																													(BgL_arg1532z00_1102,
																																																													BgL_locz00_54);
																																																												BgL_auxz00_5149
																																																													=
																																																													(
																																																													(BgL_ev_exprz00_bglt)
																																																													BGl_uconvzf2loczf2zz__evaluatez00
																																																													(BgL_wherez00_53,
																																																														BgL_globalsz00_51,
																																																														BgL_localsz00_50,
																																																														BgL_arg1532z00_1102,
																																																														BgL_arg2097z00_3207));
																																																											}
																																																											((((BgL_ev_hookz00_bglt) CREF(((BgL_ev_hookz00_bglt) BgL_new1136z00_3199)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5149), BUNSPEC);
																																																										}
																																																										((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1136z00_3199))->BgL_locz00) = ((obj_t) BgL_locz00_54), BUNSPEC);
																																																										((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1136z00_3199))->BgL_namez00) = ((obj_t) BgL_idz00_3196), BUNSPEC);
																																																										((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1136z00_3199))->BgL_modz00) = ((obj_t) BGl_evalzd2findzd2modulez00zz__evmodulez00(BgL_modnamez00_3197)), BUNSPEC);
																																																										return
																																																											(
																																																											(obj_t)
																																																											BgL_new1136z00_3199);
																																																									}
																																																								}
																																																							}
																																																						else
																																																							{	/* Eval/evaluate.scm 319 */
																																																								return
																																																									BGl_evcompilezd2errorzd2zz__evcompilez00
																																																									(BgL_locz00_54,
																																																									BGl_string2643z00zz__evaluatez00,
																																																									BGl_string2649z00zz__evaluatez00,
																																																									BgL_ez00_49);
																																																							}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 319 */
																																																						return
																																																							BGl_evcompilezd2errorzd2zz__evcompilez00
																																																							(BgL_locz00_54,
																																																							BGl_string2643z00zz__evaluatez00,
																																																							BGl_string2649z00zz__evaluatez00,
																																																							BgL_ez00_49);
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 319 */
																																																				obj_t
																																																					BgL_cdrzd26980zd2_1104;
																																																				BgL_cdrzd26980zd2_1104
																																																					=
																																																					CDR
																																																					(BgL_ez00_49);
																																																				{	/* Eval/evaluate.scm 319 */
																																																					obj_t
																																																						BgL_cdrzd26984zd2_1105;
																																																					BgL_cdrzd26984zd2_1105
																																																						=
																																																						CDR
																																																						(BgL_cdrzd26980zd2_1104);
																																																					if (PAIRP(BgL_cdrzd26984zd2_1105))
																																																						{	/* Eval/evaluate.scm 319 */
																																																							if (NULLP(CDR(BgL_cdrzd26984zd2_1105)))
																																																								{	/* Eval/evaluate.scm 319 */
																																																									obj_t
																																																										BgL_arg1537z00_1108;
																																																									obj_t
																																																										BgL_arg1539z00_1109;
																																																									BgL_arg1537z00_1108
																																																										=
																																																										CAR
																																																										(BgL_cdrzd26980zd2_1104);
																																																									BgL_arg1539z00_1109
																																																										=
																																																										CAR
																																																										(BgL_cdrzd26984zd2_1105);
																																																									{
																																																										BgL_ev_hookz00_bglt
																																																											BgL_auxz00_5171;
																																																										BgL_vz00_911
																																																											=
																																																											BgL_arg1537z00_1108;
																																																										BgL_ez00_912
																																																											=
																																																											BgL_arg1539z00_1109;
																																																									BgL_tagzd2147zd2_913:
																																																										{	/* Eval/evaluate.scm 434 */
																																																											obj_t
																																																												BgL_cvz00_1823;
																																																											obj_t
																																																												BgL_ez00_1824;
																																																											BgL_cvz00_1823
																																																												=
																																																												BGl_convzd2varzd2zz__evaluatez00
																																																												(BgL_vz00_911,
																																																												BgL_localsz00_50);
																																																											{	/* Eval/evaluate.scm 280 */
																																																												obj_t
																																																													BgL_arg2097z00_2874;
																																																												{	/* Eval/evaluate.scm 129 */
																																																													obj_t
																																																														BgL__ortest_1067z00_2877;
																																																													BgL__ortest_1067z00_2877
																																																														=
																																																														BGl_getzd2sourcezd2locationz00zz__readerz00
																																																														(BgL_ez00_912);
																																																													if (CBOOL(BgL__ortest_1067z00_2877))
																																																														{	/* Eval/evaluate.scm 129 */
																																																															BgL_arg2097z00_2874
																																																																=
																																																																BgL__ortest_1067z00_2877;
																																																														}
																																																													else
																																																														{	/* Eval/evaluate.scm 129 */
																																																															BgL_arg2097z00_2874
																																																																=
																																																																BgL_locz00_54;
																																																														}
																																																												}
																																																												BgL_ez00_1824
																																																													=
																																																													BGl_convz00zz__evaluatez00
																																																													(BgL_ez00_912,
																																																													BgL_localsz00_50,
																																																													BgL_globalsz00_51,
																																																													BFALSE,
																																																													BgL_wherez00_53,
																																																													BgL_arg2097z00_2874,
																																																													((bool_t) 0));
																																																											}
																																																											if (CBOOL(BgL_cvz00_1823))
																																																												{	/* Eval/evaluate.scm 436 */
																																																													BgL_ev_setlocalz00_bglt
																																																														BgL_new1138z00_1825;
																																																													{	/* Eval/evaluate.scm 436 */
																																																														BgL_ev_setlocalz00_bglt
																																																															BgL_new1137z00_1826;
																																																														BgL_new1137z00_1826
																																																															=
																																																															(
																																																															(BgL_ev_setlocalz00_bglt)
																																																															BREF
																																																															(GC_MALLOC
																																																																(sizeof
																																																																	(struct
																																																																		BgL_ev_setlocalz00_bgl))));
																																																														{	/* Eval/evaluate.scm 436 */
																																																															long
																																																																BgL_arg2071z00_1827;
																																																															{	/* Eval/evaluate.scm 436 */
																																																																long
																																																																	BgL_res2441z00_2881;
																																																																BgL_res2441z00_2881
																																																																	=
																																																																	BGL_CLASS_INDEX
																																																																	(BGl_ev_setlocalz00zz__evaluate_typesz00);
																																																																BgL_arg2071z00_1827
																																																																	=
																																																																	BgL_res2441z00_2881;
																																																															}
																																																															{	/* Eval/evaluate.scm 436 */
																																																																BgL_objectz00_bglt
																																																																	BgL_objz00_2882;
																																																																BgL_objz00_2882
																																																																	=
																																																																	(
																																																																	(BgL_objectz00_bglt)
																																																																	BgL_new1137z00_1826);
																																																																BGL_OBJECT_CLASS_NUM_SET
																																																																	(BgL_objz00_2882,
																																																																	BgL_arg2071z00_1827);
																																																														}}
																																																														{	/* Eval/evaluate.scm 436 */
																																																															BgL_objectz00_bglt
																																																																BgL_auxz00_5183;
																																																															BgL_auxz00_5183
																																																																=
																																																																(
																																																																(BgL_objectz00_bglt)
																																																																BgL_new1137z00_1826);
																																																															BGL_OBJECT_WIDENING_SET
																																																																(BgL_auxz00_5183,
																																																																BFALSE);
																																																														}
																																																														BgL_new1138z00_1825
																																																															=
																																																															BgL_new1137z00_1826;
																																																													}
																																																													((((BgL_ev_hookz00_bglt) CREF(((BgL_ev_hookz00_bglt) BgL_new1138z00_1825)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_ez00_1824)), BUNSPEC);
																																																													((((BgL_ev_setlocalz00_bglt) CREF(BgL_new1138z00_1825))->BgL_vz00) = ((BgL_ev_varz00_bglt) ((BgL_ev_varz00_bglt) BgL_cvz00_1823)), BUNSPEC);
																																																													BgL_auxz00_5171
																																																														=
																																																														(
																																																														(BgL_ev_hookz00_bglt)
																																																														BgL_new1138z00_1825);
																																																												}
																																																											else
																																																												{	/* Eval/evaluate.scm 439 */
																																																													BgL_ev_setglobalz00_bglt
																																																														BgL_new1140z00_1828;
																																																													{	/* Eval/evaluate.scm 439 */
																																																														BgL_ev_setglobalz00_bglt
																																																															BgL_new1139z00_1830;
																																																														BgL_new1139z00_1830
																																																															=
																																																															(
																																																															(BgL_ev_setglobalz00_bglt)
																																																															BREF
																																																															(GC_MALLOC
																																																																(sizeof
																																																																	(struct
																																																																		BgL_ev_setglobalz00_bgl))));
																																																														{	/* Eval/evaluate.scm 439 */
																																																															long
																																																																BgL_arg2073z00_1831;
																																																															{	/* Eval/evaluate.scm 439 */
																																																																long
																																																																	BgL_res2442z00_2885;
																																																																BgL_res2442z00_2885
																																																																	=
																																																																	BGL_CLASS_INDEX
																																																																	(BGl_ev_setglobalz00zz__evaluate_typesz00);
																																																																BgL_arg2073z00_1831
																																																																	=
																																																																	BgL_res2442z00_2885;
																																																															}
																																																															{	/* Eval/evaluate.scm 439 */
																																																																BgL_objectz00_bglt
																																																																	BgL_objz00_2886;
																																																																BgL_objz00_2886
																																																																	=
																																																																	(
																																																																	(BgL_objectz00_bglt)
																																																																	BgL_new1139z00_1830);
																																																																BGL_OBJECT_CLASS_NUM_SET
																																																																	(BgL_objz00_2886,
																																																																	BgL_arg2073z00_1831);
																																																														}}
																																																														{	/* Eval/evaluate.scm 439 */
																																																															BgL_objectz00_bglt
																																																																BgL_auxz00_5196;
																																																															BgL_auxz00_5196
																																																																=
																																																																(
																																																																(BgL_objectz00_bglt)
																																																																BgL_new1139z00_1830);
																																																															BGL_OBJECT_WIDENING_SET
																																																																(BgL_auxz00_5196,
																																																																BFALSE);
																																																														}
																																																														BgL_new1140z00_1828
																																																															=
																																																															BgL_new1139z00_1830;
																																																													}
																																																													((((BgL_ev_hookz00_bglt) CREF(((BgL_ev_hookz00_bglt) BgL_new1140z00_1828)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_ez00_1824)), BUNSPEC);
																																																													((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1140z00_1828))->BgL_locz00) = ((obj_t) BgL_locz00_54), BUNSPEC);
																																																													((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1140z00_1828))->BgL_namez00) = ((obj_t) BgL_vz00_911), BUNSPEC);
																																																													{
																																																														obj_t
																																																															BgL_auxz00_5204;
																																																														if (BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_51))
																																																															{	/* Eval/evaluate.scm 442 */
																																																																BgL_auxz00_5204
																																																																	=
																																																																	BgL_globalsz00_51;
																																																															}
																																																														else
																																																															{	/* Eval/evaluate.scm 442 */
																																																																BgL_auxz00_5204
																																																																	=
																																																																	BGL_MODULE
																																																																	();
																																																															}
																																																														((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1140z00_1828))->BgL_modz00) = ((obj_t) BgL_auxz00_5204), BUNSPEC);
																																																													}
																																																													BgL_auxz00_5171
																																																														=
																																																														(
																																																														(BgL_ev_hookz00_bglt)
																																																														BgL_new1140z00_1828);
																																																												}
																																																										}
																																																										return
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_5171);
																																																									}
																																																								}
																																																							else
																																																								{	/* Eval/evaluate.scm 319 */
																																																									return
																																																										BGl_evcompilezd2errorzd2zz__evcompilez00
																																																										(BgL_locz00_54,
																																																										BGl_string2643z00zz__evaluatez00,
																																																										BGl_string2649z00zz__evaluatez00,
																																																										BgL_ez00_49);
																																																								}
																																																						}
																																																					else
																																																						{	/* Eval/evaluate.scm 319 */
																																																							return
																																																								BGl_evcompilezd2errorzd2zz__evcompilez00
																																																								(BgL_locz00_54,
																																																								BGl_string2643z00zz__evaluatez00,
																																																								BGl_string2649z00zz__evaluatez00,
																																																								BgL_ez00_49);
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 319 */
																																																		obj_t
																																																			BgL_cdrzd27041zd2_1112;
																																																		BgL_cdrzd27041zd2_1112
																																																			=
																																																			CDR
																																																			(BgL_ez00_49);
																																																		{	/* Eval/evaluate.scm 319 */
																																																			obj_t
																																																				BgL_cdrzd27045zd2_1113;
																																																			BgL_cdrzd27045zd2_1113
																																																				=
																																																				CDR
																																																				(BgL_cdrzd27041zd2_1112);
																																																			if (PAIRP(BgL_cdrzd27045zd2_1113))
																																																				{	/* Eval/evaluate.scm 319 */
																																																					if (NULLP(CDR(BgL_cdrzd27045zd2_1113)))
																																																						{	/* Eval/evaluate.scm 319 */
																																																							obj_t
																																																								BgL_arg1546z00_1116;
																																																							obj_t
																																																								BgL_arg1547z00_1117;
																																																							BgL_arg1546z00_1116
																																																								=
																																																								CAR
																																																								(BgL_cdrzd27041zd2_1112);
																																																							BgL_arg1547z00_1117
																																																								=
																																																								CAR
																																																								(BgL_cdrzd27045zd2_1113);
																																																							{
																																																								BgL_ev_hookz00_bglt
																																																									BgL_auxz00_5222;
																																																								{
																																																									obj_t
																																																										BgL_ez00_5224;
																																																									obj_t
																																																										BgL_vz00_5223;
																																																									BgL_vz00_5223
																																																										=
																																																										BgL_arg1546z00_1116;
																																																									BgL_ez00_5224
																																																										=
																																																										BgL_arg1547z00_1117;
																																																									BgL_ez00_912
																																																										=
																																																										BgL_ez00_5224;
																																																									BgL_vz00_911
																																																										=
																																																										BgL_vz00_5223;
																																																									goto
																																																										BgL_tagzd2147zd2_913;
																																																								}
																																																								return
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_5222);
																																																							}
																																																						}
																																																					else
																																																						{	/* Eval/evaluate.scm 319 */
																																																							return
																																																								BGl_evcompilezd2errorzd2zz__evcompilez00
																																																								(BgL_locz00_54,
																																																								BGl_string2643z00zz__evaluatez00,
																																																								BGl_string2649z00zz__evaluatez00,
																																																								BgL_ez00_49);
																																																						}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate.scm 319 */
																																																					return
																																																						BGl_evcompilezd2errorzd2zz__evcompilez00
																																																						(BgL_locz00_54,
																																																						BGl_string2643z00zz__evaluatez00,
																																																						BGl_string2649z00zz__evaluatez00,
																																																						BgL_ez00_49);
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 319 */
																																																obj_t
																																																	BgL_cdrzd27102zd2_1119;
																																																BgL_cdrzd27102zd2_1119
																																																	=
																																																	CDR
																																																	(BgL_ez00_49);
																																																{	/* Eval/evaluate.scm 319 */
																																																	obj_t
																																																		BgL_cdrzd27106zd2_1120;
																																																	BgL_cdrzd27106zd2_1120
																																																		=
																																																		CDR
																																																		(BgL_cdrzd27102zd2_1119);
																																																	if (PAIRP(BgL_cdrzd27106zd2_1120))
																																																		{	/* Eval/evaluate.scm 319 */
																																																			if (NULLP(CDR(BgL_cdrzd27106zd2_1120)))
																																																				{	/* Eval/evaluate.scm 319 */
																																																					obj_t
																																																						BgL_arg1552z00_1123;
																																																					obj_t
																																																						BgL_arg1553z00_1124;
																																																					BgL_arg1552z00_1123
																																																						=
																																																						CAR
																																																						(BgL_cdrzd27102zd2_1119);
																																																					BgL_arg1553z00_1124
																																																						=
																																																						CAR
																																																						(BgL_cdrzd27106zd2_1120);
																																																					{
																																																						BgL_ev_hookz00_bglt
																																																							BgL_auxz00_5237;
																																																						{
																																																							obj_t
																																																								BgL_ez00_5239;
																																																							obj_t
																																																								BgL_vz00_5238;
																																																							BgL_vz00_5238
																																																								=
																																																								BgL_arg1552z00_1123;
																																																							BgL_ez00_5239
																																																								=
																																																								BgL_arg1553z00_1124;
																																																							BgL_ez00_912
																																																								=
																																																								BgL_ez00_5239;
																																																							BgL_vz00_911
																																																								=
																																																								BgL_vz00_5238;
																																																							goto
																																																								BgL_tagzd2147zd2_913;
																																																						}
																																																						return
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_5237);
																																																					}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate.scm 319 */
																																																					return
																																																						BGl_evcompilezd2errorzd2zz__evcompilez00
																																																						(BgL_locz00_54,
																																																						BGl_string2643z00zz__evaluatez00,
																																																						BGl_string2649z00zz__evaluatez00,
																																																						BgL_ez00_49);
																																																				}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 319 */
																																																			return
																																																				BGl_evcompilezd2errorzd2zz__evcompilez00
																																																				(BgL_locz00_54,
																																																				BGl_string2643z00zz__evaluatez00,
																																																				BGl_string2649z00zz__evaluatez00,
																																																				BgL_ez00_49);
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 319 */
																																														obj_t
																																															BgL_cdrzd27163zd2_1126;
																																														BgL_cdrzd27163zd2_1126
																																															=
																																															CDR
																																															(BgL_ez00_49);
																																														{	/* Eval/evaluate.scm 319 */
																																															obj_t
																																																BgL_cdrzd27167zd2_1127;
																																															BgL_cdrzd27167zd2_1127
																																																=
																																																CDR
																																																(BgL_cdrzd27163zd2_1126);
																																															if (PAIRP(BgL_cdrzd27167zd2_1127))
																																																{	/* Eval/evaluate.scm 319 */
																																																	if (NULLP(CDR(BgL_cdrzd27167zd2_1127)))
																																																		{	/* Eval/evaluate.scm 319 */
																																																			obj_t
																																																				BgL_arg1557z00_1130;
																																																			obj_t
																																																				BgL_arg1558z00_1131;
																																																			BgL_arg1557z00_1130
																																																				=
																																																				CAR
																																																				(BgL_cdrzd27163zd2_1126);
																																																			BgL_arg1558z00_1131
																																																				=
																																																				CAR
																																																				(BgL_cdrzd27167zd2_1127);
																																																			{
																																																				BgL_ev_hookz00_bglt
																																																					BgL_auxz00_5252;
																																																				{
																																																					obj_t
																																																						BgL_ez00_5254;
																																																					obj_t
																																																						BgL_vz00_5253;
																																																					BgL_vz00_5253
																																																						=
																																																						BgL_arg1557z00_1130;
																																																					BgL_ez00_5254
																																																						=
																																																						BgL_arg1558z00_1131;
																																																					BgL_ez00_912
																																																						=
																																																						BgL_ez00_5254;
																																																					BgL_vz00_911
																																																						=
																																																						BgL_vz00_5253;
																																																					goto
																																																						BgL_tagzd2147zd2_913;
																																																				}
																																																				return
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_5252);
																																																			}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 319 */
																																																			return
																																																				BGl_evcompilezd2errorzd2zz__evcompilez00
																																																				(BgL_locz00_54,
																																																				BGl_string2643z00zz__evaluatez00,
																																																				BGl_string2649z00zz__evaluatez00,
																																																				BgL_ez00_49);
																																																		}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 319 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_54,
																																																		BGl_string2643z00zz__evaluatez00,
																																																		BGl_string2649z00zz__evaluatez00,
																																																		BgL_ez00_49);
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 319 */
																																												obj_t
																																													BgL_cdrzd27224zd2_1133;
																																												BgL_cdrzd27224zd2_1133
																																													=
																																													CDR
																																													(BgL_ez00_49);
																																												{	/* Eval/evaluate.scm 319 */
																																													obj_t
																																														BgL_cdrzd27228zd2_1134;
																																													BgL_cdrzd27228zd2_1134
																																														=
																																														CDR
																																														(BgL_cdrzd27224zd2_1133);
																																													if (PAIRP(BgL_cdrzd27228zd2_1134))
																																														{	/* Eval/evaluate.scm 319 */
																																															if (NULLP(CDR(BgL_cdrzd27228zd2_1134)))
																																																{	/* Eval/evaluate.scm 319 */
																																																	obj_t
																																																		BgL_arg1563z00_1137;
																																																	obj_t
																																																		BgL_arg1564z00_1138;
																																																	BgL_arg1563z00_1137
																																																		=
																																																		CAR
																																																		(BgL_cdrzd27224zd2_1133);
																																																	BgL_arg1564z00_1138
																																																		=
																																																		CAR
																																																		(BgL_cdrzd27228zd2_1134);
																																																	{
																																																		BgL_ev_hookz00_bglt
																																																			BgL_auxz00_5267;
																																																		{
																																																			obj_t
																																																				BgL_ez00_5269;
																																																			obj_t
																																																				BgL_vz00_5268;
																																																			BgL_vz00_5268
																																																				=
																																																				BgL_arg1563z00_1137;
																																																			BgL_ez00_5269
																																																				=
																																																				BgL_arg1564z00_1138;
																																																			BgL_ez00_912
																																																				=
																																																				BgL_ez00_5269;
																																																			BgL_vz00_911
																																																				=
																																																				BgL_vz00_5268;
																																																			goto
																																																				BgL_tagzd2147zd2_913;
																																																		}
																																																		return
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_5267);
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 319 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_54,
																																																		BGl_string2643z00zz__evaluatez00,
																																																		BGl_string2649z00zz__evaluatez00,
																																																		BgL_ez00_49);
																																																}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 319 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_54,
																																																BGl_string2643z00zz__evaluatez00,
																																																BGl_string2649z00zz__evaluatez00,
																																																BgL_ez00_49);
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 319 */
																																										obj_t
																																											BgL_cdrzd27272zd2_1140;
																																										BgL_cdrzd27272zd2_1140
																																											=
																																											CDR
																																											(BgL_ez00_49);
																																										{	/* Eval/evaluate.scm 319 */
																																											obj_t
																																												BgL_carzd27275zd2_1141;
																																											obj_t
																																												BgL_cdrzd27276zd2_1142;
																																											BgL_carzd27275zd2_1141
																																												=
																																												CAR
																																												(BgL_cdrzd27272zd2_1140);
																																											BgL_cdrzd27276zd2_1142
																																												=
																																												CDR
																																												(BgL_cdrzd27272zd2_1140);
																																											if ((CAR(BgL_carzd27275zd2_1141) == BGl_symbol2657z00zz__evaluatez00))
																																												{	/* Eval/evaluate.scm 319 */
																																													if (PAIRP(BgL_cdrzd27276zd2_1142))
																																														{	/* Eval/evaluate.scm 319 */
																																															if (NULLP(CDR(BgL_cdrzd27276zd2_1142)))
																																																{	/* Eval/evaluate.scm 319 */
																																																	BgL_lz00_908
																																																		=
																																																		CDR
																																																		(BgL_carzd27275zd2_1141);
																																																	BgL_e2z00_909
																																																		=
																																																		CAR
																																																		(BgL_cdrzd27276zd2_1142);
																																																BgL_tagzd2146zd2_910:
																																																	{	/* Eval/evaluate.scm 430 */
																																																		bool_t
																																																			BgL_testz00_5284;
																																																		if (PAIRP(BgL_lz00_908))
																																																			{	/* Eval/evaluate.scm 430 */
																																																				bool_t
																																																					BgL_testz00_5287;
																																																				{	/* Ieee/pairlist.scm 214 */
																																																					obj_t
																																																						BgL_auxz00_5288;
																																																					BgL_auxz00_5288
																																																						=
																																																						CDR
																																																						(BgL_lz00_908);
																																																					BgL_testz00_5287
																																																						=
																																																						PAIRP
																																																						(BgL_auxz00_5288);
																																																				}
																																																				if (BgL_testz00_5287)
																																																					{
																																																						obj_t
																																																							BgL_l1218z00_1814;
																																																						BgL_l1218z00_1814
																																																							=
																																																							BgL_lz00_908;
																																																					BgL_zc3anonymousza32066ze3z83_1815:
																																																						if (NULLP(BgL_l1218z00_1814))
																																																							{	/* Eval/evaluate.scm 430 */
																																																								BgL_testz00_5284
																																																									=
																																																									(
																																																									(bool_t)
																																																									1);
																																																							}
																																																						else
																																																							{	/* Eval/evaluate.scm 430 */
																																																								bool_t
																																																									BgL_testz00_5293;
																																																								{	/* Ieee/symbol.scm 129 */
																																																									obj_t
																																																										BgL_auxz00_5294;
																																																									BgL_auxz00_5294
																																																										=
																																																										CAR
																																																										(BgL_l1218z00_1814);
																																																									BgL_testz00_5293
																																																										=
																																																										SYMBOLP
																																																										(BgL_auxz00_5294);
																																																								}
																																																								if (BgL_testz00_5293)
																																																									{
																																																										obj_t
																																																											BgL_l1218z00_5297;
																																																										BgL_l1218z00_5297
																																																											=
																																																											CDR
																																																											(BgL_l1218z00_1814);
																																																										BgL_l1218z00_1814
																																																											=
																																																											BgL_l1218z00_5297;
																																																										goto
																																																											BgL_zc3anonymousza32066ze3z83_1815;
																																																									}
																																																								else
																																																									{	/* Eval/evaluate.scm 430 */
																																																										BgL_testz00_5284
																																																											=
																																																											(
																																																											(bool_t)
																																																											0);
																																																									}
																																																							}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 430 */
																																																						BgL_testz00_5284
																																																							=
																																																							(
																																																							(bool_t)
																																																							0);
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 430 */
																																																				BgL_testz00_5284
																																																					=
																																																					(
																																																					(bool_t)
																																																					0);
																																																			}
																																																		if (BgL_testz00_5284)
																																																			{	/* Eval/evaluate.scm 430 */
																																																				return
																																																					BGl_convzd2fieldzd2setz00zz__evaluatez00
																																																					(BgL_lz00_908,
																																																					BgL_e2z00_909,
																																																					BgL_ez00_49,
																																																					BgL_localsz00_50,
																																																					BgL_globalsz00_51,
																																																					BgL_tailzf3zf3_52,
																																																					BgL_wherez00_53,
																																																					BgL_locz00_54,
																																																					BgL_topzf3zf3_55);
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 430 */
																																																				return
																																																					BGl_evcompilezd2errorzd2zz__evcompilez00
																																																					(BgL_locz00_54,
																																																					BGl_string2643z00zz__evaluatez00,
																																																					BGl_string2649z00zz__evaluatez00,
																																																					BgL_ez00_49);
																																																			}
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 319 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_54,
																																																		BGl_string2643z00zz__evaluatez00,
																																																		BGl_string2649z00zz__evaluatez00,
																																																		BgL_ez00_49);
																																																}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 319 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_54,
																																																BGl_string2643z00zz__evaluatez00,
																																																BGl_string2649z00zz__evaluatez00,
																																																BgL_ez00_49);
																																														}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 319 */
																																													obj_t
																																														BgL_cdrzd27352zd2_1150;
																																													BgL_cdrzd27352zd2_1150
																																														=
																																														CDR
																																														(BgL_cdrzd27272zd2_1140);
																																													if (PAIRP(BgL_cdrzd27352zd2_1150))
																																														{	/* Eval/evaluate.scm 319 */
																																															if (NULLP(CDR(BgL_cdrzd27352zd2_1150)))
																																																{	/* Eval/evaluate.scm 319 */
																																																	obj_t
																																																		BgL_arg1575z00_1153;
																																																	obj_t
																																																		BgL_arg1576z00_1154;
																																																	BgL_arg1575z00_1153
																																																		=
																																																		CAR
																																																		(BgL_cdrzd27272zd2_1140);
																																																	BgL_arg1576z00_1154
																																																		=
																																																		CAR
																																																		(BgL_cdrzd27352zd2_1150);
																																																	{
																																																		BgL_ev_hookz00_bglt
																																																			BgL_auxz00_5313;
																																																		{
																																																			obj_t
																																																				BgL_ez00_5315;
																																																			obj_t
																																																				BgL_vz00_5314;
																																																			BgL_vz00_5314
																																																				=
																																																				BgL_arg1575z00_1153;
																																																			BgL_ez00_5315
																																																				=
																																																				BgL_arg1576z00_1154;
																																																			BgL_ez00_912
																																																				=
																																																				BgL_ez00_5315;
																																																			BgL_vz00_911
																																																				=
																																																				BgL_vz00_5314;
																																																			goto
																																																				BgL_tagzd2147zd2_913;
																																																		}
																																																		return
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_5313);
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 319 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_54,
																																																		BGl_string2643z00zz__evaluatez00,
																																																		BGl_string2649z00zz__evaluatez00,
																																																		BgL_ez00_49);
																																																}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 319 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_54,
																																																BGl_string2643z00zz__evaluatez00,
																																																BGl_string2649z00zz__evaluatez00,
																																																BgL_ez00_49);
																																														}
																																												}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 319 */
																																								obj_t
																																									BgL_cdrzd27409zd2_1158;
																																								BgL_cdrzd27409zd2_1158
																																									=
																																									CDR
																																									(BgL_ez00_49);
																																								{	/* Eval/evaluate.scm 319 */
																																									obj_t
																																										BgL_cdrzd27413zd2_1159;
																																									BgL_cdrzd27413zd2_1159
																																										=
																																										CDR
																																										(BgL_cdrzd27409zd2_1158);
																																									if (PAIRP(BgL_cdrzd27413zd2_1159))
																																										{	/* Eval/evaluate.scm 319 */
																																											if (NULLP(CDR(BgL_cdrzd27413zd2_1159)))
																																												{	/* Eval/evaluate.scm 319 */
																																													obj_t
																																														BgL_arg1582z00_1162;
																																													obj_t
																																														BgL_arg1583z00_1163;
																																													BgL_arg1582z00_1162
																																														=
																																														CAR
																																														(BgL_cdrzd27409zd2_1158);
																																													BgL_arg1583z00_1163
																																														=
																																														CAR
																																														(BgL_cdrzd27413zd2_1159);
																																													{
																																														BgL_ev_hookz00_bglt
																																															BgL_auxz00_5328;
																																														{
																																															obj_t
																																																BgL_ez00_5330;
																																															obj_t
																																																BgL_vz00_5329;
																																															BgL_vz00_5329
																																																=
																																																BgL_arg1582z00_1162;
																																															BgL_ez00_5330
																																																=
																																																BgL_arg1583z00_1163;
																																															BgL_ez00_912
																																																=
																																																BgL_ez00_5330;
																																															BgL_vz00_911
																																																=
																																																BgL_vz00_5329;
																																															goto
																																																BgL_tagzd2147zd2_913;
																																														}
																																														return
																																															(
																																															(obj_t)
																																															BgL_auxz00_5328);
																																													}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 319 */
																																													return
																																														BGl_evcompilezd2errorzd2zz__evcompilez00
																																														(BgL_locz00_54,
																																														BGl_string2643z00zz__evaluatez00,
																																														BGl_string2649z00zz__evaluatez00,
																																														BgL_ez00_49);
																																												}
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 319 */
																																											return
																																												BGl_evcompilezd2errorzd2zz__evcompilez00
																																												(BgL_locz00_54,
																																												BGl_string2643z00zz__evaluatez00,
																																												BGl_string2649z00zz__evaluatez00,
																																												BgL_ez00_49);
																																										}
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 319 */
																																						return
																																							BGl_evcompilezd2errorzd2zz__evcompilez00
																																							(BgL_locz00_54,
																																							BGl_string2643z00zz__evaluatez00,
																																							BGl_string2649z00zz__evaluatez00,
																																							BgL_ez00_49);
																																					}
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 319 */
																																				obj_t
																																					BgL_cdrzd27534zd2_1165;
																																				BgL_cdrzd27534zd2_1165
																																					=
																																					CDR
																																					(BgL_ez00_49);
																																				if ((CAR
																																						(BgL_ez00_49)
																																						==
																																						BGl_symbol2679z00zz__evaluatez00))
																																					{	/* Eval/evaluate.scm 319 */
																																						if (PAIRP(BgL_cdrzd27534zd2_1165))
																																							{	/* Eval/evaluate.scm 319 */
																																								obj_t
																																									BgL_cdrzd27539zd2_1168;
																																								BgL_cdrzd27539zd2_1168
																																									=
																																									CDR
																																									(BgL_cdrzd27534zd2_1165);
																																								if (PAIRP(BgL_cdrzd27539zd2_1168))
																																									{	/* Eval/evaluate.scm 319 */
																																										obj_t
																																											BgL_carzd27543zd2_1170;
																																										BgL_carzd27543zd2_1170
																																											=
																																											CAR
																																											(BgL_cdrzd27539zd2_1168);
																																										if (PAIRP(BgL_carzd27543zd2_1170))
																																											{	/* Eval/evaluate.scm 319 */
																																												obj_t
																																													BgL_cdrzd27548zd2_1172;
																																												BgL_cdrzd27548zd2_1172
																																													=
																																													CDR
																																													(BgL_carzd27543zd2_1170);
																																												if ((CAR(BgL_carzd27543zd2_1170) == BGl_symbol2681z00zz__evaluatez00))
																																													{	/* Eval/evaluate.scm 319 */
																																														if (PAIRP(BgL_cdrzd27548zd2_1172))
																																															{	/* Eval/evaluate.scm 319 */
																																																obj_t
																																																	BgL_cdrzd27552zd2_1175;
																																																BgL_cdrzd27552zd2_1175
																																																	=
																																																	CDR
																																																	(BgL_cdrzd27548zd2_1172);
																																																if (PAIRP(BgL_cdrzd27552zd2_1175))
																																																	{	/* Eval/evaluate.scm 319 */
																																																		if (NULLP(CDR(BgL_cdrzd27552zd2_1175)))
																																																			{	/* Eval/evaluate.scm 319 */
																																																				if (NULLP(CDR(BgL_cdrzd27539zd2_1168)))
																																																					{	/* Eval/evaluate.scm 319 */
																																																						obj_t
																																																							BgL_arg1594z00_1179;
																																																						obj_t
																																																							BgL_arg1595z00_1180;
																																																						obj_t
																																																							BgL_arg1596z00_1181;
																																																						BgL_arg1594z00_1179
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27534zd2_1165);
																																																						BgL_arg1595z00_1180
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27548zd2_1172);
																																																						BgL_arg1596z00_1181
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27552zd2_1175);
																																																						{
																																																							BgL_ev_defglobalz00_bglt
																																																								BgL_auxz00_5365;
																																																							BgL_gvz00_915
																																																								=
																																																								BgL_arg1594z00_1179;
																																																							BgL_formalsz00_916
																																																								=
																																																								BgL_arg1595z00_1180;
																																																							BgL_bodyz00_917
																																																								=
																																																								BgL_arg1596z00_1181;
																																																						BgL_tagzd2149zd2_918:
																																																							{	/* Eval/evaluate.scm 447 */
																																																								BgL_ev_defglobalz00_bglt
																																																									BgL_new1142z00_1832;
																																																								{	/* Eval/evaluate.scm 447 */
																																																									BgL_ev_defglobalz00_bglt
																																																										BgL_new1141z00_1835;
																																																									BgL_new1141z00_1835
																																																										=
																																																										(
																																																										(BgL_ev_defglobalz00_bglt)
																																																										BREF
																																																										(GC_MALLOC
																																																											(sizeof
																																																												(struct
																																																													BgL_ev_defglobalz00_bgl))));
																																																									{	/* Eval/evaluate.scm 447 */
																																																										long
																																																											BgL_arg2076z00_1836;
																																																										{	/* Eval/evaluate.scm 447 */
																																																											long
																																																												BgL_res2443z00_2889;
																																																											BgL_res2443z00_2889
																																																												=
																																																												BGL_CLASS_INDEX
																																																												(BGl_ev_defglobalz00zz__evaluate_typesz00);
																																																											BgL_arg2076z00_1836
																																																												=
																																																												BgL_res2443z00_2889;
																																																										}
																																																										{	/* Eval/evaluate.scm 447 */
																																																											BgL_objectz00_bglt
																																																												BgL_objz00_2890;
																																																											BgL_objz00_2890
																																																												=
																																																												(
																																																												(BgL_objectz00_bglt)
																																																												BgL_new1141z00_1835);
																																																											BGL_OBJECT_CLASS_NUM_SET
																																																												(BgL_objz00_2890,
																																																												BgL_arg2076z00_1836);
																																																									}}
																																																									{	/* Eval/evaluate.scm 447 */
																																																										BgL_objectz00_bglt
																																																											BgL_auxz00_5370;
																																																										BgL_auxz00_5370
																																																											=
																																																											(
																																																											(BgL_objectz00_bglt)
																																																											BgL_new1141z00_1835);
																																																										BGL_OBJECT_WIDENING_SET
																																																											(BgL_auxz00_5370,
																																																											BFALSE);
																																																									}
																																																									BgL_new1142z00_1832
																																																										=
																																																										BgL_new1141z00_1835;
																																																								}
																																																								((((BgL_ev_hookz00_bglt) CREF(((BgL_ev_hookz00_bglt) BgL_new1142z00_1832)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2lambdazd2zz__evaluatez00(BgL_globalsz00_51, BgL_localsz00_50, BgL_locz00_54, BgL_ez00_49, BgL_formalsz00_916, BgL_bodyz00_917, BgL_gvz00_915))), BUNSPEC);
																																																								((((BgL_ev_setglobalz00_bglt) CREF(((BgL_ev_setglobalz00_bglt) BgL_new1142z00_1832)))->BgL_locz00) = ((obj_t) BgL_locz00_54), BUNSPEC);
																																																								{
																																																									obj_t
																																																										BgL_auxz00_5379;
																																																									{	/* Eval/evaluate.scm 449 */
																																																										obj_t
																																																											BgL_arg2074z00_1833;
																																																										BgL_arg2074z00_1833
																																																											=
																																																											BGl_untypezd2identzd2zz__evaluatez00
																																																											(BgL_gvz00_915);
																																																										BgL_auxz00_5379
																																																											=
																																																											CAR
																																																											(BgL_arg2074z00_1833);
																																																									}
																																																									((((BgL_ev_setglobalz00_bglt) CREF(((BgL_ev_setglobalz00_bglt) BgL_new1142z00_1832)))->BgL_namez00) = ((obj_t) BgL_auxz00_5379), BUNSPEC);
																																																								}
																																																								{
																																																									obj_t
																																																										BgL_auxz00_5384;
																																																									if (BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_51))
																																																										{	/* Eval/evaluate.scm 450 */
																																																											BgL_auxz00_5384
																																																												=
																																																												BgL_globalsz00_51;
																																																										}
																																																									else
																																																										{	/* Eval/evaluate.scm 450 */
																																																											BgL_auxz00_5384
																																																												=
																																																												BGL_MODULE
																																																												();
																																																										}
																																																									((((BgL_ev_setglobalz00_bglt) CREF(((BgL_ev_setglobalz00_bglt) BgL_new1142z00_1832)))->BgL_modz00) = ((obj_t) BgL_auxz00_5384), BUNSPEC);
																																																								}
																																																								BgL_auxz00_5365
																																																									=
																																																									BgL_new1142z00_1832;
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_5365);
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 319 */
																																																						obj_t
																																																							BgL_arg1597z00_1182;
																																																						BgL_arg1597z00_1182
																																																							=
																																																							CAR
																																																							(BgL_ez00_49);
																																																						{
																																																							BgL_ev_appz00_bglt
																																																								BgL_auxz00_5392;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_5394;
																																																								obj_t
																																																									BgL_fz00_5393;
																																																								BgL_fz00_5393
																																																									=
																																																									BgL_arg1597z00_1182;
																																																								BgL_argsz00_5394
																																																									=
																																																									BgL_cdrzd27534zd2_1165;
																																																								BgL_argsz00_942
																																																									=
																																																									BgL_argsz00_5394;
																																																								BgL_fz00_941
																																																									=
																																																									BgL_fz00_5393;
																																																								goto
																																																									BgL_tagzd2157zd2_943;
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_5392);
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 319 */
																																																				obj_t
																																																					BgL_cdrzd27652zd2_1186;
																																																				BgL_cdrzd27652zd2_1186
																																																					=
																																																					CDR
																																																					(BgL_cdrzd27534zd2_1165);
																																																				if (NULLP(CDR(BgL_cdrzd27652zd2_1186)))
																																																					{	/* Eval/evaluate.scm 319 */
																																																						obj_t
																																																							BgL_arg1601z00_1188;
																																																						obj_t
																																																							BgL_arg1602z00_1189;
																																																						BgL_arg1601z00_1188
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27534zd2_1165);
																																																						BgL_arg1602z00_1189
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27652zd2_1186);
																																																						{
																																																							BgL_ev_defglobalz00_bglt
																																																								BgL_auxz00_5402;
																																																							BgL_gvz00_919
																																																								=
																																																								BgL_arg1601z00_1188;
																																																							BgL_gez00_920
																																																								=
																																																								BgL_arg1602z00_1189;
																																																						BgL_tagzd2150zd2_921:
																																																							{	/* Eval/evaluate.scm 453 */
																																																								BgL_ev_defglobalz00_bglt
																																																									BgL_new1144z00_1837;
																																																								{	/* Eval/evaluate.scm 453 */
																																																									BgL_ev_defglobalz00_bglt
																																																										BgL_new1143z00_1840;
																																																									BgL_new1143z00_1840
																																																										=
																																																										(
																																																										(BgL_ev_defglobalz00_bglt)
																																																										BREF
																																																										(GC_MALLOC
																																																											(sizeof
																																																												(struct
																																																													BgL_ev_defglobalz00_bgl))));
																																																									{	/* Eval/evaluate.scm 453 */
																																																										long
																																																											BgL_arg2079z00_1841;
																																																										{	/* Eval/evaluate.scm 453 */
																																																											long
																																																												BgL_res2444z00_2894;
																																																											BgL_res2444z00_2894
																																																												=
																																																												BGL_CLASS_INDEX
																																																												(BGl_ev_defglobalz00zz__evaluate_typesz00);
																																																											BgL_arg2079z00_1841
																																																												=
																																																												BgL_res2444z00_2894;
																																																										}
																																																										{	/* Eval/evaluate.scm 453 */
																																																											BgL_objectz00_bglt
																																																												BgL_objz00_2895;
																																																											BgL_objz00_2895
																																																												=
																																																												(
																																																												(BgL_objectz00_bglt)
																																																												BgL_new1143z00_1840);
																																																											BGL_OBJECT_CLASS_NUM_SET
																																																												(BgL_objz00_2895,
																																																												BgL_arg2079z00_1841);
																																																									}}
																																																									{	/* Eval/evaluate.scm 453 */
																																																										BgL_objectz00_bglt
																																																											BgL_auxz00_5407;
																																																										BgL_auxz00_5407
																																																											=
																																																											(
																																																											(BgL_objectz00_bglt)
																																																											BgL_new1143z00_1840);
																																																										BGL_OBJECT_WIDENING_SET
																																																											(BgL_auxz00_5407,
																																																											BFALSE);
																																																									}
																																																									BgL_new1144z00_1837
																																																										=
																																																										BgL_new1143z00_1840;
																																																								}
																																																								{
																																																									BgL_ev_exprz00_bglt
																																																										BgL_auxz00_5410;
																																																									{	/* Eval/evaluate.scm 280 */
																																																										obj_t
																																																											BgL_arg2097z00_2898;
																																																										{	/* Eval/evaluate.scm 129 */
																																																											obj_t
																																																												BgL__ortest_1067z00_2901;
																																																											BgL__ortest_1067z00_2901
																																																												=
																																																												BGl_getzd2sourcezd2locationz00zz__readerz00
																																																												(BgL_gez00_920);
																																																											if (CBOOL(BgL__ortest_1067z00_2901))
																																																												{	/* Eval/evaluate.scm 129 */
																																																													BgL_arg2097z00_2898
																																																														=
																																																														BgL__ortest_1067z00_2901;
																																																												}
																																																											else
																																																												{	/* Eval/evaluate.scm 129 */
																																																													BgL_arg2097z00_2898
																																																														=
																																																														BgL_locz00_54;
																																																												}
																																																										}
																																																										BgL_auxz00_5410
																																																											=
																																																											(
																																																											(BgL_ev_exprz00_bglt)
																																																											BGl_convz00zz__evaluatez00
																																																											(BgL_gez00_920,
																																																												BgL_localsz00_50,
																																																												BgL_globalsz00_51,
																																																												BFALSE,
																																																												BgL_wherez00_53,
																																																												BgL_arg2097z00_2898,
																																																												((bool_t) 0)));
																																																									}
																																																									((((BgL_ev_hookz00_bglt) CREF(((BgL_ev_hookz00_bglt) BgL_new1144z00_1837)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5410), BUNSPEC);
																																																								}
																																																								((((BgL_ev_setglobalz00_bglt) CREF(((BgL_ev_setglobalz00_bglt) BgL_new1144z00_1837)))->BgL_locz00) = ((obj_t) BgL_locz00_54), BUNSPEC);
																																																								{
																																																									obj_t
																																																										BgL_auxz00_5420;
																																																									{	/* Eval/evaluate.scm 455 */
																																																										obj_t
																																																											BgL_arg2077z00_1838;
																																																										BgL_arg2077z00_1838
																																																											=
																																																											BGl_untypezd2identzd2zz__evaluatez00
																																																											(BgL_gvz00_919);
																																																										BgL_auxz00_5420
																																																											=
																																																											CAR
																																																											(BgL_arg2077z00_1838);
																																																									}
																																																									((((BgL_ev_setglobalz00_bglt) CREF(((BgL_ev_setglobalz00_bglt) BgL_new1144z00_1837)))->BgL_namez00) = ((obj_t) BgL_auxz00_5420), BUNSPEC);
																																																								}
																																																								{
																																																									obj_t
																																																										BgL_auxz00_5425;
																																																									if (BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_51))
																																																										{	/* Eval/evaluate.scm 456 */
																																																											BgL_auxz00_5425
																																																												=
																																																												BgL_globalsz00_51;
																																																										}
																																																									else
																																																										{	/* Eval/evaluate.scm 456 */
																																																											BgL_auxz00_5425
																																																												=
																																																												BGL_MODULE
																																																												();
																																																										}
																																																									((((BgL_ev_setglobalz00_bglt) CREF(((BgL_ev_setglobalz00_bglt) BgL_new1144z00_1837)))->BgL_modz00) = ((obj_t) BgL_auxz00_5425), BUNSPEC);
																																																								}
																																																								BgL_auxz00_5402
																																																									=
																																																									BgL_new1144z00_1837;
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_5402);
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 319 */
																																																						obj_t
																																																							BgL_arg1603z00_1190;
																																																						obj_t
																																																							BgL_arg1604z00_1191;
																																																						BgL_arg1603z00_1190
																																																							=
																																																							CAR
																																																							(BgL_ez00_49);
																																																						BgL_arg1604z00_1191
																																																							=
																																																							CDR
																																																							(BgL_ez00_49);
																																																						{
																																																							BgL_ev_appz00_bglt
																																																								BgL_auxz00_5434;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_5436;
																																																								obj_t
																																																									BgL_fz00_5435;
																																																								BgL_fz00_5435
																																																									=
																																																									BgL_arg1603z00_1190;
																																																								BgL_argsz00_5436
																																																									=
																																																									BgL_arg1604z00_1191;
																																																								BgL_argsz00_942
																																																									=
																																																									BgL_argsz00_5436;
																																																								BgL_fz00_941
																																																									=
																																																									BgL_fz00_5435;
																																																								goto
																																																									BgL_tagzd2157zd2_943;
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_5434);
																																																						}
																																																					}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 319 */
																																																		obj_t
																																																			BgL_cdrzd27739zd2_1195;
																																																		BgL_cdrzd27739zd2_1195
																																																			=
																																																			CDR
																																																			(BgL_cdrzd27534zd2_1165);
																																																		if (NULLP(CDR(BgL_cdrzd27739zd2_1195)))
																																																			{	/* Eval/evaluate.scm 319 */
																																																				obj_t
																																																					BgL_arg1609z00_1197;
																																																				obj_t
																																																					BgL_arg1610z00_1198;
																																																				BgL_arg1609z00_1197
																																																					=
																																																					CAR
																																																					(BgL_cdrzd27534zd2_1165);
																																																				BgL_arg1610z00_1198
																																																					=
																																																					CAR
																																																					(BgL_cdrzd27739zd2_1195);
																																																				{
																																																					BgL_ev_defglobalz00_bglt
																																																						BgL_auxz00_5444;
																																																					{
																																																						obj_t
																																																							BgL_gez00_5446;
																																																						obj_t
																																																							BgL_gvz00_5445;
																																																						BgL_gvz00_5445
																																																							=
																																																							BgL_arg1609z00_1197;
																																																						BgL_gez00_5446
																																																							=
																																																							BgL_arg1610z00_1198;
																																																						BgL_gez00_920
																																																							=
																																																							BgL_gez00_5446;
																																																						BgL_gvz00_919
																																																							=
																																																							BgL_gvz00_5445;
																																																						goto
																																																							BgL_tagzd2150zd2_921;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_5444);
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 319 */
																																																				obj_t
																																																					BgL_arg1611z00_1199;
																																																				obj_t
																																																					BgL_arg1612z00_1200;
																																																				BgL_arg1611z00_1199
																																																					=
																																																					CAR
																																																					(BgL_ez00_49);
																																																				BgL_arg1612z00_1200
																																																					=
																																																					CDR
																																																					(BgL_ez00_49);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_5450;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_5452;
																																																						obj_t
																																																							BgL_fz00_5451;
																																																						BgL_fz00_5451
																																																							=
																																																							BgL_arg1611z00_1199;
																																																						BgL_argsz00_5452
																																																							=
																																																							BgL_arg1612z00_1200;
																																																						BgL_argsz00_942
																																																							=
																																																							BgL_argsz00_5452;
																																																						BgL_fz00_941
																																																							=
																																																							BgL_fz00_5451;
																																																						goto
																																																							BgL_tagzd2157zd2_943;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_5450);
																																																				}
																																																			}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 319 */
																																																obj_t
																																																	BgL_cdrzd27826zd2_1203;
																																																BgL_cdrzd27826zd2_1203
																																																	=
																																																	CDR
																																																	(BgL_cdrzd27534zd2_1165);
																																																if (NULLP(CDR(BgL_cdrzd27826zd2_1203)))
																																																	{	/* Eval/evaluate.scm 319 */
																																																		obj_t
																																																			BgL_arg1615z00_1205;
																																																		obj_t
																																																			BgL_arg1616z00_1206;
																																																		BgL_arg1615z00_1205
																																																			=
																																																			CAR
																																																			(BgL_cdrzd27534zd2_1165);
																																																		BgL_arg1616z00_1206
																																																			=
																																																			CAR
																																																			(BgL_cdrzd27826zd2_1203);
																																																		{
																																																			BgL_ev_defglobalz00_bglt
																																																				BgL_auxz00_5460;
																																																			{
																																																				obj_t
																																																					BgL_gez00_5462;
																																																				obj_t
																																																					BgL_gvz00_5461;
																																																				BgL_gvz00_5461
																																																					=
																																																					BgL_arg1615z00_1205;
																																																				BgL_gez00_5462
																																																					=
																																																					BgL_arg1616z00_1206;
																																																				BgL_gez00_920
																																																					=
																																																					BgL_gez00_5462;
																																																				BgL_gvz00_919
																																																					=
																																																					BgL_gvz00_5461;
																																																				goto
																																																					BgL_tagzd2150zd2_921;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_5460);
																																																		}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 319 */
																																																		obj_t
																																																			BgL_arg1617z00_1207;
																																																		obj_t
																																																			BgL_arg1619z00_1208;
																																																		BgL_arg1617z00_1207
																																																			=
																																																			CAR
																																																			(BgL_ez00_49);
																																																		BgL_arg1619z00_1208
																																																			=
																																																			CDR
																																																			(BgL_ez00_49);
																																																		{
																																																			BgL_ev_appz00_bglt
																																																				BgL_auxz00_5466;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_5468;
																																																				obj_t
																																																					BgL_fz00_5467;
																																																				BgL_fz00_5467
																																																					=
																																																					BgL_arg1617z00_1207;
																																																				BgL_argsz00_5468
																																																					=
																																																					BgL_arg1619z00_1208;
																																																				BgL_argsz00_942
																																																					=
																																																					BgL_argsz00_5468;
																																																				BgL_fz00_941
																																																					=
																																																					BgL_fz00_5467;
																																																				goto
																																																					BgL_tagzd2157zd2_943;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_5466);
																																																		}
																																																	}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 319 */
																																														obj_t
																																															BgL_cdrzd27913zd2_1211;
																																														BgL_cdrzd27913zd2_1211
																																															=
																																															CDR
																																															(BgL_cdrzd27534zd2_1165);
																																														if (NULLP(CDR(BgL_cdrzd27913zd2_1211)))
																																															{	/* Eval/evaluate.scm 319 */
																																																obj_t
																																																	BgL_arg1622z00_1213;
																																																obj_t
																																																	BgL_arg1623z00_1214;
																																																BgL_arg1622z00_1213
																																																	=
																																																	CAR
																																																	(BgL_cdrzd27534zd2_1165);
																																																BgL_arg1623z00_1214
																																																	=
																																																	CAR
																																																	(BgL_cdrzd27913zd2_1211);
																																																{
																																																	BgL_ev_defglobalz00_bglt
																																																		BgL_auxz00_5476;
																																																	{
																																																		obj_t
																																																			BgL_gez00_5478;
																																																		obj_t
																																																			BgL_gvz00_5477;
																																																		BgL_gvz00_5477
																																																			=
																																																			BgL_arg1622z00_1213;
																																																		BgL_gez00_5478
																																																			=
																																																			BgL_arg1623z00_1214;
																																																		BgL_gez00_920
																																																			=
																																																			BgL_gez00_5478;
																																																		BgL_gvz00_919
																																																			=
																																																			BgL_gvz00_5477;
																																																		goto
																																																			BgL_tagzd2150zd2_921;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_5476);
																																																}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 319 */
																																																obj_t
																																																	BgL_arg1624z00_1215;
																																																obj_t
																																																	BgL_arg1625z00_1216;
																																																BgL_arg1624z00_1215
																																																	=
																																																	CAR
																																																	(BgL_ez00_49);
																																																BgL_arg1625z00_1216
																																																	=
																																																	CDR
																																																	(BgL_ez00_49);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_5482;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_5484;
																																																		obj_t
																																																			BgL_fz00_5483;
																																																		BgL_fz00_5483
																																																			=
																																																			BgL_arg1624z00_1215;
																																																		BgL_argsz00_5484
																																																			=
																																																			BgL_arg1625z00_1216;
																																																		BgL_argsz00_942
																																																			=
																																																			BgL_argsz00_5484;
																																																		BgL_fz00_941
																																																			=
																																																			BgL_fz00_5483;
																																																		goto
																																																			BgL_tagzd2157zd2_943;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_5482);
																																																}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 319 */
																																												obj_t
																																													BgL_cdrzd28000zd2_1220;
																																												BgL_cdrzd28000zd2_1220
																																													=
																																													CDR
																																													(BgL_cdrzd27534zd2_1165);
																																												if (NULLP(CDR(BgL_cdrzd28000zd2_1220)))
																																													{	/* Eval/evaluate.scm 319 */
																																														obj_t
																																															BgL_arg1629z00_1222;
																																														obj_t
																																															BgL_arg1630z00_1223;
																																														BgL_arg1629z00_1222
																																															=
																																															CAR
																																															(BgL_cdrzd27534zd2_1165);
																																														BgL_arg1630z00_1223
																																															=
																																															CAR
																																															(BgL_cdrzd28000zd2_1220);
																																														{
																																															BgL_ev_defglobalz00_bglt
																																																BgL_auxz00_5492;
																																															{
																																																obj_t
																																																	BgL_gez00_5494;
																																																obj_t
																																																	BgL_gvz00_5493;
																																																BgL_gvz00_5493
																																																	=
																																																	BgL_arg1629z00_1222;
																																																BgL_gez00_5494
																																																	=
																																																	BgL_arg1630z00_1223;
																																																BgL_gez00_920
																																																	=
																																																	BgL_gez00_5494;
																																																BgL_gvz00_919
																																																	=
																																																	BgL_gvz00_5493;
																																																goto
																																																	BgL_tagzd2150zd2_921;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_5492);
																																														}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 319 */
																																														obj_t
																																															BgL_arg1631z00_1224;
																																														obj_t
																																															BgL_arg1632z00_1225;
																																														BgL_arg1631z00_1224
																																															=
																																															CAR
																																															(BgL_ez00_49);
																																														BgL_arg1632z00_1225
																																															=
																																															CDR
																																															(BgL_ez00_49);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_5498;
																																															{
																																																obj_t
																																																	BgL_argsz00_5500;
																																																obj_t
																																																	BgL_fz00_5499;
																																																BgL_fz00_5499
																																																	=
																																																	BgL_arg1631z00_1224;
																																																BgL_argsz00_5500
																																																	=
																																																	BgL_arg1632z00_1225;
																																																BgL_argsz00_942
																																																	=
																																																	BgL_argsz00_5500;
																																																BgL_fz00_941
																																																	=
																																																	BgL_fz00_5499;
																																																goto
																																																	BgL_tagzd2157zd2_943;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_5498);
																																														}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 319 */
																																										obj_t
																																											BgL_arg1634z00_1227;
																																										BgL_arg1634z00_1227
																																											=
																																											CAR
																																											(BgL_ez00_49);
																																										{
																																											BgL_ev_appz00_bglt
																																												BgL_auxz00_5503;
																																											{
																																												obj_t
																																													BgL_argsz00_5505;
																																												obj_t
																																													BgL_fz00_5504;
																																												BgL_fz00_5504
																																													=
																																													BgL_arg1634z00_1227;
																																												BgL_argsz00_5505
																																													=
																																													BgL_cdrzd27534zd2_1165;
																																												BgL_argsz00_942
																																													=
																																													BgL_argsz00_5505;
																																												BgL_fz00_941
																																													=
																																													BgL_fz00_5504;
																																												goto
																																													BgL_tagzd2157zd2_943;
																																											}
																																											return
																																												(
																																												(obj_t)
																																												BgL_auxz00_5503);
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 319 */
																																								obj_t
																																									BgL_arg1636z00_1229;
																																								BgL_arg1636z00_1229
																																									=
																																									CAR
																																									(BgL_ez00_49);
																																								{
																																									BgL_ev_appz00_bglt
																																										BgL_auxz00_5508;
																																									{
																																										obj_t
																																											BgL_argsz00_5510;
																																										obj_t
																																											BgL_fz00_5509;
																																										BgL_fz00_5509
																																											=
																																											BgL_arg1636z00_1229;
																																										BgL_argsz00_5510
																																											=
																																											BgL_cdrzd27534zd2_1165;
																																										BgL_argsz00_942
																																											=
																																											BgL_argsz00_5510;
																																										BgL_fz00_941
																																											=
																																											BgL_fz00_5509;
																																										goto
																																											BgL_tagzd2157zd2_943;
																																									}
																																									return
																																										(
																																										(obj_t)
																																										BgL_auxz00_5508);
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 319 */
																																						if (
																																							(CAR
																																								(BgL_ez00_49)
																																								==
																																								BGl_symbol2683z00zz__evaluatez00))
																																							{	/* Eval/evaluate.scm 319 */
																																								if (PAIRP(BgL_cdrzd27534zd2_1165))
																																									{	/* Eval/evaluate.scm 319 */
																																										obj_t
																																											BgL_carzd28242zd2_1234;
																																										BgL_carzd28242zd2_1234
																																											=
																																											CAR
																																											(BgL_cdrzd27534zd2_1165);
																																										if (PAIRP(BgL_carzd28242zd2_1234))
																																											{	/* Eval/evaluate.scm 319 */
																																												if (NULLP(CDR(BgL_carzd28242zd2_1234)))
																																													{	/* Eval/evaluate.scm 319 */
																																														obj_t
																																															BgL_arg1642z00_1237;
																																														obj_t
																																															BgL_arg1643z00_1238;
																																														BgL_arg1642z00_1237
																																															=
																																															CAR
																																															(BgL_carzd28242zd2_1234);
																																														BgL_arg1643z00_1238
																																															=
																																															CDR
																																															(BgL_cdrzd27534zd2_1165);
																																														{
																																															BgL_ev_bindzd2exitzd2_bglt
																																																BgL_auxz00_5525;
																																															BgL_vz00_922
																																																=
																																																BgL_arg1642z00_1237;
																																															BgL_bodyz00_923
																																																=
																																																BgL_arg1643z00_1238;
																																														BgL_tagzd2151zd2_924:
																																															{	/* Eval/evaluate.scm 459 */
																																																BgL_ev_varz00_bglt
																																																	BgL_varz00_1842;
																																																{	/* Eval/evaluate.scm 459 */
																																																	BgL_ev_varz00_bglt
																																																		BgL_new1146z00_1847;
																																																	{	/* Eval/evaluate.scm 459 */
																																																		BgL_ev_varz00_bglt
																																																			BgL_new1145z00_1848;
																																																		BgL_new1145z00_1848
																																																			=
																																																			(
																																																			(BgL_ev_varz00_bglt)
																																																			BREF
																																																			(GC_MALLOC
																																																				(sizeof
																																																					(struct
																																																						BgL_ev_varz00_bgl))));
																																																		{	/* Eval/evaluate.scm 459 */
																																																			long
																																																				BgL_arg2082z00_1849;
																																																			{	/* Eval/evaluate.scm 459 */
																																																				long
																																																					BgL_res2445z00_2906;
																																																				BgL_res2445z00_2906
																																																					=
																																																					BGL_CLASS_INDEX
																																																					(BGl_ev_varz00zz__evaluate_typesz00);
																																																				BgL_arg2082z00_1849
																																																					=
																																																					BgL_res2445z00_2906;
																																																			}
																																																			{	/* Eval/evaluate.scm 459 */
																																																				BgL_objectz00_bglt
																																																					BgL_objz00_2907;
																																																				BgL_objz00_2907
																																																					=
																																																					(
																																																					(BgL_objectz00_bglt)
																																																					BgL_new1145z00_1848);
																																																				BGL_OBJECT_CLASS_NUM_SET
																																																					(BgL_objz00_2907,
																																																					BgL_arg2082z00_1849);
																																																		}}
																																																		{	/* Eval/evaluate.scm 459 */
																																																			BgL_objectz00_bglt
																																																				BgL_auxz00_5530;
																																																			BgL_auxz00_5530
																																																				=
																																																				(
																																																				(BgL_objectz00_bglt)
																																																				BgL_new1145z00_1848);
																																																			BGL_OBJECT_WIDENING_SET
																																																				(BgL_auxz00_5530,
																																																				BFALSE);
																																																		}
																																																		BgL_new1146z00_1847
																																																			=
																																																			BgL_new1145z00_1848;
																																																	}
																																																	((((BgL_ev_varz00_bglt) CREF(BgL_new1146z00_1847))->BgL_namez00) = ((obj_t) BgL_vz00_922), BUNSPEC);
																																																	((((BgL_ev_varz00_bglt) CREF(BgL_new1146z00_1847))->BgL_effz00) = ((obj_t) BFALSE), BUNSPEC);
																																																	((((BgL_ev_varz00_bglt) CREF(BgL_new1146z00_1847))->BgL_typez00) = ((obj_t) BFALSE), BUNSPEC);
																																																	BgL_varz00_1842
																																																		=
																																																		BgL_new1146z00_1847;
																																																}
																																																{	/* Eval/evaluate.scm 460 */
																																																	BgL_ev_bindzd2exitzd2_bglt
																																																		BgL_new1148z00_1843;
																																																	{	/* Eval/evaluate.scm 460 */
																																																		BgL_ev_bindzd2exitzd2_bglt
																																																			BgL_new1147z00_1845;
																																																		BgL_new1147z00_1845
																																																			=
																																																			(
																																																			(BgL_ev_bindzd2exitzd2_bglt)
																																																			BREF
																																																			(GC_MALLOC
																																																				(sizeof
																																																					(struct
																																																						BgL_ev_bindzd2exitzd2_bgl))));
																																																		{	/* Eval/evaluate.scm 460 */
																																																			long
																																																				BgL_arg2081z00_1846;
																																																			{	/* Eval/evaluate.scm 460 */
																																																				long
																																																					BgL_res2446z00_2910;
																																																				BgL_res2446z00_2910
																																																					=
																																																					BGL_CLASS_INDEX
																																																					(BGl_ev_bindzd2exitzd2zz__evaluate_typesz00);
																																																				BgL_arg2081z00_1846
																																																					=
																																																					BgL_res2446z00_2910;
																																																			}
																																																			{	/* Eval/evaluate.scm 460 */
																																																				BgL_objectz00_bglt
																																																					BgL_objz00_2911;
																																																				BgL_objz00_2911
																																																					=
																																																					(
																																																					(BgL_objectz00_bglt)
																																																					BgL_new1147z00_1845);
																																																				BGL_OBJECT_CLASS_NUM_SET
																																																					(BgL_objz00_2911,
																																																					BgL_arg2081z00_1846);
																																																		}}
																																																		{	/* Eval/evaluate.scm 460 */
																																																			BgL_objectz00_bglt
																																																				BgL_auxz00_5540;
																																																			BgL_auxz00_5540
																																																				=
																																																				(
																																																				(BgL_objectz00_bglt)
																																																				BgL_new1147z00_1845);
																																																			BGL_OBJECT_WIDENING_SET
																																																				(BgL_auxz00_5540,
																																																				BFALSE);
																																																		}
																																																		BgL_new1148z00_1843
																																																			=
																																																			BgL_new1147z00_1845;
																																																	}
																																																	((((BgL_ev_bindzd2exitzd2_bglt) CREF(BgL_new1148z00_1843))->BgL_varz00) = ((BgL_ev_varz00_bglt) BgL_varz00_1842), BUNSPEC);
																																																	{
																																																		BgL_ev_exprz00_bglt
																																																			BgL_auxz00_5544;
																																																		{	/* Eval/evaluate.scm 462 */
																																																			obj_t
																																																				BgL_arg2080z00_1844;
																																																			BgL_arg2080z00_1844
																																																				=
																																																				MAKE_PAIR
																																																				(
																																																				((obj_t) BgL_varz00_1842), BgL_localsz00_50);
																																																			BgL_auxz00_5544
																																																				=
																																																				(
																																																				(BgL_ev_exprz00_bglt)
																																																				BGl_convzd2beginzd2zz__evaluatez00
																																																				(BgL_bodyz00_923,
																																																					BgL_arg2080z00_1844,
																																																					BgL_globalsz00_51,
																																																					BFALSE,
																																																					BgL_wherez00_53,
																																																					BgL_locz00_54,
																																																					((bool_t) 0)));
																																																		}
																																																		((((BgL_ev_bindzd2exitzd2_bglt) CREF(BgL_new1148z00_1843))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5544), BUNSPEC);
																																																	}
																																																	BgL_auxz00_5525
																																																		=
																																																		BgL_new1148z00_1843;
																																															}}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_5525);
																																														}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 319 */
																																														obj_t
																																															BgL_arg1644z00_1239;
																																														obj_t
																																															BgL_arg1645z00_1240;
																																														BgL_arg1644z00_1239
																																															=
																																															CAR
																																															(BgL_ez00_49);
																																														BgL_arg1645z00_1240
																																															=
																																															CDR
																																															(BgL_ez00_49);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_5553;
																																															{
																																																obj_t
																																																	BgL_argsz00_5555;
																																																obj_t
																																																	BgL_fz00_5554;
																																																BgL_fz00_5554
																																																	=
																																																	BgL_arg1644z00_1239;
																																																BgL_argsz00_5555
																																																	=
																																																	BgL_arg1645z00_1240;
																																																BgL_argsz00_942
																																																	=
																																																	BgL_argsz00_5555;
																																																BgL_fz00_941
																																																	=
																																																	BgL_fz00_5554;
																																																goto
																																																	BgL_tagzd2157zd2_943;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_5553);
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 319 */
																																												obj_t
																																													BgL_arg1648z00_1242;
																																												obj_t
																																													BgL_arg1649z00_1243;
																																												BgL_arg1648z00_1242
																																													=
																																													CAR
																																													(BgL_ez00_49);
																																												BgL_arg1649z00_1243
																																													=
																																													CDR
																																													(BgL_ez00_49);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_5559;
																																													{
																																														obj_t
																																															BgL_argsz00_5561;
																																														obj_t
																																															BgL_fz00_5560;
																																														BgL_fz00_5560
																																															=
																																															BgL_arg1648z00_1242;
																																														BgL_argsz00_5561
																																															=
																																															BgL_arg1649z00_1243;
																																														BgL_argsz00_942
																																															=
																																															BgL_argsz00_5561;
																																														BgL_fz00_941
																																															=
																																															BgL_fz00_5560;
																																														goto
																																															BgL_tagzd2157zd2_943;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_5559);
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 319 */
																																										obj_t
																																											BgL_arg1650z00_1244;
																																										obj_t
																																											BgL_arg1651z00_1245;
																																										BgL_arg1650z00_1244
																																											=
																																											CAR
																																											(BgL_ez00_49);
																																										BgL_arg1651z00_1245
																																											=
																																											CDR
																																											(BgL_ez00_49);
																																										{
																																											BgL_ev_appz00_bglt
																																												BgL_auxz00_5565;
																																											{
																																												obj_t
																																													BgL_argsz00_5567;
																																												obj_t
																																													BgL_fz00_5566;
																																												BgL_fz00_5566
																																													=
																																													BgL_arg1650z00_1244;
																																												BgL_argsz00_5567
																																													=
																																													BgL_arg1651z00_1245;
																																												BgL_argsz00_942
																																													=
																																													BgL_argsz00_5567;
																																												BgL_fz00_941
																																													=
																																													BgL_fz00_5566;
																																												goto
																																													BgL_tagzd2157zd2_943;
																																											}
																																											return
																																												(
																																												(obj_t)
																																												BgL_auxz00_5565);
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 319 */
																																								obj_t
																																									BgL_cdrzd28407zd2_1246;
																																								BgL_cdrzd28407zd2_1246
																																									=
																																									CDR
																																									(BgL_ez00_49);
																																								if ((CAR(BgL_ez00_49) == BGl_symbol2685z00zz__evaluatez00))
																																									{	/* Eval/evaluate.scm 319 */
																																										if (PAIRP(BgL_cdrzd28407zd2_1246))
																																											{	/* Eval/evaluate.scm 319 */
																																												obj_t
																																													BgL_arg1654z00_1249;
																																												obj_t
																																													BgL_arg1655z00_1250;
																																												BgL_arg1654z00_1249
																																													=
																																													CAR
																																													(BgL_cdrzd28407zd2_1246);
																																												BgL_arg1655z00_1250
																																													=
																																													CDR
																																													(BgL_cdrzd28407zd2_1246);
																																												{
																																													BgL_ev_unwindzd2protectzd2_bglt
																																														BgL_auxz00_5577;
																																													BgL_ez00_925
																																														=
																																														BgL_arg1654z00_1249;
																																													BgL_bodyz00_926
																																														=
																																														BgL_arg1655z00_1250;
																																												BgL_tagzd2152zd2_927:
																																													{	/* Eval/evaluate.scm 464 */
																																														BgL_ev_unwindzd2protectzd2_bglt
																																															BgL_new1150z00_1850;
																																														{	/* Eval/evaluate.scm 464 */
																																															BgL_ev_unwindzd2protectzd2_bglt
																																																BgL_new1149z00_1851;
																																															BgL_new1149z00_1851
																																																=
																																																(
																																																(BgL_ev_unwindzd2protectzd2_bglt)
																																																BREF
																																																(GC_MALLOC
																																																	(sizeof
																																																		(struct
																																																			BgL_ev_unwindzd2protectzd2_bgl))));
																																															{	/* Eval/evaluate.scm 464 */
																																																long
																																																	BgL_arg2083z00_1852;
																																																{	/* Eval/evaluate.scm 464 */
																																																	long
																																																		BgL_res2447z00_2914;
																																																	BgL_res2447z00_2914
																																																		=
																																																		BGL_CLASS_INDEX
																																																		(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00);
																																																	BgL_arg2083z00_1852
																																																		=
																																																		BgL_res2447z00_2914;
																																																}
																																																{	/* Eval/evaluate.scm 464 */
																																																	BgL_objectz00_bglt
																																																		BgL_objz00_2915;
																																																	BgL_objz00_2915
																																																		=
																																																		(
																																																		(BgL_objectz00_bglt)
																																																		BgL_new1149z00_1851);
																																																	BGL_OBJECT_CLASS_NUM_SET
																																																		(BgL_objz00_2915,
																																																		BgL_arg2083z00_1852);
																																															}}
																																															{	/* Eval/evaluate.scm 464 */
																																																BgL_objectz00_bglt
																																																	BgL_auxz00_5582;
																																																BgL_auxz00_5582
																																																	=
																																																	(
																																																	(BgL_objectz00_bglt)
																																																	BgL_new1149z00_1851);
																																																BGL_OBJECT_WIDENING_SET
																																																	(BgL_auxz00_5582,
																																																	BFALSE);
																																															}
																																															BgL_new1150z00_1850
																																																=
																																																BgL_new1149z00_1851;
																																														}
																																														{
																																															BgL_ev_exprz00_bglt
																																																BgL_auxz00_5585;
																																															{	/* Eval/evaluate.scm 280 */
																																																obj_t
																																																	BgL_arg2097z00_2918;
																																																{	/* Eval/evaluate.scm 129 */
																																																	obj_t
																																																		BgL__ortest_1067z00_2921;
																																																	BgL__ortest_1067z00_2921
																																																		=
																																																		BGl_getzd2sourcezd2locationz00zz__readerz00
																																																		(BgL_ez00_925);
																																																	if (CBOOL(BgL__ortest_1067z00_2921))
																																																		{	/* Eval/evaluate.scm 129 */
																																																			BgL_arg2097z00_2918
																																																				=
																																																				BgL__ortest_1067z00_2921;
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 129 */
																																																			BgL_arg2097z00_2918
																																																				=
																																																				BgL_locz00_54;
																																																		}
																																																}
																																																BgL_auxz00_5585
																																																	=
																																																	(
																																																	(BgL_ev_exprz00_bglt)
																																																	BGl_convz00zz__evaluatez00
																																																	(BgL_ez00_925,
																																																		BgL_localsz00_50,
																																																		BgL_globalsz00_51,
																																																		BFALSE,
																																																		BgL_wherez00_53,
																																																		BgL_arg2097z00_2918,
																																																		((bool_t) 0)));
																																															}
																																															((((BgL_ev_unwindzd2protectzd2_bglt) CREF(BgL_new1150z00_1850))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5585), BUNSPEC);
																																														}
																																														((((BgL_ev_unwindzd2protectzd2_bglt) CREF(BgL_new1150z00_1850))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_bodyz00_926, BgL_localsz00_50, BgL_globalsz00_51, BFALSE, BgL_wherez00_53, BgL_locz00_54, ((bool_t) 0)))), BUNSPEC);
																																														BgL_auxz00_5577
																																															=
																																															BgL_new1150z00_1850;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_5577);
																																												}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 319 */
																																												obj_t
																																													BgL_arg1656z00_1251;
																																												BgL_arg1656z00_1251
																																													=
																																													CAR
																																													(BgL_ez00_49);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_5597;
																																													{
																																														obj_t
																																															BgL_argsz00_5599;
																																														obj_t
																																															BgL_fz00_5598;
																																														BgL_fz00_5598
																																															=
																																															BgL_arg1656z00_1251;
																																														BgL_argsz00_5599
																																															=
																																															BgL_cdrzd28407zd2_1246;
																																														BgL_argsz00_942
																																															=
																																															BgL_argsz00_5599;
																																														BgL_fz00_941
																																															=
																																															BgL_fz00_5598;
																																														goto
																																															BgL_tagzd2157zd2_943;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_5597);
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 319 */
																																										if ((CAR(BgL_ez00_49) == BGl_symbol2687z00zz__evaluatez00))
																																											{	/* Eval/evaluate.scm 319 */
																																												if (PAIRP(BgL_cdrzd28407zd2_1246))
																																													{	/* Eval/evaluate.scm 319 */
																																														obj_t
																																															BgL_arg1660z00_1256;
																																														obj_t
																																															BgL_arg1661z00_1257;
																																														BgL_arg1660z00_1256
																																															=
																																															CAR
																																															(BgL_cdrzd28407zd2_1246);
																																														BgL_arg1661z00_1257
																																															=
																																															CDR
																																															(BgL_cdrzd28407zd2_1246);
																																														{
																																															BgL_ev_withzd2handlerzd2_bglt
																																																BgL_auxz00_5608;
																																															BgL_hz00_928
																																																=
																																																BgL_arg1660z00_1256;
																																															BgL_bodyz00_929
																																																=
																																																BgL_arg1661z00_1257;
																																														BgL_tagzd2153zd2_930:
																																															{	/* Eval/evaluate.scm 468 */
																																																BgL_ev_withzd2handlerzd2_bglt
																																																	BgL_new1152z00_1853;
																																																{	/* Eval/evaluate.scm 468 */
																																																	BgL_ev_withzd2handlerzd2_bglt
																																																		BgL_new1151z00_1854;
																																																	BgL_new1151z00_1854
																																																		=
																																																		(
																																																		(BgL_ev_withzd2handlerzd2_bglt)
																																																		BREF
																																																		(GC_MALLOC
																																																			(sizeof
																																																				(struct
																																																					BgL_ev_withzd2handlerzd2_bgl))));
																																																	{	/* Eval/evaluate.scm 468 */
																																																		long
																																																			BgL_arg2084z00_1855;
																																																		{	/* Eval/evaluate.scm 468 */
																																																			long
																																																				BgL_res2448z00_2925;
																																																			BgL_res2448z00_2925
																																																				=
																																																				BGL_CLASS_INDEX
																																																				(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00);
																																																			BgL_arg2084z00_1855
																																																				=
																																																				BgL_res2448z00_2925;
																																																		}
																																																		{	/* Eval/evaluate.scm 468 */
																																																			BgL_objectz00_bglt
																																																				BgL_objz00_2926;
																																																			BgL_objz00_2926
																																																				=
																																																				(
																																																				(BgL_objectz00_bglt)
																																																				BgL_new1151z00_1854);
																																																			BGL_OBJECT_CLASS_NUM_SET
																																																				(BgL_objz00_2926,
																																																				BgL_arg2084z00_1855);
																																																	}}
																																																	{	/* Eval/evaluate.scm 468 */
																																																		BgL_objectz00_bglt
																																																			BgL_auxz00_5613;
																																																		BgL_auxz00_5613
																																																			=
																																																			(
																																																			(BgL_objectz00_bglt)
																																																			BgL_new1151z00_1854);
																																																		BGL_OBJECT_WIDENING_SET
																																																			(BgL_auxz00_5613,
																																																			BFALSE);
																																																	}
																																																	BgL_new1152z00_1853
																																																		=
																																																		BgL_new1151z00_1854;
																																																}
																																																{
																																																	BgL_ev_exprz00_bglt
																																																		BgL_auxz00_5616;
																																																	{	/* Eval/evaluate.scm 280 */
																																																		obj_t
																																																			BgL_arg2097z00_2929;
																																																		{	/* Eval/evaluate.scm 129 */
																																																			obj_t
																																																				BgL__ortest_1067z00_2932;
																																																			BgL__ortest_1067z00_2932
																																																				=
																																																				BGl_getzd2sourcezd2locationz00zz__readerz00
																																																				(BgL_hz00_928);
																																																			if (CBOOL(BgL__ortest_1067z00_2932))
																																																				{	/* Eval/evaluate.scm 129 */
																																																					BgL_arg2097z00_2929
																																																						=
																																																						BgL__ortest_1067z00_2932;
																																																				}
																																																			else
																																																				{	/* Eval/evaluate.scm 129 */
																																																					BgL_arg2097z00_2929
																																																						=
																																																						BgL_locz00_54;
																																																				}
																																																		}
																																																		BgL_auxz00_5616
																																																			=
																																																			(
																																																			(BgL_ev_exprz00_bglt)
																																																			BGl_convz00zz__evaluatez00
																																																			(BgL_hz00_928,
																																																				BgL_localsz00_50,
																																																				BgL_globalsz00_51,
																																																				BFALSE,
																																																				BgL_wherez00_53,
																																																				BgL_arg2097z00_2929,
																																																				((bool_t) 0)));
																																																	}
																																																	((((BgL_ev_withzd2handlerzd2_bglt) CREF(BgL_new1152z00_1853))->BgL_handlerz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5616), BUNSPEC);
																																																}
																																																((((BgL_ev_withzd2handlerzd2_bglt) CREF(BgL_new1152z00_1853))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_bodyz00_929, BgL_localsz00_50, BgL_globalsz00_51, BFALSE, BgL_wherez00_53, BgL_locz00_54, ((bool_t) 0)))), BUNSPEC);
																																																BgL_auxz00_5608
																																																	=
																																																	BgL_new1152z00_1853;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_5608);
																																														}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 319 */
																																														obj_t
																																															BgL_arg1664z00_1258;
																																														obj_t
																																															BgL_arg1665z00_1259;
																																														BgL_arg1664z00_1258
																																															=
																																															CAR
																																															(BgL_ez00_49);
																																														BgL_arg1665z00_1259
																																															=
																																															CDR
																																															(BgL_ez00_49);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_5629;
																																															{
																																																obj_t
																																																	BgL_argsz00_5631;
																																																obj_t
																																																	BgL_fz00_5630;
																																																BgL_fz00_5630
																																																	=
																																																	BgL_arg1664z00_1258;
																																																BgL_argsz00_5631
																																																	=
																																																	BgL_arg1665z00_1259;
																																																BgL_argsz00_942
																																																	=
																																																	BgL_argsz00_5631;
																																																BgL_fz00_941
																																																	=
																																																	BgL_fz00_5630;
																																																goto
																																																	BgL_tagzd2157zd2_943;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_5629);
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 319 */
																																												obj_t
																																													BgL_cdrzd28510zd2_1260;
																																												BgL_cdrzd28510zd2_1260
																																													=
																																													CDR
																																													(BgL_ez00_49);
																																												if ((CAR(BgL_ez00_49) == BGl_symbol2689z00zz__evaluatez00))
																																													{	/* Eval/evaluate.scm 319 */
																																														if (PAIRP(BgL_cdrzd28510zd2_1260))
																																															{	/* Eval/evaluate.scm 319 */
																																																obj_t
																																																	BgL_cdrzd28515zd2_1263;
																																																BgL_cdrzd28515zd2_1263
																																																	=
																																																	CDR
																																																	(BgL_cdrzd28510zd2_1260);
																																																if (PAIRP(BgL_cdrzd28515zd2_1263))
																																																	{	/* Eval/evaluate.scm 319 */
																																																		obj_t
																																																			BgL_cdrzd28520zd2_1265;
																																																		BgL_cdrzd28520zd2_1265
																																																			=
																																																			CDR
																																																			(BgL_cdrzd28515zd2_1263);
																																																		if ((CAR(BgL_cdrzd28515zd2_1263) == BGl_keyword2691z00zz__evaluatez00))
																																																			{	/* Eval/evaluate.scm 319 */
																																																				if (PAIRP(BgL_cdrzd28520zd2_1265))
																																																					{	/* Eval/evaluate.scm 319 */
																																																						obj_t
																																																							BgL_arg1671z00_1268;
																																																						obj_t
																																																							BgL_arg1672z00_1269;
																																																						obj_t
																																																							BgL_arg1673z00_1270;
																																																						BgL_arg1671z00_1268
																																																							=
																																																							CAR
																																																							(BgL_cdrzd28510zd2_1260);
																																																						BgL_arg1672z00_1269
																																																							=
																																																							CAR
																																																							(BgL_cdrzd28520zd2_1265);
																																																						BgL_arg1673z00_1270
																																																							=
																																																							CDR
																																																							(BgL_cdrzd28520zd2_1265);
																																																						{	/* Eval/evaluate.scm 472 */
																																																							BgL_ev_synchroniza7eza7_bglt
																																																								BgL_new1154z00_3410;
																																																							{	/* Eval/evaluate.scm 472 */
																																																								BgL_ev_synchroniza7eza7_bglt
																																																									BgL_new1153z00_3411;
																																																								BgL_new1153z00_3411
																																																									=
																																																									(
																																																									(BgL_ev_synchroniza7eza7_bglt)
																																																									BREF
																																																									(GC_MALLOC
																																																										(sizeof
																																																											(struct
																																																												BgL_ev_synchroniza7eza7_bgl))));
																																																								{	/* Eval/evaluate.scm 472 */
																																																									long
																																																										BgL_arg2085z00_3412;
																																																									{	/* Eval/evaluate.scm 472 */
																																																										long
																																																											BgL_res2527z00_3414;
																																																										BgL_res2527z00_3414
																																																											=
																																																											BGL_CLASS_INDEX
																																																											(BGl_ev_synchroniza7eza7zz__evaluate_typesz00);
																																																										BgL_arg2085z00_3412
																																																											=
																																																											BgL_res2527z00_3414;
																																																									}
																																																									{	/* Eval/evaluate.scm 472 */
																																																										BgL_objectz00_bglt
																																																											BgL_objz00_3415;
																																																										BgL_objz00_3415
																																																											=
																																																											(
																																																											(BgL_objectz00_bglt)
																																																											BgL_new1153z00_3411);
																																																										BGL_OBJECT_CLASS_NUM_SET
																																																											(BgL_objz00_3415,
																																																											BgL_arg2085z00_3412);
																																																								}}
																																																								{	/* Eval/evaluate.scm 472 */
																																																									BgL_objectz00_bglt
																																																										BgL_auxz00_5655;
																																																									BgL_auxz00_5655
																																																										=
																																																										(
																																																										(BgL_objectz00_bglt)
																																																										BgL_new1153z00_3411);
																																																									BGL_OBJECT_WIDENING_SET
																																																										(BgL_auxz00_5655,
																																																										BFALSE);
																																																								}
																																																								BgL_new1154z00_3410
																																																									=
																																																									BgL_new1153z00_3411;
																																																							}
																																																							{
																																																								BgL_ev_exprz00_bglt
																																																									BgL_auxz00_5658;
																																																								{	/* Eval/evaluate.scm 280 */
																																																									obj_t
																																																										BgL_arg2097z00_3418;
																																																									BgL_arg2097z00_3418
																																																										=
																																																										BGl_getzd2locationzd2zz__evaluatez00
																																																										(BgL_arg1671z00_1268,
																																																										BgL_locz00_54);
																																																									BgL_auxz00_5658
																																																										=
																																																										(
																																																										(BgL_ev_exprz00_bglt)
																																																										BGl_uconvzf2loczf2zz__evaluatez00
																																																										(BgL_wherez00_53,
																																																											BgL_globalsz00_51,
																																																											BgL_localsz00_50,
																																																											BgL_arg1671z00_1268,
																																																											BgL_arg2097z00_3418));
																																																								}
																																																								((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1154z00_3410))->BgL_mutexz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5658), BUNSPEC);
																																																							}
																																																							{
																																																								BgL_ev_exprz00_bglt
																																																									BgL_auxz00_5663;
																																																								{	/* Eval/evaluate.scm 280 */
																																																									obj_t
																																																										BgL_arg2097z00_3420;
																																																									BgL_arg2097z00_3420
																																																										=
																																																										BGl_getzd2locationzd2zz__evaluatez00
																																																										(BgL_arg1672z00_1269,
																																																										BgL_locz00_54);
																																																									BgL_auxz00_5663
																																																										=
																																																										(
																																																										(BgL_ev_exprz00_bglt)
																																																										BGl_uconvzf2loczf2zz__evaluatez00
																																																										(BgL_wherez00_53,
																																																											BgL_globalsz00_51,
																																																											BgL_localsz00_50,
																																																											BgL_arg1672z00_1269,
																																																											BgL_arg2097z00_3420));
																																																								}
																																																								((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1154z00_3410))->BgL_prelockz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5663), BUNSPEC);
																																																							}
																																																							((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1154z00_3410))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_arg1673z00_1270, BgL_localsz00_50, BgL_globalsz00_51, BFALSE, BgL_wherez00_53, BgL_locz00_54, ((bool_t) 0)))), BUNSPEC);
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_new1154z00_3410);
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 319 */
																																																						obj_t
																																																							BgL_arg1674z00_1272;
																																																						obj_t
																																																							BgL_arg1675z00_1273;
																																																						BgL_arg1674z00_1272
																																																							=
																																																							CAR
																																																							(BgL_cdrzd28510zd2_1260);
																																																						BgL_arg1675z00_1273
																																																							=
																																																							CDR
																																																							(BgL_cdrzd28510zd2_1260);
																																																						{
																																																							BgL_ev_synchroniza7eza7_bglt
																																																								BgL_auxz00_5674;
																																																							BgL_mz00_935
																																																								=
																																																								BgL_arg1674z00_1272;
																																																							BgL_bodyz00_936
																																																								=
																																																								BgL_arg1675z00_1273;
																																																						BgL_tagzd2155zd2_937:
																																																							{	/* Eval/evaluate.scm 477 */
																																																								BgL_ev_synchroniza7eza7_bglt
																																																									BgL_new1156z00_1859;
																																																								{	/* Eval/evaluate.scm 477 */
																																																									BgL_ev_synchroniza7eza7_bglt
																																																										BgL_new1155z00_1860;
																																																									BgL_new1155z00_1860
																																																										=
																																																										(
																																																										(BgL_ev_synchroniza7eza7_bglt)
																																																										BREF
																																																										(GC_MALLOC
																																																											(sizeof
																																																												(struct
																																																													BgL_ev_synchroniza7eza7_bgl))));
																																																									{	/* Eval/evaluate.scm 477 */
																																																										long
																																																											BgL_arg2086z00_1861;
																																																										{	/* Eval/evaluate.scm 477 */
																																																											long
																																																												BgL_res2450z00_2957;
																																																											BgL_res2450z00_2957
																																																												=
																																																												BGL_CLASS_INDEX
																																																												(BGl_ev_synchroniza7eza7zz__evaluate_typesz00);
																																																											BgL_arg2086z00_1861
																																																												=
																																																												BgL_res2450z00_2957;
																																																										}
																																																										{	/* Eval/evaluate.scm 477 */
																																																											BgL_objectz00_bglt
																																																												BgL_objz00_2958;
																																																											BgL_objz00_2958
																																																												=
																																																												(
																																																												(BgL_objectz00_bglt)
																																																												BgL_new1155z00_1860);
																																																											BGL_OBJECT_CLASS_NUM_SET
																																																												(BgL_objz00_2958,
																																																												BgL_arg2086z00_1861);
																																																									}}
																																																									{	/* Eval/evaluate.scm 477 */
																																																										BgL_objectz00_bglt
																																																											BgL_auxz00_5679;
																																																										BgL_auxz00_5679
																																																											=
																																																											(
																																																											(BgL_objectz00_bglt)
																																																											BgL_new1155z00_1860);
																																																										BGL_OBJECT_WIDENING_SET
																																																											(BgL_auxz00_5679,
																																																											BFALSE);
																																																									}
																																																									BgL_new1156z00_1859
																																																										=
																																																										BgL_new1155z00_1860;
																																																								}
																																																								{
																																																									BgL_ev_exprz00_bglt
																																																										BgL_auxz00_5682;
																																																									{	/* Eval/evaluate.scm 280 */
																																																										obj_t
																																																											BgL_arg2097z00_2961;
																																																										{	/* Eval/evaluate.scm 129 */
																																																											obj_t
																																																												BgL__ortest_1067z00_2964;
																																																											BgL__ortest_1067z00_2964
																																																												=
																																																												BGl_getzd2sourcezd2locationz00zz__readerz00
																																																												(BgL_mz00_935);
																																																											if (CBOOL(BgL__ortest_1067z00_2964))
																																																												{	/* Eval/evaluate.scm 129 */
																																																													BgL_arg2097z00_2961
																																																														=
																																																														BgL__ortest_1067z00_2964;
																																																												}
																																																											else
																																																												{	/* Eval/evaluate.scm 129 */
																																																													BgL_arg2097z00_2961
																																																														=
																																																														BgL_locz00_54;
																																																												}
																																																										}
																																																										BgL_auxz00_5682
																																																											=
																																																											(
																																																											(BgL_ev_exprz00_bglt)
																																																											BGl_convz00zz__evaluatez00
																																																											(BgL_mz00_935,
																																																												BgL_localsz00_50,
																																																												BgL_globalsz00_51,
																																																												BFALSE,
																																																												BgL_wherez00_53,
																																																												BgL_arg2097z00_2961,
																																																												((bool_t) 0)));
																																																									}
																																																									((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1156z00_1859))->BgL_mutexz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5682), BUNSPEC);
																																																								}
																																																								{
																																																									BgL_ev_exprz00_bglt
																																																										BgL_auxz00_5689;
																																																									{	/* Eval/evaluate.scm 280 */
																																																										obj_t
																																																											BgL_arg2097z00_2968;
																																																										{	/* Eval/evaluate.scm 129 */
																																																											obj_t
																																																												BgL__ortest_1067z00_2971;
																																																											BgL__ortest_1067z00_2971
																																																												=
																																																												BGl_getzd2sourcezd2locationz00zz__readerz00
																																																												(BNIL);
																																																											if (CBOOL(BgL__ortest_1067z00_2971))
																																																												{	/* Eval/evaluate.scm 129 */
																																																													BgL_arg2097z00_2968
																																																														=
																																																														BgL__ortest_1067z00_2971;
																																																												}
																																																											else
																																																												{	/* Eval/evaluate.scm 129 */
																																																													BgL_arg2097z00_2968
																																																														=
																																																														BgL_locz00_54;
																																																												}
																																																										}
																																																										BgL_auxz00_5689
																																																											=
																																																											(
																																																											(BgL_ev_exprz00_bglt)
																																																											BGl_convz00zz__evaluatez00
																																																											(BNIL,
																																																												BgL_localsz00_50,
																																																												BgL_globalsz00_51,
																																																												BFALSE,
																																																												BgL_wherez00_53,
																																																												BgL_arg2097z00_2968,
																																																												((bool_t) 0)));
																																																									}
																																																									((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1156z00_1859))->BgL_prelockz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5689), BUNSPEC);
																																																								}
																																																								((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1156z00_1859))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_bodyz00_936, BgL_localsz00_50, BgL_globalsz00_51, BFALSE, BgL_wherez00_53, BgL_locz00_54, ((bool_t) 0)))), BUNSPEC);
																																																								BgL_auxz00_5674
																																																									=
																																																									BgL_new1156z00_1859;
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_5674);
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 319 */
																																																				obj_t
																																																					BgL_arg1676z00_1275;
																																																				obj_t
																																																					BgL_arg1677z00_1276;
																																																				BgL_arg1676z00_1275
																																																					=
																																																					CAR
																																																					(BgL_cdrzd28510zd2_1260);
																																																				BgL_arg1677z00_1276
																																																					=
																																																					CDR
																																																					(BgL_cdrzd28510zd2_1260);
																																																				{
																																																					BgL_ev_synchroniza7eza7_bglt
																																																						BgL_auxz00_5702;
																																																					{
																																																						obj_t
																																																							BgL_bodyz00_5704;
																																																						obj_t
																																																							BgL_mz00_5703;
																																																						BgL_mz00_5703
																																																							=
																																																							BgL_arg1676z00_1275;
																																																						BgL_bodyz00_5704
																																																							=
																																																							BgL_arg1677z00_1276;
																																																						BgL_bodyz00_936
																																																							=
																																																							BgL_bodyz00_5704;
																																																						BgL_mz00_935
																																																							=
																																																							BgL_mz00_5703;
																																																						goto
																																																							BgL_tagzd2155zd2_937;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_5702);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 319 */
																																																		obj_t
																																																			BgL_arg1679z00_1279;
																																																		obj_t
																																																			BgL_arg1680z00_1280;
																																																		BgL_arg1679z00_1279
																																																			=
																																																			CAR
																																																			(BgL_cdrzd28510zd2_1260);
																																																		BgL_arg1680z00_1280
																																																			=
																																																			CDR
																																																			(BgL_cdrzd28510zd2_1260);
																																																		{
																																																			BgL_ev_synchroniza7eza7_bglt
																																																				BgL_auxz00_5708;
																																																			{
																																																				obj_t
																																																					BgL_bodyz00_5710;
																																																				obj_t
																																																					BgL_mz00_5709;
																																																				BgL_mz00_5709
																																																					=
																																																					BgL_arg1679z00_1279;
																																																				BgL_bodyz00_5710
																																																					=
																																																					BgL_arg1680z00_1280;
																																																				BgL_bodyz00_936
																																																					=
																																																					BgL_bodyz00_5710;
																																																				BgL_mz00_935
																																																					=
																																																					BgL_mz00_5709;
																																																				goto
																																																					BgL_tagzd2155zd2_937;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_5708);
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 319 */
																																																obj_t
																																																	BgL_arg1681z00_1281;
																																																BgL_arg1681z00_1281
																																																	=
																																																	CAR
																																																	(BgL_ez00_49);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_5713;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_5715;
																																																		obj_t
																																																			BgL_fz00_5714;
																																																		BgL_fz00_5714
																																																			=
																																																			BgL_arg1681z00_1281;
																																																		BgL_argsz00_5715
																																																			=
																																																			BgL_cdrzd28510zd2_1260;
																																																		BgL_argsz00_942
																																																			=
																																																			BgL_argsz00_5715;
																																																		BgL_fz00_941
																																																			=
																																																			BgL_fz00_5714;
																																																		goto
																																																			BgL_tagzd2157zd2_943;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_5713);
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 319 */
																																														if ((CAR(BgL_ez00_49) == BGl_symbol2681z00zz__evaluatez00))
																																															{	/* Eval/evaluate.scm 319 */
																																																if (PAIRP(BgL_cdrzd28510zd2_1260))
																																																	{	/* Eval/evaluate.scm 319 */
																																																		obj_t
																																																			BgL_cdrzd28620zd2_1286;
																																																		BgL_cdrzd28620zd2_1286
																																																			=
																																																			CDR
																																																			(BgL_cdrzd28510zd2_1260);
																																																		if (PAIRP(BgL_cdrzd28620zd2_1286))
																																																			{	/* Eval/evaluate.scm 319 */
																																																				if (NULLP(CDR(BgL_cdrzd28620zd2_1286)))
																																																					{	/* Eval/evaluate.scm 319 */
																																																						obj_t
																																																							BgL_arg1687z00_1289;
																																																						obj_t
																																																							BgL_arg1688z00_1290;
																																																						BgL_arg1687z00_1289
																																																							=
																																																							CAR
																																																							(BgL_cdrzd28510zd2_1260);
																																																						BgL_arg1688z00_1290
																																																							=
																																																							CAR
																																																							(BgL_cdrzd28620zd2_1286);
																																																						{	/* Eval/evaluate.scm 482 */
																																																							obj_t
																																																								BgL_arg2087z00_3446;
																																																							{	/* Eval/evaluate.scm 482 */
																																																								obj_t
																																																									BgL_arg2088z00_3447;
																																																								{	/* Eval/evaluate.scm 482 */
																																																									obj_t
																																																										BgL_arg2089z00_3448;
																																																									obj_t
																																																										BgL_arg2090z00_3449;
																																																									{	/* Eval/evaluate.scm 482 */
																																																										obj_t
																																																											BgL_res2531z00_3452;
																																																										{	/* Eval/evaluate.scm 482 */
																																																											obj_t
																																																												BgL_symbolz00_3450;
																																																											BgL_symbolz00_3450
																																																												=
																																																												BGl_symbol2693z00zz__evaluatez00;
																																																											{	/* Ieee/symbol.scm 135 */
																																																												obj_t
																																																													BgL_arg2268z00_3451;
																																																												BgL_arg2268z00_3451
																																																													=
																																																													SYMBOL_TO_STRING
																																																													(BgL_symbolz00_3450);
																																																												BgL_res2531z00_3452
																																																													=
																																																													BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																																																													(BgL_arg2268z00_3451);
																																																											}
																																																										}
																																																										BgL_arg2089z00_3448
																																																											=
																																																											BgL_res2531z00_3452;
																																																									}
																																																									{	/* Eval/evaluate.scm 482 */
																																																										obj_t
																																																											BgL_res2532z00_3455;
																																																										{	/* Eval/evaluate.scm 482 */
																																																											obj_t
																																																												BgL_symbolz00_3453;
																																																											BgL_symbolz00_3453
																																																												=
																																																												BgL_wherez00_53;
																																																											{	/* Ieee/symbol.scm 135 */
																																																												obj_t
																																																													BgL_arg2268z00_3454;
																																																												BgL_arg2268z00_3454
																																																													=
																																																													SYMBOL_TO_STRING
																																																													(BgL_symbolz00_3453);
																																																												BgL_res2532z00_3455
																																																													=
																																																													BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																																																													(BgL_arg2268z00_3454);
																																																											}
																																																										}
																																																										BgL_arg2090z00_3449
																																																											=
																																																											BgL_res2532z00_3455;
																																																									}
																																																									BgL_arg2088z00_3447
																																																										=
																																																										string_append
																																																										(BgL_arg2089z00_3448,
																																																										BgL_arg2090z00_3449);
																																																								}
																																																								BgL_arg2087z00_3446
																																																									=
																																																									string_to_symbol
																																																									(BSTRING_TO_STRING
																																																									(BgL_arg2088z00_3447));
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BGl_convzd2lambdazd2zz__evaluatez00
																																																								(BgL_globalsz00_51,
																																																									BgL_localsz00_50,
																																																									BgL_locz00_54,
																																																									BgL_ez00_49,
																																																									BgL_arg1687z00_1289,
																																																									BgL_arg1688z00_1290,
																																																									BgL_arg2087z00_3446));
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 319 */
																																																						obj_t
																																																							BgL_arg1689z00_1291;
																																																						obj_t
																																																							BgL_arg1690z00_1292;
																																																						BgL_arg1689z00_1291
																																																							=
																																																							CAR
																																																							(BgL_ez00_49);
																																																						BgL_arg1690z00_1292
																																																							=
																																																							CDR
																																																							(BgL_ez00_49);
																																																						{
																																																							BgL_ev_appz00_bglt
																																																								BgL_auxz00_5741;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_5743;
																																																								obj_t
																																																									BgL_fz00_5742;
																																																								BgL_fz00_5742
																																																									=
																																																									BgL_arg1689z00_1291;
																																																								BgL_argsz00_5743
																																																									=
																																																									BgL_arg1690z00_1292;
																																																								BgL_argsz00_942
																																																									=
																																																									BgL_argsz00_5743;
																																																								BgL_fz00_941
																																																									=
																																																									BgL_fz00_5742;
																																																								goto
																																																									BgL_tagzd2157zd2_943;
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_5741);
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 319 */
																																																				obj_t
																																																					BgL_arg1692z00_1294;
																																																				obj_t
																																																					BgL_arg1693z00_1295;
																																																				BgL_arg1692z00_1294
																																																					=
																																																					CAR
																																																					(BgL_ez00_49);
																																																				BgL_arg1693z00_1295
																																																					=
																																																					CDR
																																																					(BgL_ez00_49);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_5747;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_5749;
																																																						obj_t
																																																							BgL_fz00_5748;
																																																						BgL_fz00_5748
																																																							=
																																																							BgL_arg1692z00_1294;
																																																						BgL_argsz00_5749
																																																							=
																																																							BgL_arg1693z00_1295;
																																																						BgL_argsz00_942
																																																							=
																																																							BgL_argsz00_5749;
																																																						BgL_fz00_941
																																																							=
																																																							BgL_fz00_5748;
																																																						goto
																																																							BgL_tagzd2157zd2_943;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_5747);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 319 */
																																																		obj_t
																																																			BgL_arg1694z00_1296;
																																																		obj_t
																																																			BgL_arg1695z00_1297;
																																																		BgL_arg1694z00_1296
																																																			=
																																																			CAR
																																																			(BgL_ez00_49);
																																																		BgL_arg1695z00_1297
																																																			=
																																																			CDR
																																																			(BgL_ez00_49);
																																																		{
																																																			BgL_ev_appz00_bglt
																																																				BgL_auxz00_5753;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_5755;
																																																				obj_t
																																																					BgL_fz00_5754;
																																																				BgL_fz00_5754
																																																					=
																																																					BgL_arg1694z00_1296;
																																																				BgL_argsz00_5755
																																																					=
																																																					BgL_arg1695z00_1297;
																																																				BgL_argsz00_942
																																																					=
																																																					BgL_argsz00_5755;
																																																				BgL_fz00_941
																																																					=
																																																					BgL_fz00_5754;
																																																				goto
																																																					BgL_tagzd2157zd2_943;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_5753);
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 319 */
																																																obj_t
																																																	BgL_arg1696z00_1298;
																																																obj_t
																																																	BgL_arg1697z00_1299;
																																																BgL_arg1696z00_1298
																																																	=
																																																	CAR
																																																	(BgL_ez00_49);
																																																BgL_arg1697z00_1299
																																																	=
																																																	CDR
																																																	(BgL_ez00_49);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_5759;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_5761;
																																																		obj_t
																																																			BgL_fz00_5760;
																																																		BgL_fz00_5760
																																																			=
																																																			BgL_arg1696z00_1298;
																																																		BgL_argsz00_5761
																																																			=
																																																			BgL_arg1697z00_1299;
																																																		BgL_argsz00_942
																																																			=
																																																			BgL_argsz00_5761;
																																																		BgL_fz00_941
																																																			=
																																																			BgL_fz00_5760;
																																																		goto
																																																			BgL_tagzd2157zd2_943;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_5759);
																																																}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																	}
																															}
																													}
																											}
																									}
																							}
																					}
																			}
																	}
															}
													}
												else
													{	/* Eval/evaluate.scm 319 */
														if (
															(BgL_carzd23802zd2_1007 ==
																BGl_symbol2659z00zz__evaluatez00))
															{	/* Eval/evaluate.scm 319 */
																if (PAIRP(BgL_cdrzd2231zd2_949))
																	{	/* Eval/evaluate.scm 319 */
																		if (NULLP(CDR(BgL_cdrzd2231zd2_949)))
																			{	/* Eval/evaluate.scm 319 */
																				obj_t BgL_arg1718z00_1321;

																				BgL_arg1718z00_1321 =
																					CAR(BgL_cdrzd2231zd2_949);
																				{
																					BgL_ev_trapz00_bglt BgL_auxz00_5771;

																					{
																						obj_t BgL_ez00_5772;

																						BgL_ez00_5772 = BgL_arg1718z00_1321;
																						BgL_ez00_878 = BgL_ez00_5772;
																						goto BgL_tagzd2135zd2_879;
																					}
																					return ((obj_t) BgL_auxz00_5771);
																				}
																			}
																		else
																			{	/* Eval/evaluate.scm 319 */
																				obj_t BgL_arg1719z00_1322;
																				obj_t BgL_arg1720z00_1323;

																				BgL_arg1719z00_1322 = CAR(BgL_ez00_49);
																				BgL_arg1720z00_1323 = CDR(BgL_ez00_49);
																				{
																					BgL_ev_appz00_bglt BgL_auxz00_5776;

																					{
																						obj_t BgL_argsz00_5778;
																						obj_t BgL_fz00_5777;

																						BgL_fz00_5777 = BgL_arg1719z00_1322;
																						BgL_argsz00_5778 =
																							BgL_arg1720z00_1323;
																						BgL_argsz00_942 = BgL_argsz00_5778;
																						BgL_fz00_941 = BgL_fz00_5777;
																						goto BgL_tagzd2157zd2_943;
																					}
																					return ((obj_t) BgL_auxz00_5776);
																				}
																			}
																	}
																else
																	{	/* Eval/evaluate.scm 319 */
																		obj_t BgL_arg1722z00_1325;
																		obj_t BgL_arg1723z00_1326;

																		BgL_arg1722z00_1325 = CAR(BgL_ez00_49);
																		BgL_arg1723z00_1326 = CDR(BgL_ez00_49);
																		{
																			BgL_ev_appz00_bglt BgL_auxz00_5782;

																			{
																				obj_t BgL_argsz00_5784;
																				obj_t BgL_fz00_5783;

																				BgL_fz00_5783 = BgL_arg1722z00_1325;
																				BgL_argsz00_5784 = BgL_arg1723z00_1326;
																				BgL_argsz00_942 = BgL_argsz00_5784;
																				BgL_fz00_941 = BgL_fz00_5783;
																				goto BgL_tagzd2157zd2_943;
																			}
																			return ((obj_t) BgL_auxz00_5782);
																		}
																	}
															}
														else
															{	/* Eval/evaluate.scm 319 */
																obj_t BgL_cdrzd29319zd2_1327;

																BgL_cdrzd29319zd2_1327 = CDR(BgL_ez00_49);
																if (
																	(CAR(BgL_ez00_49) ==
																		BGl_symbol2661z00zz__evaluatez00))
																	{	/* Eval/evaluate.scm 319 */
																		if (PAIRP(BgL_cdrzd29319zd2_1327))
																			{	/* Eval/evaluate.scm 319 */
																				if (NULLP(CDR(BgL_cdrzd29319zd2_1327)))
																					{	/* Eval/evaluate.scm 319 */
																						obj_t BgL_arg1727z00_1331;

																						BgL_arg1727z00_1331 =
																							CAR(BgL_cdrzd29319zd2_1327);
																						{	/* Eval/evaluate.scm 356 */
																							BgL_ev_littz00_bglt
																								BgL_new1111z00_3487;
																							{	/* Eval/evaluate.scm 356 */
																								BgL_ev_littz00_bglt
																									BgL_new1110z00_3488;
																								BgL_new1110z00_3488 =
																									((BgL_ev_littz00_bglt)
																									BREF(GC_MALLOC(sizeof(struct
																												BgL_ev_littz00_bgl))));
																								{	/* Eval/evaluate.scm 356 */
																									long BgL_arg1991z00_3489;

																									{	/* Eval/evaluate.scm 356 */
																										long BgL_res2538z00_3491;

																										BgL_res2538z00_3491 =
																											BGL_CLASS_INDEX
																											(BGl_ev_littz00zz__evaluate_typesz00);
																										BgL_arg1991z00_3489 =
																											BgL_res2538z00_3491;
																									}
																									{	/* Eval/evaluate.scm 356 */
																										BgL_objectz00_bglt
																											BgL_objz00_3492;
																										BgL_objz00_3492 =
																											((BgL_objectz00_bglt)
																											BgL_new1110z00_3488);
																										BGL_OBJECT_CLASS_NUM_SET
																											(BgL_objz00_3492,
																											BgL_arg1991z00_3489);
																								}}
																								{	/* Eval/evaluate.scm 356 */
																									BgL_objectz00_bglt
																										BgL_auxz00_5800;
																									BgL_auxz00_5800 =
																										((BgL_objectz00_bglt)
																										BgL_new1110z00_3488);
																									BGL_OBJECT_WIDENING_SET
																										(BgL_auxz00_5800, BFALSE);
																								}
																								BgL_new1111z00_3487 =
																									BgL_new1110z00_3488;
																							}
																							((((BgL_ev_littz00_bglt)
																										CREF(BgL_new1111z00_3487))->
																									BgL_valuez00) =
																								((obj_t) BgL_arg1727z00_1331),
																								BUNSPEC);
																							return ((obj_t)
																								BgL_new1111z00_3487);
																						}
																					}
																				else
																					{	/* Eval/evaluate.scm 319 */
																						obj_t BgL_arg1728z00_1332;

																						BgL_arg1728z00_1332 =
																							CAR(BgL_ez00_49);
																						{
																							BgL_ev_appz00_bglt
																								BgL_auxz00_5806;
																							{
																								obj_t BgL_argsz00_5808;
																								obj_t BgL_fz00_5807;

																								BgL_fz00_5807 =
																									BgL_arg1728z00_1332;
																								BgL_argsz00_5808 =
																									BgL_cdrzd29319zd2_1327;
																								BgL_argsz00_942 =
																									BgL_argsz00_5808;
																								BgL_fz00_941 = BgL_fz00_5807;
																								goto BgL_tagzd2157zd2_943;
																							}
																							return ((obj_t) BgL_auxz00_5806);
																						}
																					}
																			}
																		else
																			{	/* Eval/evaluate.scm 319 */
																				obj_t BgL_arg1732z00_1335;

																				BgL_arg1732z00_1335 = CAR(BgL_ez00_49);
																				{
																					BgL_ev_appz00_bglt BgL_auxz00_5811;

																					{
																						obj_t BgL_argsz00_5813;
																						obj_t BgL_fz00_5812;

																						BgL_fz00_5812 = BgL_arg1732z00_1335;
																						BgL_argsz00_5813 =
																							BgL_cdrzd29319zd2_1327;
																						BgL_argsz00_942 = BgL_argsz00_5813;
																						BgL_fz00_941 = BgL_fz00_5812;
																						goto BgL_tagzd2157zd2_943;
																					}
																					return ((obj_t) BgL_auxz00_5811);
																				}
																			}
																	}
																else
																	{	/* Eval/evaluate.scm 319 */
																		if (
																			(CAR(BgL_ez00_49) ==
																				BGl_symbol2663z00zz__evaluatez00))
																			{	/* Eval/evaluate.scm 319 */
																				if (PAIRP(BgL_cdrzd29319zd2_1327))
																					{	/* Eval/evaluate.scm 319 */
																						obj_t BgL_cdrzd29929zd2_1340;

																						BgL_cdrzd29929zd2_1340 =
																							CDR(BgL_cdrzd29319zd2_1327);
																						if (PAIRP(BgL_cdrzd29929zd2_1340))
																							{	/* Eval/evaluate.scm 319 */
																								obj_t BgL_cdrzd29934zd2_1342;

																								BgL_cdrzd29934zd2_1342 =
																									CDR(BgL_cdrzd29929zd2_1340);
																								if (PAIRP
																									(BgL_cdrzd29934zd2_1342))
																									{	/* Eval/evaluate.scm 319 */
																										if (NULLP(CDR
																												(BgL_cdrzd29934zd2_1342)))
																											{	/* Eval/evaluate.scm 319 */
																												obj_t
																													BgL_arg1739z00_1345;
																												obj_t
																													BgL_arg1740z00_1346;
																												obj_t
																													BgL_arg1741z00_1347;
																												BgL_arg1739z00_1345 =
																													CAR
																													(BgL_cdrzd29319zd2_1327);
																												BgL_arg1740z00_1346 =
																													CAR
																													(BgL_cdrzd29929zd2_1340);
																												BgL_arg1741z00_1347 =
																													CAR
																													(BgL_cdrzd29934zd2_1342);
																												{
																													BgL_ev_ifz00_bglt
																														BgL_auxz00_5832;
																													{
																														obj_t BgL_oz00_5835;
																														obj_t BgL_tz00_5834;
																														obj_t BgL_pz00_5833;

																														BgL_pz00_5833 =
																															BgL_arg1739z00_1345;
																														BgL_tz00_5834 =
																															BgL_arg1740z00_1346;
																														BgL_oz00_5835 =
																															BgL_arg1741z00_1347;
																														BgL_oz00_884 =
																															BgL_oz00_5835;
																														BgL_tz00_883 =
																															BgL_tz00_5834;
																														BgL_pz00_882 =
																															BgL_pz00_5833;
																														goto
																															BgL_tagzd2137zd2_885;
																													}
																													return
																														((obj_t)
																														BgL_auxz00_5832);
																												}
																											}
																										else
																											{	/* Eval/evaluate.scm 319 */
																												obj_t
																													BgL_arg1742z00_1348;
																												obj_t
																													BgL_arg1743z00_1349;
																												BgL_arg1742z00_1348 =
																													CAR(BgL_ez00_49);
																												BgL_arg1743z00_1349 =
																													CDR(BgL_ez00_49);
																												{
																													BgL_ev_appz00_bglt
																														BgL_auxz00_5839;
																													{
																														obj_t
																															BgL_argsz00_5841;
																														obj_t BgL_fz00_5840;

																														BgL_fz00_5840 =
																															BgL_arg1742z00_1348;
																														BgL_argsz00_5841 =
																															BgL_arg1743z00_1349;
																														BgL_argsz00_942 =
																															BgL_argsz00_5841;
																														BgL_fz00_941 =
																															BgL_fz00_5840;
																														goto
																															BgL_tagzd2157zd2_943;
																													}
																													return
																														((obj_t)
																														BgL_auxz00_5839);
																												}
																											}
																									}
																								else
																									{	/* Eval/evaluate.scm 319 */
																										obj_t
																											BgL_cdrzd210232zd2_1351;
																										BgL_cdrzd210232zd2_1351 =
																											CDR(BgL_ez00_49);
																										{	/* Eval/evaluate.scm 319 */
																											obj_t
																												BgL_cdrzd210238zd2_1352;
																											BgL_cdrzd210238zd2_1352 =
																												CDR
																												(BgL_cdrzd210232zd2_1351);
																											if (NULLP(CDR
																													(BgL_cdrzd210238zd2_1352)))
																												{	/* Eval/evaluate.scm 319 */
																													obj_t
																														BgL_arg1746z00_1354;
																													obj_t
																														BgL_arg1747z00_1355;
																													BgL_arg1746z00_1354 =
																														CAR
																														(BgL_cdrzd210232zd2_1351);
																													BgL_arg1747z00_1355 =
																														CAR
																														(BgL_cdrzd210238zd2_1352);
																													{
																														BgL_ev_ifz00_bglt
																															BgL_auxz00_5850;
																														{
																															obj_t
																																BgL_tz00_5852;
																															obj_t
																																BgL_pz00_5851;
																															BgL_pz00_5851 =
																																BgL_arg1746z00_1354;
																															BgL_tz00_5852 =
																																BgL_arg1747z00_1355;
																															BgL_tz00_887 =
																																BgL_tz00_5852;
																															BgL_pz00_886 =
																																BgL_pz00_5851;
																															goto
																																BgL_tagzd2138zd2_888;
																														}
																														return
																															((obj_t)
																															BgL_auxz00_5850);
																													}
																												}
																											else
																												{	/* Eval/evaluate.scm 319 */
																													obj_t
																														BgL_arg1748z00_1356;
																													BgL_arg1748z00_1356 =
																														CAR(BgL_ez00_49);
																													{
																														BgL_ev_appz00_bglt
																															BgL_auxz00_5855;
																														{
																															obj_t
																																BgL_argsz00_5857;
																															obj_t
																																BgL_fz00_5856;
																															BgL_fz00_5856 =
																																BgL_arg1748z00_1356;
																															BgL_argsz00_5857 =
																																BgL_cdrzd210232zd2_1351;
																															BgL_argsz00_942 =
																																BgL_argsz00_5857;
																															BgL_fz00_941 =
																																BgL_fz00_5856;
																															goto
																																BgL_tagzd2157zd2_943;
																														}
																														return
																															((obj_t)
																															BgL_auxz00_5855);
																													}
																												}
																										}
																									}
																							}
																						else
																							{	/* Eval/evaluate.scm 319 */
																								obj_t BgL_arg1751z00_1359;
																								obj_t BgL_arg1752z00_1360;

																								BgL_arg1751z00_1359 =
																									CAR(BgL_ez00_49);
																								BgL_arg1752z00_1360 =
																									CDR(BgL_ez00_49);
																								{
																									BgL_ev_appz00_bglt
																										BgL_auxz00_5861;
																									{
																										obj_t BgL_argsz00_5863;
																										obj_t BgL_fz00_5862;

																										BgL_fz00_5862 =
																											BgL_arg1751z00_1359;
																										BgL_argsz00_5863 =
																											BgL_arg1752z00_1360;
																										BgL_argsz00_942 =
																											BgL_argsz00_5863;
																										BgL_fz00_941 =
																											BgL_fz00_5862;
																										goto BgL_tagzd2157zd2_943;
																									}
																									return
																										((obj_t) BgL_auxz00_5861);
																								}
																							}
																					}
																				else
																					{	/* Eval/evaluate.scm 319 */
																						obj_t BgL_arg1753z00_1361;
																						obj_t BgL_arg1754z00_1362;

																						BgL_arg1753z00_1361 =
																							CAR(BgL_ez00_49);
																						BgL_arg1754z00_1362 =
																							CDR(BgL_ez00_49);
																						{
																							BgL_ev_appz00_bglt
																								BgL_auxz00_5867;
																							{
																								obj_t BgL_argsz00_5869;
																								obj_t BgL_fz00_5868;

																								BgL_fz00_5868 =
																									BgL_arg1753z00_1361;
																								BgL_argsz00_5869 =
																									BgL_arg1754z00_1362;
																								BgL_argsz00_942 =
																									BgL_argsz00_5869;
																								BgL_fz00_941 = BgL_fz00_5868;
																								goto BgL_tagzd2157zd2_943;
																							}
																							return ((obj_t) BgL_auxz00_5867);
																						}
																					}
																			}
																		else
																			{	/* Eval/evaluate.scm 319 */
																				if (
																					(CAR(BgL_ez00_49) ==
																						BGl_symbol2665z00zz__evaluatez00))
																					{	/* Eval/evaluate.scm 319 */
																						obj_t BgL_arg1756z00_1364;

																						BgL_arg1756z00_1364 =
																							CDR(BgL_ez00_49);
																						{
																							BgL_ev_orz00_bglt BgL_auxz00_5875;

																							{
																								obj_t BgL_argsz00_5876;

																								BgL_argsz00_5876 =
																									BgL_arg1756z00_1364;
																								BgL_argsz00_889 =
																									BgL_argsz00_5876;
																								goto BgL_tagzd2139zd2_890;
																							}
																							return ((obj_t) BgL_auxz00_5875);
																						}
																					}
																				else
																					{	/* Eval/evaluate.scm 319 */
																						if (
																							(CAR(BgL_ez00_49) ==
																								BGl_symbol2667z00zz__evaluatez00))
																							{	/* Eval/evaluate.scm 319 */
																								obj_t BgL_arg1758z00_1366;

																								BgL_arg1758z00_1366 =
																									CDR(BgL_ez00_49);
																								{
																									BgL_ev_andz00_bglt
																										BgL_auxz00_5882;
																									{
																										obj_t BgL_argsz00_5883;

																										BgL_argsz00_5883 =
																											BgL_arg1758z00_1366;
																										BgL_argsz00_891 =
																											BgL_argsz00_5883;
																										goto BgL_tagzd2140zd2_892;
																									}
																									return
																										((obj_t) BgL_auxz00_5882);
																								}
																							}
																						else
																							{	/* Eval/evaluate.scm 319 */
																								if (
																									(CAR(BgL_ez00_49) ==
																										BGl_symbol2669z00zz__evaluatez00))
																									{	/* Eval/evaluate.scm 319 */
																										return
																											BGl_convzd2beginzd2zz__evaluatez00
																											(CDR(BgL_ez00_49),
																											BgL_localsz00_50,
																											BgL_globalsz00_51,
																											BgL_tailzf3zf3_52,
																											BgL_wherez00_53,
																											BgL_locz00_54,
																											BgL_topzf3zf3_55);
																									}
																								else
																									{	/* Eval/evaluate.scm 319 */
																										obj_t
																											BgL_cdrzd211131zd2_1369;
																										BgL_cdrzd211131zd2_1369 =
																											CDR(BgL_ez00_49);
																										if ((CAR(BgL_ez00_49) ==
																												BGl_symbol2671z00zz__evaluatez00))
																											{	/* Eval/evaluate.scm 319 */
																												if (PAIRP
																													(BgL_cdrzd211131zd2_1369))
																													{	/* Eval/evaluate.scm 319 */
																														obj_t
																															BgL_arg1763z00_1372;
																														obj_t
																															BgL_arg1764z00_1373;
																														BgL_arg1763z00_1372
																															=
																															CAR
																															(BgL_cdrzd211131zd2_1369);
																														BgL_arg1764z00_1373
																															=
																															CDR
																															(BgL_cdrzd211131zd2_1369);
																														{
																															BgL_ev_letz00_bglt
																																BgL_auxz00_5898;
																															{
																																obj_t
																																	BgL_bodyz00_5900;
																																obj_t
																																	BgL_bindsz00_5899;
																																BgL_bindsz00_5899
																																	=
																																	BgL_arg1763z00_1372;
																																BgL_bodyz00_5900
																																	=
																																	BgL_arg1764z00_1373;
																																BgL_bodyz00_896
																																	=
																																	BgL_bodyz00_5900;
																																BgL_bindsz00_895
																																	=
																																	BgL_bindsz00_5899;
																																goto
																																	BgL_tagzd2142zd2_897;
																															}
																															return
																																((obj_t)
																																BgL_auxz00_5898);
																														}
																													}
																												else
																													{	/* Eval/evaluate.scm 319 */
																														obj_t
																															BgL_arg1766z00_1374;
																														BgL_arg1766z00_1374
																															=
																															CAR(BgL_ez00_49);
																														{
																															BgL_ev_appz00_bglt
																																BgL_auxz00_5903;
																															{
																																obj_t
																																	BgL_argsz00_5905;
																																obj_t
																																	BgL_fz00_5904;
																																BgL_fz00_5904 =
																																	BgL_arg1766z00_1374;
																																BgL_argsz00_5905
																																	=
																																	BgL_cdrzd211131zd2_1369;
																																BgL_argsz00_942
																																	=
																																	BgL_argsz00_5905;
																																BgL_fz00_941 =
																																	BgL_fz00_5904;
																																goto
																																	BgL_tagzd2157zd2_943;
																															}
																															return
																																((obj_t)
																																BgL_auxz00_5903);
																														}
																													}
																											}
																										else
																											{	/* Eval/evaluate.scm 319 */
																												if (
																													(CAR(BgL_ez00_49) ==
																														BGl_symbol2673z00zz__evaluatez00))
																													{	/* Eval/evaluate.scm 319 */
																														if (PAIRP
																															(BgL_cdrzd211131zd2_1369))
																															{	/* Eval/evaluate.scm 319 */
																																obj_t
																																	BgL_arg1771z00_1379;
																																obj_t
																																	BgL_arg1773z00_1380;
																																BgL_arg1771z00_1379
																																	=
																																	CAR
																																	(BgL_cdrzd211131zd2_1369);
																																BgL_arg1773z00_1380
																																	=
																																	CDR
																																	(BgL_cdrzd211131zd2_1369);
																																{
																																	BgL_ev_letza2za2_bglt
																																		BgL_auxz00_5914;
																																	{
																																		obj_t
																																			BgL_bodyz00_5916;
																																		obj_t
																																			BgL_bindsz00_5915;
																																		BgL_bindsz00_5915
																																			=
																																			BgL_arg1771z00_1379;
																																		BgL_bodyz00_5916
																																			=
																																			BgL_arg1773z00_1380;
																																		BgL_bodyz00_899
																																			=
																																			BgL_bodyz00_5916;
																																		BgL_bindsz00_898
																																			=
																																			BgL_bindsz00_5915;
																																		goto
																																			BgL_tagzd2143zd2_900;
																																	}
																																	return
																																		((obj_t)
																																		BgL_auxz00_5914);
																																}
																															}
																														else
																															{	/* Eval/evaluate.scm 319 */
																																obj_t
																																	BgL_arg1774z00_1381;
																																obj_t
																																	BgL_arg1775z00_1382;
																																BgL_arg1774z00_1381
																																	=
																																	CAR
																																	(BgL_ez00_49);
																																BgL_arg1775z00_1382
																																	=
																																	CDR
																																	(BgL_ez00_49);
																																{
																																	BgL_ev_appz00_bglt
																																		BgL_auxz00_5920;
																																	{
																																		obj_t
																																			BgL_argsz00_5922;
																																		obj_t
																																			BgL_fz00_5921;
																																		BgL_fz00_5921
																																			=
																																			BgL_arg1774z00_1381;
																																		BgL_argsz00_5922
																																			=
																																			BgL_arg1775z00_1382;
																																		BgL_argsz00_942
																																			=
																																			BgL_argsz00_5922;
																																		BgL_fz00_941
																																			=
																																			BgL_fz00_5921;
																																		goto
																																			BgL_tagzd2157zd2_943;
																																	}
																																	return
																																		((obj_t)
																																		BgL_auxz00_5920);
																																}
																															}
																													}
																												else
																													{	/* Eval/evaluate.scm 319 */
																														obj_t
																															BgL_cdrzd211525zd2_1383;
																														BgL_cdrzd211525zd2_1383
																															=
																															CDR(BgL_ez00_49);
																														if ((CAR
																																(BgL_ez00_49) ==
																																BGl_symbol2675z00zz__evaluatez00))
																															{	/* Eval/evaluate.scm 319 */
																																if (PAIRP
																																	(BgL_cdrzd211525zd2_1383))
																																	{	/* Eval/evaluate.scm 319 */
																																		obj_t
																																			BgL_arg1778z00_1386;
																																		obj_t
																																			BgL_arg1779z00_1387;
																																		BgL_arg1778z00_1386
																																			=
																																			CAR
																																			(BgL_cdrzd211525zd2_1383);
																																		BgL_arg1779z00_1387
																																			=
																																			CDR
																																			(BgL_cdrzd211525zd2_1383);
																																		{
																																			BgL_ev_letrecz00_bglt
																																				BgL_auxz00_5932;
																																			{
																																				obj_t
																																					BgL_bodyz00_5934;
																																				obj_t
																																					BgL_bindsz00_5933;
																																				BgL_bindsz00_5933
																																					=
																																					BgL_arg1778z00_1386;
																																				BgL_bodyz00_5934
																																					=
																																					BgL_arg1779z00_1387;
																																				BgL_bodyz00_902
																																					=
																																					BgL_bodyz00_5934;
																																				BgL_bindsz00_901
																																					=
																																					BgL_bindsz00_5933;
																																				goto
																																					BgL_tagzd2144zd2_903;
																																			}
																																			return
																																				((obj_t)
																																				BgL_auxz00_5932);
																																		}
																																	}
																																else
																																	{	/* Eval/evaluate.scm 319 */
																																		obj_t
																																			BgL_arg1780z00_1388;
																																		BgL_arg1780z00_1388
																																			=
																																			CAR
																																			(BgL_ez00_49);
																																		{
																																			BgL_ev_appz00_bglt
																																				BgL_auxz00_5937;
																																			{
																																				obj_t
																																					BgL_argsz00_5939;
																																				obj_t
																																					BgL_fz00_5938;
																																				BgL_fz00_5938
																																					=
																																					BgL_arg1780z00_1388;
																																				BgL_argsz00_5939
																																					=
																																					BgL_cdrzd211525zd2_1383;
																																				BgL_argsz00_942
																																					=
																																					BgL_argsz00_5939;
																																				BgL_fz00_941
																																					=
																																					BgL_fz00_5938;
																																				goto
																																					BgL_tagzd2157zd2_943;
																																			}
																																			return
																																				((obj_t)
																																				BgL_auxz00_5937);
																																		}
																																	}
																															}
																														else
																															{	/* Eval/evaluate.scm 319 */
																																if (
																																	(CAR
																																		(BgL_ez00_49)
																																		==
																																		BGl_symbol2677z00zz__evaluatez00))
																																	{	/* Eval/evaluate.scm 319 */
																																		if (PAIRP
																																			(BgL_cdrzd211525zd2_1383))
																																			{	/* Eval/evaluate.scm 319 */
																																				obj_t
																																					BgL_carzd211699zd2_1393;
																																				obj_t
																																					BgL_cdrzd211700zd2_1394;
																																				BgL_carzd211699zd2_1393
																																					=
																																					CAR
																																					(BgL_cdrzd211525zd2_1383);
																																				BgL_cdrzd211700zd2_1394
																																					=
																																					CDR
																																					(BgL_cdrzd211525zd2_1383);
																																				if (PAIRP(BgL_carzd211699zd2_1393))
																																					{	/* Eval/evaluate.scm 319 */
																																						obj_t
																																							BgL_cdrzd211704zd2_1396;
																																						BgL_cdrzd211704zd2_1396
																																							=
																																							CDR
																																							(BgL_carzd211699zd2_1393);
																																						if (
																																							(CAR
																																								(BgL_carzd211699zd2_1393)
																																								==
																																								BGl_symbol2655z00zz__evaluatez00))
																																							{	/* Eval/evaluate.scm 319 */
																																								if (PAIRP(BgL_cdrzd211704zd2_1396))
																																									{	/* Eval/evaluate.scm 319 */
																																										obj_t
																																											BgL_carzd211707zd2_1399;
																																										obj_t
																																											BgL_cdrzd211708zd2_1400;
																																										BgL_carzd211707zd2_1399
																																											=
																																											CAR
																																											(BgL_cdrzd211704zd2_1396);
																																										BgL_cdrzd211708zd2_1400
																																											=
																																											CDR
																																											(BgL_cdrzd211704zd2_1396);
																																										if (SYMBOLP(BgL_carzd211707zd2_1399))
																																											{	/* Eval/evaluate.scm 319 */
																																												if (PAIRP(BgL_cdrzd211708zd2_1400))
																																													{	/* Eval/evaluate.scm 319 */
																																														obj_t
																																															BgL_carzd211712zd2_1403;
																																														BgL_carzd211712zd2_1403
																																															=
																																															CAR
																																															(BgL_cdrzd211708zd2_1400);
																																														if (SYMBOLP(BgL_carzd211712zd2_1403))
																																															{	/* Eval/evaluate.scm 319 */
																																																if (NULLP(CDR(BgL_cdrzd211708zd2_1400)))
																																																	{	/* Eval/evaluate.scm 319 */
																																																		if (PAIRP(BgL_cdrzd211700zd2_1394))
																																																			{	/* Eval/evaluate.scm 319 */
																																																				if (NULLP(CDR(BgL_cdrzd211700zd2_1394)))
																																																					{	/* Eval/evaluate.scm 319 */
																																																						obj_t
																																																							BgL_arg1793z00_1408;
																																																						BgL_arg1793z00_1408
																																																							=
																																																							CAR
																																																							(BgL_cdrzd211700zd2_1394);
																																																						{	/* Eval/evaluate.scm 319 */
																																																							obj_t
																																																								BgL_idz00_3590;
																																																							obj_t
																																																								BgL_modnamez00_3591;
																																																							BgL_idz00_3590
																																																								=
																																																								BgL_carzd211707zd2_1399;
																																																							BgL_modnamez00_3591
																																																								=
																																																								BgL_carzd211712zd2_1403;
																																																							{	/* Eval/evaluate.scm 424 */
																																																								BgL_ev_setglobalz00_bglt
																																																									BgL_new1136z00_3593;
																																																								{	/* Eval/evaluate.scm 424 */
																																																									BgL_ev_setglobalz00_bglt
																																																										BgL_new1135z00_3594;
																																																									BgL_new1135z00_3594
																																																										=
																																																										(
																																																										(BgL_ev_setglobalz00_bglt)
																																																										BREF
																																																										(GC_MALLOC
																																																											(sizeof
																																																												(struct
																																																													BgL_ev_setglobalz00_bgl))));
																																																									{	/* Eval/evaluate.scm 424 */
																																																										long
																																																											BgL_arg2062z00_3595;
																																																										{	/* Eval/evaluate.scm 424 */
																																																											long
																																																												BgL_res2556z00_3597;
																																																											BgL_res2556z00_3597
																																																												=
																																																												BGL_CLASS_INDEX
																																																												(BGl_ev_setglobalz00zz__evaluate_typesz00);
																																																											BgL_arg2062z00_3595
																																																												=
																																																												BgL_res2556z00_3597;
																																																										}
																																																										{	/* Eval/evaluate.scm 424 */
																																																											BgL_objectz00_bglt
																																																												BgL_objz00_3598;
																																																											BgL_objz00_3598
																																																												=
																																																												(
																																																												(BgL_objectz00_bglt)
																																																												BgL_new1135z00_3594);
																																																											BGL_OBJECT_CLASS_NUM_SET
																																																												(BgL_objz00_3598,
																																																												BgL_arg2062z00_3595);
																																																									}}
																																																									{	/* Eval/evaluate.scm 424 */
																																																										BgL_objectz00_bglt
																																																											BgL_auxz00_5978;
																																																										BgL_auxz00_5978
																																																											=
																																																											(
																																																											(BgL_objectz00_bglt)
																																																											BgL_new1135z00_3594);
																																																										BGL_OBJECT_WIDENING_SET
																																																											(BgL_auxz00_5978,
																																																											BFALSE);
																																																									}
																																																									BgL_new1136z00_3593
																																																										=
																																																										BgL_new1135z00_3594;
																																																								}
																																																								{
																																																									BgL_ev_exprz00_bglt
																																																										BgL_auxz00_5981;
																																																									{	/* Eval/evaluate.scm 280 */
																																																										obj_t
																																																											BgL_arg2097z00_3601;
																																																										BgL_arg2097z00_3601
																																																											=
																																																											BGl_getzd2locationzd2zz__evaluatez00
																																																											(BgL_arg1793z00_1408,
																																																											BgL_locz00_54);
																																																										BgL_auxz00_5981
																																																											=
																																																											(
																																																											(BgL_ev_exprz00_bglt)
																																																											BGl_uconvzf2loczf2zz__evaluatez00
																																																											(BgL_wherez00_53,
																																																												BgL_globalsz00_51,
																																																												BgL_localsz00_50,
																																																												BgL_arg1793z00_1408,
																																																												BgL_arg2097z00_3601));
																																																									}
																																																									((((BgL_ev_hookz00_bglt) CREF(((BgL_ev_hookz00_bglt) BgL_new1136z00_3593)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5981), BUNSPEC);
																																																								}
																																																								((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1136z00_3593))->BgL_locz00) = ((obj_t) BgL_locz00_54), BUNSPEC);
																																																								((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1136z00_3593))->BgL_namez00) = ((obj_t) BgL_idz00_3590), BUNSPEC);
																																																								((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1136z00_3593))->BgL_modz00) = ((obj_t) BGl_evalzd2findzd2modulez00zz__evmodulez00(BgL_modnamez00_3591)), BUNSPEC);
																																																								return
																																																									(
																																																									(obj_t)
																																																									BgL_new1136z00_3593);
																																																							}
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 319 */
																																																						return
																																																							BGl_evcompilezd2errorzd2zz__evcompilez00
																																																							(BgL_locz00_54,
																																																							BGl_string2643z00zz__evaluatez00,
																																																							BGl_string2649z00zz__evaluatez00,
																																																							BgL_ez00_49);
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 319 */
																																																				return
																																																					BGl_evcompilezd2errorzd2zz__evcompilez00
																																																					(BgL_locz00_54,
																																																					BGl_string2643z00zz__evaluatez00,
																																																					BGl_string2649z00zz__evaluatez00,
																																																					BgL_ez00_49);
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 319 */
																																																		obj_t
																																																			BgL_cdrzd211828zd2_1410;
																																																		BgL_cdrzd211828zd2_1410
																																																			=
																																																			CDR
																																																			(BgL_ez00_49);
																																																		{	/* Eval/evaluate.scm 319 */
																																																			obj_t
																																																				BgL_cdrzd211832zd2_1411;
																																																			BgL_cdrzd211832zd2_1411
																																																				=
																																																				CDR
																																																				(BgL_cdrzd211828zd2_1410);
																																																			if (PAIRP(BgL_cdrzd211832zd2_1411))
																																																				{	/* Eval/evaluate.scm 319 */
																																																					if (NULLP(CDR(BgL_cdrzd211832zd2_1411)))
																																																						{	/* Eval/evaluate.scm 319 */
																																																							obj_t
																																																								BgL_arg1797z00_1414;
																																																							obj_t
																																																								BgL_arg1798z00_1415;
																																																							BgL_arg1797z00_1414
																																																								=
																																																								CAR
																																																								(BgL_cdrzd211828zd2_1410);
																																																							BgL_arg1798z00_1415
																																																								=
																																																								CAR
																																																								(BgL_cdrzd211832zd2_1411);
																																																							{
																																																								BgL_ev_hookz00_bglt
																																																									BgL_auxz00_6003;
																																																								{
																																																									obj_t
																																																										BgL_ez00_6005;
																																																									obj_t
																																																										BgL_vz00_6004;
																																																									BgL_vz00_6004
																																																										=
																																																										BgL_arg1797z00_1414;
																																																									BgL_ez00_6005
																																																										=
																																																										BgL_arg1798z00_1415;
																																																									BgL_ez00_912
																																																										=
																																																										BgL_ez00_6005;
																																																									BgL_vz00_911
																																																										=
																																																										BgL_vz00_6004;
																																																									goto
																																																										BgL_tagzd2147zd2_913;
																																																								}
																																																								return
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_6003);
																																																							}
																																																						}
																																																					else
																																																						{	/* Eval/evaluate.scm 319 */
																																																							return
																																																								BGl_evcompilezd2errorzd2zz__evcompilez00
																																																								(BgL_locz00_54,
																																																								BGl_string2643z00zz__evaluatez00,
																																																								BGl_string2649z00zz__evaluatez00,
																																																								BgL_ez00_49);
																																																						}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate.scm 319 */
																																																					return
																																																						BGl_evcompilezd2errorzd2zz__evcompilez00
																																																						(BgL_locz00_54,
																																																						BGl_string2643z00zz__evaluatez00,
																																																						BGl_string2649z00zz__evaluatez00,
																																																						BgL_ez00_49);
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 319 */
																																																obj_t
																																																	BgL_cdrzd211889zd2_1418;
																																																BgL_cdrzd211889zd2_1418
																																																	=
																																																	CDR
																																																	(BgL_ez00_49);
																																																{	/* Eval/evaluate.scm 319 */
																																																	obj_t
																																																		BgL_cdrzd211893zd2_1419;
																																																	BgL_cdrzd211893zd2_1419
																																																		=
																																																		CDR
																																																		(BgL_cdrzd211889zd2_1418);
																																																	if (PAIRP(BgL_cdrzd211893zd2_1419))
																																																		{	/* Eval/evaluate.scm 319 */
																																																			if (NULLP(CDR(BgL_cdrzd211893zd2_1419)))
																																																				{	/* Eval/evaluate.scm 319 */
																																																					obj_t
																																																						BgL_arg1803z00_1422;
																																																					obj_t
																																																						BgL_arg1804z00_1423;
																																																					BgL_arg1803z00_1422
																																																						=
																																																						CAR
																																																						(BgL_cdrzd211889zd2_1418);
																																																					BgL_arg1804z00_1423
																																																						=
																																																						CAR
																																																						(BgL_cdrzd211893zd2_1419);
																																																					{
																																																						BgL_ev_hookz00_bglt
																																																							BgL_auxz00_6018;
																																																						{
																																																							obj_t
																																																								BgL_ez00_6020;
																																																							obj_t
																																																								BgL_vz00_6019;
																																																							BgL_vz00_6019
																																																								=
																																																								BgL_arg1803z00_1422;
																																																							BgL_ez00_6020
																																																								=
																																																								BgL_arg1804z00_1423;
																																																							BgL_ez00_912
																																																								=
																																																								BgL_ez00_6020;
																																																							BgL_vz00_911
																																																								=
																																																								BgL_vz00_6019;
																																																							goto
																																																								BgL_tagzd2147zd2_913;
																																																						}
																																																						return
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_6018);
																																																					}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate.scm 319 */
																																																					return
																																																						BGl_evcompilezd2errorzd2zz__evcompilez00
																																																						(BgL_locz00_54,
																																																						BGl_string2643z00zz__evaluatez00,
																																																						BGl_string2649z00zz__evaluatez00,
																																																						BgL_ez00_49);
																																																				}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 319 */
																																																			return
																																																				BGl_evcompilezd2errorzd2zz__evcompilez00
																																																				(BgL_locz00_54,
																																																				BGl_string2643z00zz__evaluatez00,
																																																				BGl_string2649z00zz__evaluatez00,
																																																				BgL_ez00_49);
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 319 */
																																														obj_t
																																															BgL_cdrzd211950zd2_1425;
																																														BgL_cdrzd211950zd2_1425
																																															=
																																															CDR
																																															(BgL_ez00_49);
																																														{	/* Eval/evaluate.scm 319 */
																																															obj_t
																																																BgL_cdrzd211954zd2_1426;
																																															BgL_cdrzd211954zd2_1426
																																																=
																																																CDR
																																																(BgL_cdrzd211950zd2_1425);
																																															if (PAIRP(BgL_cdrzd211954zd2_1426))
																																																{	/* Eval/evaluate.scm 319 */
																																																	if (NULLP(CDR(BgL_cdrzd211954zd2_1426)))
																																																		{	/* Eval/evaluate.scm 319 */
																																																			obj_t
																																																				BgL_arg1808z00_1429;
																																																			obj_t
																																																				BgL_arg1809z00_1430;
																																																			BgL_arg1808z00_1429
																																																				=
																																																				CAR
																																																				(BgL_cdrzd211950zd2_1425);
																																																			BgL_arg1809z00_1430
																																																				=
																																																				CAR
																																																				(BgL_cdrzd211954zd2_1426);
																																																			{
																																																				BgL_ev_hookz00_bglt
																																																					BgL_auxz00_6033;
																																																				{
																																																					obj_t
																																																						BgL_ez00_6035;
																																																					obj_t
																																																						BgL_vz00_6034;
																																																					BgL_vz00_6034
																																																						=
																																																						BgL_arg1808z00_1429;
																																																					BgL_ez00_6035
																																																						=
																																																						BgL_arg1809z00_1430;
																																																					BgL_ez00_912
																																																						=
																																																						BgL_ez00_6035;
																																																					BgL_vz00_911
																																																						=
																																																						BgL_vz00_6034;
																																																					goto
																																																						BgL_tagzd2147zd2_913;
																																																				}
																																																				return
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_6033);
																																																			}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 319 */
																																																			return
																																																				BGl_evcompilezd2errorzd2zz__evcompilez00
																																																				(BgL_locz00_54,
																																																				BGl_string2643z00zz__evaluatez00,
																																																				BGl_string2649z00zz__evaluatez00,
																																																				BgL_ez00_49);
																																																		}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 319 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_54,
																																																		BGl_string2643z00zz__evaluatez00,
																																																		BGl_string2649z00zz__evaluatez00,
																																																		BgL_ez00_49);
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 319 */
																																												obj_t
																																													BgL_cdrzd212011zd2_1432;
																																												BgL_cdrzd212011zd2_1432
																																													=
																																													CDR
																																													(BgL_ez00_49);
																																												{	/* Eval/evaluate.scm 319 */
																																													obj_t
																																														BgL_cdrzd212015zd2_1433;
																																													BgL_cdrzd212015zd2_1433
																																														=
																																														CDR
																																														(BgL_cdrzd212011zd2_1432);
																																													if (PAIRP(BgL_cdrzd212015zd2_1433))
																																														{	/* Eval/evaluate.scm 319 */
																																															if (NULLP(CDR(BgL_cdrzd212015zd2_1433)))
																																																{	/* Eval/evaluate.scm 319 */
																																																	obj_t
																																																		BgL_arg1813z00_1436;
																																																	obj_t
																																																		BgL_arg1814z00_1437;
																																																	BgL_arg1813z00_1436
																																																		=
																																																		CAR
																																																		(BgL_cdrzd212011zd2_1432);
																																																	BgL_arg1814z00_1437
																																																		=
																																																		CAR
																																																		(BgL_cdrzd212015zd2_1433);
																																																	{
																																																		BgL_ev_hookz00_bglt
																																																			BgL_auxz00_6048;
																																																		{
																																																			obj_t
																																																				BgL_ez00_6050;
																																																			obj_t
																																																				BgL_vz00_6049;
																																																			BgL_vz00_6049
																																																				=
																																																				BgL_arg1813z00_1436;
																																																			BgL_ez00_6050
																																																				=
																																																				BgL_arg1814z00_1437;
																																																			BgL_ez00_912
																																																				=
																																																				BgL_ez00_6050;
																																																			BgL_vz00_911
																																																				=
																																																				BgL_vz00_6049;
																																																			goto
																																																				BgL_tagzd2147zd2_913;
																																																		}
																																																		return
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_6048);
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 319 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_54,
																																																		BGl_string2643z00zz__evaluatez00,
																																																		BGl_string2649z00zz__evaluatez00,
																																																		BgL_ez00_49);
																																																}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 319 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_54,
																																																BGl_string2643z00zz__evaluatez00,
																																																BGl_string2649z00zz__evaluatez00,
																																																BgL_ez00_49);
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 319 */
																																										obj_t
																																											BgL_cdrzd212072zd2_1439;
																																										BgL_cdrzd212072zd2_1439
																																											=
																																											CDR
																																											(BgL_ez00_49);
																																										{	/* Eval/evaluate.scm 319 */
																																											obj_t
																																												BgL_cdrzd212076zd2_1440;
																																											BgL_cdrzd212076zd2_1440
																																												=
																																												CDR
																																												(BgL_cdrzd212072zd2_1439);
																																											if (PAIRP(BgL_cdrzd212076zd2_1440))
																																												{	/* Eval/evaluate.scm 319 */
																																													if (NULLP(CDR(BgL_cdrzd212076zd2_1440)))
																																														{	/* Eval/evaluate.scm 319 */
																																															obj_t
																																																BgL_arg1819z00_1443;
																																															obj_t
																																																BgL_arg1820z00_1444;
																																															BgL_arg1819z00_1443
																																																=
																																																CAR
																																																(BgL_cdrzd212072zd2_1439);
																																															BgL_arg1820z00_1444
																																																=
																																																CAR
																																																(BgL_cdrzd212076zd2_1440);
																																															{
																																																BgL_ev_hookz00_bglt
																																																	BgL_auxz00_6063;
																																																{
																																																	obj_t
																																																		BgL_ez00_6065;
																																																	obj_t
																																																		BgL_vz00_6064;
																																																	BgL_vz00_6064
																																																		=
																																																		BgL_arg1819z00_1443;
																																																	BgL_ez00_6065
																																																		=
																																																		BgL_arg1820z00_1444;
																																																	BgL_ez00_912
																																																		=
																																																		BgL_ez00_6065;
																																																	BgL_vz00_911
																																																		=
																																																		BgL_vz00_6064;
																																																	goto
																																																		BgL_tagzd2147zd2_913;
																																																}
																																																return
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_6063);
																																															}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 319 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_54,
																																																BGl_string2643z00zz__evaluatez00,
																																																BGl_string2649z00zz__evaluatez00,
																																																BgL_ez00_49);
																																														}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 319 */
																																													return
																																														BGl_evcompilezd2errorzd2zz__evcompilez00
																																														(BgL_locz00_54,
																																														BGl_string2643z00zz__evaluatez00,
																																														BGl_string2649z00zz__evaluatez00,
																																														BgL_ez00_49);
																																												}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 319 */
																																								obj_t
																																									BgL_cdrzd212120zd2_1446;
																																								BgL_cdrzd212120zd2_1446
																																									=
																																									CDR
																																									(BgL_ez00_49);
																																								{	/* Eval/evaluate.scm 319 */
																																									obj_t
																																										BgL_carzd212123zd2_1447;
																																									obj_t
																																										BgL_cdrzd212124zd2_1448;
																																									BgL_carzd212123zd2_1447
																																										=
																																										CAR
																																										(BgL_cdrzd212120zd2_1446);
																																									BgL_cdrzd212124zd2_1448
																																										=
																																										CDR
																																										(BgL_cdrzd212120zd2_1446);
																																									if ((CAR(BgL_carzd212123zd2_1447) == BGl_symbol2657z00zz__evaluatez00))
																																										{	/* Eval/evaluate.scm 319 */
																																											if (PAIRP(BgL_cdrzd212124zd2_1448))
																																												{	/* Eval/evaluate.scm 319 */
																																													if (NULLP(CDR(BgL_cdrzd212124zd2_1448)))
																																														{
																																															obj_t
																																																BgL_e2z00_6082;
																																															obj_t
																																																BgL_lz00_6080;
																																															BgL_lz00_6080
																																																=
																																																CDR
																																																(BgL_carzd212123zd2_1447);
																																															BgL_e2z00_6082
																																																=
																																																CAR
																																																(BgL_cdrzd212124zd2_1448);
																																															BgL_e2z00_909
																																																=
																																																BgL_e2z00_6082;
																																															BgL_lz00_908
																																																=
																																																BgL_lz00_6080;
																																															goto
																																																BgL_tagzd2146zd2_910;
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 319 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_54,
																																																BGl_string2643z00zz__evaluatez00,
																																																BGl_string2649z00zz__evaluatez00,
																																																BgL_ez00_49);
																																														}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 319 */
																																													return
																																														BGl_evcompilezd2errorzd2zz__evcompilez00
																																														(BgL_locz00_54,
																																														BGl_string2643z00zz__evaluatez00,
																																														BGl_string2649z00zz__evaluatez00,
																																														BgL_ez00_49);
																																												}
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 319 */
																																											obj_t
																																												BgL_cdrzd212200zd2_1456;
																																											BgL_cdrzd212200zd2_1456
																																												=
																																												CDR
																																												(BgL_cdrzd212120zd2_1446);
																																											if (PAIRP(BgL_cdrzd212200zd2_1456))
																																												{	/* Eval/evaluate.scm 319 */
																																													if (NULLP(CDR(BgL_cdrzd212200zd2_1456)))
																																														{	/* Eval/evaluate.scm 319 */
																																															obj_t
																																																BgL_arg1830z00_1459;
																																															obj_t
																																																BgL_arg1831z00_1460;
																																															BgL_arg1830z00_1459
																																																=
																																																CAR
																																																(BgL_cdrzd212120zd2_1446);
																																															BgL_arg1831z00_1460
																																																=
																																																CAR
																																																(BgL_cdrzd212200zd2_1456);
																																															{
																																																BgL_ev_hookz00_bglt
																																																	BgL_auxz00_6094;
																																																{
																																																	obj_t
																																																		BgL_ez00_6096;
																																																	obj_t
																																																		BgL_vz00_6095;
																																																	BgL_vz00_6095
																																																		=
																																																		BgL_arg1830z00_1459;
																																																	BgL_ez00_6096
																																																		=
																																																		BgL_arg1831z00_1460;
																																																	BgL_ez00_912
																																																		=
																																																		BgL_ez00_6096;
																																																	BgL_vz00_911
																																																		=
																																																		BgL_vz00_6095;
																																																	goto
																																																		BgL_tagzd2147zd2_913;
																																																}
																																																return
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_6094);
																																															}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 319 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_54,
																																																BGl_string2643z00zz__evaluatez00,
																																																BGl_string2649z00zz__evaluatez00,
																																																BgL_ez00_49);
																																														}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 319 */
																																													return
																																														BGl_evcompilezd2errorzd2zz__evcompilez00
																																														(BgL_locz00_54,
																																														BGl_string2643z00zz__evaluatez00,
																																														BGl_string2649z00zz__evaluatez00,
																																														BgL_ez00_49);
																																												}
																																										}
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 319 */
																																						obj_t
																																							BgL_cdrzd212257zd2_1464;
																																						BgL_cdrzd212257zd2_1464
																																							=
																																							CDR
																																							(BgL_ez00_49);
																																						{	/* Eval/evaluate.scm 319 */
																																							obj_t
																																								BgL_cdrzd212261zd2_1465;
																																							BgL_cdrzd212261zd2_1465
																																								=
																																								CDR
																																								(BgL_cdrzd212257zd2_1464);
																																							if (PAIRP(BgL_cdrzd212261zd2_1465))
																																								{	/* Eval/evaluate.scm 319 */
																																									if (NULLP(CDR(BgL_cdrzd212261zd2_1465)))
																																										{	/* Eval/evaluate.scm 319 */
																																											obj_t
																																												BgL_arg1837z00_1468;
																																											obj_t
																																												BgL_arg1838z00_1469;
																																											BgL_arg1837z00_1468
																																												=
																																												CAR
																																												(BgL_cdrzd212257zd2_1464);
																																											BgL_arg1838z00_1469
																																												=
																																												CAR
																																												(BgL_cdrzd212261zd2_1465);
																																											{
																																												BgL_ev_hookz00_bglt
																																													BgL_auxz00_6109;
																																												{
																																													obj_t
																																														BgL_ez00_6111;
																																													obj_t
																																														BgL_vz00_6110;
																																													BgL_vz00_6110
																																														=
																																														BgL_arg1837z00_1468;
																																													BgL_ez00_6111
																																														=
																																														BgL_arg1838z00_1469;
																																													BgL_ez00_912
																																														=
																																														BgL_ez00_6111;
																																													BgL_vz00_911
																																														=
																																														BgL_vz00_6110;
																																													goto
																																														BgL_tagzd2147zd2_913;
																																												}
																																												return
																																													(
																																													(obj_t)
																																													BgL_auxz00_6109);
																																											}
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 319 */
																																											return
																																												BGl_evcompilezd2errorzd2zz__evcompilez00
																																												(BgL_locz00_54,
																																												BGl_string2643z00zz__evaluatez00,
																																												BGl_string2649z00zz__evaluatez00,
																																												BgL_ez00_49);
																																										}
																																								}
																																							else
																																								{	/* Eval/evaluate.scm 319 */
																																									return
																																										BGl_evcompilezd2errorzd2zz__evcompilez00
																																										(BgL_locz00_54,
																																										BGl_string2643z00zz__evaluatez00,
																																										BGl_string2649z00zz__evaluatez00,
																																										BgL_ez00_49);
																																								}
																																						}
																																					}
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 319 */
																																				return
																																					BGl_evcompilezd2errorzd2zz__evcompilez00
																																					(BgL_locz00_54,
																																					BGl_string2643z00zz__evaluatez00,
																																					BGl_string2649z00zz__evaluatez00,
																																					BgL_ez00_49);
																																			}
																																	}
																																else
																																	{	/* Eval/evaluate.scm 319 */
																																		obj_t
																																			BgL_cdrzd212382zd2_1471;
																																		BgL_cdrzd212382zd2_1471
																																			=
																																			CDR
																																			(BgL_ez00_49);
																																		if ((CAR
																																				(BgL_ez00_49)
																																				==
																																				BGl_symbol2679z00zz__evaluatez00))
																																			{	/* Eval/evaluate.scm 319 */
																																				if (PAIRP(BgL_cdrzd212382zd2_1471))
																																					{	/* Eval/evaluate.scm 319 */
																																						obj_t
																																							BgL_cdrzd212387zd2_1474;
																																						BgL_cdrzd212387zd2_1474
																																							=
																																							CDR
																																							(BgL_cdrzd212382zd2_1471);
																																						if (PAIRP(BgL_cdrzd212387zd2_1474))
																																							{	/* Eval/evaluate.scm 319 */
																																								obj_t
																																									BgL_carzd212391zd2_1476;
																																								BgL_carzd212391zd2_1476
																																									=
																																									CAR
																																									(BgL_cdrzd212387zd2_1474);
																																								if (PAIRP(BgL_carzd212391zd2_1476))
																																									{	/* Eval/evaluate.scm 319 */
																																										obj_t
																																											BgL_cdrzd212396zd2_1478;
																																										BgL_cdrzd212396zd2_1478
																																											=
																																											CDR
																																											(BgL_carzd212391zd2_1476);
																																										if ((CAR(BgL_carzd212391zd2_1476) == BGl_symbol2681z00zz__evaluatez00))
																																											{	/* Eval/evaluate.scm 319 */
																																												if (PAIRP(BgL_cdrzd212396zd2_1478))
																																													{	/* Eval/evaluate.scm 319 */
																																														obj_t
																																															BgL_cdrzd212400zd2_1481;
																																														BgL_cdrzd212400zd2_1481
																																															=
																																															CDR
																																															(BgL_cdrzd212396zd2_1478);
																																														if (PAIRP(BgL_cdrzd212400zd2_1481))
																																															{	/* Eval/evaluate.scm 319 */
																																																if (NULLP(CDR(BgL_cdrzd212400zd2_1481)))
																																																	{	/* Eval/evaluate.scm 319 */
																																																		if (NULLP(CDR(BgL_cdrzd212387zd2_1474)))
																																																			{	/* Eval/evaluate.scm 319 */
																																																				obj_t
																																																					BgL_arg1849z00_1485;
																																																				obj_t
																																																					BgL_arg1850z00_1486;
																																																				obj_t
																																																					BgL_arg1851z00_1487;
																																																				BgL_arg1849z00_1485
																																																					=
																																																					CAR
																																																					(BgL_cdrzd212382zd2_1471);
																																																				BgL_arg1850z00_1486
																																																					=
																																																					CAR
																																																					(BgL_cdrzd212396zd2_1478);
																																																				BgL_arg1851z00_1487
																																																					=
																																																					CAR
																																																					(BgL_cdrzd212400zd2_1481);
																																																				{
																																																					BgL_ev_defglobalz00_bglt
																																																						BgL_auxz00_6146;
																																																					{
																																																						obj_t
																																																							BgL_bodyz00_6149;
																																																						obj_t
																																																							BgL_formalsz00_6148;
																																																						obj_t
																																																							BgL_gvz00_6147;
																																																						BgL_gvz00_6147
																																																							=
																																																							BgL_arg1849z00_1485;
																																																						BgL_formalsz00_6148
																																																							=
																																																							BgL_arg1850z00_1486;
																																																						BgL_bodyz00_6149
																																																							=
																																																							BgL_arg1851z00_1487;
																																																						BgL_bodyz00_917
																																																							=
																																																							BgL_bodyz00_6149;
																																																						BgL_formalsz00_916
																																																							=
																																																							BgL_formalsz00_6148;
																																																						BgL_gvz00_915
																																																							=
																																																							BgL_gvz00_6147;
																																																						goto
																																																							BgL_tagzd2149zd2_918;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6146);
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 319 */
																																																				obj_t
																																																					BgL_arg1852z00_1488;
																																																				BgL_arg1852z00_1488
																																																					=
																																																					CAR
																																																					(BgL_ez00_49);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_6152;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_6154;
																																																						obj_t
																																																							BgL_fz00_6153;
																																																						BgL_fz00_6153
																																																							=
																																																							BgL_arg1852z00_1488;
																																																						BgL_argsz00_6154
																																																							=
																																																							BgL_cdrzd212382zd2_1471;
																																																						BgL_argsz00_942
																																																							=
																																																							BgL_argsz00_6154;
																																																						BgL_fz00_941
																																																							=
																																																							BgL_fz00_6153;
																																																						goto
																																																							BgL_tagzd2157zd2_943;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6152);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 319 */
																																																		obj_t
																																																			BgL_cdrzd212500zd2_1492;
																																																		BgL_cdrzd212500zd2_1492
																																																			=
																																																			CDR
																																																			(BgL_cdrzd212382zd2_1471);
																																																		if (NULLP(CDR(BgL_cdrzd212500zd2_1492)))
																																																			{	/* Eval/evaluate.scm 319 */
																																																				obj_t
																																																					BgL_arg1856z00_1494;
																																																				obj_t
																																																					BgL_arg1857z00_1495;
																																																				BgL_arg1856z00_1494
																																																					=
																																																					CAR
																																																					(BgL_cdrzd212382zd2_1471);
																																																				BgL_arg1857z00_1495
																																																					=
																																																					CAR
																																																					(BgL_cdrzd212500zd2_1492);
																																																				{
																																																					BgL_ev_defglobalz00_bglt
																																																						BgL_auxz00_6162;
																																																					{
																																																						obj_t
																																																							BgL_gez00_6164;
																																																						obj_t
																																																							BgL_gvz00_6163;
																																																						BgL_gvz00_6163
																																																							=
																																																							BgL_arg1856z00_1494;
																																																						BgL_gez00_6164
																																																							=
																																																							BgL_arg1857z00_1495;
																																																						BgL_gez00_920
																																																							=
																																																							BgL_gez00_6164;
																																																						BgL_gvz00_919
																																																							=
																																																							BgL_gvz00_6163;
																																																						goto
																																																							BgL_tagzd2150zd2_921;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6162);
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 319 */
																																																				obj_t
																																																					BgL_arg1859z00_1496;
																																																				obj_t
																																																					BgL_arg1860z00_1497;
																																																				BgL_arg1859z00_1496
																																																					=
																																																					CAR
																																																					(BgL_ez00_49);
																																																				BgL_arg1860z00_1497
																																																					=
																																																					CDR
																																																					(BgL_ez00_49);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_6168;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_6170;
																																																						obj_t
																																																							BgL_fz00_6169;
																																																						BgL_fz00_6169
																																																							=
																																																							BgL_arg1859z00_1496;
																																																						BgL_argsz00_6170
																																																							=
																																																							BgL_arg1860z00_1497;
																																																						BgL_argsz00_942
																																																							=
																																																							BgL_argsz00_6170;
																																																						BgL_fz00_941
																																																							=
																																																							BgL_fz00_6169;
																																																						goto
																																																							BgL_tagzd2157zd2_943;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6168);
																																																				}
																																																			}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 319 */
																																																obj_t
																																																	BgL_cdrzd212587zd2_1501;
																																																BgL_cdrzd212587zd2_1501
																																																	=
																																																	CDR
																																																	(BgL_cdrzd212382zd2_1471);
																																																if (NULLP(CDR(BgL_cdrzd212587zd2_1501)))
																																																	{	/* Eval/evaluate.scm 319 */
																																																		obj_t
																																																			BgL_arg1864z00_1503;
																																																		obj_t
																																																			BgL_arg1866z00_1504;
																																																		BgL_arg1864z00_1503
																																																			=
																																																			CAR
																																																			(BgL_cdrzd212382zd2_1471);
																																																		BgL_arg1866z00_1504
																																																			=
																																																			CAR
																																																			(BgL_cdrzd212587zd2_1501);
																																																		{
																																																			BgL_ev_defglobalz00_bglt
																																																				BgL_auxz00_6178;
																																																			{
																																																				obj_t
																																																					BgL_gez00_6180;
																																																				obj_t
																																																					BgL_gvz00_6179;
																																																				BgL_gvz00_6179
																																																					=
																																																					BgL_arg1864z00_1503;
																																																				BgL_gez00_6180
																																																					=
																																																					BgL_arg1866z00_1504;
																																																				BgL_gez00_920
																																																					=
																																																					BgL_gez00_6180;
																																																				BgL_gvz00_919
																																																					=
																																																					BgL_gvz00_6179;
																																																				goto
																																																					BgL_tagzd2150zd2_921;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_6178);
																																																		}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 319 */
																																																		obj_t
																																																			BgL_arg1867z00_1505;
																																																		obj_t
																																																			BgL_arg1868z00_1506;
																																																		BgL_arg1867z00_1505
																																																			=
																																																			CAR
																																																			(BgL_ez00_49);
																																																		BgL_arg1868z00_1506
																																																			=
																																																			CDR
																																																			(BgL_ez00_49);
																																																		{
																																																			BgL_ev_appz00_bglt
																																																				BgL_auxz00_6184;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_6186;
																																																				obj_t
																																																					BgL_fz00_6185;
																																																				BgL_fz00_6185
																																																					=
																																																					BgL_arg1867z00_1505;
																																																				BgL_argsz00_6186
																																																					=
																																																					BgL_arg1868z00_1506;
																																																				BgL_argsz00_942
																																																					=
																																																					BgL_argsz00_6186;
																																																				BgL_fz00_941
																																																					=
																																																					BgL_fz00_6185;
																																																				goto
																																																					BgL_tagzd2157zd2_943;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_6184);
																																																		}
																																																	}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 319 */
																																														obj_t
																																															BgL_cdrzd212674zd2_1509;
																																														BgL_cdrzd212674zd2_1509
																																															=
																																															CDR
																																															(BgL_cdrzd212382zd2_1471);
																																														if (NULLP(CDR(BgL_cdrzd212674zd2_1509)))
																																															{	/* Eval/evaluate.scm 319 */
																																																obj_t
																																																	BgL_arg1871z00_1511;
																																																obj_t
																																																	BgL_arg1872z00_1512;
																																																BgL_arg1871z00_1511
																																																	=
																																																	CAR
																																																	(BgL_cdrzd212382zd2_1471);
																																																BgL_arg1872z00_1512
																																																	=
																																																	CAR
																																																	(BgL_cdrzd212674zd2_1509);
																																																{
																																																	BgL_ev_defglobalz00_bglt
																																																		BgL_auxz00_6194;
																																																	{
																																																		obj_t
																																																			BgL_gez00_6196;
																																																		obj_t
																																																			BgL_gvz00_6195;
																																																		BgL_gvz00_6195
																																																			=
																																																			BgL_arg1871z00_1511;
																																																		BgL_gez00_6196
																																																			=
																																																			BgL_arg1872z00_1512;
																																																		BgL_gez00_920
																																																			=
																																																			BgL_gez00_6196;
																																																		BgL_gvz00_919
																																																			=
																																																			BgL_gvz00_6195;
																																																		goto
																																																			BgL_tagzd2150zd2_921;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_6194);
																																																}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 319 */
																																																obj_t
																																																	BgL_arg1873z00_1513;
																																																obj_t
																																																	BgL_arg1874z00_1514;
																																																BgL_arg1873z00_1513
																																																	=
																																																	CAR
																																																	(BgL_ez00_49);
																																																BgL_arg1874z00_1514
																																																	=
																																																	CDR
																																																	(BgL_ez00_49);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_6200;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_6202;
																																																		obj_t
																																																			BgL_fz00_6201;
																																																		BgL_fz00_6201
																																																			=
																																																			BgL_arg1873z00_1513;
																																																		BgL_argsz00_6202
																																																			=
																																																			BgL_arg1874z00_1514;
																																																		BgL_argsz00_942
																																																			=
																																																			BgL_argsz00_6202;
																																																		BgL_fz00_941
																																																			=
																																																			BgL_fz00_6201;
																																																		goto
																																																			BgL_tagzd2157zd2_943;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_6200);
																																																}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 319 */
																																												obj_t
																																													BgL_cdrzd212761zd2_1517;
																																												BgL_cdrzd212761zd2_1517
																																													=
																																													CDR
																																													(BgL_cdrzd212382zd2_1471);
																																												if (NULLP(CDR(BgL_cdrzd212761zd2_1517)))
																																													{	/* Eval/evaluate.scm 319 */
																																														obj_t
																																															BgL_arg1877z00_1519;
																																														obj_t
																																															BgL_arg1878z00_1520;
																																														BgL_arg1877z00_1519
																																															=
																																															CAR
																																															(BgL_cdrzd212382zd2_1471);
																																														BgL_arg1878z00_1520
																																															=
																																															CAR
																																															(BgL_cdrzd212761zd2_1517);
																																														{
																																															BgL_ev_defglobalz00_bglt
																																																BgL_auxz00_6210;
																																															{
																																																obj_t
																																																	BgL_gez00_6212;
																																																obj_t
																																																	BgL_gvz00_6211;
																																																BgL_gvz00_6211
																																																	=
																																																	BgL_arg1877z00_1519;
																																																BgL_gez00_6212
																																																	=
																																																	BgL_arg1878z00_1520;
																																																BgL_gez00_920
																																																	=
																																																	BgL_gez00_6212;
																																																BgL_gvz00_919
																																																	=
																																																	BgL_gvz00_6211;
																																																goto
																																																	BgL_tagzd2150zd2_921;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6210);
																																														}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 319 */
																																														obj_t
																																															BgL_arg1879z00_1521;
																																														obj_t
																																															BgL_arg1880z00_1522;
																																														BgL_arg1879z00_1521
																																															=
																																															CAR
																																															(BgL_ez00_49);
																																														BgL_arg1880z00_1522
																																															=
																																															CDR
																																															(BgL_ez00_49);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_6216;
																																															{
																																																obj_t
																																																	BgL_argsz00_6218;
																																																obj_t
																																																	BgL_fz00_6217;
																																																BgL_fz00_6217
																																																	=
																																																	BgL_arg1879z00_1521;
																																																BgL_argsz00_6218
																																																	=
																																																	BgL_arg1880z00_1522;
																																																BgL_argsz00_942
																																																	=
																																																	BgL_argsz00_6218;
																																																BgL_fz00_941
																																																	=
																																																	BgL_fz00_6217;
																																																goto
																																																	BgL_tagzd2157zd2_943;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6216);
																																														}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 319 */
																																										obj_t
																																											BgL_cdrzd212848zd2_1526;
																																										BgL_cdrzd212848zd2_1526
																																											=
																																											CDR
																																											(BgL_cdrzd212382zd2_1471);
																																										if (NULLP(CDR(BgL_cdrzd212848zd2_1526)))
																																											{	/* Eval/evaluate.scm 319 */
																																												obj_t
																																													BgL_arg1884z00_1528;
																																												obj_t
																																													BgL_arg1885z00_1529;
																																												BgL_arg1884z00_1528
																																													=
																																													CAR
																																													(BgL_cdrzd212382zd2_1471);
																																												BgL_arg1885z00_1529
																																													=
																																													CAR
																																													(BgL_cdrzd212848zd2_1526);
																																												{
																																													BgL_ev_defglobalz00_bglt
																																														BgL_auxz00_6226;
																																													{
																																														obj_t
																																															BgL_gez00_6228;
																																														obj_t
																																															BgL_gvz00_6227;
																																														BgL_gvz00_6227
																																															=
																																															BgL_arg1884z00_1528;
																																														BgL_gez00_6228
																																															=
																																															BgL_arg1885z00_1529;
																																														BgL_gez00_920
																																															=
																																															BgL_gez00_6228;
																																														BgL_gvz00_919
																																															=
																																															BgL_gvz00_6227;
																																														goto
																																															BgL_tagzd2150zd2_921;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_6226);
																																												}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 319 */
																																												obj_t
																																													BgL_arg1886z00_1530;
																																												obj_t
																																													BgL_arg1887z00_1531;
																																												BgL_arg1886z00_1530
																																													=
																																													CAR
																																													(BgL_ez00_49);
																																												BgL_arg1887z00_1531
																																													=
																																													CDR
																																													(BgL_ez00_49);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_6232;
																																													{
																																														obj_t
																																															BgL_argsz00_6234;
																																														obj_t
																																															BgL_fz00_6233;
																																														BgL_fz00_6233
																																															=
																																															BgL_arg1886z00_1530;
																																														BgL_argsz00_6234
																																															=
																																															BgL_arg1887z00_1531;
																																														BgL_argsz00_942
																																															=
																																															BgL_argsz00_6234;
																																														BgL_fz00_941
																																															=
																																															BgL_fz00_6233;
																																														goto
																																															BgL_tagzd2157zd2_943;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_6232);
																																												}
																																											}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 319 */
																																								obj_t
																																									BgL_arg1890z00_1533;
																																								BgL_arg1890z00_1533
																																									=
																																									CAR
																																									(BgL_ez00_49);
																																								{
																																									BgL_ev_appz00_bglt
																																										BgL_auxz00_6237;
																																									{
																																										obj_t
																																											BgL_argsz00_6239;
																																										obj_t
																																											BgL_fz00_6238;
																																										BgL_fz00_6238
																																											=
																																											BgL_arg1890z00_1533;
																																										BgL_argsz00_6239
																																											=
																																											BgL_cdrzd212382zd2_1471;
																																										BgL_argsz00_942
																																											=
																																											BgL_argsz00_6239;
																																										BgL_fz00_941
																																											=
																																											BgL_fz00_6238;
																																										goto
																																											BgL_tagzd2157zd2_943;
																																									}
																																									return
																																										(
																																										(obj_t)
																																										BgL_auxz00_6237);
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 319 */
																																						obj_t
																																							BgL_arg1892z00_1535;
																																						BgL_arg1892z00_1535
																																							=
																																							CAR
																																							(BgL_ez00_49);
																																						{
																																							BgL_ev_appz00_bglt
																																								BgL_auxz00_6242;
																																							{
																																								obj_t
																																									BgL_argsz00_6244;
																																								obj_t
																																									BgL_fz00_6243;
																																								BgL_fz00_6243
																																									=
																																									BgL_arg1892z00_1535;
																																								BgL_argsz00_6244
																																									=
																																									BgL_cdrzd212382zd2_1471;
																																								BgL_argsz00_942
																																									=
																																									BgL_argsz00_6244;
																																								BgL_fz00_941
																																									=
																																									BgL_fz00_6243;
																																								goto
																																									BgL_tagzd2157zd2_943;
																																							}
																																							return
																																								(
																																								(obj_t)
																																								BgL_auxz00_6242);
																																						}
																																					}
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 319 */
																																				if (
																																					(CAR
																																						(BgL_ez00_49)
																																						==
																																						BGl_symbol2683z00zz__evaluatez00))
																																					{	/* Eval/evaluate.scm 319 */
																																						if (PAIRP(BgL_cdrzd212382zd2_1471))
																																							{	/* Eval/evaluate.scm 319 */
																																								obj_t
																																									BgL_carzd213090zd2_1540;
																																								BgL_carzd213090zd2_1540
																																									=
																																									CAR
																																									(BgL_cdrzd212382zd2_1471);
																																								if (PAIRP(BgL_carzd213090zd2_1540))
																																									{	/* Eval/evaluate.scm 319 */
																																										if (NULLP(CDR(BgL_carzd213090zd2_1540)))
																																											{	/* Eval/evaluate.scm 319 */
																																												obj_t
																																													BgL_arg1898z00_1543;
																																												obj_t
																																													BgL_arg1899z00_1544;
																																												BgL_arg1898z00_1543
																																													=
																																													CAR
																																													(BgL_carzd213090zd2_1540);
																																												BgL_arg1899z00_1544
																																													=
																																													CDR
																																													(BgL_cdrzd212382zd2_1471);
																																												{
																																													BgL_ev_bindzd2exitzd2_bglt
																																														BgL_auxz00_6259;
																																													{
																																														obj_t
																																															BgL_bodyz00_6261;
																																														obj_t
																																															BgL_vz00_6260;
																																														BgL_vz00_6260
																																															=
																																															BgL_arg1898z00_1543;
																																														BgL_bodyz00_6261
																																															=
																																															BgL_arg1899z00_1544;
																																														BgL_bodyz00_923
																																															=
																																															BgL_bodyz00_6261;
																																														BgL_vz00_922
																																															=
																																															BgL_vz00_6260;
																																														goto
																																															BgL_tagzd2151zd2_924;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_6259);
																																												}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 319 */
																																												obj_t
																																													BgL_arg1900z00_1545;
																																												obj_t
																																													BgL_arg1901z00_1546;
																																												BgL_arg1900z00_1545
																																													=
																																													CAR
																																													(BgL_ez00_49);
																																												BgL_arg1901z00_1546
																																													=
																																													CDR
																																													(BgL_ez00_49);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_6265;
																																													{
																																														obj_t
																																															BgL_argsz00_6267;
																																														obj_t
																																															BgL_fz00_6266;
																																														BgL_fz00_6266
																																															=
																																															BgL_arg1900z00_1545;
																																														BgL_argsz00_6267
																																															=
																																															BgL_arg1901z00_1546;
																																														BgL_argsz00_942
																																															=
																																															BgL_argsz00_6267;
																																														BgL_fz00_941
																																															=
																																															BgL_fz00_6266;
																																														goto
																																															BgL_tagzd2157zd2_943;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_6265);
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 319 */
																																										obj_t
																																											BgL_arg1903z00_1548;
																																										obj_t
																																											BgL_arg1904z00_1549;
																																										BgL_arg1903z00_1548
																																											=
																																											CAR
																																											(BgL_ez00_49);
																																										BgL_arg1904z00_1549
																																											=
																																											CDR
																																											(BgL_ez00_49);
																																										{
																																											BgL_ev_appz00_bglt
																																												BgL_auxz00_6271;
																																											{
																																												obj_t
																																													BgL_argsz00_6273;
																																												obj_t
																																													BgL_fz00_6272;
																																												BgL_fz00_6272
																																													=
																																													BgL_arg1903z00_1548;
																																												BgL_argsz00_6273
																																													=
																																													BgL_arg1904z00_1549;
																																												BgL_argsz00_942
																																													=
																																													BgL_argsz00_6273;
																																												BgL_fz00_941
																																													=
																																													BgL_fz00_6272;
																																												goto
																																													BgL_tagzd2157zd2_943;
																																											}
																																											return
																																												(
																																												(obj_t)
																																												BgL_auxz00_6271);
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 319 */
																																								obj_t
																																									BgL_arg1905z00_1550;
																																								obj_t
																																									BgL_arg1906z00_1551;
																																								BgL_arg1905z00_1550
																																									=
																																									CAR
																																									(BgL_ez00_49);
																																								BgL_arg1906z00_1551
																																									=
																																									CDR
																																									(BgL_ez00_49);
																																								{
																																									BgL_ev_appz00_bglt
																																										BgL_auxz00_6277;
																																									{
																																										obj_t
																																											BgL_argsz00_6279;
																																										obj_t
																																											BgL_fz00_6278;
																																										BgL_fz00_6278
																																											=
																																											BgL_arg1905z00_1550;
																																										BgL_argsz00_6279
																																											=
																																											BgL_arg1906z00_1551;
																																										BgL_argsz00_942
																																											=
																																											BgL_argsz00_6279;
																																										BgL_fz00_941
																																											=
																																											BgL_fz00_6278;
																																										goto
																																											BgL_tagzd2157zd2_943;
																																									}
																																									return
																																										(
																																										(obj_t)
																																										BgL_auxz00_6277);
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 319 */
																																						obj_t
																																							BgL_cdrzd213255zd2_1552;
																																						BgL_cdrzd213255zd2_1552
																																							=
																																							CDR
																																							(BgL_ez00_49);
																																						if (
																																							(CAR
																																								(BgL_ez00_49)
																																								==
																																								BGl_symbol2685z00zz__evaluatez00))
																																							{	/* Eval/evaluate.scm 319 */
																																								if (PAIRP(BgL_cdrzd213255zd2_1552))
																																									{	/* Eval/evaluate.scm 319 */
																																										obj_t
																																											BgL_arg1909z00_1555;
																																										obj_t
																																											BgL_arg1910z00_1556;
																																										BgL_arg1909z00_1555
																																											=
																																											CAR
																																											(BgL_cdrzd213255zd2_1552);
																																										BgL_arg1910z00_1556
																																											=
																																											CDR
																																											(BgL_cdrzd213255zd2_1552);
																																										{
																																											BgL_ev_unwindzd2protectzd2_bglt
																																												BgL_auxz00_6289;
																																											{
																																												obj_t
																																													BgL_bodyz00_6291;
																																												obj_t
																																													BgL_ez00_6290;
																																												BgL_ez00_6290
																																													=
																																													BgL_arg1909z00_1555;
																																												BgL_bodyz00_6291
																																													=
																																													BgL_arg1910z00_1556;
																																												BgL_bodyz00_926
																																													=
																																													BgL_bodyz00_6291;
																																												BgL_ez00_925
																																													=
																																													BgL_ez00_6290;
																																												goto
																																													BgL_tagzd2152zd2_927;
																																											}
																																											return
																																												(
																																												(obj_t)
																																												BgL_auxz00_6289);
																																										}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 319 */
																																										obj_t
																																											BgL_arg1911z00_1557;
																																										BgL_arg1911z00_1557
																																											=
																																											CAR
																																											(BgL_ez00_49);
																																										{
																																											BgL_ev_appz00_bglt
																																												BgL_auxz00_6294;
																																											{
																																												obj_t
																																													BgL_argsz00_6296;
																																												obj_t
																																													BgL_fz00_6295;
																																												BgL_fz00_6295
																																													=
																																													BgL_arg1911z00_1557;
																																												BgL_argsz00_6296
																																													=
																																													BgL_cdrzd213255zd2_1552;
																																												BgL_argsz00_942
																																													=
																																													BgL_argsz00_6296;
																																												BgL_fz00_941
																																													=
																																													BgL_fz00_6295;
																																												goto
																																													BgL_tagzd2157zd2_943;
																																											}
																																											return
																																												(
																																												(obj_t)
																																												BgL_auxz00_6294);
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 319 */
																																								if ((CAR(BgL_ez00_49) == BGl_symbol2687z00zz__evaluatez00))
																																									{	/* Eval/evaluate.scm 319 */
																																										if (PAIRP(BgL_cdrzd213255zd2_1552))
																																											{	/* Eval/evaluate.scm 319 */
																																												obj_t
																																													BgL_arg1915z00_1562;
																																												obj_t
																																													BgL_arg1916z00_1563;
																																												BgL_arg1915z00_1562
																																													=
																																													CAR
																																													(BgL_cdrzd213255zd2_1552);
																																												BgL_arg1916z00_1563
																																													=
																																													CDR
																																													(BgL_cdrzd213255zd2_1552);
																																												{
																																													BgL_ev_withzd2handlerzd2_bglt
																																														BgL_auxz00_6305;
																																													{
																																														obj_t
																																															BgL_bodyz00_6307;
																																														obj_t
																																															BgL_hz00_6306;
																																														BgL_hz00_6306
																																															=
																																															BgL_arg1915z00_1562;
																																														BgL_bodyz00_6307
																																															=
																																															BgL_arg1916z00_1563;
																																														BgL_bodyz00_929
																																															=
																																															BgL_bodyz00_6307;
																																														BgL_hz00_928
																																															=
																																															BgL_hz00_6306;
																																														goto
																																															BgL_tagzd2153zd2_930;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_6305);
																																												}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 319 */
																																												obj_t
																																													BgL_arg1917z00_1564;
																																												obj_t
																																													BgL_arg1918z00_1565;
																																												BgL_arg1917z00_1564
																																													=
																																													CAR
																																													(BgL_ez00_49);
																																												BgL_arg1918z00_1565
																																													=
																																													CDR
																																													(BgL_ez00_49);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_6311;
																																													{
																																														obj_t
																																															BgL_argsz00_6313;
																																														obj_t
																																															BgL_fz00_6312;
																																														BgL_fz00_6312
																																															=
																																															BgL_arg1917z00_1564;
																																														BgL_argsz00_6313
																																															=
																																															BgL_arg1918z00_1565;
																																														BgL_argsz00_942
																																															=
																																															BgL_argsz00_6313;
																																														BgL_fz00_941
																																															=
																																															BgL_fz00_6312;
																																														goto
																																															BgL_tagzd2157zd2_943;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_6311);
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 319 */
																																										obj_t
																																											BgL_cdrzd213358zd2_1566;
																																										BgL_cdrzd213358zd2_1566
																																											=
																																											CDR
																																											(BgL_ez00_49);
																																										if ((CAR(BgL_ez00_49) == BGl_symbol2689z00zz__evaluatez00))
																																											{	/* Eval/evaluate.scm 319 */
																																												if (PAIRP(BgL_cdrzd213358zd2_1566))
																																													{	/* Eval/evaluate.scm 319 */
																																														obj_t
																																															BgL_cdrzd213363zd2_1569;
																																														BgL_cdrzd213363zd2_1569
																																															=
																																															CDR
																																															(BgL_cdrzd213358zd2_1566);
																																														if (PAIRP(BgL_cdrzd213363zd2_1569))
																																															{	/* Eval/evaluate.scm 319 */
																																																obj_t
																																																	BgL_cdrzd213368zd2_1571;
																																																BgL_cdrzd213368zd2_1571
																																																	=
																																																	CDR
																																																	(BgL_cdrzd213363zd2_1569);
																																																if ((CAR(BgL_cdrzd213363zd2_1569) == BGl_keyword2691z00zz__evaluatez00))
																																																	{	/* Eval/evaluate.scm 319 */
																																																		if (PAIRP(BgL_cdrzd213368zd2_1571))
																																																			{	/* Eval/evaluate.scm 319 */
																																																				obj_t
																																																					BgL_arg1924z00_1574;
																																																				obj_t
																																																					BgL_arg1925z00_1575;
																																																				obj_t
																																																					BgL_arg1926z00_1576;
																																																				BgL_arg1924z00_1574
																																																					=
																																																					CAR
																																																					(BgL_cdrzd213358zd2_1566);
																																																				BgL_arg1925z00_1575
																																																					=
																																																					CAR
																																																					(BgL_cdrzd213368zd2_1571);
																																																				BgL_arg1926z00_1576
																																																					=
																																																					CDR
																																																					(BgL_cdrzd213368zd2_1571);
																																																				{	/* Eval/evaluate.scm 472 */
																																																					BgL_ev_synchroniza7eza7_bglt
																																																						BgL_new1154z00_3804;
																																																					{	/* Eval/evaluate.scm 472 */
																																																						BgL_ev_synchroniza7eza7_bglt
																																																							BgL_new1153z00_3805;
																																																						BgL_new1153z00_3805
																																																							=
																																																							(
																																																							(BgL_ev_synchroniza7eza7_bglt)
																																																							BREF
																																																							(GC_MALLOC
																																																								(sizeof
																																																									(struct
																																																										BgL_ev_synchroniza7eza7_bgl))));
																																																						{	/* Eval/evaluate.scm 472 */
																																																							long
																																																								BgL_arg2085z00_3806;
																																																							{	/* Eval/evaluate.scm 472 */
																																																								long
																																																									BgL_res2593z00_3808;
																																																								BgL_res2593z00_3808
																																																									=
																																																									BGL_CLASS_INDEX
																																																									(BGl_ev_synchroniza7eza7zz__evaluate_typesz00);
																																																								BgL_arg2085z00_3806
																																																									=
																																																									BgL_res2593z00_3808;
																																																							}
																																																							{	/* Eval/evaluate.scm 472 */
																																																								BgL_objectz00_bglt
																																																									BgL_objz00_3809;
																																																								BgL_objz00_3809
																																																									=
																																																									(
																																																									(BgL_objectz00_bglt)
																																																									BgL_new1153z00_3805);
																																																								BGL_OBJECT_CLASS_NUM_SET
																																																									(BgL_objz00_3809,
																																																									BgL_arg2085z00_3806);
																																																						}}
																																																						{	/* Eval/evaluate.scm 472 */
																																																							BgL_objectz00_bglt
																																																								BgL_auxz00_6337;
																																																							BgL_auxz00_6337
																																																								=
																																																								(
																																																								(BgL_objectz00_bglt)
																																																								BgL_new1153z00_3805);
																																																							BGL_OBJECT_WIDENING_SET
																																																								(BgL_auxz00_6337,
																																																								BFALSE);
																																																						}
																																																						BgL_new1154z00_3804
																																																							=
																																																							BgL_new1153z00_3805;
																																																					}
																																																					{
																																																						BgL_ev_exprz00_bglt
																																																							BgL_auxz00_6340;
																																																						{	/* Eval/evaluate.scm 280 */
																																																							obj_t
																																																								BgL_arg2097z00_3812;
																																																							BgL_arg2097z00_3812
																																																								=
																																																								BGl_getzd2locationzd2zz__evaluatez00
																																																								(BgL_arg1924z00_1574,
																																																								BgL_locz00_54);
																																																							BgL_auxz00_6340
																																																								=
																																																								(
																																																								(BgL_ev_exprz00_bglt)
																																																								BGl_uconvzf2loczf2zz__evaluatez00
																																																								(BgL_wherez00_53,
																																																									BgL_globalsz00_51,
																																																									BgL_localsz00_50,
																																																									BgL_arg1924z00_1574,
																																																									BgL_arg2097z00_3812));
																																																						}
																																																						((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1154z00_3804))->BgL_mutexz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6340), BUNSPEC);
																																																					}
																																																					{
																																																						BgL_ev_exprz00_bglt
																																																							BgL_auxz00_6345;
																																																						{	/* Eval/evaluate.scm 280 */
																																																							obj_t
																																																								BgL_arg2097z00_3814;
																																																							BgL_arg2097z00_3814
																																																								=
																																																								BGl_getzd2locationzd2zz__evaluatez00
																																																								(BgL_arg1925z00_1575,
																																																								BgL_locz00_54);
																																																							BgL_auxz00_6345
																																																								=
																																																								(
																																																								(BgL_ev_exprz00_bglt)
																																																								BGl_uconvzf2loczf2zz__evaluatez00
																																																								(BgL_wherez00_53,
																																																									BgL_globalsz00_51,
																																																									BgL_localsz00_50,
																																																									BgL_arg1925z00_1575,
																																																									BgL_arg2097z00_3814));
																																																						}
																																																						((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1154z00_3804))->BgL_prelockz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6345), BUNSPEC);
																																																					}
																																																					((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1154z00_3804))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_arg1926z00_1576, BgL_localsz00_50, BgL_globalsz00_51, BFALSE, BgL_wherez00_53, BgL_locz00_54, ((bool_t) 0)))), BUNSPEC);
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_new1154z00_3804);
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 319 */
																																																				obj_t
																																																					BgL_arg1927z00_1578;
																																																				obj_t
																																																					BgL_arg1928z00_1579;
																																																				BgL_arg1927z00_1578
																																																					=
																																																					CAR
																																																					(BgL_cdrzd213358zd2_1566);
																																																				BgL_arg1928z00_1579
																																																					=
																																																					CDR
																																																					(BgL_cdrzd213358zd2_1566);
																																																				{
																																																					BgL_ev_synchroniza7eza7_bglt
																																																						BgL_auxz00_6356;
																																																					{
																																																						obj_t
																																																							BgL_bodyz00_6358;
																																																						obj_t
																																																							BgL_mz00_6357;
																																																						BgL_mz00_6357
																																																							=
																																																							BgL_arg1927z00_1578;
																																																						BgL_bodyz00_6358
																																																							=
																																																							BgL_arg1928z00_1579;
																																																						BgL_bodyz00_936
																																																							=
																																																							BgL_bodyz00_6358;
																																																						BgL_mz00_935
																																																							=
																																																							BgL_mz00_6357;
																																																						goto
																																																							BgL_tagzd2155zd2_937;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6356);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 319 */
																																																		obj_t
																																																			BgL_arg1929z00_1581;
																																																		obj_t
																																																			BgL_arg1930z00_1582;
																																																		BgL_arg1929z00_1581
																																																			=
																																																			CAR
																																																			(BgL_cdrzd213358zd2_1566);
																																																		BgL_arg1930z00_1582
																																																			=
																																																			CDR
																																																			(BgL_cdrzd213358zd2_1566);
																																																		{
																																																			BgL_ev_synchroniza7eza7_bglt
																																																				BgL_auxz00_6362;
																																																			{
																																																				obj_t
																																																					BgL_bodyz00_6364;
																																																				obj_t
																																																					BgL_mz00_6363;
																																																				BgL_mz00_6363
																																																					=
																																																					BgL_arg1929z00_1581;
																																																				BgL_bodyz00_6364
																																																					=
																																																					BgL_arg1930z00_1582;
																																																				BgL_bodyz00_936
																																																					=
																																																					BgL_bodyz00_6364;
																																																				BgL_mz00_935
																																																					=
																																																					BgL_mz00_6363;
																																																				goto
																																																					BgL_tagzd2155zd2_937;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_6362);
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 319 */
																																																obj_t
																																																	BgL_arg1932z00_1585;
																																																obj_t
																																																	BgL_arg1933z00_1586;
																																																BgL_arg1932z00_1585
																																																	=
																																																	CAR
																																																	(BgL_cdrzd213358zd2_1566);
																																																BgL_arg1933z00_1586
																																																	=
																																																	CDR
																																																	(BgL_cdrzd213358zd2_1566);
																																																{
																																																	BgL_ev_synchroniza7eza7_bglt
																																																		BgL_auxz00_6368;
																																																	{
																																																		obj_t
																																																			BgL_bodyz00_6370;
																																																		obj_t
																																																			BgL_mz00_6369;
																																																		BgL_mz00_6369
																																																			=
																																																			BgL_arg1932z00_1585;
																																																		BgL_bodyz00_6370
																																																			=
																																																			BgL_arg1933z00_1586;
																																																		BgL_bodyz00_936
																																																			=
																																																			BgL_bodyz00_6370;
																																																		BgL_mz00_935
																																																			=
																																																			BgL_mz00_6369;
																																																		goto
																																																			BgL_tagzd2155zd2_937;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_6368);
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 319 */
																																														obj_t
																																															BgL_arg1934z00_1587;
																																														BgL_arg1934z00_1587
																																															=
																																															CAR
																																															(BgL_ez00_49);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_6373;
																																															{
																																																obj_t
																																																	BgL_argsz00_6375;
																																																obj_t
																																																	BgL_fz00_6374;
																																																BgL_fz00_6374
																																																	=
																																																	BgL_arg1934z00_1587;
																																																BgL_argsz00_6375
																																																	=
																																																	BgL_cdrzd213358zd2_1566;
																																																BgL_argsz00_942
																																																	=
																																																	BgL_argsz00_6375;
																																																BgL_fz00_941
																																																	=
																																																	BgL_fz00_6374;
																																																goto
																																																	BgL_tagzd2157zd2_943;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6373);
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 319 */
																																												if ((CAR(BgL_ez00_49) == BGl_symbol2681z00zz__evaluatez00))
																																													{	/* Eval/evaluate.scm 319 */
																																														if (PAIRP(BgL_cdrzd213358zd2_1566))
																																															{	/* Eval/evaluate.scm 319 */
																																																obj_t
																																																	BgL_cdrzd213468zd2_1592;
																																																BgL_cdrzd213468zd2_1592
																																																	=
																																																	CDR
																																																	(BgL_cdrzd213358zd2_1566);
																																																if (PAIRP(BgL_cdrzd213468zd2_1592))
																																																	{	/* Eval/evaluate.scm 319 */
																																																		if (NULLP(CDR(BgL_cdrzd213468zd2_1592)))
																																																			{	/* Eval/evaluate.scm 319 */
																																																				obj_t
																																																					BgL_arg1940z00_1595;
																																																				obj_t
																																																					BgL_arg1941z00_1596;
																																																				BgL_arg1940z00_1595
																																																					=
																																																					CAR
																																																					(BgL_cdrzd213358zd2_1566);
																																																				BgL_arg1941z00_1596
																																																					=
																																																					CAR
																																																					(BgL_cdrzd213468zd2_1592);
																																																				{	/* Eval/evaluate.scm 482 */
																																																					obj_t
																																																						BgL_arg2087z00_3840;
																																																					{	/* Eval/evaluate.scm 482 */
																																																						obj_t
																																																							BgL_arg2088z00_3841;
																																																						{	/* Eval/evaluate.scm 482 */
																																																							obj_t
																																																								BgL_arg2089z00_3842;
																																																							obj_t
																																																								BgL_arg2090z00_3843;
																																																							{	/* Eval/evaluate.scm 482 */
																																																								obj_t
																																																									BgL_res2597z00_3846;
																																																								{	/* Eval/evaluate.scm 482 */
																																																									obj_t
																																																										BgL_symbolz00_3844;
																																																									BgL_symbolz00_3844
																																																										=
																																																										BGl_symbol2693z00zz__evaluatez00;
																																																									{	/* Ieee/symbol.scm 135 */
																																																										obj_t
																																																											BgL_arg2268z00_3845;
																																																										BgL_arg2268z00_3845
																																																											=
																																																											SYMBOL_TO_STRING
																																																											(BgL_symbolz00_3844);
																																																										BgL_res2597z00_3846
																																																											=
																																																											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																																																											(BgL_arg2268z00_3845);
																																																									}
																																																								}
																																																								BgL_arg2089z00_3842
																																																									=
																																																									BgL_res2597z00_3846;
																																																							}
																																																							{	/* Eval/evaluate.scm 482 */
																																																								obj_t
																																																									BgL_res2598z00_3849;
																																																								{	/* Eval/evaluate.scm 482 */
																																																									obj_t
																																																										BgL_symbolz00_3847;
																																																									BgL_symbolz00_3847
																																																										=
																																																										BgL_wherez00_53;
																																																									{	/* Ieee/symbol.scm 135 */
																																																										obj_t
																																																											BgL_arg2268z00_3848;
																																																										BgL_arg2268z00_3848
																																																											=
																																																											SYMBOL_TO_STRING
																																																											(BgL_symbolz00_3847);
																																																										BgL_res2598z00_3849
																																																											=
																																																											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																																																											(BgL_arg2268z00_3848);
																																																									}
																																																								}
																																																								BgL_arg2090z00_3843
																																																									=
																																																									BgL_res2598z00_3849;
																																																							}
																																																							BgL_arg2088z00_3841
																																																								=
																																																								string_append
																																																								(BgL_arg2089z00_3842,
																																																								BgL_arg2090z00_3843);
																																																						}
																																																						BgL_arg2087z00_3840
																																																							=
																																																							string_to_symbol
																																																							(BSTRING_TO_STRING
																																																							(BgL_arg2088z00_3841));
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BGl_convzd2lambdazd2zz__evaluatez00
																																																						(BgL_globalsz00_51,
																																																							BgL_localsz00_50,
																																																							BgL_locz00_54,
																																																							BgL_ez00_49,
																																																							BgL_arg1940z00_1595,
																																																							BgL_arg1941z00_1596,
																																																							BgL_arg2087z00_3840));
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 319 */
																																																				obj_t
																																																					BgL_arg1942z00_1597;
																																																				obj_t
																																																					BgL_arg1943z00_1598;
																																																				BgL_arg1942z00_1597
																																																					=
																																																					CAR
																																																					(BgL_ez00_49);
																																																				BgL_arg1943z00_1598
																																																					=
																																																					CDR
																																																					(BgL_ez00_49);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_6401;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_6403;
																																																						obj_t
																																																							BgL_fz00_6402;
																																																						BgL_fz00_6402
																																																							=
																																																							BgL_arg1942z00_1597;
																																																						BgL_argsz00_6403
																																																							=
																																																							BgL_arg1943z00_1598;
																																																						BgL_argsz00_942
																																																							=
																																																							BgL_argsz00_6403;
																																																						BgL_fz00_941
																																																							=
																																																							BgL_fz00_6402;
																																																						goto
																																																							BgL_tagzd2157zd2_943;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6401);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 319 */
																																																		obj_t
																																																			BgL_arg1945z00_1600;
																																																		obj_t
																																																			BgL_arg1946z00_1601;
																																																		BgL_arg1945z00_1600
																																																			=
																																																			CAR
																																																			(BgL_ez00_49);
																																																		BgL_arg1946z00_1601
																																																			=
																																																			CDR
																																																			(BgL_ez00_49);
																																																		{
																																																			BgL_ev_appz00_bglt
																																																				BgL_auxz00_6407;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_6409;
																																																				obj_t
																																																					BgL_fz00_6408;
																																																				BgL_fz00_6408
																																																					=
																																																					BgL_arg1945z00_1600;
																																																				BgL_argsz00_6409
																																																					=
																																																					BgL_arg1946z00_1601;
																																																				BgL_argsz00_942
																																																					=
																																																					BgL_argsz00_6409;
																																																				BgL_fz00_941
																																																					=
																																																					BgL_fz00_6408;
																																																				goto
																																																					BgL_tagzd2157zd2_943;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_6407);
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 319 */
																																																obj_t
																																																	BgL_arg1947z00_1602;
																																																obj_t
																																																	BgL_arg1948z00_1603;
																																																BgL_arg1947z00_1602
																																																	=
																																																	CAR
																																																	(BgL_ez00_49);
																																																BgL_arg1948z00_1603
																																																	=
																																																	CDR
																																																	(BgL_ez00_49);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_6413;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_6415;
																																																		obj_t
																																																			BgL_fz00_6414;
																																																		BgL_fz00_6414
																																																			=
																																																			BgL_arg1947z00_1602;
																																																		BgL_argsz00_6415
																																																			=
																																																			BgL_arg1948z00_1603;
																																																		BgL_argsz00_942
																																																			=
																																																			BgL_argsz00_6415;
																																																		BgL_fz00_941
																																																			=
																																																			BgL_fz00_6414;
																																																		goto
																																																			BgL_tagzd2157zd2_943;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_6413);
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 319 */
																																														obj_t
																																															BgL_arg1949z00_1604;
																																														obj_t
																																															BgL_arg1950z00_1605;
																																														BgL_arg1949z00_1604
																																															=
																																															CAR
																																															(BgL_ez00_49);
																																														BgL_arg1950z00_1605
																																															=
																																															CDR
																																															(BgL_ez00_49);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_6419;
																																															{
																																																obj_t
																																																	BgL_argsz00_6421;
																																																obj_t
																																																	BgL_fz00_6420;
																																																BgL_fz00_6420
																																																	=
																																																	BgL_arg1949z00_1604;
																																																BgL_argsz00_6421
																																																	=
																																																	BgL_arg1950z00_1605;
																																																BgL_argsz00_942
																																																	=
																																																	BgL_argsz00_6421;
																																																BgL_fz00_941
																																																	=
																																																	BgL_fz00_6420;
																																																goto
																																																	BgL_tagzd2157zd2_943;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6419);
																																														}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																	}
																															}
																													}
																											}
																									}
																							}
																					}
																			}
																	}
															}
													}
											}
									}
							}
					}
				else
					{	/* Eval/evaluate.scm 319 */
						BgL_xz00_866 = BgL_ez00_49;
						if (SYMBOLP(BgL_xz00_866))
							{	/* Eval/evaluate.scm 322 */
								obj_t BgL__ortest_1098z00_1626;

								BgL__ortest_1098z00_1626 =
									BGl_convzd2varzd2zz__evaluatez00(BgL_xz00_866,
									BgL_localsz00_50);
								if (CBOOL(BgL__ortest_1098z00_1626))
									{	/* Eval/evaluate.scm 322 */
										return BgL__ortest_1098z00_1626;
									}
								else
									{	/* Eval/evaluate.scm 323 */
										BgL_ev_globalz00_bglt BgL_new1100z00_1627;

										{	/* Eval/evaluate.scm 323 */
											BgL_ev_globalz00_bglt BgL_new1099z00_1629;

											BgL_new1099z00_1629 =
												((BgL_ev_globalz00_bglt) BREF(GC_MALLOC(sizeof(struct
															BgL_ev_globalz00_bgl))));
											{	/* Eval/evaluate.scm 323 */
												long BgL_arg1974z00_1630;

												{	/* Eval/evaluate.scm 323 */
													long BgL_res2393z00_2517;

													BgL_res2393z00_2517 =
														BGL_CLASS_INDEX
														(BGl_ev_globalz00zz__evaluate_typesz00);
													BgL_arg1974z00_1630 = BgL_res2393z00_2517;
												}
												{	/* Eval/evaluate.scm 323 */
													BgL_objectz00_bglt BgL_objz00_2518;

													BgL_objz00_2518 =
														((BgL_objectz00_bglt) BgL_new1099z00_1629);
													BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2518,
														BgL_arg1974z00_1630);
											}}
											{	/* Eval/evaluate.scm 323 */
												BgL_objectz00_bglt BgL_auxz00_6432;

												BgL_auxz00_6432 =
													((BgL_objectz00_bglt) BgL_new1099z00_1629);
												BGL_OBJECT_WIDENING_SET(BgL_auxz00_6432, BFALSE);
											}
											BgL_new1100z00_1627 = BgL_new1099z00_1629;
										}
										((((BgL_ev_globalz00_bglt) CREF(BgL_new1100z00_1627))->
												BgL_locz00) = ((obj_t) BgL_locz00_54), BUNSPEC);
										((((BgL_ev_globalz00_bglt) CREF(BgL_new1100z00_1627))->
												BgL_namez00) = ((obj_t) BgL_xz00_866), BUNSPEC);
										{
											obj_t BgL_auxz00_6437;

											if (BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_51))
												{	/* Eval/evaluate.scm 326 */
													BgL_auxz00_6437 = BgL_globalsz00_51;
												}
											else
												{	/* Eval/evaluate.scm 326 */
													BgL_auxz00_6437 = BGL_MODULE();
												}
											((((BgL_ev_globalz00_bglt) CREF(BgL_new1100z00_1627))->
													BgL_modz00) = ((obj_t) BgL_auxz00_6437), BUNSPEC);
										}
										return ((obj_t) BgL_new1100z00_1627);
									}
							}
						else
							{	/* Eval/evaluate.scm 327 */
								BgL_ev_littz00_bglt BgL_new1102z00_1631;

								{	/* Eval/evaluate.scm 327 */
									BgL_ev_littz00_bglt BgL_new1101z00_1632;

									BgL_new1101z00_1632 =
										((BgL_ev_littz00_bglt) BREF(GC_MALLOC(sizeof(struct
													BgL_ev_littz00_bgl))));
									{	/* Eval/evaluate.scm 327 */
										long BgL_arg1975z00_1633;

										{	/* Eval/evaluate.scm 327 */
											long BgL_res2394z00_2521;

											BgL_res2394z00_2521 =
												BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00);
											BgL_arg1975z00_1633 = BgL_res2394z00_2521;
										}
										{	/* Eval/evaluate.scm 327 */
											BgL_objectz00_bglt BgL_objz00_2522;

											BgL_objz00_2522 =
												((BgL_objectz00_bglt) BgL_new1101z00_1632);
											BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2522,
												BgL_arg1975z00_1633);
									}}
									{	/* Eval/evaluate.scm 327 */
										BgL_objectz00_bglt BgL_auxz00_6447;

										BgL_auxz00_6447 =
											((BgL_objectz00_bglt) BgL_new1101z00_1632);
										BGL_OBJECT_WIDENING_SET(BgL_auxz00_6447, BFALSE);
									}
									BgL_new1102z00_1631 = BgL_new1101z00_1632;
								}
								((((BgL_ev_littz00_bglt) CREF(BgL_new1102z00_1631))->
										BgL_valuez00) = ((obj_t) BgL_xz00_866), BUNSPEC);
								return ((obj_t) BgL_new1102z00_1631);
							}
					}
			}
		}
	}



/* loop */
	obj_t BGl_loopz00zz__evaluatez00(obj_t BgL_wherez00_4102,
		obj_t BgL_globalsz00_4101, obj_t BgL_localsz00_4100, obj_t BgL_locz00_4099,
		obj_t BgL_esz00_1886)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 283 */
			if (NULLP(BgL_esz00_1886))
				{	/* Eval/evaluate.scm 284 */
					return BNIL;
				}
			else
				{	/* Eval/evaluate.scm 286 */
					obj_t BgL_ez00_1889;

					BgL_ez00_1889 = CAR(BgL_esz00_1886);
					{	/* Eval/evaluate.scm 287 */
						obj_t BgL_arg2101z00_1890;
						obj_t BgL_arg2102z00_1891;

						{	/* Eval/evaluate.scm 287 */
							obj_t BgL_arg2104z00_1892;

							{	/* Eval/evaluate.scm 135 */
								obj_t BgL__ortest_1068z00_2462;

								BgL__ortest_1068z00_2462 =
									BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_ez00_1889);
								if (CBOOL(BgL__ortest_1068z00_2462))
									{	/* Eval/evaluate.scm 135 */
										BgL_arg2104z00_1892 = BgL__ortest_1068z00_2462;
									}
								else
									{	/* Eval/evaluate.scm 136 */
										obj_t BgL__ortest_1069z00_2463;

										BgL__ortest_1069z00_2463 =
											BGl_getzd2sourcezd2locationz00zz__readerz00
											(BgL_esz00_1886);
										if (CBOOL(BgL__ortest_1069z00_2463))
											{	/* Eval/evaluate.scm 136 */
												BgL_arg2104z00_1892 = BgL__ortest_1069z00_2463;
											}
										else
											{	/* Eval/evaluate.scm 136 */
												BgL_arg2104z00_1892 = BgL_locz00_4099;
											}
									}
							}
							BgL_arg2101z00_1890 =
								BGl_convz00zz__evaluatez00(BgL_ez00_1889, BgL_localsz00_4100,
								BgL_globalsz00_4101, BFALSE, BgL_wherez00_4102,
								BgL_arg2104z00_1892, ((bool_t) 0));
						}
						BgL_arg2102z00_1891 =
							BGl_loopz00zz__evaluatez00(BgL_wherez00_4102, BgL_globalsz00_4101,
							BgL_localsz00_4100, BgL_locz00_4099, CDR(BgL_esz00_1886));
						return MAKE_PAIR(BgL_arg2101z00_1890, BgL_arg2102z00_1891);
					}
				}
		}
	}



/* conv-vals */
	obj_t BGl_convzd2valszd2zz__evaluatez00(obj_t BgL_wherez00_4104,
		obj_t BgL_globalsz00_4103, obj_t BgL_lz00_2757, obj_t BgL_varsz00_2758,
		obj_t BgL_localsz00_2759, obj_t BgL_locz00_2760)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 397 */
			if (NULLP(BgL_lz00_2757))
				{	/* Eval/evaluate.scm 393 */
					return BNIL;
				}
			else
				{	/* Eval/evaluate.scm 395 */
					obj_t BgL_locz00_2772;

					{	/* Eval/evaluate.scm 395 */
						obj_t BgL_arg2040z00_2773;

						BgL_arg2040z00_2773 = CAR(BgL_lz00_2757);
						{	/* Eval/evaluate.scm 129 */
							obj_t BgL__ortest_1067z00_2786;

							BgL__ortest_1067z00_2786 =
								BGl_getzd2sourcezd2locationz00zz__readerz00
								(BgL_arg2040z00_2773);
							if (CBOOL(BgL__ortest_1067z00_2786))
								{	/* Eval/evaluate.scm 129 */
									BgL_locz00_2772 = BgL__ortest_1067z00_2786;
								}
							else
								{	/* Eval/evaluate.scm 129 */
									BgL_locz00_2772 = BgL_locz00_2760;
								}
						}
					}
					{	/* Eval/evaluate.scm 396 */
						obj_t BgL_arg2031z00_2774;
						obj_t BgL_arg2032z00_2775;

						{	/* Eval/evaluate.scm 396 */
							obj_t BgL_arg2033z00_2776;

							{	/* Eval/evaluate.scm 396 */
								obj_t BgL_pairz00_2787;

								BgL_pairz00_2787 = BgL_lz00_2757;
								BgL_arg2033z00_2776 = CAR(CDR(CAR(BgL_pairz00_2787)));
							}
							BgL_arg2031z00_2774 =
								BGl_convz00zz__evaluatez00(BgL_arg2033z00_2776,
								BgL_localsz00_2759, BgL_globalsz00_4103, BFALSE,
								BgL_wherez00_4104, BgL_locz00_2772, ((bool_t) 0));
						}
						{	/* Eval/evaluate.scm 397 */
							obj_t BgL_arg2035z00_2777;
							obj_t BgL_arg2036z00_2778;
							obj_t BgL_arg2037z00_2779;

							BgL_arg2035z00_2777 = CDR(BgL_lz00_2757);
							BgL_arg2036z00_2778 = CDR(BgL_varsz00_2758);
							BgL_arg2037z00_2779 =
								MAKE_PAIR(CAR(BgL_varsz00_2758), BgL_localsz00_2759);
							BgL_arg2032z00_2775 =
								BGl_convzd2valszd2zz__evaluatez00(BgL_wherez00_4104,
								BgL_globalsz00_4103, BgL_arg2035z00_2777, BgL_arg2036z00_2778,
								BgL_arg2037z00_2779, BgL_locz00_2772);
						}
						return MAKE_PAIR(BgL_arg2031z00_2774, BgL_arg2032z00_2775);
					}
				}
		}
	}



/* conv-lambda */
	BgL_ev_absz00_bglt BGl_convzd2lambdazd2zz__evaluatez00(obj_t
		BgL_globalsz00_4108, obj_t BgL_localsz00_4107, obj_t BgL_locz00_4106,
		obj_t BgL_ez00_4105, obj_t BgL_formalsz00_1895, obj_t BgL_bodyz00_1896,
		obj_t BgL_wherez00_1897)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 301 */
			{
				obj_t BgL_lz00_1926;

				{	/* Eval/evaluate.scm 303 */
					obj_t BgL_varsz00_1900;

					BgL_lz00_1926 =
						BGl_dssslzd2formalszd2ze3schemezd2typedzd2formalsze3zz__dssslz00
						(BgL_formalsz00_1895, BGl_errorzd2envzd2zz__errorz00, ((bool_t) 1));
					{
						obj_t BgL_rz00_1930;
						obj_t BgL_flatz00_1931;
						long BgL_arityz00_1932;

						BgL_rz00_1930 = BgL_lz00_1926;
						BgL_flatz00_1931 = BNIL;
						BgL_arityz00_1932 = ((long) 0);
					BgL_zc3anonymousza32118ze3z83_1933:
						if (NULLP(BgL_rz00_1930))
							{	/* Eval/evaluate.scm 296 */
								obj_t BgL_val0_1181z00_1935;

								BgL_val0_1181z00_1935 = bgl_reverse_bang(BgL_flatz00_1931);
								{	/* Eval/evaluate.scm 296 */
									int BgL_res2381z00_2468;

									{	/* Ieee/control5.scm 73 */
										int BgL_auxz00_6484;

										BgL_auxz00_6484 = (int) (((long) 2));
										BgL_res2381z00_2468 =
											BGL_MVALUES_NUMBER_SET(BgL_auxz00_6484);
									} BgL_res2381z00_2468;
								}
								{	/* Ieee/control5.scm 85 */
									obj_t BgL_auxz00_6489;
									int BgL_auxz00_6487;

									BgL_auxz00_6489 = BINT(BgL_arityz00_1932);
									BgL_auxz00_6487 = (int) (((long) 1));
									BGL_MVALUES_VAL_SET(BgL_auxz00_6487, BgL_auxz00_6489);
								}
								BgL_varsz00_1900 = BgL_val0_1181z00_1935;
							}
						else
							{	/* Eval/evaluate.scm 295 */
								if (PAIRP(BgL_rz00_1930))
									{	/* Eval/evaluate.scm 300 */
										obj_t BgL_arg2121z00_1938;
										obj_t BgL_arg2122z00_1939;
										long BgL_arg2123z00_1940;

										BgL_arg2121z00_1938 = CDR(BgL_rz00_1930);
										BgL_arg2122z00_1939 =
											MAKE_PAIR(BGl_untypezd2identzd2zz__evaluatez00(CAR
												(BgL_rz00_1930)), BgL_flatz00_1931);
										BgL_arg2123z00_1940 = (BgL_arityz00_1932 + ((long) 1));
										{
											long BgL_arityz00_6501;
											obj_t BgL_flatz00_6500;
											obj_t BgL_rz00_6499;

											BgL_rz00_6499 = BgL_arg2121z00_1938;
											BgL_flatz00_6500 = BgL_arg2122z00_1939;
											BgL_arityz00_6501 = BgL_arg2123z00_1940;
											BgL_arityz00_1932 = BgL_arityz00_6501;
											BgL_flatz00_1931 = BgL_flatz00_6500;
											BgL_rz00_1930 = BgL_rz00_6499;
											goto BgL_zc3anonymousza32118ze3z83_1933;
										}
									}
								else
									{	/* Eval/evaluate.scm 298 */
										obj_t BgL_val0_1183z00_1943;
										long BgL_val1_1184z00_1944;

										{	/* Eval/evaluate.scm 298 */
											obj_t BgL_arg2128z00_1945;

											BgL_arg2128z00_1945 =
												MAKE_PAIR(BGl_untypezd2identzd2zz__evaluatez00
												(BgL_rz00_1930), BgL_flatz00_1931);
											BgL_val0_1183z00_1943 =
												bgl_reverse_bang(BgL_arg2128z00_1945);
										}
										BgL_val1_1184z00_1944 = (((long) -1) - BgL_arityz00_1932);
										{	/* Eval/evaluate.scm 298 */
											int BgL_res2385z00_2482;

											{	/* Ieee/control5.scm 73 */
												int BgL_auxz00_6506;

												BgL_auxz00_6506 = (int) (((long) 2));
												BgL_res2385z00_2482 =
													BGL_MVALUES_NUMBER_SET(BgL_auxz00_6506);
											} BgL_res2385z00_2482;
										}
										{	/* Ieee/control5.scm 85 */
											obj_t BgL_auxz00_6511;
											int BgL_auxz00_6509;

											BgL_auxz00_6511 = BINT(BgL_val1_1184z00_1944);
											BgL_auxz00_6509 = (int) (((long) 1));
											BGL_MVALUES_VAL_SET(BgL_auxz00_6509, BgL_auxz00_6511);
										}
										BgL_varsz00_1900 = BgL_val0_1183z00_1943;
					}}}
					{	/* Eval/evaluate.scm 305 */
						obj_t BgL_arityz00_1901;

						{	/* Ieee/control5.scm 79 */
							int BgL_auxz00_6515;

							BgL_auxz00_6515 = (int) (((long) 1));
							BgL_arityz00_1901 = BGL_MVALUES_VAL(BgL_auxz00_6515);
						}
						{	/* Eval/evaluate.scm 305 */
							obj_t BgL_varsz00_1902;
							obj_t BgL_bodyz00_1903;
							obj_t BgL_nlocz00_1904;

							if (NULLP(BgL_varsz00_1900))
								{	/* Eval/evaluate.scm 305 */
									BgL_varsz00_1902 = BNIL;
								}
							else
								{	/* Eval/evaluate.scm 305 */
									obj_t BgL_head1187z00_1911;

									{	/* Eval/evaluate.scm 305 */
										obj_t BgL_res2387z00_2490;

										BgL_res2387z00_2490 = MAKE_PAIR(BNIL, BNIL);
										BgL_head1187z00_1911 = BgL_res2387z00_2490;
									}
									{
										obj_t BgL_l1185z00_1913;
										obj_t BgL_tail1188z00_1914;

										BgL_l1185z00_1913 = BgL_varsz00_1900;
										BgL_tail1188z00_1914 = BgL_head1187z00_1911;
									BgL_zc3anonymousza32110ze3z83_1915:
										if (NULLP(BgL_l1185z00_1913))
											{	/* Eval/evaluate.scm 305 */
												BgL_varsz00_1902 = CDR(BgL_head1187z00_1911);
											}
										else
											{	/* Eval/evaluate.scm 305 */
												obj_t BgL_newtail1189z00_1917;

												{	/* Eval/evaluate.scm 305 */
													BgL_ev_varz00_bglt BgL_arg2114z00_1919;

													{	/* Eval/evaluate.scm 305 */
														obj_t BgL_vz00_1920;

														BgL_vz00_1920 = CAR(BgL_l1185z00_1913);
														{	/* Eval/evaluate.scm 306 */
															BgL_ev_varz00_bglt BgL_new1094z00_1921;

															{	/* Eval/evaluate.scm 306 */
																BgL_ev_varz00_bglt BgL_new1093z00_1922;

																BgL_new1093z00_1922 =
																	((BgL_ev_varz00_bglt)
																	BREF(GC_MALLOC(sizeof(struct
																				BgL_ev_varz00_bgl))));
																{	/* Eval/evaluate.scm 306 */
																	long BgL_arg2115z00_1923;

																	{	/* Eval/evaluate.scm 306 */
																		long BgL_res2389z00_2496;

																		BgL_res2389z00_2496 =
																			BGL_CLASS_INDEX
																			(BGl_ev_varz00zz__evaluate_typesz00);
																		BgL_arg2115z00_1923 = BgL_res2389z00_2496;
																	}
																	{	/* Eval/evaluate.scm 306 */
																		BgL_objectz00_bglt BgL_objz00_2497;

																		BgL_objz00_2497 =
																			((BgL_objectz00_bglt)
																			BgL_new1093z00_1922);
																		BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2497,
																			BgL_arg2115z00_1923);
																}}
																{	/* Eval/evaluate.scm 306 */
																	BgL_objectz00_bglt BgL_auxz00_6529;

																	BgL_auxz00_6529 =
																		((BgL_objectz00_bglt) BgL_new1093z00_1922);
																	BGL_OBJECT_WIDENING_SET(BgL_auxz00_6529,
																		BFALSE);
																}
																BgL_new1094z00_1921 = BgL_new1093z00_1922;
															}
															{
																obj_t BgL_auxz00_6532;

																{	/* Eval/evaluate.scm 307 */
																	obj_t BgL_pairz00_2499;

																	BgL_pairz00_2499 = BgL_vz00_1920;
																	BgL_auxz00_6532 = CAR(BgL_pairz00_2499);
																}
																((((BgL_ev_varz00_bglt)
																			CREF(BgL_new1094z00_1921))->BgL_namez00) =
																	((obj_t) BgL_auxz00_6532), BUNSPEC);
															}
															((((BgL_ev_varz00_bglt)
																		CREF(BgL_new1094z00_1921))->BgL_effz00) =
																((obj_t) BFALSE), BUNSPEC);
															{
																obj_t BgL_auxz00_6536;

																{	/* Eval/evaluate.scm 308 */
																	obj_t BgL_pairz00_2500;

																	BgL_pairz00_2500 = BgL_vz00_1920;
																	BgL_auxz00_6536 = CDR(BgL_pairz00_2500);
																}
																((((BgL_ev_varz00_bglt)
																			CREF(BgL_new1094z00_1921))->BgL_typez00) =
																	((obj_t) BgL_auxz00_6536), BUNSPEC);
															}
															BgL_arg2114z00_1919 = BgL_new1094z00_1921;
													}}
													{	/* Eval/evaluate.scm 305 */
														obj_t BgL_res2390z00_2503;

														{	/* Eval/evaluate.scm 305 */
															obj_t BgL_obj1z00_2501;

															BgL_obj1z00_2501 = ((obj_t) BgL_arg2114z00_1919);
															BgL_res2390z00_2503 =
																MAKE_PAIR(BgL_obj1z00_2501, BNIL);
														}
														BgL_newtail1189z00_1917 = BgL_res2390z00_2503;
												}}
												SET_CDR(BgL_tail1188z00_1914, BgL_newtail1189z00_1917);
												{
													obj_t BgL_tail1188z00_6544;
													obj_t BgL_l1185z00_6542;

													BgL_l1185z00_6542 = CDR(BgL_l1185z00_1913);
													BgL_tail1188z00_6544 = BgL_newtail1189z00_1917;
													BgL_tail1188z00_1914 = BgL_tail1188z00_6544;
													BgL_l1185z00_1913 = BgL_l1185z00_6542;
													goto BgL_zc3anonymousza32110ze3z83_1915;
												}
											}
									}
								}
							BgL_bodyz00_1903 =
								BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00
								(BgL_ez00_4105, BgL_formalsz00_1895, BgL_bodyz00_1896,
								BGl_errorzd2envzd2zz__errorz00);
							{	/* Eval/evaluate.scm 129 */
								obj_t BgL__ortest_1067z00_2509;

								BgL__ortest_1067z00_2509 =
									BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_bodyz00_1896);
								if (CBOOL(BgL__ortest_1067z00_2509))
									{	/* Eval/evaluate.scm 129 */
										BgL_nlocz00_1904 = BgL__ortest_1067z00_2509;
									}
								else
									{	/* Eval/evaluate.scm 129 */
										BgL_nlocz00_1904 = BgL_locz00_4106;
									}
							}
							{	/* Eval/evaluate.scm 312 */
								BgL_ev_absz00_bglt BgL_new1097z00_1905;

								{	/* Eval/evaluate.scm 312 */
									BgL_ev_absz00_bglt BgL_new1095z00_1907;

									BgL_new1095z00_1907 =
										((BgL_ev_absz00_bglt) BREF(GC_MALLOC(sizeof(struct
													BgL_ev_absz00_bgl))));
									{	/* Eval/evaluate.scm 312 */
										long BgL_arg2108z00_1908;

										{	/* Eval/evaluate.scm 312 */
											long BgL_res2391z00_2511;

											BgL_res2391z00_2511 =
												BGL_CLASS_INDEX(BGl_ev_absz00zz__evaluate_typesz00);
											BgL_arg2108z00_1908 = BgL_res2391z00_2511;
										}
										{	/* Eval/evaluate.scm 312 */
											BgL_objectz00_bglt BgL_objz00_2512;

											BgL_objz00_2512 =
												((BgL_objectz00_bglt) BgL_new1095z00_1907);
											BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2512,
												BgL_arg2108z00_1908);
									}}
									{	/* Eval/evaluate.scm 312 */
										BgL_objectz00_bglt BgL_auxz00_6553;

										BgL_auxz00_6553 =
											((BgL_objectz00_bglt) BgL_new1095z00_1907);
										BGL_OBJECT_WIDENING_SET(BgL_auxz00_6553, BFALSE);
									}
									BgL_new1097z00_1905 = BgL_new1095z00_1907;
								}
								((((BgL_ev_absz00_bglt) CREF(BgL_new1097z00_1905))->
										BgL_locz00) = ((obj_t) BgL_locz00_4106), BUNSPEC);
								((((BgL_ev_absz00_bglt) CREF(BgL_new1097z00_1905))->
										BgL_wherez00) = ((obj_t) BgL_wherez00_1897), BUNSPEC);
								((((BgL_ev_absz00_bglt) CREF(BgL_new1097z00_1905))->
										BgL_arityz00) = ((obj_t) BgL_arityz00_1901), BUNSPEC);
								((((BgL_ev_absz00_bglt) CREF(BgL_new1097z00_1905))->
										BgL_varsz00) = ((obj_t) BgL_varsz00_1902), BUNSPEC);
								{
									BgL_ev_exprz00_bglt BgL_auxz00_6560;

									{	/* Eval/evaluate.scm 317 */
										obj_t BgL_arg2107z00_1906;

										BgL_arg2107z00_1906 =
											BGl_appendzd221011zd2zz__evaluatez00(BgL_varsz00_1902,
											BgL_localsz00_4107);
										BgL_auxz00_6560 =
											((BgL_ev_exprz00_bglt)
											BGl_convz00zz__evaluatez00(BgL_bodyz00_1903,
												BgL_arg2107z00_1906, BgL_globalsz00_4108, BTRUE,
												BgL_wherez00_1897, BgL_nlocz00_1904, ((bool_t) 0)));
									}
									((((BgL_ev_absz00_bglt) CREF(BgL_new1097z00_1905))->
											BgL_bodyz00) =
										((BgL_ev_exprz00_bglt) BgL_auxz00_6560), BUNSPEC);
								}
								((((BgL_ev_absz00_bglt) CREF(BgL_new1097z00_1905))->
										BgL_siza7eza7) = ((int) (int) (((long) 0))), BUNSPEC);
								((((BgL_ev_absz00_bglt) CREF(BgL_new1097z00_1905))->
										BgL_bindz00) = ((obj_t) BNIL), BUNSPEC);
								((((BgL_ev_absz00_bglt) CREF(BgL_new1097z00_1905))->
										BgL_freez00) = ((obj_t) BNIL), BUNSPEC);
								((((BgL_ev_absz00_bglt) CREF(BgL_new1097z00_1905))->
										BgL_innerz00) = ((obj_t) BNIL), BUNSPEC);
								((((BgL_ev_absz00_bglt) CREF(BgL_new1097z00_1905))->
										BgL_boxesz00) = ((obj_t) BNIL), BUNSPEC);
								return BgL_new1097z00_1905;
							}
						}
					}
				}
			}
		}
	}



/* uconv/loc */
	obj_t BGl_uconvzf2loczf2zz__evaluatez00(obj_t BgL_wherez00_4115,
		obj_t BgL_globalsz00_4114, obj_t BgL_localsz00_4113, obj_t BgL_ez00_1877,
		obj_t BgL_locz00_1878)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 277 */
			return
				BGl_convz00zz__evaluatez00(BgL_ez00_1877, BgL_localsz00_4113,
				BgL_globalsz00_4114, BFALSE, BgL_wherez00_4115, BgL_locz00_1878,
				((bool_t) 0));
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zz__evaluatez00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 15 */
			return BUNSPEC;
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zz__evaluatez00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 15 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zz__evaluatez00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 15 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zz__evaluatez00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 15 */
			BGl_modulezd2initializa7ationz75zz__typez00(((long) 77607588),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 373318193),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 162724851),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__tvectorz00(((long) 135276775),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 128218210),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 258585428),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__bignumz00(((long) 6519932),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 438451175),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 443936801),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 317260169),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 441709255),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 1041382),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__threadz00(((long) 316564000),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 359798486),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)
					249410258), BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)
					247617611), BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)
					268155843), BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)
					198620800), BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)
					473309430), BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 459519430),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 460263214),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 97251556),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)
					47127928), BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)
					317842797), BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 509771705),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 162479995),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)
					116655667), BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)
					228151370), BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__ppz00(((long) 233942021),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 220648206),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__prognz00(((long) 177147622),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__expandz00(((long) 511051588),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evenvz00(((long) 23062368),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evcompilez00(((long) 492754569),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__everrorz00(((long) 375872221),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evmodulez00(((long) 6183155),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(((long) 0),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evaluate_avarz00(((long) 483789130),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evaluate_fsiza7eza7(((long)
					121298760), BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(((long) 193509656),
				BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
			return BGl_modulezd2initializa7ationz75zz__evaluate_compz00(((long)
					444000678), BSTRING_TO_STRING(BGl_string2695z00zz__evaluatez00));
		}
	}

#ifdef __cplusplus
}
#endif
