/*===========================================================================*/
/*   (Eval/evaluate_comp.scm)                                                */
/*   Bigloo (4.0a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jan 24 17:03:30 CET 2013        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -srfi enable-gmp -srfi bigloo-unsafe -O3 -fcfa-arithmetic -q +rm -lib-dir /users/serrano/prgm/project/bigloo/lib/4.0a -mklib -cc gcc -fsharing -q -no-hello -copt -fPIC -unsafe -safee -O4 -c Eval/evaluate_comp.scm -indent -o objs/obj_u/Eval/evaluate_comp.c)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_ev_exprz00_bgl
	{
		header_t header;
		obj_t widening;
	}                 *BgL_ev_exprz00_bglt;

	typedef struct BgL_ev_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_namez00;
		obj_t BgL_effz00;
		obj_t BgL_typez00;
	}                *BgL_ev_varz00_bglt;

	typedef struct BgL_ev_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                   *BgL_ev_globalz00_bglt;

	typedef struct BgL_ev_littz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_valuez00;
	}                 *BgL_ev_littz00_bglt;

	typedef struct BgL_ev_ifz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_pz00;
		struct BgL_ev_exprz00_bgl *BgL_tz00;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}               *BgL_ev_ifz00_bglt;

	typedef struct BgL_ev_listz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                 *BgL_ev_listz00_bglt;

	typedef struct BgL_ev_orz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}               *BgL_ev_orz00_bglt;

	typedef struct BgL_ev_andz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                *BgL_ev_andz00_bglt;

	typedef struct BgL_ev_prog2z00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_e1z00;
		struct BgL_ev_exprz00_bgl *BgL_e2z00;
	}                  *BgL_ev_prog2z00_bglt;

	typedef struct BgL_ev_hookz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_hookz00_bglt;

	typedef struct BgL_ev_trapz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_trapz00_bglt;

	typedef struct BgL_ev_setlocalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_varz00_bgl *BgL_vz00;
	}                     *BgL_ev_setlocalz00_bglt;

	typedef struct BgL_ev_setglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_setglobalz00_bglt;

	typedef struct BgL_ev_defglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_defglobalz00_bglt;

	typedef struct BgL_ev_bindzd2exitzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_varz00_bgl *BgL_varz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                        *BgL_ev_bindzd2exitzd2_bglt;

	typedef struct BgL_ev_unwindzd2protectzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                             *BgL_ev_unwindzd2protectzd2_bglt;

	typedef struct BgL_ev_withzd2handlerzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_handlerz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                           *BgL_ev_withzd2handlerzd2_bglt;

	typedef struct BgL_ev_synchroniza7eza7_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_mutexz00;
		struct BgL_ev_exprz00_bgl *BgL_prelockz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                          *BgL_ev_synchroniza7eza7_bglt;

	typedef struct BgL_ev_binderz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_binderz00_bglt;

	typedef struct BgL_ev_letz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_letz00_bglt;

	typedef struct BgL_ev_letza2za2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_letza2za2_bglt;

	typedef struct BgL_ev_letrecz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_letrecz00_bglt;

	typedef struct BgL_ev_labelsz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		obj_t BgL_envz00;
		obj_t BgL_stkz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_labelsz00_bglt;

	typedef struct BgL_ev_gotoz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_varz00_bgl *BgL_labelz00;
		struct BgL_ev_labelsz00_bgl *BgL_labelsz00;
		obj_t BgL_argsz00;
	}                 *BgL_ev_gotoz00_bglt;

	typedef struct BgL_ev_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_tailzf3zf3;
	}                *BgL_ev_appz00_bglt;

	typedef struct BgL_ev_absz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_wherez00;
		obj_t BgL_arityz00;
		obj_t BgL_varsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		int BgL_siza7eza7;
		obj_t BgL_bindz00;
		obj_t BgL_freez00;
		obj_t BgL_innerz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_absz00_bglt;


	static obj_t BGl_z62zc3anonymousza32599ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5491z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33708ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5493z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5495z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5497z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5499z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_abs1685zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32213ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32019ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_letrec1669zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31992ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32956ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33296ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
	static obj_t BGl_z62zc3anonymousza32141ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_if1656zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33491ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_trap1642zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33548ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33386ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32142ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza32941ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_compzd2oldzd2callz00zz__evaluate_compz00(BgL_ev_appz00_bglt,
		obj_t);
	extern obj_t BGl_ev_letrecz00zz__evaluate_typesz00;
	static obj_t BGl_zc3exitza33744ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33728ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33778ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_letz00zz__evaluate_typesz00;
	static obj_t BGl_symbol5601z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_zc3exitza33818ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_zc3exitza33656ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_symbol5603z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5605z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5607z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_subzd2stkzd2zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_symbol5609z00zz__evaluate_compz00 = BUNSPEC;
	extern bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
	static obj_t BGl_zc3exitza32112ze3z83zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32977ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33835ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_symbol5611z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5613z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5615z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5617z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62compzd2ev_defglobal1652zb0zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_symbol5619z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_objectzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_z62compzd2ev_unwindzd2prote1673z62zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_2za2za2zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_2zb2zb2zz__r4_numbers_6_5z00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32889ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_2zd2zd2zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_2zf2zf2zz__r4_numbers_6_5z00(obj_t, obj_t);
	static obj_t BGl_symbol5621z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_zc3exitza33569ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_setglobal1650zb0zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_symbol5623z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5625z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5627z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5629z00zz__evaluate_compz00 = BUNSPEC;
	extern bool_t BGl_2zc3zc3zz__r4_numbers_6_5z00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33054ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t BGl_2zd3zd3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33038ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza32946ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_symbol5631z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5633z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5635z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_valzd2fromzd2exitzf3zf3zz__bexitz00(obj_t);
	static obj_t BGl_symbol5637z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5639z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza33306ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33765ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_symbol5641z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5643z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5645z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t bstring_to_symbol(obj_t);
	static obj_t BGl_symbol5647z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza33072ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33129ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33799ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33960ze3z83zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t make_vector(int, obj_t);
	static obj_t BGl_zc3exitza33928ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_zc3exitza33677ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_ev_labelsz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza32611ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_bindzd2framezd2zz__evaluate_compz00(obj_t, obj_t, long, long,
		obj_t, obj_t);
	static obj_t BGl_appendzd221011zd2zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_zc3exitza33589ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33325ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_absz00zz__evaluate_typesz00;
	static obj_t BGl_zc3exitza32401ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_zc3exitza33857ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_everrorz00zz__everrorz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_zc3exitza31986ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32702ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5678z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza33091ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32524ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32257ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_reset_profilez00zz__evaluate_compz00();
	static obj_t BGl_z62zc3anonymousza33149ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_freezd2collectzd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_zc3exitza33205ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_zc3exitza32209ze3z83zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_ev_ifz00zz__evaluate_typesz00;
	static obj_t BGl_symbol5693z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5695z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza32631ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5697z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza32615ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5699z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_zc3exitza33400ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33222ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_zc3exitza33981ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32721ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32705ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33434ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32543ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33167ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza32138ze3z83zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62exitz62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_or1659zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33062ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33046ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3exitza32066ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_catchzd2trampolinezd2zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32650ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_gotoz00zz__evaluate_typesz00;
	static obj_t BGl_z62compzd2ev_var1644zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3lexintza1zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62run5500z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5502z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5504z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5506z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5508z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32902ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32724ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33453ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32635ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32708ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33348ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32619ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33420ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33242ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62runz62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5510z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5512z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5514z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5516z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5518z62zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32563ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32547ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33081ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33316ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3exitza32085ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_zc3exitza33138ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62run5520z62zz__evaluate_compz00(obj_t, obj_t);
	extern bool_t BGl_numberzf3zf3zz__r4_numbers_6_5z00(obj_t);
	static obj_t BGl_z62run5522z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5524z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5526z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5528z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33900ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static double BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33366ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32297ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33511ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_zc3exitza33406ze3z83zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_ev_orz00zz__evaluate_typesz00;
	static obj_t BGl_zc3exitza32175ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(obj_t,
		obj_t, obj_t, long, obj_t);
	extern obj_t BGl_ev_varz00zz__evaluate_typesz00;
	static obj_t BGl_z62run5530z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_zc3exitza33898ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5532z62zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t create_struct(obj_t, int);
	static obj_t BGl_z62run5534z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5536z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5538z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_get_profilez00zz__evaluate_compz00();
	static obj_t BGl_z62zc3anonymousza32743ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32727ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32298ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33261ze3z83zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_evarityzd2errorzd2zz__everrorz00(obj_t, obj_t, int, int);
	extern long bgl_list_length(obj_t);
	static obj_t BGl_z62run5540z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5542z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5544z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5546z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5548z62zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_evwarningz00zz__everrorz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32639ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33335ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33068ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static bool_t BGl_needzd2shiftzd2zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_ev_andz00zz__evaluate_typesz00;
	extern obj_t BGl_evmodulezd2findzd2globalz00zz__evmodulez00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32745ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33474ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32583ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32567ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33158ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_labels1679zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5501z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32819ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5503z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_zc3exitza33620ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5505z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5507z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_zc3exitza33426ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5509z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62mainz62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32836ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5511z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5513z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5515z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_ev_appz00zz__evaluate_typesz00;
	static obj_t BGl_z62main5517z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_zc3exitza33176ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5519z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_lnamez00zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62main5521z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5523z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5525z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5527z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5529z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_zc3exitza33088ze3z83zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_bigloozd2typezd2errorz00zz__errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32870ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compz62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza33494ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5531z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32587ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5533z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62main5535z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_zc3exitza33445ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5537z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62main5539z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62comp1639z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_uncompilez00zz__evaluate_uncompz00(BgL_ev_exprz00_bglt);
	static obj_t BGl_z62zc3anonymousza32944ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32693ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5541z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_zc3exitza33640ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5543z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_zc3exitza33535ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5545z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_zc3exitza33284ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5547z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_setlocal1646zb0zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33690ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32783ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31965ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32929ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33358ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_usez00zz__evaluate_usez00(BgL_ev_exprz00_bglt, obj_t);
	static obj_t BGl_z62compzd2ev_bindzd2exit1671z62zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32768ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33464ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32115ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33870ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_zc3exitza32930ze3z83zz__evaluate_compz00(obj_t, obj_t, obj_t,
		long, obj_t);
	static obj_t BGl_zc3exitza33554ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t
		BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_ev_exprz00_bglt, long,
		obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33112ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_makezd2statezd2zz__evaluate_compz00();
	static obj_t BGl_z62compzd2ev_withzd2handler1675z62zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_ev_defglobalz00zz__evaluate_typesz00;
	static obj_t BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_zc3exitza33199ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static bool_t BGl_zc3lexintzc3zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza32981ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33750ze3z83zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33662ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_letza21667z12zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3exitza32013ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33963ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(obj_t);
	static obj_t BGl_zc3exitza33841ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_zc3exitza32950ze3z83zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_zc3exitza33485ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_litt1654zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_toplevelzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_z62zc3anonymousza32047ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33575ze3z83zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32048ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_genericzd2initzd2zz__evaluate_compz00();
	extern obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	extern obj_t BGl_ev_prog2z00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza33207ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_evtypezd2errorzd2zz__everrorz00(obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00;
	static obj_t BGl_zc3exitza33771ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32987ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t bgl_reverse_bang(obj_t);
	static obj_t BGl_zc3exitza33950ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33683ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_zc3exitza33918ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static long BGl_za2za2siza7ezd2stackza2za2z75zz__evaluate_compz00;
	static obj_t BGl_symbol5553z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5555z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5557z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00;
	static obj_t BGl_zc3exitza33595ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_symbol5563z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza32351ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33226ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_recz00zz__evaluate_compz00(obj_t, obj_t, long);
	static bool_t BGl_recz72z72zz__evaluate_compz00(obj_t);
	static obj_t BGl_zc3exitza33863ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_symbol5571z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_ev_letza2za2zz__evaluate_typesz00;
	static obj_t BGl_symbol5573z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5575z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza32603ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5578z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza32069ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33121ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33105ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_zc3exitza33791ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_symbol5581z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5583z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5585z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_ozd2ze3sz31zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62zc3anonymousza32531ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5587z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5589z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_ev_trapz00zz__evaluate_typesz00;
	static obj_t BGl_zc3exitza32037ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_symbol5591z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_symbol5593z00zz__evaluate_compz00 = BUNSPEC;
	static bool_t BGl_makezd2boxeszd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol5595z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5597z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza33245ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5599z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62compzd2ev_prog21663zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_indexz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32711ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33602ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t
		BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
	static bool_t BGl_freezd2restorezd2zz__evaluate_compz00(obj_t, obj_t, long);
	static obj_t BGl_z62zc3anonymousza32088ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33302ze3z83zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_ev_setglobalz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza33190ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32623ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32607ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33409ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32178ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32089ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33052ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_Ez00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32551ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32535ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl__indexz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_inlinezd2callzd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33710ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32730ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_findzd2statezd2zz__evaluate_compz00();
	static obj_t BGl_z62zc3anonymousza32641ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32714ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33216ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33127ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_zc3exitza33991ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_compzd2withzd2pushz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_zc3exitza33797ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32820ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compilez62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33622ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33322ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_zc3exitza33144ze3z83zz__evaluate_compz00(obj_t, obj_t);
	extern bool_t string_lt(obj_t, obj_t);
	static obj_t BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza33518ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32627ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62findzd2statezb0zz__evaluate_compz00(obj_t);
	static obj_t BGl_zc3exitza32254ze3z83zz__evaluate_compz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_usez00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evmodulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__everrorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evcompilez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evenvz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__expandz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__prognz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__ppz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__srfi4z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
	extern obj_t BGl_sortz00zz__r4_vectors_6_8z00(obj_t, obj_t);
	static obj_t BGl_zc3exitza33888ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_ev_globalz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3anonymousza32733ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32571ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_let1665zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32644ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32717ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32555ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33268ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32539ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_goto1681zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(long,
		long);
	static obj_t BGl_z62zc3anonymousza33390ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_littz00zz__evaluate_typesz00;
	static obj_t BGl_zc3exitza33341ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_zc3exitza33236ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_loczd2typezd2errorz00zz__evaluate_compz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33537ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33286ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_cnstzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_zc3exitza33164ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_global1648zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_compz00();
	static obj_t BGl_z62run5464z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5466z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5468z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33732ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32647ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33505ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00;
	static obj_t BGl_z62run5470z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_synchroniza7e1677z17zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62run5472z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5474z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5476z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33822ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5478z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33644ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32591ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32826ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32737ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32575ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32559ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33182ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_zc3exitza33255ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3exitza32348ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5480z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5482z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5484z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5486z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5488z62zz__evaluate_compz00(obj_t, obj_t);
	extern bool_t BGl_evmodulezf3zf3zz__evmodulez00(obj_t);
	static obj_t BGl_compzd2call0zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long);
	static obj_t BGl_compzd2call1zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t);
	static obj_t BGl_compzd2call2zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t);
	static obj_t BGl_compzd2call3zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
	static obj_t BGl_compzd2call4zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62run5490z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5492z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5494z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5496z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5498z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32755ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_exprz00zz__evaluate_typesz00;
	static obj_t BGl_zc3exitza33702ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33451ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_app1683zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33558ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33614ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3exitza32294ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33753ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32773ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32846ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32595ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32579ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33380ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33364ze3z83zz__evaluate_compz00(obj_t, obj_t);
	extern bool_t BGl_2zc3zd3z10zz__r4_numbers_6_5z00(obj_t, obj_t);
	static obj_t BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza33932ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33665ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(obj_t,
		obj_t, obj_t, obj_t, long);
	static obj_t BGl_zc3exitza33470ze3z83zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5463z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5465z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5467z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5469z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_compz00zz__evaluate_compz00(BgL_ev_exprz00_bglt, obj_t);
	static obj_t BGl_z62zc3anonymousza32953ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33844ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32937ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33722ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5471z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_and1661zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5473z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5475z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5477z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_zc3exitza33099ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5479z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern bool_t BGl_2ze3zd3z30zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_ev_setlocalz00zz__evaluate_typesz00;
	static obj_t BGl_arithzd2expressionzd2zz__evaluate_compz00(BgL_ev_appz00_bglt,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32792ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32849ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza33578ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33812ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5481z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_zc3exitza33634ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5483z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_zc3exitza33529ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5485z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3exitza33278ze3z83zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5487z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5489z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32212ze3ze1zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t *__cnst;


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_zc3lexintzd2envz11zz__evaluate_compz00,
		BgL_bgl_za762za7c3lexintza7a1za75703z00,
		BGl_z62zc3lexintza1zz__evaluate_compz00, 0L, BUNSPEC, 2);
	extern obj_t BGl_zd2zd2envz00zz__r4_numbers_6_5z00;
	extern obj_t BGl_zd3zd2envz01zz__r4_numbers_6_5z00;
	extern obj_t BGl_f64vectorzd2refzd2envz00zz__srfi4z00;
	extern obj_t BGl_ze3zd3fxzd2envze2zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_compilezd2envzd2zz__evaluate_compz00,
		BgL_bgl_za762compileza762za7za7_5704z00,
		BGl_z62compilez62zz__evaluate_compz00, 0L, BUNSPEC, 1);
	extern obj_t BGl_zc3fxzd2envz11zz__r4_numbers_6_5_fixnumz00;
	extern obj_t BGl_zc3zd3flzd2envzc2zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_ze3zd2envz31zz__r4_numbers_6_5z00;
	extern obj_t BGl_zf2zd2envz20zz__r4_numbers_6_5z00;
	extern obj_t BGl_zd2fxzd2envz00zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2statezd2envz00zz__evaluate_compz00,
		BgL_bgl_za762findza7d2stateza75705za7,
		BGl_z62findzd2statezb0zz__evaluate_compz00, 0L, BUNSPEC, 0);
	extern obj_t BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_ze3fxzd2envz31zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STRING(BGl_string5600z00zz__evaluate_compz00,
		BgL_bgl_string5600za700za7za7_5706za7, "=", 1);
	      DEFINE_STRING(BGl_string5602z00zz__evaluate_compz00,
		BgL_bgl_string5602za700za7za7_5707za7, "+fx", 3);
	      DEFINE_STRING(BGl_string5604z00zz__evaluate_compz00,
		BgL_bgl_string5604za700za7za7_5708za7, "fixnum", 6);
	      DEFINE_STRING(BGl_string5606z00zz__evaluate_compz00,
		BgL_bgl_string5606za700za7za7_5709za7, "-fx", 3);
	      DEFINE_STRING(BGl_string5608z00zz__evaluate_compz00,
		BgL_bgl_string5608za700za7za7_5710za7, "*fx", 3);
	      DEFINE_STRING(BGl_string5610z00zz__evaluate_compz00,
		BgL_bgl_string5610za700za7za7_5711za7, "/fx", 3);
	      DEFINE_STRING(BGl_string5612z00zz__evaluate_compz00,
		BgL_bgl_string5612za700za7za7_5712za7, "<fx", 3);
	      DEFINE_STRING(BGl_string5614z00zz__evaluate_compz00,
		BgL_bgl_string5614za700za7za7_5713za7, ">fx", 3);
	      DEFINE_STRING(BGl_string5616z00zz__evaluate_compz00,
		BgL_bgl_string5616za700za7za7_5714za7, "<=fx", 4);
	      DEFINE_STRING(BGl_string5618z00zz__evaluate_compz00,
		BgL_bgl_string5618za700za7za7_5715za7, ">=fx", 4);
	extern obj_t BGl_ze3zd3flzd2envze2zz__r4_numbers_6_5_flonumz00;
	   
		 
		DEFINE_STRING(BGl_string5620z00zz__evaluate_compz00,
		BgL_bgl_string5620za700za7za7_5716za7, "=fx", 3);
	      DEFINE_STRING(BGl_string5622z00zz__evaluate_compz00,
		BgL_bgl_string5622za700za7za7_5717za7, "+fl", 3);
	      DEFINE_STRING(BGl_string5624z00zz__evaluate_compz00,
		BgL_bgl_string5624za700za7za7_5718za7, "flonum", 6);
	      DEFINE_STRING(BGl_string5626z00zz__evaluate_compz00,
		BgL_bgl_string5626za700za7za7_5719za7, "-fl", 3);
	      DEFINE_STRING(BGl_string5628z00zz__evaluate_compz00,
		BgL_bgl_string5628za700za7za7_5720za7, "*fl", 3);
	extern obj_t BGl_zc3flzd2envz11zz__r4_numbers_6_5_flonumz00;
	   
		 
		DEFINE_STRING(BGl_string5630z00zz__evaluate_compz00,
		BgL_bgl_string5630za700za7za7_5721za7, "/fl", 3);
	      DEFINE_STRING(BGl_string5632z00zz__evaluate_compz00,
		BgL_bgl_string5632za700za7za7_5722za7, "<fl", 3);
	      DEFINE_STRING(BGl_string5634z00zz__evaluate_compz00,
		BgL_bgl_string5634za700za7za7_5723za7, ">fl", 3);
	      DEFINE_STRING(BGl_string5636z00zz__evaluate_compz00,
		BgL_bgl_string5636za700za7za7_5724za7, "<=fl", 4);
	      DEFINE_STRING(BGl_string5638z00zz__evaluate_compz00,
		BgL_bgl_string5638za700za7za7_5725za7, ">=fl", 4);
	extern obj_t BGl_zc3zd3zd2envzc2zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_STRING(BGl_string5640z00zz__evaluate_compz00,
		BgL_bgl_string5640za700za7za7_5726za7, "=fl", 3);
	      DEFINE_STRING(BGl_string5642z00zz__evaluate_compz00,
		BgL_bgl_string5642za700za7za7_5727za7, "car", 3);
	      DEFINE_STRING(BGl_string5644z00zz__evaluate_compz00,
		BgL_bgl_string5644za700za7za7_5728za7, "pair", 4);
	      DEFINE_STRING(BGl_string5646z00zz__evaluate_compz00,
		BgL_bgl_string5646za700za7za7_5729za7, "cdr", 3);
	      DEFINE_STRING(BGl_string5648z00zz__evaluate_compz00,
		BgL_bgl_string5648za700za7za7_5730za7, "cadr", 4);
	extern obj_t BGl_zf2fxzd2envz20zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STRING(BGl_string5650z00zz__evaluate_compz00,
		BgL_bgl_string5650za700za7za7_5731za7, "comp1639", 8);
	      DEFINE_STRING(BGl_string5651z00zz__evaluate_compz00,
		BgL_bgl_string5651za700za7za7_5732za7, "internal error: not defined for",
		31);
	      DEFINE_STRING(BGl_string5652z00zz__evaluate_compz00,
		BgL_bgl_string5652za700za7za7_5733za7, "&comp", 5);
	      DEFINE_STRING(BGl_string5654z00zz__evaluate_compz00,
		BgL_bgl_string5654za700za7za7_5734za7, "comp", 4);
	extern obj_t BGl_za2fxzd2envz70zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STATIC_BGL_GENERIC(BGl_compzd2envzd2zz__evaluate_compz00,
		BgL_bgl_za762compza762za7za7__ev5735z00, BGl_z62compz62zz__evaluate_compz00,
		0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5676z00zz__evaluate_compz00,
		BgL_bgl_string5676za700za7za7_5736za7, "internal error", 14);
	      DEFINE_STRING(BGl_string5677z00zz__evaluate_compz00,
		BgL_bgl_string5677za700za7za7_5737za7, "must be dead code", 17);
	      DEFINE_STRING(BGl_string5679z00zz__evaluate_compz00,
		BgL_bgl_string5679za700za7za7_5738za7, "notyet", 6);
	      DEFINE_STRING(BGl_string5680z00zz__evaluate_compz00,
		BgL_bgl_string5680za700za7za7_5739za7, "set!", 4);
	      DEFINE_STRING(BGl_string5681z00zz__evaluate_compz00,
		BgL_bgl_string5681za700za7za7_5740za7, "read-only variable", 18);
	      DEFINE_STRING(BGl_string5682z00zz__evaluate_compz00,
		BgL_bgl_string5682za700za7za7_5741za7,
		"\nRedefinition of compiled variable -- ", 38);
	      DEFINE_STRING(BGl_string5683z00zz__evaluate_compz00,
		BgL_bgl_string5683za700za7za7_5742za7, "Unbound variable", 16);
	      DEFINE_STRING(BGl_string5684z00zz__evaluate_compz00,
		BgL_bgl_string5684za700za7za7_5743za7, "Uninitialized variable", 22);
	extern obj_t BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00;
	   
		 
		DEFINE_STRING(BGl_string5694z00zz__evaluate_compz00,
		BgL_bgl_string5694za700za7za7_5744za7, "get_sp", 6);
	      DEFINE_STRING(BGl_string5696z00zz__evaluate_compz00,
		BgL_bgl_string5696za700za7za7_5745za7, "reset_profile", 13);
	      DEFINE_STRING(BGl_string5698z00zz__evaluate_compz00,
		BgL_bgl_string5698za700za7za7_5746za7, "get_profile", 11);
	extern obj_t BGl_carzd2envzd2zz__r4_pairs_and_lists_6_3z00;
	extern obj_t BGl_cadrzd2envzd2zz__r4_pairs_and_lists_6_3z00;
	extern obj_t BGl_ze3zd3zd2envze2zz__r4_numbers_6_5z00;
	extern obj_t BGl_ze3flzd2envz31zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
	extern obj_t BGl_zd3fxzd2envz01zz__r4_numbers_6_5_fixnumz00;
	extern obj_t BGl_eqzf3zd2envz21zz__r4_equivalence_6_2z00;
	extern obj_t BGl_cdrzd2envzd2zz__r4_pairs_and_lists_6_3z00;
	   
		 
		DEFINE_STRING(BGl_string5700z00zz__evaluate_compz00,
		BgL_bgl_string5700za700za7za7_5747za7, "reset_stack", 11);
	      DEFINE_STRING(BGl_string5701z00zz__evaluate_compz00,
		BgL_bgl_string5701za700za7za7_5748za7, "internal error: unknown command",
		31);
	      DEFINE_STRING(BGl_string5702z00zz__evaluate_compz00,
		BgL_bgl_string5702za700za7za7_5749za7, "__evaluate_comp", 15);
	extern obj_t BGl_fixnumzd2ze3flonumzd2envze3zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_STRING(BGl_string5554z00zz__evaluate_compz00,
		BgL_bgl_string5554za700za7za7_5750za7, "all", 3);
	      DEFINE_STRING(BGl_string5556z00zz__evaluate_compz00,
		BgL_bgl_string5556za700za7za7_5751za7, "label-tag", 9);
	      DEFINE_STRING(BGl_string5558z00zz__evaluate_compz00,
		BgL_bgl_string5558za700za7za7_5752za7, "bounce", 6);
	      DEFINE_STRING(BGl_string5559z00zz__evaluate_compz00,
		BgL_bgl_string5559za700za7za7_5753za7, "non non non", 11);
	extern obj_t BGl_za2zd2envz70zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_STRING(BGl_string5560z00zz__evaluate_compz00,
		BgL_bgl_string5560za700za7za7_5754za7, " in ", 4);
	      DEFINE_STRING(BGl_string5561z00zz__evaluate_compz00,
		BgL_bgl_string5561za700za7za7_5755za7, "eval", 4);
	      DEFINE_STRING(BGl_string5562z00zz__evaluate_compz00,
		BgL_bgl_string5562za700za7za7_5756za7, "internal error: not found", 25);
	      DEFINE_STRING(BGl_string5564z00zz__evaluate_compz00,
		BgL_bgl_string5564za700za7za7_5757za7, "at", 2);
	      DEFINE_STRING(BGl_string5565z00zz__evaluate_compz00,
		BgL_bgl_string5565za700za7za7_5758za7, "", 0);
	      DEFINE_STRING(BGl_string5566z00zz__evaluate_compz00,
		BgL_bgl_string5566za700za7za7_5759za7,
		"/tmp/bigloo/runtime/Eval/evaluate_comp.scm", 42);
	extern obj_t BGl_zc3zd3fxzd2envzc2zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STRING(BGl_string5567z00zz__evaluate_compz00,
		BgL_bgl_string5567za700za7za7_5760za7, "&compile", 8);
	      DEFINE_STRING(BGl_string5568z00zz__evaluate_compz00,
		BgL_bgl_string5568za700za7za7_5761za7, "ev_expr", 7);
	      DEFINE_STRING(BGl_string5569z00zz__evaluate_compz00,
		BgL_bgl_string5569za700za7za7_5762za7, "expecting ~a, got ~a", 20);
	      DEFINE_STRING(BGl_string5570z00zz__evaluate_compz00,
		BgL_bgl_string5570za700za7za7_5763za7, "wrong number of argument", 24);
	      DEFINE_STRING(BGl_string5572z00zz__evaluate_compz00,
		BgL_bgl_string5572za700za7za7_5764za7, "mcell", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5649z00zz__evaluate_compz00,
		BgL_bgl_za762comp1639za762za7za75765z00,
		BGl_z62comp1639z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5574z00zz__evaluate_compz00,
		BgL_bgl_string5574za700za7za7_5766za7, "internal", 8);
	      DEFINE_STRING(BGl_string5576z00zz__evaluate_compz00,
		BgL_bgl_string5576za700za7za7_5767za7, "impossible", 10);
	      DEFINE_STRING(BGl_string5577z00zz__evaluate_compz00,
		BgL_bgl_string5577za700za7za7_5768za7, "procedure", 9);
	      DEFINE_STRING(BGl_string5579z00zz__evaluate_compz00,
		BgL_bgl_string5579za700za7za7_5769za7, "user", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5653z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_tra5770z00,
		BGl_z62compzd2ev_trap1642zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5655z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_var5771z00,
		BGl_z62compzd2ev_var1644zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5580z00zz__evaluate_compz00,
		BgL_bgl_string5580za700za7za7_5772za7, "invalid byte code", 17);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5656z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_set5773z00,
		BGl_z62compzd2ev_setlocal1646zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5657z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_glo5774z00,
		BGl_z62compzd2ev_global1648zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5582z00zz__evaluate_compz00,
		BgL_bgl_string5582za700za7za7_5775za7, "+", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5658z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_set5776z00,
		BGl_z62compzd2ev_setglobal1650zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5659z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_def5777z00,
		BGl_z62compzd2ev_defglobal1652zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5584z00zz__evaluate_compz00,
		BgL_bgl_string5584za700za7za7_5778za7, "number", 6);
	      DEFINE_STRING(BGl_string5586z00zz__evaluate_compz00,
		BgL_bgl_string5586za700za7za7_5779za7, "-", 1);
	      DEFINE_STRING(BGl_string5588z00zz__evaluate_compz00,
		BgL_bgl_string5588za700za7za7_5780za7, "*", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5660z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_lit5781z00,
		BGl_z62compzd2ev_litt1654zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5661z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_if15782z00,
		BGl_z62compzd2ev_if1656zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5662z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_or15783z00,
		BGl_z62compzd2ev_or1659zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5663z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_and5784z00,
		BGl_z62compzd2ev_and1661zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5664z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_pro5785z00,
		BGl_z62compzd2ev_prog21663zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5665z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_let5786z00,
		BGl_z62compzd2ev_let1665zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5590z00zz__evaluate_compz00,
		BgL_bgl_string5590za700za7za7_5787za7, "/", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5666z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_let5788z00,
		BGl_z62compzd2ev_letza21667z12zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5667z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_let5789z00,
		BGl_z62compzd2ev_letrec1669zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5592z00zz__evaluate_compz00,
		BgL_bgl_string5592za700za7za7_5790za7, "<", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5668z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_bin5791z00,
		BGl_z62compzd2ev_bindzd2exit1671z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5669z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_unw5792z00,
		BGl_z62compzd2ev_unwindzd2prote1673z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5594z00zz__evaluate_compz00,
		BgL_bgl_string5594za700za7za7_5793za7, ">", 1);
	      DEFINE_STRING(BGl_string5596z00zz__evaluate_compz00,
		BgL_bgl_string5596za700za7za7_5794za7, "<=", 2);
	      DEFINE_STRING(BGl_string5598z00zz__evaluate_compz00,
		BgL_bgl_string5598za700za7za7_5795za7, ">=", 2);
	extern obj_t BGl_zb2zd2envz60zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5670z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_wit5796z00,
		BGl_z62compzd2ev_withzd2handler1675z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5671z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_syn5797z00,
		BGl_z62compzd2ev_synchroniza7e1677z17zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5672z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_lab5798z00,
		BGl_z62compzd2ev_labels1679zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5673z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_got5799z00,
		BGl_z62compzd2ev_goto1681zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5674z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_app5800z00,
		BGl_z62compzd2ev_app1683zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5675z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_abs5801z00,
		BGl_z62compzd2ev_abs1685zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	extern obj_t BGl_zd3flzd2envz01zz__r4_numbers_6_5_flonumz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5685z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3anonymousza75802za7,
		BGl_z62zc3anonymousza32702ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5686z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3anonymousza75803za7,
		BGl_z62zc3anonymousza32705ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5687z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3anonymousza75804za7,
		BGl_z62zc3anonymousza32708ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5688z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3anonymousza75805za7,
		BGl_z62zc3anonymousza32711ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5689z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3anonymousza75806za7,
		BGl_z62zc3anonymousza32714ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5690z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3anonymousza75807za7,
		BGl_z62zc3anonymousza32717ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5691z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3anonymousza75808za7,
		BGl_z62zc3anonymousza32721ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5692z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3anonymousza75809za7,
		BGl_z62zc3anonymousza32724ze3ze1zz__evaluate_compz00, 0L, BUNSPEC, 1);
	extern obj_t BGl_zc3zd2envz11zz__r4_numbers_6_5z00;
	extern obj_t BGl_zb2fxzd2envz60zz__r4_numbers_6_5_fixnumz00;



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long
		BgL_checksumz00_17750, char *BgL_fromz00_17751)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zz__evaluate_compz00))
				{
					BGl_requirezd2initializa7ationz75zz__evaluate_compz00 =
						BBOOL(((bool_t) 0));
					BGl_cnstzd2initzd2zz__evaluate_compz00();
					BGl_importedzd2moduleszd2initz00zz__evaluate_compz00();
					BGl_genericzd2initzd2zz__evaluate_compz00();
					BGl_methodzd2initzd2zz__evaluate_compz00();
					BGl_toplevelzd2initzd2zz__evaluate_compz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zz__evaluate_compz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 15 */
			BGl_symbol5553z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5554z00zz__evaluate_compz00);
			BGl_symbol5555z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5556z00zz__evaluate_compz00);
			BGl_symbol5557z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5558z00zz__evaluate_compz00);
			BGl_symbol5563z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5564z00zz__evaluate_compz00);
			BGl_symbol5571z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5572z00zz__evaluate_compz00);
			BGl_symbol5573z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5574z00zz__evaluate_compz00);
			BGl_symbol5575z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5576z00zz__evaluate_compz00);
			BGl_symbol5578z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5579z00zz__evaluate_compz00);
			BGl_symbol5581z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5582z00zz__evaluate_compz00);
			BGl_symbol5583z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5584z00zz__evaluate_compz00);
			BGl_symbol5585z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5586z00zz__evaluate_compz00);
			BGl_symbol5587z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5588z00zz__evaluate_compz00);
			BGl_symbol5589z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5590z00zz__evaluate_compz00);
			BGl_symbol5591z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5592z00zz__evaluate_compz00);
			BGl_symbol5593z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5594z00zz__evaluate_compz00);
			BGl_symbol5595z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5596z00zz__evaluate_compz00);
			BGl_symbol5597z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5598z00zz__evaluate_compz00);
			BGl_symbol5599z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5600z00zz__evaluate_compz00);
			BGl_symbol5601z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5602z00zz__evaluate_compz00);
			BGl_symbol5603z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5604z00zz__evaluate_compz00);
			BGl_symbol5605z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5606z00zz__evaluate_compz00);
			BGl_symbol5607z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5608z00zz__evaluate_compz00);
			BGl_symbol5609z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5610z00zz__evaluate_compz00);
			BGl_symbol5611z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5612z00zz__evaluate_compz00);
			BGl_symbol5613z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5614z00zz__evaluate_compz00);
			BGl_symbol5615z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5616z00zz__evaluate_compz00);
			BGl_symbol5617z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5618z00zz__evaluate_compz00);
			BGl_symbol5619z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5620z00zz__evaluate_compz00);
			BGl_symbol5621z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5622z00zz__evaluate_compz00);
			BGl_symbol5623z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5624z00zz__evaluate_compz00);
			BGl_symbol5625z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5626z00zz__evaluate_compz00);
			BGl_symbol5627z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5628z00zz__evaluate_compz00);
			BGl_symbol5629z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5630z00zz__evaluate_compz00);
			BGl_symbol5631z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5632z00zz__evaluate_compz00);
			BGl_symbol5633z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5634z00zz__evaluate_compz00);
			BGl_symbol5635z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5636z00zz__evaluate_compz00);
			BGl_symbol5637z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5638z00zz__evaluate_compz00);
			BGl_symbol5639z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5640z00zz__evaluate_compz00);
			BGl_symbol5641z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5642z00zz__evaluate_compz00);
			BGl_symbol5643z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5644z00zz__evaluate_compz00);
			BGl_symbol5645z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5646z00zz__evaluate_compz00);
			BGl_symbol5647z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5648z00zz__evaluate_compz00);
			BGl_symbol5678z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5679z00zz__evaluate_compz00);
			BGl_symbol5693z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5694z00zz__evaluate_compz00);
			BGl_symbol5695z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5696z00zz__evaluate_compz00);
			BGl_symbol5697z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5698z00zz__evaluate_compz00);
			return (BGl_symbol5699z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5700z00zz__evaluate_compz00), BUNSPEC);
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zz__evaluate_compz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 15 */
			{	/* Eval/evaluate_comp.scm 101 */
				BGL_LONGLONG_T BgL_arg1716z00_906;

				{	/* Eval/evaluate_comp.scm 101 */
					BGL_LONGLONG_T BgL_res4327z00_5765;

					BgL_res4327z00_5765 = LONG_TO_LLONG(((long) 0));
					BgL_arg1716z00_906 = BgL_res4327z00_5765;
				}
				{	/* Eval/evaluate_comp.scm 101 */
					obj_t BgL_list1717z00_907;

					{	/* Eval/evaluate_comp.scm 101 */
						obj_t BgL_arg1718z00_908;

						BgL_arg1718z00_908 =
							MAKE_PAIR(make_bllong(BgL_arg1716z00_906), BNIL);
						BgL_list1717z00_907 =
							MAKE_PAIR(BGl_symbol5553z00zz__evaluate_compz00,
							BgL_arg1718z00_908);
					}
					BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 =
						BgL_list1717z00_907;
			}}
			BGl_za2za2siza7ezd2stackza2za2z75zz__evaluate_compz00 =
				(long) CINT(BGl_2za2za2zz__r4_numbers_6_5z00(BINT(((long) 8)),
					BINT(((long) 1024))));
			BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00 =
				create_struct(BGl_symbol5555z00zz__evaluate_compz00,
				(int) (((long) 0)));
			BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00 =
				create_struct(BGl_symbol5557z00zz__evaluate_compz00,
				(int) (((long) 0)));
			return BUNSPEC;
		}
	}



/* append-21011 */
	obj_t BGl_appendzd221011zd2zz__evaluate_compz00(obj_t BgL_l1z00_1,
		obj_t BgL_l2z00_2)
	{
		AN_OBJECT;
		{
			{
				obj_t BgL_headz00_909;

				BgL_headz00_909 = MAKE_PAIR(BNIL, BgL_l2z00_2);
				{
					obj_t BgL_prevz00_5797;
					obj_t BgL_tailz00_5798;

					BgL_prevz00_5797 = BgL_headz00_909;
					BgL_tailz00_5798 = BgL_l1z00_1;
				BgL_loopz00_5796:
					if (PAIRP(BgL_tailz00_5798))
						{
							obj_t BgL_newzd2prevzd2_5804;

							BgL_newzd2prevzd2_5804 =
								MAKE_PAIR(CAR(BgL_tailz00_5798), BgL_l2z00_2);
							SET_CDR(BgL_prevz00_5797, BgL_newzd2prevzd2_5804);
							{
								obj_t BgL_tailz00_17826;
								obj_t BgL_prevz00_17825;

								BgL_prevz00_17825 = BgL_newzd2prevzd2_5804;
								BgL_tailz00_17826 = CDR(BgL_tailz00_5798);
								BgL_tailz00_5798 = BgL_tailz00_17826;
								BgL_prevz00_5797 = BgL_prevz00_17825;
								goto BgL_loopz00_5796;
							}
						}
					else
						{
							BNIL;
						}
				}
				return CDR(BgL_headz00_909);
			}
		}
	}



/* reset_profile */
	obj_t BGl_reset_profilez00zz__evaluate_compz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 119 */
			{	/* Eval/evaluate_comp.scm 120 */
				BGL_LONGLONG_T BgL_arg1739z00_937;

				{	/* Eval/evaluate_comp.scm 120 */
					BGL_LONGLONG_T BgL_res4336z00_5815;

					BgL_res4336z00_5815 = LONG_TO_LLONG(((long) 0));
					BgL_arg1739z00_937 = BgL_res4336z00_5815;
				}
				{	/* Eval/evaluate_comp.scm 120 */
					obj_t BgL_list1740z00_938;

					{	/* Eval/evaluate_comp.scm 120 */
						obj_t BgL_arg1741z00_939;

						BgL_arg1741z00_939 =
							MAKE_PAIR(make_bllong(BgL_arg1739z00_937), BNIL);
						BgL_list1740z00_938 =
							MAKE_PAIR(BGl_symbol5553z00zz__evaluate_compz00,
							BgL_arg1741z00_939);
					}
					return (BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 =
						BgL_list1740z00_938, BUNSPEC);
				}
			}
		}
	}



/* <lexint */
	bool_t BGl_zc3lexintzc3zz__evaluate_compz00(obj_t BgL_t1z00_4,
		obj_t BgL_t2z00_5)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 122 */
			{	/* Eval/evaluate_comp.scm 129 */
				obj_t BgL_v1z00_941;
				obj_t BgL_v2z00_942;

				BgL_v1z00_941 = CAR(BgL_t1z00_4);
				BgL_v2z00_942 = CAR(BgL_t2z00_5);
				{	/* Eval/evaluate_comp.scm 130 */
					bool_t BgL_testz00_17835;

					if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_v1z00_941))
						{	/* Eval/evaluate_comp.scm 130 */
							BgL_testz00_17835 =
								BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_v2z00_942);
						}
					else
						{	/* Eval/evaluate_comp.scm 130 */
							BgL_testz00_17835 = ((bool_t) 0);
						}
					if (BgL_testz00_17835)
						{	/* Eval/evaluate_comp.scm 130 */
							return
								BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_v1z00_941, BgL_v2z00_942);
						}
					else
						{	/* Eval/evaluate_comp.scm 130 */
							return
								string_lt(BGl_ozd2ze3sz31zz__evaluate_compz00(BgL_v1z00_941),
								BGl_ozd2ze3sz31zz__evaluate_compz00(BgL_v2z00_942));
						}
				}
			}
		}
	}



/* o->s */
	obj_t BGl_ozd2ze3sz31zz__evaluate_compz00(obj_t BgL_vz00_947)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 128 */
			if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_vz00_947))
				{	/* Ieee/fixnum.scm 355 */

					return
						BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(
						(long) CINT(BgL_vz00_947), ((long) 10));
				}
			else
				{	/* Eval/evaluate_comp.scm 125 */
					if (SYMBOLP(BgL_vz00_947))
						{	/* Eval/evaluate_comp.scm 126 */
							obj_t BgL_res4339z00_5822;

							{	/* Eval/evaluate_comp.scm 126 */
								obj_t BgL_symbolz00_5820;

								BgL_symbolz00_5820 = BgL_vz00_947;
								{	/* Ieee/symbol.scm 135 */
									obj_t BgL_arg4136z00_5821;

									BgL_arg4136z00_5821 = SYMBOL_TO_STRING(BgL_symbolz00_5820);
									BgL_res4339z00_5822 =
										BGl_stringzd2copyzd2zz__r4_strings_6_7z00
										(BgL_arg4136z00_5821);
								}
							}
							return BgL_res4339z00_5822;
						}
					else
						{	/* Eval/evaluate_comp.scm 126 */
							if (STRINGP(BgL_vz00_947))
								{	/* Eval/evaluate_comp.scm 127 */
									return BgL_vz00_947;
								}
							else
								{	/* Eval/evaluate_comp.scm 127 */
									return BGl_string5559z00zz__evaluate_compz00;
								}
						}
				}
		}
	}



/* &<lexint */
	obj_t BGl_z62zc3lexintza1zz__evaluate_compz00(obj_t BgL_envz00_15673,
		obj_t BgL_t1z00_15674, obj_t BgL_t2z00_15675)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 122 */
			return
				BBOOL(BGl_zc3lexintzc3zz__evaluate_compz00(BgL_t1z00_15674,
					BgL_t2z00_15675));
		}
	}



/* get_profile */
	obj_t BGl_get_profilez00zz__evaluate_compz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 134 */
			BGl_recz72z72zz__evaluate_compz00
				(BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00);
			return BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00;
		}
	}



/* rec' */
	bool_t BGl_recz72z72zz__evaluate_compz00(obj_t BgL_tz00_956)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 135 */
			{	/* Eval/evaluate_comp.scm 136 */
				obj_t BgL_arg1752z00_958;
				obj_t BgL_arg1753z00_959;

				BgL_arg1752z00_958 = CDR(BgL_tz00_956);
				{	/* Eval/evaluate_comp.scm 136 */
					obj_t BgL_arg1754z00_960;

					{	/* Eval/evaluate_comp.scm 136 */
						obj_t BgL_pairz00_5831;

						BgL_pairz00_5831 = BgL_tz00_956;
						BgL_arg1754z00_960 = CDR(CDR(BgL_pairz00_5831));
					}
					BgL_arg1753z00_959 =
						BGl_sortz00zz__r4_vectors_6_8z00
						(BGl_zc3lexintzd2envz11zz__evaluate_compz00, BgL_arg1754z00_960);
				}
				SET_CDR(BgL_arg1752z00_958, BgL_arg1753z00_959);
			}
			{	/* Eval/evaluate_comp.scm 137 */
				obj_t BgL_g1543z00_961;

				{	/* Eval/evaluate_comp.scm 137 */
					obj_t BgL_pairz00_5837;

					BgL_pairz00_5837 = BgL_tz00_956;
					BgL_g1543z00_961 = CDR(CDR(BgL_pairz00_5837));
				}
				{
					obj_t BgL_l1541z00_5857;

					BgL_l1541z00_5857 = BgL_g1543z00_961;
				BgL_zc3anonymousza31755ze3z83_5856:
					if (PAIRP(BgL_l1541z00_5857))
						{	/* Eval/evaluate_comp.scm 137 */
							BGl_recz72z72zz__evaluate_compz00(CAR(BgL_l1541z00_5857));
							{
								obj_t BgL_l1541z00_17867;

								BgL_l1541z00_17867 = CDR(BgL_l1541z00_5857);
								BgL_l1541z00_5857 = BgL_l1541z00_17867;
								goto BgL_zc3anonymousza31755ze3z83_5856;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 137 */
							return ((bool_t) 1);
						}
				}
			}
		}
	}



/* index */
	obj_t BGl_indexz00zz__evaluate_compz00(obj_t BgL_xz00_6, obj_t BgL_lz00_7)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 143 */
			{
				obj_t BgL_lz00_5895;
				long BgL_nz00_5896;

				BgL_lz00_5895 = BgL_lz00_7;
				BgL_nz00_5896 = ((long) 0);
			BgL_walkz00_5894:
				if (NULLP(BgL_lz00_5895))
					{	/* Eval/evaluate_comp.scm 145 */
						return BFALSE;
					}
				else
					{	/* Eval/evaluate_comp.scm 145 */
						if ((BgL_xz00_6 == CAR(BgL_lz00_5895)))
							{	/* Eval/evaluate_comp.scm 146 */
								return BINT(BgL_nz00_5896);
							}
						else
							{
								long BgL_nz00_17877;
								obj_t BgL_lz00_17875;

								BgL_lz00_17875 = CDR(BgL_lz00_5895);
								BgL_nz00_17877 = (BgL_nz00_5896 + ((long) 1));
								BgL_nz00_5896 = BgL_nz00_17877;
								BgL_lz00_5895 = BgL_lz00_17875;
								goto BgL_walkz00_5894;
							}
					}
			}
		}
	}



/* _index */
	obj_t BGl__indexz00zz__evaluate_compz00(obj_t BgL_xz00_8, obj_t BgL_lz00_9)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 150 */
			{	/* Eval/evaluate_comp.scm 151 */
				obj_t BgL__ortest_1075z00_980;

				BgL__ortest_1075z00_980 =
					BGl_indexz00zz__evaluate_compz00(BgL_xz00_8, BgL_lz00_9);
				if (CBOOL(BgL__ortest_1075z00_980))
					{	/* Eval/evaluate_comp.scm 151 */
						return BgL__ortest_1075z00_980;
					}
				else
					{	/* Eval/evaluate_comp.scm 151 */
						obj_t BgL_arg1766z00_981;

						{	/* Eval/evaluate_comp.scm 151 */
							obj_t BgL_arg1768z00_982;

							if (NULLP(BgL_lz00_9))
								{	/* Eval/evaluate_comp.scm 151 */
									BgL_arg1768z00_982 = BNIL;
								}
							else
								{	/* Eval/evaluate_comp.scm 151 */
									obj_t BgL_head1546z00_988;

									{	/* Eval/evaluate_comp.scm 151 */
										obj_t BgL_arg1780z00_1000;

										{	/* Eval/evaluate_comp.scm 151 */
											obj_t BgL_arg1781z00_1001;

											BgL_arg1781z00_1001 = CAR(BgL_lz00_9);
											if (BGl_isazf3zf3zz__objectz00(BgL_arg1781z00_1001,
													BGl_ev_varz00zz__evaluate_typesz00))
												{	/* Eval/evaluate_comp.scm 176 */
													BgL_arg1780z00_1000 =
														(((BgL_ev_varz00_bglt) CREF(
																((BgL_ev_varz00_bglt) BgL_arg1781z00_1001)))->
														BgL_namez00);
												}
											else
												{	/* Eval/evaluate_comp.scm 176 */
													BgL_arg1780z00_1000 = BgL_arg1781z00_1001;
												}
										}
										{	/* Eval/evaluate_comp.scm 151 */
											obj_t BgL_res4352z00_5922;

											BgL_res4352z00_5922 =
												MAKE_PAIR(BgL_arg1780z00_1000, BNIL);
											BgL_head1546z00_988 = BgL_res4352z00_5922;
										}
									}
									{	/* Eval/evaluate_comp.scm 151 */
										obj_t BgL_g1549z00_989;

										BgL_g1549z00_989 = CDR(BgL_lz00_9);
										{
											obj_t BgL_l1544z00_5958;
											obj_t BgL_tail1547z00_5959;

											BgL_l1544z00_5958 = BgL_g1549z00_989;
											BgL_tail1547z00_5959 = BgL_head1546z00_988;
										BgL_zc3anonymousza31775ze3z83_5957:
											if (NULLP(BgL_l1544z00_5958))
												{	/* Eval/evaluate_comp.scm 151 */
													BgL_arg1768z00_982 = BgL_head1546z00_988;
												}
											else
												{	/* Eval/evaluate_comp.scm 151 */
													obj_t BgL_newtail1548z00_5966;

													{	/* Eval/evaluate_comp.scm 151 */
														obj_t BgL_arg1778z00_5967;

														BgL_arg1778z00_5967 =
															BGl_lnamez00zz__evaluate_compz00(CAR
															(BgL_l1544z00_5958));
														{	/* Eval/evaluate_comp.scm 151 */
															obj_t BgL_res4358z00_5975;

															BgL_res4358z00_5975 =
																MAKE_PAIR(BgL_arg1778z00_5967, BNIL);
															BgL_newtail1548z00_5966 = BgL_res4358z00_5975;
														}
													}
													SET_CDR(BgL_tail1547z00_5959,
														BgL_newtail1548z00_5966);
													{
														obj_t BgL_tail1547z00_17899;
														obj_t BgL_l1544z00_17897;

														BgL_l1544z00_17897 = CDR(BgL_l1544z00_5958);
														BgL_tail1547z00_17899 = BgL_newtail1548z00_5966;
														BgL_tail1547z00_5959 = BgL_tail1547z00_17899;
														BgL_l1544z00_5958 = BgL_l1544z00_17897;
														goto BgL_zc3anonymousza31775ze3z83_5957;
													}
												}
										}
									}
								}
							{	/* Eval/evaluate_comp.scm 151 */
								obj_t BgL_list1769z00_983;

								{	/* Eval/evaluate_comp.scm 151 */
									obj_t BgL_arg1771z00_984;

									{	/* Eval/evaluate_comp.scm 151 */
										obj_t BgL_arg1773z00_985;

										BgL_arg1773z00_985 = MAKE_PAIR(BgL_arg1768z00_982, BNIL);
										BgL_arg1771z00_984 =
											MAKE_PAIR(BGl_string5560z00zz__evaluate_compz00,
											BgL_arg1773z00_985);
									}
									BgL_list1769z00_983 =
										MAKE_PAIR(BgL_xz00_8, BgL_arg1771z00_984);
								}
								BgL_arg1766z00_981 = BgL_list1769z00_983;
							}
						}
						return
							BGl_errorz00zz__errorz00(BGl_string5561z00zz__evaluate_compz00,
							BGl_string5562z00zz__evaluate_compz00, BgL_arg1766z00_981);
					}
			}
		}
	}



/* lname */
	obj_t BGl_lnamez00zz__evaluate_compz00(obj_t BgL_vz00_16)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 175 */
			if (BGl_isazf3zf3zz__objectz00(BgL_vz00_16,
					BGl_ev_varz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 176 */
					return
						(((BgL_ev_varz00_bglt) CREF(
								((BgL_ev_varz00_bglt) BgL_vz00_16)))->BgL_namez00);
				}
			else
				{	/* Eval/evaluate_comp.scm 176 */
					return BgL_vz00_16;
				}
		}
	}



/* loc-type-error */
	obj_t BGl_loczd2typezd2errorz00zz__evaluate_compz00(obj_t BgL_fz00_17,
		obj_t BgL_mz00_18, obj_t BgL_vz00_19, obj_t BgL_locz00_20)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 180 */
			if (PAIRP(BgL_locz00_20))
				{	/* Eval/evaluate_comp.scm 181 */
					obj_t BgL_cdrzd2177zd2_1027;

					BgL_cdrzd2177zd2_1027 = CDR(BgL_locz00_20);
					if ((CAR(BgL_locz00_20) == BGl_symbol5563z00zz__evaluate_compz00))
						{	/* Eval/evaluate_comp.scm 181 */
							if (PAIRP(BgL_cdrzd2177zd2_1027))
								{	/* Eval/evaluate_comp.scm 181 */
									obj_t BgL_cdrzd2181zd2_1030;

									BgL_cdrzd2181zd2_1030 = CDR(BgL_cdrzd2177zd2_1027);
									if (PAIRP(BgL_cdrzd2181zd2_1030))
										{	/* Eval/evaluate_comp.scm 181 */
											if (NULLP(CDR(BgL_cdrzd2181zd2_1030)))
												{	/* Eval/evaluate_comp.scm 181 */
													return
														BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
														(BgL_fz00_17, BgL_mz00_18, BgL_vz00_19,
														CAR(BgL_cdrzd2177zd2_1027),
														CAR(BgL_cdrzd2181zd2_1030));
												}
											else
												{	/* Eval/evaluate_comp.scm 181 */
													return
														BGl_bigloozd2typezd2errorz00zz__errorz00
														(BgL_fz00_17, BgL_mz00_18, BgL_vz00_19);
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 181 */
											return
												BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17,
												BgL_mz00_18, BgL_vz00_19);
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 181 */
									return
										BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17,
										BgL_mz00_18, BgL_vz00_19);
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 181 */
							return
								BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17,
								BgL_mz00_18, BgL_vz00_19);
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 181 */
					return
						BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17, BgL_mz00_18,
						BgL_vz00_19);
				}
		}
	}



/* make-state */
	obj_t BGl_makezd2statezd2zz__evaluate_compz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 193 */
			{	/* Eval/evaluate_comp.scm 194 */
				obj_t BgL_stkz00_1044;

				BgL_stkz00_1044 =
					make_vector(
					(int) (BGl_za2za2siza7ezd2stackza2za2z75zz__evaluate_compz00),
					BGl_string5565z00zz__evaluate_compz00);
				VECTOR_SET(BgL_stkz00_1044, (int) (((long) 0)), BINT(((long) 2)));
				return BgL_stkz00_1044;
			}
		}
	}



/* find-state */
	BGL_EXPORTED_DEF obj_t BGl_findzd2statezd2zz__evaluate_compz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 198 */
			{	/* Eval/evaluate_comp.scm 199 */
				obj_t BgL_sz00_1045;

				{	/* Eval/evaluate_comp.scm 199 */
					obj_t BgL_auxz00_17935;

					BgL_auxz00_17935 = BGL_CURRENT_DYNAMIC_ENV();
					BgL_sz00_1045 = BGL_ENV_EVSTATE(BgL_auxz00_17935);
				}
				if (VECTORP(BgL_sz00_1045))
					{	/* Eval/evaluate_comp.scm 200 */
						return BgL_sz00_1045;
					}
				else
					{	/* Eval/evaluate_comp.scm 201 */
						obj_t BgL_statez00_1047;

						BgL_statez00_1047 = BGl_makezd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 202 */
							obj_t BgL_auxz00_17941;

							BgL_auxz00_17941 = BGL_CURRENT_DYNAMIC_ENV();
							BGL_ENV_EVSTATE_SET(BgL_auxz00_17941, BgL_statez00_1047);
						}
						return BgL_statez00_1047;
					}
			}
		}
	}



/* &find-state */
	obj_t BGl_z62findzd2statezb0zz__evaluate_compz00(obj_t BgL_envz00_15676)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 198 */
			return BGl_findzd2statezd2zz__evaluate_compz00();
		}
	}



/* compile */
	BGL_EXPORTED_DEF obj_t BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt
		BgL_ez00_34)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 261 */
			return BGl_compz00zz__evaluate_compz00(BgL_ez00_34, BNIL);
		}
	}



/* &compile */
	obj_t BGl_z62compilez62zz__evaluate_compz00(obj_t BgL_envz00_15677,
		obj_t BgL_ez00_15678)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 261 */
			{	/* Eval/evaluate_comp.scm 262 */
				BgL_ev_exprz00_bglt BgL_auxz00_17946;

				if (BGl_isazf3zf3zz__objectz00(BgL_ez00_15678,
						BGl_ev_exprz00zz__evaluate_typesz00))
					{	/* Eval/evaluate_comp.scm 262 */
						BgL_auxz00_17946 = ((BgL_ev_exprz00_bglt) BgL_ez00_15678);
					}
				else
					{
						obj_t BgL_auxz00_17950;

						BgL_auxz00_17950 =
							BGl_typezd2errorzd2zz__errorz00
							(BGl_string5566z00zz__evaluate_compz00, BINT(((long) 6592)),
							BGl_string5567z00zz__evaluate_compz00,
							BGl_string5568z00zz__evaluate_compz00, BgL_ez00_15678);
						FAILURE(BgL_auxz00_17950, BFALSE, BFALSE);
					}
				return BGl_compilez00zz__evaluate_compz00(BgL_auxz00_17946);
			}
		}
	}



/* global-fun-value */
	obj_t BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_ev_exprz00_bglt
		BgL_ez00_43)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 320 */
			if (BGl_isazf3zf3zz__objectz00(
					((obj_t) BgL_ez00_43), BGl_ev_globalz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 322 */
					BgL_ev_globalz00_bglt BgL_i1090z00_1097;

					BgL_i1090z00_1097 = ((BgL_ev_globalz00_bglt) BgL_ez00_43);
					{	/* Eval/evaluate_comp.scm 323 */
						obj_t BgL_gz00_1098;

						BgL_gz00_1098 =
							BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
							(((BgL_ev_globalz00_bglt) CREF(BgL_i1090z00_1097))->BgL_modz00),
							(((BgL_ev_globalz00_bglt) CREF(BgL_i1090z00_1097))->BgL_namez00));
						if (CBOOL(BgL_gz00_1098))
							{	/* Eval/evaluate_comp.scm 324 */
								return VECTOR_REF(BgL_gz00_1098, (int) (((long) 2)));
							}
						else
							{	/* Eval/evaluate_comp.scm 324 */
								return BFALSE;
							}
					}
				}
			else
				{	/* Eval/evaluate_comp.scm 321 */
					return BFALSE;
				}
		}
	}



/* push-boxes-args-on-sp */
	obj_t BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(obj_t
		BgL_sz00_82, obj_t BgL_argsz00_83, obj_t BgL_boxesz00_84, long BgL_spz00_85,
		obj_t BgL_locz00_86)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 602 */
			{
				obj_t BgL_lz00_1117;
				obj_t BgL_bsz00_1118;
				long BgL_spz00_1119;

				BgL_lz00_1117 = BgL_argsz00_83;
				BgL_bsz00_1118 = BgL_boxesz00_84;
				BgL_spz00_1119 = BgL_spz00_85;
			BgL_zc3anonymousza31864ze3z83_1120:
				if (NULLP(BgL_lz00_1117))
					{	/* Eval/evaluate_comp.scm 604 */
						if (NULLP(BgL_bsz00_1118))
							{	/* Eval/evaluate_comp.scm 605 */
								return BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 608 */
								obj_t BgL_arg1867z00_1123;

								{	/* Eval/evaluate_comp.scm 608 */
									long BgL_arg1868z00_1124;
									long BgL_arg1869z00_1125;

									BgL_arg1868z00_1124 = bgl_list_length(BgL_boxesz00_84);
									BgL_arg1869z00_1125 = bgl_list_length(BgL_argsz00_83);
									{	/* Eval/evaluate_comp.scm 607 */
										obj_t BgL_list1870z00_1126;

										{	/* Eval/evaluate_comp.scm 607 */
											obj_t BgL_arg1871z00_1127;

											BgL_arg1871z00_1127 =
												MAKE_PAIR(BINT(BgL_arg1869z00_1125), BNIL);
											BgL_list1870z00_1126 =
												MAKE_PAIR(BINT(BgL_arg1868z00_1124),
												BgL_arg1871z00_1127);
										}
										BgL_arg1867z00_1123 =
											BGl_formatz00zz__r4_output_6_10_3z00
											(BGl_string5569z00zz__evaluate_compz00,
											BgL_list1870z00_1126);
								}}
								return
									BGl_everrorz00zz__everrorz00(BgL_locz00_86,
									BGl_string5561z00zz__evaluate_compz00,
									BGl_string5570z00zz__evaluate_compz00, BgL_arg1867z00_1123);
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 604 */
						if (NULLP(BgL_bsz00_1118))
							{	/* Eval/evaluate_comp.scm 612 */
								obj_t BgL_arg1873z00_1129;

								{	/* Eval/evaluate_comp.scm 612 */
									long BgL_arg1874z00_1130;
									long BgL_arg1875z00_1131;

									BgL_arg1874z00_1130 = bgl_list_length(BgL_boxesz00_84);
									BgL_arg1875z00_1131 = bgl_list_length(BgL_argsz00_83);
									{	/* Eval/evaluate_comp.scm 611 */
										obj_t BgL_list1876z00_1132;

										{	/* Eval/evaluate_comp.scm 611 */
											obj_t BgL_arg1877z00_1133;

											BgL_arg1877z00_1133 =
												MAKE_PAIR(BINT(BgL_arg1875z00_1131), BNIL);
											BgL_list1876z00_1132 =
												MAKE_PAIR(BINT(BgL_arg1874z00_1130),
												BgL_arg1877z00_1133);
										}
										BgL_arg1873z00_1129 =
											BGl_formatz00zz__r4_output_6_10_3z00
											(BGl_string5569z00zz__evaluate_compz00,
											BgL_list1876z00_1132);
								}}
								return
									BGl_everrorz00zz__everrorz00(BgL_locz00_86,
									BGl_string5561z00zz__evaluate_compz00,
									BGl_string5570z00zz__evaluate_compz00, BgL_arg1873z00_1129);
							}
						else
							{	/* Eval/evaluate_comp.scm 609 */
								{	/* Eval/evaluate_comp.scm 615 */
									obj_t BgL_arg1878z00_1134;

									{	/* Eval/evaluate_comp.scm 615 */
										obj_t BgL_vz00_1135;

										{	/* Eval/evaluate_comp.scm 615 */
											obj_t BgL_fun1880z00_1137;

											BgL_fun1880z00_1137 = CAR(BgL_lz00_1117);
											BgL_vz00_1135 =
												PROCEDURE_ENTRY(BgL_fun1880z00_1137)
												(BgL_fun1880z00_1137, BgL_sz00_82, BEOA);
										}
										{	/* Eval/evaluate_comp.scm 616 */
											bool_t BgL_testz00_17993;

											{	/* Eval/evaluate_comp.scm 616 */
												obj_t BgL_pairz00_6050;

												BgL_pairz00_6050 = BgL_bsz00_1118;
												BgL_testz00_17993 = CBOOL(CAR(BgL_pairz00_6050));
											}
											if (BgL_testz00_17993)
												{	/* Eval/evaluate_comp.scm 189 */
													obj_t BgL_newz00_6052;

													BgL_newz00_6052 =
														create_struct(BGl_symbol5571z00zz__evaluate_compz00,
														(int) (((long) 1)));
													{	/* Llib/struct.scm 162 */
														int BgL_auxz00_17998;

														BgL_auxz00_17998 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_6052, BgL_auxz00_17998,
															BgL_vz00_1135);
													}
													BgL_arg1878z00_1134 = BgL_newz00_6052;
												}
											else
												{	/* Eval/evaluate_comp.scm 616 */
													BgL_arg1878z00_1134 = BgL_vz00_1135;
												}
										}
									}
									VECTOR_SET(BgL_sz00_82,
										(int) (BgL_spz00_1119), BgL_arg1878z00_1134);
								}
								{
									long BgL_spz00_18007;
									obj_t BgL_bsz00_18005;
									obj_t BgL_lz00_18003;

									BgL_lz00_18003 = CDR(BgL_lz00_1117);
									BgL_bsz00_18005 = CDR(BgL_bsz00_1118);
									BgL_spz00_18007 = (BgL_spz00_1119 + ((long) 1));
									BgL_spz00_1119 = BgL_spz00_18007;
									BgL_bsz00_1118 = BgL_bsz00_18005;
									BgL_lz00_1117 = BgL_lz00_18003;
									goto BgL_zc3anonymousza31864ze3z83_1120;
								}
							}
					}
			}
		}
	}



/* sub-stk */
	obj_t BGl_subzd2stkzd2zz__evaluate_compz00(obj_t BgL_l1z00_88,
		obj_t BgL_l2z00_89)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 624 */
		BGl_subzd2stkzd2zz__evaluate_compz00:
			if (NULLP(BgL_l1z00_88))
				{	/* Eval/evaluate_comp.scm 625 */
					return BgL_l2z00_89;
				}
			else
				{	/* Eval/evaluate_comp.scm 625 */
					if ((CAR(BgL_l1z00_88) == CAR(BgL_l2z00_89)))
						{
							obj_t BgL_l2z00_18017;
							obj_t BgL_l1z00_18015;

							BgL_l1z00_18015 = CDR(BgL_l1z00_88);
							BgL_l2z00_18017 = CDR(BgL_l2z00_89);
							BgL_l2z00_89 = BgL_l2z00_18017;
							BgL_l1z00_88 = BgL_l1z00_18015;
							goto BGl_subzd2stkzd2zz__evaluate_compz00;
						}
					else
						{	/* Eval/evaluate_comp.scm 626 */
							return
								BGl_errorz00zz__errorz00(BGl_string5561z00zz__evaluate_compz00,
								BGl_symbol5573z00zz__evaluate_compz00,
								BGl_symbol5575z00zz__evaluate_compz00);
						}
				}
		}
	}



/* catch-trampoline */
	obj_t BGl_catchzd2trampolinezd2zz__evaluate_compz00(obj_t BgL_fz00_93,
		obj_t BgL_sz00_94, obj_t BgL_bpz00_95)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 648 */
			{	/* Eval/evaluate_comp.scm 649 */
				obj_t BgL_savedzd2bpzd2_1155;

				BgL_savedzd2bpzd2_1155 = VECTOR_REF(BgL_sz00_94, (int) (((long) 0)));
				VECTOR_SET(BgL_sz00_94, (int) (((long) 0)), BgL_bpz00_95);
				{
					obj_t BgL_fz00_1157;

					BgL_fz00_1157 = BgL_fz00_93;
				BgL_zc3anonymousza31897ze3z83_1158:
					{	/* Eval/evaluate_comp.scm 652 */
						obj_t BgL_rz00_1159;

						BgL_rz00_1159 =
							PROCEDURE_ENTRY(BgL_fz00_1157) (BgL_fz00_1157, BgL_sz00_94, BEOA);
						{	/* Eval/evaluate_comp.scm 653 */
							bool_t BgL_testz00_18028;

							if (PROCEDUREP(BgL_rz00_1159))
								{	/* Eval/evaluate_comp.scm 653 */
									obj_t BgL_arg1900z00_1162;

									BgL_arg1900z00_1162 = PROCEDURE_ATTR(BgL_rz00_1159);
									if (STRUCTP(BgL_arg1900z00_1162))
										{	/* Eval/evaluate_comp.scm 633 */
											BgL_testz00_18028 =
												(STRUCT_KEY(BgL_arg1900z00_1162) ==
												BGl_symbol5557z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 633 */
											BgL_testz00_18028 = ((bool_t) 0);
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 653 */
									BgL_testz00_18028 = ((bool_t) 0);
								}
							if (BgL_testz00_18028)
								{
									obj_t BgL_fz00_18036;

									BgL_fz00_18036 = BgL_rz00_1159;
									BgL_fz00_1157 = BgL_fz00_18036;
									goto BgL_zc3anonymousza31897ze3z83_1158;
								}
							else
								{	/* Eval/evaluate_comp.scm 653 */
									VECTOR_SET(BgL_sz00_94,
										(int) (((long) 0)), BgL_savedzd2bpzd2_1155);
									return BgL_rz00_1159;
								}
						}
					}
				}
			}
		}
	}



/* comp-with-push */
	obj_t BGl_compzd2withzd2pushz00zz__evaluate_compz00(obj_t BgL_eza2za2_117,
		obj_t BgL_stkz00_118)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 667 */
			if (NULLP(BgL_eza2za2_117))
				{	/* Eval/evaluate_comp.scm 669 */
					return BNIL;
				}
			else
				{	/* Eval/evaluate_comp.scm 671 */
					obj_t BgL_arg1910z00_1174;
					obj_t BgL_arg1911z00_1175;

					{	/* Eval/evaluate_comp.scm 671 */
						obj_t BgL_arg1912z00_1176;

						BgL_arg1912z00_1176 = CAR(BgL_eza2za2_117);
						BgL_arg1910z00_1174 =
							BGl_compz00zz__evaluate_compz00(
							((BgL_ev_exprz00_bglt) BgL_arg1912z00_1176), BgL_stkz00_118);
					}
					{	/* Eval/evaluate_comp.scm 672 */
						obj_t BgL_arg1914z00_1177;
						obj_t BgL_arg1915z00_1178;

						BgL_arg1914z00_1177 = CDR(BgL_eza2za2_117);
						{	/* Eval/evaluate_comp.scm 672 */
							obj_t BgL_arg1916z00_1179;

							BgL_arg1916z00_1179 = MAKE_PAIR(BFALSE, BNIL);
							BgL_arg1915z00_1178 =
								BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_118,
								BgL_arg1916z00_1179);
						}
						BgL_arg1911z00_1175 =
							BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_arg1914z00_1177,
							BgL_arg1915z00_1178);
					}
					return MAKE_PAIR(BgL_arg1910z00_1174, BgL_arg1911z00_1175);
				}
		}
	}



/* rec */
	obj_t BGl_recz00zz__evaluate_compz00(obj_t BgL_stkz00_17731,
		obj_t BgL_lz00_1181, long BgL_iz00_1182)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 675 */
			if (NULLP(BgL_lz00_1181))
				{	/* Eval/evaluate_comp.scm 676 */
					return BNIL;
				}
			else
				{	/* Eval/evaluate_comp.scm 676 */
					if ((BgL_iz00_1182 == ((long) 0)))
						{	/* Eval/evaluate_comp.scm 677 */
							return
								BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_lz00_1181,
								BgL_stkz00_17731);
						}
					else
						{	/* Eval/evaluate_comp.scm 678 */
							obj_t BgL_arg1920z00_1186;
							obj_t BgL_arg1921z00_1187;

							{	/* Eval/evaluate_comp.scm 678 */
								obj_t BgL_arg1922z00_1188;

								BgL_arg1922z00_1188 = CAR(BgL_lz00_1181);
								BgL_arg1920z00_1186 =
									BGl_compz00zz__evaluate_compz00(
									((BgL_ev_exprz00_bglt) BgL_arg1922z00_1188),
									BgL_stkz00_17731);
							}
							BgL_arg1921z00_1187 =
								BGl_recz00zz__evaluate_compz00(BgL_stkz00_17731,
								CDR(BgL_lz00_1181), (BgL_iz00_1182 - ((long) 1)));
							return MAKE_PAIR(BgL_arg1920z00_1186, BgL_arg1921z00_1187);
						}
				}
		}
	}



/* subr-call-with-push */
	obj_t BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(obj_t BgL_sz00_122,
		obj_t BgL_fz00_123, obj_t BgL_argsz00_124, obj_t BgL_bpz00_125,
		long BgL_siza7eza7_126)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 681 */
			{	/* Eval/evaluate_comp.scm 683 */
				obj_t BgL_argsz00_1192;

				if (NULLP(BgL_argsz00_124))
					{	/* Eval/evaluate_comp.scm 683 */
						BgL_argsz00_1192 = BNIL;
					}
				else
					{	/* Eval/evaluate_comp.scm 683 */
						obj_t BgL_head1596z00_1197;

						{	/* Eval/evaluate_comp.scm 683 */
							obj_t BgL_res4391z00_6171;

							BgL_res4391z00_6171 = MAKE_PAIR(BNIL, BNIL);
							BgL_head1596z00_1197 = BgL_res4391z00_6171;
						}
						{
							obj_t BgL_l1594z00_6205;
							obj_t BgL_tail1597z00_6206;

							BgL_l1594z00_6205 = BgL_argsz00_124;
							BgL_tail1597z00_6206 = BgL_head1596z00_1197;
						BgL_zc3anonymousza31927ze3z83_6204:
							if (NULLP(BgL_l1594z00_6205))
								{	/* Eval/evaluate_comp.scm 683 */
									BgL_argsz00_1192 = CDR(BgL_head1596z00_1197);
								}
							else
								{	/* Eval/evaluate_comp.scm 683 */
									obj_t BgL_newtail1598z00_6213;

									{	/* Eval/evaluate_comp.scm 683 */
										obj_t BgL_arg1930z00_6214;

										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_az00_6215;

											BgL_az00_6215 = CAR(BgL_l1594z00_6205);
											BgL_arg1930z00_6214 =
												PROCEDURE_ENTRY(BgL_az00_6215) (BgL_az00_6215,
												BgL_sz00_122, BEOA);
										}
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_res4397z00_6223;

											BgL_res4397z00_6223 =
												MAKE_PAIR(BgL_arg1930z00_6214, BNIL);
											BgL_newtail1598z00_6213 = BgL_res4397z00_6223;
										}
									}
									SET_CDR(BgL_tail1597z00_6206, BgL_newtail1598z00_6213);
									{
										obj_t BgL_tail1597z00_18076;
										obj_t BgL_l1594z00_18074;

										BgL_l1594z00_18074 = CDR(BgL_l1594z00_6205);
										BgL_tail1597z00_18076 = BgL_newtail1598z00_6213;
										BgL_tail1597z00_6206 = BgL_tail1597z00_18076;
										BgL_l1594z00_6205 = BgL_l1594z00_18074;
										goto BgL_zc3anonymousza31927ze3z83_6204;
									}
								}
						}
					}
				{	/* Eval/evaluate_comp.scm 684 */
					long BgL_arg1925z00_1193;

					BgL_arg1925z00_1193 =
						((long) CINT(BgL_bpz00_125) + BgL_siza7eza7_126);
					VECTOR_SET(BgL_sz00_122,
						(int) (((long) 0)), BINT(BgL_arg1925z00_1193));
				}
				{	/* Eval/evaluate_comp.scm 685 */
					obj_t BgL_za2za2resza2za2z00_1194;

					BgL_za2za2resza2za2z00_1194 = apply(BgL_fz00_123, BgL_argsz00_1192);
					VECTOR_SET(BgL_sz00_122, (int) (((long) 0)), BgL_bpz00_125);
					return BgL_za2za2resza2za2z00_1194;
				}
			}
		}
	}



/* push-nargs-on-sp */
	obj_t BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(obj_t
		BgL_arityz00_130, obj_t BgL_sz00_131, obj_t BgL_argsz00_132,
		obj_t BgL_spz00_133)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 694 */
			{	/* Eval/evaluate_comp.scm 695 */
				long BgL_g1144z00_1218;

				BgL_g1144z00_1218 = (((long) -1) - (long) CINT(BgL_arityz00_130));
				{
					obj_t BgL_lz00_1220;
					obj_t BgL_spz00_1221;
					long BgL_nz00_1222;

					BgL_lz00_1220 = BgL_argsz00_132;
					BgL_spz00_1221 = BgL_spz00_133;
					BgL_nz00_1222 = BgL_g1144z00_1218;
				BgL_zc3anonymousza31937ze3z83_1223:
					if ((BgL_nz00_1222 == ((long) 0)))
						{
							obj_t BgL_lz00_6334;
							obj_t BgL_rz00_6335;

							BgL_lz00_6334 = BgL_lz00_1220;
							BgL_rz00_6335 = BNIL;
						BgL_rec2z00_6333:
							if (NULLP(BgL_lz00_6334))
								{	/* Eval/evaluate_comp.scm 698 */
									return
										VECTOR_SET(BgL_sz00_131,
										CINT(BgL_spz00_1221), bgl_reverse_bang(BgL_rz00_6335));
								}
							else
								{	/* Eval/evaluate_comp.scm 700 */
									obj_t BgL_arg1942z00_6344;
									obj_t BgL_arg1943z00_6345;

									BgL_arg1942z00_6344 = CDR(BgL_lz00_6334);
									{	/* Eval/evaluate_comp.scm 700 */
										obj_t BgL_arg1944z00_6346;

										{	/* Eval/evaluate_comp.scm 700 */
											obj_t BgL_fun1945z00_6347;

											BgL_fun1945z00_6347 = CAR(BgL_lz00_6334);
											BgL_arg1944z00_6346 =
												PROCEDURE_ENTRY(BgL_fun1945z00_6347)
												(BgL_fun1945z00_6347, BgL_sz00_131, BEOA);
										}
										BgL_arg1943z00_6345 =
											MAKE_PAIR(BgL_arg1944z00_6346, BgL_rz00_6335);
									}
									{
										obj_t BgL_rz00_18103;
										obj_t BgL_lz00_18102;

										BgL_lz00_18102 = BgL_arg1942z00_6344;
										BgL_rz00_18103 = BgL_arg1943z00_6345;
										BgL_rz00_6335 = BgL_rz00_18103;
										BgL_lz00_6334 = BgL_lz00_18102;
										goto BgL_rec2z00_6333;
									}
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 696 */
							{	/* Eval/evaluate_comp.scm 701 */
								obj_t BgL_arg1946z00_1237;

								{	/* Eval/evaluate_comp.scm 701 */
									obj_t BgL_fun1947z00_1238;

									BgL_fun1947z00_1238 = CAR(BgL_lz00_1220);
									BgL_arg1946z00_1237 =
										PROCEDURE_ENTRY(BgL_fun1947z00_1238) (BgL_fun1947z00_1238,
										BgL_sz00_131, BEOA);
								}
								VECTOR_SET(BgL_sz00_131,
									CINT(BgL_spz00_1221), BgL_arg1946z00_1237);
							}
							{	/* Eval/evaluate_comp.scm 702 */
								obj_t BgL_arg1948z00_1239;
								long BgL_arg1949z00_1240;
								long BgL_arg1950z00_1241;

								BgL_arg1948z00_1239 = CDR(BgL_lz00_1220);
								BgL_arg1949z00_1240 =
									((long) CINT(BgL_spz00_1221) + ((long) 1));
								BgL_arg1950z00_1241 = (BgL_nz00_1222 - ((long) 1));
								{
									long BgL_nz00_18118;
									obj_t BgL_spz00_18116;
									obj_t BgL_lz00_18115;

									BgL_lz00_18115 = BgL_arg1948z00_1239;
									BgL_spz00_18116 = BINT(BgL_arg1949z00_1240);
									BgL_nz00_18118 = BgL_arg1950z00_1241;
									BgL_nz00_1222 = BgL_nz00_18118;
									BgL_spz00_1221 = BgL_spz00_18116;
									BgL_lz00_1220 = BgL_lz00_18115;
									goto BgL_zc3anonymousza31937ze3z83_1223;
								}
							}
						}
				}
			}
		}
	}



/* need-shift */
	bool_t BGl_needzd2shiftzd2zz__evaluate_compz00(obj_t BgL_argsz00_134,
		obj_t BgL_stkz00_135)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 739 */
			{
				obj_t BgL_lz00_1244;
				obj_t BgL_stkz00_1245;

				BgL_lz00_1244 = BgL_argsz00_134;
				BgL_stkz00_1245 = BgL_stkz00_135;
			BgL_zc3anonymousza31951ze3z83_1246:
				{	/* Eval/evaluate_comp.scm 743 */
					bool_t BgL_testz00_18119;

					if (NULLP(BgL_lz00_1244))
						{	/* Eval/evaluate_comp.scm 743 */
							BgL_testz00_18119 = ((bool_t) 1);
						}
					else
						{	/* Eval/evaluate_comp.scm 743 */
							BgL_testz00_18119 = NULLP(BgL_stkz00_1245);
						}
					if (BgL_testz00_18119)
						{	/* Eval/evaluate_comp.scm 743 */
							return ((bool_t) 0);
						}
					else
						{	/* Eval/evaluate_comp.scm 745 */
							bool_t BgL_testz00_18123;

							{	/* Eval/evaluate_comp.scm 745 */
								obj_t BgL_g1601z00_1251;

								BgL_g1601z00_1251 = CDR(BgL_lz00_1244);
								{
									obj_t BgL_l1599z00_1253;

									{	/* Eval/evaluate_comp.scm 745 */
										obj_t BgL_auxz00_18125;

										BgL_l1599z00_1253 = BgL_g1601z00_1251;
									BgL_zc3anonymousza31957ze3z83_1254:
										if (NULLP(BgL_l1599z00_1253))
											{	/* Eval/evaluate_comp.scm 745 */
												BgL_auxz00_18125 = BFALSE;
											}
										else
											{	/* Eval/evaluate_comp.scm 745 */
												obj_t BgL__ortest_1602z00_1256;

												{	/* Eval/evaluate_comp.scm 745 */
													obj_t BgL_ez00_1258;

													BgL_ez00_1258 = CAR(BgL_l1599z00_1253);
													{	/* Eval/evaluate_comp.scm 745 */
														obj_t BgL_arg1960z00_1259;
														obj_t BgL_arg1961z00_1260;

														BgL_arg1960z00_1259 = CAR(BgL_stkz00_1245);
														BgL_arg1961z00_1260 =
															BGl_usez00zz__evaluate_usez00(
															((BgL_ev_exprz00_bglt) BgL_ez00_1258), BNIL);
														BgL__ortest_1602z00_1256 =
															BGl_memqz00zz__r4_pairs_and_lists_6_3z00
															(BgL_arg1960z00_1259, BgL_arg1961z00_1260);
													}
												}
												if (CBOOL(BgL__ortest_1602z00_1256))
													{	/* Eval/evaluate_comp.scm 745 */
														BgL_auxz00_18125 = BgL__ortest_1602z00_1256;
													}
												else
													{
														obj_t BgL_l1599z00_18135;

														BgL_l1599z00_18135 = CDR(BgL_l1599z00_1253);
														BgL_l1599z00_1253 = BgL_l1599z00_18135;
														goto BgL_zc3anonymousza31957ze3z83_1254;
													}
											}
										BgL_testz00_18123 = CBOOL(BgL_auxz00_18125);
									}
								}
							}
							if (BgL_testz00_18123)
								{	/* Eval/evaluate_comp.scm 745 */
									return ((bool_t) 1);
								}
							else
								{
									obj_t BgL_stkz00_18140;
									obj_t BgL_lz00_18138;

									BgL_lz00_18138 = CDR(BgL_lz00_1244);
									BgL_stkz00_18140 = CDR(BgL_stkz00_1245);
									BgL_stkz00_1245 = BgL_stkz00_18140;
									BgL_lz00_1244 = BgL_lz00_18138;
									goto BgL_zc3anonymousza31951ze3z83_1246;
								}
						}
				}
			}
		}
	}



/* comp-old-call */
	obj_t BGl_compzd2oldzd2callz00zz__evaluate_compz00(BgL_ev_appz00_bglt
		BgL_ez00_136, obj_t BgL_stkz00_137)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 749 */
			{	/* Eval/evaluate_comp.scm 751 */
				long BgL_siza7eza7_1265;
				long BgL_nbargsz00_1266;
				obj_t BgL_fz00_1267;
				obj_t BgL_symbzd2funzd2_1268;

				BgL_siza7eza7_1265 = bgl_list_length(BgL_stkz00_137);
				BgL_nbargsz00_1266 =
					bgl_list_length(
					(((BgL_ev_appz00_bglt) CREF(BgL_ez00_136))->BgL_argsz00));
				BgL_fz00_1267 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_appz00_bglt) CREF(BgL_ez00_136))->BgL_funz00),
					BgL_stkz00_137);
				BgL_symbzd2funzd2_1268 =
					BGl_uncompilez00zz__evaluate_uncompz00((((BgL_ev_appz00_bglt)
							CREF(BgL_ez00_136))->BgL_funz00));
				if (CBOOL((((BgL_ev_appz00_bglt) CREF(BgL_ez00_136))->BgL_tailzf3zf3)))
					{	/* Eval/evaluate_comp.scm 753 */
						if (BGl_needzd2shiftzd2zz__evaluate_compz00(
								(((BgL_ev_appz00_bglt) CREF(BgL_ez00_136))->BgL_argsz00),
								BgL_stkz00_137))
							{	/* Eval/evaluate_comp.scm 760 */
								obj_t BgL_argsz00_1271;

								BgL_argsz00_1271 =
									BGl_compzd2withzd2pushz00zz__evaluate_compz00(
									(((BgL_ev_appz00_bglt) CREF(BgL_ez00_136))->BgL_argsz00),
									BgL_stkz00_137);
								{	/* Eval/evaluate_comp.scm 760 */
									obj_t BgL_zc3anonymousza31965ze3z83_15679;

									BgL_zc3anonymousza31965ze3z83_15679 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3anonymousza31965ze3ze1zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_zc3anonymousza31965ze3z83_15679,
										(int) (((long) 0)), BgL_fz00_1267);
									PROCEDURE_SET(BgL_zc3anonymousza31965ze3z83_15679,
										(int) (((long) 1)), ((obj_t) BgL_ez00_136));
									PROCEDURE_SET(BgL_zc3anonymousza31965ze3z83_15679,
										(int) (((long) 2)), BgL_symbzd2funzd2_1268);
									PROCEDURE_SET(BgL_zc3anonymousza31965ze3z83_15679,
										(int) (((long) 3)), BINT(BgL_nbargsz00_1266));
									PROCEDURE_SET(BgL_zc3anonymousza31965ze3z83_15679,
										(int) (((long) 4)), BgL_argsz00_1271);
									PROCEDURE_SET(BgL_zc3anonymousza31965ze3z83_15679,
										(int) (((long) 5)), BINT(BgL_siza7eza7_1265));
									return BgL_zc3anonymousza31965ze3z83_15679;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 768 */
								obj_t BgL_argsz00_1312;

								BgL_argsz00_1312 =
									BGl_recz00zz__evaluate_compz00(BgL_stkz00_137,
									(((BgL_ev_appz00_bglt) CREF(BgL_ez00_136))->BgL_argsz00),
									BgL_siza7eza7_1265);
								{	/* Eval/evaluate_comp.scm 768 */
									obj_t BgL_zc3anonymousza31992ze3z83_15680;

									BgL_zc3anonymousza31992ze3z83_15680 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3anonymousza31992ze3ze1zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_zc3anonymousza31992ze3z83_15680,
										(int) (((long) 0)), BgL_fz00_1267);
									PROCEDURE_SET(BgL_zc3anonymousza31992ze3z83_15680,
										(int) (((long) 1)), ((obj_t) BgL_ez00_136));
									PROCEDURE_SET(BgL_zc3anonymousza31992ze3z83_15680,
										(int) (((long) 2)), BgL_symbzd2funzd2_1268);
									PROCEDURE_SET(BgL_zc3anonymousza31992ze3z83_15680,
										(int) (((long) 3)), BINT(BgL_nbargsz00_1266));
									PROCEDURE_SET(BgL_zc3anonymousza31992ze3z83_15680,
										(int) (((long) 4)), BgL_argsz00_1312);
									return BgL_zc3anonymousza31992ze3z83_15680;
								}
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 754 */
						obj_t BgL_argsz00_1351;

						BgL_argsz00_1351 =
							BGl_compzd2withzd2pushz00zz__evaluate_compz00(
							(((BgL_ev_appz00_bglt) CREF(BgL_ez00_136))->BgL_argsz00),
							BgL_stkz00_137);
						{	/* Eval/evaluate_comp.scm 754 */
							obj_t BgL_zc3anonymousza32019ze3z83_15681;

							BgL_zc3anonymousza32019ze3z83_15681 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3anonymousza32019ze3ze1zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 6)));
							PROCEDURE_SET(BgL_zc3anonymousza32019ze3z83_15681,
								(int) (((long) 0)), BgL_fz00_1267);
							PROCEDURE_SET(BgL_zc3anonymousza32019ze3z83_15681,
								(int) (((long) 1)), ((obj_t) BgL_ez00_136));
							PROCEDURE_SET(BgL_zc3anonymousza32019ze3z83_15681,
								(int) (((long) 2)), BgL_symbzd2funzd2_1268);
							PROCEDURE_SET(BgL_zc3anonymousza32019ze3z83_15681,
								(int) (((long) 3)), BINT(BgL_nbargsz00_1266));
							PROCEDURE_SET(BgL_zc3anonymousza32019ze3z83_15681,
								(int) (((long) 4)), BgL_argsz00_1351);
							PROCEDURE_SET(BgL_zc3anonymousza32019ze3z83_15681,
								(int) (((long) 5)), BINT(BgL_siza7eza7_1265));
							return BgL_zc3anonymousza32019ze3z83_15681;
						}
					}
			}
		}
	}



/* &<anonymous:1965> */
	obj_t BGl_z62zc3anonymousza31965ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15682, obj_t BgL_sz00_15689)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 760 */
			{	/* Eval/evaluate_comp.scm 760 */
				obj_t BgL_fz00_15683;
				BgL_ev_appz00_bglt BgL_i1149z00_15684;
				obj_t BgL_symbzd2funzd2_15685;
				long BgL_nbargsz00_15686;
				obj_t BgL_argsz00_15687;
				long BgL_siza7eza7_15688;

				BgL_fz00_15683 = PROCEDURE_REF(BgL_envz00_15682, (int) (((long) 0)));
				BgL_i1149z00_15684 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_15682, (int) (((long) 1))));
				BgL_symbzd2funzd2_15685 =
					PROCEDURE_REF(BgL_envz00_15682, (int) (((long) 2)));
				BgL_nbargsz00_15686 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15682, (int) (((long) 3))));
				BgL_argsz00_15687 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15682, (int) (((long) 4))));
				BgL_siza7eza7_15688 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15682, (int) (((long) 5))));
				{
					obj_t BgL_sz00_1272;

					BgL_sz00_1272 = BgL_sz00_15689;
					{	/* Eval/evaluate_comp.scm 760 */
						obj_t BgL_bpz00_1274;

						BgL_bpz00_1274 = VECTOR_REF(BgL_sz00_1272, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 760 */
							obj_t BgL_fz00_1275;

							BgL_fz00_1275 =
								PROCEDURE_ENTRY(BgL_fz00_15683) (BgL_fz00_15683, BgL_sz00_1272,
								BEOA);
							if (PROCEDUREP(BgL_fz00_1275))
								{	/* Eval/evaluate_comp.scm 760 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 760 */
									BGl_evtypezd2errorzd2zz__everrorz00(
										(((BgL_ev_appz00_bglt) CREF(BgL_i1149z00_15684))->
											BgL_locz00), BGl_string5561z00zz__evaluate_compz00,
										BGl_string5577z00zz__evaluate_compz00, BgL_fz00_1275);
								}
							{	/* Eval/evaluate_comp.scm 760 */
								obj_t BgL_ufz00_1278;

								BgL_ufz00_1278 = PROCEDURE_ATTR(BgL_fz00_1275);
								{	/* Eval/evaluate_comp.scm 760 */
									bool_t BgL_testz00_18239;

									if (STRUCTP(BgL_ufz00_1278))
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_18239 =
												(STRUCT_KEY(BgL_ufz00_1278) ==
												BGl_symbol5578z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_18239 = ((bool_t) 0);
										}
									if (BgL_testz00_18239)
										{	/* Eval/evaluate_comp.scm 760 */
											obj_t BgL_arityz00_1280;
											obj_t BgL_runz00_1281;
											obj_t BgL_sfz00_1282;

											BgL_arityz00_1280 =
												STRUCT_REF(BgL_ufz00_1278, (int) (((long) 0)));
											BgL_runz00_1281 =
												STRUCT_REF(BgL_ufz00_1278, (int) (((long) 1)));
											BgL_sfz00_1282 =
												STRUCT_REF(BgL_ufz00_1278, (int) (((long) 2)));
											{	/* Eval/evaluate_comp.scm 760 */
												long BgL_spz00_1283;

												BgL_spz00_1283 =
													((long) CINT(BgL_bpz00_1274) + BgL_siza7eza7_15688);
												if (
													((long) CINT(BgL_arityz00_1280) ==
														BgL_nbargsz00_15686))
													{	/* Eval/evaluate_comp.scm 760 */
														{
															obj_t BgL_lz00_6409;
															long BgL_spz00_6410;

															BgL_lz00_6409 = BgL_argsz00_15687;
															BgL_spz00_6410 = BgL_spz00_1283;
														BgL_recz00_6408:
															if (NULLP(BgL_lz00_6409))
																{	/* Eval/evaluate_comp.scm 690 */
																	((bool_t) 0);
																}
															else
																{	/* Eval/evaluate_comp.scm 690 */
																	{	/* Eval/evaluate_comp.scm 691 */
																		obj_t BgL_arg1933z00_6417;

																		{	/* Eval/evaluate_comp.scm 691 */
																			obj_t BgL_fun1934z00_6418;

																			BgL_fun1934z00_6418 = CAR(BgL_lz00_6409);
																			BgL_arg1933z00_6417 =
																				PROCEDURE_ENTRY(BgL_fun1934z00_6418)
																				(BgL_fun1934z00_6418, BgL_sz00_1272,
																				BEOA);
																		}
																		VECTOR_SET(BgL_sz00_1272,
																			(int) (BgL_spz00_6410),
																			BgL_arg1933z00_6417);
																	}
																	{
																		long BgL_spz00_18266;
																		obj_t BgL_lz00_18264;

																		BgL_lz00_18264 = CDR(BgL_lz00_6409);
																		BgL_spz00_18266 =
																			(BgL_spz00_6410 + ((long) 1));
																		BgL_spz00_6410 = BgL_spz00_18266;
																		BgL_lz00_6409 = BgL_lz00_18264;
																		goto BgL_recz00_6408;
																	}
																}
														}
														{	/* Eval/evaluate_comp.scm 764 */
															long BgL_arg1970z00_1285;

															BgL_arg1970z00_1285 =
																(BgL_spz00_1283 + BgL_nbargsz00_15686);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_sz00_1272, BgL_bpz00_1274, BgL_sz00_1272,
																BINT(BgL_spz00_1283),
																BINT(BgL_arg1970z00_1285));
													}}
												else
													{	/* Eval/evaluate_comp.scm 760 */
														bool_t BgL_testz00_18272;

														if (((long) CINT(BgL_arityz00_1280) >= ((long) 0)))
															{	/* Eval/evaluate_comp.scm 760 */
																BgL_testz00_18272 = ((bool_t) 1);
															}
														else
															{	/* Eval/evaluate_comp.scm 760 */
																BgL_testz00_18272 =
																	(
																	(long) CINT(BgL_arityz00_1280) <
																	(((long) -1) - BgL_nbargsz00_15686));
															}
														if (BgL_testz00_18272)
															{	/* Eval/evaluate_comp.scm 760 */
																BGl_evarityzd2errorzd2zz__everrorz00(
																	(((BgL_ev_appz00_bglt)
																			CREF(BgL_i1149z00_15684))->BgL_locz00),
																	STRUCT_REF(BgL_ufz00_1278,
																		(int) (((long) 3))),
																	(int) (BgL_nbargsz00_15686),
																	CINT(BgL_arityz00_1280));
															}
														else
															{	/* Eval/evaluate_comp.scm 760 */
																BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																	(BgL_arityz00_1280, BgL_sz00_1272,
																	BgL_argsz00_15687, BINT(BgL_spz00_1283));
																{	/* Eval/evaluate_comp.scm 766 */
																	long BgL_arg1974z00_1289;

																	BgL_arg1974z00_1289 =
																		(BgL_spz00_1283 +
																		(((long) 0) -
																			(long) CINT(BgL_arityz00_1280)));
																	BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																		(BgL_sz00_1272, BgL_bpz00_1274,
																		BgL_sz00_1272, BINT(BgL_spz00_1283),
																		BINT(BgL_arg1974z00_1289));
													}}}
												{	/* Eval/evaluate_comp.scm 760 */
													obj_t BgL_auxz00_18295;
													obj_t BgL_auxz00_18293;

													BgL_auxz00_18295 =
														(((BgL_ev_appz00_bglt) CREF(BgL_i1149z00_15684))->
														BgL_locz00);
													BgL_auxz00_18293 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_18293,
														BgL_auxz00_18295);
												}
												{	/* Eval/evaluate_comp.scm 760 */
													bool_t BgL_testz00_18298;

													{	/* Eval/evaluate_comp.scm 665 */
														int BgL_arg1908z00_6457;

														BgL_arg1908z00_6457 = VECTOR_LENGTH(BgL_sz00_1272);
														BgL_testz00_18298 =
															(
															((long) CINT(BgL_bpz00_1274) +
																(long) CINT(BgL_sfz00_1282)) <
															(long) (BgL_arg1908z00_6457));
													}
													if (BgL_testz00_18298)
														{	/* Eval/evaluate_comp.scm 760 */
															return BgL_runz00_1281;
														}
													else
														{	/* Eval/evaluate_comp.scm 760 */
															obj_t BgL_nsz00_1296;

															BgL_nsz00_1296 =
																BGl_makezd2statezd2zz__evaluate_compz00();
															{	/* Eval/evaluate_comp.scm 760 */
																long BgL_arg1980z00_1298;

																BgL_arg1980z00_1298 =
																	(
																	(long) CINT(BgL_bpz00_1274) +
																	BgL_nbargsz00_15686);
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_nsz00_1296, BINT(((long) 2)),
																	BgL_sz00_1272, BgL_bpz00_1274,
																	BINT(BgL_arg1980z00_1298));
															}
															VECTOR_SET(BgL_nsz00_1296,
																(int) (((long) 1)), BgL_sz00_1272);
															{	/* Eval/evaluate_comp.scm 760 */
																obj_t BgL_auxz00_18313;

																BgL_auxz00_18313 = BGL_CURRENT_DYNAMIC_ENV();
																BGL_ENV_EVSTATE_SET(BgL_auxz00_18313,
																	BgL_nsz00_1296);
															}
															{	/* Eval/evaluate_comp.scm 760 */
																obj_t BgL_val1153z00_1300;

																BgL_val1153z00_1300 =
																	BGl_zc3exitza31986ze3z83zz__evaluate_compz00
																	(BgL_nsz00_1296, BgL_runz00_1281);
																{	/* Eval/evaluate_comp.scm 760 */
																	obj_t BgL_auxz00_18317;

																	BgL_auxz00_18317 = BGL_CURRENT_DYNAMIC_ENV();
																	BGL_ENV_EVSTATE_SET(BgL_auxz00_18317,
																		BgL_sz00_1272);
																}
																if (CBOOL
																	(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
																		(BgL_val1153z00_1300)))
																	{	/* Eval/evaluate_comp.scm 760 */
																		return
																			BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
																			(BgL_val1153z00_1300),
																			CDR(BgL_val1153z00_1300));
																	}
																else
																	{	/* Eval/evaluate_comp.scm 760 */
																		return BgL_val1153z00_1300;
																	}
															}
														}
												}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 760 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_1275,
													(int) (BgL_nbargsz00_15686)))
												{	/* Eval/evaluate_comp.scm 760 */
													return
														BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
														(BgL_sz00_1272, BgL_fz00_1275, BgL_argsz00_15687,
														BgL_bpz00_1274, BgL_siza7eza7_15688);
												}
											else
												{	/* Eval/evaluate_comp.scm 760 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00(
														(((BgL_ev_appz00_bglt) CREF(BgL_i1149z00_15684))->
															BgL_locz00), BgL_symbzd2funzd2_15685,
														(int) (BgL_nbargsz00_15686),
														PROCEDURE_ARITY(BgL_fz00_1275));
		}}}}}}}}}
	}



/* <exit:1986> */
	obj_t BGl_zc3exitza31986ze3z83zz__evaluate_compz00(obj_t BgL_nsz00_17730,
		obj_t BgL_runz00_17729)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 760 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1154z00_1306;

			if (SET_EXIT(BgL_an_exit1154z00_1306))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1154z00_1306 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 760 */

						PUSH_EXIT(BgL_an_exit1154z00_1306, ((long) 0));
						{	/* Eval/evaluate_comp.scm 760 */
							obj_t BgL_val1155z00_1307;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_6476;

								BgL_savedzd2bpzd2_6476 =
									VECTOR_REF(BgL_nsz00_17730, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17730,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_6483;

									BgL_fz00_6483 = BgL_runz00_17729;
								BgL_recz00_6482:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_6484;

										BgL_rz00_6484 =
											PROCEDURE_ENTRY(BgL_fz00_6483) (BgL_fz00_6483,
											BgL_nsz00_17730, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_18346;

											if (PROCEDUREP(BgL_rz00_6484))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_6489;

													BgL_arg1900z00_6489 = PROCEDURE_ATTR(BgL_rz00_6484);
													if (STRUCTP(BgL_arg1900z00_6489))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_18346 =
																(STRUCT_KEY(BgL_arg1900z00_6489) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_18346 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_18346 = ((bool_t) 0);
												}
											if (BgL_testz00_18346)
												{
													obj_t BgL_fz00_18354;

													BgL_fz00_18354 = BgL_rz00_6484;
													BgL_fz00_6483 = BgL_fz00_18354;
													goto BgL_recz00_6482;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17730,
														(int) (((long) 0)), BgL_savedzd2bpzd2_6476);
													BgL_val1155z00_1307 = BgL_rz00_6484;
							}}}}}
							POP_EXIT();
							return BgL_val1155z00_1307;
						}
					}
				}
		}
	}



/* &<anonymous:1992> */
	obj_t BGl_z62zc3anonymousza31992ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15690, obj_t BgL_sz00_15696)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 768 */
			{	/* Eval/evaluate_comp.scm 768 */
				obj_t BgL_fz00_15691;
				BgL_ev_appz00_bglt BgL_i1149z00_15692;
				obj_t BgL_symbzd2funzd2_15693;
				long BgL_nbargsz00_15694;
				obj_t BgL_argsz00_15695;

				BgL_fz00_15691 = PROCEDURE_REF(BgL_envz00_15690, (int) (((long) 0)));
				BgL_i1149z00_15692 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_15690, (int) (((long) 1))));
				BgL_symbzd2funzd2_15693 =
					PROCEDURE_REF(BgL_envz00_15690, (int) (((long) 2)));
				BgL_nbargsz00_15694 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15690, (int) (((long) 3))));
				BgL_argsz00_15695 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15690, (int) (((long) 4))));
				{
					obj_t BgL_sz00_1313;

					BgL_sz00_1313 = BgL_sz00_15696;
					{	/* Eval/evaluate_comp.scm 768 */
						obj_t BgL_bpz00_1315;

						BgL_bpz00_1315 = VECTOR_REF(BgL_sz00_1313, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 768 */
							obj_t BgL_fz00_1316;

							BgL_fz00_1316 =
								PROCEDURE_ENTRY(BgL_fz00_15691) (BgL_fz00_15691, BgL_sz00_1313,
								BEOA);
							if (PROCEDUREP(BgL_fz00_1316))
								{	/* Eval/evaluate_comp.scm 768 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 768 */
									BGl_evtypezd2errorzd2zz__everrorz00(
										(((BgL_ev_appz00_bglt) CREF(BgL_i1149z00_15692))->
											BgL_locz00), BGl_string5561z00zz__evaluate_compz00,
										BGl_string5577z00zz__evaluate_compz00, BgL_fz00_1316);
								}
							{	/* Eval/evaluate_comp.scm 768 */
								obj_t BgL_ufz00_1319;

								BgL_ufz00_1319 = PROCEDURE_ATTR(BgL_fz00_1316);
								{	/* Eval/evaluate_comp.scm 768 */
									bool_t BgL_testz00_18382;

									if (STRUCTP(BgL_ufz00_1319))
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_18382 =
												(STRUCT_KEY(BgL_ufz00_1319) ==
												BGl_symbol5578z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_18382 = ((bool_t) 0);
										}
									if (BgL_testz00_18382)
										{	/* Eval/evaluate_comp.scm 768 */
											obj_t BgL_arityz00_1321;
											obj_t BgL_runz00_1322;
											obj_t BgL_sfz00_1323;

											BgL_arityz00_1321 =
												STRUCT_REF(BgL_ufz00_1319, (int) (((long) 0)));
											BgL_runz00_1322 =
												STRUCT_REF(BgL_ufz00_1319, (int) (((long) 1)));
											BgL_sfz00_1323 =
												STRUCT_REF(BgL_ufz00_1319, (int) (((long) 2)));
											if (
												((long) CINT(BgL_arityz00_1321) == BgL_nbargsz00_15694))
												{
													obj_t BgL_lz00_6535;
													obj_t BgL_spz00_6536;

													{	/* Eval/evaluate_comp.scm 689 */
														bool_t BgL_auxz00_18396;

														BgL_lz00_6535 = BgL_argsz00_15695;
														BgL_spz00_6536 = BgL_bpz00_1315;
													BgL_recz00_6534:
														if (NULLP(BgL_lz00_6535))
															{	/* Eval/evaluate_comp.scm 690 */
																BgL_auxz00_18396 = ((bool_t) 0);
															}
														else
															{	/* Eval/evaluate_comp.scm 690 */
																{	/* Eval/evaluate_comp.scm 691 */
																	obj_t BgL_arg1933z00_6543;

																	{	/* Eval/evaluate_comp.scm 691 */
																		obj_t BgL_fun1934z00_6544;

																		BgL_fun1934z00_6544 = CAR(BgL_lz00_6535);
																		BgL_arg1933z00_6543 =
																			PROCEDURE_ENTRY(BgL_fun1934z00_6544)
																			(BgL_fun1934z00_6544, BgL_sz00_1313,
																			BEOA);
																	}
																	VECTOR_SET(BgL_sz00_1313,
																		CINT(BgL_spz00_6536), BgL_arg1933z00_6543);
																}
																{	/* Eval/evaluate_comp.scm 692 */
																	obj_t BgL_arg1935z00_6545;
																	long BgL_arg1936z00_6546;

																	BgL_arg1935z00_6545 = CDR(BgL_lz00_6535);
																	BgL_arg1936z00_6546 =
																		((long) CINT(BgL_spz00_6536) + ((long) 1));
																	{
																		obj_t BgL_spz00_18410;
																		obj_t BgL_lz00_18409;

																		BgL_lz00_18409 = BgL_arg1935z00_6545;
																		BgL_spz00_18410 = BINT(BgL_arg1936z00_6546);
																		BgL_spz00_6536 = BgL_spz00_18410;
																		BgL_lz00_6535 = BgL_lz00_18409;
																		goto BgL_recz00_6534;
																	}
																}
															}
														BBOOL(BgL_auxz00_18396);
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 768 */
													bool_t BgL_testz00_18413;

													if (((long) CINT(BgL_arityz00_1321) >= ((long) 0)))
														{	/* Eval/evaluate_comp.scm 768 */
															BgL_testz00_18413 = ((bool_t) 1);
														}
													else
														{	/* Eval/evaluate_comp.scm 768 */
															BgL_testz00_18413 =
																(
																(long) CINT(BgL_arityz00_1321) <
																(((long) -1) - BgL_nbargsz00_15694));
														}
													if (BgL_testz00_18413)
														{	/* Eval/evaluate_comp.scm 768 */
															BGl_evarityzd2errorzd2zz__everrorz00(
																(((BgL_ev_appz00_bglt)
																		CREF(BgL_i1149z00_15692))->BgL_locz00),
																STRUCT_REF(BgL_ufz00_1319, (int) (((long) 3))),
																(int) (BgL_nbargsz00_15694),
																CINT(BgL_arityz00_1321));
														}
													else
														{	/* Eval/evaluate_comp.scm 768 */
															BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																(BgL_arityz00_1321, BgL_sz00_1313,
																BgL_argsz00_15695, BgL_bpz00_1315);
														}
												}
											{	/* Eval/evaluate_comp.scm 768 */
												obj_t BgL_auxz00_18429;
												obj_t BgL_auxz00_18427;

												BgL_auxz00_18429 =
													(((BgL_ev_appz00_bglt) CREF(BgL_i1149z00_15692))->
													BgL_locz00);
												BgL_auxz00_18427 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_18427,
													BgL_auxz00_18429);
											}
											{	/* Eval/evaluate_comp.scm 768 */
												bool_t BgL_testz00_18432;

												{	/* Eval/evaluate_comp.scm 665 */
													int BgL_arg1908z00_6574;

													BgL_arg1908z00_6574 = VECTOR_LENGTH(BgL_sz00_1313);
													BgL_testz00_18432 =
														(
														((long) CINT(BgL_bpz00_1315) +
															(long) CINT(BgL_sfz00_1323)) <
														(long) (BgL_arg1908z00_6574));
												}
												if (BgL_testz00_18432)
													{	/* Eval/evaluate_comp.scm 768 */
														return BgL_runz00_1322;
													}
												else
													{	/* Eval/evaluate_comp.scm 768 */
														obj_t BgL_nsz00_1334;

														BgL_nsz00_1334 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 768 */
															long BgL_arg2007z00_1336;

															BgL_arg2007z00_1336 =
																(
																(long) CINT(BgL_bpz00_1315) +
																BgL_nbargsz00_15694);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_1334, BINT(((long) 2)),
																BgL_sz00_1313, BgL_bpz00_1315,
																BINT(BgL_arg2007z00_1336));
														}
														VECTOR_SET(BgL_nsz00_1334,
															(int) (((long) 1)), BgL_sz00_1313);
														{	/* Eval/evaluate_comp.scm 768 */
															obj_t BgL_auxz00_18447;

															BgL_auxz00_18447 = BGL_CURRENT_DYNAMIC_ENV();
															BGL_ENV_EVSTATE_SET(BgL_auxz00_18447,
																BgL_nsz00_1334);
														}
														{	/* Eval/evaluate_comp.scm 768 */
															obj_t BgL_val1156z00_1338;

															BgL_val1156z00_1338 =
																BGl_zc3exitza32013ze3z83zz__evaluate_compz00
																(BgL_nsz00_1334, BgL_runz00_1322);
															{	/* Eval/evaluate_comp.scm 768 */
																obj_t BgL_auxz00_18451;

																BgL_auxz00_18451 = BGL_CURRENT_DYNAMIC_ENV();
																BGL_ENV_EVSTATE_SET(BgL_auxz00_18451,
																	BgL_sz00_1313);
															}
															if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
																	(BgL_val1156z00_1338)))
																{	/* Eval/evaluate_comp.scm 768 */
																	return
																		BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
																		(BgL_val1156z00_1338),
																		CDR(BgL_val1156z00_1338));
																}
															else
																{	/* Eval/evaluate_comp.scm 768 */
																	return BgL_val1156z00_1338;
																}
														}
													}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 768 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_1316,
													(int) (BgL_nbargsz00_15694)))
												{	/* Eval/evaluate_comp.scm 768 */
													return
														BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
														(BgL_sz00_1313, BgL_fz00_1316, BgL_argsz00_15695,
														BgL_bpz00_1315, BgL_nbargsz00_15694);
												}
											else
												{	/* Eval/evaluate_comp.scm 768 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00(
														(((BgL_ev_appz00_bglt) CREF(BgL_i1149z00_15692))->
															BgL_locz00), BgL_symbzd2funzd2_15693,
														(int) (BgL_nbargsz00_15694),
														PROCEDURE_ARITY(BgL_fz00_1316));
		}}}}}}}}}
	}



/* <exit:2013> */
	obj_t BGl_zc3exitza32013ze3z83zz__evaluate_compz00(obj_t BgL_nsz00_17728,
		obj_t BgL_runz00_17727)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 768 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1157z00_1344;

			if (SET_EXIT(BgL_an_exit1157z00_1344))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1157z00_1344 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 768 */

						PUSH_EXIT(BgL_an_exit1157z00_1344, ((long) 0));
						{	/* Eval/evaluate_comp.scm 768 */
							obj_t BgL_val1158z00_1345;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_6593;

								BgL_savedzd2bpzd2_6593 =
									VECTOR_REF(BgL_nsz00_17728, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17728,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_6600;

									BgL_fz00_6600 = BgL_runz00_17727;
								BgL_recz00_6599:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_6601;

										BgL_rz00_6601 =
											PROCEDURE_ENTRY(BgL_fz00_6600) (BgL_fz00_6600,
											BgL_nsz00_17728, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_18480;

											if (PROCEDUREP(BgL_rz00_6601))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_6606;

													BgL_arg1900z00_6606 = PROCEDURE_ATTR(BgL_rz00_6601);
													if (STRUCTP(BgL_arg1900z00_6606))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_18480 =
																(STRUCT_KEY(BgL_arg1900z00_6606) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_18480 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_18480 = ((bool_t) 0);
												}
											if (BgL_testz00_18480)
												{
													obj_t BgL_fz00_18488;

													BgL_fz00_18488 = BgL_rz00_6601;
													BgL_fz00_6600 = BgL_fz00_18488;
													goto BgL_recz00_6599;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17728,
														(int) (((long) 0)), BgL_savedzd2bpzd2_6593);
													BgL_val1158z00_1345 = BgL_rz00_6601;
							}}}}}
							POP_EXIT();
							return BgL_val1158z00_1345;
						}
					}
				}
		}
	}



/* &<anonymous:2019> */
	obj_t BGl_z62zc3anonymousza32019ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15697, obj_t BgL_sz00_15704)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 754 */
			{	/* Eval/evaluate_comp.scm 754 */
				obj_t BgL_fz00_15698;
				BgL_ev_appz00_bglt BgL_i1149z00_15699;
				obj_t BgL_symbzd2funzd2_15700;
				long BgL_nbargsz00_15701;
				obj_t BgL_argsz00_15702;
				long BgL_siza7eza7_15703;

				BgL_fz00_15698 = PROCEDURE_REF(BgL_envz00_15697, (int) (((long) 0)));
				BgL_i1149z00_15699 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_15697, (int) (((long) 1))));
				BgL_symbzd2funzd2_15700 =
					PROCEDURE_REF(BgL_envz00_15697, (int) (((long) 2)));
				BgL_nbargsz00_15701 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15697, (int) (((long) 3))));
				BgL_argsz00_15702 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15697, (int) (((long) 4))));
				BgL_siza7eza7_15703 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15697, (int) (((long) 5))));
				{
					obj_t BgL_sz00_1352;

					BgL_sz00_1352 = BgL_sz00_15704;
					{	/* Eval/evaluate_comp.scm 754 */
						obj_t BgL_bpz00_1354;

						BgL_bpz00_1354 = VECTOR_REF(BgL_sz00_1352, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 754 */
							obj_t BgL_fz00_1355;

							BgL_fz00_1355 =
								PROCEDURE_ENTRY(BgL_fz00_15698) (BgL_fz00_15698, BgL_sz00_1352,
								BEOA);
							if (PROCEDUREP(BgL_fz00_1355))
								{	/* Eval/evaluate_comp.scm 754 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 754 */
									BGl_evtypezd2errorzd2zz__everrorz00(
										(((BgL_ev_appz00_bglt) CREF(BgL_i1149z00_15699))->
											BgL_locz00), BGl_string5561z00zz__evaluate_compz00,
										BGl_string5577z00zz__evaluate_compz00, BgL_fz00_1355);
								}
							{	/* Eval/evaluate_comp.scm 754 */
								obj_t BgL_ufz00_1358;

								BgL_ufz00_1358 = PROCEDURE_ATTR(BgL_fz00_1355);
								{	/* Eval/evaluate_comp.scm 754 */
									bool_t BgL_testz00_18519;

									if (STRUCTP(BgL_ufz00_1358))
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_18519 =
												(STRUCT_KEY(BgL_ufz00_1358) ==
												BGl_symbol5578z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_18519 = ((bool_t) 0);
										}
									if (BgL_testz00_18519)
										{	/* Eval/evaluate_comp.scm 754 */
											obj_t BgL_arityz00_1360;
											obj_t BgL_runz00_1361;
											obj_t BgL_sfz00_1362;

											BgL_arityz00_1360 =
												STRUCT_REF(BgL_ufz00_1358, (int) (((long) 0)));
											BgL_runz00_1361 =
												STRUCT_REF(BgL_ufz00_1358, (int) (((long) 1)));
											BgL_sfz00_1362 =
												STRUCT_REF(BgL_ufz00_1358, (int) (((long) 2)));
											{	/* Eval/evaluate_comp.scm 754 */
												long BgL_spz00_1363;

												BgL_spz00_1363 =
													((long) CINT(BgL_bpz00_1354) + BgL_siza7eza7_15703);
												if (
													((long) CINT(BgL_arityz00_1360) ==
														BgL_nbargsz00_15701))
													{
														obj_t BgL_lz00_6652;
														long BgL_spz00_6653;

														{	/* Eval/evaluate_comp.scm 689 */
															bool_t BgL_auxz00_18535;

															BgL_lz00_6652 = BgL_argsz00_15702;
															BgL_spz00_6653 = BgL_spz00_1363;
														BgL_recz00_6651:
															if (NULLP(BgL_lz00_6652))
																{	/* Eval/evaluate_comp.scm 690 */
																	BgL_auxz00_18535 = ((bool_t) 0);
																}
															else
																{	/* Eval/evaluate_comp.scm 690 */
																	{	/* Eval/evaluate_comp.scm 691 */
																		obj_t BgL_arg1933z00_6660;

																		{	/* Eval/evaluate_comp.scm 691 */
																			obj_t BgL_fun1934z00_6661;

																			BgL_fun1934z00_6661 = CAR(BgL_lz00_6652);
																			BgL_arg1933z00_6660 =
																				PROCEDURE_ENTRY(BgL_fun1934z00_6661)
																				(BgL_fun1934z00_6661, BgL_sz00_1352,
																				BEOA);
																		}
																		VECTOR_SET(BgL_sz00_1352,
																			(int) (BgL_spz00_6653),
																			BgL_arg1933z00_6660);
																	}
																	{
																		long BgL_spz00_18547;
																		obj_t BgL_lz00_18545;

																		BgL_lz00_18545 = CDR(BgL_lz00_6652);
																		BgL_spz00_18547 =
																			(BgL_spz00_6653 + ((long) 1));
																		BgL_spz00_6653 = BgL_spz00_18547;
																		BgL_lz00_6652 = BgL_lz00_18545;
																		goto BgL_recz00_6651;
																	}
																}
															BBOOL(BgL_auxz00_18535);
														}
													}
												else
													{	/* Eval/evaluate_comp.scm 754 */
														bool_t BgL_testz00_18550;

														if (((long) CINT(BgL_arityz00_1360) >= ((long) 0)))
															{	/* Eval/evaluate_comp.scm 754 */
																BgL_testz00_18550 = ((bool_t) 1);
															}
														else
															{	/* Eval/evaluate_comp.scm 754 */
																BgL_testz00_18550 =
																	(
																	(long) CINT(BgL_arityz00_1360) <
																	(((long) -1) - BgL_nbargsz00_15701));
															}
														if (BgL_testz00_18550)
															{	/* Eval/evaluate_comp.scm 754 */
																BGl_evarityzd2errorzd2zz__everrorz00(
																	(((BgL_ev_appz00_bglt)
																			CREF(BgL_i1149z00_15699))->BgL_locz00),
																	STRUCT_REF(BgL_ufz00_1358,
																		(int) (((long) 3))),
																	(int) (BgL_nbargsz00_15701),
																	CINT(BgL_arityz00_1360));
															}
														else
															{	/* Eval/evaluate_comp.scm 754 */
																BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																	(BgL_arityz00_1360, BgL_sz00_1352,
																	BgL_argsz00_15702, BINT(BgL_spz00_1363));
															}
													}
												{	/* Eval/evaluate_comp.scm 754 */
													obj_t BgL_auxz00_18567;
													obj_t BgL_auxz00_18565;

													BgL_auxz00_18567 =
														(((BgL_ev_appz00_bglt) CREF(BgL_i1149z00_15699))->
														BgL_locz00);
													BgL_auxz00_18565 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_18565,
														BgL_auxz00_18567);
												}
												{	/* Eval/evaluate_comp.scm 754 */
													bool_t BgL_testz00_18570;

													{	/* Eval/evaluate_comp.scm 665 */
														int BgL_arg1908z00_6691;

														BgL_arg1908z00_6691 = VECTOR_LENGTH(BgL_sz00_1352);
														BgL_testz00_18570 =
															(
															(BgL_spz00_1363 +
																(long) CINT(BgL_sfz00_1362)) <
															(long) (BgL_arg1908z00_6691));
													}
													if (BgL_testz00_18570)
														{	/* Eval/evaluate_comp.scm 754 */
															return
																BGl_catchzd2trampolinezd2zz__evaluate_compz00
																(BgL_runz00_1361, BgL_sz00_1352,
																BINT(BgL_spz00_1363));
														}
													else
														{	/* Eval/evaluate_comp.scm 754 */
															obj_t BgL_nsz00_1373;

															BgL_nsz00_1373 =
																BGl_makezd2statezd2zz__evaluate_compz00();
															{	/* Eval/evaluate_comp.scm 754 */
																long BgL_arg2031z00_1375;

																BgL_arg2031z00_1375 =
																	(BgL_spz00_1363 + BgL_nbargsz00_15701);
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_nsz00_1373, BINT(((long) 2)),
																	BgL_sz00_1352, BINT(BgL_spz00_1363),
																	BINT(BgL_arg2031z00_1375));
															}
															VECTOR_SET(BgL_nsz00_1373,
																(int) (((long) 1)), BgL_sz00_1352);
															{	/* Eval/evaluate_comp.scm 754 */
																obj_t BgL_auxz00_18586;

																BgL_auxz00_18586 = BGL_CURRENT_DYNAMIC_ENV();
																BGL_ENV_EVSTATE_SET(BgL_auxz00_18586,
																	BgL_nsz00_1373);
															}
															{	/* Eval/evaluate_comp.scm 754 */
																obj_t BgL_val1150z00_1377;

																BgL_val1150z00_1377 =
																	BGl_zc3exitza32037ze3z83zz__evaluate_compz00
																	(BgL_nsz00_1373, BgL_runz00_1361);
																{	/* Eval/evaluate_comp.scm 754 */
																	obj_t BgL_auxz00_18590;

																	BgL_auxz00_18590 = BGL_CURRENT_DYNAMIC_ENV();
																	BGL_ENV_EVSTATE_SET(BgL_auxz00_18590,
																		BgL_sz00_1352);
																}
																if (CBOOL
																	(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
																		(BgL_val1150z00_1377)))
																	{	/* Eval/evaluate_comp.scm 754 */
																		return
																			BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
																			(BgL_val1150z00_1377),
																			CDR(BgL_val1150z00_1377));
																	}
																else
																	{	/* Eval/evaluate_comp.scm 754 */
																		return BgL_val1150z00_1377;
																	}
															}
														}
												}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 754 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_1355,
													(int) (BgL_nbargsz00_15701)))
												{	/* Eval/evaluate_comp.scm 754 */
													return
														BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
														(BgL_sz00_1352, BgL_fz00_1355, BgL_argsz00_15702,
														BgL_bpz00_1354, BgL_siza7eza7_15703);
												}
											else
												{	/* Eval/evaluate_comp.scm 754 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00(
														(((BgL_ev_appz00_bglt) CREF(BgL_i1149z00_15699))->
															BgL_locz00), BgL_symbzd2funzd2_15700,
														(int) (BgL_nbargsz00_15701),
														PROCEDURE_ARITY(BgL_fz00_1355));
		}}}}}}}}}
	}



/* <exit:2037> */
	obj_t BGl_zc3exitza32037ze3z83zz__evaluate_compz00(obj_t BgL_nsz00_17726,
		obj_t BgL_runz00_17725)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 754 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1151z00_1383;

			if (SET_EXIT(BgL_an_exit1151z00_1383))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1151z00_1383 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 754 */

						PUSH_EXIT(BgL_an_exit1151z00_1383, ((long) 0));
						{	/* Eval/evaluate_comp.scm 754 */
							obj_t BgL_val1152z00_1384;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_6709;

								BgL_savedzd2bpzd2_6709 =
									VECTOR_REF(BgL_nsz00_17726, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17726,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_6716;

									BgL_fz00_6716 = BgL_runz00_17725;
								BgL_recz00_6715:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_6717;

										BgL_rz00_6717 =
											PROCEDURE_ENTRY(BgL_fz00_6716) (BgL_fz00_6716,
											BgL_nsz00_17726, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_18619;

											if (PROCEDUREP(BgL_rz00_6717))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_6722;

													BgL_arg1900z00_6722 = PROCEDURE_ATTR(BgL_rz00_6717);
													if (STRUCTP(BgL_arg1900z00_6722))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_18619 =
																(STRUCT_KEY(BgL_arg1900z00_6722) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_18619 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_18619 = ((bool_t) 0);
												}
											if (BgL_testz00_18619)
												{
													obj_t BgL_fz00_18627;

													BgL_fz00_18627 = BgL_rz00_6717;
													BgL_fz00_6716 = BgL_fz00_18627;
													goto BgL_recz00_6715;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17726,
														(int) (((long) 0)), BgL_savedzd2bpzd2_6709);
													BgL_val1152z00_1384 = BgL_rz00_6717;
							}}}}}
							POP_EXIT();
							return BgL_val1152z00_1384;
						}
					}
				}
		}
	}



/* comp-call0 */
	obj_t BGl_compzd2call0zd2zz__evaluate_compz00(obj_t BgL_locz00_138,
		BgL_ev_exprz00_bglt BgL_vfunz00_139, obj_t BgL_symbzd2funzd2_140,
		obj_t BgL_funz00_141, obj_t BgL_tailzf3zf3_142, obj_t BgL_stkz00_143,
		long BgL_siza7eza7_144)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			{	/* Eval/evaluate_comp.scm 856 */
				obj_t BgL_cfunz00_1392;

				BgL_cfunz00_1392 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_139,
					((long) 0), BgL_locz00_138, BgL_symbzd2funzd2_140);
				if (CBOOL(BgL_cfunz00_1392))
					{	/* Eval/evaluate_comp.scm 856 */
						obj_t BgL_zc3anonymousza32047ze3z83_15705;

						BgL_zc3anonymousza32047ze3z83_15705 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza32047ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 2)));
						PROCEDURE_SET(BgL_zc3anonymousza32047ze3z83_15705,
							(int) (((long) 0)), BINT(BgL_siza7eza7_144));
						PROCEDURE_SET(BgL_zc3anonymousza32047ze3z83_15705,
							(int) (((long) 1)), BgL_cfunz00_1392);
						return BgL_zc3anonymousza32047ze3z83_15705;
					}
				else
					{	/* Eval/evaluate_comp.scm 856 */
						if (CBOOL(BgL_tailzf3zf3_142))
							{	/* Eval/evaluate_comp.scm 856 */
								obj_t BgL_zc3anonymousza32048ze3z83_15706;

								BgL_zc3anonymousza32048ze3z83_15706 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32048ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_zc3anonymousza32048ze3z83_15706,
									(int) (((long) 0)), BgL_funz00_141);
								PROCEDURE_SET(BgL_zc3anonymousza32048ze3z83_15706,
									(int) (((long) 1)), BgL_locz00_138);
								PROCEDURE_SET(BgL_zc3anonymousza32048ze3z83_15706,
									(int) (((long) 2)), BgL_symbzd2funzd2_140);
								PROCEDURE_SET(BgL_zc3anonymousza32048ze3z83_15706,
									(int) (((long) 3)), BINT(BgL_siza7eza7_144));
								return BgL_zc3anonymousza32048ze3z83_15706;
							}
						else
							{	/* Eval/evaluate_comp.scm 856 */
								obj_t BgL_zc3anonymousza32069ze3z83_15707;

								BgL_zc3anonymousza32069ze3z83_15707 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32069ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_zc3anonymousza32069ze3z83_15707,
									(int) (((long) 0)), BgL_funz00_141);
								PROCEDURE_SET(BgL_zc3anonymousza32069ze3z83_15707,
									(int) (((long) 1)), BgL_locz00_138);
								PROCEDURE_SET(BgL_zc3anonymousza32069ze3z83_15707,
									(int) (((long) 2)), BgL_symbzd2funzd2_140);
								PROCEDURE_SET(BgL_zc3anonymousza32069ze3z83_15707,
									(int) (((long) 3)), BINT(BgL_siza7eza7_144));
								return BgL_zc3anonymousza32069ze3z83_15707;
							}
					}
			}
		}
	}



/* &<anonymous:2047> */
	obj_t BGl_z62zc3anonymousza32047ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15708, obj_t BgL_sz00_15711)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			{	/* Eval/evaluate_comp.scm 856 */
				long BgL_siza7eza7_15709;
				obj_t BgL_cfunz00_15710;

				BgL_siza7eza7_15709 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15708, (int) (((long) 0))));
				BgL_cfunz00_15710 = PROCEDURE_REF(BgL_envz00_15708, (int) (((long) 1)));
				{
					obj_t BgL_sz00_1393;

					BgL_sz00_1393 = BgL_sz00_15711;
					{	/* Eval/evaluate_comp.scm 856 */
						obj_t BgL_bpz00_1395;

						BgL_bpz00_1395 = VECTOR_REF(BgL_sz00_1393, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 856 */

							{	/* Eval/evaluate_comp.scm 856 */
								long BgL_nbpz00_1396;

								BgL_nbpz00_1396 =
									((long) CINT(BgL_bpz00_1395) + BgL_siza7eza7_15709);
								VECTOR_SET(BgL_sz00_1393,
									(int) (((long) 0)), BINT(BgL_nbpz00_1396));
								{	/* Eval/evaluate_comp.scm 856 */
									obj_t BgL_rz00_1397;

									BgL_rz00_1397 =
										PROCEDURE_ENTRY(BgL_cfunz00_15710) (BgL_cfunz00_15710,
										BEOA);
									VECTOR_SET(BgL_sz00_1393, (int) (((long) 0)), BgL_bpz00_1395);
									return BgL_rz00_1397;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:2048> */
	obj_t BGl_z62zc3anonymousza32048ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15712, obj_t BgL_sz00_15717)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			{	/* Eval/evaluate_comp.scm 856 */
				obj_t BgL_funz00_15713;
				obj_t BgL_locz00_15714;
				obj_t BgL_symbzd2funzd2_15715;
				long BgL_siza7eza7_15716;

				BgL_funz00_15713 = PROCEDURE_REF(BgL_envz00_15712, (int) (((long) 0)));
				BgL_locz00_15714 = PROCEDURE_REF(BgL_envz00_15712, (int) (((long) 1)));
				BgL_symbzd2funzd2_15715 =
					PROCEDURE_REF(BgL_envz00_15712, (int) (((long) 2)));
				BgL_siza7eza7_15716 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15712, (int) (((long) 3))));
				{
					obj_t BgL_sz00_1398;

					BgL_sz00_1398 = BgL_sz00_15717;
					{	/* Eval/evaluate_comp.scm 856 */
						obj_t BgL_bpz00_1400;

						BgL_bpz00_1400 = VECTOR_REF(BgL_sz00_1398, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 856 */
							obj_t BgL_fz00_1401;

							BgL_fz00_1401 =
								PROCEDURE_ENTRY(BgL_funz00_15713) (BgL_funz00_15713,
								BgL_sz00_1398, BEOA);
							if (PROCEDUREP(BgL_fz00_1401))
								{	/* Eval/evaluate_comp.scm 856 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 856 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_15714,
										BGl_string5561z00zz__evaluate_compz00,
										BGl_string5577z00zz__evaluate_compz00, BgL_fz00_1401);
								}
							{	/* Eval/evaluate_comp.scm 856 */
								obj_t BgL_ufz00_1403;

								BgL_ufz00_1403 = PROCEDURE_ATTR(BgL_fz00_1401);
								{	/* Eval/evaluate_comp.scm 856 */
									bool_t BgL_testz00_18704;

									if (STRUCTP(BgL_ufz00_1403))
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_18704 =
												(STRUCT_KEY(BgL_ufz00_1403) ==
												BGl_symbol5578z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_18704 = ((bool_t) 0);
										}
									if (BgL_testz00_18704)
										{	/* Eval/evaluate_comp.scm 856 */
											obj_t BgL_arityz00_1405;
											obj_t BgL_runz00_1406;
											obj_t BgL_sfz00_1407;

											BgL_arityz00_1405 =
												STRUCT_REF(BgL_ufz00_1403, (int) (((long) 0)));
											BgL_runz00_1406 =
												STRUCT_REF(BgL_ufz00_1403, (int) (((long) 1)));
											BgL_sfz00_1407 =
												STRUCT_REF(BgL_ufz00_1403, (int) (((long) 2)));
											if (((long) CINT(BgL_arityz00_1405) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 856 */
													BUNSPEC;
												}
											else
												{	/* Eval/evaluate_comp.scm 856 */
													if (INTEGERP(BgL_arityz00_1405))
														{	/* Eval/evaluate_comp.scm 856 */
															switch ((long) CINT(BgL_arityz00_1405))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2053z00_1413;

																		BgL_arg2053z00_1413 =
																			(
																			(long) CINT(BgL_bpz00_1400) + ((long) 0));
																		VECTOR_SET(BgL_sz00_1398,
																			(int) (BgL_arg2053z00_1413), BNIL);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_15714,
																		STRUCT_REF(BgL_ufz00_1403,
																			(int) (((long) 3))), (int) (((long) 0)),
																		CINT(BgL_arityz00_1405));
														}}
													else
														{	/* Eval/evaluate_comp.scm 856 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_15714, STRUCT_REF(BgL_ufz00_1403,
																	(int) (((long) 3))), (int) (((long) 0)),
																CINT(BgL_arityz00_1405));
												}}
											{	/* Eval/evaluate_comp.scm 856 */
												obj_t BgL_auxz00_18736;

												BgL_auxz00_18736 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_18736,
													BgL_locz00_15714);
											}
											{	/* Eval/evaluate_comp.scm 856 */
												bool_t BgL_testz00_18739;

												{	/* Eval/evaluate_comp.scm 665 */
													int BgL_arg1908z00_6800;

													BgL_arg1908z00_6800 = VECTOR_LENGTH(BgL_sz00_1398);
													BgL_testz00_18739 =
														(
														((long) CINT(BgL_bpz00_1400) +
															(long) CINT(BgL_sfz00_1407)) <
														(long) (BgL_arg1908z00_6800));
												}
												if (BgL_testz00_18739)
													{	/* Eval/evaluate_comp.scm 856 */
														return BgL_runz00_1406;
													}
												else
													{	/* Eval/evaluate_comp.scm 856 */
														obj_t BgL_nsz00_1419;

														BgL_nsz00_1419 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 856 */
															long BgL_arg2059z00_1421;

															BgL_arg2059z00_1421 =
																((long) CINT(BgL_bpz00_1400) + ((long) 0));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_1419, BINT(((long) 2)),
																BgL_sz00_1398, BgL_bpz00_1400,
																BINT(BgL_arg2059z00_1421));
														}
														VECTOR_SET(BgL_nsz00_1419,
															(int) (((long) 1)), BgL_sz00_1398);
														{	/* Eval/evaluate_comp.scm 856 */
															obj_t BgL_auxz00_18754;

															BgL_auxz00_18754 = BGL_CURRENT_DYNAMIC_ENV();
															BGL_ENV_EVSTATE_SET(BgL_auxz00_18754,
																BgL_nsz00_1419);
														}
														{	/* Eval/evaluate_comp.scm 856 */
															obj_t BgL_val1170z00_1423;

															BgL_val1170z00_1423 =
																BGl_zc3exitza32066ze3z83zz__evaluate_compz00
																(BgL_nsz00_1419, BgL_runz00_1406);
															{	/* Eval/evaluate_comp.scm 856 */
																obj_t BgL_auxz00_18758;

																BgL_auxz00_18758 = BGL_CURRENT_DYNAMIC_ENV();
																BGL_ENV_EVSTATE_SET(BgL_auxz00_18758,
																	BgL_sz00_1398);
															}
															if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
																	(BgL_val1170z00_1423)))
																{	/* Eval/evaluate_comp.scm 856 */
																	return
																		BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
																		(BgL_val1170z00_1423),
																		CDR(BgL_val1170z00_1423));
																}
															else
																{	/* Eval/evaluate_comp.scm 856 */
																	return BgL_val1170z00_1423;
																}
														}
													}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 856 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_1401,
													(int) (((long) 0))))
												{	/* Eval/evaluate_comp.scm 856 */
													long BgL_nbpz00_1432;

													BgL_nbpz00_1432 =
														((long) CINT(BgL_bpz00_1400) + BgL_siza7eza7_15716);
													VECTOR_SET(BgL_sz00_1398,
														(int) (((long) 0)), BINT(BgL_nbpz00_1432));
													{	/* Eval/evaluate_comp.scm 856 */
														obj_t BgL_rz00_1433;

														BgL_rz00_1433 =
															PROCEDURE_ENTRY(BgL_fz00_1401) (BgL_fz00_1401,
															BEOA);
														VECTOR_SET(BgL_sz00_1398, (int) (((long) 0)),
															BgL_bpz00_1400);
														return BgL_rz00_1433;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 856 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_15714, BgL_symbzd2funzd2_15715,
														(int) (((long) 0)), PROCEDURE_ARITY(BgL_fz00_1401));
		}}}}}}}}}
	}



/* <exit:2066> */
	obj_t BGl_zc3exitza32066ze3z83zz__evaluate_compz00(obj_t BgL_nsz00_17724,
		obj_t BgL_runz00_17723)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1171z00_1429;

			if (SET_EXIT(BgL_an_exit1171z00_1429))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1171z00_1429 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 856 */

						PUSH_EXIT(BgL_an_exit1171z00_1429, ((long) 0));
						{	/* Eval/evaluate_comp.scm 856 */
							obj_t BgL_val1172z00_1430;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_6819;

								BgL_savedzd2bpzd2_6819 =
									VECTOR_REF(BgL_nsz00_17724, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17724,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_6826;

									BgL_fz00_6826 = BgL_runz00_17723;
								BgL_recz00_6825:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_6827;

										BgL_rz00_6827 =
											PROCEDURE_ENTRY(BgL_fz00_6826) (BgL_fz00_6826,
											BgL_nsz00_17724, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_18795;

											if (PROCEDUREP(BgL_rz00_6827))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_6832;

													BgL_arg1900z00_6832 = PROCEDURE_ATTR(BgL_rz00_6827);
													if (STRUCTP(BgL_arg1900z00_6832))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_18795 =
																(STRUCT_KEY(BgL_arg1900z00_6832) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_18795 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_18795 = ((bool_t) 0);
												}
											if (BgL_testz00_18795)
												{
													obj_t BgL_fz00_18803;

													BgL_fz00_18803 = BgL_rz00_6827;
													BgL_fz00_6826 = BgL_fz00_18803;
													goto BgL_recz00_6825;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17724,
														(int) (((long) 0)), BgL_savedzd2bpzd2_6819);
													BgL_val1172z00_1430 = BgL_rz00_6827;
							}}}}}
							POP_EXIT();
							return BgL_val1172z00_1430;
						}
					}
				}
		}
	}



/* &<anonymous:2069> */
	obj_t BGl_z62zc3anonymousza32069ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15718, obj_t BgL_sz00_15723)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			{	/* Eval/evaluate_comp.scm 856 */
				obj_t BgL_funz00_15719;
				obj_t BgL_locz00_15720;
				obj_t BgL_symbzd2funzd2_15721;
				long BgL_siza7eza7_15722;

				BgL_funz00_15719 = PROCEDURE_REF(BgL_envz00_15718, (int) (((long) 0)));
				BgL_locz00_15720 = PROCEDURE_REF(BgL_envz00_15718, (int) (((long) 1)));
				BgL_symbzd2funzd2_15721 =
					PROCEDURE_REF(BgL_envz00_15718, (int) (((long) 2)));
				BgL_siza7eza7_15722 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15718, (int) (((long) 3))));
				{
					obj_t BgL_sz00_1435;

					BgL_sz00_1435 = BgL_sz00_15723;
					{	/* Eval/evaluate_comp.scm 856 */
						obj_t BgL_bpz00_1437;

						BgL_bpz00_1437 = VECTOR_REF(BgL_sz00_1435, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 856 */
							obj_t BgL_fz00_1438;

							BgL_fz00_1438 =
								PROCEDURE_ENTRY(BgL_funz00_15719) (BgL_funz00_15719,
								BgL_sz00_1435, BEOA);
							if (PROCEDUREP(BgL_fz00_1438))
								{	/* Eval/evaluate_comp.scm 856 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 856 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_15720,
										BGl_string5561z00zz__evaluate_compz00,
										BGl_string5577z00zz__evaluate_compz00, BgL_fz00_1438);
								}
							{	/* Eval/evaluate_comp.scm 856 */
								obj_t BgL_ufz00_1440;

								BgL_ufz00_1440 = PROCEDURE_ATTR(BgL_fz00_1438);
								{	/* Eval/evaluate_comp.scm 856 */
									bool_t BgL_testz00_18826;

									if (STRUCTP(BgL_ufz00_1440))
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_18826 =
												(STRUCT_KEY(BgL_ufz00_1440) ==
												BGl_symbol5578z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_18826 = ((bool_t) 0);
										}
									if (BgL_testz00_18826)
										{	/* Eval/evaluate_comp.scm 856 */
											obj_t BgL_arityz00_1442;
											obj_t BgL_runz00_1443;
											obj_t BgL_sfz00_1444;

											BgL_arityz00_1442 =
												STRUCT_REF(BgL_ufz00_1440, (int) (((long) 0)));
											BgL_runz00_1443 =
												STRUCT_REF(BgL_ufz00_1440, (int) (((long) 1)));
											BgL_sfz00_1444 =
												STRUCT_REF(BgL_ufz00_1440, (int) (((long) 2)));
											{	/* Eval/evaluate_comp.scm 856 */
												long BgL_spz00_1445;

												BgL_spz00_1445 =
													((long) CINT(BgL_bpz00_1437) + BgL_siza7eza7_15722);
												if (((long) CINT(BgL_arityz00_1442) == ((long) 0)))
													{	/* Eval/evaluate_comp.scm 856 */
														BUNSPEC;
													}
												else
													{	/* Eval/evaluate_comp.scm 856 */
														if (INTEGERP(BgL_arityz00_1442))
															{	/* Eval/evaluate_comp.scm 856 */
																switch ((long) CINT(BgL_arityz00_1442))
																	{
																	case ((long) -1):

																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2074z00_1450;

																			BgL_arg2074z00_1450 =
																				(BgL_spz00_1445 + ((long) 0));
																			VECTOR_SET(BgL_sz00_1435,
																				(int) (BgL_arg2074z00_1450), BNIL);
																		} break;
																	default:
																		BGl_evarityzd2errorzd2zz__everrorz00
																			(BgL_locz00_15720,
																			STRUCT_REF(BgL_ufz00_1440,
																				(int) (((long) 3))), (int) (((long) 0)),
																			CINT(BgL_arityz00_1442));
															}}
														else
															{	/* Eval/evaluate_comp.scm 856 */
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_15720, STRUCT_REF(BgL_ufz00_1440,
																		(int) (((long) 3))), (int) (((long) 0)),
																	CINT(BgL_arityz00_1442));
													}}
												{	/* Eval/evaluate_comp.scm 856 */
													obj_t BgL_auxz00_18859;

													BgL_auxz00_18859 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_18859,
														BgL_locz00_15720);
												}
												{	/* Eval/evaluate_comp.scm 856 */
													bool_t BgL_testz00_18862;

													{	/* Eval/evaluate_comp.scm 665 */
														int BgL_arg1908z00_6908;

														BgL_arg1908z00_6908 = VECTOR_LENGTH(BgL_sz00_1435);
														BgL_testz00_18862 =
															(
															(BgL_spz00_1445 +
																(long) CINT(BgL_sfz00_1444)) <
															(long) (BgL_arg1908z00_6908));
													}
													if (BgL_testz00_18862)
														{	/* Eval/evaluate_comp.scm 856 */
															return
																BGl_catchzd2trampolinezd2zz__evaluate_compz00
																(BgL_runz00_1443, BgL_sz00_1435,
																BINT(BgL_spz00_1445));
														}
													else
														{	/* Eval/evaluate_comp.scm 856 */
															obj_t BgL_nsz00_1456;

															BgL_nsz00_1456 =
																BGl_makezd2statezd2zz__evaluate_compz00();
															{	/* Eval/evaluate_comp.scm 856 */
																long BgL_arg2079z00_1458;

																BgL_arg2079z00_1458 =
																	(BgL_spz00_1445 + ((long) 0));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_nsz00_1456, BINT(((long) 2)),
																	BgL_sz00_1435, BINT(BgL_spz00_1445),
																	BINT(BgL_arg2079z00_1458));
															}
															VECTOR_SET(BgL_nsz00_1456,
																(int) (((long) 1)), BgL_sz00_1435);
															{	/* Eval/evaluate_comp.scm 856 */
																obj_t BgL_auxz00_18878;

																BgL_auxz00_18878 = BGL_CURRENT_DYNAMIC_ENV();
																BGL_ENV_EVSTATE_SET(BgL_auxz00_18878,
																	BgL_nsz00_1456);
															}
															{	/* Eval/evaluate_comp.scm 856 */
																obj_t BgL_val1175z00_1460;

																BgL_val1175z00_1460 =
																	BGl_zc3exitza32085ze3z83zz__evaluate_compz00
																	(BgL_nsz00_1456, BgL_runz00_1443);
																{	/* Eval/evaluate_comp.scm 856 */
																	obj_t BgL_auxz00_18882;

																	BgL_auxz00_18882 = BGL_CURRENT_DYNAMIC_ENV();
																	BGL_ENV_EVSTATE_SET(BgL_auxz00_18882,
																		BgL_sz00_1435);
																}
																if (CBOOL
																	(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
																		(BgL_val1175z00_1460)))
																	{	/* Eval/evaluate_comp.scm 856 */
																		return
																			BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
																			(BgL_val1175z00_1460),
																			CDR(BgL_val1175z00_1460));
																	}
																else
																	{	/* Eval/evaluate_comp.scm 856 */
																		return BgL_val1175z00_1460;
																	}
															}
														}
												}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 856 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_1438,
													(int) (((long) 0))))
												{	/* Eval/evaluate_comp.scm 856 */
													long BgL_nbpz00_1469;

													BgL_nbpz00_1469 =
														((long) CINT(BgL_bpz00_1437) + BgL_siza7eza7_15722);
													VECTOR_SET(BgL_sz00_1435,
														(int) (((long) 0)), BINT(BgL_nbpz00_1469));
													{	/* Eval/evaluate_comp.scm 856 */
														obj_t BgL_rz00_1470;

														BgL_rz00_1470 =
															PROCEDURE_ENTRY(BgL_fz00_1438) (BgL_fz00_1438,
															BEOA);
														VECTOR_SET(BgL_sz00_1435, (int) (((long) 0)),
															BgL_bpz00_1437);
														return BgL_rz00_1470;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 856 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_15720, BgL_symbzd2funzd2_15721,
														(int) (((long) 0)), PROCEDURE_ARITY(BgL_fz00_1438));
		}}}}}}}}}
	}



/* <exit:2085> */
	obj_t BGl_zc3exitza32085ze3z83zz__evaluate_compz00(obj_t BgL_nsz00_17722,
		obj_t BgL_runz00_17721)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1176z00_1466;

			if (SET_EXIT(BgL_an_exit1176z00_1466))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1176z00_1466 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 856 */

						PUSH_EXIT(BgL_an_exit1176z00_1466, ((long) 0));
						{	/* Eval/evaluate_comp.scm 856 */
							obj_t BgL_val1177z00_1467;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_6926;

								BgL_savedzd2bpzd2_6926 =
									VECTOR_REF(BgL_nsz00_17722, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17722,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_6933;

									BgL_fz00_6933 = BgL_runz00_17721;
								BgL_recz00_6932:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_6934;

										BgL_rz00_6934 =
											PROCEDURE_ENTRY(BgL_fz00_6933) (BgL_fz00_6933,
											BgL_nsz00_17722, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_18919;

											if (PROCEDUREP(BgL_rz00_6934))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_6939;

													BgL_arg1900z00_6939 = PROCEDURE_ATTR(BgL_rz00_6934);
													if (STRUCTP(BgL_arg1900z00_6939))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_18919 =
																(STRUCT_KEY(BgL_arg1900z00_6939) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_18919 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_18919 = ((bool_t) 0);
												}
											if (BgL_testz00_18919)
												{
													obj_t BgL_fz00_18927;

													BgL_fz00_18927 = BgL_rz00_6934;
													BgL_fz00_6933 = BgL_fz00_18927;
													goto BgL_recz00_6932;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17722,
														(int) (((long) 0)), BgL_savedzd2bpzd2_6926);
													BgL_val1177z00_1467 = BgL_rz00_6934;
							}}}}}
							POP_EXIT();
							return BgL_val1177z00_1467;
						}
					}
				}
		}
	}



/* comp-call1 */
	obj_t BGl_compzd2call1zd2zz__evaluate_compz00(obj_t BgL_locz00_145,
		BgL_ev_exprz00_bglt BgL_vfunz00_146, obj_t BgL_symbzd2funzd2_147,
		obj_t BgL_funz00_148, obj_t BgL_tailzf3zf3_149, obj_t BgL_stkz00_150,
		long BgL_siza7eza7_151, obj_t BgL_a1z00_152)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			{	/* Eval/evaluate_comp.scm 856 */
				obj_t BgL_cfunz00_1472;

				BgL_cfunz00_1472 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_146,
					((long) 1), BgL_locz00_145, BgL_symbzd2funzd2_147);
				if (CBOOL(BgL_cfunz00_1472))
					{	/* Eval/evaluate_comp.scm 856 */
						obj_t BgL_zc3anonymousza32088ze3z83_15724;

						BgL_zc3anonymousza32088ze3z83_15724 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza32088ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 3)));
						PROCEDURE_SET(BgL_zc3anonymousza32088ze3z83_15724,
							(int) (((long) 0)), BgL_a1z00_152);
						PROCEDURE_SET(BgL_zc3anonymousza32088ze3z83_15724,
							(int) (((long) 1)), BINT(BgL_siza7eza7_151));
						PROCEDURE_SET(BgL_zc3anonymousza32088ze3z83_15724,
							(int) (((long) 2)), BgL_cfunz00_1472);
						return BgL_zc3anonymousza32088ze3z83_15724;
					}
				else
					{	/* Eval/evaluate_comp.scm 856 */
						if (CBOOL(BgL_tailzf3zf3_149))
							{	/* Eval/evaluate_comp.scm 856 */
								obj_t BgL_zc3anonymousza32089ze3z83_15725;

								BgL_zc3anonymousza32089ze3z83_15725 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32089ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_zc3anonymousza32089ze3z83_15725,
									(int) (((long) 0)), BgL_funz00_148);
								PROCEDURE_SET(BgL_zc3anonymousza32089ze3z83_15725,
									(int) (((long) 1)), BgL_a1z00_152);
								PROCEDURE_SET(BgL_zc3anonymousza32089ze3z83_15725,
									(int) (((long) 2)), BgL_locz00_145);
								PROCEDURE_SET(BgL_zc3anonymousza32089ze3z83_15725,
									(int) (((long) 3)), BgL_symbzd2funzd2_147);
								PROCEDURE_SET(BgL_zc3anonymousza32089ze3z83_15725,
									(int) (((long) 4)), BINT(BgL_siza7eza7_151));
								return BgL_zc3anonymousza32089ze3z83_15725;
							}
						else
							{	/* Eval/evaluate_comp.scm 856 */
								obj_t BgL_zc3anonymousza32115ze3z83_15726;

								BgL_zc3anonymousza32115ze3z83_15726 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32115ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_zc3anonymousza32115ze3z83_15726,
									(int) (((long) 0)), BgL_funz00_148);
								PROCEDURE_SET(BgL_zc3anonymousza32115ze3z83_15726,
									(int) (((long) 1)), BgL_a1z00_152);
								PROCEDURE_SET(BgL_zc3anonymousza32115ze3z83_15726,
									(int) (((long) 2)), BgL_locz00_145);
								PROCEDURE_SET(BgL_zc3anonymousza32115ze3z83_15726,
									(int) (((long) 3)), BgL_symbzd2funzd2_147);
								PROCEDURE_SET(BgL_zc3anonymousza32115ze3z83_15726,
									(int) (((long) 4)), BINT(BgL_siza7eza7_151));
								return BgL_zc3anonymousza32115ze3z83_15726;
							}
					}
			}
		}
	}



/* &<anonymous:2088> */
	obj_t BGl_z62zc3anonymousza32088ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15727, obj_t BgL_sz00_15731)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			{	/* Eval/evaluate_comp.scm 856 */
				obj_t BgL_a1z00_15728;
				long BgL_siza7eza7_15729;
				obj_t BgL_cfunz00_15730;

				BgL_a1z00_15728 = PROCEDURE_REF(BgL_envz00_15727, (int) (((long) 0)));
				BgL_siza7eza7_15729 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15727, (int) (((long) 1))));
				BgL_cfunz00_15730 = PROCEDURE_REF(BgL_envz00_15727, (int) (((long) 2)));
				{
					obj_t BgL_sz00_1473;

					BgL_sz00_1473 = BgL_sz00_15731;
					{	/* Eval/evaluate_comp.scm 856 */
						obj_t BgL_bpz00_1475;

						BgL_bpz00_1475 = VECTOR_REF(BgL_sz00_1473, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 856 */
							obj_t BgL_a1z00_1476;

							BgL_a1z00_1476 =
								PROCEDURE_ENTRY(BgL_a1z00_15728) (BgL_a1z00_15728,
								BgL_sz00_1473, BEOA);
							{	/* Eval/evaluate_comp.scm 856 */
								long BgL_nbpz00_1477;

								BgL_nbpz00_1477 =
									((long) CINT(BgL_bpz00_1475) + BgL_siza7eza7_15729);
								VECTOR_SET(BgL_sz00_1473,
									(int) (((long) 0)), BINT(BgL_nbpz00_1477));
								{	/* Eval/evaluate_comp.scm 856 */
									obj_t BgL_rz00_1478;

									BgL_rz00_1478 =
										PROCEDURE_ENTRY(BgL_cfunz00_15730) (BgL_cfunz00_15730,
										BgL_a1z00_1476, BEOA);
									VECTOR_SET(BgL_sz00_1473, (int) (((long) 0)), BgL_bpz00_1475);
									return BgL_rz00_1478;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:2089> */
	obj_t BGl_z62zc3anonymousza32089ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15732, obj_t BgL_sz00_15738)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			{	/* Eval/evaluate_comp.scm 856 */
				obj_t BgL_funz00_15733;
				obj_t BgL_a1z00_15734;
				obj_t BgL_locz00_15735;
				obj_t BgL_symbzd2funzd2_15736;
				long BgL_siza7eza7_15737;

				BgL_funz00_15733 = PROCEDURE_REF(BgL_envz00_15732, (int) (((long) 0)));
				BgL_a1z00_15734 = PROCEDURE_REF(BgL_envz00_15732, (int) (((long) 1)));
				BgL_locz00_15735 = PROCEDURE_REF(BgL_envz00_15732, (int) (((long) 2)));
				BgL_symbzd2funzd2_15736 =
					PROCEDURE_REF(BgL_envz00_15732, (int) (((long) 3)));
				BgL_siza7eza7_15737 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15732, (int) (((long) 4))));
				{
					obj_t BgL_sz00_1479;

					BgL_sz00_1479 = BgL_sz00_15738;
					{	/* Eval/evaluate_comp.scm 856 */
						obj_t BgL_bpz00_1481;

						BgL_bpz00_1481 = VECTOR_REF(BgL_sz00_1479, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 856 */
							obj_t BgL_fz00_1482;
							obj_t BgL_a1z00_1483;

							BgL_fz00_1482 =
								PROCEDURE_ENTRY(BgL_funz00_15733) (BgL_funz00_15733,
								BgL_sz00_1479, BEOA);
							BgL_a1z00_1483 =
								PROCEDURE_ENTRY(BgL_a1z00_15734) (BgL_a1z00_15734,
								BgL_sz00_1479, BEOA);
							if (PROCEDUREP(BgL_fz00_1482))
								{	/* Eval/evaluate_comp.scm 856 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 856 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_15735,
										BGl_string5561z00zz__evaluate_compz00,
										BGl_string5577z00zz__evaluate_compz00, BgL_fz00_1482);
								}
							{	/* Eval/evaluate_comp.scm 856 */
								obj_t BgL_ufz00_1485;

								BgL_ufz00_1485 = PROCEDURE_ATTR(BgL_fz00_1482);
								{	/* Eval/evaluate_comp.scm 856 */
									bool_t BgL_testz00_19023;

									if (STRUCTP(BgL_ufz00_1485))
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_19023 =
												(STRUCT_KEY(BgL_ufz00_1485) ==
												BGl_symbol5578z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_19023 = ((bool_t) 0);
										}
									if (BgL_testz00_19023)
										{	/* Eval/evaluate_comp.scm 856 */
											obj_t BgL_arityz00_1487;
											obj_t BgL_runz00_1488;
											obj_t BgL_sfz00_1489;

											BgL_arityz00_1487 =
												STRUCT_REF(BgL_ufz00_1485, (int) (((long) 0)));
											BgL_runz00_1488 =
												STRUCT_REF(BgL_ufz00_1485, (int) (((long) 1)));
											BgL_sfz00_1489 =
												STRUCT_REF(BgL_ufz00_1485, (int) (((long) 2)));
											if (((long) CINT(BgL_arityz00_1487) == ((long) 1)))
												{	/* Eval/evaluate_comp.scm 856 */
													long BgL_arg2093z00_1492;

													BgL_arg2093z00_1492 =
														((long) CINT(BgL_bpz00_1481) + ((long) 0));
													VECTOR_SET(BgL_sz00_1479,
														(int) (BgL_arg2093z00_1492), BgL_a1z00_1483);
												}
											else
												{	/* Eval/evaluate_comp.scm 856 */
													if (INTEGERP(BgL_arityz00_1487))
														{	/* Eval/evaluate_comp.scm 856 */
															switch ((long) CINT(BgL_arityz00_1487))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2095z00_1496;
																		obj_t BgL_arg2097z00_1497;

																		BgL_arg2095z00_1496 =
																			(
																			(long) CINT(BgL_bpz00_1481) + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 856 */
																			obj_t BgL_list2098z00_1498;

																			BgL_list2098z00_1498 =
																				MAKE_PAIR(BgL_a1z00_1483, BNIL);
																			BgL_arg2097z00_1497 =
																				BgL_list2098z00_1498;
																		}
																		VECTOR_SET(BgL_sz00_1479,
																			(int) (BgL_arg2095z00_1496),
																			BgL_arg2097z00_1497);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2099z00_1499;

																		BgL_arg2099z00_1499 =
																			(
																			(long) CINT(BgL_bpz00_1481) + ((long) 0));
																		VECTOR_SET(BgL_sz00_1479,
																			(int) (BgL_arg2099z00_1499),
																			BgL_a1z00_1483);
																	}
																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2100z00_1500;

																		BgL_arg2100z00_1500 =
																			(
																			(long) CINT(BgL_bpz00_1481) + ((long) 1));
																		VECTOR_SET(BgL_sz00_1479,
																			(int) (BgL_arg2100z00_1500), BNIL);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_15735,
																		STRUCT_REF(BgL_ufz00_1485,
																			(int) (((long) 3))), (int) (((long) 1)),
																		CINT(BgL_arityz00_1487));
														}}
													else
														{	/* Eval/evaluate_comp.scm 856 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_15735, STRUCT_REF(BgL_ufz00_1485,
																	(int) (((long) 3))), (int) (((long) 1)),
																CINT(BgL_arityz00_1487));
												}}
											{	/* Eval/evaluate_comp.scm 856 */
												obj_t BgL_auxz00_19068;

												BgL_auxz00_19068 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_19068,
													BgL_locz00_15735);
											}
											{	/* Eval/evaluate_comp.scm 856 */
												bool_t BgL_testz00_19071;

												{	/* Eval/evaluate_comp.scm 665 */
													int BgL_arg1908z00_7046;

													BgL_arg1908z00_7046 = VECTOR_LENGTH(BgL_sz00_1479);
													BgL_testz00_19071 =
														(
														((long) CINT(BgL_bpz00_1481) +
															(long) CINT(BgL_sfz00_1489)) <
														(long) (BgL_arg1908z00_7046));
												}
												if (BgL_testz00_19071)
													{	/* Eval/evaluate_comp.scm 856 */
														return BgL_runz00_1488;
													}
												else
													{	/* Eval/evaluate_comp.scm 856 */
														obj_t BgL_nsz00_1506;

														BgL_nsz00_1506 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 856 */
															long BgL_arg2106z00_1508;

															BgL_arg2106z00_1508 =
																((long) CINT(BgL_bpz00_1481) + ((long) 1));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_1506, BINT(((long) 2)),
																BgL_sz00_1479, BgL_bpz00_1481,
																BINT(BgL_arg2106z00_1508));
														}
														VECTOR_SET(BgL_nsz00_1506,
															(int) (((long) 1)), BgL_sz00_1479);
														{	/* Eval/evaluate_comp.scm 856 */
															obj_t BgL_auxz00_19086;

															BgL_auxz00_19086 = BGL_CURRENT_DYNAMIC_ENV();
															BGL_ENV_EVSTATE_SET(BgL_auxz00_19086,
																BgL_nsz00_1506);
														}
														{	/* Eval/evaluate_comp.scm 856 */
															obj_t BgL_val1180z00_1510;

															BgL_val1180z00_1510 =
																BGl_zc3exitza32112ze3z83zz__evaluate_compz00
																(BgL_nsz00_1506, BgL_runz00_1488);
															{	/* Eval/evaluate_comp.scm 856 */
																obj_t BgL_auxz00_19090;

																BgL_auxz00_19090 = BGL_CURRENT_DYNAMIC_ENV();
																BGL_ENV_EVSTATE_SET(BgL_auxz00_19090,
																	BgL_sz00_1479);
															}
															if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
																	(BgL_val1180z00_1510)))
																{	/* Eval/evaluate_comp.scm 856 */
																	return
																		BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
																		(BgL_val1180z00_1510),
																		CDR(BgL_val1180z00_1510));
																}
															else
																{	/* Eval/evaluate_comp.scm 856 */
																	return BgL_val1180z00_1510;
																}
														}
													}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 856 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_1482,
													(int) (((long) 1))))
												{	/* Eval/evaluate_comp.scm 856 */
													long BgL_nbpz00_1519;

													BgL_nbpz00_1519 =
														((long) CINT(BgL_bpz00_1481) + BgL_siza7eza7_15737);
													VECTOR_SET(BgL_sz00_1479,
														(int) (((long) 0)), BINT(BgL_nbpz00_1519));
													{	/* Eval/evaluate_comp.scm 856 */
														obj_t BgL_rz00_1520;

														BgL_rz00_1520 =
															PROCEDURE_ENTRY(BgL_fz00_1482) (BgL_fz00_1482,
															BgL_a1z00_1483, BEOA);
														VECTOR_SET(BgL_sz00_1479, (int) (((long) 0)),
															BgL_bpz00_1481);
														return BgL_rz00_1520;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 856 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_15735, BgL_symbzd2funzd2_15736,
														(int) (((long) 1)), PROCEDURE_ARITY(BgL_fz00_1482));
		}}}}}}}}}
	}



/* <exit:2112> */
	obj_t BGl_zc3exitza32112ze3z83zz__evaluate_compz00(obj_t BgL_nsz00_17720,
		obj_t BgL_runz00_17719)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1181z00_1516;

			if (SET_EXIT(BgL_an_exit1181z00_1516))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1181z00_1516 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 856 */

						PUSH_EXIT(BgL_an_exit1181z00_1516, ((long) 0));
						{	/* Eval/evaluate_comp.scm 856 */
							obj_t BgL_val1182z00_1517;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_7065;

								BgL_savedzd2bpzd2_7065 =
									VECTOR_REF(BgL_nsz00_17720, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17720,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_7072;

									BgL_fz00_7072 = BgL_runz00_17719;
								BgL_recz00_7071:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_7073;

										BgL_rz00_7073 =
											PROCEDURE_ENTRY(BgL_fz00_7072) (BgL_fz00_7072,
											BgL_nsz00_17720, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_19128;

											if (PROCEDUREP(BgL_rz00_7073))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_7078;

													BgL_arg1900z00_7078 = PROCEDURE_ATTR(BgL_rz00_7073);
													if (STRUCTP(BgL_arg1900z00_7078))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_19128 =
																(STRUCT_KEY(BgL_arg1900z00_7078) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_19128 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_19128 = ((bool_t) 0);
												}
											if (BgL_testz00_19128)
												{
													obj_t BgL_fz00_19136;

													BgL_fz00_19136 = BgL_rz00_7073;
													BgL_fz00_7072 = BgL_fz00_19136;
													goto BgL_recz00_7071;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17720,
														(int) (((long) 0)), BgL_savedzd2bpzd2_7065);
													BgL_val1182z00_1517 = BgL_rz00_7073;
							}}}}}
							POP_EXIT();
							return BgL_val1182z00_1517;
						}
					}
				}
		}
	}



/* &<anonymous:2115> */
	obj_t BGl_z62zc3anonymousza32115ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15739, obj_t BgL_sz00_15745)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			{	/* Eval/evaluate_comp.scm 856 */
				obj_t BgL_funz00_15740;
				obj_t BgL_a1z00_15741;
				obj_t BgL_locz00_15742;
				obj_t BgL_symbzd2funzd2_15743;
				long BgL_siza7eza7_15744;

				BgL_funz00_15740 = PROCEDURE_REF(BgL_envz00_15739, (int) (((long) 0)));
				BgL_a1z00_15741 = PROCEDURE_REF(BgL_envz00_15739, (int) (((long) 1)));
				BgL_locz00_15742 = PROCEDURE_REF(BgL_envz00_15739, (int) (((long) 2)));
				BgL_symbzd2funzd2_15743 =
					PROCEDURE_REF(BgL_envz00_15739, (int) (((long) 3)));
				BgL_siza7eza7_15744 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15739, (int) (((long) 4))));
				{
					obj_t BgL_sz00_1522;

					BgL_sz00_1522 = BgL_sz00_15745;
					{	/* Eval/evaluate_comp.scm 856 */
						obj_t BgL_bpz00_1524;

						BgL_bpz00_1524 = VECTOR_REF(BgL_sz00_1522, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 856 */
							obj_t BgL_fz00_1525;
							obj_t BgL_a1z00_1526;

							BgL_fz00_1525 =
								PROCEDURE_ENTRY(BgL_funz00_15740) (BgL_funz00_15740,
								BgL_sz00_1522, BEOA);
							BgL_a1z00_1526 =
								PROCEDURE_ENTRY(BgL_a1z00_15741) (BgL_a1z00_15741,
								BgL_sz00_1522, BEOA);
							if (PROCEDUREP(BgL_fz00_1525))
								{	/* Eval/evaluate_comp.scm 856 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 856 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_15742,
										BGl_string5561z00zz__evaluate_compz00,
										BGl_string5577z00zz__evaluate_compz00, BgL_fz00_1525);
								}
							{	/* Eval/evaluate_comp.scm 856 */
								obj_t BgL_ufz00_1528;

								BgL_ufz00_1528 = PROCEDURE_ATTR(BgL_fz00_1525);
								{	/* Eval/evaluate_comp.scm 856 */
									bool_t BgL_testz00_19165;

									if (STRUCTP(BgL_ufz00_1528))
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_19165 =
												(STRUCT_KEY(BgL_ufz00_1528) ==
												BGl_symbol5578z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_19165 = ((bool_t) 0);
										}
									if (BgL_testz00_19165)
										{	/* Eval/evaluate_comp.scm 856 */
											obj_t BgL_arityz00_1530;
											obj_t BgL_runz00_1531;
											obj_t BgL_sfz00_1532;

											BgL_arityz00_1530 =
												STRUCT_REF(BgL_ufz00_1528, (int) (((long) 0)));
											BgL_runz00_1531 =
												STRUCT_REF(BgL_ufz00_1528, (int) (((long) 1)));
											BgL_sfz00_1532 =
												STRUCT_REF(BgL_ufz00_1528, (int) (((long) 2)));
											{	/* Eval/evaluate_comp.scm 856 */
												long BgL_spz00_1533;

												BgL_spz00_1533 =
													((long) CINT(BgL_bpz00_1524) + BgL_siza7eza7_15744);
												if (((long) CINT(BgL_arityz00_1530) == ((long) 1)))
													{	/* Eval/evaluate_comp.scm 856 */
														long BgL_arg2120z00_1535;

														BgL_arg2120z00_1535 = (BgL_spz00_1533 + ((long) 0));
														VECTOR_SET(BgL_sz00_1522,
															(int) (BgL_arg2120z00_1535), BgL_a1z00_1526);
													}
												else
													{	/* Eval/evaluate_comp.scm 856 */
														if (INTEGERP(BgL_arityz00_1530))
															{	/* Eval/evaluate_comp.scm 856 */
																switch ((long) CINT(BgL_arityz00_1530))
																	{
																	case ((long) -1):

																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2122z00_1539;
																			obj_t BgL_arg2123z00_1540;

																			BgL_arg2122z00_1539 =
																				(BgL_spz00_1533 + ((long) 0));
																			{	/* Eval/evaluate_comp.scm 856 */
																				obj_t BgL_list2124z00_1541;

																				BgL_list2124z00_1541 =
																					MAKE_PAIR(BgL_a1z00_1526, BNIL);
																				BgL_arg2123z00_1540 =
																					BgL_list2124z00_1541;
																			}
																			VECTOR_SET(BgL_sz00_1522,
																				(int) (BgL_arg2122z00_1539),
																				BgL_arg2123z00_1540);
																		} break;
																	case ((long) -2):

																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2126z00_1542;

																			BgL_arg2126z00_1542 =
																				(BgL_spz00_1533 + ((long) 0));
																			VECTOR_SET(BgL_sz00_1522,
																				(int) (BgL_arg2126z00_1542),
																				BgL_a1z00_1526);
																		}
																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2127z00_1543;

																			BgL_arg2127z00_1543 =
																				(BgL_spz00_1533 + ((long) 1));
																			VECTOR_SET(BgL_sz00_1522,
																				(int) (BgL_arg2127z00_1543), BNIL);
																		} break;
																	default:
																		BGl_evarityzd2errorzd2zz__everrorz00
																			(BgL_locz00_15742,
																			STRUCT_REF(BgL_ufz00_1528,
																				(int) (((long) 3))), (int) (((long) 1)),
																			CINT(BgL_arityz00_1530));
															}}
														else
															{	/* Eval/evaluate_comp.scm 856 */
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_15742, STRUCT_REF(BgL_ufz00_1528,
																		(int) (((long) 3))), (int) (((long) 1)),
																	CINT(BgL_arityz00_1530));
													}}
												{	/* Eval/evaluate_comp.scm 856 */
													obj_t BgL_auxz00_19208;

													BgL_auxz00_19208 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_19208,
														BgL_locz00_15742);
												}
												{	/* Eval/evaluate_comp.scm 856 */
													bool_t BgL_testz00_19211;

													{	/* Eval/evaluate_comp.scm 665 */
														int BgL_arg1908z00_7174;

														BgL_arg1908z00_7174 = VECTOR_LENGTH(BgL_sz00_1522);
														BgL_testz00_19211 =
															(
															(BgL_spz00_1533 +
																(long) CINT(BgL_sfz00_1532)) <
															(long) (BgL_arg1908z00_7174));
													}
													if (BgL_testz00_19211)
														{	/* Eval/evaluate_comp.scm 856 */
															return
																BGl_catchzd2trampolinezd2zz__evaluate_compz00
																(BgL_runz00_1531, BgL_sz00_1522,
																BINT(BgL_spz00_1533));
														}
													else
														{	/* Eval/evaluate_comp.scm 856 */
															obj_t BgL_nsz00_1549;

															BgL_nsz00_1549 =
																BGl_makezd2statezd2zz__evaluate_compz00();
															{	/* Eval/evaluate_comp.scm 856 */
																long BgL_arg2132z00_1551;

																BgL_arg2132z00_1551 =
																	(BgL_spz00_1533 + ((long) 1));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_nsz00_1549, BINT(((long) 2)),
																	BgL_sz00_1522, BINT(BgL_spz00_1533),
																	BINT(BgL_arg2132z00_1551));
															}
															VECTOR_SET(BgL_nsz00_1549,
																(int) (((long) 1)), BgL_sz00_1522);
															{	/* Eval/evaluate_comp.scm 856 */
																obj_t BgL_auxz00_19227;

																BgL_auxz00_19227 = BGL_CURRENT_DYNAMIC_ENV();
																BGL_ENV_EVSTATE_SET(BgL_auxz00_19227,
																	BgL_nsz00_1549);
															}
															{	/* Eval/evaluate_comp.scm 856 */
																obj_t BgL_val1185z00_1553;

																BgL_val1185z00_1553 =
																	BGl_zc3exitza32138ze3z83zz__evaluate_compz00
																	(BgL_nsz00_1549, BgL_runz00_1531);
																{	/* Eval/evaluate_comp.scm 856 */
																	obj_t BgL_auxz00_19231;

																	BgL_auxz00_19231 = BGL_CURRENT_DYNAMIC_ENV();
																	BGL_ENV_EVSTATE_SET(BgL_auxz00_19231,
																		BgL_sz00_1522);
																}
																if (CBOOL
																	(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
																		(BgL_val1185z00_1553)))
																	{	/* Eval/evaluate_comp.scm 856 */
																		return
																			BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
																			(BgL_val1185z00_1553),
																			CDR(BgL_val1185z00_1553));
																	}
																else
																	{	/* Eval/evaluate_comp.scm 856 */
																		return BgL_val1185z00_1553;
																	}
															}
														}
												}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 856 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_1525,
													(int) (((long) 1))))
												{	/* Eval/evaluate_comp.scm 856 */
													long BgL_nbpz00_1562;

													BgL_nbpz00_1562 =
														((long) CINT(BgL_bpz00_1524) + BgL_siza7eza7_15744);
													VECTOR_SET(BgL_sz00_1522,
														(int) (((long) 0)), BINT(BgL_nbpz00_1562));
													{	/* Eval/evaluate_comp.scm 856 */
														obj_t BgL_rz00_1563;

														BgL_rz00_1563 =
															PROCEDURE_ENTRY(BgL_fz00_1525) (BgL_fz00_1525,
															BgL_a1z00_1526, BEOA);
														VECTOR_SET(BgL_sz00_1522, (int) (((long) 0)),
															BgL_bpz00_1524);
														return BgL_rz00_1563;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 856 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_15742, BgL_symbzd2funzd2_15743,
														(int) (((long) 1)), PROCEDURE_ARITY(BgL_fz00_1525));
		}}}}}}}}}
	}



/* <exit:2138> */
	obj_t BGl_zc3exitza32138ze3z83zz__evaluate_compz00(obj_t BgL_nsz00_17718,
		obj_t BgL_runz00_17717)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1186z00_1559;

			if (SET_EXIT(BgL_an_exit1186z00_1559))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1186z00_1559 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 856 */

						PUSH_EXIT(BgL_an_exit1186z00_1559, ((long) 0));
						{	/* Eval/evaluate_comp.scm 856 */
							obj_t BgL_val1187z00_1560;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_7192;

								BgL_savedzd2bpzd2_7192 =
									VECTOR_REF(BgL_nsz00_17718, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17718,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_7199;

									BgL_fz00_7199 = BgL_runz00_17717;
								BgL_recz00_7198:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_7200;

										BgL_rz00_7200 =
											PROCEDURE_ENTRY(BgL_fz00_7199) (BgL_fz00_7199,
											BgL_nsz00_17718, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_19269;

											if (PROCEDUREP(BgL_rz00_7200))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_7205;

													BgL_arg1900z00_7205 = PROCEDURE_ATTR(BgL_rz00_7200);
													if (STRUCTP(BgL_arg1900z00_7205))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_19269 =
																(STRUCT_KEY(BgL_arg1900z00_7205) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_19269 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_19269 = ((bool_t) 0);
												}
											if (BgL_testz00_19269)
												{
													obj_t BgL_fz00_19277;

													BgL_fz00_19277 = BgL_rz00_7200;
													BgL_fz00_7199 = BgL_fz00_19277;
													goto BgL_recz00_7198;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17718,
														(int) (((long) 0)), BgL_savedzd2bpzd2_7192);
													BgL_val1187z00_1560 = BgL_rz00_7200;
							}}}}}
							POP_EXIT();
							return BgL_val1187z00_1560;
						}
					}
				}
		}
	}



/* comp-call2 */
	obj_t BGl_compzd2call2zd2zz__evaluate_compz00(obj_t BgL_locz00_153,
		BgL_ev_exprz00_bglt BgL_vfunz00_154, obj_t BgL_symbzd2funzd2_155,
		obj_t BgL_funz00_156, obj_t BgL_tailzf3zf3_157, obj_t BgL_stkz00_158,
		long BgL_siza7eza7_159, obj_t BgL_a1z00_160, obj_t BgL_a2z00_161)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			{	/* Eval/evaluate_comp.scm 856 */
				obj_t BgL_cfunz00_1565;

				BgL_cfunz00_1565 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_154,
					((long) 2), BgL_locz00_153, BgL_symbzd2funzd2_155);
				if (CBOOL(BgL_cfunz00_1565))
					{	/* Eval/evaluate_comp.scm 856 */
						obj_t BgL_zc3anonymousza32141ze3z83_15746;

						BgL_zc3anonymousza32141ze3z83_15746 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza32141ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 4)));
						PROCEDURE_SET(BgL_zc3anonymousza32141ze3z83_15746,
							(int) (((long) 0)), BgL_a1z00_160);
						PROCEDURE_SET(BgL_zc3anonymousza32141ze3z83_15746,
							(int) (((long) 1)), BgL_a2z00_161);
						PROCEDURE_SET(BgL_zc3anonymousza32141ze3z83_15746,
							(int) (((long) 2)), BINT(BgL_siza7eza7_159));
						PROCEDURE_SET(BgL_zc3anonymousza32141ze3z83_15746,
							(int) (((long) 3)), BgL_cfunz00_1565);
						return BgL_zc3anonymousza32141ze3z83_15746;
					}
				else
					{	/* Eval/evaluate_comp.scm 856 */
						if (CBOOL(BgL_tailzf3zf3_157))
							{	/* Eval/evaluate_comp.scm 856 */
								obj_t BgL_zc3anonymousza32142ze3z83_15747;

								BgL_zc3anonymousza32142ze3z83_15747 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32142ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_zc3anonymousza32142ze3z83_15747,
									(int) (((long) 0)), BgL_funz00_156);
								PROCEDURE_SET(BgL_zc3anonymousza32142ze3z83_15747,
									(int) (((long) 1)), BgL_a1z00_160);
								PROCEDURE_SET(BgL_zc3anonymousza32142ze3z83_15747,
									(int) (((long) 2)), BgL_a2z00_161);
								PROCEDURE_SET(BgL_zc3anonymousza32142ze3z83_15747,
									(int) (((long) 3)), BgL_locz00_153);
								PROCEDURE_SET(BgL_zc3anonymousza32142ze3z83_15747,
									(int) (((long) 4)), BgL_symbzd2funzd2_155);
								PROCEDURE_SET(BgL_zc3anonymousza32142ze3z83_15747,
									(int) (((long) 5)), BINT(BgL_siza7eza7_159));
								return BgL_zc3anonymousza32142ze3z83_15747;
							}
						else
							{	/* Eval/evaluate_comp.scm 856 */
								obj_t BgL_zc3anonymousza32178ze3z83_15748;

								BgL_zc3anonymousza32178ze3z83_15748 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32178ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_zc3anonymousza32178ze3z83_15748,
									(int) (((long) 0)), BgL_funz00_156);
								PROCEDURE_SET(BgL_zc3anonymousza32178ze3z83_15748,
									(int) (((long) 1)), BgL_a1z00_160);
								PROCEDURE_SET(BgL_zc3anonymousza32178ze3z83_15748,
									(int) (((long) 2)), BgL_a2z00_161);
								PROCEDURE_SET(BgL_zc3anonymousza32178ze3z83_15748,
									(int) (((long) 3)), BgL_locz00_153);
								PROCEDURE_SET(BgL_zc3anonymousza32178ze3z83_15748,
									(int) (((long) 4)), BgL_symbzd2funzd2_155);
								PROCEDURE_SET(BgL_zc3anonymousza32178ze3z83_15748,
									(int) (((long) 5)), BINT(BgL_siza7eza7_159));
								return BgL_zc3anonymousza32178ze3z83_15748;
							}
					}
			}
		}
	}



/* &<anonymous:2141> */
	obj_t BGl_z62zc3anonymousza32141ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15749, obj_t BgL_sz00_15754)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			{	/* Eval/evaluate_comp.scm 856 */
				obj_t BgL_a1z00_15750;
				obj_t BgL_a2z00_15751;
				long BgL_siza7eza7_15752;
				obj_t BgL_cfunz00_15753;

				BgL_a1z00_15750 = PROCEDURE_REF(BgL_envz00_15749, (int) (((long) 0)));
				BgL_a2z00_15751 = PROCEDURE_REF(BgL_envz00_15749, (int) (((long) 1)));
				BgL_siza7eza7_15752 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15749, (int) (((long) 2))));
				BgL_cfunz00_15753 = PROCEDURE_REF(BgL_envz00_15749, (int) (((long) 3)));
				{
					obj_t BgL_sz00_1566;

					BgL_sz00_1566 = BgL_sz00_15754;
					{	/* Eval/evaluate_comp.scm 856 */
						obj_t BgL_bpz00_1568;

						BgL_bpz00_1568 = VECTOR_REF(BgL_sz00_1566, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 856 */
							obj_t BgL_a1z00_1569;
							obj_t BgL_a2z00_1570;

							BgL_a1z00_1569 =
								PROCEDURE_ENTRY(BgL_a1z00_15750) (BgL_a1z00_15750,
								BgL_sz00_1566, BEOA);
							BgL_a2z00_1570 =
								PROCEDURE_ENTRY(BgL_a2z00_15751) (BgL_a2z00_15751,
								BgL_sz00_1566, BEOA);
							{	/* Eval/evaluate_comp.scm 856 */
								long BgL_nbpz00_1571;

								BgL_nbpz00_1571 =
									((long) CINT(BgL_bpz00_1568) + BgL_siza7eza7_15752);
								VECTOR_SET(BgL_sz00_1566,
									(int) (((long) 0)), BINT(BgL_nbpz00_1571));
								{	/* Eval/evaluate_comp.scm 856 */
									obj_t BgL_rz00_1572;

									BgL_rz00_1572 =
										PROCEDURE_ENTRY(BgL_cfunz00_15753) (BgL_cfunz00_15753,
										BgL_a1z00_1569, BgL_a2z00_1570, BEOA);
									VECTOR_SET(BgL_sz00_1566, (int) (((long) 0)), BgL_bpz00_1568);
									return BgL_rz00_1572;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:2142> */
	obj_t BGl_z62zc3anonymousza32142ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15755, obj_t BgL_sz00_15762)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			{	/* Eval/evaluate_comp.scm 856 */
				obj_t BgL_funz00_15756;
				obj_t BgL_a1z00_15757;
				obj_t BgL_a2z00_15758;
				obj_t BgL_locz00_15759;
				obj_t BgL_symbzd2funzd2_15760;
				long BgL_siza7eza7_15761;

				BgL_funz00_15756 = PROCEDURE_REF(BgL_envz00_15755, (int) (((long) 0)));
				BgL_a1z00_15757 = PROCEDURE_REF(BgL_envz00_15755, (int) (((long) 1)));
				BgL_a2z00_15758 = PROCEDURE_REF(BgL_envz00_15755, (int) (((long) 2)));
				BgL_locz00_15759 = PROCEDURE_REF(BgL_envz00_15755, (int) (((long) 3)));
				BgL_symbzd2funzd2_15760 =
					PROCEDURE_REF(BgL_envz00_15755, (int) (((long) 4)));
				BgL_siza7eza7_15761 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15755, (int) (((long) 5))));
				{
					obj_t BgL_sz00_1573;

					BgL_sz00_1573 = BgL_sz00_15762;
					{	/* Eval/evaluate_comp.scm 856 */
						obj_t BgL_bpz00_1575;

						BgL_bpz00_1575 = VECTOR_REF(BgL_sz00_1573, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 856 */
							obj_t BgL_fz00_1576;
							obj_t BgL_a1z00_1577;
							obj_t BgL_a2z00_1578;

							BgL_fz00_1576 =
								PROCEDURE_ENTRY(BgL_funz00_15756) (BgL_funz00_15756,
								BgL_sz00_1573, BEOA);
							BgL_a1z00_1577 =
								PROCEDURE_ENTRY(BgL_a1z00_15757) (BgL_a1z00_15757,
								BgL_sz00_1573, BEOA);
							BgL_a2z00_1578 =
								PROCEDURE_ENTRY(BgL_a2z00_15758) (BgL_a2z00_15758,
								BgL_sz00_1573, BEOA);
							if (PROCEDUREP(BgL_fz00_1576))
								{	/* Eval/evaluate_comp.scm 856 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 856 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_15759,
										BGl_string5561z00zz__evaluate_compz00,
										BGl_string5577z00zz__evaluate_compz00, BgL_fz00_1576);
								}
							{	/* Eval/evaluate_comp.scm 856 */
								obj_t BgL_ufz00_1580;

								BgL_ufz00_1580 = PROCEDURE_ATTR(BgL_fz00_1576);
								{	/* Eval/evaluate_comp.scm 856 */
									bool_t BgL_testz00_19392;

									if (STRUCTP(BgL_ufz00_1580))
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_19392 =
												(STRUCT_KEY(BgL_ufz00_1580) ==
												BGl_symbol5578z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_19392 = ((bool_t) 0);
										}
									if (BgL_testz00_19392)
										{	/* Eval/evaluate_comp.scm 856 */
											obj_t BgL_arityz00_1582;
											obj_t BgL_runz00_1583;
											obj_t BgL_sfz00_1584;

											BgL_arityz00_1582 =
												STRUCT_REF(BgL_ufz00_1580, (int) (((long) 0)));
											BgL_runz00_1583 =
												STRUCT_REF(BgL_ufz00_1580, (int) (((long) 1)));
											BgL_sfz00_1584 =
												STRUCT_REF(BgL_ufz00_1580, (int) (((long) 2)));
											if (((long) CINT(BgL_arityz00_1582) == ((long) 2)))
												{	/* Eval/evaluate_comp.scm 856 */
													{	/* Eval/evaluate_comp.scm 856 */
														long BgL_arg2146z00_1587;

														BgL_arg2146z00_1587 =
															((long) CINT(BgL_bpz00_1575) + ((long) 0));
														VECTOR_SET(BgL_sz00_1573,
															(int) (BgL_arg2146z00_1587), BgL_a1z00_1577);
													}
													{	/* Eval/evaluate_comp.scm 856 */
														long BgL_arg2148z00_1588;

														BgL_arg2148z00_1588 =
															((long) CINT(BgL_bpz00_1575) + ((long) 1));
														VECTOR_SET(BgL_sz00_1573,
															(int) (BgL_arg2148z00_1588), BgL_a2z00_1578);
												}}
											else
												{	/* Eval/evaluate_comp.scm 856 */
													if (INTEGERP(BgL_arityz00_1582))
														{	/* Eval/evaluate_comp.scm 856 */
															switch ((long) CINT(BgL_arityz00_1582))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2150z00_1592;
																		obj_t BgL_arg2151z00_1593;

																		BgL_arg2150z00_1592 =
																			(
																			(long) CINT(BgL_bpz00_1575) + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 856 */
																			obj_t BgL_list2152z00_1594;

																			{	/* Eval/evaluate_comp.scm 856 */
																				obj_t BgL_arg2153z00_1595;

																				BgL_arg2153z00_1595 =
																					MAKE_PAIR(BgL_a2z00_1578, BNIL);
																				BgL_list2152z00_1594 =
																					MAKE_PAIR(BgL_a1z00_1577,
																					BgL_arg2153z00_1595);
																			}
																			BgL_arg2151z00_1593 =
																				BgL_list2152z00_1594;
																		}
																		VECTOR_SET(BgL_sz00_1573,
																			(int) (BgL_arg2150z00_1592),
																			BgL_arg2151z00_1593);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2154z00_1596;

																		BgL_arg2154z00_1596 =
																			(
																			(long) CINT(BgL_bpz00_1575) + ((long) 0));
																		VECTOR_SET(BgL_sz00_1573,
																			(int) (BgL_arg2154z00_1596),
																			BgL_a1z00_1577);
																	}
																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2155z00_1597;
																		obj_t BgL_arg2157z00_1598;

																		BgL_arg2155z00_1597 =
																			(
																			(long) CINT(BgL_bpz00_1575) + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 856 */
																			obj_t BgL_list2158z00_1599;

																			BgL_list2158z00_1599 =
																				MAKE_PAIR(BgL_a2z00_1578, BNIL);
																			BgL_arg2157z00_1598 =
																				BgL_list2158z00_1599;
																		}
																		VECTOR_SET(BgL_sz00_1573,
																			(int) (BgL_arg2155z00_1597),
																			BgL_arg2157z00_1598);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2159z00_1600;

																		BgL_arg2159z00_1600 =
																			(
																			(long) CINT(BgL_bpz00_1575) + ((long) 0));
																		VECTOR_SET(BgL_sz00_1573,
																			(int) (BgL_arg2159z00_1600),
																			BgL_a1z00_1577);
																	}
																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2160z00_1601;

																		BgL_arg2160z00_1601 =
																			(
																			(long) CINT(BgL_bpz00_1575) + ((long) 1));
																		VECTOR_SET(BgL_sz00_1573,
																			(int) (BgL_arg2160z00_1601),
																			BgL_a2z00_1578);
																	}
																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2161z00_1602;

																		BgL_arg2161z00_1602 =
																			(
																			(long) CINT(BgL_bpz00_1575) + ((long) 2));
																		VECTOR_SET(BgL_sz00_1573,
																			(int) (BgL_arg2161z00_1602), BNIL);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_15759,
																		STRUCT_REF(BgL_ufz00_1580,
																			(int) (((long) 3))), (int) (((long) 2)),
																		CINT(BgL_arityz00_1582));
														}}
													else
														{	/* Eval/evaluate_comp.scm 856 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_15759, STRUCT_REF(BgL_ufz00_1580,
																	(int) (((long) 3))), (int) (((long) 2)),
																CINT(BgL_arityz00_1582));
												}}
											{	/* Eval/evaluate_comp.scm 856 */
												obj_t BgL_auxz00_19455;

												BgL_auxz00_19455 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_19455,
													BgL_locz00_15759);
											}
											{	/* Eval/evaluate_comp.scm 856 */
												bool_t BgL_testz00_19458;

												{	/* Eval/evaluate_comp.scm 665 */
													int BgL_arg1908z00_7338;

													BgL_arg1908z00_7338 = VECTOR_LENGTH(BgL_sz00_1573);
													BgL_testz00_19458 =
														(
														((long) CINT(BgL_bpz00_1575) +
															(long) CINT(BgL_sfz00_1584)) <
														(long) (BgL_arg1908z00_7338));
												}
												if (BgL_testz00_19458)
													{	/* Eval/evaluate_comp.scm 856 */
														return BgL_runz00_1583;
													}
												else
													{	/* Eval/evaluate_comp.scm 856 */
														obj_t BgL_nsz00_1608;

														BgL_nsz00_1608 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 856 */
															long BgL_arg2168z00_1610;

															BgL_arg2168z00_1610 =
																((long) CINT(BgL_bpz00_1575) + ((long) 2));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_1608, BINT(((long) 2)),
																BgL_sz00_1573, BgL_bpz00_1575,
																BINT(BgL_arg2168z00_1610));
														}
														VECTOR_SET(BgL_nsz00_1608,
															(int) (((long) 1)), BgL_sz00_1573);
														{	/* Eval/evaluate_comp.scm 856 */
															obj_t BgL_auxz00_19473;

															BgL_auxz00_19473 = BGL_CURRENT_DYNAMIC_ENV();
															BGL_ENV_EVSTATE_SET(BgL_auxz00_19473,
																BgL_nsz00_1608);
														}
														{	/* Eval/evaluate_comp.scm 856 */
															obj_t BgL_val1190z00_1612;

															BgL_val1190z00_1612 =
																BGl_zc3exitza32175ze3z83zz__evaluate_compz00
																(BgL_nsz00_1608, BgL_runz00_1583);
															{	/* Eval/evaluate_comp.scm 856 */
																obj_t BgL_auxz00_19477;

																BgL_auxz00_19477 = BGL_CURRENT_DYNAMIC_ENV();
																BGL_ENV_EVSTATE_SET(BgL_auxz00_19477,
																	BgL_sz00_1573);
															}
															if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
																	(BgL_val1190z00_1612)))
																{	/* Eval/evaluate_comp.scm 856 */
																	return
																		BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
																		(BgL_val1190z00_1612),
																		CDR(BgL_val1190z00_1612));
																}
															else
																{	/* Eval/evaluate_comp.scm 856 */
																	return BgL_val1190z00_1612;
																}
														}
													}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 856 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_1576,
													(int) (((long) 2))))
												{	/* Eval/evaluate_comp.scm 856 */
													long BgL_nbpz00_1621;

													BgL_nbpz00_1621 =
														((long) CINT(BgL_bpz00_1575) + BgL_siza7eza7_15761);
													VECTOR_SET(BgL_sz00_1573,
														(int) (((long) 0)), BINT(BgL_nbpz00_1621));
													{	/* Eval/evaluate_comp.scm 856 */
														obj_t BgL_rz00_1622;

														BgL_rz00_1622 =
															PROCEDURE_ENTRY(BgL_fz00_1576) (BgL_fz00_1576,
															BgL_a1z00_1577, BgL_a2z00_1578, BEOA);
														VECTOR_SET(BgL_sz00_1573, (int) (((long) 0)),
															BgL_bpz00_1575);
														return BgL_rz00_1622;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 856 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_15759, BgL_symbzd2funzd2_15760,
														(int) (((long) 2)), PROCEDURE_ARITY(BgL_fz00_1576));
		}}}}}}}}}
	}



/* <exit:2175> */
	obj_t BGl_zc3exitza32175ze3z83zz__evaluate_compz00(obj_t BgL_nsz00_17716,
		obj_t BgL_runz00_17715)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1191z00_1618;

			if (SET_EXIT(BgL_an_exit1191z00_1618))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1191z00_1618 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 856 */

						PUSH_EXIT(BgL_an_exit1191z00_1618, ((long) 0));
						{	/* Eval/evaluate_comp.scm 856 */
							obj_t BgL_val1192z00_1619;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_7357;

								BgL_savedzd2bpzd2_7357 =
									VECTOR_REF(BgL_nsz00_17716, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17716,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_7364;

									BgL_fz00_7364 = BgL_runz00_17715;
								BgL_recz00_7363:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_7365;

										BgL_rz00_7365 =
											PROCEDURE_ENTRY(BgL_fz00_7364) (BgL_fz00_7364,
											BgL_nsz00_17716, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_19516;

											if (PROCEDUREP(BgL_rz00_7365))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_7370;

													BgL_arg1900z00_7370 = PROCEDURE_ATTR(BgL_rz00_7365);
													if (STRUCTP(BgL_arg1900z00_7370))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_19516 =
																(STRUCT_KEY(BgL_arg1900z00_7370) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_19516 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_19516 = ((bool_t) 0);
												}
											if (BgL_testz00_19516)
												{
													obj_t BgL_fz00_19524;

													BgL_fz00_19524 = BgL_rz00_7365;
													BgL_fz00_7364 = BgL_fz00_19524;
													goto BgL_recz00_7363;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17716,
														(int) (((long) 0)), BgL_savedzd2bpzd2_7357);
													BgL_val1192z00_1619 = BgL_rz00_7365;
							}}}}}
							POP_EXIT();
							return BgL_val1192z00_1619;
						}
					}
				}
		}
	}



/* &<anonymous:2178> */
	obj_t BGl_z62zc3anonymousza32178ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15763, obj_t BgL_sz00_15770)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			{	/* Eval/evaluate_comp.scm 856 */
				obj_t BgL_funz00_15764;
				obj_t BgL_a1z00_15765;
				obj_t BgL_a2z00_15766;
				obj_t BgL_locz00_15767;
				obj_t BgL_symbzd2funzd2_15768;
				long BgL_siza7eza7_15769;

				BgL_funz00_15764 = PROCEDURE_REF(BgL_envz00_15763, (int) (((long) 0)));
				BgL_a1z00_15765 = PROCEDURE_REF(BgL_envz00_15763, (int) (((long) 1)));
				BgL_a2z00_15766 = PROCEDURE_REF(BgL_envz00_15763, (int) (((long) 2)));
				BgL_locz00_15767 = PROCEDURE_REF(BgL_envz00_15763, (int) (((long) 3)));
				BgL_symbzd2funzd2_15768 =
					PROCEDURE_REF(BgL_envz00_15763, (int) (((long) 4)));
				BgL_siza7eza7_15769 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15763, (int) (((long) 5))));
				{
					obj_t BgL_sz00_1624;

					BgL_sz00_1624 = BgL_sz00_15770;
					{	/* Eval/evaluate_comp.scm 856 */
						obj_t BgL_bpz00_1626;

						BgL_bpz00_1626 = VECTOR_REF(BgL_sz00_1624, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 856 */
							obj_t BgL_fz00_1627;
							obj_t BgL_a1z00_1628;
							obj_t BgL_a2z00_1629;

							BgL_fz00_1627 =
								PROCEDURE_ENTRY(BgL_funz00_15764) (BgL_funz00_15764,
								BgL_sz00_1624, BEOA);
							BgL_a1z00_1628 =
								PROCEDURE_ENTRY(BgL_a1z00_15765) (BgL_a1z00_15765,
								BgL_sz00_1624, BEOA);
							BgL_a2z00_1629 =
								PROCEDURE_ENTRY(BgL_a2z00_15766) (BgL_a2z00_15766,
								BgL_sz00_1624, BEOA);
							if (PROCEDUREP(BgL_fz00_1627))
								{	/* Eval/evaluate_comp.scm 856 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 856 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_15767,
										BGl_string5561z00zz__evaluate_compz00,
										BGl_string5577z00zz__evaluate_compz00, BgL_fz00_1627);
								}
							{	/* Eval/evaluate_comp.scm 856 */
								obj_t BgL_ufz00_1631;

								BgL_ufz00_1631 = PROCEDURE_ATTR(BgL_fz00_1627);
								{	/* Eval/evaluate_comp.scm 856 */
									bool_t BgL_testz00_19559;

									if (STRUCTP(BgL_ufz00_1631))
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_19559 =
												(STRUCT_KEY(BgL_ufz00_1631) ==
												BGl_symbol5578z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_19559 = ((bool_t) 0);
										}
									if (BgL_testz00_19559)
										{	/* Eval/evaluate_comp.scm 856 */
											obj_t BgL_arityz00_1633;
											obj_t BgL_runz00_1634;
											obj_t BgL_sfz00_1635;

											BgL_arityz00_1633 =
												STRUCT_REF(BgL_ufz00_1631, (int) (((long) 0)));
											BgL_runz00_1634 =
												STRUCT_REF(BgL_ufz00_1631, (int) (((long) 1)));
											BgL_sfz00_1635 =
												STRUCT_REF(BgL_ufz00_1631, (int) (((long) 2)));
											{	/* Eval/evaluate_comp.scm 856 */
												long BgL_spz00_1636;

												BgL_spz00_1636 =
													((long) CINT(BgL_bpz00_1626) + BgL_siza7eza7_15769);
												if (((long) CINT(BgL_arityz00_1633) == ((long) 2)))
													{	/* Eval/evaluate_comp.scm 856 */
														{	/* Eval/evaluate_comp.scm 856 */
															long BgL_arg2182z00_1638;

															BgL_arg2182z00_1638 =
																(BgL_spz00_1636 + ((long) 0));
															VECTOR_SET(BgL_sz00_1624,
																(int) (BgL_arg2182z00_1638), BgL_a1z00_1628);
														}
														{	/* Eval/evaluate_comp.scm 856 */
															long BgL_arg2183z00_1639;

															BgL_arg2183z00_1639 =
																(BgL_spz00_1636 + ((long) 1));
															VECTOR_SET(BgL_sz00_1624,
																(int) (BgL_arg2183z00_1639), BgL_a2z00_1629);
													}}
												else
													{	/* Eval/evaluate_comp.scm 856 */
														if (INTEGERP(BgL_arityz00_1633))
															{	/* Eval/evaluate_comp.scm 856 */
																switch ((long) CINT(BgL_arityz00_1633))
																	{
																	case ((long) -1):

																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2186z00_1643;
																			obj_t BgL_arg2187z00_1644;

																			BgL_arg2186z00_1643 =
																				(BgL_spz00_1636 + ((long) 0));
																			{	/* Eval/evaluate_comp.scm 856 */
																				obj_t BgL_list2188z00_1645;

																				{	/* Eval/evaluate_comp.scm 856 */
																					obj_t BgL_arg2189z00_1646;

																					BgL_arg2189z00_1646 =
																						MAKE_PAIR(BgL_a2z00_1629, BNIL);
																					BgL_list2188z00_1645 =
																						MAKE_PAIR(BgL_a1z00_1628,
																						BgL_arg2189z00_1646);
																				}
																				BgL_arg2187z00_1644 =
																					BgL_list2188z00_1645;
																			}
																			VECTOR_SET(BgL_sz00_1624,
																				(int) (BgL_arg2186z00_1643),
																				BgL_arg2187z00_1644);
																		} break;
																	case ((long) -2):

																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2190z00_1647;

																			BgL_arg2190z00_1647 =
																				(BgL_spz00_1636 + ((long) 0));
																			VECTOR_SET(BgL_sz00_1624,
																				(int) (BgL_arg2190z00_1647),
																				BgL_a1z00_1628);
																		}
																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2191z00_1648;
																			obj_t BgL_arg2192z00_1649;

																			BgL_arg2191z00_1648 =
																				(BgL_spz00_1636 + ((long) 1));
																			{	/* Eval/evaluate_comp.scm 856 */
																				obj_t BgL_list2193z00_1650;

																				BgL_list2193z00_1650 =
																					MAKE_PAIR(BgL_a2z00_1629, BNIL);
																				BgL_arg2192z00_1649 =
																					BgL_list2193z00_1650;
																			}
																			VECTOR_SET(BgL_sz00_1624,
																				(int) (BgL_arg2191z00_1648),
																				BgL_arg2192z00_1649);
																		} break;
																	case ((long) -3):

																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2195z00_1651;

																			BgL_arg2195z00_1651 =
																				(BgL_spz00_1636 + ((long) 0));
																			VECTOR_SET(BgL_sz00_1624,
																				(int) (BgL_arg2195z00_1651),
																				BgL_a1z00_1628);
																		}
																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2196z00_1652;

																			BgL_arg2196z00_1652 =
																				(BgL_spz00_1636 + ((long) 1));
																			VECTOR_SET(BgL_sz00_1624,
																				(int) (BgL_arg2196z00_1652),
																				BgL_a2z00_1629);
																		}
																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2197z00_1653;

																			BgL_arg2197z00_1653 =
																				(BgL_spz00_1636 + ((long) 2));
																			VECTOR_SET(BgL_sz00_1624,
																				(int) (BgL_arg2197z00_1653), BNIL);
																		} break;
																	default:
																		BGl_evarityzd2errorzd2zz__everrorz00
																			(BgL_locz00_15767,
																			STRUCT_REF(BgL_ufz00_1631,
																				(int) (((long) 3))), (int) (((long) 2)),
																			CINT(BgL_arityz00_1633));
															}}
														else
															{	/* Eval/evaluate_comp.scm 856 */
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_15767, STRUCT_REF(BgL_ufz00_1631,
																		(int) (((long) 3))), (int) (((long) 2)),
																	CINT(BgL_arityz00_1633));
													}}
												{	/* Eval/evaluate_comp.scm 856 */
													obj_t BgL_auxz00_19616;

													BgL_auxz00_19616 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_19616,
														BgL_locz00_15767);
												}
												{	/* Eval/evaluate_comp.scm 856 */
													bool_t BgL_testz00_19619;

													{	/* Eval/evaluate_comp.scm 665 */
														int BgL_arg1908z00_7492;

														BgL_arg1908z00_7492 = VECTOR_LENGTH(BgL_sz00_1624);
														BgL_testz00_19619 =
															(
															(BgL_spz00_1636 +
																(long) CINT(BgL_sfz00_1635)) <
															(long) (BgL_arg1908z00_7492));
													}
													if (BgL_testz00_19619)
														{	/* Eval/evaluate_comp.scm 856 */
															return
																BGl_catchzd2trampolinezd2zz__evaluate_compz00
																(BgL_runz00_1634, BgL_sz00_1624,
																BINT(BgL_spz00_1636));
														}
													else
														{	/* Eval/evaluate_comp.scm 856 */
															obj_t BgL_nsz00_1659;

															BgL_nsz00_1659 =
																BGl_makezd2statezd2zz__evaluate_compz00();
															{	/* Eval/evaluate_comp.scm 856 */
																long BgL_arg2202z00_1661;

																BgL_arg2202z00_1661 =
																	(BgL_spz00_1636 + ((long) 2));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_nsz00_1659, BINT(((long) 2)),
																	BgL_sz00_1624, BINT(BgL_spz00_1636),
																	BINT(BgL_arg2202z00_1661));
															}
															VECTOR_SET(BgL_nsz00_1659,
																(int) (((long) 1)), BgL_sz00_1624);
															{	/* Eval/evaluate_comp.scm 856 */
																obj_t BgL_auxz00_19635;

																BgL_auxz00_19635 = BGL_CURRENT_DYNAMIC_ENV();
																BGL_ENV_EVSTATE_SET(BgL_auxz00_19635,
																	BgL_nsz00_1659);
															}
															{	/* Eval/evaluate_comp.scm 856 */
																obj_t BgL_val1195z00_1663;

																BgL_val1195z00_1663 =
																	BGl_zc3exitza32209ze3z83zz__evaluate_compz00
																	(BgL_nsz00_1659, BgL_runz00_1634);
																{	/* Eval/evaluate_comp.scm 856 */
																	obj_t BgL_auxz00_19639;

																	BgL_auxz00_19639 = BGL_CURRENT_DYNAMIC_ENV();
																	BGL_ENV_EVSTATE_SET(BgL_auxz00_19639,
																		BgL_sz00_1624);
																}
																if (CBOOL
																	(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
																		(BgL_val1195z00_1663)))
																	{	/* Eval/evaluate_comp.scm 856 */
																		return
																			BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
																			(BgL_val1195z00_1663),
																			CDR(BgL_val1195z00_1663));
																	}
																else
																	{	/* Eval/evaluate_comp.scm 856 */
																		return BgL_val1195z00_1663;
																	}
															}
														}
												}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 856 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_1627,
													(int) (((long) 2))))
												{	/* Eval/evaluate_comp.scm 856 */
													long BgL_nbpz00_1672;

													BgL_nbpz00_1672 =
														((long) CINT(BgL_bpz00_1626) + BgL_siza7eza7_15769);
													VECTOR_SET(BgL_sz00_1624,
														(int) (((long) 0)), BINT(BgL_nbpz00_1672));
													{	/* Eval/evaluate_comp.scm 856 */
														obj_t BgL_rz00_1673;

														BgL_rz00_1673 =
															PROCEDURE_ENTRY(BgL_fz00_1627) (BgL_fz00_1627,
															BgL_a1z00_1628, BgL_a2z00_1629, BEOA);
														VECTOR_SET(BgL_sz00_1624, (int) (((long) 0)),
															BgL_bpz00_1626);
														return BgL_rz00_1673;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 856 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_15767, BgL_symbzd2funzd2_15768,
														(int) (((long) 2)), PROCEDURE_ARITY(BgL_fz00_1627));
		}}}}}}}}}
	}



/* <exit:2209> */
	obj_t BGl_zc3exitza32209ze3z83zz__evaluate_compz00(obj_t BgL_nsz00_17714,
		obj_t BgL_runz00_17713)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1196z00_1669;

			if (SET_EXIT(BgL_an_exit1196z00_1669))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1196z00_1669 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 856 */

						PUSH_EXIT(BgL_an_exit1196z00_1669, ((long) 0));
						{	/* Eval/evaluate_comp.scm 856 */
							obj_t BgL_val1197z00_1670;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_7510;

								BgL_savedzd2bpzd2_7510 =
									VECTOR_REF(BgL_nsz00_17714, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17714,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_7517;

									BgL_fz00_7517 = BgL_runz00_17713;
								BgL_recz00_7516:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_7518;

										BgL_rz00_7518 =
											PROCEDURE_ENTRY(BgL_fz00_7517) (BgL_fz00_7517,
											BgL_nsz00_17714, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_19678;

											if (PROCEDUREP(BgL_rz00_7518))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_7523;

													BgL_arg1900z00_7523 = PROCEDURE_ATTR(BgL_rz00_7518);
													if (STRUCTP(BgL_arg1900z00_7523))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_19678 =
																(STRUCT_KEY(BgL_arg1900z00_7523) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_19678 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_19678 = ((bool_t) 0);
												}
											if (BgL_testz00_19678)
												{
													obj_t BgL_fz00_19686;

													BgL_fz00_19686 = BgL_rz00_7518;
													BgL_fz00_7517 = BgL_fz00_19686;
													goto BgL_recz00_7516;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17714,
														(int) (((long) 0)), BgL_savedzd2bpzd2_7510);
													BgL_val1197z00_1670 = BgL_rz00_7518;
							}}}}}
							POP_EXIT();
							return BgL_val1197z00_1670;
						}
					}
				}
		}
	}



/* comp-call3 */
	obj_t BGl_compzd2call3zd2zz__evaluate_compz00(obj_t BgL_locz00_162,
		BgL_ev_exprz00_bglt BgL_vfunz00_163, obj_t BgL_symbzd2funzd2_164,
		obj_t BgL_funz00_165, obj_t BgL_tailzf3zf3_166, obj_t BgL_stkz00_167,
		long BgL_siza7eza7_168, obj_t BgL_a1z00_169, obj_t BgL_a2z00_170,
		obj_t BgL_a3z00_171)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			{	/* Eval/evaluate_comp.scm 856 */
				obj_t BgL_cfunz00_1675;

				BgL_cfunz00_1675 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_163,
					((long) 3), BgL_locz00_162, BgL_symbzd2funzd2_164);
				if (CBOOL(BgL_cfunz00_1675))
					{	/* Eval/evaluate_comp.scm 856 */
						obj_t BgL_zc3anonymousza32212ze3z83_15771;

						BgL_zc3anonymousza32212ze3z83_15771 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza32212ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 5)));
						PROCEDURE_SET(BgL_zc3anonymousza32212ze3z83_15771,
							(int) (((long) 0)), BgL_a1z00_169);
						PROCEDURE_SET(BgL_zc3anonymousza32212ze3z83_15771,
							(int) (((long) 1)), BgL_a2z00_170);
						PROCEDURE_SET(BgL_zc3anonymousza32212ze3z83_15771,
							(int) (((long) 2)), BgL_a3z00_171);
						PROCEDURE_SET(BgL_zc3anonymousza32212ze3z83_15771,
							(int) (((long) 3)), BINT(BgL_siza7eza7_168));
						PROCEDURE_SET(BgL_zc3anonymousza32212ze3z83_15771,
							(int) (((long) 4)), BgL_cfunz00_1675);
						return BgL_zc3anonymousza32212ze3z83_15771;
					}
				else
					{	/* Eval/evaluate_comp.scm 856 */
						if (CBOOL(BgL_tailzf3zf3_166))
							{	/* Eval/evaluate_comp.scm 856 */
								obj_t BgL_zc3anonymousza32213ze3z83_15772;

								BgL_zc3anonymousza32213ze3z83_15772 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32213ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_zc3anonymousza32213ze3z83_15772,
									(int) (((long) 0)), BgL_funz00_165);
								PROCEDURE_SET(BgL_zc3anonymousza32213ze3z83_15772,
									(int) (((long) 1)), BgL_a1z00_169);
								PROCEDURE_SET(BgL_zc3anonymousza32213ze3z83_15772,
									(int) (((long) 2)), BgL_a2z00_170);
								PROCEDURE_SET(BgL_zc3anonymousza32213ze3z83_15772,
									(int) (((long) 3)), BgL_a3z00_171);
								PROCEDURE_SET(BgL_zc3anonymousza32213ze3z83_15772,
									(int) (((long) 4)), BgL_locz00_162);
								PROCEDURE_SET(BgL_zc3anonymousza32213ze3z83_15772,
									(int) (((long) 5)), BgL_symbzd2funzd2_164);
								PROCEDURE_SET(BgL_zc3anonymousza32213ze3z83_15772,
									(int) (((long) 6)), BINT(BgL_siza7eza7_168));
								return BgL_zc3anonymousza32213ze3z83_15772;
							}
						else
							{	/* Eval/evaluate_comp.scm 856 */
								obj_t BgL_zc3anonymousza32257ze3z83_15773;

								BgL_zc3anonymousza32257ze3z83_15773 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32257ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_zc3anonymousza32257ze3z83_15773,
									(int) (((long) 0)), BgL_funz00_165);
								PROCEDURE_SET(BgL_zc3anonymousza32257ze3z83_15773,
									(int) (((long) 1)), BgL_a1z00_169);
								PROCEDURE_SET(BgL_zc3anonymousza32257ze3z83_15773,
									(int) (((long) 2)), BgL_a2z00_170);
								PROCEDURE_SET(BgL_zc3anonymousza32257ze3z83_15773,
									(int) (((long) 3)), BgL_a3z00_171);
								PROCEDURE_SET(BgL_zc3anonymousza32257ze3z83_15773,
									(int) (((long) 4)), BgL_locz00_162);
								PROCEDURE_SET(BgL_zc3anonymousza32257ze3z83_15773,
									(int) (((long) 5)), BgL_symbzd2funzd2_164);
								PROCEDURE_SET(BgL_zc3anonymousza32257ze3z83_15773,
									(int) (((long) 6)), BINT(BgL_siza7eza7_168));
								return BgL_zc3anonymousza32257ze3z83_15773;
							}
					}
			}
		}
	}



/* &<anonymous:2212> */
	obj_t BGl_z62zc3anonymousza32212ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15774, obj_t BgL_sz00_15780)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			{	/* Eval/evaluate_comp.scm 856 */
				obj_t BgL_a1z00_15775;
				obj_t BgL_a2z00_15776;
				obj_t BgL_a3z00_15777;
				long BgL_siza7eza7_15778;
				obj_t BgL_cfunz00_15779;

				BgL_a1z00_15775 = PROCEDURE_REF(BgL_envz00_15774, (int) (((long) 0)));
				BgL_a2z00_15776 = PROCEDURE_REF(BgL_envz00_15774, (int) (((long) 1)));
				BgL_a3z00_15777 = PROCEDURE_REF(BgL_envz00_15774, (int) (((long) 2)));
				BgL_siza7eza7_15778 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15774, (int) (((long) 3))));
				BgL_cfunz00_15779 = PROCEDURE_REF(BgL_envz00_15774, (int) (((long) 4)));
				{
					obj_t BgL_sz00_1676;

					BgL_sz00_1676 = BgL_sz00_15780;
					{	/* Eval/evaluate_comp.scm 856 */
						obj_t BgL_bpz00_1678;

						BgL_bpz00_1678 = VECTOR_REF(BgL_sz00_1676, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 856 */
							obj_t BgL_a1z00_1679;
							obj_t BgL_a2z00_1680;
							obj_t BgL_a3z00_1681;

							BgL_a1z00_1679 =
								PROCEDURE_ENTRY(BgL_a1z00_15775) (BgL_a1z00_15775,
								BgL_sz00_1676, BEOA);
							BgL_a2z00_1680 =
								PROCEDURE_ENTRY(BgL_a2z00_15776) (BgL_a2z00_15776,
								BgL_sz00_1676, BEOA);
							BgL_a3z00_1681 =
								PROCEDURE_ENTRY(BgL_a3z00_15777) (BgL_a3z00_15777,
								BgL_sz00_1676, BEOA);
							{	/* Eval/evaluate_comp.scm 856 */
								long BgL_nbpz00_1682;

								BgL_nbpz00_1682 =
									((long) CINT(BgL_bpz00_1678) + BgL_siza7eza7_15778);
								VECTOR_SET(BgL_sz00_1676,
									(int) (((long) 0)), BINT(BgL_nbpz00_1682));
								{	/* Eval/evaluate_comp.scm 856 */
									obj_t BgL_rz00_1683;

									BgL_rz00_1683 =
										PROCEDURE_ENTRY(BgL_cfunz00_15779) (BgL_cfunz00_15779,
										BgL_a1z00_1679, BgL_a2z00_1680, BgL_a3z00_1681, BEOA);
									VECTOR_SET(BgL_sz00_1676, (int) (((long) 0)), BgL_bpz00_1678);
									return BgL_rz00_1683;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:2213> */
	obj_t BGl_z62zc3anonymousza32213ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15781, obj_t BgL_sz00_15789)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			{	/* Eval/evaluate_comp.scm 856 */
				obj_t BgL_funz00_15782;
				obj_t BgL_a1z00_15783;
				obj_t BgL_a2z00_15784;
				obj_t BgL_a3z00_15785;
				obj_t BgL_locz00_15786;
				obj_t BgL_symbzd2funzd2_15787;
				long BgL_siza7eza7_15788;

				BgL_funz00_15782 = PROCEDURE_REF(BgL_envz00_15781, (int) (((long) 0)));
				BgL_a1z00_15783 = PROCEDURE_REF(BgL_envz00_15781, (int) (((long) 1)));
				BgL_a2z00_15784 = PROCEDURE_REF(BgL_envz00_15781, (int) (((long) 2)));
				BgL_a3z00_15785 = PROCEDURE_REF(BgL_envz00_15781, (int) (((long) 3)));
				BgL_locz00_15786 = PROCEDURE_REF(BgL_envz00_15781, (int) (((long) 4)));
				BgL_symbzd2funzd2_15787 =
					PROCEDURE_REF(BgL_envz00_15781, (int) (((long) 5)));
				BgL_siza7eza7_15788 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15781, (int) (((long) 6))));
				{
					obj_t BgL_sz00_1684;

					BgL_sz00_1684 = BgL_sz00_15789;
					{	/* Eval/evaluate_comp.scm 856 */
						obj_t BgL_bpz00_1686;

						BgL_bpz00_1686 = VECTOR_REF(BgL_sz00_1684, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 856 */
							obj_t BgL_fz00_1687;
							obj_t BgL_a1z00_1688;
							obj_t BgL_a2z00_1689;
							obj_t BgL_a3z00_1690;

							BgL_fz00_1687 =
								PROCEDURE_ENTRY(BgL_funz00_15782) (BgL_funz00_15782,
								BgL_sz00_1684, BEOA);
							BgL_a1z00_1688 =
								PROCEDURE_ENTRY(BgL_a1z00_15783) (BgL_a1z00_15783,
								BgL_sz00_1684, BEOA);
							BgL_a2z00_1689 =
								PROCEDURE_ENTRY(BgL_a2z00_15784) (BgL_a2z00_15784,
								BgL_sz00_1684, BEOA);
							BgL_a3z00_1690 =
								PROCEDURE_ENTRY(BgL_a3z00_15785) (BgL_a3z00_15785,
								BgL_sz00_1684, BEOA);
							if (PROCEDUREP(BgL_fz00_1687))
								{	/* Eval/evaluate_comp.scm 856 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 856 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_15786,
										BGl_string5561z00zz__evaluate_compz00,
										BGl_string5577z00zz__evaluate_compz00, BgL_fz00_1687);
								}
							{	/* Eval/evaluate_comp.scm 856 */
								obj_t BgL_ufz00_1692;

								BgL_ufz00_1692 = PROCEDURE_ATTR(BgL_fz00_1687);
								{	/* Eval/evaluate_comp.scm 856 */
									bool_t BgL_testz00_19820;

									if (STRUCTP(BgL_ufz00_1692))
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_19820 =
												(STRUCT_KEY(BgL_ufz00_1692) ==
												BGl_symbol5578z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_19820 = ((bool_t) 0);
										}
									if (BgL_testz00_19820)
										{	/* Eval/evaluate_comp.scm 856 */
											obj_t BgL_arityz00_1694;
											obj_t BgL_runz00_1695;
											obj_t BgL_sfz00_1696;

											BgL_arityz00_1694 =
												STRUCT_REF(BgL_ufz00_1692, (int) (((long) 0)));
											BgL_runz00_1695 =
												STRUCT_REF(BgL_ufz00_1692, (int) (((long) 1)));
											BgL_sfz00_1696 =
												STRUCT_REF(BgL_ufz00_1692, (int) (((long) 2)));
											if (((long) CINT(BgL_arityz00_1694) == ((long) 3)))
												{	/* Eval/evaluate_comp.scm 856 */
													{	/* Eval/evaluate_comp.scm 856 */
														long BgL_arg2217z00_1699;

														BgL_arg2217z00_1699 =
															((long) CINT(BgL_bpz00_1686) + ((long) 0));
														VECTOR_SET(BgL_sz00_1684,
															(int) (BgL_arg2217z00_1699), BgL_a1z00_1688);
													}
													{	/* Eval/evaluate_comp.scm 856 */
														long BgL_arg2218z00_1700;

														BgL_arg2218z00_1700 =
															((long) CINT(BgL_bpz00_1686) + ((long) 1));
														VECTOR_SET(BgL_sz00_1684,
															(int) (BgL_arg2218z00_1700), BgL_a2z00_1689);
													}
													{	/* Eval/evaluate_comp.scm 856 */
														long BgL_arg2220z00_1701;

														BgL_arg2220z00_1701 =
															((long) CINT(BgL_bpz00_1686) + ((long) 2));
														VECTOR_SET(BgL_sz00_1684,
															(int) (BgL_arg2220z00_1701), BgL_a3z00_1690);
												}}
											else
												{	/* Eval/evaluate_comp.scm 856 */
													if (INTEGERP(BgL_arityz00_1694))
														{	/* Eval/evaluate_comp.scm 856 */
															switch ((long) CINT(BgL_arityz00_1694))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2222z00_1705;
																		obj_t BgL_arg2223z00_1706;

																		BgL_arg2222z00_1705 =
																			(
																			(long) CINT(BgL_bpz00_1686) + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 856 */
																			obj_t BgL_list2224z00_1707;

																			{	/* Eval/evaluate_comp.scm 856 */
																				obj_t BgL_arg2225z00_1708;

																				{	/* Eval/evaluate_comp.scm 856 */
																					obj_t BgL_arg2226z00_1709;

																					BgL_arg2226z00_1709 =
																						MAKE_PAIR(BgL_a3z00_1690, BNIL);
																					BgL_arg2225z00_1708 =
																						MAKE_PAIR(BgL_a2z00_1689,
																						BgL_arg2226z00_1709);
																				}
																				BgL_list2224z00_1707 =
																					MAKE_PAIR(BgL_a1z00_1688,
																					BgL_arg2225z00_1708);
																			}
																			BgL_arg2223z00_1706 =
																				BgL_list2224z00_1707;
																		}
																		VECTOR_SET(BgL_sz00_1684,
																			(int) (BgL_arg2222z00_1705),
																			BgL_arg2223z00_1706);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2227z00_1710;

																		BgL_arg2227z00_1710 =
																			(
																			(long) CINT(BgL_bpz00_1686) + ((long) 0));
																		VECTOR_SET(BgL_sz00_1684,
																			(int) (BgL_arg2227z00_1710),
																			BgL_a1z00_1688);
																	}
																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2228z00_1711;
																		obj_t BgL_arg2229z00_1712;

																		BgL_arg2228z00_1711 =
																			(
																			(long) CINT(BgL_bpz00_1686) + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 856 */
																			obj_t BgL_list2230z00_1713;

																			{	/* Eval/evaluate_comp.scm 856 */
																				obj_t BgL_arg2231z00_1714;

																				BgL_arg2231z00_1714 =
																					MAKE_PAIR(BgL_a3z00_1690, BNIL);
																				BgL_list2230z00_1713 =
																					MAKE_PAIR(BgL_a2z00_1689,
																					BgL_arg2231z00_1714);
																			}
																			BgL_arg2229z00_1712 =
																				BgL_list2230z00_1713;
																		}
																		VECTOR_SET(BgL_sz00_1684,
																			(int) (BgL_arg2228z00_1711),
																			BgL_arg2229z00_1712);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2232z00_1715;

																		BgL_arg2232z00_1715 =
																			(
																			(long) CINT(BgL_bpz00_1686) + ((long) 0));
																		VECTOR_SET(BgL_sz00_1684,
																			(int) (BgL_arg2232z00_1715),
																			BgL_a1z00_1688);
																	}
																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2233z00_1716;

																		BgL_arg2233z00_1716 =
																			(
																			(long) CINT(BgL_bpz00_1686) + ((long) 1));
																		VECTOR_SET(BgL_sz00_1684,
																			(int) (BgL_arg2233z00_1716),
																			BgL_a2z00_1689);
																	}
																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2235z00_1717;
																		obj_t BgL_arg2236z00_1718;

																		BgL_arg2235z00_1717 =
																			(
																			(long) CINT(BgL_bpz00_1686) + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 856 */
																			obj_t BgL_list2237z00_1719;

																			BgL_list2237z00_1719 =
																				MAKE_PAIR(BgL_a3z00_1690, BNIL);
																			BgL_arg2236z00_1718 =
																				BgL_list2237z00_1719;
																		}
																		VECTOR_SET(BgL_sz00_1684,
																			(int) (BgL_arg2235z00_1717),
																			BgL_arg2236z00_1718);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2238z00_1720;

																		BgL_arg2238z00_1720 =
																			(
																			(long) CINT(BgL_bpz00_1686) + ((long) 0));
																		VECTOR_SET(BgL_sz00_1684,
																			(int) (BgL_arg2238z00_1720),
																			BgL_a1z00_1688);
																	}
																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2241z00_1721;

																		BgL_arg2241z00_1721 =
																			(
																			(long) CINT(BgL_bpz00_1686) + ((long) 1));
																		VECTOR_SET(BgL_sz00_1684,
																			(int) (BgL_arg2241z00_1721),
																			BgL_a2z00_1689);
																	}
																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2242z00_1722;

																		BgL_arg2242z00_1722 =
																			(
																			(long) CINT(BgL_bpz00_1686) + ((long) 2));
																		VECTOR_SET(BgL_sz00_1684,
																			(int) (BgL_arg2242z00_1722),
																			BgL_a3z00_1690);
																	}
																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2243z00_1723;

																		BgL_arg2243z00_1723 =
																			(
																			(long) CINT(BgL_bpz00_1686) + ((long) 3));
																		VECTOR_SET(BgL_sz00_1684,
																			(int) (BgL_arg2243z00_1723), BNIL);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_15786,
																		STRUCT_REF(BgL_ufz00_1692,
																			(int) (((long) 3))), (int) (((long) 3)),
																		CINT(BgL_arityz00_1694));
														}}
													else
														{	/* Eval/evaluate_comp.scm 856 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_15786, STRUCT_REF(BgL_ufz00_1692,
																	(int) (((long) 3))), (int) (((long) 3)),
																CINT(BgL_arityz00_1694));
												}}
											{	/* Eval/evaluate_comp.scm 856 */
												obj_t BgL_auxz00_19906;

												BgL_auxz00_19906 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_19906,
													BgL_locz00_15786);
											}
											{	/* Eval/evaluate_comp.scm 856 */
												bool_t BgL_testz00_19909;

												{	/* Eval/evaluate_comp.scm 665 */
													int BgL_arg1908z00_7688;

													BgL_arg1908z00_7688 = VECTOR_LENGTH(BgL_sz00_1684);
													BgL_testz00_19909 =
														(
														((long) CINT(BgL_bpz00_1686) +
															(long) CINT(BgL_sfz00_1696)) <
														(long) (BgL_arg1908z00_7688));
												}
												if (BgL_testz00_19909)
													{	/* Eval/evaluate_comp.scm 856 */
														return BgL_runz00_1695;
													}
												else
													{	/* Eval/evaluate_comp.scm 856 */
														obj_t BgL_nsz00_1729;

														BgL_nsz00_1729 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 856 */
															long BgL_arg2248z00_1731;

															BgL_arg2248z00_1731 =
																((long) CINT(BgL_bpz00_1686) + ((long) 3));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_1729, BINT(((long) 2)),
																BgL_sz00_1684, BgL_bpz00_1686,
																BINT(BgL_arg2248z00_1731));
														}
														VECTOR_SET(BgL_nsz00_1729,
															(int) (((long) 1)), BgL_sz00_1684);
														{	/* Eval/evaluate_comp.scm 856 */
															obj_t BgL_auxz00_19924;

															BgL_auxz00_19924 = BGL_CURRENT_DYNAMIC_ENV();
															BGL_ENV_EVSTATE_SET(BgL_auxz00_19924,
																BgL_nsz00_1729);
														}
														{	/* Eval/evaluate_comp.scm 856 */
															obj_t BgL_val1200z00_1733;

															BgL_val1200z00_1733 =
																BGl_zc3exitza32254ze3z83zz__evaluate_compz00
																(BgL_nsz00_1729, BgL_runz00_1695);
															{	/* Eval/evaluate_comp.scm 856 */
																obj_t BgL_auxz00_19928;

																BgL_auxz00_19928 = BGL_CURRENT_DYNAMIC_ENV();
																BGL_ENV_EVSTATE_SET(BgL_auxz00_19928,
																	BgL_sz00_1684);
															}
															if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
																	(BgL_val1200z00_1733)))
																{	/* Eval/evaluate_comp.scm 856 */
																	return
																		BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
																		(BgL_val1200z00_1733),
																		CDR(BgL_val1200z00_1733));
																}
															else
																{	/* Eval/evaluate_comp.scm 856 */
																	return BgL_val1200z00_1733;
																}
														}
													}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 856 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_1687,
													(int) (((long) 3))))
												{	/* Eval/evaluate_comp.scm 856 */
													long BgL_nbpz00_1742;

													BgL_nbpz00_1742 =
														((long) CINT(BgL_bpz00_1686) + BgL_siza7eza7_15788);
													VECTOR_SET(BgL_sz00_1684,
														(int) (((long) 0)), BINT(BgL_nbpz00_1742));
													{	/* Eval/evaluate_comp.scm 856 */
														obj_t BgL_rz00_1743;

														BgL_rz00_1743 =
															PROCEDURE_ENTRY(BgL_fz00_1687) (BgL_fz00_1687,
															BgL_a1z00_1688, BgL_a2z00_1689, BgL_a3z00_1690,
															BEOA);
														VECTOR_SET(BgL_sz00_1684, (int) (((long) 0)),
															BgL_bpz00_1686);
														return BgL_rz00_1743;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 856 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_15786, BgL_symbzd2funzd2_15787,
														(int) (((long) 3)), PROCEDURE_ARITY(BgL_fz00_1687));
		}}}}}}}}}
	}



/* <exit:2254> */
	obj_t BGl_zc3exitza32254ze3z83zz__evaluate_compz00(obj_t BgL_nsz00_17712,
		obj_t BgL_runz00_17711)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1201z00_1739;

			if (SET_EXIT(BgL_an_exit1201z00_1739))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1201z00_1739 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 856 */

						PUSH_EXIT(BgL_an_exit1201z00_1739, ((long) 0));
						{	/* Eval/evaluate_comp.scm 856 */
							obj_t BgL_val1202z00_1740;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_7707;

								BgL_savedzd2bpzd2_7707 =
									VECTOR_REF(BgL_nsz00_17712, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17712,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_7714;

									BgL_fz00_7714 = BgL_runz00_17711;
								BgL_recz00_7713:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_7715;

										BgL_rz00_7715 =
											PROCEDURE_ENTRY(BgL_fz00_7714) (BgL_fz00_7714,
											BgL_nsz00_17712, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_19968;

											if (PROCEDUREP(BgL_rz00_7715))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_7720;

													BgL_arg1900z00_7720 = PROCEDURE_ATTR(BgL_rz00_7715);
													if (STRUCTP(BgL_arg1900z00_7720))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_19968 =
																(STRUCT_KEY(BgL_arg1900z00_7720) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_19968 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_19968 = ((bool_t) 0);
												}
											if (BgL_testz00_19968)
												{
													obj_t BgL_fz00_19976;

													BgL_fz00_19976 = BgL_rz00_7715;
													BgL_fz00_7714 = BgL_fz00_19976;
													goto BgL_recz00_7713;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17712,
														(int) (((long) 0)), BgL_savedzd2bpzd2_7707);
													BgL_val1202z00_1740 = BgL_rz00_7715;
							}}}}}
							POP_EXIT();
							return BgL_val1202z00_1740;
						}
					}
				}
		}
	}



/* &<anonymous:2257> */
	obj_t BGl_z62zc3anonymousza32257ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15790, obj_t BgL_sz00_15798)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			{	/* Eval/evaluate_comp.scm 856 */
				obj_t BgL_funz00_15791;
				obj_t BgL_a1z00_15792;
				obj_t BgL_a2z00_15793;
				obj_t BgL_a3z00_15794;
				obj_t BgL_locz00_15795;
				obj_t BgL_symbzd2funzd2_15796;
				long BgL_siza7eza7_15797;

				BgL_funz00_15791 = PROCEDURE_REF(BgL_envz00_15790, (int) (((long) 0)));
				BgL_a1z00_15792 = PROCEDURE_REF(BgL_envz00_15790, (int) (((long) 1)));
				BgL_a2z00_15793 = PROCEDURE_REF(BgL_envz00_15790, (int) (((long) 2)));
				BgL_a3z00_15794 = PROCEDURE_REF(BgL_envz00_15790, (int) (((long) 3)));
				BgL_locz00_15795 = PROCEDURE_REF(BgL_envz00_15790, (int) (((long) 4)));
				BgL_symbzd2funzd2_15796 =
					PROCEDURE_REF(BgL_envz00_15790, (int) (((long) 5)));
				BgL_siza7eza7_15797 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15790, (int) (((long) 6))));
				{
					obj_t BgL_sz00_1745;

					BgL_sz00_1745 = BgL_sz00_15798;
					{	/* Eval/evaluate_comp.scm 856 */
						obj_t BgL_bpz00_1747;

						BgL_bpz00_1747 = VECTOR_REF(BgL_sz00_1745, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 856 */
							obj_t BgL_fz00_1748;
							obj_t BgL_a1z00_1749;
							obj_t BgL_a2z00_1750;
							obj_t BgL_a3z00_1751;

							BgL_fz00_1748 =
								PROCEDURE_ENTRY(BgL_funz00_15791) (BgL_funz00_15791,
								BgL_sz00_1745, BEOA);
							BgL_a1z00_1749 =
								PROCEDURE_ENTRY(BgL_a1z00_15792) (BgL_a1z00_15792,
								BgL_sz00_1745, BEOA);
							BgL_a2z00_1750 =
								PROCEDURE_ENTRY(BgL_a2z00_15793) (BgL_a2z00_15793,
								BgL_sz00_1745, BEOA);
							BgL_a3z00_1751 =
								PROCEDURE_ENTRY(BgL_a3z00_15794) (BgL_a3z00_15794,
								BgL_sz00_1745, BEOA);
							if (PROCEDUREP(BgL_fz00_1748))
								{	/* Eval/evaluate_comp.scm 856 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 856 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_15795,
										BGl_string5561z00zz__evaluate_compz00,
										BGl_string5577z00zz__evaluate_compz00, BgL_fz00_1748);
								}
							{	/* Eval/evaluate_comp.scm 856 */
								obj_t BgL_ufz00_1753;

								BgL_ufz00_1753 = PROCEDURE_ATTR(BgL_fz00_1748);
								{	/* Eval/evaluate_comp.scm 856 */
									bool_t BgL_testz00_20017;

									if (STRUCTP(BgL_ufz00_1753))
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_20017 =
												(STRUCT_KEY(BgL_ufz00_1753) ==
												BGl_symbol5578z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_20017 = ((bool_t) 0);
										}
									if (BgL_testz00_20017)
										{	/* Eval/evaluate_comp.scm 856 */
											obj_t BgL_arityz00_1755;
											obj_t BgL_runz00_1756;
											obj_t BgL_sfz00_1757;

											BgL_arityz00_1755 =
												STRUCT_REF(BgL_ufz00_1753, (int) (((long) 0)));
											BgL_runz00_1756 =
												STRUCT_REF(BgL_ufz00_1753, (int) (((long) 1)));
											BgL_sfz00_1757 =
												STRUCT_REF(BgL_ufz00_1753, (int) (((long) 2)));
											{	/* Eval/evaluate_comp.scm 856 */
												long BgL_spz00_1758;

												BgL_spz00_1758 =
													((long) CINT(BgL_bpz00_1747) + BgL_siza7eza7_15797);
												if (((long) CINT(BgL_arityz00_1755) == ((long) 3)))
													{	/* Eval/evaluate_comp.scm 856 */
														{	/* Eval/evaluate_comp.scm 856 */
															long BgL_arg2261z00_1760;

															BgL_arg2261z00_1760 =
																(BgL_spz00_1758 + ((long) 0));
															VECTOR_SET(BgL_sz00_1745,
																(int) (BgL_arg2261z00_1760), BgL_a1z00_1749);
														}
														{	/* Eval/evaluate_comp.scm 856 */
															long BgL_arg2262z00_1761;

															BgL_arg2262z00_1761 =
																(BgL_spz00_1758 + ((long) 1));
															VECTOR_SET(BgL_sz00_1745,
																(int) (BgL_arg2262z00_1761), BgL_a2z00_1750);
														}
														{	/* Eval/evaluate_comp.scm 856 */
															long BgL_arg2263z00_1762;

															BgL_arg2263z00_1762 =
																(BgL_spz00_1758 + ((long) 2));
															VECTOR_SET(BgL_sz00_1745,
																(int) (BgL_arg2263z00_1762), BgL_a3z00_1751);
													}}
												else
													{	/* Eval/evaluate_comp.scm 856 */
														if (INTEGERP(BgL_arityz00_1755))
															{	/* Eval/evaluate_comp.scm 856 */
																switch ((long) CINT(BgL_arityz00_1755))
																	{
																	case ((long) -1):

																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2265z00_1766;
																			obj_t BgL_arg2266z00_1767;

																			BgL_arg2265z00_1766 =
																				(BgL_spz00_1758 + ((long) 0));
																			{	/* Eval/evaluate_comp.scm 856 */
																				obj_t BgL_list2267z00_1768;

																				{	/* Eval/evaluate_comp.scm 856 */
																					obj_t BgL_arg2268z00_1769;

																					{	/* Eval/evaluate_comp.scm 856 */
																						obj_t BgL_arg2269z00_1770;

																						BgL_arg2269z00_1770 =
																							MAKE_PAIR(BgL_a3z00_1751, BNIL);
																						BgL_arg2268z00_1769 =
																							MAKE_PAIR(BgL_a2z00_1750,
																							BgL_arg2269z00_1770);
																					}
																					BgL_list2267z00_1768 =
																						MAKE_PAIR(BgL_a1z00_1749,
																						BgL_arg2268z00_1769);
																				}
																				BgL_arg2266z00_1767 =
																					BgL_list2267z00_1768;
																			}
																			VECTOR_SET(BgL_sz00_1745,
																				(int) (BgL_arg2265z00_1766),
																				BgL_arg2266z00_1767);
																		} break;
																	case ((long) -2):

																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2270z00_1771;

																			BgL_arg2270z00_1771 =
																				(BgL_spz00_1758 + ((long) 0));
																			VECTOR_SET(BgL_sz00_1745,
																				(int) (BgL_arg2270z00_1771),
																				BgL_a1z00_1749);
																		}
																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2271z00_1772;
																			obj_t BgL_arg2272z00_1773;

																			BgL_arg2271z00_1772 =
																				(BgL_spz00_1758 + ((long) 1));
																			{	/* Eval/evaluate_comp.scm 856 */
																				obj_t BgL_list2273z00_1774;

																				{	/* Eval/evaluate_comp.scm 856 */
																					obj_t BgL_arg2274z00_1775;

																					BgL_arg2274z00_1775 =
																						MAKE_PAIR(BgL_a3z00_1751, BNIL);
																					BgL_list2273z00_1774 =
																						MAKE_PAIR(BgL_a2z00_1750,
																						BgL_arg2274z00_1775);
																				}
																				BgL_arg2272z00_1773 =
																					BgL_list2273z00_1774;
																			}
																			VECTOR_SET(BgL_sz00_1745,
																				(int) (BgL_arg2271z00_1772),
																				BgL_arg2272z00_1773);
																		} break;
																	case ((long) -3):

																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2275z00_1776;

																			BgL_arg2275z00_1776 =
																				(BgL_spz00_1758 + ((long) 0));
																			VECTOR_SET(BgL_sz00_1745,
																				(int) (BgL_arg2275z00_1776),
																				BgL_a1z00_1749);
																		}
																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2276z00_1777;

																			BgL_arg2276z00_1777 =
																				(BgL_spz00_1758 + ((long) 1));
																			VECTOR_SET(BgL_sz00_1745,
																				(int) (BgL_arg2276z00_1777),
																				BgL_a2z00_1750);
																		}
																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2277z00_1778;
																			obj_t BgL_arg2278z00_1779;

																			BgL_arg2277z00_1778 =
																				(BgL_spz00_1758 + ((long) 2));
																			{	/* Eval/evaluate_comp.scm 856 */
																				obj_t BgL_list2279z00_1780;

																				BgL_list2279z00_1780 =
																					MAKE_PAIR(BgL_a3z00_1751, BNIL);
																				BgL_arg2278z00_1779 =
																					BgL_list2279z00_1780;
																			}
																			VECTOR_SET(BgL_sz00_1745,
																				(int) (BgL_arg2277z00_1778),
																				BgL_arg2278z00_1779);
																		} break;
																	case ((long) -4):

																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2280z00_1781;

																			BgL_arg2280z00_1781 =
																				(BgL_spz00_1758 + ((long) 0));
																			VECTOR_SET(BgL_sz00_1745,
																				(int) (BgL_arg2280z00_1781),
																				BgL_a1z00_1749);
																		}
																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2281z00_1782;

																			BgL_arg2281z00_1782 =
																				(BgL_spz00_1758 + ((long) 1));
																			VECTOR_SET(BgL_sz00_1745,
																				(int) (BgL_arg2281z00_1782),
																				BgL_a2z00_1750);
																		}
																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2282z00_1783;

																			BgL_arg2282z00_1783 =
																				(BgL_spz00_1758 + ((long) 2));
																			VECTOR_SET(BgL_sz00_1745,
																				(int) (BgL_arg2282z00_1783),
																				BgL_a3z00_1751);
																		}
																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2283z00_1784;

																			BgL_arg2283z00_1784 =
																				(BgL_spz00_1758 + ((long) 3));
																			VECTOR_SET(BgL_sz00_1745,
																				(int) (BgL_arg2283z00_1784), BNIL);
																		} break;
																	default:
																		BGl_evarityzd2errorzd2zz__everrorz00
																			(BgL_locz00_15795,
																			STRUCT_REF(BgL_ufz00_1753,
																				(int) (((long) 3))), (int) (((long) 3)),
																			CINT(BgL_arityz00_1755));
															}}
														else
															{	/* Eval/evaluate_comp.scm 856 */
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_15795, STRUCT_REF(BgL_ufz00_1753,
																		(int) (((long) 3))), (int) (((long) 3)),
																	CINT(BgL_arityz00_1755));
													}}
												{	/* Eval/evaluate_comp.scm 856 */
													obj_t BgL_auxz00_20092;

													BgL_auxz00_20092 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_20092,
														BgL_locz00_15795);
												}
												{	/* Eval/evaluate_comp.scm 856 */
													bool_t BgL_testz00_20095;

													{	/* Eval/evaluate_comp.scm 665 */
														int BgL_arg1908z00_7874;

														BgL_arg1908z00_7874 = VECTOR_LENGTH(BgL_sz00_1745);
														BgL_testz00_20095 =
															(
															(BgL_spz00_1758 +
																(long) CINT(BgL_sfz00_1757)) <
															(long) (BgL_arg1908z00_7874));
													}
													if (BgL_testz00_20095)
														{	/* Eval/evaluate_comp.scm 856 */
															return
																BGl_catchzd2trampolinezd2zz__evaluate_compz00
																(BgL_runz00_1756, BgL_sz00_1745,
																BINT(BgL_spz00_1758));
														}
													else
														{	/* Eval/evaluate_comp.scm 856 */
															obj_t BgL_nsz00_1790;

															BgL_nsz00_1790 =
																BGl_makezd2statezd2zz__evaluate_compz00();
															{	/* Eval/evaluate_comp.scm 856 */
																long BgL_arg2288z00_1792;

																BgL_arg2288z00_1792 =
																	(BgL_spz00_1758 + ((long) 3));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_nsz00_1790, BINT(((long) 2)),
																	BgL_sz00_1745, BINT(BgL_spz00_1758),
																	BINT(BgL_arg2288z00_1792));
															}
															VECTOR_SET(BgL_nsz00_1790,
																(int) (((long) 1)), BgL_sz00_1745);
															{	/* Eval/evaluate_comp.scm 856 */
																obj_t BgL_auxz00_20111;

																BgL_auxz00_20111 = BGL_CURRENT_DYNAMIC_ENV();
																BGL_ENV_EVSTATE_SET(BgL_auxz00_20111,
																	BgL_nsz00_1790);
															}
															{	/* Eval/evaluate_comp.scm 856 */
																obj_t BgL_val1205z00_1794;

																BgL_val1205z00_1794 =
																	BGl_zc3exitza32294ze3z83zz__evaluate_compz00
																	(BgL_nsz00_1790, BgL_runz00_1756);
																{	/* Eval/evaluate_comp.scm 856 */
																	obj_t BgL_auxz00_20115;

																	BgL_auxz00_20115 = BGL_CURRENT_DYNAMIC_ENV();
																	BGL_ENV_EVSTATE_SET(BgL_auxz00_20115,
																		BgL_sz00_1745);
																}
																if (CBOOL
																	(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
																		(BgL_val1205z00_1794)))
																	{	/* Eval/evaluate_comp.scm 856 */
																		return
																			BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
																			(BgL_val1205z00_1794),
																			CDR(BgL_val1205z00_1794));
																	}
																else
																	{	/* Eval/evaluate_comp.scm 856 */
																		return BgL_val1205z00_1794;
																	}
															}
														}
												}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 856 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_1748,
													(int) (((long) 3))))
												{	/* Eval/evaluate_comp.scm 856 */
													long BgL_nbpz00_1803;

													BgL_nbpz00_1803 =
														((long) CINT(BgL_bpz00_1747) + BgL_siza7eza7_15797);
													VECTOR_SET(BgL_sz00_1745,
														(int) (((long) 0)), BINT(BgL_nbpz00_1803));
													{	/* Eval/evaluate_comp.scm 856 */
														obj_t BgL_rz00_1804;

														BgL_rz00_1804 =
															PROCEDURE_ENTRY(BgL_fz00_1748) (BgL_fz00_1748,
															BgL_a1z00_1749, BgL_a2z00_1750, BgL_a3z00_1751,
															BEOA);
														VECTOR_SET(BgL_sz00_1745, (int) (((long) 0)),
															BgL_bpz00_1747);
														return BgL_rz00_1804;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 856 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_15795, BgL_symbzd2funzd2_15796,
														(int) (((long) 3)), PROCEDURE_ARITY(BgL_fz00_1748));
		}}}}}}}}}
	}



/* <exit:2294> */
	obj_t BGl_zc3exitza32294ze3z83zz__evaluate_compz00(obj_t BgL_nsz00_17710,
		obj_t BgL_runz00_17709)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1206z00_1800;

			if (SET_EXIT(BgL_an_exit1206z00_1800))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1206z00_1800 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 856 */

						PUSH_EXIT(BgL_an_exit1206z00_1800, ((long) 0));
						{	/* Eval/evaluate_comp.scm 856 */
							obj_t BgL_val1207z00_1801;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_7892;

								BgL_savedzd2bpzd2_7892 =
									VECTOR_REF(BgL_nsz00_17710, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17710,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_7899;

									BgL_fz00_7899 = BgL_runz00_17709;
								BgL_recz00_7898:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_7900;

										BgL_rz00_7900 =
											PROCEDURE_ENTRY(BgL_fz00_7899) (BgL_fz00_7899,
											BgL_nsz00_17710, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_20155;

											if (PROCEDUREP(BgL_rz00_7900))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_7905;

													BgL_arg1900z00_7905 = PROCEDURE_ATTR(BgL_rz00_7900);
													if (STRUCTP(BgL_arg1900z00_7905))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_20155 =
																(STRUCT_KEY(BgL_arg1900z00_7905) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_20155 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_20155 = ((bool_t) 0);
												}
											if (BgL_testz00_20155)
												{
													obj_t BgL_fz00_20163;

													BgL_fz00_20163 = BgL_rz00_7900;
													BgL_fz00_7899 = BgL_fz00_20163;
													goto BgL_recz00_7898;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17710,
														(int) (((long) 0)), BgL_savedzd2bpzd2_7892);
													BgL_val1207z00_1801 = BgL_rz00_7900;
							}}}}}
							POP_EXIT();
							return BgL_val1207z00_1801;
						}
					}
				}
		}
	}



/* comp-call4 */
	obj_t BGl_compzd2call4zd2zz__evaluate_compz00(obj_t BgL_locz00_172,
		BgL_ev_exprz00_bglt BgL_vfunz00_173, obj_t BgL_symbzd2funzd2_174,
		obj_t BgL_funz00_175, obj_t BgL_tailzf3zf3_176, obj_t BgL_stkz00_177,
		long BgL_siza7eza7_178, obj_t BgL_a1z00_179, obj_t BgL_a2z00_180,
		obj_t BgL_a3z00_181, obj_t BgL_a4z00_182)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			{	/* Eval/evaluate_comp.scm 856 */
				obj_t BgL_cfunz00_1806;

				BgL_cfunz00_1806 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_173,
					((long) 4), BgL_locz00_172, BgL_symbzd2funzd2_174);
				if (CBOOL(BgL_cfunz00_1806))
					{	/* Eval/evaluate_comp.scm 856 */
						obj_t BgL_zc3anonymousza32297ze3z83_15799;

						BgL_zc3anonymousza32297ze3z83_15799 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza32297ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 6)));
						PROCEDURE_SET(BgL_zc3anonymousza32297ze3z83_15799,
							(int) (((long) 0)), BgL_a1z00_179);
						PROCEDURE_SET(BgL_zc3anonymousza32297ze3z83_15799,
							(int) (((long) 1)), BgL_a2z00_180);
						PROCEDURE_SET(BgL_zc3anonymousza32297ze3z83_15799,
							(int) (((long) 2)), BgL_a3z00_181);
						PROCEDURE_SET(BgL_zc3anonymousza32297ze3z83_15799,
							(int) (((long) 3)), BgL_a4z00_182);
						PROCEDURE_SET(BgL_zc3anonymousza32297ze3z83_15799,
							(int) (((long) 4)), BINT(BgL_siza7eza7_178));
						PROCEDURE_SET(BgL_zc3anonymousza32297ze3z83_15799,
							(int) (((long) 5)), BgL_cfunz00_1806);
						return BgL_zc3anonymousza32297ze3z83_15799;
					}
				else
					{	/* Eval/evaluate_comp.scm 856 */
						if (CBOOL(BgL_tailzf3zf3_176))
							{	/* Eval/evaluate_comp.scm 856 */
								obj_t BgL_zc3anonymousza32298ze3z83_15800;

								BgL_zc3anonymousza32298ze3z83_15800 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32298ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 8)));
								PROCEDURE_SET(BgL_zc3anonymousza32298ze3z83_15800,
									(int) (((long) 0)), BgL_funz00_175);
								PROCEDURE_SET(BgL_zc3anonymousza32298ze3z83_15800,
									(int) (((long) 1)), BgL_a1z00_179);
								PROCEDURE_SET(BgL_zc3anonymousza32298ze3z83_15800,
									(int) (((long) 2)), BgL_a2z00_180);
								PROCEDURE_SET(BgL_zc3anonymousza32298ze3z83_15800,
									(int) (((long) 3)), BgL_a3z00_181);
								PROCEDURE_SET(BgL_zc3anonymousza32298ze3z83_15800,
									(int) (((long) 4)), BgL_a4z00_182);
								PROCEDURE_SET(BgL_zc3anonymousza32298ze3z83_15800,
									(int) (((long) 5)), BgL_locz00_172);
								PROCEDURE_SET(BgL_zc3anonymousza32298ze3z83_15800,
									(int) (((long) 6)), BgL_symbzd2funzd2_174);
								PROCEDURE_SET(BgL_zc3anonymousza32298ze3z83_15800,
									(int) (((long) 7)), BINT(BgL_siza7eza7_178));
								return BgL_zc3anonymousza32298ze3z83_15800;
							}
						else
							{	/* Eval/evaluate_comp.scm 856 */
								obj_t BgL_zc3anonymousza32351ze3z83_15801;

								BgL_zc3anonymousza32351ze3z83_15801 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32351ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 8)));
								PROCEDURE_SET(BgL_zc3anonymousza32351ze3z83_15801,
									(int) (((long) 0)), BgL_funz00_175);
								PROCEDURE_SET(BgL_zc3anonymousza32351ze3z83_15801,
									(int) (((long) 1)), BgL_a1z00_179);
								PROCEDURE_SET(BgL_zc3anonymousza32351ze3z83_15801,
									(int) (((long) 2)), BgL_a2z00_180);
								PROCEDURE_SET(BgL_zc3anonymousza32351ze3z83_15801,
									(int) (((long) 3)), BgL_a3z00_181);
								PROCEDURE_SET(BgL_zc3anonymousza32351ze3z83_15801,
									(int) (((long) 4)), BgL_a4z00_182);
								PROCEDURE_SET(BgL_zc3anonymousza32351ze3z83_15801,
									(int) (((long) 5)), BgL_locz00_172);
								PROCEDURE_SET(BgL_zc3anonymousza32351ze3z83_15801,
									(int) (((long) 6)), BgL_symbzd2funzd2_174);
								PROCEDURE_SET(BgL_zc3anonymousza32351ze3z83_15801,
									(int) (((long) 7)), BINT(BgL_siza7eza7_178));
								return BgL_zc3anonymousza32351ze3z83_15801;
							}
					}
			}
		}
	}



/* &<anonymous:2297> */
	obj_t BGl_z62zc3anonymousza32297ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15802, obj_t BgL_sz00_15809)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			{	/* Eval/evaluate_comp.scm 856 */
				obj_t BgL_a1z00_15803;
				obj_t BgL_a2z00_15804;
				obj_t BgL_a3z00_15805;
				obj_t BgL_a4z00_15806;
				long BgL_siza7eza7_15807;
				obj_t BgL_cfunz00_15808;

				BgL_a1z00_15803 = PROCEDURE_REF(BgL_envz00_15802, (int) (((long) 0)));
				BgL_a2z00_15804 = PROCEDURE_REF(BgL_envz00_15802, (int) (((long) 1)));
				BgL_a3z00_15805 = PROCEDURE_REF(BgL_envz00_15802, (int) (((long) 2)));
				BgL_a4z00_15806 = PROCEDURE_REF(BgL_envz00_15802, (int) (((long) 3)));
				BgL_siza7eza7_15807 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15802, (int) (((long) 4))));
				BgL_cfunz00_15808 = PROCEDURE_REF(BgL_envz00_15802, (int) (((long) 5)));
				{
					obj_t BgL_sz00_1807;

					BgL_sz00_1807 = BgL_sz00_15809;
					{	/* Eval/evaluate_comp.scm 856 */
						obj_t BgL_bpz00_1809;

						BgL_bpz00_1809 = VECTOR_REF(BgL_sz00_1807, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 856 */
							obj_t BgL_a1z00_1810;
							obj_t BgL_a2z00_1811;
							obj_t BgL_a3z00_1812;
							obj_t BgL_a4z00_1813;

							BgL_a1z00_1810 =
								PROCEDURE_ENTRY(BgL_a1z00_15803) (BgL_a1z00_15803,
								BgL_sz00_1807, BEOA);
							BgL_a2z00_1811 =
								PROCEDURE_ENTRY(BgL_a2z00_15804) (BgL_a2z00_15804,
								BgL_sz00_1807, BEOA);
							BgL_a3z00_1812 =
								PROCEDURE_ENTRY(BgL_a3z00_15805) (BgL_a3z00_15805,
								BgL_sz00_1807, BEOA);
							BgL_a4z00_1813 =
								PROCEDURE_ENTRY(BgL_a4z00_15806) (BgL_a4z00_15806,
								BgL_sz00_1807, BEOA);
							{	/* Eval/evaluate_comp.scm 856 */
								long BgL_nbpz00_1814;

								BgL_nbpz00_1814 =
									((long) CINT(BgL_bpz00_1809) + BgL_siza7eza7_15807);
								VECTOR_SET(BgL_sz00_1807,
									(int) (((long) 0)), BINT(BgL_nbpz00_1814));
								{	/* Eval/evaluate_comp.scm 856 */
									obj_t BgL_rz00_1815;

									BgL_rz00_1815 =
										PROCEDURE_ENTRY(BgL_cfunz00_15808) (BgL_cfunz00_15808,
										BgL_a1z00_1810, BgL_a2z00_1811, BgL_a3z00_1812,
										BgL_a4z00_1813, BEOA);
									VECTOR_SET(BgL_sz00_1807, (int) (((long) 0)), BgL_bpz00_1809);
									return BgL_rz00_1815;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:2298> */
	obj_t BGl_z62zc3anonymousza32298ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15810, obj_t BgL_sz00_15819)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			{	/* Eval/evaluate_comp.scm 856 */
				obj_t BgL_funz00_15811;
				obj_t BgL_a1z00_15812;
				obj_t BgL_a2z00_15813;
				obj_t BgL_a3z00_15814;
				obj_t BgL_a4z00_15815;
				obj_t BgL_locz00_15816;
				obj_t BgL_symbzd2funzd2_15817;
				long BgL_siza7eza7_15818;

				BgL_funz00_15811 = PROCEDURE_REF(BgL_envz00_15810, (int) (((long) 0)));
				BgL_a1z00_15812 = PROCEDURE_REF(BgL_envz00_15810, (int) (((long) 1)));
				BgL_a2z00_15813 = PROCEDURE_REF(BgL_envz00_15810, (int) (((long) 2)));
				BgL_a3z00_15814 = PROCEDURE_REF(BgL_envz00_15810, (int) (((long) 3)));
				BgL_a4z00_15815 = PROCEDURE_REF(BgL_envz00_15810, (int) (((long) 4)));
				BgL_locz00_15816 = PROCEDURE_REF(BgL_envz00_15810, (int) (((long) 5)));
				BgL_symbzd2funzd2_15817 =
					PROCEDURE_REF(BgL_envz00_15810, (int) (((long) 6)));
				BgL_siza7eza7_15818 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15810, (int) (((long) 7))));
				{
					obj_t BgL_sz00_1816;

					BgL_sz00_1816 = BgL_sz00_15819;
					{	/* Eval/evaluate_comp.scm 856 */
						obj_t BgL_bpz00_1818;

						BgL_bpz00_1818 = VECTOR_REF(BgL_sz00_1816, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 856 */
							obj_t BgL_fz00_1819;
							obj_t BgL_a1z00_1820;
							obj_t BgL_a2z00_1821;
							obj_t BgL_a3z00_1822;
							obj_t BgL_a4z00_1823;

							BgL_fz00_1819 =
								PROCEDURE_ENTRY(BgL_funz00_15811) (BgL_funz00_15811,
								BgL_sz00_1816, BEOA);
							BgL_a1z00_1820 =
								PROCEDURE_ENTRY(BgL_a1z00_15812) (BgL_a1z00_15812,
								BgL_sz00_1816, BEOA);
							BgL_a2z00_1821 =
								PROCEDURE_ENTRY(BgL_a2z00_15813) (BgL_a2z00_15813,
								BgL_sz00_1816, BEOA);
							BgL_a3z00_1822 =
								PROCEDURE_ENTRY(BgL_a3z00_15814) (BgL_a3z00_15814,
								BgL_sz00_1816, BEOA);
							BgL_a4z00_1823 =
								PROCEDURE_ENTRY(BgL_a4z00_15815) (BgL_a4z00_15815,
								BgL_sz00_1816, BEOA);
							if (PROCEDUREP(BgL_fz00_1819))
								{	/* Eval/evaluate_comp.scm 856 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 856 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_15816,
										BGl_string5561z00zz__evaluate_compz00,
										BGl_string5577z00zz__evaluate_compz00, BgL_fz00_1819);
								}
							{	/* Eval/evaluate_comp.scm 856 */
								obj_t BgL_ufz00_1825;

								BgL_ufz00_1825 = PROCEDURE_ATTR(BgL_fz00_1819);
								{	/* Eval/evaluate_comp.scm 856 */
									bool_t BgL_testz00_20316;

									if (STRUCTP(BgL_ufz00_1825))
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_20316 =
												(STRUCT_KEY(BgL_ufz00_1825) ==
												BGl_symbol5578z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_20316 = ((bool_t) 0);
										}
									if (BgL_testz00_20316)
										{	/* Eval/evaluate_comp.scm 856 */
											obj_t BgL_arityz00_1827;
											obj_t BgL_runz00_1828;
											obj_t BgL_sfz00_1829;

											BgL_arityz00_1827 =
												STRUCT_REF(BgL_ufz00_1825, (int) (((long) 0)));
											BgL_runz00_1828 =
												STRUCT_REF(BgL_ufz00_1825, (int) (((long) 1)));
											BgL_sfz00_1829 =
												STRUCT_REF(BgL_ufz00_1825, (int) (((long) 2)));
											if (((long) CINT(BgL_arityz00_1827) == ((long) 4)))
												{	/* Eval/evaluate_comp.scm 856 */
													{	/* Eval/evaluate_comp.scm 856 */
														long BgL_arg2302z00_1832;

														BgL_arg2302z00_1832 =
															((long) CINT(BgL_bpz00_1818) + ((long) 0));
														VECTOR_SET(BgL_sz00_1816,
															(int) (BgL_arg2302z00_1832), BgL_a1z00_1820);
													}
													{	/* Eval/evaluate_comp.scm 856 */
														long BgL_arg2303z00_1833;

														BgL_arg2303z00_1833 =
															((long) CINT(BgL_bpz00_1818) + ((long) 1));
														VECTOR_SET(BgL_sz00_1816,
															(int) (BgL_arg2303z00_1833), BgL_a2z00_1821);
													}
													{	/* Eval/evaluate_comp.scm 856 */
														long BgL_arg2304z00_1834;

														BgL_arg2304z00_1834 =
															((long) CINT(BgL_bpz00_1818) + ((long) 2));
														VECTOR_SET(BgL_sz00_1816,
															(int) (BgL_arg2304z00_1834), BgL_a3z00_1822);
													}
													{	/* Eval/evaluate_comp.scm 856 */
														long BgL_arg2305z00_1835;

														BgL_arg2305z00_1835 =
															((long) CINT(BgL_bpz00_1818) + ((long) 3));
														VECTOR_SET(BgL_sz00_1816,
															(int) (BgL_arg2305z00_1835), BgL_a4z00_1823);
												}}
											else
												{	/* Eval/evaluate_comp.scm 856 */
													if (INTEGERP(BgL_arityz00_1827))
														{	/* Eval/evaluate_comp.scm 856 */
															switch ((long) CINT(BgL_arityz00_1827))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2307z00_1839;
																		obj_t BgL_arg2308z00_1840;

																		BgL_arg2307z00_1839 =
																			(
																			(long) CINT(BgL_bpz00_1818) + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 856 */
																			obj_t BgL_list2309z00_1841;

																			{	/* Eval/evaluate_comp.scm 856 */
																				obj_t BgL_arg2311z00_1842;

																				{	/* Eval/evaluate_comp.scm 856 */
																					obj_t BgL_arg2312z00_1843;

																					{	/* Eval/evaluate_comp.scm 856 */
																						obj_t BgL_arg2313z00_1844;

																						BgL_arg2313z00_1844 =
																							MAKE_PAIR(BgL_a4z00_1823, BNIL);
																						BgL_arg2312z00_1843 =
																							MAKE_PAIR(BgL_a3z00_1822,
																							BgL_arg2313z00_1844);
																					}
																					BgL_arg2311z00_1842 =
																						MAKE_PAIR(BgL_a2z00_1821,
																						BgL_arg2312z00_1843);
																				}
																				BgL_list2309z00_1841 =
																					MAKE_PAIR(BgL_a1z00_1820,
																					BgL_arg2311z00_1842);
																			}
																			BgL_arg2308z00_1840 =
																				BgL_list2309z00_1841;
																		}
																		VECTOR_SET(BgL_sz00_1816,
																			(int) (BgL_arg2307z00_1839),
																			BgL_arg2308z00_1840);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2314z00_1845;

																		BgL_arg2314z00_1845 =
																			(
																			(long) CINT(BgL_bpz00_1818) + ((long) 0));
																		VECTOR_SET(BgL_sz00_1816,
																			(int) (BgL_arg2314z00_1845),
																			BgL_a1z00_1820);
																	}
																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2315z00_1846;
																		obj_t BgL_arg2317z00_1847;

																		BgL_arg2315z00_1846 =
																			(
																			(long) CINT(BgL_bpz00_1818) + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 856 */
																			obj_t BgL_list2318z00_1848;

																			{	/* Eval/evaluate_comp.scm 856 */
																				obj_t BgL_arg2319z00_1849;

																				{	/* Eval/evaluate_comp.scm 856 */
																					obj_t BgL_arg2320z00_1850;

																					BgL_arg2320z00_1850 =
																						MAKE_PAIR(BgL_a4z00_1823, BNIL);
																					BgL_arg2319z00_1849 =
																						MAKE_PAIR(BgL_a3z00_1822,
																						BgL_arg2320z00_1850);
																				}
																				BgL_list2318z00_1848 =
																					MAKE_PAIR(BgL_a2z00_1821,
																					BgL_arg2319z00_1849);
																			}
																			BgL_arg2317z00_1847 =
																				BgL_list2318z00_1848;
																		}
																		VECTOR_SET(BgL_sz00_1816,
																			(int) (BgL_arg2315z00_1846),
																			BgL_arg2317z00_1847);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2321z00_1851;

																		BgL_arg2321z00_1851 =
																			(
																			(long) CINT(BgL_bpz00_1818) + ((long) 0));
																		VECTOR_SET(BgL_sz00_1816,
																			(int) (BgL_arg2321z00_1851),
																			BgL_a1z00_1820);
																	}
																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2322z00_1852;

																		BgL_arg2322z00_1852 =
																			(
																			(long) CINT(BgL_bpz00_1818) + ((long) 1));
																		VECTOR_SET(BgL_sz00_1816,
																			(int) (BgL_arg2322z00_1852),
																			BgL_a2z00_1821);
																	}
																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2323z00_1853;
																		obj_t BgL_arg2324z00_1854;

																		BgL_arg2323z00_1853 =
																			(
																			(long) CINT(BgL_bpz00_1818) + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 856 */
																			obj_t BgL_list2325z00_1855;

																			{	/* Eval/evaluate_comp.scm 856 */
																				obj_t BgL_arg2326z00_1856;

																				BgL_arg2326z00_1856 =
																					MAKE_PAIR(BgL_a4z00_1823, BNIL);
																				BgL_list2325z00_1855 =
																					MAKE_PAIR(BgL_a3z00_1822,
																					BgL_arg2326z00_1856);
																			}
																			BgL_arg2324z00_1854 =
																				BgL_list2325z00_1855;
																		}
																		VECTOR_SET(BgL_sz00_1816,
																			(int) (BgL_arg2323z00_1853),
																			BgL_arg2324z00_1854);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2327z00_1857;

																		BgL_arg2327z00_1857 =
																			(
																			(long) CINT(BgL_bpz00_1818) + ((long) 0));
																		VECTOR_SET(BgL_sz00_1816,
																			(int) (BgL_arg2327z00_1857),
																			BgL_a1z00_1820);
																	}
																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2328z00_1858;

																		BgL_arg2328z00_1858 =
																			(
																			(long) CINT(BgL_bpz00_1818) + ((long) 1));
																		VECTOR_SET(BgL_sz00_1816,
																			(int) (BgL_arg2328z00_1858),
																			BgL_a2z00_1821);
																	}
																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2329z00_1859;

																		BgL_arg2329z00_1859 =
																			(
																			(long) CINT(BgL_bpz00_1818) + ((long) 2));
																		VECTOR_SET(BgL_sz00_1816,
																			(int) (BgL_arg2329z00_1859),
																			BgL_a3z00_1822);
																	}
																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2330z00_1860;
																		obj_t BgL_arg2331z00_1861;

																		BgL_arg2330z00_1860 =
																			(
																			(long) CINT(BgL_bpz00_1818) + ((long) 3));
																		{	/* Eval/evaluate_comp.scm 856 */
																			obj_t BgL_list2332z00_1862;

																			BgL_list2332z00_1862 =
																				MAKE_PAIR(BgL_a4z00_1823, BNIL);
																			BgL_arg2331z00_1861 =
																				BgL_list2332z00_1862;
																		}
																		VECTOR_SET(BgL_sz00_1816,
																			(int) (BgL_arg2330z00_1860),
																			BgL_arg2331z00_1861);
																	} break;
																case ((long) -5):

																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2333z00_1863;

																		BgL_arg2333z00_1863 =
																			(
																			(long) CINT(BgL_bpz00_1818) + ((long) 0));
																		VECTOR_SET(BgL_sz00_1816,
																			(int) (BgL_arg2333z00_1863),
																			BgL_a1z00_1820);
																	}
																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2334z00_1864;

																		BgL_arg2334z00_1864 =
																			(
																			(long) CINT(BgL_bpz00_1818) + ((long) 1));
																		VECTOR_SET(BgL_sz00_1816,
																			(int) (BgL_arg2334z00_1864),
																			BgL_a2z00_1821);
																	}
																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2335z00_1865;

																		BgL_arg2335z00_1865 =
																			(
																			(long) CINT(BgL_bpz00_1818) + ((long) 2));
																		VECTOR_SET(BgL_sz00_1816,
																			(int) (BgL_arg2335z00_1865),
																			BgL_a3z00_1822);
																	}
																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2336z00_1866;

																		BgL_arg2336z00_1866 =
																			(
																			(long) CINT(BgL_bpz00_1818) + ((long) 3));
																		VECTOR_SET(BgL_sz00_1816,
																			(int) (BgL_arg2336z00_1866),
																			BgL_a4z00_1823);
																	}
																	{	/* Eval/evaluate_comp.scm 856 */
																		long BgL_arg2337z00_1867;

																		BgL_arg2337z00_1867 =
																			(
																			(long) CINT(BgL_bpz00_1818) + ((long) 4));
																		VECTOR_SET(BgL_sz00_1816,
																			(int) (BgL_arg2337z00_1867), BNIL);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_15816,
																		STRUCT_REF(BgL_ufz00_1825,
																			(int) (((long) 3))), (int) (((long) 4)),
																		CINT(BgL_arityz00_1827));
														}}
													else
														{	/* Eval/evaluate_comp.scm 856 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_15816, STRUCT_REF(BgL_ufz00_1825,
																	(int) (((long) 3))), (int) (((long) 4)),
																CINT(BgL_arityz00_1827));
												}}
											{	/* Eval/evaluate_comp.scm 856 */
												obj_t BgL_auxz00_20430;

												BgL_auxz00_20430 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_20430,
													BgL_locz00_15816);
											}
											{	/* Eval/evaluate_comp.scm 856 */
												bool_t BgL_testz00_20433;

												{	/* Eval/evaluate_comp.scm 665 */
													int BgL_arg1908z00_8108;

													BgL_arg1908z00_8108 = VECTOR_LENGTH(BgL_sz00_1816);
													BgL_testz00_20433 =
														(
														((long) CINT(BgL_bpz00_1818) +
															(long) CINT(BgL_sfz00_1829)) <
														(long) (BgL_arg1908z00_8108));
												}
												if (BgL_testz00_20433)
													{	/* Eval/evaluate_comp.scm 856 */
														return BgL_runz00_1828;
													}
												else
													{	/* Eval/evaluate_comp.scm 856 */
														obj_t BgL_nsz00_1873;

														BgL_nsz00_1873 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 856 */
															long BgL_arg2342z00_1875;

															BgL_arg2342z00_1875 =
																((long) CINT(BgL_bpz00_1818) + ((long) 4));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_1873, BINT(((long) 2)),
																BgL_sz00_1816, BgL_bpz00_1818,
																BINT(BgL_arg2342z00_1875));
														}
														VECTOR_SET(BgL_nsz00_1873,
															(int) (((long) 1)), BgL_sz00_1816);
														{	/* Eval/evaluate_comp.scm 856 */
															obj_t BgL_auxz00_20448;

															BgL_auxz00_20448 = BGL_CURRENT_DYNAMIC_ENV();
															BGL_ENV_EVSTATE_SET(BgL_auxz00_20448,
																BgL_nsz00_1873);
														}
														{	/* Eval/evaluate_comp.scm 856 */
															obj_t BgL_val1210z00_1877;

															BgL_val1210z00_1877 =
																BGl_zc3exitza32348ze3z83zz__evaluate_compz00
																(BgL_nsz00_1873, BgL_runz00_1828);
															{	/* Eval/evaluate_comp.scm 856 */
																obj_t BgL_auxz00_20452;

																BgL_auxz00_20452 = BGL_CURRENT_DYNAMIC_ENV();
																BGL_ENV_EVSTATE_SET(BgL_auxz00_20452,
																	BgL_sz00_1816);
															}
															if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
																	(BgL_val1210z00_1877)))
																{	/* Eval/evaluate_comp.scm 856 */
																	return
																		BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
																		(BgL_val1210z00_1877),
																		CDR(BgL_val1210z00_1877));
																}
															else
																{	/* Eval/evaluate_comp.scm 856 */
																	return BgL_val1210z00_1877;
																}
														}
													}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 856 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_1819,
													(int) (((long) 4))))
												{	/* Eval/evaluate_comp.scm 856 */
													long BgL_nbpz00_1886;

													BgL_nbpz00_1886 =
														((long) CINT(BgL_bpz00_1818) + BgL_siza7eza7_15818);
													VECTOR_SET(BgL_sz00_1816,
														(int) (((long) 0)), BINT(BgL_nbpz00_1886));
													{	/* Eval/evaluate_comp.scm 856 */
														obj_t BgL_rz00_1887;

														BgL_rz00_1887 =
															PROCEDURE_ENTRY(BgL_fz00_1819) (BgL_fz00_1819,
															BgL_a1z00_1820, BgL_a2z00_1821, BgL_a3z00_1822,
															BgL_a4z00_1823, BEOA);
														VECTOR_SET(BgL_sz00_1816, (int) (((long) 0)),
															BgL_bpz00_1818);
														return BgL_rz00_1887;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 856 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_15816, BgL_symbzd2funzd2_15817,
														(int) (((long) 4)), PROCEDURE_ARITY(BgL_fz00_1819));
		}}}}}}}}}
	}



/* <exit:2348> */
	obj_t BGl_zc3exitza32348ze3z83zz__evaluate_compz00(obj_t BgL_nsz00_17708,
		obj_t BgL_runz00_17707)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1211z00_1883;

			if (SET_EXIT(BgL_an_exit1211z00_1883))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1211z00_1883 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 856 */

						PUSH_EXIT(BgL_an_exit1211z00_1883, ((long) 0));
						{	/* Eval/evaluate_comp.scm 856 */
							obj_t BgL_val1212z00_1884;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_8127;

								BgL_savedzd2bpzd2_8127 =
									VECTOR_REF(BgL_nsz00_17708, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17708,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_8134;

									BgL_fz00_8134 = BgL_runz00_17707;
								BgL_recz00_8133:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_8135;

										BgL_rz00_8135 =
											PROCEDURE_ENTRY(BgL_fz00_8134) (BgL_fz00_8134,
											BgL_nsz00_17708, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_20493;

											if (PROCEDUREP(BgL_rz00_8135))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_8140;

													BgL_arg1900z00_8140 = PROCEDURE_ATTR(BgL_rz00_8135);
													if (STRUCTP(BgL_arg1900z00_8140))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_20493 =
																(STRUCT_KEY(BgL_arg1900z00_8140) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_20493 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_20493 = ((bool_t) 0);
												}
											if (BgL_testz00_20493)
												{
													obj_t BgL_fz00_20501;

													BgL_fz00_20501 = BgL_rz00_8135;
													BgL_fz00_8134 = BgL_fz00_20501;
													goto BgL_recz00_8133;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17708,
														(int) (((long) 0)), BgL_savedzd2bpzd2_8127);
													BgL_val1212z00_1884 = BgL_rz00_8135;
							}}}}}
							POP_EXIT();
							return BgL_val1212z00_1884;
						}
					}
				}
		}
	}



/* &<anonymous:2351> */
	obj_t BGl_z62zc3anonymousza32351ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15820, obj_t BgL_sz00_15829)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			{	/* Eval/evaluate_comp.scm 856 */
				obj_t BgL_funz00_15821;
				obj_t BgL_a1z00_15822;
				obj_t BgL_a2z00_15823;
				obj_t BgL_a3z00_15824;
				obj_t BgL_a4z00_15825;
				obj_t BgL_locz00_15826;
				obj_t BgL_symbzd2funzd2_15827;
				long BgL_siza7eza7_15828;

				BgL_funz00_15821 = PROCEDURE_REF(BgL_envz00_15820, (int) (((long) 0)));
				BgL_a1z00_15822 = PROCEDURE_REF(BgL_envz00_15820, (int) (((long) 1)));
				BgL_a2z00_15823 = PROCEDURE_REF(BgL_envz00_15820, (int) (((long) 2)));
				BgL_a3z00_15824 = PROCEDURE_REF(BgL_envz00_15820, (int) (((long) 3)));
				BgL_a4z00_15825 = PROCEDURE_REF(BgL_envz00_15820, (int) (((long) 4)));
				BgL_locz00_15826 = PROCEDURE_REF(BgL_envz00_15820, (int) (((long) 5)));
				BgL_symbzd2funzd2_15827 =
					PROCEDURE_REF(BgL_envz00_15820, (int) (((long) 6)));
				BgL_siza7eza7_15828 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15820, (int) (((long) 7))));
				{
					obj_t BgL_sz00_1889;

					BgL_sz00_1889 = BgL_sz00_15829;
					{	/* Eval/evaluate_comp.scm 856 */
						obj_t BgL_bpz00_1891;

						BgL_bpz00_1891 = VECTOR_REF(BgL_sz00_1889, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 856 */
							obj_t BgL_fz00_1892;
							obj_t BgL_a1z00_1893;
							obj_t BgL_a2z00_1894;
							obj_t BgL_a3z00_1895;
							obj_t BgL_a4z00_1896;

							BgL_fz00_1892 =
								PROCEDURE_ENTRY(BgL_funz00_15821) (BgL_funz00_15821,
								BgL_sz00_1889, BEOA);
							BgL_a1z00_1893 =
								PROCEDURE_ENTRY(BgL_a1z00_15822) (BgL_a1z00_15822,
								BgL_sz00_1889, BEOA);
							BgL_a2z00_1894 =
								PROCEDURE_ENTRY(BgL_a2z00_15823) (BgL_a2z00_15823,
								BgL_sz00_1889, BEOA);
							BgL_a3z00_1895 =
								PROCEDURE_ENTRY(BgL_a3z00_15824) (BgL_a3z00_15824,
								BgL_sz00_1889, BEOA);
							BgL_a4z00_1896 =
								PROCEDURE_ENTRY(BgL_a4z00_15825) (BgL_a4z00_15825,
								BgL_sz00_1889, BEOA);
							if (PROCEDUREP(BgL_fz00_1892))
								{	/* Eval/evaluate_comp.scm 856 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 856 */
									BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_15826,
										BGl_string5561z00zz__evaluate_compz00,
										BGl_string5577z00zz__evaluate_compz00, BgL_fz00_1892);
								}
							{	/* Eval/evaluate_comp.scm 856 */
								obj_t BgL_ufz00_1898;

								BgL_ufz00_1898 = PROCEDURE_ATTR(BgL_fz00_1892);
								{	/* Eval/evaluate_comp.scm 856 */
									bool_t BgL_testz00_20548;

									if (STRUCTP(BgL_ufz00_1898))
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_20548 =
												(STRUCT_KEY(BgL_ufz00_1898) ==
												BGl_symbol5578z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 662 */
											BgL_testz00_20548 = ((bool_t) 0);
										}
									if (BgL_testz00_20548)
										{	/* Eval/evaluate_comp.scm 856 */
											obj_t BgL_arityz00_1900;
											obj_t BgL_runz00_1901;
											obj_t BgL_sfz00_1902;

											BgL_arityz00_1900 =
												STRUCT_REF(BgL_ufz00_1898, (int) (((long) 0)));
											BgL_runz00_1901 =
												STRUCT_REF(BgL_ufz00_1898, (int) (((long) 1)));
											BgL_sfz00_1902 =
												STRUCT_REF(BgL_ufz00_1898, (int) (((long) 2)));
											{	/* Eval/evaluate_comp.scm 856 */
												long BgL_spz00_1903;

												BgL_spz00_1903 =
													((long) CINT(BgL_bpz00_1891) + BgL_siza7eza7_15828);
												if (((long) CINT(BgL_arityz00_1900) == ((long) 4)))
													{	/* Eval/evaluate_comp.scm 856 */
														{	/* Eval/evaluate_comp.scm 856 */
															long BgL_arg2355z00_1905;

															BgL_arg2355z00_1905 =
																(BgL_spz00_1903 + ((long) 0));
															VECTOR_SET(BgL_sz00_1889,
																(int) (BgL_arg2355z00_1905), BgL_a1z00_1893);
														}
														{	/* Eval/evaluate_comp.scm 856 */
															long BgL_arg2356z00_1906;

															BgL_arg2356z00_1906 =
																(BgL_spz00_1903 + ((long) 1));
															VECTOR_SET(BgL_sz00_1889,
																(int) (BgL_arg2356z00_1906), BgL_a2z00_1894);
														}
														{	/* Eval/evaluate_comp.scm 856 */
															long BgL_arg2358z00_1907;

															BgL_arg2358z00_1907 =
																(BgL_spz00_1903 + ((long) 2));
															VECTOR_SET(BgL_sz00_1889,
																(int) (BgL_arg2358z00_1907), BgL_a3z00_1895);
														}
														{	/* Eval/evaluate_comp.scm 856 */
															long BgL_arg2359z00_1908;

															BgL_arg2359z00_1908 =
																(BgL_spz00_1903 + ((long) 3));
															VECTOR_SET(BgL_sz00_1889,
																(int) (BgL_arg2359z00_1908), BgL_a4z00_1896);
													}}
												else
													{	/* Eval/evaluate_comp.scm 856 */
														if (INTEGERP(BgL_arityz00_1900))
															{	/* Eval/evaluate_comp.scm 856 */
																switch ((long) CINT(BgL_arityz00_1900))
																	{
																	case ((long) -1):

																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2361z00_1912;
																			obj_t BgL_arg2362z00_1913;

																			BgL_arg2361z00_1912 =
																				(BgL_spz00_1903 + ((long) 0));
																			{	/* Eval/evaluate_comp.scm 856 */
																				obj_t BgL_list2363z00_1914;

																				{	/* Eval/evaluate_comp.scm 856 */
																					obj_t BgL_arg2364z00_1915;

																					{	/* Eval/evaluate_comp.scm 856 */
																						obj_t BgL_arg2365z00_1916;

																						{	/* Eval/evaluate_comp.scm 856 */
																							obj_t BgL_arg2366z00_1917;

																							BgL_arg2366z00_1917 =
																								MAKE_PAIR(BgL_a4z00_1896, BNIL);
																							BgL_arg2365z00_1916 =
																								MAKE_PAIR(BgL_a3z00_1895,
																								BgL_arg2366z00_1917);
																						}
																						BgL_arg2364z00_1915 =
																							MAKE_PAIR(BgL_a2z00_1894,
																							BgL_arg2365z00_1916);
																					}
																					BgL_list2363z00_1914 =
																						MAKE_PAIR(BgL_a1z00_1893,
																						BgL_arg2364z00_1915);
																				}
																				BgL_arg2362z00_1913 =
																					BgL_list2363z00_1914;
																			}
																			VECTOR_SET(BgL_sz00_1889,
																				(int) (BgL_arg2361z00_1912),
																				BgL_arg2362z00_1913);
																		} break;
																	case ((long) -2):

																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2367z00_1918;

																			BgL_arg2367z00_1918 =
																				(BgL_spz00_1903 + ((long) 0));
																			VECTOR_SET(BgL_sz00_1889,
																				(int) (BgL_arg2367z00_1918),
																				BgL_a1z00_1893);
																		}
																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2368z00_1919;
																			obj_t BgL_arg2369z00_1920;

																			BgL_arg2368z00_1919 =
																				(BgL_spz00_1903 + ((long) 1));
																			{	/* Eval/evaluate_comp.scm 856 */
																				obj_t BgL_list2370z00_1921;

																				{	/* Eval/evaluate_comp.scm 856 */
																					obj_t BgL_arg2371z00_1922;

																					{	/* Eval/evaluate_comp.scm 856 */
																						obj_t BgL_arg2372z00_1923;

																						BgL_arg2372z00_1923 =
																							MAKE_PAIR(BgL_a4z00_1896, BNIL);
																						BgL_arg2371z00_1922 =
																							MAKE_PAIR(BgL_a3z00_1895,
																							BgL_arg2372z00_1923);
																					}
																					BgL_list2370z00_1921 =
																						MAKE_PAIR(BgL_a2z00_1894,
																						BgL_arg2371z00_1922);
																				}
																				BgL_arg2369z00_1920 =
																					BgL_list2370z00_1921;
																			}
																			VECTOR_SET(BgL_sz00_1889,
																				(int) (BgL_arg2368z00_1919),
																				BgL_arg2369z00_1920);
																		} break;
																	case ((long) -3):

																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2373z00_1924;

																			BgL_arg2373z00_1924 =
																				(BgL_spz00_1903 + ((long) 0));
																			VECTOR_SET(BgL_sz00_1889,
																				(int) (BgL_arg2373z00_1924),
																				BgL_a1z00_1893);
																		}
																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2374z00_1925;

																			BgL_arg2374z00_1925 =
																				(BgL_spz00_1903 + ((long) 1));
																			VECTOR_SET(BgL_sz00_1889,
																				(int) (BgL_arg2374z00_1925),
																				BgL_a2z00_1894);
																		}
																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2375z00_1926;
																			obj_t BgL_arg2376z00_1927;

																			BgL_arg2375z00_1926 =
																				(BgL_spz00_1903 + ((long) 2));
																			{	/* Eval/evaluate_comp.scm 856 */
																				obj_t BgL_list2377z00_1928;

																				{	/* Eval/evaluate_comp.scm 856 */
																					obj_t BgL_arg2378z00_1929;

																					BgL_arg2378z00_1929 =
																						MAKE_PAIR(BgL_a4z00_1896, BNIL);
																					BgL_list2377z00_1928 =
																						MAKE_PAIR(BgL_a3z00_1895,
																						BgL_arg2378z00_1929);
																				}
																				BgL_arg2376z00_1927 =
																					BgL_list2377z00_1928;
																			}
																			VECTOR_SET(BgL_sz00_1889,
																				(int) (BgL_arg2375z00_1926),
																				BgL_arg2376z00_1927);
																		} break;
																	case ((long) -4):

																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2379z00_1930;

																			BgL_arg2379z00_1930 =
																				(BgL_spz00_1903 + ((long) 0));
																			VECTOR_SET(BgL_sz00_1889,
																				(int) (BgL_arg2379z00_1930),
																				BgL_a1z00_1893);
																		}
																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2380z00_1931;

																			BgL_arg2380z00_1931 =
																				(BgL_spz00_1903 + ((long) 1));
																			VECTOR_SET(BgL_sz00_1889,
																				(int) (BgL_arg2380z00_1931),
																				BgL_a2z00_1894);
																		}
																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2381z00_1932;

																			BgL_arg2381z00_1932 =
																				(BgL_spz00_1903 + ((long) 2));
																			VECTOR_SET(BgL_sz00_1889,
																				(int) (BgL_arg2381z00_1932),
																				BgL_a3z00_1895);
																		}
																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2382z00_1933;
																			obj_t BgL_arg2383z00_1934;

																			BgL_arg2382z00_1933 =
																				(BgL_spz00_1903 + ((long) 3));
																			{	/* Eval/evaluate_comp.scm 856 */
																				obj_t BgL_list2384z00_1935;

																				BgL_list2384z00_1935 =
																					MAKE_PAIR(BgL_a4z00_1896, BNIL);
																				BgL_arg2383z00_1934 =
																					BgL_list2384z00_1935;
																			}
																			VECTOR_SET(BgL_sz00_1889,
																				(int) (BgL_arg2382z00_1933),
																				BgL_arg2383z00_1934);
																		} break;
																	case ((long) -5):

																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2385z00_1936;

																			BgL_arg2385z00_1936 =
																				(BgL_spz00_1903 + ((long) 0));
																			VECTOR_SET(BgL_sz00_1889,
																				(int) (BgL_arg2385z00_1936),
																				BgL_a1z00_1893);
																		}
																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2386z00_1937;

																			BgL_arg2386z00_1937 =
																				(BgL_spz00_1903 + ((long) 1));
																			VECTOR_SET(BgL_sz00_1889,
																				(int) (BgL_arg2386z00_1937),
																				BgL_a2z00_1894);
																		}
																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2387z00_1938;

																			BgL_arg2387z00_1938 =
																				(BgL_spz00_1903 + ((long) 2));
																			VECTOR_SET(BgL_sz00_1889,
																				(int) (BgL_arg2387z00_1938),
																				BgL_a3z00_1895);
																		}
																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2388z00_1939;

																			BgL_arg2388z00_1939 =
																				(BgL_spz00_1903 + ((long) 3));
																			VECTOR_SET(BgL_sz00_1889,
																				(int) (BgL_arg2388z00_1939),
																				BgL_a4z00_1896);
																		}
																		{	/* Eval/evaluate_comp.scm 856 */
																			long BgL_arg2389z00_1940;

																			BgL_arg2389z00_1940 =
																				(BgL_spz00_1903 + ((long) 4));
																			VECTOR_SET(BgL_sz00_1889,
																				(int) (BgL_arg2389z00_1940), BNIL);
																		} break;
																	default:
																		BGl_evarityzd2errorzd2zz__everrorz00
																			(BgL_locz00_15826,
																			STRUCT_REF(BgL_ufz00_1898,
																				(int) (((long) 3))), (int) (((long) 4)),
																			CINT(BgL_arityz00_1900));
															}}
														else
															{	/* Eval/evaluate_comp.scm 856 */
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_15826, STRUCT_REF(BgL_ufz00_1898,
																		(int) (((long) 3))), (int) (((long) 4)),
																	CINT(BgL_arityz00_1900));
													}}
												{	/* Eval/evaluate_comp.scm 856 */
													obj_t BgL_auxz00_20645;

													BgL_auxz00_20645 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_auxz00_20645,
														BgL_locz00_15826);
												}
												{	/* Eval/evaluate_comp.scm 856 */
													bool_t BgL_testz00_20648;

													{	/* Eval/evaluate_comp.scm 665 */
														int BgL_arg1908z00_8332;

														BgL_arg1908z00_8332 = VECTOR_LENGTH(BgL_sz00_1889);
														BgL_testz00_20648 =
															(
															(BgL_spz00_1903 +
																(long) CINT(BgL_sfz00_1902)) <
															(long) (BgL_arg1908z00_8332));
													}
													if (BgL_testz00_20648)
														{	/* Eval/evaluate_comp.scm 856 */
															return
																BGl_catchzd2trampolinezd2zz__evaluate_compz00
																(BgL_runz00_1901, BgL_sz00_1889,
																BINT(BgL_spz00_1903));
														}
													else
														{	/* Eval/evaluate_comp.scm 856 */
															obj_t BgL_nsz00_1946;

															BgL_nsz00_1946 =
																BGl_makezd2statezd2zz__evaluate_compz00();
															{	/* Eval/evaluate_comp.scm 856 */
																long BgL_arg2395z00_1948;

																BgL_arg2395z00_1948 =
																	(BgL_spz00_1903 + ((long) 4));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_nsz00_1946, BINT(((long) 2)),
																	BgL_sz00_1889, BINT(BgL_spz00_1903),
																	BINT(BgL_arg2395z00_1948));
															}
															VECTOR_SET(BgL_nsz00_1946,
																(int) (((long) 1)), BgL_sz00_1889);
															{	/* Eval/evaluate_comp.scm 856 */
																obj_t BgL_auxz00_20664;

																BgL_auxz00_20664 = BGL_CURRENT_DYNAMIC_ENV();
																BGL_ENV_EVSTATE_SET(BgL_auxz00_20664,
																	BgL_nsz00_1946);
															}
															{	/* Eval/evaluate_comp.scm 856 */
																obj_t BgL_val1215z00_1950;

																BgL_val1215z00_1950 =
																	BGl_zc3exitza32401ze3z83zz__evaluate_compz00
																	(BgL_nsz00_1946, BgL_runz00_1901);
																{	/* Eval/evaluate_comp.scm 856 */
																	obj_t BgL_auxz00_20668;

																	BgL_auxz00_20668 = BGL_CURRENT_DYNAMIC_ENV();
																	BGL_ENV_EVSTATE_SET(BgL_auxz00_20668,
																		BgL_sz00_1889);
																}
																if (CBOOL
																	(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
																		(BgL_val1215z00_1950)))
																	{	/* Eval/evaluate_comp.scm 856 */
																		return
																			BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
																			(BgL_val1215z00_1950),
																			CDR(BgL_val1215z00_1950));
																	}
																else
																	{	/* Eval/evaluate_comp.scm 856 */
																		return BgL_val1215z00_1950;
																	}
															}
														}
												}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 856 */
											if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_1892,
													(int) (((long) 4))))
												{	/* Eval/evaluate_comp.scm 856 */
													long BgL_nbpz00_1959;

													BgL_nbpz00_1959 =
														((long) CINT(BgL_bpz00_1891) + BgL_siza7eza7_15828);
													VECTOR_SET(BgL_sz00_1889,
														(int) (((long) 0)), BINT(BgL_nbpz00_1959));
													{	/* Eval/evaluate_comp.scm 856 */
														obj_t BgL_rz00_1960;

														BgL_rz00_1960 =
															PROCEDURE_ENTRY(BgL_fz00_1892) (BgL_fz00_1892,
															BgL_a1z00_1893, BgL_a2z00_1894, BgL_a3z00_1895,
															BgL_a4z00_1896, BEOA);
														VECTOR_SET(BgL_sz00_1889, (int) (((long) 0)),
															BgL_bpz00_1891);
														return BgL_rz00_1960;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 856 */
													return
														BGl_evarityzd2errorzd2zz__everrorz00
														(BgL_locz00_15826, BgL_symbzd2funzd2_15827,
														(int) (((long) 4)), PROCEDURE_ARITY(BgL_fz00_1892));
		}}}}}}}}}
	}



/* <exit:2401> */
	obj_t BGl_zc3exitza32401ze3z83zz__evaluate_compz00(obj_t BgL_nsz00_17706,
		obj_t BgL_runz00_17705)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 856 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1216z00_1956;

			if (SET_EXIT(BgL_an_exit1216z00_1956))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1216z00_1956 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 856 */

						PUSH_EXIT(BgL_an_exit1216z00_1956, ((long) 0));
						{	/* Eval/evaluate_comp.scm 856 */
							obj_t BgL_val1217z00_1957;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_8350;

								BgL_savedzd2bpzd2_8350 =
									VECTOR_REF(BgL_nsz00_17706, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17706,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_8357;

									BgL_fz00_8357 = BgL_runz00_17705;
								BgL_recz00_8356:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_8358;

										BgL_rz00_8358 =
											PROCEDURE_ENTRY(BgL_fz00_8357) (BgL_fz00_8357,
											BgL_nsz00_17706, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_20709;

											if (PROCEDUREP(BgL_rz00_8358))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_8363;

													BgL_arg1900z00_8363 = PROCEDURE_ATTR(BgL_rz00_8358);
													if (STRUCTP(BgL_arg1900z00_8363))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_20709 =
																(STRUCT_KEY(BgL_arg1900z00_8363) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_20709 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_20709 = ((bool_t) 0);
												}
											if (BgL_testz00_20709)
												{
													obj_t BgL_fz00_20717;

													BgL_fz00_20717 = BgL_rz00_8358;
													BgL_fz00_8357 = BgL_fz00_20717;
													goto BgL_recz00_8356;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17706,
														(int) (((long) 0)), BgL_savedzd2bpzd2_8350);
													BgL_val1217z00_1957 = BgL_rz00_8358;
							}}}}}
							POP_EXIT();
							return BgL_val1217z00_1957;
						}
					}
				}
		}
	}



/* is-constant-fun? */
	obj_t BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_ev_exprz00_bglt
		BgL_funz00_183, long BgL_nbargsz00_184, obj_t BgL_locz00_185,
		obj_t BgL_symbzd2funzd2_186)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 859 */
			if (BGl_isazf3zf3zz__objectz00(
					((obj_t) BgL_funz00_183), BGl_ev_globalz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 862 */
					BgL_ev_globalz00_bglt BgL_i1218z00_1963;

					BgL_i1218z00_1963 = ((BgL_ev_globalz00_bglt) BgL_funz00_183);
					{	/* Eval/evaluate_comp.scm 863 */
						obj_t BgL_gz00_1964;

						BgL_gz00_1964 =
							BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
							(((BgL_ev_globalz00_bglt) CREF(BgL_i1218z00_1963))->BgL_modz00),
							(((BgL_ev_globalz00_bglt) CREF(BgL_i1218z00_1963))->BgL_namez00));
						if (CBOOL(BgL_gz00_1964))
							{	/* Eval/evaluate_comp.scm 865 */
								bool_t BgL_testz00_20730;

								{	/* Eval/evaluate_comp.scm 865 */
									int BgL_arg2408z00_1969;

									{	/* Eval/evaluate_comp.scm 865 */
										int BgL_res4711z00_8390;

										{	/* Eval/evaluate_comp.scm 865 */
											obj_t BgL_evalzd2globalzd2_8387;

											BgL_evalzd2globalzd2_8387 = BgL_gz00_1964;
											{	/* Eval/evenv.scm 188 */
												int BgL_kz00_8389;

												BgL_kz00_8389 = (int) (((long) 0));
												BgL_res4711z00_8390 =
													CINT(VECTOR_REF(BgL_evalzd2globalzd2_8387,
														BgL_kz00_8389));
										}}
										BgL_arg2408z00_1969 = BgL_res4711z00_8390;
									}
									BgL_testz00_20730 =
										((long) (BgL_arg2408z00_1969) == ((long) 0));
								}
								if (BgL_testz00_20730)
									{	/* Eval/evaluate_comp.scm 866 */
										obj_t BgL_valz00_1966;

										BgL_valz00_1966 =
											VECTOR_REF(BgL_gz00_1964, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 867 */
											bool_t BgL_testz00_20738;

											if (PROCEDUREP(BgL_valz00_1966))
												{	/* Eval/evaluate_comp.scm 867 */
													BgL_testz00_20738 =
														PROCEDURE_CORRECT_ARITYP(BgL_valz00_1966,
														(int) (BgL_nbargsz00_184));
												}
											else
												{	/* Eval/evaluate_comp.scm 867 */
													BgL_testz00_20738 = ((bool_t) 0);
												}
											if (BgL_testz00_20738)
												{	/* Eval/evaluate_comp.scm 867 */
													return BgL_valz00_1966;
												}
											else
												{	/* Eval/evaluate_comp.scm 867 */
													return BFALSE;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 865 */
										return BFALSE;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 864 */
								return BFALSE;
							}
					}
				}
			else
				{	/* Eval/evaluate_comp.scm 870 */
					bool_t BgL_testz00_20743;

					if (BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_funz00_183), BGl_ev_littz00zz__evaluate_typesz00))
						{	/* Ieee/control.scm 76 */
							obj_t BgL_auxz00_20747;

							BgL_auxz00_20747 =
								(((BgL_ev_littz00_bglt) CREF(
										((BgL_ev_littz00_bglt) BgL_funz00_183)))->BgL_valuez00);
							BgL_testz00_20743 = PROCEDUREP(BgL_auxz00_20747);
						}
					else
						{	/* Eval/evaluate_comp.scm 870 */
							BgL_testz00_20743 = ((bool_t) 0);
						}
					if (BgL_testz00_20743)
						{	/* Eval/evaluate_comp.scm 872 */
							BgL_ev_littz00_bglt BgL_i1220z00_1973;

							BgL_i1220z00_1973 = ((BgL_ev_littz00_bglt) BgL_funz00_183);
							if (PROCEDURE_CORRECT_ARITYP(
									(((BgL_ev_littz00_bglt) CREF(BgL_i1220z00_1973))->
										BgL_valuez00), (int) (BgL_nbargsz00_184)))
								{	/* Eval/evaluate_comp.scm 873 */
									return
										(((BgL_ev_littz00_bglt) CREF(BgL_i1220z00_1973))->
										BgL_valuez00);
								}
							else
								{	/* Eval/evaluate_comp.scm 873 */
									return
										BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_185,
										BgL_symbzd2funzd2_186, (int) (BgL_nbargsz00_184),
										PROCEDURE_ARITY((((BgL_ev_littz00_bglt)
													CREF(BgL_i1220z00_1973))->BgL_valuez00)));
						}}
					else
						{	/* Eval/evaluate_comp.scm 870 */
							return BFALSE;
						}
				}
		}
	}



/* compile-float-arith */
	obj_t BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(obj_t
		BgL_exprz00_187, obj_t BgL_stkz00_188)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 878 */
			if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
					BGl_ev_littz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 883 */
					BgL_ev_littz00_bglt BgL_i1221z00_1983;

					BgL_i1221z00_1983 = ((BgL_ev_littz00_bglt) BgL_exprz00_187);
					if (INTEGERP(
							(((BgL_ev_littz00_bglt) CREF(BgL_i1221z00_1983))->BgL_valuez00)))
						{	/* Eval/evaluate_comp.scm 884 */
							obj_t BgL_v1603z00_1985;

							BgL_v1603z00_1985 = create_vector((int) (((long) 2)));
							{	/* Eval/evaluate_comp.scm 884 */
								double BgL_arg2420z00_1986;

								BgL_arg2420z00_1986 =
									(double) (
									(long) CINT(
										(((BgL_ev_littz00_bglt) CREF(BgL_i1221z00_1983))->
											BgL_valuez00)));
								{	/* Eval/evaluate_comp.scm 884 */
									int BgL_kz00_8406;
									obj_t BgL_objz00_8407;

									BgL_kz00_8406 = (int) (((long) 1));
									BgL_objz00_8407 = DOUBLE_TO_REAL(BgL_arg2420z00_1986);
									VECTOR_SET(BgL_v1603z00_1985, BgL_kz00_8406, BgL_objz00_8407);
							}}
							VECTOR_SET(BgL_v1603z00_1985,
								(int) (((long) 0)), BINT(((long) 1)));
							return BgL_v1603z00_1985;
						}
					else
						{	/* Eval/evaluate_comp.scm 885 */
							bool_t BgL_testz00_20778;

							{	/* Ieee/flonum.scm 307 */
								obj_t BgL_auxz00_20779;

								BgL_auxz00_20779 =
									(((BgL_ev_littz00_bglt) CREF(BgL_i1221z00_1983))->
									BgL_valuez00);
								BgL_testz00_20778 = REALP(BgL_auxz00_20779);
							}
							if (BgL_testz00_20778)
								{	/* Eval/evaluate_comp.scm 885 */
									obj_t BgL_v1604z00_1989;

									BgL_v1604z00_1989 = create_vector((int) (((long) 2)));
									VECTOR_SET(BgL_v1604z00_1989,
										(int) (((long) 1)),
										(((BgL_ev_littz00_bglt) CREF(BgL_i1221z00_1983))->
											BgL_valuez00));
									VECTOR_SET(BgL_v1604z00_1989, (int) (((long) 0)),
										BINT(((long) 1)));
									return BgL_v1604z00_1989;
								}
							else
								{	/* Eval/evaluate_comp.scm 886 */
									obj_t BgL_v1605z00_1991;

									BgL_v1605z00_1991 = create_vector((int) (((long) 2)));
									{	/* Eval/evaluate_comp.scm 886 */
										obj_t BgL_arg2425z00_1992;

										BgL_arg2425z00_1992 =
											BGl_compz00zz__evaluate_compz00(
											((BgL_ev_exprz00_bglt)
												((BgL_ev_littz00_bglt) BgL_exprz00_187)),
											BgL_stkz00_188);
										VECTOR_SET(BgL_v1605z00_1991, (int) (((long) 1)),
											BgL_arg2425z00_1992);
									}
									VECTOR_SET(BgL_v1605z00_1991,
										(int) (((long) 0)), BINT(((long) 0)));
									return BgL_v1605z00_1991;
								}
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 882 */
					if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
							BGl_ev_varz00zz__evaluate_typesz00))
						{	/* Eval/evaluate_comp.scm 888 */
							BgL_ev_varz00_bglt BgL_i1222z00_1996;

							BgL_i1222z00_1996 = ((BgL_ev_varz00_bglt) BgL_exprz00_187);
							if (CBOOL(
									(((BgL_ev_varz00_bglt) CREF(BgL_i1222z00_1996))->BgL_effz00)))
								{	/* Eval/evaluate_comp.scm 890 */
									obj_t BgL_v1606z00_1998;

									BgL_v1606z00_1998 = create_vector((int) (((long) 2)));
									VECTOR_SET(BgL_v1606z00_1998,
										(int) (((long) 1)),
										BGl__indexz00zz__evaluate_compz00(BgL_exprz00_187,
											BgL_stkz00_188));
									VECTOR_SET(BgL_v1606z00_1998, (int) (((long) 0)),
										BINT(((long) 3)));
									return BgL_v1606z00_1998;
								}
							else
								{	/* Eval/evaluate_comp.scm 891 */
									obj_t BgL_v1607z00_2000;

									BgL_v1607z00_2000 = create_vector((int) (((long) 2)));
									VECTOR_SET(BgL_v1607z00_2000,
										(int) (((long) 1)),
										BGl__indexz00zz__evaluate_compz00(BgL_exprz00_187,
											BgL_stkz00_188));
									VECTOR_SET(BgL_v1607z00_2000, (int) (((long) 0)),
										BINT(((long) 2)));
									return BgL_v1607z00_2000;
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 887 */
							if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
									BGl_ev_globalz00zz__evaluate_typesz00))
								{	/* Eval/evaluate_comp.scm 893 */
									BgL_ev_globalz00_bglt BgL_i1223z00_2003;

									BgL_i1223z00_2003 = ((BgL_ev_globalz00_bglt) BgL_exprz00_187);
									{	/* Eval/evaluate_comp.scm 894 */
										obj_t BgL_gz00_2004;

										BgL_gz00_2004 =
											BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
											(((BgL_ev_globalz00_bglt) CREF(BgL_i1223z00_2003))->
												BgL_modz00),
											(((BgL_ev_globalz00_bglt) CREF(BgL_i1223z00_2003))->
												BgL_namez00));
										if (CBOOL(BgL_gz00_2004))
											{	/* Eval/evaluate_comp.scm 896 */
												bool_t BgL_testz00_20830;

												{	/* Eval/evaluate_comp.scm 896 */
													int BgL_arg2435z00_2008;

													{	/* Eval/evaluate_comp.scm 896 */
														int BgL_res4718z00_8440;

														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_evalzd2globalzd2_8437;

															BgL_evalzd2globalzd2_8437 = BgL_gz00_2004;
															{	/* Eval/evenv.scm 188 */
																int BgL_kz00_8439;

																BgL_kz00_8439 = (int) (((long) 0));
																BgL_res4718z00_8440 =
																	CINT(VECTOR_REF(BgL_evalzd2globalzd2_8437,
																		BgL_kz00_8439));
														}}
														BgL_arg2435z00_2008 = BgL_res4718z00_8440;
													}
													BgL_testz00_20830 =
														(BINT(BgL_arg2435z00_2008) == BINT(((long) 1)));
												}
												if (BgL_testz00_20830)
													{	/* Eval/evaluate_comp.scm 897 */
														obj_t BgL_v1608z00_2006;

														BgL_v1608z00_2006 =
															create_vector((int) (((long) 2)));
														VECTOR_SET(BgL_v1608z00_2006,
															(int) (((long) 1)), BgL_gz00_2004);
														VECTOR_SET(BgL_v1608z00_2006,
															(int) (((long) 0)), BINT(((long) 4)));
														return BgL_v1608z00_2006;
													}
												else
													{	/* Eval/evaluate_comp.scm 898 */
														obj_t BgL_v1609z00_2007;

														BgL_v1609z00_2007 =
															create_vector((int) (((long) 2)));
														VECTOR_SET(BgL_v1609z00_2007,
															(int) (((long) 1)), BgL_gz00_2004);
														VECTOR_SET(BgL_v1609z00_2007,
															(int) (((long) 0)), BINT(((long) 5)));
														return BgL_v1609z00_2007;
													}
											}
										else
											{	/* Eval/evaluate_comp.scm 899 */
												obj_t BgL_v1610z00_2009;

												BgL_v1610z00_2009 = create_vector((int) (((long) 2)));
												{	/* Eval/evaluate_comp.scm 899 */
													obj_t BgL_arg2436z00_2010;

													BgL_arg2436z00_2010 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt)
															((BgL_ev_globalz00_bglt) BgL_exprz00_187)),
														BgL_stkz00_188);
													VECTOR_SET(BgL_v1610z00_2009, (int) (((long) 1)),
														BgL_arg2436z00_2010);
												}
												VECTOR_SET(BgL_v1610z00_2009,
													(int) (((long) 0)), BINT(((long) 0)));
												return BgL_v1610z00_2009;
											}
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 892 */
									if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
											BGl_ev_appz00zz__evaluate_typesz00))
										{	/* Eval/evaluate_comp.scm 901 */
											BgL_ev_appz00_bglt BgL_i1224z00_2014;

											BgL_i1224z00_2014 =
												((BgL_ev_appz00_bglt) BgL_exprz00_187);
											{	/* Eval/evaluate_comp.scm 902 */
												obj_t BgL_fvalz00_2015;

												BgL_fvalz00_2015 =
													BGl_globalzd2funzd2valuez00zz__evaluate_compz00(
													(((BgL_ev_appz00_bglt) CREF(BgL_i1224z00_2014))->
														BgL_funz00));
												if ((BgL_fvalz00_2015 ==
														BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
													{	/* Eval/evaluate_comp.scm 905 */
														obj_t BgL_v1611z00_2017;

														BgL_v1611z00_2017 =
															create_vector((int) (((long) 3)));
														{	/* Eval/evaluate_comp.scm 905 */
															obj_t BgL_arg2441z00_2018;

															{	/* Eval/evaluate_comp.scm 905 */
																obj_t BgL_arg2442z00_2019;

																{	/* Eval/evaluate_comp.scm 905 */
																	obj_t BgL_pairz00_8459;

																	BgL_pairz00_8459 =
																		(((BgL_ev_appz00_bglt)
																			CREF(BgL_i1224z00_2014))->BgL_argsz00);
																	BgL_arg2442z00_2019 =
																		CAR(CDR(BgL_pairz00_8459));
																}
																BgL_arg2441z00_2018 =
																	BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																	(BgL_arg2442z00_2019, BgL_stkz00_188);
															}
															VECTOR_SET(BgL_v1611z00_2017,
																(int) (((long) 2)), BgL_arg2441z00_2018);
														}
														VECTOR_SET(BgL_v1611z00_2017,
															(int) (((long) 1)),
															BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
															(CAR((((BgL_ev_appz00_bglt)
																			CREF(BgL_i1224z00_2014))->BgL_argsz00)),
																BgL_stkz00_188));
														VECTOR_SET(BgL_v1611z00_2017, (int) (((long) 0)),
															BINT(((long) 6)));
														return BgL_v1611z00_2017;
													}
												else
													{	/* Eval/evaluate_comp.scm 904 */
														if (
															(BgL_fvalz00_2015 ==
																BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
															{	/* Eval/evaluate_comp.scm 907 */
																obj_t BgL_v1612z00_2025;

																BgL_v1612z00_2025 =
																	create_vector((int) (((long) 3)));
																{	/* Eval/evaluate_comp.scm 907 */
																	obj_t BgL_arg2449z00_2026;

																	{	/* Eval/evaluate_comp.scm 907 */
																		obj_t BgL_arg2450z00_2027;

																		{	/* Eval/evaluate_comp.scm 907 */
																			obj_t BgL_pairz00_8475;

																			BgL_pairz00_8475 =
																				(((BgL_ev_appz00_bglt)
																					CREF(BgL_i1224z00_2014))->
																				BgL_argsz00);
																			BgL_arg2450z00_2027 =
																				CAR(CDR(BgL_pairz00_8475));
																		}
																		BgL_arg2449z00_2026 =
																			BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																			(BgL_arg2450z00_2027, BgL_stkz00_188);
																	}
																	VECTOR_SET(BgL_v1612z00_2025,
																		(int) (((long) 2)), BgL_arg2449z00_2026);
																}
																VECTOR_SET(BgL_v1612z00_2025,
																	(int) (((long) 1)),
																	BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																	(CAR((((BgL_ev_appz00_bglt)
																					CREF(BgL_i1224z00_2014))->
																				BgL_argsz00)), BgL_stkz00_188));
																VECTOR_SET(BgL_v1612z00_2025,
																	(int) (((long) 0)), BINT(((long) 7)));
																return BgL_v1612z00_2025;
															}
														else
															{	/* Eval/evaluate_comp.scm 906 */
																if (
																	(BgL_fvalz00_2015 ==
																		BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
																	{	/* Eval/evaluate_comp.scm 909 */
																		obj_t BgL_v1613z00_2033;

																		BgL_v1613z00_2033 =
																			create_vector((int) (((long) 3)));
																		{	/* Eval/evaluate_comp.scm 909 */
																			obj_t BgL_arg2456z00_2034;

																			{	/* Eval/evaluate_comp.scm 909 */
																				obj_t BgL_arg2457z00_2035;

																				{	/* Eval/evaluate_comp.scm 909 */
																					obj_t BgL_pairz00_8491;

																					BgL_pairz00_8491 =
																						(((BgL_ev_appz00_bglt)
																							CREF(BgL_i1224z00_2014))->
																						BgL_argsz00);
																					BgL_arg2457z00_2035 =
																						CAR(CDR(BgL_pairz00_8491));
																				}
																				BgL_arg2456z00_2034 =
																					BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																					(BgL_arg2457z00_2035, BgL_stkz00_188);
																			}
																			VECTOR_SET(BgL_v1613z00_2033,
																				(int) (((long) 2)),
																				BgL_arg2456z00_2034);
																		}
																		VECTOR_SET(BgL_v1613z00_2033,
																			(int) (((long) 1)),
																			BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																			(CAR((((BgL_ev_appz00_bglt)
																							CREF(BgL_i1224z00_2014))->
																						BgL_argsz00)), BgL_stkz00_188));
																		VECTOR_SET(BgL_v1613z00_2033,
																			(int) (((long) 0)), BINT(((long) 8)));
																		return BgL_v1613z00_2033;
																	}
																else
																	{	/* Eval/evaluate_comp.scm 908 */
																		if (
																			(BgL_fvalz00_2015 ==
																				BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00))
																			{	/* Eval/evaluate_comp.scm 911 */
																				obj_t BgL_v1614z00_2041;

																				BgL_v1614z00_2041 =
																					create_vector((int) (((long) 3)));
																				{	/* Eval/evaluate_comp.scm 911 */
																					obj_t BgL_arg2463z00_2042;

																					{	/* Eval/evaluate_comp.scm 911 */
																						obj_t BgL_arg2464z00_2043;

																						{	/* Eval/evaluate_comp.scm 911 */
																							obj_t BgL_pairz00_8507;

																							BgL_pairz00_8507 =
																								(((BgL_ev_appz00_bglt)
																									CREF(BgL_i1224z00_2014))->
																								BgL_argsz00);
																							BgL_arg2464z00_2043 =
																								CAR(CDR(BgL_pairz00_8507));
																						}
																						BgL_arg2463z00_2042 =
																							BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																							(BgL_arg2464z00_2043,
																							BgL_stkz00_188);
																					}
																					VECTOR_SET(BgL_v1614z00_2041,
																						(int) (((long) 2)),
																						BgL_arg2463z00_2042);
																				}
																				VECTOR_SET(BgL_v1614z00_2041,
																					(int) (((long) 1)),
																					BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																					(CAR((((BgL_ev_appz00_bglt)
																									CREF(BgL_i1224z00_2014))->
																								BgL_argsz00)), BgL_stkz00_188));
																				VECTOR_SET(BgL_v1614z00_2041,
																					(int) (((long) 0)), BINT(((long) 9)));
																				return BgL_v1614z00_2041;
																			}
																		else
																			{	/* Eval/evaluate_comp.scm 910 */
																				if (
																					(BgL_fvalz00_2015 ==
																						BGl_fixnumzd2ze3flonumzd2envze3zz__r4_numbers_6_5z00))
																					{	/* Eval/evaluate_comp.scm 913 */
																						obj_t BgL_v1615z00_2049;

																						BgL_v1615z00_2049 =
																							create_vector((int) (((long) 2)));
																						{	/* Eval/evaluate_comp.scm 913 */
																							obj_t BgL_arg2470z00_2050;

																							{	/* Eval/evaluate_comp.scm 913 */
																								obj_t BgL_arg2471z00_2051;

																								BgL_arg2471z00_2051 =
																									CAR(
																									(((BgL_ev_appz00_bglt)
																											CREF(BgL_i1224z00_2014))->
																										BgL_argsz00));
																								BgL_arg2470z00_2050 =
																									BGl_compz00zz__evaluate_compz00
																									(((BgL_ev_exprz00_bglt)
																										BgL_arg2471z00_2051),
																									BgL_stkz00_188);
																							}
																							VECTOR_SET(BgL_v1615z00_2049,
																								(int) (((long) 1)),
																								BgL_arg2470z00_2050);
																						}
																						VECTOR_SET(BgL_v1615z00_2049,
																							(int) (((long) 0)),
																							BINT(((long) 10)));
																						return BgL_v1615z00_2049;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 912 */
																						if (
																							(BgL_fvalz00_2015 ==
																								BGl_f64vectorzd2refzd2envz00zz__srfi4z00))
																							{	/* Eval/evaluate_comp.scm 915 */
																								obj_t BgL_v1616z00_2054;

																								BgL_v1616z00_2054 =
																									create_vector(
																									(int) (((long) 3)));
																								{	/* Eval/evaluate_comp.scm 915 */
																									obj_t BgL_arg2474z00_2055;

																									{	/* Eval/evaluate_comp.scm 915 */
																										obj_t BgL_arg2475z00_2056;

																										{	/* Eval/evaluate_comp.scm 915 */
																											obj_t BgL_pairz00_8530;

																											BgL_pairz00_8530 =
																												(((BgL_ev_appz00_bglt)
																													CREF
																													(BgL_i1224z00_2014))->
																												BgL_argsz00);
																											BgL_arg2475z00_2056 =
																												CAR(CDR
																												(BgL_pairz00_8530));
																										}
																										BgL_arg2474z00_2055 =
																											BGl_compz00zz__evaluate_compz00
																											(((BgL_ev_exprz00_bglt)
																												BgL_arg2475z00_2056),
																											BgL_stkz00_188);
																									}
																									VECTOR_SET(BgL_v1616z00_2054,
																										(int) (((long) 2)),
																										BgL_arg2474z00_2055);
																								}
																								{	/* Eval/evaluate_comp.scm 915 */
																									obj_t BgL_arg2477z00_2058;

																									{	/* Eval/evaluate_comp.scm 915 */
																										obj_t BgL_arg2478z00_2059;

																										BgL_arg2478z00_2059 =
																											CAR(
																											(((BgL_ev_appz00_bglt)
																													CREF
																													(BgL_i1224z00_2014))->
																												BgL_argsz00));
																										BgL_arg2477z00_2058 =
																											BGl_compz00zz__evaluate_compz00
																											(((BgL_ev_exprz00_bglt)
																												BgL_arg2478z00_2059),
																											BgL_stkz00_188);
																									}
																									VECTOR_SET(BgL_v1616z00_2054,
																										(int) (((long) 1)),
																										BgL_arg2477z00_2058);
																								}
																								VECTOR_SET(BgL_v1616z00_2054,
																									(int) (((long) 0)),
																									BINT(((long) 11)));
																								return BgL_v1616z00_2054;
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 917 */
																								obj_t BgL_v1617z00_2061;

																								BgL_v1617z00_2061 =
																									create_vector(
																									(int) (((long) 2)));
																								{	/* Eval/evaluate_comp.scm 917 */
																									obj_t BgL_arg2480z00_2062;

																									BgL_arg2480z00_2062 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt) (
																												(BgL_ev_appz00_bglt)
																												BgL_exprz00_187)),
																										BgL_stkz00_188);
																									VECTOR_SET(BgL_v1617z00_2061,
																										(int) (((long) 1)),
																										BgL_arg2480z00_2062);
																								}
																								VECTOR_SET(BgL_v1617z00_2061,
																									(int) (((long) 0)),
																									BINT(((long) 0)));
																								return BgL_v1617z00_2061;
																							}
																					}
																			}
																	}
															}
													}
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 918 */
											obj_t BgL_v1618z00_2064;

											BgL_v1618z00_2064 = create_vector((int) (((long) 2)));
											{	/* Eval/evaluate_comp.scm 918 */
												obj_t BgL_arg2482z00_2065;

												BgL_arg2482z00_2065 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt) BgL_exprz00_187),
													BgL_stkz00_188);
												VECTOR_SET(BgL_v1618z00_2064, (int) (((long) 1)),
													BgL_arg2482z00_2065);
											}
											VECTOR_SET(BgL_v1618z00_2064,
												(int) (((long) 0)), BINT(((long) 0)));
											return BgL_v1618z00_2064;
										}
								}
						}
				}
		}
	}



/* eval-float-arith */
	double BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(obj_t BgL_bcz00_189,
		obj_t BgL_sz00_190)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 920 */
			return
				REAL_TO_DOUBLE(BGl_Ez00zz__evaluate_compz00(BgL_sz00_190,
					BgL_bcz00_189));
		}
	}



/* E */
	obj_t BGl_Ez00zz__evaluate_compz00(obj_t BgL_sz00_17704, obj_t BgL_bcz00_2070)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 935 */
			{	/* Eval/evaluate_comp.scm 922 */
				obj_t BgL_aux1226z00_2073;

				BgL_aux1226z00_2073 = VECTOR_REF(BgL_bcz00_2070, (int) (((long) 0)));
				if (INTEGERP(BgL_aux1226z00_2073))
					{	/* Eval/evaluate_comp.scm 922 */
						switch ((long) CINT(BgL_aux1226z00_2073))
							{
							case ((long) 0):

								{	/* Eval/evaluate_comp.scm 923 */
									obj_t BgL_fun2486z00_2075;

									BgL_fun2486z00_2075 =
										VECTOR_REF(BgL_bcz00_2070, (int) (((long) 1)));
									return
										PROCEDURE_ENTRY(BgL_fun2486z00_2075) (BgL_fun2486z00_2075,
										BgL_sz00_17704, BEOA);
								}
								break;
							case ((long) 1):

								return VECTOR_REF(BgL_bcz00_2070, (int) (((long) 1)));
								break;
							case ((long) 2):

								{	/* Eval/evaluate_comp.scm 925 */
									long BgL_arg2487z00_2076;

									{	/* Eval/evaluate_comp.scm 925 */
										obj_t BgL_arg2488z00_2077;
										obj_t BgL_arg2490z00_2078;

										BgL_arg2488z00_2077 =
											VECTOR_REF(BgL_sz00_17704, (int) (((long) 0)));
										BgL_arg2490z00_2078 =
											VECTOR_REF(BgL_bcz00_2070, (int) (((long) 1)));
										BgL_arg2487z00_2076 =
											(
											(long) CINT(BgL_arg2488z00_2077) +
											(long) CINT(BgL_arg2490z00_2078));
									}
									return
										VECTOR_REF(BgL_sz00_17704, (int) (BgL_arg2487z00_2076));
								} break;
							case ((long) 3):

								{	/* Eval/evaluate_comp.scm 926 */
									obj_t BgL_arg2492z00_2079;

									{	/* Eval/evaluate_comp.scm 926 */
										long BgL_arg2493z00_2080;

										{	/* Eval/evaluate_comp.scm 926 */
											obj_t BgL_arg2494z00_2081;
											obj_t BgL_arg2495z00_2082;

											BgL_arg2494z00_2081 =
												VECTOR_REF(BgL_sz00_17704, (int) (((long) 0)));
											BgL_arg2495z00_2082 =
												VECTOR_REF(BgL_sz00_17704, (int) (((long) 1)));
											BgL_arg2493z00_2080 =
												(
												(long) CINT(BgL_arg2494z00_2081) +
												(long) CINT(BgL_arg2495z00_2082));
										}
										BgL_arg2492z00_2079 =
											VECTOR_REF(BgL_sz00_17704, (int) (BgL_arg2493z00_2080));
									}
									return STRUCT_REF(BgL_arg2492z00_2079, (int) (((long) 0)));
								} break;
							case ((long) 4):

								{	/* Eval/evaluate_comp.scm 927 */
									obj_t BgL_arg2496z00_2083;

									{	/* Eval/evaluate_comp.scm 927 */
										obj_t BgL_arg2497z00_2084;

										BgL_arg2497z00_2084 =
											VECTOR_REF(BgL_bcz00_2070, (int) (((long) 1)));
										BgL_arg2496z00_2083 =
											VECTOR_REF(BgL_arg2497z00_2084, (int) (((long) 2)));
									}
									return __EVMEANING_ADDRESS_REF(BgL_arg2496z00_2083);
								}
								break;
							case ((long) 5):

								{	/* Eval/evaluate_comp.scm 928 */
									obj_t BgL_arg2498z00_2085;

									BgL_arg2498z00_2085 =
										VECTOR_REF(BgL_bcz00_2070, (int) (((long) 1)));
									return VECTOR_REF(BgL_arg2498z00_2085, (int) (((long) 2)));
								} break;
							case ((long) 6):

								{	/* Eval/evaluate_comp.scm 929 */
									obj_t BgL_arg2499z00_2086;
									obj_t BgL_arg2500z00_2087;

									BgL_arg2499z00_2086 =
										BGl_Ez00zz__evaluate_compz00(BgL_sz00_17704,
										VECTOR_REF(BgL_bcz00_2070, (int) (((long) 1))));
									BgL_arg2500z00_2087 =
										BGl_Ez00zz__evaluate_compz00(BgL_sz00_17704,
										VECTOR_REF(BgL_bcz00_2070, (int) (((long) 2))));
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2499z00_2086) +
											REAL_TO_DOUBLE(BgL_arg2500z00_2087)));
								}
								break;
							case ((long) 7):

								{	/* Eval/evaluate_comp.scm 930 */
									obj_t BgL_arg2504z00_2090;
									obj_t BgL_arg2505z00_2091;

									BgL_arg2504z00_2090 =
										BGl_Ez00zz__evaluate_compz00(BgL_sz00_17704,
										VECTOR_REF(BgL_bcz00_2070, (int) (((long) 1))));
									BgL_arg2505z00_2091 =
										BGl_Ez00zz__evaluate_compz00(BgL_sz00_17704,
										VECTOR_REF(BgL_bcz00_2070, (int) (((long) 2))));
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2504z00_2090) -
											REAL_TO_DOUBLE(BgL_arg2505z00_2091)));
								}
								break;
							case ((long) 8):

								{	/* Eval/evaluate_comp.scm 931 */
									obj_t BgL_arg2508z00_2094;
									obj_t BgL_arg2509z00_2095;

									BgL_arg2508z00_2094 =
										BGl_Ez00zz__evaluate_compz00(BgL_sz00_17704,
										VECTOR_REF(BgL_bcz00_2070, (int) (((long) 1))));
									BgL_arg2509z00_2095 =
										BGl_Ez00zz__evaluate_compz00(BgL_sz00_17704,
										VECTOR_REF(BgL_bcz00_2070, (int) (((long) 2))));
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2508z00_2094) *
											REAL_TO_DOUBLE(BgL_arg2509z00_2095)));
								}
								break;
							case ((long) 9):

								{	/* Eval/evaluate_comp.scm 932 */
									obj_t BgL_arg2512z00_2098;
									obj_t BgL_arg2513z00_2099;

									BgL_arg2512z00_2098 =
										BGl_Ez00zz__evaluate_compz00(BgL_sz00_17704,
										VECTOR_REF(BgL_bcz00_2070, (int) (((long) 1))));
									BgL_arg2513z00_2099 =
										BGl_Ez00zz__evaluate_compz00(BgL_sz00_17704,
										VECTOR_REF(BgL_bcz00_2070, (int) (((long) 2))));
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2512z00_2098) /
											REAL_TO_DOUBLE(BgL_arg2513z00_2099)));
								}
								break;
							case ((long) 10):

								{	/* Eval/evaluate_comp.scm 933 */
									obj_t BgL_arg2516z00_2102;

									{	/* Eval/evaluate_comp.scm 933 */
										obj_t BgL_fun2517z00_2103;

										BgL_fun2517z00_2103 =
											VECTOR_REF(BgL_bcz00_2070, (int) (((long) 1)));
										BgL_arg2516z00_2102 =
											PROCEDURE_ENTRY(BgL_fun2517z00_2103) (BgL_fun2517z00_2103,
											BgL_sz00_17704, BEOA);
									}
									return
										DOUBLE_TO_REAL((double) ((long) CINT(BgL_arg2516z00_2102)));
								} break;
							case ((long) 11):

								{	/* Eval/evaluate_comp.scm 934 */
									obj_t BgL_arg2518z00_2104;
									obj_t BgL_arg2519z00_2105;

									{	/* Eval/evaluate_comp.scm 934 */
										obj_t BgL_fun2520z00_2106;

										BgL_fun2520z00_2106 =
											VECTOR_REF(BgL_bcz00_2070, (int) (((long) 1)));
										BgL_arg2518z00_2104 =
											PROCEDURE_ENTRY(BgL_fun2520z00_2106) (BgL_fun2520z00_2106,
											BgL_sz00_17704, BEOA);
									}
									{	/* Eval/evaluate_comp.scm 934 */
										obj_t BgL_fun2521z00_2107;

										BgL_fun2521z00_2107 =
											VECTOR_REF(BgL_bcz00_2070, (int) (((long) 2)));
										BgL_arg2519z00_2105 =
											PROCEDURE_ENTRY(BgL_fun2521z00_2107) (BgL_fun2521z00_2107,
											BgL_sz00_17704, BEOA);
									}
									{	/* Eval/evaluate_comp.scm 934 */
										double BgL_auxz00_21094;

										{	/* Eval/evaluate_comp.scm 934 */
											long BgL_auxz00_21095;

											BgL_auxz00_21095 = (long) CINT(BgL_arg2519z00_2105);
											BgL_auxz00_21094 =
												BGL_F64VREF(BgL_arg2518z00_2104, BgL_auxz00_21095);
										}
										return DOUBLE_TO_REAL(BgL_auxz00_21094);
									}
								}
								break;
							default:
								return
									BGl_errorz00zz__errorz00
									(BGl_string5561z00zz__evaluate_compz00,
									BGl_string5580z00zz__evaluate_compz00,
									VECTOR_REF(BgL_bcz00_2070, (int) (((long) 0))));
					}}
				else
					{	/* Eval/evaluate_comp.scm 922 */
						return
							BGl_errorz00zz__errorz00(BGl_string5561z00zz__evaluate_compz00,
							BGl_string5580z00zz__evaluate_compz00, VECTOR_REF(BgL_bcz00_2070,
								(int) (((long) 0))));
		}}}
	}



/* arith-expression */
	obj_t BGl_arithzd2expressionzd2zz__evaluate_compz00(BgL_ev_appz00_bglt
		BgL_exprz00_191, obj_t BgL_stkz00_192)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 938 */
			{	/* Eval/evaluate_comp.scm 940 */
				obj_t BgL_fvalz00_2111;

				BgL_fvalz00_2111 =
					BGl_globalzd2funzd2valuez00zz__evaluate_compz00(
					(((BgL_ev_appz00_bglt) CREF(BgL_exprz00_191))->BgL_funz00));
				{	/* Eval/evaluate_comp.scm 941 */
					bool_t BgL_testz00_21109;

					if (
						(BgL_fvalz00_2111 ==
							BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
						{	/* Eval/evaluate_comp.scm 941 */
							BgL_testz00_21109 = ((bool_t) 1);
						}
					else
						{	/* Eval/evaluate_comp.scm 941 */
							if (
								(BgL_fvalz00_2111 ==
									BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
								{	/* Eval/evaluate_comp.scm 941 */
									BgL_testz00_21109 = ((bool_t) 1);
								}
							else
								{	/* Eval/evaluate_comp.scm 941 */
									if (
										(BgL_fvalz00_2111 ==
											BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
										{	/* Eval/evaluate_comp.scm 941 */
											BgL_testz00_21109 = ((bool_t) 1);
										}
									else
										{	/* Eval/evaluate_comp.scm 941 */
											BgL_testz00_21109 =
												(BgL_fvalz00_2111 ==
												BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00);
										}
								}
						}
					if (BgL_testz00_21109)
						{	/* Eval/evaluate_comp.scm 942 */
							obj_t BgL_bcz00_2113;

							BgL_bcz00_2113 =
								BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(
								((obj_t) BgL_exprz00_191), BgL_stkz00_192);
							{	/* Eval/evaluate_comp.scm 943 */
								obj_t BgL_zc3anonymousza32524ze3z83_15847;

								BgL_zc3anonymousza32524ze3z83_15847 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32524ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_zc3anonymousza32524ze3z83_15847,
									(int) (((long) 0)), BgL_bcz00_2113);
								return BgL_zc3anonymousza32524ze3z83_15847;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 941 */
							return BFALSE;
						}
				}
			}
		}
	}



/* &<anonymous:2524> */
	obj_t BGl_z62zc3anonymousza32524ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15848, obj_t BgL_sz00_15850)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 943 */
			{	/* Eval/evaluate_comp.scm 943 */
				obj_t BgL_bcz00_15849;

				BgL_bcz00_15849 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15848, (int) (((long) 0))));
				{
					obj_t BgL_sz00_2114;

					{	/* Eval/evaluate_comp.scm 943 */
						double BgL_auxz00_21127;

						BgL_sz00_2114 = BgL_sz00_15850;
						{	/* Eval/evaluate_comp.scm 943 */
							obj_t BgL_bpz00_8638;

							BgL_bpz00_8638 = VECTOR_REF(BgL_sz00_2114, (int) (((long) 0)));
							BgL_auxz00_21127 =
								BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(BgL_bcz00_15849,
								BgL_sz00_2114);
						}
						return DOUBLE_TO_REAL(BgL_auxz00_21127);
					}
				}
			}
		}
	}



/* inline-call */
	obj_t BGl_inlinezd2callzd2zz__evaluate_compz00(obj_t BgL_locz00_193,
		BgL_ev_exprz00_bglt BgL_funz00_194, obj_t BgL_argsz00_195,
		obj_t BgL_stkz00_196)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 969 */
			{	/* Eval/evaluate_comp.scm 970 */
				obj_t BgL_valz00_2121;

				BgL_valz00_2121 =
					BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_funz00_194);
				if (CBOOL(BgL_valz00_2121))
					{	/* Eval/evaluate_comp.scm 972 */
						long BgL_nz00_2122;

						BgL_nz00_2122 = bgl_list_length(BgL_argsz00_195);
						{	/* Eval/evaluate_comp.scm 973 */
							obj_t BgL__ortest_1232z00_2123;

							if ((BgL_nz00_2122 == ((long) 1)))
								{	/* Eval/evaluate_comp.scm 974 */
									obj_t BgL_a1z00_2414;

									BgL_a1z00_2414 = CAR(BgL_argsz00_195);
									if (
										(BgL_valz00_2121 ==
											BGl_carzd2envzd2zz__r4_pairs_and_lists_6_3z00))
										{	/* Eval/evaluate_comp.scm 975 */
											obj_t BgL_a1z00_2416;

											BgL_a1z00_2416 =
												BGl_compz00zz__evaluate_compz00(
												((BgL_ev_exprz00_bglt) BgL_a1z00_2414), BgL_stkz00_196);
											{	/* Eval/evaluate_comp.scm 975 */
												obj_t BgL_zc3anonymousza32644ze3z83_15880;

												BgL_zc3anonymousza32644ze3z83_15880 =
													MAKE_FX_PROCEDURE
													(BGl_z62zc3anonymousza32644ze3ze1zz__evaluate_compz00,
													(int) (((long) 1)), (int) (((long) 2)));
												PROCEDURE_SET(BgL_zc3anonymousza32644ze3z83_15880,
													(int) (((long) 0)), BgL_a1z00_2416);
												PROCEDURE_SET(BgL_zc3anonymousza32644ze3z83_15880,
													(int) (((long) 1)), BgL_locz00_193);
												BgL__ortest_1232z00_2123 =
													BgL_zc3anonymousza32644ze3z83_15880;
										}}
									else
										{	/* Eval/evaluate_comp.scm 975 */
											if (
												(BgL_valz00_2121 ==
													BGl_cdrzd2envzd2zz__r4_pairs_and_lists_6_3z00))
												{	/* Eval/evaluate_comp.scm 975 */
													obj_t BgL_a1z00_2423;

													BgL_a1z00_2423 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_a1z00_2414),
														BgL_stkz00_196);
													{	/* Eval/evaluate_comp.scm 975 */
														obj_t BgL_zc3anonymousza32647ze3z83_15881;

														BgL_zc3anonymousza32647ze3z83_15881 =
															MAKE_FX_PROCEDURE
															(BGl_z62zc3anonymousza32647ze3ze1zz__evaluate_compz00,
															(int) (((long) 1)), (int) (((long) 2)));
														PROCEDURE_SET(BgL_zc3anonymousza32647ze3z83_15881,
															(int) (((long) 0)), BgL_a1z00_2423);
														PROCEDURE_SET(BgL_zc3anonymousza32647ze3z83_15881,
															(int) (((long) 1)), BgL_locz00_193);
														BgL__ortest_1232z00_2123 =
															BgL_zc3anonymousza32647ze3z83_15881;
												}}
											else
												{	/* Eval/evaluate_comp.scm 975 */
													if (
														(BgL_valz00_2121 ==
															BGl_cadrzd2envzd2zz__r4_pairs_and_lists_6_3z00))
														{	/* Eval/evaluate_comp.scm 975 */
															obj_t BgL_a1z00_2430;

															BgL_a1z00_2430 =
																BGl_compz00zz__evaluate_compz00(
																((BgL_ev_exprz00_bglt) BgL_a1z00_2414),
																BgL_stkz00_196);
															{	/* Eval/evaluate_comp.scm 975 */
																obj_t BgL_zc3anonymousza32650ze3z83_15882;

																BgL_zc3anonymousza32650ze3z83_15882 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza32650ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 2)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza32650ze3z83_15882,
																	(int) (((long) 0)), BgL_a1z00_2430);
																PROCEDURE_SET
																	(BgL_zc3anonymousza32650ze3z83_15882,
																	(int) (((long) 1)), BgL_locz00_193);
																BgL__ortest_1232z00_2123 =
																	BgL_zc3anonymousza32650ze3z83_15882;
														}}
													else
														{	/* Eval/evaluate_comp.scm 975 */
															BgL__ortest_1232z00_2123 = BFALSE;
														}
												}
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 973 */
									BgL__ortest_1232z00_2123 = BFALSE;
								}
							if (CBOOL(BgL__ortest_1232z00_2123))
								{	/* Eval/evaluate_comp.scm 973 */
									return BgL__ortest_1232z00_2123;
								}
							else
								{	/* Eval/evaluate_comp.scm 973 */
									if ((BgL_nz00_2122 == ((long) 2)))
										{	/* Eval/evaluate_comp.scm 977 */
											obj_t BgL_a1z00_2125;
											obj_t BgL_a2z00_2126;

											BgL_a1z00_2125 = CAR(BgL_argsz00_195);
											{	/* Eval/evaluate_comp.scm 977 */
												obj_t BgL_pairz00_8673;

												BgL_pairz00_8673 = BgL_argsz00_195;
												BgL_a2z00_2126 = CAR(CDR(BgL_pairz00_8673));
											}
											if (
												(BgL_valz00_2121 ==
													BGl_zb2zd2envz60zz__r4_numbers_6_5z00))
												{	/* Eval/evaluate_comp.scm 978 */
													obj_t BgL_a1z00_2128;
													obj_t BgL_a2z00_2129;

													BgL_a1z00_2128 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_a1z00_2125),
														BgL_stkz00_196);
													BgL_a2z00_2129 =
														BGl_compz00zz__evaluate_compz00((
															(BgL_ev_exprz00_bglt) BgL_a2z00_2126),
														BgL_stkz00_196);
													{	/* Eval/evaluate_comp.scm 978 */
														obj_t BgL_zc3anonymousza32531ze3z83_15851;

														BgL_zc3anonymousza32531ze3z83_15851 =
															MAKE_FX_PROCEDURE
															(BGl_z62zc3anonymousza32531ze3ze1zz__evaluate_compz00,
															(int) (((long) 1)), (int) (((long) 3)));
														PROCEDURE_SET(BgL_zc3anonymousza32531ze3z83_15851,
															(int) (((long) 0)), BgL_a1z00_2128);
														PROCEDURE_SET(BgL_zc3anonymousza32531ze3z83_15851,
															(int) (((long) 1)), BgL_a2z00_2129);
														PROCEDURE_SET(BgL_zc3anonymousza32531ze3z83_15851,
															(int) (((long) 2)), BgL_locz00_193);
														return BgL_zc3anonymousza32531ze3z83_15851;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 978 */
													if (
														(BgL_valz00_2121 ==
															BGl_zd2zd2envz00zz__r4_numbers_6_5z00))
														{	/* Eval/evaluate_comp.scm 978 */
															obj_t BgL_a1z00_2138;
															obj_t BgL_a2z00_2139;

															BgL_a1z00_2138 =
																BGl_compz00zz__evaluate_compz00(
																((BgL_ev_exprz00_bglt) BgL_a1z00_2125),
																BgL_stkz00_196);
															BgL_a2z00_2139 =
																BGl_compz00zz__evaluate_compz00((
																	(BgL_ev_exprz00_bglt) BgL_a2z00_2126),
																BgL_stkz00_196);
															{	/* Eval/evaluate_comp.scm 978 */
																obj_t BgL_zc3anonymousza32535ze3z83_15852;

																BgL_zc3anonymousza32535ze3z83_15852 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3anonymousza32535ze3ze1zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 3)));
																PROCEDURE_SET
																	(BgL_zc3anonymousza32535ze3z83_15852,
																	(int) (((long) 0)), BgL_a1z00_2138);
																PROCEDURE_SET
																	(BgL_zc3anonymousza32535ze3z83_15852,
																	(int) (((long) 1)), BgL_a2z00_2139);
																PROCEDURE_SET
																	(BgL_zc3anonymousza32535ze3z83_15852,
																	(int) (((long) 2)), BgL_locz00_193);
																return BgL_zc3anonymousza32535ze3z83_15852;
															}
														}
													else
														{	/* Eval/evaluate_comp.scm 978 */
															if (
																(BgL_valz00_2121 ==
																	BGl_za2zd2envz70zz__r4_numbers_6_5z00))
																{	/* Eval/evaluate_comp.scm 978 */
																	obj_t BgL_a1z00_2148;
																	obj_t BgL_a2z00_2149;

																	BgL_a1z00_2148 =
																		BGl_compz00zz__evaluate_compz00(
																		((BgL_ev_exprz00_bglt) BgL_a1z00_2125),
																		BgL_stkz00_196);
																	BgL_a2z00_2149 =
																		BGl_compz00zz__evaluate_compz00((
																			(BgL_ev_exprz00_bglt) BgL_a2z00_2126),
																		BgL_stkz00_196);
																	{	/* Eval/evaluate_comp.scm 978 */
																		obj_t BgL_zc3anonymousza32539ze3z83_15853;

																		BgL_zc3anonymousza32539ze3z83_15853 =
																			MAKE_FX_PROCEDURE
																			(BGl_z62zc3anonymousza32539ze3ze1zz__evaluate_compz00,
																			(int) (((long) 1)), (int) (((long) 3)));
																		PROCEDURE_SET
																			(BgL_zc3anonymousza32539ze3z83_15853,
																			(int) (((long) 0)), BgL_a1z00_2148);
																		PROCEDURE_SET
																			(BgL_zc3anonymousza32539ze3z83_15853,
																			(int) (((long) 1)), BgL_a2z00_2149);
																		PROCEDURE_SET
																			(BgL_zc3anonymousza32539ze3z83_15853,
																			(int) (((long) 2)), BgL_locz00_193);
																		return BgL_zc3anonymousza32539ze3z83_15853;
																	}
																}
															else
																{	/* Eval/evaluate_comp.scm 978 */
																	if (
																		(BgL_valz00_2121 ==
																			BGl_zf2zd2envz20zz__r4_numbers_6_5z00))
																		{	/* Eval/evaluate_comp.scm 978 */
																			obj_t BgL_a1z00_2158;
																			obj_t BgL_a2z00_2159;

																			BgL_a1z00_2158 =
																				BGl_compz00zz__evaluate_compz00(
																				((BgL_ev_exprz00_bglt) BgL_a1z00_2125),
																				BgL_stkz00_196);
																			BgL_a2z00_2159 =
																				BGl_compz00zz__evaluate_compz00((
																					(BgL_ev_exprz00_bglt) BgL_a2z00_2126),
																				BgL_stkz00_196);
																			{	/* Eval/evaluate_comp.scm 978 */
																				obj_t
																					BgL_zc3anonymousza32543ze3z83_15854;
																				BgL_zc3anonymousza32543ze3z83_15854 =
																					MAKE_FX_PROCEDURE
																					(BGl_z62zc3anonymousza32543ze3ze1zz__evaluate_compz00,
																					(int) (((long) 1)),
																					(int) (((long) 3)));
																				PROCEDURE_SET
																					(BgL_zc3anonymousza32543ze3z83_15854,
																					(int) (((long) 0)), BgL_a1z00_2158);
																				PROCEDURE_SET
																					(BgL_zc3anonymousza32543ze3z83_15854,
																					(int) (((long) 1)), BgL_a2z00_2159);
																				PROCEDURE_SET
																					(BgL_zc3anonymousza32543ze3z83_15854,
																					(int) (((long) 2)), BgL_locz00_193);
																				return
																					BgL_zc3anonymousza32543ze3z83_15854;
																			}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 978 */
																			if (
																				(BgL_valz00_2121 ==
																					BGl_zc3zd2envz11zz__r4_numbers_6_5z00))
																				{	/* Eval/evaluate_comp.scm 978 */
																					obj_t BgL_a1z00_2168;
																					obj_t BgL_a2z00_2169;

																					BgL_a1z00_2168 =
																						BGl_compz00zz__evaluate_compz00(
																						((BgL_ev_exprz00_bglt)
																							BgL_a1z00_2125), BgL_stkz00_196);
																					BgL_a2z00_2169 =
																						BGl_compz00zz__evaluate_compz00((
																							(BgL_ev_exprz00_bglt)
																							BgL_a2z00_2126), BgL_stkz00_196);
																					{	/* Eval/evaluate_comp.scm 978 */
																						obj_t
																							BgL_zc3anonymousza32547ze3z83_15855;
																						BgL_zc3anonymousza32547ze3z83_15855
																							=
																							MAKE_FX_PROCEDURE
																							(BGl_z62zc3anonymousza32547ze3ze1zz__evaluate_compz00,
																							(int) (((long) 1)),
																							(int) (((long) 3)));
																						PROCEDURE_SET
																							(BgL_zc3anonymousza32547ze3z83_15855,
																							(int) (((long) 0)),
																							BgL_a1z00_2168);
																						PROCEDURE_SET
																							(BgL_zc3anonymousza32547ze3z83_15855,
																							(int) (((long) 1)),
																							BgL_a2z00_2169);
																						PROCEDURE_SET
																							(BgL_zc3anonymousza32547ze3z83_15855,
																							(int) (((long) 2)),
																							BgL_locz00_193);
																						return
																							BgL_zc3anonymousza32547ze3z83_15855;
																					}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 978 */
																					if (
																						(BgL_valz00_2121 ==
																							BGl_ze3zd2envz31zz__r4_numbers_6_5z00))
																						{	/* Eval/evaluate_comp.scm 978 */
																							obj_t BgL_a1z00_2178;
																							obj_t BgL_a2z00_2179;

																							BgL_a1z00_2178 =
																								BGl_compz00zz__evaluate_compz00(
																								((BgL_ev_exprz00_bglt)
																									BgL_a1z00_2125),
																								BgL_stkz00_196);
																							BgL_a2z00_2179 =
																								BGl_compz00zz__evaluate_compz00(
																								((BgL_ev_exprz00_bglt)
																									BgL_a2z00_2126),
																								BgL_stkz00_196);
																							{	/* Eval/evaluate_comp.scm 978 */
																								obj_t
																									BgL_zc3anonymousza32551ze3z83_15856;
																								BgL_zc3anonymousza32551ze3z83_15856
																									=
																									MAKE_FX_PROCEDURE
																									(BGl_z62zc3anonymousza32551ze3ze1zz__evaluate_compz00,
																									(int) (((long) 1)),
																									(int) (((long) 3)));
																								PROCEDURE_SET
																									(BgL_zc3anonymousza32551ze3z83_15856,
																									(int) (((long) 0)),
																									BgL_a1z00_2178);
																								PROCEDURE_SET
																									(BgL_zc3anonymousza32551ze3z83_15856,
																									(int) (((long) 1)),
																									BgL_a2z00_2179);
																								PROCEDURE_SET
																									(BgL_zc3anonymousza32551ze3z83_15856,
																									(int) (((long) 2)),
																									BgL_locz00_193);
																								return
																									BgL_zc3anonymousza32551ze3z83_15856;
																							}
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 978 */
																							if (
																								(BgL_valz00_2121 ==
																									BGl_zc3zd3zd2envzc2zz__r4_numbers_6_5z00))
																								{	/* Eval/evaluate_comp.scm 978 */
																									obj_t BgL_a1z00_2188;
																									obj_t BgL_a2z00_2189;

																									BgL_a1z00_2188 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_a1z00_2125),
																										BgL_stkz00_196);
																									BgL_a2z00_2189 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_a2z00_2126),
																										BgL_stkz00_196);
																									{	/* Eval/evaluate_comp.scm 978 */
																										obj_t
																											BgL_zc3anonymousza32555ze3z83_15857;
																										BgL_zc3anonymousza32555ze3z83_15857
																											=
																											MAKE_FX_PROCEDURE
																											(BGl_z62zc3anonymousza32555ze3ze1zz__evaluate_compz00,
																											(int) (((long) 1)),
																											(int) (((long) 3)));
																										PROCEDURE_SET
																											(BgL_zc3anonymousza32555ze3z83_15857,
																											(int) (((long) 0)),
																											BgL_a1z00_2188);
																										PROCEDURE_SET
																											(BgL_zc3anonymousza32555ze3z83_15857,
																											(int) (((long) 1)),
																											BgL_a2z00_2189);
																										PROCEDURE_SET
																											(BgL_zc3anonymousza32555ze3z83_15857,
																											(int) (((long) 2)),
																											BgL_locz00_193);
																										return
																											BgL_zc3anonymousza32555ze3z83_15857;
																									}
																								}
																							else
																								{	/* Eval/evaluate_comp.scm 978 */
																									if (
																										(BgL_valz00_2121 ==
																											BGl_ze3zd3zd2envze2zz__r4_numbers_6_5z00))
																										{	/* Eval/evaluate_comp.scm 978 */
																											obj_t BgL_a1z00_2198;
																											obj_t BgL_a2z00_2199;

																											BgL_a1z00_2198 =
																												BGl_compz00zz__evaluate_compz00
																												(((BgL_ev_exprz00_bglt)
																													BgL_a1z00_2125),
																												BgL_stkz00_196);
																											BgL_a2z00_2199 =
																												BGl_compz00zz__evaluate_compz00
																												(((BgL_ev_exprz00_bglt)
																													BgL_a2z00_2126),
																												BgL_stkz00_196);
																											{	/* Eval/evaluate_comp.scm 978 */
																												obj_t
																													BgL_zc3anonymousza32559ze3z83_15858;
																												BgL_zc3anonymousza32559ze3z83_15858
																													=
																													MAKE_FX_PROCEDURE
																													(BGl_z62zc3anonymousza32559ze3ze1zz__evaluate_compz00,
																													(int) (((long) 1)),
																													(int) (((long) 3)));
																												PROCEDURE_SET
																													(BgL_zc3anonymousza32559ze3z83_15858,
																													(int) (((long) 0)),
																													BgL_a1z00_2198);
																												PROCEDURE_SET
																													(BgL_zc3anonymousza32559ze3z83_15858,
																													(int) (((long) 1)),
																													BgL_a2z00_2199);
																												PROCEDURE_SET
																													(BgL_zc3anonymousza32559ze3z83_15858,
																													(int) (((long) 2)),
																													BgL_locz00_193);
																												return
																													BgL_zc3anonymousza32559ze3z83_15858;
																											}
																										}
																									else
																										{	/* Eval/evaluate_comp.scm 978 */
																											if (
																												(BgL_valz00_2121 ==
																													BGl_zd3zd2envz01zz__r4_numbers_6_5z00))
																												{	/* Eval/evaluate_comp.scm 978 */
																													obj_t BgL_a1z00_2208;
																													obj_t BgL_a2z00_2209;

																													BgL_a1z00_2208 =
																														BGl_compz00zz__evaluate_compz00
																														(((BgL_ev_exprz00_bglt) BgL_a1z00_2125), BgL_stkz00_196);
																													BgL_a2z00_2209 =
																														BGl_compz00zz__evaluate_compz00
																														(((BgL_ev_exprz00_bglt) BgL_a2z00_2126), BgL_stkz00_196);
																													{	/* Eval/evaluate_comp.scm 978 */
																														obj_t
																															BgL_zc3anonymousza32563ze3z83_15859;
																														BgL_zc3anonymousza32563ze3z83_15859
																															=
																															MAKE_FX_PROCEDURE
																															(BGl_z62zc3anonymousza32563ze3ze1zz__evaluate_compz00,
																															(int) (((long)
																																	1)),
																															(int) (((long)
																																	3)));
																														PROCEDURE_SET
																															(BgL_zc3anonymousza32563ze3z83_15859,
																															(int) (((long)
																																	0)),
																															BgL_a1z00_2208);
																														PROCEDURE_SET
																															(BgL_zc3anonymousza32563ze3z83_15859,
																															(int) (((long)
																																	1)),
																															BgL_a2z00_2209);
																														PROCEDURE_SET
																															(BgL_zc3anonymousza32563ze3z83_15859,
																															(int) (((long)
																																	2)),
																															BgL_locz00_193);
																														return
																															BgL_zc3anonymousza32563ze3z83_15859;
																													}
																												}
																											else
																												{	/* Eval/evaluate_comp.scm 978 */
																													if (
																														(BgL_valz00_2121 ==
																															BGl_zb2fxzd2envz60zz__r4_numbers_6_5_fixnumz00))
																														{	/* Eval/evaluate_comp.scm 978 */
																															obj_t
																																BgL_a1z00_2218;
																															obj_t
																																BgL_a2z00_2219;
																															BgL_a1z00_2218 =
																																BGl_compz00zz__evaluate_compz00
																																(((BgL_ev_exprz00_bglt) BgL_a1z00_2125), BgL_stkz00_196);
																															BgL_a2z00_2219 =
																																BGl_compz00zz__evaluate_compz00
																																(((BgL_ev_exprz00_bglt) BgL_a2z00_2126), BgL_stkz00_196);
																															{	/* Eval/evaluate_comp.scm 978 */
																																obj_t
																																	BgL_zc3anonymousza32567ze3z83_15860;
																																BgL_zc3anonymousza32567ze3z83_15860
																																	=
																																	MAKE_FX_PROCEDURE
																																	(BGl_z62zc3anonymousza32567ze3ze1zz__evaluate_compz00,
																																	(int) (((long)
																																			1)),
																																	(int) (((long)
																																			3)));
																																PROCEDURE_SET
																																	(BgL_zc3anonymousza32567ze3z83_15860,
																																	(int) (((long)
																																			0)),
																																	BgL_a1z00_2218);
																																PROCEDURE_SET
																																	(BgL_zc3anonymousza32567ze3z83_15860,
																																	(int) (((long)
																																			1)),
																																	BgL_a2z00_2219);
																																PROCEDURE_SET
																																	(BgL_zc3anonymousza32567ze3z83_15860,
																																	(int) (((long)
																																			2)),
																																	BgL_locz00_193);
																																return
																																	BgL_zc3anonymousza32567ze3z83_15860;
																															}
																														}
																													else
																														{	/* Eval/evaluate_comp.scm 978 */
																															if (
																																(BgL_valz00_2121
																																	==
																																	BGl_zd2fxzd2envz00zz__r4_numbers_6_5_fixnumz00))
																																{	/* Eval/evaluate_comp.scm 978 */
																																	obj_t
																																		BgL_a1z00_2228;
																																	obj_t
																																		BgL_a2z00_2229;
																																	BgL_a1z00_2228
																																		=
																																		BGl_compz00zz__evaluate_compz00
																																		(((BgL_ev_exprz00_bglt) BgL_a1z00_2125), BgL_stkz00_196);
																																	BgL_a2z00_2229
																																		=
																																		BGl_compz00zz__evaluate_compz00
																																		(((BgL_ev_exprz00_bglt) BgL_a2z00_2126), BgL_stkz00_196);
																																	{	/* Eval/evaluate_comp.scm 978 */
																																		obj_t
																																			BgL_zc3anonymousza32571ze3z83_15861;
																																		BgL_zc3anonymousza32571ze3z83_15861
																																			=
																																			MAKE_FX_PROCEDURE
																																			(BGl_z62zc3anonymousza32571ze3ze1zz__evaluate_compz00,
																																			(int) ((
																																					(long)
																																					1)),
																																			(int) ((
																																					(long)
																																					3)));
																																		PROCEDURE_SET
																																			(BgL_zc3anonymousza32571ze3z83_15861,
																																			(int) ((
																																					(long)
																																					0)),
																																			BgL_a1z00_2228);
																																		PROCEDURE_SET
																																			(BgL_zc3anonymousza32571ze3z83_15861,
																																			(int) ((
																																					(long)
																																					1)),
																																			BgL_a2z00_2229);
																																		PROCEDURE_SET
																																			(BgL_zc3anonymousza32571ze3z83_15861,
																																			(int) ((
																																					(long)
																																					2)),
																																			BgL_locz00_193);
																																		return
																																			BgL_zc3anonymousza32571ze3z83_15861;
																																	}
																																}
																															else
																																{	/* Eval/evaluate_comp.scm 978 */
																																	if (
																																		(BgL_valz00_2121
																																			==
																																			BGl_za2fxzd2envz70zz__r4_numbers_6_5_fixnumz00))
																																		{	/* Eval/evaluate_comp.scm 978 */
																																			obj_t
																																				BgL_a1z00_2238;
																																			obj_t
																																				BgL_a2z00_2239;
																																			BgL_a1z00_2238
																																				=
																																				BGl_compz00zz__evaluate_compz00
																																				(((BgL_ev_exprz00_bglt) BgL_a1z00_2125), BgL_stkz00_196);
																																			BgL_a2z00_2239
																																				=
																																				BGl_compz00zz__evaluate_compz00
																																				(((BgL_ev_exprz00_bglt) BgL_a2z00_2126), BgL_stkz00_196);
																																			{	/* Eval/evaluate_comp.scm 978 */
																																				obj_t
																																					BgL_zc3anonymousza32575ze3z83_15862;
																																				BgL_zc3anonymousza32575ze3z83_15862
																																					=
																																					MAKE_FX_PROCEDURE
																																					(BGl_z62zc3anonymousza32575ze3ze1zz__evaluate_compz00,
																																					(int)
																																					(((long) 1)), (int) (((long) 3)));
																																				PROCEDURE_SET
																																					(BgL_zc3anonymousza32575ze3z83_15862,
																																					(int)
																																					(((long) 0)), BgL_a1z00_2238);
																																				PROCEDURE_SET
																																					(BgL_zc3anonymousza32575ze3z83_15862,
																																					(int)
																																					(((long) 1)), BgL_a2z00_2239);
																																				PROCEDURE_SET
																																					(BgL_zc3anonymousza32575ze3z83_15862,
																																					(int)
																																					(((long) 2)), BgL_locz00_193);
																																				return
																																					BgL_zc3anonymousza32575ze3z83_15862;
																																			}
																																		}
																																	else
																																		{	/* Eval/evaluate_comp.scm 978 */
																																			if (
																																				(BgL_valz00_2121
																																					==
																																					BGl_zf2fxzd2envz20zz__r4_numbers_6_5_fixnumz00))
																																				{	/* Eval/evaluate_comp.scm 978 */
																																					obj_t
																																						BgL_a1z00_2248;
																																					obj_t
																																						BgL_a2z00_2249;
																																					BgL_a1z00_2248
																																						=
																																						BGl_compz00zz__evaluate_compz00
																																						(((BgL_ev_exprz00_bglt) BgL_a1z00_2125), BgL_stkz00_196);
																																					BgL_a2z00_2249
																																						=
																																						BGl_compz00zz__evaluate_compz00
																																						(((BgL_ev_exprz00_bglt) BgL_a2z00_2126), BgL_stkz00_196);
																																					{	/* Eval/evaluate_comp.scm 978 */
																																						obj_t
																																							BgL_zc3anonymousza32579ze3z83_15863;
																																						BgL_zc3anonymousza32579ze3z83_15863
																																							=
																																							MAKE_FX_PROCEDURE
																																							(BGl_z62zc3anonymousza32579ze3ze1zz__evaluate_compz00,
																																							(int)
																																							(((long) 1)), (int) (((long) 3)));
																																						PROCEDURE_SET
																																							(BgL_zc3anonymousza32579ze3z83_15863,
																																							(int)
																																							(((long) 0)), BgL_a1z00_2248);
																																						PROCEDURE_SET
																																							(BgL_zc3anonymousza32579ze3z83_15863,
																																							(int)
																																							(((long) 1)), BgL_a2z00_2249);
																																						PROCEDURE_SET
																																							(BgL_zc3anonymousza32579ze3z83_15863,
																																							(int)
																																							(((long) 2)), BgL_locz00_193);
																																						return
																																							BgL_zc3anonymousza32579ze3z83_15863;
																																					}
																																				}
																																			else
																																				{	/* Eval/evaluate_comp.scm 978 */
																																					if (
																																						(BgL_valz00_2121
																																							==
																																							BGl_zc3fxzd2envz11zz__r4_numbers_6_5_fixnumz00))
																																						{	/* Eval/evaluate_comp.scm 978 */
																																							obj_t
																																								BgL_a1z00_2258;
																																							obj_t
																																								BgL_a2z00_2259;
																																							BgL_a1z00_2258
																																								=
																																								BGl_compz00zz__evaluate_compz00
																																								(
																																								((BgL_ev_exprz00_bglt) BgL_a1z00_2125), BgL_stkz00_196);
																																							BgL_a2z00_2259
																																								=
																																								BGl_compz00zz__evaluate_compz00
																																								(
																																								((BgL_ev_exprz00_bglt) BgL_a2z00_2126), BgL_stkz00_196);
																																							{	/* Eval/evaluate_comp.scm 978 */
																																								obj_t
																																									BgL_zc3anonymousza32583ze3z83_15864;
																																								BgL_zc3anonymousza32583ze3z83_15864
																																									=
																																									MAKE_FX_PROCEDURE
																																									(BGl_z62zc3anonymousza32583ze3ze1zz__evaluate_compz00,
																																									(int)
																																									(((long) 1)), (int) (((long) 3)));
																																								PROCEDURE_SET
																																									(BgL_zc3anonymousza32583ze3z83_15864,
																																									(int)
																																									(((long) 0)), BgL_a1z00_2258);
																																								PROCEDURE_SET
																																									(BgL_zc3anonymousza32583ze3z83_15864,
																																									(int)
																																									(((long) 1)), BgL_a2z00_2259);
																																								PROCEDURE_SET
																																									(BgL_zc3anonymousza32583ze3z83_15864,
																																									(int)
																																									(((long) 2)), BgL_locz00_193);
																																								return
																																									BgL_zc3anonymousza32583ze3z83_15864;
																																							}
																																						}
																																					else
																																						{	/* Eval/evaluate_comp.scm 978 */
																																							if ((BgL_valz00_2121 == BGl_ze3fxzd2envz31zz__r4_numbers_6_5_fixnumz00))
																																								{	/* Eval/evaluate_comp.scm 978 */
																																									obj_t
																																										BgL_a1z00_2268;
																																									obj_t
																																										BgL_a2z00_2269;
																																									BgL_a1z00_2268
																																										=
																																										BGl_compz00zz__evaluate_compz00
																																										(
																																										((BgL_ev_exprz00_bglt) BgL_a1z00_2125), BgL_stkz00_196);
																																									BgL_a2z00_2269
																																										=
																																										BGl_compz00zz__evaluate_compz00
																																										(
																																										((BgL_ev_exprz00_bglt) BgL_a2z00_2126), BgL_stkz00_196);
																																									{	/* Eval/evaluate_comp.scm 978 */
																																										obj_t
																																											BgL_zc3anonymousza32587ze3z83_15865;
																																										BgL_zc3anonymousza32587ze3z83_15865
																																											=
																																											MAKE_FX_PROCEDURE
																																											(BGl_z62zc3anonymousza32587ze3ze1zz__evaluate_compz00,
																																											(int)
																																											(((long) 1)), (int) (((long) 3)));
																																										PROCEDURE_SET
																																											(BgL_zc3anonymousza32587ze3z83_15865,
																																											(int)
																																											(((long) 0)), BgL_a1z00_2268);
																																										PROCEDURE_SET
																																											(BgL_zc3anonymousza32587ze3z83_15865,
																																											(int)
																																											(((long) 1)), BgL_a2z00_2269);
																																										PROCEDURE_SET
																																											(BgL_zc3anonymousza32587ze3z83_15865,
																																											(int)
																																											(((long) 2)), BgL_locz00_193);
																																										return
																																											BgL_zc3anonymousza32587ze3z83_15865;
																																									}
																																								}
																																							else
																																								{	/* Eval/evaluate_comp.scm 978 */
																																									if ((BgL_valz00_2121 == BGl_zc3zd3fxzd2envzc2zz__r4_numbers_6_5_fixnumz00))
																																										{	/* Eval/evaluate_comp.scm 978 */
																																											obj_t
																																												BgL_a1z00_2278;
																																											obj_t
																																												BgL_a2z00_2279;
																																											BgL_a1z00_2278
																																												=
																																												BGl_compz00zz__evaluate_compz00
																																												(
																																												((BgL_ev_exprz00_bglt) BgL_a1z00_2125), BgL_stkz00_196);
																																											BgL_a2z00_2279
																																												=
																																												BGl_compz00zz__evaluate_compz00
																																												(
																																												((BgL_ev_exprz00_bglt) BgL_a2z00_2126), BgL_stkz00_196);
																																											{	/* Eval/evaluate_comp.scm 978 */
																																												obj_t
																																													BgL_zc3anonymousza32591ze3z83_15866;
																																												BgL_zc3anonymousza32591ze3z83_15866
																																													=
																																													MAKE_FX_PROCEDURE
																																													(BGl_z62zc3anonymousza32591ze3ze1zz__evaluate_compz00,
																																													(int)
																																													(((long) 1)), (int) (((long) 3)));
																																												PROCEDURE_SET
																																													(BgL_zc3anonymousza32591ze3z83_15866,
																																													(int)
																																													(((long) 0)), BgL_a1z00_2278);
																																												PROCEDURE_SET
																																													(BgL_zc3anonymousza32591ze3z83_15866,
																																													(int)
																																													(((long) 1)), BgL_a2z00_2279);
																																												PROCEDURE_SET
																																													(BgL_zc3anonymousza32591ze3z83_15866,
																																													(int)
																																													(((long) 2)), BgL_locz00_193);
																																												return
																																													BgL_zc3anonymousza32591ze3z83_15866;
																																											}
																																										}
																																									else
																																										{	/* Eval/evaluate_comp.scm 978 */
																																											if ((BgL_valz00_2121 == BGl_ze3zd3fxzd2envze2zz__r4_numbers_6_5_fixnumz00))
																																												{	/* Eval/evaluate_comp.scm 978 */
																																													obj_t
																																														BgL_a1z00_2288;
																																													obj_t
																																														BgL_a2z00_2289;
																																													BgL_a1z00_2288
																																														=
																																														BGl_compz00zz__evaluate_compz00
																																														(
																																														((BgL_ev_exprz00_bglt) BgL_a1z00_2125), BgL_stkz00_196);
																																													BgL_a2z00_2289
																																														=
																																														BGl_compz00zz__evaluate_compz00
																																														(
																																														((BgL_ev_exprz00_bglt) BgL_a2z00_2126), BgL_stkz00_196);
																																													{	/* Eval/evaluate_comp.scm 978 */
																																														obj_t
																																															BgL_zc3anonymousza32595ze3z83_15867;
																																														BgL_zc3anonymousza32595ze3z83_15867
																																															=
																																															MAKE_FX_PROCEDURE
																																															(BGl_z62zc3anonymousza32595ze3ze1zz__evaluate_compz00,
																																															(int)
																																															(((long) 1)), (int) (((long) 3)));
																																														PROCEDURE_SET
																																															(BgL_zc3anonymousza32595ze3z83_15867,
																																															(int)
																																															(((long) 0)), BgL_a1z00_2288);
																																														PROCEDURE_SET
																																															(BgL_zc3anonymousza32595ze3z83_15867,
																																															(int)
																																															(((long) 1)), BgL_a2z00_2289);
																																														PROCEDURE_SET
																																															(BgL_zc3anonymousza32595ze3z83_15867,
																																															(int)
																																															(((long) 2)), BgL_locz00_193);
																																														return
																																															BgL_zc3anonymousza32595ze3z83_15867;
																																													}
																																												}
																																											else
																																												{	/* Eval/evaluate_comp.scm 978 */
																																													if ((BgL_valz00_2121 == BGl_zd3fxzd2envz01zz__r4_numbers_6_5_fixnumz00))
																																														{	/* Eval/evaluate_comp.scm 978 */
																																															obj_t
																																																BgL_a1z00_2298;
																																															obj_t
																																																BgL_a2z00_2299;
																																															BgL_a1z00_2298
																																																=
																																																BGl_compz00zz__evaluate_compz00
																																																(
																																																((BgL_ev_exprz00_bglt) BgL_a1z00_2125), BgL_stkz00_196);
																																															BgL_a2z00_2299
																																																=
																																																BGl_compz00zz__evaluate_compz00
																																																(
																																																((BgL_ev_exprz00_bglt) BgL_a2z00_2126), BgL_stkz00_196);
																																															{	/* Eval/evaluate_comp.scm 978 */
																																																obj_t
																																																	BgL_zc3anonymousza32599ze3z83_15868;
																																																BgL_zc3anonymousza32599ze3z83_15868
																																																	=
																																																	MAKE_FX_PROCEDURE
																																																	(BGl_z62zc3anonymousza32599ze3ze1zz__evaluate_compz00,
																																																	(int)
																																																	(((long) 1)), (int) (((long) 3)));
																																																PROCEDURE_SET
																																																	(BgL_zc3anonymousza32599ze3z83_15868,
																																																	(int)
																																																	(((long) 0)), BgL_a1z00_2298);
																																																PROCEDURE_SET
																																																	(BgL_zc3anonymousza32599ze3z83_15868,
																																																	(int)
																																																	(((long) 1)), BgL_a2z00_2299);
																																																PROCEDURE_SET
																																																	(BgL_zc3anonymousza32599ze3z83_15868,
																																																	(int)
																																																	(((long) 2)), BgL_locz00_193);
																																																return
																																																	BgL_zc3anonymousza32599ze3z83_15868;
																																															}
																																														}
																																													else
																																														{	/* Eval/evaluate_comp.scm 978 */
																																															if ((BgL_valz00_2121 == BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
																																																{	/* Eval/evaluate_comp.scm 978 */
																																																	obj_t
																																																		BgL_a1z00_2308;
																																																	obj_t
																																																		BgL_a2z00_2309;
																																																	BgL_a1z00_2308
																																																		=
																																																		BGl_compz00zz__evaluate_compz00
																																																		(
																																																		((BgL_ev_exprz00_bglt) BgL_a1z00_2125), BgL_stkz00_196);
																																																	BgL_a2z00_2309
																																																		=
																																																		BGl_compz00zz__evaluate_compz00
																																																		(
																																																		((BgL_ev_exprz00_bglt) BgL_a2z00_2126), BgL_stkz00_196);
																																																	{	/* Eval/evaluate_comp.scm 978 */
																																																		obj_t
																																																			BgL_zc3anonymousza32603ze3z83_15869;
																																																		BgL_zc3anonymousza32603ze3z83_15869
																																																			=
																																																			MAKE_FX_PROCEDURE
																																																			(BGl_z62zc3anonymousza32603ze3ze1zz__evaluate_compz00,
																																																			(int)
																																																			(((long) 1)), (int) (((long) 3)));
																																																		PROCEDURE_SET
																																																			(BgL_zc3anonymousza32603ze3z83_15869,
																																																			(int)
																																																			(((long) 0)), BgL_a1z00_2308);
																																																		PROCEDURE_SET
																																																			(BgL_zc3anonymousza32603ze3z83_15869,
																																																			(int)
																																																			(((long) 1)), BgL_a2z00_2309);
																																																		PROCEDURE_SET
																																																			(BgL_zc3anonymousza32603ze3z83_15869,
																																																			(int)
																																																			(((long) 2)), BgL_locz00_193);
																																																		return
																																																			BgL_zc3anonymousza32603ze3z83_15869;
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate_comp.scm 978 */
																																																	if ((BgL_valz00_2121 == BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
																																																		{	/* Eval/evaluate_comp.scm 978 */
																																																			obj_t
																																																				BgL_a1z00_2318;
																																																			obj_t
																																																				BgL_a2z00_2319;
																																																			BgL_a1z00_2318
																																																				=
																																																				BGl_compz00zz__evaluate_compz00
																																																				(
																																																				((BgL_ev_exprz00_bglt) BgL_a1z00_2125), BgL_stkz00_196);
																																																			BgL_a2z00_2319
																																																				=
																																																				BGl_compz00zz__evaluate_compz00
																																																				(
																																																				((BgL_ev_exprz00_bglt) BgL_a2z00_2126), BgL_stkz00_196);
																																																			{	/* Eval/evaluate_comp.scm 978 */
																																																				obj_t
																																																					BgL_zc3anonymousza32607ze3z83_15870;
																																																				BgL_zc3anonymousza32607ze3z83_15870
																																																					=
																																																					MAKE_FX_PROCEDURE
																																																					(BGl_z62zc3anonymousza32607ze3ze1zz__evaluate_compz00,
																																																					(int)
																																																					(((long) 1)), (int) (((long) 3)));
																																																				PROCEDURE_SET
																																																					(BgL_zc3anonymousza32607ze3z83_15870,
																																																					(int)
																																																					(((long) 0)), BgL_a1z00_2318);
																																																				PROCEDURE_SET
																																																					(BgL_zc3anonymousza32607ze3z83_15870,
																																																					(int)
																																																					(((long) 1)), BgL_a2z00_2319);
																																																				PROCEDURE_SET
																																																					(BgL_zc3anonymousza32607ze3z83_15870,
																																																					(int)
																																																					(((long) 2)), BgL_locz00_193);
																																																				return
																																																					BgL_zc3anonymousza32607ze3z83_15870;
																																																			}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate_comp.scm 978 */
																																																			if ((BgL_valz00_2121 == BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
																																																				{	/* Eval/evaluate_comp.scm 978 */
																																																					obj_t
																																																						BgL_a1z00_2328;
																																																					obj_t
																																																						BgL_a2z00_2329;
																																																					BgL_a1z00_2328
																																																						=
																																																						BGl_compz00zz__evaluate_compz00
																																																						(
																																																						((BgL_ev_exprz00_bglt) BgL_a1z00_2125), BgL_stkz00_196);
																																																					BgL_a2z00_2329
																																																						=
																																																						BGl_compz00zz__evaluate_compz00
																																																						(
																																																						((BgL_ev_exprz00_bglt) BgL_a2z00_2126), BgL_stkz00_196);
																																																					{	/* Eval/evaluate_comp.scm 978 */
																																																						obj_t
																																																							BgL_zc3anonymousza32611ze3z83_15871;
																																																						BgL_zc3anonymousza32611ze3z83_15871
																																																							=
																																																							MAKE_FX_PROCEDURE
																																																							(BGl_z62zc3anonymousza32611ze3ze1zz__evaluate_compz00,
																																																							(int)
																																																							(((long) 1)), (int) (((long) 3)));
																																																						PROCEDURE_SET
																																																							(BgL_zc3anonymousza32611ze3z83_15871,
																																																							(int)
																																																							(((long) 0)), BgL_a1z00_2328);
																																																						PROCEDURE_SET
																																																							(BgL_zc3anonymousza32611ze3z83_15871,
																																																							(int)
																																																							(((long) 1)), BgL_a2z00_2329);
																																																						PROCEDURE_SET
																																																							(BgL_zc3anonymousza32611ze3z83_15871,
																																																							(int)
																																																							(((long) 2)), BgL_locz00_193);
																																																						return
																																																							BgL_zc3anonymousza32611ze3z83_15871;
																																																					}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate_comp.scm 978 */
																																																					if ((BgL_valz00_2121 == BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00))
																																																						{	/* Eval/evaluate_comp.scm 978 */
																																																							obj_t
																																																								BgL_a1z00_2338;
																																																							obj_t
																																																								BgL_a2z00_2339;
																																																							BgL_a1z00_2338
																																																								=
																																																								BGl_compz00zz__evaluate_compz00
																																																								(
																																																								((BgL_ev_exprz00_bglt) BgL_a1z00_2125), BgL_stkz00_196);
																																																							BgL_a2z00_2339
																																																								=
																																																								BGl_compz00zz__evaluate_compz00
																																																								(
																																																								((BgL_ev_exprz00_bglt) BgL_a2z00_2126), BgL_stkz00_196);
																																																							{	/* Eval/evaluate_comp.scm 978 */
																																																								obj_t
																																																									BgL_zc3anonymousza32615ze3z83_15872;
																																																								BgL_zc3anonymousza32615ze3z83_15872
																																																									=
																																																									MAKE_FX_PROCEDURE
																																																									(BGl_z62zc3anonymousza32615ze3ze1zz__evaluate_compz00,
																																																									(int)
																																																									(((long) 1)), (int) (((long) 3)));
																																																								PROCEDURE_SET
																																																									(BgL_zc3anonymousza32615ze3z83_15872,
																																																									(int)
																																																									(((long) 0)), BgL_a1z00_2338);
																																																								PROCEDURE_SET
																																																									(BgL_zc3anonymousza32615ze3z83_15872,
																																																									(int)
																																																									(((long) 1)), BgL_a2z00_2339);
																																																								PROCEDURE_SET
																																																									(BgL_zc3anonymousza32615ze3z83_15872,
																																																									(int)
																																																									(((long) 2)), BgL_locz00_193);
																																																								return
																																																									BgL_zc3anonymousza32615ze3z83_15872;
																																																							}
																																																						}
																																																					else
																																																						{	/* Eval/evaluate_comp.scm 978 */
																																																							if ((BgL_valz00_2121 == BGl_zc3flzd2envz11zz__r4_numbers_6_5_flonumz00))
																																																								{	/* Eval/evaluate_comp.scm 978 */
																																																									obj_t
																																																										BgL_a1z00_2348;
																																																									obj_t
																																																										BgL_a2z00_2349;
																																																									BgL_a1z00_2348
																																																										=
																																																										BGl_compz00zz__evaluate_compz00
																																																										(
																																																										((BgL_ev_exprz00_bglt) BgL_a1z00_2125), BgL_stkz00_196);
																																																									BgL_a2z00_2349
																																																										=
																																																										BGl_compz00zz__evaluate_compz00
																																																										(
																																																										((BgL_ev_exprz00_bglt) BgL_a2z00_2126), BgL_stkz00_196);
																																																									{	/* Eval/evaluate_comp.scm 978 */
																																																										obj_t
																																																											BgL_zc3anonymousza32619ze3z83_15873;
																																																										BgL_zc3anonymousza32619ze3z83_15873
																																																											=
																																																											MAKE_FX_PROCEDURE
																																																											(BGl_z62zc3anonymousza32619ze3ze1zz__evaluate_compz00,
																																																											(int)
																																																											(((long) 1)), (int) (((long) 3)));
																																																										PROCEDURE_SET
																																																											(BgL_zc3anonymousza32619ze3z83_15873,
																																																											(int)
																																																											(((long) 0)), BgL_a1z00_2348);
																																																										PROCEDURE_SET
																																																											(BgL_zc3anonymousza32619ze3z83_15873,
																																																											(int)
																																																											(((long) 1)), BgL_a2z00_2349);
																																																										PROCEDURE_SET
																																																											(BgL_zc3anonymousza32619ze3z83_15873,
																																																											(int)
																																																											(((long) 2)), BgL_locz00_193);
																																																										return
																																																											BgL_zc3anonymousza32619ze3z83_15873;
																																																									}
																																																								}
																																																							else
																																																								{	/* Eval/evaluate_comp.scm 978 */
																																																									if ((BgL_valz00_2121 == BGl_ze3flzd2envz31zz__r4_numbers_6_5_flonumz00))
																																																										{	/* Eval/evaluate_comp.scm 978 */
																																																											obj_t
																																																												BgL_a1z00_2358;
																																																											obj_t
																																																												BgL_a2z00_2359;
																																																											BgL_a1z00_2358
																																																												=
																																																												BGl_compz00zz__evaluate_compz00
																																																												(
																																																												((BgL_ev_exprz00_bglt) BgL_a1z00_2125), BgL_stkz00_196);
																																																											BgL_a2z00_2359
																																																												=
																																																												BGl_compz00zz__evaluate_compz00
																																																												(
																																																												((BgL_ev_exprz00_bglt) BgL_a2z00_2126), BgL_stkz00_196);
																																																											{	/* Eval/evaluate_comp.scm 978 */
																																																												obj_t
																																																													BgL_zc3anonymousza32623ze3z83_15874;
																																																												BgL_zc3anonymousza32623ze3z83_15874
																																																													=
																																																													MAKE_FX_PROCEDURE
																																																													(BGl_z62zc3anonymousza32623ze3ze1zz__evaluate_compz00,
																																																													(int)
																																																													(((long) 1)), (int) (((long) 3)));
																																																												PROCEDURE_SET
																																																													(BgL_zc3anonymousza32623ze3z83_15874,
																																																													(int)
																																																													(((long) 0)), BgL_a1z00_2358);
																																																												PROCEDURE_SET
																																																													(BgL_zc3anonymousza32623ze3z83_15874,
																																																													(int)
																																																													(((long) 1)), BgL_a2z00_2359);
																																																												PROCEDURE_SET
																																																													(BgL_zc3anonymousza32623ze3z83_15874,
																																																													(int)
																																																													(((long) 2)), BgL_locz00_193);
																																																												return
																																																													BgL_zc3anonymousza32623ze3z83_15874;
																																																											}
																																																										}
																																																									else
																																																										{	/* Eval/evaluate_comp.scm 978 */
																																																											if ((BgL_valz00_2121 == BGl_zc3zd3flzd2envzc2zz__r4_numbers_6_5_flonumz00))
																																																												{	/* Eval/evaluate_comp.scm 978 */
																																																													obj_t
																																																														BgL_a1z00_2368;
																																																													obj_t
																																																														BgL_a2z00_2369;
																																																													BgL_a1z00_2368
																																																														=
																																																														BGl_compz00zz__evaluate_compz00
																																																														(
																																																														((BgL_ev_exprz00_bglt) BgL_a1z00_2125), BgL_stkz00_196);
																																																													BgL_a2z00_2369
																																																														=
																																																														BGl_compz00zz__evaluate_compz00
																																																														(
																																																														((BgL_ev_exprz00_bglt) BgL_a2z00_2126), BgL_stkz00_196);
																																																													{	/* Eval/evaluate_comp.scm 978 */
																																																														obj_t
																																																															BgL_zc3anonymousza32627ze3z83_15875;
																																																														BgL_zc3anonymousza32627ze3z83_15875
																																																															=
																																																															MAKE_FX_PROCEDURE
																																																															(BGl_z62zc3anonymousza32627ze3ze1zz__evaluate_compz00,
																																																															(int)
																																																															(((long) 1)), (int) (((long) 3)));
																																																														PROCEDURE_SET
																																																															(BgL_zc3anonymousza32627ze3z83_15875,
																																																															(int)
																																																															(((long) 0)), BgL_a1z00_2368);
																																																														PROCEDURE_SET
																																																															(BgL_zc3anonymousza32627ze3z83_15875,
																																																															(int)
																																																															(((long) 1)), BgL_a2z00_2369);
																																																														PROCEDURE_SET
																																																															(BgL_zc3anonymousza32627ze3z83_15875,
																																																															(int)
																																																															(((long) 2)), BgL_locz00_193);
																																																														return
																																																															BgL_zc3anonymousza32627ze3z83_15875;
																																																													}
																																																												}
																																																											else
																																																												{	/* Eval/evaluate_comp.scm 978 */
																																																													if ((BgL_valz00_2121 == BGl_ze3zd3flzd2envze2zz__r4_numbers_6_5_flonumz00))
																																																														{	/* Eval/evaluate_comp.scm 978 */
																																																															obj_t
																																																																BgL_a1z00_2378;
																																																															obj_t
																																																																BgL_a2z00_2379;
																																																															BgL_a1z00_2378
																																																																=
																																																																BGl_compz00zz__evaluate_compz00
																																																																(
																																																																((BgL_ev_exprz00_bglt) BgL_a1z00_2125), BgL_stkz00_196);
																																																															BgL_a2z00_2379
																																																																=
																																																																BGl_compz00zz__evaluate_compz00
																																																																(
																																																																((BgL_ev_exprz00_bglt) BgL_a2z00_2126), BgL_stkz00_196);
																																																															{	/* Eval/evaluate_comp.scm 978 */
																																																																obj_t
																																																																	BgL_zc3anonymousza32631ze3z83_15876;
																																																																BgL_zc3anonymousza32631ze3z83_15876
																																																																	=
																																																																	MAKE_FX_PROCEDURE
																																																																	(BGl_z62zc3anonymousza32631ze3ze1zz__evaluate_compz00,
																																																																	(int)
																																																																	(((long) 1)), (int) (((long) 3)));
																																																																PROCEDURE_SET
																																																																	(BgL_zc3anonymousza32631ze3z83_15876,
																																																																	(int)
																																																																	(((long) 0)), BgL_a1z00_2378);
																																																																PROCEDURE_SET
																																																																	(BgL_zc3anonymousza32631ze3z83_15876,
																																																																	(int)
																																																																	(((long) 1)), BgL_a2z00_2379);
																																																																PROCEDURE_SET
																																																																	(BgL_zc3anonymousza32631ze3z83_15876,
																																																																	(int)
																																																																	(((long) 2)), BgL_locz00_193);
																																																																return
																																																																	BgL_zc3anonymousza32631ze3z83_15876;
																																																															}
																																																														}
																																																													else
																																																														{	/* Eval/evaluate_comp.scm 978 */
																																																															if ((BgL_valz00_2121 == BGl_zd3flzd2envz01zz__r4_numbers_6_5_flonumz00))
																																																																{	/* Eval/evaluate_comp.scm 978 */
																																																																	obj_t
																																																																		BgL_a1z00_2388;
																																																																	obj_t
																																																																		BgL_a2z00_2389;
																																																																	BgL_a1z00_2388
																																																																		=
																																																																		BGl_compz00zz__evaluate_compz00
																																																																		(
																																																																		((BgL_ev_exprz00_bglt) BgL_a1z00_2125), BgL_stkz00_196);
																																																																	BgL_a2z00_2389
																																																																		=
																																																																		BGl_compz00zz__evaluate_compz00
																																																																		(
																																																																		((BgL_ev_exprz00_bglt) BgL_a2z00_2126), BgL_stkz00_196);
																																																																	{	/* Eval/evaluate_comp.scm 978 */
																																																																		obj_t
																																																																			BgL_zc3anonymousza32635ze3z83_15877;
																																																																		BgL_zc3anonymousza32635ze3z83_15877
																																																																			=
																																																																			MAKE_FX_PROCEDURE
																																																																			(BGl_z62zc3anonymousza32635ze3ze1zz__evaluate_compz00,
																																																																			(int)
																																																																			(((long) 1)), (int) (((long) 3)));
																																																																		PROCEDURE_SET
																																																																			(BgL_zc3anonymousza32635ze3z83_15877,
																																																																			(int)
																																																																			(((long) 0)), BgL_a1z00_2388);
																																																																		PROCEDURE_SET
																																																																			(BgL_zc3anonymousza32635ze3z83_15877,
																																																																			(int)
																																																																			(((long) 1)), BgL_a2z00_2389);
																																																																		PROCEDURE_SET
																																																																			(BgL_zc3anonymousza32635ze3z83_15877,
																																																																			(int)
																																																																			(((long) 2)), BgL_locz00_193);
																																																																		return
																																																																			BgL_zc3anonymousza32635ze3z83_15877;
																																																																	}
																																																																}
																																																															else
																																																																{	/* Eval/evaluate_comp.scm 978 */
																																																																	if ((BgL_valz00_2121 == BGl_eqzf3zd2envz21zz__r4_equivalence_6_2z00))
																																																																		{	/* Eval/evaluate_comp.scm 978 */
																																																																			obj_t
																																																																				BgL_a1z00_2398;
																																																																			obj_t
																																																																				BgL_a2z00_2399;
																																																																			BgL_a1z00_2398
																																																																				=
																																																																				BGl_compz00zz__evaluate_compz00
																																																																				(
																																																																				((BgL_ev_exprz00_bglt) BgL_a1z00_2125), BgL_stkz00_196);
																																																																			BgL_a2z00_2399
																																																																				=
																																																																				BGl_compz00zz__evaluate_compz00
																																																																				(
																																																																				((BgL_ev_exprz00_bglt) BgL_a2z00_2126), BgL_stkz00_196);
																																																																			{	/* Eval/evaluate_comp.scm 978 */
																																																																				obj_t
																																																																					BgL_zc3anonymousza32639ze3z83_15878;
																																																																				BgL_zc3anonymousza32639ze3z83_15878
																																																																					=
																																																																					MAKE_FX_PROCEDURE
																																																																					(BGl_z62zc3anonymousza32639ze3ze1zz__evaluate_compz00,
																																																																					(int)
																																																																					(((long) 1)), (int) (((long) 2)));
																																																																				PROCEDURE_SET
																																																																					(BgL_zc3anonymousza32639ze3z83_15878,
																																																																					(int)
																																																																					(((long) 0)), BgL_a1z00_2398);
																																																																				PROCEDURE_SET
																																																																					(BgL_zc3anonymousza32639ze3z83_15878,
																																																																					(int)
																																																																					(((long) 1)), BgL_a2z00_2399);
																																																																				return
																																																																					BgL_zc3anonymousza32639ze3z83_15878;
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Eval/evaluate_comp.scm 978 */
																																																																			if ((BgL_valz00_2121 == BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00))
																																																																				{	/* Eval/evaluate_comp.scm 978 */
																																																																					obj_t
																																																																						BgL_a1z00_2406;
																																																																					obj_t
																																																																						BgL_a2z00_2407;
																																																																					BgL_a1z00_2406
																																																																						=
																																																																						BGl_compz00zz__evaluate_compz00
																																																																						(
																																																																						((BgL_ev_exprz00_bglt) BgL_a1z00_2125), BgL_stkz00_196);
																																																																					BgL_a2z00_2407
																																																																						=
																																																																						BGl_compz00zz__evaluate_compz00
																																																																						(
																																																																						((BgL_ev_exprz00_bglt) BgL_a2z00_2126), BgL_stkz00_196);
																																																																					{	/* Eval/evaluate_comp.scm 978 */
																																																																						obj_t
																																																																							BgL_zc3anonymousza32641ze3z83_15879;
																																																																						BgL_zc3anonymousza32641ze3z83_15879
																																																																							=
																																																																							MAKE_FX_PROCEDURE
																																																																							(BGl_z62zc3anonymousza32641ze3ze1zz__evaluate_compz00,
																																																																							(int)
																																																																							(((long) 1)), (int) (((long) 2)));
																																																																						PROCEDURE_SET
																																																																							(BgL_zc3anonymousza32641ze3z83_15879,
																																																																							(int)
																																																																							(((long) 0)), BgL_a1z00_2406);
																																																																						PROCEDURE_SET
																																																																							(BgL_zc3anonymousza32641ze3z83_15879,
																																																																							(int)
																																																																							(((long) 1)), BgL_a2z00_2407);
																																																																						return
																																																																							BgL_zc3anonymousza32641ze3z83_15879;
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Eval/evaluate_comp.scm 978 */
																																																																					return
																																																																						BFALSE;
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																						}
																				}
																		}
																}
														}
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 976 */
											return BFALSE;
										}
								}
						}
					}
				else
					{	/* Eval/evaluate_comp.scm 971 */
						return BFALSE;
					}
			}
		}
	}



/* &<anonymous:2531> */
	obj_t BGl_z62zc3anonymousza32531ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15883, obj_t BgL_sz00_15887)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_15884;
				obj_t BgL_a2z00_15885;
				obj_t BgL_locz00_15886;

				BgL_a1z00_15884 = PROCEDURE_REF(BgL_envz00_15883, (int) (((long) 0)));
				BgL_a2z00_15885 = PROCEDURE_REF(BgL_envz00_15883, (int) (((long) 1)));
				BgL_locz00_15886 = PROCEDURE_REF(BgL_envz00_15883, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2130;

					BgL_sz00_2130 = BgL_sz00_15887;
					{	/* Eval/evaluate_comp.scm 978 */
						obj_t BgL_bpz00_2132;

						BgL_bpz00_2132 = VECTOR_REF(BgL_sz00_2130, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_a1z00_2133;
							obj_t BgL_a2z00_2134;

							BgL_a1z00_2133 =
								PROCEDURE_ENTRY(BgL_a1z00_15884) (BgL_a1z00_15884,
								BgL_sz00_2130, BEOA);
							BgL_a2z00_2134 =
								PROCEDURE_ENTRY(BgL_a2z00_15885) (BgL_a2z00_15885,
								BgL_sz00_2130, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_2133))
								{	/* Eval/evaluate_comp.scm 978 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 978 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5581z00zz__evaluate_compz00,
										BGl_symbol5583z00zz__evaluate_compz00, BgL_a1z00_2133,
										BgL_locz00_15886);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_2134))
								{	/* Eval/evaluate_comp.scm 978 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 978 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5581z00zz__evaluate_compz00,
										BGl_symbol5583z00zz__evaluate_compz00, BgL_a2z00_2134,
										BgL_locz00_15886);
								}
							return
								BGl_2zb2zb2zz__r4_numbers_6_5z00(BgL_a1z00_2133,
								BgL_a2z00_2134);
						}
					}
				}
			}
		}
	}



/* &<anonymous:2535> */
	obj_t BGl_z62zc3anonymousza32535ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15888, obj_t BgL_sz00_15892)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_15889;
				obj_t BgL_a2z00_15890;
				obj_t BgL_locz00_15891;

				BgL_a1z00_15889 = PROCEDURE_REF(BgL_envz00_15888, (int) (((long) 0)));
				BgL_a2z00_15890 = PROCEDURE_REF(BgL_envz00_15888, (int) (((long) 1)));
				BgL_locz00_15891 = PROCEDURE_REF(BgL_envz00_15888, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2140;

					BgL_sz00_2140 = BgL_sz00_15892;
					{	/* Eval/evaluate_comp.scm 978 */
						obj_t BgL_bpz00_2142;

						BgL_bpz00_2142 = VECTOR_REF(BgL_sz00_2140, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_a1z00_2143;
							obj_t BgL_a2z00_2144;

							BgL_a1z00_2143 =
								PROCEDURE_ENTRY(BgL_a1z00_15889) (BgL_a1z00_15889,
								BgL_sz00_2140, BEOA);
							BgL_a2z00_2144 =
								PROCEDURE_ENTRY(BgL_a2z00_15890) (BgL_a2z00_15890,
								BgL_sz00_2140, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_2143))
								{	/* Eval/evaluate_comp.scm 978 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 978 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5585z00zz__evaluate_compz00,
										BGl_symbol5583z00zz__evaluate_compz00, BgL_a1z00_2143,
										BgL_locz00_15891);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_2144))
								{	/* Eval/evaluate_comp.scm 978 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 978 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5585z00zz__evaluate_compz00,
										BGl_symbol5583z00zz__evaluate_compz00, BgL_a2z00_2144,
										BgL_locz00_15891);
								}
							return
								BGl_2zd2zd2zz__r4_numbers_6_5z00(BgL_a1z00_2143,
								BgL_a2z00_2144);
						}
					}
				}
			}
		}
	}



/* &<anonymous:2539> */
	obj_t BGl_z62zc3anonymousza32539ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15893, obj_t BgL_sz00_15897)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_15894;
				obj_t BgL_a2z00_15895;
				obj_t BgL_locz00_15896;

				BgL_a1z00_15894 = PROCEDURE_REF(BgL_envz00_15893, (int) (((long) 0)));
				BgL_a2z00_15895 = PROCEDURE_REF(BgL_envz00_15893, (int) (((long) 1)));
				BgL_locz00_15896 = PROCEDURE_REF(BgL_envz00_15893, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2150;

					BgL_sz00_2150 = BgL_sz00_15897;
					{	/* Eval/evaluate_comp.scm 978 */
						obj_t BgL_bpz00_2152;

						BgL_bpz00_2152 = VECTOR_REF(BgL_sz00_2150, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_a1z00_2153;
							obj_t BgL_a2z00_2154;

							BgL_a1z00_2153 =
								PROCEDURE_ENTRY(BgL_a1z00_15894) (BgL_a1z00_15894,
								BgL_sz00_2150, BEOA);
							BgL_a2z00_2154 =
								PROCEDURE_ENTRY(BgL_a2z00_15895) (BgL_a2z00_15895,
								BgL_sz00_2150, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_2153))
								{	/* Eval/evaluate_comp.scm 978 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 978 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5587z00zz__evaluate_compz00,
										BGl_symbol5583z00zz__evaluate_compz00, BgL_a1z00_2153,
										BgL_locz00_15896);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_2154))
								{	/* Eval/evaluate_comp.scm 978 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 978 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5587z00zz__evaluate_compz00,
										BGl_symbol5583z00zz__evaluate_compz00, BgL_a2z00_2154,
										BgL_locz00_15896);
								}
							return
								BGl_2za2za2zz__r4_numbers_6_5z00(BgL_a1z00_2153,
								BgL_a2z00_2154);
						}
					}
				}
			}
		}
	}



/* &<anonymous:2543> */
	obj_t BGl_z62zc3anonymousza32543ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15898, obj_t BgL_sz00_15902)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_15899;
				obj_t BgL_a2z00_15900;
				obj_t BgL_locz00_15901;

				BgL_a1z00_15899 = PROCEDURE_REF(BgL_envz00_15898, (int) (((long) 0)));
				BgL_a2z00_15900 = PROCEDURE_REF(BgL_envz00_15898, (int) (((long) 1)));
				BgL_locz00_15901 = PROCEDURE_REF(BgL_envz00_15898, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2160;

					BgL_sz00_2160 = BgL_sz00_15902;
					{	/* Eval/evaluate_comp.scm 978 */
						obj_t BgL_bpz00_2162;

						BgL_bpz00_2162 = VECTOR_REF(BgL_sz00_2160, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_a1z00_2163;
							obj_t BgL_a2z00_2164;

							BgL_a1z00_2163 =
								PROCEDURE_ENTRY(BgL_a1z00_15899) (BgL_a1z00_15899,
								BgL_sz00_2160, BEOA);
							BgL_a2z00_2164 =
								PROCEDURE_ENTRY(BgL_a2z00_15900) (BgL_a2z00_15900,
								BgL_sz00_2160, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_2163))
								{	/* Eval/evaluate_comp.scm 978 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 978 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5589z00zz__evaluate_compz00,
										BGl_symbol5583z00zz__evaluate_compz00, BgL_a1z00_2163,
										BgL_locz00_15901);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_2164))
								{	/* Eval/evaluate_comp.scm 978 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 978 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5589z00zz__evaluate_compz00,
										BGl_symbol5583z00zz__evaluate_compz00, BgL_a2z00_2164,
										BgL_locz00_15901);
								}
							return
								BGl_2zf2zf2zz__r4_numbers_6_5z00(BgL_a1z00_2163,
								BgL_a2z00_2164);
						}
					}
				}
			}
		}
	}



/* &<anonymous:2547> */
	obj_t BGl_z62zc3anonymousza32547ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15903, obj_t BgL_sz00_15907)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_15904;
				obj_t BgL_a2z00_15905;
				obj_t BgL_locz00_15906;

				BgL_a1z00_15904 = PROCEDURE_REF(BgL_envz00_15903, (int) (((long) 0)));
				BgL_a2z00_15905 = PROCEDURE_REF(BgL_envz00_15903, (int) (((long) 1)));
				BgL_locz00_15906 = PROCEDURE_REF(BgL_envz00_15903, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2170;

					{	/* Eval/evaluate_comp.scm 978 */
						bool_t BgL_auxz00_21708;

						BgL_sz00_2170 = BgL_sz00_15907;
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_bpz00_2172;

							BgL_bpz00_2172 = VECTOR_REF(BgL_sz00_2170, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 978 */
								obj_t BgL_a1z00_2173;
								obj_t BgL_a2z00_2174;

								BgL_a1z00_2173 =
									PROCEDURE_ENTRY(BgL_a1z00_15904) (BgL_a1z00_15904,
									BgL_sz00_2170, BEOA);
								BgL_a2z00_2174 =
									PROCEDURE_ENTRY(BgL_a2z00_15905) (BgL_a2z00_15905,
									BgL_sz00_2170, BEOA);
								if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_2173))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5591z00zz__evaluate_compz00,
											BGl_symbol5583z00zz__evaluate_compz00, BgL_a1z00_2173,
											BgL_locz00_15906);
									}
								if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_2174))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5591z00zz__evaluate_compz00,
											BGl_symbol5583z00zz__evaluate_compz00, BgL_a2z00_2174,
											BgL_locz00_15906);
									}
								BgL_auxz00_21708 =
									BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_a1z00_2173,
									BgL_a2z00_2174);
							}
						}
						return BBOOL(BgL_auxz00_21708);
					}
				}
			}
		}
	}



/* &<anonymous:2551> */
	obj_t BGl_z62zc3anonymousza32551ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15908, obj_t BgL_sz00_15912)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_15909;
				obj_t BgL_a2z00_15910;
				obj_t BgL_locz00_15911;

				BgL_a1z00_15909 = PROCEDURE_REF(BgL_envz00_15908, (int) (((long) 0)));
				BgL_a2z00_15910 = PROCEDURE_REF(BgL_envz00_15908, (int) (((long) 1)));
				BgL_locz00_15911 = PROCEDURE_REF(BgL_envz00_15908, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2180;

					{	/* Eval/evaluate_comp.scm 978 */
						bool_t BgL_auxz00_21733;

						BgL_sz00_2180 = BgL_sz00_15912;
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_bpz00_2182;

							BgL_bpz00_2182 = VECTOR_REF(BgL_sz00_2180, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 978 */
								obj_t BgL_a1z00_2183;
								obj_t BgL_a2z00_2184;

								BgL_a1z00_2183 =
									PROCEDURE_ENTRY(BgL_a1z00_15909) (BgL_a1z00_15909,
									BgL_sz00_2180, BEOA);
								BgL_a2z00_2184 =
									PROCEDURE_ENTRY(BgL_a2z00_15910) (BgL_a2z00_15910,
									BgL_sz00_2180, BEOA);
								if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_2183))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5593z00zz__evaluate_compz00,
											BGl_symbol5583z00zz__evaluate_compz00, BgL_a1z00_2183,
											BgL_locz00_15911);
									}
								if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_2184))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5593z00zz__evaluate_compz00,
											BGl_symbol5583z00zz__evaluate_compz00, BgL_a2z00_2184,
											BgL_locz00_15911);
									}
								BgL_auxz00_21733 =
									BGl_2ze3ze3zz__r4_numbers_6_5z00(BgL_a1z00_2183,
									BgL_a2z00_2184);
							}
						}
						return BBOOL(BgL_auxz00_21733);
					}
				}
			}
		}
	}



/* &<anonymous:2555> */
	obj_t BGl_z62zc3anonymousza32555ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15913, obj_t BgL_sz00_15917)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_15914;
				obj_t BgL_a2z00_15915;
				obj_t BgL_locz00_15916;

				BgL_a1z00_15914 = PROCEDURE_REF(BgL_envz00_15913, (int) (((long) 0)));
				BgL_a2z00_15915 = PROCEDURE_REF(BgL_envz00_15913, (int) (((long) 1)));
				BgL_locz00_15916 = PROCEDURE_REF(BgL_envz00_15913, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2190;

					{	/* Eval/evaluate_comp.scm 978 */
						bool_t BgL_auxz00_21758;

						BgL_sz00_2190 = BgL_sz00_15917;
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_bpz00_2192;

							BgL_bpz00_2192 = VECTOR_REF(BgL_sz00_2190, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 978 */
								obj_t BgL_a1z00_2193;
								obj_t BgL_a2z00_2194;

								BgL_a1z00_2193 =
									PROCEDURE_ENTRY(BgL_a1z00_15914) (BgL_a1z00_15914,
									BgL_sz00_2190, BEOA);
								BgL_a2z00_2194 =
									PROCEDURE_ENTRY(BgL_a2z00_15915) (BgL_a2z00_15915,
									BgL_sz00_2190, BEOA);
								if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_2193))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5595z00zz__evaluate_compz00,
											BGl_symbol5583z00zz__evaluate_compz00, BgL_a1z00_2193,
											BgL_locz00_15916);
									}
								if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_2194))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5595z00zz__evaluate_compz00,
											BGl_symbol5583z00zz__evaluate_compz00, BgL_a2z00_2194,
											BgL_locz00_15916);
									}
								BgL_auxz00_21758 =
									BGl_2zc3zd3z10zz__r4_numbers_6_5z00(BgL_a1z00_2193,
									BgL_a2z00_2194);
							}
						}
						return BBOOL(BgL_auxz00_21758);
					}
				}
			}
		}
	}



/* &<anonymous:2559> */
	obj_t BGl_z62zc3anonymousza32559ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15918, obj_t BgL_sz00_15922)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_15919;
				obj_t BgL_a2z00_15920;
				obj_t BgL_locz00_15921;

				BgL_a1z00_15919 = PROCEDURE_REF(BgL_envz00_15918, (int) (((long) 0)));
				BgL_a2z00_15920 = PROCEDURE_REF(BgL_envz00_15918, (int) (((long) 1)));
				BgL_locz00_15921 = PROCEDURE_REF(BgL_envz00_15918, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2200;

					{	/* Eval/evaluate_comp.scm 978 */
						bool_t BgL_auxz00_21783;

						BgL_sz00_2200 = BgL_sz00_15922;
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_bpz00_2202;

							BgL_bpz00_2202 = VECTOR_REF(BgL_sz00_2200, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 978 */
								obj_t BgL_a1z00_2203;
								obj_t BgL_a2z00_2204;

								BgL_a1z00_2203 =
									PROCEDURE_ENTRY(BgL_a1z00_15919) (BgL_a1z00_15919,
									BgL_sz00_2200, BEOA);
								BgL_a2z00_2204 =
									PROCEDURE_ENTRY(BgL_a2z00_15920) (BgL_a2z00_15920,
									BgL_sz00_2200, BEOA);
								if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_2203))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5597z00zz__evaluate_compz00,
											BGl_symbol5583z00zz__evaluate_compz00, BgL_a1z00_2203,
											BgL_locz00_15921);
									}
								if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_2204))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5597z00zz__evaluate_compz00,
											BGl_symbol5583z00zz__evaluate_compz00, BgL_a2z00_2204,
											BgL_locz00_15921);
									}
								BgL_auxz00_21783 =
									BGl_2ze3zd3z30zz__r4_numbers_6_5z00(BgL_a1z00_2203,
									BgL_a2z00_2204);
							}
						}
						return BBOOL(BgL_auxz00_21783);
					}
				}
			}
		}
	}



/* &<anonymous:2563> */
	obj_t BGl_z62zc3anonymousza32563ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15923, obj_t BgL_sz00_15927)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_15924;
				obj_t BgL_a2z00_15925;
				obj_t BgL_locz00_15926;

				BgL_a1z00_15924 = PROCEDURE_REF(BgL_envz00_15923, (int) (((long) 0)));
				BgL_a2z00_15925 = PROCEDURE_REF(BgL_envz00_15923, (int) (((long) 1)));
				BgL_locz00_15926 = PROCEDURE_REF(BgL_envz00_15923, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2210;

					{	/* Eval/evaluate_comp.scm 978 */
						bool_t BgL_auxz00_21808;

						BgL_sz00_2210 = BgL_sz00_15927;
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_bpz00_2212;

							BgL_bpz00_2212 = VECTOR_REF(BgL_sz00_2210, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 978 */
								obj_t BgL_a1z00_2213;
								obj_t BgL_a2z00_2214;

								BgL_a1z00_2213 =
									PROCEDURE_ENTRY(BgL_a1z00_15924) (BgL_a1z00_15924,
									BgL_sz00_2210, BEOA);
								BgL_a2z00_2214 =
									PROCEDURE_ENTRY(BgL_a2z00_15925) (BgL_a2z00_15925,
									BgL_sz00_2210, BEOA);
								if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_2213))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5599z00zz__evaluate_compz00,
											BGl_symbol5583z00zz__evaluate_compz00, BgL_a1z00_2213,
											BgL_locz00_15926);
									}
								if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_2214))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5599z00zz__evaluate_compz00,
											BGl_symbol5583z00zz__evaluate_compz00, BgL_a2z00_2214,
											BgL_locz00_15926);
									}
								BgL_auxz00_21808 =
									BGl_2zd3zd3zz__r4_numbers_6_5z00(BgL_a1z00_2213,
									BgL_a2z00_2214);
							}
						}
						return BBOOL(BgL_auxz00_21808);
					}
				}
			}
		}
	}



/* &<anonymous:2567> */
	obj_t BGl_z62zc3anonymousza32567ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15928, obj_t BgL_sz00_15932)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_15929;
				obj_t BgL_a2z00_15930;
				obj_t BgL_locz00_15931;

				BgL_a1z00_15929 = PROCEDURE_REF(BgL_envz00_15928, (int) (((long) 0)));
				BgL_a2z00_15930 = PROCEDURE_REF(BgL_envz00_15928, (int) (((long) 1)));
				BgL_locz00_15931 = PROCEDURE_REF(BgL_envz00_15928, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2220;

					{	/* Eval/evaluate_comp.scm 978 */
						long BgL_auxz00_21833;

						BgL_sz00_2220 = BgL_sz00_15932;
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_bpz00_2222;

							BgL_bpz00_2222 = VECTOR_REF(BgL_sz00_2220, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 978 */
								obj_t BgL_a1z00_2223;
								obj_t BgL_a2z00_2224;

								BgL_a1z00_2223 =
									PROCEDURE_ENTRY(BgL_a1z00_15929) (BgL_a1z00_15929,
									BgL_sz00_2220, BEOA);
								BgL_a2z00_2224 =
									PROCEDURE_ENTRY(BgL_a2z00_15930) (BgL_a2z00_15930,
									BgL_sz00_2220, BEOA);
								if (INTEGERP(BgL_a1z00_2223))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5601z00zz__evaluate_compz00,
											BGl_symbol5603z00zz__evaluate_compz00, BgL_a1z00_2223,
											BgL_locz00_15931);
									}
								if (INTEGERP(BgL_a2z00_2224))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5601z00zz__evaluate_compz00,
											BGl_symbol5603z00zz__evaluate_compz00, BgL_a2z00_2224,
											BgL_locz00_15931);
									}
								BgL_auxz00_21833 =
									((long) CINT(BgL_a1z00_2223) + (long) CINT(BgL_a2z00_2224));
						}}
						return BINT(BgL_auxz00_21833);
					}
				}
			}
		}
	}



/* &<anonymous:2571> */
	obj_t BGl_z62zc3anonymousza32571ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15933, obj_t BgL_sz00_15937)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_15934;
				obj_t BgL_a2z00_15935;
				obj_t BgL_locz00_15936;

				BgL_a1z00_15934 = PROCEDURE_REF(BgL_envz00_15933, (int) (((long) 0)));
				BgL_a2z00_15935 = PROCEDURE_REF(BgL_envz00_15933, (int) (((long) 1)));
				BgL_locz00_15936 = PROCEDURE_REF(BgL_envz00_15933, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2230;

					{	/* Eval/evaluate_comp.scm 978 */
						long BgL_auxz00_21860;

						BgL_sz00_2230 = BgL_sz00_15937;
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_bpz00_2232;

							BgL_bpz00_2232 = VECTOR_REF(BgL_sz00_2230, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 978 */
								obj_t BgL_a1z00_2233;
								obj_t BgL_a2z00_2234;

								BgL_a1z00_2233 =
									PROCEDURE_ENTRY(BgL_a1z00_15934) (BgL_a1z00_15934,
									BgL_sz00_2230, BEOA);
								BgL_a2z00_2234 =
									PROCEDURE_ENTRY(BgL_a2z00_15935) (BgL_a2z00_15935,
									BgL_sz00_2230, BEOA);
								if (INTEGERP(BgL_a1z00_2233))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5605z00zz__evaluate_compz00,
											BGl_symbol5603z00zz__evaluate_compz00, BgL_a1z00_2233,
											BgL_locz00_15936);
									}
								if (INTEGERP(BgL_a2z00_2234))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5605z00zz__evaluate_compz00,
											BGl_symbol5603z00zz__evaluate_compz00, BgL_a2z00_2234,
											BgL_locz00_15936);
									}
								BgL_auxz00_21860 =
									((long) CINT(BgL_a1z00_2233) - (long) CINT(BgL_a2z00_2234));
						}}
						return BINT(BgL_auxz00_21860);
					}
				}
			}
		}
	}



/* &<anonymous:2575> */
	obj_t BGl_z62zc3anonymousza32575ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15938, obj_t BgL_sz00_15942)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_15939;
				obj_t BgL_a2z00_15940;
				obj_t BgL_locz00_15941;

				BgL_a1z00_15939 = PROCEDURE_REF(BgL_envz00_15938, (int) (((long) 0)));
				BgL_a2z00_15940 = PROCEDURE_REF(BgL_envz00_15938, (int) (((long) 1)));
				BgL_locz00_15941 = PROCEDURE_REF(BgL_envz00_15938, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2240;

					{	/* Eval/evaluate_comp.scm 978 */
						long BgL_auxz00_21887;

						BgL_sz00_2240 = BgL_sz00_15942;
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_bpz00_2242;

							BgL_bpz00_2242 = VECTOR_REF(BgL_sz00_2240, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 978 */
								obj_t BgL_a1z00_2243;
								obj_t BgL_a2z00_2244;

								BgL_a1z00_2243 =
									PROCEDURE_ENTRY(BgL_a1z00_15939) (BgL_a1z00_15939,
									BgL_sz00_2240, BEOA);
								BgL_a2z00_2244 =
									PROCEDURE_ENTRY(BgL_a2z00_15940) (BgL_a2z00_15940,
									BgL_sz00_2240, BEOA);
								if (INTEGERP(BgL_a1z00_2243))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5607z00zz__evaluate_compz00,
											BGl_symbol5603z00zz__evaluate_compz00, BgL_a1z00_2243,
											BgL_locz00_15941);
									}
								if (INTEGERP(BgL_a2z00_2244))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5607z00zz__evaluate_compz00,
											BGl_symbol5603z00zz__evaluate_compz00, BgL_a2z00_2244,
											BgL_locz00_15941);
									}
								BgL_auxz00_21887 =
									((long) CINT(BgL_a1z00_2243) * (long) CINT(BgL_a2z00_2244));
						}}
						return BINT(BgL_auxz00_21887);
					}
				}
			}
		}
	}



/* &<anonymous:2579> */
	obj_t BGl_z62zc3anonymousza32579ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15943, obj_t BgL_sz00_15947)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_15944;
				obj_t BgL_a2z00_15945;
				obj_t BgL_locz00_15946;

				BgL_a1z00_15944 = PROCEDURE_REF(BgL_envz00_15943, (int) (((long) 0)));
				BgL_a2z00_15945 = PROCEDURE_REF(BgL_envz00_15943, (int) (((long) 1)));
				BgL_locz00_15946 = PROCEDURE_REF(BgL_envz00_15943, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2250;

					{	/* Eval/evaluate_comp.scm 978 */
						long BgL_auxz00_21914;

						BgL_sz00_2250 = BgL_sz00_15947;
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_bpz00_2252;

							BgL_bpz00_2252 = VECTOR_REF(BgL_sz00_2250, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 978 */
								obj_t BgL_a1z00_2253;
								obj_t BgL_a2z00_2254;

								BgL_a1z00_2253 =
									PROCEDURE_ENTRY(BgL_a1z00_15944) (BgL_a1z00_15944,
									BgL_sz00_2250, BEOA);
								BgL_a2z00_2254 =
									PROCEDURE_ENTRY(BgL_a2z00_15945) (BgL_a2z00_15945,
									BgL_sz00_2250, BEOA);
								if (INTEGERP(BgL_a1z00_2253))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5609z00zz__evaluate_compz00,
											BGl_symbol5603z00zz__evaluate_compz00, BgL_a1z00_2253,
											BgL_locz00_15946);
									}
								if (INTEGERP(BgL_a2z00_2254))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5609z00zz__evaluate_compz00,
											BGl_symbol5603z00zz__evaluate_compz00, BgL_a2z00_2254,
											BgL_locz00_15946);
									}
								BgL_auxz00_21914 =
									((long) CINT(BgL_a1z00_2253) / (long) CINT(BgL_a2z00_2254));
						}}
						return BINT(BgL_auxz00_21914);
					}
				}
			}
		}
	}



/* &<anonymous:2583> */
	obj_t BGl_z62zc3anonymousza32583ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15948, obj_t BgL_sz00_15952)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_15949;
				obj_t BgL_a2z00_15950;
				obj_t BgL_locz00_15951;

				BgL_a1z00_15949 = PROCEDURE_REF(BgL_envz00_15948, (int) (((long) 0)));
				BgL_a2z00_15950 = PROCEDURE_REF(BgL_envz00_15948, (int) (((long) 1)));
				BgL_locz00_15951 = PROCEDURE_REF(BgL_envz00_15948, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2260;

					{	/* Eval/evaluate_comp.scm 978 */
						bool_t BgL_auxz00_21941;

						BgL_sz00_2260 = BgL_sz00_15952;
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_bpz00_2262;

							BgL_bpz00_2262 = VECTOR_REF(BgL_sz00_2260, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 978 */
								obj_t BgL_a1z00_2263;
								obj_t BgL_a2z00_2264;

								BgL_a1z00_2263 =
									PROCEDURE_ENTRY(BgL_a1z00_15949) (BgL_a1z00_15949,
									BgL_sz00_2260, BEOA);
								BgL_a2z00_2264 =
									PROCEDURE_ENTRY(BgL_a2z00_15950) (BgL_a2z00_15950,
									BgL_sz00_2260, BEOA);
								if (INTEGERP(BgL_a1z00_2263))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5611z00zz__evaluate_compz00,
											BGl_symbol5603z00zz__evaluate_compz00, BgL_a1z00_2263,
											BgL_locz00_15951);
									}
								if (INTEGERP(BgL_a2z00_2264))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5611z00zz__evaluate_compz00,
											BGl_symbol5603z00zz__evaluate_compz00, BgL_a2z00_2264,
											BgL_locz00_15951);
									}
								BgL_auxz00_21941 =
									((long) CINT(BgL_a1z00_2263) < (long) CINT(BgL_a2z00_2264));
						}}
						return BBOOL(BgL_auxz00_21941);
					}
				}
			}
		}
	}



/* &<anonymous:2587> */
	obj_t BGl_z62zc3anonymousza32587ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15953, obj_t BgL_sz00_15957)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_15954;
				obj_t BgL_a2z00_15955;
				obj_t BgL_locz00_15956;

				BgL_a1z00_15954 = PROCEDURE_REF(BgL_envz00_15953, (int) (((long) 0)));
				BgL_a2z00_15955 = PROCEDURE_REF(BgL_envz00_15953, (int) (((long) 1)));
				BgL_locz00_15956 = PROCEDURE_REF(BgL_envz00_15953, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2270;

					{	/* Eval/evaluate_comp.scm 978 */
						bool_t BgL_auxz00_21968;

						BgL_sz00_2270 = BgL_sz00_15957;
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_bpz00_2272;

							BgL_bpz00_2272 = VECTOR_REF(BgL_sz00_2270, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 978 */
								obj_t BgL_a1z00_2273;
								obj_t BgL_a2z00_2274;

								BgL_a1z00_2273 =
									PROCEDURE_ENTRY(BgL_a1z00_15954) (BgL_a1z00_15954,
									BgL_sz00_2270, BEOA);
								BgL_a2z00_2274 =
									PROCEDURE_ENTRY(BgL_a2z00_15955) (BgL_a2z00_15955,
									BgL_sz00_2270, BEOA);
								if (INTEGERP(BgL_a1z00_2273))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5613z00zz__evaluate_compz00,
											BGl_symbol5603z00zz__evaluate_compz00, BgL_a1z00_2273,
											BgL_locz00_15956);
									}
								if (INTEGERP(BgL_a2z00_2274))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5613z00zz__evaluate_compz00,
											BGl_symbol5603z00zz__evaluate_compz00, BgL_a2z00_2274,
											BgL_locz00_15956);
									}
								BgL_auxz00_21968 =
									((long) CINT(BgL_a1z00_2273) > (long) CINT(BgL_a2z00_2274));
						}}
						return BBOOL(BgL_auxz00_21968);
					}
				}
			}
		}
	}



/* &<anonymous:2591> */
	obj_t BGl_z62zc3anonymousza32591ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15958, obj_t BgL_sz00_15962)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_15959;
				obj_t BgL_a2z00_15960;
				obj_t BgL_locz00_15961;

				BgL_a1z00_15959 = PROCEDURE_REF(BgL_envz00_15958, (int) (((long) 0)));
				BgL_a2z00_15960 = PROCEDURE_REF(BgL_envz00_15958, (int) (((long) 1)));
				BgL_locz00_15961 = PROCEDURE_REF(BgL_envz00_15958, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2280;

					{	/* Eval/evaluate_comp.scm 978 */
						bool_t BgL_auxz00_21995;

						BgL_sz00_2280 = BgL_sz00_15962;
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_bpz00_2282;

							BgL_bpz00_2282 = VECTOR_REF(BgL_sz00_2280, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 978 */
								obj_t BgL_a1z00_2283;
								obj_t BgL_a2z00_2284;

								BgL_a1z00_2283 =
									PROCEDURE_ENTRY(BgL_a1z00_15959) (BgL_a1z00_15959,
									BgL_sz00_2280, BEOA);
								BgL_a2z00_2284 =
									PROCEDURE_ENTRY(BgL_a2z00_15960) (BgL_a2z00_15960,
									BgL_sz00_2280, BEOA);
								if (INTEGERP(BgL_a1z00_2283))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5615z00zz__evaluate_compz00,
											BGl_symbol5603z00zz__evaluate_compz00, BgL_a1z00_2283,
											BgL_locz00_15961);
									}
								if (INTEGERP(BgL_a2z00_2284))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5615z00zz__evaluate_compz00,
											BGl_symbol5603z00zz__evaluate_compz00, BgL_a2z00_2284,
											BgL_locz00_15961);
									}
								BgL_auxz00_21995 =
									((long) CINT(BgL_a1z00_2283) <= (long) CINT(BgL_a2z00_2284));
						}}
						return BBOOL(BgL_auxz00_21995);
					}
				}
			}
		}
	}



/* &<anonymous:2595> */
	obj_t BGl_z62zc3anonymousza32595ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15963, obj_t BgL_sz00_15967)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_15964;
				obj_t BgL_a2z00_15965;
				obj_t BgL_locz00_15966;

				BgL_a1z00_15964 = PROCEDURE_REF(BgL_envz00_15963, (int) (((long) 0)));
				BgL_a2z00_15965 = PROCEDURE_REF(BgL_envz00_15963, (int) (((long) 1)));
				BgL_locz00_15966 = PROCEDURE_REF(BgL_envz00_15963, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2290;

					{	/* Eval/evaluate_comp.scm 978 */
						bool_t BgL_auxz00_22022;

						BgL_sz00_2290 = BgL_sz00_15967;
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_bpz00_2292;

							BgL_bpz00_2292 = VECTOR_REF(BgL_sz00_2290, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 978 */
								obj_t BgL_a1z00_2293;
								obj_t BgL_a2z00_2294;

								BgL_a1z00_2293 =
									PROCEDURE_ENTRY(BgL_a1z00_15964) (BgL_a1z00_15964,
									BgL_sz00_2290, BEOA);
								BgL_a2z00_2294 =
									PROCEDURE_ENTRY(BgL_a2z00_15965) (BgL_a2z00_15965,
									BgL_sz00_2290, BEOA);
								if (INTEGERP(BgL_a1z00_2293))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5617z00zz__evaluate_compz00,
											BGl_symbol5603z00zz__evaluate_compz00, BgL_a1z00_2293,
											BgL_locz00_15966);
									}
								if (INTEGERP(BgL_a2z00_2294))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5617z00zz__evaluate_compz00,
											BGl_symbol5603z00zz__evaluate_compz00, BgL_a2z00_2294,
											BgL_locz00_15966);
									}
								BgL_auxz00_22022 =
									((long) CINT(BgL_a1z00_2293) >= (long) CINT(BgL_a2z00_2294));
						}}
						return BBOOL(BgL_auxz00_22022);
					}
				}
			}
		}
	}



/* &<anonymous:2599> */
	obj_t BGl_z62zc3anonymousza32599ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15968, obj_t BgL_sz00_15972)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_15969;
				obj_t BgL_a2z00_15970;
				obj_t BgL_locz00_15971;

				BgL_a1z00_15969 = PROCEDURE_REF(BgL_envz00_15968, (int) (((long) 0)));
				BgL_a2z00_15970 = PROCEDURE_REF(BgL_envz00_15968, (int) (((long) 1)));
				BgL_locz00_15971 = PROCEDURE_REF(BgL_envz00_15968, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2300;

					{	/* Eval/evaluate_comp.scm 978 */
						bool_t BgL_auxz00_22049;

						BgL_sz00_2300 = BgL_sz00_15972;
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_bpz00_2302;

							BgL_bpz00_2302 = VECTOR_REF(BgL_sz00_2300, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 978 */
								obj_t BgL_a1z00_2303;
								obj_t BgL_a2z00_2304;

								BgL_a1z00_2303 =
									PROCEDURE_ENTRY(BgL_a1z00_15969) (BgL_a1z00_15969,
									BgL_sz00_2300, BEOA);
								BgL_a2z00_2304 =
									PROCEDURE_ENTRY(BgL_a2z00_15970) (BgL_a2z00_15970,
									BgL_sz00_2300, BEOA);
								if (INTEGERP(BgL_a1z00_2303))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5619z00zz__evaluate_compz00,
											BGl_symbol5603z00zz__evaluate_compz00, BgL_a1z00_2303,
											BgL_locz00_15971);
									}
								if (INTEGERP(BgL_a2z00_2304))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5619z00zz__evaluate_compz00,
											BGl_symbol5603z00zz__evaluate_compz00, BgL_a2z00_2304,
											BgL_locz00_15971);
									}
								BgL_auxz00_22049 =
									((long) CINT(BgL_a1z00_2303) == (long) CINT(BgL_a2z00_2304));
						}}
						return BBOOL(BgL_auxz00_22049);
					}
				}
			}
		}
	}



/* &<anonymous:2603> */
	obj_t BGl_z62zc3anonymousza32603ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15973, obj_t BgL_sz00_15977)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_15974;
				obj_t BgL_a2z00_15975;
				obj_t BgL_locz00_15976;

				BgL_a1z00_15974 = PROCEDURE_REF(BgL_envz00_15973, (int) (((long) 0)));
				BgL_a2z00_15975 = PROCEDURE_REF(BgL_envz00_15973, (int) (((long) 1)));
				BgL_locz00_15976 = PROCEDURE_REF(BgL_envz00_15973, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2310;

					{	/* Eval/evaluate_comp.scm 978 */
						double BgL_auxz00_22076;

						BgL_sz00_2310 = BgL_sz00_15977;
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_bpz00_2312;

							BgL_bpz00_2312 = VECTOR_REF(BgL_sz00_2310, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 978 */
								obj_t BgL_a1z00_2313;
								obj_t BgL_a2z00_2314;

								BgL_a1z00_2313 =
									PROCEDURE_ENTRY(BgL_a1z00_15974) (BgL_a1z00_15974,
									BgL_sz00_2310, BEOA);
								BgL_a2z00_2314 =
									PROCEDURE_ENTRY(BgL_a2z00_15975) (BgL_a2z00_15975,
									BgL_sz00_2310, BEOA);
								if (REALP(BgL_a1z00_2313))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5621z00zz__evaluate_compz00,
											BGl_symbol5623z00zz__evaluate_compz00, BgL_a1z00_2313,
											BgL_locz00_15976);
									}
								if (REALP(BgL_a2z00_2314))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5621z00zz__evaluate_compz00,
											BGl_symbol5623z00zz__evaluate_compz00, BgL_a2z00_2314,
											BgL_locz00_15976);
									}
								BgL_auxz00_22076 =
									(REAL_TO_DOUBLE(BgL_a1z00_2313) +
									REAL_TO_DOUBLE(BgL_a2z00_2314));
							}
						}
						return DOUBLE_TO_REAL(BgL_auxz00_22076);
					}
				}
			}
		}
	}



/* &<anonymous:2607> */
	obj_t BGl_z62zc3anonymousza32607ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15978, obj_t BgL_sz00_15982)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_15979;
				obj_t BgL_a2z00_15980;
				obj_t BgL_locz00_15981;

				BgL_a1z00_15979 = PROCEDURE_REF(BgL_envz00_15978, (int) (((long) 0)));
				BgL_a2z00_15980 = PROCEDURE_REF(BgL_envz00_15978, (int) (((long) 1)));
				BgL_locz00_15981 = PROCEDURE_REF(BgL_envz00_15978, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2320;

					{	/* Eval/evaluate_comp.scm 978 */
						double BgL_auxz00_22103;

						BgL_sz00_2320 = BgL_sz00_15982;
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_bpz00_2322;

							BgL_bpz00_2322 = VECTOR_REF(BgL_sz00_2320, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 978 */
								obj_t BgL_a1z00_2323;
								obj_t BgL_a2z00_2324;

								BgL_a1z00_2323 =
									PROCEDURE_ENTRY(BgL_a1z00_15979) (BgL_a1z00_15979,
									BgL_sz00_2320, BEOA);
								BgL_a2z00_2324 =
									PROCEDURE_ENTRY(BgL_a2z00_15980) (BgL_a2z00_15980,
									BgL_sz00_2320, BEOA);
								if (REALP(BgL_a1z00_2323))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5625z00zz__evaluate_compz00,
											BGl_symbol5623z00zz__evaluate_compz00, BgL_a1z00_2323,
											BgL_locz00_15981);
									}
								if (REALP(BgL_a2z00_2324))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5625z00zz__evaluate_compz00,
											BGl_symbol5623z00zz__evaluate_compz00, BgL_a2z00_2324,
											BgL_locz00_15981);
									}
								BgL_auxz00_22103 =
									(REAL_TO_DOUBLE(BgL_a1z00_2323) -
									REAL_TO_DOUBLE(BgL_a2z00_2324));
							}
						}
						return DOUBLE_TO_REAL(BgL_auxz00_22103);
					}
				}
			}
		}
	}



/* &<anonymous:2611> */
	obj_t BGl_z62zc3anonymousza32611ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15983, obj_t BgL_sz00_15987)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_15984;
				obj_t BgL_a2z00_15985;
				obj_t BgL_locz00_15986;

				BgL_a1z00_15984 = PROCEDURE_REF(BgL_envz00_15983, (int) (((long) 0)));
				BgL_a2z00_15985 = PROCEDURE_REF(BgL_envz00_15983, (int) (((long) 1)));
				BgL_locz00_15986 = PROCEDURE_REF(BgL_envz00_15983, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2330;

					{	/* Eval/evaluate_comp.scm 978 */
						double BgL_auxz00_22130;

						BgL_sz00_2330 = BgL_sz00_15987;
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_bpz00_2332;

							BgL_bpz00_2332 = VECTOR_REF(BgL_sz00_2330, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 978 */
								obj_t BgL_a1z00_2333;
								obj_t BgL_a2z00_2334;

								BgL_a1z00_2333 =
									PROCEDURE_ENTRY(BgL_a1z00_15984) (BgL_a1z00_15984,
									BgL_sz00_2330, BEOA);
								BgL_a2z00_2334 =
									PROCEDURE_ENTRY(BgL_a2z00_15985) (BgL_a2z00_15985,
									BgL_sz00_2330, BEOA);
								if (REALP(BgL_a1z00_2333))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5627z00zz__evaluate_compz00,
											BGl_symbol5623z00zz__evaluate_compz00, BgL_a1z00_2333,
											BgL_locz00_15986);
									}
								if (REALP(BgL_a2z00_2334))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5627z00zz__evaluate_compz00,
											BGl_symbol5623z00zz__evaluate_compz00, BgL_a2z00_2334,
											BgL_locz00_15986);
									}
								BgL_auxz00_22130 =
									(REAL_TO_DOUBLE(BgL_a1z00_2333) *
									REAL_TO_DOUBLE(BgL_a2z00_2334));
							}
						}
						return DOUBLE_TO_REAL(BgL_auxz00_22130);
					}
				}
			}
		}
	}



/* &<anonymous:2615> */
	obj_t BGl_z62zc3anonymousza32615ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15988, obj_t BgL_sz00_15992)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_15989;
				obj_t BgL_a2z00_15990;
				obj_t BgL_locz00_15991;

				BgL_a1z00_15989 = PROCEDURE_REF(BgL_envz00_15988, (int) (((long) 0)));
				BgL_a2z00_15990 = PROCEDURE_REF(BgL_envz00_15988, (int) (((long) 1)));
				BgL_locz00_15991 = PROCEDURE_REF(BgL_envz00_15988, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2340;

					{	/* Eval/evaluate_comp.scm 978 */
						double BgL_auxz00_22157;

						BgL_sz00_2340 = BgL_sz00_15992;
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_bpz00_2342;

							BgL_bpz00_2342 = VECTOR_REF(BgL_sz00_2340, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 978 */
								obj_t BgL_a1z00_2343;
								obj_t BgL_a2z00_2344;

								BgL_a1z00_2343 =
									PROCEDURE_ENTRY(BgL_a1z00_15989) (BgL_a1z00_15989,
									BgL_sz00_2340, BEOA);
								BgL_a2z00_2344 =
									PROCEDURE_ENTRY(BgL_a2z00_15990) (BgL_a2z00_15990,
									BgL_sz00_2340, BEOA);
								if (REALP(BgL_a1z00_2343))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5629z00zz__evaluate_compz00,
											BGl_symbol5623z00zz__evaluate_compz00, BgL_a1z00_2343,
											BgL_locz00_15991);
									}
								if (REALP(BgL_a2z00_2344))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5629z00zz__evaluate_compz00,
											BGl_symbol5623z00zz__evaluate_compz00, BgL_a2z00_2344,
											BgL_locz00_15991);
									}
								BgL_auxz00_22157 =
									(REAL_TO_DOUBLE(BgL_a1z00_2343) /
									REAL_TO_DOUBLE(BgL_a2z00_2344));
							}
						}
						return DOUBLE_TO_REAL(BgL_auxz00_22157);
					}
				}
			}
		}
	}



/* &<anonymous:2619> */
	obj_t BGl_z62zc3anonymousza32619ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15993, obj_t BgL_sz00_15997)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_15994;
				obj_t BgL_a2z00_15995;
				obj_t BgL_locz00_15996;

				BgL_a1z00_15994 = PROCEDURE_REF(BgL_envz00_15993, (int) (((long) 0)));
				BgL_a2z00_15995 = PROCEDURE_REF(BgL_envz00_15993, (int) (((long) 1)));
				BgL_locz00_15996 = PROCEDURE_REF(BgL_envz00_15993, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2350;

					{	/* Eval/evaluate_comp.scm 978 */
						bool_t BgL_auxz00_22184;

						BgL_sz00_2350 = BgL_sz00_15997;
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_bpz00_2352;

							BgL_bpz00_2352 = VECTOR_REF(BgL_sz00_2350, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 978 */
								obj_t BgL_a1z00_2353;
								obj_t BgL_a2z00_2354;

								BgL_a1z00_2353 =
									PROCEDURE_ENTRY(BgL_a1z00_15994) (BgL_a1z00_15994,
									BgL_sz00_2350, BEOA);
								BgL_a2z00_2354 =
									PROCEDURE_ENTRY(BgL_a2z00_15995) (BgL_a2z00_15995,
									BgL_sz00_2350, BEOA);
								if (REALP(BgL_a1z00_2353))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5631z00zz__evaluate_compz00,
											BGl_symbol5623z00zz__evaluate_compz00, BgL_a1z00_2353,
											BgL_locz00_15996);
									}
								if (REALP(BgL_a2z00_2354))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5631z00zz__evaluate_compz00,
											BGl_symbol5623z00zz__evaluate_compz00, BgL_a2z00_2354,
											BgL_locz00_15996);
									}
								BgL_auxz00_22184 =
									(REAL_TO_DOUBLE(BgL_a1z00_2353) <
									REAL_TO_DOUBLE(BgL_a2z00_2354));
							}
						}
						return BBOOL(BgL_auxz00_22184);
					}
				}
			}
		}
	}



/* &<anonymous:2623> */
	obj_t BGl_z62zc3anonymousza32623ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_15998, obj_t BgL_sz00_16002)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_15999;
				obj_t BgL_a2z00_16000;
				obj_t BgL_locz00_16001;

				BgL_a1z00_15999 = PROCEDURE_REF(BgL_envz00_15998, (int) (((long) 0)));
				BgL_a2z00_16000 = PROCEDURE_REF(BgL_envz00_15998, (int) (((long) 1)));
				BgL_locz00_16001 = PROCEDURE_REF(BgL_envz00_15998, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2360;

					{	/* Eval/evaluate_comp.scm 978 */
						bool_t BgL_auxz00_22211;

						BgL_sz00_2360 = BgL_sz00_16002;
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_bpz00_2362;

							BgL_bpz00_2362 = VECTOR_REF(BgL_sz00_2360, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 978 */
								obj_t BgL_a1z00_2363;
								obj_t BgL_a2z00_2364;

								BgL_a1z00_2363 =
									PROCEDURE_ENTRY(BgL_a1z00_15999) (BgL_a1z00_15999,
									BgL_sz00_2360, BEOA);
								BgL_a2z00_2364 =
									PROCEDURE_ENTRY(BgL_a2z00_16000) (BgL_a2z00_16000,
									BgL_sz00_2360, BEOA);
								if (REALP(BgL_a1z00_2363))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5633z00zz__evaluate_compz00,
											BGl_symbol5623z00zz__evaluate_compz00, BgL_a1z00_2363,
											BgL_locz00_16001);
									}
								if (REALP(BgL_a2z00_2364))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5633z00zz__evaluate_compz00,
											BGl_symbol5623z00zz__evaluate_compz00, BgL_a2z00_2364,
											BgL_locz00_16001);
									}
								BgL_auxz00_22211 =
									(REAL_TO_DOUBLE(BgL_a1z00_2363) >
									REAL_TO_DOUBLE(BgL_a2z00_2364));
							}
						}
						return BBOOL(BgL_auxz00_22211);
					}
				}
			}
		}
	}



/* &<anonymous:2627> */
	obj_t BGl_z62zc3anonymousza32627ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16003, obj_t BgL_sz00_16007)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_16004;
				obj_t BgL_a2z00_16005;
				obj_t BgL_locz00_16006;

				BgL_a1z00_16004 = PROCEDURE_REF(BgL_envz00_16003, (int) (((long) 0)));
				BgL_a2z00_16005 = PROCEDURE_REF(BgL_envz00_16003, (int) (((long) 1)));
				BgL_locz00_16006 = PROCEDURE_REF(BgL_envz00_16003, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2370;

					{	/* Eval/evaluate_comp.scm 978 */
						bool_t BgL_auxz00_22238;

						BgL_sz00_2370 = BgL_sz00_16007;
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_bpz00_2372;

							BgL_bpz00_2372 = VECTOR_REF(BgL_sz00_2370, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 978 */
								obj_t BgL_a1z00_2373;
								obj_t BgL_a2z00_2374;

								BgL_a1z00_2373 =
									PROCEDURE_ENTRY(BgL_a1z00_16004) (BgL_a1z00_16004,
									BgL_sz00_2370, BEOA);
								BgL_a2z00_2374 =
									PROCEDURE_ENTRY(BgL_a2z00_16005) (BgL_a2z00_16005,
									BgL_sz00_2370, BEOA);
								if (REALP(BgL_a1z00_2373))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5635z00zz__evaluate_compz00,
											BGl_symbol5623z00zz__evaluate_compz00, BgL_a1z00_2373,
											BgL_locz00_16006);
									}
								if (REALP(BgL_a2z00_2374))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5635z00zz__evaluate_compz00,
											BGl_symbol5623z00zz__evaluate_compz00, BgL_a2z00_2374,
											BgL_locz00_16006);
									}
								BgL_auxz00_22238 =
									(REAL_TO_DOUBLE(BgL_a1z00_2373) <=
									REAL_TO_DOUBLE(BgL_a2z00_2374));
							}
						}
						return BBOOL(BgL_auxz00_22238);
					}
				}
			}
		}
	}



/* &<anonymous:2631> */
	obj_t BGl_z62zc3anonymousza32631ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16008, obj_t BgL_sz00_16012)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_16009;
				obj_t BgL_a2z00_16010;
				obj_t BgL_locz00_16011;

				BgL_a1z00_16009 = PROCEDURE_REF(BgL_envz00_16008, (int) (((long) 0)));
				BgL_a2z00_16010 = PROCEDURE_REF(BgL_envz00_16008, (int) (((long) 1)));
				BgL_locz00_16011 = PROCEDURE_REF(BgL_envz00_16008, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2380;

					{	/* Eval/evaluate_comp.scm 978 */
						bool_t BgL_auxz00_22265;

						BgL_sz00_2380 = BgL_sz00_16012;
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_bpz00_2382;

							BgL_bpz00_2382 = VECTOR_REF(BgL_sz00_2380, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 978 */
								obj_t BgL_a1z00_2383;
								obj_t BgL_a2z00_2384;

								BgL_a1z00_2383 =
									PROCEDURE_ENTRY(BgL_a1z00_16009) (BgL_a1z00_16009,
									BgL_sz00_2380, BEOA);
								BgL_a2z00_2384 =
									PROCEDURE_ENTRY(BgL_a2z00_16010) (BgL_a2z00_16010,
									BgL_sz00_2380, BEOA);
								if (REALP(BgL_a1z00_2383))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5637z00zz__evaluate_compz00,
											BGl_symbol5623z00zz__evaluate_compz00, BgL_a1z00_2383,
											BgL_locz00_16011);
									}
								if (REALP(BgL_a2z00_2384))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5637z00zz__evaluate_compz00,
											BGl_symbol5623z00zz__evaluate_compz00, BgL_a2z00_2384,
											BgL_locz00_16011);
									}
								BgL_auxz00_22265 =
									(REAL_TO_DOUBLE(BgL_a1z00_2383) >=
									REAL_TO_DOUBLE(BgL_a2z00_2384));
							}
						}
						return BBOOL(BgL_auxz00_22265);
					}
				}
			}
		}
	}



/* &<anonymous:2635> */
	obj_t BGl_z62zc3anonymousza32635ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16013, obj_t BgL_sz00_16017)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_16014;
				obj_t BgL_a2z00_16015;
				obj_t BgL_locz00_16016;

				BgL_a1z00_16014 = PROCEDURE_REF(BgL_envz00_16013, (int) (((long) 0)));
				BgL_a2z00_16015 = PROCEDURE_REF(BgL_envz00_16013, (int) (((long) 1)));
				BgL_locz00_16016 = PROCEDURE_REF(BgL_envz00_16013, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2390;

					{	/* Eval/evaluate_comp.scm 978 */
						bool_t BgL_auxz00_22292;

						BgL_sz00_2390 = BgL_sz00_16017;
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_bpz00_2392;

							BgL_bpz00_2392 = VECTOR_REF(BgL_sz00_2390, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 978 */
								obj_t BgL_a1z00_2393;
								obj_t BgL_a2z00_2394;

								BgL_a1z00_2393 =
									PROCEDURE_ENTRY(BgL_a1z00_16014) (BgL_a1z00_16014,
									BgL_sz00_2390, BEOA);
								BgL_a2z00_2394 =
									PROCEDURE_ENTRY(BgL_a2z00_16015) (BgL_a2z00_16015,
									BgL_sz00_2390, BEOA);
								if (REALP(BgL_a1z00_2393))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5639z00zz__evaluate_compz00,
											BGl_symbol5623z00zz__evaluate_compz00, BgL_a1z00_2393,
											BgL_locz00_16016);
									}
								if (REALP(BgL_a2z00_2394))
									{	/* Eval/evaluate_comp.scm 978 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 978 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5639z00zz__evaluate_compz00,
											BGl_symbol5623z00zz__evaluate_compz00, BgL_a2z00_2394,
											BgL_locz00_16016);
									}
								BgL_auxz00_22292 =
									(REAL_TO_DOUBLE(BgL_a1z00_2393) ==
									REAL_TO_DOUBLE(BgL_a2z00_2394));
							}
						}
						return BBOOL(BgL_auxz00_22292);
					}
				}
			}
		}
	}



/* &<anonymous:2639> */
	obj_t BGl_z62zc3anonymousza32639ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16018, obj_t BgL_sz00_16021)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_16019;
				obj_t BgL_a2z00_16020;

				BgL_a1z00_16019 = PROCEDURE_REF(BgL_envz00_16018, (int) (((long) 0)));
				BgL_a2z00_16020 = PROCEDURE_REF(BgL_envz00_16018, (int) (((long) 1)));
				{
					obj_t BgL_sz00_2400;

					{	/* Eval/evaluate_comp.scm 978 */
						bool_t BgL_auxz00_22317;

						BgL_sz00_2400 = BgL_sz00_16021;
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_bpz00_8857;

							BgL_bpz00_8857 = VECTOR_REF(BgL_sz00_2400, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 978 */
								obj_t BgL_a1z00_8858;
								obj_t BgL_a2z00_8859;

								BgL_a1z00_8858 =
									PROCEDURE_ENTRY(BgL_a1z00_16019) (BgL_a1z00_16019,
									BgL_sz00_2400, BEOA);
								BgL_a2z00_8859 =
									PROCEDURE_ENTRY(BgL_a2z00_16020) (BgL_a2z00_16020,
									BgL_sz00_2400, BEOA);
								BgL_auxz00_22317 = (BgL_a1z00_8858 == BgL_a2z00_8859);
						}}
						return BBOOL(BgL_auxz00_22317);
					}
				}
			}
		}
	}



/* &<anonymous:2641> */
	obj_t BGl_z62zc3anonymousza32641ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16022, obj_t BgL_sz00_16025)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 978 */
				obj_t BgL_a1z00_16023;
				obj_t BgL_a2z00_16024;

				BgL_a1z00_16023 = PROCEDURE_REF(BgL_envz00_16022, (int) (((long) 0)));
				BgL_a2z00_16024 = PROCEDURE_REF(BgL_envz00_16022, (int) (((long) 1)));
				{
					obj_t BgL_sz00_2408;

					BgL_sz00_2408 = BgL_sz00_16025;
					{	/* Eval/evaluate_comp.scm 978 */
						obj_t BgL_bpz00_8862;

						BgL_bpz00_8862 = VECTOR_REF(BgL_sz00_2408, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 978 */
							obj_t BgL_a1z00_8863;
							obj_t BgL_a2z00_8864;

							BgL_a1z00_8863 =
								PROCEDURE_ENTRY(BgL_a1z00_16023) (BgL_a1z00_16023,
								BgL_sz00_2408, BEOA);
							BgL_a2z00_8864 =
								PROCEDURE_ENTRY(BgL_a2z00_16024) (BgL_a2z00_16024,
								BgL_sz00_2408, BEOA);
							return MAKE_PAIR(BgL_a1z00_8863, BgL_a2z00_8864);
						}
					}
				}
			}
		}
	}



/* &<anonymous:2644> */
	obj_t BGl_z62zc3anonymousza32644ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16026, obj_t BgL_sz00_16029)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 975 */
			{	/* Eval/evaluate_comp.scm 975 */
				obj_t BgL_a1z00_16027;
				obj_t BgL_locz00_16028;

				BgL_a1z00_16027 = PROCEDURE_REF(BgL_envz00_16026, (int) (((long) 0)));
				BgL_locz00_16028 = PROCEDURE_REF(BgL_envz00_16026, (int) (((long) 1)));
				{
					obj_t BgL_sz00_2417;

					BgL_sz00_2417 = BgL_sz00_16029;
					{	/* Eval/evaluate_comp.scm 975 */
						obj_t BgL_bpz00_2419;

						BgL_bpz00_2419 = VECTOR_REF(BgL_sz00_2417, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 975 */
							obj_t BgL_a1z00_2420;

							BgL_a1z00_2420 =
								PROCEDURE_ENTRY(BgL_a1z00_16027) (BgL_a1z00_16027,
								BgL_sz00_2417, BEOA);
							if (PAIRP(BgL_a1z00_2420))
								{	/* Eval/evaluate_comp.scm 975 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 975 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5641z00zz__evaluate_compz00,
										BGl_symbol5643z00zz__evaluate_compz00, BgL_a1z00_2420,
										BgL_locz00_16028);
								}
							return CAR(BgL_a1z00_2420);
						}
					}
				}
			}
		}
	}



/* &<anonymous:2647> */
	obj_t BGl_z62zc3anonymousza32647ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16030, obj_t BgL_sz00_16033)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 975 */
			{	/* Eval/evaluate_comp.scm 975 */
				obj_t BgL_a1z00_16031;
				obj_t BgL_locz00_16032;

				BgL_a1z00_16031 = PROCEDURE_REF(BgL_envz00_16030, (int) (((long) 0)));
				BgL_locz00_16032 = PROCEDURE_REF(BgL_envz00_16030, (int) (((long) 1)));
				{
					obj_t BgL_sz00_2424;

					BgL_sz00_2424 = BgL_sz00_16033;
					{	/* Eval/evaluate_comp.scm 975 */
						obj_t BgL_bpz00_2426;

						BgL_bpz00_2426 = VECTOR_REF(BgL_sz00_2424, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 975 */
							obj_t BgL_a1z00_2427;

							BgL_a1z00_2427 =
								PROCEDURE_ENTRY(BgL_a1z00_16031) (BgL_a1z00_16031,
								BgL_sz00_2424, BEOA);
							if (PAIRP(BgL_a1z00_2427))
								{	/* Eval/evaluate_comp.scm 975 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 975 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5645z00zz__evaluate_compz00,
										BGl_symbol5643z00zz__evaluate_compz00, BgL_a1z00_2427,
										BgL_locz00_16032);
								}
							return CDR(BgL_a1z00_2427);
						}
					}
				}
			}
		}
	}



/* &<anonymous:2650> */
	obj_t BGl_z62zc3anonymousza32650ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16034, obj_t BgL_sz00_16037)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 975 */
			{	/* Eval/evaluate_comp.scm 975 */
				obj_t BgL_a1z00_16035;
				obj_t BgL_locz00_16036;

				BgL_a1z00_16035 = PROCEDURE_REF(BgL_envz00_16034, (int) (((long) 0)));
				BgL_locz00_16036 = PROCEDURE_REF(BgL_envz00_16034, (int) (((long) 1)));
				{
					obj_t BgL_sz00_2431;

					BgL_sz00_2431 = BgL_sz00_16037;
					{	/* Eval/evaluate_comp.scm 975 */
						obj_t BgL_bpz00_2433;

						BgL_bpz00_2433 = VECTOR_REF(BgL_sz00_2431, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 975 */
							obj_t BgL_a1z00_2434;

							BgL_a1z00_2434 =
								PROCEDURE_ENTRY(BgL_a1z00_16035) (BgL_a1z00_16035,
								BgL_sz00_2431, BEOA);
							{	/* Eval/evaluate_comp.scm 975 */
								bool_t BgL_testz00_22383;

								if (PAIRP(BgL_a1z00_2434))
									{	/* Ieee/pairlist.scm 214 */
										obj_t BgL_auxz00_22386;

										BgL_auxz00_22386 = CDR(BgL_a1z00_2434);
										BgL_testz00_22383 = PAIRP(BgL_auxz00_22386);
									}
								else
									{	/* Eval/evaluate_comp.scm 984 */
										BgL_testz00_22383 = ((bool_t) 0);
									}
								if (BgL_testz00_22383)
									{	/* Eval/evaluate_comp.scm 975 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 975 */
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
											(BGl_symbol5647z00zz__evaluate_compz00,
											BGl_symbol5643z00zz__evaluate_compz00, BgL_a1z00_2434,
											BgL_locz00_16036);
									}
							}
							{	/* Eval/evaluate_comp.scm 975 */
								obj_t BgL_pairz00_8665;

								BgL_pairz00_8665 = BgL_a1z00_2434;
								return CAR(CDR(BgL_pairz00_8665));
							}
						}
					}
				}
			}
		}
	}



/* bind-frame */
	obj_t BGl_bindzd2framezd2zz__evaluate_compz00(obj_t BgL_sz00_202,
		obj_t BgL_wherez00_203, long BgL_spz00_204, long BgL_arityz00_205,
		obj_t BgL_valsz00_206, obj_t BgL_locz00_207)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1017 */
			if ((BgL_arityz00_205 < ((long) 0)))
				{	/* Eval/evaluate_comp.scm 1019 */
					long BgL_g1242z00_2440;

					BgL_g1242z00_2440 = (((long) -1) - BgL_arityz00_205);
					{
						long BgL_rz00_2442;
						long BgL_spz00_2443;
						obj_t BgL_lz00_2444;

						BgL_rz00_2442 = BgL_g1242z00_2440;
						BgL_spz00_2443 = BgL_spz00_204;
						BgL_lz00_2444 = BgL_valsz00_206;
					BgL_zc3anonymousza32655ze3z83_2445:
						if ((BgL_rz00_2442 == ((long) 0)))
							{	/* Eval/evaluate_comp.scm 1021 */
								return
									VECTOR_SET(BgL_sz00_202,
									(int) (BgL_spz00_2443), BgL_lz00_2444);
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								if (PAIRP(BgL_lz00_2444))
									{	/* Eval/evaluate_comp.scm 1023 */
										VECTOR_SET(BgL_sz00_202,
											(int) (BgL_spz00_2443), CAR(BgL_lz00_2444));
										{
											obj_t BgL_lz00_22408;
											long BgL_spz00_22406;
											long BgL_rz00_22404;

											BgL_rz00_22404 = (BgL_rz00_2442 - ((long) 1));
											BgL_spz00_22406 = (BgL_spz00_2443 + ((long) 1));
											BgL_lz00_22408 = CDR(BgL_lz00_2444);
											BgL_lz00_2444 = BgL_lz00_22408;
											BgL_spz00_2443 = BgL_spz00_22406;
											BgL_rz00_2442 = BgL_rz00_22404;
											goto BgL_zc3anonymousza32655ze3z83_2445;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1024 */
										long BgL_arg2663z00_2452;

										BgL_arg2663z00_2452 = bgl_list_length(BgL_valsz00_206);
										return
											BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_207,
											BgL_wherez00_203, (int) (BgL_arityz00_205),
											(int) (BgL_arg2663z00_2452));
				}}}}
			else
				{
					long BgL_rz00_2455;
					long BgL_spz00_2456;
					obj_t BgL_lz00_2457;

					BgL_rz00_2455 = BgL_arityz00_205;
					BgL_spz00_2456 = BgL_spz00_204;
					BgL_lz00_2457 = BgL_valsz00_206;
				BgL_zc3anonymousza32664ze3z83_2458:
					if ((BgL_rz00_2455 == ((long) 0)))
						{	/* Eval/evaluate_comp.scm 1030 */
							if (NULLP(BgL_lz00_2457))
								{	/* Eval/evaluate_comp.scm 1031 */
									return BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1032 */
									long BgL_arg2667z00_2461;

									BgL_arg2667z00_2461 = bgl_list_length(BgL_valsz00_206);
									return
										BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_207,
										BgL_wherez00_203, (int) (BgL_arityz00_205),
										(int) (BgL_arg2667z00_2461));
						}}
					else
						{	/* Eval/evaluate_comp.scm 1030 */
							if (PAIRP(BgL_lz00_2457))
								{	/* Eval/evaluate_comp.scm 1033 */
									VECTOR_SET(BgL_sz00_202,
										(int) (BgL_spz00_2456), CAR(BgL_lz00_2457));
									{
										obj_t BgL_lz00_22431;
										long BgL_spz00_22429;
										long BgL_rz00_22427;

										BgL_rz00_22427 = (BgL_rz00_2455 - ((long) 1));
										BgL_spz00_22429 = (BgL_spz00_2456 + ((long) 1));
										BgL_lz00_22431 = CDR(BgL_lz00_2457);
										BgL_lz00_2457 = BgL_lz00_22431;
										BgL_spz00_2456 = BgL_spz00_22429;
										BgL_rz00_2455 = BgL_rz00_22427;
										goto BgL_zc3anonymousza32664ze3z83_2458;
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 1034 */
									long BgL_arg2673z00_2467;

									BgL_arg2673z00_2467 = bgl_list_length(BgL_valsz00_206);
									return
										BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_207,
										BgL_wherez00_203, (int) (BgL_arityz00_205),
										(int) (BgL_arg2673z00_2467));
		}}}}
	}



/* make-boxes */
	bool_t BGl_makezd2boxeszd2zz__evaluate_compz00(obj_t BgL_sz00_210,
		obj_t BgL_ibza2za2_211, obj_t BgL_bpz00_212)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1132 */
			{	/* Eval/evaluate_comp.scm 1133 */
				int BgL_nz00_2469;

				BgL_nz00_2469 = VECTOR_LENGTH(BgL_ibza2za2_211);
				{
					long BgL_iz00_2471;

					BgL_iz00_2471 = ((long) 0);
				BgL_zc3anonymousza32674ze3z83_2472:
					{	/* Eval/evaluate_comp.scm 1135 */
						long BgL_spz00_2473;

						{	/* Eval/evaluate_comp.scm 1135 */
							obj_t BgL_arg2678z00_2478;

							BgL_arg2678z00_2478 =
								VECTOR_REF(BgL_ibza2za2_211, (int) (BgL_iz00_2471));
							BgL_spz00_2473 =
								((long) CINT(BgL_bpz00_212) + (long) CINT(BgL_arg2678z00_2478));
						}
						{	/* Eval/evaluate_comp.scm 1136 */
							obj_t BgL_arg2675z00_2474;

							{	/* Eval/evaluate_comp.scm 1136 */
								obj_t BgL_arg2676z00_2475;

								BgL_arg2676z00_2475 =
									VECTOR_REF(BgL_sz00_210, (int) (BgL_spz00_2473));
								{	/* Eval/evaluate_comp.scm 189 */
									obj_t BgL_newz00_8936;

									BgL_newz00_8936 =
										create_struct(BGl_symbol5571z00zz__evaluate_compz00,
										(int) (((long) 1)));
									{	/* Llib/struct.scm 162 */
										int BgL_auxz00_22447;

										BgL_auxz00_22447 = (int) (((long) 0));
										STRUCT_SET(BgL_newz00_8936, BgL_auxz00_22447,
											BgL_arg2676z00_2475);
									}
									BgL_arg2675z00_2474 = BgL_newz00_8936;
							}}
							VECTOR_SET(BgL_sz00_210,
								(int) (BgL_spz00_2473), BgL_arg2675z00_2474);
						}
						{	/* Eval/evaluate_comp.scm 1137 */
							long BgL_niz00_2476;

							BgL_niz00_2476 = (BgL_iz00_2471 + ((long) 1));
							if ((BgL_niz00_2476 < (long) (BgL_nz00_2469)))
								{
									long BgL_iz00_22456;

									BgL_iz00_22456 = BgL_niz00_2476;
									BgL_iz00_2471 = BgL_iz00_22456;
									goto BgL_zc3anonymousza32674ze3z83_2472;
								}
							else
								{	/* Eval/evaluate_comp.scm 1138 */
									return ((bool_t) 0);
								}
						}
					}
				}
			}
		}
	}



/* free-collect */
	obj_t BGl_freezd2collectzd2zz__evaluate_compz00(obj_t BgL_sz00_213,
		obj_t BgL_bpz00_214, obj_t BgL_iza2za2_215)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1140 */
			{	/* Eval/evaluate_comp.scm 1141 */
				int BgL_nz00_2480;

				BgL_nz00_2480 = VECTOR_LENGTH(BgL_iza2za2_215);
				{	/* Eval/evaluate_comp.scm 1141 */
					obj_t BgL_rz00_2481;

					BgL_rz00_2481 = make_vector(BgL_nz00_2480, BUNSPEC);
					{	/* Eval/evaluate_comp.scm 1141 */

						{
							long BgL_iz00_2483;

							BgL_iz00_2483 = ((long) 0);
						BgL_zc3anonymousza32679ze3z83_2484:
							if ((BgL_iz00_2483 >= (long) (BgL_nz00_2480)))
								{	/* Eval/evaluate_comp.scm 1143 */
									return BgL_rz00_2481;
								}
							else
								{	/* Eval/evaluate_comp.scm 1143 */
									{	/* Eval/evaluate_comp.scm 1146 */
										obj_t BgL_arg2681z00_2486;

										{	/* Eval/evaluate_comp.scm 1146 */
											long BgL_arg2682z00_2487;

											{	/* Eval/evaluate_comp.scm 1146 */
												obj_t BgL_arg2683z00_2488;

												BgL_arg2683z00_2488 =
													VECTOR_REF(BgL_iza2za2_215, (int) (BgL_iz00_2483));
												BgL_arg2682z00_2487 =
													(
													(long) CINT(BgL_bpz00_214) +
													(long) CINT(BgL_arg2683z00_2488));
											}
											BgL_arg2681z00_2486 =
												VECTOR_REF(BgL_sz00_213, (int) (BgL_arg2682z00_2487));
										}
										VECTOR_SET(BgL_rz00_2481,
											(int) (BgL_iz00_2483), BgL_arg2681z00_2486);
									}
									{
										long BgL_iz00_22471;

										BgL_iz00_22471 = (BgL_iz00_2483 + ((long) 1));
										BgL_iz00_2483 = BgL_iz00_22471;
										goto BgL_zc3anonymousza32679ze3z83_2484;
									}
								}
						}
					}
				}
			}
		}
	}



/* free-restore */
	bool_t BGl_freezd2restorezd2zz__evaluate_compz00(obj_t BgL_sz00_216,
		obj_t BgL_valza2za2_217, long BgL_spz00_218)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1149 */
			{	/* Eval/evaluate_comp.scm 1150 */
				long BgL_stopz00_2492;

				{	/* Eval/evaluate_comp.scm 1150 */
					int BgL_arg2691z00_2502;

					BgL_arg2691z00_2502 = VECTOR_LENGTH(BgL_valza2za2_217);
					BgL_stopz00_2492 = (BgL_spz00_218 + (long) (BgL_arg2691z00_2502));
				}
				{
					long BgL_iz00_9012;
					long BgL_spz00_9013;

					BgL_iz00_9012 = ((long) 0);
					BgL_spz00_9013 = BgL_spz00_218;
				BgL_recz00_9011:
					if ((BgL_spz00_9013 < BgL_stopz00_2492))
						{	/* Eval/evaluate_comp.scm 1152 */
							VECTOR_SET(BgL_sz00_216,
								(int) (BgL_spz00_9013),
								VECTOR_REF(BgL_valza2za2_217, (int) (BgL_iz00_9012)));
							{
								long BgL_spz00_22484;
								long BgL_iz00_22482;

								BgL_iz00_22482 = (BgL_iz00_9012 + ((long) 1));
								BgL_spz00_22484 = (BgL_spz00_9013 + ((long) 1));
								BgL_spz00_9013 = BgL_spz00_22484;
								BgL_iz00_9012 = BgL_iz00_22482;
								goto BgL_recz00_9011;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 1152 */
							return ((bool_t) 0);
						}
				}
			}
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zz__evaluate_compz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 15 */
			return BUNSPEC;
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zz__evaluate_compz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 15 */
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_proc5649z00zz__evaluate_compz00,
				BGl_ev_exprz00zz__evaluate_typesz00,
				BGl_string5650z00zz__evaluate_compz00);
		}
	}



/* &comp1639 */
	obj_t BGl_z62comp1639z62zz__evaluate_compz00(obj_t BgL_envz00_16123,
		obj_t BgL_ez00_16124, obj_t BgL_stkz00_16125)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 264 */
			{
				BgL_ev_exprz00_bglt BgL_ez00_2504;
				obj_t BgL_stkz00_2505;

				BgL_ez00_2504 = ((BgL_ev_exprz00_bglt) BgL_ez00_16124);
				BgL_stkz00_2505 = BgL_stkz00_16125;
				return
					BGl_errorz00zz__errorz00(BGl_string5561z00zz__evaluate_compz00,
					BGl_string5651z00zz__evaluate_compz00, ((obj_t) BgL_ez00_2504));
			}
		}
	}



/* comp */
	obj_t BGl_compz00zz__evaluate_compz00(BgL_ev_exprz00_bglt BgL_ez00_35,
		obj_t BgL_stkz00_36)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 264 */
			{	/* Eval/evaluate_comp.scm 264 */
				obj_t BgL_method1640z00_2508;

				{	/* Eval/evaluate_comp.scm 264 */
					obj_t BgL_res4825z00_9064;

					{	/* Eval/evaluate_comp.scm 264 */
						BgL_objectz00_bglt BgL_objz00_9036;

						BgL_objz00_9036 = ((BgL_objectz00_bglt) BgL_ez00_35);
						{	/* Llib/object.scm 1141 */
							long BgL_objzd2classzd2numz00_9037;

							{	/* Llib/object.scm 1141 */
								long BgL_res4819z00_9040;

								BgL_res4819z00_9040 = BGL_OBJECT_CLASS_NUM(BgL_objz00_9036);
								BgL_objzd2classzd2numz00_9037 = BgL_res4819z00_9040;
							}
							{	/* Llib/object.scm 1142 */
								obj_t BgL_arg4321z00_9038;

								BgL_arg4321z00_9038 =
									PROCEDURE_REF(BGl_compzd2envzd2zz__evaluate_compz00,
									(int) (((long) 1)));
								{	/* Llib/object.scm 1142 */
									obj_t BgL_arrayz00_9041;
									int BgL_offsetz00_9042;

									BgL_arrayz00_9041 = BgL_arg4321z00_9038;
									BgL_offsetz00_9042 = (int) (BgL_objzd2classzd2numz00_9037);
									{	/* Llib/object.scm 830 */
										long BgL_offsetz00_9043;

										BgL_offsetz00_9043 =
											((long) (BgL_offsetz00_9042) - OBJECT_TYPE);
										{	/* Llib/object.scm 830 */
											long BgL_modz00_9044;

											{	/* Llib/object.scm 831 */
												int BgL_arg4323z00_9045;

												BgL_arg4323z00_9045 = (int) (((long) 16));
												{	/* Llib/object.scm 831 */
													long BgL_res4822z00_9055;

													{	/* Ieee/fixnum.scm 1135 */
														long BgL_auxz00_22498;

														BgL_auxz00_22498 = (long) (BgL_arg4323z00_9045);
														BgL_res4822z00_9055 =
															(BgL_offsetz00_9043 / BgL_auxz00_22498);
													}
													BgL_modz00_9044 = BgL_res4822z00_9055;
											}}
											{	/* Llib/object.scm 831 */
												long BgL_restz00_9046;

												{	/* Llib/object.scm 832 */
													int BgL_arg4322z00_9047;

													BgL_arg4322z00_9047 = (int) (((long) 16));
													{	/* Llib/object.scm 832 */
														long BgL_res4824z00_9059;

														{	/* Ieee/fixnum.scm 1165 */
															long BgL_auxz00_22502;

															BgL_auxz00_22502 = (long) (BgL_arg4322z00_9047);
															BgL_res4824z00_9059 =
																(BgL_offsetz00_9043 % BgL_auxz00_22502);
														}
														BgL_restz00_9046 = BgL_res4824z00_9059;
												}}
												{	/* Llib/object.scm 832 */

													BgL_res4825z00_9064 =
														VECTOR_REF(VECTOR_REF(BgL_arrayz00_9041,
															(int) (BgL_modz00_9044)),
														(int) (BgL_restz00_9046));
					}}}}}}}}
					BgL_method1640z00_2508 = BgL_res4825z00_9064;
				}
				return
					PROCEDURE_ENTRY(BgL_method1640z00_2508) (BgL_method1640z00_2508,
					((obj_t) BgL_ez00_35), BgL_stkz00_36, BEOA);
			}
		}
	}



/* &comp */
	obj_t BGl_z62compz62zz__evaluate_compz00(obj_t BgL_envz00_16126,
		obj_t BgL_ez00_16127, obj_t BgL_stkz00_16128)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 264 */
			{	/* Eval/evaluate_comp.scm 264 */
				BgL_ev_exprz00_bglt BgL_auxz00_22515;

				if (BGl_isazf3zf3zz__objectz00(BgL_ez00_16127,
						BGl_ev_exprz00zz__evaluate_typesz00))
					{	/* Eval/evaluate_comp.scm 264 */
						BgL_auxz00_22515 = ((BgL_ev_exprz00_bglt) BgL_ez00_16127);
					}
				else
					{
						obj_t BgL_auxz00_22519;

						BgL_auxz00_22519 =
							BGl_typezd2errorzd2zz__errorz00
							(BGl_string5566z00zz__evaluate_compz00, BINT(((long) 6608)),
							BGl_string5652z00zz__evaluate_compz00,
							BGl_string5568z00zz__evaluate_compz00, BgL_ez00_16127);
						FAILURE(BgL_auxz00_22519, BFALSE, BFALSE);
					}
				return
					BGl_compz00zz__evaluate_compz00(BgL_auxz00_22515, BgL_stkz00_16128);
			}
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zz__evaluate_compz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 15 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_trapz00zz__evaluate_typesz00,
				BGl_proc5653z00zz__evaluate_compz00,
				BGl_string5654z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_varz00zz__evaluate_typesz00, BGl_proc5655z00zz__evaluate_compz00,
				BGl_string5654z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_setlocalz00zz__evaluate_typesz00,
				BGl_proc5656z00zz__evaluate_compz00,
				BGl_string5654z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_globalz00zz__evaluate_typesz00,
				BGl_proc5657z00zz__evaluate_compz00,
				BGl_string5654z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_setglobalz00zz__evaluate_typesz00,
				BGl_proc5658z00zz__evaluate_compz00,
				BGl_string5654z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_defglobalz00zz__evaluate_typesz00,
				BGl_proc5659z00zz__evaluate_compz00,
				BGl_string5654z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_littz00zz__evaluate_typesz00,
				BGl_proc5660z00zz__evaluate_compz00,
				BGl_string5654z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_ifz00zz__evaluate_typesz00, BGl_proc5661z00zz__evaluate_compz00,
				BGl_string5654z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_orz00zz__evaluate_typesz00, BGl_proc5662z00zz__evaluate_compz00,
				BGl_string5654z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_andz00zz__evaluate_typesz00, BGl_proc5663z00zz__evaluate_compz00,
				BGl_string5654z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_prog2z00zz__evaluate_typesz00,
				BGl_proc5664z00zz__evaluate_compz00,
				BGl_string5654z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_letz00zz__evaluate_typesz00, BGl_proc5665z00zz__evaluate_compz00,
				BGl_string5654z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_letza2za2zz__evaluate_typesz00,
				BGl_proc5666z00zz__evaluate_compz00,
				BGl_string5654z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_letrecz00zz__evaluate_typesz00,
				BGl_proc5667z00zz__evaluate_compz00,
				BGl_string5654z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_bindzd2exitzd2zz__evaluate_typesz00,
				BGl_proc5668z00zz__evaluate_compz00,
				BGl_string5654z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00,
				BGl_proc5669z00zz__evaluate_compz00,
				BGl_string5654z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_withzd2handlerzd2zz__evaluate_typesz00,
				BGl_proc5670z00zz__evaluate_compz00,
				BGl_string5654z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_synchroniza7eza7zz__evaluate_typesz00,
				BGl_proc5671z00zz__evaluate_compz00,
				BGl_string5654z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_labelsz00zz__evaluate_typesz00,
				BGl_proc5672z00zz__evaluate_compz00,
				BGl_string5654z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_gotoz00zz__evaluate_typesz00,
				BGl_proc5673z00zz__evaluate_compz00,
				BGl_string5654z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_appz00zz__evaluate_typesz00, BGl_proc5674z00zz__evaluate_compz00,
				BGl_string5654z00zz__evaluate_compz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_absz00zz__evaluate_typesz00, BGl_proc5675z00zz__evaluate_compz00,
				BGl_string5654z00zz__evaluate_compz00);
		}
	}



/* &comp-ev_abs1685 */
	obj_t BGl_z62compzd2ev_abs1685zb0zz__evaluate_compz00(obj_t BgL_envz00_16321,
		obj_t BgL_ez00_16322, obj_t BgL_stkz00_16323)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1120 */
			{
				BgL_ev_absz00_bglt BgL_ez00_3281;
				obj_t BgL_stkz00_3282;

				BgL_ez00_3281 = ((BgL_ev_absz00_bglt) BgL_ez00_16322);
				BgL_stkz00_3282 = BgL_stkz00_16323;
				{	/* Eval/evaluate_comp.scm 1122 */
					obj_t BgL_ifreesz00_3286;
					obj_t BgL_iboxesz00_3287;
					long BgL_siza7eza7_3288;
					long BgL_siza7ezd2framez75_3289;
					obj_t BgL_nstkz00_3290;

					{	/* Eval/evaluate_comp.scm 1122 */
						obj_t BgL_arg3997z00_5310;

						{	/* Eval/evaluate_comp.scm 1122 */
							obj_t BgL_l1619z00_5311;

							BgL_l1619z00_5311 =
								(((BgL_ev_absz00_bglt) CREF(BgL_ez00_3281))->BgL_freez00);
							if (NULLP(BgL_l1619z00_5311))
								{	/* Eval/evaluate_comp.scm 1122 */
									BgL_arg3997z00_5310 = BNIL;
								}
							else
								{	/* Eval/evaluate_comp.scm 1122 */
									obj_t BgL_head1621z00_5313;

									{	/* Eval/evaluate_comp.scm 1122 */
										obj_t BgL_res4963z00_10328;

										BgL_res4963z00_10328 = MAKE_PAIR(BNIL, BNIL);
										BgL_head1621z00_5313 = BgL_res4963z00_10328;
									}
									{
										obj_t BgL_l1619z00_10362;
										obj_t BgL_tail1622z00_10363;

										BgL_l1619z00_10362 = BgL_l1619z00_5311;
										BgL_tail1622z00_10363 = BgL_head1621z00_5313;
									BgL_zc3anonymousza33999ze3z83_10361:
										if (NULLP(BgL_l1619z00_10362))
											{	/* Eval/evaluate_comp.scm 1122 */
												BgL_arg3997z00_5310 = CDR(BgL_head1621z00_5313);
											}
										else
											{	/* Eval/evaluate_comp.scm 1122 */
												obj_t BgL_newtail1623z00_10370;

												{	/* Eval/evaluate_comp.scm 1122 */
													obj_t BgL_arg4002z00_10371;

													BgL_arg4002z00_10371 =
														BGl__indexz00zz__evaluate_compz00(CAR
														(BgL_l1619z00_10362), BgL_stkz00_3282);
													{	/* Eval/evaluate_comp.scm 1122 */
														obj_t BgL_res4969z00_10380;

														BgL_res4969z00_10380 =
															MAKE_PAIR(BgL_arg4002z00_10371, BNIL);
														BgL_newtail1623z00_10370 = BgL_res4969z00_10380;
													}
												}
												SET_CDR(BgL_tail1622z00_10363,
													BgL_newtail1623z00_10370);
												{
													obj_t BgL_tail1622z00_22559;
													obj_t BgL_l1619z00_22557;

													BgL_l1619z00_22557 = CDR(BgL_l1619z00_10362);
													BgL_tail1622z00_22559 = BgL_newtail1623z00_10370;
													BgL_tail1622z00_10363 = BgL_tail1622z00_22559;
													BgL_l1619z00_10362 = BgL_l1619z00_22557;
													goto BgL_zc3anonymousza33999ze3z83_10361;
												}
											}
									}
								}
						}
						BgL_ifreesz00_3286 =
							BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg3997z00_5310);
					}
					{	/* Eval/evaluate_comp.scm 1123 */
						obj_t BgL_arg4003z00_5324;

						{	/* Eval/evaluate_comp.scm 1123 */
							obj_t BgL_l1624z00_5325;

							BgL_l1624z00_5325 =
								(((BgL_ev_absz00_bglt) CREF(BgL_ez00_3281))->BgL_boxesz00);
							if (NULLP(BgL_l1624z00_5325))
								{	/* Eval/evaluate_comp.scm 1123 */
									BgL_arg4003z00_5324 = BNIL;
								}
							else
								{	/* Eval/evaluate_comp.scm 1123 */
									obj_t BgL_head1626z00_5327;

									{	/* Eval/evaluate_comp.scm 1123 */
										obj_t BgL_res4971z00_10388;

										BgL_res4971z00_10388 = MAKE_PAIR(BNIL, BNIL);
										BgL_head1626z00_5327 = BgL_res4971z00_10388;
									}
									{
										obj_t BgL_l1624z00_5329;
										obj_t BgL_tail1627z00_5330;

										BgL_l1624z00_5329 = BgL_l1624z00_5325;
										BgL_tail1627z00_5330 = BgL_head1626z00_5327;
									BgL_zc3anonymousza34005ze3z83_5331:
										if (NULLP(BgL_l1624z00_5329))
											{	/* Eval/evaluate_comp.scm 1123 */
												BgL_arg4003z00_5324 = CDR(BgL_head1626z00_5327);
											}
										else
											{	/* Eval/evaluate_comp.scm 1123 */
												obj_t BgL_newtail1628z00_5333;

												{	/* Eval/evaluate_comp.scm 1123 */
													obj_t BgL_arg4008z00_5335;

													BgL_arg4008z00_5335 =
														BGl__indexz00zz__evaluate_compz00(CAR
														(BgL_l1624z00_5329),
														(((BgL_ev_absz00_bglt) CREF(BgL_ez00_3281))->
															BgL_varsz00));
													{	/* Eval/evaluate_comp.scm 1123 */
														obj_t BgL_res4973z00_10395;

														BgL_res4973z00_10395 =
															MAKE_PAIR(BgL_arg4008z00_5335, BNIL);
														BgL_newtail1628z00_5333 = BgL_res4973z00_10395;
													}
												}
												SET_CDR(BgL_tail1627z00_5330, BgL_newtail1628z00_5333);
												{
													obj_t BgL_tail1627z00_22575;
													obj_t BgL_l1624z00_22573;

													BgL_l1624z00_22573 = CDR(BgL_l1624z00_5329);
													BgL_tail1627z00_22575 = BgL_newtail1628z00_5333;
													BgL_tail1627z00_5330 = BgL_tail1627z00_22575;
													BgL_l1624z00_5329 = BgL_l1624z00_22573;
													goto BgL_zc3anonymousza34005ze3z83_5331;
												}
											}
									}
								}
						}
						BgL_iboxesz00_3287 =
							BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg4003z00_5324);
					}
					BgL_siza7eza7_3288 =
						bgl_list_length(
						(((BgL_ev_absz00_bglt) CREF(BgL_ez00_3281))->BgL_varsz00));
					BgL_siza7ezd2framez75_3289 =
						(
						(long) (
							(((BgL_ev_absz00_bglt) CREF(BgL_ez00_3281))->BgL_siza7eza7)) +
						bgl_list_length(
							(((BgL_ev_absz00_bglt) CREF(BgL_ez00_3281))->BgL_freez00)));
					BgL_nstkz00_3290 =
						BGl_appendzd221011zd2zz__evaluate_compz00(
						(((BgL_ev_absz00_bglt) CREF(BgL_ez00_3281))->BgL_varsz00),
						(((BgL_ev_absz00_bglt) CREF(BgL_ez00_3281))->BgL_freez00));
					{	/* Eval/evaluate_comp.scm 1127 */
						obj_t BgL_bodyz00_3291;

						BgL_bodyz00_3291 =
							BGl_compz00zz__evaluate_compz00(
							(((BgL_ev_absz00_bglt) CREF(BgL_ez00_3281))->BgL_bodyz00),
							BgL_nstkz00_3290);
						{

							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_aux1278z00_3293;

								BgL_aux1278z00_3293 =
									(((BgL_ev_absz00_bglt) CREF(BgL_ez00_3281))->BgL_arityz00);
								if (INTEGERP(BgL_aux1278z00_3293))
									{	/* Eval/evaluate_comp.scm 1129 */
										switch ((long) CINT(BgL_aux1278z00_3293))
											{
											case ((long) 0):

												{	/* Eval/evaluate_comp.scm 1129 */
													bool_t BgL_testz00_22592;

													{	/* Eval/evaluate_comp.scm 1129 */
														int BgL_arg3109z00_3452;

														BgL_arg3109z00_3452 =
															VECTOR_LENGTH(BgL_ifreesz00_3286);
														BgL_testz00_22592 =
															((long) (BgL_arg3109z00_3452) == ((long) 0));
													}
													if (BgL_testz00_22592)
														{	/* Eval/evaluate_comp.scm 1129 */
															bool_t BgL_testz00_22596;

															{	/* Eval/evaluate_comp.scm 1129 */
																int BgL_arg3070z00_3371;

																BgL_arg3070z00_3371 =
																	VECTOR_LENGTH(BgL_iboxesz00_3287);
																BgL_testz00_22596 =
																	((long) (BgL_arg3070z00_3371) == ((long) 0));
															}
															if (BgL_testz00_22596)
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33038ze3z83_16140;

																	BgL_zc3anonymousza33038ze3z83_16140 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33038ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 3)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33038ze3z83_16140,
																		(int) (((long) 0)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33038ze3z83_16140,
																		(int) (((long) 1)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33038ze3z83_16140,
																		(int) (((long) 2)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33038ze3z83_16140;
																}
															else
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33054ze3z83_16137;

																	BgL_zc3anonymousza33054ze3z83_16137 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33054ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 4)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33054ze3z83_16137,
																		(int) (((long) 0)), BgL_iboxesz00_3287);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33054ze3z83_16137,
																		(int) (((long) 1)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33054ze3z83_16137,
																		(int) (((long) 2)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33054ze3z83_16137,
																		(int) (((long) 3)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33054ze3z83_16137;
																}
														}
													else
														{	/* Eval/evaluate_comp.scm 1129 */
															bool_t BgL_testz00_22624;

															{	/* Eval/evaluate_comp.scm 1129 */
																int BgL_arg3108z00_3451;

																BgL_arg3108z00_3451 =
																	VECTOR_LENGTH(BgL_iboxesz00_3287);
																BgL_testz00_22624 =
																	((long) (BgL_arg3108z00_3451) == ((long) 0));
															}
															if (BgL_testz00_22624)
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33072ze3z83_16134;

																	BgL_zc3anonymousza33072ze3z83_16134 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33072ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 5)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33072ze3z83_16134,
																		(int) (((long) 0)), BgL_ifreesz00_3286);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33072ze3z83_16134,
																		(int) (((long) 1)),
																		BINT(BgL_siza7eza7_3288));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33072ze3z83_16134,
																		(int) (((long) 2)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33072ze3z83_16134,
																		(int) (((long) 3)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33072ze3z83_16134,
																		(int) (((long) 4)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33072ze3z83_16134;
																}
															else
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33091ze3z83_16131;

																	BgL_zc3anonymousza33091ze3z83_16131 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33091ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 6)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33091ze3z83_16131,
																		(int) (((long) 0)), BgL_ifreesz00_3286);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33091ze3z83_16131,
																		(int) (((long) 1)), BgL_iboxesz00_3287);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33091ze3z83_16131,
																		(int) (((long) 2)),
																		BINT(BgL_siza7eza7_3288));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33091ze3z83_16131,
																		(int) (((long) 3)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33091ze3z83_16131,
																		(int) (((long) 4)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33091ze3z83_16131,
																		(int) (((long) 5)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33091ze3z83_16131;
																}
														}
												}
												break;
											case ((long) -1):

												{	/* Eval/evaluate_comp.scm 1129 */
													bool_t BgL_testz00_22662;

													{	/* Eval/evaluate_comp.scm 1129 */
														int BgL_arg3187z00_3618;

														BgL_arg3187z00_3618 =
															VECTOR_LENGTH(BgL_ifreesz00_3286);
														BgL_testz00_22662 =
															((long) (BgL_arg3187z00_3618) == ((long) 0));
													}
													if (BgL_testz00_22662)
														{	/* Eval/evaluate_comp.scm 1129 */
															bool_t BgL_testz00_22666;

															{	/* Eval/evaluate_comp.scm 1129 */
																int BgL_arg3147z00_3533;

																BgL_arg3147z00_3533 =
																	VECTOR_LENGTH(BgL_iboxesz00_3287);
																BgL_testz00_22666 =
																	((long) (BgL_arg3147z00_3533) == ((long) 0));
															}
															if (BgL_testz00_22666)
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33112ze3z83_16152;

																	BgL_zc3anonymousza33112ze3z83_16152 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33112ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 3)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33112ze3z83_16152,
																		(int) (((long) 0)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33112ze3z83_16152,
																		(int) (((long) 1)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33112ze3z83_16152,
																		(int) (((long) 2)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33112ze3z83_16152;
																}
															else
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33129ze3z83_16149;

																	BgL_zc3anonymousza33129ze3z83_16149 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33129ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 4)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33129ze3z83_16149,
																		(int) (((long) 0)), BgL_iboxesz00_3287);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33129ze3z83_16149,
																		(int) (((long) 1)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33129ze3z83_16149,
																		(int) (((long) 2)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33129ze3z83_16149,
																		(int) (((long) 3)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33129ze3z83_16149;
																}
														}
													else
														{	/* Eval/evaluate_comp.scm 1129 */
															bool_t BgL_testz00_22694;

															{	/* Eval/evaluate_comp.scm 1129 */
																int BgL_arg3186z00_3617;

																BgL_arg3186z00_3617 =
																	VECTOR_LENGTH(BgL_iboxesz00_3287);
																BgL_testz00_22694 =
																	((long) (BgL_arg3186z00_3617) == ((long) 0));
															}
															if (BgL_testz00_22694)
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33149ze3z83_16146;

																	BgL_zc3anonymousza33149ze3z83_16146 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33149ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 5)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33149ze3z83_16146,
																		(int) (((long) 0)), BgL_ifreesz00_3286);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33149ze3z83_16146,
																		(int) (((long) 1)),
																		BINT(BgL_siza7eza7_3288));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33149ze3z83_16146,
																		(int) (((long) 2)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33149ze3z83_16146,
																		(int) (((long) 3)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33149ze3z83_16146,
																		(int) (((long) 4)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33149ze3z83_16146;
																}
															else
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33167ze3z83_16143;

																	BgL_zc3anonymousza33167ze3z83_16143 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33167ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 6)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33167ze3z83_16143,
																		(int) (((long) 0)), BgL_ifreesz00_3286);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33167ze3z83_16143,
																		(int) (((long) 1)), BgL_iboxesz00_3287);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33167ze3z83_16143,
																		(int) (((long) 2)),
																		BINT(BgL_siza7eza7_3288));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33167ze3z83_16143,
																		(int) (((long) 3)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33167ze3z83_16143,
																		(int) (((long) 4)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33167ze3z83_16143,
																		(int) (((long) 5)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33167ze3z83_16143;
																}
														}
												}
												break;
											case ((long) 1):

												{	/* Eval/evaluate_comp.scm 1129 */
													bool_t BgL_testz00_22732;

													{	/* Eval/evaluate_comp.scm 1129 */
														int BgL_arg3265z00_3784;

														BgL_arg3265z00_3784 =
															VECTOR_LENGTH(BgL_ifreesz00_3286);
														BgL_testz00_22732 =
															((long) (BgL_arg3265z00_3784) == ((long) 0));
													}
													if (BgL_testz00_22732)
														{	/* Eval/evaluate_comp.scm 1129 */
															bool_t BgL_testz00_22736;

															{	/* Eval/evaluate_comp.scm 1129 */
																int BgL_arg3224z00_3699;

																BgL_arg3224z00_3699 =
																	VECTOR_LENGTH(BgL_iboxesz00_3287);
																BgL_testz00_22736 =
																	((long) (BgL_arg3224z00_3699) == ((long) 0));
															}
															if (BgL_testz00_22736)
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33190ze3z83_16164;

																	BgL_zc3anonymousza33190ze3z83_16164 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33190ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 3)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33190ze3z83_16164,
																		(int) (((long) 0)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33190ze3z83_16164,
																		(int) (((long) 1)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33190ze3z83_16164,
																		(int) (((long) 2)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33190ze3z83_16164;
																}
															else
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33207ze3z83_16161;

																	BgL_zc3anonymousza33207ze3z83_16161 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33207ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 4)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33207ze3z83_16161,
																		(int) (((long) 0)), BgL_iboxesz00_3287);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33207ze3z83_16161,
																		(int) (((long) 1)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33207ze3z83_16161,
																		(int) (((long) 2)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33207ze3z83_16161,
																		(int) (((long) 3)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33207ze3z83_16161;
																}
														}
													else
														{	/* Eval/evaluate_comp.scm 1129 */
															bool_t BgL_testz00_22764;

															{	/* Eval/evaluate_comp.scm 1129 */
																int BgL_arg3264z00_3783;

																BgL_arg3264z00_3783 =
																	VECTOR_LENGTH(BgL_iboxesz00_3287);
																BgL_testz00_22764 =
																	((long) (BgL_arg3264z00_3783) == ((long) 0));
															}
															if (BgL_testz00_22764)
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33226ze3z83_16158;

																	BgL_zc3anonymousza33226ze3z83_16158 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33226ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 5)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33226ze3z83_16158,
																		(int) (((long) 0)), BgL_ifreesz00_3286);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33226ze3z83_16158,
																		(int) (((long) 1)),
																		BINT(BgL_siza7eza7_3288));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33226ze3z83_16158,
																		(int) (((long) 2)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33226ze3z83_16158,
																		(int) (((long) 3)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33226ze3z83_16158,
																		(int) (((long) 4)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33226ze3z83_16158;
																}
															else
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33245ze3z83_16155;

																	BgL_zc3anonymousza33245ze3z83_16155 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33245ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 6)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33245ze3z83_16155,
																		(int) (((long) 0)), BgL_ifreesz00_3286);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33245ze3z83_16155,
																		(int) (((long) 1)), BgL_iboxesz00_3287);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33245ze3z83_16155,
																		(int) (((long) 2)),
																		BINT(BgL_siza7eza7_3288));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33245ze3z83_16155,
																		(int) (((long) 3)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33245ze3z83_16155,
																		(int) (((long) 4)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33245ze3z83_16155,
																		(int) (((long) 5)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33245ze3z83_16155;
																}
														}
												}
												break;
											case ((long) -2):

												{	/* Eval/evaluate_comp.scm 1129 */
													bool_t BgL_testz00_22802;

													{	/* Eval/evaluate_comp.scm 1129 */
														int BgL_arg3345z00_3958;

														BgL_arg3345z00_3958 =
															VECTOR_LENGTH(BgL_ifreesz00_3286);
														BgL_testz00_22802 =
															((long) (BgL_arg3345z00_3958) == ((long) 0));
													}
													if (BgL_testz00_22802)
														{	/* Eval/evaluate_comp.scm 1129 */
															bool_t BgL_testz00_22806;

															{	/* Eval/evaluate_comp.scm 1129 */
																int BgL_arg3304z00_3869;

																BgL_arg3304z00_3869 =
																	VECTOR_LENGTH(BgL_iboxesz00_3287);
																BgL_testz00_22806 =
																	((long) (BgL_arg3304z00_3869) == ((long) 0));
															}
															if (BgL_testz00_22806)
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33268ze3z83_16176;

																	BgL_zc3anonymousza33268ze3z83_16176 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33268ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 3)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33268ze3z83_16176,
																		(int) (((long) 0)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33268ze3z83_16176,
																		(int) (((long) 1)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33268ze3z83_16176,
																		(int) (((long) 2)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33268ze3z83_16176;
																}
															else
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33286ze3z83_16173;

																	BgL_zc3anonymousza33286ze3z83_16173 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33286ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 4)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33286ze3z83_16173,
																		(int) (((long) 0)), BgL_iboxesz00_3287);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33286ze3z83_16173,
																		(int) (((long) 1)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33286ze3z83_16173,
																		(int) (((long) 2)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33286ze3z83_16173,
																		(int) (((long) 3)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33286ze3z83_16173;
																}
														}
													else
														{	/* Eval/evaluate_comp.scm 1129 */
															bool_t BgL_testz00_22834;

															{	/* Eval/evaluate_comp.scm 1129 */
																int BgL_arg3344z00_3957;

																BgL_arg3344z00_3957 =
																	VECTOR_LENGTH(BgL_iboxesz00_3287);
																BgL_testz00_22834 =
																	((long) (BgL_arg3344z00_3957) == ((long) 0));
															}
															if (BgL_testz00_22834)
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33306ze3z83_16170;

																	BgL_zc3anonymousza33306ze3z83_16170 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33306ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 5)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33306ze3z83_16170,
																		(int) (((long) 0)), BgL_ifreesz00_3286);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33306ze3z83_16170,
																		(int) (((long) 1)),
																		BINT(BgL_siza7eza7_3288));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33306ze3z83_16170,
																		(int) (((long) 2)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33306ze3z83_16170,
																		(int) (((long) 3)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33306ze3z83_16170,
																		(int) (((long) 4)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33306ze3z83_16170;
																}
															else
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33325ze3z83_16167;

																	BgL_zc3anonymousza33325ze3z83_16167 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33325ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 6)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33325ze3z83_16167,
																		(int) (((long) 0)), BgL_ifreesz00_3286);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33325ze3z83_16167,
																		(int) (((long) 1)), BgL_iboxesz00_3287);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33325ze3z83_16167,
																		(int) (((long) 2)),
																		BINT(BgL_siza7eza7_3288));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33325ze3z83_16167,
																		(int) (((long) 3)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33325ze3z83_16167,
																		(int) (((long) 4)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33325ze3z83_16167,
																		(int) (((long) 5)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33325ze3z83_16167;
																}
														}
												}
												break;
											case ((long) 2):

												{	/* Eval/evaluate_comp.scm 1129 */
													bool_t BgL_testz00_22872;

													{	/* Eval/evaluate_comp.scm 1129 */
														int BgL_arg3431z00_4132;

														BgL_arg3431z00_4132 =
															VECTOR_LENGTH(BgL_ifreesz00_3286);
														BgL_testz00_22872 =
															((long) (BgL_arg3431z00_4132) == ((long) 0));
													}
													if (BgL_testz00_22872)
														{	/* Eval/evaluate_comp.scm 1129 */
															bool_t BgL_testz00_22876;

															{	/* Eval/evaluate_comp.scm 1129 */
																int BgL_arg3388z00_4043;

																BgL_arg3388z00_4043 =
																	VECTOR_LENGTH(BgL_iboxesz00_3287);
																BgL_testz00_22876 =
																	((long) (BgL_arg3388z00_4043) == ((long) 0));
															}
															if (BgL_testz00_22876)
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33348ze3z83_16188;

																	BgL_zc3anonymousza33348ze3z83_16188 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33348ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 3)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33348ze3z83_16188,
																		(int) (((long) 0)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33348ze3z83_16188,
																		(int) (((long) 1)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33348ze3z83_16188,
																		(int) (((long) 2)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33348ze3z83_16188;
																}
															else
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33366ze3z83_16185;

																	BgL_zc3anonymousza33366ze3z83_16185 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33366ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 4)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33366ze3z83_16185,
																		(int) (((long) 0)), BgL_iboxesz00_3287);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33366ze3z83_16185,
																		(int) (((long) 1)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33366ze3z83_16185,
																		(int) (((long) 2)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33366ze3z83_16185,
																		(int) (((long) 3)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33366ze3z83_16185;
																}
														}
													else
														{	/* Eval/evaluate_comp.scm 1129 */
															bool_t BgL_testz00_22904;

															{	/* Eval/evaluate_comp.scm 1129 */
																int BgL_arg3430z00_4131;

																BgL_arg3430z00_4131 =
																	VECTOR_LENGTH(BgL_iboxesz00_3287);
																BgL_testz00_22904 =
																	((long) (BgL_arg3430z00_4131) == ((long) 0));
															}
															if (BgL_testz00_22904)
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33390ze3z83_16182;

																	BgL_zc3anonymousza33390ze3z83_16182 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33390ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 5)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33390ze3z83_16182,
																		(int) (((long) 0)), BgL_ifreesz00_3286);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33390ze3z83_16182,
																		(int) (((long) 1)),
																		BINT(BgL_siza7eza7_3288));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33390ze3z83_16182,
																		(int) (((long) 2)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33390ze3z83_16182,
																		(int) (((long) 3)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33390ze3z83_16182,
																		(int) (((long) 4)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33390ze3z83_16182;
																}
															else
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33409ze3z83_16179;

																	BgL_zc3anonymousza33409ze3z83_16179 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33409ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 6)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33409ze3z83_16179,
																		(int) (((long) 0)), BgL_ifreesz00_3286);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33409ze3z83_16179,
																		(int) (((long) 1)), BgL_iboxesz00_3287);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33409ze3z83_16179,
																		(int) (((long) 2)),
																		BINT(BgL_siza7eza7_3288));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33409ze3z83_16179,
																		(int) (((long) 3)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33409ze3z83_16179,
																		(int) (((long) 4)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33409ze3z83_16179,
																		(int) (((long) 5)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33409ze3z83_16179;
																}
														}
												}
												break;
											case ((long) -3):

												{	/* Eval/evaluate_comp.scm 1129 */
													bool_t BgL_testz00_22942;

													{	/* Eval/evaluate_comp.scm 1129 */
														int BgL_arg3515z00_4314;

														BgL_arg3515z00_4314 =
															VECTOR_LENGTH(BgL_ifreesz00_3286);
														BgL_testz00_22942 =
															((long) (BgL_arg3515z00_4314) == ((long) 0));
													}
													if (BgL_testz00_22942)
														{	/* Eval/evaluate_comp.scm 1129 */
															bool_t BgL_testz00_22946;

															{	/* Eval/evaluate_comp.scm 1129 */
																int BgL_arg3472z00_4221;

																BgL_arg3472z00_4221 =
																	VECTOR_LENGTH(BgL_iboxesz00_3287);
																BgL_testz00_22946 =
																	((long) (BgL_arg3472z00_4221) == ((long) 0));
															}
															if (BgL_testz00_22946)
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33434ze3z83_16200;

																	BgL_zc3anonymousza33434ze3z83_16200 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33434ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 3)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33434ze3z83_16200,
																		(int) (((long) 0)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33434ze3z83_16200,
																		(int) (((long) 1)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33434ze3z83_16200,
																		(int) (((long) 2)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33434ze3z83_16200;
																}
															else
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33453ze3z83_16197;

																	BgL_zc3anonymousza33453ze3z83_16197 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33453ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 4)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33453ze3z83_16197,
																		(int) (((long) 0)), BgL_iboxesz00_3287);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33453ze3z83_16197,
																		(int) (((long) 1)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33453ze3z83_16197,
																		(int) (((long) 2)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33453ze3z83_16197,
																		(int) (((long) 3)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33453ze3z83_16197;
																}
														}
													else
														{	/* Eval/evaluate_comp.scm 1129 */
															bool_t BgL_testz00_22974;

															{	/* Eval/evaluate_comp.scm 1129 */
																int BgL_arg3514z00_4313;

																BgL_arg3514z00_4313 =
																	VECTOR_LENGTH(BgL_iboxesz00_3287);
																BgL_testz00_22974 =
																	((long) (BgL_arg3514z00_4313) == ((long) 0));
															}
															if (BgL_testz00_22974)
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33474ze3z83_16194;

																	BgL_zc3anonymousza33474ze3z83_16194 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33474ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 5)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33474ze3z83_16194,
																		(int) (((long) 0)), BgL_ifreesz00_3286);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33474ze3z83_16194,
																		(int) (((long) 1)),
																		BINT(BgL_siza7eza7_3288));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33474ze3z83_16194,
																		(int) (((long) 2)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33474ze3z83_16194,
																		(int) (((long) 3)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33474ze3z83_16194,
																		(int) (((long) 4)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33474ze3z83_16194;
																}
															else
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33494ze3z83_16191;

																	BgL_zc3anonymousza33494ze3z83_16191 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33494ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 6)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33494ze3z83_16191,
																		(int) (((long) 0)), BgL_ifreesz00_3286);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33494ze3z83_16191,
																		(int) (((long) 1)), BgL_iboxesz00_3287);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33494ze3z83_16191,
																		(int) (((long) 2)),
																		BINT(BgL_siza7eza7_3288));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33494ze3z83_16191,
																		(int) (((long) 3)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33494ze3z83_16191,
																		(int) (((long) 4)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33494ze3z83_16191,
																		(int) (((long) 5)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33494ze3z83_16191;
																}
														}
												}
												break;
											case ((long) 3):

												{	/* Eval/evaluate_comp.scm 1129 */
													bool_t BgL_testz00_23012;

													{	/* Eval/evaluate_comp.scm 1129 */
														int BgL_arg3599z00_4496;

														BgL_arg3599z00_4496 =
															VECTOR_LENGTH(BgL_ifreesz00_3286);
														BgL_testz00_23012 =
															((long) (BgL_arg3599z00_4496) == ((long) 0));
													}
													if (BgL_testz00_23012)
														{	/* Eval/evaluate_comp.scm 1129 */
															bool_t BgL_testz00_23016;

															{	/* Eval/evaluate_comp.scm 1129 */
																int BgL_arg3556z00_4403;

																BgL_arg3556z00_4403 =
																	VECTOR_LENGTH(BgL_iboxesz00_3287);
																BgL_testz00_23016 =
																	((long) (BgL_arg3556z00_4403) == ((long) 0));
															}
															if (BgL_testz00_23016)
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33518ze3z83_16212;

																	BgL_zc3anonymousza33518ze3z83_16212 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33518ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 3)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33518ze3z83_16212,
																		(int) (((long) 0)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33518ze3z83_16212,
																		(int) (((long) 1)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33518ze3z83_16212,
																		(int) (((long) 2)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33518ze3z83_16212;
																}
															else
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33537ze3z83_16209;

																	BgL_zc3anonymousza33537ze3z83_16209 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33537ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 4)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33537ze3z83_16209,
																		(int) (((long) 0)), BgL_iboxesz00_3287);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33537ze3z83_16209,
																		(int) (((long) 1)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33537ze3z83_16209,
																		(int) (((long) 2)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33537ze3z83_16209,
																		(int) (((long) 3)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33537ze3z83_16209;
																}
														}
													else
														{	/* Eval/evaluate_comp.scm 1129 */
															bool_t BgL_testz00_23044;

															{	/* Eval/evaluate_comp.scm 1129 */
																int BgL_arg3598z00_4495;

																BgL_arg3598z00_4495 =
																	VECTOR_LENGTH(BgL_iboxesz00_3287);
																BgL_testz00_23044 =
																	((long) (BgL_arg3598z00_4495) == ((long) 0));
															}
															if (BgL_testz00_23044)
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33558ze3z83_16206;

																	BgL_zc3anonymousza33558ze3z83_16206 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33558ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 5)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33558ze3z83_16206,
																		(int) (((long) 0)), BgL_ifreesz00_3286);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33558ze3z83_16206,
																		(int) (((long) 1)),
																		BINT(BgL_siza7eza7_3288));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33558ze3z83_16206,
																		(int) (((long) 2)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33558ze3z83_16206,
																		(int) (((long) 3)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33558ze3z83_16206,
																		(int) (((long) 4)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33558ze3z83_16206;
																}
															else
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33578ze3z83_16203;

																	BgL_zc3anonymousza33578ze3z83_16203 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33578ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 6)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33578ze3z83_16203,
																		(int) (((long) 0)), BgL_ifreesz00_3286);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33578ze3z83_16203,
																		(int) (((long) 1)), BgL_iboxesz00_3287);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33578ze3z83_16203,
																		(int) (((long) 2)),
																		BINT(BgL_siza7eza7_3288));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33578ze3z83_16203,
																		(int) (((long) 3)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33578ze3z83_16203,
																		(int) (((long) 4)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33578ze3z83_16203,
																		(int) (((long) 5)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33578ze3z83_16203;
																}
														}
												}
												break;
											case ((long) -4):

												{	/* Eval/evaluate_comp.scm 1129 */
													bool_t BgL_testz00_23082;

													{	/* Eval/evaluate_comp.scm 1129 */
														int BgL_arg3687z00_4686;

														BgL_arg3687z00_4686 =
															VECTOR_LENGTH(BgL_ifreesz00_3286);
														BgL_testz00_23082 =
															((long) (BgL_arg3687z00_4686) == ((long) 0));
													}
													if (BgL_testz00_23082)
														{	/* Eval/evaluate_comp.scm 1129 */
															bool_t BgL_testz00_23086;

															{	/* Eval/evaluate_comp.scm 1129 */
																int BgL_arg3642z00_4589;

																BgL_arg3642z00_4589 =
																	VECTOR_LENGTH(BgL_iboxesz00_3287);
																BgL_testz00_23086 =
																	((long) (BgL_arg3642z00_4589) == ((long) 0));
															}
															if (BgL_testz00_23086)
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33602ze3z83_16224;

																	BgL_zc3anonymousza33602ze3z83_16224 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33602ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 3)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33602ze3z83_16224,
																		(int) (((long) 0)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33602ze3z83_16224,
																		(int) (((long) 1)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33602ze3z83_16224,
																		(int) (((long) 2)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33602ze3z83_16224;
																}
															else
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33622ze3z83_16221;

																	BgL_zc3anonymousza33622ze3z83_16221 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33622ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 4)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33622ze3z83_16221,
																		(int) (((long) 0)), BgL_iboxesz00_3287);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33622ze3z83_16221,
																		(int) (((long) 1)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33622ze3z83_16221,
																		(int) (((long) 2)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33622ze3z83_16221,
																		(int) (((long) 3)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33622ze3z83_16221;
																}
														}
													else
														{	/* Eval/evaluate_comp.scm 1129 */
															bool_t BgL_testz00_23114;

															{	/* Eval/evaluate_comp.scm 1129 */
																int BgL_arg3686z00_4685;

																BgL_arg3686z00_4685 =
																	VECTOR_LENGTH(BgL_iboxesz00_3287);
																BgL_testz00_23114 =
																	((long) (BgL_arg3686z00_4685) == ((long) 0));
															}
															if (BgL_testz00_23114)
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33644ze3z83_16218;

																	BgL_zc3anonymousza33644ze3z83_16218 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33644ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 5)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33644ze3z83_16218,
																		(int) (((long) 0)), BgL_ifreesz00_3286);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33644ze3z83_16218,
																		(int) (((long) 1)),
																		BINT(BgL_siza7eza7_3288));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33644ze3z83_16218,
																		(int) (((long) 2)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33644ze3z83_16218,
																		(int) (((long) 3)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33644ze3z83_16218,
																		(int) (((long) 4)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33644ze3z83_16218;
																}
															else
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33665ze3z83_16215;

																	BgL_zc3anonymousza33665ze3z83_16215 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33665ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 6)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33665ze3z83_16215,
																		(int) (((long) 0)), BgL_ifreesz00_3286);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33665ze3z83_16215,
																		(int) (((long) 1)), BgL_iboxesz00_3287);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33665ze3z83_16215,
																		(int) (((long) 2)),
																		BINT(BgL_siza7eza7_3288));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33665ze3z83_16215,
																		(int) (((long) 3)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33665ze3z83_16215,
																		(int) (((long) 4)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33665ze3z83_16215,
																		(int) (((long) 5)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33665ze3z83_16215;
																}
														}
												}
												break;
											case ((long) 4):

												{	/* Eval/evaluate_comp.scm 1129 */
													bool_t BgL_testz00_23152;

													{	/* Eval/evaluate_comp.scm 1129 */
														int BgL_arg3775z00_4876;

														BgL_arg3775z00_4876 =
															VECTOR_LENGTH(BgL_ifreesz00_3286);
														BgL_testz00_23152 =
															((long) (BgL_arg3775z00_4876) == ((long) 0));
													}
													if (BgL_testz00_23152)
														{	/* Eval/evaluate_comp.scm 1129 */
															bool_t BgL_testz00_23156;

															{	/* Eval/evaluate_comp.scm 1129 */
																int BgL_arg3730z00_4779;

																BgL_arg3730z00_4779 =
																	VECTOR_LENGTH(BgL_iboxesz00_3287);
																BgL_testz00_23156 =
																	((long) (BgL_arg3730z00_4779) == ((long) 0));
															}
															if (BgL_testz00_23156)
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33690ze3z83_16236;

																	BgL_zc3anonymousza33690ze3z83_16236 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33690ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 3)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33690ze3z83_16236,
																		(int) (((long) 0)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33690ze3z83_16236,
																		(int) (((long) 1)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33690ze3z83_16236,
																		(int) (((long) 2)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33690ze3z83_16236;
																}
															else
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33710ze3z83_16233;

																	BgL_zc3anonymousza33710ze3z83_16233 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33710ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 4)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33710ze3z83_16233,
																		(int) (((long) 0)), BgL_iboxesz00_3287);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33710ze3z83_16233,
																		(int) (((long) 1)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33710ze3z83_16233,
																		(int) (((long) 2)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33710ze3z83_16233,
																		(int) (((long) 3)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33710ze3z83_16233;
																}
														}
													else
														{	/* Eval/evaluate_comp.scm 1129 */
															bool_t BgL_testz00_23184;

															{	/* Eval/evaluate_comp.scm 1129 */
																int BgL_arg3774z00_4875;

																BgL_arg3774z00_4875 =
																	VECTOR_LENGTH(BgL_iboxesz00_3287);
																BgL_testz00_23184 =
																	((long) (BgL_arg3774z00_4875) == ((long) 0));
															}
															if (BgL_testz00_23184)
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33732ze3z83_16230;

																	BgL_zc3anonymousza33732ze3z83_16230 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33732ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 5)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33732ze3z83_16230,
																		(int) (((long) 0)), BgL_ifreesz00_3286);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33732ze3z83_16230,
																		(int) (((long) 1)),
																		BINT(BgL_siza7eza7_3288));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33732ze3z83_16230,
																		(int) (((long) 2)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33732ze3z83_16230,
																		(int) (((long) 3)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33732ze3z83_16230,
																		(int) (((long) 4)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33732ze3z83_16230;
																}
															else
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33753ze3z83_16227;

																	BgL_zc3anonymousza33753ze3z83_16227 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33753ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 6)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33753ze3z83_16227,
																		(int) (((long) 0)), BgL_ifreesz00_3286);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33753ze3z83_16227,
																		(int) (((long) 1)), BgL_iboxesz00_3287);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33753ze3z83_16227,
																		(int) (((long) 2)),
																		BINT(BgL_siza7eza7_3288));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33753ze3z83_16227,
																		(int) (((long) 3)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33753ze3z83_16227,
																		(int) (((long) 4)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33753ze3z83_16227,
																		(int) (((long) 5)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33753ze3z83_16227;
																}
														}
												}
												break;
											case ((long) -5):

												{	/* Eval/evaluate_comp.scm 1129 */
													bool_t BgL_testz00_23222;

													{	/* Eval/evaluate_comp.scm 1129 */
														int BgL_arg3867z00_5074;

														BgL_arg3867z00_5074 =
															VECTOR_LENGTH(BgL_ifreesz00_3286);
														BgL_testz00_23222 =
															((long) (BgL_arg3867z00_5074) == ((long) 0));
													}
													if (BgL_testz00_23222)
														{	/* Eval/evaluate_comp.scm 1129 */
															bool_t BgL_testz00_23226;

															{	/* Eval/evaluate_comp.scm 1129 */
																int BgL_arg3820z00_4973;

																BgL_arg3820z00_4973 =
																	VECTOR_LENGTH(BgL_iboxesz00_3287);
																BgL_testz00_23226 =
																	((long) (BgL_arg3820z00_4973) == ((long) 0));
															}
															if (BgL_testz00_23226)
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33778ze3z83_16248;

																	BgL_zc3anonymousza33778ze3z83_16248 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33778ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 3)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33778ze3z83_16248,
																		(int) (((long) 0)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33778ze3z83_16248,
																		(int) (((long) 1)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33778ze3z83_16248,
																		(int) (((long) 2)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33778ze3z83_16248;
																}
															else
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33799ze3z83_16245;

																	BgL_zc3anonymousza33799ze3z83_16245 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33799ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 4)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33799ze3z83_16245,
																		(int) (((long) 0)), BgL_iboxesz00_3287);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33799ze3z83_16245,
																		(int) (((long) 1)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33799ze3z83_16245,
																		(int) (((long) 2)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33799ze3z83_16245,
																		(int) (((long) 3)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33799ze3z83_16245;
																}
														}
													else
														{	/* Eval/evaluate_comp.scm 1129 */
															bool_t BgL_testz00_23254;

															{	/* Eval/evaluate_comp.scm 1129 */
																int BgL_arg3866z00_5073;

																BgL_arg3866z00_5073 =
																	VECTOR_LENGTH(BgL_iboxesz00_3287);
																BgL_testz00_23254 =
																	((long) (BgL_arg3866z00_5073) == ((long) 0));
															}
															if (BgL_testz00_23254)
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33822ze3z83_16242;

																	BgL_zc3anonymousza33822ze3z83_16242 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33822ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 5)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33822ze3z83_16242,
																		(int) (((long) 0)), BgL_ifreesz00_3286);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33822ze3z83_16242,
																		(int) (((long) 1)),
																		BINT(BgL_siza7eza7_3288));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33822ze3z83_16242,
																		(int) (((long) 2)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33822ze3z83_16242,
																		(int) (((long) 3)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33822ze3z83_16242,
																		(int) (((long) 4)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33822ze3z83_16242;
																}
															else
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33844ze3z83_16239;

																	BgL_zc3anonymousza33844ze3z83_16239 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33844ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 6)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33844ze3z83_16239,
																		(int) (((long) 0)), BgL_ifreesz00_3286);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33844ze3z83_16239,
																		(int) (((long) 1)), BgL_iboxesz00_3287);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33844ze3z83_16239,
																		(int) (((long) 2)),
																		BINT(BgL_siza7eza7_3288));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33844ze3z83_16239,
																		(int) (((long) 3)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33844ze3z83_16239,
																		(int) (((long) 4)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33844ze3z83_16239,
																		(int) (((long) 5)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33844ze3z83_16239;
																}
														}
												}
												break;
											default:
											BgL_case_else1277z00_3292:
												{	/* Eval/evaluate_comp.scm 1129 */
													bool_t BgL_testz00_23292;

													{	/* Eval/evaluate_comp.scm 1129 */
														int BgL_arg3995z00_5308;

														BgL_arg3995z00_5308 =
															VECTOR_LENGTH(BgL_ifreesz00_3286);
														BgL_testz00_23292 =
															((long) (BgL_arg3995z00_5308) == ((long) 0));
													}
													if (BgL_testz00_23292)
														{	/* Eval/evaluate_comp.scm 1129 */
															bool_t BgL_testz00_23296;

															{	/* Eval/evaluate_comp.scm 1129 */
																int BgL_arg3930z00_5189;

																BgL_arg3930z00_5189 =
																	VECTOR_LENGTH(BgL_iboxesz00_3287);
																BgL_testz00_23296 =
																	((long) (BgL_arg3930z00_5189) == ((long) 0));
															}
															if (BgL_testz00_23296)
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33870ze3z83_16260;

																	BgL_zc3anonymousza33870ze3z83_16260 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33870ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 3)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33870ze3z83_16260,
																		(int) (((long) 0)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33870ze3z83_16260,
																		(int) (((long) 1)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33870ze3z83_16260,
																		(int) (((long) 2)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33870ze3z83_16260;
																}
															else
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33900ze3z83_16257;

																	BgL_zc3anonymousza33900ze3z83_16257 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33900ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 4)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33900ze3z83_16257,
																		(int) (((long) 0)), BgL_iboxesz00_3287);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33900ze3z83_16257,
																		(int) (((long) 1)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33900ze3z83_16257,
																		(int) (((long) 2)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33900ze3z83_16257,
																		(int) (((long) 3)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33900ze3z83_16257;
																}
														}
													else
														{	/* Eval/evaluate_comp.scm 1129 */
															bool_t BgL_testz00_23324;

															{	/* Eval/evaluate_comp.scm 1129 */
																int BgL_arg3994z00_5307;

																BgL_arg3994z00_5307 =
																	VECTOR_LENGTH(BgL_iboxesz00_3287);
																BgL_testz00_23324 =
																	((long) (BgL_arg3994z00_5307) == ((long) 0));
															}
															if (BgL_testz00_23324)
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33932ze3z83_16254;

																	BgL_zc3anonymousza33932ze3z83_16254 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33932ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 5)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33932ze3z83_16254,
																		(int) (((long) 0)), BgL_ifreesz00_3286);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33932ze3z83_16254,
																		(int) (((long) 1)),
																		BINT(BgL_siza7eza7_3288));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33932ze3z83_16254,
																		(int) (((long) 2)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33932ze3z83_16254,
																		(int) (((long) 3)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33932ze3z83_16254,
																		(int) (((long) 4)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33932ze3z83_16254;
																}
															else
																{	/* Eval/evaluate_comp.scm 1129 */
																	obj_t BgL_zc3anonymousza33963ze3z83_16251;

																	BgL_zc3anonymousza33963ze3z83_16251 =
																		MAKE_FX_PROCEDURE
																		(BGl_z62zc3anonymousza33963ze3ze1zz__evaluate_compz00,
																		(int) (((long) 1)), (int) (((long) 6)));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33963ze3z83_16251,
																		(int) (((long) 0)), BgL_ifreesz00_3286);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33963ze3z83_16251,
																		(int) (((long) 1)), BgL_iboxesz00_3287);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33963ze3z83_16251,
																		(int) (((long) 2)),
																		BINT(BgL_siza7eza7_3288));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33963ze3z83_16251,
																		(int) (((long) 3)),
																		((obj_t) BgL_ez00_3281));
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33963ze3z83_16251,
																		(int) (((long) 4)), BgL_bodyz00_3291);
																	PROCEDURE_SET
																		(BgL_zc3anonymousza33963ze3z83_16251,
																		(int) (((long) 5)),
																		BINT(BgL_siza7ezd2framez75_3289));
																	return BgL_zc3anonymousza33963ze3z83_16251;
																}
														}
												}
											}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										goto BgL_case_else1277z00_3292;
									}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3778> */
	obj_t BGl_z62zc3anonymousza33778ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16324, obj_t BgL_sz00_16328)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_16325;
				obj_t BgL_bodyz00_16326;
				long BgL_siza7ezd2framez75_16327;

				BgL_i1252z00_16325 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16324, (int) (((long) 0))));
				BgL_bodyz00_16326 = PROCEDURE_REF(BgL_envz00_16324, (int) (((long) 1)));
				BgL_siza7ezd2framez75_16327 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16324, (int) (((long) 2))));
				{
					obj_t BgL_sz00_4879;

					BgL_sz00_4879 = BgL_sz00_16328;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4881;

						BgL_bpz00_4881 = VECTOR_REF(BgL_sz00_4879, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */

							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16246;

								BgL_runz00_16246 =
									MAKE_FX_PROCEDURE(BGl_z62runz62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_runz00_16246,
									(int) (((long) 0)), ((obj_t) BgL_i1252z00_16325));
								PROCEDURE_SET(BgL_runz00_16246,
									(int) (((long) 1)), BgL_bodyz00_16326);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16247;

									BgL_mainz00_16247 =
										MAKE_VA_PROCEDURE(BGl_z62mainz62zz__evaluate_compz00,
										(int) (((long) -5)), (int) (((long) 4)));
									PROCEDURE_SET(BgL_mainz00_16247,
										(int) (((long) 0)), ((obj_t) BgL_i1252z00_16325));
									PROCEDURE_SET(BgL_mainz00_16247,
										(int) (((long) 1)), BgL_bodyz00_16326);
									PROCEDURE_SET(BgL_mainz00_16247,
										(int) (((long) 2)), BgL_runz00_16246);
									PROCEDURE_SET(BgL_mainz00_16247,
										(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_16327));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_14945;

										BgL_objz00_14945 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16246, BgL_objz00_14945);
										BgL_objz00_14945;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3779z00_4884;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3780z00_4885;

											BgL_arg3780z00_4885 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16325))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_14949;

												BgL_newz00_14949 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_23400;

													BgL_auxz00_23400 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_14949, BgL_auxz00_23400,
														BgL_arg3780z00_4885);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_23405;
													int BgL_auxz00_23403;

													BgL_auxz00_23405 = BINT(BgL_siza7ezd2framez75_16327);
													BgL_auxz00_23403 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_14949, BgL_auxz00_23403,
														BgL_auxz00_23405);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_23408;

													BgL_auxz00_23408 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_14949, BgL_auxz00_23408,
														BgL_runz00_16246);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_23413;
													int BgL_auxz00_23411;

													BgL_auxz00_23413 = BINT(((long) -5));
													BgL_auxz00_23411 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_14949, BgL_auxz00_23411,
														BgL_auxz00_23413);
												}
												BgL_arg3779z00_4884 = BgL_newz00_14949;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16247, BgL_arg3779z00_4884);
										BgL_arg3779z00_4884;
									}
									return BgL_mainz00_16247;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main */
	obj_t BGl_z62mainz62zz__evaluate_compz00(obj_t BgL_envz00_16329,
		obj_t BgL_az00_16334, obj_t BgL_bz00_16335, obj_t BgL_cz00_16336,
		obj_t BgL_dz00_16337, obj_t BgL_lastz00_16338)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16332;
				long BgL_siza7ezd2framez75_16333;

				BgL_runz00_16332 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16329, (int) (((long) 2))));
				BgL_siza7ezd2framez75_16333 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16329, (int) (((long) 3))));
				{
					obj_t BgL_az00_4886;
					obj_t BgL_bz00_4887;
					obj_t BgL_cz00_4888;
					obj_t BgL_dz00_4889;
					obj_t BgL_lastz00_4890;

					BgL_az00_4886 = BgL_az00_16334;
					BgL_bz00_4887 = BgL_bz00_16335;
					BgL_cz00_4888 = BgL_cz00_16336;
					BgL_dz00_4889 = BgL_dz00_16337;
					BgL_lastz00_4890 = BgL_lastz00_16338;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_4892;

						BgL_sz00_4892 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_4893;

							BgL_bpz00_4893 = VECTOR_REF(BgL_sz00_4892, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_23426;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_14853;

									BgL_arg1908z00_14853 = VECTOR_LENGTH(BgL_sz00_4892);
									BgL_testz00_23426 =
										(
										((long) CINT(BgL_bpz00_4893) +
											BgL_siza7ezd2framez75_16333) <
										(long) (BgL_arg1908z00_14853));
								}
								if (BgL_testz00_23426)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3783z00_4895;

											BgL_arg3783z00_4895 =
												((long) CINT(BgL_bpz00_4893) + ((long) 0));
											VECTOR_SET(BgL_sz00_4892,
												(int) (BgL_arg3783z00_4895), BgL_az00_4886);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3784z00_4896;

											BgL_arg3784z00_4896 =
												((long) CINT(BgL_bpz00_4893) + ((long) 1));
											VECTOR_SET(BgL_sz00_4892,
												(int) (BgL_arg3784z00_4896), BgL_bz00_4887);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3785z00_4897;

											BgL_arg3785z00_4897 =
												((long) CINT(BgL_bpz00_4893) + ((long) 2));
											VECTOR_SET(BgL_sz00_4892,
												(int) (BgL_arg3785z00_4897), BgL_cz00_4888);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3786z00_4898;

											BgL_arg3786z00_4898 =
												((long) CINT(BgL_bpz00_4893) + ((long) 3));
											VECTOR_SET(BgL_sz00_4892,
												(int) (BgL_arg3786z00_4898), BgL_dz00_4889);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3787z00_4899;

											BgL_arg3787z00_4899 =
												((long) CINT(BgL_bpz00_4893) + ((long) 4));
											VECTOR_SET(BgL_sz00_4892,
												(int) (BgL_arg3787z00_4899), BgL_lastz00_4890);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1495z00_4900;

											BgL_val1495z00_4900 =
												BGl_zc3exitza33791ze3z83zz__evaluate_compz00
												(BgL_bpz00_4893, BgL_sz00_4892, BgL_runz00_16332);
											VECTOR_SET(BgL_sz00_4892, (int) (((long) 0)),
												BgL_bpz00_4893);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1495z00_4900)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1495z00_4900), CDR(BgL_val1495z00_4900));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1495z00_4900;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_4907;

										BgL_nsz00_4907 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4907,
											(int) (((long) 1)), BgL_sz00_4892);
										VECTOR_SET(BgL_nsz00_4907,
											(int) (((long) 2)), BgL_az00_4886);
										VECTOR_SET(BgL_nsz00_4907,
											(int) (((long) 3)), BgL_bz00_4887);
										VECTOR_SET(BgL_nsz00_4907,
											(int) (((long) 4)), BgL_cz00_4888);
										VECTOR_SET(BgL_nsz00_4907,
											(int) (((long) 5)), BgL_dz00_4889);
										VECTOR_SET(BgL_nsz00_4907,
											(int) (((long) 6)), BgL_lastz00_4890);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_23474;

											BgL_auxz00_23474 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_23474, BgL_nsz00_4907);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1498z00_4909;

											BgL_val1498z00_4909 =
												BGl_zc3exitza33797ze3z83zz__evaluate_compz00
												(BgL_runz00_16332, BgL_nsz00_4907);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_23478;

												BgL_auxz00_23478 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_23478, BgL_sz00_4892);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1498z00_4909)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1498z00_4909), CDR(BgL_val1498z00_4909));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1498z00_4909;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3797> */
	obj_t BGl_zc3exitza33797ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17700,
		obj_t BgL_nsz00_17699)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1499z00_4915;

			if (SET_EXIT(BgL_an_exit1499z00_4915))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1499z00_4915 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1499z00_4915, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1500z00_4916;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_14917;

								BgL_savedzd2bpzd2_14917 =
									VECTOR_REF(BgL_nsz00_17699, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17699,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_14924;

									BgL_fz00_14924 = BgL_runz00_17700;
								BgL_recz00_14923:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_14925;

										BgL_rz00_14925 =
											PROCEDURE_ENTRY(BgL_fz00_14924) (BgL_fz00_14924,
											BgL_nsz00_17699, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_23499;

											if (PROCEDUREP(BgL_rz00_14925))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_14930;

													BgL_arg1900z00_14930 = PROCEDURE_ATTR(BgL_rz00_14925);
													if (STRUCTP(BgL_arg1900z00_14930))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_23499 =
																(STRUCT_KEY(BgL_arg1900z00_14930) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_23499 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_23499 = ((bool_t) 0);
												}
											if (BgL_testz00_23499)
												{
													obj_t BgL_fz00_23507;

													BgL_fz00_23507 = BgL_rz00_14925;
													BgL_fz00_14924 = BgL_fz00_23507;
													goto BgL_recz00_14923;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17699,
														(int) (((long) 0)), BgL_savedzd2bpzd2_14917);
													BgL_val1500z00_4916 = BgL_rz00_14925;
							}}}}}
							POP_EXIT();
							return BgL_val1500z00_4916;
						}
					}
				}
		}
	}



/* <exit:3791> */
	obj_t BGl_zc3exitza33791ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17703,
		obj_t BgL_sz00_17702, obj_t BgL_runz00_17701)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1496z00_4905;

			if (SET_EXIT(BgL_an_exit1496z00_4905))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1496z00_4905 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1496z00_4905, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1497z00_4906;

							BgL_val1497z00_4906 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17701,
								BgL_sz00_17702, BgL_bpz00_17703);
							POP_EXIT();
							return BgL_val1497z00_4906;
						}
					}
				}
		}
	}



/* &run */
	obj_t BGl_z62runz62zz__evaluate_compz00(obj_t BgL_envz00_16339,
		obj_t BgL_sz00_16342)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_16340;
				obj_t BgL_bodyz00_16341;

				BgL_i1252z00_16340 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16339, (int) (((long) 0))));
				BgL_bodyz00_16341 = PROCEDURE_REF(BgL_envz00_16339, (int) (((long) 1)));
				{
					obj_t BgL_sz00_4918;

					BgL_sz00_4918 = BgL_sz00_16342;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4920;

						BgL_bpz00_4920 = VECTOR_REF(BgL_sz00_4918, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_z12denvz12_4921;
							obj_t BgL_wherez00_4922;
							obj_t BgL_locz00_4923;

							BgL_z12denvz12_4921 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4922 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16340))->BgL_wherez00);
							BgL_locz00_4923 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16340))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1129 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4921, BgL_wherez00_4922,
									BgL_locz00_4923);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_za2za2resza2za2z00_4924;

									BgL_za2za2resza2za2z00_4924 =
										PROCEDURE_ENTRY(BgL_bodyz00_16341) (BgL_bodyz00_16341,
										BgL_sz00_4918, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4921);
									return BgL_za2za2resza2za2z00_4924;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3799> */
	obj_t BGl_z62zc3anonymousza33799ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16343, obj_t BgL_sz00_16348)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_16344;
				BgL_ev_absz00_bglt BgL_i1252z00_16345;
				obj_t BgL_bodyz00_16346;
				long BgL_siza7ezd2framez75_16347;

				BgL_iboxesz00_16344 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16343, (int) (((long) 0))));
				BgL_i1252z00_16345 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16343, (int) (((long) 1))));
				BgL_bodyz00_16346 = PROCEDURE_REF(BgL_envz00_16343, (int) (((long) 2)));
				BgL_siza7ezd2framez75_16347 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16343, (int) (((long) 3))));
				{
					obj_t BgL_sz00_4926;

					BgL_sz00_4926 = BgL_sz00_16348;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4928;

						BgL_bpz00_4928 = VECTOR_REF(BgL_sz00_4926, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */

							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16243;

								BgL_runz00_16243 =
									MAKE_FX_PROCEDURE(BGl_z62run5464z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_runz00_16243,
									(int) (((long) 0)), BgL_iboxesz00_16344);
								PROCEDURE_SET(BgL_runz00_16243,
									(int) (((long) 1)), ((obj_t) BgL_i1252z00_16345));
								PROCEDURE_SET(BgL_runz00_16243,
									(int) (((long) 2)), BgL_bodyz00_16346);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16244;

									BgL_mainz00_16244 =
										MAKE_VA_PROCEDURE(BGl_z62main5463z62zz__evaluate_compz00,
										(int) (((long) -5)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_mainz00_16244,
										(int) (((long) 0)), BgL_iboxesz00_16344);
									PROCEDURE_SET(BgL_mainz00_16244,
										(int) (((long) 1)), ((obj_t) BgL_i1252z00_16345));
									PROCEDURE_SET(BgL_mainz00_16244,
										(int) (((long) 2)), BgL_bodyz00_16346);
									PROCEDURE_SET(BgL_mainz00_16244,
										(int) (((long) 3)), BgL_runz00_16243);
									PROCEDURE_SET(BgL_mainz00_16244,
										(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_16347));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_15072;

										BgL_objz00_15072 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16243, BgL_objz00_15072);
										BgL_objz00_15072;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3800z00_4931;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3801z00_4932;

											BgL_arg3801z00_4932 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16345))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_15076;

												BgL_newz00_15076 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_23574;

													BgL_auxz00_23574 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_15076, BgL_auxz00_23574,
														BgL_arg3801z00_4932);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_23579;
													int BgL_auxz00_23577;

													BgL_auxz00_23579 = BINT(BgL_siza7ezd2framez75_16347);
													BgL_auxz00_23577 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_15076, BgL_auxz00_23577,
														BgL_auxz00_23579);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_23582;

													BgL_auxz00_23582 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_15076, BgL_auxz00_23582,
														BgL_runz00_16243);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_23587;
													int BgL_auxz00_23585;

													BgL_auxz00_23587 = BINT(((long) -5));
													BgL_auxz00_23585 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_15076, BgL_auxz00_23585,
														BgL_auxz00_23587);
												}
												BgL_arg3800z00_4931 = BgL_newz00_15076;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16244, BgL_arg3800z00_4931);
										BgL_arg3800z00_4931;
									}
									return BgL_mainz00_16244;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5463 */
	obj_t BGl_z62main5463z62zz__evaluate_compz00(obj_t BgL_envz00_16349,
		obj_t BgL_az00_16355, obj_t BgL_bz00_16356, obj_t BgL_cz00_16357,
		obj_t BgL_dz00_16358, obj_t BgL_lastz00_16359)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16353;
				long BgL_siza7ezd2framez75_16354;

				BgL_runz00_16353 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16349, (int) (((long) 3))));
				BgL_siza7ezd2framez75_16354 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16349, (int) (((long) 4))));
				{
					obj_t BgL_az00_4933;
					obj_t BgL_bz00_4934;
					obj_t BgL_cz00_4935;
					obj_t BgL_dz00_4936;
					obj_t BgL_lastz00_4937;

					BgL_az00_4933 = BgL_az00_16355;
					BgL_bz00_4934 = BgL_bz00_16356;
					BgL_cz00_4935 = BgL_cz00_16357;
					BgL_dz00_4936 = BgL_dz00_16358;
					BgL_lastz00_4937 = BgL_lastz00_16359;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_4939;

						BgL_sz00_4939 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_4940;

							BgL_bpz00_4940 = VECTOR_REF(BgL_sz00_4939, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_23600;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_14980;

									BgL_arg1908z00_14980 = VECTOR_LENGTH(BgL_sz00_4939);
									BgL_testz00_23600 =
										(
										((long) CINT(BgL_bpz00_4940) +
											BgL_siza7ezd2framez75_16354) <
										(long) (BgL_arg1908z00_14980));
								}
								if (BgL_testz00_23600)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3804z00_4942;

											BgL_arg3804z00_4942 =
												((long) CINT(BgL_bpz00_4940) + ((long) 0));
											VECTOR_SET(BgL_sz00_4939,
												(int) (BgL_arg3804z00_4942), BgL_az00_4933);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3805z00_4943;

											BgL_arg3805z00_4943 =
												((long) CINT(BgL_bpz00_4940) + ((long) 1));
											VECTOR_SET(BgL_sz00_4939,
												(int) (BgL_arg3805z00_4943), BgL_bz00_4934);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3806z00_4944;

											BgL_arg3806z00_4944 =
												((long) CINT(BgL_bpz00_4940) + ((long) 2));
											VECTOR_SET(BgL_sz00_4939,
												(int) (BgL_arg3806z00_4944), BgL_cz00_4935);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3807z00_4945;

											BgL_arg3807z00_4945 =
												((long) CINT(BgL_bpz00_4940) + ((long) 3));
											VECTOR_SET(BgL_sz00_4939,
												(int) (BgL_arg3807z00_4945), BgL_dz00_4936);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3808z00_4946;

											BgL_arg3808z00_4946 =
												((long) CINT(BgL_bpz00_4940) + ((long) 4));
											VECTOR_SET(BgL_sz00_4939,
												(int) (BgL_arg3808z00_4946), BgL_lastz00_4937);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1501z00_4947;

											BgL_val1501z00_4947 =
												BGl_zc3exitza33812ze3z83zz__evaluate_compz00
												(BgL_bpz00_4940, BgL_sz00_4939, BgL_runz00_16353);
											VECTOR_SET(BgL_sz00_4939, (int) (((long) 0)),
												BgL_bpz00_4940);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1501z00_4947)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1501z00_4947), CDR(BgL_val1501z00_4947));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1501z00_4947;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_4954;

										BgL_nsz00_4954 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4954,
											(int) (((long) 1)), BgL_sz00_4939);
										VECTOR_SET(BgL_nsz00_4954,
											(int) (((long) 2)), BgL_az00_4933);
										VECTOR_SET(BgL_nsz00_4954,
											(int) (((long) 3)), BgL_bz00_4934);
										VECTOR_SET(BgL_nsz00_4954,
											(int) (((long) 4)), BgL_cz00_4935);
										VECTOR_SET(BgL_nsz00_4954,
											(int) (((long) 5)), BgL_dz00_4936);
										VECTOR_SET(BgL_nsz00_4954,
											(int) (((long) 6)), BgL_lastz00_4937);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_23648;

											BgL_auxz00_23648 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_23648, BgL_nsz00_4954);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1504z00_4956;

											BgL_val1504z00_4956 =
												BGl_zc3exitza33818ze3z83zz__evaluate_compz00
												(BgL_runz00_16353, BgL_nsz00_4954);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_23652;

												BgL_auxz00_23652 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_23652, BgL_sz00_4939);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1504z00_4956)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1504z00_4956), CDR(BgL_val1504z00_4956));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1504z00_4956;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3818> */
	obj_t BGl_zc3exitza33818ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17695,
		obj_t BgL_nsz00_17694)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1505z00_4962;

			if (SET_EXIT(BgL_an_exit1505z00_4962))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1505z00_4962 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1505z00_4962, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1506z00_4963;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_15044;

								BgL_savedzd2bpzd2_15044 =
									VECTOR_REF(BgL_nsz00_17694, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17694,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_15051;

									BgL_fz00_15051 = BgL_runz00_17695;
								BgL_recz00_15050:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_15052;

										BgL_rz00_15052 =
											PROCEDURE_ENTRY(BgL_fz00_15051) (BgL_fz00_15051,
											BgL_nsz00_17694, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_23673;

											if (PROCEDUREP(BgL_rz00_15052))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_15057;

													BgL_arg1900z00_15057 = PROCEDURE_ATTR(BgL_rz00_15052);
													if (STRUCTP(BgL_arg1900z00_15057))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_23673 =
																(STRUCT_KEY(BgL_arg1900z00_15057) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_23673 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_23673 = ((bool_t) 0);
												}
											if (BgL_testz00_23673)
												{
													obj_t BgL_fz00_23681;

													BgL_fz00_23681 = BgL_rz00_15052;
													BgL_fz00_15051 = BgL_fz00_23681;
													goto BgL_recz00_15050;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17694,
														(int) (((long) 0)), BgL_savedzd2bpzd2_15044);
													BgL_val1506z00_4963 = BgL_rz00_15052;
							}}}}}
							POP_EXIT();
							return BgL_val1506z00_4963;
						}
					}
				}
		}
	}



/* <exit:3812> */
	obj_t BGl_zc3exitza33812ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17698,
		obj_t BgL_sz00_17697, obj_t BgL_runz00_17696)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1502z00_4952;

			if (SET_EXIT(BgL_an_exit1502z00_4952))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1502z00_4952 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1502z00_4952, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1503z00_4953;

							BgL_val1503z00_4953 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17696,
								BgL_sz00_17697, BgL_bpz00_17698);
							POP_EXIT();
							return BgL_val1503z00_4953;
						}
					}
				}
		}
	}



/* &run5464 */
	obj_t BGl_z62run5464z62zz__evaluate_compz00(obj_t BgL_envz00_16360,
		obj_t BgL_sz00_16364)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_16361;
				BgL_ev_absz00_bglt BgL_i1252z00_16362;
				obj_t BgL_bodyz00_16363;

				BgL_iboxesz00_16361 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16360, (int) (((long) 0))));
				BgL_i1252z00_16362 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16360, (int) (((long) 1))));
				BgL_bodyz00_16363 = PROCEDURE_REF(BgL_envz00_16360, (int) (((long) 2)));
				{
					obj_t BgL_sz00_4965;

					BgL_sz00_4965 = BgL_sz00_16364;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4967;

						BgL_bpz00_4967 = VECTOR_REF(BgL_sz00_4965, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_4965,
							BgL_iboxesz00_16361, BgL_bpz00_4967);
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_z12denvz12_4968;
							obj_t BgL_wherez00_4969;
							obj_t BgL_locz00_4970;

							BgL_z12denvz12_4968 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4969 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16362))->BgL_wherez00);
							BgL_locz00_4970 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16362))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1129 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4968, BgL_wherez00_4969,
									BgL_locz00_4970);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_za2za2resza2za2z00_4971;

									BgL_za2za2resza2za2z00_4971 =
										PROCEDURE_ENTRY(BgL_bodyz00_16363) (BgL_bodyz00_16363,
										BgL_sz00_4965, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4968);
									return BgL_za2za2resza2za2z00_4971;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3822> */
	obj_t BGl_z62zc3anonymousza33822ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16365, obj_t BgL_sz00_16371)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_ifreesz00_16366;
				long BgL_siza7eza7_16367;
				BgL_ev_absz00_bglt BgL_i1252z00_16368;
				obj_t BgL_bodyz00_16369;
				long BgL_siza7ezd2framez75_16370;

				BgL_ifreesz00_16366 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16365, (int) (((long) 0))));
				BgL_siza7eza7_16367 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16365, (int) (((long) 1))));
				BgL_i1252z00_16368 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16365, (int) (((long) 2))));
				BgL_bodyz00_16369 = PROCEDURE_REF(BgL_envz00_16365, (int) (((long) 3)));
				BgL_siza7ezd2framez75_16370 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16365, (int) (((long) 4))));
				{
					obj_t BgL_sz00_4975;

					BgL_sz00_4975 = BgL_sz00_16371;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4977;

						BgL_bpz00_4977 = VECTOR_REF(BgL_sz00_4975, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_valza2za2_4978;

							BgL_valza2za2_4978 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_4975,
								BgL_bpz00_4977, BgL_ifreesz00_16366);
							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16240;

								BgL_runz00_16240 =
									MAKE_FX_PROCEDURE(BGl_z62run5466z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_runz00_16240,
									(int) (((long) 0)), BINT(BgL_siza7eza7_16367));
								PROCEDURE_SET(BgL_runz00_16240,
									(int) (((long) 1)), BgL_valza2za2_4978);
								PROCEDURE_SET(BgL_runz00_16240,
									(int) (((long) 2)), ((obj_t) BgL_i1252z00_16368));
								PROCEDURE_SET(BgL_runz00_16240,
									(int) (((long) 3)), BgL_bodyz00_16369);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16241;

									BgL_mainz00_16241 =
										MAKE_VA_PROCEDURE(BGl_z62main5465z62zz__evaluate_compz00,
										(int) (((long) -5)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_mainz00_16241,
										(int) (((long) 0)), BINT(BgL_siza7eza7_16367));
									PROCEDURE_SET(BgL_mainz00_16241,
										(int) (((long) 1)), BgL_valza2za2_4978);
									PROCEDURE_SET(BgL_mainz00_16241,
										(int) (((long) 2)), ((obj_t) BgL_i1252z00_16368));
									PROCEDURE_SET(BgL_mainz00_16241,
										(int) (((long) 3)), BgL_bodyz00_16369);
									PROCEDURE_SET(BgL_mainz00_16241,
										(int) (((long) 4)), BgL_runz00_16240);
									PROCEDURE_SET(BgL_mainz00_16241,
										(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_16370));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_15206;

										BgL_objz00_15206 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16240, BgL_objz00_15206);
										BgL_objz00_15206;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3823z00_4981;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3824z00_4982;

											BgL_arg3824z00_4982 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16368))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_15210;

												BgL_newz00_15210 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_23762;

													BgL_auxz00_23762 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_15210, BgL_auxz00_23762,
														BgL_arg3824z00_4982);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_23767;
													int BgL_auxz00_23765;

													BgL_auxz00_23767 = BINT(BgL_siza7ezd2framez75_16370);
													BgL_auxz00_23765 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_15210, BgL_auxz00_23765,
														BgL_auxz00_23767);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_23770;

													BgL_auxz00_23770 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_15210, BgL_auxz00_23770,
														BgL_runz00_16240);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_23775;
													int BgL_auxz00_23773;

													BgL_auxz00_23775 = BINT(((long) -5));
													BgL_auxz00_23773 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_15210, BgL_auxz00_23773,
														BgL_auxz00_23775);
												}
												BgL_arg3823z00_4981 = BgL_newz00_15210;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16241, BgL_arg3823z00_4981);
										BgL_arg3823z00_4981;
									}
									return BgL_mainz00_16241;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5465 */
	obj_t BGl_z62main5465z62zz__evaluate_compz00(obj_t BgL_envz00_16372,
		obj_t BgL_az00_16379, obj_t BgL_bz00_16380, obj_t BgL_cz00_16381,
		obj_t BgL_dz00_16382, obj_t BgL_lastz00_16383)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16377;
				long BgL_siza7ezd2framez75_16378;

				BgL_runz00_16377 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16372, (int) (((long) 4))));
				BgL_siza7ezd2framez75_16378 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16372, (int) (((long) 5))));
				{
					obj_t BgL_az00_4983;
					obj_t BgL_bz00_4984;
					obj_t BgL_cz00_4985;
					obj_t BgL_dz00_4986;
					obj_t BgL_lastz00_4987;

					BgL_az00_4983 = BgL_az00_16379;
					BgL_bz00_4984 = BgL_bz00_16380;
					BgL_cz00_4985 = BgL_cz00_16381;
					BgL_dz00_4986 = BgL_dz00_16382;
					BgL_lastz00_4987 = BgL_lastz00_16383;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_4989;

						BgL_sz00_4989 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_4990;

							BgL_bpz00_4990 = VECTOR_REF(BgL_sz00_4989, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_23788;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_15114;

									BgL_arg1908z00_15114 = VECTOR_LENGTH(BgL_sz00_4989);
									BgL_testz00_23788 =
										(
										((long) CINT(BgL_bpz00_4990) +
											BgL_siza7ezd2framez75_16378) <
										(long) (BgL_arg1908z00_15114));
								}
								if (BgL_testz00_23788)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3827z00_4992;

											BgL_arg3827z00_4992 =
												((long) CINT(BgL_bpz00_4990) + ((long) 0));
											VECTOR_SET(BgL_sz00_4989,
												(int) (BgL_arg3827z00_4992), BgL_az00_4983);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3828z00_4993;

											BgL_arg3828z00_4993 =
												((long) CINT(BgL_bpz00_4990) + ((long) 1));
											VECTOR_SET(BgL_sz00_4989,
												(int) (BgL_arg3828z00_4993), BgL_bz00_4984);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3829z00_4994;

											BgL_arg3829z00_4994 =
												((long) CINT(BgL_bpz00_4990) + ((long) 2));
											VECTOR_SET(BgL_sz00_4989,
												(int) (BgL_arg3829z00_4994), BgL_cz00_4985);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3830z00_4995;

											BgL_arg3830z00_4995 =
												((long) CINT(BgL_bpz00_4990) + ((long) 3));
											VECTOR_SET(BgL_sz00_4989,
												(int) (BgL_arg3830z00_4995), BgL_dz00_4986);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3831z00_4996;

											BgL_arg3831z00_4996 =
												((long) CINT(BgL_bpz00_4990) + ((long) 4));
											VECTOR_SET(BgL_sz00_4989,
												(int) (BgL_arg3831z00_4996), BgL_lastz00_4987);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1507z00_4997;

											BgL_val1507z00_4997 =
												BGl_zc3exitza33835ze3z83zz__evaluate_compz00
												(BgL_bpz00_4990, BgL_sz00_4989, BgL_runz00_16377);
											VECTOR_SET(BgL_sz00_4989, (int) (((long) 0)),
												BgL_bpz00_4990);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1507z00_4997)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1507z00_4997), CDR(BgL_val1507z00_4997));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1507z00_4997;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_5004;

										BgL_nsz00_5004 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5004,
											(int) (((long) 1)), BgL_sz00_4989);
										VECTOR_SET(BgL_nsz00_5004,
											(int) (((long) 2)), BgL_az00_4983);
										VECTOR_SET(BgL_nsz00_5004,
											(int) (((long) 3)), BgL_bz00_4984);
										VECTOR_SET(BgL_nsz00_5004,
											(int) (((long) 4)), BgL_cz00_4985);
										VECTOR_SET(BgL_nsz00_5004,
											(int) (((long) 5)), BgL_dz00_4986);
										VECTOR_SET(BgL_nsz00_5004,
											(int) (((long) 6)), BgL_lastz00_4987);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_23836;

											BgL_auxz00_23836 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_23836, BgL_nsz00_5004);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1510z00_5006;

											BgL_val1510z00_5006 =
												BGl_zc3exitza33841ze3z83zz__evaluate_compz00
												(BgL_runz00_16377, BgL_nsz00_5004);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_23840;

												BgL_auxz00_23840 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_23840, BgL_sz00_4989);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1510z00_5006)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1510z00_5006), CDR(BgL_val1510z00_5006));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1510z00_5006;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3841> */
	obj_t BGl_zc3exitza33841ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17690,
		obj_t BgL_nsz00_17689)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1511z00_5012;

			if (SET_EXIT(BgL_an_exit1511z00_5012))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1511z00_5012 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1511z00_5012, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1512z00_5013;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_15178;

								BgL_savedzd2bpzd2_15178 =
									VECTOR_REF(BgL_nsz00_17689, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17689,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_15185;

									BgL_fz00_15185 = BgL_runz00_17690;
								BgL_recz00_15184:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_15186;

										BgL_rz00_15186 =
											PROCEDURE_ENTRY(BgL_fz00_15185) (BgL_fz00_15185,
											BgL_nsz00_17689, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_23861;

											if (PROCEDUREP(BgL_rz00_15186))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_15191;

													BgL_arg1900z00_15191 = PROCEDURE_ATTR(BgL_rz00_15186);
													if (STRUCTP(BgL_arg1900z00_15191))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_23861 =
																(STRUCT_KEY(BgL_arg1900z00_15191) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_23861 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_23861 = ((bool_t) 0);
												}
											if (BgL_testz00_23861)
												{
													obj_t BgL_fz00_23869;

													BgL_fz00_23869 = BgL_rz00_15186;
													BgL_fz00_15185 = BgL_fz00_23869;
													goto BgL_recz00_15184;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17689,
														(int) (((long) 0)), BgL_savedzd2bpzd2_15178);
													BgL_val1512z00_5013 = BgL_rz00_15186;
							}}}}}
							POP_EXIT();
							return BgL_val1512z00_5013;
						}
					}
				}
		}
	}



/* <exit:3835> */
	obj_t BGl_zc3exitza33835ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17693,
		obj_t BgL_sz00_17692, obj_t BgL_runz00_17691)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1508z00_5002;

			if (SET_EXIT(BgL_an_exit1508z00_5002))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1508z00_5002 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1508z00_5002, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1509z00_5003;

							BgL_val1509z00_5003 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17691,
								BgL_sz00_17692, BgL_bpz00_17693);
							POP_EXIT();
							return BgL_val1509z00_5003;
						}
					}
				}
		}
	}



/* &run5466 */
	obj_t BGl_z62run5466z62zz__evaluate_compz00(obj_t BgL_envz00_16384,
		obj_t BgL_sz00_16389)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				long BgL_siza7eza7_16385;
				obj_t BgL_valza2za2_16386;
				BgL_ev_absz00_bglt BgL_i1252z00_16387;
				obj_t BgL_bodyz00_16388;

				BgL_siza7eza7_16385 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16384, (int) (((long) 0))));
				BgL_valza2za2_16386 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16384, (int) (((long) 1))));
				BgL_i1252z00_16387 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16384, (int) (((long) 2))));
				BgL_bodyz00_16388 = PROCEDURE_REF(BgL_envz00_16384, (int) (((long) 3)));
				{
					obj_t BgL_sz00_5015;

					BgL_sz00_5015 = BgL_sz00_16389;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_5017;

						BgL_bpz00_5017 = VECTOR_REF(BgL_sz00_5015, (int) (((long) 0)));
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_5015,
							BgL_valza2za2_16386,
							((long) CINT(BgL_bpz00_5017) + BgL_siza7eza7_16385));
						{	/* Eval/evaluate_comp.scm 1049 */
							obj_t BgL_z12denvz12_5019;
							obj_t BgL_wherez00_5020;
							obj_t BgL_locz00_5021;

							BgL_z12denvz12_5019 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5020 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16387))->BgL_wherez00);
							BgL_locz00_5021 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16387))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1049 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5019, BgL_wherez00_5020,
									BgL_locz00_5021);
								{	/* Eval/evaluate_comp.scm 1049 */
									obj_t BgL_za2za2resza2za2z00_5022;

									BgL_za2za2resza2za2z00_5022 =
										PROCEDURE_ENTRY(BgL_bodyz00_16388) (BgL_bodyz00_16388,
										BgL_sz00_5015, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5019);
									return BgL_za2za2resza2za2z00_5022;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3844> */
	obj_t BGl_z62zc3anonymousza33844ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16390, obj_t BgL_sz00_16397)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_ifreesz00_16391;
				obj_t BgL_iboxesz00_16392;
				long BgL_siza7eza7_16393;
				BgL_ev_absz00_bglt BgL_i1252z00_16394;
				obj_t BgL_bodyz00_16395;
				long BgL_siza7ezd2framez75_16396;

				BgL_ifreesz00_16391 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16390, (int) (((long) 0))));
				BgL_iboxesz00_16392 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16390, (int) (((long) 1))));
				BgL_siza7eza7_16393 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16390, (int) (((long) 2))));
				BgL_i1252z00_16394 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16390, (int) (((long) 3))));
				BgL_bodyz00_16395 = PROCEDURE_REF(BgL_envz00_16390, (int) (((long) 4)));
				BgL_siza7ezd2framez75_16396 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16390, (int) (((long) 5))));
				{
					obj_t BgL_sz00_5024;

					BgL_sz00_5024 = BgL_sz00_16397;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_5026;

						BgL_bpz00_5026 = VECTOR_REF(BgL_sz00_5024, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_valza2za2_5027;

							BgL_valza2za2_5027 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_5024,
								BgL_bpz00_5026, BgL_ifreesz00_16391);
							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16237;

								BgL_runz00_16237 =
									MAKE_FX_PROCEDURE(BGl_z62run5468z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_runz00_16237,
									(int) (((long) 0)), BgL_iboxesz00_16392);
								PROCEDURE_SET(BgL_runz00_16237,
									(int) (((long) 1)), BINT(BgL_siza7eza7_16393));
								PROCEDURE_SET(BgL_runz00_16237,
									(int) (((long) 2)), BgL_valza2za2_5027);
								PROCEDURE_SET(BgL_runz00_16237,
									(int) (((long) 3)), ((obj_t) BgL_i1252z00_16394));
								PROCEDURE_SET(BgL_runz00_16237,
									(int) (((long) 4)), BgL_bodyz00_16395);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16238;

									BgL_mainz00_16238 =
										MAKE_VA_PROCEDURE(BGl_z62main5467z62zz__evaluate_compz00,
										(int) (((long) -5)), (int) (((long) 7)));
									PROCEDURE_SET(BgL_mainz00_16238,
										(int) (((long) 0)), BgL_iboxesz00_16392);
									PROCEDURE_SET(BgL_mainz00_16238,
										(int) (((long) 1)), BINT(BgL_siza7eza7_16393));
									PROCEDURE_SET(BgL_mainz00_16238,
										(int) (((long) 2)), BgL_valza2za2_5027);
									PROCEDURE_SET(BgL_mainz00_16238,
										(int) (((long) 3)), ((obj_t) BgL_i1252z00_16394));
									PROCEDURE_SET(BgL_mainz00_16238,
										(int) (((long) 4)), BgL_bodyz00_16395);
									PROCEDURE_SET(BgL_mainz00_16238,
										(int) (((long) 5)), BgL_runz00_16237);
									PROCEDURE_SET(BgL_mainz00_16238,
										(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_16396));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_15336;

										BgL_objz00_15336 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16237, BgL_objz00_15336);
										BgL_objz00_15336;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3845z00_5030;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3846z00_5031;

											BgL_arg3846z00_5031 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16394))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_15340;

												BgL_newz00_15340 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_23962;

													BgL_auxz00_23962 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_15340, BgL_auxz00_23962,
														BgL_arg3846z00_5031);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_23967;
													int BgL_auxz00_23965;

													BgL_auxz00_23967 = BINT(BgL_siza7ezd2framez75_16396);
													BgL_auxz00_23965 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_15340, BgL_auxz00_23965,
														BgL_auxz00_23967);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_23970;

													BgL_auxz00_23970 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_15340, BgL_auxz00_23970,
														BgL_runz00_16237);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_23975;
													int BgL_auxz00_23973;

													BgL_auxz00_23975 = BINT(((long) -5));
													BgL_auxz00_23973 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_15340, BgL_auxz00_23973,
														BgL_auxz00_23975);
												}
												BgL_arg3845z00_5030 = BgL_newz00_15340;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16238, BgL_arg3845z00_5030);
										BgL_arg3845z00_5030;
									}
									return BgL_mainz00_16238;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5467 */
	obj_t BGl_z62main5467z62zz__evaluate_compz00(obj_t BgL_envz00_16398,
		obj_t BgL_az00_16406, obj_t BgL_bz00_16407, obj_t BgL_cz00_16408,
		obj_t BgL_dz00_16409, obj_t BgL_lastz00_16410)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16404;
				long BgL_siza7ezd2framez75_16405;

				BgL_runz00_16404 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16398, (int) (((long) 5))));
				BgL_siza7ezd2framez75_16405 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16398, (int) (((long) 6))));
				{
					obj_t BgL_az00_5032;
					obj_t BgL_bz00_5033;
					obj_t BgL_cz00_5034;
					obj_t BgL_dz00_5035;
					obj_t BgL_lastz00_5036;

					BgL_az00_5032 = BgL_az00_16406;
					BgL_bz00_5033 = BgL_bz00_16407;
					BgL_cz00_5034 = BgL_cz00_16408;
					BgL_dz00_5035 = BgL_dz00_16409;
					BgL_lastz00_5036 = BgL_lastz00_16410;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_5038;

						BgL_sz00_5038 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_5039;

							BgL_bpz00_5039 = VECTOR_REF(BgL_sz00_5038, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_23988;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_15244;

									BgL_arg1908z00_15244 = VECTOR_LENGTH(BgL_sz00_5038);
									BgL_testz00_23988 =
										(
										((long) CINT(BgL_bpz00_5039) +
											BgL_siza7ezd2framez75_16405) <
										(long) (BgL_arg1908z00_15244));
								}
								if (BgL_testz00_23988)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3849z00_5041;

											BgL_arg3849z00_5041 =
												((long) CINT(BgL_bpz00_5039) + ((long) 0));
											VECTOR_SET(BgL_sz00_5038,
												(int) (BgL_arg3849z00_5041), BgL_az00_5032);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3850z00_5042;

											BgL_arg3850z00_5042 =
												((long) CINT(BgL_bpz00_5039) + ((long) 1));
											VECTOR_SET(BgL_sz00_5038,
												(int) (BgL_arg3850z00_5042), BgL_bz00_5033);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3851z00_5043;

											BgL_arg3851z00_5043 =
												((long) CINT(BgL_bpz00_5039) + ((long) 2));
											VECTOR_SET(BgL_sz00_5038,
												(int) (BgL_arg3851z00_5043), BgL_cz00_5034);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3852z00_5044;

											BgL_arg3852z00_5044 =
												((long) CINT(BgL_bpz00_5039) + ((long) 3));
											VECTOR_SET(BgL_sz00_5038,
												(int) (BgL_arg3852z00_5044), BgL_dz00_5035);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3853z00_5045;

											BgL_arg3853z00_5045 =
												((long) CINT(BgL_bpz00_5039) + ((long) 4));
											VECTOR_SET(BgL_sz00_5038,
												(int) (BgL_arg3853z00_5045), BgL_lastz00_5036);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1513z00_5046;

											BgL_val1513z00_5046 =
												BGl_zc3exitza33857ze3z83zz__evaluate_compz00
												(BgL_bpz00_5039, BgL_sz00_5038, BgL_runz00_16404);
											VECTOR_SET(BgL_sz00_5038, (int) (((long) 0)),
												BgL_bpz00_5039);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1513z00_5046)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1513z00_5046), CDR(BgL_val1513z00_5046));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1513z00_5046;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_5053;

										BgL_nsz00_5053 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5053,
											(int) (((long) 1)), BgL_sz00_5038);
										VECTOR_SET(BgL_nsz00_5053,
											(int) (((long) 2)), BgL_az00_5032);
										VECTOR_SET(BgL_nsz00_5053,
											(int) (((long) 3)), BgL_bz00_5033);
										VECTOR_SET(BgL_nsz00_5053,
											(int) (((long) 4)), BgL_cz00_5034);
										VECTOR_SET(BgL_nsz00_5053,
											(int) (((long) 5)), BgL_dz00_5035);
										VECTOR_SET(BgL_nsz00_5053,
											(int) (((long) 6)), BgL_lastz00_5036);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_24036;

											BgL_auxz00_24036 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_24036, BgL_nsz00_5053);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1516z00_5055;

											BgL_val1516z00_5055 =
												BGl_zc3exitza33863ze3z83zz__evaluate_compz00
												(BgL_runz00_16404, BgL_nsz00_5053);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_24040;

												BgL_auxz00_24040 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_24040, BgL_sz00_5038);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1516z00_5055)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1516z00_5055), CDR(BgL_val1516z00_5055));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1516z00_5055;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3863> */
	obj_t BGl_zc3exitza33863ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17685,
		obj_t BgL_nsz00_17684)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1517z00_5061;

			if (SET_EXIT(BgL_an_exit1517z00_5061))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1517z00_5061 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1517z00_5061, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1518z00_5062;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_15308;

								BgL_savedzd2bpzd2_15308 =
									VECTOR_REF(BgL_nsz00_17684, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17684,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_15315;

									BgL_fz00_15315 = BgL_runz00_17685;
								BgL_recz00_15314:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_15316;

										BgL_rz00_15316 =
											PROCEDURE_ENTRY(BgL_fz00_15315) (BgL_fz00_15315,
											BgL_nsz00_17684, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_24061;

											if (PROCEDUREP(BgL_rz00_15316))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_15321;

													BgL_arg1900z00_15321 = PROCEDURE_ATTR(BgL_rz00_15316);
													if (STRUCTP(BgL_arg1900z00_15321))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_24061 =
																(STRUCT_KEY(BgL_arg1900z00_15321) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_24061 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_24061 = ((bool_t) 0);
												}
											if (BgL_testz00_24061)
												{
													obj_t BgL_fz00_24069;

													BgL_fz00_24069 = BgL_rz00_15316;
													BgL_fz00_15315 = BgL_fz00_24069;
													goto BgL_recz00_15314;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17684,
														(int) (((long) 0)), BgL_savedzd2bpzd2_15308);
													BgL_val1518z00_5062 = BgL_rz00_15316;
							}}}}}
							POP_EXIT();
							return BgL_val1518z00_5062;
						}
					}
				}
		}
	}



/* <exit:3857> */
	obj_t BGl_zc3exitza33857ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17688,
		obj_t BgL_sz00_17687, obj_t BgL_runz00_17686)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1514z00_5051;

			if (SET_EXIT(BgL_an_exit1514z00_5051))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1514z00_5051 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1514z00_5051, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1515z00_5052;

							BgL_val1515z00_5052 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17686,
								BgL_sz00_17687, BgL_bpz00_17688);
							POP_EXIT();
							return BgL_val1515z00_5052;
						}
					}
				}
		}
	}



/* &run5468 */
	obj_t BGl_z62run5468z62zz__evaluate_compz00(obj_t BgL_envz00_16411,
		obj_t BgL_sz00_16417)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_16412;
				long BgL_siza7eza7_16413;
				obj_t BgL_valza2za2_16414;
				BgL_ev_absz00_bglt BgL_i1252z00_16415;
				obj_t BgL_bodyz00_16416;

				BgL_iboxesz00_16412 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16411, (int) (((long) 0))));
				BgL_siza7eza7_16413 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16411, (int) (((long) 1))));
				BgL_valza2za2_16414 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16411, (int) (((long) 2))));
				BgL_i1252z00_16415 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16411, (int) (((long) 3))));
				BgL_bodyz00_16416 = PROCEDURE_REF(BgL_envz00_16411, (int) (((long) 4)));
				{
					obj_t BgL_sz00_5064;

					BgL_sz00_5064 = BgL_sz00_16417;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_5066;

						BgL_bpz00_5066 = VECTOR_REF(BgL_sz00_5064, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_5064,
							BgL_iboxesz00_16412, BgL_bpz00_5066);
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_5064,
							BgL_valza2za2_16414,
							((long) CINT(BgL_bpz00_5066) + BgL_siza7eza7_16413));
						{	/* Eval/evaluate_comp.scm 1049 */
							obj_t BgL_z12denvz12_5068;
							obj_t BgL_wherez00_5069;
							obj_t BgL_locz00_5070;

							BgL_z12denvz12_5068 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5069 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16415))->BgL_wherez00);
							BgL_locz00_5070 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16415))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1049 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5068, BgL_wherez00_5069,
									BgL_locz00_5070);
								{	/* Eval/evaluate_comp.scm 1049 */
									obj_t BgL_za2za2resza2za2z00_5071;

									BgL_za2za2resza2za2z00_5071 =
										PROCEDURE_ENTRY(BgL_bodyz00_16416) (BgL_bodyz00_16416,
										BgL_sz00_5064, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5068);
									return BgL_za2za2resza2za2z00_5071;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3690> */
	obj_t BGl_z62zc3anonymousza33690ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16418, obj_t BgL_sz00_16422)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_16419;
				obj_t BgL_bodyz00_16420;
				long BgL_siza7ezd2framez75_16421;

				BgL_i1252z00_16419 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16418, (int) (((long) 0))));
				BgL_bodyz00_16420 = PROCEDURE_REF(BgL_envz00_16418, (int) (((long) 1)));
				BgL_siza7ezd2framez75_16421 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16418, (int) (((long) 2))));
				{
					obj_t BgL_sz00_4689;

					BgL_sz00_4689 = BgL_sz00_16422;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4691;

						BgL_bpz00_4691 = VECTOR_REF(BgL_sz00_4689, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */

							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16234;

								BgL_runz00_16234 =
									MAKE_FX_PROCEDURE(BGl_z62run5470z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_runz00_16234,
									(int) (((long) 0)), ((obj_t) BgL_i1252z00_16419));
								PROCEDURE_SET(BgL_runz00_16234,
									(int) (((long) 1)), BgL_bodyz00_16420);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16235;

									BgL_mainz00_16235 =
										MAKE_FX_PROCEDURE(BGl_z62main5469z62zz__evaluate_compz00,
										(int) (((long) 4)), (int) (((long) 4)));
									PROCEDURE_SET(BgL_mainz00_16235,
										(int) (((long) 0)), ((obj_t) BgL_i1252z00_16419));
									PROCEDURE_SET(BgL_mainz00_16235,
										(int) (((long) 1)), BgL_bodyz00_16420);
									PROCEDURE_SET(BgL_mainz00_16235,
										(int) (((long) 2)), BgL_runz00_16234);
									PROCEDURE_SET(BgL_mainz00_16235,
										(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_16421));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_14446;

										BgL_objz00_14446 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16234, BgL_objz00_14446);
										BgL_objz00_14446;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3691z00_4694;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3692z00_4695;

											BgL_arg3692z00_4695 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16419))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_14450;

												BgL_newz00_14450 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_24142;

													BgL_auxz00_24142 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_14450, BgL_auxz00_24142,
														BgL_arg3692z00_4695);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_24147;
													int BgL_auxz00_24145;

													BgL_auxz00_24147 = BINT(BgL_siza7ezd2framez75_16421);
													BgL_auxz00_24145 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_14450, BgL_auxz00_24145,
														BgL_auxz00_24147);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_24150;

													BgL_auxz00_24150 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_14450, BgL_auxz00_24150,
														BgL_runz00_16234);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_24155;
													int BgL_auxz00_24153;

													BgL_auxz00_24155 = BINT(((long) 4));
													BgL_auxz00_24153 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_14450, BgL_auxz00_24153,
														BgL_auxz00_24155);
												}
												BgL_arg3691z00_4694 = BgL_newz00_14450;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16235, BgL_arg3691z00_4694);
										BgL_arg3691z00_4694;
									}
									return BgL_mainz00_16235;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5469 */
	obj_t BGl_z62main5469z62zz__evaluate_compz00(obj_t BgL_envz00_16423,
		obj_t BgL_az00_16428, obj_t BgL_bz00_16429, obj_t BgL_cz00_16430,
		obj_t BgL_dz00_16431)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16426;
				long BgL_siza7ezd2framez75_16427;

				BgL_runz00_16426 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16423, (int) (((long) 2))));
				BgL_siza7ezd2framez75_16427 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16423, (int) (((long) 3))));
				{
					obj_t BgL_az00_4696;
					obj_t BgL_bz00_4697;
					obj_t BgL_cz00_4698;
					obj_t BgL_dz00_4699;

					BgL_az00_4696 = BgL_az00_16428;
					BgL_bz00_4697 = BgL_bz00_16429;
					BgL_cz00_4698 = BgL_cz00_16430;
					BgL_dz00_4699 = BgL_dz00_16431;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_4701;

						BgL_sz00_4701 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_4702;

							BgL_bpz00_4702 = VECTOR_REF(BgL_sz00_4701, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_24168;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_14363;

									BgL_arg1908z00_14363 = VECTOR_LENGTH(BgL_sz00_4701);
									BgL_testz00_24168 =
										(
										((long) CINT(BgL_bpz00_4702) +
											BgL_siza7ezd2framez75_16427) <
										(long) (BgL_arg1908z00_14363));
								}
								if (BgL_testz00_24168)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3695z00_4704;

											BgL_arg3695z00_4704 =
												((long) CINT(BgL_bpz00_4702) + ((long) 0));
											VECTOR_SET(BgL_sz00_4701,
												(int) (BgL_arg3695z00_4704), BgL_az00_4696);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3696z00_4705;

											BgL_arg3696z00_4705 =
												((long) CINT(BgL_bpz00_4702) + ((long) 1));
											VECTOR_SET(BgL_sz00_4701,
												(int) (BgL_arg3696z00_4705), BgL_bz00_4697);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3697z00_4706;

											BgL_arg3697z00_4706 =
												((long) CINT(BgL_bpz00_4702) + ((long) 2));
											VECTOR_SET(BgL_sz00_4701,
												(int) (BgL_arg3697z00_4706), BgL_cz00_4698);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3698z00_4707;

											BgL_arg3698z00_4707 =
												((long) CINT(BgL_bpz00_4702) + ((long) 3));
											VECTOR_SET(BgL_sz00_4701,
												(int) (BgL_arg3698z00_4707), BgL_dz00_4699);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1471z00_4708;

											BgL_val1471z00_4708 =
												BGl_zc3exitza33702ze3z83zz__evaluate_compz00
												(BgL_bpz00_4702, BgL_sz00_4701, BgL_runz00_16426);
											VECTOR_SET(BgL_sz00_4701, (int) (((long) 0)),
												BgL_bpz00_4702);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1471z00_4708)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1471z00_4708), CDR(BgL_val1471z00_4708));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1471z00_4708;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_4715;

										BgL_nsz00_4715 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4715,
											(int) (((long) 1)), BgL_sz00_4701);
										VECTOR_SET(BgL_nsz00_4715,
											(int) (((long) 2)), BgL_az00_4696);
										VECTOR_SET(BgL_nsz00_4715,
											(int) (((long) 3)), BgL_bz00_4697);
										VECTOR_SET(BgL_nsz00_4715,
											(int) (((long) 4)), BgL_cz00_4698);
										VECTOR_SET(BgL_nsz00_4715,
											(int) (((long) 5)), BgL_dz00_4699);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_24210;

											BgL_auxz00_24210 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_24210, BgL_nsz00_4715);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1474z00_4717;

											BgL_val1474z00_4717 =
												BGl_zc3exitza33708ze3z83zz__evaluate_compz00
												(BgL_runz00_16426, BgL_nsz00_4715);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_24214;

												BgL_auxz00_24214 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_24214, BgL_sz00_4701);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1474z00_4717)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1474z00_4717), CDR(BgL_val1474z00_4717));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1474z00_4717;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3708> */
	obj_t BGl_zc3exitza33708ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17680,
		obj_t BgL_nsz00_17679)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1475z00_4723;

			if (SET_EXIT(BgL_an_exit1475z00_4723))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1475z00_4723 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1475z00_4723, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1476z00_4724;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_14418;

								BgL_savedzd2bpzd2_14418 =
									VECTOR_REF(BgL_nsz00_17679, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17679,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_14425;

									BgL_fz00_14425 = BgL_runz00_17680;
								BgL_recz00_14424:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_14426;

										BgL_rz00_14426 =
											PROCEDURE_ENTRY(BgL_fz00_14425) (BgL_fz00_14425,
											BgL_nsz00_17679, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_24235;

											if (PROCEDUREP(BgL_rz00_14426))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_14431;

													BgL_arg1900z00_14431 = PROCEDURE_ATTR(BgL_rz00_14426);
													if (STRUCTP(BgL_arg1900z00_14431))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_24235 =
																(STRUCT_KEY(BgL_arg1900z00_14431) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_24235 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_24235 = ((bool_t) 0);
												}
											if (BgL_testz00_24235)
												{
													obj_t BgL_fz00_24243;

													BgL_fz00_24243 = BgL_rz00_14426;
													BgL_fz00_14425 = BgL_fz00_24243;
													goto BgL_recz00_14424;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17679,
														(int) (((long) 0)), BgL_savedzd2bpzd2_14418);
													BgL_val1476z00_4724 = BgL_rz00_14426;
							}}}}}
							POP_EXIT();
							return BgL_val1476z00_4724;
						}
					}
				}
		}
	}



/* <exit:3702> */
	obj_t BGl_zc3exitza33702ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17683,
		obj_t BgL_sz00_17682, obj_t BgL_runz00_17681)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1472z00_4713;

			if (SET_EXIT(BgL_an_exit1472z00_4713))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1472z00_4713 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1472z00_4713, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1473z00_4714;

							BgL_val1473z00_4714 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17681,
								BgL_sz00_17682, BgL_bpz00_17683);
							POP_EXIT();
							return BgL_val1473z00_4714;
						}
					}
				}
		}
	}



/* &run5470 */
	obj_t BGl_z62run5470z62zz__evaluate_compz00(obj_t BgL_envz00_16432,
		obj_t BgL_sz00_16435)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_16433;
				obj_t BgL_bodyz00_16434;

				BgL_i1252z00_16433 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16432, (int) (((long) 0))));
				BgL_bodyz00_16434 = PROCEDURE_REF(BgL_envz00_16432, (int) (((long) 1)));
				{
					obj_t BgL_sz00_4726;

					BgL_sz00_4726 = BgL_sz00_16435;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4728;

						BgL_bpz00_4728 = VECTOR_REF(BgL_sz00_4726, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_z12denvz12_4729;
							obj_t BgL_wherez00_4730;
							obj_t BgL_locz00_4731;

							BgL_z12denvz12_4729 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4730 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16433))->BgL_wherez00);
							BgL_locz00_4731 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16433))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1129 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4729, BgL_wherez00_4730,
									BgL_locz00_4731);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_za2za2resza2za2z00_4732;

									BgL_za2za2resza2za2z00_4732 =
										PROCEDURE_ENTRY(BgL_bodyz00_16434) (BgL_bodyz00_16434,
										BgL_sz00_4726, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4729);
									return BgL_za2za2resza2za2z00_4732;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3710> */
	obj_t BGl_z62zc3anonymousza33710ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16436, obj_t BgL_sz00_16441)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_16437;
				BgL_ev_absz00_bglt BgL_i1252z00_16438;
				obj_t BgL_bodyz00_16439;
				long BgL_siza7ezd2framez75_16440;

				BgL_iboxesz00_16437 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16436, (int) (((long) 0))));
				BgL_i1252z00_16438 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16436, (int) (((long) 1))));
				BgL_bodyz00_16439 = PROCEDURE_REF(BgL_envz00_16436, (int) (((long) 2)));
				BgL_siza7ezd2framez75_16440 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16436, (int) (((long) 3))));
				{
					obj_t BgL_sz00_4734;

					BgL_sz00_4734 = BgL_sz00_16441;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4736;

						BgL_bpz00_4736 = VECTOR_REF(BgL_sz00_4734, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */

							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16231;

								BgL_runz00_16231 =
									MAKE_FX_PROCEDURE(BGl_z62run5472z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_runz00_16231,
									(int) (((long) 0)), BgL_iboxesz00_16437);
								PROCEDURE_SET(BgL_runz00_16231,
									(int) (((long) 1)), ((obj_t) BgL_i1252z00_16438));
								PROCEDURE_SET(BgL_runz00_16231,
									(int) (((long) 2)), BgL_bodyz00_16439);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16232;

									BgL_mainz00_16232 =
										MAKE_FX_PROCEDURE(BGl_z62main5471z62zz__evaluate_compz00,
										(int) (((long) 4)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_mainz00_16232,
										(int) (((long) 0)), BgL_iboxesz00_16437);
									PROCEDURE_SET(BgL_mainz00_16232,
										(int) (((long) 1)), ((obj_t) BgL_i1252z00_16438));
									PROCEDURE_SET(BgL_mainz00_16232,
										(int) (((long) 2)), BgL_bodyz00_16439);
									PROCEDURE_SET(BgL_mainz00_16232,
										(int) (((long) 3)), BgL_runz00_16231);
									PROCEDURE_SET(BgL_mainz00_16232,
										(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_16440));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_14564;

										BgL_objz00_14564 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16231, BgL_objz00_14564);
										BgL_objz00_14564;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3711z00_4739;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3712z00_4740;

											BgL_arg3712z00_4740 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16438))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_14568;

												BgL_newz00_14568 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_24310;

													BgL_auxz00_24310 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_14568, BgL_auxz00_24310,
														BgL_arg3712z00_4740);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_24315;
													int BgL_auxz00_24313;

													BgL_auxz00_24315 = BINT(BgL_siza7ezd2framez75_16440);
													BgL_auxz00_24313 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_14568, BgL_auxz00_24313,
														BgL_auxz00_24315);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_24318;

													BgL_auxz00_24318 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_14568, BgL_auxz00_24318,
														BgL_runz00_16231);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_24323;
													int BgL_auxz00_24321;

													BgL_auxz00_24323 = BINT(((long) 4));
													BgL_auxz00_24321 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_14568, BgL_auxz00_24321,
														BgL_auxz00_24323);
												}
												BgL_arg3711z00_4739 = BgL_newz00_14568;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16232, BgL_arg3711z00_4739);
										BgL_arg3711z00_4739;
									}
									return BgL_mainz00_16232;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5471 */
	obj_t BGl_z62main5471z62zz__evaluate_compz00(obj_t BgL_envz00_16442,
		obj_t BgL_az00_16448, obj_t BgL_bz00_16449, obj_t BgL_cz00_16450,
		obj_t BgL_dz00_16451)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16446;
				long BgL_siza7ezd2framez75_16447;

				BgL_runz00_16446 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16442, (int) (((long) 3))));
				BgL_siza7ezd2framez75_16447 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16442, (int) (((long) 4))));
				{
					obj_t BgL_az00_4741;
					obj_t BgL_bz00_4742;
					obj_t BgL_cz00_4743;
					obj_t BgL_dz00_4744;

					BgL_az00_4741 = BgL_az00_16448;
					BgL_bz00_4742 = BgL_bz00_16449;
					BgL_cz00_4743 = BgL_cz00_16450;
					BgL_dz00_4744 = BgL_dz00_16451;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_4746;

						BgL_sz00_4746 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_4747;

							BgL_bpz00_4747 = VECTOR_REF(BgL_sz00_4746, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_24336;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_14481;

									BgL_arg1908z00_14481 = VECTOR_LENGTH(BgL_sz00_4746);
									BgL_testz00_24336 =
										(
										((long) CINT(BgL_bpz00_4747) +
											BgL_siza7ezd2framez75_16447) <
										(long) (BgL_arg1908z00_14481));
								}
								if (BgL_testz00_24336)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3715z00_4749;

											BgL_arg3715z00_4749 =
												((long) CINT(BgL_bpz00_4747) + ((long) 0));
											VECTOR_SET(BgL_sz00_4746,
												(int) (BgL_arg3715z00_4749), BgL_az00_4741);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3716z00_4750;

											BgL_arg3716z00_4750 =
												((long) CINT(BgL_bpz00_4747) + ((long) 1));
											VECTOR_SET(BgL_sz00_4746,
												(int) (BgL_arg3716z00_4750), BgL_bz00_4742);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3717z00_4751;

											BgL_arg3717z00_4751 =
												((long) CINT(BgL_bpz00_4747) + ((long) 2));
											VECTOR_SET(BgL_sz00_4746,
												(int) (BgL_arg3717z00_4751), BgL_cz00_4743);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3718z00_4752;

											BgL_arg3718z00_4752 =
												((long) CINT(BgL_bpz00_4747) + ((long) 3));
											VECTOR_SET(BgL_sz00_4746,
												(int) (BgL_arg3718z00_4752), BgL_dz00_4744);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1477z00_4753;

											BgL_val1477z00_4753 =
												BGl_zc3exitza33722ze3z83zz__evaluate_compz00
												(BgL_bpz00_4747, BgL_sz00_4746, BgL_runz00_16446);
											VECTOR_SET(BgL_sz00_4746, (int) (((long) 0)),
												BgL_bpz00_4747);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1477z00_4753)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1477z00_4753), CDR(BgL_val1477z00_4753));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1477z00_4753;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_4760;

										BgL_nsz00_4760 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4760,
											(int) (((long) 1)), BgL_sz00_4746);
										VECTOR_SET(BgL_nsz00_4760,
											(int) (((long) 2)), BgL_az00_4741);
										VECTOR_SET(BgL_nsz00_4760,
											(int) (((long) 3)), BgL_bz00_4742);
										VECTOR_SET(BgL_nsz00_4760,
											(int) (((long) 4)), BgL_cz00_4743);
										VECTOR_SET(BgL_nsz00_4760,
											(int) (((long) 5)), BgL_dz00_4744);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_24378;

											BgL_auxz00_24378 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_24378, BgL_nsz00_4760);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1480z00_4762;

											BgL_val1480z00_4762 =
												BGl_zc3exitza33728ze3z83zz__evaluate_compz00
												(BgL_runz00_16446, BgL_nsz00_4760);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_24382;

												BgL_auxz00_24382 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_24382, BgL_sz00_4746);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1480z00_4762)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1480z00_4762), CDR(BgL_val1480z00_4762));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1480z00_4762;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3728> */
	obj_t BGl_zc3exitza33728ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17675,
		obj_t BgL_nsz00_17674)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1481z00_4768;

			if (SET_EXIT(BgL_an_exit1481z00_4768))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1481z00_4768 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1481z00_4768, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1482z00_4769;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_14536;

								BgL_savedzd2bpzd2_14536 =
									VECTOR_REF(BgL_nsz00_17674, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17674,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_14543;

									BgL_fz00_14543 = BgL_runz00_17675;
								BgL_recz00_14542:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_14544;

										BgL_rz00_14544 =
											PROCEDURE_ENTRY(BgL_fz00_14543) (BgL_fz00_14543,
											BgL_nsz00_17674, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_24403;

											if (PROCEDUREP(BgL_rz00_14544))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_14549;

													BgL_arg1900z00_14549 = PROCEDURE_ATTR(BgL_rz00_14544);
													if (STRUCTP(BgL_arg1900z00_14549))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_24403 =
																(STRUCT_KEY(BgL_arg1900z00_14549) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_24403 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_24403 = ((bool_t) 0);
												}
											if (BgL_testz00_24403)
												{
													obj_t BgL_fz00_24411;

													BgL_fz00_24411 = BgL_rz00_14544;
													BgL_fz00_14543 = BgL_fz00_24411;
													goto BgL_recz00_14542;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17674,
														(int) (((long) 0)), BgL_savedzd2bpzd2_14536);
													BgL_val1482z00_4769 = BgL_rz00_14544;
							}}}}}
							POP_EXIT();
							return BgL_val1482z00_4769;
						}
					}
				}
		}
	}



/* <exit:3722> */
	obj_t BGl_zc3exitza33722ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17678,
		obj_t BgL_sz00_17677, obj_t BgL_runz00_17676)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1478z00_4758;

			if (SET_EXIT(BgL_an_exit1478z00_4758))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1478z00_4758 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1478z00_4758, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1479z00_4759;

							BgL_val1479z00_4759 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17676,
								BgL_sz00_17677, BgL_bpz00_17678);
							POP_EXIT();
							return BgL_val1479z00_4759;
						}
					}
				}
		}
	}



/* &run5472 */
	obj_t BGl_z62run5472z62zz__evaluate_compz00(obj_t BgL_envz00_16452,
		obj_t BgL_sz00_16456)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_16453;
				BgL_ev_absz00_bglt BgL_i1252z00_16454;
				obj_t BgL_bodyz00_16455;

				BgL_iboxesz00_16453 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16452, (int) (((long) 0))));
				BgL_i1252z00_16454 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16452, (int) (((long) 1))));
				BgL_bodyz00_16455 = PROCEDURE_REF(BgL_envz00_16452, (int) (((long) 2)));
				{
					obj_t BgL_sz00_4771;

					BgL_sz00_4771 = BgL_sz00_16456;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4773;

						BgL_bpz00_4773 = VECTOR_REF(BgL_sz00_4771, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_4771,
							BgL_iboxesz00_16453, BgL_bpz00_4773);
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_z12denvz12_4774;
							obj_t BgL_wherez00_4775;
							obj_t BgL_locz00_4776;

							BgL_z12denvz12_4774 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4775 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16454))->BgL_wherez00);
							BgL_locz00_4776 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16454))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1129 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4774, BgL_wherez00_4775,
									BgL_locz00_4776);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_za2za2resza2za2z00_4777;

									BgL_za2za2resza2za2z00_4777 =
										PROCEDURE_ENTRY(BgL_bodyz00_16455) (BgL_bodyz00_16455,
										BgL_sz00_4771, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4774);
									return BgL_za2za2resza2za2z00_4777;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3732> */
	obj_t BGl_z62zc3anonymousza33732ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16457, obj_t BgL_sz00_16463)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_ifreesz00_16458;
				long BgL_siza7eza7_16459;
				BgL_ev_absz00_bglt BgL_i1252z00_16460;
				obj_t BgL_bodyz00_16461;
				long BgL_siza7ezd2framez75_16462;

				BgL_ifreesz00_16458 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16457, (int) (((long) 0))));
				BgL_siza7eza7_16459 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16457, (int) (((long) 1))));
				BgL_i1252z00_16460 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16457, (int) (((long) 2))));
				BgL_bodyz00_16461 = PROCEDURE_REF(BgL_envz00_16457, (int) (((long) 3)));
				BgL_siza7ezd2framez75_16462 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16457, (int) (((long) 4))));
				{
					obj_t BgL_sz00_4781;

					BgL_sz00_4781 = BgL_sz00_16463;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4783;

						BgL_bpz00_4783 = VECTOR_REF(BgL_sz00_4781, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_valza2za2_4784;

							BgL_valza2za2_4784 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_4781,
								BgL_bpz00_4783, BgL_ifreesz00_16458);
							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16228;

								BgL_runz00_16228 =
									MAKE_FX_PROCEDURE(BGl_z62run5474z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_runz00_16228,
									(int) (((long) 0)), BINT(BgL_siza7eza7_16459));
								PROCEDURE_SET(BgL_runz00_16228,
									(int) (((long) 1)), BgL_valza2za2_4784);
								PROCEDURE_SET(BgL_runz00_16228,
									(int) (((long) 2)), ((obj_t) BgL_i1252z00_16460));
								PROCEDURE_SET(BgL_runz00_16228,
									(int) (((long) 3)), BgL_bodyz00_16461);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16229;

									BgL_mainz00_16229 =
										MAKE_FX_PROCEDURE(BGl_z62main5473z62zz__evaluate_compz00,
										(int) (((long) 4)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_mainz00_16229,
										(int) (((long) 0)), BINT(BgL_siza7eza7_16459));
									PROCEDURE_SET(BgL_mainz00_16229,
										(int) (((long) 1)), BgL_valza2za2_4784);
									PROCEDURE_SET(BgL_mainz00_16229,
										(int) (((long) 2)), ((obj_t) BgL_i1252z00_16460));
									PROCEDURE_SET(BgL_mainz00_16229,
										(int) (((long) 3)), BgL_bodyz00_16461);
									PROCEDURE_SET(BgL_mainz00_16229,
										(int) (((long) 4)), BgL_runz00_16228);
									PROCEDURE_SET(BgL_mainz00_16229,
										(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_16462));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_14689;

										BgL_objz00_14689 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16228, BgL_objz00_14689);
										BgL_objz00_14689;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3733z00_4787;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3734z00_4788;

											BgL_arg3734z00_4788 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16460))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_14693;

												BgL_newz00_14693 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_24492;

													BgL_auxz00_24492 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_14693, BgL_auxz00_24492,
														BgL_arg3734z00_4788);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_24497;
													int BgL_auxz00_24495;

													BgL_auxz00_24497 = BINT(BgL_siza7ezd2framez75_16462);
													BgL_auxz00_24495 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_14693, BgL_auxz00_24495,
														BgL_auxz00_24497);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_24500;

													BgL_auxz00_24500 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_14693, BgL_auxz00_24500,
														BgL_runz00_16228);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_24505;
													int BgL_auxz00_24503;

													BgL_auxz00_24505 = BINT(((long) 4));
													BgL_auxz00_24503 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_14693, BgL_auxz00_24503,
														BgL_auxz00_24505);
												}
												BgL_arg3733z00_4787 = BgL_newz00_14693;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16229, BgL_arg3733z00_4787);
										BgL_arg3733z00_4787;
									}
									return BgL_mainz00_16229;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5473 */
	obj_t BGl_z62main5473z62zz__evaluate_compz00(obj_t BgL_envz00_16464,
		obj_t BgL_az00_16471, obj_t BgL_bz00_16472, obj_t BgL_cz00_16473,
		obj_t BgL_dz00_16474)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16469;
				long BgL_siza7ezd2framez75_16470;

				BgL_runz00_16469 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16464, (int) (((long) 4))));
				BgL_siza7ezd2framez75_16470 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16464, (int) (((long) 5))));
				{
					obj_t BgL_az00_4789;
					obj_t BgL_bz00_4790;
					obj_t BgL_cz00_4791;
					obj_t BgL_dz00_4792;

					BgL_az00_4789 = BgL_az00_16471;
					BgL_bz00_4790 = BgL_bz00_16472;
					BgL_cz00_4791 = BgL_cz00_16473;
					BgL_dz00_4792 = BgL_dz00_16474;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_4794;

						BgL_sz00_4794 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_4795;

							BgL_bpz00_4795 = VECTOR_REF(BgL_sz00_4794, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_24518;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_14606;

									BgL_arg1908z00_14606 = VECTOR_LENGTH(BgL_sz00_4794);
									BgL_testz00_24518 =
										(
										((long) CINT(BgL_bpz00_4795) +
											BgL_siza7ezd2framez75_16470) <
										(long) (BgL_arg1908z00_14606));
								}
								if (BgL_testz00_24518)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3737z00_4797;

											BgL_arg3737z00_4797 =
												((long) CINT(BgL_bpz00_4795) + ((long) 0));
											VECTOR_SET(BgL_sz00_4794,
												(int) (BgL_arg3737z00_4797), BgL_az00_4789);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3738z00_4798;

											BgL_arg3738z00_4798 =
												((long) CINT(BgL_bpz00_4795) + ((long) 1));
											VECTOR_SET(BgL_sz00_4794,
												(int) (BgL_arg3738z00_4798), BgL_bz00_4790);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3739z00_4799;

											BgL_arg3739z00_4799 =
												((long) CINT(BgL_bpz00_4795) + ((long) 2));
											VECTOR_SET(BgL_sz00_4794,
												(int) (BgL_arg3739z00_4799), BgL_cz00_4791);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3740z00_4800;

											BgL_arg3740z00_4800 =
												((long) CINT(BgL_bpz00_4795) + ((long) 3));
											VECTOR_SET(BgL_sz00_4794,
												(int) (BgL_arg3740z00_4800), BgL_dz00_4792);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1483z00_4801;

											BgL_val1483z00_4801 =
												BGl_zc3exitza33744ze3z83zz__evaluate_compz00
												(BgL_bpz00_4795, BgL_sz00_4794, BgL_runz00_16469);
											VECTOR_SET(BgL_sz00_4794, (int) (((long) 0)),
												BgL_bpz00_4795);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1483z00_4801)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1483z00_4801), CDR(BgL_val1483z00_4801));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1483z00_4801;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_4808;

										BgL_nsz00_4808 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4808,
											(int) (((long) 1)), BgL_sz00_4794);
										VECTOR_SET(BgL_nsz00_4808,
											(int) (((long) 2)), BgL_az00_4789);
										VECTOR_SET(BgL_nsz00_4808,
											(int) (((long) 3)), BgL_bz00_4790);
										VECTOR_SET(BgL_nsz00_4808,
											(int) (((long) 4)), BgL_cz00_4791);
										VECTOR_SET(BgL_nsz00_4808,
											(int) (((long) 5)), BgL_dz00_4792);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_24560;

											BgL_auxz00_24560 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_24560, BgL_nsz00_4808);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1486z00_4810;

											BgL_val1486z00_4810 =
												BGl_zc3exitza33750ze3z83zz__evaluate_compz00
												(BgL_runz00_16469, BgL_nsz00_4808);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_24564;

												BgL_auxz00_24564 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_24564, BgL_sz00_4794);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1486z00_4810)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1486z00_4810), CDR(BgL_val1486z00_4810));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1486z00_4810;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3750> */
	obj_t BGl_zc3exitza33750ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17670,
		obj_t BgL_nsz00_17669)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1487z00_4816;

			if (SET_EXIT(BgL_an_exit1487z00_4816))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1487z00_4816 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1487z00_4816, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1488z00_4817;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_14661;

								BgL_savedzd2bpzd2_14661 =
									VECTOR_REF(BgL_nsz00_17669, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17669,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_14668;

									BgL_fz00_14668 = BgL_runz00_17670;
								BgL_recz00_14667:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_14669;

										BgL_rz00_14669 =
											PROCEDURE_ENTRY(BgL_fz00_14668) (BgL_fz00_14668,
											BgL_nsz00_17669, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_24585;

											if (PROCEDUREP(BgL_rz00_14669))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_14674;

													BgL_arg1900z00_14674 = PROCEDURE_ATTR(BgL_rz00_14669);
													if (STRUCTP(BgL_arg1900z00_14674))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_24585 =
																(STRUCT_KEY(BgL_arg1900z00_14674) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_24585 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_24585 = ((bool_t) 0);
												}
											if (BgL_testz00_24585)
												{
													obj_t BgL_fz00_24593;

													BgL_fz00_24593 = BgL_rz00_14669;
													BgL_fz00_14668 = BgL_fz00_24593;
													goto BgL_recz00_14667;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17669,
														(int) (((long) 0)), BgL_savedzd2bpzd2_14661);
													BgL_val1488z00_4817 = BgL_rz00_14669;
							}}}}}
							POP_EXIT();
							return BgL_val1488z00_4817;
						}
					}
				}
		}
	}



/* <exit:3744> */
	obj_t BGl_zc3exitza33744ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17673,
		obj_t BgL_sz00_17672, obj_t BgL_runz00_17671)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1484z00_4806;

			if (SET_EXIT(BgL_an_exit1484z00_4806))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1484z00_4806 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1484z00_4806, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1485z00_4807;

							BgL_val1485z00_4807 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17671,
								BgL_sz00_17672, BgL_bpz00_17673);
							POP_EXIT();
							return BgL_val1485z00_4807;
						}
					}
				}
		}
	}



/* &run5474 */
	obj_t BGl_z62run5474z62zz__evaluate_compz00(obj_t BgL_envz00_16475,
		obj_t BgL_sz00_16480)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				long BgL_siza7eza7_16476;
				obj_t BgL_valza2za2_16477;
				BgL_ev_absz00_bglt BgL_i1252z00_16478;
				obj_t BgL_bodyz00_16479;

				BgL_siza7eza7_16476 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16475, (int) (((long) 0))));
				BgL_valza2za2_16477 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16475, (int) (((long) 1))));
				BgL_i1252z00_16478 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16475, (int) (((long) 2))));
				BgL_bodyz00_16479 = PROCEDURE_REF(BgL_envz00_16475, (int) (((long) 3)));
				{
					obj_t BgL_sz00_4819;

					BgL_sz00_4819 = BgL_sz00_16480;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4821;

						BgL_bpz00_4821 = VECTOR_REF(BgL_sz00_4819, (int) (((long) 0)));
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_4819,
							BgL_valza2za2_16477,
							((long) CINT(BgL_bpz00_4821) + BgL_siza7eza7_16476));
						{	/* Eval/evaluate_comp.scm 1049 */
							obj_t BgL_z12denvz12_4823;
							obj_t BgL_wherez00_4824;
							obj_t BgL_locz00_4825;

							BgL_z12denvz12_4823 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4824 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16478))->BgL_wherez00);
							BgL_locz00_4825 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16478))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1049 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4823, BgL_wherez00_4824,
									BgL_locz00_4825);
								{	/* Eval/evaluate_comp.scm 1049 */
									obj_t BgL_za2za2resza2za2z00_4826;

									BgL_za2za2resza2za2z00_4826 =
										PROCEDURE_ENTRY(BgL_bodyz00_16479) (BgL_bodyz00_16479,
										BgL_sz00_4819, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4823);
									return BgL_za2za2resza2za2z00_4826;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3753> */
	obj_t BGl_z62zc3anonymousza33753ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16481, obj_t BgL_sz00_16488)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_ifreesz00_16482;
				obj_t BgL_iboxesz00_16483;
				long BgL_siza7eza7_16484;
				BgL_ev_absz00_bglt BgL_i1252z00_16485;
				obj_t BgL_bodyz00_16486;
				long BgL_siza7ezd2framez75_16487;

				BgL_ifreesz00_16482 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16481, (int) (((long) 0))));
				BgL_iboxesz00_16483 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16481, (int) (((long) 1))));
				BgL_siza7eza7_16484 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16481, (int) (((long) 2))));
				BgL_i1252z00_16485 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16481, (int) (((long) 3))));
				BgL_bodyz00_16486 = PROCEDURE_REF(BgL_envz00_16481, (int) (((long) 4)));
				BgL_siza7ezd2framez75_16487 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16481, (int) (((long) 5))));
				{
					obj_t BgL_sz00_4828;

					BgL_sz00_4828 = BgL_sz00_16488;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4830;

						BgL_bpz00_4830 = VECTOR_REF(BgL_sz00_4828, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_valza2za2_4831;

							BgL_valza2za2_4831 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_4828,
								BgL_bpz00_4830, BgL_ifreesz00_16482);
							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16225;

								BgL_runz00_16225 =
									MAKE_FX_PROCEDURE(BGl_z62run5476z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_runz00_16225,
									(int) (((long) 0)), BgL_iboxesz00_16483);
								PROCEDURE_SET(BgL_runz00_16225,
									(int) (((long) 1)), BINT(BgL_siza7eza7_16484));
								PROCEDURE_SET(BgL_runz00_16225,
									(int) (((long) 2)), BgL_valza2za2_4831);
								PROCEDURE_SET(BgL_runz00_16225,
									(int) (((long) 3)), ((obj_t) BgL_i1252z00_16485));
								PROCEDURE_SET(BgL_runz00_16225,
									(int) (((long) 4)), BgL_bodyz00_16486);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16226;

									BgL_mainz00_16226 =
										MAKE_FX_PROCEDURE(BGl_z62main5475z62zz__evaluate_compz00,
										(int) (((long) 4)), (int) (((long) 7)));
									PROCEDURE_SET(BgL_mainz00_16226,
										(int) (((long) 0)), BgL_iboxesz00_16483);
									PROCEDURE_SET(BgL_mainz00_16226,
										(int) (((long) 1)), BINT(BgL_siza7eza7_16484));
									PROCEDURE_SET(BgL_mainz00_16226,
										(int) (((long) 2)), BgL_valza2za2_4831);
									PROCEDURE_SET(BgL_mainz00_16226,
										(int) (((long) 3)), ((obj_t) BgL_i1252z00_16485));
									PROCEDURE_SET(BgL_mainz00_16226,
										(int) (((long) 4)), BgL_bodyz00_16486);
									PROCEDURE_SET(BgL_mainz00_16226,
										(int) (((long) 5)), BgL_runz00_16225);
									PROCEDURE_SET(BgL_mainz00_16226,
										(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_16487));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_14810;

										BgL_objz00_14810 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16225, BgL_objz00_14810);
										BgL_objz00_14810;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3754z00_4834;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3755z00_4835;

											BgL_arg3755z00_4835 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16485))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_14814;

												BgL_newz00_14814 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_24686;

													BgL_auxz00_24686 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_14814, BgL_auxz00_24686,
														BgL_arg3755z00_4835);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_24691;
													int BgL_auxz00_24689;

													BgL_auxz00_24691 = BINT(BgL_siza7ezd2framez75_16487);
													BgL_auxz00_24689 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_14814, BgL_auxz00_24689,
														BgL_auxz00_24691);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_24694;

													BgL_auxz00_24694 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_14814, BgL_auxz00_24694,
														BgL_runz00_16225);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_24699;
													int BgL_auxz00_24697;

													BgL_auxz00_24699 = BINT(((long) 4));
													BgL_auxz00_24697 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_14814, BgL_auxz00_24697,
														BgL_auxz00_24699);
												}
												BgL_arg3754z00_4834 = BgL_newz00_14814;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16226, BgL_arg3754z00_4834);
										BgL_arg3754z00_4834;
									}
									return BgL_mainz00_16226;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5475 */
	obj_t BGl_z62main5475z62zz__evaluate_compz00(obj_t BgL_envz00_16489,
		obj_t BgL_az00_16497, obj_t BgL_bz00_16498, obj_t BgL_cz00_16499,
		obj_t BgL_dz00_16500)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16495;
				long BgL_siza7ezd2framez75_16496;

				BgL_runz00_16495 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16489, (int) (((long) 5))));
				BgL_siza7ezd2framez75_16496 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16489, (int) (((long) 6))));
				{
					obj_t BgL_az00_4836;
					obj_t BgL_bz00_4837;
					obj_t BgL_cz00_4838;
					obj_t BgL_dz00_4839;

					BgL_az00_4836 = BgL_az00_16497;
					BgL_bz00_4837 = BgL_bz00_16498;
					BgL_cz00_4838 = BgL_cz00_16499;
					BgL_dz00_4839 = BgL_dz00_16500;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_4841;

						BgL_sz00_4841 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_4842;

							BgL_bpz00_4842 = VECTOR_REF(BgL_sz00_4841, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_24712;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_14727;

									BgL_arg1908z00_14727 = VECTOR_LENGTH(BgL_sz00_4841);
									BgL_testz00_24712 =
										(
										((long) CINT(BgL_bpz00_4842) +
											BgL_siza7ezd2framez75_16496) <
										(long) (BgL_arg1908z00_14727));
								}
								if (BgL_testz00_24712)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3758z00_4844;

											BgL_arg3758z00_4844 =
												((long) CINT(BgL_bpz00_4842) + ((long) 0));
											VECTOR_SET(BgL_sz00_4841,
												(int) (BgL_arg3758z00_4844), BgL_az00_4836);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3759z00_4845;

											BgL_arg3759z00_4845 =
												((long) CINT(BgL_bpz00_4842) + ((long) 1));
											VECTOR_SET(BgL_sz00_4841,
												(int) (BgL_arg3759z00_4845), BgL_bz00_4837);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3760z00_4846;

											BgL_arg3760z00_4846 =
												((long) CINT(BgL_bpz00_4842) + ((long) 2));
											VECTOR_SET(BgL_sz00_4841,
												(int) (BgL_arg3760z00_4846), BgL_cz00_4838);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3761z00_4847;

											BgL_arg3761z00_4847 =
												((long) CINT(BgL_bpz00_4842) + ((long) 3));
											VECTOR_SET(BgL_sz00_4841,
												(int) (BgL_arg3761z00_4847), BgL_dz00_4839);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1489z00_4848;

											BgL_val1489z00_4848 =
												BGl_zc3exitza33765ze3z83zz__evaluate_compz00
												(BgL_bpz00_4842, BgL_sz00_4841, BgL_runz00_16495);
											VECTOR_SET(BgL_sz00_4841, (int) (((long) 0)),
												BgL_bpz00_4842);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1489z00_4848)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1489z00_4848), CDR(BgL_val1489z00_4848));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1489z00_4848;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_4855;

										BgL_nsz00_4855 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4855,
											(int) (((long) 1)), BgL_sz00_4841);
										VECTOR_SET(BgL_nsz00_4855,
											(int) (((long) 2)), BgL_az00_4836);
										VECTOR_SET(BgL_nsz00_4855,
											(int) (((long) 3)), BgL_bz00_4837);
										VECTOR_SET(BgL_nsz00_4855,
											(int) (((long) 4)), BgL_cz00_4838);
										VECTOR_SET(BgL_nsz00_4855,
											(int) (((long) 5)), BgL_dz00_4839);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_24754;

											BgL_auxz00_24754 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_24754, BgL_nsz00_4855);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1492z00_4857;

											BgL_val1492z00_4857 =
												BGl_zc3exitza33771ze3z83zz__evaluate_compz00
												(BgL_runz00_16495, BgL_nsz00_4855);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_24758;

												BgL_auxz00_24758 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_24758, BgL_sz00_4841);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1492z00_4857)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1492z00_4857), CDR(BgL_val1492z00_4857));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1492z00_4857;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3771> */
	obj_t BGl_zc3exitza33771ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17665,
		obj_t BgL_nsz00_17664)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1493z00_4863;

			if (SET_EXIT(BgL_an_exit1493z00_4863))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1493z00_4863 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1493z00_4863, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1494z00_4864;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_14782;

								BgL_savedzd2bpzd2_14782 =
									VECTOR_REF(BgL_nsz00_17664, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17664,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_14789;

									BgL_fz00_14789 = BgL_runz00_17665;
								BgL_recz00_14788:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_14790;

										BgL_rz00_14790 =
											PROCEDURE_ENTRY(BgL_fz00_14789) (BgL_fz00_14789,
											BgL_nsz00_17664, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_24779;

											if (PROCEDUREP(BgL_rz00_14790))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_14795;

													BgL_arg1900z00_14795 = PROCEDURE_ATTR(BgL_rz00_14790);
													if (STRUCTP(BgL_arg1900z00_14795))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_24779 =
																(STRUCT_KEY(BgL_arg1900z00_14795) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_24779 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_24779 = ((bool_t) 0);
												}
											if (BgL_testz00_24779)
												{
													obj_t BgL_fz00_24787;

													BgL_fz00_24787 = BgL_rz00_14790;
													BgL_fz00_14789 = BgL_fz00_24787;
													goto BgL_recz00_14788;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17664,
														(int) (((long) 0)), BgL_savedzd2bpzd2_14782);
													BgL_val1494z00_4864 = BgL_rz00_14790;
							}}}}}
							POP_EXIT();
							return BgL_val1494z00_4864;
						}
					}
				}
		}
	}



/* <exit:3765> */
	obj_t BGl_zc3exitza33765ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17668,
		obj_t BgL_sz00_17667, obj_t BgL_runz00_17666)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1490z00_4853;

			if (SET_EXIT(BgL_an_exit1490z00_4853))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1490z00_4853 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1490z00_4853, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1491z00_4854;

							BgL_val1491z00_4854 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17666,
								BgL_sz00_17667, BgL_bpz00_17668);
							POP_EXIT();
							return BgL_val1491z00_4854;
						}
					}
				}
		}
	}



/* &run5476 */
	obj_t BGl_z62run5476z62zz__evaluate_compz00(obj_t BgL_envz00_16501,
		obj_t BgL_sz00_16507)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_16502;
				long BgL_siza7eza7_16503;
				obj_t BgL_valza2za2_16504;
				BgL_ev_absz00_bglt BgL_i1252z00_16505;
				obj_t BgL_bodyz00_16506;

				BgL_iboxesz00_16502 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16501, (int) (((long) 0))));
				BgL_siza7eza7_16503 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16501, (int) (((long) 1))));
				BgL_valza2za2_16504 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16501, (int) (((long) 2))));
				BgL_i1252z00_16505 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16501, (int) (((long) 3))));
				BgL_bodyz00_16506 = PROCEDURE_REF(BgL_envz00_16501, (int) (((long) 4)));
				{
					obj_t BgL_sz00_4866;

					BgL_sz00_4866 = BgL_sz00_16507;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4868;

						BgL_bpz00_4868 = VECTOR_REF(BgL_sz00_4866, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_4866,
							BgL_iboxesz00_16502, BgL_bpz00_4868);
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_4866,
							BgL_valza2za2_16504,
							((long) CINT(BgL_bpz00_4868) + BgL_siza7eza7_16503));
						{	/* Eval/evaluate_comp.scm 1049 */
							obj_t BgL_z12denvz12_4870;
							obj_t BgL_wherez00_4871;
							obj_t BgL_locz00_4872;

							BgL_z12denvz12_4870 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4871 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16505))->BgL_wherez00);
							BgL_locz00_4872 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16505))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1049 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4870, BgL_wherez00_4871,
									BgL_locz00_4872);
								{	/* Eval/evaluate_comp.scm 1049 */
									obj_t BgL_za2za2resza2za2z00_4873;

									BgL_za2za2resza2za2z00_4873 =
										PROCEDURE_ENTRY(BgL_bodyz00_16506) (BgL_bodyz00_16506,
										BgL_sz00_4866, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4870);
									return BgL_za2za2resza2za2z00_4873;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3602> */
	obj_t BGl_z62zc3anonymousza33602ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16508, obj_t BgL_sz00_16512)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_16509;
				obj_t BgL_bodyz00_16510;
				long BgL_siza7ezd2framez75_16511;

				BgL_i1252z00_16509 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16508, (int) (((long) 0))));
				BgL_bodyz00_16510 = PROCEDURE_REF(BgL_envz00_16508, (int) (((long) 1)));
				BgL_siza7ezd2framez75_16511 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16508, (int) (((long) 2))));
				{
					obj_t BgL_sz00_4499;

					BgL_sz00_4499 = BgL_sz00_16512;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4501;

						BgL_bpz00_4501 = VECTOR_REF(BgL_sz00_4499, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */

							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16222;

								BgL_runz00_16222 =
									MAKE_FX_PROCEDURE(BGl_z62run5478z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_runz00_16222,
									(int) (((long) 0)), ((obj_t) BgL_i1252z00_16509));
								PROCEDURE_SET(BgL_runz00_16222,
									(int) (((long) 1)), BgL_bodyz00_16510);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16223;

									BgL_mainz00_16223 =
										MAKE_VA_PROCEDURE(BGl_z62main5477z62zz__evaluate_compz00,
										(int) (((long) -4)), (int) (((long) 4)));
									PROCEDURE_SET(BgL_mainz00_16223,
										(int) (((long) 0)), ((obj_t) BgL_i1252z00_16509));
									PROCEDURE_SET(BgL_mainz00_16223,
										(int) (((long) 1)), BgL_bodyz00_16510);
									PROCEDURE_SET(BgL_mainz00_16223,
										(int) (((long) 2)), BgL_runz00_16222);
									PROCEDURE_SET(BgL_mainz00_16223,
										(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_16511));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_13956;

										BgL_objz00_13956 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16222, BgL_objz00_13956);
										BgL_objz00_13956;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3603z00_4504;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3604z00_4505;

											BgL_arg3604z00_4505 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16509))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_13960;

												BgL_newz00_13960 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_24860;

													BgL_auxz00_24860 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_13960, BgL_auxz00_24860,
														BgL_arg3604z00_4505);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_24865;
													int BgL_auxz00_24863;

													BgL_auxz00_24865 = BINT(BgL_siza7ezd2framez75_16511);
													BgL_auxz00_24863 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_13960, BgL_auxz00_24863,
														BgL_auxz00_24865);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_24868;

													BgL_auxz00_24868 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_13960, BgL_auxz00_24868,
														BgL_runz00_16222);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_24873;
													int BgL_auxz00_24871;

													BgL_auxz00_24873 = BINT(((long) -4));
													BgL_auxz00_24871 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_13960, BgL_auxz00_24871,
														BgL_auxz00_24873);
												}
												BgL_arg3603z00_4504 = BgL_newz00_13960;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16223, BgL_arg3603z00_4504);
										BgL_arg3603z00_4504;
									}
									return BgL_mainz00_16223;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5477 */
	obj_t BGl_z62main5477z62zz__evaluate_compz00(obj_t BgL_envz00_16513,
		obj_t BgL_bz00_16518, obj_t BgL_cz00_16519, obj_t BgL_dz00_16520,
		obj_t BgL_lastz00_16521)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16516;
				long BgL_siza7ezd2framez75_16517;

				BgL_runz00_16516 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16513, (int) (((long) 2))));
				BgL_siza7ezd2framez75_16517 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16513, (int) (((long) 3))));
				{
					obj_t BgL_bz00_4506;
					obj_t BgL_cz00_4507;
					obj_t BgL_dz00_4508;
					obj_t BgL_lastz00_4509;

					BgL_bz00_4506 = BgL_bz00_16518;
					BgL_cz00_4507 = BgL_cz00_16519;
					BgL_dz00_4508 = BgL_dz00_16520;
					BgL_lastz00_4509 = BgL_lastz00_16521;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_4511;

						BgL_sz00_4511 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_4512;

							BgL_bpz00_4512 = VECTOR_REF(BgL_sz00_4511, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_24886;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_13873;

									BgL_arg1908z00_13873 = VECTOR_LENGTH(BgL_sz00_4511);
									BgL_testz00_24886 =
										(
										((long) CINT(BgL_bpz00_4512) +
											BgL_siza7ezd2framez75_16517) <
										(long) (BgL_arg1908z00_13873));
								}
								if (BgL_testz00_24886)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3607z00_4514;

											BgL_arg3607z00_4514 =
												((long) CINT(BgL_bpz00_4512) + ((long) 0));
											VECTOR_SET(BgL_sz00_4511,
												(int) (BgL_arg3607z00_4514), BgL_bz00_4506);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3608z00_4515;

											BgL_arg3608z00_4515 =
												((long) CINT(BgL_bpz00_4512) + ((long) 1));
											VECTOR_SET(BgL_sz00_4511,
												(int) (BgL_arg3608z00_4515), BgL_cz00_4507);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3609z00_4516;

											BgL_arg3609z00_4516 =
												((long) CINT(BgL_bpz00_4512) + ((long) 2));
											VECTOR_SET(BgL_sz00_4511,
												(int) (BgL_arg3609z00_4516), BgL_dz00_4508);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3610z00_4517;

											BgL_arg3610z00_4517 =
												((long) CINT(BgL_bpz00_4512) + ((long) 3));
											VECTOR_SET(BgL_sz00_4511,
												(int) (BgL_arg3610z00_4517), BgL_lastz00_4509);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1447z00_4518;

											BgL_val1447z00_4518 =
												BGl_zc3exitza33614ze3z83zz__evaluate_compz00
												(BgL_bpz00_4512, BgL_sz00_4511, BgL_runz00_16516);
											VECTOR_SET(BgL_sz00_4511, (int) (((long) 0)),
												BgL_bpz00_4512);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1447z00_4518)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1447z00_4518), CDR(BgL_val1447z00_4518));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1447z00_4518;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_4525;

										BgL_nsz00_4525 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4525,
											(int) (((long) 1)), BgL_sz00_4511);
										VECTOR_SET(BgL_nsz00_4525,
											(int) (((long) 2)), BgL_bz00_4506);
										VECTOR_SET(BgL_nsz00_4525,
											(int) (((long) 3)), BgL_cz00_4507);
										VECTOR_SET(BgL_nsz00_4525,
											(int) (((long) 4)), BgL_dz00_4508);
										VECTOR_SET(BgL_nsz00_4525,
											(int) (((long) 5)), BgL_lastz00_4509);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_24928;

											BgL_auxz00_24928 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_24928, BgL_nsz00_4525);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1450z00_4527;

											BgL_val1450z00_4527 =
												BGl_zc3exitza33620ze3z83zz__evaluate_compz00
												(BgL_runz00_16516, BgL_nsz00_4525);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_24932;

												BgL_auxz00_24932 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_24932, BgL_sz00_4511);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1450z00_4527)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1450z00_4527), CDR(BgL_val1450z00_4527));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1450z00_4527;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3620> */
	obj_t BGl_zc3exitza33620ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17660,
		obj_t BgL_nsz00_17659)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1451z00_4533;

			if (SET_EXIT(BgL_an_exit1451z00_4533))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1451z00_4533 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1451z00_4533, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1452z00_4534;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_13928;

								BgL_savedzd2bpzd2_13928 =
									VECTOR_REF(BgL_nsz00_17659, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17659,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_13935;

									BgL_fz00_13935 = BgL_runz00_17660;
								BgL_recz00_13934:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_13936;

										BgL_rz00_13936 =
											PROCEDURE_ENTRY(BgL_fz00_13935) (BgL_fz00_13935,
											BgL_nsz00_17659, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_24953;

											if (PROCEDUREP(BgL_rz00_13936))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_13941;

													BgL_arg1900z00_13941 = PROCEDURE_ATTR(BgL_rz00_13936);
													if (STRUCTP(BgL_arg1900z00_13941))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_24953 =
																(STRUCT_KEY(BgL_arg1900z00_13941) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_24953 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_24953 = ((bool_t) 0);
												}
											if (BgL_testz00_24953)
												{
													obj_t BgL_fz00_24961;

													BgL_fz00_24961 = BgL_rz00_13936;
													BgL_fz00_13935 = BgL_fz00_24961;
													goto BgL_recz00_13934;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17659,
														(int) (((long) 0)), BgL_savedzd2bpzd2_13928);
													BgL_val1452z00_4534 = BgL_rz00_13936;
							}}}}}
							POP_EXIT();
							return BgL_val1452z00_4534;
						}
					}
				}
		}
	}



/* <exit:3614> */
	obj_t BGl_zc3exitza33614ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17663,
		obj_t BgL_sz00_17662, obj_t BgL_runz00_17661)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1448z00_4523;

			if (SET_EXIT(BgL_an_exit1448z00_4523))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1448z00_4523 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1448z00_4523, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1449z00_4524;

							BgL_val1449z00_4524 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17661,
								BgL_sz00_17662, BgL_bpz00_17663);
							POP_EXIT();
							return BgL_val1449z00_4524;
						}
					}
				}
		}
	}



/* &run5478 */
	obj_t BGl_z62run5478z62zz__evaluate_compz00(obj_t BgL_envz00_16522,
		obj_t BgL_sz00_16525)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_16523;
				obj_t BgL_bodyz00_16524;

				BgL_i1252z00_16523 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16522, (int) (((long) 0))));
				BgL_bodyz00_16524 = PROCEDURE_REF(BgL_envz00_16522, (int) (((long) 1)));
				{
					obj_t BgL_sz00_4536;

					BgL_sz00_4536 = BgL_sz00_16525;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4538;

						BgL_bpz00_4538 = VECTOR_REF(BgL_sz00_4536, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_z12denvz12_4539;
							obj_t BgL_wherez00_4540;
							obj_t BgL_locz00_4541;

							BgL_z12denvz12_4539 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4540 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16523))->BgL_wherez00);
							BgL_locz00_4541 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16523))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1129 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4539, BgL_wherez00_4540,
									BgL_locz00_4541);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_za2za2resza2za2z00_4542;

									BgL_za2za2resza2za2z00_4542 =
										PROCEDURE_ENTRY(BgL_bodyz00_16524) (BgL_bodyz00_16524,
										BgL_sz00_4536, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4539);
									return BgL_za2za2resza2za2z00_4542;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3622> */
	obj_t BGl_z62zc3anonymousza33622ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16526, obj_t BgL_sz00_16531)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_16527;
				BgL_ev_absz00_bglt BgL_i1252z00_16528;
				obj_t BgL_bodyz00_16529;
				long BgL_siza7ezd2framez75_16530;

				BgL_iboxesz00_16527 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16526, (int) (((long) 0))));
				BgL_i1252z00_16528 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16526, (int) (((long) 1))));
				BgL_bodyz00_16529 = PROCEDURE_REF(BgL_envz00_16526, (int) (((long) 2)));
				BgL_siza7ezd2framez75_16530 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16526, (int) (((long) 3))));
				{
					obj_t BgL_sz00_4544;

					BgL_sz00_4544 = BgL_sz00_16531;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4546;

						BgL_bpz00_4546 = VECTOR_REF(BgL_sz00_4544, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */

							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16219;

								BgL_runz00_16219 =
									MAKE_FX_PROCEDURE(BGl_z62run5480z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_runz00_16219,
									(int) (((long) 0)), BgL_iboxesz00_16527);
								PROCEDURE_SET(BgL_runz00_16219,
									(int) (((long) 1)), ((obj_t) BgL_i1252z00_16528));
								PROCEDURE_SET(BgL_runz00_16219,
									(int) (((long) 2)), BgL_bodyz00_16529);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16220;

									BgL_mainz00_16220 =
										MAKE_VA_PROCEDURE(BGl_z62main5479z62zz__evaluate_compz00,
										(int) (((long) -4)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_mainz00_16220,
										(int) (((long) 0)), BgL_iboxesz00_16527);
									PROCEDURE_SET(BgL_mainz00_16220,
										(int) (((long) 1)), ((obj_t) BgL_i1252z00_16528));
									PROCEDURE_SET(BgL_mainz00_16220,
										(int) (((long) 2)), BgL_bodyz00_16529);
									PROCEDURE_SET(BgL_mainz00_16220,
										(int) (((long) 3)), BgL_runz00_16219);
									PROCEDURE_SET(BgL_mainz00_16220,
										(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_16530));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_14074;

										BgL_objz00_14074 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16219, BgL_objz00_14074);
										BgL_objz00_14074;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3623z00_4549;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3624z00_4550;

											BgL_arg3624z00_4550 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16528))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_14078;

												BgL_newz00_14078 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_25028;

													BgL_auxz00_25028 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_14078, BgL_auxz00_25028,
														BgL_arg3624z00_4550);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_25033;
													int BgL_auxz00_25031;

													BgL_auxz00_25033 = BINT(BgL_siza7ezd2framez75_16530);
													BgL_auxz00_25031 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_14078, BgL_auxz00_25031,
														BgL_auxz00_25033);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_25036;

													BgL_auxz00_25036 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_14078, BgL_auxz00_25036,
														BgL_runz00_16219);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_25041;
													int BgL_auxz00_25039;

													BgL_auxz00_25041 = BINT(((long) -4));
													BgL_auxz00_25039 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_14078, BgL_auxz00_25039,
														BgL_auxz00_25041);
												}
												BgL_arg3623z00_4549 = BgL_newz00_14078;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16220, BgL_arg3623z00_4549);
										BgL_arg3623z00_4549;
									}
									return BgL_mainz00_16220;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5479 */
	obj_t BGl_z62main5479z62zz__evaluate_compz00(obj_t BgL_envz00_16532,
		obj_t BgL_bz00_16538, obj_t BgL_cz00_16539, obj_t BgL_dz00_16540,
		obj_t BgL_lastz00_16541)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16536;
				long BgL_siza7ezd2framez75_16537;

				BgL_runz00_16536 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16532, (int) (((long) 3))));
				BgL_siza7ezd2framez75_16537 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16532, (int) (((long) 4))));
				{
					obj_t BgL_bz00_4551;
					obj_t BgL_cz00_4552;
					obj_t BgL_dz00_4553;
					obj_t BgL_lastz00_4554;

					BgL_bz00_4551 = BgL_bz00_16538;
					BgL_cz00_4552 = BgL_cz00_16539;
					BgL_dz00_4553 = BgL_dz00_16540;
					BgL_lastz00_4554 = BgL_lastz00_16541;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_4556;

						BgL_sz00_4556 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_4557;

							BgL_bpz00_4557 = VECTOR_REF(BgL_sz00_4556, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_25054;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_13991;

									BgL_arg1908z00_13991 = VECTOR_LENGTH(BgL_sz00_4556);
									BgL_testz00_25054 =
										(
										((long) CINT(BgL_bpz00_4557) +
											BgL_siza7ezd2framez75_16537) <
										(long) (BgL_arg1908z00_13991));
								}
								if (BgL_testz00_25054)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3627z00_4559;

											BgL_arg3627z00_4559 =
												((long) CINT(BgL_bpz00_4557) + ((long) 0));
											VECTOR_SET(BgL_sz00_4556,
												(int) (BgL_arg3627z00_4559), BgL_bz00_4551);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3628z00_4560;

											BgL_arg3628z00_4560 =
												((long) CINT(BgL_bpz00_4557) + ((long) 1));
											VECTOR_SET(BgL_sz00_4556,
												(int) (BgL_arg3628z00_4560), BgL_cz00_4552);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3629z00_4561;

											BgL_arg3629z00_4561 =
												((long) CINT(BgL_bpz00_4557) + ((long) 2));
											VECTOR_SET(BgL_sz00_4556,
												(int) (BgL_arg3629z00_4561), BgL_dz00_4553);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3630z00_4562;

											BgL_arg3630z00_4562 =
												((long) CINT(BgL_bpz00_4557) + ((long) 3));
											VECTOR_SET(BgL_sz00_4556,
												(int) (BgL_arg3630z00_4562), BgL_lastz00_4554);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1453z00_4563;

											BgL_val1453z00_4563 =
												BGl_zc3exitza33634ze3z83zz__evaluate_compz00
												(BgL_bpz00_4557, BgL_sz00_4556, BgL_runz00_16536);
											VECTOR_SET(BgL_sz00_4556, (int) (((long) 0)),
												BgL_bpz00_4557);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1453z00_4563)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1453z00_4563), CDR(BgL_val1453z00_4563));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1453z00_4563;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_4570;

										BgL_nsz00_4570 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4570,
											(int) (((long) 1)), BgL_sz00_4556);
										VECTOR_SET(BgL_nsz00_4570,
											(int) (((long) 2)), BgL_bz00_4551);
										VECTOR_SET(BgL_nsz00_4570,
											(int) (((long) 3)), BgL_cz00_4552);
										VECTOR_SET(BgL_nsz00_4570,
											(int) (((long) 4)), BgL_dz00_4553);
										VECTOR_SET(BgL_nsz00_4570,
											(int) (((long) 5)), BgL_lastz00_4554);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_25096;

											BgL_auxz00_25096 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_25096, BgL_nsz00_4570);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1456z00_4572;

											BgL_val1456z00_4572 =
												BGl_zc3exitza33640ze3z83zz__evaluate_compz00
												(BgL_runz00_16536, BgL_nsz00_4570);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_25100;

												BgL_auxz00_25100 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_25100, BgL_sz00_4556);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1456z00_4572)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1456z00_4572), CDR(BgL_val1456z00_4572));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1456z00_4572;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3640> */
	obj_t BGl_zc3exitza33640ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17655,
		obj_t BgL_nsz00_17654)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1457z00_4578;

			if (SET_EXIT(BgL_an_exit1457z00_4578))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1457z00_4578 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1457z00_4578, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1458z00_4579;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_14046;

								BgL_savedzd2bpzd2_14046 =
									VECTOR_REF(BgL_nsz00_17654, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17654,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_14053;

									BgL_fz00_14053 = BgL_runz00_17655;
								BgL_recz00_14052:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_14054;

										BgL_rz00_14054 =
											PROCEDURE_ENTRY(BgL_fz00_14053) (BgL_fz00_14053,
											BgL_nsz00_17654, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_25121;

											if (PROCEDUREP(BgL_rz00_14054))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_14059;

													BgL_arg1900z00_14059 = PROCEDURE_ATTR(BgL_rz00_14054);
													if (STRUCTP(BgL_arg1900z00_14059))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_25121 =
																(STRUCT_KEY(BgL_arg1900z00_14059) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_25121 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_25121 = ((bool_t) 0);
												}
											if (BgL_testz00_25121)
												{
													obj_t BgL_fz00_25129;

													BgL_fz00_25129 = BgL_rz00_14054;
													BgL_fz00_14053 = BgL_fz00_25129;
													goto BgL_recz00_14052;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17654,
														(int) (((long) 0)), BgL_savedzd2bpzd2_14046);
													BgL_val1458z00_4579 = BgL_rz00_14054;
							}}}}}
							POP_EXIT();
							return BgL_val1458z00_4579;
						}
					}
				}
		}
	}



/* <exit:3634> */
	obj_t BGl_zc3exitza33634ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17658,
		obj_t BgL_sz00_17657, obj_t BgL_runz00_17656)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1454z00_4568;

			if (SET_EXIT(BgL_an_exit1454z00_4568))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1454z00_4568 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1454z00_4568, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1455z00_4569;

							BgL_val1455z00_4569 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17656,
								BgL_sz00_17657, BgL_bpz00_17658);
							POP_EXIT();
							return BgL_val1455z00_4569;
						}
					}
				}
		}
	}



/* &run5480 */
	obj_t BGl_z62run5480z62zz__evaluate_compz00(obj_t BgL_envz00_16542,
		obj_t BgL_sz00_16546)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_16543;
				BgL_ev_absz00_bglt BgL_i1252z00_16544;
				obj_t BgL_bodyz00_16545;

				BgL_iboxesz00_16543 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16542, (int) (((long) 0))));
				BgL_i1252z00_16544 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16542, (int) (((long) 1))));
				BgL_bodyz00_16545 = PROCEDURE_REF(BgL_envz00_16542, (int) (((long) 2)));
				{
					obj_t BgL_sz00_4581;

					BgL_sz00_4581 = BgL_sz00_16546;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4583;

						BgL_bpz00_4583 = VECTOR_REF(BgL_sz00_4581, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_4581,
							BgL_iboxesz00_16543, BgL_bpz00_4583);
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_z12denvz12_4584;
							obj_t BgL_wherez00_4585;
							obj_t BgL_locz00_4586;

							BgL_z12denvz12_4584 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4585 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16544))->BgL_wherez00);
							BgL_locz00_4586 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16544))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1129 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4584, BgL_wherez00_4585,
									BgL_locz00_4586);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_za2za2resza2za2z00_4587;

									BgL_za2za2resza2za2z00_4587 =
										PROCEDURE_ENTRY(BgL_bodyz00_16545) (BgL_bodyz00_16545,
										BgL_sz00_4581, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4584);
									return BgL_za2za2resza2za2z00_4587;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3644> */
	obj_t BGl_z62zc3anonymousza33644ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16547, obj_t BgL_sz00_16553)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_ifreesz00_16548;
				long BgL_siza7eza7_16549;
				BgL_ev_absz00_bglt BgL_i1252z00_16550;
				obj_t BgL_bodyz00_16551;
				long BgL_siza7ezd2framez75_16552;

				BgL_ifreesz00_16548 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16547, (int) (((long) 0))));
				BgL_siza7eza7_16549 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16547, (int) (((long) 1))));
				BgL_i1252z00_16550 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16547, (int) (((long) 2))));
				BgL_bodyz00_16551 = PROCEDURE_REF(BgL_envz00_16547, (int) (((long) 3)));
				BgL_siza7ezd2framez75_16552 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16547, (int) (((long) 4))));
				{
					obj_t BgL_sz00_4591;

					BgL_sz00_4591 = BgL_sz00_16553;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4593;

						BgL_bpz00_4593 = VECTOR_REF(BgL_sz00_4591, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_valza2za2_4594;

							BgL_valza2za2_4594 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_4591,
								BgL_bpz00_4593, BgL_ifreesz00_16548);
							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16216;

								BgL_runz00_16216 =
									MAKE_FX_PROCEDURE(BGl_z62run5482z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_runz00_16216,
									(int) (((long) 0)), BINT(BgL_siza7eza7_16549));
								PROCEDURE_SET(BgL_runz00_16216,
									(int) (((long) 1)), BgL_valza2za2_4594);
								PROCEDURE_SET(BgL_runz00_16216,
									(int) (((long) 2)), ((obj_t) BgL_i1252z00_16550));
								PROCEDURE_SET(BgL_runz00_16216,
									(int) (((long) 3)), BgL_bodyz00_16551);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16217;

									BgL_mainz00_16217 =
										MAKE_VA_PROCEDURE(BGl_z62main5481z62zz__evaluate_compz00,
										(int) (((long) -4)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_mainz00_16217,
										(int) (((long) 0)), BINT(BgL_siza7eza7_16549));
									PROCEDURE_SET(BgL_mainz00_16217,
										(int) (((long) 1)), BgL_valza2za2_4594);
									PROCEDURE_SET(BgL_mainz00_16217,
										(int) (((long) 2)), ((obj_t) BgL_i1252z00_16550));
									PROCEDURE_SET(BgL_mainz00_16217,
										(int) (((long) 3)), BgL_bodyz00_16551);
									PROCEDURE_SET(BgL_mainz00_16217,
										(int) (((long) 4)), BgL_runz00_16216);
									PROCEDURE_SET(BgL_mainz00_16217,
										(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_16552));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_14199;

										BgL_objz00_14199 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16216, BgL_objz00_14199);
										BgL_objz00_14199;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3645z00_4597;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3646z00_4598;

											BgL_arg3646z00_4598 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16550))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_14203;

												BgL_newz00_14203 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_25210;

													BgL_auxz00_25210 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_14203, BgL_auxz00_25210,
														BgL_arg3646z00_4598);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_25215;
													int BgL_auxz00_25213;

													BgL_auxz00_25215 = BINT(BgL_siza7ezd2framez75_16552);
													BgL_auxz00_25213 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_14203, BgL_auxz00_25213,
														BgL_auxz00_25215);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_25218;

													BgL_auxz00_25218 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_14203, BgL_auxz00_25218,
														BgL_runz00_16216);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_25223;
													int BgL_auxz00_25221;

													BgL_auxz00_25223 = BINT(((long) -4));
													BgL_auxz00_25221 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_14203, BgL_auxz00_25221,
														BgL_auxz00_25223);
												}
												BgL_arg3645z00_4597 = BgL_newz00_14203;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16217, BgL_arg3645z00_4597);
										BgL_arg3645z00_4597;
									}
									return BgL_mainz00_16217;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5481 */
	obj_t BGl_z62main5481z62zz__evaluate_compz00(obj_t BgL_envz00_16554,
		obj_t BgL_bz00_16561, obj_t BgL_cz00_16562, obj_t BgL_dz00_16563,
		obj_t BgL_lastz00_16564)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16559;
				long BgL_siza7ezd2framez75_16560;

				BgL_runz00_16559 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16554, (int) (((long) 4))));
				BgL_siza7ezd2framez75_16560 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16554, (int) (((long) 5))));
				{
					obj_t BgL_bz00_4599;
					obj_t BgL_cz00_4600;
					obj_t BgL_dz00_4601;
					obj_t BgL_lastz00_4602;

					BgL_bz00_4599 = BgL_bz00_16561;
					BgL_cz00_4600 = BgL_cz00_16562;
					BgL_dz00_4601 = BgL_dz00_16563;
					BgL_lastz00_4602 = BgL_lastz00_16564;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_4604;

						BgL_sz00_4604 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_4605;

							BgL_bpz00_4605 = VECTOR_REF(BgL_sz00_4604, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_25236;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_14116;

									BgL_arg1908z00_14116 = VECTOR_LENGTH(BgL_sz00_4604);
									BgL_testz00_25236 =
										(
										((long) CINT(BgL_bpz00_4605) +
											BgL_siza7ezd2framez75_16560) <
										(long) (BgL_arg1908z00_14116));
								}
								if (BgL_testz00_25236)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3649z00_4607;

											BgL_arg3649z00_4607 =
												((long) CINT(BgL_bpz00_4605) + ((long) 0));
											VECTOR_SET(BgL_sz00_4604,
												(int) (BgL_arg3649z00_4607), BgL_bz00_4599);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3650z00_4608;

											BgL_arg3650z00_4608 =
												((long) CINT(BgL_bpz00_4605) + ((long) 1));
											VECTOR_SET(BgL_sz00_4604,
												(int) (BgL_arg3650z00_4608), BgL_cz00_4600);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3651z00_4609;

											BgL_arg3651z00_4609 =
												((long) CINT(BgL_bpz00_4605) + ((long) 2));
											VECTOR_SET(BgL_sz00_4604,
												(int) (BgL_arg3651z00_4609), BgL_dz00_4601);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3652z00_4610;

											BgL_arg3652z00_4610 =
												((long) CINT(BgL_bpz00_4605) + ((long) 3));
											VECTOR_SET(BgL_sz00_4604,
												(int) (BgL_arg3652z00_4610), BgL_lastz00_4602);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1459z00_4611;

											BgL_val1459z00_4611 =
												BGl_zc3exitza33656ze3z83zz__evaluate_compz00
												(BgL_bpz00_4605, BgL_sz00_4604, BgL_runz00_16559);
											VECTOR_SET(BgL_sz00_4604, (int) (((long) 0)),
												BgL_bpz00_4605);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1459z00_4611)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1459z00_4611), CDR(BgL_val1459z00_4611));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1459z00_4611;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_4618;

										BgL_nsz00_4618 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4618,
											(int) (((long) 1)), BgL_sz00_4604);
										VECTOR_SET(BgL_nsz00_4618,
											(int) (((long) 2)), BgL_bz00_4599);
										VECTOR_SET(BgL_nsz00_4618,
											(int) (((long) 3)), BgL_cz00_4600);
										VECTOR_SET(BgL_nsz00_4618,
											(int) (((long) 4)), BgL_dz00_4601);
										VECTOR_SET(BgL_nsz00_4618,
											(int) (((long) 5)), BgL_lastz00_4602);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_25278;

											BgL_auxz00_25278 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_25278, BgL_nsz00_4618);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1462z00_4620;

											BgL_val1462z00_4620 =
												BGl_zc3exitza33662ze3z83zz__evaluate_compz00
												(BgL_runz00_16559, BgL_nsz00_4618);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_25282;

												BgL_auxz00_25282 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_25282, BgL_sz00_4604);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1462z00_4620)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1462z00_4620), CDR(BgL_val1462z00_4620));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1462z00_4620;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3662> */
	obj_t BGl_zc3exitza33662ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17650,
		obj_t BgL_nsz00_17649)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1463z00_4626;

			if (SET_EXIT(BgL_an_exit1463z00_4626))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1463z00_4626 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1463z00_4626, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1464z00_4627;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_14171;

								BgL_savedzd2bpzd2_14171 =
									VECTOR_REF(BgL_nsz00_17649, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17649,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_14178;

									BgL_fz00_14178 = BgL_runz00_17650;
								BgL_recz00_14177:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_14179;

										BgL_rz00_14179 =
											PROCEDURE_ENTRY(BgL_fz00_14178) (BgL_fz00_14178,
											BgL_nsz00_17649, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_25303;

											if (PROCEDUREP(BgL_rz00_14179))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_14184;

													BgL_arg1900z00_14184 = PROCEDURE_ATTR(BgL_rz00_14179);
													if (STRUCTP(BgL_arg1900z00_14184))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_25303 =
																(STRUCT_KEY(BgL_arg1900z00_14184) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_25303 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_25303 = ((bool_t) 0);
												}
											if (BgL_testz00_25303)
												{
													obj_t BgL_fz00_25311;

													BgL_fz00_25311 = BgL_rz00_14179;
													BgL_fz00_14178 = BgL_fz00_25311;
													goto BgL_recz00_14177;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17649,
														(int) (((long) 0)), BgL_savedzd2bpzd2_14171);
													BgL_val1464z00_4627 = BgL_rz00_14179;
							}}}}}
							POP_EXIT();
							return BgL_val1464z00_4627;
						}
					}
				}
		}
	}



/* <exit:3656> */
	obj_t BGl_zc3exitza33656ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17653,
		obj_t BgL_sz00_17652, obj_t BgL_runz00_17651)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1460z00_4616;

			if (SET_EXIT(BgL_an_exit1460z00_4616))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1460z00_4616 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1460z00_4616, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1461z00_4617;

							BgL_val1461z00_4617 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17651,
								BgL_sz00_17652, BgL_bpz00_17653);
							POP_EXIT();
							return BgL_val1461z00_4617;
						}
					}
				}
		}
	}



/* &run5482 */
	obj_t BGl_z62run5482z62zz__evaluate_compz00(obj_t BgL_envz00_16565,
		obj_t BgL_sz00_16570)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				long BgL_siza7eza7_16566;
				obj_t BgL_valza2za2_16567;
				BgL_ev_absz00_bglt BgL_i1252z00_16568;
				obj_t BgL_bodyz00_16569;

				BgL_siza7eza7_16566 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16565, (int) (((long) 0))));
				BgL_valza2za2_16567 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16565, (int) (((long) 1))));
				BgL_i1252z00_16568 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16565, (int) (((long) 2))));
				BgL_bodyz00_16569 = PROCEDURE_REF(BgL_envz00_16565, (int) (((long) 3)));
				{
					obj_t BgL_sz00_4629;

					BgL_sz00_4629 = BgL_sz00_16570;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4631;

						BgL_bpz00_4631 = VECTOR_REF(BgL_sz00_4629, (int) (((long) 0)));
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_4629,
							BgL_valza2za2_16567,
							((long) CINT(BgL_bpz00_4631) + BgL_siza7eza7_16566));
						{	/* Eval/evaluate_comp.scm 1049 */
							obj_t BgL_z12denvz12_4633;
							obj_t BgL_wherez00_4634;
							obj_t BgL_locz00_4635;

							BgL_z12denvz12_4633 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4634 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16568))->BgL_wherez00);
							BgL_locz00_4635 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16568))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1049 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4633, BgL_wherez00_4634,
									BgL_locz00_4635);
								{	/* Eval/evaluate_comp.scm 1049 */
									obj_t BgL_za2za2resza2za2z00_4636;

									BgL_za2za2resza2za2z00_4636 =
										PROCEDURE_ENTRY(BgL_bodyz00_16569) (BgL_bodyz00_16569,
										BgL_sz00_4629, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4633);
									return BgL_za2za2resza2za2z00_4636;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3665> */
	obj_t BGl_z62zc3anonymousza33665ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16571, obj_t BgL_sz00_16578)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_ifreesz00_16572;
				obj_t BgL_iboxesz00_16573;
				long BgL_siza7eza7_16574;
				BgL_ev_absz00_bglt BgL_i1252z00_16575;
				obj_t BgL_bodyz00_16576;
				long BgL_siza7ezd2framez75_16577;

				BgL_ifreesz00_16572 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16571, (int) (((long) 0))));
				BgL_iboxesz00_16573 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16571, (int) (((long) 1))));
				BgL_siza7eza7_16574 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16571, (int) (((long) 2))));
				BgL_i1252z00_16575 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16571, (int) (((long) 3))));
				BgL_bodyz00_16576 = PROCEDURE_REF(BgL_envz00_16571, (int) (((long) 4)));
				BgL_siza7ezd2framez75_16577 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16571, (int) (((long) 5))));
				{
					obj_t BgL_sz00_4638;

					BgL_sz00_4638 = BgL_sz00_16578;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4640;

						BgL_bpz00_4640 = VECTOR_REF(BgL_sz00_4638, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_valza2za2_4641;

							BgL_valza2za2_4641 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_4638,
								BgL_bpz00_4640, BgL_ifreesz00_16572);
							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16213;

								BgL_runz00_16213 =
									MAKE_FX_PROCEDURE(BGl_z62run5484z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_runz00_16213,
									(int) (((long) 0)), BgL_iboxesz00_16573);
								PROCEDURE_SET(BgL_runz00_16213,
									(int) (((long) 1)), BINT(BgL_siza7eza7_16574));
								PROCEDURE_SET(BgL_runz00_16213,
									(int) (((long) 2)), BgL_valza2za2_4641);
								PROCEDURE_SET(BgL_runz00_16213,
									(int) (((long) 3)), ((obj_t) BgL_i1252z00_16575));
								PROCEDURE_SET(BgL_runz00_16213,
									(int) (((long) 4)), BgL_bodyz00_16576);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16214;

									BgL_mainz00_16214 =
										MAKE_VA_PROCEDURE(BGl_z62main5483z62zz__evaluate_compz00,
										(int) (((long) -4)), (int) (((long) 7)));
									PROCEDURE_SET(BgL_mainz00_16214,
										(int) (((long) 0)), BgL_iboxesz00_16573);
									PROCEDURE_SET(BgL_mainz00_16214,
										(int) (((long) 1)), BINT(BgL_siza7eza7_16574));
									PROCEDURE_SET(BgL_mainz00_16214,
										(int) (((long) 2)), BgL_valza2za2_4641);
									PROCEDURE_SET(BgL_mainz00_16214,
										(int) (((long) 3)), ((obj_t) BgL_i1252z00_16575));
									PROCEDURE_SET(BgL_mainz00_16214,
										(int) (((long) 4)), BgL_bodyz00_16576);
									PROCEDURE_SET(BgL_mainz00_16214,
										(int) (((long) 5)), BgL_runz00_16213);
									PROCEDURE_SET(BgL_mainz00_16214,
										(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_16577));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_14320;

										BgL_objz00_14320 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16213, BgL_objz00_14320);
										BgL_objz00_14320;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3666z00_4644;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3667z00_4645;

											BgL_arg3667z00_4645 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16575))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_14324;

												BgL_newz00_14324 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_25404;

													BgL_auxz00_25404 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_14324, BgL_auxz00_25404,
														BgL_arg3667z00_4645);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_25409;
													int BgL_auxz00_25407;

													BgL_auxz00_25409 = BINT(BgL_siza7ezd2framez75_16577);
													BgL_auxz00_25407 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_14324, BgL_auxz00_25407,
														BgL_auxz00_25409);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_25412;

													BgL_auxz00_25412 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_14324, BgL_auxz00_25412,
														BgL_runz00_16213);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_25417;
													int BgL_auxz00_25415;

													BgL_auxz00_25417 = BINT(((long) -4));
													BgL_auxz00_25415 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_14324, BgL_auxz00_25415,
														BgL_auxz00_25417);
												}
												BgL_arg3666z00_4644 = BgL_newz00_14324;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16214, BgL_arg3666z00_4644);
										BgL_arg3666z00_4644;
									}
									return BgL_mainz00_16214;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5483 */
	obj_t BGl_z62main5483z62zz__evaluate_compz00(obj_t BgL_envz00_16579,
		obj_t BgL_bz00_16587, obj_t BgL_cz00_16588, obj_t BgL_dz00_16589,
		obj_t BgL_lastz00_16590)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16585;
				long BgL_siza7ezd2framez75_16586;

				BgL_runz00_16585 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16579, (int) (((long) 5))));
				BgL_siza7ezd2framez75_16586 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16579, (int) (((long) 6))));
				{
					obj_t BgL_bz00_4646;
					obj_t BgL_cz00_4647;
					obj_t BgL_dz00_4648;
					obj_t BgL_lastz00_4649;

					BgL_bz00_4646 = BgL_bz00_16587;
					BgL_cz00_4647 = BgL_cz00_16588;
					BgL_dz00_4648 = BgL_dz00_16589;
					BgL_lastz00_4649 = BgL_lastz00_16590;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_4651;

						BgL_sz00_4651 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_4652;

							BgL_bpz00_4652 = VECTOR_REF(BgL_sz00_4651, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_25430;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_14237;

									BgL_arg1908z00_14237 = VECTOR_LENGTH(BgL_sz00_4651);
									BgL_testz00_25430 =
										(
										((long) CINT(BgL_bpz00_4652) +
											BgL_siza7ezd2framez75_16586) <
										(long) (BgL_arg1908z00_14237));
								}
								if (BgL_testz00_25430)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3670z00_4654;

											BgL_arg3670z00_4654 =
												((long) CINT(BgL_bpz00_4652) + ((long) 0));
											VECTOR_SET(BgL_sz00_4651,
												(int) (BgL_arg3670z00_4654), BgL_bz00_4646);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3671z00_4655;

											BgL_arg3671z00_4655 =
												((long) CINT(BgL_bpz00_4652) + ((long) 1));
											VECTOR_SET(BgL_sz00_4651,
												(int) (BgL_arg3671z00_4655), BgL_cz00_4647);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3672z00_4656;

											BgL_arg3672z00_4656 =
												((long) CINT(BgL_bpz00_4652) + ((long) 2));
											VECTOR_SET(BgL_sz00_4651,
												(int) (BgL_arg3672z00_4656), BgL_dz00_4648);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3673z00_4657;

											BgL_arg3673z00_4657 =
												((long) CINT(BgL_bpz00_4652) + ((long) 3));
											VECTOR_SET(BgL_sz00_4651,
												(int) (BgL_arg3673z00_4657), BgL_lastz00_4649);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1465z00_4658;

											BgL_val1465z00_4658 =
												BGl_zc3exitza33677ze3z83zz__evaluate_compz00
												(BgL_bpz00_4652, BgL_sz00_4651, BgL_runz00_16585);
											VECTOR_SET(BgL_sz00_4651, (int) (((long) 0)),
												BgL_bpz00_4652);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1465z00_4658)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1465z00_4658), CDR(BgL_val1465z00_4658));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1465z00_4658;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_4665;

										BgL_nsz00_4665 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4665,
											(int) (((long) 1)), BgL_sz00_4651);
										VECTOR_SET(BgL_nsz00_4665,
											(int) (((long) 2)), BgL_bz00_4646);
										VECTOR_SET(BgL_nsz00_4665,
											(int) (((long) 3)), BgL_cz00_4647);
										VECTOR_SET(BgL_nsz00_4665,
											(int) (((long) 4)), BgL_dz00_4648);
										VECTOR_SET(BgL_nsz00_4665,
											(int) (((long) 5)), BgL_lastz00_4649);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_25472;

											BgL_auxz00_25472 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_25472, BgL_nsz00_4665);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1468z00_4667;

											BgL_val1468z00_4667 =
												BGl_zc3exitza33683ze3z83zz__evaluate_compz00
												(BgL_runz00_16585, BgL_nsz00_4665);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_25476;

												BgL_auxz00_25476 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_25476, BgL_sz00_4651);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1468z00_4667)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1468z00_4667), CDR(BgL_val1468z00_4667));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1468z00_4667;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3683> */
	obj_t BGl_zc3exitza33683ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17645,
		obj_t BgL_nsz00_17644)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1469z00_4673;

			if (SET_EXIT(BgL_an_exit1469z00_4673))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1469z00_4673 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1469z00_4673, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1470z00_4674;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_14292;

								BgL_savedzd2bpzd2_14292 =
									VECTOR_REF(BgL_nsz00_17644, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17644,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_14299;

									BgL_fz00_14299 = BgL_runz00_17645;
								BgL_recz00_14298:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_14300;

										BgL_rz00_14300 =
											PROCEDURE_ENTRY(BgL_fz00_14299) (BgL_fz00_14299,
											BgL_nsz00_17644, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_25497;

											if (PROCEDUREP(BgL_rz00_14300))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_14305;

													BgL_arg1900z00_14305 = PROCEDURE_ATTR(BgL_rz00_14300);
													if (STRUCTP(BgL_arg1900z00_14305))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_25497 =
																(STRUCT_KEY(BgL_arg1900z00_14305) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_25497 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_25497 = ((bool_t) 0);
												}
											if (BgL_testz00_25497)
												{
													obj_t BgL_fz00_25505;

													BgL_fz00_25505 = BgL_rz00_14300;
													BgL_fz00_14299 = BgL_fz00_25505;
													goto BgL_recz00_14298;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17644,
														(int) (((long) 0)), BgL_savedzd2bpzd2_14292);
													BgL_val1470z00_4674 = BgL_rz00_14300;
							}}}}}
							POP_EXIT();
							return BgL_val1470z00_4674;
						}
					}
				}
		}
	}



/* <exit:3677> */
	obj_t BGl_zc3exitza33677ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17648,
		obj_t BgL_sz00_17647, obj_t BgL_runz00_17646)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1466z00_4663;

			if (SET_EXIT(BgL_an_exit1466z00_4663))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1466z00_4663 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1466z00_4663, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1467z00_4664;

							BgL_val1467z00_4664 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17646,
								BgL_sz00_17647, BgL_bpz00_17648);
							POP_EXIT();
							return BgL_val1467z00_4664;
						}
					}
				}
		}
	}



/* &run5484 */
	obj_t BGl_z62run5484z62zz__evaluate_compz00(obj_t BgL_envz00_16591,
		obj_t BgL_sz00_16597)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_16592;
				long BgL_siza7eza7_16593;
				obj_t BgL_valza2za2_16594;
				BgL_ev_absz00_bglt BgL_i1252z00_16595;
				obj_t BgL_bodyz00_16596;

				BgL_iboxesz00_16592 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16591, (int) (((long) 0))));
				BgL_siza7eza7_16593 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16591, (int) (((long) 1))));
				BgL_valza2za2_16594 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16591, (int) (((long) 2))));
				BgL_i1252z00_16595 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16591, (int) (((long) 3))));
				BgL_bodyz00_16596 = PROCEDURE_REF(BgL_envz00_16591, (int) (((long) 4)));
				{
					obj_t BgL_sz00_4676;

					BgL_sz00_4676 = BgL_sz00_16597;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4678;

						BgL_bpz00_4678 = VECTOR_REF(BgL_sz00_4676, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_4676,
							BgL_iboxesz00_16592, BgL_bpz00_4678);
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_4676,
							BgL_valza2za2_16594,
							((long) CINT(BgL_bpz00_4678) + BgL_siza7eza7_16593));
						{	/* Eval/evaluate_comp.scm 1049 */
							obj_t BgL_z12denvz12_4680;
							obj_t BgL_wherez00_4681;
							obj_t BgL_locz00_4682;

							BgL_z12denvz12_4680 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4681 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16595))->BgL_wherez00);
							BgL_locz00_4682 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16595))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1049 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4680, BgL_wherez00_4681,
									BgL_locz00_4682);
								{	/* Eval/evaluate_comp.scm 1049 */
									obj_t BgL_za2za2resza2za2z00_4683;

									BgL_za2za2resza2za2z00_4683 =
										PROCEDURE_ENTRY(BgL_bodyz00_16596) (BgL_bodyz00_16596,
										BgL_sz00_4676, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4680);
									return BgL_za2za2resza2za2z00_4683;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3518> */
	obj_t BGl_z62zc3anonymousza33518ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16598, obj_t BgL_sz00_16602)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_16599;
				obj_t BgL_bodyz00_16600;
				long BgL_siza7ezd2framez75_16601;

				BgL_i1252z00_16599 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16598, (int) (((long) 0))));
				BgL_bodyz00_16600 = PROCEDURE_REF(BgL_envz00_16598, (int) (((long) 1)));
				BgL_siza7ezd2framez75_16601 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16598, (int) (((long) 2))));
				{
					obj_t BgL_sz00_4317;

					BgL_sz00_4317 = BgL_sz00_16602;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4319;

						BgL_bpz00_4319 = VECTOR_REF(BgL_sz00_4317, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */

							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16210;

								BgL_runz00_16210 =
									MAKE_FX_PROCEDURE(BGl_z62run5486z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_runz00_16210,
									(int) (((long) 0)), ((obj_t) BgL_i1252z00_16599));
								PROCEDURE_SET(BgL_runz00_16210,
									(int) (((long) 1)), BgL_bodyz00_16600);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16211;

									BgL_mainz00_16211 =
										MAKE_FX_PROCEDURE(BGl_z62main5485z62zz__evaluate_compz00,
										(int) (((long) 3)), (int) (((long) 4)));
									PROCEDURE_SET(BgL_mainz00_16211,
										(int) (((long) 0)), ((obj_t) BgL_i1252z00_16599));
									PROCEDURE_SET(BgL_mainz00_16211,
										(int) (((long) 1)), BgL_bodyz00_16600);
									PROCEDURE_SET(BgL_mainz00_16211,
										(int) (((long) 2)), BgL_runz00_16210);
									PROCEDURE_SET(BgL_mainz00_16211,
										(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_16601));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_13493;

										BgL_objz00_13493 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16210, BgL_objz00_13493);
										BgL_objz00_13493;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3519z00_4322;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3520z00_4323;

											BgL_arg3520z00_4323 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16599))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_13497;

												BgL_newz00_13497 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_25578;

													BgL_auxz00_25578 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_13497, BgL_auxz00_25578,
														BgL_arg3520z00_4323);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_25583;
													int BgL_auxz00_25581;

													BgL_auxz00_25583 = BINT(BgL_siza7ezd2framez75_16601);
													BgL_auxz00_25581 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_13497, BgL_auxz00_25581,
														BgL_auxz00_25583);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_25586;

													BgL_auxz00_25586 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_13497, BgL_auxz00_25586,
														BgL_runz00_16210);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_25591;
													int BgL_auxz00_25589;

													BgL_auxz00_25591 = BINT(((long) 3));
													BgL_auxz00_25589 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_13497, BgL_auxz00_25589,
														BgL_auxz00_25591);
												}
												BgL_arg3519z00_4322 = BgL_newz00_13497;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16211, BgL_arg3519z00_4322);
										BgL_arg3519z00_4322;
									}
									return BgL_mainz00_16211;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5485 */
	obj_t BGl_z62main5485z62zz__evaluate_compz00(obj_t BgL_envz00_16603,
		obj_t BgL_bz00_16608, obj_t BgL_cz00_16609, obj_t BgL_dz00_16610)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16606;
				long BgL_siza7ezd2framez75_16607;

				BgL_runz00_16606 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16603, (int) (((long) 2))));
				BgL_siza7ezd2framez75_16607 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16603, (int) (((long) 3))));
				{
					obj_t BgL_bz00_4324;
					obj_t BgL_cz00_4325;
					obj_t BgL_dz00_4326;

					BgL_bz00_4324 = BgL_bz00_16608;
					BgL_cz00_4325 = BgL_cz00_16609;
					BgL_dz00_4326 = BgL_dz00_16610;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_4328;

						BgL_sz00_4328 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_4329;

							BgL_bpz00_4329 = VECTOR_REF(BgL_sz00_4328, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_25604;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_13419;

									BgL_arg1908z00_13419 = VECTOR_LENGTH(BgL_sz00_4328);
									BgL_testz00_25604 =
										(
										((long) CINT(BgL_bpz00_4329) +
											BgL_siza7ezd2framez75_16607) <
										(long) (BgL_arg1908z00_13419));
								}
								if (BgL_testz00_25604)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3523z00_4331;

											BgL_arg3523z00_4331 =
												((long) CINT(BgL_bpz00_4329) + ((long) 0));
											VECTOR_SET(BgL_sz00_4328,
												(int) (BgL_arg3523z00_4331), BgL_bz00_4324);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3524z00_4332;

											BgL_arg3524z00_4332 =
												((long) CINT(BgL_bpz00_4329) + ((long) 1));
											VECTOR_SET(BgL_sz00_4328,
												(int) (BgL_arg3524z00_4332), BgL_cz00_4325);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3525z00_4333;

											BgL_arg3525z00_4333 =
												((long) CINT(BgL_bpz00_4329) + ((long) 2));
											VECTOR_SET(BgL_sz00_4328,
												(int) (BgL_arg3525z00_4333), BgL_dz00_4326);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1423z00_4334;

											BgL_val1423z00_4334 =
												BGl_zc3exitza33529ze3z83zz__evaluate_compz00
												(BgL_bpz00_4329, BgL_sz00_4328, BgL_runz00_16606);
											VECTOR_SET(BgL_sz00_4328, (int) (((long) 0)),
												BgL_bpz00_4329);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1423z00_4334)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1423z00_4334), CDR(BgL_val1423z00_4334));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1423z00_4334;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_4341;

										BgL_nsz00_4341 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4341,
											(int) (((long) 1)), BgL_sz00_4328);
										VECTOR_SET(BgL_nsz00_4341,
											(int) (((long) 2)), BgL_bz00_4324);
										VECTOR_SET(BgL_nsz00_4341,
											(int) (((long) 3)), BgL_cz00_4325);
										VECTOR_SET(BgL_nsz00_4341,
											(int) (((long) 4)), BgL_dz00_4326);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_25640;

											BgL_auxz00_25640 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_25640, BgL_nsz00_4341);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1426z00_4343;

											BgL_val1426z00_4343 =
												BGl_zc3exitza33535ze3z83zz__evaluate_compz00
												(BgL_runz00_16606, BgL_nsz00_4341);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_25644;

												BgL_auxz00_25644 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_25644, BgL_sz00_4328);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1426z00_4343)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1426z00_4343), CDR(BgL_val1426z00_4343));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1426z00_4343;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3535> */
	obj_t BGl_zc3exitza33535ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17640,
		obj_t BgL_nsz00_17639)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1427z00_4349;

			if (SET_EXIT(BgL_an_exit1427z00_4349))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1427z00_4349 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1427z00_4349, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1428z00_4350;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_13465;

								BgL_savedzd2bpzd2_13465 =
									VECTOR_REF(BgL_nsz00_17639, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17639,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_13472;

									BgL_fz00_13472 = BgL_runz00_17640;
								BgL_recz00_13471:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_13473;

										BgL_rz00_13473 =
											PROCEDURE_ENTRY(BgL_fz00_13472) (BgL_fz00_13472,
											BgL_nsz00_17639, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_25665;

											if (PROCEDUREP(BgL_rz00_13473))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_13478;

													BgL_arg1900z00_13478 = PROCEDURE_ATTR(BgL_rz00_13473);
													if (STRUCTP(BgL_arg1900z00_13478))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_25665 =
																(STRUCT_KEY(BgL_arg1900z00_13478) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_25665 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_25665 = ((bool_t) 0);
												}
											if (BgL_testz00_25665)
												{
													obj_t BgL_fz00_25673;

													BgL_fz00_25673 = BgL_rz00_13473;
													BgL_fz00_13472 = BgL_fz00_25673;
													goto BgL_recz00_13471;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17639,
														(int) (((long) 0)), BgL_savedzd2bpzd2_13465);
													BgL_val1428z00_4350 = BgL_rz00_13473;
							}}}}}
							POP_EXIT();
							return BgL_val1428z00_4350;
						}
					}
				}
		}
	}



/* <exit:3529> */
	obj_t BGl_zc3exitza33529ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17643,
		obj_t BgL_sz00_17642, obj_t BgL_runz00_17641)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1424z00_4339;

			if (SET_EXIT(BgL_an_exit1424z00_4339))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1424z00_4339 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1424z00_4339, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1425z00_4340;

							BgL_val1425z00_4340 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17641,
								BgL_sz00_17642, BgL_bpz00_17643);
							POP_EXIT();
							return BgL_val1425z00_4340;
						}
					}
				}
		}
	}



/* &run5486 */
	obj_t BGl_z62run5486z62zz__evaluate_compz00(obj_t BgL_envz00_16611,
		obj_t BgL_sz00_16614)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_16612;
				obj_t BgL_bodyz00_16613;

				BgL_i1252z00_16612 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16611, (int) (((long) 0))));
				BgL_bodyz00_16613 = PROCEDURE_REF(BgL_envz00_16611, (int) (((long) 1)));
				{
					obj_t BgL_sz00_4352;

					BgL_sz00_4352 = BgL_sz00_16614;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4354;

						BgL_bpz00_4354 = VECTOR_REF(BgL_sz00_4352, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_z12denvz12_4355;
							obj_t BgL_wherez00_4356;
							obj_t BgL_locz00_4357;

							BgL_z12denvz12_4355 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4356 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16612))->BgL_wherez00);
							BgL_locz00_4357 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16612))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1129 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4355, BgL_wherez00_4356,
									BgL_locz00_4357);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_za2za2resza2za2z00_4358;

									BgL_za2za2resza2za2z00_4358 =
										PROCEDURE_ENTRY(BgL_bodyz00_16613) (BgL_bodyz00_16613,
										BgL_sz00_4352, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4355);
									return BgL_za2za2resza2za2z00_4358;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3537> */
	obj_t BGl_z62zc3anonymousza33537ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16615, obj_t BgL_sz00_16620)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_16616;
				BgL_ev_absz00_bglt BgL_i1252z00_16617;
				obj_t BgL_bodyz00_16618;
				long BgL_siza7ezd2framez75_16619;

				BgL_iboxesz00_16616 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16615, (int) (((long) 0))));
				BgL_i1252z00_16617 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16615, (int) (((long) 1))));
				BgL_bodyz00_16618 = PROCEDURE_REF(BgL_envz00_16615, (int) (((long) 2)));
				BgL_siza7ezd2framez75_16619 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16615, (int) (((long) 3))));
				{
					obj_t BgL_sz00_4360;

					BgL_sz00_4360 = BgL_sz00_16620;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4362;

						BgL_bpz00_4362 = VECTOR_REF(BgL_sz00_4360, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */

							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16207;

								BgL_runz00_16207 =
									MAKE_FX_PROCEDURE(BGl_z62run5488z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_runz00_16207,
									(int) (((long) 0)), BgL_iboxesz00_16616);
								PROCEDURE_SET(BgL_runz00_16207,
									(int) (((long) 1)), ((obj_t) BgL_i1252z00_16617));
								PROCEDURE_SET(BgL_runz00_16207,
									(int) (((long) 2)), BgL_bodyz00_16618);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16208;

									BgL_mainz00_16208 =
										MAKE_FX_PROCEDURE(BGl_z62main5487z62zz__evaluate_compz00,
										(int) (((long) 3)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_mainz00_16208,
										(int) (((long) 0)), BgL_iboxesz00_16616);
									PROCEDURE_SET(BgL_mainz00_16208,
										(int) (((long) 1)), ((obj_t) BgL_i1252z00_16617));
									PROCEDURE_SET(BgL_mainz00_16208,
										(int) (((long) 2)), BgL_bodyz00_16618);
									PROCEDURE_SET(BgL_mainz00_16208,
										(int) (((long) 3)), BgL_runz00_16207);
									PROCEDURE_SET(BgL_mainz00_16208,
										(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_16619));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_13602;

										BgL_objz00_13602 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16207, BgL_objz00_13602);
										BgL_objz00_13602;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3538z00_4365;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3539z00_4366;

											BgL_arg3539z00_4366 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16617))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_13606;

												BgL_newz00_13606 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_25740;

													BgL_auxz00_25740 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_13606, BgL_auxz00_25740,
														BgL_arg3539z00_4366);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_25745;
													int BgL_auxz00_25743;

													BgL_auxz00_25745 = BINT(BgL_siza7ezd2framez75_16619);
													BgL_auxz00_25743 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_13606, BgL_auxz00_25743,
														BgL_auxz00_25745);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_25748;

													BgL_auxz00_25748 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_13606, BgL_auxz00_25748,
														BgL_runz00_16207);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_25753;
													int BgL_auxz00_25751;

													BgL_auxz00_25753 = BINT(((long) 3));
													BgL_auxz00_25751 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_13606, BgL_auxz00_25751,
														BgL_auxz00_25753);
												}
												BgL_arg3538z00_4365 = BgL_newz00_13606;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16208, BgL_arg3538z00_4365);
										BgL_arg3538z00_4365;
									}
									return BgL_mainz00_16208;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5487 */
	obj_t BGl_z62main5487z62zz__evaluate_compz00(obj_t BgL_envz00_16621,
		obj_t BgL_bz00_16627, obj_t BgL_cz00_16628, obj_t BgL_dz00_16629)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16625;
				long BgL_siza7ezd2framez75_16626;

				BgL_runz00_16625 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16621, (int) (((long) 3))));
				BgL_siza7ezd2framez75_16626 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16621, (int) (((long) 4))));
				{
					obj_t BgL_bz00_4367;
					obj_t BgL_cz00_4368;
					obj_t BgL_dz00_4369;

					BgL_bz00_4367 = BgL_bz00_16627;
					BgL_cz00_4368 = BgL_cz00_16628;
					BgL_dz00_4369 = BgL_dz00_16629;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_4371;

						BgL_sz00_4371 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_4372;

							BgL_bpz00_4372 = VECTOR_REF(BgL_sz00_4371, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_25766;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_13528;

									BgL_arg1908z00_13528 = VECTOR_LENGTH(BgL_sz00_4371);
									BgL_testz00_25766 =
										(
										((long) CINT(BgL_bpz00_4372) +
											BgL_siza7ezd2framez75_16626) <
										(long) (BgL_arg1908z00_13528));
								}
								if (BgL_testz00_25766)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3542z00_4374;

											BgL_arg3542z00_4374 =
												((long) CINT(BgL_bpz00_4372) + ((long) 0));
											VECTOR_SET(BgL_sz00_4371,
												(int) (BgL_arg3542z00_4374), BgL_bz00_4367);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3543z00_4375;

											BgL_arg3543z00_4375 =
												((long) CINT(BgL_bpz00_4372) + ((long) 1));
											VECTOR_SET(BgL_sz00_4371,
												(int) (BgL_arg3543z00_4375), BgL_cz00_4368);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3544z00_4376;

											BgL_arg3544z00_4376 =
												((long) CINT(BgL_bpz00_4372) + ((long) 2));
											VECTOR_SET(BgL_sz00_4371,
												(int) (BgL_arg3544z00_4376), BgL_dz00_4369);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1429z00_4377;

											BgL_val1429z00_4377 =
												BGl_zc3exitza33548ze3z83zz__evaluate_compz00
												(BgL_bpz00_4372, BgL_sz00_4371, BgL_runz00_16625);
											VECTOR_SET(BgL_sz00_4371, (int) (((long) 0)),
												BgL_bpz00_4372);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1429z00_4377)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1429z00_4377), CDR(BgL_val1429z00_4377));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1429z00_4377;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_4384;

										BgL_nsz00_4384 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4384,
											(int) (((long) 1)), BgL_sz00_4371);
										VECTOR_SET(BgL_nsz00_4384,
											(int) (((long) 2)), BgL_bz00_4367);
										VECTOR_SET(BgL_nsz00_4384,
											(int) (((long) 3)), BgL_cz00_4368);
										VECTOR_SET(BgL_nsz00_4384,
											(int) (((long) 4)), BgL_dz00_4369);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_25802;

											BgL_auxz00_25802 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_25802, BgL_nsz00_4384);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1432z00_4386;

											BgL_val1432z00_4386 =
												BGl_zc3exitza33554ze3z83zz__evaluate_compz00
												(BgL_runz00_16625, BgL_nsz00_4384);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_25806;

												BgL_auxz00_25806 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_25806, BgL_sz00_4371);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1432z00_4386)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1432z00_4386), CDR(BgL_val1432z00_4386));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1432z00_4386;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3554> */
	obj_t BGl_zc3exitza33554ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17635,
		obj_t BgL_nsz00_17634)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1433z00_4392;

			if (SET_EXIT(BgL_an_exit1433z00_4392))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1433z00_4392 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1433z00_4392, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1434z00_4393;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_13574;

								BgL_savedzd2bpzd2_13574 =
									VECTOR_REF(BgL_nsz00_17634, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17634,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_13581;

									BgL_fz00_13581 = BgL_runz00_17635;
								BgL_recz00_13580:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_13582;

										BgL_rz00_13582 =
											PROCEDURE_ENTRY(BgL_fz00_13581) (BgL_fz00_13581,
											BgL_nsz00_17634, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_25827;

											if (PROCEDUREP(BgL_rz00_13582))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_13587;

													BgL_arg1900z00_13587 = PROCEDURE_ATTR(BgL_rz00_13582);
													if (STRUCTP(BgL_arg1900z00_13587))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_25827 =
																(STRUCT_KEY(BgL_arg1900z00_13587) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_25827 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_25827 = ((bool_t) 0);
												}
											if (BgL_testz00_25827)
												{
													obj_t BgL_fz00_25835;

													BgL_fz00_25835 = BgL_rz00_13582;
													BgL_fz00_13581 = BgL_fz00_25835;
													goto BgL_recz00_13580;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17634,
														(int) (((long) 0)), BgL_savedzd2bpzd2_13574);
													BgL_val1434z00_4393 = BgL_rz00_13582;
							}}}}}
							POP_EXIT();
							return BgL_val1434z00_4393;
						}
					}
				}
		}
	}



/* <exit:3548> */
	obj_t BGl_zc3exitza33548ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17638,
		obj_t BgL_sz00_17637, obj_t BgL_runz00_17636)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1430z00_4382;

			if (SET_EXIT(BgL_an_exit1430z00_4382))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1430z00_4382 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1430z00_4382, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1431z00_4383;

							BgL_val1431z00_4383 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17636,
								BgL_sz00_17637, BgL_bpz00_17638);
							POP_EXIT();
							return BgL_val1431z00_4383;
						}
					}
				}
		}
	}



/* &run5488 */
	obj_t BGl_z62run5488z62zz__evaluate_compz00(obj_t BgL_envz00_16630,
		obj_t BgL_sz00_16634)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_16631;
				BgL_ev_absz00_bglt BgL_i1252z00_16632;
				obj_t BgL_bodyz00_16633;

				BgL_iboxesz00_16631 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16630, (int) (((long) 0))));
				BgL_i1252z00_16632 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16630, (int) (((long) 1))));
				BgL_bodyz00_16633 = PROCEDURE_REF(BgL_envz00_16630, (int) (((long) 2)));
				{
					obj_t BgL_sz00_4395;

					BgL_sz00_4395 = BgL_sz00_16634;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4397;

						BgL_bpz00_4397 = VECTOR_REF(BgL_sz00_4395, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_4395,
							BgL_iboxesz00_16631, BgL_bpz00_4397);
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_z12denvz12_4398;
							obj_t BgL_wherez00_4399;
							obj_t BgL_locz00_4400;

							BgL_z12denvz12_4398 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4399 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16632))->BgL_wherez00);
							BgL_locz00_4400 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16632))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1129 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4398, BgL_wherez00_4399,
									BgL_locz00_4400);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_za2za2resza2za2z00_4401;

									BgL_za2za2resza2za2z00_4401 =
										PROCEDURE_ENTRY(BgL_bodyz00_16633) (BgL_bodyz00_16633,
										BgL_sz00_4395, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4398);
									return BgL_za2za2resza2za2z00_4401;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3558> */
	obj_t BGl_z62zc3anonymousza33558ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16635, obj_t BgL_sz00_16641)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_ifreesz00_16636;
				long BgL_siza7eza7_16637;
				BgL_ev_absz00_bglt BgL_i1252z00_16638;
				obj_t BgL_bodyz00_16639;
				long BgL_siza7ezd2framez75_16640;

				BgL_ifreesz00_16636 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16635, (int) (((long) 0))));
				BgL_siza7eza7_16637 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16635, (int) (((long) 1))));
				BgL_i1252z00_16638 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16635, (int) (((long) 2))));
				BgL_bodyz00_16639 = PROCEDURE_REF(BgL_envz00_16635, (int) (((long) 3)));
				BgL_siza7ezd2framez75_16640 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16635, (int) (((long) 4))));
				{
					obj_t BgL_sz00_4405;

					BgL_sz00_4405 = BgL_sz00_16641;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4407;

						BgL_bpz00_4407 = VECTOR_REF(BgL_sz00_4405, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_valza2za2_4408;

							BgL_valza2za2_4408 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_4405,
								BgL_bpz00_4407, BgL_ifreesz00_16636);
							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16204;

								BgL_runz00_16204 =
									MAKE_FX_PROCEDURE(BGl_z62run5490z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_runz00_16204,
									(int) (((long) 0)), BINT(BgL_siza7eza7_16637));
								PROCEDURE_SET(BgL_runz00_16204,
									(int) (((long) 1)), BgL_valza2za2_4408);
								PROCEDURE_SET(BgL_runz00_16204,
									(int) (((long) 2)), ((obj_t) BgL_i1252z00_16638));
								PROCEDURE_SET(BgL_runz00_16204,
									(int) (((long) 3)), BgL_bodyz00_16639);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16205;

									BgL_mainz00_16205 =
										MAKE_FX_PROCEDURE(BGl_z62main5489z62zz__evaluate_compz00,
										(int) (((long) 3)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_mainz00_16205,
										(int) (((long) 0)), BINT(BgL_siza7eza7_16637));
									PROCEDURE_SET(BgL_mainz00_16205,
										(int) (((long) 1)), BgL_valza2za2_4408);
									PROCEDURE_SET(BgL_mainz00_16205,
										(int) (((long) 2)), ((obj_t) BgL_i1252z00_16638));
									PROCEDURE_SET(BgL_mainz00_16205,
										(int) (((long) 3)), BgL_bodyz00_16639);
									PROCEDURE_SET(BgL_mainz00_16205,
										(int) (((long) 4)), BgL_runz00_16204);
									PROCEDURE_SET(BgL_mainz00_16205,
										(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_16640));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_13718;

										BgL_objz00_13718 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16204, BgL_objz00_13718);
										BgL_objz00_13718;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3559z00_4411;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3560z00_4412;

											BgL_arg3560z00_4412 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16638))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_13722;

												BgL_newz00_13722 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_25916;

													BgL_auxz00_25916 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_13722, BgL_auxz00_25916,
														BgL_arg3560z00_4412);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_25921;
													int BgL_auxz00_25919;

													BgL_auxz00_25921 = BINT(BgL_siza7ezd2framez75_16640);
													BgL_auxz00_25919 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_13722, BgL_auxz00_25919,
														BgL_auxz00_25921);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_25924;

													BgL_auxz00_25924 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_13722, BgL_auxz00_25924,
														BgL_runz00_16204);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_25929;
													int BgL_auxz00_25927;

													BgL_auxz00_25929 = BINT(((long) 3));
													BgL_auxz00_25927 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_13722, BgL_auxz00_25927,
														BgL_auxz00_25929);
												}
												BgL_arg3559z00_4411 = BgL_newz00_13722;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16205, BgL_arg3559z00_4411);
										BgL_arg3559z00_4411;
									}
									return BgL_mainz00_16205;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5489 */
	obj_t BGl_z62main5489z62zz__evaluate_compz00(obj_t BgL_envz00_16642,
		obj_t BgL_bz00_16649, obj_t BgL_cz00_16650, obj_t BgL_dz00_16651)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16647;
				long BgL_siza7ezd2framez75_16648;

				BgL_runz00_16647 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16642, (int) (((long) 4))));
				BgL_siza7ezd2framez75_16648 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16642, (int) (((long) 5))));
				{
					obj_t BgL_bz00_4413;
					obj_t BgL_cz00_4414;
					obj_t BgL_dz00_4415;

					BgL_bz00_4413 = BgL_bz00_16649;
					BgL_cz00_4414 = BgL_cz00_16650;
					BgL_dz00_4415 = BgL_dz00_16651;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_4417;

						BgL_sz00_4417 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_4418;

							BgL_bpz00_4418 = VECTOR_REF(BgL_sz00_4417, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_25942;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_13644;

									BgL_arg1908z00_13644 = VECTOR_LENGTH(BgL_sz00_4417);
									BgL_testz00_25942 =
										(
										((long) CINT(BgL_bpz00_4418) +
											BgL_siza7ezd2framez75_16648) <
										(long) (BgL_arg1908z00_13644));
								}
								if (BgL_testz00_25942)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3563z00_4420;

											BgL_arg3563z00_4420 =
												((long) CINT(BgL_bpz00_4418) + ((long) 0));
											VECTOR_SET(BgL_sz00_4417,
												(int) (BgL_arg3563z00_4420), BgL_bz00_4413);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3564z00_4421;

											BgL_arg3564z00_4421 =
												((long) CINT(BgL_bpz00_4418) + ((long) 1));
											VECTOR_SET(BgL_sz00_4417,
												(int) (BgL_arg3564z00_4421), BgL_cz00_4414);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3565z00_4422;

											BgL_arg3565z00_4422 =
												((long) CINT(BgL_bpz00_4418) + ((long) 2));
											VECTOR_SET(BgL_sz00_4417,
												(int) (BgL_arg3565z00_4422), BgL_dz00_4415);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1435z00_4423;

											BgL_val1435z00_4423 =
												BGl_zc3exitza33569ze3z83zz__evaluate_compz00
												(BgL_bpz00_4418, BgL_sz00_4417, BgL_runz00_16647);
											VECTOR_SET(BgL_sz00_4417, (int) (((long) 0)),
												BgL_bpz00_4418);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1435z00_4423)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1435z00_4423), CDR(BgL_val1435z00_4423));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1435z00_4423;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_4430;

										BgL_nsz00_4430 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4430,
											(int) (((long) 1)), BgL_sz00_4417);
										VECTOR_SET(BgL_nsz00_4430,
											(int) (((long) 2)), BgL_bz00_4413);
										VECTOR_SET(BgL_nsz00_4430,
											(int) (((long) 3)), BgL_cz00_4414);
										VECTOR_SET(BgL_nsz00_4430,
											(int) (((long) 4)), BgL_dz00_4415);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_25978;

											BgL_auxz00_25978 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_25978, BgL_nsz00_4430);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1438z00_4432;

											BgL_val1438z00_4432 =
												BGl_zc3exitza33575ze3z83zz__evaluate_compz00
												(BgL_runz00_16647, BgL_nsz00_4430);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_25982;

												BgL_auxz00_25982 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_25982, BgL_sz00_4417);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1438z00_4432)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1438z00_4432), CDR(BgL_val1438z00_4432));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1438z00_4432;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3575> */
	obj_t BGl_zc3exitza33575ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17630,
		obj_t BgL_nsz00_17629)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1439z00_4438;

			if (SET_EXIT(BgL_an_exit1439z00_4438))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1439z00_4438 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1439z00_4438, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1440z00_4439;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_13690;

								BgL_savedzd2bpzd2_13690 =
									VECTOR_REF(BgL_nsz00_17629, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17629,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_13697;

									BgL_fz00_13697 = BgL_runz00_17630;
								BgL_recz00_13696:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_13698;

										BgL_rz00_13698 =
											PROCEDURE_ENTRY(BgL_fz00_13697) (BgL_fz00_13697,
											BgL_nsz00_17629, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_26003;

											if (PROCEDUREP(BgL_rz00_13698))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_13703;

													BgL_arg1900z00_13703 = PROCEDURE_ATTR(BgL_rz00_13698);
													if (STRUCTP(BgL_arg1900z00_13703))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_26003 =
																(STRUCT_KEY(BgL_arg1900z00_13703) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_26003 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_26003 = ((bool_t) 0);
												}
											if (BgL_testz00_26003)
												{
													obj_t BgL_fz00_26011;

													BgL_fz00_26011 = BgL_rz00_13698;
													BgL_fz00_13697 = BgL_fz00_26011;
													goto BgL_recz00_13696;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17629,
														(int) (((long) 0)), BgL_savedzd2bpzd2_13690);
													BgL_val1440z00_4439 = BgL_rz00_13698;
							}}}}}
							POP_EXIT();
							return BgL_val1440z00_4439;
						}
					}
				}
		}
	}



/* <exit:3569> */
	obj_t BGl_zc3exitza33569ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17633,
		obj_t BgL_sz00_17632, obj_t BgL_runz00_17631)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1436z00_4428;

			if (SET_EXIT(BgL_an_exit1436z00_4428))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1436z00_4428 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1436z00_4428, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1437z00_4429;

							BgL_val1437z00_4429 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17631,
								BgL_sz00_17632, BgL_bpz00_17633);
							POP_EXIT();
							return BgL_val1437z00_4429;
						}
					}
				}
		}
	}



/* &run5490 */
	obj_t BGl_z62run5490z62zz__evaluate_compz00(obj_t BgL_envz00_16652,
		obj_t BgL_sz00_16657)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				long BgL_siza7eza7_16653;
				obj_t BgL_valza2za2_16654;
				BgL_ev_absz00_bglt BgL_i1252z00_16655;
				obj_t BgL_bodyz00_16656;

				BgL_siza7eza7_16653 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16652, (int) (((long) 0))));
				BgL_valza2za2_16654 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16652, (int) (((long) 1))));
				BgL_i1252z00_16655 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16652, (int) (((long) 2))));
				BgL_bodyz00_16656 = PROCEDURE_REF(BgL_envz00_16652, (int) (((long) 3)));
				{
					obj_t BgL_sz00_4441;

					BgL_sz00_4441 = BgL_sz00_16657;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4443;

						BgL_bpz00_4443 = VECTOR_REF(BgL_sz00_4441, (int) (((long) 0)));
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_4441,
							BgL_valza2za2_16654,
							((long) CINT(BgL_bpz00_4443) + BgL_siza7eza7_16653));
						{	/* Eval/evaluate_comp.scm 1049 */
							obj_t BgL_z12denvz12_4445;
							obj_t BgL_wherez00_4446;
							obj_t BgL_locz00_4447;

							BgL_z12denvz12_4445 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4446 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16655))->BgL_wherez00);
							BgL_locz00_4447 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16655))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1049 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4445, BgL_wherez00_4446,
									BgL_locz00_4447);
								{	/* Eval/evaluate_comp.scm 1049 */
									obj_t BgL_za2za2resza2za2z00_4448;

									BgL_za2za2resza2za2z00_4448 =
										PROCEDURE_ENTRY(BgL_bodyz00_16656) (BgL_bodyz00_16656,
										BgL_sz00_4441, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4445);
									return BgL_za2za2resza2za2z00_4448;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3578> */
	obj_t BGl_z62zc3anonymousza33578ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16658, obj_t BgL_sz00_16665)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_ifreesz00_16659;
				obj_t BgL_iboxesz00_16660;
				long BgL_siza7eza7_16661;
				BgL_ev_absz00_bglt BgL_i1252z00_16662;
				obj_t BgL_bodyz00_16663;
				long BgL_siza7ezd2framez75_16664;

				BgL_ifreesz00_16659 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16658, (int) (((long) 0))));
				BgL_iboxesz00_16660 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16658, (int) (((long) 1))));
				BgL_siza7eza7_16661 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16658, (int) (((long) 2))));
				BgL_i1252z00_16662 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16658, (int) (((long) 3))));
				BgL_bodyz00_16663 = PROCEDURE_REF(BgL_envz00_16658, (int) (((long) 4)));
				BgL_siza7ezd2framez75_16664 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16658, (int) (((long) 5))));
				{
					obj_t BgL_sz00_4450;

					BgL_sz00_4450 = BgL_sz00_16665;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4452;

						BgL_bpz00_4452 = VECTOR_REF(BgL_sz00_4450, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_valza2za2_4453;

							BgL_valza2za2_4453 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_4450,
								BgL_bpz00_4452, BgL_ifreesz00_16659);
							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16201;

								BgL_runz00_16201 =
									MAKE_FX_PROCEDURE(BGl_z62run5492z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_runz00_16201,
									(int) (((long) 0)), BgL_iboxesz00_16660);
								PROCEDURE_SET(BgL_runz00_16201,
									(int) (((long) 1)), BINT(BgL_siza7eza7_16661));
								PROCEDURE_SET(BgL_runz00_16201,
									(int) (((long) 2)), BgL_valza2za2_4453);
								PROCEDURE_SET(BgL_runz00_16201,
									(int) (((long) 3)), ((obj_t) BgL_i1252z00_16662));
								PROCEDURE_SET(BgL_runz00_16201,
									(int) (((long) 4)), BgL_bodyz00_16663);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16202;

									BgL_mainz00_16202 =
										MAKE_FX_PROCEDURE(BGl_z62main5491z62zz__evaluate_compz00,
										(int) (((long) 3)), (int) (((long) 7)));
									PROCEDURE_SET(BgL_mainz00_16202,
										(int) (((long) 0)), BgL_iboxesz00_16660);
									PROCEDURE_SET(BgL_mainz00_16202,
										(int) (((long) 1)), BINT(BgL_siza7eza7_16661));
									PROCEDURE_SET(BgL_mainz00_16202,
										(int) (((long) 2)), BgL_valza2za2_4453);
									PROCEDURE_SET(BgL_mainz00_16202,
										(int) (((long) 3)), ((obj_t) BgL_i1252z00_16662));
									PROCEDURE_SET(BgL_mainz00_16202,
										(int) (((long) 4)), BgL_bodyz00_16663);
									PROCEDURE_SET(BgL_mainz00_16202,
										(int) (((long) 5)), BgL_runz00_16201);
									PROCEDURE_SET(BgL_mainz00_16202,
										(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_16664));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_13830;

										BgL_objz00_13830 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16201, BgL_objz00_13830);
										BgL_objz00_13830;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3579z00_4456;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3580z00_4457;

											BgL_arg3580z00_4457 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16662))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_13834;

												BgL_newz00_13834 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_26104;

													BgL_auxz00_26104 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_13834, BgL_auxz00_26104,
														BgL_arg3580z00_4457);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_26109;
													int BgL_auxz00_26107;

													BgL_auxz00_26109 = BINT(BgL_siza7ezd2framez75_16664);
													BgL_auxz00_26107 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_13834, BgL_auxz00_26107,
														BgL_auxz00_26109);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_26112;

													BgL_auxz00_26112 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_13834, BgL_auxz00_26112,
														BgL_runz00_16201);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_26117;
													int BgL_auxz00_26115;

													BgL_auxz00_26117 = BINT(((long) 3));
													BgL_auxz00_26115 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_13834, BgL_auxz00_26115,
														BgL_auxz00_26117);
												}
												BgL_arg3579z00_4456 = BgL_newz00_13834;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16202, BgL_arg3579z00_4456);
										BgL_arg3579z00_4456;
									}
									return BgL_mainz00_16202;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5491 */
	obj_t BGl_z62main5491z62zz__evaluate_compz00(obj_t BgL_envz00_16666,
		obj_t BgL_bz00_16674, obj_t BgL_cz00_16675, obj_t BgL_dz00_16676)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16672;
				long BgL_siza7ezd2framez75_16673;

				BgL_runz00_16672 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16666, (int) (((long) 5))));
				BgL_siza7ezd2framez75_16673 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16666, (int) (((long) 6))));
				{
					obj_t BgL_bz00_4458;
					obj_t BgL_cz00_4459;
					obj_t BgL_dz00_4460;

					BgL_bz00_4458 = BgL_bz00_16674;
					BgL_cz00_4459 = BgL_cz00_16675;
					BgL_dz00_4460 = BgL_dz00_16676;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_4462;

						BgL_sz00_4462 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_4463;

							BgL_bpz00_4463 = VECTOR_REF(BgL_sz00_4462, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_26130;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_13756;

									BgL_arg1908z00_13756 = VECTOR_LENGTH(BgL_sz00_4462);
									BgL_testz00_26130 =
										(
										((long) CINT(BgL_bpz00_4463) +
											BgL_siza7ezd2framez75_16673) <
										(long) (BgL_arg1908z00_13756));
								}
								if (BgL_testz00_26130)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3583z00_4465;

											BgL_arg3583z00_4465 =
												((long) CINT(BgL_bpz00_4463) + ((long) 0));
											VECTOR_SET(BgL_sz00_4462,
												(int) (BgL_arg3583z00_4465), BgL_bz00_4458);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3584z00_4466;

											BgL_arg3584z00_4466 =
												((long) CINT(BgL_bpz00_4463) + ((long) 1));
											VECTOR_SET(BgL_sz00_4462,
												(int) (BgL_arg3584z00_4466), BgL_cz00_4459);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3585z00_4467;

											BgL_arg3585z00_4467 =
												((long) CINT(BgL_bpz00_4463) + ((long) 2));
											VECTOR_SET(BgL_sz00_4462,
												(int) (BgL_arg3585z00_4467), BgL_dz00_4460);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1441z00_4468;

											BgL_val1441z00_4468 =
												BGl_zc3exitza33589ze3z83zz__evaluate_compz00
												(BgL_bpz00_4463, BgL_sz00_4462, BgL_runz00_16672);
											VECTOR_SET(BgL_sz00_4462, (int) (((long) 0)),
												BgL_bpz00_4463);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1441z00_4468)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1441z00_4468), CDR(BgL_val1441z00_4468));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1441z00_4468;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_4475;

										BgL_nsz00_4475 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4475,
											(int) (((long) 1)), BgL_sz00_4462);
										VECTOR_SET(BgL_nsz00_4475,
											(int) (((long) 2)), BgL_bz00_4458);
										VECTOR_SET(BgL_nsz00_4475,
											(int) (((long) 3)), BgL_cz00_4459);
										VECTOR_SET(BgL_nsz00_4475,
											(int) (((long) 4)), BgL_dz00_4460);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_26166;

											BgL_auxz00_26166 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_26166, BgL_nsz00_4475);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1444z00_4477;

											BgL_val1444z00_4477 =
												BGl_zc3exitza33595ze3z83zz__evaluate_compz00
												(BgL_runz00_16672, BgL_nsz00_4475);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_26170;

												BgL_auxz00_26170 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_26170, BgL_sz00_4462);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1444z00_4477)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1444z00_4477), CDR(BgL_val1444z00_4477));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1444z00_4477;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3595> */
	obj_t BGl_zc3exitza33595ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17625,
		obj_t BgL_nsz00_17624)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1445z00_4483;

			if (SET_EXIT(BgL_an_exit1445z00_4483))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1445z00_4483 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1445z00_4483, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1446z00_4484;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_13802;

								BgL_savedzd2bpzd2_13802 =
									VECTOR_REF(BgL_nsz00_17624, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17624,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_13809;

									BgL_fz00_13809 = BgL_runz00_17625;
								BgL_recz00_13808:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_13810;

										BgL_rz00_13810 =
											PROCEDURE_ENTRY(BgL_fz00_13809) (BgL_fz00_13809,
											BgL_nsz00_17624, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_26191;

											if (PROCEDUREP(BgL_rz00_13810))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_13815;

													BgL_arg1900z00_13815 = PROCEDURE_ATTR(BgL_rz00_13810);
													if (STRUCTP(BgL_arg1900z00_13815))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_26191 =
																(STRUCT_KEY(BgL_arg1900z00_13815) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_26191 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_26191 = ((bool_t) 0);
												}
											if (BgL_testz00_26191)
												{
													obj_t BgL_fz00_26199;

													BgL_fz00_26199 = BgL_rz00_13810;
													BgL_fz00_13809 = BgL_fz00_26199;
													goto BgL_recz00_13808;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17624,
														(int) (((long) 0)), BgL_savedzd2bpzd2_13802);
													BgL_val1446z00_4484 = BgL_rz00_13810;
							}}}}}
							POP_EXIT();
							return BgL_val1446z00_4484;
						}
					}
				}
		}
	}



/* <exit:3589> */
	obj_t BGl_zc3exitza33589ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17628,
		obj_t BgL_sz00_17627, obj_t BgL_runz00_17626)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1442z00_4473;

			if (SET_EXIT(BgL_an_exit1442z00_4473))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1442z00_4473 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1442z00_4473, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1443z00_4474;

							BgL_val1443z00_4474 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17626,
								BgL_sz00_17627, BgL_bpz00_17628);
							POP_EXIT();
							return BgL_val1443z00_4474;
						}
					}
				}
		}
	}



/* &run5492 */
	obj_t BGl_z62run5492z62zz__evaluate_compz00(obj_t BgL_envz00_16677,
		obj_t BgL_sz00_16683)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_16678;
				long BgL_siza7eza7_16679;
				obj_t BgL_valza2za2_16680;
				BgL_ev_absz00_bglt BgL_i1252z00_16681;
				obj_t BgL_bodyz00_16682;

				BgL_iboxesz00_16678 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16677, (int) (((long) 0))));
				BgL_siza7eza7_16679 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16677, (int) (((long) 1))));
				BgL_valza2za2_16680 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16677, (int) (((long) 2))));
				BgL_i1252z00_16681 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16677, (int) (((long) 3))));
				BgL_bodyz00_16682 = PROCEDURE_REF(BgL_envz00_16677, (int) (((long) 4)));
				{
					obj_t BgL_sz00_4486;

					BgL_sz00_4486 = BgL_sz00_16683;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4488;

						BgL_bpz00_4488 = VECTOR_REF(BgL_sz00_4486, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_4486,
							BgL_iboxesz00_16678, BgL_bpz00_4488);
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_4486,
							BgL_valza2za2_16680,
							((long) CINT(BgL_bpz00_4488) + BgL_siza7eza7_16679));
						{	/* Eval/evaluate_comp.scm 1049 */
							obj_t BgL_z12denvz12_4490;
							obj_t BgL_wherez00_4491;
							obj_t BgL_locz00_4492;

							BgL_z12denvz12_4490 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4491 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16681))->BgL_wherez00);
							BgL_locz00_4492 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16681))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1049 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4490, BgL_wherez00_4491,
									BgL_locz00_4492);
								{	/* Eval/evaluate_comp.scm 1049 */
									obj_t BgL_za2za2resza2za2z00_4493;

									BgL_za2za2resza2za2z00_4493 =
										PROCEDURE_ENTRY(BgL_bodyz00_16682) (BgL_bodyz00_16682,
										BgL_sz00_4486, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4490);
									return BgL_za2za2resza2za2z00_4493;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3434> */
	obj_t BGl_z62zc3anonymousza33434ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16684, obj_t BgL_sz00_16688)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_16685;
				obj_t BgL_bodyz00_16686;
				long BgL_siza7ezd2framez75_16687;

				BgL_i1252z00_16685 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16684, (int) (((long) 0))));
				BgL_bodyz00_16686 = PROCEDURE_REF(BgL_envz00_16684, (int) (((long) 1)));
				BgL_siza7ezd2framez75_16687 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16684, (int) (((long) 2))));
				{
					obj_t BgL_sz00_4135;

					BgL_sz00_4135 = BgL_sz00_16688;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4137;

						BgL_bpz00_4137 = VECTOR_REF(BgL_sz00_4135, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */

							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16198;

								BgL_runz00_16198 =
									MAKE_FX_PROCEDURE(BGl_z62run5494z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_runz00_16198,
									(int) (((long) 0)), ((obj_t) BgL_i1252z00_16685));
								PROCEDURE_SET(BgL_runz00_16198,
									(int) (((long) 1)), BgL_bodyz00_16686);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16199;

									BgL_mainz00_16199 =
										MAKE_VA_PROCEDURE(BGl_z62main5493z62zz__evaluate_compz00,
										(int) (((long) -3)), (int) (((long) 4)));
									PROCEDURE_SET(BgL_mainz00_16199,
										(int) (((long) 0)), ((obj_t) BgL_i1252z00_16685));
									PROCEDURE_SET(BgL_mainz00_16199,
										(int) (((long) 1)), BgL_bodyz00_16686);
									PROCEDURE_SET(BgL_mainz00_16199,
										(int) (((long) 2)), BgL_runz00_16198);
									PROCEDURE_SET(BgL_mainz00_16199,
										(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_16687));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_13039;

										BgL_objz00_13039 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16198, BgL_objz00_13039);
										BgL_objz00_13039;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3435z00_4140;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3436z00_4141;

											BgL_arg3436z00_4141 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16685))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_13043;

												BgL_newz00_13043 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_26272;

													BgL_auxz00_26272 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_13043, BgL_auxz00_26272,
														BgL_arg3436z00_4141);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_26277;
													int BgL_auxz00_26275;

													BgL_auxz00_26277 = BINT(BgL_siza7ezd2framez75_16687);
													BgL_auxz00_26275 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_13043, BgL_auxz00_26275,
														BgL_auxz00_26277);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_26280;

													BgL_auxz00_26280 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_13043, BgL_auxz00_26280,
														BgL_runz00_16198);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_26285;
													int BgL_auxz00_26283;

													BgL_auxz00_26285 = BINT(((long) -3));
													BgL_auxz00_26283 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_13043, BgL_auxz00_26283,
														BgL_auxz00_26285);
												}
												BgL_arg3435z00_4140 = BgL_newz00_13043;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16199, BgL_arg3435z00_4140);
										BgL_arg3435z00_4140;
									}
									return BgL_mainz00_16199;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5493 */
	obj_t BGl_z62main5493z62zz__evaluate_compz00(obj_t BgL_envz00_16689,
		obj_t BgL_cz00_16694, obj_t BgL_dz00_16695, obj_t BgL_lastz00_16696)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16692;
				long BgL_siza7ezd2framez75_16693;

				BgL_runz00_16692 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16689, (int) (((long) 2))));
				BgL_siza7ezd2framez75_16693 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16689, (int) (((long) 3))));
				{
					obj_t BgL_cz00_4142;
					obj_t BgL_dz00_4143;
					obj_t BgL_lastz00_4144;

					BgL_cz00_4142 = BgL_cz00_16694;
					BgL_dz00_4143 = BgL_dz00_16695;
					BgL_lastz00_4144 = BgL_lastz00_16696;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_4146;

						BgL_sz00_4146 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_4147;

							BgL_bpz00_4147 = VECTOR_REF(BgL_sz00_4146, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_26298;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_12965;

									BgL_arg1908z00_12965 = VECTOR_LENGTH(BgL_sz00_4146);
									BgL_testz00_26298 =
										(
										((long) CINT(BgL_bpz00_4147) +
											BgL_siza7ezd2framez75_16693) <
										(long) (BgL_arg1908z00_12965));
								}
								if (BgL_testz00_26298)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3439z00_4149;

											BgL_arg3439z00_4149 =
												((long) CINT(BgL_bpz00_4147) + ((long) 0));
											VECTOR_SET(BgL_sz00_4146,
												(int) (BgL_arg3439z00_4149), BgL_cz00_4142);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3440z00_4150;

											BgL_arg3440z00_4150 =
												((long) CINT(BgL_bpz00_4147) + ((long) 1));
											VECTOR_SET(BgL_sz00_4146,
												(int) (BgL_arg3440z00_4150), BgL_dz00_4143);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3441z00_4151;

											BgL_arg3441z00_4151 =
												((long) CINT(BgL_bpz00_4147) + ((long) 2));
											VECTOR_SET(BgL_sz00_4146,
												(int) (BgL_arg3441z00_4151), BgL_lastz00_4144);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1399z00_4152;

											BgL_val1399z00_4152 =
												BGl_zc3exitza33445ze3z83zz__evaluate_compz00
												(BgL_bpz00_4147, BgL_sz00_4146, BgL_runz00_16692);
											VECTOR_SET(BgL_sz00_4146, (int) (((long) 0)),
												BgL_bpz00_4147);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1399z00_4152)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1399z00_4152), CDR(BgL_val1399z00_4152));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1399z00_4152;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_4159;

										BgL_nsz00_4159 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4159,
											(int) (((long) 1)), BgL_sz00_4146);
										VECTOR_SET(BgL_nsz00_4159,
											(int) (((long) 2)), BgL_cz00_4142);
										VECTOR_SET(BgL_nsz00_4159,
											(int) (((long) 3)), BgL_dz00_4143);
										VECTOR_SET(BgL_nsz00_4159,
											(int) (((long) 4)), BgL_lastz00_4144);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_26334;

											BgL_auxz00_26334 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_26334, BgL_nsz00_4159);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1402z00_4161;

											BgL_val1402z00_4161 =
												BGl_zc3exitza33451ze3z83zz__evaluate_compz00
												(BgL_runz00_16692, BgL_nsz00_4159);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_26338;

												BgL_auxz00_26338 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_26338, BgL_sz00_4146);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1402z00_4161)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1402z00_4161), CDR(BgL_val1402z00_4161));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1402z00_4161;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3451> */
	obj_t BGl_zc3exitza33451ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17620,
		obj_t BgL_nsz00_17619)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1403z00_4167;

			if (SET_EXIT(BgL_an_exit1403z00_4167))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1403z00_4167 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1403z00_4167, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1404z00_4168;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_13011;

								BgL_savedzd2bpzd2_13011 =
									VECTOR_REF(BgL_nsz00_17619, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17619,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_13018;

									BgL_fz00_13018 = BgL_runz00_17620;
								BgL_recz00_13017:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_13019;

										BgL_rz00_13019 =
											PROCEDURE_ENTRY(BgL_fz00_13018) (BgL_fz00_13018,
											BgL_nsz00_17619, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_26359;

											if (PROCEDUREP(BgL_rz00_13019))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_13024;

													BgL_arg1900z00_13024 = PROCEDURE_ATTR(BgL_rz00_13019);
													if (STRUCTP(BgL_arg1900z00_13024))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_26359 =
																(STRUCT_KEY(BgL_arg1900z00_13024) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_26359 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_26359 = ((bool_t) 0);
												}
											if (BgL_testz00_26359)
												{
													obj_t BgL_fz00_26367;

													BgL_fz00_26367 = BgL_rz00_13019;
													BgL_fz00_13018 = BgL_fz00_26367;
													goto BgL_recz00_13017;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17619,
														(int) (((long) 0)), BgL_savedzd2bpzd2_13011);
													BgL_val1404z00_4168 = BgL_rz00_13019;
							}}}}}
							POP_EXIT();
							return BgL_val1404z00_4168;
						}
					}
				}
		}
	}



/* <exit:3445> */
	obj_t BGl_zc3exitza33445ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17623,
		obj_t BgL_sz00_17622, obj_t BgL_runz00_17621)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1400z00_4157;

			if (SET_EXIT(BgL_an_exit1400z00_4157))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1400z00_4157 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1400z00_4157, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1401z00_4158;

							BgL_val1401z00_4158 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17621,
								BgL_sz00_17622, BgL_bpz00_17623);
							POP_EXIT();
							return BgL_val1401z00_4158;
						}
					}
				}
		}
	}



/* &run5494 */
	obj_t BGl_z62run5494z62zz__evaluate_compz00(obj_t BgL_envz00_16697,
		obj_t BgL_sz00_16700)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_16698;
				obj_t BgL_bodyz00_16699;

				BgL_i1252z00_16698 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16697, (int) (((long) 0))));
				BgL_bodyz00_16699 = PROCEDURE_REF(BgL_envz00_16697, (int) (((long) 1)));
				{
					obj_t BgL_sz00_4170;

					BgL_sz00_4170 = BgL_sz00_16700;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4172;

						BgL_bpz00_4172 = VECTOR_REF(BgL_sz00_4170, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_z12denvz12_4173;
							obj_t BgL_wherez00_4174;
							obj_t BgL_locz00_4175;

							BgL_z12denvz12_4173 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4174 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16698))->BgL_wherez00);
							BgL_locz00_4175 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16698))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1129 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4173, BgL_wherez00_4174,
									BgL_locz00_4175);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_za2za2resza2za2z00_4176;

									BgL_za2za2resza2za2z00_4176 =
										PROCEDURE_ENTRY(BgL_bodyz00_16699) (BgL_bodyz00_16699,
										BgL_sz00_4170, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4173);
									return BgL_za2za2resza2za2z00_4176;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3453> */
	obj_t BGl_z62zc3anonymousza33453ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16701, obj_t BgL_sz00_16706)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_16702;
				BgL_ev_absz00_bglt BgL_i1252z00_16703;
				obj_t BgL_bodyz00_16704;
				long BgL_siza7ezd2framez75_16705;

				BgL_iboxesz00_16702 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16701, (int) (((long) 0))));
				BgL_i1252z00_16703 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16701, (int) (((long) 1))));
				BgL_bodyz00_16704 = PROCEDURE_REF(BgL_envz00_16701, (int) (((long) 2)));
				BgL_siza7ezd2framez75_16705 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16701, (int) (((long) 3))));
				{
					obj_t BgL_sz00_4178;

					BgL_sz00_4178 = BgL_sz00_16706;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4180;

						BgL_bpz00_4180 = VECTOR_REF(BgL_sz00_4178, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */

							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16195;

								BgL_runz00_16195 =
									MAKE_FX_PROCEDURE(BGl_z62run5496z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_runz00_16195,
									(int) (((long) 0)), BgL_iboxesz00_16702);
								PROCEDURE_SET(BgL_runz00_16195,
									(int) (((long) 1)), ((obj_t) BgL_i1252z00_16703));
								PROCEDURE_SET(BgL_runz00_16195,
									(int) (((long) 2)), BgL_bodyz00_16704);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16196;

									BgL_mainz00_16196 =
										MAKE_VA_PROCEDURE(BGl_z62main5495z62zz__evaluate_compz00,
										(int) (((long) -3)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_mainz00_16196,
										(int) (((long) 0)), BgL_iboxesz00_16702);
									PROCEDURE_SET(BgL_mainz00_16196,
										(int) (((long) 1)), ((obj_t) BgL_i1252z00_16703));
									PROCEDURE_SET(BgL_mainz00_16196,
										(int) (((long) 2)), BgL_bodyz00_16704);
									PROCEDURE_SET(BgL_mainz00_16196,
										(int) (((long) 3)), BgL_runz00_16195);
									PROCEDURE_SET(BgL_mainz00_16196,
										(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_16705));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_13148;

										BgL_objz00_13148 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16195, BgL_objz00_13148);
										BgL_objz00_13148;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3454z00_4183;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3455z00_4184;

											BgL_arg3455z00_4184 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16703))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_13152;

												BgL_newz00_13152 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_26434;

													BgL_auxz00_26434 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_13152, BgL_auxz00_26434,
														BgL_arg3455z00_4184);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_26439;
													int BgL_auxz00_26437;

													BgL_auxz00_26439 = BINT(BgL_siza7ezd2framez75_16705);
													BgL_auxz00_26437 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_13152, BgL_auxz00_26437,
														BgL_auxz00_26439);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_26442;

													BgL_auxz00_26442 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_13152, BgL_auxz00_26442,
														BgL_runz00_16195);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_26447;
													int BgL_auxz00_26445;

													BgL_auxz00_26447 = BINT(((long) -3));
													BgL_auxz00_26445 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_13152, BgL_auxz00_26445,
														BgL_auxz00_26447);
												}
												BgL_arg3454z00_4183 = BgL_newz00_13152;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16196, BgL_arg3454z00_4183);
										BgL_arg3454z00_4183;
									}
									return BgL_mainz00_16196;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5495 */
	obj_t BGl_z62main5495z62zz__evaluate_compz00(obj_t BgL_envz00_16707,
		obj_t BgL_cz00_16713, obj_t BgL_dz00_16714, obj_t BgL_lastz00_16715)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16711;
				long BgL_siza7ezd2framez75_16712;

				BgL_runz00_16711 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16707, (int) (((long) 3))));
				BgL_siza7ezd2framez75_16712 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16707, (int) (((long) 4))));
				{
					obj_t BgL_cz00_4185;
					obj_t BgL_dz00_4186;
					obj_t BgL_lastz00_4187;

					BgL_cz00_4185 = BgL_cz00_16713;
					BgL_dz00_4186 = BgL_dz00_16714;
					BgL_lastz00_4187 = BgL_lastz00_16715;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_4189;

						BgL_sz00_4189 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_4190;

							BgL_bpz00_4190 = VECTOR_REF(BgL_sz00_4189, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_26460;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_13074;

									BgL_arg1908z00_13074 = VECTOR_LENGTH(BgL_sz00_4189);
									BgL_testz00_26460 =
										(
										((long) CINT(BgL_bpz00_4190) +
											BgL_siza7ezd2framez75_16712) <
										(long) (BgL_arg1908z00_13074));
								}
								if (BgL_testz00_26460)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3458z00_4192;

											BgL_arg3458z00_4192 =
												((long) CINT(BgL_bpz00_4190) + ((long) 0));
											VECTOR_SET(BgL_sz00_4189,
												(int) (BgL_arg3458z00_4192), BgL_cz00_4185);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3459z00_4193;

											BgL_arg3459z00_4193 =
												((long) CINT(BgL_bpz00_4190) + ((long) 1));
											VECTOR_SET(BgL_sz00_4189,
												(int) (BgL_arg3459z00_4193), BgL_dz00_4186);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3460z00_4194;

											BgL_arg3460z00_4194 =
												((long) CINT(BgL_bpz00_4190) + ((long) 2));
											VECTOR_SET(BgL_sz00_4189,
												(int) (BgL_arg3460z00_4194), BgL_lastz00_4187);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1405z00_4195;

											BgL_val1405z00_4195 =
												BGl_zc3exitza33464ze3z83zz__evaluate_compz00
												(BgL_bpz00_4190, BgL_sz00_4189, BgL_runz00_16711);
											VECTOR_SET(BgL_sz00_4189, (int) (((long) 0)),
												BgL_bpz00_4190);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1405z00_4195)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1405z00_4195), CDR(BgL_val1405z00_4195));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1405z00_4195;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_4202;

										BgL_nsz00_4202 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4202,
											(int) (((long) 1)), BgL_sz00_4189);
										VECTOR_SET(BgL_nsz00_4202,
											(int) (((long) 2)), BgL_cz00_4185);
										VECTOR_SET(BgL_nsz00_4202,
											(int) (((long) 3)), BgL_dz00_4186);
										VECTOR_SET(BgL_nsz00_4202,
											(int) (((long) 4)), BgL_lastz00_4187);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_26496;

											BgL_auxz00_26496 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_26496, BgL_nsz00_4202);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1408z00_4204;

											BgL_val1408z00_4204 =
												BGl_zc3exitza33470ze3z83zz__evaluate_compz00
												(BgL_runz00_16711, BgL_nsz00_4202);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_26500;

												BgL_auxz00_26500 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_26500, BgL_sz00_4189);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1408z00_4204)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1408z00_4204), CDR(BgL_val1408z00_4204));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1408z00_4204;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3470> */
	obj_t BGl_zc3exitza33470ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17615,
		obj_t BgL_nsz00_17614)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1409z00_4210;

			if (SET_EXIT(BgL_an_exit1409z00_4210))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1409z00_4210 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1409z00_4210, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1410z00_4211;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_13120;

								BgL_savedzd2bpzd2_13120 =
									VECTOR_REF(BgL_nsz00_17614, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17614,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_13127;

									BgL_fz00_13127 = BgL_runz00_17615;
								BgL_recz00_13126:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_13128;

										BgL_rz00_13128 =
											PROCEDURE_ENTRY(BgL_fz00_13127) (BgL_fz00_13127,
											BgL_nsz00_17614, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_26521;

											if (PROCEDUREP(BgL_rz00_13128))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_13133;

													BgL_arg1900z00_13133 = PROCEDURE_ATTR(BgL_rz00_13128);
													if (STRUCTP(BgL_arg1900z00_13133))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_26521 =
																(STRUCT_KEY(BgL_arg1900z00_13133) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_26521 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_26521 = ((bool_t) 0);
												}
											if (BgL_testz00_26521)
												{
													obj_t BgL_fz00_26529;

													BgL_fz00_26529 = BgL_rz00_13128;
													BgL_fz00_13127 = BgL_fz00_26529;
													goto BgL_recz00_13126;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17614,
														(int) (((long) 0)), BgL_savedzd2bpzd2_13120);
													BgL_val1410z00_4211 = BgL_rz00_13128;
							}}}}}
							POP_EXIT();
							return BgL_val1410z00_4211;
						}
					}
				}
		}
	}



/* <exit:3464> */
	obj_t BGl_zc3exitza33464ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17618,
		obj_t BgL_sz00_17617, obj_t BgL_runz00_17616)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1406z00_4200;

			if (SET_EXIT(BgL_an_exit1406z00_4200))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1406z00_4200 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1406z00_4200, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1407z00_4201;

							BgL_val1407z00_4201 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17616,
								BgL_sz00_17617, BgL_bpz00_17618);
							POP_EXIT();
							return BgL_val1407z00_4201;
						}
					}
				}
		}
	}



/* &run5496 */
	obj_t BGl_z62run5496z62zz__evaluate_compz00(obj_t BgL_envz00_16716,
		obj_t BgL_sz00_16720)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_16717;
				BgL_ev_absz00_bglt BgL_i1252z00_16718;
				obj_t BgL_bodyz00_16719;

				BgL_iboxesz00_16717 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16716, (int) (((long) 0))));
				BgL_i1252z00_16718 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16716, (int) (((long) 1))));
				BgL_bodyz00_16719 = PROCEDURE_REF(BgL_envz00_16716, (int) (((long) 2)));
				{
					obj_t BgL_sz00_4213;

					BgL_sz00_4213 = BgL_sz00_16720;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4215;

						BgL_bpz00_4215 = VECTOR_REF(BgL_sz00_4213, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_4213,
							BgL_iboxesz00_16717, BgL_bpz00_4215);
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_z12denvz12_4216;
							obj_t BgL_wherez00_4217;
							obj_t BgL_locz00_4218;

							BgL_z12denvz12_4216 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4217 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16718))->BgL_wherez00);
							BgL_locz00_4218 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16718))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1129 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4216, BgL_wherez00_4217,
									BgL_locz00_4218);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_za2za2resza2za2z00_4219;

									BgL_za2za2resza2za2z00_4219 =
										PROCEDURE_ENTRY(BgL_bodyz00_16719) (BgL_bodyz00_16719,
										BgL_sz00_4213, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4216);
									return BgL_za2za2resza2za2z00_4219;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3474> */
	obj_t BGl_z62zc3anonymousza33474ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16721, obj_t BgL_sz00_16727)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_ifreesz00_16722;
				long BgL_siza7eza7_16723;
				BgL_ev_absz00_bglt BgL_i1252z00_16724;
				obj_t BgL_bodyz00_16725;
				long BgL_siza7ezd2framez75_16726;

				BgL_ifreesz00_16722 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16721, (int) (((long) 0))));
				BgL_siza7eza7_16723 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16721, (int) (((long) 1))));
				BgL_i1252z00_16724 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16721, (int) (((long) 2))));
				BgL_bodyz00_16725 = PROCEDURE_REF(BgL_envz00_16721, (int) (((long) 3)));
				BgL_siza7ezd2framez75_16726 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16721, (int) (((long) 4))));
				{
					obj_t BgL_sz00_4223;

					BgL_sz00_4223 = BgL_sz00_16727;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4225;

						BgL_bpz00_4225 = VECTOR_REF(BgL_sz00_4223, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_valza2za2_4226;

							BgL_valza2za2_4226 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_4223,
								BgL_bpz00_4225, BgL_ifreesz00_16722);
							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16192;

								BgL_runz00_16192 =
									MAKE_FX_PROCEDURE(BGl_z62run5498z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_runz00_16192,
									(int) (((long) 0)), BINT(BgL_siza7eza7_16723));
								PROCEDURE_SET(BgL_runz00_16192,
									(int) (((long) 1)), BgL_valza2za2_4226);
								PROCEDURE_SET(BgL_runz00_16192,
									(int) (((long) 2)), ((obj_t) BgL_i1252z00_16724));
								PROCEDURE_SET(BgL_runz00_16192,
									(int) (((long) 3)), BgL_bodyz00_16725);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16193;

									BgL_mainz00_16193 =
										MAKE_VA_PROCEDURE(BGl_z62main5497z62zz__evaluate_compz00,
										(int) (((long) -3)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_mainz00_16193,
										(int) (((long) 0)), BINT(BgL_siza7eza7_16723));
									PROCEDURE_SET(BgL_mainz00_16193,
										(int) (((long) 1)), BgL_valza2za2_4226);
									PROCEDURE_SET(BgL_mainz00_16193,
										(int) (((long) 2)), ((obj_t) BgL_i1252z00_16724));
									PROCEDURE_SET(BgL_mainz00_16193,
										(int) (((long) 3)), BgL_bodyz00_16725);
									PROCEDURE_SET(BgL_mainz00_16193,
										(int) (((long) 4)), BgL_runz00_16192);
									PROCEDURE_SET(BgL_mainz00_16193,
										(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_16726));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_13264;

										BgL_objz00_13264 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16192, BgL_objz00_13264);
										BgL_objz00_13264;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3475z00_4229;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3476z00_4230;

											BgL_arg3476z00_4230 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16724))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_13268;

												BgL_newz00_13268 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_26610;

													BgL_auxz00_26610 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_13268, BgL_auxz00_26610,
														BgL_arg3476z00_4230);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_26615;
													int BgL_auxz00_26613;

													BgL_auxz00_26615 = BINT(BgL_siza7ezd2framez75_16726);
													BgL_auxz00_26613 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_13268, BgL_auxz00_26613,
														BgL_auxz00_26615);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_26618;

													BgL_auxz00_26618 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_13268, BgL_auxz00_26618,
														BgL_runz00_16192);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_26623;
													int BgL_auxz00_26621;

													BgL_auxz00_26623 = BINT(((long) -3));
													BgL_auxz00_26621 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_13268, BgL_auxz00_26621,
														BgL_auxz00_26623);
												}
												BgL_arg3475z00_4229 = BgL_newz00_13268;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16193, BgL_arg3475z00_4229);
										BgL_arg3475z00_4229;
									}
									return BgL_mainz00_16193;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5497 */
	obj_t BGl_z62main5497z62zz__evaluate_compz00(obj_t BgL_envz00_16728,
		obj_t BgL_cz00_16735, obj_t BgL_dz00_16736, obj_t BgL_lastz00_16737)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16733;
				long BgL_siza7ezd2framez75_16734;

				BgL_runz00_16733 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16728, (int) (((long) 4))));
				BgL_siza7ezd2framez75_16734 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16728, (int) (((long) 5))));
				{
					obj_t BgL_cz00_4231;
					obj_t BgL_dz00_4232;
					obj_t BgL_lastz00_4233;

					BgL_cz00_4231 = BgL_cz00_16735;
					BgL_dz00_4232 = BgL_dz00_16736;
					BgL_lastz00_4233 = BgL_lastz00_16737;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_4235;

						BgL_sz00_4235 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_4236;

							BgL_bpz00_4236 = VECTOR_REF(BgL_sz00_4235, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_26636;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_13190;

									BgL_arg1908z00_13190 = VECTOR_LENGTH(BgL_sz00_4235);
									BgL_testz00_26636 =
										(
										((long) CINT(BgL_bpz00_4236) +
											BgL_siza7ezd2framez75_16734) <
										(long) (BgL_arg1908z00_13190));
								}
								if (BgL_testz00_26636)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3479z00_4238;

											BgL_arg3479z00_4238 =
												((long) CINT(BgL_bpz00_4236) + ((long) 0));
											VECTOR_SET(BgL_sz00_4235,
												(int) (BgL_arg3479z00_4238), BgL_cz00_4231);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3480z00_4239;

											BgL_arg3480z00_4239 =
												((long) CINT(BgL_bpz00_4236) + ((long) 1));
											VECTOR_SET(BgL_sz00_4235,
												(int) (BgL_arg3480z00_4239), BgL_dz00_4232);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3481z00_4240;

											BgL_arg3481z00_4240 =
												((long) CINT(BgL_bpz00_4236) + ((long) 2));
											VECTOR_SET(BgL_sz00_4235,
												(int) (BgL_arg3481z00_4240), BgL_lastz00_4233);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1411z00_4241;

											BgL_val1411z00_4241 =
												BGl_zc3exitza33485ze3z83zz__evaluate_compz00
												(BgL_bpz00_4236, BgL_sz00_4235, BgL_runz00_16733);
											VECTOR_SET(BgL_sz00_4235, (int) (((long) 0)),
												BgL_bpz00_4236);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1411z00_4241)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1411z00_4241), CDR(BgL_val1411z00_4241));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1411z00_4241;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_4248;

										BgL_nsz00_4248 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4248,
											(int) (((long) 1)), BgL_sz00_4235);
										VECTOR_SET(BgL_nsz00_4248,
											(int) (((long) 2)), BgL_cz00_4231);
										VECTOR_SET(BgL_nsz00_4248,
											(int) (((long) 3)), BgL_dz00_4232);
										VECTOR_SET(BgL_nsz00_4248,
											(int) (((long) 4)), BgL_lastz00_4233);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_26672;

											BgL_auxz00_26672 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_26672, BgL_nsz00_4248);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1414z00_4250;

											BgL_val1414z00_4250 =
												BGl_zc3exitza33491ze3z83zz__evaluate_compz00
												(BgL_runz00_16733, BgL_nsz00_4248);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_26676;

												BgL_auxz00_26676 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_26676, BgL_sz00_4235);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1414z00_4250)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1414z00_4250), CDR(BgL_val1414z00_4250));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1414z00_4250;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3491> */
	obj_t BGl_zc3exitza33491ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17610,
		obj_t BgL_nsz00_17609)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1415z00_4256;

			if (SET_EXIT(BgL_an_exit1415z00_4256))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1415z00_4256 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1415z00_4256, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1416z00_4257;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_13236;

								BgL_savedzd2bpzd2_13236 =
									VECTOR_REF(BgL_nsz00_17609, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17609,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_13243;

									BgL_fz00_13243 = BgL_runz00_17610;
								BgL_recz00_13242:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_13244;

										BgL_rz00_13244 =
											PROCEDURE_ENTRY(BgL_fz00_13243) (BgL_fz00_13243,
											BgL_nsz00_17609, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_26697;

											if (PROCEDUREP(BgL_rz00_13244))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_13249;

													BgL_arg1900z00_13249 = PROCEDURE_ATTR(BgL_rz00_13244);
													if (STRUCTP(BgL_arg1900z00_13249))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_26697 =
																(STRUCT_KEY(BgL_arg1900z00_13249) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_26697 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_26697 = ((bool_t) 0);
												}
											if (BgL_testz00_26697)
												{
													obj_t BgL_fz00_26705;

													BgL_fz00_26705 = BgL_rz00_13244;
													BgL_fz00_13243 = BgL_fz00_26705;
													goto BgL_recz00_13242;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17609,
														(int) (((long) 0)), BgL_savedzd2bpzd2_13236);
													BgL_val1416z00_4257 = BgL_rz00_13244;
							}}}}}
							POP_EXIT();
							return BgL_val1416z00_4257;
						}
					}
				}
		}
	}



/* <exit:3485> */
	obj_t BGl_zc3exitza33485ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17613,
		obj_t BgL_sz00_17612, obj_t BgL_runz00_17611)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1412z00_4246;

			if (SET_EXIT(BgL_an_exit1412z00_4246))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1412z00_4246 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1412z00_4246, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1413z00_4247;

							BgL_val1413z00_4247 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17611,
								BgL_sz00_17612, BgL_bpz00_17613);
							POP_EXIT();
							return BgL_val1413z00_4247;
						}
					}
				}
		}
	}



/* &run5498 */
	obj_t BGl_z62run5498z62zz__evaluate_compz00(obj_t BgL_envz00_16738,
		obj_t BgL_sz00_16743)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				long BgL_siza7eza7_16739;
				obj_t BgL_valza2za2_16740;
				BgL_ev_absz00_bglt BgL_i1252z00_16741;
				obj_t BgL_bodyz00_16742;

				BgL_siza7eza7_16739 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16738, (int) (((long) 0))));
				BgL_valza2za2_16740 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16738, (int) (((long) 1))));
				BgL_i1252z00_16741 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16738, (int) (((long) 2))));
				BgL_bodyz00_16742 = PROCEDURE_REF(BgL_envz00_16738, (int) (((long) 3)));
				{
					obj_t BgL_sz00_4259;

					BgL_sz00_4259 = BgL_sz00_16743;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4261;

						BgL_bpz00_4261 = VECTOR_REF(BgL_sz00_4259, (int) (((long) 0)));
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_4259,
							BgL_valza2za2_16740,
							((long) CINT(BgL_bpz00_4261) + BgL_siza7eza7_16739));
						{	/* Eval/evaluate_comp.scm 1049 */
							obj_t BgL_z12denvz12_4263;
							obj_t BgL_wherez00_4264;
							obj_t BgL_locz00_4265;

							BgL_z12denvz12_4263 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4264 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16741))->BgL_wherez00);
							BgL_locz00_4265 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16741))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1049 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4263, BgL_wherez00_4264,
									BgL_locz00_4265);
								{	/* Eval/evaluate_comp.scm 1049 */
									obj_t BgL_za2za2resza2za2z00_4266;

									BgL_za2za2resza2za2z00_4266 =
										PROCEDURE_ENTRY(BgL_bodyz00_16742) (BgL_bodyz00_16742,
										BgL_sz00_4259, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4263);
									return BgL_za2za2resza2za2z00_4266;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3494> */
	obj_t BGl_z62zc3anonymousza33494ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16744, obj_t BgL_sz00_16751)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_ifreesz00_16745;
				obj_t BgL_iboxesz00_16746;
				long BgL_siza7eza7_16747;
				BgL_ev_absz00_bglt BgL_i1252z00_16748;
				obj_t BgL_bodyz00_16749;
				long BgL_siza7ezd2framez75_16750;

				BgL_ifreesz00_16745 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16744, (int) (((long) 0))));
				BgL_iboxesz00_16746 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16744, (int) (((long) 1))));
				BgL_siza7eza7_16747 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16744, (int) (((long) 2))));
				BgL_i1252z00_16748 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16744, (int) (((long) 3))));
				BgL_bodyz00_16749 = PROCEDURE_REF(BgL_envz00_16744, (int) (((long) 4)));
				BgL_siza7ezd2framez75_16750 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16744, (int) (((long) 5))));
				{
					obj_t BgL_sz00_4268;

					BgL_sz00_4268 = BgL_sz00_16751;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4270;

						BgL_bpz00_4270 = VECTOR_REF(BgL_sz00_4268, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_valza2za2_4271;

							BgL_valza2za2_4271 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_4268,
								BgL_bpz00_4270, BgL_ifreesz00_16745);
							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16189;

								BgL_runz00_16189 =
									MAKE_FX_PROCEDURE(BGl_z62run5500z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_runz00_16189,
									(int) (((long) 0)), BgL_iboxesz00_16746);
								PROCEDURE_SET(BgL_runz00_16189,
									(int) (((long) 1)), BINT(BgL_siza7eza7_16747));
								PROCEDURE_SET(BgL_runz00_16189,
									(int) (((long) 2)), BgL_valza2za2_4271);
								PROCEDURE_SET(BgL_runz00_16189,
									(int) (((long) 3)), ((obj_t) BgL_i1252z00_16748));
								PROCEDURE_SET(BgL_runz00_16189,
									(int) (((long) 4)), BgL_bodyz00_16749);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16190;

									BgL_mainz00_16190 =
										MAKE_VA_PROCEDURE(BGl_z62main5499z62zz__evaluate_compz00,
										(int) (((long) -3)), (int) (((long) 7)));
									PROCEDURE_SET(BgL_mainz00_16190,
										(int) (((long) 0)), BgL_iboxesz00_16746);
									PROCEDURE_SET(BgL_mainz00_16190,
										(int) (((long) 1)), BINT(BgL_siza7eza7_16747));
									PROCEDURE_SET(BgL_mainz00_16190,
										(int) (((long) 2)), BgL_valza2za2_4271);
									PROCEDURE_SET(BgL_mainz00_16190,
										(int) (((long) 3)), ((obj_t) BgL_i1252z00_16748));
									PROCEDURE_SET(BgL_mainz00_16190,
										(int) (((long) 4)), BgL_bodyz00_16749);
									PROCEDURE_SET(BgL_mainz00_16190,
										(int) (((long) 5)), BgL_runz00_16189);
									PROCEDURE_SET(BgL_mainz00_16190,
										(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_16750));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_13376;

										BgL_objz00_13376 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16189, BgL_objz00_13376);
										BgL_objz00_13376;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3495z00_4274;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3496z00_4275;

											BgL_arg3496z00_4275 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16748))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_13380;

												BgL_newz00_13380 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_26798;

													BgL_auxz00_26798 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_13380, BgL_auxz00_26798,
														BgL_arg3496z00_4275);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_26803;
													int BgL_auxz00_26801;

													BgL_auxz00_26803 = BINT(BgL_siza7ezd2framez75_16750);
													BgL_auxz00_26801 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_13380, BgL_auxz00_26801,
														BgL_auxz00_26803);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_26806;

													BgL_auxz00_26806 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_13380, BgL_auxz00_26806,
														BgL_runz00_16189);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_26811;
													int BgL_auxz00_26809;

													BgL_auxz00_26811 = BINT(((long) -3));
													BgL_auxz00_26809 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_13380, BgL_auxz00_26809,
														BgL_auxz00_26811);
												}
												BgL_arg3495z00_4274 = BgL_newz00_13380;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16190, BgL_arg3495z00_4274);
										BgL_arg3495z00_4274;
									}
									return BgL_mainz00_16190;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5499 */
	obj_t BGl_z62main5499z62zz__evaluate_compz00(obj_t BgL_envz00_16752,
		obj_t BgL_cz00_16760, obj_t BgL_dz00_16761, obj_t BgL_lastz00_16762)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16758;
				long BgL_siza7ezd2framez75_16759;

				BgL_runz00_16758 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16752, (int) (((long) 5))));
				BgL_siza7ezd2framez75_16759 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16752, (int) (((long) 6))));
				{
					obj_t BgL_cz00_4276;
					obj_t BgL_dz00_4277;
					obj_t BgL_lastz00_4278;

					BgL_cz00_4276 = BgL_cz00_16760;
					BgL_dz00_4277 = BgL_dz00_16761;
					BgL_lastz00_4278 = BgL_lastz00_16762;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_4280;

						BgL_sz00_4280 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_4281;

							BgL_bpz00_4281 = VECTOR_REF(BgL_sz00_4280, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_26824;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_13302;

									BgL_arg1908z00_13302 = VECTOR_LENGTH(BgL_sz00_4280);
									BgL_testz00_26824 =
										(
										((long) CINT(BgL_bpz00_4281) +
											BgL_siza7ezd2framez75_16759) <
										(long) (BgL_arg1908z00_13302));
								}
								if (BgL_testz00_26824)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3499z00_4283;

											BgL_arg3499z00_4283 =
												((long) CINT(BgL_bpz00_4281) + ((long) 0));
											VECTOR_SET(BgL_sz00_4280,
												(int) (BgL_arg3499z00_4283), BgL_cz00_4276);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3500z00_4284;

											BgL_arg3500z00_4284 =
												((long) CINT(BgL_bpz00_4281) + ((long) 1));
											VECTOR_SET(BgL_sz00_4280,
												(int) (BgL_arg3500z00_4284), BgL_dz00_4277);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3501z00_4285;

											BgL_arg3501z00_4285 =
												((long) CINT(BgL_bpz00_4281) + ((long) 2));
											VECTOR_SET(BgL_sz00_4280,
												(int) (BgL_arg3501z00_4285), BgL_lastz00_4278);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1417z00_4286;

											BgL_val1417z00_4286 =
												BGl_zc3exitza33505ze3z83zz__evaluate_compz00
												(BgL_bpz00_4281, BgL_sz00_4280, BgL_runz00_16758);
											VECTOR_SET(BgL_sz00_4280, (int) (((long) 0)),
												BgL_bpz00_4281);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1417z00_4286)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1417z00_4286), CDR(BgL_val1417z00_4286));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1417z00_4286;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_4293;

										BgL_nsz00_4293 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4293,
											(int) (((long) 1)), BgL_sz00_4280);
										VECTOR_SET(BgL_nsz00_4293,
											(int) (((long) 2)), BgL_cz00_4276);
										VECTOR_SET(BgL_nsz00_4293,
											(int) (((long) 3)), BgL_dz00_4277);
										VECTOR_SET(BgL_nsz00_4293,
											(int) (((long) 4)), BgL_lastz00_4278);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_26860;

											BgL_auxz00_26860 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_26860, BgL_nsz00_4293);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1420z00_4295;

											BgL_val1420z00_4295 =
												BGl_zc3exitza33511ze3z83zz__evaluate_compz00
												(BgL_runz00_16758, BgL_nsz00_4293);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_26864;

												BgL_auxz00_26864 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_26864, BgL_sz00_4280);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1420z00_4295)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1420z00_4295), CDR(BgL_val1420z00_4295));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1420z00_4295;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3511> */
	obj_t BGl_zc3exitza33511ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17605,
		obj_t BgL_nsz00_17604)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1421z00_4301;

			if (SET_EXIT(BgL_an_exit1421z00_4301))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1421z00_4301 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1421z00_4301, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1422z00_4302;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_13348;

								BgL_savedzd2bpzd2_13348 =
									VECTOR_REF(BgL_nsz00_17604, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17604,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_13355;

									BgL_fz00_13355 = BgL_runz00_17605;
								BgL_recz00_13354:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_13356;

										BgL_rz00_13356 =
											PROCEDURE_ENTRY(BgL_fz00_13355) (BgL_fz00_13355,
											BgL_nsz00_17604, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_26885;

											if (PROCEDUREP(BgL_rz00_13356))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_13361;

													BgL_arg1900z00_13361 = PROCEDURE_ATTR(BgL_rz00_13356);
													if (STRUCTP(BgL_arg1900z00_13361))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_26885 =
																(STRUCT_KEY(BgL_arg1900z00_13361) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_26885 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_26885 = ((bool_t) 0);
												}
											if (BgL_testz00_26885)
												{
													obj_t BgL_fz00_26893;

													BgL_fz00_26893 = BgL_rz00_13356;
													BgL_fz00_13355 = BgL_fz00_26893;
													goto BgL_recz00_13354;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17604,
														(int) (((long) 0)), BgL_savedzd2bpzd2_13348);
													BgL_val1422z00_4302 = BgL_rz00_13356;
							}}}}}
							POP_EXIT();
							return BgL_val1422z00_4302;
						}
					}
				}
		}
	}



/* <exit:3505> */
	obj_t BGl_zc3exitza33505ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17608,
		obj_t BgL_sz00_17607, obj_t BgL_runz00_17606)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1418z00_4291;

			if (SET_EXIT(BgL_an_exit1418z00_4291))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1418z00_4291 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1418z00_4291, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1419z00_4292;

							BgL_val1419z00_4292 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17606,
								BgL_sz00_17607, BgL_bpz00_17608);
							POP_EXIT();
							return BgL_val1419z00_4292;
						}
					}
				}
		}
	}



/* &run5500 */
	obj_t BGl_z62run5500z62zz__evaluate_compz00(obj_t BgL_envz00_16763,
		obj_t BgL_sz00_16769)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_16764;
				long BgL_siza7eza7_16765;
				obj_t BgL_valza2za2_16766;
				BgL_ev_absz00_bglt BgL_i1252z00_16767;
				obj_t BgL_bodyz00_16768;

				BgL_iboxesz00_16764 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16763, (int) (((long) 0))));
				BgL_siza7eza7_16765 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16763, (int) (((long) 1))));
				BgL_valza2za2_16766 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16763, (int) (((long) 2))));
				BgL_i1252z00_16767 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16763, (int) (((long) 3))));
				BgL_bodyz00_16768 = PROCEDURE_REF(BgL_envz00_16763, (int) (((long) 4)));
				{
					obj_t BgL_sz00_4304;

					BgL_sz00_4304 = BgL_sz00_16769;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4306;

						BgL_bpz00_4306 = VECTOR_REF(BgL_sz00_4304, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_4304,
							BgL_iboxesz00_16764, BgL_bpz00_4306);
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_4304,
							BgL_valza2za2_16766,
							((long) CINT(BgL_bpz00_4306) + BgL_siza7eza7_16765));
						{	/* Eval/evaluate_comp.scm 1049 */
							obj_t BgL_z12denvz12_4308;
							obj_t BgL_wherez00_4309;
							obj_t BgL_locz00_4310;

							BgL_z12denvz12_4308 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4309 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16767))->BgL_wherez00);
							BgL_locz00_4310 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16767))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1049 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4308, BgL_wherez00_4309,
									BgL_locz00_4310);
								{	/* Eval/evaluate_comp.scm 1049 */
									obj_t BgL_za2za2resza2za2z00_4311;

									BgL_za2za2resza2za2z00_4311 =
										PROCEDURE_ENTRY(BgL_bodyz00_16768) (BgL_bodyz00_16768,
										BgL_sz00_4304, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4308);
									return BgL_za2za2resza2za2z00_4311;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3348> */
	obj_t BGl_z62zc3anonymousza33348ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16770, obj_t BgL_sz00_16774)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_16771;
				obj_t BgL_bodyz00_16772;
				long BgL_siza7ezd2framez75_16773;

				BgL_i1252z00_16771 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16770, (int) (((long) 0))));
				BgL_bodyz00_16772 = PROCEDURE_REF(BgL_envz00_16770, (int) (((long) 1)));
				BgL_siza7ezd2framez75_16773 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16770, (int) (((long) 2))));
				{
					obj_t BgL_sz00_3961;

					BgL_sz00_3961 = BgL_sz00_16774;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3963;

						BgL_bpz00_3963 = VECTOR_REF(BgL_sz00_3961, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */

							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16186;

								BgL_runz00_16186 =
									MAKE_FX_PROCEDURE(BGl_z62run5502z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_runz00_16186,
									(int) (((long) 0)), ((obj_t) BgL_i1252z00_16771));
								PROCEDURE_SET(BgL_runz00_16186,
									(int) (((long) 1)), BgL_bodyz00_16772);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16187;

									BgL_mainz00_16187 =
										MAKE_FX_PROCEDURE(BGl_z62main5501z62zz__evaluate_compz00,
										(int) (((long) 2)), (int) (((long) 4)));
									PROCEDURE_SET(BgL_mainz00_16187,
										(int) (((long) 0)), ((obj_t) BgL_i1252z00_16771));
									PROCEDURE_SET(BgL_mainz00_16187,
										(int) (((long) 1)), BgL_bodyz00_16772);
									PROCEDURE_SET(BgL_mainz00_16187,
										(int) (((long) 2)), BgL_runz00_16186);
									PROCEDURE_SET(BgL_mainz00_16187,
										(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_16773));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_12612;

										BgL_objz00_12612 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16186, BgL_objz00_12612);
										BgL_objz00_12612;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3349z00_3966;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3350z00_3967;

											BgL_arg3350z00_3967 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16771))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_12616;

												BgL_newz00_12616 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_26966;

													BgL_auxz00_26966 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_12616, BgL_auxz00_26966,
														BgL_arg3350z00_3967);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_26971;
													int BgL_auxz00_26969;

													BgL_auxz00_26971 = BINT(BgL_siza7ezd2framez75_16773);
													BgL_auxz00_26969 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_12616, BgL_auxz00_26969,
														BgL_auxz00_26971);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_26974;

													BgL_auxz00_26974 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_12616, BgL_auxz00_26974,
														BgL_runz00_16186);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_26979;
													int BgL_auxz00_26977;

													BgL_auxz00_26979 = BINT(((long) 2));
													BgL_auxz00_26977 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_12616, BgL_auxz00_26977,
														BgL_auxz00_26979);
												}
												BgL_arg3349z00_3966 = BgL_newz00_12616;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16187, BgL_arg3349z00_3966);
										BgL_arg3349z00_3966;
									}
									return BgL_mainz00_16187;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5501 */
	obj_t BGl_z62main5501z62zz__evaluate_compz00(obj_t BgL_envz00_16775,
		obj_t BgL_cz00_16780, obj_t BgL_dz00_16781)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16778;
				long BgL_siza7ezd2framez75_16779;

				BgL_runz00_16778 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16775, (int) (((long) 2))));
				BgL_siza7ezd2framez75_16779 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16775, (int) (((long) 3))));
				{
					obj_t BgL_cz00_3968;
					obj_t BgL_dz00_3969;

					BgL_cz00_3968 = BgL_cz00_16780;
					BgL_dz00_3969 = BgL_dz00_16781;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_3971;

						BgL_sz00_3971 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_3972;

							BgL_bpz00_3972 = VECTOR_REF(BgL_sz00_3971, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_26992;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_12547;

									BgL_arg1908z00_12547 = VECTOR_LENGTH(BgL_sz00_3971);
									BgL_testz00_26992 =
										(
										((long) CINT(BgL_bpz00_3972) +
											BgL_siza7ezd2framez75_16779) <
										(long) (BgL_arg1908z00_12547));
								}
								if (BgL_testz00_26992)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3353z00_3974;

											BgL_arg3353z00_3974 =
												((long) CINT(BgL_bpz00_3972) + ((long) 0));
											VECTOR_SET(BgL_sz00_3971,
												(int) (BgL_arg3353z00_3974), BgL_cz00_3968);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3354z00_3975;

											BgL_arg3354z00_3975 =
												((long) CINT(BgL_bpz00_3972) + ((long) 1));
											VECTOR_SET(BgL_sz00_3971,
												(int) (BgL_arg3354z00_3975), BgL_dz00_3969);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1375z00_3976;

											BgL_val1375z00_3976 =
												BGl_zc3exitza33358ze3z83zz__evaluate_compz00
												(BgL_bpz00_3972, BgL_sz00_3971, BgL_runz00_16778);
											VECTOR_SET(BgL_sz00_3971, (int) (((long) 0)),
												BgL_bpz00_3972);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1375z00_3976)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1375z00_3976), CDR(BgL_val1375z00_3976));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1375z00_3976;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_3983;

										BgL_nsz00_3983 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_3983,
											(int) (((long) 1)), BgL_sz00_3971);
										VECTOR_SET(BgL_nsz00_3983,
											(int) (((long) 2)), BgL_cz00_3968);
										VECTOR_SET(BgL_nsz00_3983,
											(int) (((long) 3)), BgL_dz00_3969);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_27022;

											BgL_auxz00_27022 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_27022, BgL_nsz00_3983);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1378z00_3985;

											BgL_val1378z00_3985 =
												BGl_zc3exitza33364ze3z83zz__evaluate_compz00
												(BgL_runz00_16778, BgL_nsz00_3983);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_27026;

												BgL_auxz00_27026 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_27026, BgL_sz00_3971);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1378z00_3985)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1378z00_3985), CDR(BgL_val1378z00_3985));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1378z00_3985;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3364> */
	obj_t BGl_zc3exitza33364ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17600,
		obj_t BgL_nsz00_17599)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1379z00_3991;

			if (SET_EXIT(BgL_an_exit1379z00_3991))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1379z00_3991 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1379z00_3991, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1380z00_3992;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_12584;

								BgL_savedzd2bpzd2_12584 =
									VECTOR_REF(BgL_nsz00_17599, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17599,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_12591;

									BgL_fz00_12591 = BgL_runz00_17600;
								BgL_recz00_12590:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_12592;

										BgL_rz00_12592 =
											PROCEDURE_ENTRY(BgL_fz00_12591) (BgL_fz00_12591,
											BgL_nsz00_17599, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_27047;

											if (PROCEDUREP(BgL_rz00_12592))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_12597;

													BgL_arg1900z00_12597 = PROCEDURE_ATTR(BgL_rz00_12592);
													if (STRUCTP(BgL_arg1900z00_12597))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_27047 =
																(STRUCT_KEY(BgL_arg1900z00_12597) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_27047 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_27047 = ((bool_t) 0);
												}
											if (BgL_testz00_27047)
												{
													obj_t BgL_fz00_27055;

													BgL_fz00_27055 = BgL_rz00_12592;
													BgL_fz00_12591 = BgL_fz00_27055;
													goto BgL_recz00_12590;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17599,
														(int) (((long) 0)), BgL_savedzd2bpzd2_12584);
													BgL_val1380z00_3992 = BgL_rz00_12592;
							}}}}}
							POP_EXIT();
							return BgL_val1380z00_3992;
						}
					}
				}
		}
	}



/* <exit:3358> */
	obj_t BGl_zc3exitza33358ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17603,
		obj_t BgL_sz00_17602, obj_t BgL_runz00_17601)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1376z00_3981;

			if (SET_EXIT(BgL_an_exit1376z00_3981))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1376z00_3981 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1376z00_3981, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1377z00_3982;

							BgL_val1377z00_3982 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17601,
								BgL_sz00_17602, BgL_bpz00_17603);
							POP_EXIT();
							return BgL_val1377z00_3982;
						}
					}
				}
		}
	}



/* &run5502 */
	obj_t BGl_z62run5502z62zz__evaluate_compz00(obj_t BgL_envz00_16782,
		obj_t BgL_sz00_16785)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_16783;
				obj_t BgL_bodyz00_16784;

				BgL_i1252z00_16783 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16782, (int) (((long) 0))));
				BgL_bodyz00_16784 = PROCEDURE_REF(BgL_envz00_16782, (int) (((long) 1)));
				{
					obj_t BgL_sz00_3994;

					BgL_sz00_3994 = BgL_sz00_16785;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3996;

						BgL_bpz00_3996 = VECTOR_REF(BgL_sz00_3994, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_z12denvz12_3997;
							obj_t BgL_wherez00_3998;
							obj_t BgL_locz00_3999;

							BgL_z12denvz12_3997 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_3998 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16783))->BgL_wherez00);
							BgL_locz00_3999 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16783))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1129 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_3997, BgL_wherez00_3998,
									BgL_locz00_3999);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_za2za2resza2za2z00_4000;

									BgL_za2za2resza2za2z00_4000 =
										PROCEDURE_ENTRY(BgL_bodyz00_16784) (BgL_bodyz00_16784,
										BgL_sz00_3994, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_3997);
									return BgL_za2za2resza2za2z00_4000;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3366> */
	obj_t BGl_z62zc3anonymousza33366ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16786, obj_t BgL_sz00_16791)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_16787;
				BgL_ev_absz00_bglt BgL_i1252z00_16788;
				obj_t BgL_bodyz00_16789;
				long BgL_siza7ezd2framez75_16790;

				BgL_iboxesz00_16787 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16786, (int) (((long) 0))));
				BgL_i1252z00_16788 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16786, (int) (((long) 1))));
				BgL_bodyz00_16789 = PROCEDURE_REF(BgL_envz00_16786, (int) (((long) 2)));
				BgL_siza7ezd2framez75_16790 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16786, (int) (((long) 3))));
				{
					obj_t BgL_sz00_4002;

					BgL_sz00_4002 = BgL_sz00_16791;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4004;

						BgL_bpz00_4004 = VECTOR_REF(BgL_sz00_4002, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */

							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16183;

								BgL_runz00_16183 =
									MAKE_FX_PROCEDURE(BGl_z62run5504z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_runz00_16183,
									(int) (((long) 0)), BgL_iboxesz00_16787);
								PROCEDURE_SET(BgL_runz00_16183,
									(int) (((long) 1)), ((obj_t) BgL_i1252z00_16788));
								PROCEDURE_SET(BgL_runz00_16183,
									(int) (((long) 2)), BgL_bodyz00_16789);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16184;

									BgL_mainz00_16184 =
										MAKE_FX_PROCEDURE(BGl_z62main5503z62zz__evaluate_compz00,
										(int) (((long) 2)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_mainz00_16184,
										(int) (((long) 0)), BgL_iboxesz00_16787);
									PROCEDURE_SET(BgL_mainz00_16184,
										(int) (((long) 1)), ((obj_t) BgL_i1252z00_16788));
									PROCEDURE_SET(BgL_mainz00_16184,
										(int) (((long) 2)), BgL_bodyz00_16789);
									PROCEDURE_SET(BgL_mainz00_16184,
										(int) (((long) 3)), BgL_runz00_16183);
									PROCEDURE_SET(BgL_mainz00_16184,
										(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_16790));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_12712;

										BgL_objz00_12712 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16183, BgL_objz00_12712);
										BgL_objz00_12712;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3367z00_4007;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3370z00_4008;

											BgL_arg3370z00_4008 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16788))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_12716;

												BgL_newz00_12716 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_27122;

													BgL_auxz00_27122 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_12716, BgL_auxz00_27122,
														BgL_arg3370z00_4008);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_27127;
													int BgL_auxz00_27125;

													BgL_auxz00_27127 = BINT(BgL_siza7ezd2framez75_16790);
													BgL_auxz00_27125 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_12716, BgL_auxz00_27125,
														BgL_auxz00_27127);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_27130;

													BgL_auxz00_27130 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_12716, BgL_auxz00_27130,
														BgL_runz00_16183);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_27135;
													int BgL_auxz00_27133;

													BgL_auxz00_27135 = BINT(((long) 2));
													BgL_auxz00_27133 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_12716, BgL_auxz00_27133,
														BgL_auxz00_27135);
												}
												BgL_arg3367z00_4007 = BgL_newz00_12716;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16184, BgL_arg3367z00_4007);
										BgL_arg3367z00_4007;
									}
									return BgL_mainz00_16184;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5503 */
	obj_t BGl_z62main5503z62zz__evaluate_compz00(obj_t BgL_envz00_16792,
		obj_t BgL_cz00_16798, obj_t BgL_dz00_16799)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16796;
				long BgL_siza7ezd2framez75_16797;

				BgL_runz00_16796 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16792, (int) (((long) 3))));
				BgL_siza7ezd2framez75_16797 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16792, (int) (((long) 4))));
				{
					obj_t BgL_cz00_4009;
					obj_t BgL_dz00_4010;

					BgL_cz00_4009 = BgL_cz00_16798;
					BgL_dz00_4010 = BgL_dz00_16799;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_4012;

						BgL_sz00_4012 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_4013;

							BgL_bpz00_4013 = VECTOR_REF(BgL_sz00_4012, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_27148;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_12647;

									BgL_arg1908z00_12647 = VECTOR_LENGTH(BgL_sz00_4012);
									BgL_testz00_27148 =
										(
										((long) CINT(BgL_bpz00_4013) +
											BgL_siza7ezd2framez75_16797) <
										(long) (BgL_arg1908z00_12647));
								}
								if (BgL_testz00_27148)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3374z00_4015;

											BgL_arg3374z00_4015 =
												((long) CINT(BgL_bpz00_4013) + ((long) 0));
											VECTOR_SET(BgL_sz00_4012,
												(int) (BgL_arg3374z00_4015), BgL_cz00_4009);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3375z00_4016;

											BgL_arg3375z00_4016 =
												((long) CINT(BgL_bpz00_4013) + ((long) 1));
											VECTOR_SET(BgL_sz00_4012,
												(int) (BgL_arg3375z00_4016), BgL_dz00_4010);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1381z00_4017;

											BgL_val1381z00_4017 =
												BGl_zc3exitza33380ze3z83zz__evaluate_compz00
												(BgL_bpz00_4013, BgL_sz00_4012, BgL_runz00_16796);
											VECTOR_SET(BgL_sz00_4012, (int) (((long) 0)),
												BgL_bpz00_4013);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1381z00_4017)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1381z00_4017), CDR(BgL_val1381z00_4017));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1381z00_4017;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_4024;

										BgL_nsz00_4024 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4024,
											(int) (((long) 1)), BgL_sz00_4012);
										VECTOR_SET(BgL_nsz00_4024,
											(int) (((long) 2)), BgL_cz00_4009);
										VECTOR_SET(BgL_nsz00_4024,
											(int) (((long) 3)), BgL_dz00_4010);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_27178;

											BgL_auxz00_27178 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_27178, BgL_nsz00_4024);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1384z00_4026;

											BgL_val1384z00_4026 =
												BGl_zc3exitza33386ze3z83zz__evaluate_compz00
												(BgL_runz00_16796, BgL_nsz00_4024);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_27182;

												BgL_auxz00_27182 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_27182, BgL_sz00_4012);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1384z00_4026)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1384z00_4026), CDR(BgL_val1384z00_4026));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1384z00_4026;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3386> */
	obj_t BGl_zc3exitza33386ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17595,
		obj_t BgL_nsz00_17594)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1385z00_4032;

			if (SET_EXIT(BgL_an_exit1385z00_4032))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1385z00_4032 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1385z00_4032, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1386z00_4033;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_12684;

								BgL_savedzd2bpzd2_12684 =
									VECTOR_REF(BgL_nsz00_17594, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17594,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_12691;

									BgL_fz00_12691 = BgL_runz00_17595;
								BgL_recz00_12690:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_12692;

										BgL_rz00_12692 =
											PROCEDURE_ENTRY(BgL_fz00_12691) (BgL_fz00_12691,
											BgL_nsz00_17594, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_27203;

											if (PROCEDUREP(BgL_rz00_12692))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_12697;

													BgL_arg1900z00_12697 = PROCEDURE_ATTR(BgL_rz00_12692);
													if (STRUCTP(BgL_arg1900z00_12697))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_27203 =
																(STRUCT_KEY(BgL_arg1900z00_12697) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_27203 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_27203 = ((bool_t) 0);
												}
											if (BgL_testz00_27203)
												{
													obj_t BgL_fz00_27211;

													BgL_fz00_27211 = BgL_rz00_12692;
													BgL_fz00_12691 = BgL_fz00_27211;
													goto BgL_recz00_12690;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17594,
														(int) (((long) 0)), BgL_savedzd2bpzd2_12684);
													BgL_val1386z00_4033 = BgL_rz00_12692;
							}}}}}
							POP_EXIT();
							return BgL_val1386z00_4033;
						}
					}
				}
		}
	}



/* <exit:3380> */
	obj_t BGl_zc3exitza33380ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17598,
		obj_t BgL_sz00_17597, obj_t BgL_runz00_17596)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1382z00_4022;

			if (SET_EXIT(BgL_an_exit1382z00_4022))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1382z00_4022 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1382z00_4022, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1383z00_4023;

							BgL_val1383z00_4023 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17596,
								BgL_sz00_17597, BgL_bpz00_17598);
							POP_EXIT();
							return BgL_val1383z00_4023;
						}
					}
				}
		}
	}



/* &run5504 */
	obj_t BGl_z62run5504z62zz__evaluate_compz00(obj_t BgL_envz00_16800,
		obj_t BgL_sz00_16804)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_16801;
				BgL_ev_absz00_bglt BgL_i1252z00_16802;
				obj_t BgL_bodyz00_16803;

				BgL_iboxesz00_16801 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16800, (int) (((long) 0))));
				BgL_i1252z00_16802 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16800, (int) (((long) 1))));
				BgL_bodyz00_16803 = PROCEDURE_REF(BgL_envz00_16800, (int) (((long) 2)));
				{
					obj_t BgL_sz00_4035;

					BgL_sz00_4035 = BgL_sz00_16804;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4037;

						BgL_bpz00_4037 = VECTOR_REF(BgL_sz00_4035, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_4035,
							BgL_iboxesz00_16801, BgL_bpz00_4037);
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_z12denvz12_4038;
							obj_t BgL_wherez00_4039;
							obj_t BgL_locz00_4040;

							BgL_z12denvz12_4038 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4039 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16802))->BgL_wherez00);
							BgL_locz00_4040 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16802))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1129 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4038, BgL_wherez00_4039,
									BgL_locz00_4040);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_za2za2resza2za2z00_4041;

									BgL_za2za2resza2za2z00_4041 =
										PROCEDURE_ENTRY(BgL_bodyz00_16803) (BgL_bodyz00_16803,
										BgL_sz00_4035, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4038);
									return BgL_za2za2resza2za2z00_4041;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3390> */
	obj_t BGl_z62zc3anonymousza33390ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16805, obj_t BgL_sz00_16811)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_ifreesz00_16806;
				long BgL_siza7eza7_16807;
				BgL_ev_absz00_bglt BgL_i1252z00_16808;
				obj_t BgL_bodyz00_16809;
				long BgL_siza7ezd2framez75_16810;

				BgL_ifreesz00_16806 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16805, (int) (((long) 0))));
				BgL_siza7eza7_16807 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16805, (int) (((long) 1))));
				BgL_i1252z00_16808 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16805, (int) (((long) 2))));
				BgL_bodyz00_16809 = PROCEDURE_REF(BgL_envz00_16805, (int) (((long) 3)));
				BgL_siza7ezd2framez75_16810 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16805, (int) (((long) 4))));
				{
					obj_t BgL_sz00_4045;

					BgL_sz00_4045 = BgL_sz00_16811;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4047;

						BgL_bpz00_4047 = VECTOR_REF(BgL_sz00_4045, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_valza2za2_4048;

							BgL_valza2za2_4048 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_4045,
								BgL_bpz00_4047, BgL_ifreesz00_16806);
							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16180;

								BgL_runz00_16180 =
									MAKE_FX_PROCEDURE(BGl_z62run5506z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_runz00_16180,
									(int) (((long) 0)), BINT(BgL_siza7eza7_16807));
								PROCEDURE_SET(BgL_runz00_16180,
									(int) (((long) 1)), BgL_valza2za2_4048);
								PROCEDURE_SET(BgL_runz00_16180,
									(int) (((long) 2)), ((obj_t) BgL_i1252z00_16808));
								PROCEDURE_SET(BgL_runz00_16180,
									(int) (((long) 3)), BgL_bodyz00_16809);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16181;

									BgL_mainz00_16181 =
										MAKE_FX_PROCEDURE(BGl_z62main5505z62zz__evaluate_compz00,
										(int) (((long) 2)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_mainz00_16181,
										(int) (((long) 0)), BINT(BgL_siza7eza7_16807));
									PROCEDURE_SET(BgL_mainz00_16181,
										(int) (((long) 1)), BgL_valza2za2_4048);
									PROCEDURE_SET(BgL_mainz00_16181,
										(int) (((long) 2)), ((obj_t) BgL_i1252z00_16808));
									PROCEDURE_SET(BgL_mainz00_16181,
										(int) (((long) 3)), BgL_bodyz00_16809);
									PROCEDURE_SET(BgL_mainz00_16181,
										(int) (((long) 4)), BgL_runz00_16180);
									PROCEDURE_SET(BgL_mainz00_16181,
										(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_16810));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_12819;

										BgL_objz00_12819 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16180, BgL_objz00_12819);
										BgL_objz00_12819;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3391z00_4051;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3392z00_4052;

											BgL_arg3392z00_4052 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16808))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_12823;

												BgL_newz00_12823 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_27292;

													BgL_auxz00_27292 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_12823, BgL_auxz00_27292,
														BgL_arg3392z00_4052);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_27297;
													int BgL_auxz00_27295;

													BgL_auxz00_27297 = BINT(BgL_siza7ezd2framez75_16810);
													BgL_auxz00_27295 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_12823, BgL_auxz00_27295,
														BgL_auxz00_27297);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_27300;

													BgL_auxz00_27300 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_12823, BgL_auxz00_27300,
														BgL_runz00_16180);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_27305;
													int BgL_auxz00_27303;

													BgL_auxz00_27305 = BINT(((long) 2));
													BgL_auxz00_27303 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_12823, BgL_auxz00_27303,
														BgL_auxz00_27305);
												}
												BgL_arg3391z00_4051 = BgL_newz00_12823;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16181, BgL_arg3391z00_4051);
										BgL_arg3391z00_4051;
									}
									return BgL_mainz00_16181;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5505 */
	obj_t BGl_z62main5505z62zz__evaluate_compz00(obj_t BgL_envz00_16812,
		obj_t BgL_cz00_16819, obj_t BgL_dz00_16820)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16817;
				long BgL_siza7ezd2framez75_16818;

				BgL_runz00_16817 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16812, (int) (((long) 4))));
				BgL_siza7ezd2framez75_16818 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16812, (int) (((long) 5))));
				{
					obj_t BgL_cz00_4053;
					obj_t BgL_dz00_4054;

					BgL_cz00_4053 = BgL_cz00_16819;
					BgL_dz00_4054 = BgL_dz00_16820;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_4056;

						BgL_sz00_4056 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_4057;

							BgL_bpz00_4057 = VECTOR_REF(BgL_sz00_4056, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_27318;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_12754;

									BgL_arg1908z00_12754 = VECTOR_LENGTH(BgL_sz00_4056);
									BgL_testz00_27318 =
										(
										((long) CINT(BgL_bpz00_4057) +
											BgL_siza7ezd2framez75_16818) <
										(long) (BgL_arg1908z00_12754));
								}
								if (BgL_testz00_27318)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3395z00_4059;

											BgL_arg3395z00_4059 =
												((long) CINT(BgL_bpz00_4057) + ((long) 0));
											VECTOR_SET(BgL_sz00_4056,
												(int) (BgL_arg3395z00_4059), BgL_cz00_4053);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3396z00_4060;

											BgL_arg3396z00_4060 =
												((long) CINT(BgL_bpz00_4057) + ((long) 1));
											VECTOR_SET(BgL_sz00_4056,
												(int) (BgL_arg3396z00_4060), BgL_dz00_4054);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1387z00_4061;

											BgL_val1387z00_4061 =
												BGl_zc3exitza33400ze3z83zz__evaluate_compz00
												(BgL_bpz00_4057, BgL_sz00_4056, BgL_runz00_16817);
											VECTOR_SET(BgL_sz00_4056, (int) (((long) 0)),
												BgL_bpz00_4057);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1387z00_4061)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1387z00_4061), CDR(BgL_val1387z00_4061));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1387z00_4061;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_4068;

										BgL_nsz00_4068 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4068,
											(int) (((long) 1)), BgL_sz00_4056);
										VECTOR_SET(BgL_nsz00_4068,
											(int) (((long) 2)), BgL_cz00_4053);
										VECTOR_SET(BgL_nsz00_4068,
											(int) (((long) 3)), BgL_dz00_4054);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_27348;

											BgL_auxz00_27348 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_27348, BgL_nsz00_4068);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1390z00_4070;

											BgL_val1390z00_4070 =
												BGl_zc3exitza33406ze3z83zz__evaluate_compz00
												(BgL_runz00_16817, BgL_nsz00_4068);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_27352;

												BgL_auxz00_27352 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_27352, BgL_sz00_4056);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1390z00_4070)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1390z00_4070), CDR(BgL_val1390z00_4070));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1390z00_4070;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3406> */
	obj_t BGl_zc3exitza33406ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17590,
		obj_t BgL_nsz00_17589)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1391z00_4076;

			if (SET_EXIT(BgL_an_exit1391z00_4076))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1391z00_4076 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1391z00_4076, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1392z00_4077;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_12791;

								BgL_savedzd2bpzd2_12791 =
									VECTOR_REF(BgL_nsz00_17589, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17589,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_12798;

									BgL_fz00_12798 = BgL_runz00_17590;
								BgL_recz00_12797:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_12799;

										BgL_rz00_12799 =
											PROCEDURE_ENTRY(BgL_fz00_12798) (BgL_fz00_12798,
											BgL_nsz00_17589, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_27373;

											if (PROCEDUREP(BgL_rz00_12799))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_12804;

													BgL_arg1900z00_12804 = PROCEDURE_ATTR(BgL_rz00_12799);
													if (STRUCTP(BgL_arg1900z00_12804))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_27373 =
																(STRUCT_KEY(BgL_arg1900z00_12804) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_27373 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_27373 = ((bool_t) 0);
												}
											if (BgL_testz00_27373)
												{
													obj_t BgL_fz00_27381;

													BgL_fz00_27381 = BgL_rz00_12799;
													BgL_fz00_12798 = BgL_fz00_27381;
													goto BgL_recz00_12797;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17589,
														(int) (((long) 0)), BgL_savedzd2bpzd2_12791);
													BgL_val1392z00_4077 = BgL_rz00_12799;
							}}}}}
							POP_EXIT();
							return BgL_val1392z00_4077;
						}
					}
				}
		}
	}



/* <exit:3400> */
	obj_t BGl_zc3exitza33400ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17593,
		obj_t BgL_sz00_17592, obj_t BgL_runz00_17591)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1388z00_4066;

			if (SET_EXIT(BgL_an_exit1388z00_4066))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1388z00_4066 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1388z00_4066, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1389z00_4067;

							BgL_val1389z00_4067 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17591,
								BgL_sz00_17592, BgL_bpz00_17593);
							POP_EXIT();
							return BgL_val1389z00_4067;
						}
					}
				}
		}
	}



/* &run5506 */
	obj_t BGl_z62run5506z62zz__evaluate_compz00(obj_t BgL_envz00_16821,
		obj_t BgL_sz00_16826)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				long BgL_siza7eza7_16822;
				obj_t BgL_valza2za2_16823;
				BgL_ev_absz00_bglt BgL_i1252z00_16824;
				obj_t BgL_bodyz00_16825;

				BgL_siza7eza7_16822 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16821, (int) (((long) 0))));
				BgL_valza2za2_16823 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16821, (int) (((long) 1))));
				BgL_i1252z00_16824 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16821, (int) (((long) 2))));
				BgL_bodyz00_16825 = PROCEDURE_REF(BgL_envz00_16821, (int) (((long) 3)));
				{
					obj_t BgL_sz00_4079;

					BgL_sz00_4079 = BgL_sz00_16826;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4081;

						BgL_bpz00_4081 = VECTOR_REF(BgL_sz00_4079, (int) (((long) 0)));
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_4079,
							BgL_valza2za2_16823,
							((long) CINT(BgL_bpz00_4081) + BgL_siza7eza7_16822));
						{	/* Eval/evaluate_comp.scm 1049 */
							obj_t BgL_z12denvz12_4083;
							obj_t BgL_wherez00_4084;
							obj_t BgL_locz00_4085;

							BgL_z12denvz12_4083 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4084 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16824))->BgL_wherez00);
							BgL_locz00_4085 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16824))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1049 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4083, BgL_wherez00_4084,
									BgL_locz00_4085);
								{	/* Eval/evaluate_comp.scm 1049 */
									obj_t BgL_za2za2resza2za2z00_4086;

									BgL_za2za2resza2za2z00_4086 =
										PROCEDURE_ENTRY(BgL_bodyz00_16825) (BgL_bodyz00_16825,
										BgL_sz00_4079, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4083);
									return BgL_za2za2resza2za2z00_4086;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3409> */
	obj_t BGl_z62zc3anonymousza33409ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16827, obj_t BgL_sz00_16834)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_ifreesz00_16828;
				obj_t BgL_iboxesz00_16829;
				long BgL_siza7eza7_16830;
				BgL_ev_absz00_bglt BgL_i1252z00_16831;
				obj_t BgL_bodyz00_16832;
				long BgL_siza7ezd2framez75_16833;

				BgL_ifreesz00_16828 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16827, (int) (((long) 0))));
				BgL_iboxesz00_16829 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16827, (int) (((long) 1))));
				BgL_siza7eza7_16830 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16827, (int) (((long) 2))));
				BgL_i1252z00_16831 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16827, (int) (((long) 3))));
				BgL_bodyz00_16832 = PROCEDURE_REF(BgL_envz00_16827, (int) (((long) 4)));
				BgL_siza7ezd2framez75_16833 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16827, (int) (((long) 5))));
				{
					obj_t BgL_sz00_4088;

					BgL_sz00_4088 = BgL_sz00_16834;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4090;

						BgL_bpz00_4090 = VECTOR_REF(BgL_sz00_4088, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_valza2za2_4091;

							BgL_valza2za2_4091 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_4088,
								BgL_bpz00_4090, BgL_ifreesz00_16828);
							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16177;

								BgL_runz00_16177 =
									MAKE_FX_PROCEDURE(BGl_z62run5508z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_runz00_16177,
									(int) (((long) 0)), BgL_iboxesz00_16829);
								PROCEDURE_SET(BgL_runz00_16177,
									(int) (((long) 1)), BINT(BgL_siza7eza7_16830));
								PROCEDURE_SET(BgL_runz00_16177,
									(int) (((long) 2)), BgL_valza2za2_4091);
								PROCEDURE_SET(BgL_runz00_16177,
									(int) (((long) 3)), ((obj_t) BgL_i1252z00_16831));
								PROCEDURE_SET(BgL_runz00_16177,
									(int) (((long) 4)), BgL_bodyz00_16832);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16178;

									BgL_mainz00_16178 =
										MAKE_FX_PROCEDURE(BGl_z62main5507z62zz__evaluate_compz00,
										(int) (((long) 2)), (int) (((long) 7)));
									PROCEDURE_SET(BgL_mainz00_16178,
										(int) (((long) 0)), BgL_iboxesz00_16829);
									PROCEDURE_SET(BgL_mainz00_16178,
										(int) (((long) 1)), BINT(BgL_siza7eza7_16830));
									PROCEDURE_SET(BgL_mainz00_16178,
										(int) (((long) 2)), BgL_valza2za2_4091);
									PROCEDURE_SET(BgL_mainz00_16178,
										(int) (((long) 3)), ((obj_t) BgL_i1252z00_16831));
									PROCEDURE_SET(BgL_mainz00_16178,
										(int) (((long) 4)), BgL_bodyz00_16832);
									PROCEDURE_SET(BgL_mainz00_16178,
										(int) (((long) 5)), BgL_runz00_16177);
									PROCEDURE_SET(BgL_mainz00_16178,
										(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_16833));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_12922;

										BgL_objz00_12922 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16177, BgL_objz00_12922);
										BgL_objz00_12922;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3410z00_4094;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3411z00_4095;

											BgL_arg3411z00_4095 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16831))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_12926;

												BgL_newz00_12926 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_27474;

													BgL_auxz00_27474 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_12926, BgL_auxz00_27474,
														BgL_arg3411z00_4095);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_27479;
													int BgL_auxz00_27477;

													BgL_auxz00_27479 = BINT(BgL_siza7ezd2framez75_16833);
													BgL_auxz00_27477 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_12926, BgL_auxz00_27477,
														BgL_auxz00_27479);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_27482;

													BgL_auxz00_27482 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_12926, BgL_auxz00_27482,
														BgL_runz00_16177);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_27487;
													int BgL_auxz00_27485;

													BgL_auxz00_27487 = BINT(((long) 2));
													BgL_auxz00_27485 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_12926, BgL_auxz00_27485,
														BgL_auxz00_27487);
												}
												BgL_arg3410z00_4094 = BgL_newz00_12926;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16178, BgL_arg3410z00_4094);
										BgL_arg3410z00_4094;
									}
									return BgL_mainz00_16178;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5507 */
	obj_t BGl_z62main5507z62zz__evaluate_compz00(obj_t BgL_envz00_16835,
		obj_t BgL_cz00_16843, obj_t BgL_dz00_16844)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16841;
				long BgL_siza7ezd2framez75_16842;

				BgL_runz00_16841 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16835, (int) (((long) 5))));
				BgL_siza7ezd2framez75_16842 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16835, (int) (((long) 6))));
				{
					obj_t BgL_cz00_4096;
					obj_t BgL_dz00_4097;

					BgL_cz00_4096 = BgL_cz00_16843;
					BgL_dz00_4097 = BgL_dz00_16844;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_4099;

						BgL_sz00_4099 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_4100;

							BgL_bpz00_4100 = VECTOR_REF(BgL_sz00_4099, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_27500;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_12857;

									BgL_arg1908z00_12857 = VECTOR_LENGTH(BgL_sz00_4099);
									BgL_testz00_27500 =
										(
										((long) CINT(BgL_bpz00_4100) +
											BgL_siza7ezd2framez75_16842) <
										(long) (BgL_arg1908z00_12857));
								}
								if (BgL_testz00_27500)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3414z00_4102;

											BgL_arg3414z00_4102 =
												((long) CINT(BgL_bpz00_4100) + ((long) 0));
											VECTOR_SET(BgL_sz00_4099,
												(int) (BgL_arg3414z00_4102), BgL_cz00_4096);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3416z00_4103;

											BgL_arg3416z00_4103 =
												((long) CINT(BgL_bpz00_4100) + ((long) 1));
											VECTOR_SET(BgL_sz00_4099,
												(int) (BgL_arg3416z00_4103), BgL_dz00_4097);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1393z00_4104;

											BgL_val1393z00_4104 =
												BGl_zc3exitza33420ze3z83zz__evaluate_compz00
												(BgL_bpz00_4100, BgL_sz00_4099, BgL_runz00_16841);
											VECTOR_SET(BgL_sz00_4099, (int) (((long) 0)),
												BgL_bpz00_4100);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1393z00_4104)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1393z00_4104), CDR(BgL_val1393z00_4104));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1393z00_4104;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_4111;

										BgL_nsz00_4111 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_4111,
											(int) (((long) 1)), BgL_sz00_4099);
										VECTOR_SET(BgL_nsz00_4111,
											(int) (((long) 2)), BgL_cz00_4096);
										VECTOR_SET(BgL_nsz00_4111,
											(int) (((long) 3)), BgL_dz00_4097);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_27530;

											BgL_auxz00_27530 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_27530, BgL_nsz00_4111);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1396z00_4113;

											BgL_val1396z00_4113 =
												BGl_zc3exitza33426ze3z83zz__evaluate_compz00
												(BgL_runz00_16841, BgL_nsz00_4111);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_27534;

												BgL_auxz00_27534 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_27534, BgL_sz00_4099);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1396z00_4113)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1396z00_4113), CDR(BgL_val1396z00_4113));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1396z00_4113;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3426> */
	obj_t BGl_zc3exitza33426ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17585,
		obj_t BgL_nsz00_17584)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1397z00_4119;

			if (SET_EXIT(BgL_an_exit1397z00_4119))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1397z00_4119 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1397z00_4119, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1398z00_4120;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_12894;

								BgL_savedzd2bpzd2_12894 =
									VECTOR_REF(BgL_nsz00_17584, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17584,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_12901;

									BgL_fz00_12901 = BgL_runz00_17585;
								BgL_recz00_12900:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_12902;

										BgL_rz00_12902 =
											PROCEDURE_ENTRY(BgL_fz00_12901) (BgL_fz00_12901,
											BgL_nsz00_17584, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_27555;

											if (PROCEDUREP(BgL_rz00_12902))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_12907;

													BgL_arg1900z00_12907 = PROCEDURE_ATTR(BgL_rz00_12902);
													if (STRUCTP(BgL_arg1900z00_12907))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_27555 =
																(STRUCT_KEY(BgL_arg1900z00_12907) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_27555 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_27555 = ((bool_t) 0);
												}
											if (BgL_testz00_27555)
												{
													obj_t BgL_fz00_27563;

													BgL_fz00_27563 = BgL_rz00_12902;
													BgL_fz00_12901 = BgL_fz00_27563;
													goto BgL_recz00_12900;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17584,
														(int) (((long) 0)), BgL_savedzd2bpzd2_12894);
													BgL_val1398z00_4120 = BgL_rz00_12902;
							}}}}}
							POP_EXIT();
							return BgL_val1398z00_4120;
						}
					}
				}
		}
	}



/* <exit:3420> */
	obj_t BGl_zc3exitza33420ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17588,
		obj_t BgL_sz00_17587, obj_t BgL_runz00_17586)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1394z00_4109;

			if (SET_EXIT(BgL_an_exit1394z00_4109))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1394z00_4109 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1394z00_4109, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1395z00_4110;

							BgL_val1395z00_4110 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17586,
								BgL_sz00_17587, BgL_bpz00_17588);
							POP_EXIT();
							return BgL_val1395z00_4110;
						}
					}
				}
		}
	}



/* &run5508 */
	obj_t BGl_z62run5508z62zz__evaluate_compz00(obj_t BgL_envz00_16845,
		obj_t BgL_sz00_16851)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_16846;
				long BgL_siza7eza7_16847;
				obj_t BgL_valza2za2_16848;
				BgL_ev_absz00_bglt BgL_i1252z00_16849;
				obj_t BgL_bodyz00_16850;

				BgL_iboxesz00_16846 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16845, (int) (((long) 0))));
				BgL_siza7eza7_16847 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16845, (int) (((long) 1))));
				BgL_valza2za2_16848 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16845, (int) (((long) 2))));
				BgL_i1252z00_16849 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16845, (int) (((long) 3))));
				BgL_bodyz00_16850 = PROCEDURE_REF(BgL_envz00_16845, (int) (((long) 4)));
				{
					obj_t BgL_sz00_4122;

					BgL_sz00_4122 = BgL_sz00_16851;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_4124;

						BgL_bpz00_4124 = VECTOR_REF(BgL_sz00_4122, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_4122,
							BgL_iboxesz00_16846, BgL_bpz00_4124);
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_4122,
							BgL_valza2za2_16848,
							((long) CINT(BgL_bpz00_4124) + BgL_siza7eza7_16847));
						{	/* Eval/evaluate_comp.scm 1049 */
							obj_t BgL_z12denvz12_4126;
							obj_t BgL_wherez00_4127;
							obj_t BgL_locz00_4128;

							BgL_z12denvz12_4126 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_4127 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16849))->BgL_wherez00);
							BgL_locz00_4128 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16849))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1049 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_4126, BgL_wherez00_4127,
									BgL_locz00_4128);
								{	/* Eval/evaluate_comp.scm 1049 */
									obj_t BgL_za2za2resza2za2z00_4129;

									BgL_za2za2resza2za2z00_4129 =
										PROCEDURE_ENTRY(BgL_bodyz00_16850) (BgL_bodyz00_16850,
										BgL_sz00_4122, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_4126);
									return BgL_za2za2resza2za2z00_4129;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3268> */
	obj_t BGl_z62zc3anonymousza33268ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16852, obj_t BgL_sz00_16856)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_16853;
				obj_t BgL_bodyz00_16854;
				long BgL_siza7ezd2framez75_16855;

				BgL_i1252z00_16853 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16852, (int) (((long) 0))));
				BgL_bodyz00_16854 = PROCEDURE_REF(BgL_envz00_16852, (int) (((long) 1)));
				BgL_siza7ezd2framez75_16855 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16852, (int) (((long) 2))));
				{
					obj_t BgL_sz00_3787;

					BgL_sz00_3787 = BgL_sz00_16856;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3789;

						BgL_bpz00_3789 = VECTOR_REF(BgL_sz00_3787, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */

							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16174;

								BgL_runz00_16174 =
									MAKE_FX_PROCEDURE(BGl_z62run5510z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_runz00_16174,
									(int) (((long) 0)), ((obj_t) BgL_i1252z00_16853));
								PROCEDURE_SET(BgL_runz00_16174,
									(int) (((long) 1)), BgL_bodyz00_16854);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16175;

									BgL_mainz00_16175 =
										MAKE_VA_PROCEDURE(BGl_z62main5509z62zz__evaluate_compz00,
										(int) (((long) -2)), (int) (((long) 4)));
									PROCEDURE_SET(BgL_mainz00_16175,
										(int) (((long) 0)), ((obj_t) BgL_i1252z00_16853));
									PROCEDURE_SET(BgL_mainz00_16175,
										(int) (((long) 1)), BgL_bodyz00_16854);
									PROCEDURE_SET(BgL_mainz00_16175,
										(int) (((long) 2)), BgL_runz00_16174);
									PROCEDURE_SET(BgL_mainz00_16175,
										(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_16855));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_12194;

										BgL_objz00_12194 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16174, BgL_objz00_12194);
										BgL_objz00_12194;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3269z00_3792;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3270z00_3793;

											BgL_arg3270z00_3793 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16853))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_12198;

												BgL_newz00_12198 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_27636;

													BgL_auxz00_27636 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_12198, BgL_auxz00_27636,
														BgL_arg3270z00_3793);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_27641;
													int BgL_auxz00_27639;

													BgL_auxz00_27641 = BINT(BgL_siza7ezd2framez75_16855);
													BgL_auxz00_27639 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_12198, BgL_auxz00_27639,
														BgL_auxz00_27641);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_27644;

													BgL_auxz00_27644 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_12198, BgL_auxz00_27644,
														BgL_runz00_16174);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_27649;
													int BgL_auxz00_27647;

													BgL_auxz00_27649 = BINT(((long) -2));
													BgL_auxz00_27647 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_12198, BgL_auxz00_27647,
														BgL_auxz00_27649);
												}
												BgL_arg3269z00_3792 = BgL_newz00_12198;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16175, BgL_arg3269z00_3792);
										BgL_arg3269z00_3792;
									}
									return BgL_mainz00_16175;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5509 */
	obj_t BGl_z62main5509z62zz__evaluate_compz00(obj_t BgL_envz00_16857,
		obj_t BgL_dz00_16862, obj_t BgL_lastz00_16863)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16860;
				long BgL_siza7ezd2framez75_16861;

				BgL_runz00_16860 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16857, (int) (((long) 2))));
				BgL_siza7ezd2framez75_16861 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16857, (int) (((long) 3))));
				{
					obj_t BgL_dz00_3794;
					obj_t BgL_lastz00_3795;

					BgL_dz00_3794 = BgL_dz00_16862;
					BgL_lastz00_3795 = BgL_lastz00_16863;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_3797;

						BgL_sz00_3797 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_3798;

							BgL_bpz00_3798 = VECTOR_REF(BgL_sz00_3797, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_27662;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_12129;

									BgL_arg1908z00_12129 = VECTOR_LENGTH(BgL_sz00_3797);
									BgL_testz00_27662 =
										(
										((long) CINT(BgL_bpz00_3798) +
											BgL_siza7ezd2framez75_16861) <
										(long) (BgL_arg1908z00_12129));
								}
								if (BgL_testz00_27662)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3273z00_3800;

											BgL_arg3273z00_3800 =
												((long) CINT(BgL_bpz00_3798) + ((long) 0));
											VECTOR_SET(BgL_sz00_3797,
												(int) (BgL_arg3273z00_3800), BgL_dz00_3794);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3274z00_3801;

											BgL_arg3274z00_3801 =
												((long) CINT(BgL_bpz00_3798) + ((long) 1));
											VECTOR_SET(BgL_sz00_3797,
												(int) (BgL_arg3274z00_3801), BgL_lastz00_3795);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1351z00_3802;

											BgL_val1351z00_3802 =
												BGl_zc3exitza33278ze3z83zz__evaluate_compz00
												(BgL_bpz00_3798, BgL_sz00_3797, BgL_runz00_16860);
											VECTOR_SET(BgL_sz00_3797, (int) (((long) 0)),
												BgL_bpz00_3798);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1351z00_3802)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1351z00_3802), CDR(BgL_val1351z00_3802));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1351z00_3802;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_3809;

										BgL_nsz00_3809 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_3809,
											(int) (((long) 1)), BgL_sz00_3797);
										VECTOR_SET(BgL_nsz00_3809,
											(int) (((long) 2)), BgL_dz00_3794);
										VECTOR_SET(BgL_nsz00_3809,
											(int) (((long) 3)), BgL_lastz00_3795);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_27692;

											BgL_auxz00_27692 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_27692, BgL_nsz00_3809);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1354z00_3811;

											BgL_val1354z00_3811 =
												BGl_zc3exitza33284ze3z83zz__evaluate_compz00
												(BgL_runz00_16860, BgL_nsz00_3809);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_27696;

												BgL_auxz00_27696 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_27696, BgL_sz00_3797);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1354z00_3811)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1354z00_3811), CDR(BgL_val1354z00_3811));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1354z00_3811;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3284> */
	obj_t BGl_zc3exitza33284ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17580,
		obj_t BgL_nsz00_17579)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1355z00_3817;

			if (SET_EXIT(BgL_an_exit1355z00_3817))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1355z00_3817 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1355z00_3817, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1356z00_3818;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_12166;

								BgL_savedzd2bpzd2_12166 =
									VECTOR_REF(BgL_nsz00_17579, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17579,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_12173;

									BgL_fz00_12173 = BgL_runz00_17580;
								BgL_recz00_12172:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_12174;

										BgL_rz00_12174 =
											PROCEDURE_ENTRY(BgL_fz00_12173) (BgL_fz00_12173,
											BgL_nsz00_17579, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_27717;

											if (PROCEDUREP(BgL_rz00_12174))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_12179;

													BgL_arg1900z00_12179 = PROCEDURE_ATTR(BgL_rz00_12174);
													if (STRUCTP(BgL_arg1900z00_12179))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_27717 =
																(STRUCT_KEY(BgL_arg1900z00_12179) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_27717 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_27717 = ((bool_t) 0);
												}
											if (BgL_testz00_27717)
												{
													obj_t BgL_fz00_27725;

													BgL_fz00_27725 = BgL_rz00_12174;
													BgL_fz00_12173 = BgL_fz00_27725;
													goto BgL_recz00_12172;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17579,
														(int) (((long) 0)), BgL_savedzd2bpzd2_12166);
													BgL_val1356z00_3818 = BgL_rz00_12174;
							}}}}}
							POP_EXIT();
							return BgL_val1356z00_3818;
						}
					}
				}
		}
	}



/* <exit:3278> */
	obj_t BGl_zc3exitza33278ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17583,
		obj_t BgL_sz00_17582, obj_t BgL_runz00_17581)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1352z00_3807;

			if (SET_EXIT(BgL_an_exit1352z00_3807))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1352z00_3807 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1352z00_3807, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1353z00_3808;

							BgL_val1353z00_3808 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17581,
								BgL_sz00_17582, BgL_bpz00_17583);
							POP_EXIT();
							return BgL_val1353z00_3808;
						}
					}
				}
		}
	}



/* &run5510 */
	obj_t BGl_z62run5510z62zz__evaluate_compz00(obj_t BgL_envz00_16864,
		obj_t BgL_sz00_16867)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_16865;
				obj_t BgL_bodyz00_16866;

				BgL_i1252z00_16865 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16864, (int) (((long) 0))));
				BgL_bodyz00_16866 = PROCEDURE_REF(BgL_envz00_16864, (int) (((long) 1)));
				{
					obj_t BgL_sz00_3820;

					BgL_sz00_3820 = BgL_sz00_16867;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3822;

						BgL_bpz00_3822 = VECTOR_REF(BgL_sz00_3820, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_z12denvz12_3823;
							obj_t BgL_wherez00_3824;
							obj_t BgL_locz00_3825;

							BgL_z12denvz12_3823 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_3824 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16865))->BgL_wherez00);
							BgL_locz00_3825 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16865))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1129 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_3823, BgL_wherez00_3824,
									BgL_locz00_3825);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_za2za2resza2za2z00_3826;

									BgL_za2za2resza2za2z00_3826 =
										PROCEDURE_ENTRY(BgL_bodyz00_16866) (BgL_bodyz00_16866,
										BgL_sz00_3820, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_3823);
									return BgL_za2za2resza2za2z00_3826;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3286> */
	obj_t BGl_z62zc3anonymousza33286ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16868, obj_t BgL_sz00_16873)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_16869;
				BgL_ev_absz00_bglt BgL_i1252z00_16870;
				obj_t BgL_bodyz00_16871;
				long BgL_siza7ezd2framez75_16872;

				BgL_iboxesz00_16869 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16868, (int) (((long) 0))));
				BgL_i1252z00_16870 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16868, (int) (((long) 1))));
				BgL_bodyz00_16871 = PROCEDURE_REF(BgL_envz00_16868, (int) (((long) 2)));
				BgL_siza7ezd2framez75_16872 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16868, (int) (((long) 3))));
				{
					obj_t BgL_sz00_3828;

					BgL_sz00_3828 = BgL_sz00_16873;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3830;

						BgL_bpz00_3830 = VECTOR_REF(BgL_sz00_3828, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */

							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16171;

								BgL_runz00_16171 =
									MAKE_FX_PROCEDURE(BGl_z62run5512z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_runz00_16171,
									(int) (((long) 0)), BgL_iboxesz00_16869);
								PROCEDURE_SET(BgL_runz00_16171,
									(int) (((long) 1)), ((obj_t) BgL_i1252z00_16870));
								PROCEDURE_SET(BgL_runz00_16171,
									(int) (((long) 2)), BgL_bodyz00_16871);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16172;

									BgL_mainz00_16172 =
										MAKE_VA_PROCEDURE(BGl_z62main5511z62zz__evaluate_compz00,
										(int) (((long) -2)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_mainz00_16172,
										(int) (((long) 0)), BgL_iboxesz00_16869);
									PROCEDURE_SET(BgL_mainz00_16172,
										(int) (((long) 1)), ((obj_t) BgL_i1252z00_16870));
									PROCEDURE_SET(BgL_mainz00_16172,
										(int) (((long) 2)), BgL_bodyz00_16871);
									PROCEDURE_SET(BgL_mainz00_16172,
										(int) (((long) 3)), BgL_runz00_16171);
									PROCEDURE_SET(BgL_mainz00_16172,
										(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_16872));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_12294;

										BgL_objz00_12294 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16171, BgL_objz00_12294);
										BgL_objz00_12294;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3287z00_3833;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3288z00_3834;

											BgL_arg3288z00_3834 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16870))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_12298;

												BgL_newz00_12298 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_27792;

													BgL_auxz00_27792 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_12298, BgL_auxz00_27792,
														BgL_arg3288z00_3834);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_27797;
													int BgL_auxz00_27795;

													BgL_auxz00_27797 = BINT(BgL_siza7ezd2framez75_16872);
													BgL_auxz00_27795 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_12298, BgL_auxz00_27795,
														BgL_auxz00_27797);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_27800;

													BgL_auxz00_27800 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_12298, BgL_auxz00_27800,
														BgL_runz00_16171);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_27805;
													int BgL_auxz00_27803;

													BgL_auxz00_27805 = BINT(((long) -2));
													BgL_auxz00_27803 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_12298, BgL_auxz00_27803,
														BgL_auxz00_27805);
												}
												BgL_arg3287z00_3833 = BgL_newz00_12298;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16172, BgL_arg3287z00_3833);
										BgL_arg3287z00_3833;
									}
									return BgL_mainz00_16172;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5511 */
	obj_t BGl_z62main5511z62zz__evaluate_compz00(obj_t BgL_envz00_16874,
		obj_t BgL_dz00_16880, obj_t BgL_lastz00_16881)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16878;
				long BgL_siza7ezd2framez75_16879;

				BgL_runz00_16878 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16874, (int) (((long) 3))));
				BgL_siza7ezd2framez75_16879 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16874, (int) (((long) 4))));
				{
					obj_t BgL_dz00_3835;
					obj_t BgL_lastz00_3836;

					BgL_dz00_3835 = BgL_dz00_16880;
					BgL_lastz00_3836 = BgL_lastz00_16881;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_3838;

						BgL_sz00_3838 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_3839;

							BgL_bpz00_3839 = VECTOR_REF(BgL_sz00_3838, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_27818;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_12229;

									BgL_arg1908z00_12229 = VECTOR_LENGTH(BgL_sz00_3838);
									BgL_testz00_27818 =
										(
										((long) CINT(BgL_bpz00_3839) +
											BgL_siza7ezd2framez75_16879) <
										(long) (BgL_arg1908z00_12229));
								}
								if (BgL_testz00_27818)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3291z00_3841;

											BgL_arg3291z00_3841 =
												((long) CINT(BgL_bpz00_3839) + ((long) 0));
											VECTOR_SET(BgL_sz00_3838,
												(int) (BgL_arg3291z00_3841), BgL_dz00_3835);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3292z00_3842;

											BgL_arg3292z00_3842 =
												((long) CINT(BgL_bpz00_3839) + ((long) 1));
											VECTOR_SET(BgL_sz00_3838,
												(int) (BgL_arg3292z00_3842), BgL_lastz00_3836);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1357z00_3843;

											BgL_val1357z00_3843 =
												BGl_zc3exitza33296ze3z83zz__evaluate_compz00
												(BgL_bpz00_3839, BgL_sz00_3838, BgL_runz00_16878);
											VECTOR_SET(BgL_sz00_3838, (int) (((long) 0)),
												BgL_bpz00_3839);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1357z00_3843)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1357z00_3843), CDR(BgL_val1357z00_3843));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1357z00_3843;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_3850;

										BgL_nsz00_3850 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_3850,
											(int) (((long) 1)), BgL_sz00_3838);
										VECTOR_SET(BgL_nsz00_3850,
											(int) (((long) 2)), BgL_dz00_3835);
										VECTOR_SET(BgL_nsz00_3850,
											(int) (((long) 3)), BgL_lastz00_3836);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_27848;

											BgL_auxz00_27848 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_27848, BgL_nsz00_3850);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1360z00_3852;

											BgL_val1360z00_3852 =
												BGl_zc3exitza33302ze3z83zz__evaluate_compz00
												(BgL_runz00_16878, BgL_nsz00_3850);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_27852;

												BgL_auxz00_27852 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_27852, BgL_sz00_3838);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1360z00_3852)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1360z00_3852), CDR(BgL_val1360z00_3852));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1360z00_3852;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3302> */
	obj_t BGl_zc3exitza33302ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17575,
		obj_t BgL_nsz00_17574)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1361z00_3858;

			if (SET_EXIT(BgL_an_exit1361z00_3858))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1361z00_3858 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1361z00_3858, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1362z00_3859;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_12266;

								BgL_savedzd2bpzd2_12266 =
									VECTOR_REF(BgL_nsz00_17574, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17574,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_12273;

									BgL_fz00_12273 = BgL_runz00_17575;
								BgL_recz00_12272:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_12274;

										BgL_rz00_12274 =
											PROCEDURE_ENTRY(BgL_fz00_12273) (BgL_fz00_12273,
											BgL_nsz00_17574, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_27873;

											if (PROCEDUREP(BgL_rz00_12274))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_12279;

													BgL_arg1900z00_12279 = PROCEDURE_ATTR(BgL_rz00_12274);
													if (STRUCTP(BgL_arg1900z00_12279))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_27873 =
																(STRUCT_KEY(BgL_arg1900z00_12279) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_27873 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_27873 = ((bool_t) 0);
												}
											if (BgL_testz00_27873)
												{
													obj_t BgL_fz00_27881;

													BgL_fz00_27881 = BgL_rz00_12274;
													BgL_fz00_12273 = BgL_fz00_27881;
													goto BgL_recz00_12272;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17574,
														(int) (((long) 0)), BgL_savedzd2bpzd2_12266);
													BgL_val1362z00_3859 = BgL_rz00_12274;
							}}}}}
							POP_EXIT();
							return BgL_val1362z00_3859;
						}
					}
				}
		}
	}



/* <exit:3296> */
	obj_t BGl_zc3exitza33296ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17578,
		obj_t BgL_sz00_17577, obj_t BgL_runz00_17576)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1358z00_3848;

			if (SET_EXIT(BgL_an_exit1358z00_3848))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1358z00_3848 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1358z00_3848, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1359z00_3849;

							BgL_val1359z00_3849 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17576,
								BgL_sz00_17577, BgL_bpz00_17578);
							POP_EXIT();
							return BgL_val1359z00_3849;
						}
					}
				}
		}
	}



/* &run5512 */
	obj_t BGl_z62run5512z62zz__evaluate_compz00(obj_t BgL_envz00_16882,
		obj_t BgL_sz00_16886)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_16883;
				BgL_ev_absz00_bglt BgL_i1252z00_16884;
				obj_t BgL_bodyz00_16885;

				BgL_iboxesz00_16883 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16882, (int) (((long) 0))));
				BgL_i1252z00_16884 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16882, (int) (((long) 1))));
				BgL_bodyz00_16885 = PROCEDURE_REF(BgL_envz00_16882, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3861;

					BgL_sz00_3861 = BgL_sz00_16886;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3863;

						BgL_bpz00_3863 = VECTOR_REF(BgL_sz00_3861, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_3861,
							BgL_iboxesz00_16883, BgL_bpz00_3863);
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_z12denvz12_3864;
							obj_t BgL_wherez00_3865;
							obj_t BgL_locz00_3866;

							BgL_z12denvz12_3864 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_3865 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16884))->BgL_wherez00);
							BgL_locz00_3866 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16884))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1129 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_3864, BgL_wherez00_3865,
									BgL_locz00_3866);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_za2za2resza2za2z00_3867;

									BgL_za2za2resza2za2z00_3867 =
										PROCEDURE_ENTRY(BgL_bodyz00_16885) (BgL_bodyz00_16885,
										BgL_sz00_3861, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_3864);
									return BgL_za2za2resza2za2z00_3867;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3306> */
	obj_t BGl_z62zc3anonymousza33306ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16887, obj_t BgL_sz00_16893)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_ifreesz00_16888;
				long BgL_siza7eza7_16889;
				BgL_ev_absz00_bglt BgL_i1252z00_16890;
				obj_t BgL_bodyz00_16891;
				long BgL_siza7ezd2framez75_16892;

				BgL_ifreesz00_16888 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16887, (int) (((long) 0))));
				BgL_siza7eza7_16889 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16887, (int) (((long) 1))));
				BgL_i1252z00_16890 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16887, (int) (((long) 2))));
				BgL_bodyz00_16891 = PROCEDURE_REF(BgL_envz00_16887, (int) (((long) 3)));
				BgL_siza7ezd2framez75_16892 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16887, (int) (((long) 4))));
				{
					obj_t BgL_sz00_3871;

					BgL_sz00_3871 = BgL_sz00_16893;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3873;

						BgL_bpz00_3873 = VECTOR_REF(BgL_sz00_3871, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_valza2za2_3874;

							BgL_valza2za2_3874 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_3871,
								BgL_bpz00_3873, BgL_ifreesz00_16888);
							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16168;

								BgL_runz00_16168 =
									MAKE_FX_PROCEDURE(BGl_z62run5514z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_runz00_16168,
									(int) (((long) 0)), BINT(BgL_siza7eza7_16889));
								PROCEDURE_SET(BgL_runz00_16168,
									(int) (((long) 1)), BgL_valza2za2_3874);
								PROCEDURE_SET(BgL_runz00_16168,
									(int) (((long) 2)), ((obj_t) BgL_i1252z00_16890));
								PROCEDURE_SET(BgL_runz00_16168,
									(int) (((long) 3)), BgL_bodyz00_16891);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16169;

									BgL_mainz00_16169 =
										MAKE_VA_PROCEDURE(BGl_z62main5513z62zz__evaluate_compz00,
										(int) (((long) -2)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_mainz00_16169,
										(int) (((long) 0)), BINT(BgL_siza7eza7_16889));
									PROCEDURE_SET(BgL_mainz00_16169,
										(int) (((long) 1)), BgL_valza2za2_3874);
									PROCEDURE_SET(BgL_mainz00_16169,
										(int) (((long) 2)), ((obj_t) BgL_i1252z00_16890));
									PROCEDURE_SET(BgL_mainz00_16169,
										(int) (((long) 3)), BgL_bodyz00_16891);
									PROCEDURE_SET(BgL_mainz00_16169,
										(int) (((long) 4)), BgL_runz00_16168);
									PROCEDURE_SET(BgL_mainz00_16169,
										(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_16892));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_12401;

										BgL_objz00_12401 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16168, BgL_objz00_12401);
										BgL_objz00_12401;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3307z00_3877;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3308z00_3878;

											BgL_arg3308z00_3878 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16890))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_12405;

												BgL_newz00_12405 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_27962;

													BgL_auxz00_27962 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_12405, BgL_auxz00_27962,
														BgL_arg3308z00_3878);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_27967;
													int BgL_auxz00_27965;

													BgL_auxz00_27967 = BINT(BgL_siza7ezd2framez75_16892);
													BgL_auxz00_27965 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_12405, BgL_auxz00_27965,
														BgL_auxz00_27967);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_27970;

													BgL_auxz00_27970 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_12405, BgL_auxz00_27970,
														BgL_runz00_16168);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_27975;
													int BgL_auxz00_27973;

													BgL_auxz00_27975 = BINT(((long) -2));
													BgL_auxz00_27973 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_12405, BgL_auxz00_27973,
														BgL_auxz00_27975);
												}
												BgL_arg3307z00_3877 = BgL_newz00_12405;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16169, BgL_arg3307z00_3877);
										BgL_arg3307z00_3877;
									}
									return BgL_mainz00_16169;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5513 */
	obj_t BGl_z62main5513z62zz__evaluate_compz00(obj_t BgL_envz00_16894,
		obj_t BgL_dz00_16901, obj_t BgL_lastz00_16902)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16899;
				long BgL_siza7ezd2framez75_16900;

				BgL_runz00_16899 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16894, (int) (((long) 4))));
				BgL_siza7ezd2framez75_16900 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16894, (int) (((long) 5))));
				{
					obj_t BgL_dz00_3879;
					obj_t BgL_lastz00_3880;

					BgL_dz00_3879 = BgL_dz00_16901;
					BgL_lastz00_3880 = BgL_lastz00_16902;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_3882;

						BgL_sz00_3882 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_3883;

							BgL_bpz00_3883 = VECTOR_REF(BgL_sz00_3882, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_27988;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_12336;

									BgL_arg1908z00_12336 = VECTOR_LENGTH(BgL_sz00_3882);
									BgL_testz00_27988 =
										(
										((long) CINT(BgL_bpz00_3883) +
											BgL_siza7ezd2framez75_16900) <
										(long) (BgL_arg1908z00_12336));
								}
								if (BgL_testz00_27988)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3311z00_3885;

											BgL_arg3311z00_3885 =
												((long) CINT(BgL_bpz00_3883) + ((long) 0));
											VECTOR_SET(BgL_sz00_3882,
												(int) (BgL_arg3311z00_3885), BgL_dz00_3879);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3312z00_3886;

											BgL_arg3312z00_3886 =
												((long) CINT(BgL_bpz00_3883) + ((long) 1));
											VECTOR_SET(BgL_sz00_3882,
												(int) (BgL_arg3312z00_3886), BgL_lastz00_3880);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1363z00_3887;

											BgL_val1363z00_3887 =
												BGl_zc3exitza33316ze3z83zz__evaluate_compz00
												(BgL_bpz00_3883, BgL_sz00_3882, BgL_runz00_16899);
											VECTOR_SET(BgL_sz00_3882, (int) (((long) 0)),
												BgL_bpz00_3883);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1363z00_3887)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1363z00_3887), CDR(BgL_val1363z00_3887));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1363z00_3887;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_3894;

										BgL_nsz00_3894 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_3894,
											(int) (((long) 1)), BgL_sz00_3882);
										VECTOR_SET(BgL_nsz00_3894,
											(int) (((long) 2)), BgL_dz00_3879);
										VECTOR_SET(BgL_nsz00_3894,
											(int) (((long) 3)), BgL_lastz00_3880);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_28018;

											BgL_auxz00_28018 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_28018, BgL_nsz00_3894);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1366z00_3896;

											BgL_val1366z00_3896 =
												BGl_zc3exitza33322ze3z83zz__evaluate_compz00
												(BgL_runz00_16899, BgL_nsz00_3894);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_28022;

												BgL_auxz00_28022 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_28022, BgL_sz00_3882);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1366z00_3896)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1366z00_3896), CDR(BgL_val1366z00_3896));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1366z00_3896;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3322> */
	obj_t BGl_zc3exitza33322ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17570,
		obj_t BgL_nsz00_17569)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1367z00_3902;

			if (SET_EXIT(BgL_an_exit1367z00_3902))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1367z00_3902 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1367z00_3902, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1368z00_3903;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_12373;

								BgL_savedzd2bpzd2_12373 =
									VECTOR_REF(BgL_nsz00_17569, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17569,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_12380;

									BgL_fz00_12380 = BgL_runz00_17570;
								BgL_recz00_12379:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_12381;

										BgL_rz00_12381 =
											PROCEDURE_ENTRY(BgL_fz00_12380) (BgL_fz00_12380,
											BgL_nsz00_17569, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_28043;

											if (PROCEDUREP(BgL_rz00_12381))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_12386;

													BgL_arg1900z00_12386 = PROCEDURE_ATTR(BgL_rz00_12381);
													if (STRUCTP(BgL_arg1900z00_12386))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_28043 =
																(STRUCT_KEY(BgL_arg1900z00_12386) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_28043 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_28043 = ((bool_t) 0);
												}
											if (BgL_testz00_28043)
												{
													obj_t BgL_fz00_28051;

													BgL_fz00_28051 = BgL_rz00_12381;
													BgL_fz00_12380 = BgL_fz00_28051;
													goto BgL_recz00_12379;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17569,
														(int) (((long) 0)), BgL_savedzd2bpzd2_12373);
													BgL_val1368z00_3903 = BgL_rz00_12381;
							}}}}}
							POP_EXIT();
							return BgL_val1368z00_3903;
						}
					}
				}
		}
	}



/* <exit:3316> */
	obj_t BGl_zc3exitza33316ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17573,
		obj_t BgL_sz00_17572, obj_t BgL_runz00_17571)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1364z00_3892;

			if (SET_EXIT(BgL_an_exit1364z00_3892))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1364z00_3892 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1364z00_3892, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1365z00_3893;

							BgL_val1365z00_3893 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17571,
								BgL_sz00_17572, BgL_bpz00_17573);
							POP_EXIT();
							return BgL_val1365z00_3893;
						}
					}
				}
		}
	}



/* &run5514 */
	obj_t BGl_z62run5514z62zz__evaluate_compz00(obj_t BgL_envz00_16903,
		obj_t BgL_sz00_16908)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				long BgL_siza7eza7_16904;
				obj_t BgL_valza2za2_16905;
				BgL_ev_absz00_bglt BgL_i1252z00_16906;
				obj_t BgL_bodyz00_16907;

				BgL_siza7eza7_16904 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16903, (int) (((long) 0))));
				BgL_valza2za2_16905 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16903, (int) (((long) 1))));
				BgL_i1252z00_16906 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16903, (int) (((long) 2))));
				BgL_bodyz00_16907 = PROCEDURE_REF(BgL_envz00_16903, (int) (((long) 3)));
				{
					obj_t BgL_sz00_3905;

					BgL_sz00_3905 = BgL_sz00_16908;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3907;

						BgL_bpz00_3907 = VECTOR_REF(BgL_sz00_3905, (int) (((long) 0)));
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_3905,
							BgL_valza2za2_16905,
							((long) CINT(BgL_bpz00_3907) + BgL_siza7eza7_16904));
						{	/* Eval/evaluate_comp.scm 1049 */
							obj_t BgL_z12denvz12_3909;
							obj_t BgL_wherez00_3910;
							obj_t BgL_locz00_3911;

							BgL_z12denvz12_3909 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_3910 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16906))->BgL_wherez00);
							BgL_locz00_3911 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16906))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1049 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_3909, BgL_wherez00_3910,
									BgL_locz00_3911);
								{	/* Eval/evaluate_comp.scm 1049 */
									obj_t BgL_za2za2resza2za2z00_3912;

									BgL_za2za2resza2za2z00_3912 =
										PROCEDURE_ENTRY(BgL_bodyz00_16907) (BgL_bodyz00_16907,
										BgL_sz00_3905, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_3909);
									return BgL_za2za2resza2za2z00_3912;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3325> */
	obj_t BGl_z62zc3anonymousza33325ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16909, obj_t BgL_sz00_16916)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_ifreesz00_16910;
				obj_t BgL_iboxesz00_16911;
				long BgL_siza7eza7_16912;
				BgL_ev_absz00_bglt BgL_i1252z00_16913;
				obj_t BgL_bodyz00_16914;
				long BgL_siza7ezd2framez75_16915;

				BgL_ifreesz00_16910 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16909, (int) (((long) 0))));
				BgL_iboxesz00_16911 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16909, (int) (((long) 1))));
				BgL_siza7eza7_16912 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16909, (int) (((long) 2))));
				BgL_i1252z00_16913 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16909, (int) (((long) 3))));
				BgL_bodyz00_16914 = PROCEDURE_REF(BgL_envz00_16909, (int) (((long) 4)));
				BgL_siza7ezd2framez75_16915 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16909, (int) (((long) 5))));
				{
					obj_t BgL_sz00_3914;

					BgL_sz00_3914 = BgL_sz00_16916;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3916;

						BgL_bpz00_3916 = VECTOR_REF(BgL_sz00_3914, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_valza2za2_3917;

							BgL_valza2za2_3917 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_3914,
								BgL_bpz00_3916, BgL_ifreesz00_16910);
							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16165;

								BgL_runz00_16165 =
									MAKE_FX_PROCEDURE(BGl_z62run5516z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_runz00_16165,
									(int) (((long) 0)), BgL_iboxesz00_16911);
								PROCEDURE_SET(BgL_runz00_16165,
									(int) (((long) 1)), BINT(BgL_siza7eza7_16912));
								PROCEDURE_SET(BgL_runz00_16165,
									(int) (((long) 2)), BgL_valza2za2_3917);
								PROCEDURE_SET(BgL_runz00_16165,
									(int) (((long) 3)), ((obj_t) BgL_i1252z00_16913));
								PROCEDURE_SET(BgL_runz00_16165,
									(int) (((long) 4)), BgL_bodyz00_16914);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16166;

									BgL_mainz00_16166 =
										MAKE_VA_PROCEDURE(BGl_z62main5515z62zz__evaluate_compz00,
										(int) (((long) -2)), (int) (((long) 7)));
									PROCEDURE_SET(BgL_mainz00_16166,
										(int) (((long) 0)), BgL_iboxesz00_16911);
									PROCEDURE_SET(BgL_mainz00_16166,
										(int) (((long) 1)), BINT(BgL_siza7eza7_16912));
									PROCEDURE_SET(BgL_mainz00_16166,
										(int) (((long) 2)), BgL_valza2za2_3917);
									PROCEDURE_SET(BgL_mainz00_16166,
										(int) (((long) 3)), ((obj_t) BgL_i1252z00_16913));
									PROCEDURE_SET(BgL_mainz00_16166,
										(int) (((long) 4)), BgL_bodyz00_16914);
									PROCEDURE_SET(BgL_mainz00_16166,
										(int) (((long) 5)), BgL_runz00_16165);
									PROCEDURE_SET(BgL_mainz00_16166,
										(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_16915));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_12504;

										BgL_objz00_12504 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16165, BgL_objz00_12504);
										BgL_objz00_12504;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3326z00_3920;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3327z00_3921;

											BgL_arg3327z00_3921 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16913))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_12508;

												BgL_newz00_12508 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_28144;

													BgL_auxz00_28144 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_12508, BgL_auxz00_28144,
														BgL_arg3327z00_3921);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_28149;
													int BgL_auxz00_28147;

													BgL_auxz00_28149 = BINT(BgL_siza7ezd2framez75_16915);
													BgL_auxz00_28147 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_12508, BgL_auxz00_28147,
														BgL_auxz00_28149);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_28152;

													BgL_auxz00_28152 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_12508, BgL_auxz00_28152,
														BgL_runz00_16165);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_28157;
													int BgL_auxz00_28155;

													BgL_auxz00_28157 = BINT(((long) -2));
													BgL_auxz00_28155 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_12508, BgL_auxz00_28155,
														BgL_auxz00_28157);
												}
												BgL_arg3326z00_3920 = BgL_newz00_12508;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16166, BgL_arg3326z00_3920);
										BgL_arg3326z00_3920;
									}
									return BgL_mainz00_16166;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5515 */
	obj_t BGl_z62main5515z62zz__evaluate_compz00(obj_t BgL_envz00_16917,
		obj_t BgL_dz00_16925, obj_t BgL_lastz00_16926)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16923;
				long BgL_siza7ezd2framez75_16924;

				BgL_runz00_16923 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16917, (int) (((long) 5))));
				BgL_siza7ezd2framez75_16924 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16917, (int) (((long) 6))));
				{
					obj_t BgL_dz00_3922;
					obj_t BgL_lastz00_3923;

					BgL_dz00_3922 = BgL_dz00_16925;
					BgL_lastz00_3923 = BgL_lastz00_16926;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_3925;

						BgL_sz00_3925 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_3926;

							BgL_bpz00_3926 = VECTOR_REF(BgL_sz00_3925, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_28170;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_12439;

									BgL_arg1908z00_12439 = VECTOR_LENGTH(BgL_sz00_3925);
									BgL_testz00_28170 =
										(
										((long) CINT(BgL_bpz00_3926) +
											BgL_siza7ezd2framez75_16924) <
										(long) (BgL_arg1908z00_12439));
								}
								if (BgL_testz00_28170)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3330z00_3928;

											BgL_arg3330z00_3928 =
												((long) CINT(BgL_bpz00_3926) + ((long) 0));
											VECTOR_SET(BgL_sz00_3925,
												(int) (BgL_arg3330z00_3928), BgL_dz00_3922);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3331z00_3929;

											BgL_arg3331z00_3929 =
												((long) CINT(BgL_bpz00_3926) + ((long) 1));
											VECTOR_SET(BgL_sz00_3925,
												(int) (BgL_arg3331z00_3929), BgL_lastz00_3923);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1369z00_3930;

											BgL_val1369z00_3930 =
												BGl_zc3exitza33335ze3z83zz__evaluate_compz00
												(BgL_bpz00_3926, BgL_sz00_3925, BgL_runz00_16923);
											VECTOR_SET(BgL_sz00_3925, (int) (((long) 0)),
												BgL_bpz00_3926);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1369z00_3930)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1369z00_3930), CDR(BgL_val1369z00_3930));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1369z00_3930;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_3937;

										BgL_nsz00_3937 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_3937,
											(int) (((long) 1)), BgL_sz00_3925);
										VECTOR_SET(BgL_nsz00_3937,
											(int) (((long) 2)), BgL_dz00_3922);
										VECTOR_SET(BgL_nsz00_3937,
											(int) (((long) 3)), BgL_lastz00_3923);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_28200;

											BgL_auxz00_28200 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_28200, BgL_nsz00_3937);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1372z00_3939;

											BgL_val1372z00_3939 =
												BGl_zc3exitza33341ze3z83zz__evaluate_compz00
												(BgL_runz00_16923, BgL_nsz00_3937);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_28204;

												BgL_auxz00_28204 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_28204, BgL_sz00_3925);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1372z00_3939)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1372z00_3939), CDR(BgL_val1372z00_3939));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1372z00_3939;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3341> */
	obj_t BGl_zc3exitza33341ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17565,
		obj_t BgL_nsz00_17564)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1373z00_3945;

			if (SET_EXIT(BgL_an_exit1373z00_3945))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1373z00_3945 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1373z00_3945, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1374z00_3946;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_12476;

								BgL_savedzd2bpzd2_12476 =
									VECTOR_REF(BgL_nsz00_17564, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17564,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_12483;

									BgL_fz00_12483 = BgL_runz00_17565;
								BgL_recz00_12482:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_12484;

										BgL_rz00_12484 =
											PROCEDURE_ENTRY(BgL_fz00_12483) (BgL_fz00_12483,
											BgL_nsz00_17564, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_28225;

											if (PROCEDUREP(BgL_rz00_12484))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_12489;

													BgL_arg1900z00_12489 = PROCEDURE_ATTR(BgL_rz00_12484);
													if (STRUCTP(BgL_arg1900z00_12489))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_28225 =
																(STRUCT_KEY(BgL_arg1900z00_12489) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_28225 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_28225 = ((bool_t) 0);
												}
											if (BgL_testz00_28225)
												{
													obj_t BgL_fz00_28233;

													BgL_fz00_28233 = BgL_rz00_12484;
													BgL_fz00_12483 = BgL_fz00_28233;
													goto BgL_recz00_12482;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17564,
														(int) (((long) 0)), BgL_savedzd2bpzd2_12476);
													BgL_val1374z00_3946 = BgL_rz00_12484;
							}}}}}
							POP_EXIT();
							return BgL_val1374z00_3946;
						}
					}
				}
		}
	}



/* <exit:3335> */
	obj_t BGl_zc3exitza33335ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17568,
		obj_t BgL_sz00_17567, obj_t BgL_runz00_17566)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1370z00_3935;

			if (SET_EXIT(BgL_an_exit1370z00_3935))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1370z00_3935 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1370z00_3935, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1371z00_3936;

							BgL_val1371z00_3936 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17566,
								BgL_sz00_17567, BgL_bpz00_17568);
							POP_EXIT();
							return BgL_val1371z00_3936;
						}
					}
				}
		}
	}



/* &run5516 */
	obj_t BGl_z62run5516z62zz__evaluate_compz00(obj_t BgL_envz00_16927,
		obj_t BgL_sz00_16933)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_16928;
				long BgL_siza7eza7_16929;
				obj_t BgL_valza2za2_16930;
				BgL_ev_absz00_bglt BgL_i1252z00_16931;
				obj_t BgL_bodyz00_16932;

				BgL_iboxesz00_16928 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16927, (int) (((long) 0))));
				BgL_siza7eza7_16929 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16927, (int) (((long) 1))));
				BgL_valza2za2_16930 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16927, (int) (((long) 2))));
				BgL_i1252z00_16931 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16927, (int) (((long) 3))));
				BgL_bodyz00_16932 = PROCEDURE_REF(BgL_envz00_16927, (int) (((long) 4)));
				{
					obj_t BgL_sz00_3948;

					BgL_sz00_3948 = BgL_sz00_16933;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3950;

						BgL_bpz00_3950 = VECTOR_REF(BgL_sz00_3948, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_3948,
							BgL_iboxesz00_16928, BgL_bpz00_3950);
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_3948,
							BgL_valza2za2_16930,
							((long) CINT(BgL_bpz00_3950) + BgL_siza7eza7_16929));
						{	/* Eval/evaluate_comp.scm 1049 */
							obj_t BgL_z12denvz12_3952;
							obj_t BgL_wherez00_3953;
							obj_t BgL_locz00_3954;

							BgL_z12denvz12_3952 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_3953 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16931))->BgL_wherez00);
							BgL_locz00_3954 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16931))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1049 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_3952, BgL_wherez00_3953,
									BgL_locz00_3954);
								{	/* Eval/evaluate_comp.scm 1049 */
									obj_t BgL_za2za2resza2za2z00_3955;

									BgL_za2za2resza2za2z00_3955 =
										PROCEDURE_ENTRY(BgL_bodyz00_16932) (BgL_bodyz00_16932,
										BgL_sz00_3948, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_3952);
									return BgL_za2za2resza2za2z00_3955;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3190> */
	obj_t BGl_z62zc3anonymousza33190ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16934, obj_t BgL_sz00_16938)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_16935;
				obj_t BgL_bodyz00_16936;
				long BgL_siza7ezd2framez75_16937;

				BgL_i1252z00_16935 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16934, (int) (((long) 0))));
				BgL_bodyz00_16936 = PROCEDURE_REF(BgL_envz00_16934, (int) (((long) 1)));
				BgL_siza7ezd2framez75_16937 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16934, (int) (((long) 2))));
				{
					obj_t BgL_sz00_3621;

					BgL_sz00_3621 = BgL_sz00_16938;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3623;

						BgL_bpz00_3623 = VECTOR_REF(BgL_sz00_3621, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */

							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16162;

								BgL_runz00_16162 =
									MAKE_FX_PROCEDURE(BGl_z62run5518z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_runz00_16162,
									(int) (((long) 0)), ((obj_t) BgL_i1252z00_16935));
								PROCEDURE_SET(BgL_runz00_16162,
									(int) (((long) 1)), BgL_bodyz00_16936);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16163;

									BgL_mainz00_16163 =
										MAKE_FX_PROCEDURE(BGl_z62main5517z62zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 4)));
									PROCEDURE_SET(BgL_mainz00_16163,
										(int) (((long) 0)), ((obj_t) BgL_i1252z00_16935));
									PROCEDURE_SET(BgL_mainz00_16163,
										(int) (((long) 1)), BgL_bodyz00_16936);
									PROCEDURE_SET(BgL_mainz00_16163,
										(int) (((long) 2)), BgL_runz00_16162);
									PROCEDURE_SET(BgL_mainz00_16163,
										(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_16937));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_11803;

										BgL_objz00_11803 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16162, BgL_objz00_11803);
										BgL_objz00_11803;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3191z00_3626;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3192z00_3627;

											BgL_arg3192z00_3627 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16935))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_11807;

												BgL_newz00_11807 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_28306;

													BgL_auxz00_28306 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_11807, BgL_auxz00_28306,
														BgL_arg3192z00_3627);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_28311;
													int BgL_auxz00_28309;

													BgL_auxz00_28311 = BINT(BgL_siza7ezd2framez75_16937);
													BgL_auxz00_28309 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_11807, BgL_auxz00_28309,
														BgL_auxz00_28311);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_28314;

													BgL_auxz00_28314 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_11807, BgL_auxz00_28314,
														BgL_runz00_16162);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_28319;
													int BgL_auxz00_28317;

													BgL_auxz00_28319 = BINT(((long) 1));
													BgL_auxz00_28317 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_11807, BgL_auxz00_28317,
														BgL_auxz00_28319);
												}
												BgL_arg3191z00_3626 = BgL_newz00_11807;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16163, BgL_arg3191z00_3626);
										BgL_arg3191z00_3626;
									}
									return BgL_mainz00_16163;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5517 */
	obj_t BGl_z62main5517z62zz__evaluate_compz00(obj_t BgL_envz00_16939,
		obj_t BgL_dz00_16944)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16942;
				long BgL_siza7ezd2framez75_16943;

				BgL_runz00_16942 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16939, (int) (((long) 2))));
				BgL_siza7ezd2framez75_16943 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16939, (int) (((long) 3))));
				{
					obj_t BgL_dz00_3628;

					BgL_dz00_3628 = BgL_dz00_16944;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_3630;

						BgL_sz00_3630 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_3631;

							BgL_bpz00_3631 = VECTOR_REF(BgL_sz00_3630, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_28332;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_11747;

									BgL_arg1908z00_11747 = VECTOR_LENGTH(BgL_sz00_3630);
									BgL_testz00_28332 =
										(
										((long) CINT(BgL_bpz00_3631) +
											BgL_siza7ezd2framez75_16943) <
										(long) (BgL_arg1908z00_11747));
								}
								if (BgL_testz00_28332)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3195z00_3633;

											BgL_arg3195z00_3633 =
												((long) CINT(BgL_bpz00_3631) + ((long) 0));
											VECTOR_SET(BgL_sz00_3630,
												(int) (BgL_arg3195z00_3633), BgL_dz00_3628);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1327z00_3634;

											BgL_val1327z00_3634 =
												BGl_zc3exitza33199ze3z83zz__evaluate_compz00
												(BgL_bpz00_3631, BgL_sz00_3630, BgL_runz00_16942);
											VECTOR_SET(BgL_sz00_3630, (int) (((long) 0)),
												BgL_bpz00_3631);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1327z00_3634)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1327z00_3634), CDR(BgL_val1327z00_3634));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1327z00_3634;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_3641;

										BgL_nsz00_3641 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_3641,
											(int) (((long) 1)), BgL_sz00_3630);
										VECTOR_SET(BgL_nsz00_3641,
											(int) (((long) 2)), BgL_dz00_3628);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_28356;

											BgL_auxz00_28356 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_28356, BgL_nsz00_3641);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1330z00_3643;

											BgL_val1330z00_3643 =
												BGl_zc3exitza33205ze3z83zz__evaluate_compz00
												(BgL_runz00_16942, BgL_nsz00_3641);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_28360;

												BgL_auxz00_28360 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_28360, BgL_sz00_3630);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1330z00_3643)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1330z00_3643), CDR(BgL_val1330z00_3643));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1330z00_3643;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3205> */
	obj_t BGl_zc3exitza33205ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17560,
		obj_t BgL_nsz00_17559)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1331z00_3649;

			if (SET_EXIT(BgL_an_exit1331z00_3649))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1331z00_3649 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1331z00_3649, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1332z00_3650;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_11775;

								BgL_savedzd2bpzd2_11775 =
									VECTOR_REF(BgL_nsz00_17559, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17559,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_11782;

									BgL_fz00_11782 = BgL_runz00_17560;
								BgL_recz00_11781:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_11783;

										BgL_rz00_11783 =
											PROCEDURE_ENTRY(BgL_fz00_11782) (BgL_fz00_11782,
											BgL_nsz00_17559, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_28381;

											if (PROCEDUREP(BgL_rz00_11783))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_11788;

													BgL_arg1900z00_11788 = PROCEDURE_ATTR(BgL_rz00_11783);
													if (STRUCTP(BgL_arg1900z00_11788))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_28381 =
																(STRUCT_KEY(BgL_arg1900z00_11788) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_28381 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_28381 = ((bool_t) 0);
												}
											if (BgL_testz00_28381)
												{
													obj_t BgL_fz00_28389;

													BgL_fz00_28389 = BgL_rz00_11783;
													BgL_fz00_11782 = BgL_fz00_28389;
													goto BgL_recz00_11781;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17559,
														(int) (((long) 0)), BgL_savedzd2bpzd2_11775);
													BgL_val1332z00_3650 = BgL_rz00_11783;
							}}}}}
							POP_EXIT();
							return BgL_val1332z00_3650;
						}
					}
				}
		}
	}



/* <exit:3199> */
	obj_t BGl_zc3exitza33199ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17563,
		obj_t BgL_sz00_17562, obj_t BgL_runz00_17561)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1328z00_3639;

			if (SET_EXIT(BgL_an_exit1328z00_3639))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1328z00_3639 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1328z00_3639, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1329z00_3640;

							BgL_val1329z00_3640 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17561,
								BgL_sz00_17562, BgL_bpz00_17563);
							POP_EXIT();
							return BgL_val1329z00_3640;
						}
					}
				}
		}
	}



/* &run5518 */
	obj_t BGl_z62run5518z62zz__evaluate_compz00(obj_t BgL_envz00_16945,
		obj_t BgL_sz00_16948)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_16946;
				obj_t BgL_bodyz00_16947;

				BgL_i1252z00_16946 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16945, (int) (((long) 0))));
				BgL_bodyz00_16947 = PROCEDURE_REF(BgL_envz00_16945, (int) (((long) 1)));
				{
					obj_t BgL_sz00_3652;

					BgL_sz00_3652 = BgL_sz00_16948;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3654;

						BgL_bpz00_3654 = VECTOR_REF(BgL_sz00_3652, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_z12denvz12_3655;
							obj_t BgL_wherez00_3656;
							obj_t BgL_locz00_3657;

							BgL_z12denvz12_3655 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_3656 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16946))->BgL_wherez00);
							BgL_locz00_3657 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16946))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1129 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_3655, BgL_wherez00_3656,
									BgL_locz00_3657);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_za2za2resza2za2z00_3658;

									BgL_za2za2resza2za2z00_3658 =
										PROCEDURE_ENTRY(BgL_bodyz00_16947) (BgL_bodyz00_16947,
										BgL_sz00_3652, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_3655);
									return BgL_za2za2resza2za2z00_3658;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3207> */
	obj_t BGl_z62zc3anonymousza33207ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16949, obj_t BgL_sz00_16954)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_16950;
				BgL_ev_absz00_bglt BgL_i1252z00_16951;
				obj_t BgL_bodyz00_16952;
				long BgL_siza7ezd2framez75_16953;

				BgL_iboxesz00_16950 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16949, (int) (((long) 0))));
				BgL_i1252z00_16951 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16949, (int) (((long) 1))));
				BgL_bodyz00_16952 = PROCEDURE_REF(BgL_envz00_16949, (int) (((long) 2)));
				BgL_siza7ezd2framez75_16953 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16949, (int) (((long) 3))));
				{
					obj_t BgL_sz00_3660;

					BgL_sz00_3660 = BgL_sz00_16954;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3662;

						BgL_bpz00_3662 = VECTOR_REF(BgL_sz00_3660, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */

							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16159;

								BgL_runz00_16159 =
									MAKE_FX_PROCEDURE(BGl_z62run5520z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_runz00_16159,
									(int) (((long) 0)), BgL_iboxesz00_16950);
								PROCEDURE_SET(BgL_runz00_16159,
									(int) (((long) 1)), ((obj_t) BgL_i1252z00_16951));
								PROCEDURE_SET(BgL_runz00_16159,
									(int) (((long) 2)), BgL_bodyz00_16952);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16160;

									BgL_mainz00_16160 =
										MAKE_FX_PROCEDURE(BGl_z62main5519z62zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_mainz00_16160,
										(int) (((long) 0)), BgL_iboxesz00_16950);
									PROCEDURE_SET(BgL_mainz00_16160,
										(int) (((long) 1)), ((obj_t) BgL_i1252z00_16951));
									PROCEDURE_SET(BgL_mainz00_16160,
										(int) (((long) 2)), BgL_bodyz00_16952);
									PROCEDURE_SET(BgL_mainz00_16160,
										(int) (((long) 3)), BgL_runz00_16159);
									PROCEDURE_SET(BgL_mainz00_16160,
										(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_16953));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_11894;

										BgL_objz00_11894 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16159, BgL_objz00_11894);
										BgL_objz00_11894;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3208z00_3665;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3209z00_3666;

											BgL_arg3209z00_3666 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16951))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_11898;

												BgL_newz00_11898 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_28456;

													BgL_auxz00_28456 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_11898, BgL_auxz00_28456,
														BgL_arg3209z00_3666);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_28461;
													int BgL_auxz00_28459;

													BgL_auxz00_28461 = BINT(BgL_siza7ezd2framez75_16953);
													BgL_auxz00_28459 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_11898, BgL_auxz00_28459,
														BgL_auxz00_28461);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_28464;

													BgL_auxz00_28464 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_11898, BgL_auxz00_28464,
														BgL_runz00_16159);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_28469;
													int BgL_auxz00_28467;

													BgL_auxz00_28469 = BINT(((long) 1));
													BgL_auxz00_28467 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_11898, BgL_auxz00_28467,
														BgL_auxz00_28469);
												}
												BgL_arg3208z00_3665 = BgL_newz00_11898;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16160, BgL_arg3208z00_3665);
										BgL_arg3208z00_3665;
									}
									return BgL_mainz00_16160;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5519 */
	obj_t BGl_z62main5519z62zz__evaluate_compz00(obj_t BgL_envz00_16955,
		obj_t BgL_dz00_16961)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16959;
				long BgL_siza7ezd2framez75_16960;

				BgL_runz00_16959 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16955, (int) (((long) 3))));
				BgL_siza7ezd2framez75_16960 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16955, (int) (((long) 4))));
				{
					obj_t BgL_dz00_3667;

					BgL_dz00_3667 = BgL_dz00_16961;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_3669;

						BgL_sz00_3669 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_3670;

							BgL_bpz00_3670 = VECTOR_REF(BgL_sz00_3669, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_28482;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_11838;

									BgL_arg1908z00_11838 = VECTOR_LENGTH(BgL_sz00_3669);
									BgL_testz00_28482 =
										(
										((long) CINT(BgL_bpz00_3670) +
											BgL_siza7ezd2framez75_16960) <
										(long) (BgL_arg1908z00_11838));
								}
								if (BgL_testz00_28482)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3212z00_3672;

											BgL_arg3212z00_3672 =
												((long) CINT(BgL_bpz00_3670) + ((long) 0));
											VECTOR_SET(BgL_sz00_3669,
												(int) (BgL_arg3212z00_3672), BgL_dz00_3667);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1333z00_3673;

											BgL_val1333z00_3673 =
												BGl_zc3exitza33216ze3z83zz__evaluate_compz00
												(BgL_bpz00_3670, BgL_sz00_3669, BgL_runz00_16959);
											VECTOR_SET(BgL_sz00_3669, (int) (((long) 0)),
												BgL_bpz00_3670);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1333z00_3673)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1333z00_3673), CDR(BgL_val1333z00_3673));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1333z00_3673;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_3680;

										BgL_nsz00_3680 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_3680,
											(int) (((long) 1)), BgL_sz00_3669);
										VECTOR_SET(BgL_nsz00_3680,
											(int) (((long) 2)), BgL_dz00_3667);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_28506;

											BgL_auxz00_28506 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_28506, BgL_nsz00_3680);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1336z00_3682;

											BgL_val1336z00_3682 =
												BGl_zc3exitza33222ze3z83zz__evaluate_compz00
												(BgL_runz00_16959, BgL_nsz00_3680);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_28510;

												BgL_auxz00_28510 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_28510, BgL_sz00_3669);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1336z00_3682)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1336z00_3682), CDR(BgL_val1336z00_3682));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1336z00_3682;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3222> */
	obj_t BGl_zc3exitza33222ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17555,
		obj_t BgL_nsz00_17554)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1337z00_3688;

			if (SET_EXIT(BgL_an_exit1337z00_3688))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1337z00_3688 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1337z00_3688, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1338z00_3689;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_11866;

								BgL_savedzd2bpzd2_11866 =
									VECTOR_REF(BgL_nsz00_17554, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17554,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_11873;

									BgL_fz00_11873 = BgL_runz00_17555;
								BgL_recz00_11872:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_11874;

										BgL_rz00_11874 =
											PROCEDURE_ENTRY(BgL_fz00_11873) (BgL_fz00_11873,
											BgL_nsz00_17554, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_28531;

											if (PROCEDUREP(BgL_rz00_11874))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_11879;

													BgL_arg1900z00_11879 = PROCEDURE_ATTR(BgL_rz00_11874);
													if (STRUCTP(BgL_arg1900z00_11879))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_28531 =
																(STRUCT_KEY(BgL_arg1900z00_11879) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_28531 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_28531 = ((bool_t) 0);
												}
											if (BgL_testz00_28531)
												{
													obj_t BgL_fz00_28539;

													BgL_fz00_28539 = BgL_rz00_11874;
													BgL_fz00_11873 = BgL_fz00_28539;
													goto BgL_recz00_11872;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17554,
														(int) (((long) 0)), BgL_savedzd2bpzd2_11866);
													BgL_val1338z00_3689 = BgL_rz00_11874;
							}}}}}
							POP_EXIT();
							return BgL_val1338z00_3689;
						}
					}
				}
		}
	}



/* <exit:3216> */
	obj_t BGl_zc3exitza33216ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17558,
		obj_t BgL_sz00_17557, obj_t BgL_runz00_17556)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1334z00_3678;

			if (SET_EXIT(BgL_an_exit1334z00_3678))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1334z00_3678 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1334z00_3678, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1335z00_3679;

							BgL_val1335z00_3679 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17556,
								BgL_sz00_17557, BgL_bpz00_17558);
							POP_EXIT();
							return BgL_val1335z00_3679;
						}
					}
				}
		}
	}



/* &run5520 */
	obj_t BGl_z62run5520z62zz__evaluate_compz00(obj_t BgL_envz00_16962,
		obj_t BgL_sz00_16966)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_16963;
				BgL_ev_absz00_bglt BgL_i1252z00_16964;
				obj_t BgL_bodyz00_16965;

				BgL_iboxesz00_16963 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16962, (int) (((long) 0))));
				BgL_i1252z00_16964 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16962, (int) (((long) 1))));
				BgL_bodyz00_16965 = PROCEDURE_REF(BgL_envz00_16962, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3691;

					BgL_sz00_3691 = BgL_sz00_16966;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3693;

						BgL_bpz00_3693 = VECTOR_REF(BgL_sz00_3691, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_3691,
							BgL_iboxesz00_16963, BgL_bpz00_3693);
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_z12denvz12_3694;
							obj_t BgL_wherez00_3695;
							obj_t BgL_locz00_3696;

							BgL_z12denvz12_3694 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_3695 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16964))->BgL_wherez00);
							BgL_locz00_3696 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16964))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1129 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_3694, BgL_wherez00_3695,
									BgL_locz00_3696);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_za2za2resza2za2z00_3697;

									BgL_za2za2resza2za2z00_3697 =
										PROCEDURE_ENTRY(BgL_bodyz00_16965) (BgL_bodyz00_16965,
										BgL_sz00_3691, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_3694);
									return BgL_za2za2resza2za2z00_3697;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3226> */
	obj_t BGl_z62zc3anonymousza33226ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16967, obj_t BgL_sz00_16973)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_ifreesz00_16968;
				long BgL_siza7eza7_16969;
				BgL_ev_absz00_bglt BgL_i1252z00_16970;
				obj_t BgL_bodyz00_16971;
				long BgL_siza7ezd2framez75_16972;

				BgL_ifreesz00_16968 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16967, (int) (((long) 0))));
				BgL_siza7eza7_16969 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16967, (int) (((long) 1))));
				BgL_i1252z00_16970 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16967, (int) (((long) 2))));
				BgL_bodyz00_16971 = PROCEDURE_REF(BgL_envz00_16967, (int) (((long) 3)));
				BgL_siza7ezd2framez75_16972 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16967, (int) (((long) 4))));
				{
					obj_t BgL_sz00_3701;

					BgL_sz00_3701 = BgL_sz00_16973;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3703;

						BgL_bpz00_3703 = VECTOR_REF(BgL_sz00_3701, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_valza2za2_3704;

							BgL_valza2za2_3704 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_3701,
								BgL_bpz00_3703, BgL_ifreesz00_16968);
							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16156;

								BgL_runz00_16156 =
									MAKE_FX_PROCEDURE(BGl_z62run5522z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_runz00_16156,
									(int) (((long) 0)), BINT(BgL_siza7eza7_16969));
								PROCEDURE_SET(BgL_runz00_16156,
									(int) (((long) 1)), BgL_valza2za2_3704);
								PROCEDURE_SET(BgL_runz00_16156,
									(int) (((long) 2)), ((obj_t) BgL_i1252z00_16970));
								PROCEDURE_SET(BgL_runz00_16156,
									(int) (((long) 3)), BgL_bodyz00_16971);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16157;

									BgL_mainz00_16157 =
										MAKE_FX_PROCEDURE(BGl_z62main5521z62zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_mainz00_16157,
										(int) (((long) 0)), BINT(BgL_siza7eza7_16969));
									PROCEDURE_SET(BgL_mainz00_16157,
										(int) (((long) 1)), BgL_valza2za2_3704);
									PROCEDURE_SET(BgL_mainz00_16157,
										(int) (((long) 2)), ((obj_t) BgL_i1252z00_16970));
									PROCEDURE_SET(BgL_mainz00_16157,
										(int) (((long) 3)), BgL_bodyz00_16971);
									PROCEDURE_SET(BgL_mainz00_16157,
										(int) (((long) 4)), BgL_runz00_16156);
									PROCEDURE_SET(BgL_mainz00_16157,
										(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_16972));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_11992;

										BgL_objz00_11992 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16156, BgL_objz00_11992);
										BgL_objz00_11992;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3227z00_3707;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3228z00_3708;

											BgL_arg3228z00_3708 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16970))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_11996;

												BgL_newz00_11996 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_28620;

													BgL_auxz00_28620 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_11996, BgL_auxz00_28620,
														BgL_arg3228z00_3708);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_28625;
													int BgL_auxz00_28623;

													BgL_auxz00_28625 = BINT(BgL_siza7ezd2framez75_16972);
													BgL_auxz00_28623 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_11996, BgL_auxz00_28623,
														BgL_auxz00_28625);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_28628;

													BgL_auxz00_28628 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_11996, BgL_auxz00_28628,
														BgL_runz00_16156);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_28633;
													int BgL_auxz00_28631;

													BgL_auxz00_28633 = BINT(((long) 1));
													BgL_auxz00_28631 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_11996, BgL_auxz00_28631,
														BgL_auxz00_28633);
												}
												BgL_arg3227z00_3707 = BgL_newz00_11996;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16157, BgL_arg3227z00_3707);
										BgL_arg3227z00_3707;
									}
									return BgL_mainz00_16157;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5521 */
	obj_t BGl_z62main5521z62zz__evaluate_compz00(obj_t BgL_envz00_16974,
		obj_t BgL_dz00_16981)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_16979;
				long BgL_siza7ezd2framez75_16980;

				BgL_runz00_16979 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16974, (int) (((long) 4))));
				BgL_siza7ezd2framez75_16980 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16974, (int) (((long) 5))));
				{
					obj_t BgL_dz00_3709;

					BgL_dz00_3709 = BgL_dz00_16981;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_3711;

						BgL_sz00_3711 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_3712;

							BgL_bpz00_3712 = VECTOR_REF(BgL_sz00_3711, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_28646;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_11936;

									BgL_arg1908z00_11936 = VECTOR_LENGTH(BgL_sz00_3711);
									BgL_testz00_28646 =
										(
										((long) CINT(BgL_bpz00_3712) +
											BgL_siza7ezd2framez75_16980) <
										(long) (BgL_arg1908z00_11936));
								}
								if (BgL_testz00_28646)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3232z00_3714;

											BgL_arg3232z00_3714 =
												((long) CINT(BgL_bpz00_3712) + ((long) 0));
											VECTOR_SET(BgL_sz00_3711,
												(int) (BgL_arg3232z00_3714), BgL_dz00_3709);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1339z00_3715;

											BgL_val1339z00_3715 =
												BGl_zc3exitza33236ze3z83zz__evaluate_compz00
												(BgL_bpz00_3712, BgL_sz00_3711, BgL_runz00_16979);
											VECTOR_SET(BgL_sz00_3711, (int) (((long) 0)),
												BgL_bpz00_3712);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1339z00_3715)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1339z00_3715), CDR(BgL_val1339z00_3715));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1339z00_3715;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_3722;

										BgL_nsz00_3722 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_3722,
											(int) (((long) 1)), BgL_sz00_3711);
										VECTOR_SET(BgL_nsz00_3722,
											(int) (((long) 2)), BgL_dz00_3709);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_28670;

											BgL_auxz00_28670 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_28670, BgL_nsz00_3722);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1342z00_3724;

											BgL_val1342z00_3724 =
												BGl_zc3exitza33242ze3z83zz__evaluate_compz00
												(BgL_runz00_16979, BgL_nsz00_3722);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_28674;

												BgL_auxz00_28674 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_28674, BgL_sz00_3711);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1342z00_3724)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1342z00_3724), CDR(BgL_val1342z00_3724));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1342z00_3724;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3242> */
	obj_t BGl_zc3exitza33242ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17550,
		obj_t BgL_nsz00_17549)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1343z00_3730;

			if (SET_EXIT(BgL_an_exit1343z00_3730))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1343z00_3730 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1343z00_3730, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1344z00_3731;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_11964;

								BgL_savedzd2bpzd2_11964 =
									VECTOR_REF(BgL_nsz00_17549, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17549,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_11971;

									BgL_fz00_11971 = BgL_runz00_17550;
								BgL_recz00_11970:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_11972;

										BgL_rz00_11972 =
											PROCEDURE_ENTRY(BgL_fz00_11971) (BgL_fz00_11971,
											BgL_nsz00_17549, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_28695;

											if (PROCEDUREP(BgL_rz00_11972))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_11977;

													BgL_arg1900z00_11977 = PROCEDURE_ATTR(BgL_rz00_11972);
													if (STRUCTP(BgL_arg1900z00_11977))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_28695 =
																(STRUCT_KEY(BgL_arg1900z00_11977) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_28695 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_28695 = ((bool_t) 0);
												}
											if (BgL_testz00_28695)
												{
													obj_t BgL_fz00_28703;

													BgL_fz00_28703 = BgL_rz00_11972;
													BgL_fz00_11971 = BgL_fz00_28703;
													goto BgL_recz00_11970;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17549,
														(int) (((long) 0)), BgL_savedzd2bpzd2_11964);
													BgL_val1344z00_3731 = BgL_rz00_11972;
							}}}}}
							POP_EXIT();
							return BgL_val1344z00_3731;
						}
					}
				}
		}
	}



/* <exit:3236> */
	obj_t BGl_zc3exitza33236ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17553,
		obj_t BgL_sz00_17552, obj_t BgL_runz00_17551)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1340z00_3720;

			if (SET_EXIT(BgL_an_exit1340z00_3720))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1340z00_3720 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1340z00_3720, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1341z00_3721;

							BgL_val1341z00_3721 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17551,
								BgL_sz00_17552, BgL_bpz00_17553);
							POP_EXIT();
							return BgL_val1341z00_3721;
						}
					}
				}
		}
	}



/* &run5522 */
	obj_t BGl_z62run5522z62zz__evaluate_compz00(obj_t BgL_envz00_16982,
		obj_t BgL_sz00_16987)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				long BgL_siza7eza7_16983;
				obj_t BgL_valza2za2_16984;
				BgL_ev_absz00_bglt BgL_i1252z00_16985;
				obj_t BgL_bodyz00_16986;

				BgL_siza7eza7_16983 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16982, (int) (((long) 0))));
				BgL_valza2za2_16984 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16982, (int) (((long) 1))));
				BgL_i1252z00_16985 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16982, (int) (((long) 2))));
				BgL_bodyz00_16986 = PROCEDURE_REF(BgL_envz00_16982, (int) (((long) 3)));
				{
					obj_t BgL_sz00_3733;

					BgL_sz00_3733 = BgL_sz00_16987;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3735;

						BgL_bpz00_3735 = VECTOR_REF(BgL_sz00_3733, (int) (((long) 0)));
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_3733,
							BgL_valza2za2_16984,
							((long) CINT(BgL_bpz00_3735) + BgL_siza7eza7_16983));
						{	/* Eval/evaluate_comp.scm 1049 */
							obj_t BgL_z12denvz12_3737;
							obj_t BgL_wherez00_3738;
							obj_t BgL_locz00_3739;

							BgL_z12denvz12_3737 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_3738 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16985))->BgL_wherez00);
							BgL_locz00_3739 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16985))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1049 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_3737, BgL_wherez00_3738,
									BgL_locz00_3739);
								{	/* Eval/evaluate_comp.scm 1049 */
									obj_t BgL_za2za2resza2za2z00_3740;

									BgL_za2za2resza2za2z00_3740 =
										PROCEDURE_ENTRY(BgL_bodyz00_16986) (BgL_bodyz00_16986,
										BgL_sz00_3733, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_3737);
									return BgL_za2za2resza2za2z00_3740;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3245> */
	obj_t BGl_z62zc3anonymousza33245ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_16988, obj_t BgL_sz00_16995)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_ifreesz00_16989;
				obj_t BgL_iboxesz00_16990;
				long BgL_siza7eza7_16991;
				BgL_ev_absz00_bglt BgL_i1252z00_16992;
				obj_t BgL_bodyz00_16993;
				long BgL_siza7ezd2framez75_16994;

				BgL_ifreesz00_16989 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16988, (int) (((long) 0))));
				BgL_iboxesz00_16990 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16988, (int) (((long) 1))));
				BgL_siza7eza7_16991 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16988, (int) (((long) 2))));
				BgL_i1252z00_16992 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_16988, (int) (((long) 3))));
				BgL_bodyz00_16993 = PROCEDURE_REF(BgL_envz00_16988, (int) (((long) 4)));
				BgL_siza7ezd2framez75_16994 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16988, (int) (((long) 5))));
				{
					obj_t BgL_sz00_3742;

					BgL_sz00_3742 = BgL_sz00_16995;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3744;

						BgL_bpz00_3744 = VECTOR_REF(BgL_sz00_3742, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_valza2za2_3745;

							BgL_valza2za2_3745 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_3742,
								BgL_bpz00_3744, BgL_ifreesz00_16989);
							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16153;

								BgL_runz00_16153 =
									MAKE_FX_PROCEDURE(BGl_z62run5524z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_runz00_16153,
									(int) (((long) 0)), BgL_iboxesz00_16990);
								PROCEDURE_SET(BgL_runz00_16153,
									(int) (((long) 1)), BINT(BgL_siza7eza7_16991));
								PROCEDURE_SET(BgL_runz00_16153,
									(int) (((long) 2)), BgL_valza2za2_3745);
								PROCEDURE_SET(BgL_runz00_16153,
									(int) (((long) 3)), ((obj_t) BgL_i1252z00_16992));
								PROCEDURE_SET(BgL_runz00_16153,
									(int) (((long) 4)), BgL_bodyz00_16993);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16154;

									BgL_mainz00_16154 =
										MAKE_FX_PROCEDURE(BGl_z62main5523z62zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 7)));
									PROCEDURE_SET(BgL_mainz00_16154,
										(int) (((long) 0)), BgL_iboxesz00_16990);
									PROCEDURE_SET(BgL_mainz00_16154,
										(int) (((long) 1)), BINT(BgL_siza7eza7_16991));
									PROCEDURE_SET(BgL_mainz00_16154,
										(int) (((long) 2)), BgL_valza2za2_3745);
									PROCEDURE_SET(BgL_mainz00_16154,
										(int) (((long) 3)), ((obj_t) BgL_i1252z00_16992));
									PROCEDURE_SET(BgL_mainz00_16154,
										(int) (((long) 4)), BgL_bodyz00_16993);
									PROCEDURE_SET(BgL_mainz00_16154,
										(int) (((long) 5)), BgL_runz00_16153);
									PROCEDURE_SET(BgL_mainz00_16154,
										(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_16994));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_12086;

										BgL_objz00_12086 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16153, BgL_objz00_12086);
										BgL_objz00_12086;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3246z00_3748;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3247z00_3749;

											BgL_arg3247z00_3749 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_16992))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_12090;

												BgL_newz00_12090 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_28796;

													BgL_auxz00_28796 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_12090, BgL_auxz00_28796,
														BgL_arg3247z00_3749);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_28801;
													int BgL_auxz00_28799;

													BgL_auxz00_28801 = BINT(BgL_siza7ezd2framez75_16994);
													BgL_auxz00_28799 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_12090, BgL_auxz00_28799,
														BgL_auxz00_28801);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_28804;

													BgL_auxz00_28804 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_12090, BgL_auxz00_28804,
														BgL_runz00_16153);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_28809;
													int BgL_auxz00_28807;

													BgL_auxz00_28809 = BINT(((long) 1));
													BgL_auxz00_28807 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_12090, BgL_auxz00_28807,
														BgL_auxz00_28809);
												}
												BgL_arg3246z00_3748 = BgL_newz00_12090;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16154, BgL_arg3246z00_3748);
										BgL_arg3246z00_3748;
									}
									return BgL_mainz00_16154;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5523 */
	obj_t BGl_z62main5523z62zz__evaluate_compz00(obj_t BgL_envz00_16996,
		obj_t BgL_dz00_17004)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_17002;
				long BgL_siza7ezd2framez75_17003;

				BgL_runz00_17002 =
					((obj_t) PROCEDURE_REF(BgL_envz00_16996, (int) (((long) 5))));
				BgL_siza7ezd2framez75_17003 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_16996, (int) (((long) 6))));
				{
					obj_t BgL_dz00_3750;

					BgL_dz00_3750 = BgL_dz00_17004;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_3752;

						BgL_sz00_3752 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_3753;

							BgL_bpz00_3753 = VECTOR_REF(BgL_sz00_3752, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_28822;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_12030;

									BgL_arg1908z00_12030 = VECTOR_LENGTH(BgL_sz00_3752);
									BgL_testz00_28822 =
										(
										((long) CINT(BgL_bpz00_3753) +
											BgL_siza7ezd2framez75_17003) <
										(long) (BgL_arg1908z00_12030));
								}
								if (BgL_testz00_28822)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3251z00_3755;

											BgL_arg3251z00_3755 =
												((long) CINT(BgL_bpz00_3753) + ((long) 0));
											VECTOR_SET(BgL_sz00_3752,
												(int) (BgL_arg3251z00_3755), BgL_dz00_3750);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1345z00_3756;

											BgL_val1345z00_3756 =
												BGl_zc3exitza33255ze3z83zz__evaluate_compz00
												(BgL_bpz00_3753, BgL_sz00_3752, BgL_runz00_17002);
											VECTOR_SET(BgL_sz00_3752, (int) (((long) 0)),
												BgL_bpz00_3753);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1345z00_3756)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1345z00_3756), CDR(BgL_val1345z00_3756));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1345z00_3756;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_3763;

										BgL_nsz00_3763 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_3763,
											(int) (((long) 1)), BgL_sz00_3752);
										VECTOR_SET(BgL_nsz00_3763,
											(int) (((long) 2)), BgL_dz00_3750);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_28846;

											BgL_auxz00_28846 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_28846, BgL_nsz00_3763);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1348z00_3765;

											BgL_val1348z00_3765 =
												BGl_zc3exitza33261ze3z83zz__evaluate_compz00
												(BgL_runz00_17002, BgL_nsz00_3763);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_28850;

												BgL_auxz00_28850 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_28850, BgL_sz00_3752);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1348z00_3765)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1348z00_3765), CDR(BgL_val1348z00_3765));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1348z00_3765;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3261> */
	obj_t BGl_zc3exitza33261ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17545,
		obj_t BgL_nsz00_17544)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1349z00_3771;

			if (SET_EXIT(BgL_an_exit1349z00_3771))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1349z00_3771 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1349z00_3771, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1350z00_3772;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_12058;

								BgL_savedzd2bpzd2_12058 =
									VECTOR_REF(BgL_nsz00_17544, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17544,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_12065;

									BgL_fz00_12065 = BgL_runz00_17545;
								BgL_recz00_12064:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_12066;

										BgL_rz00_12066 =
											PROCEDURE_ENTRY(BgL_fz00_12065) (BgL_fz00_12065,
											BgL_nsz00_17544, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_28871;

											if (PROCEDUREP(BgL_rz00_12066))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_12071;

													BgL_arg1900z00_12071 = PROCEDURE_ATTR(BgL_rz00_12066);
													if (STRUCTP(BgL_arg1900z00_12071))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_28871 =
																(STRUCT_KEY(BgL_arg1900z00_12071) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_28871 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_28871 = ((bool_t) 0);
												}
											if (BgL_testz00_28871)
												{
													obj_t BgL_fz00_28879;

													BgL_fz00_28879 = BgL_rz00_12066;
													BgL_fz00_12065 = BgL_fz00_28879;
													goto BgL_recz00_12064;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17544,
														(int) (((long) 0)), BgL_savedzd2bpzd2_12058);
													BgL_val1350z00_3772 = BgL_rz00_12066;
							}}}}}
							POP_EXIT();
							return BgL_val1350z00_3772;
						}
					}
				}
		}
	}



/* <exit:3255> */
	obj_t BGl_zc3exitza33255ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17548,
		obj_t BgL_sz00_17547, obj_t BgL_runz00_17546)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1346z00_3761;

			if (SET_EXIT(BgL_an_exit1346z00_3761))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1346z00_3761 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1346z00_3761, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1347z00_3762;

							BgL_val1347z00_3762 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17546,
								BgL_sz00_17547, BgL_bpz00_17548);
							POP_EXIT();
							return BgL_val1347z00_3762;
						}
					}
				}
		}
	}



/* &run5524 */
	obj_t BGl_z62run5524z62zz__evaluate_compz00(obj_t BgL_envz00_17005,
		obj_t BgL_sz00_17011)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_17006;
				long BgL_siza7eza7_17007;
				obj_t BgL_valza2za2_17008;
				BgL_ev_absz00_bglt BgL_i1252z00_17009;
				obj_t BgL_bodyz00_17010;

				BgL_iboxesz00_17006 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17005, (int) (((long) 0))));
				BgL_siza7eza7_17007 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17005, (int) (((long) 1))));
				BgL_valza2za2_17008 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17005, (int) (((long) 2))));
				BgL_i1252z00_17009 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17005, (int) (((long) 3))));
				BgL_bodyz00_17010 = PROCEDURE_REF(BgL_envz00_17005, (int) (((long) 4)));
				{
					obj_t BgL_sz00_3774;

					BgL_sz00_3774 = BgL_sz00_17011;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3776;

						BgL_bpz00_3776 = VECTOR_REF(BgL_sz00_3774, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_3774,
							BgL_iboxesz00_17006, BgL_bpz00_3776);
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_3774,
							BgL_valza2za2_17008,
							((long) CINT(BgL_bpz00_3776) + BgL_siza7eza7_17007));
						{	/* Eval/evaluate_comp.scm 1049 */
							obj_t BgL_z12denvz12_3778;
							obj_t BgL_wherez00_3779;
							obj_t BgL_locz00_3780;

							BgL_z12denvz12_3778 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_3779 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17009))->BgL_wherez00);
							BgL_locz00_3780 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17009))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1049 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_3778, BgL_wherez00_3779,
									BgL_locz00_3780);
								{	/* Eval/evaluate_comp.scm 1049 */
									obj_t BgL_za2za2resza2za2z00_3781;

									BgL_za2za2resza2za2z00_3781 =
										PROCEDURE_ENTRY(BgL_bodyz00_17010) (BgL_bodyz00_17010,
										BgL_sz00_3774, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_3778);
									return BgL_za2za2resza2za2z00_3781;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3112> */
	obj_t BGl_z62zc3anonymousza33112ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17012, obj_t BgL_sz00_17016)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_17013;
				obj_t BgL_bodyz00_17014;
				long BgL_siza7ezd2framez75_17015;

				BgL_i1252z00_17013 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17012, (int) (((long) 0))));
				BgL_bodyz00_17014 = PROCEDURE_REF(BgL_envz00_17012, (int) (((long) 1)));
				BgL_siza7ezd2framez75_17015 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17012, (int) (((long) 2))));
				{
					obj_t BgL_sz00_3455;

					BgL_sz00_3455 = BgL_sz00_17016;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3457;

						BgL_bpz00_3457 = VECTOR_REF(BgL_sz00_3455, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */

							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16150;

								BgL_runz00_16150 =
									MAKE_FX_PROCEDURE(BGl_z62run5526z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_runz00_16150,
									(int) (((long) 0)), ((obj_t) BgL_i1252z00_17013));
								PROCEDURE_SET(BgL_runz00_16150,
									(int) (((long) 1)), BgL_bodyz00_17014);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16151;

									BgL_mainz00_16151 =
										MAKE_VA_PROCEDURE(BGl_z62main5525z62zz__evaluate_compz00,
										(int) (((long) -1)), (int) (((long) 4)));
									PROCEDURE_SET(BgL_mainz00_16151,
										(int) (((long) 0)), ((obj_t) BgL_i1252z00_17013));
									PROCEDURE_SET(BgL_mainz00_16151,
										(int) (((long) 1)), BgL_bodyz00_17014);
									PROCEDURE_SET(BgL_mainz00_16151,
										(int) (((long) 2)), BgL_runz00_16150);
									PROCEDURE_SET(BgL_mainz00_16151,
										(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_17015));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_11421;

										BgL_objz00_11421 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16150, BgL_objz00_11421);
										BgL_objz00_11421;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3113z00_3460;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3114z00_3461;

											BgL_arg3114z00_3461 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17013))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_11425;

												BgL_newz00_11425 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_28952;

													BgL_auxz00_28952 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_11425, BgL_auxz00_28952,
														BgL_arg3114z00_3461);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_28957;
													int BgL_auxz00_28955;

													BgL_auxz00_28957 = BINT(BgL_siza7ezd2framez75_17015);
													BgL_auxz00_28955 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_11425, BgL_auxz00_28955,
														BgL_auxz00_28957);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_28960;

													BgL_auxz00_28960 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_11425, BgL_auxz00_28960,
														BgL_runz00_16150);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_28965;
													int BgL_auxz00_28963;

													BgL_auxz00_28965 = BINT(((long) -1));
													BgL_auxz00_28963 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_11425, BgL_auxz00_28963,
														BgL_auxz00_28965);
												}
												BgL_arg3113z00_3460 = BgL_newz00_11425;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16151, BgL_arg3113z00_3460);
										BgL_arg3113z00_3460;
									}
									return BgL_mainz00_16151;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5525 */
	obj_t BGl_z62main5525z62zz__evaluate_compz00(obj_t BgL_envz00_17017,
		obj_t BgL_lastz00_17022)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_17020;
				long BgL_siza7ezd2framez75_17021;

				BgL_runz00_17020 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17017, (int) (((long) 2))));
				BgL_siza7ezd2framez75_17021 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17017, (int) (((long) 3))));
				{
					obj_t BgL_lastz00_3462;

					BgL_lastz00_3462 = BgL_lastz00_17022;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_3464;

						BgL_sz00_3464 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_3465;

							BgL_bpz00_3465 = VECTOR_REF(BgL_sz00_3464, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_28978;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_11365;

									BgL_arg1908z00_11365 = VECTOR_LENGTH(BgL_sz00_3464);
									BgL_testz00_28978 =
										(
										((long) CINT(BgL_bpz00_3465) +
											BgL_siza7ezd2framez75_17021) <
										(long) (BgL_arg1908z00_11365));
								}
								if (BgL_testz00_28978)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3117z00_3467;

											BgL_arg3117z00_3467 =
												((long) CINT(BgL_bpz00_3465) + ((long) 0));
											VECTOR_SET(BgL_sz00_3464,
												(int) (BgL_arg3117z00_3467), BgL_lastz00_3462);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1303z00_3468;

											BgL_val1303z00_3468 =
												BGl_zc3exitza33121ze3z83zz__evaluate_compz00
												(BgL_bpz00_3465, BgL_sz00_3464, BgL_runz00_17020);
											VECTOR_SET(BgL_sz00_3464, (int) (((long) 0)),
												BgL_bpz00_3465);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1303z00_3468)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1303z00_3468), CDR(BgL_val1303z00_3468));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1303z00_3468;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_3475;

										BgL_nsz00_3475 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_3475,
											(int) (((long) 1)), BgL_sz00_3464);
										VECTOR_SET(BgL_nsz00_3475,
											(int) (((long) 2)), BgL_lastz00_3462);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_29002;

											BgL_auxz00_29002 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_29002, BgL_nsz00_3475);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1306z00_3477;

											BgL_val1306z00_3477 =
												BGl_zc3exitza33127ze3z83zz__evaluate_compz00
												(BgL_runz00_17020, BgL_nsz00_3475);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_29006;

												BgL_auxz00_29006 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_29006, BgL_sz00_3464);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1306z00_3477)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1306z00_3477), CDR(BgL_val1306z00_3477));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1306z00_3477;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3127> */
	obj_t BGl_zc3exitza33127ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17540,
		obj_t BgL_nsz00_17539)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1307z00_3483;

			if (SET_EXIT(BgL_an_exit1307z00_3483))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1307z00_3483 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1307z00_3483, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1308z00_3484;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_11393;

								BgL_savedzd2bpzd2_11393 =
									VECTOR_REF(BgL_nsz00_17539, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17539,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_11400;

									BgL_fz00_11400 = BgL_runz00_17540;
								BgL_recz00_11399:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_11401;

										BgL_rz00_11401 =
											PROCEDURE_ENTRY(BgL_fz00_11400) (BgL_fz00_11400,
											BgL_nsz00_17539, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_29027;

											if (PROCEDUREP(BgL_rz00_11401))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_11406;

													BgL_arg1900z00_11406 = PROCEDURE_ATTR(BgL_rz00_11401);
													if (STRUCTP(BgL_arg1900z00_11406))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_29027 =
																(STRUCT_KEY(BgL_arg1900z00_11406) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_29027 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_29027 = ((bool_t) 0);
												}
											if (BgL_testz00_29027)
												{
													obj_t BgL_fz00_29035;

													BgL_fz00_29035 = BgL_rz00_11401;
													BgL_fz00_11400 = BgL_fz00_29035;
													goto BgL_recz00_11399;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17539,
														(int) (((long) 0)), BgL_savedzd2bpzd2_11393);
													BgL_val1308z00_3484 = BgL_rz00_11401;
							}}}}}
							POP_EXIT();
							return BgL_val1308z00_3484;
						}
					}
				}
		}
	}



/* <exit:3121> */
	obj_t BGl_zc3exitza33121ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17543,
		obj_t BgL_sz00_17542, obj_t BgL_runz00_17541)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1304z00_3473;

			if (SET_EXIT(BgL_an_exit1304z00_3473))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1304z00_3473 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1304z00_3473, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1305z00_3474;

							BgL_val1305z00_3474 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17541,
								BgL_sz00_17542, BgL_bpz00_17543);
							POP_EXIT();
							return BgL_val1305z00_3474;
						}
					}
				}
		}
	}



/* &run5526 */
	obj_t BGl_z62run5526z62zz__evaluate_compz00(obj_t BgL_envz00_17023,
		obj_t BgL_sz00_17026)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_17024;
				obj_t BgL_bodyz00_17025;

				BgL_i1252z00_17024 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17023, (int) (((long) 0))));
				BgL_bodyz00_17025 = PROCEDURE_REF(BgL_envz00_17023, (int) (((long) 1)));
				{
					obj_t BgL_sz00_3486;

					BgL_sz00_3486 = BgL_sz00_17026;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3488;

						BgL_bpz00_3488 = VECTOR_REF(BgL_sz00_3486, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_z12denvz12_3489;
							obj_t BgL_wherez00_3490;
							obj_t BgL_locz00_3491;

							BgL_z12denvz12_3489 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_3490 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17024))->BgL_wherez00);
							BgL_locz00_3491 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17024))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1129 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_3489, BgL_wherez00_3490,
									BgL_locz00_3491);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_za2za2resza2za2z00_3492;

									BgL_za2za2resza2za2z00_3492 =
										PROCEDURE_ENTRY(BgL_bodyz00_17025) (BgL_bodyz00_17025,
										BgL_sz00_3486, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_3489);
									return BgL_za2za2resza2za2z00_3492;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3129> */
	obj_t BGl_z62zc3anonymousza33129ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17027, obj_t BgL_sz00_17032)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_17028;
				BgL_ev_absz00_bglt BgL_i1252z00_17029;
				obj_t BgL_bodyz00_17030;
				long BgL_siza7ezd2framez75_17031;

				BgL_iboxesz00_17028 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17027, (int) (((long) 0))));
				BgL_i1252z00_17029 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17027, (int) (((long) 1))));
				BgL_bodyz00_17030 = PROCEDURE_REF(BgL_envz00_17027, (int) (((long) 2)));
				BgL_siza7ezd2framez75_17031 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17027, (int) (((long) 3))));
				{
					obj_t BgL_sz00_3494;

					BgL_sz00_3494 = BgL_sz00_17032;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3496;

						BgL_bpz00_3496 = VECTOR_REF(BgL_sz00_3494, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */

							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16147;

								BgL_runz00_16147 =
									MAKE_FX_PROCEDURE(BGl_z62run5528z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_runz00_16147,
									(int) (((long) 0)), BgL_iboxesz00_17028);
								PROCEDURE_SET(BgL_runz00_16147,
									(int) (((long) 1)), ((obj_t) BgL_i1252z00_17029));
								PROCEDURE_SET(BgL_runz00_16147,
									(int) (((long) 2)), BgL_bodyz00_17030);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16148;

									BgL_mainz00_16148 =
										MAKE_VA_PROCEDURE(BGl_z62main5527z62zz__evaluate_compz00,
										(int) (((long) -1)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_mainz00_16148,
										(int) (((long) 0)), BgL_iboxesz00_17028);
									PROCEDURE_SET(BgL_mainz00_16148,
										(int) (((long) 1)), ((obj_t) BgL_i1252z00_17029));
									PROCEDURE_SET(BgL_mainz00_16148,
										(int) (((long) 2)), BgL_bodyz00_17030);
									PROCEDURE_SET(BgL_mainz00_16148,
										(int) (((long) 3)), BgL_runz00_16147);
									PROCEDURE_SET(BgL_mainz00_16148,
										(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_17031));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_11512;

										BgL_objz00_11512 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16147, BgL_objz00_11512);
										BgL_objz00_11512;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3130z00_3499;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3131z00_3500;

											BgL_arg3131z00_3500 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17029))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_11516;

												BgL_newz00_11516 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_29102;

													BgL_auxz00_29102 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_11516, BgL_auxz00_29102,
														BgL_arg3131z00_3500);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_29107;
													int BgL_auxz00_29105;

													BgL_auxz00_29107 = BINT(BgL_siza7ezd2framez75_17031);
													BgL_auxz00_29105 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_11516, BgL_auxz00_29105,
														BgL_auxz00_29107);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_29110;

													BgL_auxz00_29110 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_11516, BgL_auxz00_29110,
														BgL_runz00_16147);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_29115;
													int BgL_auxz00_29113;

													BgL_auxz00_29115 = BINT(((long) -1));
													BgL_auxz00_29113 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_11516, BgL_auxz00_29113,
														BgL_auxz00_29115);
												}
												BgL_arg3130z00_3499 = BgL_newz00_11516;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16148, BgL_arg3130z00_3499);
										BgL_arg3130z00_3499;
									}
									return BgL_mainz00_16148;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5527 */
	obj_t BGl_z62main5527z62zz__evaluate_compz00(obj_t BgL_envz00_17033,
		obj_t BgL_lastz00_17039)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_17037;
				long BgL_siza7ezd2framez75_17038;

				BgL_runz00_17037 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17033, (int) (((long) 3))));
				BgL_siza7ezd2framez75_17038 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17033, (int) (((long) 4))));
				{
					obj_t BgL_lastz00_3501;

					BgL_lastz00_3501 = BgL_lastz00_17039;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_3503;

						BgL_sz00_3503 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_3504;

							BgL_bpz00_3504 = VECTOR_REF(BgL_sz00_3503, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_29128;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_11456;

									BgL_arg1908z00_11456 = VECTOR_LENGTH(BgL_sz00_3503);
									BgL_testz00_29128 =
										(
										((long) CINT(BgL_bpz00_3504) +
											BgL_siza7ezd2framez75_17038) <
										(long) (BgL_arg1908z00_11456));
								}
								if (BgL_testz00_29128)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3134z00_3506;

											BgL_arg3134z00_3506 =
												((long) CINT(BgL_bpz00_3504) + ((long) 0));
											VECTOR_SET(BgL_sz00_3503,
												(int) (BgL_arg3134z00_3506), BgL_lastz00_3501);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1309z00_3507;

											BgL_val1309z00_3507 =
												BGl_zc3exitza33138ze3z83zz__evaluate_compz00
												(BgL_bpz00_3504, BgL_sz00_3503, BgL_runz00_17037);
											VECTOR_SET(BgL_sz00_3503, (int) (((long) 0)),
												BgL_bpz00_3504);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1309z00_3507)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1309z00_3507), CDR(BgL_val1309z00_3507));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1309z00_3507;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_3514;

										BgL_nsz00_3514 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_3514,
											(int) (((long) 1)), BgL_sz00_3503);
										VECTOR_SET(BgL_nsz00_3514,
											(int) (((long) 2)), BgL_lastz00_3501);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_29152;

											BgL_auxz00_29152 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_29152, BgL_nsz00_3514);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1312z00_3516;

											BgL_val1312z00_3516 =
												BGl_zc3exitza33144ze3z83zz__evaluate_compz00
												(BgL_runz00_17037, BgL_nsz00_3514);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_29156;

												BgL_auxz00_29156 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_29156, BgL_sz00_3503);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1312z00_3516)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1312z00_3516), CDR(BgL_val1312z00_3516));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1312z00_3516;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3144> */
	obj_t BGl_zc3exitza33144ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17535,
		obj_t BgL_nsz00_17534)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1313z00_3522;

			if (SET_EXIT(BgL_an_exit1313z00_3522))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1313z00_3522 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1313z00_3522, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1314z00_3523;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_11484;

								BgL_savedzd2bpzd2_11484 =
									VECTOR_REF(BgL_nsz00_17534, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17534,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_11491;

									BgL_fz00_11491 = BgL_runz00_17535;
								BgL_recz00_11490:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_11492;

										BgL_rz00_11492 =
											PROCEDURE_ENTRY(BgL_fz00_11491) (BgL_fz00_11491,
											BgL_nsz00_17534, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_29177;

											if (PROCEDUREP(BgL_rz00_11492))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_11497;

													BgL_arg1900z00_11497 = PROCEDURE_ATTR(BgL_rz00_11492);
													if (STRUCTP(BgL_arg1900z00_11497))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_29177 =
																(STRUCT_KEY(BgL_arg1900z00_11497) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_29177 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_29177 = ((bool_t) 0);
												}
											if (BgL_testz00_29177)
												{
													obj_t BgL_fz00_29185;

													BgL_fz00_29185 = BgL_rz00_11492;
													BgL_fz00_11491 = BgL_fz00_29185;
													goto BgL_recz00_11490;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17534,
														(int) (((long) 0)), BgL_savedzd2bpzd2_11484);
													BgL_val1314z00_3523 = BgL_rz00_11492;
							}}}}}
							POP_EXIT();
							return BgL_val1314z00_3523;
						}
					}
				}
		}
	}



/* <exit:3138> */
	obj_t BGl_zc3exitza33138ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17538,
		obj_t BgL_sz00_17537, obj_t BgL_runz00_17536)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1310z00_3512;

			if (SET_EXIT(BgL_an_exit1310z00_3512))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1310z00_3512 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1310z00_3512, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1311z00_3513;

							BgL_val1311z00_3513 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17536,
								BgL_sz00_17537, BgL_bpz00_17538);
							POP_EXIT();
							return BgL_val1311z00_3513;
						}
					}
				}
		}
	}



/* &run5528 */
	obj_t BGl_z62run5528z62zz__evaluate_compz00(obj_t BgL_envz00_17040,
		obj_t BgL_sz00_17044)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_17041;
				BgL_ev_absz00_bglt BgL_i1252z00_17042;
				obj_t BgL_bodyz00_17043;

				BgL_iboxesz00_17041 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17040, (int) (((long) 0))));
				BgL_i1252z00_17042 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17040, (int) (((long) 1))));
				BgL_bodyz00_17043 = PROCEDURE_REF(BgL_envz00_17040, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3525;

					BgL_sz00_3525 = BgL_sz00_17044;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3527;

						BgL_bpz00_3527 = VECTOR_REF(BgL_sz00_3525, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_3525,
							BgL_iboxesz00_17041, BgL_bpz00_3527);
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_z12denvz12_3528;
							obj_t BgL_wherez00_3529;
							obj_t BgL_locz00_3530;

							BgL_z12denvz12_3528 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_3529 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17042))->BgL_wherez00);
							BgL_locz00_3530 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17042))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1129 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_3528, BgL_wherez00_3529,
									BgL_locz00_3530);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_za2za2resza2za2z00_3531;

									BgL_za2za2resza2za2z00_3531 =
										PROCEDURE_ENTRY(BgL_bodyz00_17043) (BgL_bodyz00_17043,
										BgL_sz00_3525, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_3528);
									return BgL_za2za2resza2za2z00_3531;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3149> */
	obj_t BGl_z62zc3anonymousza33149ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17045, obj_t BgL_sz00_17051)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_ifreesz00_17046;
				long BgL_siza7eza7_17047;
				BgL_ev_absz00_bglt BgL_i1252z00_17048;
				obj_t BgL_bodyz00_17049;
				long BgL_siza7ezd2framez75_17050;

				BgL_ifreesz00_17046 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17045, (int) (((long) 0))));
				BgL_siza7eza7_17047 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17045, (int) (((long) 1))));
				BgL_i1252z00_17048 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17045, (int) (((long) 2))));
				BgL_bodyz00_17049 = PROCEDURE_REF(BgL_envz00_17045, (int) (((long) 3)));
				BgL_siza7ezd2framez75_17050 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17045, (int) (((long) 4))));
				{
					obj_t BgL_sz00_3535;

					BgL_sz00_3535 = BgL_sz00_17051;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3537;

						BgL_bpz00_3537 = VECTOR_REF(BgL_sz00_3535, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_valza2za2_3538;

							BgL_valza2za2_3538 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_3535,
								BgL_bpz00_3537, BgL_ifreesz00_17046);
							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16144;

								BgL_runz00_16144 =
									MAKE_FX_PROCEDURE(BGl_z62run5530z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_runz00_16144,
									(int) (((long) 0)), BINT(BgL_siza7eza7_17047));
								PROCEDURE_SET(BgL_runz00_16144,
									(int) (((long) 1)), BgL_valza2za2_3538);
								PROCEDURE_SET(BgL_runz00_16144,
									(int) (((long) 2)), ((obj_t) BgL_i1252z00_17048));
								PROCEDURE_SET(BgL_runz00_16144,
									(int) (((long) 3)), BgL_bodyz00_17049);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16145;

									BgL_mainz00_16145 =
										MAKE_VA_PROCEDURE(BGl_z62main5529z62zz__evaluate_compz00,
										(int) (((long) -1)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_mainz00_16145,
										(int) (((long) 0)), BINT(BgL_siza7eza7_17047));
									PROCEDURE_SET(BgL_mainz00_16145,
										(int) (((long) 1)), BgL_valza2za2_3538);
									PROCEDURE_SET(BgL_mainz00_16145,
										(int) (((long) 2)), ((obj_t) BgL_i1252z00_17048));
									PROCEDURE_SET(BgL_mainz00_16145,
										(int) (((long) 3)), BgL_bodyz00_17049);
									PROCEDURE_SET(BgL_mainz00_16145,
										(int) (((long) 4)), BgL_runz00_16144);
									PROCEDURE_SET(BgL_mainz00_16145,
										(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_17050));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_11610;

										BgL_objz00_11610 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16144, BgL_objz00_11610);
										BgL_objz00_11610;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3150z00_3541;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3151z00_3542;

											BgL_arg3151z00_3542 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17048))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_11614;

												BgL_newz00_11614 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_29266;

													BgL_auxz00_29266 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_11614, BgL_auxz00_29266,
														BgL_arg3151z00_3542);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_29271;
													int BgL_auxz00_29269;

													BgL_auxz00_29271 = BINT(BgL_siza7ezd2framez75_17050);
													BgL_auxz00_29269 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_11614, BgL_auxz00_29269,
														BgL_auxz00_29271);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_29274;

													BgL_auxz00_29274 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_11614, BgL_auxz00_29274,
														BgL_runz00_16144);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_29279;
													int BgL_auxz00_29277;

													BgL_auxz00_29279 = BINT(((long) -1));
													BgL_auxz00_29277 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_11614, BgL_auxz00_29277,
														BgL_auxz00_29279);
												}
												BgL_arg3150z00_3541 = BgL_newz00_11614;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16145, BgL_arg3150z00_3541);
										BgL_arg3150z00_3541;
									}
									return BgL_mainz00_16145;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5529 */
	obj_t BGl_z62main5529z62zz__evaluate_compz00(obj_t BgL_envz00_17052,
		obj_t BgL_lastz00_17059)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_17057;
				long BgL_siza7ezd2framez75_17058;

				BgL_runz00_17057 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17052, (int) (((long) 4))));
				BgL_siza7ezd2framez75_17058 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17052, (int) (((long) 5))));
				{
					obj_t BgL_lastz00_3543;

					BgL_lastz00_3543 = BgL_lastz00_17059;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_3545;

						BgL_sz00_3545 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_3546;

							BgL_bpz00_3546 = VECTOR_REF(BgL_sz00_3545, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_29292;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_11554;

									BgL_arg1908z00_11554 = VECTOR_LENGTH(BgL_sz00_3545);
									BgL_testz00_29292 =
										(
										((long) CINT(BgL_bpz00_3546) +
											BgL_siza7ezd2framez75_17058) <
										(long) (BgL_arg1908z00_11554));
								}
								if (BgL_testz00_29292)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3154z00_3548;

											BgL_arg3154z00_3548 =
												((long) CINT(BgL_bpz00_3546) + ((long) 0));
											VECTOR_SET(BgL_sz00_3545,
												(int) (BgL_arg3154z00_3548), BgL_lastz00_3543);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1315z00_3549;

											BgL_val1315z00_3549 =
												BGl_zc3exitza33158ze3z83zz__evaluate_compz00
												(BgL_bpz00_3546, BgL_sz00_3545, BgL_runz00_17057);
											VECTOR_SET(BgL_sz00_3545, (int) (((long) 0)),
												BgL_bpz00_3546);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1315z00_3549)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1315z00_3549), CDR(BgL_val1315z00_3549));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1315z00_3549;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_3556;

										BgL_nsz00_3556 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_3556,
											(int) (((long) 1)), BgL_sz00_3545);
										VECTOR_SET(BgL_nsz00_3556,
											(int) (((long) 2)), BgL_lastz00_3543);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_29316;

											BgL_auxz00_29316 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_29316, BgL_nsz00_3556);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1318z00_3558;

											BgL_val1318z00_3558 =
												BGl_zc3exitza33164ze3z83zz__evaluate_compz00
												(BgL_runz00_17057, BgL_nsz00_3556);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_29320;

												BgL_auxz00_29320 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_29320, BgL_sz00_3545);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1318z00_3558)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1318z00_3558), CDR(BgL_val1318z00_3558));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1318z00_3558;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3164> */
	obj_t BGl_zc3exitza33164ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17530,
		obj_t BgL_nsz00_17529)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1319z00_3564;

			if (SET_EXIT(BgL_an_exit1319z00_3564))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1319z00_3564 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1319z00_3564, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1320z00_3565;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_11582;

								BgL_savedzd2bpzd2_11582 =
									VECTOR_REF(BgL_nsz00_17529, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17529,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_11589;

									BgL_fz00_11589 = BgL_runz00_17530;
								BgL_recz00_11588:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_11590;

										BgL_rz00_11590 =
											PROCEDURE_ENTRY(BgL_fz00_11589) (BgL_fz00_11589,
											BgL_nsz00_17529, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_29341;

											if (PROCEDUREP(BgL_rz00_11590))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_11595;

													BgL_arg1900z00_11595 = PROCEDURE_ATTR(BgL_rz00_11590);
													if (STRUCTP(BgL_arg1900z00_11595))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_29341 =
																(STRUCT_KEY(BgL_arg1900z00_11595) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_29341 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_29341 = ((bool_t) 0);
												}
											if (BgL_testz00_29341)
												{
													obj_t BgL_fz00_29349;

													BgL_fz00_29349 = BgL_rz00_11590;
													BgL_fz00_11589 = BgL_fz00_29349;
													goto BgL_recz00_11588;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17529,
														(int) (((long) 0)), BgL_savedzd2bpzd2_11582);
													BgL_val1320z00_3565 = BgL_rz00_11590;
							}}}}}
							POP_EXIT();
							return BgL_val1320z00_3565;
						}
					}
				}
		}
	}



/* <exit:3158> */
	obj_t BGl_zc3exitza33158ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17533,
		obj_t BgL_sz00_17532, obj_t BgL_runz00_17531)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1316z00_3554;

			if (SET_EXIT(BgL_an_exit1316z00_3554))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1316z00_3554 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1316z00_3554, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1317z00_3555;

							BgL_val1317z00_3555 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17531,
								BgL_sz00_17532, BgL_bpz00_17533);
							POP_EXIT();
							return BgL_val1317z00_3555;
						}
					}
				}
		}
	}



/* &run5530 */
	obj_t BGl_z62run5530z62zz__evaluate_compz00(obj_t BgL_envz00_17060,
		obj_t BgL_sz00_17065)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				long BgL_siza7eza7_17061;
				obj_t BgL_valza2za2_17062;
				BgL_ev_absz00_bglt BgL_i1252z00_17063;
				obj_t BgL_bodyz00_17064;

				BgL_siza7eza7_17061 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17060, (int) (((long) 0))));
				BgL_valza2za2_17062 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17060, (int) (((long) 1))));
				BgL_i1252z00_17063 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17060, (int) (((long) 2))));
				BgL_bodyz00_17064 = PROCEDURE_REF(BgL_envz00_17060, (int) (((long) 3)));
				{
					obj_t BgL_sz00_3567;

					BgL_sz00_3567 = BgL_sz00_17065;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3569;

						BgL_bpz00_3569 = VECTOR_REF(BgL_sz00_3567, (int) (((long) 0)));
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_3567,
							BgL_valza2za2_17062,
							((long) CINT(BgL_bpz00_3569) + BgL_siza7eza7_17061));
						{	/* Eval/evaluate_comp.scm 1049 */
							obj_t BgL_z12denvz12_3571;
							obj_t BgL_wherez00_3572;
							obj_t BgL_locz00_3573;

							BgL_z12denvz12_3571 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_3572 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17063))->BgL_wherez00);
							BgL_locz00_3573 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17063))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1049 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_3571, BgL_wherez00_3572,
									BgL_locz00_3573);
								{	/* Eval/evaluate_comp.scm 1049 */
									obj_t BgL_za2za2resza2za2z00_3574;

									BgL_za2za2resza2za2z00_3574 =
										PROCEDURE_ENTRY(BgL_bodyz00_17064) (BgL_bodyz00_17064,
										BgL_sz00_3567, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_3571);
									return BgL_za2za2resza2za2z00_3574;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3167> */
	obj_t BGl_z62zc3anonymousza33167ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17066, obj_t BgL_sz00_17073)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_ifreesz00_17067;
				obj_t BgL_iboxesz00_17068;
				long BgL_siza7eza7_17069;
				BgL_ev_absz00_bglt BgL_i1252z00_17070;
				obj_t BgL_bodyz00_17071;
				long BgL_siza7ezd2framez75_17072;

				BgL_ifreesz00_17067 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17066, (int) (((long) 0))));
				BgL_iboxesz00_17068 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17066, (int) (((long) 1))));
				BgL_siza7eza7_17069 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17066, (int) (((long) 2))));
				BgL_i1252z00_17070 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17066, (int) (((long) 3))));
				BgL_bodyz00_17071 = PROCEDURE_REF(BgL_envz00_17066, (int) (((long) 4)));
				BgL_siza7ezd2framez75_17072 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17066, (int) (((long) 5))));
				{
					obj_t BgL_sz00_3576;

					BgL_sz00_3576 = BgL_sz00_17073;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3578;

						BgL_bpz00_3578 = VECTOR_REF(BgL_sz00_3576, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_valza2za2_3579;

							BgL_valza2za2_3579 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_3576,
								BgL_bpz00_3578, BgL_ifreesz00_17067);
							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16141;

								BgL_runz00_16141 =
									MAKE_FX_PROCEDURE(BGl_z62run5532z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_runz00_16141,
									(int) (((long) 0)), BgL_iboxesz00_17068);
								PROCEDURE_SET(BgL_runz00_16141,
									(int) (((long) 1)), BINT(BgL_siza7eza7_17069));
								PROCEDURE_SET(BgL_runz00_16141,
									(int) (((long) 2)), BgL_valza2za2_3579);
								PROCEDURE_SET(BgL_runz00_16141,
									(int) (((long) 3)), ((obj_t) BgL_i1252z00_17070));
								PROCEDURE_SET(BgL_runz00_16141,
									(int) (((long) 4)), BgL_bodyz00_17071);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16142;

									BgL_mainz00_16142 =
										MAKE_VA_PROCEDURE(BGl_z62main5531z62zz__evaluate_compz00,
										(int) (((long) -1)), (int) (((long) 7)));
									PROCEDURE_SET(BgL_mainz00_16142,
										(int) (((long) 0)), BgL_iboxesz00_17068);
									PROCEDURE_SET(BgL_mainz00_16142,
										(int) (((long) 1)), BINT(BgL_siza7eza7_17069));
									PROCEDURE_SET(BgL_mainz00_16142,
										(int) (((long) 2)), BgL_valza2za2_3579);
									PROCEDURE_SET(BgL_mainz00_16142,
										(int) (((long) 3)), ((obj_t) BgL_i1252z00_17070));
									PROCEDURE_SET(BgL_mainz00_16142,
										(int) (((long) 4)), BgL_bodyz00_17071);
									PROCEDURE_SET(BgL_mainz00_16142,
										(int) (((long) 5)), BgL_runz00_16141);
									PROCEDURE_SET(BgL_mainz00_16142,
										(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_17072));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_11704;

										BgL_objz00_11704 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16141, BgL_objz00_11704);
										BgL_objz00_11704;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3168z00_3582;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3169z00_3583;

											BgL_arg3169z00_3583 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17070))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_11708;

												BgL_newz00_11708 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_29442;

													BgL_auxz00_29442 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_11708, BgL_auxz00_29442,
														BgL_arg3169z00_3583);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_29447;
													int BgL_auxz00_29445;

													BgL_auxz00_29447 = BINT(BgL_siza7ezd2framez75_17072);
													BgL_auxz00_29445 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_11708, BgL_auxz00_29445,
														BgL_auxz00_29447);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_29450;

													BgL_auxz00_29450 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_11708, BgL_auxz00_29450,
														BgL_runz00_16141);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_29455;
													int BgL_auxz00_29453;

													BgL_auxz00_29455 = BINT(((long) -1));
													BgL_auxz00_29453 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_11708, BgL_auxz00_29453,
														BgL_auxz00_29455);
												}
												BgL_arg3168z00_3582 = BgL_newz00_11708;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16142, BgL_arg3168z00_3582);
										BgL_arg3168z00_3582;
									}
									return BgL_mainz00_16142;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5531 */
	obj_t BGl_z62main5531z62zz__evaluate_compz00(obj_t BgL_envz00_17074,
		obj_t BgL_lastz00_17082)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_17080;
				long BgL_siza7ezd2framez75_17081;

				BgL_runz00_17080 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17074, (int) (((long) 5))));
				BgL_siza7ezd2framez75_17081 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17074, (int) (((long) 6))));
				{
					obj_t BgL_lastz00_3584;

					BgL_lastz00_3584 = BgL_lastz00_17082;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_3586;

						BgL_sz00_3586 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_3587;

							BgL_bpz00_3587 = VECTOR_REF(BgL_sz00_3586, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_29468;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_11648;

									BgL_arg1908z00_11648 = VECTOR_LENGTH(BgL_sz00_3586);
									BgL_testz00_29468 =
										(
										((long) CINT(BgL_bpz00_3587) +
											BgL_siza7ezd2framez75_17081) <
										(long) (BgL_arg1908z00_11648));
								}
								if (BgL_testz00_29468)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3172z00_3589;

											BgL_arg3172z00_3589 =
												((long) CINT(BgL_bpz00_3587) + ((long) 0));
											VECTOR_SET(BgL_sz00_3586,
												(int) (BgL_arg3172z00_3589), BgL_lastz00_3584);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1321z00_3590;

											BgL_val1321z00_3590 =
												BGl_zc3exitza33176ze3z83zz__evaluate_compz00
												(BgL_bpz00_3587, BgL_sz00_3586, BgL_runz00_17080);
											VECTOR_SET(BgL_sz00_3586, (int) (((long) 0)),
												BgL_bpz00_3587);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1321z00_3590)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1321z00_3590), CDR(BgL_val1321z00_3590));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1321z00_3590;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_3597;

										BgL_nsz00_3597 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_3597,
											(int) (((long) 1)), BgL_sz00_3586);
										VECTOR_SET(BgL_nsz00_3597,
											(int) (((long) 2)), BgL_lastz00_3584);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_29492;

											BgL_auxz00_29492 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_29492, BgL_nsz00_3597);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1324z00_3599;

											BgL_val1324z00_3599 =
												BGl_zc3exitza33182ze3z83zz__evaluate_compz00
												(BgL_runz00_17080, BgL_nsz00_3597);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_29496;

												BgL_auxz00_29496 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_29496, BgL_sz00_3586);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1324z00_3599)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1324z00_3599), CDR(BgL_val1324z00_3599));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1324z00_3599;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3182> */
	obj_t BGl_zc3exitza33182ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17525,
		obj_t BgL_nsz00_17524)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1325z00_3605;

			if (SET_EXIT(BgL_an_exit1325z00_3605))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1325z00_3605 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1325z00_3605, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1326z00_3606;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_11676;

								BgL_savedzd2bpzd2_11676 =
									VECTOR_REF(BgL_nsz00_17524, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17524,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_11683;

									BgL_fz00_11683 = BgL_runz00_17525;
								BgL_recz00_11682:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_11684;

										BgL_rz00_11684 =
											PROCEDURE_ENTRY(BgL_fz00_11683) (BgL_fz00_11683,
											BgL_nsz00_17524, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_29517;

											if (PROCEDUREP(BgL_rz00_11684))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_11689;

													BgL_arg1900z00_11689 = PROCEDURE_ATTR(BgL_rz00_11684);
													if (STRUCTP(BgL_arg1900z00_11689))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_29517 =
																(STRUCT_KEY(BgL_arg1900z00_11689) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_29517 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_29517 = ((bool_t) 0);
												}
											if (BgL_testz00_29517)
												{
													obj_t BgL_fz00_29525;

													BgL_fz00_29525 = BgL_rz00_11684;
													BgL_fz00_11683 = BgL_fz00_29525;
													goto BgL_recz00_11682;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17524,
														(int) (((long) 0)), BgL_savedzd2bpzd2_11676);
													BgL_val1326z00_3606 = BgL_rz00_11684;
							}}}}}
							POP_EXIT();
							return BgL_val1326z00_3606;
						}
					}
				}
		}
	}



/* <exit:3176> */
	obj_t BGl_zc3exitza33176ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17528,
		obj_t BgL_sz00_17527, obj_t BgL_runz00_17526)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1322z00_3595;

			if (SET_EXIT(BgL_an_exit1322z00_3595))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1322z00_3595 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1322z00_3595, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1323z00_3596;

							BgL_val1323z00_3596 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17526,
								BgL_sz00_17527, BgL_bpz00_17528);
							POP_EXIT();
							return BgL_val1323z00_3596;
						}
					}
				}
		}
	}



/* &run5532 */
	obj_t BGl_z62run5532z62zz__evaluate_compz00(obj_t BgL_envz00_17083,
		obj_t BgL_sz00_17089)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_17084;
				long BgL_siza7eza7_17085;
				obj_t BgL_valza2za2_17086;
				BgL_ev_absz00_bglt BgL_i1252z00_17087;
				obj_t BgL_bodyz00_17088;

				BgL_iboxesz00_17084 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17083, (int) (((long) 0))));
				BgL_siza7eza7_17085 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17083, (int) (((long) 1))));
				BgL_valza2za2_17086 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17083, (int) (((long) 2))));
				BgL_i1252z00_17087 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17083, (int) (((long) 3))));
				BgL_bodyz00_17088 = PROCEDURE_REF(BgL_envz00_17083, (int) (((long) 4)));
				{
					obj_t BgL_sz00_3608;

					BgL_sz00_3608 = BgL_sz00_17089;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3610;

						BgL_bpz00_3610 = VECTOR_REF(BgL_sz00_3608, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_3608,
							BgL_iboxesz00_17084, BgL_bpz00_3610);
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_3608,
							BgL_valza2za2_17086,
							((long) CINT(BgL_bpz00_3610) + BgL_siza7eza7_17085));
						{	/* Eval/evaluate_comp.scm 1049 */
							obj_t BgL_z12denvz12_3612;
							obj_t BgL_wherez00_3613;
							obj_t BgL_locz00_3614;

							BgL_z12denvz12_3612 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_3613 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17087))->BgL_wherez00);
							BgL_locz00_3614 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17087))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1049 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_3612, BgL_wherez00_3613,
									BgL_locz00_3614);
								{	/* Eval/evaluate_comp.scm 1049 */
									obj_t BgL_za2za2resza2za2z00_3615;

									BgL_za2za2resza2za2z00_3615 =
										PROCEDURE_ENTRY(BgL_bodyz00_17088) (BgL_bodyz00_17088,
										BgL_sz00_3608, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_3612);
									return BgL_za2za2resza2za2z00_3615;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3038> */
	obj_t BGl_z62zc3anonymousza33038ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17090, obj_t BgL_sz00_17094)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_17091;
				obj_t BgL_bodyz00_17092;
				long BgL_siza7ezd2framez75_17093;

				BgL_i1252z00_17091 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17090, (int) (((long) 0))));
				BgL_bodyz00_17092 = PROCEDURE_REF(BgL_envz00_17090, (int) (((long) 1)));
				BgL_siza7ezd2framez75_17093 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17090, (int) (((long) 2))));
				{
					obj_t BgL_sz00_3297;

					BgL_sz00_3297 = BgL_sz00_17094;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3299;

						BgL_bpz00_3299 = VECTOR_REF(BgL_sz00_3297, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */

							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16138;

								BgL_runz00_16138 =
									MAKE_FX_PROCEDURE(BGl_z62run5534z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_runz00_16138,
									(int) (((long) 0)), ((obj_t) BgL_i1252z00_17091));
								PROCEDURE_SET(BgL_runz00_16138,
									(int) (((long) 1)), BgL_bodyz00_17092);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16139;

									BgL_mainz00_16139 =
										MAKE_FX_PROCEDURE(BGl_z62main5533z62zz__evaluate_compz00,
										(int) (((long) 0)), (int) (((long) 4)));
									PROCEDURE_SET(BgL_mainz00_16139,
										(int) (((long) 0)), ((obj_t) BgL_i1252z00_17091));
									PROCEDURE_SET(BgL_mainz00_16139,
										(int) (((long) 1)), BgL_bodyz00_17092);
									PROCEDURE_SET(BgL_mainz00_16139,
										(int) (((long) 2)), BgL_runz00_16138);
									PROCEDURE_SET(BgL_mainz00_16139,
										(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_17093));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_11066;

										BgL_objz00_11066 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16138, BgL_objz00_11066);
										BgL_objz00_11066;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3039z00_3302;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3040z00_3303;

											BgL_arg3040z00_3303 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17091))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_11070;

												BgL_newz00_11070 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_29598;

													BgL_auxz00_29598 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_11070, BgL_auxz00_29598,
														BgL_arg3040z00_3303);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_29603;
													int BgL_auxz00_29601;

													BgL_auxz00_29603 = BINT(BgL_siza7ezd2framez75_17093);
													BgL_auxz00_29601 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_11070, BgL_auxz00_29601,
														BgL_auxz00_29603);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_29606;

													BgL_auxz00_29606 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_11070, BgL_auxz00_29606,
														BgL_runz00_16138);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_29611;
													int BgL_auxz00_29609;

													BgL_auxz00_29611 = BINT(((long) 0));
													BgL_auxz00_29609 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_11070, BgL_auxz00_29609,
														BgL_auxz00_29611);
												}
												BgL_arg3039z00_3302 = BgL_newz00_11070;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16139, BgL_arg3039z00_3302);
										BgL_arg3039z00_3302;
									}
									return BgL_mainz00_16139;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5533 */
	obj_t BGl_z62main5533z62zz__evaluate_compz00(obj_t BgL_envz00_17095)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_17098;
				long BgL_siza7ezd2framez75_17099;

				BgL_runz00_17098 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17095, (int) (((long) 2))));
				BgL_siza7ezd2framez75_17099 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17095, (int) (((long) 3))));
				{

					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_3305;

						BgL_sz00_3305 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_3306;

							BgL_bpz00_3306 = VECTOR_REF(BgL_sz00_3305, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_29624;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_11019;

									BgL_arg1908z00_11019 = VECTOR_LENGTH(BgL_sz00_3305);
									BgL_testz00_29624 =
										(
										((long) CINT(BgL_bpz00_3306) +
											BgL_siza7ezd2framez75_17099) <
										(long) (BgL_arg1908z00_11019));
								}
								if (BgL_testz00_29624)
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_val1279z00_3308;

										BgL_val1279z00_3308 =
											BGl_zc3exitza33046ze3z83zz__evaluate_compz00
											(BgL_bpz00_3306, BgL_sz00_3305, BgL_runz00_17098);
										VECTOR_SET(BgL_sz00_3305, (int) (((long) 0)),
											BgL_bpz00_3306);
										if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
												(BgL_val1279z00_3308)))
											{	/* Eval/evaluate_comp.scm 1129 */
												return
													BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
													(BgL_val1279z00_3308), CDR(BgL_val1279z00_3308));
											}
										else
											{	/* Eval/evaluate_comp.scm 1129 */
												return BgL_val1279z00_3308;
											}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_3315;

										BgL_nsz00_3315 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_3315,
											(int) (((long) 1)), BgL_sz00_3305);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_29642;

											BgL_auxz00_29642 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_29642, BgL_nsz00_3315);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1282z00_3317;

											BgL_val1282z00_3317 =
												BGl_zc3exitza33052ze3z83zz__evaluate_compz00
												(BgL_runz00_17098, BgL_nsz00_3315);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_29646;

												BgL_auxz00_29646 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_29646, BgL_sz00_3305);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1282z00_3317)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1282z00_3317), CDR(BgL_val1282z00_3317));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1282z00_3317;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3052> */
	obj_t BGl_zc3exitza33052ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17520,
		obj_t BgL_nsz00_17519)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1283z00_3323;

			if (SET_EXIT(BgL_an_exit1283z00_3323))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1283z00_3323 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1283z00_3323, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1284z00_3324;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_11038;

								BgL_savedzd2bpzd2_11038 =
									VECTOR_REF(BgL_nsz00_17519, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17519,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_11045;

									BgL_fz00_11045 = BgL_runz00_17520;
								BgL_recz00_11044:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_11046;

										BgL_rz00_11046 =
											PROCEDURE_ENTRY(BgL_fz00_11045) (BgL_fz00_11045,
											BgL_nsz00_17519, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_29667;

											if (PROCEDUREP(BgL_rz00_11046))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_11051;

													BgL_arg1900z00_11051 = PROCEDURE_ATTR(BgL_rz00_11046);
													if (STRUCTP(BgL_arg1900z00_11051))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_29667 =
																(STRUCT_KEY(BgL_arg1900z00_11051) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_29667 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_29667 = ((bool_t) 0);
												}
											if (BgL_testz00_29667)
												{
													obj_t BgL_fz00_29675;

													BgL_fz00_29675 = BgL_rz00_11046;
													BgL_fz00_11045 = BgL_fz00_29675;
													goto BgL_recz00_11044;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17519,
														(int) (((long) 0)), BgL_savedzd2bpzd2_11038);
													BgL_val1284z00_3324 = BgL_rz00_11046;
							}}}}}
							POP_EXIT();
							return BgL_val1284z00_3324;
						}
					}
				}
		}
	}



/* <exit:3046> */
	obj_t BGl_zc3exitza33046ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17523,
		obj_t BgL_sz00_17522, obj_t BgL_runz00_17521)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1280z00_3313;

			if (SET_EXIT(BgL_an_exit1280z00_3313))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1280z00_3313 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1280z00_3313, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1281z00_3314;

							BgL_val1281z00_3314 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17521,
								BgL_sz00_17522, BgL_bpz00_17523);
							POP_EXIT();
							return BgL_val1281z00_3314;
						}
					}
				}
		}
	}



/* &run5534 */
	obj_t BGl_z62run5534z62zz__evaluate_compz00(obj_t BgL_envz00_17100,
		obj_t BgL_sz00_17103)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_17101;
				obj_t BgL_bodyz00_17102;

				BgL_i1252z00_17101 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17100, (int) (((long) 0))));
				BgL_bodyz00_17102 = PROCEDURE_REF(BgL_envz00_17100, (int) (((long) 1)));
				{
					obj_t BgL_sz00_3326;

					BgL_sz00_3326 = BgL_sz00_17103;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3328;

						BgL_bpz00_3328 = VECTOR_REF(BgL_sz00_3326, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_z12denvz12_3329;
							obj_t BgL_wherez00_3330;
							obj_t BgL_locz00_3331;

							BgL_z12denvz12_3329 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_3330 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17101))->BgL_wherez00);
							BgL_locz00_3331 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17101))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1129 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_3329, BgL_wherez00_3330,
									BgL_locz00_3331);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_za2za2resza2za2z00_3332;

									BgL_za2za2resza2za2z00_3332 =
										PROCEDURE_ENTRY(BgL_bodyz00_17102) (BgL_bodyz00_17102,
										BgL_sz00_3326, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_3329);
									return BgL_za2za2resza2za2z00_3332;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3054> */
	obj_t BGl_z62zc3anonymousza33054ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17104, obj_t BgL_sz00_17109)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_17105;
				BgL_ev_absz00_bglt BgL_i1252z00_17106;
				obj_t BgL_bodyz00_17107;
				long BgL_siza7ezd2framez75_17108;

				BgL_iboxesz00_17105 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17104, (int) (((long) 0))));
				BgL_i1252z00_17106 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17104, (int) (((long) 1))));
				BgL_bodyz00_17107 = PROCEDURE_REF(BgL_envz00_17104, (int) (((long) 2)));
				BgL_siza7ezd2framez75_17108 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17104, (int) (((long) 3))));
				{
					obj_t BgL_sz00_3334;

					BgL_sz00_3334 = BgL_sz00_17109;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3336;

						BgL_bpz00_3336 = VECTOR_REF(BgL_sz00_3334, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */

							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16135;

								BgL_runz00_16135 =
									MAKE_FX_PROCEDURE(BGl_z62run5536z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_runz00_16135,
									(int) (((long) 0)), BgL_iboxesz00_17105);
								PROCEDURE_SET(BgL_runz00_16135,
									(int) (((long) 1)), ((obj_t) BgL_i1252z00_17106));
								PROCEDURE_SET(BgL_runz00_16135,
									(int) (((long) 2)), BgL_bodyz00_17107);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16136;

									BgL_mainz00_16136 =
										MAKE_FX_PROCEDURE(BGl_z62main5535z62zz__evaluate_compz00,
										(int) (((long) 0)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_mainz00_16136,
										(int) (((long) 0)), BgL_iboxesz00_17105);
									PROCEDURE_SET(BgL_mainz00_16136,
										(int) (((long) 1)), ((obj_t) BgL_i1252z00_17106));
									PROCEDURE_SET(BgL_mainz00_16136,
										(int) (((long) 2)), BgL_bodyz00_17107);
									PROCEDURE_SET(BgL_mainz00_16136,
										(int) (((long) 3)), BgL_runz00_16135);
									PROCEDURE_SET(BgL_mainz00_16136,
										(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_17108));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_11148;

										BgL_objz00_11148 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16135, BgL_objz00_11148);
										BgL_objz00_11148;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3055z00_3339;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3056z00_3340;

											BgL_arg3056z00_3340 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17106))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_11152;

												BgL_newz00_11152 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_29742;

													BgL_auxz00_29742 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_11152, BgL_auxz00_29742,
														BgL_arg3056z00_3340);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_29747;
													int BgL_auxz00_29745;

													BgL_auxz00_29747 = BINT(BgL_siza7ezd2framez75_17108);
													BgL_auxz00_29745 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_11152, BgL_auxz00_29745,
														BgL_auxz00_29747);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_29750;

													BgL_auxz00_29750 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_11152, BgL_auxz00_29750,
														BgL_runz00_16135);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_29755;
													int BgL_auxz00_29753;

													BgL_auxz00_29755 = BINT(((long) 0));
													BgL_auxz00_29753 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_11152, BgL_auxz00_29753,
														BgL_auxz00_29755);
												}
												BgL_arg3055z00_3339 = BgL_newz00_11152;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16136, BgL_arg3055z00_3339);
										BgL_arg3055z00_3339;
									}
									return BgL_mainz00_16136;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5535 */
	obj_t BGl_z62main5535z62zz__evaluate_compz00(obj_t BgL_envz00_17110)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_17114;
				long BgL_siza7ezd2framez75_17115;

				BgL_runz00_17114 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17110, (int) (((long) 3))));
				BgL_siza7ezd2framez75_17115 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17110, (int) (((long) 4))));
				{

					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_3342;

						BgL_sz00_3342 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_3343;

							BgL_bpz00_3343 = VECTOR_REF(BgL_sz00_3342, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_29768;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_11101;

									BgL_arg1908z00_11101 = VECTOR_LENGTH(BgL_sz00_3342);
									BgL_testz00_29768 =
										(
										((long) CINT(BgL_bpz00_3343) +
											BgL_siza7ezd2framez75_17115) <
										(long) (BgL_arg1908z00_11101));
								}
								if (BgL_testz00_29768)
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_val1285z00_3345;

										BgL_val1285z00_3345 =
											BGl_zc3exitza33062ze3z83zz__evaluate_compz00
											(BgL_bpz00_3343, BgL_sz00_3342, BgL_runz00_17114);
										VECTOR_SET(BgL_sz00_3342, (int) (((long) 0)),
											BgL_bpz00_3343);
										if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
												(BgL_val1285z00_3345)))
											{	/* Eval/evaluate_comp.scm 1129 */
												return
													BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
													(BgL_val1285z00_3345), CDR(BgL_val1285z00_3345));
											}
										else
											{	/* Eval/evaluate_comp.scm 1129 */
												return BgL_val1285z00_3345;
											}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_3352;

										BgL_nsz00_3352 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_3352,
											(int) (((long) 1)), BgL_sz00_3342);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_29786;

											BgL_auxz00_29786 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_29786, BgL_nsz00_3352);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1288z00_3354;

											BgL_val1288z00_3354 =
												BGl_zc3exitza33068ze3z83zz__evaluate_compz00
												(BgL_runz00_17114, BgL_nsz00_3352);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_29790;

												BgL_auxz00_29790 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_29790, BgL_sz00_3342);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1288z00_3354)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1288z00_3354), CDR(BgL_val1288z00_3354));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1288z00_3354;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3068> */
	obj_t BGl_zc3exitza33068ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17515,
		obj_t BgL_nsz00_17514)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1289z00_3360;

			if (SET_EXIT(BgL_an_exit1289z00_3360))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1289z00_3360 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1289z00_3360, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1290z00_3361;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_11120;

								BgL_savedzd2bpzd2_11120 =
									VECTOR_REF(BgL_nsz00_17514, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17514,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_11127;

									BgL_fz00_11127 = BgL_runz00_17515;
								BgL_recz00_11126:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_11128;

										BgL_rz00_11128 =
											PROCEDURE_ENTRY(BgL_fz00_11127) (BgL_fz00_11127,
											BgL_nsz00_17514, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_29811;

											if (PROCEDUREP(BgL_rz00_11128))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_11133;

													BgL_arg1900z00_11133 = PROCEDURE_ATTR(BgL_rz00_11128);
													if (STRUCTP(BgL_arg1900z00_11133))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_29811 =
																(STRUCT_KEY(BgL_arg1900z00_11133) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_29811 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_29811 = ((bool_t) 0);
												}
											if (BgL_testz00_29811)
												{
													obj_t BgL_fz00_29819;

													BgL_fz00_29819 = BgL_rz00_11128;
													BgL_fz00_11127 = BgL_fz00_29819;
													goto BgL_recz00_11126;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17514,
														(int) (((long) 0)), BgL_savedzd2bpzd2_11120);
													BgL_val1290z00_3361 = BgL_rz00_11128;
							}}}}}
							POP_EXIT();
							return BgL_val1290z00_3361;
						}
					}
				}
		}
	}



/* <exit:3062> */
	obj_t BGl_zc3exitza33062ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17518,
		obj_t BgL_sz00_17517, obj_t BgL_runz00_17516)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1286z00_3350;

			if (SET_EXIT(BgL_an_exit1286z00_3350))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1286z00_3350 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1286z00_3350, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1287z00_3351;

							BgL_val1287z00_3351 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17516,
								BgL_sz00_17517, BgL_bpz00_17518);
							POP_EXIT();
							return BgL_val1287z00_3351;
						}
					}
				}
		}
	}



/* &run5536 */
	obj_t BGl_z62run5536z62zz__evaluate_compz00(obj_t BgL_envz00_17116,
		obj_t BgL_sz00_17120)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_17117;
				BgL_ev_absz00_bglt BgL_i1252z00_17118;
				obj_t BgL_bodyz00_17119;

				BgL_iboxesz00_17117 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17116, (int) (((long) 0))));
				BgL_i1252z00_17118 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17116, (int) (((long) 1))));
				BgL_bodyz00_17119 = PROCEDURE_REF(BgL_envz00_17116, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3363;

					BgL_sz00_3363 = BgL_sz00_17120;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3365;

						BgL_bpz00_3365 = VECTOR_REF(BgL_sz00_3363, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_3363,
							BgL_iboxesz00_17117, BgL_bpz00_3365);
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_z12denvz12_3366;
							obj_t BgL_wherez00_3367;
							obj_t BgL_locz00_3368;

							BgL_z12denvz12_3366 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_3367 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17118))->BgL_wherez00);
							BgL_locz00_3368 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17118))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1129 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_3366, BgL_wherez00_3367,
									BgL_locz00_3368);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_za2za2resza2za2z00_3369;

									BgL_za2za2resza2za2z00_3369 =
										PROCEDURE_ENTRY(BgL_bodyz00_17119) (BgL_bodyz00_17119,
										BgL_sz00_3363, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_3366);
									return BgL_za2za2resza2za2z00_3369;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3072> */
	obj_t BGl_z62zc3anonymousza33072ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17121, obj_t BgL_sz00_17127)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_ifreesz00_17122;
				long BgL_siza7eza7_17123;
				BgL_ev_absz00_bglt BgL_i1252z00_17124;
				obj_t BgL_bodyz00_17125;
				long BgL_siza7ezd2framez75_17126;

				BgL_ifreesz00_17122 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17121, (int) (((long) 0))));
				BgL_siza7eza7_17123 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17121, (int) (((long) 1))));
				BgL_i1252z00_17124 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17121, (int) (((long) 2))));
				BgL_bodyz00_17125 = PROCEDURE_REF(BgL_envz00_17121, (int) (((long) 3)));
				BgL_siza7ezd2framez75_17126 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17121, (int) (((long) 4))));
				{
					obj_t BgL_sz00_3373;

					BgL_sz00_3373 = BgL_sz00_17127;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3375;

						BgL_bpz00_3375 = VECTOR_REF(BgL_sz00_3373, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_valza2za2_3376;

							BgL_valza2za2_3376 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_3373,
								BgL_bpz00_3375, BgL_ifreesz00_17122);
							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16132;

								BgL_runz00_16132 =
									MAKE_FX_PROCEDURE(BGl_z62run5538z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_runz00_16132,
									(int) (((long) 0)), BINT(BgL_siza7eza7_17123));
								PROCEDURE_SET(BgL_runz00_16132,
									(int) (((long) 1)), BgL_valza2za2_3376);
								PROCEDURE_SET(BgL_runz00_16132,
									(int) (((long) 2)), ((obj_t) BgL_i1252z00_17124));
								PROCEDURE_SET(BgL_runz00_16132,
									(int) (((long) 3)), BgL_bodyz00_17125);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16133;

									BgL_mainz00_16133 =
										MAKE_FX_PROCEDURE(BGl_z62main5537z62zz__evaluate_compz00,
										(int) (((long) 0)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_mainz00_16133,
										(int) (((long) 0)), BINT(BgL_siza7eza7_17123));
									PROCEDURE_SET(BgL_mainz00_16133,
										(int) (((long) 1)), BgL_valza2za2_3376);
									PROCEDURE_SET(BgL_mainz00_16133,
										(int) (((long) 2)), ((obj_t) BgL_i1252z00_17124));
									PROCEDURE_SET(BgL_mainz00_16133,
										(int) (((long) 3)), BgL_bodyz00_17125);
									PROCEDURE_SET(BgL_mainz00_16133,
										(int) (((long) 4)), BgL_runz00_16132);
									PROCEDURE_SET(BgL_mainz00_16133,
										(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_17126));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_11237;

										BgL_objz00_11237 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16132, BgL_objz00_11237);
										BgL_objz00_11237;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3073z00_3379;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3075z00_3380;

											BgL_arg3075z00_3380 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17124))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_11241;

												BgL_newz00_11241 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_29900;

													BgL_auxz00_29900 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_11241, BgL_auxz00_29900,
														BgL_arg3075z00_3380);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_29905;
													int BgL_auxz00_29903;

													BgL_auxz00_29905 = BINT(BgL_siza7ezd2framez75_17126);
													BgL_auxz00_29903 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_11241, BgL_auxz00_29903,
														BgL_auxz00_29905);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_29908;

													BgL_auxz00_29908 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_11241, BgL_auxz00_29908,
														BgL_runz00_16132);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_29913;
													int BgL_auxz00_29911;

													BgL_auxz00_29913 = BINT(((long) 0));
													BgL_auxz00_29911 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_11241, BgL_auxz00_29911,
														BgL_auxz00_29913);
												}
												BgL_arg3073z00_3379 = BgL_newz00_11241;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16133, BgL_arg3073z00_3379);
										BgL_arg3073z00_3379;
									}
									return BgL_mainz00_16133;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5537 */
	obj_t BGl_z62main5537z62zz__evaluate_compz00(obj_t BgL_envz00_17128)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_17133;
				long BgL_siza7ezd2framez75_17134;

				BgL_runz00_17133 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17128, (int) (((long) 4))));
				BgL_siza7ezd2framez75_17134 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17128, (int) (((long) 5))));
				{

					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_3382;

						BgL_sz00_3382 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_3383;

							BgL_bpz00_3383 = VECTOR_REF(BgL_sz00_3382, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_29926;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_11190;

									BgL_arg1908z00_11190 = VECTOR_LENGTH(BgL_sz00_3382);
									BgL_testz00_29926 =
										(
										((long) CINT(BgL_bpz00_3383) +
											BgL_siza7ezd2framez75_17134) <
										(long) (BgL_arg1908z00_11190));
								}
								if (BgL_testz00_29926)
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_val1291z00_3385;

										BgL_val1291z00_3385 =
											BGl_zc3exitza33081ze3z83zz__evaluate_compz00
											(BgL_bpz00_3383, BgL_sz00_3382, BgL_runz00_17133);
										VECTOR_SET(BgL_sz00_3382, (int) (((long) 0)),
											BgL_bpz00_3383);
										if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
												(BgL_val1291z00_3385)))
											{	/* Eval/evaluate_comp.scm 1129 */
												return
													BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
													(BgL_val1291z00_3385), CDR(BgL_val1291z00_3385));
											}
										else
											{	/* Eval/evaluate_comp.scm 1129 */
												return BgL_val1291z00_3385;
											}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_3392;

										BgL_nsz00_3392 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_3392,
											(int) (((long) 1)), BgL_sz00_3382);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_29944;

											BgL_auxz00_29944 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_29944, BgL_nsz00_3392);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1294z00_3394;

											BgL_val1294z00_3394 =
												BGl_zc3exitza33088ze3z83zz__evaluate_compz00
												(BgL_runz00_17133, BgL_nsz00_3392);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_29948;

												BgL_auxz00_29948 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_29948, BgL_sz00_3382);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1294z00_3394)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1294z00_3394), CDR(BgL_val1294z00_3394));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1294z00_3394;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3088> */
	obj_t BGl_zc3exitza33088ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17510,
		obj_t BgL_nsz00_17509)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1295z00_3400;

			if (SET_EXIT(BgL_an_exit1295z00_3400))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1295z00_3400 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1295z00_3400, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1296z00_3401;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_11209;

								BgL_savedzd2bpzd2_11209 =
									VECTOR_REF(BgL_nsz00_17509, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17509,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_11216;

									BgL_fz00_11216 = BgL_runz00_17510;
								BgL_recz00_11215:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_11217;

										BgL_rz00_11217 =
											PROCEDURE_ENTRY(BgL_fz00_11216) (BgL_fz00_11216,
											BgL_nsz00_17509, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_29969;

											if (PROCEDUREP(BgL_rz00_11217))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_11222;

													BgL_arg1900z00_11222 = PROCEDURE_ATTR(BgL_rz00_11217);
													if (STRUCTP(BgL_arg1900z00_11222))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_29969 =
																(STRUCT_KEY(BgL_arg1900z00_11222) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_29969 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_29969 = ((bool_t) 0);
												}
											if (BgL_testz00_29969)
												{
													obj_t BgL_fz00_29977;

													BgL_fz00_29977 = BgL_rz00_11217;
													BgL_fz00_11216 = BgL_fz00_29977;
													goto BgL_recz00_11215;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17509,
														(int) (((long) 0)), BgL_savedzd2bpzd2_11209);
													BgL_val1296z00_3401 = BgL_rz00_11217;
							}}}}}
							POP_EXIT();
							return BgL_val1296z00_3401;
						}
					}
				}
		}
	}



/* <exit:3081> */
	obj_t BGl_zc3exitza33081ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17513,
		obj_t BgL_sz00_17512, obj_t BgL_runz00_17511)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1292z00_3390;

			if (SET_EXIT(BgL_an_exit1292z00_3390))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1292z00_3390 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1292z00_3390, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1293z00_3391;

							BgL_val1293z00_3391 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17511,
								BgL_sz00_17512, BgL_bpz00_17513);
							POP_EXIT();
							return BgL_val1293z00_3391;
						}
					}
				}
		}
	}



/* &run5538 */
	obj_t BGl_z62run5538z62zz__evaluate_compz00(obj_t BgL_envz00_17135,
		obj_t BgL_sz00_17140)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				long BgL_siza7eza7_17136;
				obj_t BgL_valza2za2_17137;
				BgL_ev_absz00_bglt BgL_i1252z00_17138;
				obj_t BgL_bodyz00_17139;

				BgL_siza7eza7_17136 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17135, (int) (((long) 0))));
				BgL_valza2za2_17137 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17135, (int) (((long) 1))));
				BgL_i1252z00_17138 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17135, (int) (((long) 2))));
				BgL_bodyz00_17139 = PROCEDURE_REF(BgL_envz00_17135, (int) (((long) 3)));
				{
					obj_t BgL_sz00_3403;

					BgL_sz00_3403 = BgL_sz00_17140;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3405;

						BgL_bpz00_3405 = VECTOR_REF(BgL_sz00_3403, (int) (((long) 0)));
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_3403,
							BgL_valza2za2_17137,
							((long) CINT(BgL_bpz00_3405) + BgL_siza7eza7_17136));
						{	/* Eval/evaluate_comp.scm 1049 */
							obj_t BgL_z12denvz12_3407;
							obj_t BgL_wherez00_3408;
							obj_t BgL_locz00_3409;

							BgL_z12denvz12_3407 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_3408 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17138))->BgL_wherez00);
							BgL_locz00_3409 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17138))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1049 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_3407, BgL_wherez00_3408,
									BgL_locz00_3409);
								{	/* Eval/evaluate_comp.scm 1049 */
									obj_t BgL_za2za2resza2za2z00_3410;

									BgL_za2za2resza2za2z00_3410 =
										PROCEDURE_ENTRY(BgL_bodyz00_17139) (BgL_bodyz00_17139,
										BgL_sz00_3403, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_3407);
									return BgL_za2za2resza2za2z00_3410;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3091> */
	obj_t BGl_z62zc3anonymousza33091ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17141, obj_t BgL_sz00_17148)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_ifreesz00_17142;
				obj_t BgL_iboxesz00_17143;
				long BgL_siza7eza7_17144;
				BgL_ev_absz00_bglt BgL_i1252z00_17145;
				obj_t BgL_bodyz00_17146;
				long BgL_siza7ezd2framez75_17147;

				BgL_ifreesz00_17142 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17141, (int) (((long) 0))));
				BgL_iboxesz00_17143 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17141, (int) (((long) 1))));
				BgL_siza7eza7_17144 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17141, (int) (((long) 2))));
				BgL_i1252z00_17145 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17141, (int) (((long) 3))));
				BgL_bodyz00_17146 = PROCEDURE_REF(BgL_envz00_17141, (int) (((long) 4)));
				BgL_siza7ezd2framez75_17147 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17141, (int) (((long) 5))));
				{
					obj_t BgL_sz00_3412;

					BgL_sz00_3412 = BgL_sz00_17148;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3414;

						BgL_bpz00_3414 = VECTOR_REF(BgL_sz00_3412, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_valza2za2_3415;

							BgL_valza2za2_3415 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_3412,
								BgL_bpz00_3414, BgL_ifreesz00_17142);
							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16129;

								BgL_runz00_16129 =
									MAKE_FX_PROCEDURE(BGl_z62run5540z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_runz00_16129,
									(int) (((long) 0)), BgL_iboxesz00_17143);
								PROCEDURE_SET(BgL_runz00_16129,
									(int) (((long) 1)), BINT(BgL_siza7eza7_17144));
								PROCEDURE_SET(BgL_runz00_16129,
									(int) (((long) 2)), BgL_valza2za2_3415);
								PROCEDURE_SET(BgL_runz00_16129,
									(int) (((long) 3)), ((obj_t) BgL_i1252z00_17145));
								PROCEDURE_SET(BgL_runz00_16129,
									(int) (((long) 4)), BgL_bodyz00_17146);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16130;

									BgL_mainz00_16130 =
										MAKE_FX_PROCEDURE(BGl_z62main5539z62zz__evaluate_compz00,
										(int) (((long) 0)), (int) (((long) 7)));
									PROCEDURE_SET(BgL_mainz00_16130,
										(int) (((long) 0)), BgL_iboxesz00_17143);
									PROCEDURE_SET(BgL_mainz00_16130,
										(int) (((long) 1)), BINT(BgL_siza7eza7_17144));
									PROCEDURE_SET(BgL_mainz00_16130,
										(int) (((long) 2)), BgL_valza2za2_3415);
									PROCEDURE_SET(BgL_mainz00_16130,
										(int) (((long) 3)), ((obj_t) BgL_i1252z00_17145));
									PROCEDURE_SET(BgL_mainz00_16130,
										(int) (((long) 4)), BgL_bodyz00_17146);
									PROCEDURE_SET(BgL_mainz00_16130,
										(int) (((long) 5)), BgL_runz00_16129);
									PROCEDURE_SET(BgL_mainz00_16130,
										(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_17147));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_11322;

										BgL_objz00_11322 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16129, BgL_objz00_11322);
										BgL_objz00_11322;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3092z00_3418;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3093z00_3419;

											BgL_arg3093z00_3419 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17145))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_11326;

												BgL_newz00_11326 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_30070;

													BgL_auxz00_30070 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_11326, BgL_auxz00_30070,
														BgL_arg3093z00_3419);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_30075;
													int BgL_auxz00_30073;

													BgL_auxz00_30075 = BINT(BgL_siza7ezd2framez75_17147);
													BgL_auxz00_30073 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_11326, BgL_auxz00_30073,
														BgL_auxz00_30075);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_30078;

													BgL_auxz00_30078 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_11326, BgL_auxz00_30078,
														BgL_runz00_16129);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_30083;
													int BgL_auxz00_30081;

													BgL_auxz00_30083 = BINT(((long) 0));
													BgL_auxz00_30081 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_11326, BgL_auxz00_30081,
														BgL_auxz00_30083);
												}
												BgL_arg3092z00_3418 = BgL_newz00_11326;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16130, BgL_arg3092z00_3418);
										BgL_arg3092z00_3418;
									}
									return BgL_mainz00_16130;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5539 */
	obj_t BGl_z62main5539z62zz__evaluate_compz00(obj_t BgL_envz00_17149)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_runz00_17155;
				long BgL_siza7ezd2framez75_17156;

				BgL_runz00_17155 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17149, (int) (((long) 5))));
				BgL_siza7ezd2framez75_17156 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17149, (int) (((long) 6))));
				{

					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_3421;

						BgL_sz00_3421 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_3422;

							BgL_bpz00_3422 = VECTOR_REF(BgL_sz00_3421, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_30096;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_11275;

									BgL_arg1908z00_11275 = VECTOR_LENGTH(BgL_sz00_3421);
									BgL_testz00_30096 =
										(
										((long) CINT(BgL_bpz00_3422) +
											BgL_siza7ezd2framez75_17156) <
										(long) (BgL_arg1908z00_11275));
								}
								if (BgL_testz00_30096)
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_val1297z00_3424;

										BgL_val1297z00_3424 =
											BGl_zc3exitza33099ze3z83zz__evaluate_compz00
											(BgL_bpz00_3422, BgL_sz00_3421, BgL_runz00_17155);
										VECTOR_SET(BgL_sz00_3421, (int) (((long) 0)),
											BgL_bpz00_3422);
										if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
												(BgL_val1297z00_3424)))
											{	/* Eval/evaluate_comp.scm 1129 */
												return
													BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
													(BgL_val1297z00_3424), CDR(BgL_val1297z00_3424));
											}
										else
											{	/* Eval/evaluate_comp.scm 1129 */
												return BgL_val1297z00_3424;
											}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_3431;

										BgL_nsz00_3431 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_3431,
											(int) (((long) 1)), BgL_sz00_3421);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_30114;

											BgL_auxz00_30114 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_30114, BgL_nsz00_3431);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1300z00_3433;

											BgL_val1300z00_3433 =
												BGl_zc3exitza33105ze3z83zz__evaluate_compz00
												(BgL_runz00_17155, BgL_nsz00_3431);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_30118;

												BgL_auxz00_30118 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_30118, BgL_sz00_3421);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1300z00_3433)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1300z00_3433), CDR(BgL_val1300z00_3433));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1300z00_3433;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3105> */
	obj_t BGl_zc3exitza33105ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17505,
		obj_t BgL_nsz00_17504)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1301z00_3439;

			if (SET_EXIT(BgL_an_exit1301z00_3439))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1301z00_3439 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1301z00_3439, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1302z00_3440;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_11294;

								BgL_savedzd2bpzd2_11294 =
									VECTOR_REF(BgL_nsz00_17504, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17504,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_11301;

									BgL_fz00_11301 = BgL_runz00_17505;
								BgL_recz00_11300:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_11302;

										BgL_rz00_11302 =
											PROCEDURE_ENTRY(BgL_fz00_11301) (BgL_fz00_11301,
											BgL_nsz00_17504, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_30139;

											if (PROCEDUREP(BgL_rz00_11302))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_11307;

													BgL_arg1900z00_11307 = PROCEDURE_ATTR(BgL_rz00_11302);
													if (STRUCTP(BgL_arg1900z00_11307))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_30139 =
																(STRUCT_KEY(BgL_arg1900z00_11307) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_30139 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_30139 = ((bool_t) 0);
												}
											if (BgL_testz00_30139)
												{
													obj_t BgL_fz00_30147;

													BgL_fz00_30147 = BgL_rz00_11302;
													BgL_fz00_11301 = BgL_fz00_30147;
													goto BgL_recz00_11300;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17504,
														(int) (((long) 0)), BgL_savedzd2bpzd2_11294);
													BgL_val1302z00_3440 = BgL_rz00_11302;
							}}}}}
							POP_EXIT();
							return BgL_val1302z00_3440;
						}
					}
				}
		}
	}



/* <exit:3099> */
	obj_t BGl_zc3exitza33099ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17508,
		obj_t BgL_sz00_17507, obj_t BgL_runz00_17506)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1298z00_3429;

			if (SET_EXIT(BgL_an_exit1298z00_3429))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1298z00_3429 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1298z00_3429, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1299z00_3430;

							BgL_val1299z00_3430 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17506,
								BgL_sz00_17507, BgL_bpz00_17508);
							POP_EXIT();
							return BgL_val1299z00_3430;
						}
					}
				}
		}
	}



/* &run5540 */
	obj_t BGl_z62run5540z62zz__evaluate_compz00(obj_t BgL_envz00_17157,
		obj_t BgL_sz00_17163)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_17158;
				long BgL_siza7eza7_17159;
				obj_t BgL_valza2za2_17160;
				BgL_ev_absz00_bglt BgL_i1252z00_17161;
				obj_t BgL_bodyz00_17162;

				BgL_iboxesz00_17158 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17157, (int) (((long) 0))));
				BgL_siza7eza7_17159 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17157, (int) (((long) 1))));
				BgL_valza2za2_17160 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17157, (int) (((long) 2))));
				BgL_i1252z00_17161 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17157, (int) (((long) 3))));
				BgL_bodyz00_17162 = PROCEDURE_REF(BgL_envz00_17157, (int) (((long) 4)));
				{
					obj_t BgL_sz00_3442;

					BgL_sz00_3442 = BgL_sz00_17163;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_3444;

						BgL_bpz00_3444 = VECTOR_REF(BgL_sz00_3442, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_3442,
							BgL_iboxesz00_17158, BgL_bpz00_3444);
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_3442,
							BgL_valza2za2_17160,
							((long) CINT(BgL_bpz00_3444) + BgL_siza7eza7_17159));
						{	/* Eval/evaluate_comp.scm 1049 */
							obj_t BgL_z12denvz12_3446;
							obj_t BgL_wherez00_3447;
							obj_t BgL_locz00_3448;

							BgL_z12denvz12_3446 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_3447 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17161))->BgL_wherez00);
							BgL_locz00_3448 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17161))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1049 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_3446, BgL_wherez00_3447,
									BgL_locz00_3448);
								{	/* Eval/evaluate_comp.scm 1049 */
									obj_t BgL_za2za2resza2za2z00_3449;

									BgL_za2za2resza2za2z00_3449 =
										PROCEDURE_ENTRY(BgL_bodyz00_17162) (BgL_bodyz00_17162,
										BgL_sz00_3442, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_3446);
									return BgL_za2za2resza2za2z00_3449;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3870> */
	obj_t BGl_z62zc3anonymousza33870ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17164, obj_t BgL_sz00_17168)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_17165;
				obj_t BgL_bodyz00_17166;
				long BgL_siza7ezd2framez75_17167;

				BgL_i1252z00_17165 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17164, (int) (((long) 0))));
				BgL_bodyz00_17166 = PROCEDURE_REF(BgL_envz00_17164, (int) (((long) 1)));
				BgL_siza7ezd2framez75_17167 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17164, (int) (((long) 2))));
				{
					obj_t BgL_sz00_5077;

					BgL_sz00_5077 = BgL_sz00_17168;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_5079;

						BgL_bpz00_5079 = VECTOR_REF(BgL_sz00_5077, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */

							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16258;

								BgL_runz00_16258 =
									MAKE_FX_PROCEDURE(BGl_z62run5542z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_runz00_16258,
									(int) (((long) 0)), ((obj_t) BgL_i1252z00_17165));
								PROCEDURE_SET(BgL_runz00_16258,
									(int) (((long) 1)), BgL_bodyz00_17166);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16259;

									BgL_mainz00_16259 =
										MAKE_VA_PROCEDURE(BGl_z62main5541z62zz__evaluate_compz00,
										(int) (((long) -5)), (int) (((long) 4)));
									PROCEDURE_SET(BgL_mainz00_16259,
										(int) (((long) 0)), BgL_bodyz00_17166);
									PROCEDURE_SET(BgL_mainz00_16259,
										(int) (((long) 1)), ((obj_t) BgL_i1252z00_17165));
									PROCEDURE_SET(BgL_mainz00_16259,
										(int) (((long) 2)), BgL_runz00_16258);
									PROCEDURE_SET(BgL_mainz00_16259,
										(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_17167));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_10531;

										BgL_objz00_10531 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16258, BgL_objz00_10531);
										BgL_objz00_10531;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3871z00_5082;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3872z00_5083;
											obj_t BgL_arg3873z00_5084;

											BgL_arg3872z00_5083 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17165))->
												BgL_arityz00);
											BgL_arg3873z00_5084 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17165))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_10535;

												BgL_newz00_10535 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_30221;

													BgL_auxz00_30221 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_10535, BgL_auxz00_30221,
														BgL_arg3873z00_5084);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_30226;
													int BgL_auxz00_30224;

													BgL_auxz00_30226 = BINT(BgL_siza7ezd2framez75_17167);
													BgL_auxz00_30224 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_10535, BgL_auxz00_30224,
														BgL_auxz00_30226);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_30229;

													BgL_auxz00_30229 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_10535, BgL_auxz00_30229,
														BgL_runz00_16258);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_30232;

													BgL_auxz00_30232 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_10535, BgL_auxz00_30232,
														BgL_arg3872z00_5083);
												}
												BgL_arg3871z00_5082 = BgL_newz00_10535;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16259, BgL_arg3871z00_5082);
										BgL_arg3871z00_5082;
									}
									return BgL_mainz00_16259;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5541 */
	obj_t BGl_z62main5541z62zz__evaluate_compz00(obj_t BgL_envz00_17169,
		obj_t BgL_az00_17174, obj_t BgL_bz00_17175, obj_t BgL_cz00_17176,
		obj_t BgL_dz00_17177, obj_t BgL_restz00_17178)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_17171;
				obj_t BgL_runz00_17172;
				long BgL_siza7ezd2framez75_17173;

				BgL_i1252z00_17171 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17169, (int) (((long) 1))));
				BgL_runz00_17172 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17169, (int) (((long) 2))));
				BgL_siza7ezd2framez75_17173 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17169, (int) (((long) 3))));
				{
					obj_t BgL_az00_5085;
					obj_t BgL_bz00_5086;
					obj_t BgL_cz00_5087;
					obj_t BgL_dz00_5088;
					obj_t BgL_restz00_5089;

					BgL_az00_5085 = BgL_az00_17174;
					BgL_bz00_5086 = BgL_bz00_17175;
					BgL_cz00_5087 = BgL_cz00_17176;
					BgL_dz00_5088 = BgL_dz00_17177;
					BgL_restz00_5089 = BgL_restz00_17178;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_5091;

						BgL_sz00_5091 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_5092;

							BgL_bpz00_5092 = VECTOR_REF(BgL_sz00_5091, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_30248;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_10421;

									BgL_arg1908z00_10421 = VECTOR_LENGTH(BgL_sz00_5091);
									BgL_testz00_30248 =
										(
										((long) CINT(BgL_bpz00_5092) +
											BgL_siza7ezd2framez75_17173) <
										(long) (BgL_arg1908z00_10421));
								}
								if (BgL_testz00_30248)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3876z00_5094;

											BgL_arg3876z00_5094 =
												((long) CINT(BgL_bpz00_5092) + ((long) 0));
											VECTOR_SET(BgL_sz00_5091,
												(int) (BgL_arg3876z00_5094), BgL_az00_5085);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3877z00_5095;

											BgL_arg3877z00_5095 =
												((long) CINT(BgL_bpz00_5092) + ((long) 1));
											VECTOR_SET(BgL_sz00_5091,
												(int) (BgL_arg3877z00_5095), BgL_bz00_5086);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3878z00_5096;

											BgL_arg3878z00_5096 =
												((long) CINT(BgL_bpz00_5092) + ((long) 2));
											VECTOR_SET(BgL_sz00_5091,
												(int) (BgL_arg3878z00_5096), BgL_cz00_5087);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3879z00_5097;

											BgL_arg3879z00_5097 =
												((long) CINT(BgL_bpz00_5092) + ((long) 3));
											VECTOR_SET(BgL_sz00_5091,
												(int) (BgL_arg3879z00_5097), BgL_dz00_5088);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3880z00_5098;
											long BgL_arg3881z00_5099;
											long BgL_arg3882z00_5100;
											obj_t BgL_arg3883z00_5101;

											BgL_arg3880z00_5098 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17171))->
												BgL_wherez00);
											BgL_arg3881z00_5099 =
												((long) CINT(BgL_bpz00_5092) + ((long) 4));
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_nz00_10456;

												BgL_nz00_10456 =
													(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17171))->
													BgL_arityz00);
												if (((long) CINT(BgL_nz00_10456) < ((long) 0)))
													{	/* Eval/evaluate_comp.scm 1013 */
														BgL_arg3882z00_5100 =
															((long) CINT(BgL_nz00_10456) + ((long) 4));
													}
												else
													{	/* Eval/evaluate_comp.scm 1013 */
														BgL_arg3882z00_5100 =
															((long) CINT(BgL_nz00_10456) - ((long) 4));
											}}
											BgL_arg3883z00_5101 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17171))->
												BgL_locz00);
											BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_5091,
												BgL_arg3880z00_5098, BgL_arg3881z00_5099,
												BgL_arg3882z00_5100, BgL_restz00_5089,
												BgL_arg3883z00_5101);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1253z00_5103;

											BgL_val1253z00_5103 =
												BGl_zc3exitza33888ze3z83zz__evaluate_compz00
												(BgL_bpz00_5092, BgL_sz00_5091, BgL_runz00_17172);
											VECTOR_SET(BgL_sz00_5091, (int) (((long) 0)),
												BgL_bpz00_5092);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1253z00_5103)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1253z00_5103), CDR(BgL_val1253z00_5103));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1253z00_5103;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_5110;

										BgL_nsz00_5110 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5110,
											(int) (((long) 1)), BgL_sz00_5091);
										VECTOR_SET(BgL_nsz00_5110,
											(int) (((long) 2)), BgL_az00_5085);
										VECTOR_SET(BgL_nsz00_5110,
											(int) (((long) 3)), BgL_bz00_5086);
										VECTOR_SET(BgL_nsz00_5110,
											(int) (((long) 4)), BgL_cz00_5087);
										VECTOR_SET(BgL_nsz00_5110,
											(int) (((long) 5)), BgL_dz00_5088);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3889z00_5111;
											long BgL_arg3890z00_5112;
											obj_t BgL_arg3891z00_5113;

											BgL_arg3889z00_5111 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17171))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_nz00_10488;

												BgL_nz00_10488 =
													(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17171))->
													BgL_arityz00);
												if (((long) CINT(BgL_nz00_10488) < ((long) 0)))
													{	/* Eval/evaluate_comp.scm 1013 */
														BgL_arg3890z00_5112 =
															((long) CINT(BgL_nz00_10488) + ((long) 4));
													}
												else
													{	/* Eval/evaluate_comp.scm 1013 */
														BgL_arg3890z00_5112 =
															((long) CINT(BgL_nz00_10488) - ((long) 4));
											}}
											BgL_arg3891z00_5113 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17171))->
												BgL_locz00);
											BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_5110,
												BgL_arg3889z00_5111, ((long) 6), BgL_arg3890z00_5112,
												BgL_restz00_5089, BgL_arg3891z00_5113);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_30314;

											BgL_auxz00_30314 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_30314, BgL_nsz00_5110);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1256z00_5116;

											BgL_val1256z00_5116 =
												BGl_zc3exitza33898ze3z83zz__evaluate_compz00
												(BgL_runz00_17172, BgL_nsz00_5110);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_30318;

												BgL_auxz00_30318 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_30318, BgL_sz00_5091);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1256z00_5116)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1256z00_5116), CDR(BgL_val1256z00_5116));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1256z00_5116;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3898> */
	obj_t BGl_zc3exitza33898ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17500,
		obj_t BgL_nsz00_17499)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1257z00_5122;

			if (SET_EXIT(BgL_an_exit1257z00_5122))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1257z00_5122 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1257z00_5122, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1258z00_5123;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_10503;

								BgL_savedzd2bpzd2_10503 =
									VECTOR_REF(BgL_nsz00_17499, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17499,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_10510;

									BgL_fz00_10510 = BgL_runz00_17500;
								BgL_recz00_10509:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_10511;

										BgL_rz00_10511 =
											PROCEDURE_ENTRY(BgL_fz00_10510) (BgL_fz00_10510,
											BgL_nsz00_17499, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_30339;

											if (PROCEDUREP(BgL_rz00_10511))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_10516;

													BgL_arg1900z00_10516 = PROCEDURE_ATTR(BgL_rz00_10511);
													if (STRUCTP(BgL_arg1900z00_10516))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_30339 =
																(STRUCT_KEY(BgL_arg1900z00_10516) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_30339 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_30339 = ((bool_t) 0);
												}
											if (BgL_testz00_30339)
												{
													obj_t BgL_fz00_30347;

													BgL_fz00_30347 = BgL_rz00_10511;
													BgL_fz00_10510 = BgL_fz00_30347;
													goto BgL_recz00_10509;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17499,
														(int) (((long) 0)), BgL_savedzd2bpzd2_10503);
													BgL_val1258z00_5123 = BgL_rz00_10511;
							}}}}}
							POP_EXIT();
							return BgL_val1258z00_5123;
						}
					}
				}
		}
	}



/* <exit:3888> */
	obj_t BGl_zc3exitza33888ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17503,
		obj_t BgL_sz00_17502, obj_t BgL_runz00_17501)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1254z00_5108;

			if (SET_EXIT(BgL_an_exit1254z00_5108))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1254z00_5108 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1254z00_5108, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1255z00_5109;

							BgL_val1255z00_5109 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17501,
								BgL_sz00_17502, BgL_bpz00_17503);
							POP_EXIT();
							return BgL_val1255z00_5109;
						}
					}
				}
		}
	}



/* &run5542 */
	obj_t BGl_z62run5542z62zz__evaluate_compz00(obj_t BgL_envz00_17179,
		obj_t BgL_sz00_17182)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_17180;
				obj_t BgL_bodyz00_17181;

				BgL_i1252z00_17180 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17179, (int) (((long) 0))));
				BgL_bodyz00_17181 = PROCEDURE_REF(BgL_envz00_17179, (int) (((long) 1)));
				{
					obj_t BgL_sz00_5125;

					BgL_sz00_5125 = BgL_sz00_17182;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_5127;

						BgL_bpz00_5127 = VECTOR_REF(BgL_sz00_5125, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_z12denvz12_5128;
							obj_t BgL_wherez00_5129;
							obj_t BgL_locz00_5130;

							BgL_z12denvz12_5128 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5129 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17180))->BgL_wherez00);
							BgL_locz00_5130 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17180))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1129 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5128, BgL_wherez00_5129,
									BgL_locz00_5130);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_za2za2resza2za2z00_5131;

									BgL_za2za2resza2za2z00_5131 =
										PROCEDURE_ENTRY(BgL_bodyz00_17181) (BgL_bodyz00_17181,
										BgL_sz00_5125, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5128);
									return BgL_za2za2resza2za2z00_5131;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3900> */
	obj_t BGl_z62zc3anonymousza33900ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17183, obj_t BgL_sz00_17188)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_17184;
				BgL_ev_absz00_bglt BgL_i1252z00_17185;
				obj_t BgL_bodyz00_17186;
				long BgL_siza7ezd2framez75_17187;

				BgL_iboxesz00_17184 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17183, (int) (((long) 0))));
				BgL_i1252z00_17185 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17183, (int) (((long) 1))));
				BgL_bodyz00_17186 = PROCEDURE_REF(BgL_envz00_17183, (int) (((long) 2)));
				BgL_siza7ezd2framez75_17187 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17183, (int) (((long) 3))));
				{
					obj_t BgL_sz00_5133;

					BgL_sz00_5133 = BgL_sz00_17188;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_5135;

						BgL_bpz00_5135 = VECTOR_REF(BgL_sz00_5133, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */

							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16255;

								BgL_runz00_16255 =
									MAKE_FX_PROCEDURE(BGl_z62run5544z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_runz00_16255,
									(int) (((long) 0)), BgL_iboxesz00_17184);
								PROCEDURE_SET(BgL_runz00_16255,
									(int) (((long) 1)), ((obj_t) BgL_i1252z00_17185));
								PROCEDURE_SET(BgL_runz00_16255,
									(int) (((long) 2)), BgL_bodyz00_17186);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16256;

									BgL_mainz00_16256 =
										MAKE_VA_PROCEDURE(BGl_z62main5543z62zz__evaluate_compz00,
										(int) (((long) -5)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_mainz00_16256,
										(int) (((long) 0)), BgL_iboxesz00_17184);
									PROCEDURE_SET(BgL_mainz00_16256,
										(int) (((long) 1)), BgL_bodyz00_17186);
									PROCEDURE_SET(BgL_mainz00_16256,
										(int) (((long) 2)), ((obj_t) BgL_i1252z00_17185));
									PROCEDURE_SET(BgL_mainz00_16256,
										(int) (((long) 3)), BgL_runz00_16255);
									PROCEDURE_SET(BgL_mainz00_16256,
										(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_17187));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_10676;

										BgL_objz00_10676 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16255, BgL_objz00_10676);
										BgL_objz00_10676;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3901z00_5138;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3902z00_5139;
											obj_t BgL_arg3903z00_5140;

											BgL_arg3902z00_5139 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17185))->
												BgL_arityz00);
											BgL_arg3903z00_5140 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17185))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_10680;

												BgL_newz00_10680 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_30415;

													BgL_auxz00_30415 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_10680, BgL_auxz00_30415,
														BgL_arg3903z00_5140);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_30420;
													int BgL_auxz00_30418;

													BgL_auxz00_30420 = BINT(BgL_siza7ezd2framez75_17187);
													BgL_auxz00_30418 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_10680, BgL_auxz00_30418,
														BgL_auxz00_30420);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_30423;

													BgL_auxz00_30423 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_10680, BgL_auxz00_30423,
														BgL_runz00_16255);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_30426;

													BgL_auxz00_30426 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_10680, BgL_auxz00_30426,
														BgL_arg3902z00_5139);
												}
												BgL_arg3901z00_5138 = BgL_newz00_10680;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16256, BgL_arg3901z00_5138);
										BgL_arg3901z00_5138;
									}
									return BgL_mainz00_16256;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5543 */
	obj_t BGl_z62main5543z62zz__evaluate_compz00(obj_t BgL_envz00_17189,
		obj_t BgL_az00_17195, obj_t BgL_bz00_17196, obj_t BgL_cz00_17197,
		obj_t BgL_dz00_17198, obj_t BgL_restz00_17199)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_17192;
				obj_t BgL_runz00_17193;
				long BgL_siza7ezd2framez75_17194;

				BgL_i1252z00_17192 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17189, (int) (((long) 2))));
				BgL_runz00_17193 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17189, (int) (((long) 3))));
				BgL_siza7ezd2framez75_17194 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17189, (int) (((long) 4))));
				{
					obj_t BgL_az00_5141;
					obj_t BgL_bz00_5142;
					obj_t BgL_cz00_5143;
					obj_t BgL_dz00_5144;
					obj_t BgL_restz00_5145;

					BgL_az00_5141 = BgL_az00_17195;
					BgL_bz00_5142 = BgL_bz00_17196;
					BgL_cz00_5143 = BgL_cz00_17197;
					BgL_dz00_5144 = BgL_dz00_17198;
					BgL_restz00_5145 = BgL_restz00_17199;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_5147;

						BgL_sz00_5147 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_5148;

							BgL_bpz00_5148 = VECTOR_REF(BgL_sz00_5147, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_30442;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_10566;

									BgL_arg1908z00_10566 = VECTOR_LENGTH(BgL_sz00_5147);
									BgL_testz00_30442 =
										(
										((long) CINT(BgL_bpz00_5148) +
											BgL_siza7ezd2framez75_17194) <
										(long) (BgL_arg1908z00_10566));
								}
								if (BgL_testz00_30442)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3906z00_5150;

											BgL_arg3906z00_5150 =
												((long) CINT(BgL_bpz00_5148) + ((long) 0));
											VECTOR_SET(BgL_sz00_5147,
												(int) (BgL_arg3906z00_5150), BgL_az00_5141);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3907z00_5151;

											BgL_arg3907z00_5151 =
												((long) CINT(BgL_bpz00_5148) + ((long) 1));
											VECTOR_SET(BgL_sz00_5147,
												(int) (BgL_arg3907z00_5151), BgL_bz00_5142);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3908z00_5152;

											BgL_arg3908z00_5152 =
												((long) CINT(BgL_bpz00_5148) + ((long) 2));
											VECTOR_SET(BgL_sz00_5147,
												(int) (BgL_arg3908z00_5152), BgL_cz00_5143);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3909z00_5153;

											BgL_arg3909z00_5153 =
												((long) CINT(BgL_bpz00_5148) + ((long) 3));
											VECTOR_SET(BgL_sz00_5147,
												(int) (BgL_arg3909z00_5153), BgL_dz00_5144);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3910z00_5154;
											long BgL_arg3911z00_5155;
											long BgL_arg3912z00_5156;
											obj_t BgL_arg3913z00_5157;

											BgL_arg3910z00_5154 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17192))->
												BgL_wherez00);
											BgL_arg3911z00_5155 =
												((long) CINT(BgL_bpz00_5148) + ((long) 4));
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_nz00_10601;

												BgL_nz00_10601 =
													(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17192))->
													BgL_arityz00);
												if (((long) CINT(BgL_nz00_10601) < ((long) 0)))
													{	/* Eval/evaluate_comp.scm 1013 */
														BgL_arg3912z00_5156 =
															((long) CINT(BgL_nz00_10601) + ((long) 4));
													}
												else
													{	/* Eval/evaluate_comp.scm 1013 */
														BgL_arg3912z00_5156 =
															((long) CINT(BgL_nz00_10601) - ((long) 4));
											}}
											BgL_arg3913z00_5157 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17192))->
												BgL_locz00);
											BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_5147,
												BgL_arg3910z00_5154, BgL_arg3911z00_5155,
												BgL_arg3912z00_5156, BgL_restz00_5145,
												BgL_arg3913z00_5157);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1259z00_5159;

											BgL_val1259z00_5159 =
												BGl_zc3exitza33918ze3z83zz__evaluate_compz00
												(BgL_bpz00_5148, BgL_sz00_5147, BgL_runz00_17193);
											VECTOR_SET(BgL_sz00_5147, (int) (((long) 0)),
												BgL_bpz00_5148);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1259z00_5159)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1259z00_5159), CDR(BgL_val1259z00_5159));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1259z00_5159;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_5166;

										BgL_nsz00_5166 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5166,
											(int) (((long) 1)), BgL_sz00_5147);
										VECTOR_SET(BgL_nsz00_5166,
											(int) (((long) 2)), BgL_az00_5141);
										VECTOR_SET(BgL_nsz00_5166,
											(int) (((long) 3)), BgL_bz00_5142);
										VECTOR_SET(BgL_nsz00_5166,
											(int) (((long) 4)), BgL_cz00_5143);
										VECTOR_SET(BgL_nsz00_5166,
											(int) (((long) 5)), BgL_dz00_5144);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3919z00_5167;
											long BgL_arg3920z00_5168;
											obj_t BgL_arg3921z00_5169;

											BgL_arg3919z00_5167 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17192))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_nz00_10633;

												BgL_nz00_10633 =
													(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17192))->
													BgL_arityz00);
												if (((long) CINT(BgL_nz00_10633) < ((long) 0)))
													{	/* Eval/evaluate_comp.scm 1013 */
														BgL_arg3920z00_5168 =
															((long) CINT(BgL_nz00_10633) + ((long) 4));
													}
												else
													{	/* Eval/evaluate_comp.scm 1013 */
														BgL_arg3920z00_5168 =
															((long) CINT(BgL_nz00_10633) - ((long) 4));
											}}
											BgL_arg3921z00_5169 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17192))->
												BgL_locz00);
											BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_5166,
												BgL_arg3919z00_5167, ((long) 6), BgL_arg3920z00_5168,
												BgL_restz00_5145, BgL_arg3921z00_5169);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_30508;

											BgL_auxz00_30508 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_30508, BgL_nsz00_5166);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1262z00_5172;

											BgL_val1262z00_5172 =
												BGl_zc3exitza33928ze3z83zz__evaluate_compz00
												(BgL_runz00_17193, BgL_nsz00_5166);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_30512;

												BgL_auxz00_30512 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_30512, BgL_sz00_5147);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1262z00_5172)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1262z00_5172), CDR(BgL_val1262z00_5172));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1262z00_5172;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3928> */
	obj_t BGl_zc3exitza33928ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17495,
		obj_t BgL_nsz00_17494)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1263z00_5178;

			if (SET_EXIT(BgL_an_exit1263z00_5178))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1263z00_5178 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1263z00_5178, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1264z00_5179;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_10648;

								BgL_savedzd2bpzd2_10648 =
									VECTOR_REF(BgL_nsz00_17494, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17494,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_10655;

									BgL_fz00_10655 = BgL_runz00_17495;
								BgL_recz00_10654:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_10656;

										BgL_rz00_10656 =
											PROCEDURE_ENTRY(BgL_fz00_10655) (BgL_fz00_10655,
											BgL_nsz00_17494, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_30533;

											if (PROCEDUREP(BgL_rz00_10656))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_10661;

													BgL_arg1900z00_10661 = PROCEDURE_ATTR(BgL_rz00_10656);
													if (STRUCTP(BgL_arg1900z00_10661))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_30533 =
																(STRUCT_KEY(BgL_arg1900z00_10661) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_30533 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_30533 = ((bool_t) 0);
												}
											if (BgL_testz00_30533)
												{
													obj_t BgL_fz00_30541;

													BgL_fz00_30541 = BgL_rz00_10656;
													BgL_fz00_10655 = BgL_fz00_30541;
													goto BgL_recz00_10654;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17494,
														(int) (((long) 0)), BgL_savedzd2bpzd2_10648);
													BgL_val1264z00_5179 = BgL_rz00_10656;
							}}}}}
							POP_EXIT();
							return BgL_val1264z00_5179;
						}
					}
				}
		}
	}



/* <exit:3918> */
	obj_t BGl_zc3exitza33918ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17498,
		obj_t BgL_sz00_17497, obj_t BgL_runz00_17496)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1260z00_5164;

			if (SET_EXIT(BgL_an_exit1260z00_5164))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1260z00_5164 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1260z00_5164, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1261z00_5165;

							BgL_val1261z00_5165 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17496,
								BgL_sz00_17497, BgL_bpz00_17498);
							POP_EXIT();
							return BgL_val1261z00_5165;
						}
					}
				}
		}
	}



/* &run5544 */
	obj_t BGl_z62run5544z62zz__evaluate_compz00(obj_t BgL_envz00_17200,
		obj_t BgL_sz00_17204)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_17201;
				BgL_ev_absz00_bglt BgL_i1252z00_17202;
				obj_t BgL_bodyz00_17203;

				BgL_iboxesz00_17201 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17200, (int) (((long) 0))));
				BgL_i1252z00_17202 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17200, (int) (((long) 1))));
				BgL_bodyz00_17203 = PROCEDURE_REF(BgL_envz00_17200, (int) (((long) 2)));
				{
					obj_t BgL_sz00_5181;

					BgL_sz00_5181 = BgL_sz00_17204;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_5183;

						BgL_bpz00_5183 = VECTOR_REF(BgL_sz00_5181, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_5181,
							BgL_iboxesz00_17201, BgL_bpz00_5183);
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_z12denvz12_5184;
							obj_t BgL_wherez00_5185;
							obj_t BgL_locz00_5186;

							BgL_z12denvz12_5184 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5185 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17202))->BgL_wherez00);
							BgL_locz00_5186 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17202))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1129 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5184, BgL_wherez00_5185,
									BgL_locz00_5186);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_za2za2resza2za2z00_5187;

									BgL_za2za2resza2za2z00_5187 =
										PROCEDURE_ENTRY(BgL_bodyz00_17203) (BgL_bodyz00_17203,
										BgL_sz00_5181, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5184);
									return BgL_za2za2resza2za2z00_5187;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3932> */
	obj_t BGl_z62zc3anonymousza33932ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17205, obj_t BgL_sz00_17211)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_ifreesz00_17206;
				long BgL_siza7eza7_17207;
				BgL_ev_absz00_bglt BgL_i1252z00_17208;
				obj_t BgL_bodyz00_17209;
				long BgL_siza7ezd2framez75_17210;

				BgL_ifreesz00_17206 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17205, (int) (((long) 0))));
				BgL_siza7eza7_17207 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17205, (int) (((long) 1))));
				BgL_i1252z00_17208 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17205, (int) (((long) 2))));
				BgL_bodyz00_17209 = PROCEDURE_REF(BgL_envz00_17205, (int) (((long) 3)));
				BgL_siza7ezd2framez75_17210 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17205, (int) (((long) 4))));
				{
					obj_t BgL_sz00_5191;

					BgL_sz00_5191 = BgL_sz00_17211;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_5193;

						BgL_bpz00_5193 = VECTOR_REF(BgL_sz00_5191, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_valza2za2_5194;

							BgL_valza2za2_5194 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_5191,
								BgL_bpz00_5193, BgL_ifreesz00_17206);
							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16252;

								BgL_runz00_16252 =
									MAKE_FX_PROCEDURE(BGl_z62run5546z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_runz00_16252,
									(int) (((long) 0)), BINT(BgL_siza7eza7_17207));
								PROCEDURE_SET(BgL_runz00_16252,
									(int) (((long) 1)), BgL_valza2za2_5194);
								PROCEDURE_SET(BgL_runz00_16252,
									(int) (((long) 2)), ((obj_t) BgL_i1252z00_17208));
								PROCEDURE_SET(BgL_runz00_16252,
									(int) (((long) 3)), BgL_bodyz00_17209);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16253;

									BgL_mainz00_16253 =
										MAKE_VA_PROCEDURE(BGl_z62main5545z62zz__evaluate_compz00,
										(int) (((long) -5)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_mainz00_16253,
										(int) (((long) 0)), BINT(BgL_siza7eza7_17207));
									PROCEDURE_SET(BgL_mainz00_16253,
										(int) (((long) 1)), BgL_valza2za2_5194);
									PROCEDURE_SET(BgL_mainz00_16253,
										(int) (((long) 2)), BgL_bodyz00_17209);
									PROCEDURE_SET(BgL_mainz00_16253,
										(int) (((long) 3)), ((obj_t) BgL_i1252z00_17208));
									PROCEDURE_SET(BgL_mainz00_16253,
										(int) (((long) 4)), BgL_runz00_16252);
									PROCEDURE_SET(BgL_mainz00_16253,
										(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_17210));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_10828;

										BgL_objz00_10828 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16252, BgL_objz00_10828);
										BgL_objz00_10828;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3933z00_5197;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3934z00_5198;
											obj_t BgL_arg3935z00_5199;

											BgL_arg3934z00_5198 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17208))->
												BgL_arityz00);
											BgL_arg3935z00_5199 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17208))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_10832;

												BgL_newz00_10832 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_30623;

													BgL_auxz00_30623 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_10832, BgL_auxz00_30623,
														BgL_arg3935z00_5199);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_30628;
													int BgL_auxz00_30626;

													BgL_auxz00_30628 = BINT(BgL_siza7ezd2framez75_17210);
													BgL_auxz00_30626 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_10832, BgL_auxz00_30626,
														BgL_auxz00_30628);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_30631;

													BgL_auxz00_30631 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_10832, BgL_auxz00_30631,
														BgL_runz00_16252);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_30634;

													BgL_auxz00_30634 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_10832, BgL_auxz00_30634,
														BgL_arg3934z00_5198);
												}
												BgL_arg3933z00_5197 = BgL_newz00_10832;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16253, BgL_arg3933z00_5197);
										BgL_arg3933z00_5197;
									}
									return BgL_mainz00_16253;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5545 */
	obj_t BGl_z62main5545z62zz__evaluate_compz00(obj_t BgL_envz00_17212,
		obj_t BgL_az00_17219, obj_t BgL_bz00_17220, obj_t BgL_cz00_17221,
		obj_t BgL_dz00_17222, obj_t BgL_restz00_17223)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_17216;
				obj_t BgL_runz00_17217;
				long BgL_siza7ezd2framez75_17218;

				BgL_i1252z00_17216 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17212, (int) (((long) 3))));
				BgL_runz00_17217 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17212, (int) (((long) 4))));
				BgL_siza7ezd2framez75_17218 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17212, (int) (((long) 5))));
				{
					obj_t BgL_az00_5200;
					obj_t BgL_bz00_5201;
					obj_t BgL_cz00_5202;
					obj_t BgL_dz00_5203;
					obj_t BgL_restz00_5204;

					BgL_az00_5200 = BgL_az00_17219;
					BgL_bz00_5201 = BgL_bz00_17220;
					BgL_cz00_5202 = BgL_cz00_17221;
					BgL_dz00_5203 = BgL_dz00_17222;
					BgL_restz00_5204 = BgL_restz00_17223;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_5206;

						BgL_sz00_5206 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_5207;

							BgL_bpz00_5207 = VECTOR_REF(BgL_sz00_5206, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_30650;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_10718;

									BgL_arg1908z00_10718 = VECTOR_LENGTH(BgL_sz00_5206);
									BgL_testz00_30650 =
										(
										((long) CINT(BgL_bpz00_5207) +
											BgL_siza7ezd2framez75_17218) <
										(long) (BgL_arg1908z00_10718));
								}
								if (BgL_testz00_30650)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3938z00_5209;

											BgL_arg3938z00_5209 =
												((long) CINT(BgL_bpz00_5207) + ((long) 0));
											VECTOR_SET(BgL_sz00_5206,
												(int) (BgL_arg3938z00_5209), BgL_az00_5200);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3939z00_5210;

											BgL_arg3939z00_5210 =
												((long) CINT(BgL_bpz00_5207) + ((long) 1));
											VECTOR_SET(BgL_sz00_5206,
												(int) (BgL_arg3939z00_5210), BgL_bz00_5201);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3940z00_5211;

											BgL_arg3940z00_5211 =
												((long) CINT(BgL_bpz00_5207) + ((long) 2));
											VECTOR_SET(BgL_sz00_5206,
												(int) (BgL_arg3940z00_5211), BgL_cz00_5202);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3941z00_5212;

											BgL_arg3941z00_5212 =
												((long) CINT(BgL_bpz00_5207) + ((long) 3));
											VECTOR_SET(BgL_sz00_5206,
												(int) (BgL_arg3941z00_5212), BgL_dz00_5203);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3942z00_5213;
											long BgL_arg3943z00_5214;
											long BgL_arg3944z00_5215;
											obj_t BgL_arg3945z00_5216;

											BgL_arg3942z00_5213 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17216))->
												BgL_wherez00);
											BgL_arg3943z00_5214 =
												((long) CINT(BgL_bpz00_5207) + ((long) 4));
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_nz00_10753;

												BgL_nz00_10753 =
													(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17216))->
													BgL_arityz00);
												if (((long) CINT(BgL_nz00_10753) < ((long) 0)))
													{	/* Eval/evaluate_comp.scm 1013 */
														BgL_arg3944z00_5215 =
															((long) CINT(BgL_nz00_10753) + ((long) 4));
													}
												else
													{	/* Eval/evaluate_comp.scm 1013 */
														BgL_arg3944z00_5215 =
															((long) CINT(BgL_nz00_10753) - ((long) 4));
											}}
											BgL_arg3945z00_5216 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17216))->
												BgL_locz00);
											BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_5206,
												BgL_arg3942z00_5213, BgL_arg3943z00_5214,
												BgL_arg3944z00_5215, BgL_restz00_5204,
												BgL_arg3945z00_5216);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1265z00_5218;

											BgL_val1265z00_5218 =
												BGl_zc3exitza33950ze3z83zz__evaluate_compz00
												(BgL_bpz00_5207, BgL_sz00_5206, BgL_runz00_17217);
											VECTOR_SET(BgL_sz00_5206, (int) (((long) 0)),
												BgL_bpz00_5207);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1265z00_5218)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1265z00_5218), CDR(BgL_val1265z00_5218));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1265z00_5218;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_5225;

										BgL_nsz00_5225 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5225,
											(int) (((long) 1)), BgL_sz00_5206);
										VECTOR_SET(BgL_nsz00_5225,
											(int) (((long) 2)), BgL_az00_5200);
										VECTOR_SET(BgL_nsz00_5225,
											(int) (((long) 3)), BgL_bz00_5201);
										VECTOR_SET(BgL_nsz00_5225,
											(int) (((long) 4)), BgL_cz00_5202);
										VECTOR_SET(BgL_nsz00_5225,
											(int) (((long) 5)), BgL_dz00_5203);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3951z00_5226;
											long BgL_arg3952z00_5227;
											obj_t BgL_arg3953z00_5228;

											BgL_arg3951z00_5226 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17216))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_nz00_10785;

												BgL_nz00_10785 =
													(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17216))->
													BgL_arityz00);
												if (((long) CINT(BgL_nz00_10785) < ((long) 0)))
													{	/* Eval/evaluate_comp.scm 1013 */
														BgL_arg3952z00_5227 =
															((long) CINT(BgL_nz00_10785) + ((long) 4));
													}
												else
													{	/* Eval/evaluate_comp.scm 1013 */
														BgL_arg3952z00_5227 =
															((long) CINT(BgL_nz00_10785) - ((long) 4));
											}}
											BgL_arg3953z00_5228 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17216))->
												BgL_locz00);
											BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_5225,
												BgL_arg3951z00_5226, ((long) 6), BgL_arg3952z00_5227,
												BgL_restz00_5204, BgL_arg3953z00_5228);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_30716;

											BgL_auxz00_30716 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_30716, BgL_nsz00_5225);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1268z00_5231;

											BgL_val1268z00_5231 =
												BGl_zc3exitza33960ze3z83zz__evaluate_compz00
												(BgL_runz00_17217, BgL_nsz00_5225);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_30720;

												BgL_auxz00_30720 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_30720, BgL_sz00_5206);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1268z00_5231)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1268z00_5231), CDR(BgL_val1268z00_5231));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1268z00_5231;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3960> */
	obj_t BGl_zc3exitza33960ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17490,
		obj_t BgL_nsz00_17489)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1269z00_5237;

			if (SET_EXIT(BgL_an_exit1269z00_5237))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1269z00_5237 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1269z00_5237, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1270z00_5238;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_10800;

								BgL_savedzd2bpzd2_10800 =
									VECTOR_REF(BgL_nsz00_17489, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17489,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_10807;

									BgL_fz00_10807 = BgL_runz00_17490;
								BgL_recz00_10806:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_10808;

										BgL_rz00_10808 =
											PROCEDURE_ENTRY(BgL_fz00_10807) (BgL_fz00_10807,
											BgL_nsz00_17489, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_30741;

											if (PROCEDUREP(BgL_rz00_10808))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_10813;

													BgL_arg1900z00_10813 = PROCEDURE_ATTR(BgL_rz00_10808);
													if (STRUCTP(BgL_arg1900z00_10813))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_30741 =
																(STRUCT_KEY(BgL_arg1900z00_10813) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_30741 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_30741 = ((bool_t) 0);
												}
											if (BgL_testz00_30741)
												{
													obj_t BgL_fz00_30749;

													BgL_fz00_30749 = BgL_rz00_10808;
													BgL_fz00_10807 = BgL_fz00_30749;
													goto BgL_recz00_10806;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17489,
														(int) (((long) 0)), BgL_savedzd2bpzd2_10800);
													BgL_val1270z00_5238 = BgL_rz00_10808;
							}}}}}
							POP_EXIT();
							return BgL_val1270z00_5238;
						}
					}
				}
		}
	}



/* <exit:3950> */
	obj_t BGl_zc3exitza33950ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17493,
		obj_t BgL_sz00_17492, obj_t BgL_runz00_17491)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1266z00_5223;

			if (SET_EXIT(BgL_an_exit1266z00_5223))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1266z00_5223 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1266z00_5223, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1267z00_5224;

							BgL_val1267z00_5224 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17491,
								BgL_sz00_17492, BgL_bpz00_17493);
							POP_EXIT();
							return BgL_val1267z00_5224;
						}
					}
				}
		}
	}



/* &run5546 */
	obj_t BGl_z62run5546z62zz__evaluate_compz00(obj_t BgL_envz00_17224,
		obj_t BgL_sz00_17229)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				long BgL_siza7eza7_17225;
				obj_t BgL_valza2za2_17226;
				BgL_ev_absz00_bglt BgL_i1252z00_17227;
				obj_t BgL_bodyz00_17228;

				BgL_siza7eza7_17225 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17224, (int) (((long) 0))));
				BgL_valza2za2_17226 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17224, (int) (((long) 1))));
				BgL_i1252z00_17227 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17224, (int) (((long) 2))));
				BgL_bodyz00_17228 = PROCEDURE_REF(BgL_envz00_17224, (int) (((long) 3)));
				{
					obj_t BgL_sz00_5240;

					BgL_sz00_5240 = BgL_sz00_17229;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_5242;

						BgL_bpz00_5242 = VECTOR_REF(BgL_sz00_5240, (int) (((long) 0)));
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_5240,
							BgL_valza2za2_17226,
							((long) CINT(BgL_bpz00_5242) + BgL_siza7eza7_17225));
						{	/* Eval/evaluate_comp.scm 1049 */
							obj_t BgL_z12denvz12_5244;
							obj_t BgL_wherez00_5245;
							obj_t BgL_locz00_5246;

							BgL_z12denvz12_5244 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5245 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17227))->BgL_wherez00);
							BgL_locz00_5246 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17227))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1049 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5244, BgL_wherez00_5245,
									BgL_locz00_5246);
								{	/* Eval/evaluate_comp.scm 1049 */
									obj_t BgL_za2za2resza2za2z00_5247;

									BgL_za2za2resza2za2z00_5247 =
										PROCEDURE_ENTRY(BgL_bodyz00_17228) (BgL_bodyz00_17228,
										BgL_sz00_5240, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5244);
									return BgL_za2za2resza2za2z00_5247;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:3963> */
	obj_t BGl_z62zc3anonymousza33963ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17230, obj_t BgL_sz00_17237)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_ifreesz00_17231;
				obj_t BgL_iboxesz00_17232;
				long BgL_siza7eza7_17233;
				BgL_ev_absz00_bglt BgL_i1252z00_17234;
				obj_t BgL_bodyz00_17235;
				long BgL_siza7ezd2framez75_17236;

				BgL_ifreesz00_17231 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17230, (int) (((long) 0))));
				BgL_iboxesz00_17232 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17230, (int) (((long) 1))));
				BgL_siza7eza7_17233 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17230, (int) (((long) 2))));
				BgL_i1252z00_17234 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17230, (int) (((long) 3))));
				BgL_bodyz00_17235 = PROCEDURE_REF(BgL_envz00_17230, (int) (((long) 4)));
				BgL_siza7ezd2framez75_17236 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17230, (int) (((long) 5))));
				{
					obj_t BgL_sz00_5249;

					BgL_sz00_5249 = BgL_sz00_17237;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_5251;

						BgL_bpz00_5251 = VECTOR_REF(BgL_sz00_5249, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_valza2za2_5252;

							BgL_valza2za2_5252 =
								BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_5249,
								BgL_bpz00_5251, BgL_ifreesz00_17231);
							{	/* Eval/evaluate_comp.scm 1129 */
								obj_t BgL_runz00_16249;

								BgL_runz00_16249 =
									MAKE_FX_PROCEDURE(BGl_z62run5548z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_runz00_16249,
									(int) (((long) 0)), BgL_iboxesz00_17232);
								PROCEDURE_SET(BgL_runz00_16249,
									(int) (((long) 1)), BINT(BgL_siza7eza7_17233));
								PROCEDURE_SET(BgL_runz00_16249,
									(int) (((long) 2)), BgL_valza2za2_5252);
								PROCEDURE_SET(BgL_runz00_16249,
									(int) (((long) 3)), ((obj_t) BgL_i1252z00_17234));
								PROCEDURE_SET(BgL_runz00_16249,
									(int) (((long) 4)), BgL_bodyz00_17235);
								{	/* Eval/evaluate_comp.scm 1129 */
									obj_t BgL_mainz00_16250;

									BgL_mainz00_16250 =
										MAKE_VA_PROCEDURE(BGl_z62main5547z62zz__evaluate_compz00,
										(int) (((long) -5)), (int) (((long) 7)));
									PROCEDURE_SET(BgL_mainz00_16250,
										(int) (((long) 0)), BgL_iboxesz00_17232);
									PROCEDURE_SET(BgL_mainz00_16250,
										(int) (((long) 1)), BINT(BgL_siza7eza7_17233));
									PROCEDURE_SET(BgL_mainz00_16250,
										(int) (((long) 2)), BgL_valza2za2_5252);
									PROCEDURE_SET(BgL_mainz00_16250,
										(int) (((long) 3)), BgL_bodyz00_17235);
									PROCEDURE_SET(BgL_mainz00_16250,
										(int) (((long) 4)), ((obj_t) BgL_i1252z00_17234));
									PROCEDURE_SET(BgL_mainz00_16250,
										(int) (((long) 5)), BgL_runz00_16249);
									PROCEDURE_SET(BgL_mainz00_16250,
										(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_17236));
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_objz00_10976;

										BgL_objz00_10976 =
											BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
										PROCEDURE_ATTR_SET(BgL_runz00_16249, BgL_objz00_10976);
										BgL_objz00_10976;
									}
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_arg3964z00_5255;

										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3965z00_5256;
											obj_t BgL_arg3966z00_5257;

											BgL_arg3965z00_5256 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17234))->
												BgL_arityz00);
											BgL_arg3966z00_5257 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17234))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 662 */
												obj_t BgL_newz00_10980;

												BgL_newz00_10980 =
													create_struct(BGl_symbol5578z00zz__evaluate_compz00,
													(int) (((long) 4)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_30843;

													BgL_auxz00_30843 = (int) (((long) 3));
													STRUCT_SET(BgL_newz00_10980, BgL_auxz00_30843,
														BgL_arg3966z00_5257);
												}
												{	/* Llib/struct.scm 162 */
													obj_t BgL_auxz00_30848;
													int BgL_auxz00_30846;

													BgL_auxz00_30848 = BINT(BgL_siza7ezd2framez75_17236);
													BgL_auxz00_30846 = (int) (((long) 2));
													STRUCT_SET(BgL_newz00_10980, BgL_auxz00_30846,
														BgL_auxz00_30848);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_30851;

													BgL_auxz00_30851 = (int) (((long) 1));
													STRUCT_SET(BgL_newz00_10980, BgL_auxz00_30851,
														BgL_runz00_16249);
												}
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_30854;

													BgL_auxz00_30854 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_10980, BgL_auxz00_30854,
														BgL_arg3965z00_5256);
												}
												BgL_arg3964z00_5255 = BgL_newz00_10980;
										}}
										PROCEDURE_ATTR_SET(BgL_mainz00_16250, BgL_arg3964z00_5255);
										BgL_arg3964z00_5255;
									}
									return BgL_mainz00_16250;
								}
							}
						}
					}
				}
			}
		}
	}



/* &main5547 */
	obj_t BGl_z62main5547z62zz__evaluate_compz00(obj_t BgL_envz00_17238,
		obj_t BgL_az00_17246, obj_t BgL_bz00_17247, obj_t BgL_cz00_17248,
		obj_t BgL_dz00_17249, obj_t BgL_restz00_17250)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				BgL_ev_absz00_bglt BgL_i1252z00_17243;
				obj_t BgL_runz00_17244;
				long BgL_siza7ezd2framez75_17245;

				BgL_i1252z00_17243 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17238, (int) (((long) 4))));
				BgL_runz00_17244 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17238, (int) (((long) 5))));
				BgL_siza7ezd2framez75_17245 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17238, (int) (((long) 6))));
				{
					obj_t BgL_az00_5258;
					obj_t BgL_bz00_5259;
					obj_t BgL_cz00_5260;
					obj_t BgL_dz00_5261;
					obj_t BgL_restz00_5262;

					BgL_az00_5258 = BgL_az00_17246;
					BgL_bz00_5259 = BgL_bz00_17247;
					BgL_cz00_5260 = BgL_cz00_17248;
					BgL_dz00_5261 = BgL_dz00_17249;
					BgL_restz00_5262 = BgL_restz00_17250;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_sz00_5264;

						BgL_sz00_5264 = BGl_findzd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_bpz00_5265;

							BgL_bpz00_5265 = VECTOR_REF(BgL_sz00_5264, (int) (((long) 0)));
							{	/* Eval/evaluate_comp.scm 1129 */
								bool_t BgL_testz00_30870;

								{	/* Eval/evaluate_comp.scm 665 */
									int BgL_arg1908z00_10866;

									BgL_arg1908z00_10866 = VECTOR_LENGTH(BgL_sz00_5264);
									BgL_testz00_30870 =
										(
										((long) CINT(BgL_bpz00_5265) +
											BgL_siza7ezd2framez75_17245) <
										(long) (BgL_arg1908z00_10866));
								}
								if (BgL_testz00_30870)
									{	/* Eval/evaluate_comp.scm 1129 */
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3969z00_5267;

											BgL_arg3969z00_5267 =
												((long) CINT(BgL_bpz00_5265) + ((long) 0));
											VECTOR_SET(BgL_sz00_5264,
												(int) (BgL_arg3969z00_5267), BgL_az00_5258);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3970z00_5268;

											BgL_arg3970z00_5268 =
												((long) CINT(BgL_bpz00_5265) + ((long) 1));
											VECTOR_SET(BgL_sz00_5264,
												(int) (BgL_arg3970z00_5268), BgL_bz00_5259);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3971z00_5269;

											BgL_arg3971z00_5269 =
												((long) CINT(BgL_bpz00_5265) + ((long) 2));
											VECTOR_SET(BgL_sz00_5264,
												(int) (BgL_arg3971z00_5269), BgL_cz00_5260);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											long BgL_arg3972z00_5270;

											BgL_arg3972z00_5270 =
												((long) CINT(BgL_bpz00_5265) + ((long) 3));
											VECTOR_SET(BgL_sz00_5264,
												(int) (BgL_arg3972z00_5270), BgL_dz00_5261);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3973z00_5271;
											long BgL_arg3974z00_5272;
											long BgL_arg3975z00_5273;
											obj_t BgL_arg3976z00_5274;

											BgL_arg3973z00_5271 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17243))->
												BgL_wherez00);
											BgL_arg3974z00_5272 =
												((long) CINT(BgL_bpz00_5265) + ((long) 4));
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_nz00_10901;

												BgL_nz00_10901 =
													(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17243))->
													BgL_arityz00);
												if (((long) CINT(BgL_nz00_10901) < ((long) 0)))
													{	/* Eval/evaluate_comp.scm 1013 */
														BgL_arg3975z00_5273 =
															((long) CINT(BgL_nz00_10901) + ((long) 4));
													}
												else
													{	/* Eval/evaluate_comp.scm 1013 */
														BgL_arg3975z00_5273 =
															((long) CINT(BgL_nz00_10901) - ((long) 4));
											}}
											BgL_arg3976z00_5274 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17243))->
												BgL_locz00);
											BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_5264,
												BgL_arg3973z00_5271, BgL_arg3974z00_5272,
												BgL_arg3975z00_5273, BgL_restz00_5262,
												BgL_arg3976z00_5274);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1271z00_5276;

											BgL_val1271z00_5276 =
												BGl_zc3exitza33981ze3z83zz__evaluate_compz00
												(BgL_bpz00_5265, BgL_sz00_5264, BgL_runz00_17244);
											VECTOR_SET(BgL_sz00_5264, (int) (((long) 0)),
												BgL_bpz00_5265);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1271z00_5276)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1271z00_5276), CDR(BgL_val1271z00_5276));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1271z00_5276;
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1129 */
										obj_t BgL_nsz00_5283;

										BgL_nsz00_5283 = BGl_makezd2statezd2zz__evaluate_compz00();
										VECTOR_SET(BgL_nsz00_5283,
											(int) (((long) 1)), BgL_sz00_5264);
										VECTOR_SET(BgL_nsz00_5283,
											(int) (((long) 2)), BgL_az00_5258);
										VECTOR_SET(BgL_nsz00_5283,
											(int) (((long) 3)), BgL_bz00_5259);
										VECTOR_SET(BgL_nsz00_5283,
											(int) (((long) 4)), BgL_cz00_5260);
										VECTOR_SET(BgL_nsz00_5283,
											(int) (((long) 5)), BgL_dz00_5261);
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_arg3982z00_5284;
											long BgL_arg3983z00_5285;
											obj_t BgL_arg3984z00_5286;

											BgL_arg3982z00_5284 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17243))->
												BgL_wherez00);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_nz00_10933;

												BgL_nz00_10933 =
													(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17243))->
													BgL_arityz00);
												if (((long) CINT(BgL_nz00_10933) < ((long) 0)))
													{	/* Eval/evaluate_comp.scm 1013 */
														BgL_arg3983z00_5285 =
															((long) CINT(BgL_nz00_10933) + ((long) 4));
													}
												else
													{	/* Eval/evaluate_comp.scm 1013 */
														BgL_arg3983z00_5285 =
															((long) CINT(BgL_nz00_10933) - ((long) 4));
											}}
											BgL_arg3984z00_5286 =
												(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17243))->
												BgL_locz00);
											BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_5283,
												BgL_arg3982z00_5284, ((long) 6), BgL_arg3983z00_5285,
												BgL_restz00_5262, BgL_arg3984z00_5286);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_auxz00_30936;

											BgL_auxz00_30936 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_EVSTATE_SET(BgL_auxz00_30936, BgL_nsz00_5283);
										}
										{	/* Eval/evaluate_comp.scm 1129 */
											obj_t BgL_val1274z00_5289;

											BgL_val1274z00_5289 =
												BGl_zc3exitza33991ze3z83zz__evaluate_compz00
												(BgL_runz00_17244, BgL_nsz00_5283);
											{	/* Eval/evaluate_comp.scm 1129 */
												obj_t BgL_auxz00_30940;

												BgL_auxz00_30940 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_EVSTATE_SET(BgL_auxz00_30940, BgL_sz00_5264);
											}
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val1274z00_5289)))
												{	/* Eval/evaluate_comp.scm 1129 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val1274z00_5289), CDR(BgL_val1274z00_5289));
												}
											else
												{	/* Eval/evaluate_comp.scm 1129 */
													return BgL_val1274z00_5289;
												}
										}
									}
							}
						}
					}
				}
			}
		}
	}



/* <exit:3991> */
	obj_t BGl_zc3exitza33991ze3z83zz__evaluate_compz00(obj_t BgL_runz00_17485,
		obj_t BgL_nsz00_17484)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1275z00_5295;

			if (SET_EXIT(BgL_an_exit1275z00_5295))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1275z00_5295 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1275z00_5295, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1276z00_5296;

							{	/* Eval/evaluate_comp.scm 649 */
								obj_t BgL_savedzd2bpzd2_10948;

								BgL_savedzd2bpzd2_10948 =
									VECTOR_REF(BgL_nsz00_17484, (int) (((long) 0)));
								VECTOR_SET(BgL_nsz00_17484,
									(int) (((long) 0)), BINT(((long) 2)));
								{
									obj_t BgL_fz00_10955;

									BgL_fz00_10955 = BgL_runz00_17485;
								BgL_recz00_10954:
									{	/* Eval/evaluate_comp.scm 652 */
										obj_t BgL_rz00_10956;

										BgL_rz00_10956 =
											PROCEDURE_ENTRY(BgL_fz00_10955) (BgL_fz00_10955,
											BgL_nsz00_17484, BEOA);
										{	/* Eval/evaluate_comp.scm 653 */
											bool_t BgL_testz00_30961;

											if (PROCEDUREP(BgL_rz00_10956))
												{	/* Eval/evaluate_comp.scm 653 */
													obj_t BgL_arg1900z00_10961;

													BgL_arg1900z00_10961 = PROCEDURE_ATTR(BgL_rz00_10956);
													if (STRUCTP(BgL_arg1900z00_10961))
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_30961 =
																(STRUCT_KEY(BgL_arg1900z00_10961) ==
																BGl_symbol5557z00zz__evaluate_compz00);
														}
													else
														{	/* Eval/evaluate_comp.scm 633 */
															BgL_testz00_30961 = ((bool_t) 0);
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													BgL_testz00_30961 = ((bool_t) 0);
												}
											if (BgL_testz00_30961)
												{
													obj_t BgL_fz00_30969;

													BgL_fz00_30969 = BgL_rz00_10956;
													BgL_fz00_10955 = BgL_fz00_30969;
													goto BgL_recz00_10954;
												}
											else
												{	/* Eval/evaluate_comp.scm 653 */
													VECTOR_SET(BgL_nsz00_17484,
														(int) (((long) 0)), BgL_savedzd2bpzd2_10948);
													BgL_val1276z00_5296 = BgL_rz00_10956;
							}}}}}
							POP_EXIT();
							return BgL_val1276z00_5296;
						}
					}
				}
		}
	}



/* <exit:3981> */
	obj_t BGl_zc3exitza33981ze3z83zz__evaluate_compz00(obj_t BgL_bpz00_17488,
		obj_t BgL_sz00_17487, obj_t BgL_runz00_17486)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1272z00_5281;

			if (SET_EXIT(BgL_an_exit1272z00_5281))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1272z00_5281 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 1129 */

						PUSH_EXIT(BgL_an_exit1272z00_5281, ((long) 0));
						{	/* Eval/evaluate_comp.scm 1129 */
							obj_t BgL_val1273z00_5282;

							BgL_val1273z00_5282 =
								BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_17486,
								BgL_sz00_17487, BgL_bpz00_17488);
							POP_EXIT();
							return BgL_val1273z00_5282;
						}
					}
				}
		}
	}



/* &run5548 */
	obj_t BGl_z62run5548z62zz__evaluate_compz00(obj_t BgL_envz00_17251,
		obj_t BgL_sz00_17257)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 1129 */
			{	/* Eval/evaluate_comp.scm 1129 */
				obj_t BgL_iboxesz00_17252;
				long BgL_siza7eza7_17253;
				obj_t BgL_valza2za2_17254;
				BgL_ev_absz00_bglt BgL_i1252z00_17255;
				obj_t BgL_bodyz00_17256;

				BgL_iboxesz00_17252 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17251, (int) (((long) 0))));
				BgL_siza7eza7_17253 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17251, (int) (((long) 1))));
				BgL_valza2za2_17254 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17251, (int) (((long) 2))));
				BgL_i1252z00_17255 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_17251, (int) (((long) 3))));
				BgL_bodyz00_17256 = PROCEDURE_REF(BgL_envz00_17251, (int) (((long) 4)));
				{
					obj_t BgL_sz00_5298;

					BgL_sz00_5298 = BgL_sz00_17257;
					{	/* Eval/evaluate_comp.scm 1129 */
						obj_t BgL_bpz00_5300;

						BgL_bpz00_5300 = VECTOR_REF(BgL_sz00_5298, (int) (((long) 0)));
						BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_5298,
							BgL_iboxesz00_17252, BgL_bpz00_5300);
						BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_5298,
							BgL_valza2za2_17254,
							((long) CINT(BgL_bpz00_5300) + BgL_siza7eza7_17253));
						{	/* Eval/evaluate_comp.scm 1049 */
							obj_t BgL_z12denvz12_5302;
							obj_t BgL_wherez00_5303;
							obj_t BgL_locz00_5304;

							BgL_z12denvz12_5302 = BGL_CURRENT_DYNAMIC_ENV();
							BgL_wherez00_5303 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17255))->BgL_wherez00);
							BgL_locz00_5304 =
								(((BgL_ev_absz00_bglt) CREF(BgL_i1252z00_17255))->BgL_locz00);
							{	/* Eval/evaluate_comp.scm 1049 */

								BGL_ENV_PUSH_TRACE(BgL_z12denvz12_5302, BgL_wherez00_5303,
									BgL_locz00_5304);
								{	/* Eval/evaluate_comp.scm 1049 */
									obj_t BgL_za2za2resza2za2z00_5305;

									BgL_za2za2resza2za2z00_5305 =
										PROCEDURE_ENTRY(BgL_bodyz00_17256) (BgL_bodyz00_17256,
										BgL_sz00_5298, BEOA);
									BGL_ENV_POP_TRACE(BgL_z12denvz12_5302);
									return BgL_za2za2resza2za2z00_5305;
								}
							}
						}
					}
				}
			}
		}
	}



/* &comp-ev_app1683 */
	obj_t BGl_z62compzd2ev_app1683zb0zz__evaluate_compz00(obj_t BgL_envz00_17258,
		obj_t BgL_ez00_17259, obj_t BgL_stkz00_17260)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 998 */
			{
				BgL_ev_appz00_bglt BgL_ez00_3225;
				obj_t BgL_stkz00_3226;

				BgL_ez00_3225 = ((BgL_ev_appz00_bglt) BgL_ez00_17259);
				BgL_stkz00_3226 = BgL_stkz00_17260;
				{	/* Eval/evaluate_comp.scm 1000 */
					obj_t BgL__ortest_1238z00_3230;

					BgL__ortest_1238z00_3230 =
						BGl_arithzd2expressionzd2zz__evaluate_compz00(BgL_ez00_3225,
						BgL_stkz00_3226);
					if (CBOOL(BgL__ortest_1238z00_3230))
						{	/* Eval/evaluate_comp.scm 1000 */
							return BgL__ortest_1238z00_3230;
						}
					else
						{	/* Eval/evaluate_comp.scm 1001 */
							obj_t BgL__ortest_1239z00_3231;

							BgL__ortest_1239z00_3231 =
								BGl_inlinezd2callzd2zz__evaluate_compz00(
								(((BgL_ev_appz00_bglt) CREF(BgL_ez00_3225))->BgL_locz00),
								(((BgL_ev_appz00_bglt) CREF(BgL_ez00_3225))->BgL_funz00),
								(((BgL_ev_appz00_bglt) CREF(BgL_ez00_3225))->BgL_argsz00),
								BgL_stkz00_3226);
							if (CBOOL(BgL__ortest_1239z00_3231))
								{	/* Eval/evaluate_comp.scm 1001 */
									return BgL__ortest_1239z00_3231;
								}
							else
								{	/* Eval/evaluate_comp.scm 1001 */
									if (
										(bgl_list_length(
												(((BgL_ev_appz00_bglt) CREF(BgL_ez00_3225))->
													BgL_argsz00)) > ((long) 4)))
										{	/* Eval/evaluate_comp.scm 1002 */
											return
												BGl_compzd2oldzd2callz00zz__evaluate_compz00
												(BgL_ez00_3225, BgL_stkz00_3226);
										}
									else
										{	/* Eval/evaluate_comp.scm 1004 */
											obj_t BgL_fz00_3233;
											long BgL_siza7eza7_3234;
											obj_t BgL_symbzd2funzd2_3235;

											BgL_fz00_3233 =
												BGl_compz00zz__evaluate_compz00(
												(((BgL_ev_appz00_bglt) CREF(BgL_ez00_3225))->
													BgL_funz00), BgL_stkz00_3226);
											BgL_siza7eza7_3234 = bgl_list_length(BgL_stkz00_3226);
											BgL_symbzd2funzd2_3235 =
												BGl_uncompilez00zz__evaluate_uncompz00(
												(((BgL_ev_appz00_bglt) CREF(BgL_ez00_3225))->
													BgL_funz00));
											if (NULLP((((BgL_ev_appz00_bglt) CREF(BgL_ez00_3225))->
														BgL_argsz00)))
												{	/* Eval/evaluate_comp.scm 1005 */
													return
														BGl_compzd2call0zd2zz__evaluate_compz00(
														(((BgL_ev_appz00_bglt) CREF(BgL_ez00_3225))->
															BgL_locz00),
														(((BgL_ev_appz00_bglt) CREF(BgL_ez00_3225))->
															BgL_funz00), BgL_symbzd2funzd2_3235,
														BgL_fz00_3233,
														(((BgL_ev_appz00_bglt) CREF(BgL_ez00_3225))->
															BgL_tailzf3zf3), BgL_stkz00_3226,
														BgL_siza7eza7_3234);
												}
											else
												{	/* Eval/evaluate_comp.scm 1007 */
													obj_t BgL_a1z00_3240;
													obj_t BgL_argsz00_3241;

													{	/* Eval/evaluate_comp.scm 1007 */
														obj_t BgL_arg3024z00_3267;

														BgL_arg3024z00_3267 =
															CAR(
															(((BgL_ev_appz00_bglt) CREF(BgL_ez00_3225))->
																BgL_argsz00));
														BgL_a1z00_3240 =
															BGl_compz00zz__evaluate_compz00((
																(BgL_ev_exprz00_bglt) BgL_arg3024z00_3267),
															BgL_stkz00_3226);
													}
													BgL_argsz00_3241 =
														CDR(
														(((BgL_ev_appz00_bglt) CREF(BgL_ez00_3225))->
															BgL_argsz00));
													if (NULLP(BgL_argsz00_3241))
														{	/* Eval/evaluate_comp.scm 1007 */
															return
																BGl_compzd2call1zd2zz__evaluate_compz00(
																(((BgL_ev_appz00_bglt) CREF(BgL_ez00_3225))->
																	BgL_locz00),
																(((BgL_ev_appz00_bglt) CREF(BgL_ez00_3225))->
																	BgL_funz00), BgL_symbzd2funzd2_3235,
																BgL_fz00_3233,
																(((BgL_ev_appz00_bglt) CREF(BgL_ez00_3225))->
																	BgL_tailzf3zf3), BgL_stkz00_3226,
																BgL_siza7eza7_3234, BgL_a1z00_3240);
														}
													else
														{	/* Eval/evaluate_comp.scm 1007 */
															obj_t BgL_a2z00_3246;
															obj_t BgL_argsz00_3247;

															{	/* Eval/evaluate_comp.scm 1007 */
																obj_t BgL_arg3023z00_3266;

																BgL_arg3023z00_3266 = CAR(BgL_argsz00_3241);
																BgL_a2z00_3246 =
																	BGl_compz00zz__evaluate_compz00(
																	((BgL_ev_exprz00_bglt) BgL_arg3023z00_3266),
																	BgL_stkz00_3226);
															}
															BgL_argsz00_3247 = CDR(BgL_argsz00_3241);
															if (NULLP(BgL_argsz00_3247))
																{	/* Eval/evaluate_comp.scm 1007 */
																	return
																		BGl_compzd2call2zd2zz__evaluate_compz00(
																		(((BgL_ev_appz00_bglt)
																				CREF(BgL_ez00_3225))->BgL_locz00),
																		(((BgL_ev_appz00_bglt)
																				CREF(BgL_ez00_3225))->BgL_funz00),
																		BgL_symbzd2funzd2_3235, BgL_fz00_3233,
																		(((BgL_ev_appz00_bglt)
																				CREF(BgL_ez00_3225))->BgL_tailzf3zf3),
																		BgL_stkz00_3226, BgL_siza7eza7_3234,
																		BgL_a1z00_3240, BgL_a2z00_3246);
																}
															else
																{	/* Eval/evaluate_comp.scm 1007 */
																	obj_t BgL_a3z00_3252;
																	obj_t BgL_argsz00_3253;

																	{	/* Eval/evaluate_comp.scm 1007 */
																		obj_t BgL_arg3022z00_3265;

																		BgL_arg3022z00_3265 = CAR(BgL_argsz00_3247);
																		BgL_a3z00_3252 =
																			BGl_compz00zz__evaluate_compz00(
																			((BgL_ev_exprz00_bglt)
																				BgL_arg3022z00_3265), BgL_stkz00_3226);
																	}
																	BgL_argsz00_3253 = CDR(BgL_argsz00_3247);
																	if (NULLP(BgL_argsz00_3253))
																		{	/* Eval/evaluate_comp.scm 1007 */
																			return
																				BGl_compzd2call3zd2zz__evaluate_compz00(
																				(((BgL_ev_appz00_bglt)
																						CREF(BgL_ez00_3225))->BgL_locz00),
																				(((BgL_ev_appz00_bglt)
																						CREF(BgL_ez00_3225))->BgL_funz00),
																				BgL_symbzd2funzd2_3235, BgL_fz00_3233,
																				(((BgL_ev_appz00_bglt)
																						CREF(BgL_ez00_3225))->
																					BgL_tailzf3zf3), BgL_stkz00_3226,
																				BgL_siza7eza7_3234, BgL_a1z00_3240,
																				BgL_a2z00_3246, BgL_a3z00_3252);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 1007 */
																			obj_t BgL_a4z00_3258;
																			obj_t BgL_argsz00_3259;

																			{	/* Eval/evaluate_comp.scm 1007 */
																				obj_t BgL_arg3021z00_3264;

																				BgL_arg3021z00_3264 =
																					CAR(BgL_argsz00_3253);
																				BgL_a4z00_3258 =
																					BGl_compz00zz__evaluate_compz00(
																					((BgL_ev_exprz00_bglt)
																						BgL_arg3021z00_3264),
																					BgL_stkz00_3226);
																			}
																			BgL_argsz00_3259 = CDR(BgL_argsz00_3253);
																			if (NULLP(BgL_argsz00_3259))
																				{	/* Eval/evaluate_comp.scm 1007 */
																					return
																						BGl_compzd2call4zd2zz__evaluate_compz00
																						((((BgL_ev_appz00_bglt)
																								CREF(BgL_ez00_3225))->
																							BgL_locz00),
																						(((BgL_ev_appz00_bglt)
																								CREF(BgL_ez00_3225))->
																							BgL_funz00),
																						BgL_symbzd2funzd2_3235,
																						BgL_fz00_3233,
																						(((BgL_ev_appz00_bglt)
																								CREF(BgL_ez00_3225))->
																							BgL_tailzf3zf3), BgL_stkz00_3226,
																						BgL_siza7eza7_3234, BgL_a1z00_3240,
																						BgL_a2z00_3246, BgL_a3z00_3252,
																						BgL_a4z00_3258);
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 1007 */
																					return
																						BGl_errorz00zz__errorz00
																						(BGl_string5561z00zz__evaluate_compz00,
																						BGl_string5676z00zz__evaluate_compz00,
																						BGl_string5677z00zz__evaluate_compz00);
																				}
																		}
																}
														}
												}
										}
								}
						}
				}
			}
		}
	}



/* &comp-ev_goto1681 */
	obj_t BGl_z62compzd2ev_goto1681zb0zz__evaluate_compz00(obj_t BgL_envz00_17261,
		obj_t BgL_ez00_17262, obj_t BgL_stkz00_17263)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 583 */
			{
				BgL_ev_gotoz00_bglt BgL_ez00_3182;
				obj_t BgL_stkz00_3183;

				BgL_ez00_3182 = ((BgL_ev_gotoz00_bglt) BgL_ez00_17262);
				BgL_stkz00_3183 = BgL_stkz00_17263;
				{	/* Eval/evaluate_comp.scm 586 */
					obj_t BgL_slotz00_3187;
					long BgL_siza7eza7_3188;
					obj_t BgL_lstkz00_3189;

					BgL_slotz00_3187 =
						BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
						((obj_t)
							(((BgL_ev_gotoz00_bglt) CREF(BgL_ez00_3182))->BgL_labelz00)),
						(((BgL_ev_labelsz00_bglt) CREF(
									(((BgL_ev_gotoz00_bglt) CREF(BgL_ez00_3182))->
										BgL_labelsz00)))->BgL_envz00));
					BgL_siza7eza7_3188 = bgl_list_length(BgL_stkz00_3183);
					BgL_lstkz00_3189 =
						(((BgL_ev_labelsz00_bglt) CREF(
								(((BgL_ev_gotoz00_bglt) CREF(BgL_ez00_3182))->BgL_labelsz00)))->
						BgL_stkz00);
					{	/* Eval/evaluate_comp.scm 588 */
						long BgL_llstkz00_3190;
						obj_t BgL_substkz00_3191;
						obj_t BgL_boxesz00_3192;

						BgL_llstkz00_3190 = bgl_list_length(BgL_lstkz00_3189);
						BgL_substkz00_3191 =
							BGl_subzd2stkzd2zz__evaluate_compz00(BgL_lstkz00_3189,
							BgL_stkz00_3183);
						{	/* Eval/evaluate_comp.scm 588 */
							obj_t BgL_pairz00_10279;

							BgL_pairz00_10279 =
								BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
								((obj_t)
									(((BgL_ev_gotoz00_bglt) CREF(BgL_ez00_3182))->BgL_labelz00)),
								(((BgL_ev_labelsz00_bglt) CREF(
											(((BgL_ev_gotoz00_bglt) CREF(BgL_ez00_3182))->
												BgL_labelsz00)))->BgL_boxesz00));
							BgL_boxesz00_3192 = CDR(BgL_pairz00_10279);
						}
						if (BGl_needzd2shiftzd2zz__evaluate_compz00(
								(((BgL_ev_gotoz00_bglt) CREF(BgL_ez00_3182))->BgL_argsz00),
								BgL_substkz00_3191))
							{	/* Eval/evaluate_comp.scm 591 */
								obj_t BgL_argsz00_3194;
								long BgL_nbargsz00_3195;

								BgL_argsz00_3194 =
									BGl_compzd2withzd2pushz00zz__evaluate_compz00(
									(((BgL_ev_gotoz00_bglt) CREF(BgL_ez00_3182))->BgL_argsz00),
									BgL_stkz00_3183);
								BgL_nbargsz00_3195 =
									bgl_list_length((((BgL_ev_gotoz00_bglt) CREF(BgL_ez00_3182))->
										BgL_argsz00));
								{	/* Eval/evaluate_comp.scm 592 */
									obj_t BgL_zc3anonymousza32981ze3z83_16263;

									BgL_zc3anonymousza32981ze3z83_16263 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3anonymousza32981ze3ze1zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 7)));
									PROCEDURE_SET(BgL_zc3anonymousza32981ze3z83_16263,
										(int) (((long) 0)), BINT(BgL_siza7eza7_3188));
									PROCEDURE_SET(BgL_zc3anonymousza32981ze3z83_16263,
										(int) (((long) 1)), BINT(BgL_llstkz00_3190));
									PROCEDURE_SET(BgL_zc3anonymousza32981ze3z83_16263,
										(int) (((long) 2)), ((obj_t) BgL_ez00_3182));
									PROCEDURE_SET(BgL_zc3anonymousza32981ze3z83_16263,
										(int) (((long) 3)), BgL_argsz00_3194);
									PROCEDURE_SET(BgL_zc3anonymousza32981ze3z83_16263,
										(int) (((long) 4)), BgL_boxesz00_3192);
									PROCEDURE_SET(BgL_zc3anonymousza32981ze3z83_16263,
										(int) (((long) 5)), BINT(BgL_nbargsz00_3195));
									PROCEDURE_SET(BgL_zc3anonymousza32981ze3z83_16263,
										(int) (((long) 6)), BgL_slotz00_3187);
									return BgL_zc3anonymousza32981ze3z83_16263;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 597 */
								obj_t BgL_argsz00_3206;

								BgL_argsz00_3206 =
									BGl_recz00zz__evaluate_compz00(BgL_stkz00_3183,
									(((BgL_ev_gotoz00_bglt) CREF(BgL_ez00_3182))->BgL_argsz00),
									(BgL_siza7eza7_3188 - BgL_llstkz00_3190));
								{	/* Eval/evaluate_comp.scm 598 */
									obj_t BgL_zc3anonymousza32987ze3z83_16264;

									BgL_zc3anonymousza32987ze3z83_16264 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3anonymousza32987ze3ze1zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 5)));
									PROCEDURE_SET(BgL_zc3anonymousza32987ze3z83_16264,
										(int) (((long) 0)), BINT(BgL_llstkz00_3190));
									PROCEDURE_SET(BgL_zc3anonymousza32987ze3z83_16264,
										(int) (((long) 1)), ((obj_t) BgL_ez00_3182));
									PROCEDURE_SET(BgL_zc3anonymousza32987ze3z83_16264,
										(int) (((long) 2)), BgL_argsz00_3206);
									PROCEDURE_SET(BgL_zc3anonymousza32987ze3z83_16264,
										(int) (((long) 3)), BgL_boxesz00_3192);
									PROCEDURE_SET(BgL_zc3anonymousza32987ze3z83_16264,
										(int) (((long) 4)), BgL_slotz00_3187);
									return BgL_zc3anonymousza32987ze3z83_16264;
								}
							}
					}
				}
			}
		}
	}



/* &<anonymous:2981> */
	obj_t BGl_z62zc3anonymousza32981ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17264, obj_t BgL_sz00_17272)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 592 */
			{	/* Eval/evaluate_comp.scm 592 */
				long BgL_siza7eza7_17265;
				long BgL_llstkz00_17266;
				BgL_ev_gotoz00_bglt BgL_i1140z00_17267;
				obj_t BgL_argsz00_17268;
				obj_t BgL_boxesz00_17269;
				long BgL_nbargsz00_17270;
				obj_t BgL_slotz00_17271;

				BgL_siza7eza7_17265 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17264, (int) (((long) 0))));
				BgL_llstkz00_17266 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17264, (int) (((long) 1))));
				BgL_i1140z00_17267 =
					((BgL_ev_gotoz00_bglt)
					PROCEDURE_REF(BgL_envz00_17264, (int) (((long) 2))));
				BgL_argsz00_17268 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17264, (int) (((long) 3))));
				BgL_boxesz00_17269 =
					PROCEDURE_REF(BgL_envz00_17264, (int) (((long) 4)));
				BgL_nbargsz00_17270 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17264, (int) (((long) 5))));
				BgL_slotz00_17271 = PROCEDURE_REF(BgL_envz00_17264, (int) (((long) 6)));
				{
					obj_t BgL_sz00_3196;

					BgL_sz00_3196 = BgL_sz00_17272;
					{	/* Eval/evaluate_comp.scm 592 */
						obj_t BgL_bpz00_3198;

						BgL_bpz00_3198 = VECTOR_REF(BgL_sz00_3196, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 593 */
							long BgL_spz00_3199;
							long BgL_lspz00_3200;

							BgL_spz00_3199 =
								((long) CINT(BgL_bpz00_3198) + BgL_siza7eza7_17265);
							BgL_lspz00_3200 =
								((long) CINT(BgL_bpz00_3198) + BgL_llstkz00_17266);
							BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00
								(BgL_sz00_3196, BgL_argsz00_17268, BgL_boxesz00_17269,
								BgL_spz00_3199,
								(((BgL_ev_gotoz00_bglt) CREF(BgL_i1140z00_17267))->BgL_locz00));
							{	/* Eval/evaluate_comp.scm 595 */
								long BgL_arg2983z00_3202;

								BgL_arg2983z00_3202 = (BgL_spz00_3199 + BgL_nbargsz00_17270);
								BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_3196,
									BINT(BgL_lspz00_3200), BgL_sz00_3196,
									BINT(BgL_spz00_3199), BINT(BgL_arg2983z00_3202));
							}
							return CDR(BgL_slotz00_17271);
						}
					}
				}
			}
		}
	}



/* &<anonymous:2987> */
	obj_t BGl_z62zc3anonymousza32987ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17273, obj_t BgL_sz00_17279)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 598 */
			{	/* Eval/evaluate_comp.scm 598 */
				long BgL_llstkz00_17274;
				BgL_ev_gotoz00_bglt BgL_i1140z00_17275;
				obj_t BgL_argsz00_17276;
				obj_t BgL_boxesz00_17277;
				obj_t BgL_slotz00_17278;

				BgL_llstkz00_17274 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17273, (int) (((long) 0))));
				BgL_i1140z00_17275 =
					((BgL_ev_gotoz00_bglt)
					PROCEDURE_REF(BgL_envz00_17273, (int) (((long) 1))));
				BgL_argsz00_17276 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17273, (int) (((long) 2))));
				BgL_boxesz00_17277 =
					PROCEDURE_REF(BgL_envz00_17273, (int) (((long) 3)));
				BgL_slotz00_17278 = PROCEDURE_REF(BgL_envz00_17273, (int) (((long) 4)));
				{
					obj_t BgL_sz00_3207;

					BgL_sz00_3207 = BgL_sz00_17279;
					{	/* Eval/evaluate_comp.scm 598 */
						obj_t BgL_bpz00_3209;

						BgL_bpz00_3209 = VECTOR_REF(BgL_sz00_3207, (int) (((long) 0)));
						BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00
							(BgL_sz00_3207, BgL_argsz00_17276, BgL_boxesz00_17277,
							((long) CINT(BgL_bpz00_3209) + BgL_llstkz00_17274),
							(((BgL_ev_gotoz00_bglt) CREF(BgL_i1140z00_17275))->BgL_locz00));
						return CDR(BgL_slotz00_17278);
					}
				}
			}
		}
	}



/* &comp-ev_labels1679 */
	obj_t BGl_z62compzd2ev_labels1679zb0zz__evaluate_compz00(obj_t
		BgL_envz00_17280, obj_t BgL_ez00_17281, obj_t BgL_stkz00_17282)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 551 */
			{
				BgL_ev_labelsz00_bglt BgL_ez00_3136;
				obj_t BgL_stkz00_3137;

				BgL_ez00_3136 = ((BgL_ev_labelsz00_bglt) BgL_ez00_17281);
				BgL_stkz00_3137 = BgL_stkz00_17282;
				((((BgL_ev_labelsz00_bglt) CREF(BgL_ez00_3136))->BgL_stkz00) =
					((obj_t) BgL_stkz00_3137), BUNSPEC);
				{	/* Eval/evaluate_comp.scm 558 */
					obj_t BgL_envz00_3142;

					{	/* Eval/evaluate_comp.scm 558 */
						obj_t BgL_l1585z00_3160;

						BgL_l1585z00_3160 =
							(((BgL_ev_labelsz00_bglt) CREF(BgL_ez00_3136))->BgL_varsz00);
						if (NULLP(BgL_l1585z00_3160))
							{	/* Eval/evaluate_comp.scm 558 */
								BgL_envz00_3142 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 558 */
								obj_t BgL_head1587z00_3162;

								{	/* Eval/evaluate_comp.scm 558 */
									obj_t BgL_res4940z00_10189;

									BgL_res4940z00_10189 = MAKE_PAIR(BNIL, BNIL);
									BgL_head1587z00_3162 = BgL_res4940z00_10189;
								}
								{
									obj_t BgL_l1585z00_10223;
									obj_t BgL_tail1588z00_10224;

									BgL_l1585z00_10223 = BgL_l1585z00_3160;
									BgL_tail1588z00_10224 = BgL_head1587z00_3162;
								BgL_zc3anonymousza32973ze3z83_10222:
									if (NULLP(BgL_l1585z00_10223))
										{	/* Eval/evaluate_comp.scm 558 */
											BgL_envz00_3142 = CDR(BgL_head1587z00_3162);
										}
									else
										{	/* Eval/evaluate_comp.scm 558 */
											obj_t BgL_newtail1589z00_10231;

											{	/* Eval/evaluate_comp.scm 558 */
												obj_t BgL_arg2976z00_10232;

												{	/* Eval/evaluate_comp.scm 558 */
													obj_t BgL_vz00_10233;

													BgL_vz00_10233 = CAR(BgL_l1585z00_10223);
													BgL_arg2976z00_10232 =
														MAKE_PAIR(BgL_vz00_10233,
														BGl_symbol5678z00zz__evaluate_compz00);
												}
												{	/* Eval/evaluate_comp.scm 558 */
													obj_t BgL_res4946z00_10241;

													BgL_res4946z00_10241 =
														MAKE_PAIR(BgL_arg2976z00_10232, BNIL);
													BgL_newtail1589z00_10231 = BgL_res4946z00_10241;
												}
											}
											SET_CDR(BgL_tail1588z00_10224, BgL_newtail1589z00_10231);
											{
												obj_t BgL_tail1588z00_31207;
												obj_t BgL_l1585z00_31205;

												BgL_l1585z00_31205 = CDR(BgL_l1585z00_10223);
												BgL_tail1588z00_31207 = BgL_newtail1589z00_10231;
												BgL_tail1588z00_10224 = BgL_tail1588z00_31207;
												BgL_l1585z00_10223 = BgL_l1585z00_31205;
												goto BgL_zc3anonymousza32973ze3z83_10222;
											}
										}
								}
							}
					}
					((((BgL_ev_labelsz00_bglt) CREF(BgL_ez00_3136))->BgL_envz00) =
						((obj_t) BgL_envz00_3142), BUNSPEC);
					{	/* Eval/evaluate_comp.scm 561 */
						obj_t BgL_g1593z00_3144;

						BgL_g1593z00_3144 =
							(((BgL_ev_labelsz00_bglt) CREF(BgL_ez00_3136))->BgL_valsz00);
						{
							obj_t BgL_ll1590z00_3146;
							obj_t BgL_ll1591z00_3147;

							BgL_ll1590z00_3146 = BgL_envz00_3142;
							BgL_ll1591z00_3147 = BgL_g1593z00_3144;
						BgL_zc3anonymousza32961ze3z83_3148:
							if (NULLP(BgL_ll1590z00_3146))
								{	/* Eval/evaluate_comp.scm 561 */
									((bool_t) 1);
								}
							else
								{	/* Eval/evaluate_comp.scm 561 */
									{	/* Eval/evaluate_comp.scm 563 */
										obj_t BgL_slotz00_3150;
										obj_t BgL_valz00_3151;

										BgL_slotz00_3150 = CAR(BgL_ll1590z00_3146);
										BgL_valz00_3151 = CAR(BgL_ll1591z00_3147);
										{	/* Eval/evaluate_comp.scm 564 */
											obj_t BgL_arg2963z00_3152;

											{	/* Eval/evaluate_comp.scm 564 */
												obj_t BgL_arg2964z00_3153;

												{	/* Eval/evaluate_comp.scm 564 */
													obj_t BgL_arg2965z00_3154;
													obj_t BgL_arg2967z00_3155;

													BgL_arg2965z00_3154 = CDR(BgL_valz00_3151);
													BgL_arg2967z00_3155 =
														BGl_appendzd221011zd2zz__evaluate_compz00
														(BgL_stkz00_3137, CAR(BgL_valz00_3151));
													BgL_arg2964z00_3153 =
														BGl_compz00zz__evaluate_compz00((
															(BgL_ev_exprz00_bglt) BgL_arg2965z00_3154),
														BgL_arg2967z00_3155);
												}
												{	/* Eval/evaluate_comp.scm 553 */
													obj_t BgL_procz00_10252;
													obj_t BgL_objz00_10253;

													BgL_procz00_10252 = BgL_arg2964z00_3153;
													BgL_objz00_10253 =
														BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00;
													PROCEDURE_ATTR_SET(BgL_procz00_10252,
														BgL_objz00_10253);
													BgL_objz00_10253;
												}
												BgL_arg2963z00_3152 = BgL_arg2964z00_3153;
											}
											SET_CDR(BgL_slotz00_3150, BgL_arg2963z00_3152);
										}
									}
									{
										obj_t BgL_ll1591z00_31223;
										obj_t BgL_ll1590z00_31221;

										BgL_ll1590z00_31221 = CDR(BgL_ll1590z00_3146);
										BgL_ll1591z00_31223 = CDR(BgL_ll1591z00_3147);
										BgL_ll1591z00_3147 = BgL_ll1591z00_31223;
										BgL_ll1590z00_3146 = BgL_ll1590z00_31221;
										goto BgL_zc3anonymousza32961ze3z83_3148;
									}
								}
						}
					}
				}
				{	/* Eval/evaluate_comp.scm 568 */
					obj_t BgL_bodyz00_3173;

					BgL_bodyz00_3173 =
						BGl_compz00zz__evaluate_compz00(
						(((BgL_ev_labelsz00_bglt) CREF(BgL_ez00_3136))->BgL_bodyz00),
						BgL_stkz00_3137);
					{	/* Eval/evaluate_comp.scm 569 */
						obj_t BgL_zc3anonymousza32977ze3z83_16266;

						BgL_zc3anonymousza32977ze3z83_16266 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza32977ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 1)));
						PROCEDURE_SET(BgL_zc3anonymousza32977ze3z83_16266,
							(int) (((long) 0)), BgL_bodyz00_3173);
						return BgL_zc3anonymousza32977ze3z83_16266;
					}
				}
			}
		}
	}



/* &<anonymous:2977> */
	obj_t BGl_z62zc3anonymousza32977ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17283, obj_t BgL_sz00_17285)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 569 */
			{	/* Eval/evaluate_comp.scm 569 */
				obj_t BgL_bodyz00_17284;

				BgL_bodyz00_17284 = PROCEDURE_REF(BgL_envz00_17283, (int) (((long) 0)));
				{
					obj_t BgL_sz00_3174;

					BgL_sz00_3174 = BgL_sz00_17285;
					{	/* Eval/evaluate_comp.scm 569 */
						obj_t BgL_bpz00_10258;

						BgL_bpz00_10258 = VECTOR_REF(BgL_sz00_3174, (int) (((long) 0)));
						{
							obj_t BgL_fz00_10264;

							BgL_fz00_10264 = BgL_bodyz00_17284;
						BgL_recz00_10263:
							{	/* Eval/evaluate_comp.scm 576 */
								obj_t BgL_rz00_10265;

								BgL_rz00_10265 =
									PROCEDURE_ENTRY(BgL_fz00_10264) (BgL_fz00_10264,
									BgL_sz00_3174, BEOA);
								{	/* Eval/evaluate_comp.scm 578 */
									bool_t BgL_testz00_31241;

									if (PROCEDUREP(BgL_rz00_10265))
										{	/* Eval/evaluate_comp.scm 578 */
											obj_t BgL_arg1863z00_10268;

											BgL_arg1863z00_10268 = PROCEDURE_ATTR(BgL_rz00_10265);
											if (STRUCTP(BgL_arg1863z00_10268))
												{	/* Eval/evaluate_comp.scm 548 */
													BgL_testz00_31241 =
														(STRUCT_KEY(BgL_arg1863z00_10268) ==
														BGl_symbol5555z00zz__evaluate_compz00);
												}
											else
												{	/* Eval/evaluate_comp.scm 548 */
													BgL_testz00_31241 = ((bool_t) 0);
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 578 */
											BgL_testz00_31241 = ((bool_t) 0);
										}
									if (BgL_testz00_31241)
										{
											obj_t BgL_fz00_31249;

											BgL_fz00_31249 = BgL_rz00_10265;
											BgL_fz00_10264 = BgL_fz00_31249;
											goto BgL_recz00_10263;
										}
									else
										{	/* Eval/evaluate_comp.scm 578 */
											return BgL_rz00_10265;
										}
								}
							}
						}
					}
				}
			}
		}
	}



/* &comp-ev_synchronize1677 */
	obj_t BGl_z62compzd2ev_synchroniza7e1677z17zz__evaluate_compz00(obj_t
		BgL_envz00_17286, obj_t BgL_ez00_17287, obj_t BgL_stkz00_17288)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 533 */
			{
				BgL_ev_synchroniza7eza7_bglt BgL_ez00_3116;
				obj_t BgL_stkz00_3117;

				BgL_ez00_3116 = ((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_17287);
				BgL_stkz00_3117 = BgL_stkz00_17288;
				{	/* Eval/evaluate_comp.scm 535 */
					obj_t BgL_mutexz00_3121;
					obj_t BgL_prelockz00_3122;
					obj_t BgL_bodyz00_3123;

					BgL_mutexz00_3121 =
						BGl_compz00zz__evaluate_compz00(
						(((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_ez00_3116))->
							BgL_mutexz00), BgL_stkz00_3117);
					BgL_prelockz00_3122 =
						BGl_compz00zz__evaluate_compz00((((BgL_ev_synchroniza7eza7_bglt)
								CREF(BgL_ez00_3116))->BgL_prelockz00), BgL_stkz00_3117);
					BgL_bodyz00_3123 =
						BGl_compz00zz__evaluate_compz00((((BgL_ev_synchroniza7eza7_bglt)
								CREF(BgL_ez00_3116))->BgL_bodyz00), BgL_stkz00_3117);
					{	/* Eval/evaluate_comp.scm 538 */
						obj_t BgL_zc3anonymousza32956ze3z83_16268;

						BgL_zc3anonymousza32956ze3z83_16268 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza32956ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 3)));
						PROCEDURE_SET(BgL_zc3anonymousza32956ze3z83_16268,
							(int) (((long) 0)), BgL_mutexz00_3121);
						PROCEDURE_SET(BgL_zc3anonymousza32956ze3z83_16268,
							(int) (((long) 1)), BgL_prelockz00_3122);
						PROCEDURE_SET(BgL_zc3anonymousza32956ze3z83_16268,
							(int) (((long) 2)), BgL_bodyz00_3123);
						return BgL_zc3anonymousza32956ze3z83_16268;
					}
				}
			}
		}
	}



/* &<anonymous:2956> */
	obj_t BGl_z62zc3anonymousza32956ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17289, obj_t BgL_sz00_17293)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 538 */
			{	/* Eval/evaluate_comp.scm 538 */
				obj_t BgL_mutexz00_17290;
				obj_t BgL_prelockz00_17291;
				obj_t BgL_bodyz00_17292;

				BgL_mutexz00_17290 =
					PROCEDURE_REF(BgL_envz00_17289, (int) (((long) 0)));
				BgL_prelockz00_17291 =
					PROCEDURE_REF(BgL_envz00_17289, (int) (((long) 1)));
				BgL_bodyz00_17292 = PROCEDURE_REF(BgL_envz00_17289, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3124;

					BgL_sz00_3124 = BgL_sz00_17293;
					{	/* Eval/evaluate_comp.scm 538 */
						obj_t BgL_bpz00_3126;

						BgL_bpz00_3126 = VECTOR_REF(BgL_sz00_3124, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 539 */
							obj_t BgL_mz00_3127;

							BgL_mz00_3127 =
								PROCEDURE_ENTRY(BgL_mutexz00_17290) (BgL_mutexz00_17290,
								BgL_sz00_3124, BEOA);
							{	/* Eval/evaluate_comp.scm 540 */
								obj_t BgL_pz00_3128;

								BgL_pz00_3128 =
									PROCEDURE_ENTRY(BgL_prelockz00_17291) (BgL_prelockz00_17291,
									BgL_sz00_3124, BEOA);
								{	/* Eval/evaluate_comp.scm 542 */
									obj_t BgL_za2za2resza2za2z00_3130;

									if (PAIRP(BgL_pz00_3128))
										{	/* Eval/evaluate_comp.scm 543 */
											obj_t BgL_top5811z00_31285;

											BgL_top5811z00_31285 = BGL_EXITD_TOP_AS_OBJ();
											BGL_MUTEX_LOCK_PRELOCK(BgL_mz00_3127, BgL_pz00_3128);
											BGL_EXITD_PUSH_MUTEX(BgL_top5811z00_31285, BgL_mz00_3127);
											{	/* Eval/evaluate_comp.scm 543 */
												obj_t BgL_tmp5810z00_31284;

												BgL_tmp5810z00_31284 =
													PROCEDURE_ENTRY(BgL_bodyz00_17292) (BgL_bodyz00_17292,
													BgL_sz00_3124, BEOA);
												BGL_EXITD_POP_MUTEX(BgL_top5811z00_31285,
													BgL_mz00_3127);
												BGL_MUTEX_UNLOCK(BgL_mz00_3127);
												BgL_za2za2resza2za2z00_3130 = BgL_tmp5810z00_31284;
											}
										}
									else
										{	/* Eval/evaluate_comp.scm 544 */
											obj_t BgL_top5813z00_31296;

											BgL_top5813z00_31296 = BGL_EXITD_TOP_AS_OBJ();
											BGL_MUTEX_LOCK(BgL_mz00_3127);
											BGL_EXITD_PUSH_MUTEX(BgL_top5813z00_31296, BgL_mz00_3127);
											{	/* Eval/evaluate_comp.scm 544 */
												obj_t BgL_tmp5812z00_31295;

												BgL_tmp5812z00_31295 =
													PROCEDURE_ENTRY(BgL_bodyz00_17292) (BgL_bodyz00_17292,
													BgL_sz00_3124, BEOA);
												BGL_EXITD_POP_MUTEX(BgL_top5813z00_31296,
													BgL_mz00_3127);
												BGL_MUTEX_UNLOCK(BgL_mz00_3127);
												BgL_za2za2resza2za2z00_3130 = BgL_tmp5812z00_31295;
											}
										}
									VECTOR_SET(BgL_sz00_3124, (int) (((long) 0)), BgL_bpz00_3126);
									return BgL_za2za2resza2za2z00_3130;
								}
							}
						}
					}
				}
			}
		}
	}



/* &comp-ev_with-handler1675 */
	obj_t BGl_z62compzd2ev_withzd2handler1675z62zz__evaluate_compz00(obj_t
		BgL_envz00_17294, obj_t BgL_ez00_17295, obj_t BgL_stkz00_17296)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 524 */
			{
				BgL_ev_withzd2handlerzd2_bglt BgL_ez00_3078;
				obj_t BgL_stkz00_3079;

				BgL_ez00_3078 = ((BgL_ev_withzd2handlerzd2_bglt) BgL_ez00_17295);
				BgL_stkz00_3079 = BgL_stkz00_17296;
				{	/* Eval/evaluate_comp.scm 526 */
					obj_t BgL_handlerz00_3083;
					obj_t BgL_bodyz00_3084;

					BgL_handlerz00_3083 =
						BGl_compz00zz__evaluate_compz00(
						(((BgL_ev_withzd2handlerzd2_bglt) CREF(BgL_ez00_3078))->
							BgL_handlerz00), BgL_stkz00_3079);
					BgL_bodyz00_3084 =
						BGl_compz00zz__evaluate_compz00((((BgL_ev_withzd2handlerzd2_bglt)
								CREF(BgL_ez00_3078))->BgL_bodyz00), BgL_stkz00_3079);
					{	/* Eval/evaluate_comp.scm 527 */
						obj_t BgL_zc3anonymousza32944ze3z83_16271;

						BgL_zc3anonymousza32944ze3z83_16271 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza32944ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 2)));
						PROCEDURE_SET(BgL_zc3anonymousza32944ze3z83_16271,
							(int) (((long) 0)), BgL_handlerz00_3083);
						PROCEDURE_SET(BgL_zc3anonymousza32944ze3z83_16271,
							(int) (((long) 1)), BgL_bodyz00_3084);
						return BgL_zc3anonymousza32944ze3z83_16271;
					}
				}
			}
		}
	}



/* &<anonymous:2944> */
	obj_t BGl_z62zc3anonymousza32944ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17297, obj_t BgL_sz00_17300)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 527 */
			{	/* Eval/evaluate_comp.scm 527 */
				obj_t BgL_handlerz00_17298;
				obj_t BgL_bodyz00_17299;

				BgL_handlerz00_17298 =
					PROCEDURE_REF(BgL_envz00_17297, (int) (((long) 0)));
				BgL_bodyz00_17299 = PROCEDURE_REF(BgL_envz00_17297, (int) (((long) 1)));
				{
					obj_t BgL_sz00_3085;

					BgL_sz00_3085 = BgL_sz00_17300;
					{	/* Eval/evaluate_comp.scm 527 */
						obj_t BgL_bpz00_3087;

						BgL_bpz00_3087 = VECTOR_REF(BgL_sz00_3085, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 528 */
							obj_t BgL_hz00_3088;

							BgL_hz00_3088 =
								PROCEDURE_ENTRY(BgL_handlerz00_17298) (BgL_handlerz00_17298,
								BgL_sz00_3085, BEOA);
							{	/* Eval/evaluate_comp.scm 530 */
								obj_t BgL_za2za2resza2za2z00_3090;

								{	/* Eval/evaluate_comp.scm 530 */
									obj_t BgL_res1127z00_3091;

									BgL_res1127z00_3091 = MAKE_CELL(BUNSPEC);
									if (CBOOL(BGl_zc3exitza32946ze3z83zz__evaluate_compz00
											(BgL_sz00_3085, BgL_bodyz00_17299, BgL_res1127z00_3091)))
										{	/* Eval/evaluate_comp.scm 530 */
											BgL_za2za2resza2za2z00_3090 =
												PROCEDURE_ENTRY(BgL_hz00_3088) (BgL_hz00_3088,
												CELL_REF(BgL_res1127z00_3091), BEOA);
										}
									else
										{	/* Eval/evaluate_comp.scm 530 */
											BgL_za2za2resza2za2z00_3090 =
												CELL_REF(BgL_res1127z00_3091);
										}
								}
								VECTOR_SET(BgL_sz00_3085, (int) (((long) 0)), BgL_bpz00_3087);
								return BgL_za2za2resza2za2z00_3090;
							}
						}
					}
				}
			}
		}
	}



/* <exit:2950> */
	obj_t BGl_zc3exitza32950ze3z83zz__evaluate_compz00(obj_t BgL_sz00_17480,
		obj_t BgL_bodyz00_17479, obj_t BgL_ohs1125z00_17478,
		obj_t BgL_an_exitd1131z00_17477, obj_t BgL_res1127z00_17476)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 530 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1135z00_3106;

			if (SET_EXIT(BgL_an_exit1135z00_3106))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1135z00_3106 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 530 */

						PUSH_EXIT(BgL_an_exit1135z00_3106, ((long) 0));
						{	/* Eval/evaluate_comp.scm 530 */
							bool_t BgL_val1136z00_3107;

							{	/* Eval/evaluate_comp.scm 530 */
								obj_t BgL_arg2951z00_3108;

								{	/* Eval/evaluate_comp.scm 530 */
									obj_t BgL_zc3anonymousza32953ze3z83_16270;

									BgL_zc3anonymousza32953ze3z83_16270 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3anonymousza32953ze3ze1zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 2)));
									PROCEDURE_SET(BgL_zc3anonymousza32953ze3z83_16270,
										(int) (((long) 0)), BgL_res1127z00_17476);
									PROCEDURE_SET(BgL_zc3anonymousza32953ze3z83_16270,
										(int) (((long) 1)), BgL_an_exitd1131z00_17477);
									BgL_arg2951z00_3108 =
										MAKE_PAIR(BgL_zc3anonymousza32953ze3z83_16270,
										BgL_ohs1125z00_17478);
								}
								BGL_ERROR_HANDLER_SET(BgL_arg2951z00_3108);
								BUNSPEC;
							}
							{	/* Eval/evaluate_comp.scm 530 */
								obj_t BgL_auxz00_17301;

								BgL_auxz00_17301 =
									PROCEDURE_ENTRY(BgL_bodyz00_17479) (BgL_bodyz00_17479,
									BgL_sz00_17480, BEOA);
								CELL_SET(BgL_res1127z00_17476, BgL_auxz00_17301);
							}
							BgL_val1136z00_3107 = ((bool_t) 0);
							POP_EXIT();
							return BBOOL(BgL_val1136z00_3107);
						}
					}
				}
		}
	}



/* <exit:2946> */
	obj_t BGl_zc3exitza32946ze3z83zz__evaluate_compz00(obj_t BgL_sz00_17483,
		obj_t BgL_bodyz00_17482, obj_t BgL_res1127z00_17481)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 530 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1130z00_3095;

			if (SET_EXIT(BgL_an_exit1130z00_3095))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1130z00_3095 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 530 */

						PUSH_EXIT(BgL_an_exit1130z00_3095, ((long) 1));
						{	/* Eval/evaluate_comp.scm 530 */
							obj_t BgL_an_exitd1131z00_3096;

							BgL_an_exitd1131z00_3096 = ((obj_t) (&exitd));
							{	/* Eval/evaluate_comp.scm 530 */
								obj_t BgL_res1133z00_3099;

								{	/* Eval/evaluate_comp.scm 530 */
									obj_t BgL_ohs1125z00_3100;

									BgL_ohs1125z00_3100 = BGL_ERROR_HANDLER_GET();
									{	/* Eval/evaluate_comp.scm 530 */
										obj_t BgL_val1134z00_3101;

										BgL_val1134z00_3101 =
											BGl_zc3exitza32950ze3z83zz__evaluate_compz00
											(BgL_sz00_17483, BgL_bodyz00_17482, BgL_ohs1125z00_3100,
											BgL_an_exitd1131z00_3096, BgL_res1127z00_17481);
										BGL_ERROR_HANDLER_SET(BgL_ohs1125z00_3100);
										BUNSPEC;
										if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
												(BgL_val1134z00_3101)))
											{	/* Eval/evaluate_comp.scm 530 */
												BgL_res1133z00_3099 =
													BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
													(BgL_val1134z00_3101), CDR(BgL_val1134z00_3101));
											}
										else
											{	/* Eval/evaluate_comp.scm 530 */
												BgL_res1133z00_3099 = BgL_val1134z00_3101;
											}
									}
								}
								POP_EXIT();
								return BgL_res1133z00_3099;
							}
						}
					}
				}
		}
	}



/* &<anonymous:2953> */
	obj_t BGl_z62zc3anonymousza32953ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17302, obj_t BgL_ez00_17305)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 530 */
			{	/* Eval/evaluate_comp.scm 530 */
				obj_t BgL_res1127z00_17303;
				obj_t BgL_an_exitd1131z00_17304;

				BgL_res1127z00_17303 =
					PROCEDURE_REF(BgL_envz00_17302, (int) (((long) 0)));
				BgL_an_exitd1131z00_17304 =
					PROCEDURE_REF(BgL_envz00_17302, (int) (((long) 1)));
				{
					obj_t BgL_ez00_3110;

					BgL_ez00_3110 = BgL_ez00_17305;
					CELL_SET(BgL_res1127z00_17303, BgL_ez00_3110);
					return
						BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1131z00_17304,
						BTRUE);
				}
			}
		}
	}



/* &comp-ev_unwind-prote1673 */
	obj_t BGl_z62compzd2ev_unwindzd2prote1673z62zz__evaluate_compz00(obj_t
		BgL_envz00_17307, obj_t BgL_ez00_17308, obj_t BgL_stkz00_17309)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 515 */
			{
				BgL_ev_unwindzd2protectzd2_bglt BgL_ez00_3057;
				obj_t BgL_stkz00_3058;

				BgL_ez00_3057 = ((BgL_ev_unwindzd2protectzd2_bglt) BgL_ez00_17308);
				BgL_stkz00_3058 = BgL_stkz00_17309;
				{	/* Eval/evaluate_comp.scm 517 */
					obj_t BgL_ez00_3062;
					obj_t BgL_bodyz00_3063;

					BgL_ez00_3062 =
						BGl_compz00zz__evaluate_compz00(
						(((BgL_ev_unwindzd2protectzd2_bglt) CREF(BgL_ez00_3057))->BgL_ez00),
						BgL_stkz00_3058);
					BgL_bodyz00_3063 =
						BGl_compz00zz__evaluate_compz00((((BgL_ev_unwindzd2protectzd2_bglt)
								CREF(BgL_ez00_3057))->BgL_bodyz00), BgL_stkz00_3058);
					{	/* Eval/evaluate_comp.scm 518 */
						obj_t BgL_zc3anonymousza32937ze3z83_16273;

						BgL_zc3anonymousza32937ze3z83_16273 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza32937ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 2)));
						PROCEDURE_SET(BgL_zc3anonymousza32937ze3z83_16273,
							(int) (((long) 0)), BgL_ez00_3062);
						PROCEDURE_SET(BgL_zc3anonymousza32937ze3z83_16273,
							(int) (((long) 1)), BgL_bodyz00_3063);
						return BgL_zc3anonymousza32937ze3z83_16273;
					}
				}
			}
		}
	}



/* &<anonymous:2937> */
	obj_t BGl_z62zc3anonymousza32937ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17310, obj_t BgL_sz00_17313)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 518 */
			{	/* Eval/evaluate_comp.scm 518 */
				obj_t BgL_ez00_17311;
				obj_t BgL_bodyz00_17312;

				BgL_ez00_17311 = PROCEDURE_REF(BgL_envz00_17310, (int) (((long) 0)));
				BgL_bodyz00_17312 = PROCEDURE_REF(BgL_envz00_17310, (int) (((long) 1)));
				{
					obj_t BgL_sz00_3064;

					BgL_sz00_3064 = BgL_sz00_17313;
					{	/* Eval/evaluate_comp.scm 518 */
						obj_t BgL_bpz00_3066;

						BgL_bpz00_3066 = VECTOR_REF(BgL_sz00_3064, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 520 */
							obj_t BgL_val1121z00_3068;

							BgL_val1121z00_3068 =
								BGl_zc3exitza32941ze3z83zz__evaluate_compz00(BgL_sz00_3064,
								BgL_ez00_17311);
							VECTOR_SET(BgL_sz00_3064, (int) (((long) 0)), BgL_bpz00_3066);
							PROCEDURE_ENTRY(BgL_bodyz00_17312) (BgL_bodyz00_17312,
								BgL_sz00_3064, BEOA);
							if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
									(BgL_val1121z00_3068)))
								{	/* Eval/evaluate_comp.scm 522 */
									return
										BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
										(BgL_val1121z00_3068), CDR(BgL_val1121z00_3068));
								}
							else
								{	/* Eval/evaluate_comp.scm 522 */
									return BgL_val1121z00_3068;
								}
						}
					}
				}
			}
		}
	}



/* <exit:2941> */
	obj_t BGl_zc3exitza32941ze3z83zz__evaluate_compz00(obj_t BgL_sz00_17475,
		obj_t BgL_ez00_17474)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 521 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1122z00_3073;

			if (SET_EXIT(BgL_an_exit1122z00_3073))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1122z00_3073 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 521 */

						PUSH_EXIT(BgL_an_exit1122z00_3073, ((long) 0));
						{	/* Eval/evaluate_comp.scm 520 */
							obj_t BgL_val1123z00_3074;

							BgL_val1123z00_3074 =
								PROCEDURE_ENTRY(BgL_ez00_17474) (BgL_ez00_17474, BgL_sz00_17475,
								BEOA);
							POP_EXIT();
							return BgL_val1123z00_3074;
						}
					}
				}
		}
	}



/* &comp-ev_bind-exit1671 */
	obj_t BGl_z62compzd2ev_bindzd2exit1671z62zz__evaluate_compz00(obj_t
		BgL_envz00_17314, obj_t BgL_ez00_17315, obj_t BgL_stkz00_17316)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 504 */
			{
				BgL_ev_bindzd2exitzd2_bglt BgL_ez00_3030;
				obj_t BgL_stkz00_3031;

				BgL_ez00_3030 = ((BgL_ev_bindzd2exitzd2_bglt) BgL_ez00_17315);
				BgL_stkz00_3031 = BgL_stkz00_17316;
				{	/* Eval/evaluate_comp.scm 506 */
					long BgL_siza7eza7_3035;
					obj_t BgL_nstkz00_3036;

					BgL_siza7eza7_3035 = bgl_list_length(BgL_stkz00_3031);
					{	/* Eval/evaluate_comp.scm 506 */
						obj_t BgL_arg2935z00_3054;

						{	/* Eval/evaluate_comp.scm 506 */
							BgL_ev_varz00_bglt BgL_arg2936z00_3055;

							BgL_arg2936z00_3055 =
								(((BgL_ev_bindzd2exitzd2_bglt) CREF(BgL_ez00_3030))->
								BgL_varz00);
							BgL_arg2935z00_3054 =
								MAKE_PAIR(((obj_t) BgL_arg2936z00_3055), BNIL);
						}
						BgL_nstkz00_3036 =
							BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_3031,
							BgL_arg2935z00_3054);
					}
					{	/* Eval/evaluate_comp.scm 507 */
						obj_t BgL_bodyz00_3037;
						obj_t BgL_effzf3zf3_3038;

						BgL_bodyz00_3037 =
							BGl_compz00zz__evaluate_compz00(
							(((BgL_ev_bindzd2exitzd2_bglt) CREF(BgL_ez00_3030))->BgL_bodyz00),
							BgL_nstkz00_3036);
						BgL_effzf3zf3_3038 =
							(((BgL_ev_varz00_bglt) CREF((((BgL_ev_bindzd2exitzd2_bglt)
											CREF(BgL_ez00_3030))->BgL_varz00)))->BgL_effz00);
						{	/* Eval/evaluate_comp.scm 508 */
							obj_t BgL_zc3anonymousza32929ze3z83_16276;

							BgL_zc3anonymousza32929ze3z83_16276 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3anonymousza32929ze3ze1zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_zc3anonymousza32929ze3z83_16276,
								(int) (((long) 0)), BINT(BgL_siza7eza7_3035));
							PROCEDURE_SET(BgL_zc3anonymousza32929ze3z83_16276,
								(int) (((long) 1)), BgL_effzf3zf3_3038);
							PROCEDURE_SET(BgL_zc3anonymousza32929ze3z83_16276,
								(int) (((long) 2)), BgL_bodyz00_3037);
							return BgL_zc3anonymousza32929ze3z83_16276;
						}
					}
				}
			}
		}
	}



/* &<anonymous:2929> */
	obj_t BGl_z62zc3anonymousza32929ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17317, obj_t BgL_sz00_17321)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 508 */
			{	/* Eval/evaluate_comp.scm 508 */
				long BgL_siza7eza7_17318;
				obj_t BgL_effzf3zf3_17319;
				obj_t BgL_bodyz00_17320;

				BgL_siza7eza7_17318 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17317, (int) (((long) 0))));
				BgL_effzf3zf3_17319 =
					PROCEDURE_REF(BgL_envz00_17317, (int) (((long) 1)));
				BgL_bodyz00_17320 = PROCEDURE_REF(BgL_envz00_17317, (int) (((long) 2)));
				{
					obj_t BgL_sz00_3039;

					BgL_sz00_3039 = BgL_sz00_17321;
					{	/* Eval/evaluate_comp.scm 508 */
						obj_t BgL_bpz00_3041;

						BgL_bpz00_3041 = VECTOR_REF(BgL_sz00_3039, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 510 */
							obj_t BgL_za2za2resza2za2z00_3043;

							BgL_za2za2resza2za2z00_3043 =
								BGl_zc3exitza32930ze3z83zz__evaluate_compz00(BgL_bodyz00_17320,
								BgL_sz00_3039, BgL_effzf3zf3_17319, BgL_siza7eza7_17318,
								BgL_bpz00_3041);
							VECTOR_SET(BgL_sz00_3039, (int) (((long) 0)), BgL_bpz00_3041);
							return BgL_za2za2resza2za2z00_3043;
						}
					}
				}
			}
		}
	}



/* <exit:2930> */
	obj_t BGl_zc3exitza32930ze3z83zz__evaluate_compz00(obj_t BgL_bodyz00_17473,
		obj_t BgL_sz00_17472, obj_t BgL_effzf3zf3_17471, long BgL_siza7eza7_17470,
		obj_t BgL_bpz00_17469)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 510 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1116z00_3045;

			if (SET_EXIT(BgL_an_exit1116z00_3045))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1116z00_3045 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 510 */

						PUSH_EXIT(BgL_an_exit1116z00_3045, ((long) 1));
						{	/* Eval/evaluate_comp.scm 510 */
							obj_t BgL_an_exitd1117z00_3046;

							BgL_an_exitd1117z00_3046 = ((obj_t) (&exitd));
							{	/* Eval/evaluate_comp.scm 510 */
								obj_t BgL_exitz00_16275;

								BgL_exitz00_16275 =
									MAKE_FX_PROCEDURE(BGl_z62exitz62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_exitz00_16275,
									(int) (((long) 0)), BgL_an_exitd1117z00_3046);
								{	/* Eval/evaluate_comp.scm 511 */
									obj_t BgL_res1119z00_3049;

									{	/* Eval/evaluate_comp.scm 511 */
										long BgL_arg2931z00_3050;
										obj_t BgL_arg2933z00_3051;

										BgL_arg2931z00_3050 =
											((long) CINT(BgL_bpz00_17469) + BgL_siza7eza7_17470);
										if (CBOOL(BgL_effzf3zf3_17471))
											{	/* Eval/evaluate_comp.scm 189 */
												obj_t BgL_newz00_10151;

												BgL_newz00_10151 =
													create_struct(BGl_symbol5571z00zz__evaluate_compz00,
													(int) (((long) 1)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_31460;

													BgL_auxz00_31460 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_10151, BgL_auxz00_31460,
														BgL_exitz00_16275);
												}
												BgL_arg2933z00_3051 = BgL_newz00_10151;
											}
										else
											{	/* Eval/evaluate_comp.scm 511 */
												BgL_arg2933z00_3051 = BgL_exitz00_16275;
											}
										VECTOR_SET(BgL_sz00_17472,
											(int) (BgL_arg2931z00_3050), BgL_arg2933z00_3051);
									}
									BgL_res1119z00_3049 =
										PROCEDURE_ENTRY(BgL_bodyz00_17473) (BgL_bodyz00_17473,
										BgL_sz00_17472, BEOA);
									POP_EXIT();
									return BgL_res1119z00_3049;
								}
							}
						}
					}
				}
		}
	}



/* &exit */
	obj_t BGl_z62exitz62zz__evaluate_compz00(obj_t BgL_envz00_17322,
		obj_t BgL_val1118z00_17324)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 510 */
			{	/* Eval/evaluate_comp.scm 510 */
				obj_t BgL_an_exitd1117z00_17323;

				BgL_an_exitd1117z00_17323 =
					PROCEDURE_REF(BgL_envz00_17322, (int) (((long) 0)));
				{
					obj_t BgL_val1118z00_3047;

					BgL_val1118z00_3047 = BgL_val1118z00_17324;
					return
						BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1117z00_17323,
						BgL_val1118z00_3047);
				}
			}
		}
	}



/* &comp-ev_letrec1669 */
	obj_t BGl_z62compzd2ev_letrec1669zb0zz__evaluate_compz00(obj_t
		BgL_envz00_17325, obj_t BgL_ez00_17326, obj_t BgL_stkz00_17327)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 475 */
			{
				BgL_ev_letrecz00_bglt BgL_ez00_2931;
				obj_t BgL_stkz00_2932;

				BgL_ez00_2931 = ((BgL_ev_letrecz00_bglt) BgL_ez00_17326);
				BgL_stkz00_2932 = BgL_stkz00_17327;
				{	/* Eval/evaluate_comp.scm 477 */
					long BgL_siza7eza7_2936;
					obj_t BgL_nstkz00_2937;

					BgL_siza7eza7_2936 = bgl_list_length(BgL_stkz00_2932);
					{	/* Eval/evaluate_comp.scm 477 */
						obj_t BgL_arg2928z00_3028;

						BgL_arg2928z00_3028 =
							(((BgL_ev_binderz00_bglt) CREF(
									((BgL_ev_binderz00_bglt) BgL_ez00_2931)))->BgL_varsz00);
						BgL_nstkz00_2937 =
							BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_2932,
							BgL_arg2928z00_3028);
					}
					{	/* Eval/evaluate_comp.scm 478 */
						obj_t BgL_cvalsz00_2938;
						obj_t BgL_bodyz00_2939;

						{	/* Eval/evaluate_comp.scm 478 */
							obj_t BgL_l1571z00_3014;

							BgL_l1571z00_3014 =
								(((BgL_ev_binderz00_bglt) CREF(
										((BgL_ev_binderz00_bglt) BgL_ez00_2931)))->BgL_valsz00);
							if (NULLP(BgL_l1571z00_3014))
								{	/* Eval/evaluate_comp.scm 478 */
									BgL_cvalsz00_2938 = BNIL;
								}
							else
								{	/* Eval/evaluate_comp.scm 478 */
									obj_t BgL_head1573z00_3016;

									{	/* Eval/evaluate_comp.scm 478 */
										obj_t BgL_res4897z00_9791;

										BgL_res4897z00_9791 = MAKE_PAIR(BNIL, BNIL);
										BgL_head1573z00_3016 = BgL_res4897z00_9791;
									}
									{
										obj_t BgL_l1571z00_9825;
										obj_t BgL_tail1574z00_9826;

										BgL_l1571z00_9825 = BgL_l1571z00_3014;
										BgL_tail1574z00_9826 = BgL_head1573z00_3016;
									BgL_zc3anonymousza32923ze3z83_9824:
										if (NULLP(BgL_l1571z00_9825))
											{	/* Eval/evaluate_comp.scm 478 */
												BgL_cvalsz00_2938 = CDR(BgL_head1573z00_3016);
											}
										else
											{	/* Eval/evaluate_comp.scm 478 */
												obj_t BgL_newtail1575z00_9833;

												{	/* Eval/evaluate_comp.scm 478 */
													obj_t BgL_arg2926z00_9834;

													{	/* Eval/evaluate_comp.scm 478 */
														obj_t BgL_vz00_9835;

														BgL_vz00_9835 = CAR(BgL_l1571z00_9825);
														BgL_arg2926z00_9834 =
															BGl_compz00zz__evaluate_compz00(
															((BgL_ev_exprz00_bglt) BgL_vz00_9835),
															BgL_nstkz00_2937);
													}
													{	/* Eval/evaluate_comp.scm 478 */
														obj_t BgL_res4903z00_9843;

														BgL_res4903z00_9843 =
															MAKE_PAIR(BgL_arg2926z00_9834, BNIL);
														BgL_newtail1575z00_9833 = BgL_res4903z00_9843;
													}
												}
												SET_CDR(BgL_tail1574z00_9826, BgL_newtail1575z00_9833);
												{
													obj_t BgL_tail1574z00_31492;
													obj_t BgL_l1571z00_31490;

													BgL_l1571z00_31490 = CDR(BgL_l1571z00_9825);
													BgL_tail1574z00_31492 = BgL_newtail1575z00_9833;
													BgL_tail1574z00_9826 = BgL_tail1574z00_31492;
													BgL_l1571z00_9825 = BgL_l1571z00_31490;
													goto BgL_zc3anonymousza32923ze3z83_9824;
												}
											}
									}
								}
						}
						{	/* Eval/evaluate_comp.scm 479 */
							BgL_ev_exprz00_bglt BgL_arg2927z00_3027;

							BgL_arg2927z00_3027 =
								(((BgL_ev_binderz00_bglt) CREF(
										((BgL_ev_binderz00_bglt) BgL_ez00_2931)))->BgL_bodyz00);
							BgL_bodyz00_2939 =
								BGl_compz00zz__evaluate_compz00(BgL_arg2927z00_3027,
								BgL_nstkz00_2937);
						}
						{	/* Eval/evaluate_comp.scm 480 */
							bool_t BgL_testz00_31496;

							{
								obj_t BgL_l1576z00_3006;

								BgL_l1576z00_3006 =
									(((BgL_ev_binderz00_bglt) CREF(
											((BgL_ev_binderz00_bglt) BgL_ez00_2931)))->BgL_valsz00);
							BgL_zc3anonymousza32919ze3z83_3007:
								if (NULLP(BgL_l1576z00_3006))
									{	/* Eval/evaluate_comp.scm 480 */
										BgL_testz00_31496 = ((bool_t) 1);
									}
								else
									{	/* Eval/evaluate_comp.scm 480 */
										bool_t BgL_testz00_31499;

										{	/* Eval/evaluate_comp.scm 480 */
											obj_t BgL_vz00_3012;

											BgL_vz00_3012 = CAR(BgL_l1576z00_3006);
											BgL_testz00_31499 =
												BGl_isazf3zf3zz__objectz00(BgL_vz00_3012,
												BGl_ev_absz00zz__evaluate_typesz00);
										}
										if (BgL_testz00_31499)
											{
												obj_t BgL_l1576z00_31502;

												BgL_l1576z00_31502 = CDR(BgL_l1576z00_3006);
												BgL_l1576z00_3006 = BgL_l1576z00_31502;
												goto BgL_zc3anonymousza32919ze3z83_3007;
											}
										else
											{	/* Eval/evaluate_comp.scm 480 */
												BgL_testz00_31496 = ((bool_t) 0);
											}
									}
							}
							if (BgL_testz00_31496)
								{	/* Eval/evaluate_comp.scm 481 */
									obj_t BgL_zc3anonymousza32889ze3z83_16279;

									BgL_zc3anonymousza32889ze3z83_16279 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3anonymousza32889ze3ze1zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 3)));
									PROCEDURE_SET(BgL_zc3anonymousza32889ze3z83_16279,
										(int) (((long) 0)), BINT(BgL_siza7eza7_2936));
									PROCEDURE_SET(BgL_zc3anonymousza32889ze3z83_16279,
										(int) (((long) 1)), BgL_cvalsz00_2938);
									PROCEDURE_SET(BgL_zc3anonymousza32889ze3z83_16279,
										(int) (((long) 2)), BgL_bodyz00_2939);
									return BgL_zc3anonymousza32889ze3z83_16279;
								}
							else
								{	/* Eval/evaluate_comp.scm 491 */
									obj_t BgL_zc3anonymousza32902ze3z83_16278;

									BgL_zc3anonymousza32902ze3z83_16278 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3anonymousza32902ze3ze1zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 3)));
									PROCEDURE_SET(BgL_zc3anonymousza32902ze3z83_16278,
										(int) (((long) 0)), BINT(BgL_siza7eza7_2936));
									PROCEDURE_SET(BgL_zc3anonymousza32902ze3z83_16278,
										(int) (((long) 1)), BgL_cvalsz00_2938);
									PROCEDURE_SET(BgL_zc3anonymousza32902ze3z83_16278,
										(int) (((long) 2)), BgL_bodyz00_2939);
									return BgL_zc3anonymousza32902ze3z83_16278;
								}
						}
					}
				}
			}
		}
	}



/* &<anonymous:2889> */
	obj_t BGl_z62zc3anonymousza32889ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17328, obj_t BgL_sz00_17332)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 481 */
			{	/* Eval/evaluate_comp.scm 481 */
				long BgL_siza7eza7_17329;
				obj_t BgL_cvalsz00_17330;
				obj_t BgL_bodyz00_17331;

				BgL_siza7eza7_17329 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17328, (int) (((long) 0))));
				BgL_cvalsz00_17330 =
					PROCEDURE_REF(BgL_envz00_17328, (int) (((long) 1)));
				BgL_bodyz00_17331 = PROCEDURE_REF(BgL_envz00_17328, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2941;

					BgL_sz00_2941 = BgL_sz00_17332;
					{	/* Eval/evaluate_comp.scm 481 */
						obj_t BgL_bpz00_2943;

						BgL_bpz00_2943 = VECTOR_REF(BgL_sz00_2941, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 482 */
							long BgL_g1110z00_2944;

							BgL_g1110z00_2944 =
								((long) CINT(BgL_bpz00_2943) + BgL_siza7eza7_17329);
							{
								obj_t BgL_lz00_9899;
								long BgL_iz00_9900;

								BgL_lz00_9899 = BgL_cvalsz00_17330;
								BgL_iz00_9900 = BgL_g1110z00_2944;
							BgL_recz00_9898:
								if (NULLP(BgL_lz00_9899))
									{	/* Eval/evaluate_comp.scm 483 */
										((bool_t) 0);
									}
								else
									{	/* Eval/evaluate_comp.scm 483 */
										{	/* Eval/evaluate_comp.scm 484 */
											obj_t BgL_arg2892z00_9906;

											{	/* Eval/evaluate_comp.scm 189 */
												obj_t BgL_newz00_9912;

												BgL_newz00_9912 =
													create_struct(BGl_symbol5571z00zz__evaluate_compz00,
													(int) (((long) 1)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_31542;

													BgL_auxz00_31542 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_9912, BgL_auxz00_31542,
														BUNSPEC);
												}
												BgL_arg2892z00_9906 = BgL_newz00_9912;
											}
											VECTOR_SET(BgL_sz00_2941,
												(int) (BgL_iz00_9900), BgL_arg2892z00_9906);
										}
										{
											long BgL_iz00_31549;
											obj_t BgL_lz00_31547;

											BgL_lz00_31547 = CDR(BgL_lz00_9899);
											BgL_iz00_31549 = (BgL_iz00_9900 + ((long) 1));
											BgL_iz00_9900 = BgL_iz00_31549;
											BgL_lz00_9899 = BgL_lz00_31547;
											goto BgL_recz00_9898;
										}
									}
							}
						}
						{	/* Eval/evaluate_comp.scm 486 */
							long BgL_g1111z00_2954;

							BgL_g1111z00_2954 =
								((long) CINT(BgL_bpz00_2943) + BgL_siza7eza7_17329);
							{
								obj_t BgL_lz00_2956;
								long BgL_iz00_2957;

								BgL_lz00_2956 = BgL_cvalsz00_17330;
								BgL_iz00_2957 = BgL_g1111z00_2954;
							BgL_zc3anonymousza32895ze3z83_2958:
								if (NULLP(BgL_lz00_2956))
									{	/* Eval/evaluate_comp.scm 487 */
										((bool_t) 0);
									}
								else
									{	/* Eval/evaluate_comp.scm 487 */
										{	/* Eval/evaluate_comp.scm 488 */
											obj_t BgL_arg2897z00_2960;
											obj_t BgL_arg2898z00_2961;

											BgL_arg2897z00_2960 =
												VECTOR_REF(BgL_sz00_2941, (int) (BgL_iz00_2957));
											{	/* Eval/evaluate_comp.scm 488 */
												obj_t BgL_fun2899z00_2962;

												BgL_fun2899z00_2962 = CAR(BgL_lz00_2956);
												BgL_arg2898z00_2961 =
													PROCEDURE_ENTRY(BgL_fun2899z00_2962)
													(BgL_fun2899z00_2962, BgL_sz00_2941, BEOA);
											}
											{	/* Llib/struct.scm 162 */
												int BgL_auxz00_31562;

												BgL_auxz00_31562 = (int) (((long) 0));
												STRUCT_SET(BgL_arg2897z00_2960, BgL_auxz00_31562,
													BgL_arg2898z00_2961);
										}}
										{
											long BgL_iz00_31567;
											obj_t BgL_lz00_31565;

											BgL_lz00_31565 = CDR(BgL_lz00_2956);
											BgL_iz00_31567 = (BgL_iz00_2957 + ((long) 1));
											BgL_iz00_2957 = BgL_iz00_31567;
											BgL_lz00_2956 = BgL_lz00_31565;
											goto BgL_zc3anonymousza32895ze3z83_2958;
										}
									}
							}
						}
						return
							PROCEDURE_ENTRY(BgL_bodyz00_17331) (BgL_bodyz00_17331,
							BgL_sz00_2941, BEOA);
					}
				}
			}
		}
	}



/* &<anonymous:2902> */
	obj_t BGl_z62zc3anonymousza32902ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17333, obj_t BgL_sz00_17337)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 491 */
			{	/* Eval/evaluate_comp.scm 491 */
				long BgL_siza7eza7_17334;
				obj_t BgL_cvalsz00_17335;
				obj_t BgL_bodyz00_17336;

				BgL_siza7eza7_17334 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17333, (int) (((long) 0))));
				BgL_cvalsz00_17335 =
					PROCEDURE_REF(BgL_envz00_17333, (int) (((long) 1)));
				BgL_bodyz00_17336 = PROCEDURE_REF(BgL_envz00_17333, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2966;

					BgL_sz00_2966 = BgL_sz00_17337;
					{	/* Eval/evaluate_comp.scm 491 */
						obj_t BgL_bpz00_2968;

						BgL_bpz00_2968 = VECTOR_REF(BgL_sz00_2966, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 492 */
							long BgL_g1112z00_2969;

							BgL_g1112z00_2969 =
								((long) CINT(BgL_bpz00_2968) + BgL_siza7eza7_17334);
							{
								obj_t BgL_lz00_9990;
								long BgL_iz00_9991;

								BgL_lz00_9990 = BgL_cvalsz00_17335;
								BgL_iz00_9991 = BgL_g1112z00_2969;
							BgL_recz00_9989:
								if (NULLP(BgL_lz00_9990))
									{	/* Eval/evaluate_comp.scm 493 */
										((bool_t) 0);
									}
								else
									{	/* Eval/evaluate_comp.scm 493 */
										{	/* Eval/evaluate_comp.scm 494 */
											obj_t BgL_arg2905z00_9997;

											{	/* Eval/evaluate_comp.scm 189 */
												obj_t BgL_newz00_10003;

												BgL_newz00_10003 =
													create_struct(BGl_symbol5571z00zz__evaluate_compz00,
													(int) (((long) 1)));
												{	/* Llib/struct.scm 162 */
													int BgL_auxz00_31588;

													BgL_auxz00_31588 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_10003, BgL_auxz00_31588,
														BUNSPEC);
												}
												BgL_arg2905z00_9997 = BgL_newz00_10003;
											}
											VECTOR_SET(BgL_sz00_2966,
												(int) (BgL_iz00_9991), BgL_arg2905z00_9997);
										}
										{
											long BgL_iz00_31595;
											obj_t BgL_lz00_31593;

											BgL_lz00_31593 = CDR(BgL_lz00_9990);
											BgL_iz00_31595 = (BgL_iz00_9991 + ((long) 1));
											BgL_iz00_9991 = BgL_iz00_31595;
											BgL_lz00_9990 = BgL_lz00_31593;
											goto BgL_recz00_9989;
										}
									}
							}
						}
						{	/* Eval/evaluate_comp.scm 496 */
							obj_t BgL_rvalsz00_2979;

							if (NULLP(BgL_cvalsz00_17335))
								{	/* Eval/evaluate_comp.scm 496 */
									BgL_rvalsz00_2979 = BNIL;
								}
							else
								{	/* Eval/evaluate_comp.scm 496 */
									obj_t BgL_head1582z00_2993;

									{	/* Eval/evaluate_comp.scm 496 */
										obj_t BgL_res4923z00_10020;

										BgL_res4923z00_10020 = MAKE_PAIR(BNIL, BNIL);
										BgL_head1582z00_2993 = BgL_res4923z00_10020;
									}
									{
										obj_t BgL_l1580z00_10054;
										obj_t BgL_tail1583z00_10055;

										BgL_l1580z00_10054 = BgL_cvalsz00_17335;
										BgL_tail1583z00_10055 = BgL_head1582z00_2993;
									BgL_zc3anonymousza32915ze3z83_10053:
										if (NULLP(BgL_l1580z00_10054))
											{	/* Eval/evaluate_comp.scm 496 */
												BgL_rvalsz00_2979 = CDR(BgL_head1582z00_2993);
											}
										else
											{	/* Eval/evaluate_comp.scm 496 */
												obj_t BgL_newtail1584z00_10062;

												{	/* Eval/evaluate_comp.scm 496 */
													obj_t BgL_arg2918z00_10063;

													{	/* Eval/evaluate_comp.scm 496 */
														obj_t BgL_vz00_10064;

														BgL_vz00_10064 = CAR(BgL_l1580z00_10054);
														BgL_arg2918z00_10063 =
															PROCEDURE_ENTRY(BgL_vz00_10064) (BgL_vz00_10064,
															BgL_sz00_2966, BEOA);
													}
													{	/* Eval/evaluate_comp.scm 496 */
														obj_t BgL_res4929z00_10072;

														BgL_res4929z00_10072 =
															MAKE_PAIR(BgL_arg2918z00_10063, BNIL);
														BgL_newtail1584z00_10062 = BgL_res4929z00_10072;
													}
												}
												SET_CDR(BgL_tail1583z00_10055,
													BgL_newtail1584z00_10062);
												{
													obj_t BgL_tail1583z00_31612;
													obj_t BgL_l1580z00_31610;

													BgL_l1580z00_31610 = CDR(BgL_l1580z00_10054);
													BgL_tail1583z00_31612 = BgL_newtail1584z00_10062;
													BgL_tail1583z00_10055 = BgL_tail1583z00_31612;
													BgL_l1580z00_10054 = BgL_l1580z00_31610;
													goto BgL_zc3anonymousza32915ze3z83_10053;
												}
											}
									}
								}
							{	/* Eval/evaluate_comp.scm 497 */
								long BgL_g1113z00_2980;

								BgL_g1113z00_2980 =
									((long) CINT(BgL_bpz00_2968) + BgL_siza7eza7_17334);
								{
									obj_t BgL_lz00_10120;
									long BgL_iz00_10121;

									BgL_lz00_10120 = BgL_rvalsz00_2979;
									BgL_iz00_10121 = BgL_g1113z00_2980;
								BgL_recz00_10119:
									if (NULLP(BgL_lz00_10120))
										{	/* Eval/evaluate_comp.scm 498 */
											((bool_t) 0);
										}
									else
										{	/* Eval/evaluate_comp.scm 498 */
											{	/* Llib/struct.scm 162 */
												obj_t BgL_auxz00_31622;
												int BgL_auxz00_31620;
												obj_t BgL_auxz00_31617;

												BgL_auxz00_31622 = CAR(BgL_lz00_10120);
												BgL_auxz00_31620 = (int) (((long) 0));
												BgL_auxz00_31617 =
													VECTOR_REF(BgL_sz00_2966, (int) (BgL_iz00_10121));
												STRUCT_SET(BgL_auxz00_31617, BgL_auxz00_31620,
													BgL_auxz00_31622);
											}
											{
												long BgL_iz00_31627;
												obj_t BgL_lz00_31625;

												BgL_lz00_31625 = CDR(BgL_lz00_10120);
												BgL_iz00_31627 = (BgL_iz00_10121 + ((long) 1));
												BgL_iz00_10121 = BgL_iz00_31627;
												BgL_lz00_10120 = BgL_lz00_31625;
												goto BgL_recz00_10119;
											}
										}
								}
							}
							return
								PROCEDURE_ENTRY(BgL_bodyz00_17336) (BgL_bodyz00_17336,
								BgL_sz00_2966, BEOA);
						}
					}
				}
			}
		}
	}



/* &comp-ev_let*1667 */
	obj_t BGl_z62compzd2ev_letza21667z12zz__evaluate_compz00(obj_t
		BgL_envz00_17338, obj_t BgL_ez00_17339, obj_t BgL_stkz00_17340)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 462 */
			{
				BgL_ev_letza2za2_bglt BgL_ez00_2887;
				obj_t BgL_stkz00_2888;

				BgL_ez00_2887 = ((BgL_ev_letza2za2_bglt) BgL_ez00_17339);
				BgL_stkz00_2888 = BgL_stkz00_17340;
				{	/* Eval/evaluate_comp.scm 464 */
					long BgL_siza7eza7_2892;
					obj_t BgL_nstkz00_2893;

					BgL_siza7eza7_2892 = bgl_list_length(BgL_stkz00_2888);
					{	/* Eval/evaluate_comp.scm 464 */
						obj_t BgL_arg2887z00_2929;

						BgL_arg2887z00_2929 =
							(((BgL_ev_binderz00_bglt) CREF(
									((BgL_ev_binderz00_bglt) BgL_ez00_2887)))->BgL_varsz00);
						BgL_nstkz00_2893 =
							BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_2888,
							BgL_arg2887z00_2929);
					}
					{	/* Eval/evaluate_comp.scm 465 */
						obj_t BgL_valsz00_2894;
						obj_t BgL_bodyz00_2895;

						{	/* Eval/evaluate_comp.scm 465 */
							obj_t BgL_l1566z00_2915;

							BgL_l1566z00_2915 =
								(((BgL_ev_binderz00_bglt) CREF(
										((BgL_ev_binderz00_bglt) BgL_ez00_2887)))->BgL_valsz00);
							if (NULLP(BgL_l1566z00_2915))
								{	/* Eval/evaluate_comp.scm 465 */
									BgL_valsz00_2894 = BNIL;
								}
							else
								{	/* Eval/evaluate_comp.scm 465 */
									obj_t BgL_head1568z00_2917;

									{	/* Eval/evaluate_comp.scm 465 */
										obj_t BgL_res4886z00_9707;

										BgL_res4886z00_9707 = MAKE_PAIR(BNIL, BNIL);
										BgL_head1568z00_2917 = BgL_res4886z00_9707;
									}
									{
										obj_t BgL_l1566z00_9741;
										obj_t BgL_tail1569z00_9742;

										BgL_l1566z00_9741 = BgL_l1566z00_2915;
										BgL_tail1569z00_9742 = BgL_head1568z00_2917;
									BgL_zc3anonymousza32881ze3z83_9740:
										if (NULLP(BgL_l1566z00_9741))
											{	/* Eval/evaluate_comp.scm 465 */
												BgL_valsz00_2894 = CDR(BgL_head1568z00_2917);
											}
										else
											{	/* Eval/evaluate_comp.scm 465 */
												obj_t BgL_newtail1570z00_9749;

												{	/* Eval/evaluate_comp.scm 465 */
													obj_t BgL_arg2885z00_9750;

													{	/* Eval/evaluate_comp.scm 465 */
														obj_t BgL_vz00_9751;

														BgL_vz00_9751 = CAR(BgL_l1566z00_9741);
														BgL_arg2885z00_9750 =
															BGl_compz00zz__evaluate_compz00(
															((BgL_ev_exprz00_bglt) BgL_vz00_9751),
															BgL_nstkz00_2893);
													}
													{	/* Eval/evaluate_comp.scm 465 */
														obj_t BgL_res4892z00_9759;

														BgL_res4892z00_9759 =
															MAKE_PAIR(BgL_arg2885z00_9750, BNIL);
														BgL_newtail1570z00_9749 = BgL_res4892z00_9759;
													}
												}
												SET_CDR(BgL_tail1569z00_9742, BgL_newtail1570z00_9749);
												{
													obj_t BgL_tail1569z00_31652;
													obj_t BgL_l1566z00_31650;

													BgL_l1566z00_31650 = CDR(BgL_l1566z00_9741);
													BgL_tail1569z00_31652 = BgL_newtail1570z00_9749;
													BgL_tail1569z00_9742 = BgL_tail1569z00_31652;
													BgL_l1566z00_9741 = BgL_l1566z00_31650;
													goto BgL_zc3anonymousza32881ze3z83_9740;
												}
											}
									}
								}
						}
						{	/* Eval/evaluate_comp.scm 466 */
							BgL_ev_exprz00_bglt BgL_arg2886z00_2928;

							BgL_arg2886z00_2928 =
								(((BgL_ev_binderz00_bglt) CREF(
										((BgL_ev_binderz00_bglt) BgL_ez00_2887)))->BgL_bodyz00);
							BgL_bodyz00_2895 =
								BGl_compz00zz__evaluate_compz00(BgL_arg2886z00_2928,
								BgL_nstkz00_2893);
						}
						{	/* Eval/evaluate_comp.scm 467 */
							obj_t BgL_zc3anonymousza32870ze3z83_16281;

							BgL_zc3anonymousza32870ze3z83_16281 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3anonymousza32870ze3ze1zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_zc3anonymousza32870ze3z83_16281,
								(int) (((long) 0)), BINT(BgL_siza7eza7_2892));
							PROCEDURE_SET(BgL_zc3anonymousza32870ze3z83_16281,
								(int) (((long) 1)), ((obj_t) BgL_ez00_2887));
							PROCEDURE_SET(BgL_zc3anonymousza32870ze3z83_16281,
								(int) (((long) 2)), BgL_valsz00_2894);
							PROCEDURE_SET(BgL_zc3anonymousza32870ze3z83_16281,
								(int) (((long) 3)), BgL_bodyz00_2895);
							return BgL_zc3anonymousza32870ze3z83_16281;
						}
					}
				}
			}
		}
	}



/* &<anonymous:2870> */
	obj_t BGl_z62zc3anonymousza32870ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17341, obj_t BgL_sz00_17346)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 467 */
			{	/* Eval/evaluate_comp.scm 467 */
				long BgL_siza7eza7_17342;
				BgL_ev_letza2za2_bglt BgL_i1107z00_17343;
				obj_t BgL_valsz00_17344;
				obj_t BgL_bodyz00_17345;

				BgL_siza7eza7_17342 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17341, (int) (((long) 0))));
				BgL_i1107z00_17343 =
					((BgL_ev_letza2za2_bglt)
					PROCEDURE_REF(BgL_envz00_17341, (int) (((long) 1))));
				BgL_valsz00_17344 = PROCEDURE_REF(BgL_envz00_17341, (int) (((long) 2)));
				BgL_bodyz00_17345 = PROCEDURE_REF(BgL_envz00_17341, (int) (((long) 3)));
				{
					obj_t BgL_sz00_2896;

					BgL_sz00_2896 = BgL_sz00_17346;
					{	/* Eval/evaluate_comp.scm 467 */
						obj_t BgL_bpz00_2898;

						BgL_bpz00_2898 = VECTOR_REF(BgL_sz00_2896, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 468 */
							long BgL_g1108z00_2899;

							BgL_g1108z00_2899 =
								((long) CINT(BgL_bpz00_2898) + BgL_siza7eza7_17342);
							{
								obj_t BgL_lz00_2902;
								long BgL_iz00_2903;
								obj_t BgL_bza2za2_2904;

								BgL_lz00_2902 = BgL_valsz00_17344;
								BgL_iz00_2903 = BgL_g1108z00_2899;
								BgL_bza2za2_2904 =
									(((BgL_ev_letza2za2_bglt) CREF(BgL_i1107z00_17343))->
									BgL_boxesz00);
							BgL_zc3anonymousza32872ze3z83_2905:
								if (NULLP(BgL_lz00_2902))
									{	/* Eval/evaluate_comp.scm 469 */
										((bool_t) 0);
									}
								else
									{	/* Eval/evaluate_comp.scm 469 */
										{	/* Eval/evaluate_comp.scm 470 */
											obj_t BgL_valz00_2907;

											{	/* Eval/evaluate_comp.scm 470 */
												obj_t BgL_fun2876z00_2910;

												BgL_fun2876z00_2910 = CAR(BgL_lz00_2902);
												BgL_valz00_2907 =
													PROCEDURE_ENTRY(BgL_fun2876z00_2910)
													(BgL_fun2876z00_2910, BgL_sz00_2896, BEOA);
											}
											{	/* Eval/evaluate_comp.scm 471 */
												obj_t BgL_arg2874z00_2908;

												{	/* Eval/evaluate_comp.scm 471 */
													bool_t BgL_testz00_31691;

													{	/* Eval/evaluate_comp.scm 471 */
														obj_t BgL_pairz00_9771;

														BgL_pairz00_9771 = BgL_bza2za2_2904;
														BgL_testz00_31691 = CBOOL(CAR(BgL_pairz00_9771));
													}
													if (BgL_testz00_31691)
														{	/* Eval/evaluate_comp.scm 189 */
															obj_t BgL_newz00_9773;

															BgL_newz00_9773 =
																create_struct
																(BGl_symbol5571z00zz__evaluate_compz00,
																(int) (((long) 1)));
															{	/* Llib/struct.scm 162 */
																int BgL_auxz00_31696;

																BgL_auxz00_31696 = (int) (((long) 0));
																STRUCT_SET(BgL_newz00_9773, BgL_auxz00_31696,
																	BgL_valz00_2907);
															}
															BgL_arg2874z00_2908 = BgL_newz00_9773;
														}
													else
														{	/* Eval/evaluate_comp.scm 471 */
															BgL_arg2874z00_2908 = BgL_valz00_2907;
														}
												}
												VECTOR_SET(BgL_sz00_2896,
													(int) (BgL_iz00_2903), BgL_arg2874z00_2908);
										}}
										{
											obj_t BgL_bza2za2_31705;
											long BgL_iz00_31703;
											obj_t BgL_lz00_31701;

											BgL_lz00_31701 = CDR(BgL_lz00_2902);
											BgL_iz00_31703 = (BgL_iz00_2903 + ((long) 1));
											BgL_bza2za2_31705 = CDR(BgL_bza2za2_2904);
											BgL_bza2za2_2904 = BgL_bza2za2_31705;
											BgL_iz00_2903 = BgL_iz00_31703;
											BgL_lz00_2902 = BgL_lz00_31701;
											goto BgL_zc3anonymousza32872ze3z83_2905;
										}
									}
							}
						}
						return
							PROCEDURE_ENTRY(BgL_bodyz00_17345) (BgL_bodyz00_17345,
							BgL_sz00_2896, BEOA);
					}
				}
			}
		}
	}



/* &comp-ev_let1665 */
	obj_t BGl_z62compzd2ev_let1665zb0zz__evaluate_compz00(obj_t BgL_envz00_17347,
		obj_t BgL_ez00_17348, obj_t BgL_stkz00_17349)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 443 */
			{
				BgL_ev_letz00_bglt BgL_ez00_2836;
				obj_t BgL_stkz00_2837;

				BgL_ez00_2836 = ((BgL_ev_letz00_bglt) BgL_ez00_17348);
				BgL_stkz00_2837 = BgL_stkz00_17349;
				{	/* Eval/evaluate_comp.scm 445 */
					long BgL_siza7eza7_2841;
					obj_t BgL_nstkz00_2842;

					BgL_siza7eza7_2841 = bgl_list_length(BgL_stkz00_2837);
					{	/* Eval/evaluate_comp.scm 445 */
						obj_t BgL_arg2869z00_2885;

						BgL_arg2869z00_2885 =
							(((BgL_ev_binderz00_bglt) CREF(
									((BgL_ev_binderz00_bglt) BgL_ez00_2836)))->BgL_varsz00);
						BgL_nstkz00_2842 =
							BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_2837,
							BgL_arg2869z00_2885);
					}
					{	/* Eval/evaluate_comp.scm 446 */
						obj_t BgL_valsz00_2843;
						obj_t BgL_iboxesz00_2844;
						obj_t BgL_bodyz00_2845;

						{	/* Eval/evaluate_comp.scm 447 */
							obj_t BgL_arg2862z00_2870;

							BgL_arg2862z00_2870 =
								(((BgL_ev_binderz00_bglt) CREF(
										((BgL_ev_binderz00_bglt) BgL_ez00_2836)))->BgL_valsz00);
							BgL_valsz00_2843 =
								BGl_compzd2withzd2pushz00zz__evaluate_compz00
								(BgL_arg2862z00_2870, BgL_stkz00_2837);
						}
						{	/* Eval/evaluate_comp.scm 448 */
							obj_t BgL_l1561z00_2871;

							BgL_l1561z00_2871 =
								(((BgL_ev_letz00_bglt) CREF(BgL_ez00_2836))->BgL_boxesz00);
							if (NULLP(BgL_l1561z00_2871))
								{	/* Eval/evaluate_comp.scm 448 */
									BgL_iboxesz00_2844 = BNIL;
								}
							else
								{	/* Eval/evaluate_comp.scm 448 */
									obj_t BgL_head1563z00_2873;

									{	/* Eval/evaluate_comp.scm 448 */
										obj_t BgL_res4869z00_9568;

										BgL_res4869z00_9568 = MAKE_PAIR(BNIL, BNIL);
										BgL_head1563z00_2873 = BgL_res4869z00_9568;
									}
									{
										obj_t BgL_l1561z00_9602;
										obj_t BgL_tail1564z00_9603;

										BgL_l1561z00_9602 = BgL_l1561z00_2871;
										BgL_tail1564z00_9603 = BgL_head1563z00_2873;
									BgL_zc3anonymousza32864ze3z83_9601:
										if (NULLP(BgL_l1561z00_9602))
											{	/* Eval/evaluate_comp.scm 448 */
												BgL_iboxesz00_2844 = CDR(BgL_head1563z00_2873);
											}
										else
											{	/* Eval/evaluate_comp.scm 448 */
												obj_t BgL_newtail1565z00_9610;

												{	/* Eval/evaluate_comp.scm 448 */
													obj_t BgL_arg2867z00_9611;

													BgL_arg2867z00_9611 =
														BGl__indexz00zz__evaluate_compz00(CAR
														(BgL_l1561z00_9602), BgL_nstkz00_2842);
													{	/* Eval/evaluate_comp.scm 448 */
														obj_t BgL_res4875z00_9620;

														BgL_res4875z00_9620 =
															MAKE_PAIR(BgL_arg2867z00_9611, BNIL);
														BgL_newtail1565z00_9610 = BgL_res4875z00_9620;
													}
												}
												SET_CDR(BgL_tail1564z00_9603, BgL_newtail1565z00_9610);
												{
													obj_t BgL_tail1564z00_31732;
													obj_t BgL_l1561z00_31730;

													BgL_l1561z00_31730 = CDR(BgL_l1561z00_9602);
													BgL_tail1564z00_31732 = BgL_newtail1565z00_9610;
													BgL_tail1564z00_9603 = BgL_tail1564z00_31732;
													BgL_l1561z00_9602 = BgL_l1561z00_31730;
													goto BgL_zc3anonymousza32864ze3z83_9601;
												}
											}
									}
								}
						}
						{	/* Eval/evaluate_comp.scm 449 */
							BgL_ev_exprz00_bglt BgL_arg2868z00_2884;

							BgL_arg2868z00_2884 =
								(((BgL_ev_binderz00_bglt) CREF(
										((BgL_ev_binderz00_bglt) BgL_ez00_2836)))->BgL_bodyz00);
							BgL_bodyz00_2845 =
								BGl_compz00zz__evaluate_compz00(BgL_arg2868z00_2884,
								BgL_nstkz00_2842);
						}
						{	/* Eval/evaluate_comp.scm 450 */
							obj_t BgL_zc3anonymousza32849ze3z83_16283;

							BgL_zc3anonymousza32849ze3z83_16283 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3anonymousza32849ze3ze1zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_zc3anonymousza32849ze3z83_16283,
								(int) (((long) 0)), BINT(BgL_siza7eza7_2841));
							PROCEDURE_SET(BgL_zc3anonymousza32849ze3z83_16283,
								(int) (((long) 1)), BgL_valsz00_2843);
							PROCEDURE_SET(BgL_zc3anonymousza32849ze3z83_16283,
								(int) (((long) 2)), BgL_iboxesz00_2844);
							PROCEDURE_SET(BgL_zc3anonymousza32849ze3z83_16283,
								(int) (((long) 3)), BgL_bodyz00_2845);
							return BgL_zc3anonymousza32849ze3z83_16283;
						}
					}
				}
			}
		}
	}



/* &<anonymous:2849> */
	obj_t BGl_z62zc3anonymousza32849ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17350, obj_t BgL_sz00_17355)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 450 */
			{	/* Eval/evaluate_comp.scm 450 */
				long BgL_siza7eza7_17351;
				obj_t BgL_valsz00_17352;
				obj_t BgL_iboxesz00_17353;
				obj_t BgL_bodyz00_17354;

				BgL_siza7eza7_17351 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_17350, (int) (((long) 0))));
				BgL_valsz00_17352 =
					((obj_t) PROCEDURE_REF(BgL_envz00_17350, (int) (((long) 1))));
				BgL_iboxesz00_17353 =
					PROCEDURE_REF(BgL_envz00_17350, (int) (((long) 2)));
				BgL_bodyz00_17354 = PROCEDURE_REF(BgL_envz00_17350, (int) (((long) 3)));
				{
					obj_t BgL_sz00_2846;

					BgL_sz00_2846 = BgL_sz00_17355;
					{	/* Eval/evaluate_comp.scm 450 */
						obj_t BgL_bpz00_2848;

						BgL_bpz00_2848 = VECTOR_REF(BgL_sz00_2846, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 451 */
							long BgL_g1106z00_2849;

							BgL_g1106z00_2849 =
								((long) CINT(BgL_bpz00_2848) + BgL_siza7eza7_17351);
							{
								obj_t BgL_lz00_9662;
								long BgL_iz00_9663;

								BgL_lz00_9662 = BgL_valsz00_17352;
								BgL_iz00_9663 = BgL_g1106z00_2849;
							BgL_recz00_9661:
								if (NULLP(BgL_lz00_9662))
									{	/* Eval/evaluate_comp.scm 452 */
										((bool_t) 0);
									}
								else
									{	/* Eval/evaluate_comp.scm 452 */
										{	/* Eval/evaluate_comp.scm 453 */
											obj_t BgL_arg2852z00_9670;

											{	/* Eval/evaluate_comp.scm 453 */
												obj_t BgL_fun2853z00_9671;

												BgL_fun2853z00_9671 = CAR(BgL_lz00_9662);
												BgL_arg2852z00_9670 =
													PROCEDURE_ENTRY(BgL_fun2853z00_9671)
													(BgL_fun2853z00_9671, BgL_sz00_2846, BEOA);
											}
											VECTOR_SET(BgL_sz00_2846,
												(int) (BgL_iz00_9663), BgL_arg2852z00_9670);
										}
										{
											long BgL_iz00_31774;
											obj_t BgL_lz00_31772;

											BgL_lz00_31772 = CDR(BgL_lz00_9662);
											BgL_iz00_31774 = (BgL_iz00_9663 + ((long) 1));
											BgL_iz00_9663 = BgL_iz00_31774;
											BgL_lz00_9662 = BgL_lz00_31772;
											goto BgL_recz00_9661;
										}
									}
							}
						}
						{
							obj_t BgL_lz00_2861;

							BgL_lz00_2861 = BgL_iboxesz00_17353;
						BgL_zc3anonymousza32856ze3z83_2862:
							if (NULLP(BgL_lz00_2861))
								{	/* Eval/evaluate_comp.scm 456 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 456 */
									{	/* Eval/evaluate_comp.scm 457 */
										long BgL_iz00_2864;

										{	/* Ieee/fixnum.scm 919 */
											long BgL_auxz00_31778;

											{	/* Eval/evaluate_comp.scm 457 */
												obj_t BgL_pairz00_9686;

												BgL_pairz00_9686 = BgL_lz00_2861;
												BgL_auxz00_31778 = (long) CINT(CAR(BgL_pairz00_9686));
											}
											BgL_iz00_2864 =
												((long) CINT(BgL_bpz00_2848) + BgL_auxz00_31778);
										}
										{	/* Eval/evaluate_comp.scm 458 */
											obj_t BgL_arg2858z00_2865;

											{	/* Eval/evaluate_comp.scm 458 */
												obj_t BgL_arg2859z00_2866;

												BgL_arg2859z00_2866 =
													VECTOR_REF(BgL_sz00_2846, (int) (BgL_iz00_2864));
												{	/* Eval/evaluate_comp.scm 189 */
													obj_t BgL_newz00_9693;

													BgL_newz00_9693 =
														create_struct(BGl_symbol5571z00zz__evaluate_compz00,
														(int) (((long) 1)));
													{	/* Llib/struct.scm 162 */
														int BgL_auxz00_31787;

														BgL_auxz00_31787 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_9693, BgL_auxz00_31787,
															BgL_arg2859z00_2866);
													}
													BgL_arg2858z00_2865 = BgL_newz00_9693;
											}}
											VECTOR_SET(BgL_sz00_2846,
												(int) (BgL_iz00_2864), BgL_arg2858z00_2865);
									}}
									{
										obj_t BgL_lz00_31792;

										BgL_lz00_31792 = CDR(BgL_lz00_2861);
										BgL_lz00_2861 = BgL_lz00_31792;
										goto BgL_zc3anonymousza32856ze3z83_2862;
									}
								}
						}
						return
							PROCEDURE_ENTRY(BgL_bodyz00_17354) (BgL_bodyz00_17354,
							BgL_sz00_2846, BEOA);
					}
				}
			}
		}
	}



/* &comp-ev_prog21663 */
	obj_t BGl_z62compzd2ev_prog21663zb0zz__evaluate_compz00(obj_t
		BgL_envz00_17356, obj_t BgL_ez00_17357, obj_t BgL_stkz00_17358)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 437 */
			{
				BgL_ev_prog2z00_bglt BgL_ez00_2823;
				obj_t BgL_stkz00_2824;

				BgL_ez00_2823 = ((BgL_ev_prog2z00_bglt) BgL_ez00_17357);
				BgL_stkz00_2824 = BgL_stkz00_17358;
				{	/* Eval/evaluate_comp.scm 439 */
					obj_t BgL_e1z00_2828;
					obj_t BgL_e2z00_2829;

					BgL_e1z00_2828 =
						BGl_compz00zz__evaluate_compz00(
						(((BgL_ev_prog2z00_bglt) CREF(BgL_ez00_2823))->BgL_e1z00),
						BgL_stkz00_2824);
					BgL_e2z00_2829 =
						BGl_compz00zz__evaluate_compz00((((BgL_ev_prog2z00_bglt)
								CREF(BgL_ez00_2823))->BgL_e2z00), BgL_stkz00_2824);
					{	/* Eval/evaluate_comp.scm 440 */
						obj_t BgL_zc3anonymousza32846ze3z83_16285;

						BgL_zc3anonymousza32846ze3z83_16285 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza32846ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 2)));
						PROCEDURE_SET(BgL_zc3anonymousza32846ze3z83_16285,
							(int) (((long) 0)), BgL_e1z00_2828);
						PROCEDURE_SET(BgL_zc3anonymousza32846ze3z83_16285,
							(int) (((long) 1)), BgL_e2z00_2829);
						return BgL_zc3anonymousza32846ze3z83_16285;
					}
				}
			}
		}
	}



/* &<anonymous:2846> */
	obj_t BGl_z62zc3anonymousza32846ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17359, obj_t BgL_sz00_17362)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 440 */
			{	/* Eval/evaluate_comp.scm 440 */
				obj_t BgL_e1z00_17360;
				obj_t BgL_e2z00_17361;

				BgL_e1z00_17360 = PROCEDURE_REF(BgL_envz00_17359, (int) (((long) 0)));
				BgL_e2z00_17361 = PROCEDURE_REF(BgL_envz00_17359, (int) (((long) 1)));
				{
					obj_t BgL_sz00_2830;

					BgL_sz00_2830 = BgL_sz00_17362;
					{	/* Eval/evaluate_comp.scm 440 */
						obj_t BgL_bpz00_9561;

						BgL_bpz00_9561 = VECTOR_REF(BgL_sz00_2830, (int) (((long) 0)));
						PROCEDURE_ENTRY(BgL_e1z00_17360) (BgL_e1z00_17360, BgL_sz00_2830,
							BEOA);
						return PROCEDURE_ENTRY(BgL_e2z00_17361) (BgL_e2z00_17361,
							BgL_sz00_2830, BEOA);
					}
				}
			}
		}
	}



/* &comp-ev_and1661 */
	obj_t BGl_z62compzd2ev_and1661zb0zz__evaluate_compz00(obj_t BgL_envz00_17363,
		obj_t BgL_ez00_17364, obj_t BgL_stkz00_17365)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 427 */
			{
				BgL_ev_andz00_bglt BgL_ez00_2790;
				obj_t BgL_stkz00_2791;

				BgL_ez00_2790 = ((BgL_ev_andz00_bglt) BgL_ez00_17364);
				BgL_stkz00_2791 = BgL_stkz00_17365;
				{	/* Eval/evaluate_comp.scm 429 */
					obj_t BgL_argsz00_2795;

					{	/* Eval/evaluate_comp.scm 429 */
						obj_t BgL_l1556z00_2809;

						BgL_l1556z00_2809 =
							(((BgL_ev_listz00_bglt) CREF(
									((BgL_ev_listz00_bglt) BgL_ez00_2790)))->BgL_argsz00);
						if (NULLP(BgL_l1556z00_2809))
							{	/* Eval/evaluate_comp.scm 429 */
								BgL_argsz00_2795 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 429 */
								obj_t BgL_head1558z00_2811;

								{	/* Eval/evaluate_comp.scm 429 */
									obj_t BgL_res4858z00_9466;

									BgL_res4858z00_9466 = MAKE_PAIR(BNIL, BNIL);
									BgL_head1558z00_2811 = BgL_res4858z00_9466;
								}
								{
									obj_t BgL_l1556z00_9500;
									obj_t BgL_tail1559z00_9501;

									BgL_l1556z00_9500 = BgL_l1556z00_2809;
									BgL_tail1559z00_9501 = BgL_head1558z00_2811;
								BgL_zc3anonymousza32842ze3z83_9499:
									if (NULLP(BgL_l1556z00_9500))
										{	/* Eval/evaluate_comp.scm 429 */
											BgL_argsz00_2795 = CDR(BgL_head1558z00_2811);
										}
									else
										{	/* Eval/evaluate_comp.scm 429 */
											obj_t BgL_newtail1560z00_9508;

											{	/* Eval/evaluate_comp.scm 429 */
												obj_t BgL_arg2845z00_9509;

												{	/* Eval/evaluate_comp.scm 429 */
													obj_t BgL_ez00_9510;

													BgL_ez00_9510 = CAR(BgL_l1556z00_9500);
													BgL_arg2845z00_9509 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_ez00_9510),
														BgL_stkz00_2791);
												}
												{	/* Eval/evaluate_comp.scm 429 */
													obj_t BgL_res4864z00_9518;

													BgL_res4864z00_9518 =
														MAKE_PAIR(BgL_arg2845z00_9509, BNIL);
													BgL_newtail1560z00_9508 = BgL_res4864z00_9518;
												}
											}
											SET_CDR(BgL_tail1559z00_9501, BgL_newtail1560z00_9508);
											{
												obj_t BgL_tail1559z00_31839;
												obj_t BgL_l1556z00_31837;

												BgL_l1556z00_31837 = CDR(BgL_l1556z00_9500);
												BgL_tail1559z00_31839 = BgL_newtail1560z00_9508;
												BgL_tail1559z00_9501 = BgL_tail1559z00_31839;
												BgL_l1556z00_9500 = BgL_l1556z00_31837;
												goto BgL_zc3anonymousza32842ze3z83_9499;
											}
										}
								}
							}
					}
					{	/* Eval/evaluate_comp.scm 430 */
						obj_t BgL_zc3anonymousza32836ze3z83_16287;

						BgL_zc3anonymousza32836ze3z83_16287 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza32836ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 1)));
						PROCEDURE_SET(BgL_zc3anonymousza32836ze3z83_16287,
							(int) (((long) 0)), BgL_argsz00_2795);
						return BgL_zc3anonymousza32836ze3z83_16287;
					}
				}
			}
		}
	}



/* &<anonymous:2836> */
	obj_t BGl_z62zc3anonymousza32836ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17366, obj_t BgL_sz00_17368)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 430 */
			{	/* Eval/evaluate_comp.scm 430 */
				obj_t BgL_argsz00_17367;

				BgL_argsz00_17367 = PROCEDURE_REF(BgL_envz00_17366, (int) (((long) 0)));
				{
					obj_t BgL_sz00_2796;

					BgL_sz00_2796 = BgL_sz00_17368;
					{	/* Eval/evaluate_comp.scm 430 */
						obj_t BgL_bpz00_2798;

						BgL_bpz00_2798 = VECTOR_REF(BgL_sz00_2796, (int) (((long) 0)));
						{
							obj_t BgL_lz00_9545;
							obj_t BgL_rz00_9546;

							BgL_lz00_9545 = BgL_argsz00_17367;
							BgL_rz00_9546 = BTRUE;
						BgL_recz00_9544:
							if (NULLP(BgL_lz00_9545))
								{	/* Eval/evaluate_comp.scm 432 */
									return BgL_rz00_9546;
								}
							else
								{	/* Eval/evaluate_comp.scm 434 */
									obj_t BgL_vz00_9553;

									{	/* Eval/evaluate_comp.scm 434 */
										obj_t BgL_fun2840z00_9554;

										BgL_fun2840z00_9554 = CAR(BgL_lz00_9545);
										BgL_vz00_9553 =
											PROCEDURE_ENTRY(BgL_fun2840z00_9554) (BgL_fun2840z00_9554,
											BgL_sz00_2796, BEOA);
									}
									if (CBOOL(BgL_vz00_9553))
										{
											obj_t BgL_rz00_31861;
											obj_t BgL_lz00_31859;

											BgL_lz00_31859 = CDR(BgL_lz00_9545);
											BgL_rz00_31861 = BgL_vz00_9553;
											BgL_rz00_9546 = BgL_rz00_31861;
											BgL_lz00_9545 = BgL_lz00_31859;
											goto BgL_recz00_9544;
										}
									else
										{	/* Eval/evaluate_comp.scm 435 */
											return BFALSE;
										}
								}
						}
					}
				}
			}
		}
	}



/* &comp-ev_or1659 */
	obj_t BGl_z62compzd2ev_or1659zb0zz__evaluate_compz00(obj_t BgL_envz00_17369,
		obj_t BgL_ez00_17370, obj_t BgL_stkz00_17371)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 418 */
			{
				BgL_ev_orz00_bglt BgL_ez00_2759;
				obj_t BgL_stkz00_2760;

				BgL_ez00_2759 = ((BgL_ev_orz00_bglt) BgL_ez00_17370);
				BgL_stkz00_2760 = BgL_stkz00_17371;
				{	/* Eval/evaluate_comp.scm 420 */
					obj_t BgL_argsz00_2764;

					{	/* Eval/evaluate_comp.scm 420 */
						obj_t BgL_l1551z00_2776;

						BgL_l1551z00_2776 =
							(((BgL_ev_listz00_bglt) CREF(
									((BgL_ev_listz00_bglt) BgL_ez00_2759)))->BgL_argsz00);
						if (NULLP(BgL_l1551z00_2776))
							{	/* Eval/evaluate_comp.scm 420 */
								BgL_argsz00_2764 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 420 */
								obj_t BgL_head1553z00_2778;

								{	/* Eval/evaluate_comp.scm 420 */
									obj_t BgL_res4849z00_9400;

									BgL_res4849z00_9400 = MAKE_PAIR(BNIL, BNIL);
									BgL_head1553z00_2778 = BgL_res4849z00_9400;
								}
								{
									obj_t BgL_l1551z00_9434;
									obj_t BgL_tail1554z00_9435;

									BgL_l1551z00_9434 = BgL_l1551z00_2776;
									BgL_tail1554z00_9435 = BgL_head1553z00_2778;
								BgL_zc3anonymousza32832ze3z83_9433:
									if (NULLP(BgL_l1551z00_9434))
										{	/* Eval/evaluate_comp.scm 420 */
											BgL_argsz00_2764 = CDR(BgL_head1553z00_2778);
										}
									else
										{	/* Eval/evaluate_comp.scm 420 */
											obj_t BgL_newtail1555z00_9442;

											{	/* Eval/evaluate_comp.scm 420 */
												obj_t BgL_arg2835z00_9443;

												{	/* Eval/evaluate_comp.scm 420 */
													obj_t BgL_ez00_9444;

													BgL_ez00_9444 = CAR(BgL_l1551z00_9434);
													BgL_arg2835z00_9443 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_ez00_9444),
														BgL_stkz00_2760);
												}
												{	/* Eval/evaluate_comp.scm 420 */
													obj_t BgL_res4855z00_9452;

													BgL_res4855z00_9452 =
														MAKE_PAIR(BgL_arg2835z00_9443, BNIL);
													BgL_newtail1555z00_9442 = BgL_res4855z00_9452;
												}
											}
											SET_CDR(BgL_tail1554z00_9435, BgL_newtail1555z00_9442);
											{
												obj_t BgL_tail1554z00_31877;
												obj_t BgL_l1551z00_31875;

												BgL_l1551z00_31875 = CDR(BgL_l1551z00_9434);
												BgL_tail1554z00_31877 = BgL_newtail1555z00_9442;
												BgL_tail1554z00_9435 = BgL_tail1554z00_31877;
												BgL_l1551z00_9434 = BgL_l1551z00_31875;
												goto BgL_zc3anonymousza32832ze3z83_9433;
											}
										}
								}
							}
					}
					{	/* Eval/evaluate_comp.scm 421 */
						obj_t BgL_zc3anonymousza32826ze3z83_16289;

						BgL_zc3anonymousza32826ze3z83_16289 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza32826ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 1)));
						PROCEDURE_SET(BgL_zc3anonymousza32826ze3z83_16289,
							(int) (((long) 0)), BgL_argsz00_2764);
						return BgL_zc3anonymousza32826ze3z83_16289;
					}
				}
			}
		}
	}



/* &<anonymous:2826> */
	obj_t BGl_z62zc3anonymousza32826ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17372, obj_t BgL_sz00_17374)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 421 */
			{	/* Eval/evaluate_comp.scm 421 */
				obj_t BgL_argsz00_17373;

				BgL_argsz00_17373 = PROCEDURE_REF(BgL_envz00_17372, (int) (((long) 0)));
				{
					obj_t BgL_sz00_2765;

					BgL_sz00_2765 = BgL_sz00_17374;
					{	/* Eval/evaluate_comp.scm 421 */
						obj_t BgL_bpz00_2767;

						BgL_bpz00_2767 = VECTOR_REF(BgL_sz00_2765, (int) (((long) 0)));
						{
							obj_t BgL_lz00_2769;

							BgL_lz00_2769 = BgL_argsz00_17373;
						BgL_zc3anonymousza32827ze3z83_2770:
							if (NULLP(BgL_lz00_2769))
								{	/* Eval/evaluate_comp.scm 423 */
									return BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 425 */
									obj_t BgL__ortest_1101z00_2772;

									{	/* Eval/evaluate_comp.scm 425 */
										obj_t BgL_fun2830z00_2774;

										BgL_fun2830z00_2774 = CAR(BgL_lz00_2769);
										BgL__ortest_1101z00_2772 =
											PROCEDURE_ENTRY(BgL_fun2830z00_2774) (BgL_fun2830z00_2774,
											BgL_sz00_2765, BEOA);
									}
									if (CBOOL(BgL__ortest_1101z00_2772))
										{	/* Eval/evaluate_comp.scm 425 */
											return BgL__ortest_1101z00_2772;
										}
									else
										{
											obj_t BgL_lz00_31897;

											BgL_lz00_31897 = CDR(BgL_lz00_2769);
											BgL_lz00_2769 = BgL_lz00_31897;
											goto BgL_zc3anonymousza32827ze3z83_2770;
										}
								}
						}
					}
				}
			}
		}
	}



/* &comp-ev_if1656 */
	obj_t BGl_z62compzd2ev_if1656zb0zz__evaluate_compz00(obj_t BgL_envz00_17375,
		obj_t BgL_ez00_17376, obj_t BgL_stkz00_17377)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 412 */
			{
				BgL_ev_ifz00_bglt BgL_ez00_2743;
				obj_t BgL_stkz00_2744;

				BgL_ez00_2743 = ((BgL_ev_ifz00_bglt) BgL_ez00_17376);
				BgL_stkz00_2744 = BgL_stkz00_17377;
				{	/* Eval/evaluate_comp.scm 414 */
					obj_t BgL_pz00_2748;
					obj_t BgL_tz00_2749;
					obj_t BgL_ez00_2750;

					BgL_pz00_2748 =
						BGl_compz00zz__evaluate_compz00(
						(((BgL_ev_ifz00_bglt) CREF(BgL_ez00_2743))->BgL_pz00),
						BgL_stkz00_2744);
					BgL_tz00_2749 =
						BGl_compz00zz__evaluate_compz00((((BgL_ev_ifz00_bglt)
								CREF(BgL_ez00_2743))->BgL_tz00), BgL_stkz00_2744);
					BgL_ez00_2750 =
						BGl_compz00zz__evaluate_compz00((((BgL_ev_ifz00_bglt)
								CREF(BgL_ez00_2743))->BgL_ez00), BgL_stkz00_2744);
					{	/* Eval/evaluate_comp.scm 415 */
						obj_t BgL_zc3anonymousza32820ze3z83_16291;

						BgL_zc3anonymousza32820ze3z83_16291 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza32820ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 3)));
						PROCEDURE_SET(BgL_zc3anonymousza32820ze3z83_16291,
							(int) (((long) 0)), BgL_ez00_2750);
						PROCEDURE_SET(BgL_zc3anonymousza32820ze3z83_16291,
							(int) (((long) 1)), BgL_tz00_2749);
						PROCEDURE_SET(BgL_zc3anonymousza32820ze3z83_16291,
							(int) (((long) 2)), BgL_pz00_2748);
						return BgL_zc3anonymousza32820ze3z83_16291;
					}
				}
			}
		}
	}



/* &<anonymous:2820> */
	obj_t BGl_z62zc3anonymousza32820ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17378, obj_t BgL_sz00_17382)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 415 */
			{	/* Eval/evaluate_comp.scm 415 */
				obj_t BgL_ez00_17379;
				obj_t BgL_tz00_17380;
				obj_t BgL_pz00_17381;

				BgL_ez00_17379 = PROCEDURE_REF(BgL_envz00_17378, (int) (((long) 0)));
				BgL_tz00_17380 = PROCEDURE_REF(BgL_envz00_17378, (int) (((long) 1)));
				BgL_pz00_17381 = PROCEDURE_REF(BgL_envz00_17378, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2751;

					BgL_sz00_2751 = BgL_sz00_17382;
					{	/* Eval/evaluate_comp.scm 415 */
						obj_t BgL_bpz00_9392;

						BgL_bpz00_9392 = VECTOR_REF(BgL_sz00_2751, (int) (((long) 0)));
						if (CBOOL(PROCEDURE_ENTRY(BgL_pz00_17381) (BgL_pz00_17381,
									BgL_sz00_2751, BEOA)))
							{	/* Eval/evaluate_comp.scm 416 */
								return
									PROCEDURE_ENTRY(BgL_tz00_17380) (BgL_tz00_17380,
									BgL_sz00_2751, BEOA);
							}
						else
							{	/* Eval/evaluate_comp.scm 416 */
								return
									PROCEDURE_ENTRY(BgL_ez00_17379) (BgL_ez00_17379,
									BgL_sz00_2751, BEOA);
							}
					}
				}
			}
		}
	}



/* &comp-ev_litt1654 */
	obj_t BGl_z62compzd2ev_litt1654zb0zz__evaluate_compz00(obj_t BgL_envz00_17383,
		obj_t BgL_ez00_17384, obj_t BgL_stkz00_17385)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 407 */
			{
				BgL_ev_littz00_bglt BgL_ez00_2734;
				obj_t BgL_stkz00_2735;

				BgL_ez00_2734 = ((BgL_ev_littz00_bglt) BgL_ez00_17384);
				BgL_stkz00_2735 = BgL_stkz00_17385;
				{	/* Eval/evaluate_comp.scm 409 */
					obj_t BgL_zc3anonymousza32819ze3z83_16293;

					BgL_zc3anonymousza32819ze3z83_16293 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3anonymousza32819ze3ze1zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3anonymousza32819ze3z83_16293, (int) (((long) 0)),
						((obj_t) BgL_ez00_2734));
					return BgL_zc3anonymousza32819ze3z83_16293;
				}
			}
		}
	}



/* &<anonymous:2819> */
	obj_t BGl_z62zc3anonymousza32819ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17386, obj_t BgL_sz00_17388)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 409 */
			{	/* Eval/evaluate_comp.scm 409 */
				BgL_ev_littz00_bglt BgL_i1098z00_17387;

				BgL_i1098z00_17387 =
					((BgL_ev_littz00_bglt)
					PROCEDURE_REF(BgL_envz00_17386, (int) (((long) 0))));
				{
					obj_t BgL_sz00_9387;

					BgL_sz00_9387 = BgL_sz00_17388;
					{	/* Eval/evaluate_comp.scm 409 */
						obj_t BgL_bpz00_9389;

						BgL_bpz00_9389 = VECTOR_REF(BgL_sz00_9387, (int) (((long) 0)));
						return
							(((BgL_ev_littz00_bglt) CREF(BgL_i1098z00_17387))->BgL_valuez00);
					}
				}
			}
		}
	}



/* &comp-ev_defglobal1652 */
	obj_t BGl_z62compzd2ev_defglobal1652zb0zz__evaluate_compz00(obj_t
		BgL_envz00_17389, obj_t BgL_ez00_17390, obj_t BgL_stkz00_17391)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 376 */
			{
				BgL_ev_defglobalz00_bglt BgL_ez00_2695;
				obj_t BgL_stkz00_2696;

				BgL_ez00_2695 = ((BgL_ev_defglobalz00_bglt) BgL_ez00_17390);
				BgL_stkz00_2696 = BgL_stkz00_17391;
				{	/* Eval/evaluate_comp.scm 378 */
					obj_t BgL_ez00_2700;

					{	/* Eval/evaluate_comp.scm 378 */
						BgL_ev_exprz00_bglt BgL_arg2818z00_2732;

						BgL_arg2818z00_2732 =
							(((BgL_ev_hookz00_bglt) CREF(
									((BgL_ev_hookz00_bglt) BgL_ez00_2695)))->BgL_ez00);
						BgL_ez00_2700 =
							BGl_compz00zz__evaluate_compz00(BgL_arg2818z00_2732,
							BgL_stkz00_2696);
					}
					{	/* Eval/evaluate_comp.scm 379 */
						obj_t BgL_zc3anonymousza32792ze3z83_16295;

						BgL_zc3anonymousza32792ze3z83_16295 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza32792ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 2)));
						PROCEDURE_SET(BgL_zc3anonymousza32792ze3z83_16295,
							(int) (((long) 0)), ((obj_t) BgL_ez00_2695));
						PROCEDURE_SET(BgL_zc3anonymousza32792ze3z83_16295,
							(int) (((long) 1)), BgL_ez00_2700);
						return BgL_zc3anonymousza32792ze3z83_16295;
					}
				}
			}
		}
	}



/* &<anonymous:2792> */
	obj_t BGl_z62zc3anonymousza32792ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17392, obj_t BgL_sz00_17395)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 379 */
			{	/* Eval/evaluate_comp.scm 379 */
				BgL_ev_defglobalz00_bglt BgL_i1095z00_17393;
				obj_t BgL_ez00_17394;

				BgL_i1095z00_17393 =
					((BgL_ev_defglobalz00_bglt)
					PROCEDURE_REF(BgL_envz00_17392, (int) (((long) 0))));
				BgL_ez00_17394 = PROCEDURE_REF(BgL_envz00_17392, (int) (((long) 1)));
				{
					obj_t BgL_sz00_2701;

					BgL_sz00_2701 = BgL_sz00_17395;
					{	/* Eval/evaluate_comp.scm 379 */
						obj_t BgL_bpz00_2703;

						BgL_bpz00_2703 = VECTOR_REF(BgL_sz00_2701, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 380 */
							obj_t BgL_gz00_2704;

							{	/* Eval/evaluate_comp.scm 380 */
								obj_t BgL_arg2816z00_2730;
								obj_t BgL_arg2817z00_2731;

								BgL_arg2816z00_2730 =
									(((BgL_ev_setglobalz00_bglt) CREF(
											((BgL_ev_setglobalz00_bglt) BgL_i1095z00_17393)))->
									BgL_modz00);
								BgL_arg2817z00_2731 =
									(((BgL_ev_setglobalz00_bglt) CREF(((BgL_ev_setglobalz00_bglt)
												BgL_i1095z00_17393)))->BgL_namez00);
								BgL_gz00_2704 =
									BGl_evmodulezd2findzd2globalz00zz__evmodulez00
									(BgL_arg2816z00_2730, BgL_arg2817z00_2731);
							}
							if (CBOOL(BgL_gz00_2704))
								{	/* Eval/evaluate_comp.scm 382 */
									{

										{	/* Eval/evaluate_comp.scm 384 */
											int BgL_aux1097z00_2706;

											{	/* Eval/evaluate_comp.scm 384 */
												int BgL_res4847z00_9332;

												{	/* Eval/evaluate_comp.scm 384 */
													obj_t BgL_evalzd2globalzd2_9329;

													BgL_evalzd2globalzd2_9329 = BgL_gz00_2704;
													{	/* Eval/evenv.scm 188 */
														int BgL_kz00_9331;

														BgL_kz00_9331 = (int) (((long) 0));
														BgL_res4847z00_9332 =
															CINT(VECTOR_REF(BgL_evalzd2globalzd2_9329,
																BgL_kz00_9331));
												}}
												BgL_aux1097z00_2706 = BgL_res4847z00_9332;
											}
											switch ((long) (BgL_aux1097z00_2706))
												{
												case ((long) 0):

													{	/* Eval/evaluate_comp.scm 386 */
														obj_t BgL_arg2794z00_2708;
														obj_t BgL_arg2795z00_2709;

														BgL_arg2794z00_2708 =
															(((BgL_ev_setglobalz00_bglt) CREF(
																	((BgL_ev_setglobalz00_bglt)
																		BgL_i1095z00_17393)))->BgL_locz00);
														BgL_arg2795z00_2709 =
															(((BgL_ev_setglobalz00_bglt)
																CREF(((BgL_ev_setglobalz00_bglt)
																		BgL_i1095z00_17393)))->BgL_namez00);
														BGl_everrorz00zz__everrorz00(BgL_arg2794z00_2708,
															BGl_string5680z00zz__evaluate_compz00,
															BGl_string5681z00zz__evaluate_compz00,
															BgL_arg2795z00_2709);
													} break;
												case ((long) 1):

													{	/* Eval/evaluate_comp.scm 388 */
														obj_t BgL_arg2796z00_2710;
														obj_t BgL_arg2798z00_2711;

														BgL_arg2796z00_2710 =
															(((BgL_ev_setglobalz00_bglt) CREF(
																	((BgL_ev_setglobalz00_bglt)
																		BgL_i1095z00_17393)))->BgL_locz00);
														BgL_arg2798z00_2711 =
															(((BgL_ev_setglobalz00_bglt)
																CREF(((BgL_ev_setglobalz00_bglt)
																		BgL_i1095z00_17393)))->BgL_namez00);
														{	/* Eval/evaluate_comp.scm 388 */
															obj_t BgL_list2799z00_2712;

															{	/* Eval/evaluate_comp.scm 388 */
																obj_t BgL_arg2800z00_2713;

																{	/* Eval/evaluate_comp.scm 388 */
																	obj_t BgL_arg2801z00_2714;

																	BgL_arg2801z00_2714 =
																		MAKE_PAIR(BgL_arg2798z00_2711, BNIL);
																	BgL_arg2800z00_2713 =
																		MAKE_PAIR
																		(BGl_string5682z00zz__evaluate_compz00,
																		BgL_arg2801z00_2714);
																}
																BgL_list2799z00_2712 =
																	MAKE_PAIR
																	(BGl_string5561z00zz__evaluate_compz00,
																	BgL_arg2800z00_2713);
															}
															BGl_evwarningz00zz__everrorz00
																(BgL_arg2796z00_2710, BgL_list2799z00_2712);
													}}
													{	/* Eval/evaluate_comp.scm 390 */
														obj_t BgL_arg2802z00_2715;
														obj_t BgL_arg2803z00_2716;

														BgL_arg2802z00_2715 =
															VECTOR_REF(BgL_gz00_2704, (int) (((long) 2)));
														BgL_arg2803z00_2716 =
															PROCEDURE_ENTRY(BgL_ez00_17394) (BgL_ez00_17394,
															BgL_sz00_2701, BEOA);
														__EVMEANING_ADDRESS_SET(BgL_arg2802z00_2715,
															BgL_arg2803z00_2716);
													} break;
												case ((long) 2):

													{	/* Eval/evaluate_comp.scm 392 */
														obj_t BgL_arg2804z00_2717;

														BgL_arg2804z00_2717 =
															PROCEDURE_ENTRY(BgL_ez00_17394) (BgL_ez00_17394,
															BgL_sz00_2701, BEOA);
														VECTOR_SET(BgL_gz00_2704, (int) (((long) 2)),
															BgL_arg2804z00_2717);
													} break;
												case ((long) 3):

													{	/* Eval/evaluate_comp.scm 394 */
														obj_t BgL_arg2805z00_2718;

														BgL_arg2805z00_2718 =
															PROCEDURE_ENTRY(BgL_ez00_17394) (BgL_ez00_17394,
															BgL_sz00_2701, BEOA);
														VECTOR_SET(BgL_gz00_2704, (int) (((long) 2)),
															BgL_arg2805z00_2718);
													}
													{	/* Eval/evaluate_comp.scm 395 */
														obj_t BgL_evalzd2globalzd2_9346;
														int BgL_tagz00_9347;

														BgL_evalzd2globalzd2_9346 = BgL_gz00_2704;
														BgL_tagz00_9347 = (int) (((long) 2));
														VECTOR_SET(BgL_evalzd2globalzd2_9346,
															(int) (((long) 0)), BINT(BgL_tagz00_9347));
													} break;
												case ((long) 4):

													{	/* Eval/evaluate_comp.scm 397 */
														obj_t BgL_arg2806z00_2719;

														BgL_arg2806z00_2719 =
															PROCEDURE_ENTRY(BgL_ez00_17394) (BgL_ez00_17394,
															BgL_sz00_2701, BEOA);
														VECTOR_SET(BgL_gz00_2704, (int) (((long) 2)),
															BgL_arg2806z00_2719);
													}
													{	/* Eval/evaluate_comp.scm 398 */
														obj_t BgL_evalzd2globalzd2_9356;
														int BgL_tagz00_9357;

														BgL_evalzd2globalzd2_9356 = BgL_gz00_2704;
														BgL_tagz00_9357 = (int) (((long) 5));
														VECTOR_SET(BgL_evalzd2globalzd2_9356,
															(int) (((long) 0)), BINT(BgL_tagz00_9357));
													} break;
												default:
													{	/* Eval/evaluate_comp.scm 400 */
														obj_t BgL_arg2807z00_2720;
														obj_t BgL_arg2808z00_2721;

														BgL_arg2807z00_2720 =
															(((BgL_ev_setglobalz00_bglt) CREF(
																	((BgL_ev_setglobalz00_bglt)
																		BgL_i1095z00_17393)))->BgL_locz00);
														BgL_arg2808z00_2721 =
															(((BgL_ev_setglobalz00_bglt)
																CREF(((BgL_ev_setglobalz00_bglt)
																		BgL_i1095z00_17393)))->BgL_namez00);
														BGl_everrorz00zz__everrorz00(BgL_arg2807z00_2720,
															BGl_string5680z00zz__evaluate_compz00,
															BGl_string5681z00zz__evaluate_compz00,
															BgL_arg2808z00_2721);
													}
												}
										}
									}
									return
										(((BgL_ev_setglobalz00_bglt) CREF(
												((BgL_ev_setglobalz00_bglt) BgL_i1095z00_17393)))->
										BgL_namez00);
								}
							else
								{	/* Eval/evaluate_comp.scm 402 */
									obj_t BgL_gz00_2722;

									{	/* Eval/evaluate_comp.scm 402 */
										obj_t BgL_arg2813z00_2727;
										obj_t BgL_arg2814z00_2728;
										obj_t BgL_arg2815z00_2729;

										BgL_arg2813z00_2727 =
											(((BgL_ev_setglobalz00_bglt) CREF(
													((BgL_ev_setglobalz00_bglt) BgL_i1095z00_17393)))->
											BgL_namez00);
										BgL_arg2814z00_2728 =
											(((BgL_ev_setglobalz00_bglt)
												CREF(((BgL_ev_setglobalz00_bglt) BgL_i1095z00_17393)))->
											BgL_modz00);
										BgL_arg2815z00_2729 =
											(((BgL_ev_setglobalz00_bglt)
												CREF(((BgL_ev_setglobalz00_bglt) BgL_i1095z00_17393)))->
											BgL_locz00);
										{	/* Eval/evenv.scm 114 */
											obj_t BgL_v1629z00_9364;

											BgL_v1629z00_9364 = create_vector((int) (((long) 5)));
											VECTOR_SET(BgL_v1629z00_9364,
												(int) (((long) 4)), BgL_arg2815z00_2729);
											VECTOR_SET(BgL_v1629z00_9364,
												(int) (((long) 3)), BgL_arg2814z00_2728);
											VECTOR_SET(BgL_v1629z00_9364,
												(int) (((long) 2)), BUNSPEC);
											VECTOR_SET(BgL_v1629z00_9364,
												(int) (((long) 1)), BgL_arg2813z00_2727);
											VECTOR_SET(BgL_v1629z00_9364,
												(int) (((long) 0)), BINT(((long) 2)));
											BgL_gz00_2722 = BgL_v1629z00_9364;
									}}
									{	/* Eval/evaluate_comp.scm 403 */
										obj_t BgL_arg2809z00_2723;

										BgL_arg2809z00_2723 =
											PROCEDURE_ENTRY(BgL_ez00_17394) (BgL_ez00_17394,
											BgL_sz00_2701, BEOA);
										VECTOR_SET(BgL_gz00_2722, (int) (((long) 2)),
											BgL_arg2809z00_2723);
									}
									{	/* Eval/evaluate_comp.scm 404 */
										obj_t BgL_arg2810z00_2724;
										obj_t BgL_arg2811z00_2725;
										obj_t BgL_arg2812z00_2726;

										BgL_arg2810z00_2724 =
											(((BgL_ev_setglobalz00_bglt) CREF(
													((BgL_ev_setglobalz00_bglt) BgL_i1095z00_17393)))->
											BgL_modz00);
										BgL_arg2811z00_2725 =
											(((BgL_ev_setglobalz00_bglt)
												CREF(((BgL_ev_setglobalz00_bglt) BgL_i1095z00_17393)))->
											BgL_namez00);
										BgL_arg2812z00_2726 =
											(((BgL_ev_setglobalz00_bglt)
												CREF(((BgL_ev_setglobalz00_bglt) BgL_i1095z00_17393)))->
											BgL_locz00);
										BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00
											(BgL_arg2810z00_2724, BgL_arg2811z00_2725, BgL_gz00_2722,
											BgL_arg2812z00_2726);
									}
									return
										(((BgL_ev_setglobalz00_bglt) CREF(
												((BgL_ev_setglobalz00_bglt) BgL_i1095z00_17393)))->
										BgL_namez00);
								}
						}
					}
				}
			}
		}
	}



/* &comp-ev_setglobal1650 */
	obj_t BGl_z62compzd2ev_setglobal1650zb0zz__evaluate_compz00(obj_t
		BgL_envz00_17396, obj_t BgL_ez00_17397, obj_t BgL_stkz00_17398)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 353 */
			{
				BgL_ev_setglobalz00_bglt BgL_ez00_2652;
				obj_t BgL_stkz00_2653;

				BgL_ez00_2652 = ((BgL_ev_setglobalz00_bglt) BgL_ez00_17397);
				BgL_stkz00_2653 = BgL_stkz00_17398;
				{	/* Eval/evaluate_comp.scm 355 */
					obj_t BgL_gz00_2657;
					obj_t BgL_ez00_2658;

					BgL_gz00_2657 =
						BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
						(((BgL_ev_setglobalz00_bglt) CREF(BgL_ez00_2652))->BgL_modz00),
						(((BgL_ev_setglobalz00_bglt) CREF(BgL_ez00_2652))->BgL_namez00));
					{	/* Eval/evaluate_comp.scm 355 */
						BgL_ev_exprz00_bglt BgL_arg2791z00_2693;

						BgL_arg2791z00_2693 =
							(((BgL_ev_hookz00_bglt) CREF(
									((BgL_ev_hookz00_bglt) BgL_ez00_2652)))->BgL_ez00);
						BgL_ez00_2658 =
							BGl_compz00zz__evaluate_compz00(BgL_arg2791z00_2693,
							BgL_stkz00_2653);
					}
					if (CBOOL(BgL_gz00_2657))
						{

							{	/* Eval/evaluate_comp.scm 357 */
								int BgL_aux1094z00_2660;

								{	/* Eval/evaluate_comp.scm 357 */
									int BgL_res4846z00_9287;

									{	/* Eval/evaluate_comp.scm 357 */
										obj_t BgL_evalzd2globalzd2_9284;

										BgL_evalzd2globalzd2_9284 = BgL_gz00_2657;
										{	/* Eval/evenv.scm 188 */
											int BgL_kz00_9286;

											BgL_kz00_9286 = (int) (((long) 0));
											BgL_res4846z00_9287 =
												CINT(VECTOR_REF(BgL_evalzd2globalzd2_9284,
													BgL_kz00_9286));
									}}
									BgL_aux1094z00_2660 = BgL_res4846z00_9287;
								}
								switch ((long) (BgL_aux1094z00_2660))
									{
									case ((long) 1):

										{	/* Eval/evaluate_comp.scm 359 */
											obj_t BgL_zc3anonymousza32768ze3z83_16298;

											BgL_zc3anonymousza32768ze3z83_16298 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3anonymousza32768ze3ze1zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 2)));
											PROCEDURE_SET(BgL_zc3anonymousza32768ze3z83_16298,
												(int) (((long) 0)), BgL_gz00_2657);
											PROCEDURE_SET(BgL_zc3anonymousza32768ze3z83_16298,
												(int) (((long) 1)), BgL_ez00_2658);
											return BgL_zc3anonymousza32768ze3z83_16298;
										}
										break;
									case ((long) 0):
									case ((long) 4):
									case ((long) 5):

										return
											BGl_everrorz00zz__everrorz00(
											(((BgL_ev_setglobalz00_bglt) CREF(BgL_ez00_2652))->
												BgL_locz00), BGl_string5680z00zz__evaluate_compz00,
											BGl_string5681z00zz__evaluate_compz00,
											(((BgL_ev_setglobalz00_bglt) CREF(BgL_ez00_2652))->
												BgL_namez00));
										break;
									default:
										{	/* Eval/evaluate_comp.scm 364 */
											obj_t BgL_zc3anonymousza32773ze3z83_16299;

											BgL_zc3anonymousza32773ze3z83_16299 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3anonymousza32773ze3ze1zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 2)));
											PROCEDURE_SET(BgL_zc3anonymousza32773ze3z83_16299,
												(int) (((long) 0)), BgL_ez00_2658);
											PROCEDURE_SET(BgL_zc3anonymousza32773ze3z83_16299,
												(int) (((long) 1)), BgL_gz00_2657);
											return BgL_zc3anonymousza32773ze3z83_16299;
										}
									}
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 365 */
							obj_t BgL_slotz00_2673;

							BgL_slotz00_2673 = MAKE_CELL(BFALSE);
							if (BGl_evmodulezf3zf3zz__evmodulez00(
									(((BgL_ev_setglobalz00_bglt) CREF(BgL_ez00_2652))->
										BgL_modz00)))
								{	/* Eval/evaluate_comp.scm 367 */
									obj_t BgL_gz00_2675;

									{	/* Eval/evaluate_comp.scm 367 */
										obj_t BgL_arg2779z00_2679;
										obj_t BgL_arg2780z00_2680;
										obj_t BgL_arg2781z00_2681;

										BgL_arg2779z00_2679 =
											(((BgL_ev_setglobalz00_bglt) CREF(BgL_ez00_2652))->
											BgL_namez00);
										BgL_arg2780z00_2680 =
											(((BgL_ev_setglobalz00_bglt) CREF(BgL_ez00_2652))->
											BgL_modz00);
										BgL_arg2781z00_2681 =
											(((BgL_ev_setglobalz00_bglt) CREF(BgL_ez00_2652))->
											BgL_locz00);
										{	/* Eval/evenv.scm 114 */
											obj_t BgL_v1629z00_9299;

											BgL_v1629z00_9299 = create_vector((int) (((long) 5)));
											VECTOR_SET(BgL_v1629z00_9299,
												(int) (((long) 4)), BgL_arg2781z00_2681);
											VECTOR_SET(BgL_v1629z00_9299,
												(int) (((long) 3)), BgL_arg2780z00_2680);
											VECTOR_SET(BgL_v1629z00_9299,
												(int) (((long) 2)), BUNSPEC);
											VECTOR_SET(BgL_v1629z00_9299,
												(int) (((long) 1)), BgL_arg2779z00_2679);
											VECTOR_SET(BgL_v1629z00_9299,
												(int) (((long) 0)), BINT(((long) 2)));
											BgL_gz00_2675 = BgL_v1629z00_9299;
									}}
									{	/* Eval/evaluate_comp.scm 368 */
										int BgL_tagz00_9316;

										BgL_tagz00_9316 = (int) (((long) 3));
										VECTOR_SET(BgL_gz00_2675,
											(int) (((long) 0)), BINT(BgL_tagz00_9316));
									}
									BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(
										(((BgL_ev_setglobalz00_bglt) CREF(BgL_ez00_2652))->
											BgL_modz00),
										(((BgL_ev_setglobalz00_bglt) CREF(BgL_ez00_2652))->
											BgL_namez00), BgL_gz00_2675,
										(((BgL_ev_setglobalz00_bglt) CREF(BgL_ez00_2652))->
											BgL_locz00));
								}
							else
								{	/* Eval/evaluate_comp.scm 366 */
									BFALSE;
								}
							{	/* Eval/evaluate_comp.scm 370 */
								obj_t BgL_zc3anonymousza32783ze3z83_16297;

								BgL_zc3anonymousza32783ze3z83_16297 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32783ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3anonymousza32783ze3z83_16297,
									(int) (((long) 0)), ((obj_t) BgL_ez00_2652));
								PROCEDURE_SET(BgL_zc3anonymousza32783ze3z83_16297,
									(int) (((long) 1)), BgL_slotz00_2673);
								PROCEDURE_SET(BgL_zc3anonymousza32783ze3z83_16297,
									(int) (((long) 2)), BgL_ez00_2658);
								return BgL_zc3anonymousza32783ze3z83_16297;
							}
						}
				}
			}
		}
	}



/* &<anonymous:2768> */
	obj_t BGl_z62zc3anonymousza32768ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17399, obj_t BgL_sz00_17402)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 359 */
			{	/* Eval/evaluate_comp.scm 359 */
				obj_t BgL_gz00_17400;
				obj_t BgL_ez00_17401;

				BgL_gz00_17400 = PROCEDURE_REF(BgL_envz00_17399, (int) (((long) 0)));
				BgL_ez00_17401 = PROCEDURE_REF(BgL_envz00_17399, (int) (((long) 1)));
				{
					obj_t BgL_sz00_2662;

					BgL_sz00_2662 = BgL_sz00_17402;
					{	/* Eval/evaluate_comp.scm 359 */
						obj_t BgL_bpz00_9288;

						BgL_bpz00_9288 = VECTOR_REF(BgL_sz00_2662, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 360 */
							obj_t BgL_arg2769z00_9289;
							obj_t BgL_arg2770z00_9290;

							BgL_arg2769z00_9289 =
								VECTOR_REF(BgL_gz00_17400, (int) (((long) 2)));
							BgL_arg2770z00_9290 =
								PROCEDURE_ENTRY(BgL_ez00_17401) (BgL_ez00_17401, BgL_sz00_2662,
								BEOA);
							return __EVMEANING_ADDRESS_SET(BgL_arg2769z00_9289,
								BgL_arg2770z00_9290);
						}
					}
				}
			}
		}
	}



/* &<anonymous:2773> */
	obj_t BGl_z62zc3anonymousza32773ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17403, obj_t BgL_sz00_17406)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 364 */
			{	/* Eval/evaluate_comp.scm 364 */
				obj_t BgL_ez00_17404;
				obj_t BgL_gz00_17405;

				BgL_ez00_17404 = PROCEDURE_REF(BgL_envz00_17403, (int) (((long) 0)));
				BgL_gz00_17405 = PROCEDURE_REF(BgL_envz00_17403, (int) (((long) 1)));
				{
					obj_t BgL_sz00_2669;

					BgL_sz00_2669 = BgL_sz00_17406;
					{	/* Eval/evaluate_comp.scm 364 */
						obj_t BgL_bpz00_9275;

						BgL_bpz00_9275 = VECTOR_REF(BgL_sz00_2669, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 364 */
							obj_t BgL_arg2774z00_9276;

							BgL_arg2774z00_9276 =
								PROCEDURE_ENTRY(BgL_ez00_17404) (BgL_ez00_17404, BgL_sz00_2669,
								BEOA);
							return VECTOR_SET(BgL_gz00_17405, (int) (((long) 2)),
								BgL_arg2774z00_9276);
		}}}}}
	}



/* &<anonymous:2783> */
	obj_t BGl_z62zc3anonymousza32783ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17407, obj_t BgL_sz00_17411)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 370 */
			{	/* Eval/evaluate_comp.scm 370 */
				BgL_ev_setglobalz00_bglt BgL_i1092z00_17408;
				obj_t BgL_slotz00_17409;
				obj_t BgL_ez00_17410;

				BgL_i1092z00_17408 =
					((BgL_ev_setglobalz00_bglt)
					PROCEDURE_REF(BgL_envz00_17407, (int) (((long) 0))));
				BgL_slotz00_17409 = PROCEDURE_REF(BgL_envz00_17407, (int) (((long) 1)));
				BgL_ez00_17410 = PROCEDURE_REF(BgL_envz00_17407, (int) (((long) 2)));
				{
					obj_t BgL_sz00_2683;

					BgL_sz00_2683 = BgL_sz00_17411;
					{	/* Eval/evaluate_comp.scm 370 */
						obj_t BgL_bpz00_2685;

						BgL_bpz00_2685 = VECTOR_REF(BgL_sz00_2683, (int) (((long) 0)));
						if (CBOOL(CELL_REF(BgL_slotz00_17409)))
							{	/* Eval/evaluate_comp.scm 371 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 371 */
								{	/* Eval/evaluate_comp.scm 372 */
									obj_t BgL_auxz00_17412;

									BgL_auxz00_17412 =
										BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
										(((BgL_ev_setglobalz00_bglt) CREF(BgL_i1092z00_17408))->
											BgL_modz00),
										(((BgL_ev_setglobalz00_bglt) CREF(BgL_i1092z00_17408))->
											BgL_namez00));
									CELL_SET(BgL_slotz00_17409, BgL_auxz00_17412);
								}
								if (CBOOL(CELL_REF(BgL_slotz00_17409)))
									{	/* Eval/evaluate_comp.scm 373 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 373 */
										BGl_everrorz00zz__everrorz00(
											(((BgL_ev_setglobalz00_bglt) CREF(BgL_i1092z00_17408))->
												BgL_locz00), BGl_string5561z00zz__evaluate_compz00,
											BGl_string5683z00zz__evaluate_compz00,
											(((BgL_ev_setglobalz00_bglt) CREF(BgL_i1092z00_17408))->
												BgL_namez00));
									}
							}
						{	/* Eval/evaluate_comp.scm 374 */
							obj_t BgL_arg2788z00_2690;

							BgL_arg2788z00_2690 =
								PROCEDURE_ENTRY(BgL_ez00_17410) (BgL_ez00_17410, BgL_sz00_2683,
								BEOA);
							{	/* Eval/evaluate_comp.scm 374 */
								obj_t BgL_evalzd2globalzd2_9322;

								BgL_evalzd2globalzd2_9322 = CELL_REF(BgL_slotz00_17409);
								return
									VECTOR_SET(BgL_evalzd2globalzd2_9322,
									(int) (((long) 2)), BgL_arg2788z00_2690);
		}}}}}}
	}



/* &comp-ev_global1648 */
	obj_t BGl_z62compzd2ev_global1648zb0zz__evaluate_compz00(obj_t
		BgL_envz00_17413, obj_t BgL_varz00_17414, obj_t BgL_stkz00_17415)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 327 */
			{
				BgL_ev_globalz00_bglt BgL_varz00_2610;
				obj_t BgL_stkz00_2611;

				BgL_varz00_2610 = ((BgL_ev_globalz00_bglt) BgL_varz00_17414);
				BgL_stkz00_2611 = BgL_stkz00_17415;
				{	/* Eval/evaluate_comp.scm 329 */
					obj_t BgL_gz00_2615;

					BgL_gz00_2615 =
						BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
						(((BgL_ev_globalz00_bglt) CREF(BgL_varz00_2610))->BgL_modz00),
						(((BgL_ev_globalz00_bglt) CREF(BgL_varz00_2610))->BgL_namez00));
					if (CBOOL(BgL_gz00_2615))
						{	/* Eval/evaluate_comp.scm 331 */
							bool_t BgL_testz00_32191;

							{	/* Eval/evaluate_comp.scm 331 */
								int BgL_arg2746z00_2624;

								{	/* Eval/evaluate_comp.scm 331 */
									int BgL_res4842z00_9222;

									{	/* Eval/evaluate_comp.scm 331 */
										obj_t BgL_evalzd2globalzd2_9219;

										BgL_evalzd2globalzd2_9219 = BgL_gz00_2615;
										{	/* Eval/evenv.scm 188 */
											int BgL_kz00_9221;

											BgL_kz00_9221 = (int) (((long) 0));
											BgL_res4842z00_9222 =
												CINT(VECTOR_REF(BgL_evalzd2globalzd2_9219,
													BgL_kz00_9221));
									}}
									BgL_arg2746z00_2624 = BgL_res4842z00_9222;
								}
								BgL_testz00_32191 =
									(BINT(BgL_arg2746z00_2624) == BINT(((long) 1)));
							}
							if (BgL_testz00_32191)
								{	/* Eval/evaluate_comp.scm 332 */
									obj_t BgL_zc3anonymousza32743ze3z83_16301;

									BgL_zc3anonymousza32743ze3z83_16301 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3anonymousza32743ze3ze1zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 1)));
									PROCEDURE_SET(BgL_zc3anonymousza32743ze3z83_16301,
										(int) (((long) 0)), BgL_gz00_2615);
									return BgL_zc3anonymousza32743ze3z83_16301;
								}
							else
								{	/* Eval/evaluate_comp.scm 334 */
									obj_t BgL_zc3anonymousza32745ze3z83_16302;

									BgL_zc3anonymousza32745ze3z83_16302 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3anonymousza32745ze3ze1zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 1)));
									PROCEDURE_SET(BgL_zc3anonymousza32745ze3z83_16302,
										(int) (((long) 0)), BgL_gz00_2615);
									return BgL_zc3anonymousza32745ze3z83_16302;
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 336 */
							obj_t BgL_slotz00_2625;

							BgL_slotz00_2625 = MAKE_CELL(BFALSE);
							if (BGl_evmodulezf3zf3zz__evmodulez00(
									(((BgL_ev_globalz00_bglt) CREF(BgL_varz00_2610))->
										BgL_modz00)))
								{	/* Eval/evaluate_comp.scm 338 */
									obj_t BgL_gz00_2627;

									{	/* Eval/evaluate_comp.scm 338 */
										obj_t BgL_arg2751z00_2631;
										obj_t BgL_arg2752z00_2632;
										obj_t BgL_arg2753z00_2633;

										BgL_arg2751z00_2631 =
											(((BgL_ev_globalz00_bglt) CREF(BgL_varz00_2610))->
											BgL_namez00);
										BgL_arg2752z00_2632 =
											(((BgL_ev_globalz00_bglt) CREF(BgL_varz00_2610))->
											BgL_modz00);
										BgL_arg2753z00_2633 =
											(((BgL_ev_globalz00_bglt) CREF(BgL_varz00_2610))->
											BgL_locz00);
										{	/* Eval/evenv.scm 114 */
											obj_t BgL_v1629z00_9239;

											BgL_v1629z00_9239 = create_vector((int) (((long) 5)));
											VECTOR_SET(BgL_v1629z00_9239,
												(int) (((long) 4)), BgL_arg2753z00_2633);
											VECTOR_SET(BgL_v1629z00_9239,
												(int) (((long) 3)), BgL_arg2752z00_2632);
											VECTOR_SET(BgL_v1629z00_9239,
												(int) (((long) 2)), BUNSPEC);
											VECTOR_SET(BgL_v1629z00_9239,
												(int) (((long) 1)), BgL_arg2751z00_2631);
											VECTOR_SET(BgL_v1629z00_9239,
												(int) (((long) 0)), BINT(((long) 2)));
											BgL_gz00_2627 = BgL_v1629z00_9239;
									}}
									{	/* Eval/evaluate_comp.scm 339 */
										int BgL_tagz00_9256;

										BgL_tagz00_9256 = (int) (((long) 3));
										VECTOR_SET(BgL_gz00_2627,
											(int) (((long) 0)), BINT(BgL_tagz00_9256));
									}
									BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(
										(((BgL_ev_globalz00_bglt) CREF(BgL_varz00_2610))->
											BgL_modz00),
										(((BgL_ev_globalz00_bglt) CREF(BgL_varz00_2610))->
											BgL_namez00), BgL_gz00_2627,
										(((BgL_ev_globalz00_bglt) CREF(BgL_varz00_2610))->
											BgL_locz00));
								}
							else
								{	/* Eval/evaluate_comp.scm 337 */
									BFALSE;
								}
							{	/* Eval/evaluate_comp.scm 341 */
								obj_t BgL_zc3anonymousza32755ze3z83_16303;

								BgL_zc3anonymousza32755ze3z83_16303 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3anonymousza32755ze3ze1zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_zc3anonymousza32755ze3z83_16303,
									(int) (((long) 0)), ((obj_t) BgL_varz00_2610));
								PROCEDURE_SET(BgL_zc3anonymousza32755ze3z83_16303,
									(int) (((long) 1)), BgL_slotz00_2625);
								return BgL_zc3anonymousza32755ze3z83_16303;
							}
						}
				}
			}
		}
	}



/* &<anonymous:2743> */
	obj_t BGl_z62zc3anonymousza32743ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17416, obj_t BgL_sz00_17418)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 332 */
			{	/* Eval/evaluate_comp.scm 332 */
				obj_t BgL_gz00_17417;

				BgL_gz00_17417 = PROCEDURE_REF(BgL_envz00_17416, (int) (((long) 0)));
				{
					obj_t BgL_sz00_2617;

					BgL_sz00_2617 = BgL_sz00_17418;
					{	/* Eval/evaluate_comp.scm 332 */
						obj_t BgL_bpz00_9223;

						BgL_bpz00_9223 = VECTOR_REF(BgL_sz00_2617, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 333 */
							obj_t BgL_auxz00_32248;

							BgL_auxz00_32248 = VECTOR_REF(BgL_gz00_17417, (int) (((long) 2)));
							return __EVMEANING_ADDRESS_REF(BgL_auxz00_32248);
						}
					}
				}
			}
		}
	}



/* &<anonymous:2745> */
	obj_t BGl_z62zc3anonymousza32745ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17419, obj_t BgL_sz00_17421)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 334 */
			{	/* Eval/evaluate_comp.scm 334 */
				obj_t BgL_gz00_17420;

				BgL_gz00_17420 = PROCEDURE_REF(BgL_envz00_17419, (int) (((long) 0)));
				{
					obj_t BgL_sz00_2621;

					BgL_sz00_2621 = BgL_sz00_17421;
					{	/* Eval/evaluate_comp.scm 334 */
						obj_t BgL_bpz00_9230;

						BgL_bpz00_9230 = VECTOR_REF(BgL_sz00_2621, (int) (((long) 0)));
						return VECTOR_REF(BgL_gz00_17420, (int) (((long) 2)));
		}}}}
	}



/* &<anonymous:2755> */
	obj_t BGl_z62zc3anonymousza32755ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17422, obj_t BgL_sz00_17425)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 341 */
			{	/* Eval/evaluate_comp.scm 341 */
				BgL_ev_globalz00_bglt BgL_i1091z00_17423;
				obj_t BgL_slotz00_17424;

				BgL_i1091z00_17423 =
					((BgL_ev_globalz00_bglt)
					PROCEDURE_REF(BgL_envz00_17422, (int) (((long) 0))));
				BgL_slotz00_17424 = PROCEDURE_REF(BgL_envz00_17422, (int) (((long) 1)));
				{
					obj_t BgL_sz00_2635;

					BgL_sz00_2635 = BgL_sz00_17425;
					{	/* Eval/evaluate_comp.scm 341 */
						obj_t BgL_bpz00_2637;

						BgL_bpz00_2637 = VECTOR_REF(BgL_sz00_2635, (int) (((long) 0)));
						if (CBOOL(CELL_REF(BgL_slotz00_17424)))
							{	/* Eval/evaluate_comp.scm 342 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 342 */
								{	/* Eval/evaluate_comp.scm 343 */
									obj_t BgL_auxz00_17426;

									BgL_auxz00_17426 =
										BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
										(((BgL_ev_globalz00_bglt) CREF(BgL_i1091z00_17423))->
											BgL_modz00),
										(((BgL_ev_globalz00_bglt) CREF(BgL_i1091z00_17423))->
											BgL_namez00));
									CELL_SET(BgL_slotz00_17424, BgL_auxz00_17426);
								}
								if (CBOOL(CELL_REF(BgL_slotz00_17424)))
									{	/* Eval/evaluate_comp.scm 344 */
										BFALSE;
									}
								else
									{	/* Eval/evaluate_comp.scm 344 */
										BGl_everrorz00zz__everrorz00(
											(((BgL_ev_globalz00_bglt) CREF(BgL_i1091z00_17423))->
												BgL_locz00), BGl_string5561z00zz__evaluate_compz00,
											BGl_string5683z00zz__evaluate_compz00,
											(((BgL_ev_globalz00_bglt) CREF(BgL_i1091z00_17423))->
												BgL_namez00));
									}
							}
						{	/* Eval/evaluate_comp.scm 345 */
							obj_t BgL_vz00_2642;

							{	/* Eval/evaluate_comp.scm 345 */
								obj_t BgL_evalzd2globalzd2_9262;

								BgL_evalzd2globalzd2_9262 = CELL_REF(BgL_slotz00_17424);
								BgL_vz00_2642 =
									VECTOR_REF(BgL_evalzd2globalzd2_9262, (int) (((long) 2)));
							}
							if ((BgL_vz00_2642 == BUNSPEC))
								{	/* Eval/evaluate_comp.scm 347 */
									int BgL_tz00_2644;

									{	/* Eval/evaluate_comp.scm 347 */
										int BgL_res4843z00_9268;

										{	/* Eval/evaluate_comp.scm 347 */
											obj_t BgL_evalzd2globalzd2_9265;

											BgL_evalzd2globalzd2_9265 = CELL_REF(BgL_slotz00_17424);
											{	/* Eval/evenv.scm 188 */
												int BgL_kz00_9267;

												BgL_kz00_9267 = (int) (((long) 0));
												BgL_res4843z00_9268 =
													CINT(VECTOR_REF(BgL_evalzd2globalzd2_9265,
														BgL_kz00_9267));
										}}
										BgL_tz00_2644 = BgL_res4843z00_9268;
									}
									{	/* Eval/evaluate_comp.scm 348 */
										bool_t BgL_testz00_32282;

										if (((long) (BgL_tz00_2644) == ((long) 3)))
											{	/* Eval/evaluate_comp.scm 348 */
												BgL_testz00_32282 = ((bool_t) 1);
											}
										else
											{	/* Eval/evaluate_comp.scm 348 */
												BgL_testz00_32282 =
													((long) (BgL_tz00_2644) == ((long) 4));
											}
										if (BgL_testz00_32282)
											{	/* Eval/evaluate_comp.scm 348 */
												return
													BGl_everrorz00zz__everrorz00(
													(((BgL_ev_globalz00_bglt) CREF(BgL_i1091z00_17423))->
														BgL_locz00), BGl_string5561z00zz__evaluate_compz00,
													BGl_string5684z00zz__evaluate_compz00,
													(((BgL_ev_globalz00_bglt) CREF(BgL_i1091z00_17423))->
														BgL_namez00));
											}
										else
											{	/* Eval/evaluate_comp.scm 348 */
												return BgL_vz00_2642;
											}
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 346 */
									return BgL_vz00_2642;
								}
						}
					}
				}
			}
		}
	}



/* &comp-ev_setlocal1646 */
	obj_t BGl_z62compzd2ev_setlocal1646zb0zz__evaluate_compz00(obj_t
		BgL_envz00_17427, obj_t BgL_ez00_17428, obj_t BgL_stkz00_17429)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 309 */
			{
				BgL_ev_setlocalz00_bglt BgL_ez00_2587;
				obj_t BgL_stkz00_2588;

				BgL_ez00_2587 = ((BgL_ev_setlocalz00_bglt) BgL_ez00_17428);
				BgL_stkz00_2588 = BgL_stkz00_17429;
				{	/* Eval/evaluate_comp.scm 311 */
					obj_t BgL_iz00_2592;
					obj_t BgL_ez00_2593;

					{	/* Eval/evaluate_comp.scm 311 */
						BgL_ev_varz00_bglt BgL_arg2740z00_2607;

						BgL_arg2740z00_2607 =
							(((BgL_ev_setlocalz00_bglt) CREF(BgL_ez00_2587))->BgL_vz00);
						BgL_iz00_2592 =
							BGl__indexz00zz__evaluate_compz00(
							((obj_t) BgL_arg2740z00_2607), BgL_stkz00_2588);
					}
					{	/* Eval/evaluate_comp.scm 311 */
						BgL_ev_exprz00_bglt BgL_arg2741z00_2608;

						BgL_arg2741z00_2608 =
							(((BgL_ev_hookz00_bglt) CREF(
									((BgL_ev_hookz00_bglt) BgL_ez00_2587)))->BgL_ez00);
						BgL_ez00_2593 =
							BGl_compz00zz__evaluate_compz00(BgL_arg2741z00_2608,
							BgL_stkz00_2588);
					}
					if (CBOOL(
							(((BgL_ev_varz00_bglt) CREF(
										(((BgL_ev_setlocalz00_bglt) CREF(BgL_ez00_2587))->
											BgL_vz00)))->BgL_effz00)))
						{	/* Eval/evaluate_comp.scm 314 */
							obj_t BgL_zc3anonymousza32733ze3z83_16305;

							BgL_zc3anonymousza32733ze3z83_16305 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3anonymousza32733ze3ze1zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_zc3anonymousza32733ze3z83_16305,
								(int) (((long) 0)), BgL_iz00_2592);
							PROCEDURE_SET(BgL_zc3anonymousza32733ze3z83_16305,
								(int) (((long) 1)), BgL_ez00_2593);
							return BgL_zc3anonymousza32733ze3z83_16305;
						}
					else
						{	/* Eval/evaluate_comp.scm 316 */
							obj_t BgL_zc3anonymousza32737ze3z83_16306;

							BgL_zc3anonymousza32737ze3z83_16306 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3anonymousza32737ze3ze1zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_zc3anonymousza32737ze3z83_16306,
								(int) (((long) 0)), BgL_iz00_2592);
							PROCEDURE_SET(BgL_zc3anonymousza32737ze3z83_16306,
								(int) (((long) 1)), BgL_ez00_2593);
							return BgL_zc3anonymousza32737ze3z83_16306;
						}
				}
			}
		}
	}



/* &<anonymous:2733> */
	obj_t BGl_z62zc3anonymousza32733ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17430, obj_t BgL_sz00_17433)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 314 */
			{	/* Eval/evaluate_comp.scm 314 */
				obj_t BgL_iz00_17431;
				obj_t BgL_ez00_17432;

				BgL_iz00_17431 = PROCEDURE_REF(BgL_envz00_17430, (int) (((long) 0)));
				BgL_ez00_17432 = PROCEDURE_REF(BgL_envz00_17430, (int) (((long) 1)));
				{
					obj_t BgL_sz00_2596;

					BgL_sz00_2596 = BgL_sz00_17433;
					{	/* Eval/evaluate_comp.scm 314 */
						obj_t BgL_bpz00_9192;

						BgL_bpz00_9192 = VECTOR_REF(BgL_sz00_2596, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 315 */
							obj_t BgL_arg2734z00_9193;
							obj_t BgL_arg2735z00_9194;

							{	/* Eval/evaluate_comp.scm 315 */
								long BgL_arg2736z00_9195;

								BgL_arg2736z00_9195 =
									((long) CINT(BgL_bpz00_9192) + (long) CINT(BgL_iz00_17431));
								BgL_arg2734z00_9193 =
									VECTOR_REF(BgL_sz00_2596, (int) (BgL_arg2736z00_9195));
							}
							BgL_arg2735z00_9194 =
								PROCEDURE_ENTRY(BgL_ez00_17432) (BgL_ez00_17432, BgL_sz00_2596,
								BEOA);
							{	/* Eval/evaluate_comp.scm 189 */
								obj_t BgL_sz00_9205;

								BgL_sz00_9205 = BgL_arg2734z00_9193;
								{	/* Llib/struct.scm 162 */
									obj_t BgL_xz00_17743;

									{	/* Llib/struct.scm 162 */
										int BgL_auxz00_32331;

										BgL_auxz00_32331 = (int) (((long) 0));
										BgL_xz00_17743 =
											STRUCT_SET(BgL_sz00_9205, BgL_auxz00_32331,
											BgL_arg2735z00_9194);
									}
									return BUNSPEC;
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:2737> */
	obj_t BGl_z62zc3anonymousza32737ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17434, obj_t BgL_sz00_17437)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 316 */
			{	/* Eval/evaluate_comp.scm 316 */
				obj_t BgL_iz00_17435;
				obj_t BgL_ez00_17436;

				BgL_iz00_17435 = PROCEDURE_REF(BgL_envz00_17434, (int) (((long) 0)));
				BgL_ez00_17436 = PROCEDURE_REF(BgL_envz00_17434, (int) (((long) 1)));
				{
					obj_t BgL_sz00_2602;

					BgL_sz00_2602 = BgL_sz00_17437;
					{	/* Eval/evaluate_comp.scm 316 */
						obj_t BgL_bpz00_9208;

						BgL_bpz00_9208 = VECTOR_REF(BgL_sz00_2602, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 317 */
							long BgL_arg2738z00_9209;
							obj_t BgL_arg2739z00_9210;

							BgL_arg2738z00_9209 =
								((long) CINT(BgL_bpz00_9208) + (long) CINT(BgL_iz00_17435));
							BgL_arg2739z00_9210 =
								PROCEDURE_ENTRY(BgL_ez00_17436) (BgL_ez00_17436, BgL_sz00_2602,
								BEOA);
							return VECTOR_SET(BgL_sz00_2602, (int) (BgL_arg2738z00_9209),
								BgL_arg2739z00_9210);
		}}}}}
	}



/* &comp-ev_var1644 */
	obj_t BGl_z62compzd2ev_var1644zb0zz__evaluate_compz00(obj_t BgL_envz00_17438,
		obj_t BgL_varz00_17439, obj_t BgL_stkz00_17440)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 304 */
			{
				BgL_ev_varz00_bglt BgL_varz00_2527;
				obj_t BgL_stkz00_2528;

				BgL_varz00_2527 = ((BgL_ev_varz00_bglt) BgL_varz00_17439);
				BgL_stkz00_2528 = BgL_stkz00_17440;
				{	/* Eval/evaluate_comp.scm 305 */
					obj_t BgL_iz00_2531;

					BgL_iz00_2531 =
						BGl__indexz00zz__evaluate_compz00(
						((obj_t) BgL_varz00_2527), BgL_stkz00_2528);
					{

						if (INTEGERP(BgL_iz00_2531))
							{	/* Eval/evaluate_comp.scm 307 */
								switch ((long) CINT(BgL_iz00_2531))
									{
									case ((long) 0):

										if (CBOOL(
												(((BgL_ev_varz00_bglt) CREF(BgL_varz00_2527))->
													BgL_effz00)))
											{	/* Eval/evaluate_comp.scm 307 */
												return BGl_proc5685z00zz__evaluate_compz00;
											}
										else
											{	/* Eval/evaluate_comp.scm 307 */
												return BGl_proc5686z00zz__evaluate_compz00;
											}
										break;
									case ((long) 1):

										if (CBOOL(
												(((BgL_ev_varz00_bglt) CREF(BgL_varz00_2527))->
													BgL_effz00)))
											{	/* Eval/evaluate_comp.scm 307 */
												return BGl_proc5687z00zz__evaluate_compz00;
											}
										else
											{	/* Eval/evaluate_comp.scm 307 */
												return BGl_proc5688z00zz__evaluate_compz00;
											}
										break;
									case ((long) 2):

										if (CBOOL(
												(((BgL_ev_varz00_bglt) CREF(BgL_varz00_2527))->
													BgL_effz00)))
											{	/* Eval/evaluate_comp.scm 307 */
												return BGl_proc5689z00zz__evaluate_compz00;
											}
										else
											{	/* Eval/evaluate_comp.scm 307 */
												return BGl_proc5690z00zz__evaluate_compz00;
											}
										break;
									case ((long) 3):

										if (CBOOL(
												(((BgL_ev_varz00_bglt) CREF(BgL_varz00_2527))->
													BgL_effz00)))
											{	/* Eval/evaluate_comp.scm 307 */
												return BGl_proc5691z00zz__evaluate_compz00;
											}
										else
											{	/* Eval/evaluate_comp.scm 307 */
												return BGl_proc5692z00zz__evaluate_compz00;
											}
										break;
									default:
									BgL_case_else1086z00_2533:
										if (CBOOL(
												(((BgL_ev_varz00_bglt) CREF(BgL_varz00_2527))->
													BgL_effz00)))
											{	/* Eval/evaluate_comp.scm 307 */
												obj_t BgL_zc3anonymousza32727ze3z83_16317;

												BgL_zc3anonymousza32727ze3z83_16317 =
													MAKE_FX_PROCEDURE
													(BGl_z62zc3anonymousza32727ze3ze1zz__evaluate_compz00,
													(int) (((long) 1)), (int) (((long) 1)));
												PROCEDURE_SET(BgL_zc3anonymousza32727ze3z83_16317,
													(int) (((long) 0)), BgL_iz00_2531);
												return BgL_zc3anonymousza32727ze3z83_16317;
											}
										else
											{	/* Eval/evaluate_comp.scm 307 */
												obj_t BgL_zc3anonymousza32730ze3z83_16316;

												BgL_zc3anonymousza32730ze3z83_16316 =
													MAKE_FX_PROCEDURE
													(BGl_z62zc3anonymousza32730ze3ze1zz__evaluate_compz00,
													(int) (((long) 1)), (int) (((long) 1)));
												PROCEDURE_SET(BgL_zc3anonymousza32730ze3z83_16316,
													(int) (((long) 0)), BgL_iz00_2531);
												return BgL_zc3anonymousza32730ze3z83_16316;
											}
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 307 */
								goto BgL_case_else1086z00_2533;
							}
					}
				}
			}
		}
	}



/* &<anonymous:2721> */
	obj_t BGl_z62zc3anonymousza32721ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17441, obj_t BgL_sz00_17442)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 307 */
			{
				obj_t BgL_sz00_2567;

				BgL_sz00_2567 = BgL_sz00_17442;
				{	/* Eval/evaluate_comp.scm 307 */
					obj_t BgL_bpz00_9170;

					BgL_bpz00_9170 = VECTOR_REF(BgL_sz00_2567, (int) (((long) 0)));
					{	/* Eval/evaluate_comp.scm 307 */
						obj_t BgL_arg2722z00_9171;

						{	/* Eval/evaluate_comp.scm 307 */
							long BgL_arg2723z00_9172;

							BgL_arg2723z00_9172 = ((long) CINT(BgL_bpz00_9170) + ((long) 3));
							BgL_arg2722z00_9171 =
								VECTOR_REF(BgL_sz00_2567, (int) (BgL_arg2723z00_9172));
						}
						return STRUCT_REF(BgL_arg2722z00_9171, (int) (((long) 0)));
		}}}}
	}



/* &<anonymous:2724> */
	obj_t BGl_z62zc3anonymousza32724ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17443, obj_t BgL_sz00_17444)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 307 */
			{
				obj_t BgL_sz00_2572;

				BgL_sz00_2572 = BgL_sz00_17444;
				{	/* Eval/evaluate_comp.scm 307 */
					obj_t BgL_bpz00_9183;

					BgL_bpz00_9183 = VECTOR_REF(BgL_sz00_2572, (int) (((long) 0)));
					{	/* Eval/evaluate_comp.scm 307 */
						long BgL_arg2725z00_9184;

						BgL_arg2725z00_9184 = ((long) CINT(BgL_bpz00_9183) + ((long) 3));
						return VECTOR_REF(BgL_sz00_2572, (int) (BgL_arg2725z00_9184));
		}}}}
	}



/* &<anonymous:2714> */
	obj_t BGl_z62zc3anonymousza32714ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17445, obj_t BgL_sz00_17446)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 307 */
			{
				obj_t BgL_sz00_2557;

				BgL_sz00_2557 = BgL_sz00_17446;
				{	/* Eval/evaluate_comp.scm 307 */
					obj_t BgL_bpz00_9148;

					BgL_bpz00_9148 = VECTOR_REF(BgL_sz00_2557, (int) (((long) 0)));
					{	/* Eval/evaluate_comp.scm 307 */
						obj_t BgL_arg2715z00_9149;

						{	/* Eval/evaluate_comp.scm 307 */
							long BgL_arg2716z00_9150;

							BgL_arg2716z00_9150 = ((long) CINT(BgL_bpz00_9148) + ((long) 2));
							BgL_arg2715z00_9149 =
								VECTOR_REF(BgL_sz00_2557, (int) (BgL_arg2716z00_9150));
						}
						return STRUCT_REF(BgL_arg2715z00_9149, (int) (((long) 0)));
		}}}}
	}



/* &<anonymous:2717> */
	obj_t BGl_z62zc3anonymousza32717ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17447, obj_t BgL_sz00_17448)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 307 */
			{
				obj_t BgL_sz00_2562;

				BgL_sz00_2562 = BgL_sz00_17448;
				{	/* Eval/evaluate_comp.scm 307 */
					obj_t BgL_bpz00_9161;

					BgL_bpz00_9161 = VECTOR_REF(BgL_sz00_2562, (int) (((long) 0)));
					{	/* Eval/evaluate_comp.scm 307 */
						long BgL_arg2719z00_9162;

						BgL_arg2719z00_9162 = ((long) CINT(BgL_bpz00_9161) + ((long) 2));
						return VECTOR_REF(BgL_sz00_2562, (int) (BgL_arg2719z00_9162));
		}}}}
	}



/* &<anonymous:2708> */
	obj_t BGl_z62zc3anonymousza32708ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17449, obj_t BgL_sz00_17450)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 307 */
			{
				obj_t BgL_sz00_2547;

				BgL_sz00_2547 = BgL_sz00_17450;
				{	/* Eval/evaluate_comp.scm 307 */
					obj_t BgL_bpz00_9126;

					BgL_bpz00_9126 = VECTOR_REF(BgL_sz00_2547, (int) (((long) 0)));
					{	/* Eval/evaluate_comp.scm 307 */
						obj_t BgL_arg2709z00_9127;

						{	/* Eval/evaluate_comp.scm 307 */
							long BgL_arg2710z00_9128;

							BgL_arg2710z00_9128 = ((long) CINT(BgL_bpz00_9126) + ((long) 1));
							BgL_arg2709z00_9127 =
								VECTOR_REF(BgL_sz00_2547, (int) (BgL_arg2710z00_9128));
						}
						return STRUCT_REF(BgL_arg2709z00_9127, (int) (((long) 0)));
		}}}}
	}



/* &<anonymous:2711> */
	obj_t BGl_z62zc3anonymousza32711ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17451, obj_t BgL_sz00_17452)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 307 */
			{
				obj_t BgL_sz00_2552;

				BgL_sz00_2552 = BgL_sz00_17452;
				{	/* Eval/evaluate_comp.scm 307 */
					obj_t BgL_bpz00_9139;

					BgL_bpz00_9139 = VECTOR_REF(BgL_sz00_2552, (int) (((long) 0)));
					{	/* Eval/evaluate_comp.scm 307 */
						long BgL_arg2712z00_9140;

						BgL_arg2712z00_9140 = ((long) CINT(BgL_bpz00_9139) + ((long) 1));
						return VECTOR_REF(BgL_sz00_2552, (int) (BgL_arg2712z00_9140));
		}}}}
	}



/* &<anonymous:2702> */
	obj_t BGl_z62zc3anonymousza32702ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17453, obj_t BgL_sz00_17454)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 307 */
			{
				obj_t BgL_sz00_2537;

				BgL_sz00_2537 = BgL_sz00_17454;
				{	/* Eval/evaluate_comp.scm 307 */
					obj_t BgL_bpz00_9104;

					BgL_bpz00_9104 = VECTOR_REF(BgL_sz00_2537, (int) (((long) 0)));
					{	/* Eval/evaluate_comp.scm 307 */
						obj_t BgL_arg2703z00_9105;

						{	/* Eval/evaluate_comp.scm 307 */
							long BgL_arg2704z00_9106;

							BgL_arg2704z00_9106 = ((long) CINT(BgL_bpz00_9104) + ((long) 0));
							BgL_arg2703z00_9105 =
								VECTOR_REF(BgL_sz00_2537, (int) (BgL_arg2704z00_9106));
						}
						return STRUCT_REF(BgL_arg2703z00_9105, (int) (((long) 0)));
		}}}}
	}



/* &<anonymous:2705> */
	obj_t BGl_z62zc3anonymousza32705ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17455, obj_t BgL_sz00_17456)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 307 */
			{
				obj_t BgL_sz00_2542;

				BgL_sz00_2542 = BgL_sz00_17456;
				{	/* Eval/evaluate_comp.scm 307 */
					obj_t BgL_bpz00_9117;

					BgL_bpz00_9117 = VECTOR_REF(BgL_sz00_2542, (int) (((long) 0)));
					{	/* Eval/evaluate_comp.scm 307 */
						long BgL_arg2706z00_9118;

						BgL_arg2706z00_9118 = ((long) CINT(BgL_bpz00_9117) + ((long) 0));
						return VECTOR_REF(BgL_sz00_2542, (int) (BgL_arg2706z00_9118));
		}}}}
	}



/* &<anonymous:2727> */
	obj_t BGl_z62zc3anonymousza32727ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17457, obj_t BgL_sz00_17459)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 307 */
			{	/* Eval/evaluate_comp.scm 307 */
				obj_t BgL_iz00_17458;

				BgL_iz00_17458 = PROCEDURE_REF(BgL_envz00_17457, (int) (((long) 0)));
				{
					obj_t BgL_sz00_2577;

					BgL_sz00_2577 = BgL_sz00_17459;
					{	/* Eval/evaluate_comp.scm 307 */
						obj_t BgL_bpz00_9082;

						BgL_bpz00_9082 = VECTOR_REF(BgL_sz00_2577, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 307 */
							obj_t BgL_arg2728z00_9083;

							{	/* Eval/evaluate_comp.scm 307 */
								long BgL_arg2729z00_9084;

								BgL_arg2729z00_9084 =
									((long) CINT(BgL_bpz00_9082) + (long) CINT(BgL_iz00_17458));
								BgL_arg2728z00_9083 =
									VECTOR_REF(BgL_sz00_2577, (int) (BgL_arg2729z00_9084));
							}
							return STRUCT_REF(BgL_arg2728z00_9083, (int) (((long) 0)));
		}}}}}
	}



/* &<anonymous:2730> */
	obj_t BGl_z62zc3anonymousza32730ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17460, obj_t BgL_sz00_17462)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 307 */
			{	/* Eval/evaluate_comp.scm 307 */
				obj_t BgL_iz00_17461;

				BgL_iz00_17461 = PROCEDURE_REF(BgL_envz00_17460, (int) (((long) 0)));
				{
					obj_t BgL_sz00_2582;

					BgL_sz00_2582 = BgL_sz00_17462;
					{	/* Eval/evaluate_comp.scm 307 */
						obj_t BgL_bpz00_9095;

						BgL_bpz00_9095 = VECTOR_REF(BgL_sz00_2582, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 307 */
							long BgL_arg2731z00_9096;

							BgL_arg2731z00_9096 =
								((long) CINT(BgL_bpz00_9095) + (long) CINT(BgL_iz00_17461));
							return VECTOR_REF(BgL_sz00_2582, (int) (BgL_arg2731z00_9096));
		}}}}}
	}



/* &comp-ev_trap1642 */
	obj_t BGl_z62compzd2ev_trap1642zb0zz__evaluate_compz00(obj_t BgL_envz00_17463,
		obj_t BgL_ez00_17464, obj_t BgL_stkz00_17465)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 277 */
			{
				BgL_ev_trapz00_bglt BgL_ez00_2509;
				obj_t BgL_stkz00_2510;

				BgL_ez00_2509 = ((BgL_ev_trapz00_bglt) BgL_ez00_17464);
				BgL_stkz00_2510 = BgL_stkz00_17465;
				{	/* Eval/evaluate_comp.scm 279 */
					obj_t BgL_ez00_2514;

					{	/* Eval/evaluate_comp.scm 279 */
						BgL_ev_exprz00_bglt BgL_arg2699z00_2525;

						BgL_arg2699z00_2525 =
							(((BgL_ev_hookz00_bglt) CREF(
									((BgL_ev_hookz00_bglt) BgL_ez00_2509)))->BgL_ez00);
						BgL_ez00_2514 =
							BGl_compz00zz__evaluate_compz00(BgL_arg2699z00_2525,
							BgL_stkz00_2510);
					}
					{	/* Eval/evaluate_comp.scm 280 */
						obj_t BgL_zc3anonymousza32693ze3z83_16319;

						BgL_zc3anonymousza32693ze3z83_16319 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3anonymousza32693ze3ze1zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 1)));
						PROCEDURE_SET(BgL_zc3anonymousza32693ze3z83_16319,
							(int) (((long) 0)), BgL_ez00_2514);
						return BgL_zc3anonymousza32693ze3z83_16319;
					}
				}
			}
		}
	}



/* &<anonymous:2693> */
	obj_t BGl_z62zc3anonymousza32693ze3ze1zz__evaluate_compz00(obj_t
		BgL_envz00_17466, obj_t BgL_sz00_17468)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 280 */
			{	/* Eval/evaluate_comp.scm 280 */
				obj_t BgL_ez00_17467;

				BgL_ez00_17467 = PROCEDURE_REF(BgL_envz00_17466, (int) (((long) 0)));
				{
					obj_t BgL_sz00_2515;

					BgL_sz00_2515 = BgL_sz00_17468;
					{	/* Eval/evaluate_comp.scm 280 */
						obj_t BgL_bpz00_2517;

						BgL_bpz00_2517 = VECTOR_REF(BgL_sz00_2515, (int) (((long) 0)));
						{	/* Eval/evaluate_comp.scm 281 */
							obj_t BgL_cmdz00_2518;

							BgL_cmdz00_2518 =
								PROCEDURE_ENTRY(BgL_ez00_17467) (BgL_ez00_17467, BgL_sz00_2515,
								BEOA);
							if ((BgL_cmdz00_2518 == BGl_symbol5693z00zz__evaluate_compz00))
								{	/* Eval/evaluate_comp.scm 282 */
									return BgL_bpz00_2517;
								}
							else
								{	/* Eval/evaluate_comp.scm 282 */
									if (
										(BgL_cmdz00_2518 == BGl_symbol5695z00zz__evaluate_compz00))
										{	/* Eval/evaluate_comp.scm 282 */
											return BGl_reset_profilez00zz__evaluate_compz00();
										}
									else
										{	/* Eval/evaluate_comp.scm 282 */
											if (
												(BgL_cmdz00_2518 ==
													BGl_symbol5697z00zz__evaluate_compz00))
												{	/* Eval/evaluate_comp.scm 282 */
													return BGl_get_profilez00zz__evaluate_compz00();
												}
											else
												{	/* Eval/evaluate_comp.scm 282 */
													if (
														(BgL_cmdz00_2518 ==
															BGl_symbol5699z00zz__evaluate_compz00))
														{	/* Eval/evaluate_comp.scm 282 */
															return
																VECTOR_SET
																(BGl_findzd2statezd2zz__evaluate_compz00(),
																(int) (((long) 0)), BINT(((long) 2)));
														}
													else
														{	/* Eval/evaluate_comp.scm 282 */
															return
																BGl_errorz00zz__errorz00
																(BGl_string5561z00zz__evaluate_compz00,
																BGl_string5701z00zz__evaluate_compz00,
																BgL_cmdz00_2518);
														}
												}
										}
								}
						}
					}
				}
			}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_compz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_comp.scm 15 */
			BGl_modulezd2initializa7ationz75zz__typez00(((long) 77607588),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 373318193),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 162724851),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__tvectorz00(((long) 135276775),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 128218210),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 258585428),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__bignumz00(((long) 6519932),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 438451175),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 443936801),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 317260169),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 441709255),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 1041382),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__threadz00(((long) 316564000),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__srfi4z00(((long) 289341023),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 359798486),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)
					249410258), BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)
					247617611), BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)
					268155843), BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)
					198620800), BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)
					473309430), BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 459519430),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 460263214),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 97251556),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)
					47127928), BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)
					317842797), BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)
					228151370), BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 509771705),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 162479995),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)
					116655667), BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__ppz00(((long) 233942021),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 220648206),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__prognz00(((long) 177147622),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__expandz00(((long) 511051588),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evenvz00(((long) 23062368),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evcompilez00(((long) 492754569),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__everrorz00(((long) 375872221),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evmodulez00(((long) 6183155),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(((long) 0),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(((long) 193509656),
				BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
			return BGl_modulezd2initializa7ationz75zz__evaluate_usez00(((long)
					20669940), BSTRING_TO_STRING(BGl_string5702z00zz__evaluate_compz00));
		}
	}

#ifdef __cplusplus
}
#endif
