/*===========================================================================*/
/*   (Eval/evaluate_types.scm)                                               */
/*   Bigloo (4.0a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jan 24 17:03:30 CET 2013        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -srfi enable-gmp -srfi bigloo-unsafe -O3 -fcfa-arithmetic -q +rm -lib-dir /users/serrano/prgm/project/bigloo/lib/4.0a -mklib -cc gcc -fsharing -q -no-hello -copt -fPIC -unsafe -safee -O4 -c Eval/evaluate_types.scm -indent -o objs/obj_u/Eval/evaluate_types.c)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_ev_exprz00_bgl
	{
		header_t header;
		obj_t widening;
	}                 *BgL_ev_exprz00_bglt;

	typedef struct BgL_ev_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_namez00;
		obj_t BgL_effz00;
		obj_t BgL_typez00;
	}                *BgL_ev_varz00_bglt;

	typedef struct BgL_ev_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                   *BgL_ev_globalz00_bglt;

	typedef struct BgL_ev_littz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_valuez00;
	}                 *BgL_ev_littz00_bglt;

	typedef struct BgL_ev_ifz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_pz00;
		struct BgL_ev_exprz00_bgl *BgL_tz00;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}               *BgL_ev_ifz00_bglt;

	typedef struct BgL_ev_listz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                 *BgL_ev_listz00_bglt;

	typedef struct BgL_ev_orz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}               *BgL_ev_orz00_bglt;

	typedef struct BgL_ev_andz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                *BgL_ev_andz00_bglt;

	typedef struct BgL_ev_prog2z00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_e1z00;
		struct BgL_ev_exprz00_bgl *BgL_e2z00;
	}                  *BgL_ev_prog2z00_bglt;

	typedef struct BgL_ev_hookz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_hookz00_bglt;

	typedef struct BgL_ev_trapz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_trapz00_bglt;

	typedef struct BgL_ev_setlocalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_varz00_bgl *BgL_vz00;
	}                     *BgL_ev_setlocalz00_bglt;

	typedef struct BgL_ev_setglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_setglobalz00_bglt;

	typedef struct BgL_ev_defglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_defglobalz00_bglt;

	typedef struct BgL_ev_bindzd2exitzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_varz00_bgl *BgL_varz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                        *BgL_ev_bindzd2exitzd2_bglt;

	typedef struct BgL_ev_unwindzd2protectzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                             *BgL_ev_unwindzd2protectzd2_bglt;

	typedef struct BgL_ev_withzd2handlerzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_handlerz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                           *BgL_ev_withzd2handlerzd2_bglt;

	typedef struct BgL_ev_synchroniza7eza7_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_mutexz00;
		struct BgL_ev_exprz00_bgl *BgL_prelockz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                          *BgL_ev_synchroniza7eza7_bglt;

	typedef struct BgL_ev_binderz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_binderz00_bglt;

	typedef struct BgL_ev_letz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_letz00_bglt;

	typedef struct BgL_ev_letza2za2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_letza2za2_bglt;

	typedef struct BgL_ev_letrecz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_letrecz00_bglt;

	typedef struct BgL_ev_labelsz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		obj_t BgL_envz00;
		obj_t BgL_stkz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_labelsz00_bglt;

	typedef struct BgL_ev_gotoz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_varz00_bgl *BgL_labelz00;
		struct BgL_ev_labelsz00_bgl *BgL_labelsz00;
		obj_t BgL_argsz00;
	}                 *BgL_ev_gotoz00_bglt;

	typedef struct BgL_ev_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_tailzf3zf3;
	}                *BgL_ev_appz00_bglt;

	typedef struct BgL_ev_absz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_wherez00;
		obj_t BgL_arityz00;
		obj_t BgL_varsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		int BgL_siza7eza7;
		obj_t BgL_bindz00;
		obj_t BgL_freez00;
		obj_t BgL_innerz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_absz00_bglt;


	static BgL_ev_exprz00_bglt BGl_z62lambda1765z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1766z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2562z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2568z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza32035ze3ze1zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1931z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1932z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1772z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1773z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1936z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1937z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_withzd2handlerzd2_bglt
		BGl_z62lambda1779z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2572z00zz__evaluate_typesz00 = BUNSPEC;
	extern obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
	static obj_t BGl_symbol2577z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_withzd2handlerzd2_bglt
		BGl_z62lambda1781z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_gotoz00_bglt BGl_z62lambda1944z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_ev_gotoz00_bglt BGl_z62lambda1946z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1787z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1788z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2582z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2587z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1952z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1953z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1792z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1793z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_labelsz00_bglt BGl_z62lambda1958z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1959z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_synchroniza7eza7_bglt
		BGl_z62lambda1799z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2595z00zz__evaluate_typesz00 = BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_letrecz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_varz00_bglt BGl_z62lambda1963z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1964z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_appz00_bglt
		BGl_z62zc3anonymousza31979ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1968z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1969z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_appz00_bglt BGl_z62lambda1975z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_letz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_appz00_bglt BGl_z62lambda1977z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1983z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1984z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1988z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1989z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_objectzd2initzd2zz__evaluate_typesz00();
	static BgL_ev_exprz00_bglt BGl_z62lambda1994z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1995z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1999z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31507ze3ze1zz__evaluate_typesz00(obj_t);
	extern obj_t bstring_to_symbol(obj_t);
	static BgL_ev_andz00_bglt
		BGl_z62zc3anonymousza31630ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_setglobalz00_bglt
		BGl_z62zc3anonymousza31703ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_labelsz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_globalz00_bglt
		BGl_z62zc3anonymousza31526ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zz__evaluate_typesz00();
	BGL_EXPORTED_DEF obj_t BGl_ev_absz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_labelsz00_bglt
		BGl_z62zc3anonymousza31900ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_littz00_bglt
		BGl_z62zc3anonymousza31560ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_ifz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_bindzd2exitzd2_bglt
		BGl_z62zc3anonymousza31740ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31920ze3ze1zz__evaluate_typesz00(obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_gotoz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_unwindzd2protectzd2_bglt
		BGl_z62zc3anonymousza31760ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31907ze3ze1zz__evaluate_typesz00(obj_t);
	static BgL_ev_varz00_bglt
		BGl_z62zc3anonymousza31494ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_defglobalz00_bglt
		BGl_z62zc3anonymousza31729ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_orz00zz__evaluate_typesz00 = BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_varz00zz__evaluate_typesz00 = BUNSPEC;
	extern obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t,
		long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_andz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_listz00_bglt BGl_z62lambda1600z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_listz00_bglt BGl_z62lambda1602z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_letz00_bglt
		BGl_z62zc3anonymousza31854ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31927ze3ze1zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1609z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_symbol2404z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2408z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1610z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_orz00_bglt BGl_z62lambda1616z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_orz00_bglt BGl_z62lambda1618z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_symbol2414z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2419z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza32020ze3ze1zz__evaluate_typesz00(obj_t);
	static BgL_ev_andz00_bglt BGl_z62lambda1626z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_withzd2handlerzd2_bglt
		BGl_z62zc3anonymousza31783ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_andz00_bglt BGl_z62lambda1628z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_trapz00_bglt
		BGl_z62zc3anonymousza31678ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_appz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2423z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2428z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_letza2za2_bglt
		BGl_z62zc3anonymousza31873ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_prog2z00_bglt BGl_z62lambda1636z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t);
	static BgL_ev_prog2z00_bglt BGl_z62lambda1638z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1477z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1479z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_symbol2432z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2436z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_synchroniza7eza7_bglt
		BGl_z62lambda1801z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_letrecz00_bglt
		BGl_z62zc3anonymousza31890ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1644z62zz__evaluate_typesz00(obj_t,
		obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1645z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1807z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1808z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2600z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2440z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2445z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2449z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_exprz00_bglt BGl_z62lambda1650z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1812z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1651z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1813z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_varz00_bglt BGl_z62lambda1490z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_ev_varz00_bglt BGl_z62lambda1492z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1817z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1818z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_gotoz00_bglt
		BGl_z62zc3anonymousza31948ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_hookz00_bglt BGl_z62lambda1657z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_hookz00_bglt BGl_z62lambda1659z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1498z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1499z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2610z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2615z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2454z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2459z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_binderz00_bglt BGl_z62lambda1824z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_ev_binderz00_bglt BGl_z62lambda1826z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1667z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1668z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2624z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2464z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2468z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_exprz00_bglt BGl_z62lambda1832z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1833z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_trapz00_bglt BGl_z62lambda1674z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1837z62zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_trapz00_bglt BGl_z62lambda1676z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1838z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2630z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2634z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2472z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2477z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1842z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1843z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_setlocalz00_bglt
		BGl_z62lambda1684z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_setlocalz00_bglt
		BGl_z62lambda1686z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_symbol2641z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2645z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2484z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza32043ze3ze1zz__evaluate_typesz00(obj_t);
	static obj_t BGl_symbol2489z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza32027ze3ze1zz__evaluate_typesz00(obj_t);
	static BgL_ev_letz00_bglt BGl_z62lambda1850z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_ev_letz00_bglt BGl_z62lambda1852z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_varz00_bglt BGl_z62lambda1692z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1693z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_defglobalz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_setglobalz00_bglt
		BGl_z62lambda1699z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_symbol2651z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2493z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2658z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2498z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_requirezd2initializa7ationz75zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1860z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1861z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_letza2za2_bglt BGl_z62lambda1869z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2666z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_letza2za2_bglt BGl_z62lambda1871z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1878z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1879z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2671z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2676z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_letrecz00_bglt BGl_z62lambda1886z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_ev_letrecz00_bglt BGl_z62lambda1888z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_symbol2681z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2683z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_toplevelzd2initzd2zz__evaluate_typesz00();
	static BgL_ev_labelsz00_bglt BGl_z62lambda1896z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	static BgL_ev_labelsz00_bglt BGl_z62lambda1898z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_symbol2691z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2695z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_genericzd2initzd2zz__evaluate_typesz00();
	BGL_EXPORTED_DEF obj_t BGl_ev_prog2z00zz__evaluate_typesz00 = BUNSPEC;
	extern obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t,
		bool_t, bool_t, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_orz00_bglt
		BGl_z62zc3anonymousza31620ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_listz00_bglt
		BGl_z62zc3anonymousza31604ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00 =
		BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_letza2za2zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_prog2z00_bglt
		BGl_z62zc3anonymousza31640ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_trapz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_synchroniza7eza7_bglt
		BGl_z62zc3anonymousza31803ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_setglobalz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda2000z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt
		BGl_z62zc3anonymousza31481ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_absz00_bglt BGl_z62lambda2009z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_hookz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_absz00_bglt BGl_z62lambda2011z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda2018z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2019z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda2025z62zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_hookz00_bglt
		BGl_z62zc3anonymousza31661ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2026z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda2033z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2034z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda2041z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2042z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda2048z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2049z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
	BGL_EXPORTED_DEF obj_t BGl_ev_globalz00zz__evaluate_typesz00 = BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_binderz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_exprz00_bglt BGl_z62lambda2054z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda2055z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_listz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda2060z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2061z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda2065z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2066z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_littz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda2070z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2071z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1505z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1506z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda2075z62zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_binderz00_bglt
		BGl_z62zc3anonymousza31828ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda2076z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_cnstzd2initzd2zz__evaluate_typesz00();
	static obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_typesz00();
	static obj_t BGl_z62lambda1511z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1512z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_globalz00_bglt BGl_z62lambda1519z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_ev_ifz00_bglt
		BGl_z62zc3anonymousza31578ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00 =
		BUNSPEC;
	static BgL_ev_globalz00_bglt BGl_z62lambda1521z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62zc3anonymousza31862ze3ze1zz__evaluate_typesz00(obj_t);
	extern obj_t BGl_objectz00zz__objectz00;
	static obj_t BGl_z62lambda1535z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1536z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_setglobalz00_bglt
		BGl_z62lambda1701z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1541z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1542z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31880ze3ze1zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1546z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1708z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1547z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1709z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_ev_exprz00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2509z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_absz00_bglt
		BGl_z62zc3anonymousza32013ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1713z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1714z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_littz00_bglt BGl_z62lambda1555z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1718z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1719z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_littz00_bglt BGl_z62lambda1558z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_symbol2514z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2518z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_defglobalz00_bglt
		BGl_z62lambda1725z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static BgL_ev_defglobalz00_bglt
		BGl_z62lambda1727z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_z62lambda1566z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1567z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_setlocalz00_bglt
		BGl_z62zc3anonymousza31688ze3ze1zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_symbol2522z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2527z00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_ifz00_bglt BGl_z62lambda1574z62zz__evaluate_typesz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_ev_bindzd2exitzd2_bglt
		BGl_z62lambda1736z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_ifz00_bglt BGl_z62lambda1576z62zz__evaluate_typesz00(obj_t);
	static BgL_ev_bindzd2exitzd2_bglt
		BGl_z62lambda1738z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_symbol2536z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1905z62zz__evaluate_typesz00(obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1582z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1744z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1906z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1583z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1745z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1587z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static BgL_ev_varz00_bglt BGl_z62lambda1749z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1588z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol2702z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2704z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2542z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2380z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2382z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2547z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2386z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2388z00zz__evaluate_typesz00 = BUNSPEC;
	BGL_EXPORTED_DEF obj_t BGl_ev_setlocalz00zz__evaluate_typesz00 = BUNSPEC;
	static BgL_ev_exprz00_bglt BGl_z62lambda1911z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1750z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1912z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_exprz00_bglt BGl_z62lambda1593z62zz__evaluate_typesz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1594z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_unwindzd2protectzd2_bglt
		BGl_z62lambda1756z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62lambda1918z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1919z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static BgL_ev_unwindzd2protectzd2_bglt
		BGl_z62lambda1758z62zz__evaluate_typesz00(obj_t);
	static obj_t BGl_symbol2553z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2393z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2557z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza32050ze3ze1zz__evaluate_typesz00(obj_t);
	static obj_t BGl_symbol2397z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_symbol2399z00zz__evaluate_typesz00 = BUNSPEC;
	static obj_t BGl_z62lambda1925z62zz__evaluate_typesz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1926z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
	static obj_t *__cnst;


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2401z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72706za7,
		BGl_z62zc3anonymousza31494ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2402z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1492za7622707z00,
		BGl_z62lambda1492z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2403z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1490za7622708z00,
		BGl_z62lambda1490z62zz__evaluate_typesz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2406z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1536za7622709z00,
		BGl_z62lambda1536z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2407z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1535za7622710z00,
		BGl_z62lambda1535z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2410z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1542za7622711z00,
		BGl_z62lambda1542z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2411z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1541za7622712z00,
		BGl_z62lambda1541z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2412z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1547za7622713z00,
		BGl_z62lambda1547z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2413z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1546za7622714z00,
		BGl_z62lambda1546z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2416z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72715za7,
		BGl_z62zc3anonymousza31526ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2417z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1521za7622716z00,
		BGl_z62lambda1521z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2418z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1519za7622717z00,
		BGl_z62lambda1519z62zz__evaluate_typesz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2421z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1567za7622718z00,
		BGl_z62lambda1567z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2422z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1566za7622719z00,
		BGl_z62lambda1566z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2510z00zz__evaluate_typesz00,
		BgL_bgl_string2510za700za7za7_2720za7, "ev_setglobal", 12);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2425z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72721za7,
		BGl_z62zc3anonymousza31560ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2426z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1558za7622722z00,
		BGl_z62lambda1558z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2427z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1555za7622723z00,
		BGl_z62lambda1555z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2515z00zz__evaluate_typesz00,
		BgL_bgl_string2515za700za7za7_2724za7, "ev_defglobal", 12);
	      DEFINE_STRING(BGl_string2519z00zz__evaluate_typesz00,
		BgL_bgl_string2519za700za7za7_2725za7, "body", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2430z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1583za7622726z00,
		BGl_z62lambda1583z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2431z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1582za7622727z00,
		BGl_z62lambda1582z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2434z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1588za7622728z00,
		BGl_z62lambda1588z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2435z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1587za7622729z00,
		BGl_z62lambda1587z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2523z00zz__evaluate_typesz00,
		BgL_bgl_string2523za700za7za7_2730za7, "var", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2438z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1594za7622731z00,
		BGl_z62lambda1594z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2439z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1593za7622732z00,
		BGl_z62lambda1593z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2528z00zz__evaluate_typesz00,
		BgL_bgl_string2528za700za7za7_2733za7, "ev_bind-exit", 12);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2602z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72734za7,
		BGl_z62zc3anonymousza31907ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2603z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1906za7622735z00,
		BGl_z62lambda1906z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2604z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1905za7622736z00,
		BGl_z62lambda1905z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2442z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72737za7,
		BGl_z62zc3anonymousza31578ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2605z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1912za7622738z00,
		BGl_z62lambda1912z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2443z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1576za7622739z00,
		BGl_z62lambda1576z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2606z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1911za7622740z00,
		BGl_z62lambda1911z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2444z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1574za7622741z00,
		BGl_z62lambda1574z62zz__evaluate_typesz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2607z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72742za7,
		BGl_z62zc3anonymousza31920ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2608z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1919za7622743z00,
		BGl_z62lambda1919z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2609z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1918za7622744z00,
		BGl_z62lambda1918z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2447z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1610za7622745z00,
		BGl_z62lambda1610z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2448z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1609za7622746z00,
		BGl_z62lambda1609z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2537z00zz__evaluate_typesz00,
		BgL_bgl_string2537za700za7za7_2747za7, "ev_unwind-protect", 17);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2612z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72748za7,
		BGl_z62zc3anonymousza31927ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2613z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1926za7622749z00,
		BGl_z62lambda1926z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2451z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72750za7,
		BGl_z62zc3anonymousza31604ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2614z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1925za7622751z00,
		BGl_z62lambda1925z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2452z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1602za7622752z00,
		BGl_z62lambda1602z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2453z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1600za7622753z00,
		BGl_z62lambda1600z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2703z00zz__evaluate_typesz00,
		BgL_bgl_string2703za700za7za7_2754za7, "ev_abs", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2617z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1932za7622755z00,
		BGl_z62lambda1932z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2705z00zz__evaluate_typesz00,
		BgL_bgl_string2705za700za7za7_2756za7, "_", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2618z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1931za7622757z00,
		BGl_z62lambda1931z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2543z00zz__evaluate_typesz00,
		BgL_bgl_string2543za700za7za7_2758za7, "handler", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2456z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72759za7,
		BGl_z62zc3anonymousza31620ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2381z00zz__evaluate_typesz00,
		BgL_bgl_string2381za700za7za7_2760za7, "ev_expr", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2619z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1937za7622761z00,
		BGl_z62lambda1937z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2457z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1618za7622762z00,
		BGl_z62lambda1618z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2458z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1616za7622763z00,
		BGl_z62lambda1616z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2383z00zz__evaluate_typesz00,
		BgL_bgl_string2383za700za7za7_2764za7, "__evaluate_types", 16);
	      DEFINE_STRING(BGl_string2548z00zz__evaluate_typesz00,
		BgL_bgl_string2548za700za7za7_2765za7, "ev_with-handler", 15);
	      DEFINE_STRING(BGl_string2387z00zz__evaluate_typesz00,
		BgL_bgl_string2387za700za7za7_2766za7, "type", 4);
	      DEFINE_STRING(BGl_string2389z00zz__evaluate_typesz00,
		BgL_bgl_string2389za700za7za7_2767za7, "obj", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2620z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1936za7622768z00,
		BGl_z62lambda1936z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2621z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72769za7,
		BGl_z62zc3anonymousza31900ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2622z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1898za7622770z00,
		BGl_z62lambda1898z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2623z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1896za7622771z00,
		BGl_z62lambda1896z62zz__evaluate_typesz00, 0L, BUNSPEC, 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2461z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72772za7,
		BGl_z62zc3anonymousza31630ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2462z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1628za7622773z00,
		BGl_z62lambda1628z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2463z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1626za7622774z00,
		BGl_z62lambda1626z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2626z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1953za7622775z00,
		BGl_z62lambda1953z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2627z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1952za7622776z00,
		BGl_z62lambda1952z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2628z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1959za7622777z00,
		BGl_z62lambda1959z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2466z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1645za7622778z00,
		BGl_z62lambda1645z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2629z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1958za7622779z00,
		BGl_z62lambda1958z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2554z00zz__evaluate_typesz00,
		BgL_bgl_string2554za700za7za7_2780za7, "prelock", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2467z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1644za7622781z00,
		BGl_z62lambda1644z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2394z00zz__evaluate_typesz00,
		BgL_bgl_string2394za700za7za7_2782za7, "eff", 3);
	      DEFINE_STRING(BGl_string2558z00zz__evaluate_typesz00,
		BgL_bgl_string2558za700za7za7_2783za7, "mutex", 5);
	      DEFINE_STRING(BGl_string2398z00zz__evaluate_typesz00,
		BgL_bgl_string2398za700za7za7_2784za7, "name", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2632z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1964za7622785z00,
		BGl_z62lambda1964z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2470z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1651za7622786z00,
		BGl_z62lambda1651z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2633z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1963za7622787z00,
		BGl_z62lambda1963z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2471z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1650za7622788z00,
		BGl_z62lambda1650z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2636z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1969za7622789z00,
		BGl_z62lambda1969z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2474z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72790za7,
		BGl_z62zc3anonymousza31640ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2637z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1968za7622791z00,
		BGl_z62lambda1968z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2475z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1638za7622792z00,
		BGl_z62lambda1638z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2638z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72793za7,
		BGl_z62zc3anonymousza31948ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2563z00zz__evaluate_typesz00,
		BgL_bgl_string2563za700za7za7_2794za7, "ev_synchronize", 14);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2476z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1636za7622795z00,
		BGl_z62lambda1636z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2639z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1946za7622796z00,
		BGl_z62lambda1946z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2479z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1668za7622797z00,
		BGl_z62lambda1668z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2569z00zz__evaluate_typesz00,
		BgL_bgl_string2569za700za7za7_2798za7, "vals", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2640z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1944za7622799z00,
		BGl_z62lambda1944z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2480z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1667za7622800z00,
		BGl_z62lambda1667z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2643z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1984za7622801z00,
		BGl_z62lambda1984z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2481z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72802za7,
		BGl_z62zc3anonymousza31661ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2644z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1983za7622803z00,
		BGl_z62lambda1983z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2482z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1659za7622804z00,
		BGl_z62lambda1659z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2483z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1657za7622805z00,
		BGl_z62lambda1657z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2647z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1989za7622806z00,
		BGl_z62lambda1989z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2648z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1988za7622807z00,
		BGl_z62lambda1988z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2573z00zz__evaluate_typesz00,
		BgL_bgl_string2573za700za7za7_2808za7, "vars", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2486z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72809za7,
		BGl_z62zc3anonymousza31678ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2649z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1995za7622810z00,
		BGl_z62lambda1995z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2487z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1676za7622811z00,
		BGl_z62lambda1676z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2488z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1674za7622812z00,
		BGl_z62lambda1674z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2578z00zz__evaluate_typesz00,
		BgL_bgl_string2578za700za7za7_2813za7, "ev_binder", 9);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2650z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1994za7622814z00,
		BGl_z62lambda1994z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2653z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2000za7622815z00,
		BGl_z62lambda2000z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2491z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1693za7622816z00,
		BGl_z62lambda1693z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2654z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1999za7622817z00,
		BGl_z62lambda1999z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2492z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1692za7622818z00,
		BGl_z62lambda1692z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2655z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72819za7,
		BGl_z62zc3anonymousza31979ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2656z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1977za7622820z00,
		BGl_z62lambda1977z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2657z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1975za7622821z00,
		BGl_z62lambda1975z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2495z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72822za7,
		BGl_z62zc3anonymousza31688ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2583z00zz__evaluate_typesz00,
		BgL_bgl_string2583za700za7za7_2823za7, "boxes", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2496z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1686za7622824z00,
		BGl_z62lambda1686z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2497z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1684za7622825z00,
		BGl_z62lambda1684z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2588z00zz__evaluate_typesz00,
		BgL_bgl_string2588za700za7za7_2826za7, "ev_let", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2660z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72827za7,
		BGl_z62zc3anonymousza32020ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2661z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2019za7622828z00,
		BGl_z62lambda2019z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2662z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2018za7622829z00,
		BGl_z62lambda2018z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2663z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72830za7,
		BGl_z62zc3anonymousza32027ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2664z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2026za7622831z00,
		BGl_z62lambda2026z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2665z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2025za7622832z00,
		BGl_z62lambda2025z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2668z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72833za7,
		BGl_z62zc3anonymousza32035ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2669z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2034za7622834z00,
		BGl_z62lambda2034z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2596z00zz__evaluate_typesz00,
		BgL_bgl_string2596za700za7za7_2835za7, "ev_let*", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2670z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2033za7622836z00,
		BGl_z62lambda2033z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2673z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72837za7,
		BGl_z62zc3anonymousza32043ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2674z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2042za7622838z00,
		BGl_z62lambda2042z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2675z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2041za7622839z00,
		BGl_z62lambda2041z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2678z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72840za7,
		BGl_z62zc3anonymousza32050ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2679z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2049za7622841z00,
		BGl_z62lambda2049z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2680z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2048za7622842z00,
		BGl_z62lambda2048z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2685z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2055za7622843z00,
		BGl_z62lambda2055z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2686z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2054za7622844z00,
		BGl_z62lambda2054z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2687z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2061za7622845z00,
		BGl_z62lambda2061z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2688z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2060za7622846z00,
		BGl_z62lambda2060z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2689z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2066za7622847z00,
		BGl_z62lambda2066z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2690z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2065za7622848z00,
		BGl_z62lambda2065z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2693z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2071za7622849z00,
		BGl_z62lambda2071z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2694z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2070za7622850z00,
		BGl_z62lambda2070z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2697z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2076za7622851z00,
		BGl_z62lambda2076z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2698z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2075za7622852z00,
		BGl_z62lambda2075z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2699z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72853za7,
		BGl_z62zc3anonymousza32013ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2400z00zz__evaluate_typesz00,
		BgL_bgl_string2400za700za7za7_2854za7, "symbol", 6);
	      DEFINE_STRING(BGl_string2405z00zz__evaluate_typesz00,
		BgL_bgl_string2405za700za7za7_2855za7, "ev_var", 6);
	      DEFINE_STRING(BGl_string2409z00zz__evaluate_typesz00,
		BgL_bgl_string2409za700za7za7_2856za7, "mod", 3);
	      DEFINE_STRING(BGl_string2415z00zz__evaluate_typesz00,
		BgL_bgl_string2415za700za7za7_2857za7, "loc", 3);
	      DEFINE_STRING(BGl_string2420z00zz__evaluate_typesz00,
		BgL_bgl_string2420za700za7za7_2858za7, "ev_global", 9);
	      DEFINE_STRING(BGl_string2424z00zz__evaluate_typesz00,
		BgL_bgl_string2424za700za7za7_2859za7, "value", 5);
	      DEFINE_STRING(BGl_string2429z00zz__evaluate_typesz00,
		BgL_bgl_string2429za700za7za7_2860za7, "ev_litt", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2500z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1709za7622861z00,
		BGl_z62lambda1709z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2501z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1708za7622862z00,
		BGl_z62lambda1708z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2502z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1714za7622863z00,
		BGl_z62lambda1714z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2503z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1713za7622864z00,
		BGl_z62lambda1713z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2504z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1719za7622865z00,
		BGl_z62lambda1719z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2505z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1718za7622866z00,
		BGl_z62lambda1718z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2506z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72867za7,
		BGl_z62zc3anonymousza31703ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2507z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1701za7622868z00,
		BGl_z62lambda1701z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2508z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1699za7622869z00,
		BGl_z62lambda1699z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STRING(BGl_string2433z00zz__evaluate_typesz00,
		BgL_bgl_string2433za700za7za7_2870za7, "e", 1);
	      DEFINE_STRING(BGl_string2437z00zz__evaluate_typesz00,
		BgL_bgl_string2437za700za7za7_2871za7, "t", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2511z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72872za7,
		BGl_z62zc3anonymousza31729ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2512z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1727za7622873z00,
		BGl_z62lambda1727z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2513z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1725za7622874z00,
		BGl_z62lambda1725z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STRING(BGl_string2601z00zz__evaluate_typesz00,
		BgL_bgl_string2601za700za7za7_2875za7, "ev_letrec", 9);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2516z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1745za7622876z00,
		BGl_z62lambda1745z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2441z00zz__evaluate_typesz00,
		BgL_bgl_string2441za700za7za7_2877za7, "p", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2517z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1744za7622878z00,
		BGl_z62lambda1744z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2446z00zz__evaluate_typesz00,
		BgL_bgl_string2446za700za7za7_2879za7, "ev_if", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2520z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1750za7622880z00,
		BGl_z62lambda1750z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2521z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1749za7622881z00,
		BGl_z62lambda1749z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2611z00zz__evaluate_typesz00,
		BgL_bgl_string2611za700za7za7_2882za7, "stk", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2524z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72883za7,
		BGl_z62zc3anonymousza31740ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2525z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1738za7622884z00,
		BGl_z62lambda1738z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string2450z00zz__evaluate_typesz00,
		BgL_bgl_string2450za700za7za7_2885za7, "args", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2526z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1736za7622886z00,
		BGl_z62lambda1736z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2616z00zz__evaluate_typesz00,
		BgL_bgl_string2616za700za7za7_2887za7, "env", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2529z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1766za7622888z00,
		BGl_z62lambda1766z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2455z00zz__evaluate_typesz00,
		BgL_bgl_string2455za700za7za7_2889za7, "ev_list", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2530z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1765za7622890z00,
		BGl_z62lambda1765z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2531z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1773za7622891z00,
		BGl_z62lambda1773z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2532z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1772za7622892z00,
		BGl_z62lambda1772z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2533z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72893za7,
		BGl_z62zc3anonymousza31760ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2534z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1758za7622894z00,
		BGl_z62lambda1758z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2535z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1756za7622895z00,
		BGl_z62lambda1756z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2460z00zz__evaluate_typesz00,
		BgL_bgl_string2460za700za7za7_2896za7, "ev_or", 5);
	      DEFINE_STRING(BGl_string2625z00zz__evaluate_typesz00,
		BgL_bgl_string2625za700za7za7_2897za7, "ev_labels", 9);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2538z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1788za7622898z00,
		BGl_z62lambda1788z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2539z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1787za7622899z00,
		BGl_z62lambda1787z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2377z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72900za7,
		BGl_z62zc3anonymousza31481ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2465z00zz__evaluate_typesz00,
		BgL_bgl_string2465za700za7za7_2901za7, "ev_and", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2378z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1479za7622902z00,
		BGl_z62lambda1479z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2379z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1477za7622903z00,
		BGl_z62lambda1477z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string2469z00zz__evaluate_typesz00,
		BgL_bgl_string2469za700za7za7_2904za7, "e2", 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2700z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2011za7622905z00,
		BGl_z62lambda2011z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2701z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda2009za7622906z00,
		BGl_z62lambda2009z62zz__evaluate_typesz00, 0L, BUNSPEC, 10);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2540z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1793za7622907z00,
		BGl_z62lambda1793z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2541z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1792za7622908z00,
		BGl_z62lambda1792z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2631z00zz__evaluate_typesz00,
		BgL_bgl_string2631za700za7za7_2909za7, "labels", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2544z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72910za7,
		BGl_z62zc3anonymousza31783ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2545z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1781za7622911z00,
		BGl_z62lambda1781z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2546z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1779za7622912z00,
		BGl_z62lambda1779z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2384z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1499za7622913z00,
		BGl_z62lambda1499z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2385z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1498za7622914z00,
		BGl_z62lambda1498z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2635z00zz__evaluate_typesz00,
		BgL_bgl_string2635za700za7za7_2915za7, "label", 5);
	      DEFINE_STRING(BGl_string2473z00zz__evaluate_typesz00,
		BgL_bgl_string2473za700za7za7_2916za7, "e1", 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2549z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1808za7622917z00,
		BGl_z62lambda1808z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2478z00zz__evaluate_typesz00,
		BgL_bgl_string2478za700za7za7_2918za7, "ev_prog2", 8);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2550z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1807za7622919z00,
		BGl_z62lambda1807z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2551z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1813za7622920z00,
		BGl_z62lambda1813z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2552z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1812za7622921z00,
		BGl_z62lambda1812z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2390z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72922za7,
		BGl_z62zc3anonymousza31507ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2391z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1506za7622923z00,
		BGl_z62lambda1506z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2392z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1505za7622924z00,
		BGl_z62lambda1505z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2642z00zz__evaluate_typesz00,
		BgL_bgl_string2642za700za7za7_2925za7, "ev_goto", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2555z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1818za7622926z00,
		BGl_z62lambda1818z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2556z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1817za7622927z00,
		BGl_z62lambda1817z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2395z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1512za7622928z00,
		BGl_z62lambda1512z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2396z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1511za7622929z00,
		BGl_z62lambda1511z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2646z00zz__evaluate_typesz00,
		BgL_bgl_string2646za700za7za7_2930za7, "tail?", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2559z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72931za7,
		BGl_z62zc3anonymousza31803ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2485z00zz__evaluate_typesz00,
		BgL_bgl_string2485za700za7za7_2932za7, "ev_hook", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2560z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1801za7622933z00,
		BGl_z62lambda1801z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2561z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1799za7622934z00,
		BGl_z62lambda1799z62zz__evaluate_typesz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2564z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1833za7622935z00,
		BGl_z62lambda1833z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2652z00zz__evaluate_typesz00,
		BgL_bgl_string2652za700za7za7_2936za7, "fun", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2565z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1832za7622937z00,
		BGl_z62lambda1832z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2490z00zz__evaluate_typesz00,
		BgL_bgl_string2490za700za7za7_2938za7, "ev_trap", 7);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2566z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1838za7622939z00,
		BGl_z62lambda1838z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2567z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1837za7622940z00,
		BGl_z62lambda1837z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2494z00zz__evaluate_typesz00,
		BgL_bgl_string2494za700za7za7_2941za7, "v", 1);
	      DEFINE_STRING(BGl_string2659z00zz__evaluate_typesz00,
		BgL_bgl_string2659za700za7za7_2942za7, "ev_app", 6);
	      DEFINE_STRING(BGl_string2499z00zz__evaluate_typesz00,
		BgL_bgl_string2499za700za7za7_2943za7, "ev_setlocal", 11);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2570z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1843za7622944z00,
		BGl_z62lambda1843z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2571z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1842za7622945z00,
		BGl_z62lambda1842z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2574z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72946za7,
		BGl_z62zc3anonymousza31828ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2575z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1826za7622947z00,
		BGl_z62lambda1826z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2576z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1824za7622948z00,
		BGl_z62lambda1824z62zz__evaluate_typesz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2579z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72949za7,
		BGl_z62zc3anonymousza31862ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string2667z00zz__evaluate_typesz00,
		BgL_bgl_string2667za700za7za7_2950za7, "inner", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2580z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1861za7622951z00,
		BGl_z62lambda1861z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2581z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1860za7622952z00,
		BGl_z62lambda1860z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2584z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72953za7,
		BGl_z62zc3anonymousza31854ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2672z00zz__evaluate_typesz00,
		BgL_bgl_string2672za700za7za7_2954za7, "free", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2585z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1852za7622955z00,
		BGl_z62lambda1852z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2586z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1850za7622956z00,
		BGl_z62lambda1850z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2589z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72957za7,
		BGl_z62zc3anonymousza31880ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string2677z00zz__evaluate_typesz00,
		BgL_bgl_string2677za700za7za7_2958za7, "bind", 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2590z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1879za7622959z00,
		BGl_z62lambda1879z62zz__evaluate_typesz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2591z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1878za7622960z00,
		BGl_z62lambda1878z62zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2592z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72961za7,
		BGl_z62zc3anonymousza31873ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2593z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1871za7622962z00,
		BGl_z62lambda1871z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2594z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1869za7622963z00,
		BGl_z62lambda1869z62zz__evaluate_typesz00, 0L, BUNSPEC, 4);
	      DEFINE_STRING(BGl_string2682z00zz__evaluate_typesz00,
		BgL_bgl_string2682za700za7za7_2964za7, "size", 4);
	      DEFINE_STRING(BGl_string2684z00zz__evaluate_typesz00,
		BgL_bgl_string2684za700za7za7_2965za7, "int", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2597z00zz__evaluate_typesz00,
		BgL_bgl_za762za7c3anonymousza72966za7,
		BGl_z62zc3anonymousza31890ze3ze1zz__evaluate_typesz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2598z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1888za7622967z00,
		BGl_z62lambda1888z62zz__evaluate_typesz00, 0L, BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2599z00zz__evaluate_typesz00,
		BgL_bgl_za762lambda1886za7622968z00,
		BGl_z62lambda1886z62zz__evaluate_typesz00, 0L, BUNSPEC, 3);
	      DEFINE_STRING(BGl_string2692z00zz__evaluate_typesz00,
		BgL_bgl_string2692za700za7za7_2969za7, "arity", 5);
	      DEFINE_STRING(BGl_string2696z00zz__evaluate_typesz00,
		BgL_bgl_string2696za700za7za7_2970za7, "where", 5);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long
		BgL_checksumz00_3818, char *BgL_fromz00_3819)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zz__evaluate_typesz00))
				{
					BGl_requirezd2initializa7ationz75zz__evaluate_typesz00 =
						BBOOL(((bool_t) 0));
					BGl_cnstzd2initzd2zz__evaluate_typesz00();
					BGl_importedzd2moduleszd2initz00zz__evaluate_typesz00();
					BGl_objectzd2initzd2zz__evaluate_typesz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zz__evaluate_typesz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 15 */
			BGl_symbol2380z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2381z00zz__evaluate_typesz00);
			BGl_symbol2382z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2383z00zz__evaluate_typesz00);
			BGl_symbol2386z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2387z00zz__evaluate_typesz00);
			BGl_symbol2388z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2389z00zz__evaluate_typesz00);
			BGl_symbol2393z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2394z00zz__evaluate_typesz00);
			BGl_symbol2397z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2398z00zz__evaluate_typesz00);
			BGl_symbol2399z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2400z00zz__evaluate_typesz00);
			BGl_symbol2404z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2405z00zz__evaluate_typesz00);
			BGl_symbol2408z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2409z00zz__evaluate_typesz00);
			BGl_symbol2414z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2415z00zz__evaluate_typesz00);
			BGl_symbol2419z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2420z00zz__evaluate_typesz00);
			BGl_symbol2423z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2424z00zz__evaluate_typesz00);
			BGl_symbol2428z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2429z00zz__evaluate_typesz00);
			BGl_symbol2432z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2433z00zz__evaluate_typesz00);
			BGl_symbol2436z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2437z00zz__evaluate_typesz00);
			BGl_symbol2440z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2441z00zz__evaluate_typesz00);
			BGl_symbol2445z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2446z00zz__evaluate_typesz00);
			BGl_symbol2449z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2450z00zz__evaluate_typesz00);
			BGl_symbol2454z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2455z00zz__evaluate_typesz00);
			BGl_symbol2459z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2460z00zz__evaluate_typesz00);
			BGl_symbol2464z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2465z00zz__evaluate_typesz00);
			BGl_symbol2468z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2469z00zz__evaluate_typesz00);
			BGl_symbol2472z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2473z00zz__evaluate_typesz00);
			BGl_symbol2477z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2478z00zz__evaluate_typesz00);
			BGl_symbol2484z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2485z00zz__evaluate_typesz00);
			BGl_symbol2489z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2490z00zz__evaluate_typesz00);
			BGl_symbol2493z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2494z00zz__evaluate_typesz00);
			BGl_symbol2498z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2499z00zz__evaluate_typesz00);
			BGl_symbol2509z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2510z00zz__evaluate_typesz00);
			BGl_symbol2514z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2515z00zz__evaluate_typesz00);
			BGl_symbol2518z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2519z00zz__evaluate_typesz00);
			BGl_symbol2522z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2523z00zz__evaluate_typesz00);
			BGl_symbol2527z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2528z00zz__evaluate_typesz00);
			BGl_symbol2536z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2537z00zz__evaluate_typesz00);
			BGl_symbol2542z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2543z00zz__evaluate_typesz00);
			BGl_symbol2547z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2548z00zz__evaluate_typesz00);
			BGl_symbol2553z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2554z00zz__evaluate_typesz00);
			BGl_symbol2557z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2558z00zz__evaluate_typesz00);
			BGl_symbol2562z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2563z00zz__evaluate_typesz00);
			BGl_symbol2568z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2569z00zz__evaluate_typesz00);
			BGl_symbol2572z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2573z00zz__evaluate_typesz00);
			BGl_symbol2577z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2578z00zz__evaluate_typesz00);
			BGl_symbol2582z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2583z00zz__evaluate_typesz00);
			BGl_symbol2587z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2588z00zz__evaluate_typesz00);
			BGl_symbol2595z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2596z00zz__evaluate_typesz00);
			BGl_symbol2600z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2601z00zz__evaluate_typesz00);
			BGl_symbol2610z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2611z00zz__evaluate_typesz00);
			BGl_symbol2615z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2616z00zz__evaluate_typesz00);
			BGl_symbol2624z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2625z00zz__evaluate_typesz00);
			BGl_symbol2630z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2631z00zz__evaluate_typesz00);
			BGl_symbol2634z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2635z00zz__evaluate_typesz00);
			BGl_symbol2641z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2642z00zz__evaluate_typesz00);
			BGl_symbol2645z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2646z00zz__evaluate_typesz00);
			BGl_symbol2651z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2652z00zz__evaluate_typesz00);
			BGl_symbol2658z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2659z00zz__evaluate_typesz00);
			BGl_symbol2666z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2667z00zz__evaluate_typesz00);
			BGl_symbol2671z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2672z00zz__evaluate_typesz00);
			BGl_symbol2676z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2677z00zz__evaluate_typesz00);
			BGl_symbol2681z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2682z00zz__evaluate_typesz00);
			BGl_symbol2683z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2684z00zz__evaluate_typesz00);
			BGl_symbol2691z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2692z00zz__evaluate_typesz00);
			BGl_symbol2695z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2696z00zz__evaluate_typesz00);
			BGl_symbol2702z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2703z00zz__evaluate_typesz00);
			return (BGl_symbol2704z00zz__evaluate_typesz00 =
				bstring_to_symbol(BGl_string2705z00zz__evaluate_typesz00), BUNSPEC);
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zz__evaluate_typesz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 15 */
			return BUNSPEC;
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zz__evaluate_typesz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 15 */
			{	/* Eval/evaluate_types.scm 49 */
				obj_t BgL_arg1474z00_615;
				obj_t BgL_arg1476z00_616;

				{	/* Eval/evaluate_types.scm 49 */
					obj_t BgL_v1377z00_626;

					BgL_v1377z00_626 = create_vector((int) (((long) 0)));
					BgL_arg1474z00_615 = BgL_v1377z00_626;
				}
				{	/* Eval/evaluate_types.scm 49 */
					obj_t BgL_v1378z00_627;

					BgL_v1378z00_627 = create_vector((int) (((long) 0)));
					BgL_arg1476z00_616 = BgL_v1378z00_627;
				}
				BGl_ev_exprz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2380z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00, BGl_objectz00zz__objectz00,
					((long) 36682), BGl_proc2379z00zz__evaluate_typesz00,
					BGl_proc2378z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2377z00zz__evaluate_typesz00, BFALSE, BgL_arg1474z00_615,
					BgL_arg1476z00_616);
			}
			{	/* Eval/evaluate_types.scm 51 */
				obj_t BgL_arg1488z00_634;
				obj_t BgL_arg1489z00_635;

				{	/* Eval/evaluate_types.scm 51 */
					obj_t BgL_v1379z00_648;

					BgL_v1379z00_648 = create_vector((int) (((long) 3)));
					VECTOR_SET(BgL_v1379z00_648,
						(int) (((long) 2)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2386z00zz__evaluate_typesz00,
							BGl_proc2385z00zz__evaluate_typesz00,
							BGl_proc2384z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2388z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1379z00_648, (int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2393z00zz__evaluate_typesz00,
							BGl_proc2392z00zz__evaluate_typesz00,
							BGl_proc2391z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2390z00zz__evaluate_typesz00,
							BGl_symbol2388z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1379z00_648, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2397z00zz__evaluate_typesz00,
							BGl_proc2396z00zz__evaluate_typesz00,
							BGl_proc2395z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2399z00zz__evaluate_typesz00));
					BgL_arg1488z00_634 = BgL_v1379z00_648;
				}
				{	/* Eval/evaluate_types.scm 51 */
					obj_t BgL_v1380z00_688;

					BgL_v1380z00_688 = create_vector((int) (((long) 0)));
					BgL_arg1489z00_635 = BgL_v1380z00_688;
				}
				BGl_ev_varz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2404z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 7625),
					BGl_proc2403z00zz__evaluate_typesz00,
					BGl_proc2402z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2401z00zz__evaluate_typesz00, BFALSE, BgL_arg1488z00_634,
					BgL_arg1489z00_635);
			}
			{	/* Eval/evaluate_types.scm 55 */
				obj_t BgL_arg1517z00_695;
				obj_t BgL_arg1518z00_696;

				{	/* Eval/evaluate_types.scm 55 */
					obj_t BgL_v1381z00_709;

					BgL_v1381z00_709 = create_vector((int) (((long) 3)));
					VECTOR_SET(BgL_v1381z00_709,
						(int) (((long) 2)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2408z00zz__evaluate_typesz00,
							BGl_proc2407z00zz__evaluate_typesz00,
							BGl_proc2406z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2388z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1381z00_709, (int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2397z00zz__evaluate_typesz00,
							BGl_proc2411z00zz__evaluate_typesz00,
							BGl_proc2410z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2399z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1381z00_709, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2414z00zz__evaluate_typesz00,
							BGl_proc2413z00zz__evaluate_typesz00,
							BGl_proc2412z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2388z00zz__evaluate_typesz00));
					BgL_arg1517z00_695 = BgL_v1381z00_709;
				}
				{	/* Eval/evaluate_types.scm 55 */
					obj_t BgL_v1382z00_746;

					BgL_v1382z00_746 = create_vector((int) (((long) 0)));
					BgL_arg1518z00_696 = BgL_v1382z00_746;
				}
				BGl_ev_globalz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2419z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 59175),
					BGl_proc2418z00zz__evaluate_typesz00,
					BGl_proc2417z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2416z00zz__evaluate_typesz00, BFALSE, BgL_arg1517z00_695,
					BgL_arg1518z00_696);
			}
			{	/* Eval/evaluate_types.scm 60 */
				obj_t BgL_arg1553z00_753;
				obj_t BgL_arg1554z00_754;

				{	/* Eval/evaluate_types.scm 60 */
					obj_t BgL_v1383z00_765;

					BgL_v1383z00_765 = create_vector((int) (((long) 1)));
					VECTOR_SET(BgL_v1383z00_765,
						(int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2423z00zz__evaluate_typesz00,
							BGl_proc2422z00zz__evaluate_typesz00,
							BGl_proc2421z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2388z00zz__evaluate_typesz00));
					BgL_arg1553z00_753 = BgL_v1383z00_765;
				}
				{	/* Eval/evaluate_types.scm 60 */
					obj_t BgL_v1384z00_778;

					BgL_v1384z00_778 = create_vector((int) (((long) 0)));
					BgL_arg1554z00_754 = BgL_v1384z00_778;
				}
				BGl_ev_littz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2428z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 42418),
					BGl_proc2427z00zz__evaluate_typesz00,
					BGl_proc2426z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2425z00zz__evaluate_typesz00, BFALSE, BgL_arg1553z00_753,
					BgL_arg1554z00_754);
			}
			{	/* Eval/evaluate_types.scm 62 */
				obj_t BgL_arg1572z00_785;
				obj_t BgL_arg1573z00_786;

				{	/* Eval/evaluate_types.scm 62 */
					obj_t BgL_v1385z00_799;

					BgL_v1385z00_799 = create_vector((int) (((long) 3)));
					VECTOR_SET(BgL_v1385z00_799,
						(int) (((long) 2)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2432z00zz__evaluate_typesz00,
							BGl_proc2431z00zz__evaluate_typesz00,
							BGl_proc2430z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1385z00_799, (int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2436z00zz__evaluate_typesz00,
							BGl_proc2435z00zz__evaluate_typesz00,
							BGl_proc2434z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1385z00_799, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2440z00zz__evaluate_typesz00,
							BGl_proc2439z00zz__evaluate_typesz00,
							BGl_proc2438z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1572z00_785 = BgL_v1385z00_799;
				}
				{	/* Eval/evaluate_types.scm 62 */
					obj_t BgL_v1386z00_836;

					BgL_v1386z00_836 = create_vector((int) (((long) 0)));
					BgL_arg1573z00_786 = BgL_v1386z00_836;
				}
				BGl_ev_ifz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2445z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 19099),
					BGl_proc2444z00zz__evaluate_typesz00,
					BGl_proc2443z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2442z00zz__evaluate_typesz00, BFALSE, BgL_arg1572z00_785,
					BgL_arg1573z00_786);
			}
			{	/* Eval/evaluate_types.scm 66 */
				obj_t BgL_arg1598z00_843;
				obj_t BgL_arg1599z00_844;

				{	/* Eval/evaluate_types.scm 66 */
					obj_t BgL_v1387z00_855;

					BgL_v1387z00_855 = create_vector((int) (((long) 1)));
					VECTOR_SET(BgL_v1387z00_855,
						(int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2449z00zz__evaluate_typesz00,
							BGl_proc2448z00zz__evaluate_typesz00,
							BGl_proc2447z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2388z00zz__evaluate_typesz00));
					BgL_arg1598z00_843 = BgL_v1387z00_855;
				}
				{	/* Eval/evaluate_types.scm 66 */
					obj_t BgL_v1388z00_868;

					BgL_v1388z00_868 = create_vector((int) (((long) 0)));
					BgL_arg1599z00_844 = BgL_v1388z00_868;
				}
				BGl_ev_listz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2454z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 39617),
					BGl_proc2453z00zz__evaluate_typesz00,
					BGl_proc2452z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2451z00zz__evaluate_typesz00, BFALSE, BgL_arg1598z00_843,
					BgL_arg1599z00_844);
			}
			{	/* Eval/evaluate_types.scm 68 */
				obj_t BgL_arg1614z00_875;
				obj_t BgL_arg1615z00_876;

				{	/* Eval/evaluate_types.scm 68 */
					obj_t BgL_v1389z00_887;

					BgL_v1389z00_887 = create_vector((int) (((long) 0)));
					BgL_arg1614z00_875 = BgL_v1389z00_887;
				}
				{	/* Eval/evaluate_types.scm 68 */
					obj_t BgL_v1390z00_888;

					BgL_v1390z00_888 = create_vector((int) (((long) 0)));
					BgL_arg1615z00_876 = BgL_v1390z00_888;
				}
				BGl_ev_orz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2459z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_listz00zz__evaluate_typesz00, ((long) 50334),
					BGl_proc2458z00zz__evaluate_typesz00,
					BGl_proc2457z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2456z00zz__evaluate_typesz00, BFALSE, BgL_arg1614z00_875,
					BgL_arg1615z00_876);
			}
			{	/* Eval/evaluate_types.scm 69 */
				obj_t BgL_arg1624z00_895;
				obj_t BgL_arg1625z00_896;

				{	/* Eval/evaluate_types.scm 69 */
					obj_t BgL_v1391z00_907;

					BgL_v1391z00_907 = create_vector((int) (((long) 0)));
					BgL_arg1624z00_895 = BgL_v1391z00_907;
				}
				{	/* Eval/evaluate_types.scm 69 */
					obj_t BgL_v1392z00_908;

					BgL_v1392z00_908 = create_vector((int) (((long) 0)));
					BgL_arg1625z00_896 = BgL_v1392z00_908;
				}
				BGl_ev_andz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2464z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_listz00zz__evaluate_typesz00, ((long) 26888),
					BGl_proc2463z00zz__evaluate_typesz00,
					BGl_proc2462z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2461z00zz__evaluate_typesz00, BFALSE, BgL_arg1624z00_895,
					BgL_arg1625z00_896);
			}
			{	/* Eval/evaluate_types.scm 70 */
				obj_t BgL_arg1634z00_915;
				obj_t BgL_arg1635z00_916;

				{	/* Eval/evaluate_types.scm 70 */
					obj_t BgL_v1393z00_928;

					BgL_v1393z00_928 = create_vector((int) (((long) 2)));
					VECTOR_SET(BgL_v1393z00_928,
						(int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2468z00zz__evaluate_typesz00,
							BGl_proc2467z00zz__evaluate_typesz00,
							BGl_proc2466z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1393z00_928, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2472z00zz__evaluate_typesz00,
							BGl_proc2471z00zz__evaluate_typesz00,
							BGl_proc2470z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1634z00_915 = BgL_v1393z00_928;
				}
				{	/* Eval/evaluate_types.scm 70 */
					obj_t BgL_v1394z00_953;

					BgL_v1394z00_953 = create_vector((int) (((long) 0)));
					BgL_arg1635z00_916 = BgL_v1394z00_953;
				}
				BGl_ev_prog2z00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2477z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 14177),
					BGl_proc2476z00zz__evaluate_typesz00,
					BGl_proc2475z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2474z00zz__evaluate_typesz00, BFALSE, BgL_arg1634z00_915,
					BgL_arg1635z00_916);
			}
			{	/* Eval/evaluate_types.scm 73 */
				obj_t BgL_arg1655z00_960;
				obj_t BgL_arg1656z00_961;

				{	/* Eval/evaluate_types.scm 73 */
					obj_t BgL_v1395z00_972;

					BgL_v1395z00_972 = create_vector((int) (((long) 1)));
					VECTOR_SET(BgL_v1395z00_972,
						(int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2432z00zz__evaluate_typesz00,
							BGl_proc2480z00zz__evaluate_typesz00,
							BGl_proc2479z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1655z00_960 = BgL_v1395z00_972;
				}
				{	/* Eval/evaluate_types.scm 73 */
					obj_t BgL_v1396z00_985;

					BgL_v1396z00_985 = create_vector((int) (((long) 0)));
					BgL_arg1656z00_961 = BgL_v1396z00_985;
				}
				BGl_ev_hookz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2484z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 32125),
					BGl_proc2483z00zz__evaluate_typesz00,
					BGl_proc2482z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2481z00zz__evaluate_typesz00, BFALSE, BgL_arg1655z00_960,
					BgL_arg1656z00_961);
			}
			{	/* Eval/evaluate_types.scm 75 */
				obj_t BgL_arg1672z00_992;
				obj_t BgL_arg1673z00_993;

				{	/* Eval/evaluate_types.scm 75 */
					obj_t BgL_v1397z00_1004;

					BgL_v1397z00_1004 = create_vector((int) (((long) 0)));
					BgL_arg1672z00_992 = BgL_v1397z00_1004;
				}
				{	/* Eval/evaluate_types.scm 75 */
					obj_t BgL_v1398z00_1005;

					BgL_v1398z00_1005 = create_vector((int) (((long) 0)));
					BgL_arg1673z00_993 = BgL_v1398z00_1005;
				}
				BGl_ev_trapz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2489z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_hookz00zz__evaluate_typesz00, ((long) 24451),
					BGl_proc2488z00zz__evaluate_typesz00,
					BGl_proc2487z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2486z00zz__evaluate_typesz00, BFALSE, BgL_arg1672z00_992,
					BgL_arg1673z00_993);
			}
			{	/* Eval/evaluate_types.scm 76 */
				obj_t BgL_arg1682z00_1012;
				obj_t BgL_arg1683z00_1013;

				{	/* Eval/evaluate_types.scm 76 */
					obj_t BgL_v1399z00_1025;

					BgL_v1399z00_1025 = create_vector((int) (((long) 1)));
					VECTOR_SET(BgL_v1399z00_1025,
						(int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2493z00zz__evaluate_typesz00,
							BGl_proc2492z00zz__evaluate_typesz00,
							BGl_proc2491z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_varz00zz__evaluate_typesz00));
					BgL_arg1682z00_1012 = BgL_v1399z00_1025;
				}
				{	/* Eval/evaluate_types.scm 76 */
					obj_t BgL_v1400z00_1038;

					BgL_v1400z00_1038 = create_vector((int) (((long) 0)));
					BgL_arg1683z00_1013 = BgL_v1400z00_1038;
				}
				BGl_ev_setlocalz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2498z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_hookz00zz__evaluate_typesz00, ((long) 37950),
					BGl_proc2497z00zz__evaluate_typesz00,
					BGl_proc2496z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2495z00zz__evaluate_typesz00, BFALSE, BgL_arg1682z00_1012,
					BgL_arg1683z00_1013);
			}
			{	/* Eval/evaluate_types.scm 78 */
				obj_t BgL_arg1697z00_1045;
				obj_t BgL_arg1698z00_1046;

				{	/* Eval/evaluate_types.scm 78 */
					obj_t BgL_v1401z00_1060;

					BgL_v1401z00_1060 = create_vector((int) (((long) 3)));
					VECTOR_SET(BgL_v1401z00_1060,
						(int) (((long) 2)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2408z00zz__evaluate_typesz00,
							BGl_proc2501z00zz__evaluate_typesz00,
							BGl_proc2500z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2388z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1401z00_1060, (int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2397z00zz__evaluate_typesz00,
							BGl_proc2503z00zz__evaluate_typesz00,
							BGl_proc2502z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2399z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1401z00_1060, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2414z00zz__evaluate_typesz00,
							BGl_proc2505z00zz__evaluate_typesz00,
							BGl_proc2504z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2388z00zz__evaluate_typesz00));
					BgL_arg1697z00_1045 = BgL_v1401z00_1060;
				}
				{	/* Eval/evaluate_types.scm 78 */
					obj_t BgL_v1402z00_1097;

					BgL_v1402z00_1097 = create_vector((int) (((long) 0)));
					BgL_arg1698z00_1046 = BgL_v1402z00_1097;
				}
				BGl_ev_setglobalz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2509z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_hookz00zz__evaluate_typesz00, ((long) 62117),
					BGl_proc2508z00zz__evaluate_typesz00,
					BGl_proc2507z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2506z00zz__evaluate_typesz00, BFALSE, BgL_arg1697z00_1045,
					BgL_arg1698z00_1046);
			}
			{	/* Eval/evaluate_types.scm 82 */
				obj_t BgL_arg1723z00_1104;
				obj_t BgL_arg1724z00_1105;

				{	/* Eval/evaluate_types.scm 82 */
					obj_t BgL_v1403z00_1119;

					BgL_v1403z00_1119 = create_vector((int) (((long) 0)));
					BgL_arg1723z00_1104 = BgL_v1403z00_1119;
				}
				{	/* Eval/evaluate_types.scm 82 */
					obj_t BgL_v1404z00_1120;

					BgL_v1404z00_1120 = create_vector((int) (((long) 0)));
					BgL_arg1724z00_1105 = BgL_v1404z00_1120;
				}
				BGl_ev_defglobalz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2514z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_setglobalz00zz__evaluate_typesz00, ((long) 36158),
					BGl_proc2513z00zz__evaluate_typesz00,
					BGl_proc2512z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2511z00zz__evaluate_typesz00, BFALSE, BgL_arg1723z00_1104,
					BgL_arg1724z00_1105);
			}
			{	/* Eval/evaluate_types.scm 83 */
				obj_t BgL_arg1734z00_1127;
				obj_t BgL_arg1735z00_1128;

				{	/* Eval/evaluate_types.scm 83 */
					obj_t BgL_v1405z00_1140;

					BgL_v1405z00_1140 = create_vector((int) (((long) 2)));
					VECTOR_SET(BgL_v1405z00_1140,
						(int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2518z00zz__evaluate_typesz00,
							BGl_proc2517z00zz__evaluate_typesz00,
							BGl_proc2516z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1405z00_1140, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2522z00zz__evaluate_typesz00,
							BGl_proc2521z00zz__evaluate_typesz00,
							BGl_proc2520z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_varz00zz__evaluate_typesz00));
					BgL_arg1734z00_1127 = BgL_v1405z00_1140;
				}
				{	/* Eval/evaluate_types.scm 83 */
					obj_t BgL_v1406z00_1165;

					BgL_v1406z00_1165 = create_vector((int) (((long) 0)));
					BgL_arg1735z00_1128 = BgL_v1406z00_1165;
				}
				BGl_ev_bindzd2exitzd2zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2527z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 10723),
					BGl_proc2526z00zz__evaluate_typesz00,
					BGl_proc2525z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2524z00zz__evaluate_typesz00, BFALSE, BgL_arg1734z00_1127,
					BgL_arg1735z00_1128);
			}
			{	/* Eval/evaluate_types.scm 86 */
				obj_t BgL_arg1754z00_1172;
				obj_t BgL_arg1755z00_1173;

				{	/* Eval/evaluate_types.scm 86 */
					obj_t BgL_v1407z00_1185;

					BgL_v1407z00_1185 = create_vector((int) (((long) 2)));
					VECTOR_SET(BgL_v1407z00_1185,
						(int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2518z00zz__evaluate_typesz00,
							BGl_proc2530z00zz__evaluate_typesz00,
							BGl_proc2529z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1407z00_1185, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2432z00zz__evaluate_typesz00,
							BGl_proc2532z00zz__evaluate_typesz00,
							BGl_proc2531z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1754z00_1172 = BgL_v1407z00_1185;
				}
				{	/* Eval/evaluate_types.scm 86 */
					obj_t BgL_v1408z00_1210;

					BgL_v1408z00_1210 = create_vector((int) (((long) 0)));
					BgL_arg1755z00_1173 = BgL_v1408z00_1210;
				}
				BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2536z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 59644),
					BGl_proc2535z00zz__evaluate_typesz00,
					BGl_proc2534z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2533z00zz__evaluate_typesz00, BFALSE, BgL_arg1754z00_1172,
					BgL_arg1755z00_1173);
			}
			{	/* Eval/evaluate_types.scm 89 */
				obj_t BgL_arg1777z00_1217;
				obj_t BgL_arg1778z00_1218;

				{	/* Eval/evaluate_types.scm 89 */
					obj_t BgL_v1409z00_1230;

					BgL_v1409z00_1230 = create_vector((int) (((long) 2)));
					VECTOR_SET(BgL_v1409z00_1230,
						(int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2518z00zz__evaluate_typesz00,
							BGl_proc2539z00zz__evaluate_typesz00,
							BGl_proc2538z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1409z00_1230, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2542z00zz__evaluate_typesz00,
							BGl_proc2541z00zz__evaluate_typesz00,
							BGl_proc2540z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1777z00_1217 = BgL_v1409z00_1230;
				}
				{	/* Eval/evaluate_types.scm 89 */
					obj_t BgL_v1410z00_1255;

					BgL_v1410z00_1255 = create_vector((int) (((long) 0)));
					BgL_arg1778z00_1218 = BgL_v1410z00_1255;
				}
				BGl_ev_withzd2handlerzd2zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2547z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 54033),
					BGl_proc2546z00zz__evaluate_typesz00,
					BGl_proc2545z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2544z00zz__evaluate_typesz00, BFALSE, BgL_arg1777z00_1217,
					BgL_arg1778z00_1218);
			}
			{	/* Eval/evaluate_types.scm 92 */
				obj_t BgL_arg1797z00_1262;
				obj_t BgL_arg1798z00_1263;

				{	/* Eval/evaluate_types.scm 92 */
					obj_t BgL_v1411z00_1276;

					BgL_v1411z00_1276 = create_vector((int) (((long) 3)));
					VECTOR_SET(BgL_v1411z00_1276,
						(int) (((long) 2)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2518z00zz__evaluate_typesz00,
							BGl_proc2550z00zz__evaluate_typesz00,
							BGl_proc2549z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1411z00_1276, (int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2553z00zz__evaluate_typesz00,
							BGl_proc2552z00zz__evaluate_typesz00,
							BGl_proc2551z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1411z00_1276, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2557z00zz__evaluate_typesz00,
							BGl_proc2556z00zz__evaluate_typesz00,
							BGl_proc2555z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					BgL_arg1797z00_1262 = BgL_v1411z00_1276;
				}
				{	/* Eval/evaluate_types.scm 92 */
					obj_t BgL_v1412z00_1313;

					BgL_v1412z00_1313 = create_vector((int) (((long) 0)));
					BgL_arg1798z00_1263 = BgL_v1412z00_1313;
				}
				BGl_ev_synchroniza7eza7zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2562z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 55446),
					BGl_proc2561z00zz__evaluate_typesz00,
					BGl_proc2560z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2559z00zz__evaluate_typesz00, BFALSE, BgL_arg1797z00_1262,
					BgL_arg1798z00_1263);
			}
			{	/* Eval/evaluate_types.scm 96 */
				obj_t BgL_arg1822z00_1320;
				obj_t BgL_arg1823z00_1321;

				{	/* Eval/evaluate_types.scm 96 */
					obj_t BgL_v1413z00_1334;

					BgL_v1413z00_1334 = create_vector((int) (((long) 3)));
					VECTOR_SET(BgL_v1413z00_1334,
						(int) (((long) 2)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2518z00zz__evaluate_typesz00,
							BGl_proc2565z00zz__evaluate_typesz00,
							BGl_proc2564z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1413z00_1334, (int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2568z00zz__evaluate_typesz00,
							BGl_proc2567z00zz__evaluate_typesz00,
							BGl_proc2566z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2388z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1413z00_1334, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2572z00zz__evaluate_typesz00,
							BGl_proc2571z00zz__evaluate_typesz00,
							BGl_proc2570z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2388z00zz__evaluate_typesz00));
					BgL_arg1822z00_1320 = BgL_v1413z00_1334;
				}
				{	/* Eval/evaluate_types.scm 96 */
					obj_t BgL_v1414z00_1371;

					BgL_v1414z00_1371 = create_vector((int) (((long) 0)));
					BgL_arg1823z00_1321 = BgL_v1414z00_1371;
				}
				BGl_ev_binderz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2577z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 50341),
					BGl_proc2576z00zz__evaluate_typesz00,
					BGl_proc2575z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2574z00zz__evaluate_typesz00, BFALSE, BgL_arg1822z00_1320,
					BgL_arg1823z00_1321);
			}
			{	/* Eval/evaluate_types.scm 100 */
				obj_t BgL_arg1848z00_1378;
				obj_t BgL_arg1849z00_1379;

				{	/* Eval/evaluate_types.scm 100 */
					obj_t BgL_v1415z00_1393;

					BgL_v1415z00_1393 = create_vector((int) (((long) 1)));
					VECTOR_SET(BgL_v1415z00_1393,
						(int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2582z00zz__evaluate_typesz00,
							BGl_proc2581z00zz__evaluate_typesz00,
							BGl_proc2580z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2579z00zz__evaluate_typesz00,
							BGl_symbol2388z00zz__evaluate_typesz00));
					BgL_arg1848z00_1378 = BgL_v1415z00_1393;
				}
				{	/* Eval/evaluate_types.scm 100 */
					obj_t BgL_v1416z00_1409;

					BgL_v1416z00_1409 = create_vector((int) (((long) 0)));
					BgL_arg1849z00_1379 = BgL_v1416z00_1409;
				}
				BGl_ev_letz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2587z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_binderz00zz__evaluate_typesz00, ((long) 20484),
					BGl_proc2586z00zz__evaluate_typesz00,
					BGl_proc2585z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2584z00zz__evaluate_typesz00, BFALSE, BgL_arg1848z00_1378,
					BgL_arg1849z00_1379);
			}
			{	/* Eval/evaluate_types.scm 102 */
				obj_t BgL_arg1867z00_1416;
				obj_t BgL_arg1868z00_1417;

				{	/* Eval/evaluate_types.scm 102 */
					obj_t BgL_v1417z00_1431;

					BgL_v1417z00_1431 = create_vector((int) (((long) 1)));
					VECTOR_SET(BgL_v1417z00_1431,
						(int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2582z00zz__evaluate_typesz00,
							BGl_proc2591z00zz__evaluate_typesz00,
							BGl_proc2590z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2589z00zz__evaluate_typesz00,
							BGl_symbol2388z00zz__evaluate_typesz00));
					BgL_arg1867z00_1416 = BgL_v1417z00_1431;
				}
				{	/* Eval/evaluate_types.scm 102 */
					obj_t BgL_v1418z00_1447;

					BgL_v1418z00_1447 = create_vector((int) (((long) 0)));
					BgL_arg1868z00_1417 = BgL_v1418z00_1447;
				}
				BGl_ev_letza2za2zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2595z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_binderz00zz__evaluate_typesz00, ((long) 9906),
					BGl_proc2594z00zz__evaluate_typesz00,
					BGl_proc2593z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2592z00zz__evaluate_typesz00, BFALSE, BgL_arg1867z00_1416,
					BgL_arg1868z00_1417);
			}
			{	/* Eval/evaluate_types.scm 104 */
				obj_t BgL_arg1884z00_1454;
				obj_t BgL_arg1885z00_1455;

				{	/* Eval/evaluate_types.scm 104 */
					obj_t BgL_v1419z00_1468;

					BgL_v1419z00_1468 = create_vector((int) (((long) 0)));
					BgL_arg1884z00_1454 = BgL_v1419z00_1468;
				}
				{	/* Eval/evaluate_types.scm 104 */
					obj_t BgL_v1420z00_1469;

					BgL_v1420z00_1469 = create_vector((int) (((long) 0)));
					BgL_arg1885z00_1455 = BgL_v1420z00_1469;
				}
				BGl_ev_letrecz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2600z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_binderz00zz__evaluate_typesz00, ((long) 43956),
					BGl_proc2599z00zz__evaluate_typesz00,
					BGl_proc2598z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2597z00zz__evaluate_typesz00, BFALSE, BgL_arg1884z00_1454,
					BgL_arg1885z00_1455);
			}
			{	/* Eval/evaluate_types.scm 105 */
				obj_t BgL_arg1894z00_1476;
				obj_t BgL_arg1895z00_1477;

				{	/* Eval/evaluate_types.scm 105 */
					obj_t BgL_v1421z00_1493;

					BgL_v1421z00_1493 = create_vector((int) (((long) 6)));
					VECTOR_SET(BgL_v1421z00_1493,
						(int) (((long) 5)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2582z00zz__evaluate_typesz00,
							BGl_proc2604z00zz__evaluate_typesz00,
							BGl_proc2603z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2602z00zz__evaluate_typesz00,
							BGl_symbol2388z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1421z00_1493, (int) (((long) 4)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2518z00zz__evaluate_typesz00,
							BGl_proc2606z00zz__evaluate_typesz00,
							BGl_proc2605z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1421z00_1493, (int) (((long) 3)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2610z00zz__evaluate_typesz00,
							BGl_proc2609z00zz__evaluate_typesz00,
							BGl_proc2608z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2607z00zz__evaluate_typesz00,
							BGl_symbol2388z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1421z00_1493, (int) (((long) 2)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2615z00zz__evaluate_typesz00,
							BGl_proc2614z00zz__evaluate_typesz00,
							BGl_proc2613z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2612z00zz__evaluate_typesz00,
							BGl_symbol2388z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1421z00_1493, (int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2568z00zz__evaluate_typesz00,
							BGl_proc2618z00zz__evaluate_typesz00,
							BGl_proc2617z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2388z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1421z00_1493, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2572z00zz__evaluate_typesz00,
							BGl_proc2620z00zz__evaluate_typesz00,
							BGl_proc2619z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2388z00zz__evaluate_typesz00));
					BgL_arg1894z00_1476 = BgL_v1421z00_1493;
				}
				{	/* Eval/evaluate_types.scm 105 */
					obj_t BgL_v1422z00_1575;

					BgL_v1422z00_1575 = create_vector((int) (((long) 0)));
					BgL_arg1895z00_1477 = BgL_v1422z00_1575;
				}
				BGl_ev_labelsz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2624z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 51941),
					BGl_proc2623z00zz__evaluate_typesz00,
					BGl_proc2622z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2621z00zz__evaluate_typesz00, BFALSE, BgL_arg1894z00_1476,
					BgL_arg1895z00_1477);
			}
			{	/* Eval/evaluate_types.scm 113 */
				obj_t BgL_arg1942z00_1582;
				obj_t BgL_arg1943z00_1583;

				{	/* Eval/evaluate_types.scm 113 */
					obj_t BgL_v1423z00_1597;

					BgL_v1423z00_1597 = create_vector((int) (((long) 4)));
					VECTOR_SET(BgL_v1423z00_1597,
						(int) (((long) 3)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2449z00zz__evaluate_typesz00,
							BGl_proc2627z00zz__evaluate_typesz00,
							BGl_proc2626z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2388z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1423z00_1597, (int) (((long) 2)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2630z00zz__evaluate_typesz00,
							BGl_proc2629z00zz__evaluate_typesz00,
							BGl_proc2628z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_labelsz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1423z00_1597, (int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2634z00zz__evaluate_typesz00,
							BGl_proc2633z00zz__evaluate_typesz00,
							BGl_proc2632z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_varz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1423z00_1597, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2414z00zz__evaluate_typesz00,
							BGl_proc2637z00zz__evaluate_typesz00,
							BGl_proc2636z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2388z00zz__evaluate_typesz00));
					BgL_arg1942z00_1582 = BgL_v1423z00_1597;
				}
				{	/* Eval/evaluate_types.scm 113 */
					obj_t BgL_v1424z00_1646;

					BgL_v1424z00_1646 = create_vector((int) (((long) 0)));
					BgL_arg1943z00_1583 = BgL_v1424z00_1646;
				}
				BGl_ev_gotoz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2641z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 25746),
					BGl_proc2640z00zz__evaluate_typesz00,
					BGl_proc2639z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2638z00zz__evaluate_typesz00, BFALSE, BgL_arg1942z00_1582,
					BgL_arg1943z00_1583);
			}
			{	/* Eval/evaluate_types.scm 118 */
				obj_t BgL_arg1973z00_1653;
				obj_t BgL_arg1974z00_1654;

				{	/* Eval/evaluate_types.scm 118 */
					obj_t BgL_v1425z00_1668;

					BgL_v1425z00_1668 = create_vector((int) (((long) 4)));
					VECTOR_SET(BgL_v1425z00_1668,
						(int) (((long) 3)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2645z00zz__evaluate_typesz00,
							BGl_proc2644z00zz__evaluate_typesz00,
							BGl_proc2643z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2388z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1425z00_1668, (int) (((long) 2)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2449z00zz__evaluate_typesz00,
							BGl_proc2648z00zz__evaluate_typesz00,
							BGl_proc2647z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2388z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1425z00_1668, (int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2651z00zz__evaluate_typesz00,
							BGl_proc2650z00zz__evaluate_typesz00,
							BGl_proc2649z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1425z00_1668, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2414z00zz__evaluate_typesz00,
							BGl_proc2654z00zz__evaluate_typesz00,
							BGl_proc2653z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2388z00zz__evaluate_typesz00));
					BgL_arg1973z00_1653 = BgL_v1425z00_1668;
				}
				{	/* Eval/evaluate_types.scm 118 */
					obj_t BgL_v1426z00_1717;

					BgL_v1426z00_1717 = create_vector((int) (((long) 0)));
					BgL_arg1974z00_1654 = BgL_v1426z00_1717;
				}
				BGl_ev_appz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2658z00zz__evaluate_typesz00,
					BGl_symbol2382z00zz__evaluate_typesz00,
					BGl_ev_exprz00zz__evaluate_typesz00, ((long) 55822),
					BGl_proc2657z00zz__evaluate_typesz00,
					BGl_proc2656z00zz__evaluate_typesz00, BFALSE,
					BGl_proc2655z00zz__evaluate_typesz00, BFALSE, BgL_arg1973z00_1653,
					BgL_arg1974z00_1654);
			}
			{	/* Eval/evaluate_types.scm 121 */
				obj_t BgL_arg2007z00_1724;
				obj_t BgL_arg2008z00_1725;

				{	/* Eval/evaluate_types.scm 121 */
					obj_t BgL_v1427z00_1745;

					BgL_v1427z00_1745 = create_vector((int) (((long) 10)));
					VECTOR_SET(BgL_v1427z00_1745,
						(int) (((long) 9)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2582z00zz__evaluate_typesz00,
							BGl_proc2662z00zz__evaluate_typesz00,
							BGl_proc2661z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2660z00zz__evaluate_typesz00,
							BGl_symbol2388z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1427z00_1745, (int) (((long) 8)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2666z00zz__evaluate_typesz00,
							BGl_proc2665z00zz__evaluate_typesz00,
							BGl_proc2664z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2663z00zz__evaluate_typesz00,
							BGl_symbol2388z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1427z00_1745, (int) (((long) 7)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2671z00zz__evaluate_typesz00,
							BGl_proc2670z00zz__evaluate_typesz00,
							BGl_proc2669z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2668z00zz__evaluate_typesz00,
							BGl_symbol2388z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1427z00_1745, (int) (((long) 6)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2676z00zz__evaluate_typesz00,
							BGl_proc2675z00zz__evaluate_typesz00,
							BGl_proc2674z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2673z00zz__evaluate_typesz00,
							BGl_symbol2388z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1427z00_1745, (int) (((long) 5)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2681z00zz__evaluate_typesz00,
							BGl_proc2680z00zz__evaluate_typesz00,
							BGl_proc2679z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BGl_proc2678z00zz__evaluate_typesz00,
							BGl_symbol2683z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1427z00_1745, (int) (((long) 4)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2518z00zz__evaluate_typesz00,
							BGl_proc2686z00zz__evaluate_typesz00,
							BGl_proc2685z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1427z00_1745, (int) (((long) 3)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2572z00zz__evaluate_typesz00,
							BGl_proc2688z00zz__evaluate_typesz00,
							BGl_proc2687z00zz__evaluate_typesz00, ((bool_t) 0), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2388z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1427z00_1745, (int) (((long) 2)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2691z00zz__evaluate_typesz00,
							BGl_proc2690z00zz__evaluate_typesz00,
							BGl_proc2689z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2388z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1427z00_1745, (int) (((long) 1)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2695z00zz__evaluate_typesz00,
							BGl_proc2694z00zz__evaluate_typesz00,
							BGl_proc2693z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2388z00zz__evaluate_typesz00));
					VECTOR_SET(BgL_v1427z00_1745, (int) (((long) 0)),
						BGl_makezd2classzd2fieldz00zz__objectz00
						(BGl_symbol2414z00zz__evaluate_typesz00,
							BGl_proc2698z00zz__evaluate_typesz00,
							BGl_proc2697z00zz__evaluate_typesz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_symbol2388z00zz__evaluate_typesz00));
					BgL_arg2007z00_1724 = BgL_v1427z00_1745;
				}
				{	/* Eval/evaluate_types.scm 121 */
					obj_t BgL_v1428z00_1881;

					BgL_v1428z00_1881 = create_vector((int) (((long) 0)));
					BgL_arg2008z00_1725 = BgL_v1428z00_1881;
				}
				return (BGl_ev_absz00zz__evaluate_typesz00 =
					BGl_registerzd2classz12zc0zz__objectz00
					(BGl_symbol2702z00zz__evaluate_typesz00,
						BGl_symbol2382z00zz__evaluate_typesz00,
						BGl_ev_exprz00zz__evaluate_typesz00, ((long) 22827),
						BGl_proc2701z00zz__evaluate_typesz00,
						BGl_proc2700z00zz__evaluate_typesz00, BFALSE,
						BGl_proc2699z00zz__evaluate_typesz00, BFALSE, BgL_arg2007z00_1724,
						BgL_arg2008z00_1725), BUNSPEC);
		}}
	}



/* &<anonymous:2013> */
	BgL_ev_absz00_bglt BGl_z62zc3anonymousza32013ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3182, obj_t BgL_new1189z00_3183)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			{
				BgL_ev_absz00_bglt BgL_new1189z00_1743;

				BgL_new1189z00_1743 = ((BgL_ev_absz00_bglt) BgL_new1189z00_3183);
				((((BgL_ev_absz00_bglt) CREF(BgL_new1189z00_1743))->BgL_locz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_absz00_bglt) CREF(BgL_new1189z00_1743))->BgL_wherez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_absz00_bglt) CREF(BgL_new1189z00_1743))->BgL_arityz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_absz00_bglt) CREF(BgL_new1189z00_1743))->BgL_varsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4192;

					{	/* Eval/evaluate_types.scm 121 */
						obj_t BgL_classz00_2759;

						BgL_classz00_2759 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2760;

							BgL__ortest_1376z00_2760 = BGL_CLASS_NIL(BgL_classz00_2759);
							if (CBOOL(BgL__ortest_1376z00_2760))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4192 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2760);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4192 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2759));
								}
						}
					}
					((((BgL_ev_absz00_bglt) CREF(BgL_new1189z00_1743))->BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_4192), BUNSPEC);
				}
				((((BgL_ev_absz00_bglt) CREF(BgL_new1189z00_1743))->BgL_siza7eza7) =
					((int) (int) (((long) 0))), BUNSPEC);
				((((BgL_ev_absz00_bglt) CREF(BgL_new1189z00_1743))->BgL_bindz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_absz00_bglt) CREF(BgL_new1189z00_1743))->BgL_freez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_absz00_bglt) CREF(BgL_new1189z00_1743))->BgL_innerz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_absz00_bglt) CREF(BgL_new1189z00_1743))->BgL_boxesz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1189z00_1743;
			}
		}
	}



/* &lambda2011 */
	BgL_ev_absz00_bglt BGl_z62lambda2011z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3184)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			{

				{	/* Eval/evaluate_types.scm 121 */
					BgL_ev_absz00_bglt BgL_new1188z00_1741;

					BgL_new1188z00_1741 =
						((BgL_ev_absz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_absz00_bgl))));
					{	/* Eval/evaluate_types.scm 121 */
						long BgL_arg2012z00_1742;

						{	/* Eval/evaluate_types.scm 121 */
							long BgL_res2340z00_2756;

							BgL_res2340z00_2756 =
								BGL_CLASS_INDEX(BGl_ev_absz00zz__evaluate_typesz00);
							BgL_arg2012z00_1742 = BgL_res2340z00_2756;
						}
						{	/* Eval/evaluate_types.scm 121 */
							BgL_objectz00_bglt BgL_objz00_2757;

							BgL_objz00_2757 = ((BgL_objectz00_bglt) BgL_new1188z00_1741);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2757, BgL_arg2012z00_1742);
					}}
					{	/* Eval/evaluate_types.scm 121 */
						BgL_objectz00_bglt BgL_auxz00_4211;

						BgL_auxz00_4211 = ((BgL_objectz00_bglt) BgL_new1188z00_1741);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4211, BFALSE);
					}
					return BgL_new1188z00_1741;
				}
			}
		}
	}



/* &lambda2009 */
	BgL_ev_absz00_bglt BGl_z62lambda2009z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3185, obj_t BgL_loc1178z00_3186, obj_t BgL_where1179z00_3187,
		obj_t BgL_arity1180z00_3188, obj_t BgL_vars1181z00_3189,
		obj_t BgL_body1182z00_3190, obj_t BgL_siza7e1183za7_3191,
		obj_t BgL_bind1184z00_3192, obj_t BgL_free1185z00_3193,
		obj_t BgL_inner1186z00_3194, obj_t BgL_boxes1187z00_3195)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			{
				obj_t BgL_loc1178z00_1726;
				obj_t BgL_where1179z00_1727;
				obj_t BgL_arity1180z00_1728;
				obj_t BgL_vars1181z00_1729;
				BgL_ev_exprz00_bglt BgL_body1182z00_1730;
				int BgL_siza7e1183za7_1731;
				obj_t BgL_bind1184z00_1732;
				obj_t BgL_free1185z00_1733;
				obj_t BgL_inner1186z00_1734;
				obj_t BgL_boxes1187z00_1735;

				BgL_loc1178z00_1726 = BgL_loc1178z00_3186;
				BgL_where1179z00_1727 = BgL_where1179z00_3187;
				BgL_arity1180z00_1728 = BgL_arity1180z00_3188;
				BgL_vars1181z00_1729 = BgL_vars1181z00_3189;
				BgL_body1182z00_1730 = ((BgL_ev_exprz00_bglt) BgL_body1182z00_3190);
				BgL_siza7e1183za7_1731 = CINT(BgL_siza7e1183za7_3191);
				BgL_bind1184z00_1732 = BgL_bind1184z00_3192;
				BgL_free1185z00_1733 = BgL_free1185z00_3193;
				BgL_inner1186z00_1734 = BgL_inner1186z00_3194;
				BgL_boxes1187z00_1735 = BgL_boxes1187z00_3195;
				{	/* Eval/evaluate_types.scm 121 */
					BgL_ev_absz00_bglt BgL_new1334z00_2748;

					{	/* Eval/evaluate_types.scm 121 */
						BgL_ev_absz00_bglt BgL_new1333z00_2749;

						BgL_new1333z00_2749 =
							((BgL_ev_absz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_absz00_bgl))));
						{	/* Eval/evaluate_types.scm 121 */
							long BgL_arg2010z00_2750;

							{	/* Eval/evaluate_types.scm 121 */
								long BgL_res2339z00_2752;

								BgL_res2339z00_2752 =
									BGL_CLASS_INDEX(BGl_ev_absz00zz__evaluate_typesz00);
								BgL_arg2010z00_2750 = BgL_res2339z00_2752;
							}
							{	/* Eval/evaluate_types.scm 121 */
								BgL_objectz00_bglt BgL_objz00_2753;

								BgL_objz00_2753 = ((BgL_objectz00_bglt) BgL_new1333z00_2749);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2753, BgL_arg2010z00_2750);
						}}
						{	/* Eval/evaluate_types.scm 121 */
							BgL_objectz00_bglt BgL_auxz00_4218;

							BgL_auxz00_4218 = ((BgL_objectz00_bglt) BgL_new1333z00_2749);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4218, BFALSE);
						}
						BgL_new1334z00_2748 = BgL_new1333z00_2749;
					}
					((((BgL_ev_absz00_bglt) CREF(BgL_new1334z00_2748))->BgL_locz00) =
						((obj_t) BgL_loc1178z00_1726), BUNSPEC);
					((((BgL_ev_absz00_bglt) CREF(BgL_new1334z00_2748))->BgL_wherez00) =
						((obj_t) BgL_where1179z00_1727), BUNSPEC);
					((((BgL_ev_absz00_bglt) CREF(BgL_new1334z00_2748))->BgL_arityz00) =
						((obj_t) BgL_arity1180z00_1728), BUNSPEC);
					((((BgL_ev_absz00_bglt) CREF(BgL_new1334z00_2748))->BgL_varsz00) =
						((obj_t) BgL_vars1181z00_1729), BUNSPEC);
					((((BgL_ev_absz00_bglt) CREF(BgL_new1334z00_2748))->BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_body1182z00_1730), BUNSPEC);
					((((BgL_ev_absz00_bglt) CREF(BgL_new1334z00_2748))->BgL_siza7eza7) =
						((int) BgL_siza7e1183za7_1731), BUNSPEC);
					((((BgL_ev_absz00_bglt) CREF(BgL_new1334z00_2748))->BgL_bindz00) =
						((obj_t) BgL_bind1184z00_1732), BUNSPEC);
					((((BgL_ev_absz00_bglt) CREF(BgL_new1334z00_2748))->BgL_freez00) =
						((obj_t) BgL_free1185z00_1733), BUNSPEC);
					((((BgL_ev_absz00_bglt) CREF(BgL_new1334z00_2748))->BgL_innerz00) =
						((obj_t) BgL_inner1186z00_1734), BUNSPEC);
					((((BgL_ev_absz00_bglt) CREF(BgL_new1334z00_2748))->BgL_boxesz00) =
						((obj_t) BgL_boxes1187z00_1735), BUNSPEC);
					return BgL_new1334z00_2748;
				}
			}
		}
	}



/* &lambda2076 */
	obj_t BGl_z62lambda2076z62zz__evaluate_typesz00(obj_t BgL_envz00_3196,
		obj_t BgL_oz00_3197, obj_t BgL_vz00_3198)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			{	/* Eval/evaluate_types.scm 121 */
				BgL_ev_absz00_bglt BgL_oz00_3651;

				BgL_oz00_3651 = ((BgL_ev_absz00_bglt) BgL_oz00_3197);
				return
					((((BgL_ev_absz00_bglt) CREF(BgL_oz00_3651))->BgL_locz00) =
					((obj_t) BgL_vz00_3198), BUNSPEC);
			}
		}
	}



/* &lambda2075 */
	obj_t BGl_z62lambda2075z62zz__evaluate_typesz00(obj_t BgL_envz00_3199,
		obj_t BgL_oz00_3200)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			return
				(((BgL_ev_absz00_bglt) CREF(
						((BgL_ev_absz00_bglt) BgL_oz00_3200)))->BgL_locz00);
		}
	}



/* &lambda2071 */
	obj_t BGl_z62lambda2071z62zz__evaluate_typesz00(obj_t BgL_envz00_3201,
		obj_t BgL_oz00_3202, obj_t BgL_vz00_3203)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			{	/* Eval/evaluate_types.scm 121 */
				BgL_ev_absz00_bglt BgL_oz00_3654;

				BgL_oz00_3654 = ((BgL_ev_absz00_bglt) BgL_oz00_3202);
				return
					((((BgL_ev_absz00_bglt) CREF(BgL_oz00_3654))->BgL_wherez00) =
					((obj_t) BgL_vz00_3203), BUNSPEC);
			}
		}
	}



/* &lambda2070 */
	obj_t BGl_z62lambda2070z62zz__evaluate_typesz00(obj_t BgL_envz00_3204,
		obj_t BgL_oz00_3205)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			return
				(((BgL_ev_absz00_bglt) CREF(
						((BgL_ev_absz00_bglt) BgL_oz00_3205)))->BgL_wherez00);
		}
	}



/* &lambda2066 */
	obj_t BGl_z62lambda2066z62zz__evaluate_typesz00(obj_t BgL_envz00_3206,
		obj_t BgL_oz00_3207, obj_t BgL_vz00_3208)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			{	/* Eval/evaluate_types.scm 121 */
				BgL_ev_absz00_bglt BgL_oz00_3657;

				BgL_oz00_3657 = ((BgL_ev_absz00_bglt) BgL_oz00_3207);
				return
					((((BgL_ev_absz00_bglt) CREF(BgL_oz00_3657))->BgL_arityz00) =
					((obj_t) BgL_vz00_3208), BUNSPEC);
			}
		}
	}



/* &lambda2065 */
	obj_t BGl_z62lambda2065z62zz__evaluate_typesz00(obj_t BgL_envz00_3209,
		obj_t BgL_oz00_3210)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			return
				(((BgL_ev_absz00_bglt) CREF(
						((BgL_ev_absz00_bglt) BgL_oz00_3210)))->BgL_arityz00);
		}
	}



/* &lambda2061 */
	obj_t BGl_z62lambda2061z62zz__evaluate_typesz00(obj_t BgL_envz00_3211,
		obj_t BgL_oz00_3212, obj_t BgL_vz00_3213)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			{	/* Eval/evaluate_types.scm 121 */
				BgL_ev_absz00_bglt BgL_oz00_3660;

				BgL_oz00_3660 = ((BgL_ev_absz00_bglt) BgL_oz00_3212);
				return
					((((BgL_ev_absz00_bglt) CREF(BgL_oz00_3660))->BgL_varsz00) =
					((obj_t) BgL_vz00_3213), BUNSPEC);
			}
		}
	}



/* &lambda2060 */
	obj_t BGl_z62lambda2060z62zz__evaluate_typesz00(obj_t BgL_envz00_3214,
		obj_t BgL_oz00_3215)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			return
				(((BgL_ev_absz00_bglt) CREF(
						((BgL_ev_absz00_bglt) BgL_oz00_3215)))->BgL_varsz00);
		}
	}



/* &lambda2055 */
	obj_t BGl_z62lambda2055z62zz__evaluate_typesz00(obj_t BgL_envz00_3216,
		obj_t BgL_oz00_3217, obj_t BgL_vz00_3218)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			{	/* Eval/evaluate_types.scm 121 */
				BgL_ev_absz00_bglt BgL_oz00_3663;
				BgL_ev_exprz00_bglt BgL_vz00_3664;

				BgL_oz00_3663 = ((BgL_ev_absz00_bglt) BgL_oz00_3217);
				BgL_vz00_3664 = ((BgL_ev_exprz00_bglt) BgL_vz00_3218);
				return
					((((BgL_ev_absz00_bglt) CREF(BgL_oz00_3663))->BgL_bodyz00) =
					((BgL_ev_exprz00_bglt) BgL_vz00_3664), BUNSPEC);
			}
		}
	}



/* &lambda2054 */
	BgL_ev_exprz00_bglt BGl_z62lambda2054z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3219, obj_t BgL_oz00_3220)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			return
				(((BgL_ev_absz00_bglt) CREF(
						((BgL_ev_absz00_bglt) BgL_oz00_3220)))->BgL_bodyz00);
		}
	}



/* &<anonymous:2050> */
	obj_t BGl_z62zc3anonymousza32050ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3221)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			return BINT(((long) 0));
		}
	}



/* &lambda2049 */
	obj_t BGl_z62lambda2049z62zz__evaluate_typesz00(obj_t BgL_envz00_3222,
		obj_t BgL_oz00_3223, obj_t BgL_vz00_3224)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			{	/* Eval/evaluate_types.scm 121 */
				BgL_ev_absz00_bglt BgL_oz00_3666;
				int BgL_vz00_3667;

				BgL_oz00_3666 = ((BgL_ev_absz00_bglt) BgL_oz00_3223);
				BgL_vz00_3667 = CINT(BgL_vz00_3224);
				return
					((((BgL_ev_absz00_bglt) CREF(BgL_oz00_3666))->BgL_siza7eza7) =
					((int) BgL_vz00_3667), BUNSPEC);
		}}
	}



/* &lambda2048 */
	obj_t BGl_z62lambda2048z62zz__evaluate_typesz00(obj_t BgL_envz00_3225,
		obj_t BgL_oz00_3226)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			return
				BINT(
				(((BgL_ev_absz00_bglt) CREF(
							((BgL_ev_absz00_bglt) BgL_oz00_3226)))->BgL_siza7eza7));
		}
	}



/* &<anonymous:2043> */
	obj_t BGl_z62zc3anonymousza32043ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3227)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			return BNIL;
		}
	}



/* &lambda2042 */
	obj_t BGl_z62lambda2042z62zz__evaluate_typesz00(obj_t BgL_envz00_3228,
		obj_t BgL_oz00_3229, obj_t BgL_vz00_3230)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			{	/* Eval/evaluate_types.scm 121 */
				BgL_ev_absz00_bglt BgL_oz00_3669;

				BgL_oz00_3669 = ((BgL_ev_absz00_bglt) BgL_oz00_3229);
				return
					((((BgL_ev_absz00_bglt) CREF(BgL_oz00_3669))->BgL_bindz00) =
					((obj_t) BgL_vz00_3230), BUNSPEC);
			}
		}
	}



/* &lambda2041 */
	obj_t BGl_z62lambda2041z62zz__evaluate_typesz00(obj_t BgL_envz00_3231,
		obj_t BgL_oz00_3232)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			return
				(((BgL_ev_absz00_bglt) CREF(
						((BgL_ev_absz00_bglt) BgL_oz00_3232)))->BgL_bindz00);
		}
	}



/* &<anonymous:2035> */
	obj_t BGl_z62zc3anonymousza32035ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3233)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			return BNIL;
		}
	}



/* &lambda2034 */
	obj_t BGl_z62lambda2034z62zz__evaluate_typesz00(obj_t BgL_envz00_3234,
		obj_t BgL_oz00_3235, obj_t BgL_vz00_3236)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			{	/* Eval/evaluate_types.scm 121 */
				BgL_ev_absz00_bglt BgL_oz00_3672;

				BgL_oz00_3672 = ((BgL_ev_absz00_bglt) BgL_oz00_3235);
				return
					((((BgL_ev_absz00_bglt) CREF(BgL_oz00_3672))->BgL_freez00) =
					((obj_t) BgL_vz00_3236), BUNSPEC);
			}
		}
	}



/* &lambda2033 */
	obj_t BGl_z62lambda2033z62zz__evaluate_typesz00(obj_t BgL_envz00_3237,
		obj_t BgL_oz00_3238)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			return
				(((BgL_ev_absz00_bglt) CREF(
						((BgL_ev_absz00_bglt) BgL_oz00_3238)))->BgL_freez00);
		}
	}



/* &<anonymous:2027> */
	obj_t BGl_z62zc3anonymousza32027ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3239)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			return BNIL;
		}
	}



/* &lambda2026 */
	obj_t BGl_z62lambda2026z62zz__evaluate_typesz00(obj_t BgL_envz00_3240,
		obj_t BgL_oz00_3241, obj_t BgL_vz00_3242)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			{	/* Eval/evaluate_types.scm 121 */
				BgL_ev_absz00_bglt BgL_oz00_3675;

				BgL_oz00_3675 = ((BgL_ev_absz00_bglt) BgL_oz00_3241);
				return
					((((BgL_ev_absz00_bglt) CREF(BgL_oz00_3675))->BgL_innerz00) =
					((obj_t) BgL_vz00_3242), BUNSPEC);
			}
		}
	}



/* &lambda2025 */
	obj_t BGl_z62lambda2025z62zz__evaluate_typesz00(obj_t BgL_envz00_3243,
		obj_t BgL_oz00_3244)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			return
				(((BgL_ev_absz00_bglt) CREF(
						((BgL_ev_absz00_bglt) BgL_oz00_3244)))->BgL_innerz00);
		}
	}



/* &<anonymous:2020> */
	obj_t BGl_z62zc3anonymousza32020ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3245)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			return BNIL;
		}
	}



/* &lambda2019 */
	obj_t BGl_z62lambda2019z62zz__evaluate_typesz00(obj_t BgL_envz00_3246,
		obj_t BgL_oz00_3247, obj_t BgL_vz00_3248)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			{	/* Eval/evaluate_types.scm 121 */
				BgL_ev_absz00_bglt BgL_oz00_3678;

				BgL_oz00_3678 = ((BgL_ev_absz00_bglt) BgL_oz00_3247);
				return
					((((BgL_ev_absz00_bglt) CREF(BgL_oz00_3678))->BgL_boxesz00) =
					((obj_t) BgL_vz00_3248), BUNSPEC);
			}
		}
	}



/* &lambda2018 */
	obj_t BGl_z62lambda2018z62zz__evaluate_typesz00(obj_t BgL_envz00_3249,
		obj_t BgL_oz00_3250)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 121 */
			return
				(((BgL_ev_absz00_bglt) CREF(
						((BgL_ev_absz00_bglt) BgL_oz00_3250)))->BgL_boxesz00);
		}
	}



/* &<anonymous:1979> */
	BgL_ev_appz00_bglt BGl_z62zc3anonymousza31979ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3251, obj_t BgL_new1176z00_3252)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 118 */
			{
				BgL_ev_appz00_bglt BgL_new1176z00_1666;

				BgL_new1176z00_1666 = ((BgL_ev_appz00_bglt) BgL_new1176z00_3252);
				((((BgL_ev_appz00_bglt) CREF(BgL_new1176z00_1666))->BgL_locz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4278;

					{	/* Eval/evaluate_types.scm 118 */
						obj_t BgL_classz00_2696;

						BgL_classz00_2696 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2697;

							BgL__ortest_1376z00_2697 = BGL_CLASS_NIL(BgL_classz00_2696);
							if (CBOOL(BgL__ortest_1376z00_2697))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4278 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2697);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4278 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2696));
								}
						}
					}
					((((BgL_ev_appz00_bglt) CREF(BgL_new1176z00_1666))->BgL_funz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_4278), BUNSPEC);
				}
				((((BgL_ev_appz00_bglt) CREF(BgL_new1176z00_1666))->BgL_argsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_appz00_bglt) CREF(BgL_new1176z00_1666))->BgL_tailzf3zf3) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1176z00_1666;
			}
		}
	}



/* &lambda1977 */
	BgL_ev_appz00_bglt BGl_z62lambda1977z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3253)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 118 */
			{

				{	/* Eval/evaluate_types.scm 118 */
					BgL_ev_appz00_bglt BgL_new1175z00_1664;

					BgL_new1175z00_1664 =
						((BgL_ev_appz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_appz00_bgl))));
					{	/* Eval/evaluate_types.scm 118 */
						long BgL_arg1978z00_1665;

						{	/* Eval/evaluate_types.scm 118 */
							long BgL_res2338z00_2693;

							BgL_res2338z00_2693 =
								BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00);
							BgL_arg1978z00_1665 = BgL_res2338z00_2693;
						}
						{	/* Eval/evaluate_types.scm 118 */
							BgL_objectz00_bglt BgL_objz00_2694;

							BgL_objz00_2694 = ((BgL_objectz00_bglt) BgL_new1175z00_1664);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2694, BgL_arg1978z00_1665);
					}}
					{	/* Eval/evaluate_types.scm 118 */
						BgL_objectz00_bglt BgL_auxz00_4293;

						BgL_auxz00_4293 = ((BgL_objectz00_bglt) BgL_new1175z00_1664);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4293, BFALSE);
					}
					return BgL_new1175z00_1664;
				}
			}
		}
	}



/* &lambda1975 */
	BgL_ev_appz00_bglt BGl_z62lambda1975z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3254, obj_t BgL_loc1171z00_3255, obj_t BgL_fun1172z00_3256,
		obj_t BgL_args1173z00_3257, obj_t BgL_tailzf31174zf3_3258)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 118 */
			{
				obj_t BgL_loc1171z00_1655;
				BgL_ev_exprz00_bglt BgL_fun1172z00_1656;
				obj_t BgL_args1173z00_1657;
				obj_t BgL_tailzf31174zf3_1658;

				BgL_loc1171z00_1655 = BgL_loc1171z00_3255;
				BgL_fun1172z00_1656 = ((BgL_ev_exprz00_bglt) BgL_fun1172z00_3256);
				BgL_args1173z00_1657 = BgL_args1173z00_3257;
				BgL_tailzf31174zf3_1658 = BgL_tailzf31174zf3_3258;
				{	/* Eval/evaluate_types.scm 118 */
					BgL_ev_appz00_bglt BgL_new1324z00_2685;

					{	/* Eval/evaluate_types.scm 118 */
						BgL_ev_appz00_bglt BgL_new1323z00_2686;

						BgL_new1323z00_2686 =
							((BgL_ev_appz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_appz00_bgl))));
						{	/* Eval/evaluate_types.scm 118 */
							long BgL_arg1976z00_2687;

							{	/* Eval/evaluate_types.scm 118 */
								long BgL_res2337z00_2689;

								BgL_res2337z00_2689 =
									BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00);
								BgL_arg1976z00_2687 = BgL_res2337z00_2689;
							}
							{	/* Eval/evaluate_types.scm 118 */
								BgL_objectz00_bglt BgL_objz00_2690;

								BgL_objz00_2690 = ((BgL_objectz00_bglt) BgL_new1323z00_2686);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2690, BgL_arg1976z00_2687);
						}}
						{	/* Eval/evaluate_types.scm 118 */
							BgL_objectz00_bglt BgL_auxz00_4300;

							BgL_auxz00_4300 = ((BgL_objectz00_bglt) BgL_new1323z00_2686);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4300, BFALSE);
						}
						BgL_new1324z00_2685 = BgL_new1323z00_2686;
					}
					((((BgL_ev_appz00_bglt) CREF(BgL_new1324z00_2685))->BgL_locz00) =
						((obj_t) BgL_loc1171z00_1655), BUNSPEC);
					((((BgL_ev_appz00_bglt) CREF(BgL_new1324z00_2685))->BgL_funz00) =
						((BgL_ev_exprz00_bglt) BgL_fun1172z00_1656), BUNSPEC);
					((((BgL_ev_appz00_bglt) CREF(BgL_new1324z00_2685))->BgL_argsz00) =
						((obj_t) BgL_args1173z00_1657), BUNSPEC);
					((((BgL_ev_appz00_bglt) CREF(BgL_new1324z00_2685))->BgL_tailzf3zf3) =
						((obj_t) BgL_tailzf31174zf3_1658), BUNSPEC);
					return BgL_new1324z00_2685;
				}
			}
		}
	}



/* &lambda2000 */
	obj_t BGl_z62lambda2000z62zz__evaluate_typesz00(obj_t BgL_envz00_3259,
		obj_t BgL_oz00_3260, obj_t BgL_vz00_3261)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 118 */
			{	/* Eval/evaluate_types.scm 118 */
				BgL_ev_appz00_bglt BgL_oz00_3681;

				BgL_oz00_3681 = ((BgL_ev_appz00_bglt) BgL_oz00_3260);
				return
					((((BgL_ev_appz00_bglt) CREF(BgL_oz00_3681))->BgL_locz00) =
					((obj_t) BgL_vz00_3261), BUNSPEC);
			}
		}
	}



/* &lambda1999 */
	obj_t BGl_z62lambda1999z62zz__evaluate_typesz00(obj_t BgL_envz00_3262,
		obj_t BgL_oz00_3263)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 118 */
			return
				(((BgL_ev_appz00_bglt) CREF(
						((BgL_ev_appz00_bglt) BgL_oz00_3263)))->BgL_locz00);
		}
	}



/* &lambda1995 */
	obj_t BGl_z62lambda1995z62zz__evaluate_typesz00(obj_t BgL_envz00_3264,
		obj_t BgL_oz00_3265, obj_t BgL_vz00_3266)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 118 */
			{	/* Eval/evaluate_types.scm 118 */
				BgL_ev_appz00_bglt BgL_oz00_3684;
				BgL_ev_exprz00_bglt BgL_vz00_3685;

				BgL_oz00_3684 = ((BgL_ev_appz00_bglt) BgL_oz00_3265);
				BgL_vz00_3685 = ((BgL_ev_exprz00_bglt) BgL_vz00_3266);
				return
					((((BgL_ev_appz00_bglt) CREF(BgL_oz00_3684))->BgL_funz00) =
					((BgL_ev_exprz00_bglt) BgL_vz00_3685), BUNSPEC);
			}
		}
	}



/* &lambda1994 */
	BgL_ev_exprz00_bglt BGl_z62lambda1994z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3267, obj_t BgL_oz00_3268)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 118 */
			return
				(((BgL_ev_appz00_bglt) CREF(
						((BgL_ev_appz00_bglt) BgL_oz00_3268)))->BgL_funz00);
		}
	}



/* &lambda1989 */
	obj_t BGl_z62lambda1989z62zz__evaluate_typesz00(obj_t BgL_envz00_3269,
		obj_t BgL_oz00_3270, obj_t BgL_vz00_3271)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 118 */
			{	/* Eval/evaluate_types.scm 118 */
				BgL_ev_appz00_bglt BgL_oz00_3687;

				BgL_oz00_3687 = ((BgL_ev_appz00_bglt) BgL_oz00_3270);
				return
					((((BgL_ev_appz00_bglt) CREF(BgL_oz00_3687))->BgL_argsz00) =
					((obj_t) BgL_vz00_3271), BUNSPEC);
			}
		}
	}



/* &lambda1988 */
	obj_t BGl_z62lambda1988z62zz__evaluate_typesz00(obj_t BgL_envz00_3272,
		obj_t BgL_oz00_3273)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 118 */
			return
				(((BgL_ev_appz00_bglt) CREF(
						((BgL_ev_appz00_bglt) BgL_oz00_3273)))->BgL_argsz00);
		}
	}



/* &lambda1984 */
	obj_t BGl_z62lambda1984z62zz__evaluate_typesz00(obj_t BgL_envz00_3274,
		obj_t BgL_oz00_3275, obj_t BgL_vz00_3276)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 118 */
			{	/* Eval/evaluate_types.scm 118 */
				BgL_ev_appz00_bglt BgL_oz00_3690;

				BgL_oz00_3690 = ((BgL_ev_appz00_bglt) BgL_oz00_3275);
				return
					((((BgL_ev_appz00_bglt) CREF(BgL_oz00_3690))->BgL_tailzf3zf3) =
					((obj_t) BgL_vz00_3276), BUNSPEC);
			}
		}
	}



/* &lambda1983 */
	obj_t BGl_z62lambda1983z62zz__evaluate_typesz00(obj_t BgL_envz00_3277,
		obj_t BgL_oz00_3278)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 118 */
			return
				(((BgL_ev_appz00_bglt) CREF(
						((BgL_ev_appz00_bglt) BgL_oz00_3278)))->BgL_tailzf3zf3);
		}
	}



/* &<anonymous:1948> */
	BgL_ev_gotoz00_bglt
		BGl_z62zc3anonymousza31948ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3279,
		obj_t BgL_new1169z00_3280)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 113 */
			{
				BgL_ev_gotoz00_bglt BgL_new1169z00_1595;

				BgL_new1169z00_1595 = ((BgL_ev_gotoz00_bglt) BgL_new1169z00_3280);
				((((BgL_ev_gotoz00_bglt) CREF(BgL_new1169z00_1595))->BgL_locz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_varz00_bglt BgL_auxz00_4326;

					{	/* Eval/evaluate_types.scm 113 */
						obj_t BgL_classz00_2661;

						BgL_classz00_2661 = BGl_ev_varz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2662;

							BgL__ortest_1376z00_2662 = BGL_CLASS_NIL(BgL_classz00_2661);
							if (CBOOL(BgL__ortest_1376z00_2662))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4326 =
										((BgL_ev_varz00_bglt) BgL__ortest_1376z00_2662);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4326 =
										((BgL_ev_varz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2661));
								}
						}
					}
					((((BgL_ev_gotoz00_bglt) CREF(BgL_new1169z00_1595))->BgL_labelz00) =
						((BgL_ev_varz00_bglt) BgL_auxz00_4326), BUNSPEC);
				}
				{
					BgL_ev_labelsz00_bglt BgL_auxz00_4334;

					{	/* Eval/evaluate_types.scm 113 */
						obj_t BgL_classz00_2663;

						BgL_classz00_2663 = BGl_ev_labelsz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2664;

							BgL__ortest_1376z00_2664 = BGL_CLASS_NIL(BgL_classz00_2663);
							if (CBOOL(BgL__ortest_1376z00_2664))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4334 =
										((BgL_ev_labelsz00_bglt) BgL__ortest_1376z00_2664);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4334 =
										((BgL_ev_labelsz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2663));
								}
						}
					}
					((((BgL_ev_gotoz00_bglt) CREF(BgL_new1169z00_1595))->BgL_labelsz00) =
						((BgL_ev_labelsz00_bglt) BgL_auxz00_4334), BUNSPEC);
				}
				((((BgL_ev_gotoz00_bglt) CREF(BgL_new1169z00_1595))->BgL_argsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1169z00_1595;
			}
		}
	}



/* &lambda1946 */
	BgL_ev_gotoz00_bglt BGl_z62lambda1946z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3281)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 113 */
			{

				{	/* Eval/evaluate_types.scm 113 */
					BgL_ev_gotoz00_bglt BgL_new1168z00_1593;

					BgL_new1168z00_1593 =
						((BgL_ev_gotoz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_gotoz00_bgl))));
					{	/* Eval/evaluate_types.scm 113 */
						long BgL_arg1947z00_1594;

						{	/* Eval/evaluate_types.scm 113 */
							long BgL_res2336z00_2658;

							BgL_res2336z00_2658 =
								BGL_CLASS_INDEX(BGl_ev_gotoz00zz__evaluate_typesz00);
							BgL_arg1947z00_1594 = BgL_res2336z00_2658;
						}
						{	/* Eval/evaluate_types.scm 113 */
							BgL_objectz00_bglt BgL_objz00_2659;

							BgL_objz00_2659 = ((BgL_objectz00_bglt) BgL_new1168z00_1593);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2659, BgL_arg1947z00_1594);
					}}
					{	/* Eval/evaluate_types.scm 113 */
						BgL_objectz00_bglt BgL_auxz00_4348;

						BgL_auxz00_4348 = ((BgL_objectz00_bglt) BgL_new1168z00_1593);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4348, BFALSE);
					}
					return BgL_new1168z00_1593;
				}
			}
		}
	}



/* &lambda1944 */
	BgL_ev_gotoz00_bglt BGl_z62lambda1944z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3282, obj_t BgL_loc1164z00_3283, obj_t BgL_label1165z00_3284,
		obj_t BgL_labels1166z00_3285, obj_t BgL_args1167z00_3286)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 113 */
			{
				obj_t BgL_loc1164z00_1584;
				BgL_ev_varz00_bglt BgL_label1165z00_1585;
				BgL_ev_labelsz00_bglt BgL_labels1166z00_1586;
				obj_t BgL_args1167z00_1587;

				BgL_loc1164z00_1584 = BgL_loc1164z00_3283;
				BgL_label1165z00_1585 = ((BgL_ev_varz00_bglt) BgL_label1165z00_3284);
				BgL_labels1166z00_1586 =
					((BgL_ev_labelsz00_bglt) BgL_labels1166z00_3285);
				BgL_args1167z00_1587 = BgL_args1167z00_3286;
				{	/* Eval/evaluate_types.scm 113 */
					BgL_ev_gotoz00_bglt BgL_new1314z00_2650;

					{	/* Eval/evaluate_types.scm 113 */
						BgL_ev_gotoz00_bglt BgL_new1313z00_2651;

						BgL_new1313z00_2651 =
							((BgL_ev_gotoz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_gotoz00_bgl))));
						{	/* Eval/evaluate_types.scm 113 */
							long BgL_arg1945z00_2652;

							{	/* Eval/evaluate_types.scm 113 */
								long BgL_res2335z00_2654;

								BgL_res2335z00_2654 =
									BGL_CLASS_INDEX(BGl_ev_gotoz00zz__evaluate_typesz00);
								BgL_arg1945z00_2652 = BgL_res2335z00_2654;
							}
							{	/* Eval/evaluate_types.scm 113 */
								BgL_objectz00_bglt BgL_objz00_2655;

								BgL_objz00_2655 = ((BgL_objectz00_bglt) BgL_new1313z00_2651);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2655, BgL_arg1945z00_2652);
						}}
						{	/* Eval/evaluate_types.scm 113 */
							BgL_objectz00_bglt BgL_auxz00_4355;

							BgL_auxz00_4355 = ((BgL_objectz00_bglt) BgL_new1313z00_2651);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4355, BFALSE);
						}
						BgL_new1314z00_2650 = BgL_new1313z00_2651;
					}
					((((BgL_ev_gotoz00_bglt) CREF(BgL_new1314z00_2650))->BgL_locz00) =
						((obj_t) BgL_loc1164z00_1584), BUNSPEC);
					((((BgL_ev_gotoz00_bglt) CREF(BgL_new1314z00_2650))->BgL_labelz00) =
						((BgL_ev_varz00_bglt) BgL_label1165z00_1585), BUNSPEC);
					((((BgL_ev_gotoz00_bglt) CREF(BgL_new1314z00_2650))->BgL_labelsz00) =
						((BgL_ev_labelsz00_bglt) BgL_labels1166z00_1586), BUNSPEC);
					((((BgL_ev_gotoz00_bglt) CREF(BgL_new1314z00_2650))->BgL_argsz00) =
						((obj_t) BgL_args1167z00_1587), BUNSPEC);
					return BgL_new1314z00_2650;
				}
			}
		}
	}



/* &lambda1969 */
	obj_t BGl_z62lambda1969z62zz__evaluate_typesz00(obj_t BgL_envz00_3287,
		obj_t BgL_oz00_3288, obj_t BgL_vz00_3289)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 113 */
			{	/* Eval/evaluate_types.scm 113 */
				BgL_ev_gotoz00_bglt BgL_oz00_3693;

				BgL_oz00_3693 = ((BgL_ev_gotoz00_bglt) BgL_oz00_3288);
				return
					((((BgL_ev_gotoz00_bglt) CREF(BgL_oz00_3693))->BgL_locz00) =
					((obj_t) BgL_vz00_3289), BUNSPEC);
			}
		}
	}



/* &lambda1968 */
	obj_t BGl_z62lambda1968z62zz__evaluate_typesz00(obj_t BgL_envz00_3290,
		obj_t BgL_oz00_3291)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 113 */
			return
				(((BgL_ev_gotoz00_bglt) CREF(
						((BgL_ev_gotoz00_bglt) BgL_oz00_3291)))->BgL_locz00);
		}
	}



/* &lambda1964 */
	obj_t BGl_z62lambda1964z62zz__evaluate_typesz00(obj_t BgL_envz00_3292,
		obj_t BgL_oz00_3293, obj_t BgL_vz00_3294)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 113 */
			{	/* Eval/evaluate_types.scm 113 */
				BgL_ev_gotoz00_bglt BgL_oz00_3696;
				BgL_ev_varz00_bglt BgL_vz00_3697;

				BgL_oz00_3696 = ((BgL_ev_gotoz00_bglt) BgL_oz00_3293);
				BgL_vz00_3697 = ((BgL_ev_varz00_bglt) BgL_vz00_3294);
				return
					((((BgL_ev_gotoz00_bglt) CREF(BgL_oz00_3696))->BgL_labelz00) =
					((BgL_ev_varz00_bglt) BgL_vz00_3697), BUNSPEC);
			}
		}
	}



/* &lambda1963 */
	BgL_ev_varz00_bglt BGl_z62lambda1963z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3295, obj_t BgL_oz00_3296)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 113 */
			return
				(((BgL_ev_gotoz00_bglt) CREF(
						((BgL_ev_gotoz00_bglt) BgL_oz00_3296)))->BgL_labelz00);
		}
	}



/* &lambda1959 */
	obj_t BGl_z62lambda1959z62zz__evaluate_typesz00(obj_t BgL_envz00_3297,
		obj_t BgL_oz00_3298, obj_t BgL_vz00_3299)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 113 */
			{	/* Eval/evaluate_types.scm 113 */
				BgL_ev_gotoz00_bglt BgL_oz00_3699;
				BgL_ev_labelsz00_bglt BgL_vz00_3700;

				BgL_oz00_3699 = ((BgL_ev_gotoz00_bglt) BgL_oz00_3298);
				BgL_vz00_3700 = ((BgL_ev_labelsz00_bglt) BgL_vz00_3299);
				return
					((((BgL_ev_gotoz00_bglt) CREF(BgL_oz00_3699))->BgL_labelsz00) =
					((BgL_ev_labelsz00_bglt) BgL_vz00_3700), BUNSPEC);
			}
		}
	}



/* &lambda1958 */
	BgL_ev_labelsz00_bglt BGl_z62lambda1958z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3300, obj_t BgL_oz00_3301)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 113 */
			return
				(((BgL_ev_gotoz00_bglt) CREF(
						((BgL_ev_gotoz00_bglt) BgL_oz00_3301)))->BgL_labelsz00);
		}
	}



/* &lambda1953 */
	obj_t BGl_z62lambda1953z62zz__evaluate_typesz00(obj_t BgL_envz00_3302,
		obj_t BgL_oz00_3303, obj_t BgL_vz00_3304)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 113 */
			{	/* Eval/evaluate_types.scm 113 */
				BgL_ev_gotoz00_bglt BgL_oz00_3702;

				BgL_oz00_3702 = ((BgL_ev_gotoz00_bglt) BgL_oz00_3303);
				return
					((((BgL_ev_gotoz00_bglt) CREF(BgL_oz00_3702))->BgL_argsz00) =
					((obj_t) BgL_vz00_3304), BUNSPEC);
			}
		}
	}



/* &lambda1952 */
	obj_t BGl_z62lambda1952z62zz__evaluate_typesz00(obj_t BgL_envz00_3305,
		obj_t BgL_oz00_3306)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 113 */
			return
				(((BgL_ev_gotoz00_bglt) CREF(
						((BgL_ev_gotoz00_bglt) BgL_oz00_3306)))->BgL_argsz00);
		}
	}



/* &<anonymous:1900> */
	BgL_ev_labelsz00_bglt
		BGl_z62zc3anonymousza31900ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3307,
		obj_t BgL_new1162z00_3308)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 105 */
			{
				BgL_ev_labelsz00_bglt BgL_new1162z00_1491;

				BgL_new1162z00_1491 = ((BgL_ev_labelsz00_bglt) BgL_new1162z00_3308);
				((((BgL_ev_labelsz00_bglt) CREF(BgL_new1162z00_1491))->BgL_varsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_labelsz00_bglt) CREF(BgL_new1162z00_1491))->BgL_valsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_labelsz00_bglt) CREF(BgL_new1162z00_1491))->BgL_envz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_labelsz00_bglt) CREF(BgL_new1162z00_1491))->BgL_stkz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4386;

					{	/* Eval/evaluate_types.scm 105 */
						obj_t BgL_classz00_2628;

						BgL_classz00_2628 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2629;

							BgL__ortest_1376z00_2629 = BGL_CLASS_NIL(BgL_classz00_2628);
							if (CBOOL(BgL__ortest_1376z00_2629))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4386 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2629);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4386 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2628));
								}
						}
					}
					((((BgL_ev_labelsz00_bglt) CREF(BgL_new1162z00_1491))->BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_4386), BUNSPEC);
				}
				((((BgL_ev_labelsz00_bglt) CREF(BgL_new1162z00_1491))->BgL_boxesz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1162z00_1491;
			}
		}
	}



/* &lambda1898 */
	BgL_ev_labelsz00_bglt BGl_z62lambda1898z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3309)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 105 */
			{

				{	/* Eval/evaluate_types.scm 105 */
					BgL_ev_labelsz00_bglt BgL_new1161z00_1489;

					BgL_new1161z00_1489 =
						((BgL_ev_labelsz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_labelsz00_bgl))));
					{	/* Eval/evaluate_types.scm 105 */
						long BgL_arg1899z00_1490;

						{	/* Eval/evaluate_types.scm 105 */
							long BgL_res2334z00_2625;

							BgL_res2334z00_2625 =
								BGL_CLASS_INDEX(BGl_ev_labelsz00zz__evaluate_typesz00);
							BgL_arg1899z00_1490 = BgL_res2334z00_2625;
						}
						{	/* Eval/evaluate_types.scm 105 */
							BgL_objectz00_bglt BgL_objz00_2626;

							BgL_objz00_2626 = ((BgL_objectz00_bglt) BgL_new1161z00_1489);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2626, BgL_arg1899z00_1490);
					}}
					{	/* Eval/evaluate_types.scm 105 */
						BgL_objectz00_bglt BgL_auxz00_4400;

						BgL_auxz00_4400 = ((BgL_objectz00_bglt) BgL_new1161z00_1489);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4400, BFALSE);
					}
					return BgL_new1161z00_1489;
				}
			}
		}
	}



/* &lambda1896 */
	BgL_ev_labelsz00_bglt BGl_z62lambda1896z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3310, obj_t BgL_vars1155z00_3311, obj_t BgL_vals1156z00_3312,
		obj_t BgL_env1157z00_3313, obj_t BgL_stk1158z00_3314,
		obj_t BgL_body1159z00_3315, obj_t BgL_boxes1160z00_3316)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 105 */
			{
				obj_t BgL_vars1155z00_1478;
				obj_t BgL_vals1156z00_1479;
				obj_t BgL_env1157z00_1480;
				obj_t BgL_stk1158z00_1481;
				BgL_ev_exprz00_bglt BgL_body1159z00_1482;
				obj_t BgL_boxes1160z00_1483;

				BgL_vars1155z00_1478 = BgL_vars1155z00_3311;
				BgL_vals1156z00_1479 = BgL_vals1156z00_3312;
				BgL_env1157z00_1480 = BgL_env1157z00_3313;
				BgL_stk1158z00_1481 = BgL_stk1158z00_3314;
				BgL_body1159z00_1482 = ((BgL_ev_exprz00_bglt) BgL_body1159z00_3315);
				BgL_boxes1160z00_1483 = BgL_boxes1160z00_3316;
				{	/* Eval/evaluate_types.scm 105 */
					BgL_ev_labelsz00_bglt BgL_new1300z00_2617;

					{	/* Eval/evaluate_types.scm 105 */
						BgL_ev_labelsz00_bglt BgL_new1299z00_2618;

						BgL_new1299z00_2618 =
							((BgL_ev_labelsz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_labelsz00_bgl))));
						{	/* Eval/evaluate_types.scm 105 */
							long BgL_arg1897z00_2619;

							{	/* Eval/evaluate_types.scm 105 */
								long BgL_res2333z00_2621;

								BgL_res2333z00_2621 =
									BGL_CLASS_INDEX(BGl_ev_labelsz00zz__evaluate_typesz00);
								BgL_arg1897z00_2619 = BgL_res2333z00_2621;
							}
							{	/* Eval/evaluate_types.scm 105 */
								BgL_objectz00_bglt BgL_objz00_2622;

								BgL_objz00_2622 = ((BgL_objectz00_bglt) BgL_new1299z00_2618);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2622, BgL_arg1897z00_2619);
						}}
						{	/* Eval/evaluate_types.scm 105 */
							BgL_objectz00_bglt BgL_auxz00_4407;

							BgL_auxz00_4407 = ((BgL_objectz00_bglt) BgL_new1299z00_2618);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4407, BFALSE);
						}
						BgL_new1300z00_2617 = BgL_new1299z00_2618;
					}
					((((BgL_ev_labelsz00_bglt) CREF(BgL_new1300z00_2617))->BgL_varsz00) =
						((obj_t) BgL_vars1155z00_1478), BUNSPEC);
					((((BgL_ev_labelsz00_bglt) CREF(BgL_new1300z00_2617))->BgL_valsz00) =
						((obj_t) BgL_vals1156z00_1479), BUNSPEC);
					((((BgL_ev_labelsz00_bglt) CREF(BgL_new1300z00_2617))->BgL_envz00) =
						((obj_t) BgL_env1157z00_1480), BUNSPEC);
					((((BgL_ev_labelsz00_bglt) CREF(BgL_new1300z00_2617))->BgL_stkz00) =
						((obj_t) BgL_stk1158z00_1481), BUNSPEC);
					((((BgL_ev_labelsz00_bglt) CREF(BgL_new1300z00_2617))->BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_body1159z00_1482), BUNSPEC);
					((((BgL_ev_labelsz00_bglt) CREF(BgL_new1300z00_2617))->BgL_boxesz00) =
						((obj_t) BgL_boxes1160z00_1483), BUNSPEC);
					return BgL_new1300z00_2617;
				}
			}
		}
	}



/* &lambda1937 */
	obj_t BGl_z62lambda1937z62zz__evaluate_typesz00(obj_t BgL_envz00_3317,
		obj_t BgL_oz00_3318, obj_t BgL_vz00_3319)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 105 */
			{	/* Eval/evaluate_types.scm 105 */
				BgL_ev_labelsz00_bglt BgL_oz00_3705;

				BgL_oz00_3705 = ((BgL_ev_labelsz00_bglt) BgL_oz00_3318);
				return
					((((BgL_ev_labelsz00_bglt) CREF(BgL_oz00_3705))->BgL_varsz00) =
					((obj_t) BgL_vz00_3319), BUNSPEC);
			}
		}
	}



/* &lambda1936 */
	obj_t BGl_z62lambda1936z62zz__evaluate_typesz00(obj_t BgL_envz00_3320,
		obj_t BgL_oz00_3321)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 105 */
			return
				(((BgL_ev_labelsz00_bglt) CREF(
						((BgL_ev_labelsz00_bglt) BgL_oz00_3321)))->BgL_varsz00);
		}
	}



/* &lambda1932 */
	obj_t BGl_z62lambda1932z62zz__evaluate_typesz00(obj_t BgL_envz00_3322,
		obj_t BgL_oz00_3323, obj_t BgL_vz00_3324)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 105 */
			{	/* Eval/evaluate_types.scm 105 */
				BgL_ev_labelsz00_bglt BgL_oz00_3708;

				BgL_oz00_3708 = ((BgL_ev_labelsz00_bglt) BgL_oz00_3323);
				return
					((((BgL_ev_labelsz00_bglt) CREF(BgL_oz00_3708))->BgL_valsz00) =
					((obj_t) BgL_vz00_3324), BUNSPEC);
			}
		}
	}



/* &lambda1931 */
	obj_t BGl_z62lambda1931z62zz__evaluate_typesz00(obj_t BgL_envz00_3325,
		obj_t BgL_oz00_3326)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 105 */
			return
				(((BgL_ev_labelsz00_bglt) CREF(
						((BgL_ev_labelsz00_bglt) BgL_oz00_3326)))->BgL_valsz00);
		}
	}



/* &<anonymous:1927> */
	obj_t BGl_z62zc3anonymousza31927ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3327)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 105 */
			return BNIL;
		}
	}



/* &lambda1926 */
	obj_t BGl_z62lambda1926z62zz__evaluate_typesz00(obj_t BgL_envz00_3328,
		obj_t BgL_oz00_3329, obj_t BgL_vz00_3330)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 105 */
			{	/* Eval/evaluate_types.scm 105 */
				BgL_ev_labelsz00_bglt BgL_oz00_3711;

				BgL_oz00_3711 = ((BgL_ev_labelsz00_bglt) BgL_oz00_3329);
				return
					((((BgL_ev_labelsz00_bglt) CREF(BgL_oz00_3711))->BgL_envz00) =
					((obj_t) BgL_vz00_3330), BUNSPEC);
			}
		}
	}



/* &lambda1925 */
	obj_t BGl_z62lambda1925z62zz__evaluate_typesz00(obj_t BgL_envz00_3331,
		obj_t BgL_oz00_3332)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 105 */
			return
				(((BgL_ev_labelsz00_bglt) CREF(
						((BgL_ev_labelsz00_bglt) BgL_oz00_3332)))->BgL_envz00);
		}
	}



/* &<anonymous:1920> */
	obj_t BGl_z62zc3anonymousza31920ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3333)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 105 */
			return BNIL;
		}
	}



/* &lambda1919 */
	obj_t BGl_z62lambda1919z62zz__evaluate_typesz00(obj_t BgL_envz00_3334,
		obj_t BgL_oz00_3335, obj_t BgL_vz00_3336)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 105 */
			{	/* Eval/evaluate_types.scm 105 */
				BgL_ev_labelsz00_bglt BgL_oz00_3714;

				BgL_oz00_3714 = ((BgL_ev_labelsz00_bglt) BgL_oz00_3335);
				return
					((((BgL_ev_labelsz00_bglt) CREF(BgL_oz00_3714))->BgL_stkz00) =
					((obj_t) BgL_vz00_3336), BUNSPEC);
			}
		}
	}



/* &lambda1918 */
	obj_t BGl_z62lambda1918z62zz__evaluate_typesz00(obj_t BgL_envz00_3337,
		obj_t BgL_oz00_3338)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 105 */
			return
				(((BgL_ev_labelsz00_bglt) CREF(
						((BgL_ev_labelsz00_bglt) BgL_oz00_3338)))->BgL_stkz00);
		}
	}



/* &lambda1912 */
	obj_t BGl_z62lambda1912z62zz__evaluate_typesz00(obj_t BgL_envz00_3339,
		obj_t BgL_oz00_3340, obj_t BgL_vz00_3341)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 105 */
			{	/* Eval/evaluate_types.scm 105 */
				BgL_ev_labelsz00_bglt BgL_oz00_3717;
				BgL_ev_exprz00_bglt BgL_vz00_3718;

				BgL_oz00_3717 = ((BgL_ev_labelsz00_bglt) BgL_oz00_3340);
				BgL_vz00_3718 = ((BgL_ev_exprz00_bglt) BgL_vz00_3341);
				return
					((((BgL_ev_labelsz00_bglt) CREF(BgL_oz00_3717))->BgL_bodyz00) =
					((BgL_ev_exprz00_bglt) BgL_vz00_3718), BUNSPEC);
			}
		}
	}



/* &lambda1911 */
	BgL_ev_exprz00_bglt BGl_z62lambda1911z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3342, obj_t BgL_oz00_3343)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 105 */
			return
				(((BgL_ev_labelsz00_bglt) CREF(
						((BgL_ev_labelsz00_bglt) BgL_oz00_3343)))->BgL_bodyz00);
		}
	}



/* &<anonymous:1907> */
	obj_t BGl_z62zc3anonymousza31907ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3344)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 105 */
			return BNIL;
		}
	}



/* &lambda1906 */
	obj_t BGl_z62lambda1906z62zz__evaluate_typesz00(obj_t BgL_envz00_3345,
		obj_t BgL_oz00_3346, obj_t BgL_vz00_3347)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 105 */
			{	/* Eval/evaluate_types.scm 105 */
				BgL_ev_labelsz00_bglt BgL_oz00_3720;

				BgL_oz00_3720 = ((BgL_ev_labelsz00_bglt) BgL_oz00_3346);
				return
					((((BgL_ev_labelsz00_bglt) CREF(BgL_oz00_3720))->BgL_boxesz00) =
					((obj_t) BgL_vz00_3347), BUNSPEC);
			}
		}
	}



/* &lambda1905 */
	obj_t BGl_z62lambda1905z62zz__evaluate_typesz00(obj_t BgL_envz00_3348,
		obj_t BgL_oz00_3349)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 105 */
			return
				(((BgL_ev_labelsz00_bglt) CREF(
						((BgL_ev_labelsz00_bglt) BgL_oz00_3349)))->BgL_boxesz00);
		}
	}



/* &<anonymous:1890> */
	BgL_ev_letrecz00_bglt
		BGl_z62zc3anonymousza31890ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3350,
		obj_t BgL_new1153z00_3351)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 104 */
			{
				BgL_ev_letrecz00_bglt BgL_new1153z00_1466;

				BgL_new1153z00_1466 = ((BgL_ev_letrecz00_bglt) BgL_new1153z00_3351);
				((((BgL_ev_binderz00_bglt) CREF(
								((BgL_ev_binderz00_bglt) BgL_new1153z00_1466)))->BgL_varsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt)
									BgL_new1153z00_1466)))->BgL_valsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4446;

					{	/* Eval/evaluate_types.scm 104 */
						obj_t BgL_classz00_2585;

						BgL_classz00_2585 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2586;

							BgL__ortest_1376z00_2586 = BGL_CLASS_NIL(BgL_classz00_2585);
							if (CBOOL(BgL__ortest_1376z00_2586))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4446 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2586);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4446 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2585));
								}
						}
					}
					((((BgL_ev_binderz00_bglt) CREF(
									((BgL_ev_binderz00_bglt) BgL_new1153z00_1466)))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4446), BUNSPEC);
				}
				return BgL_new1153z00_1466;
			}
		}
	}



/* &lambda1888 */
	BgL_ev_letrecz00_bglt BGl_z62lambda1888z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3352)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 104 */
			{

				{	/* Eval/evaluate_types.scm 104 */
					BgL_ev_letrecz00_bglt BgL_new1152z00_1464;

					BgL_new1152z00_1464 =
						((BgL_ev_letrecz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_letrecz00_bgl))));
					{	/* Eval/evaluate_types.scm 104 */
						long BgL_arg1889z00_1465;

						{	/* Eval/evaluate_types.scm 104 */
							long BgL_res2332z00_2582;

							BgL_res2332z00_2582 =
								BGL_CLASS_INDEX(BGl_ev_letrecz00zz__evaluate_typesz00);
							BgL_arg1889z00_1465 = BgL_res2332z00_2582;
						}
						{	/* Eval/evaluate_types.scm 104 */
							BgL_objectz00_bglt BgL_objz00_2583;

							BgL_objz00_2583 = ((BgL_objectz00_bglt) BgL_new1152z00_1464);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2583, BgL_arg1889z00_1465);
					}}
					{	/* Eval/evaluate_types.scm 104 */
						BgL_objectz00_bglt BgL_auxz00_4460;

						BgL_auxz00_4460 = ((BgL_objectz00_bglt) BgL_new1152z00_1464);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4460, BFALSE);
					}
					return BgL_new1152z00_1464;
				}
			}
		}
	}



/* &lambda1886 */
	BgL_ev_letrecz00_bglt BGl_z62lambda1886z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3353, obj_t BgL_vars1149z00_3354, obj_t BgL_vals1150z00_3355,
		obj_t BgL_body1151z00_3356)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 104 */
			{
				obj_t BgL_vars1149z00_1456;
				obj_t BgL_vals1150z00_1457;
				BgL_ev_exprz00_bglt BgL_body1151z00_1458;

				BgL_vars1149z00_1456 = BgL_vars1149z00_3354;
				BgL_vals1150z00_1457 = BgL_vals1150z00_3355;
				BgL_body1151z00_1458 = ((BgL_ev_exprz00_bglt) BgL_body1151z00_3356);
				{	/* Eval/evaluate_types.scm 104 */
					BgL_ev_letrecz00_bglt BgL_new1298z00_2574;

					{	/* Eval/evaluate_types.scm 104 */
						BgL_ev_letrecz00_bglt BgL_new1297z00_2575;

						BgL_new1297z00_2575 =
							((BgL_ev_letrecz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_letrecz00_bgl))));
						{	/* Eval/evaluate_types.scm 104 */
							long BgL_arg1887z00_2576;

							{	/* Eval/evaluate_types.scm 104 */
								long BgL_res2331z00_2578;

								BgL_res2331z00_2578 =
									BGL_CLASS_INDEX(BGl_ev_letrecz00zz__evaluate_typesz00);
								BgL_arg1887z00_2576 = BgL_res2331z00_2578;
							}
							{	/* Eval/evaluate_types.scm 104 */
								BgL_objectz00_bglt BgL_objz00_2579;

								BgL_objz00_2579 = ((BgL_objectz00_bglt) BgL_new1297z00_2575);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2579, BgL_arg1887z00_2576);
						}}
						{	/* Eval/evaluate_types.scm 104 */
							BgL_objectz00_bglt BgL_auxz00_4467;

							BgL_auxz00_4467 = ((BgL_objectz00_bglt) BgL_new1297z00_2575);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4467, BFALSE);
						}
						BgL_new1298z00_2574 = BgL_new1297z00_2575;
					}
					((((BgL_ev_binderz00_bglt) CREF(
									((BgL_ev_binderz00_bglt) BgL_new1298z00_2574)))->
							BgL_varsz00) = ((obj_t) BgL_vars1149z00_1456), BUNSPEC);
					((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt)
										BgL_new1298z00_2574)))->BgL_valsz00) =
						((obj_t) BgL_vals1150z00_1457), BUNSPEC);
					((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt)
										BgL_new1298z00_2574)))->BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_body1151z00_1458), BUNSPEC);
					return BgL_new1298z00_2574;
				}
			}
		}
	}



/* &<anonymous:1873> */
	BgL_ev_letza2za2_bglt
		BGl_z62zc3anonymousza31873ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3357,
		obj_t BgL_new1147z00_3358)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 102 */
			{
				BgL_ev_letza2za2_bglt BgL_new1147z00_1429;

				BgL_new1147z00_1429 = ((BgL_ev_letza2za2_bglt) BgL_new1147z00_3358);
				((((BgL_ev_binderz00_bglt) CREF(
								((BgL_ev_binderz00_bglt) BgL_new1147z00_1429)))->BgL_varsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt)
									BgL_new1147z00_1429)))->BgL_valsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4481;

					{	/* Eval/evaluate_types.scm 102 */
						obj_t BgL_classz00_2572;

						BgL_classz00_2572 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2573;

							BgL__ortest_1376z00_2573 = BGL_CLASS_NIL(BgL_classz00_2572);
							if (CBOOL(BgL__ortest_1376z00_2573))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4481 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2573);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4481 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2572));
								}
						}
					}
					((((BgL_ev_binderz00_bglt) CREF(
									((BgL_ev_binderz00_bglt) BgL_new1147z00_1429)))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4481), BUNSPEC);
				}
				((((BgL_ev_letza2za2_bglt) CREF(BgL_new1147z00_1429))->BgL_boxesz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1147z00_1429;
			}
		}
	}



/* &lambda1871 */
	BgL_ev_letza2za2_bglt BGl_z62lambda1871z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3359)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 102 */
			{

				{	/* Eval/evaluate_types.scm 102 */
					BgL_ev_letza2za2_bglt BgL_new1146z00_1427;

					BgL_new1146z00_1427 =
						((BgL_ev_letza2za2_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_letza2za2_bgl))));
					{	/* Eval/evaluate_types.scm 102 */
						long BgL_arg1872z00_1428;

						{	/* Eval/evaluate_types.scm 102 */
							long BgL_res2330z00_2569;

							BgL_res2330z00_2569 =
								BGL_CLASS_INDEX(BGl_ev_letza2za2zz__evaluate_typesz00);
							BgL_arg1872z00_1428 = BgL_res2330z00_2569;
						}
						{	/* Eval/evaluate_types.scm 102 */
							BgL_objectz00_bglt BgL_objz00_2570;

							BgL_objz00_2570 = ((BgL_objectz00_bglt) BgL_new1146z00_1427);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2570, BgL_arg1872z00_1428);
					}}
					{	/* Eval/evaluate_types.scm 102 */
						BgL_objectz00_bglt BgL_auxz00_4496;

						BgL_auxz00_4496 = ((BgL_objectz00_bglt) BgL_new1146z00_1427);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4496, BFALSE);
					}
					return BgL_new1146z00_1427;
				}
			}
		}
	}



/* &lambda1869 */
	BgL_ev_letza2za2_bglt BGl_z62lambda1869z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3360, obj_t BgL_vars1142z00_3361, obj_t BgL_vals1143z00_3362,
		obj_t BgL_body1144z00_3363, obj_t BgL_boxes1145z00_3364)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 102 */
			{
				obj_t BgL_vars1142z00_1418;
				obj_t BgL_vals1143z00_1419;
				BgL_ev_exprz00_bglt BgL_body1144z00_1420;
				obj_t BgL_boxes1145z00_1421;

				BgL_vars1142z00_1418 = BgL_vars1142z00_3361;
				BgL_vals1143z00_1419 = BgL_vals1143z00_3362;
				BgL_body1144z00_1420 = ((BgL_ev_exprz00_bglt) BgL_body1144z00_3363);
				BgL_boxes1145z00_1421 = BgL_boxes1145z00_3364;
				{	/* Eval/evaluate_types.scm 102 */
					BgL_ev_letza2za2_bglt BgL_new1294z00_2561;

					{	/* Eval/evaluate_types.scm 102 */
						BgL_ev_letza2za2_bglt BgL_new1293z00_2562;

						BgL_new1293z00_2562 =
							((BgL_ev_letza2za2_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_letza2za2_bgl))));
						{	/* Eval/evaluate_types.scm 102 */
							long BgL_arg1870z00_2563;

							{	/* Eval/evaluate_types.scm 102 */
								long BgL_res2329z00_2565;

								BgL_res2329z00_2565 =
									BGL_CLASS_INDEX(BGl_ev_letza2za2zz__evaluate_typesz00);
								BgL_arg1870z00_2563 = BgL_res2329z00_2565;
							}
							{	/* Eval/evaluate_types.scm 102 */
								BgL_objectz00_bglt BgL_objz00_2566;

								BgL_objz00_2566 = ((BgL_objectz00_bglt) BgL_new1293z00_2562);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2566, BgL_arg1870z00_2563);
						}}
						{	/* Eval/evaluate_types.scm 102 */
							BgL_objectz00_bglt BgL_auxz00_4503;

							BgL_auxz00_4503 = ((BgL_objectz00_bglt) BgL_new1293z00_2562);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4503, BFALSE);
						}
						BgL_new1294z00_2561 = BgL_new1293z00_2562;
					}
					((((BgL_ev_binderz00_bglt) CREF(
									((BgL_ev_binderz00_bglt) BgL_new1294z00_2561)))->
							BgL_varsz00) = ((obj_t) BgL_vars1142z00_1418), BUNSPEC);
					((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt)
										BgL_new1294z00_2561)))->BgL_valsz00) =
						((obj_t) BgL_vals1143z00_1419), BUNSPEC);
					((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt)
										BgL_new1294z00_2561)))->BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_body1144z00_1420), BUNSPEC);
					((((BgL_ev_letza2za2_bglt) CREF(BgL_new1294z00_2561))->BgL_boxesz00) =
						((obj_t) BgL_boxes1145z00_1421), BUNSPEC);
					return BgL_new1294z00_2561;
				}
			}
		}
	}



/* &<anonymous:1880> */
	obj_t BGl_z62zc3anonymousza31880ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3365)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 102 */
			return BNIL;
		}
	}



/* &lambda1879 */
	obj_t BGl_z62lambda1879z62zz__evaluate_typesz00(obj_t BgL_envz00_3366,
		obj_t BgL_oz00_3367, obj_t BgL_vz00_3368)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 102 */
			{	/* Eval/evaluate_types.scm 102 */
				BgL_ev_letza2za2_bglt BgL_oz00_3723;

				BgL_oz00_3723 = ((BgL_ev_letza2za2_bglt) BgL_oz00_3367);
				return
					((((BgL_ev_letza2za2_bglt) CREF(BgL_oz00_3723))->BgL_boxesz00) =
					((obj_t) BgL_vz00_3368), BUNSPEC);
			}
		}
	}



/* &lambda1878 */
	obj_t BGl_z62lambda1878z62zz__evaluate_typesz00(obj_t BgL_envz00_3369,
		obj_t BgL_oz00_3370)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 102 */
			return
				(((BgL_ev_letza2za2_bglt) CREF(
						((BgL_ev_letza2za2_bglt) BgL_oz00_3370)))->BgL_boxesz00);
		}
	}



/* &<anonymous:1854> */
	BgL_ev_letz00_bglt BGl_z62zc3anonymousza31854ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3371, obj_t BgL_new1140z00_3372)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 100 */
			{
				BgL_ev_letz00_bglt BgL_new1140z00_1391;

				BgL_new1140z00_1391 = ((BgL_ev_letz00_bglt) BgL_new1140z00_3372);
				((((BgL_ev_binderz00_bglt) CREF(
								((BgL_ev_binderz00_bglt) BgL_new1140z00_1391)))->BgL_varsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt)
									BgL_new1140z00_1391)))->BgL_valsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4522;

					{	/* Eval/evaluate_types.scm 100 */
						obj_t BgL_classz00_2554;

						BgL_classz00_2554 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2555;

							BgL__ortest_1376z00_2555 = BGL_CLASS_NIL(BgL_classz00_2554);
							if (CBOOL(BgL__ortest_1376z00_2555))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4522 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2555);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4522 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2554));
								}
						}
					}
					((((BgL_ev_binderz00_bglt) CREF(
									((BgL_ev_binderz00_bglt) BgL_new1140z00_1391)))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4522), BUNSPEC);
				}
				((((BgL_ev_letz00_bglt) CREF(BgL_new1140z00_1391))->BgL_boxesz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1140z00_1391;
			}
		}
	}



/* &lambda1852 */
	BgL_ev_letz00_bglt BGl_z62lambda1852z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3373)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 100 */
			{

				{	/* Eval/evaluate_types.scm 100 */
					BgL_ev_letz00_bglt BgL_new1139z00_1389;

					BgL_new1139z00_1389 =
						((BgL_ev_letz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_letz00_bgl))));
					{	/* Eval/evaluate_types.scm 100 */
						long BgL_arg1853z00_1390;

						{	/* Eval/evaluate_types.scm 100 */
							long BgL_res2328z00_2551;

							BgL_res2328z00_2551 =
								BGL_CLASS_INDEX(BGl_ev_letz00zz__evaluate_typesz00);
							BgL_arg1853z00_1390 = BgL_res2328z00_2551;
						}
						{	/* Eval/evaluate_types.scm 100 */
							BgL_objectz00_bglt BgL_objz00_2552;

							BgL_objz00_2552 = ((BgL_objectz00_bglt) BgL_new1139z00_1389);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2552, BgL_arg1853z00_1390);
					}}
					{	/* Eval/evaluate_types.scm 100 */
						BgL_objectz00_bglt BgL_auxz00_4537;

						BgL_auxz00_4537 = ((BgL_objectz00_bglt) BgL_new1139z00_1389);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4537, BFALSE);
					}
					return BgL_new1139z00_1389;
				}
			}
		}
	}



/* &lambda1850 */
	BgL_ev_letz00_bglt BGl_z62lambda1850z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3374, obj_t BgL_vars1135z00_3375, obj_t BgL_vals1136z00_3376,
		obj_t BgL_body1137z00_3377, obj_t BgL_boxes1138z00_3378)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 100 */
			{
				obj_t BgL_vars1135z00_1380;
				obj_t BgL_vals1136z00_1381;
				BgL_ev_exprz00_bglt BgL_body1137z00_1382;
				obj_t BgL_boxes1138z00_1383;

				BgL_vars1135z00_1380 = BgL_vars1135z00_3375;
				BgL_vals1136z00_1381 = BgL_vals1136z00_3376;
				BgL_body1137z00_1382 = ((BgL_ev_exprz00_bglt) BgL_body1137z00_3377);
				BgL_boxes1138z00_1383 = BgL_boxes1138z00_3378;
				{	/* Eval/evaluate_types.scm 100 */
					BgL_ev_letz00_bglt BgL_new1290z00_2543;

					{	/* Eval/evaluate_types.scm 100 */
						BgL_ev_letz00_bglt BgL_new1289z00_2544;

						BgL_new1289z00_2544 =
							((BgL_ev_letz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_letz00_bgl))));
						{	/* Eval/evaluate_types.scm 100 */
							long BgL_arg1851z00_2545;

							{	/* Eval/evaluate_types.scm 100 */
								long BgL_res2327z00_2547;

								BgL_res2327z00_2547 =
									BGL_CLASS_INDEX(BGl_ev_letz00zz__evaluate_typesz00);
								BgL_arg1851z00_2545 = BgL_res2327z00_2547;
							}
							{	/* Eval/evaluate_types.scm 100 */
								BgL_objectz00_bglt BgL_objz00_2548;

								BgL_objz00_2548 = ((BgL_objectz00_bglt) BgL_new1289z00_2544);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2548, BgL_arg1851z00_2545);
						}}
						{	/* Eval/evaluate_types.scm 100 */
							BgL_objectz00_bglt BgL_auxz00_4544;

							BgL_auxz00_4544 = ((BgL_objectz00_bglt) BgL_new1289z00_2544);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4544, BFALSE);
						}
						BgL_new1290z00_2543 = BgL_new1289z00_2544;
					}
					((((BgL_ev_binderz00_bglt) CREF(
									((BgL_ev_binderz00_bglt) BgL_new1290z00_2543)))->
							BgL_varsz00) = ((obj_t) BgL_vars1135z00_1380), BUNSPEC);
					((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt)
										BgL_new1290z00_2543)))->BgL_valsz00) =
						((obj_t) BgL_vals1136z00_1381), BUNSPEC);
					((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt)
										BgL_new1290z00_2543)))->BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_body1137z00_1382), BUNSPEC);
					((((BgL_ev_letz00_bglt) CREF(BgL_new1290z00_2543))->BgL_boxesz00) =
						((obj_t) BgL_boxes1138z00_1383), BUNSPEC);
					return BgL_new1290z00_2543;
				}
			}
		}
	}



/* &<anonymous:1862> */
	obj_t BGl_z62zc3anonymousza31862ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3379)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 100 */
			return BNIL;
		}
	}



/* &lambda1861 */
	obj_t BGl_z62lambda1861z62zz__evaluate_typesz00(obj_t BgL_envz00_3380,
		obj_t BgL_oz00_3381, obj_t BgL_vz00_3382)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 100 */
			{	/* Eval/evaluate_types.scm 100 */
				BgL_ev_letz00_bglt BgL_oz00_3726;

				BgL_oz00_3726 = ((BgL_ev_letz00_bglt) BgL_oz00_3381);
				return
					((((BgL_ev_letz00_bglt) CREF(BgL_oz00_3726))->BgL_boxesz00) =
					((obj_t) BgL_vz00_3382), BUNSPEC);
			}
		}
	}



/* &lambda1860 */
	obj_t BGl_z62lambda1860z62zz__evaluate_typesz00(obj_t BgL_envz00_3383,
		obj_t BgL_oz00_3384)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 100 */
			return
				(((BgL_ev_letz00_bglt) CREF(
						((BgL_ev_letz00_bglt) BgL_oz00_3384)))->BgL_boxesz00);
		}
	}



/* &<anonymous:1828> */
	BgL_ev_binderz00_bglt
		BGl_z62zc3anonymousza31828ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3385,
		obj_t BgL_new1133z00_3386)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 96 */
			{
				BgL_ev_binderz00_bglt BgL_new1133z00_1332;

				BgL_new1133z00_1332 = ((BgL_ev_binderz00_bglt) BgL_new1133z00_3386);
				((((BgL_ev_binderz00_bglt) CREF(BgL_new1133z00_1332))->BgL_varsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_binderz00_bglt) CREF(BgL_new1133z00_1332))->BgL_valsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4561;

					{	/* Eval/evaluate_types.scm 96 */
						obj_t BgL_classz00_2536;

						BgL_classz00_2536 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2537;

							BgL__ortest_1376z00_2537 = BGL_CLASS_NIL(BgL_classz00_2536);
							if (CBOOL(BgL__ortest_1376z00_2537))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4561 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2537);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4561 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2536));
								}
						}
					}
					((((BgL_ev_binderz00_bglt) CREF(BgL_new1133z00_1332))->BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_4561), BUNSPEC);
				}
				return BgL_new1133z00_1332;
			}
		}
	}



/* &lambda1826 */
	BgL_ev_binderz00_bglt BGl_z62lambda1826z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3387)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 96 */
			{

				{	/* Eval/evaluate_types.scm 96 */
					BgL_ev_binderz00_bglt BgL_new1132z00_1330;

					BgL_new1132z00_1330 =
						((BgL_ev_binderz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_binderz00_bgl))));
					{	/* Eval/evaluate_types.scm 96 */
						long BgL_arg1827z00_1331;

						{	/* Eval/evaluate_types.scm 96 */
							long BgL_res2326z00_2533;

							BgL_res2326z00_2533 =
								BGL_CLASS_INDEX(BGl_ev_binderz00zz__evaluate_typesz00);
							BgL_arg1827z00_1331 = BgL_res2326z00_2533;
						}
						{	/* Eval/evaluate_types.scm 96 */
							BgL_objectz00_bglt BgL_objz00_2534;

							BgL_objz00_2534 = ((BgL_objectz00_bglt) BgL_new1132z00_1330);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2534, BgL_arg1827z00_1331);
					}}
					{	/* Eval/evaluate_types.scm 96 */
						BgL_objectz00_bglt BgL_auxz00_4574;

						BgL_auxz00_4574 = ((BgL_objectz00_bglt) BgL_new1132z00_1330);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4574, BFALSE);
					}
					return BgL_new1132z00_1330;
				}
			}
		}
	}



/* &lambda1824 */
	BgL_ev_binderz00_bglt BGl_z62lambda1824z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3388, obj_t BgL_vars1129z00_3389, obj_t BgL_vals1130z00_3390,
		obj_t BgL_body1131z00_3391)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 96 */
			{
				obj_t BgL_vars1129z00_1322;
				obj_t BgL_vals1130z00_1323;
				BgL_ev_exprz00_bglt BgL_body1131z00_1324;

				BgL_vars1129z00_1322 = BgL_vars1129z00_3389;
				BgL_vals1130z00_1323 = BgL_vals1130z00_3390;
				BgL_body1131z00_1324 = ((BgL_ev_exprz00_bglt) BgL_body1131z00_3391);
				{	/* Eval/evaluate_types.scm 96 */
					BgL_ev_binderz00_bglt BgL_new1282z00_2525;

					{	/* Eval/evaluate_types.scm 96 */
						BgL_ev_binderz00_bglt BgL_new1281z00_2526;

						BgL_new1281z00_2526 =
							((BgL_ev_binderz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_binderz00_bgl))));
						{	/* Eval/evaluate_types.scm 96 */
							long BgL_arg1825z00_2527;

							{	/* Eval/evaluate_types.scm 96 */
								long BgL_res2325z00_2529;

								BgL_res2325z00_2529 =
									BGL_CLASS_INDEX(BGl_ev_binderz00zz__evaluate_typesz00);
								BgL_arg1825z00_2527 = BgL_res2325z00_2529;
							}
							{	/* Eval/evaluate_types.scm 96 */
								BgL_objectz00_bglt BgL_objz00_2530;

								BgL_objz00_2530 = ((BgL_objectz00_bglt) BgL_new1281z00_2526);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2530, BgL_arg1825z00_2527);
						}}
						{	/* Eval/evaluate_types.scm 96 */
							BgL_objectz00_bglt BgL_auxz00_4581;

							BgL_auxz00_4581 = ((BgL_objectz00_bglt) BgL_new1281z00_2526);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4581, BFALSE);
						}
						BgL_new1282z00_2525 = BgL_new1281z00_2526;
					}
					((((BgL_ev_binderz00_bglt) CREF(BgL_new1282z00_2525))->BgL_varsz00) =
						((obj_t) BgL_vars1129z00_1322), BUNSPEC);
					((((BgL_ev_binderz00_bglt) CREF(BgL_new1282z00_2525))->BgL_valsz00) =
						((obj_t) BgL_vals1130z00_1323), BUNSPEC);
					((((BgL_ev_binderz00_bglt) CREF(BgL_new1282z00_2525))->BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_body1131z00_1324), BUNSPEC);
					return BgL_new1282z00_2525;
				}
			}
		}
	}



/* &lambda1843 */
	obj_t BGl_z62lambda1843z62zz__evaluate_typesz00(obj_t BgL_envz00_3392,
		obj_t BgL_oz00_3393, obj_t BgL_vz00_3394)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 96 */
			{	/* Eval/evaluate_types.scm 96 */
				BgL_ev_binderz00_bglt BgL_oz00_3729;

				BgL_oz00_3729 = ((BgL_ev_binderz00_bglt) BgL_oz00_3393);
				return
					((((BgL_ev_binderz00_bglt) CREF(BgL_oz00_3729))->BgL_varsz00) =
					((obj_t) BgL_vz00_3394), BUNSPEC);
			}
		}
	}



/* &lambda1842 */
	obj_t BGl_z62lambda1842z62zz__evaluate_typesz00(obj_t BgL_envz00_3395,
		obj_t BgL_oz00_3396)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 96 */
			return
				(((BgL_ev_binderz00_bglt) CREF(
						((BgL_ev_binderz00_bglt) BgL_oz00_3396)))->BgL_varsz00);
		}
	}



/* &lambda1838 */
	obj_t BGl_z62lambda1838z62zz__evaluate_typesz00(obj_t BgL_envz00_3397,
		obj_t BgL_oz00_3398, obj_t BgL_vz00_3399)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 96 */
			{	/* Eval/evaluate_types.scm 96 */
				BgL_ev_binderz00_bglt BgL_oz00_3732;

				BgL_oz00_3732 = ((BgL_ev_binderz00_bglt) BgL_oz00_3398);
				return
					((((BgL_ev_binderz00_bglt) CREF(BgL_oz00_3732))->BgL_valsz00) =
					((obj_t) BgL_vz00_3399), BUNSPEC);
			}
		}
	}



/* &lambda1837 */
	obj_t BGl_z62lambda1837z62zz__evaluate_typesz00(obj_t BgL_envz00_3400,
		obj_t BgL_oz00_3401)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 96 */
			return
				(((BgL_ev_binderz00_bglt) CREF(
						((BgL_ev_binderz00_bglt) BgL_oz00_3401)))->BgL_valsz00);
		}
	}



/* &lambda1833 */
	obj_t BGl_z62lambda1833z62zz__evaluate_typesz00(obj_t BgL_envz00_3402,
		obj_t BgL_oz00_3403, obj_t BgL_vz00_3404)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 96 */
			{	/* Eval/evaluate_types.scm 96 */
				BgL_ev_binderz00_bglt BgL_oz00_3735;
				BgL_ev_exprz00_bglt BgL_vz00_3736;

				BgL_oz00_3735 = ((BgL_ev_binderz00_bglt) BgL_oz00_3403);
				BgL_vz00_3736 = ((BgL_ev_exprz00_bglt) BgL_vz00_3404);
				return
					((((BgL_ev_binderz00_bglt) CREF(BgL_oz00_3735))->BgL_bodyz00) =
					((BgL_ev_exprz00_bglt) BgL_vz00_3736), BUNSPEC);
			}
		}
	}



/* &lambda1832 */
	BgL_ev_exprz00_bglt BGl_z62lambda1832z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3405, obj_t BgL_oz00_3406)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 96 */
			return
				(((BgL_ev_binderz00_bglt) CREF(
						((BgL_ev_binderz00_bglt) BgL_oz00_3406)))->BgL_bodyz00);
		}
	}



/* &<anonymous:1803> */
	BgL_ev_synchroniza7eza7_bglt
		BGl_z62zc3anonymousza31803ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3407,
		obj_t BgL_new1127z00_3408)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 92 */
			{
				BgL_ev_synchroniza7eza7_bglt BgL_new1127z00_1274;

				BgL_new1127z00_1274 =
					((BgL_ev_synchroniza7eza7_bglt) BgL_new1127z00_3408);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4601;

					{	/* Eval/evaluate_types.scm 92 */
						obj_t BgL_classz00_2504;

						BgL_classz00_2504 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2505;

							BgL__ortest_1376z00_2505 = BGL_CLASS_NIL(BgL_classz00_2504);
							if (CBOOL(BgL__ortest_1376z00_2505))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4601 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2505);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4601 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2504));
								}
						}
					}
					((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1127z00_1274))->
							BgL_mutexz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4601), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4609;

					{	/* Eval/evaluate_types.scm 92 */
						obj_t BgL_classz00_2506;

						BgL_classz00_2506 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2507;

							BgL__ortest_1376z00_2507 = BGL_CLASS_NIL(BgL_classz00_2506);
							if (CBOOL(BgL__ortest_1376z00_2507))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4609 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2507);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4609 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2506));
								}
						}
					}
					((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1127z00_1274))->
							BgL_prelockz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_4609), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4617;

					{	/* Eval/evaluate_types.scm 92 */
						obj_t BgL_classz00_2508;

						BgL_classz00_2508 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2509;

							BgL__ortest_1376z00_2509 = BGL_CLASS_NIL(BgL_classz00_2508);
							if (CBOOL(BgL__ortest_1376z00_2509))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4617 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2509);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4617 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2508));
								}
						}
					}
					((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1127z00_1274))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4617), BUNSPEC);
				}
				return BgL_new1127z00_1274;
			}
		}
	}



/* &lambda1801 */
	BgL_ev_synchroniza7eza7_bglt BGl_z62lambda1801z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3409)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 92 */
			{

				{	/* Eval/evaluate_types.scm 92 */
					BgL_ev_synchroniza7eza7_bglt BgL_new1126z00_1272;

					BgL_new1126z00_1272 =
						((BgL_ev_synchroniza7eza7_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_synchroniza7eza7_bgl))));
					{	/* Eval/evaluate_types.scm 92 */
						long BgL_arg1802z00_1273;

						{	/* Eval/evaluate_types.scm 92 */
							long BgL_res2324z00_2501;

							BgL_res2324z00_2501 =
								BGL_CLASS_INDEX(BGl_ev_synchroniza7eza7zz__evaluate_typesz00);
							BgL_arg1802z00_1273 = BgL_res2324z00_2501;
						}
						{	/* Eval/evaluate_types.scm 92 */
							BgL_objectz00_bglt BgL_objz00_2502;

							BgL_objz00_2502 = ((BgL_objectz00_bglt) BgL_new1126z00_1272);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2502, BgL_arg1802z00_1273);
					}}
					{	/* Eval/evaluate_types.scm 92 */
						BgL_objectz00_bglt BgL_auxz00_4630;

						BgL_auxz00_4630 = ((BgL_objectz00_bglt) BgL_new1126z00_1272);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4630, BFALSE);
					}
					return BgL_new1126z00_1272;
				}
			}
		}
	}



/* &lambda1799 */
	BgL_ev_synchroniza7eza7_bglt BGl_z62lambda1799z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3410, obj_t BgL_mutex1123z00_3411, obj_t BgL_prelock1124z00_3412,
		obj_t BgL_body1125z00_3413)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 92 */
			{
				BgL_ev_exprz00_bglt BgL_mutex1123z00_1264;
				BgL_ev_exprz00_bglt BgL_prelock1124z00_1265;
				BgL_ev_exprz00_bglt BgL_body1125z00_1266;

				BgL_mutex1123z00_1264 = ((BgL_ev_exprz00_bglt) BgL_mutex1123z00_3411);
				BgL_prelock1124z00_1265 =
					((BgL_ev_exprz00_bglt) BgL_prelock1124z00_3412);
				BgL_body1125z00_1266 = ((BgL_ev_exprz00_bglt) BgL_body1125z00_3413);
				{	/* Eval/evaluate_types.scm 92 */
					BgL_ev_synchroniza7eza7_bglt BgL_new1274z00_2493;

					{	/* Eval/evaluate_types.scm 92 */
						BgL_ev_synchroniza7eza7_bglt BgL_new1273z00_2494;

						BgL_new1273z00_2494 =
							((BgL_ev_synchroniza7eza7_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_synchroniza7eza7_bgl))));
						{	/* Eval/evaluate_types.scm 92 */
							long BgL_arg1800z00_2495;

							{	/* Eval/evaluate_types.scm 92 */
								long BgL_res2323z00_2497;

								BgL_res2323z00_2497 =
									BGL_CLASS_INDEX(BGl_ev_synchroniza7eza7zz__evaluate_typesz00);
								BgL_arg1800z00_2495 = BgL_res2323z00_2497;
							}
							{	/* Eval/evaluate_types.scm 92 */
								BgL_objectz00_bglt BgL_objz00_2498;

								BgL_objz00_2498 = ((BgL_objectz00_bglt) BgL_new1273z00_2494);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2498, BgL_arg1800z00_2495);
						}}
						{	/* Eval/evaluate_types.scm 92 */
							BgL_objectz00_bglt BgL_auxz00_4637;

							BgL_auxz00_4637 = ((BgL_objectz00_bglt) BgL_new1273z00_2494);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4637, BFALSE);
						}
						BgL_new1274z00_2493 = BgL_new1273z00_2494;
					}
					((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1274z00_2493))->
							BgL_mutexz00) =
						((BgL_ev_exprz00_bglt) BgL_mutex1123z00_1264), BUNSPEC);
					((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1274z00_2493))->
							BgL_prelockz00) =
						((BgL_ev_exprz00_bglt) BgL_prelock1124z00_1265), BUNSPEC);
					((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1274z00_2493))->
							BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_body1125z00_1266), BUNSPEC);
					return BgL_new1274z00_2493;
				}
			}
		}
	}



/* &lambda1818 */
	obj_t BGl_z62lambda1818z62zz__evaluate_typesz00(obj_t BgL_envz00_3414,
		obj_t BgL_oz00_3415, obj_t BgL_vz00_3416)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 92 */
			{	/* Eval/evaluate_types.scm 92 */
				BgL_ev_synchroniza7eza7_bglt BgL_oz00_3738;
				BgL_ev_exprz00_bglt BgL_vz00_3739;

				BgL_oz00_3738 = ((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3415);
				BgL_vz00_3739 = ((BgL_ev_exprz00_bglt) BgL_vz00_3416);
				return
					((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_oz00_3738))->
						BgL_mutexz00) = ((BgL_ev_exprz00_bglt) BgL_vz00_3739), BUNSPEC);
			}
		}
	}



/* &lambda1817 */
	BgL_ev_exprz00_bglt BGl_z62lambda1817z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3417, obj_t BgL_oz00_3418)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 92 */
			return
				(((BgL_ev_synchroniza7eza7_bglt) CREF(
						((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3418)))->BgL_mutexz00);
		}
	}



/* &lambda1813 */
	obj_t BGl_z62lambda1813z62zz__evaluate_typesz00(obj_t BgL_envz00_3419,
		obj_t BgL_oz00_3420, obj_t BgL_vz00_3421)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 92 */
			{	/* Eval/evaluate_types.scm 92 */
				BgL_ev_synchroniza7eza7_bglt BgL_oz00_3741;
				BgL_ev_exprz00_bglt BgL_vz00_3742;

				BgL_oz00_3741 = ((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3420);
				BgL_vz00_3742 = ((BgL_ev_exprz00_bglt) BgL_vz00_3421);
				return
					((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_oz00_3741))->
						BgL_prelockz00) = ((BgL_ev_exprz00_bglt) BgL_vz00_3742), BUNSPEC);
			}
		}
	}



/* &lambda1812 */
	BgL_ev_exprz00_bglt BGl_z62lambda1812z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3422, obj_t BgL_oz00_3423)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 92 */
			return
				(((BgL_ev_synchroniza7eza7_bglt) CREF(
						((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3423)))->BgL_prelockz00);
		}
	}



/* &lambda1808 */
	obj_t BGl_z62lambda1808z62zz__evaluate_typesz00(obj_t BgL_envz00_3424,
		obj_t BgL_oz00_3425, obj_t BgL_vz00_3426)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 92 */
			{	/* Eval/evaluate_types.scm 92 */
				BgL_ev_synchroniza7eza7_bglt BgL_oz00_3744;
				BgL_ev_exprz00_bglt BgL_vz00_3745;

				BgL_oz00_3744 = ((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3425);
				BgL_vz00_3745 = ((BgL_ev_exprz00_bglt) BgL_vz00_3426);
				return
					((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_oz00_3744))->BgL_bodyz00) =
					((BgL_ev_exprz00_bglt) BgL_vz00_3745), BUNSPEC);
			}
		}
	}



/* &lambda1807 */
	BgL_ev_exprz00_bglt BGl_z62lambda1807z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3427, obj_t BgL_oz00_3428)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 92 */
			return
				(((BgL_ev_synchroniza7eza7_bglt) CREF(
						((BgL_ev_synchroniza7eza7_bglt) BgL_oz00_3428)))->BgL_bodyz00);
		}
	}



/* &<anonymous:1783> */
	BgL_ev_withzd2handlerzd2_bglt
		BGl_z62zc3anonymousza31783ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3429,
		obj_t BgL_new1121z00_3430)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 89 */
			{
				BgL_ev_withzd2handlerzd2_bglt BgL_new1121z00_1228;

				BgL_new1121z00_1228 =
					((BgL_ev_withzd2handlerzd2_bglt) BgL_new1121z00_3430);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4661;

					{	/* Eval/evaluate_types.scm 89 */
						obj_t BgL_classz00_2474;

						BgL_classz00_2474 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2475;

							BgL__ortest_1376z00_2475 = BGL_CLASS_NIL(BgL_classz00_2474);
							if (CBOOL(BgL__ortest_1376z00_2475))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4661 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2475);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4661 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2474));
								}
						}
					}
					((((BgL_ev_withzd2handlerzd2_bglt) CREF(BgL_new1121z00_1228))->
							BgL_handlerz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_4661), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4669;

					{	/* Eval/evaluate_types.scm 89 */
						obj_t BgL_classz00_2476;

						BgL_classz00_2476 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2477;

							BgL__ortest_1376z00_2477 = BGL_CLASS_NIL(BgL_classz00_2476);
							if (CBOOL(BgL__ortest_1376z00_2477))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4669 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2477);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4669 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2476));
								}
						}
					}
					((((BgL_ev_withzd2handlerzd2_bglt) CREF(BgL_new1121z00_1228))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4669), BUNSPEC);
				}
				return BgL_new1121z00_1228;
			}
		}
	}



/* &lambda1781 */
	BgL_ev_withzd2handlerzd2_bglt BGl_z62lambda1781z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3431)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 89 */
			{

				{	/* Eval/evaluate_types.scm 89 */
					BgL_ev_withzd2handlerzd2_bglt BgL_new1120z00_1226;

					BgL_new1120z00_1226 =
						((BgL_ev_withzd2handlerzd2_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_withzd2handlerzd2_bgl))));
					{	/* Eval/evaluate_types.scm 89 */
						long BgL_arg1782z00_1227;

						{	/* Eval/evaluate_types.scm 89 */
							long BgL_res2322z00_2471;

							BgL_res2322z00_2471 =
								BGL_CLASS_INDEX(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00);
							BgL_arg1782z00_1227 = BgL_res2322z00_2471;
						}
						{	/* Eval/evaluate_types.scm 89 */
							BgL_objectz00_bglt BgL_objz00_2472;

							BgL_objz00_2472 = ((BgL_objectz00_bglt) BgL_new1120z00_1226);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2472, BgL_arg1782z00_1227);
					}}
					{	/* Eval/evaluate_types.scm 89 */
						BgL_objectz00_bglt BgL_auxz00_4682;

						BgL_auxz00_4682 = ((BgL_objectz00_bglt) BgL_new1120z00_1226);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4682, BFALSE);
					}
					return BgL_new1120z00_1226;
				}
			}
		}
	}



/* &lambda1779 */
	BgL_ev_withzd2handlerzd2_bglt BGl_z62lambda1779z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3432, obj_t BgL_handler1118z00_3433, obj_t BgL_body1119z00_3434)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 89 */
			{
				BgL_ev_exprz00_bglt BgL_handler1118z00_1219;
				BgL_ev_exprz00_bglt BgL_body1119z00_1220;

				BgL_handler1118z00_1219 =
					((BgL_ev_exprz00_bglt) BgL_handler1118z00_3433);
				BgL_body1119z00_1220 = ((BgL_ev_exprz00_bglt) BgL_body1119z00_3434);
				{	/* Eval/evaluate_types.scm 89 */
					BgL_ev_withzd2handlerzd2_bglt BgL_new1268z00_2463;

					{	/* Eval/evaluate_types.scm 89 */
						BgL_ev_withzd2handlerzd2_bglt BgL_new1267z00_2464;

						BgL_new1267z00_2464 =
							((BgL_ev_withzd2handlerzd2_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_withzd2handlerzd2_bgl))));
						{	/* Eval/evaluate_types.scm 89 */
							long BgL_arg1780z00_2465;

							{	/* Eval/evaluate_types.scm 89 */
								long BgL_res2321z00_2467;

								BgL_res2321z00_2467 =
									BGL_CLASS_INDEX
									(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00);
								BgL_arg1780z00_2465 = BgL_res2321z00_2467;
							}
							{	/* Eval/evaluate_types.scm 89 */
								BgL_objectz00_bglt BgL_objz00_2468;

								BgL_objz00_2468 = ((BgL_objectz00_bglt) BgL_new1267z00_2464);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2468, BgL_arg1780z00_2465);
						}}
						{	/* Eval/evaluate_types.scm 89 */
							BgL_objectz00_bglt BgL_auxz00_4689;

							BgL_auxz00_4689 = ((BgL_objectz00_bglt) BgL_new1267z00_2464);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4689, BFALSE);
						}
						BgL_new1268z00_2463 = BgL_new1267z00_2464;
					}
					((((BgL_ev_withzd2handlerzd2_bglt) CREF(BgL_new1268z00_2463))->
							BgL_handlerz00) =
						((BgL_ev_exprz00_bglt) BgL_handler1118z00_1219), BUNSPEC);
					((((BgL_ev_withzd2handlerzd2_bglt) CREF(BgL_new1268z00_2463))->
							BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_body1119z00_1220), BUNSPEC);
					return BgL_new1268z00_2463;
				}
			}
		}
	}



/* &lambda1793 */
	obj_t BGl_z62lambda1793z62zz__evaluate_typesz00(obj_t BgL_envz00_3435,
		obj_t BgL_oz00_3436, obj_t BgL_vz00_3437)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 89 */
			{	/* Eval/evaluate_types.scm 89 */
				BgL_ev_withzd2handlerzd2_bglt BgL_oz00_3747;
				BgL_ev_exprz00_bglt BgL_vz00_3748;

				BgL_oz00_3747 = ((BgL_ev_withzd2handlerzd2_bglt) BgL_oz00_3436);
				BgL_vz00_3748 = ((BgL_ev_exprz00_bglt) BgL_vz00_3437);
				return
					((((BgL_ev_withzd2handlerzd2_bglt) CREF(BgL_oz00_3747))->
						BgL_handlerz00) = ((BgL_ev_exprz00_bglt) BgL_vz00_3748), BUNSPEC);
			}
		}
	}



/* &lambda1792 */
	BgL_ev_exprz00_bglt BGl_z62lambda1792z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3438, obj_t BgL_oz00_3439)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 89 */
			return
				(((BgL_ev_withzd2handlerzd2_bglt) CREF(
						((BgL_ev_withzd2handlerzd2_bglt) BgL_oz00_3439)))->BgL_handlerz00);
		}
	}



/* &lambda1788 */
	obj_t BGl_z62lambda1788z62zz__evaluate_typesz00(obj_t BgL_envz00_3440,
		obj_t BgL_oz00_3441, obj_t BgL_vz00_3442)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 89 */
			{	/* Eval/evaluate_types.scm 89 */
				BgL_ev_withzd2handlerzd2_bglt BgL_oz00_3750;
				BgL_ev_exprz00_bglt BgL_vz00_3751;

				BgL_oz00_3750 = ((BgL_ev_withzd2handlerzd2_bglt) BgL_oz00_3441);
				BgL_vz00_3751 = ((BgL_ev_exprz00_bglt) BgL_vz00_3442);
				return
					((((BgL_ev_withzd2handlerzd2_bglt) CREF(BgL_oz00_3750))->
						BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_vz00_3751), BUNSPEC);
			}
		}
	}



/* &lambda1787 */
	BgL_ev_exprz00_bglt BGl_z62lambda1787z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3443, obj_t BgL_oz00_3444)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 89 */
			return
				(((BgL_ev_withzd2handlerzd2_bglt) CREF(
						((BgL_ev_withzd2handlerzd2_bglt) BgL_oz00_3444)))->BgL_bodyz00);
		}
	}



/* &<anonymous:1760> */
	BgL_ev_unwindzd2protectzd2_bglt
		BGl_z62zc3anonymousza31760ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3445,
		obj_t BgL_new1116z00_3446)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 86 */
			{
				BgL_ev_unwindzd2protectzd2_bglt BgL_new1116z00_1183;

				BgL_new1116z00_1183 =
					((BgL_ev_unwindzd2protectzd2_bglt) BgL_new1116z00_3446);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4706;

					{	/* Eval/evaluate_types.scm 86 */
						obj_t BgL_classz00_2449;

						BgL_classz00_2449 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2450;

							BgL__ortest_1376z00_2450 = BGL_CLASS_NIL(BgL_classz00_2449);
							if (CBOOL(BgL__ortest_1376z00_2450))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4706 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2450);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4706 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2449));
								}
						}
					}
					((((BgL_ev_unwindzd2protectzd2_bglt) CREF(BgL_new1116z00_1183))->
							BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4706), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4714;

					{	/* Eval/evaluate_types.scm 86 */
						obj_t BgL_classz00_2451;

						BgL_classz00_2451 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2452;

							BgL__ortest_1376z00_2452 = BGL_CLASS_NIL(BgL_classz00_2451);
							if (CBOOL(BgL__ortest_1376z00_2452))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4714 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2452);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4714 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2451));
								}
						}
					}
					((((BgL_ev_unwindzd2protectzd2_bglt) CREF(BgL_new1116z00_1183))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4714), BUNSPEC);
				}
				return BgL_new1116z00_1183;
			}
		}
	}



/* &lambda1758 */
	BgL_ev_unwindzd2protectzd2_bglt
		BGl_z62lambda1758z62zz__evaluate_typesz00(obj_t BgL_envz00_3447)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 86 */
			{

				{	/* Eval/evaluate_types.scm 86 */
					BgL_ev_unwindzd2protectzd2_bglt BgL_new1115z00_1181;

					BgL_new1115z00_1181 =
						((BgL_ev_unwindzd2protectzd2_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_unwindzd2protectzd2_bgl))));
					{	/* Eval/evaluate_types.scm 86 */
						long BgL_arg1759z00_1182;

						{	/* Eval/evaluate_types.scm 86 */
							long BgL_res2320z00_2446;

							BgL_res2320z00_2446 =
								BGL_CLASS_INDEX
								(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00);
							BgL_arg1759z00_1182 = BgL_res2320z00_2446;
						}
						{	/* Eval/evaluate_types.scm 86 */
							BgL_objectz00_bglt BgL_objz00_2447;

							BgL_objz00_2447 = ((BgL_objectz00_bglt) BgL_new1115z00_1181);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2447, BgL_arg1759z00_1182);
					}}
					{	/* Eval/evaluate_types.scm 86 */
						BgL_objectz00_bglt BgL_auxz00_4727;

						BgL_auxz00_4727 = ((BgL_objectz00_bglt) BgL_new1115z00_1181);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4727, BFALSE);
					}
					return BgL_new1115z00_1181;
				}
			}
		}
	}



/* &lambda1756 */
	BgL_ev_unwindzd2protectzd2_bglt
		BGl_z62lambda1756z62zz__evaluate_typesz00(obj_t BgL_envz00_3448,
		obj_t BgL_e1113z00_3449, obj_t BgL_body1114z00_3450)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 86 */
			{
				BgL_ev_exprz00_bglt BgL_e1113z00_1174;
				BgL_ev_exprz00_bglt BgL_body1114z00_1175;

				BgL_e1113z00_1174 = ((BgL_ev_exprz00_bglt) BgL_e1113z00_3449);
				BgL_body1114z00_1175 = ((BgL_ev_exprz00_bglt) BgL_body1114z00_3450);
				{	/* Eval/evaluate_types.scm 86 */
					BgL_ev_unwindzd2protectzd2_bglt BgL_new1262z00_2438;

					{	/* Eval/evaluate_types.scm 86 */
						BgL_ev_unwindzd2protectzd2_bglt BgL_new1261z00_2439;

						BgL_new1261z00_2439 =
							((BgL_ev_unwindzd2protectzd2_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_unwindzd2protectzd2_bgl))));
						{	/* Eval/evaluate_types.scm 86 */
							long BgL_arg1757z00_2440;

							{	/* Eval/evaluate_types.scm 86 */
								long BgL_res2319z00_2442;

								BgL_res2319z00_2442 =
									BGL_CLASS_INDEX
									(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00);
								BgL_arg1757z00_2440 = BgL_res2319z00_2442;
							}
							{	/* Eval/evaluate_types.scm 86 */
								BgL_objectz00_bglt BgL_objz00_2443;

								BgL_objz00_2443 = ((BgL_objectz00_bglt) BgL_new1261z00_2439);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2443, BgL_arg1757z00_2440);
						}}
						{	/* Eval/evaluate_types.scm 86 */
							BgL_objectz00_bglt BgL_auxz00_4734;

							BgL_auxz00_4734 = ((BgL_objectz00_bglt) BgL_new1261z00_2439);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4734, BFALSE);
						}
						BgL_new1262z00_2438 = BgL_new1261z00_2439;
					}
					((((BgL_ev_unwindzd2protectzd2_bglt) CREF(BgL_new1262z00_2438))->
							BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_e1113z00_1174), BUNSPEC);
					((((BgL_ev_unwindzd2protectzd2_bglt) CREF(BgL_new1262z00_2438))->
							BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_body1114z00_1175), BUNSPEC);
					return BgL_new1262z00_2438;
				}
			}
		}
	}



/* &lambda1773 */
	obj_t BGl_z62lambda1773z62zz__evaluate_typesz00(obj_t BgL_envz00_3451,
		obj_t BgL_oz00_3452, obj_t BgL_vz00_3453)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 86 */
			{	/* Eval/evaluate_types.scm 86 */
				BgL_ev_unwindzd2protectzd2_bglt BgL_oz00_3753;
				BgL_ev_exprz00_bglt BgL_vz00_3754;

				BgL_oz00_3753 = ((BgL_ev_unwindzd2protectzd2_bglt) BgL_oz00_3452);
				BgL_vz00_3754 = ((BgL_ev_exprz00_bglt) BgL_vz00_3453);
				return
					((((BgL_ev_unwindzd2protectzd2_bglt) CREF(BgL_oz00_3753))->BgL_ez00) =
					((BgL_ev_exprz00_bglt) BgL_vz00_3754), BUNSPEC);
			}
		}
	}



/* &lambda1772 */
	BgL_ev_exprz00_bglt BGl_z62lambda1772z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3454, obj_t BgL_oz00_3455)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 86 */
			return
				(((BgL_ev_unwindzd2protectzd2_bglt) CREF(
						((BgL_ev_unwindzd2protectzd2_bglt) BgL_oz00_3455)))->BgL_ez00);
		}
	}



/* &lambda1766 */
	obj_t BGl_z62lambda1766z62zz__evaluate_typesz00(obj_t BgL_envz00_3456,
		obj_t BgL_oz00_3457, obj_t BgL_vz00_3458)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 86 */
			{	/* Eval/evaluate_types.scm 86 */
				BgL_ev_unwindzd2protectzd2_bglt BgL_oz00_3756;
				BgL_ev_exprz00_bglt BgL_vz00_3757;

				BgL_oz00_3756 = ((BgL_ev_unwindzd2protectzd2_bglt) BgL_oz00_3457);
				BgL_vz00_3757 = ((BgL_ev_exprz00_bglt) BgL_vz00_3458);
				return
					((((BgL_ev_unwindzd2protectzd2_bglt) CREF(BgL_oz00_3756))->
						BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_vz00_3757), BUNSPEC);
			}
		}
	}



/* &lambda1765 */
	BgL_ev_exprz00_bglt BGl_z62lambda1765z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3459, obj_t BgL_oz00_3460)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 86 */
			return
				(((BgL_ev_unwindzd2protectzd2_bglt) CREF(
						((BgL_ev_unwindzd2protectzd2_bglt) BgL_oz00_3460)))->BgL_bodyz00);
		}
	}



/* &<anonymous:1740> */
	BgL_ev_bindzd2exitzd2_bglt
		BGl_z62zc3anonymousza31740ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3461,
		obj_t BgL_new1111z00_3462)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 83 */
			{
				BgL_ev_bindzd2exitzd2_bglt BgL_new1111z00_1138;

				BgL_new1111z00_1138 =
					((BgL_ev_bindzd2exitzd2_bglt) BgL_new1111z00_3462);
				{
					BgL_ev_varz00_bglt BgL_auxz00_4751;

					{	/* Eval/evaluate_types.scm 83 */
						obj_t BgL_classz00_2424;

						BgL_classz00_2424 = BGl_ev_varz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2425;

							BgL__ortest_1376z00_2425 = BGL_CLASS_NIL(BgL_classz00_2424);
							if (CBOOL(BgL__ortest_1376z00_2425))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4751 =
										((BgL_ev_varz00_bglt) BgL__ortest_1376z00_2425);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4751 =
										((BgL_ev_varz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2424));
								}
						}
					}
					((((BgL_ev_bindzd2exitzd2_bglt) CREF(BgL_new1111z00_1138))->
							BgL_varz00) = ((BgL_ev_varz00_bglt) BgL_auxz00_4751), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4759;

					{	/* Eval/evaluate_types.scm 83 */
						obj_t BgL_classz00_2426;

						BgL_classz00_2426 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2427;

							BgL__ortest_1376z00_2427 = BGL_CLASS_NIL(BgL_classz00_2426);
							if (CBOOL(BgL__ortest_1376z00_2427))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4759 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2427);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4759 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2426));
								}
						}
					}
					((((BgL_ev_bindzd2exitzd2_bglt) CREF(BgL_new1111z00_1138))->
							BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_4759), BUNSPEC);
				}
				return BgL_new1111z00_1138;
			}
		}
	}



/* &lambda1738 */
	BgL_ev_bindzd2exitzd2_bglt BGl_z62lambda1738z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3463)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 83 */
			{

				{	/* Eval/evaluate_types.scm 83 */
					BgL_ev_bindzd2exitzd2_bglt BgL_new1110z00_1136;

					BgL_new1110z00_1136 =
						((BgL_ev_bindzd2exitzd2_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_bindzd2exitzd2_bgl))));
					{	/* Eval/evaluate_types.scm 83 */
						long BgL_arg1739z00_1137;

						{	/* Eval/evaluate_types.scm 83 */
							long BgL_res2318z00_2421;

							BgL_res2318z00_2421 =
								BGL_CLASS_INDEX(BGl_ev_bindzd2exitzd2zz__evaluate_typesz00);
							BgL_arg1739z00_1137 = BgL_res2318z00_2421;
						}
						{	/* Eval/evaluate_types.scm 83 */
							BgL_objectz00_bglt BgL_objz00_2422;

							BgL_objz00_2422 = ((BgL_objectz00_bglt) BgL_new1110z00_1136);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2422, BgL_arg1739z00_1137);
					}}
					{	/* Eval/evaluate_types.scm 83 */
						BgL_objectz00_bglt BgL_auxz00_4772;

						BgL_auxz00_4772 = ((BgL_objectz00_bglt) BgL_new1110z00_1136);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4772, BFALSE);
					}
					return BgL_new1110z00_1136;
				}
			}
		}
	}



/* &lambda1736 */
	BgL_ev_bindzd2exitzd2_bglt BGl_z62lambda1736z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3464, obj_t BgL_var1108z00_3465, obj_t BgL_body1109z00_3466)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 83 */
			{
				BgL_ev_varz00_bglt BgL_var1108z00_1129;
				BgL_ev_exprz00_bglt BgL_body1109z00_1130;

				BgL_var1108z00_1129 = ((BgL_ev_varz00_bglt) BgL_var1108z00_3465);
				BgL_body1109z00_1130 = ((BgL_ev_exprz00_bglt) BgL_body1109z00_3466);
				{	/* Eval/evaluate_types.scm 83 */
					BgL_ev_bindzd2exitzd2_bglt BgL_new1256z00_2413;

					{	/* Eval/evaluate_types.scm 83 */
						BgL_ev_bindzd2exitzd2_bglt BgL_new1255z00_2414;

						BgL_new1255z00_2414 =
							((BgL_ev_bindzd2exitzd2_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_bindzd2exitzd2_bgl))));
						{	/* Eval/evaluate_types.scm 83 */
							long BgL_arg1737z00_2415;

							{	/* Eval/evaluate_types.scm 83 */
								long BgL_res2317z00_2417;

								BgL_res2317z00_2417 =
									BGL_CLASS_INDEX(BGl_ev_bindzd2exitzd2zz__evaluate_typesz00);
								BgL_arg1737z00_2415 = BgL_res2317z00_2417;
							}
							{	/* Eval/evaluate_types.scm 83 */
								BgL_objectz00_bglt BgL_objz00_2418;

								BgL_objz00_2418 = ((BgL_objectz00_bglt) BgL_new1255z00_2414);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2418, BgL_arg1737z00_2415);
						}}
						{	/* Eval/evaluate_types.scm 83 */
							BgL_objectz00_bglt BgL_auxz00_4779;

							BgL_auxz00_4779 = ((BgL_objectz00_bglt) BgL_new1255z00_2414);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4779, BFALSE);
						}
						BgL_new1256z00_2413 = BgL_new1255z00_2414;
					}
					((((BgL_ev_bindzd2exitzd2_bglt) CREF(BgL_new1256z00_2413))->
							BgL_varz00) =
						((BgL_ev_varz00_bglt) BgL_var1108z00_1129), BUNSPEC);
					((((BgL_ev_bindzd2exitzd2_bglt) CREF(BgL_new1256z00_2413))->
							BgL_bodyz00) =
						((BgL_ev_exprz00_bglt) BgL_body1109z00_1130), BUNSPEC);
					return BgL_new1256z00_2413;
				}
			}
		}
	}



/* &lambda1750 */
	obj_t BGl_z62lambda1750z62zz__evaluate_typesz00(obj_t BgL_envz00_3467,
		obj_t BgL_oz00_3468, obj_t BgL_vz00_3469)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 83 */
			{	/* Eval/evaluate_types.scm 83 */
				BgL_ev_bindzd2exitzd2_bglt BgL_oz00_3759;
				BgL_ev_varz00_bglt BgL_vz00_3760;

				BgL_oz00_3759 = ((BgL_ev_bindzd2exitzd2_bglt) BgL_oz00_3468);
				BgL_vz00_3760 = ((BgL_ev_varz00_bglt) BgL_vz00_3469);
				return
					((((BgL_ev_bindzd2exitzd2_bglt) CREF(BgL_oz00_3759))->BgL_varz00) =
					((BgL_ev_varz00_bglt) BgL_vz00_3760), BUNSPEC);
			}
		}
	}



/* &lambda1749 */
	BgL_ev_varz00_bglt BGl_z62lambda1749z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3470, obj_t BgL_oz00_3471)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 83 */
			return
				(((BgL_ev_bindzd2exitzd2_bglt) CREF(
						((BgL_ev_bindzd2exitzd2_bglt) BgL_oz00_3471)))->BgL_varz00);
		}
	}



/* &lambda1745 */
	obj_t BGl_z62lambda1745z62zz__evaluate_typesz00(obj_t BgL_envz00_3472,
		obj_t BgL_oz00_3473, obj_t BgL_vz00_3474)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 83 */
			{	/* Eval/evaluate_types.scm 83 */
				BgL_ev_bindzd2exitzd2_bglt BgL_oz00_3762;
				BgL_ev_exprz00_bglt BgL_vz00_3763;

				BgL_oz00_3762 = ((BgL_ev_bindzd2exitzd2_bglt) BgL_oz00_3473);
				BgL_vz00_3763 = ((BgL_ev_exprz00_bglt) BgL_vz00_3474);
				return
					((((BgL_ev_bindzd2exitzd2_bglt) CREF(BgL_oz00_3762))->BgL_bodyz00) =
					((BgL_ev_exprz00_bglt) BgL_vz00_3763), BUNSPEC);
			}
		}
	}



/* &lambda1744 */
	BgL_ev_exprz00_bglt BGl_z62lambda1744z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3475, obj_t BgL_oz00_3476)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 83 */
			return
				(((BgL_ev_bindzd2exitzd2_bglt) CREF(
						((BgL_ev_bindzd2exitzd2_bglt) BgL_oz00_3476)))->BgL_bodyz00);
		}
	}



/* &<anonymous:1729> */
	BgL_ev_defglobalz00_bglt
		BGl_z62zc3anonymousza31729ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3477,
		obj_t BgL_new1106z00_3478)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 82 */
			{
				BgL_ev_defglobalz00_bglt BgL_new1106z00_1117;

				BgL_new1106z00_1117 = ((BgL_ev_defglobalz00_bglt) BgL_new1106z00_3478);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4796;

					{	/* Eval/evaluate_types.scm 82 */
						obj_t BgL_classz00_2401;

						BgL_classz00_2401 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2402;

							BgL__ortest_1376z00_2402 = BGL_CLASS_NIL(BgL_classz00_2401);
							if (CBOOL(BgL__ortest_1376z00_2402))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4796 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2402);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4796 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2401));
								}
						}
					}
					((((BgL_ev_hookz00_bglt) CREF(
									((BgL_ev_hookz00_bglt) BgL_new1106z00_1117)))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_4796), BUNSPEC);
				}
				((((BgL_ev_setglobalz00_bglt) CREF(
								((BgL_ev_setglobalz00_bglt) BgL_new1106z00_1117)))->
						BgL_locz00) = ((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_setglobalz00_bglt) CREF(((BgL_ev_setglobalz00_bglt)
									BgL_new1106z00_1117)))->BgL_namez00) =
					((obj_t) BGl_symbol2704z00zz__evaluate_typesz00), BUNSPEC);
				((((BgL_ev_setglobalz00_bglt) CREF(((BgL_ev_setglobalz00_bglt)
									BgL_new1106z00_1117)))->BgL_modz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1106z00_1117;
			}
		}
	}



/* &lambda1727 */
	BgL_ev_defglobalz00_bglt BGl_z62lambda1727z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3479)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 82 */
			{

				{	/* Eval/evaluate_types.scm 82 */
					BgL_ev_defglobalz00_bglt BgL_new1105z00_1115;

					BgL_new1105z00_1115 =
						((BgL_ev_defglobalz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_defglobalz00_bgl))));
					{	/* Eval/evaluate_types.scm 82 */
						long BgL_arg1728z00_1116;

						{	/* Eval/evaluate_types.scm 82 */
							long BgL_res2316z00_2398;

							BgL_res2316z00_2398 =
								BGL_CLASS_INDEX(BGl_ev_defglobalz00zz__evaluate_typesz00);
							BgL_arg1728z00_1116 = BgL_res2316z00_2398;
						}
						{	/* Eval/evaluate_types.scm 82 */
							BgL_objectz00_bglt BgL_objz00_2399;

							BgL_objz00_2399 = ((BgL_objectz00_bglt) BgL_new1105z00_1115);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2399, BgL_arg1728z00_1116);
					}}
					{	/* Eval/evaluate_types.scm 82 */
						BgL_objectz00_bglt BgL_auxz00_4816;

						BgL_auxz00_4816 = ((BgL_objectz00_bglt) BgL_new1105z00_1115);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4816, BFALSE);
					}
					return BgL_new1105z00_1115;
				}
			}
		}
	}



/* &lambda1725 */
	BgL_ev_defglobalz00_bglt BGl_z62lambda1725z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3480, obj_t BgL_e1101z00_3481, obj_t BgL_loc1102z00_3482,
		obj_t BgL_name1103z00_3483, obj_t BgL_mod1104z00_3484)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 82 */
			{
				BgL_ev_exprz00_bglt BgL_e1101z00_1106;
				obj_t BgL_loc1102z00_1107;
				obj_t BgL_name1103z00_1108;
				obj_t BgL_mod1104z00_1109;

				BgL_e1101z00_1106 = ((BgL_ev_exprz00_bglt) BgL_e1101z00_3481);
				BgL_loc1102z00_1107 = BgL_loc1102z00_3482;
				BgL_name1103z00_1108 = BgL_name1103z00_3483;
				BgL_mod1104z00_1109 = BgL_mod1104z00_3484;
				{	/* Eval/evaluate_types.scm 82 */
					BgL_ev_defglobalz00_bglt BgL_new1254z00_2390;

					{	/* Eval/evaluate_types.scm 82 */
						BgL_ev_defglobalz00_bglt BgL_new1253z00_2391;

						BgL_new1253z00_2391 =
							((BgL_ev_defglobalz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_defglobalz00_bgl))));
						{	/* Eval/evaluate_types.scm 82 */
							long BgL_arg1726z00_2392;

							{	/* Eval/evaluate_types.scm 82 */
								long BgL_res2315z00_2394;

								BgL_res2315z00_2394 =
									BGL_CLASS_INDEX(BGl_ev_defglobalz00zz__evaluate_typesz00);
								BgL_arg1726z00_2392 = BgL_res2315z00_2394;
							}
							{	/* Eval/evaluate_types.scm 82 */
								BgL_objectz00_bglt BgL_objz00_2395;

								BgL_objz00_2395 = ((BgL_objectz00_bglt) BgL_new1253z00_2391);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2395, BgL_arg1726z00_2392);
						}}
						{	/* Eval/evaluate_types.scm 82 */
							BgL_objectz00_bglt BgL_auxz00_4823;

							BgL_auxz00_4823 = ((BgL_objectz00_bglt) BgL_new1253z00_2391);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4823, BFALSE);
						}
						BgL_new1254z00_2390 = BgL_new1253z00_2391;
					}
					((((BgL_ev_hookz00_bglt) CREF(
									((BgL_ev_hookz00_bglt) BgL_new1254z00_2390)))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_e1101z00_1106), BUNSPEC);
					((((BgL_ev_setglobalz00_bglt) CREF(((BgL_ev_setglobalz00_bglt)
										BgL_new1254z00_2390)))->BgL_locz00) =
						((obj_t) BgL_loc1102z00_1107), BUNSPEC);
					((((BgL_ev_setglobalz00_bglt) CREF(((BgL_ev_setglobalz00_bglt)
										BgL_new1254z00_2390)))->BgL_namez00) =
						((obj_t) BgL_name1103z00_1108), BUNSPEC);
					((((BgL_ev_setglobalz00_bglt) CREF(((BgL_ev_setglobalz00_bglt)
										BgL_new1254z00_2390)))->BgL_modz00) =
						((obj_t) BgL_mod1104z00_1109), BUNSPEC);
					return BgL_new1254z00_2390;
				}
			}
		}
	}



/* &<anonymous:1703> */
	BgL_ev_setglobalz00_bglt
		BGl_z62zc3anonymousza31703ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3485,
		obj_t BgL_new1099z00_3486)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 78 */
			{
				BgL_ev_setglobalz00_bglt BgL_new1099z00_1058;

				BgL_new1099z00_1058 = ((BgL_ev_setglobalz00_bglt) BgL_new1099z00_3486);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4835;

					{	/* Eval/evaluate_types.scm 78 */
						obj_t BgL_classz00_2388;

						BgL_classz00_2388 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2389;

							BgL__ortest_1376z00_2389 = BGL_CLASS_NIL(BgL_classz00_2388);
							if (CBOOL(BgL__ortest_1376z00_2389))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4835 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2389);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4835 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2388));
								}
						}
					}
					((((BgL_ev_hookz00_bglt) CREF(
									((BgL_ev_hookz00_bglt) BgL_new1099z00_1058)))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_4835), BUNSPEC);
				}
				((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1099z00_1058))->BgL_locz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1099z00_1058))->BgL_namez00) =
					((obj_t) BGl_symbol2704z00zz__evaluate_typesz00), BUNSPEC);
				((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1099z00_1058))->BgL_modz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1099z00_1058;
			}
		}
	}



/* &lambda1701 */
	BgL_ev_setglobalz00_bglt BGl_z62lambda1701z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3487)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 78 */
			{

				{	/* Eval/evaluate_types.scm 78 */
					BgL_ev_setglobalz00_bglt BgL_new1098z00_1056;

					BgL_new1098z00_1056 =
						((BgL_ev_setglobalz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_setglobalz00_bgl))));
					{	/* Eval/evaluate_types.scm 78 */
						long BgL_arg1702z00_1057;

						{	/* Eval/evaluate_types.scm 78 */
							long BgL_res2314z00_2385;

							BgL_res2314z00_2385 =
								BGL_CLASS_INDEX(BGl_ev_setglobalz00zz__evaluate_typesz00);
							BgL_arg1702z00_1057 = BgL_res2314z00_2385;
						}
						{	/* Eval/evaluate_types.scm 78 */
							BgL_objectz00_bglt BgL_objz00_2386;

							BgL_objz00_2386 = ((BgL_objectz00_bglt) BgL_new1098z00_1056);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2386, BgL_arg1702z00_1057);
					}}
					{	/* Eval/evaluate_types.scm 78 */
						BgL_objectz00_bglt BgL_auxz00_4852;

						BgL_auxz00_4852 = ((BgL_objectz00_bglt) BgL_new1098z00_1056);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4852, BFALSE);
					}
					return BgL_new1098z00_1056;
				}
			}
		}
	}



/* &lambda1699 */
	BgL_ev_setglobalz00_bglt BGl_z62lambda1699z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3488, obj_t BgL_e1094z00_3489, obj_t BgL_loc1095z00_3490,
		obj_t BgL_name1096z00_3491, obj_t BgL_mod1097z00_3492)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 78 */
			{
				BgL_ev_exprz00_bglt BgL_e1094z00_1047;
				obj_t BgL_loc1095z00_1048;
				obj_t BgL_name1096z00_1049;
				obj_t BgL_mod1097z00_1050;

				BgL_e1094z00_1047 = ((BgL_ev_exprz00_bglt) BgL_e1094z00_3489);
				BgL_loc1095z00_1048 = BgL_loc1095z00_3490;
				BgL_name1096z00_1049 = BgL_name1096z00_3491;
				BgL_mod1097z00_1050 = BgL_mod1097z00_3492;
				{	/* Eval/evaluate_types.scm 78 */
					BgL_ev_setglobalz00_bglt BgL_new1246z00_2377;

					{	/* Eval/evaluate_types.scm 78 */
						BgL_ev_setglobalz00_bglt BgL_new1245z00_2378;

						BgL_new1245z00_2378 =
							((BgL_ev_setglobalz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_setglobalz00_bgl))));
						{	/* Eval/evaluate_types.scm 78 */
							long BgL_arg1700z00_2379;

							{	/* Eval/evaluate_types.scm 78 */
								long BgL_res2313z00_2381;

								BgL_res2313z00_2381 =
									BGL_CLASS_INDEX(BGl_ev_setglobalz00zz__evaluate_typesz00);
								BgL_arg1700z00_2379 = BgL_res2313z00_2381;
							}
							{	/* Eval/evaluate_types.scm 78 */
								BgL_objectz00_bglt BgL_objz00_2382;

								BgL_objz00_2382 = ((BgL_objectz00_bglt) BgL_new1245z00_2378);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2382, BgL_arg1700z00_2379);
						}}
						{	/* Eval/evaluate_types.scm 78 */
							BgL_objectz00_bglt BgL_auxz00_4859;

							BgL_auxz00_4859 = ((BgL_objectz00_bglt) BgL_new1245z00_2378);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4859, BFALSE);
						}
						BgL_new1246z00_2377 = BgL_new1245z00_2378;
					}
					((((BgL_ev_hookz00_bglt) CREF(
									((BgL_ev_hookz00_bglt) BgL_new1246z00_2377)))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_e1094z00_1047), BUNSPEC);
					((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1246z00_2377))->
							BgL_locz00) = ((obj_t) BgL_loc1095z00_1048), BUNSPEC);
					((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1246z00_2377))->
							BgL_namez00) = ((obj_t) BgL_name1096z00_1049), BUNSPEC);
					((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1246z00_2377))->
							BgL_modz00) = ((obj_t) BgL_mod1097z00_1050), BUNSPEC);
					return BgL_new1246z00_2377;
				}
			}
		}
	}



/* &lambda1719 */
	obj_t BGl_z62lambda1719z62zz__evaluate_typesz00(obj_t BgL_envz00_3493,
		obj_t BgL_oz00_3494, obj_t BgL_vz00_3495)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 78 */
			{	/* Eval/evaluate_types.scm 78 */
				BgL_ev_setglobalz00_bglt BgL_oz00_3765;

				BgL_oz00_3765 = ((BgL_ev_setglobalz00_bglt) BgL_oz00_3494);
				return
					((((BgL_ev_setglobalz00_bglt) CREF(BgL_oz00_3765))->BgL_locz00) =
					((obj_t) BgL_vz00_3495), BUNSPEC);
			}
		}
	}



/* &lambda1718 */
	obj_t BGl_z62lambda1718z62zz__evaluate_typesz00(obj_t BgL_envz00_3496,
		obj_t BgL_oz00_3497)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 78 */
			return
				(((BgL_ev_setglobalz00_bglt) CREF(
						((BgL_ev_setglobalz00_bglt) BgL_oz00_3497)))->BgL_locz00);
		}
	}



/* &lambda1714 */
	obj_t BGl_z62lambda1714z62zz__evaluate_typesz00(obj_t BgL_envz00_3498,
		obj_t BgL_oz00_3499, obj_t BgL_vz00_3500)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 78 */
			{	/* Eval/evaluate_types.scm 78 */
				BgL_ev_setglobalz00_bglt BgL_oz00_3768;
				obj_t BgL_vz00_3769;

				BgL_oz00_3768 = ((BgL_ev_setglobalz00_bglt) BgL_oz00_3499);
				BgL_vz00_3769 = BgL_vz00_3500;
				return
					((((BgL_ev_setglobalz00_bglt) CREF(BgL_oz00_3768))->BgL_namez00) =
					((obj_t) BgL_vz00_3769), BUNSPEC);
			}
		}
	}



/* &lambda1713 */
	obj_t BGl_z62lambda1713z62zz__evaluate_typesz00(obj_t BgL_envz00_3501,
		obj_t BgL_oz00_3502)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 78 */
			return
				(((BgL_ev_setglobalz00_bglt) CREF(
						((BgL_ev_setglobalz00_bglt) BgL_oz00_3502)))->BgL_namez00);
		}
	}



/* &lambda1709 */
	obj_t BGl_z62lambda1709z62zz__evaluate_typesz00(obj_t BgL_envz00_3503,
		obj_t BgL_oz00_3504, obj_t BgL_vz00_3505)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 78 */
			{	/* Eval/evaluate_types.scm 78 */
				BgL_ev_setglobalz00_bglt BgL_oz00_3771;

				BgL_oz00_3771 = ((BgL_ev_setglobalz00_bglt) BgL_oz00_3504);
				return
					((((BgL_ev_setglobalz00_bglt) CREF(BgL_oz00_3771))->BgL_modz00) =
					((obj_t) BgL_vz00_3505), BUNSPEC);
			}
		}
	}



/* &lambda1708 */
	obj_t BGl_z62lambda1708z62zz__evaluate_typesz00(obj_t BgL_envz00_3506,
		obj_t BgL_oz00_3507)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 78 */
			return
				(((BgL_ev_setglobalz00_bglt) CREF(
						((BgL_ev_setglobalz00_bglt) BgL_oz00_3507)))->BgL_modz00);
		}
	}



/* &<anonymous:1688> */
	BgL_ev_setlocalz00_bglt
		BGl_z62zc3anonymousza31688ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3508,
		obj_t BgL_new1092z00_3509)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 76 */
			{
				BgL_ev_setlocalz00_bglt BgL_new1092z00_1023;

				BgL_new1092z00_1023 = ((BgL_ev_setlocalz00_bglt) BgL_new1092z00_3509);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4880;

					{	/* Eval/evaluate_types.scm 76 */
						obj_t BgL_classz00_2358;

						BgL_classz00_2358 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2359;

							BgL__ortest_1376z00_2359 = BGL_CLASS_NIL(BgL_classz00_2358);
							if (CBOOL(BgL__ortest_1376z00_2359))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4880 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2359);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4880 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2358));
								}
						}
					}
					((((BgL_ev_hookz00_bglt) CREF(
									((BgL_ev_hookz00_bglt) BgL_new1092z00_1023)))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_4880), BUNSPEC);
				}
				{
					BgL_ev_varz00_bglt BgL_auxz00_4889;

					{	/* Eval/evaluate_types.scm 76 */
						obj_t BgL_classz00_2360;

						BgL_classz00_2360 = BGl_ev_varz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2361;

							BgL__ortest_1376z00_2361 = BGL_CLASS_NIL(BgL_classz00_2360);
							if (CBOOL(BgL__ortest_1376z00_2361))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4889 =
										((BgL_ev_varz00_bglt) BgL__ortest_1376z00_2361);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4889 =
										((BgL_ev_varz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2360));
								}
						}
					}
					((((BgL_ev_setlocalz00_bglt) CREF(BgL_new1092z00_1023))->BgL_vz00) =
						((BgL_ev_varz00_bglt) BgL_auxz00_4889), BUNSPEC);
				}
				return BgL_new1092z00_1023;
			}
		}
	}



/* &lambda1686 */
	BgL_ev_setlocalz00_bglt BGl_z62lambda1686z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3510)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 76 */
			{

				{	/* Eval/evaluate_types.scm 76 */
					BgL_ev_setlocalz00_bglt BgL_new1091z00_1021;

					BgL_new1091z00_1021 =
						((BgL_ev_setlocalz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_setlocalz00_bgl))));
					{	/* Eval/evaluate_types.scm 76 */
						long BgL_arg1687z00_1022;

						{	/* Eval/evaluate_types.scm 76 */
							long BgL_res2312z00_2355;

							BgL_res2312z00_2355 =
								BGL_CLASS_INDEX(BGl_ev_setlocalz00zz__evaluate_typesz00);
							BgL_arg1687z00_1022 = BgL_res2312z00_2355;
						}
						{	/* Eval/evaluate_types.scm 76 */
							BgL_objectz00_bglt BgL_objz00_2356;

							BgL_objz00_2356 = ((BgL_objectz00_bglt) BgL_new1091z00_1021);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2356, BgL_arg1687z00_1022);
					}}
					{	/* Eval/evaluate_types.scm 76 */
						BgL_objectz00_bglt BgL_auxz00_4902;

						BgL_auxz00_4902 = ((BgL_objectz00_bglt) BgL_new1091z00_1021);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4902, BFALSE);
					}
					return BgL_new1091z00_1021;
				}
			}
		}
	}



/* &lambda1684 */
	BgL_ev_setlocalz00_bglt BGl_z62lambda1684z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3511, obj_t BgL_e1089z00_3512, obj_t BgL_v1090z00_3513)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 76 */
			{
				BgL_ev_exprz00_bglt BgL_e1089z00_1014;
				BgL_ev_varz00_bglt BgL_v1090z00_1015;

				BgL_e1089z00_1014 = ((BgL_ev_exprz00_bglt) BgL_e1089z00_3512);
				BgL_v1090z00_1015 = ((BgL_ev_varz00_bglt) BgL_v1090z00_3513);
				{	/* Eval/evaluate_types.scm 76 */
					BgL_ev_setlocalz00_bglt BgL_new1242z00_2347;

					{	/* Eval/evaluate_types.scm 76 */
						BgL_ev_setlocalz00_bglt BgL_new1241z00_2348;

						BgL_new1241z00_2348 =
							((BgL_ev_setlocalz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_setlocalz00_bgl))));
						{	/* Eval/evaluate_types.scm 76 */
							long BgL_arg1685z00_2349;

							{	/* Eval/evaluate_types.scm 76 */
								long BgL_res2311z00_2351;

								BgL_res2311z00_2351 =
									BGL_CLASS_INDEX(BGl_ev_setlocalz00zz__evaluate_typesz00);
								BgL_arg1685z00_2349 = BgL_res2311z00_2351;
							}
							{	/* Eval/evaluate_types.scm 76 */
								BgL_objectz00_bglt BgL_objz00_2352;

								BgL_objz00_2352 = ((BgL_objectz00_bglt) BgL_new1241z00_2348);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2352, BgL_arg1685z00_2349);
						}}
						{	/* Eval/evaluate_types.scm 76 */
							BgL_objectz00_bglt BgL_auxz00_4909;

							BgL_auxz00_4909 = ((BgL_objectz00_bglt) BgL_new1241z00_2348);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4909, BFALSE);
						}
						BgL_new1242z00_2347 = BgL_new1241z00_2348;
					}
					((((BgL_ev_hookz00_bglt) CREF(
									((BgL_ev_hookz00_bglt) BgL_new1242z00_2347)))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_e1089z00_1014), BUNSPEC);
					((((BgL_ev_setlocalz00_bglt) CREF(BgL_new1242z00_2347))->BgL_vz00) =
						((BgL_ev_varz00_bglt) BgL_v1090z00_1015), BUNSPEC);
					return BgL_new1242z00_2347;
				}
			}
		}
	}



/* &lambda1693 */
	obj_t BGl_z62lambda1693z62zz__evaluate_typesz00(obj_t BgL_envz00_3514,
		obj_t BgL_oz00_3515, obj_t BgL_vz00_3516)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 76 */
			{
				BgL_ev_setlocalz00_bglt BgL_oz00_1032;
				BgL_ev_varz00_bglt BgL_vz00_1033;

				BgL_oz00_1032 = ((BgL_ev_setlocalz00_bglt) BgL_oz00_3515);
				BgL_vz00_1033 = ((BgL_ev_varz00_bglt) BgL_vz00_3516);
				return
					((((BgL_ev_setlocalz00_bglt) CREF(BgL_oz00_1032))->BgL_vz00) =
					((BgL_ev_varz00_bglt) (((BgL_ev_setlocalz00_bglt)
								CREF(BgL_oz00_1032))->BgL_vz00)), BUNSPEC);
			}
		}
	}



/* &lambda1692 */
	BgL_ev_varz00_bglt BGl_z62lambda1692z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3517, obj_t BgL_oz00_3518)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 76 */
			return
				(((BgL_ev_setlocalz00_bglt) CREF(
						((BgL_ev_setlocalz00_bglt) BgL_oz00_3518)))->BgL_vz00);
		}
	}



/* &<anonymous:1678> */
	BgL_ev_trapz00_bglt
		BGl_z62zc3anonymousza31678ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3519,
		obj_t BgL_new1087z00_3520)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 75 */
			{
				BgL_ev_trapz00_bglt BgL_new1087z00_1002;

				BgL_new1087z00_1002 = ((BgL_ev_trapz00_bglt) BgL_new1087z00_3520);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4923;

					{	/* Eval/evaluate_types.scm 75 */
						obj_t BgL_classz00_2340;

						BgL_classz00_2340 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2341;

							BgL__ortest_1376z00_2341 = BGL_CLASS_NIL(BgL_classz00_2340);
							if (CBOOL(BgL__ortest_1376z00_2341))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4923 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2341);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4923 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2340));
								}
						}
					}
					((((BgL_ev_hookz00_bglt) CREF(
									((BgL_ev_hookz00_bglt) BgL_new1087z00_1002)))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_4923), BUNSPEC);
				}
				return BgL_new1087z00_1002;
			}
		}
	}



/* &lambda1676 */
	BgL_ev_trapz00_bglt BGl_z62lambda1676z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3521)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 75 */
			{

				{	/* Eval/evaluate_types.scm 75 */
					BgL_ev_trapz00_bglt BgL_new1086z00_1000;

					BgL_new1086z00_1000 =
						((BgL_ev_trapz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_trapz00_bgl))));
					{	/* Eval/evaluate_types.scm 75 */
						long BgL_arg1677z00_1001;

						{	/* Eval/evaluate_types.scm 75 */
							long BgL_res2310z00_2337;

							BgL_res2310z00_2337 =
								BGL_CLASS_INDEX(BGl_ev_trapz00zz__evaluate_typesz00);
							BgL_arg1677z00_1001 = BgL_res2310z00_2337;
						}
						{	/* Eval/evaluate_types.scm 75 */
							BgL_objectz00_bglt BgL_objz00_2338;

							BgL_objz00_2338 = ((BgL_objectz00_bglt) BgL_new1086z00_1000);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2338, BgL_arg1677z00_1001);
					}}
					{	/* Eval/evaluate_types.scm 75 */
						BgL_objectz00_bglt BgL_auxz00_4937;

						BgL_auxz00_4937 = ((BgL_objectz00_bglt) BgL_new1086z00_1000);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4937, BFALSE);
					}
					return BgL_new1086z00_1000;
				}
			}
		}
	}



/* &lambda1674 */
	BgL_ev_trapz00_bglt BGl_z62lambda1674z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3522, obj_t BgL_e1085z00_3523)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 75 */
			{
				BgL_ev_exprz00_bglt BgL_e1085z00_994;

				BgL_e1085z00_994 = ((BgL_ev_exprz00_bglt) BgL_e1085z00_3523);
				{	/* Eval/evaluate_types.scm 75 */
					BgL_ev_trapz00_bglt BgL_new1240z00_2329;

					{	/* Eval/evaluate_types.scm 75 */
						BgL_ev_trapz00_bglt BgL_new1239z00_2330;

						BgL_new1239z00_2330 =
							((BgL_ev_trapz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_trapz00_bgl))));
						{	/* Eval/evaluate_types.scm 75 */
							long BgL_arg1675z00_2331;

							{	/* Eval/evaluate_types.scm 75 */
								long BgL_res2309z00_2333;

								BgL_res2309z00_2333 =
									BGL_CLASS_INDEX(BGl_ev_trapz00zz__evaluate_typesz00);
								BgL_arg1675z00_2331 = BgL_res2309z00_2333;
							}
							{	/* Eval/evaluate_types.scm 75 */
								BgL_objectz00_bglt BgL_objz00_2334;

								BgL_objz00_2334 = ((BgL_objectz00_bglt) BgL_new1239z00_2330);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2334, BgL_arg1675z00_2331);
						}}
						{	/* Eval/evaluate_types.scm 75 */
							BgL_objectz00_bglt BgL_auxz00_4944;

							BgL_auxz00_4944 = ((BgL_objectz00_bglt) BgL_new1239z00_2330);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4944, BFALSE);
						}
						BgL_new1240z00_2329 = BgL_new1239z00_2330;
					}
					((((BgL_ev_hookz00_bglt) CREF(
									((BgL_ev_hookz00_bglt) BgL_new1240z00_2329)))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_e1085z00_994), BUNSPEC);
					return BgL_new1240z00_2329;
				}
			}
		}
	}



/* &<anonymous:1661> */
	BgL_ev_hookz00_bglt
		BGl_z62zc3anonymousza31661ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3524,
		obj_t BgL_new1083z00_3525)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 73 */
			{
				BgL_ev_hookz00_bglt BgL_new1083z00_970;

				BgL_new1083z00_970 = ((BgL_ev_hookz00_bglt) BgL_new1083z00_3525);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4950;

					{	/* Eval/evaluate_types.scm 73 */
						obj_t BgL_classz00_2327;

						BgL_classz00_2327 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2328;

							BgL__ortest_1376z00_2328 = BGL_CLASS_NIL(BgL_classz00_2327);
							if (CBOOL(BgL__ortest_1376z00_2328))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4950 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2328);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4950 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2327));
								}
						}
					}
					((((BgL_ev_hookz00_bglt) CREF(BgL_new1083z00_970))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_4950), BUNSPEC);
				}
				return BgL_new1083z00_970;
			}
		}
	}



/* &lambda1659 */
	BgL_ev_hookz00_bglt BGl_z62lambda1659z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3526)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 73 */
			{

				{	/* Eval/evaluate_types.scm 73 */
					BgL_ev_hookz00_bglt BgL_new1082z00_968;

					BgL_new1082z00_968 =
						((BgL_ev_hookz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_hookz00_bgl))));
					{	/* Eval/evaluate_types.scm 73 */
						long BgL_arg1660z00_969;

						{	/* Eval/evaluate_types.scm 73 */
							long BgL_res2308z00_2324;

							BgL_res2308z00_2324 =
								BGL_CLASS_INDEX(BGl_ev_hookz00zz__evaluate_typesz00);
							BgL_arg1660z00_969 = BgL_res2308z00_2324;
						}
						{	/* Eval/evaluate_types.scm 73 */
							BgL_objectz00_bglt BgL_objz00_2325;

							BgL_objz00_2325 = ((BgL_objectz00_bglt) BgL_new1082z00_968);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2325, BgL_arg1660z00_969);
					}}
					{	/* Eval/evaluate_types.scm 73 */
						BgL_objectz00_bglt BgL_auxz00_4963;

						BgL_auxz00_4963 = ((BgL_objectz00_bglt) BgL_new1082z00_968);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_4963, BFALSE);
					}
					return BgL_new1082z00_968;
				}
			}
		}
	}



/* &lambda1657 */
	BgL_ev_hookz00_bglt BGl_z62lambda1657z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3527, obj_t BgL_e1081z00_3528)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 73 */
			{
				BgL_ev_exprz00_bglt BgL_e1081z00_962;

				BgL_e1081z00_962 = ((BgL_ev_exprz00_bglt) BgL_e1081z00_3528);
				{	/* Eval/evaluate_types.scm 73 */
					BgL_ev_hookz00_bglt BgL_new1236z00_2316;

					{	/* Eval/evaluate_types.scm 73 */
						BgL_ev_hookz00_bglt BgL_new1235z00_2317;

						BgL_new1235z00_2317 =
							((BgL_ev_hookz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_hookz00_bgl))));
						{	/* Eval/evaluate_types.scm 73 */
							long BgL_arg1658z00_2318;

							{	/* Eval/evaluate_types.scm 73 */
								long BgL_res2307z00_2320;

								BgL_res2307z00_2320 =
									BGL_CLASS_INDEX(BGl_ev_hookz00zz__evaluate_typesz00);
								BgL_arg1658z00_2318 = BgL_res2307z00_2320;
							}
							{	/* Eval/evaluate_types.scm 73 */
								BgL_objectz00_bglt BgL_objz00_2321;

								BgL_objz00_2321 = ((BgL_objectz00_bglt) BgL_new1235z00_2317);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2321, BgL_arg1658z00_2318);
						}}
						{	/* Eval/evaluate_types.scm 73 */
							BgL_objectz00_bglt BgL_auxz00_4970;

							BgL_auxz00_4970 = ((BgL_objectz00_bglt) BgL_new1235z00_2317);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_4970, BFALSE);
						}
						BgL_new1236z00_2316 = BgL_new1235z00_2317;
					}
					((((BgL_ev_hookz00_bglt) CREF(BgL_new1236z00_2316))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_e1081z00_962), BUNSPEC);
					return BgL_new1236z00_2316;
				}
			}
		}
	}



/* &lambda1668 */
	obj_t BGl_z62lambda1668z62zz__evaluate_typesz00(obj_t BgL_envz00_3529,
		obj_t BgL_oz00_3530, obj_t BgL_vz00_3531)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 73 */
			{	/* Eval/evaluate_types.scm 73 */
				BgL_ev_hookz00_bglt BgL_oz00_3775;
				BgL_ev_exprz00_bglt BgL_vz00_3776;

				BgL_oz00_3775 = ((BgL_ev_hookz00_bglt) BgL_oz00_3530);
				BgL_vz00_3776 = ((BgL_ev_exprz00_bglt) BgL_vz00_3531);
				return
					((((BgL_ev_hookz00_bglt) CREF(BgL_oz00_3775))->BgL_ez00) =
					((BgL_ev_exprz00_bglt) BgL_vz00_3776), BUNSPEC);
			}
		}
	}



/* &lambda1667 */
	BgL_ev_exprz00_bglt BGl_z62lambda1667z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3532, obj_t BgL_oz00_3533)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 73 */
			return
				(((BgL_ev_hookz00_bglt) CREF(
						((BgL_ev_hookz00_bglt) BgL_oz00_3533)))->BgL_ez00);
		}
	}



/* &<anonymous:1640> */
	BgL_ev_prog2z00_bglt
		BGl_z62zc3anonymousza31640ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3534,
		obj_t BgL_new1079z00_3535)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 70 */
			{
				BgL_ev_prog2z00_bglt BgL_new1079z00_926;

				BgL_new1079z00_926 = ((BgL_ev_prog2z00_bglt) BgL_new1079z00_3535);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4980;

					{	/* Eval/evaluate_types.scm 70 */
						obj_t BgL_classz00_2307;

						BgL_classz00_2307 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2308;

							BgL__ortest_1376z00_2308 = BGL_CLASS_NIL(BgL_classz00_2307);
							if (CBOOL(BgL__ortest_1376z00_2308))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4980 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2308);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4980 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2307));
								}
						}
					}
					((((BgL_ev_prog2z00_bglt) CREF(BgL_new1079z00_926))->BgL_e1z00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_4980), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_4988;

					{	/* Eval/evaluate_types.scm 70 */
						obj_t BgL_classz00_2309;

						BgL_classz00_2309 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2310;

							BgL__ortest_1376z00_2310 = BGL_CLASS_NIL(BgL_classz00_2309);
							if (CBOOL(BgL__ortest_1376z00_2310))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4988 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2310);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_4988 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2309));
								}
						}
					}
					((((BgL_ev_prog2z00_bglt) CREF(BgL_new1079z00_926))->BgL_e2z00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_4988), BUNSPEC);
				}
				return BgL_new1079z00_926;
			}
		}
	}



/* &lambda1638 */
	BgL_ev_prog2z00_bglt BGl_z62lambda1638z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3536)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 70 */
			{

				{	/* Eval/evaluate_types.scm 70 */
					BgL_ev_prog2z00_bglt BgL_new1078z00_924;

					BgL_new1078z00_924 =
						((BgL_ev_prog2z00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_prog2z00_bgl))));
					{	/* Eval/evaluate_types.scm 70 */
						long BgL_arg1639z00_925;

						{	/* Eval/evaluate_types.scm 70 */
							long BgL_res2306z00_2304;

							BgL_res2306z00_2304 =
								BGL_CLASS_INDEX(BGl_ev_prog2z00zz__evaluate_typesz00);
							BgL_arg1639z00_925 = BgL_res2306z00_2304;
						}
						{	/* Eval/evaluate_types.scm 70 */
							BgL_objectz00_bglt BgL_objz00_2305;

							BgL_objz00_2305 = ((BgL_objectz00_bglt) BgL_new1078z00_924);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2305, BgL_arg1639z00_925);
					}}
					{	/* Eval/evaluate_types.scm 70 */
						BgL_objectz00_bglt BgL_auxz00_5001;

						BgL_auxz00_5001 = ((BgL_objectz00_bglt) BgL_new1078z00_924);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_5001, BFALSE);
					}
					return BgL_new1078z00_924;
				}
			}
		}
	}



/* &lambda1636 */
	BgL_ev_prog2z00_bglt BGl_z62lambda1636z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3537, obj_t BgL_e11076z00_3538, obj_t BgL_e21077z00_3539)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 70 */
			{
				BgL_ev_exprz00_bglt BgL_e11076z00_917;
				BgL_ev_exprz00_bglt BgL_e21077z00_918;

				BgL_e11076z00_917 = ((BgL_ev_exprz00_bglt) BgL_e11076z00_3538);
				BgL_e21077z00_918 = ((BgL_ev_exprz00_bglt) BgL_e21077z00_3539);
				{	/* Eval/evaluate_types.scm 70 */
					BgL_ev_prog2z00_bglt BgL_new1230z00_2296;

					{	/* Eval/evaluate_types.scm 70 */
						BgL_ev_prog2z00_bglt BgL_new1229z00_2297;

						BgL_new1229z00_2297 =
							((BgL_ev_prog2z00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_prog2z00_bgl))));
						{	/* Eval/evaluate_types.scm 70 */
							long BgL_arg1637z00_2298;

							{	/* Eval/evaluate_types.scm 70 */
								long BgL_res2305z00_2300;

								BgL_res2305z00_2300 =
									BGL_CLASS_INDEX(BGl_ev_prog2z00zz__evaluate_typesz00);
								BgL_arg1637z00_2298 = BgL_res2305z00_2300;
							}
							{	/* Eval/evaluate_types.scm 70 */
								BgL_objectz00_bglt BgL_objz00_2301;

								BgL_objz00_2301 = ((BgL_objectz00_bglt) BgL_new1229z00_2297);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2301, BgL_arg1637z00_2298);
						}}
						{	/* Eval/evaluate_types.scm 70 */
							BgL_objectz00_bglt BgL_auxz00_5008;

							BgL_auxz00_5008 = ((BgL_objectz00_bglt) BgL_new1229z00_2297);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5008, BFALSE);
						}
						BgL_new1230z00_2296 = BgL_new1229z00_2297;
					}
					((((BgL_ev_prog2z00_bglt) CREF(BgL_new1230z00_2296))->BgL_e1z00) =
						((BgL_ev_exprz00_bglt) BgL_e11076z00_917), BUNSPEC);
					((((BgL_ev_prog2z00_bglt) CREF(BgL_new1230z00_2296))->BgL_e2z00) =
						((BgL_ev_exprz00_bglt) BgL_e21077z00_918), BUNSPEC);
					return BgL_new1230z00_2296;
				}
			}
		}
	}



/* &lambda1651 */
	obj_t BGl_z62lambda1651z62zz__evaluate_typesz00(obj_t BgL_envz00_3540,
		obj_t BgL_oz00_3541, obj_t BgL_vz00_3542)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 70 */
			{	/* Eval/evaluate_types.scm 70 */
				BgL_ev_prog2z00_bglt BgL_oz00_3778;
				BgL_ev_exprz00_bglt BgL_vz00_3779;

				BgL_oz00_3778 = ((BgL_ev_prog2z00_bglt) BgL_oz00_3541);
				BgL_vz00_3779 = ((BgL_ev_exprz00_bglt) BgL_vz00_3542);
				return
					((((BgL_ev_prog2z00_bglt) CREF(BgL_oz00_3778))->BgL_e1z00) =
					((BgL_ev_exprz00_bglt) BgL_vz00_3779), BUNSPEC);
			}
		}
	}



/* &lambda1650 */
	BgL_ev_exprz00_bglt BGl_z62lambda1650z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3543, obj_t BgL_oz00_3544)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 70 */
			return
				(((BgL_ev_prog2z00_bglt) CREF(
						((BgL_ev_prog2z00_bglt) BgL_oz00_3544)))->BgL_e1z00);
		}
	}



/* &lambda1645 */
	obj_t BGl_z62lambda1645z62zz__evaluate_typesz00(obj_t BgL_envz00_3545,
		obj_t BgL_oz00_3546, obj_t BgL_vz00_3547)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 70 */
			{	/* Eval/evaluate_types.scm 70 */
				BgL_ev_prog2z00_bglt BgL_oz00_3781;
				BgL_ev_exprz00_bglt BgL_vz00_3782;

				BgL_oz00_3781 = ((BgL_ev_prog2z00_bglt) BgL_oz00_3546);
				BgL_vz00_3782 = ((BgL_ev_exprz00_bglt) BgL_vz00_3547);
				return
					((((BgL_ev_prog2z00_bglt) CREF(BgL_oz00_3781))->BgL_e2z00) =
					((BgL_ev_exprz00_bglt) BgL_vz00_3782), BUNSPEC);
			}
		}
	}



/* &lambda1644 */
	BgL_ev_exprz00_bglt BGl_z62lambda1644z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3548, obj_t BgL_oz00_3549)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 70 */
			return
				(((BgL_ev_prog2z00_bglt) CREF(
						((BgL_ev_prog2z00_bglt) BgL_oz00_3549)))->BgL_e2z00);
		}
	}



/* &<anonymous:1630> */
	BgL_ev_andz00_bglt BGl_z62zc3anonymousza31630ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3550, obj_t BgL_new1074z00_3551)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 69 */
			{
				BgL_ev_andz00_bglt BgL_new1074z00_905;

				BgL_new1074z00_905 = ((BgL_ev_andz00_bglt) BgL_new1074z00_3551);
				((((BgL_ev_listz00_bglt) CREF(
								((BgL_ev_listz00_bglt) BgL_new1074z00_905)))->BgL_argsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1074z00_905;
			}
		}
	}



/* &lambda1628 */
	BgL_ev_andz00_bglt BGl_z62lambda1628z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3552)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 69 */
			{

				{	/* Eval/evaluate_types.scm 69 */
					BgL_ev_andz00_bglt BgL_new1073z00_903;

					BgL_new1073z00_903 =
						((BgL_ev_andz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_andz00_bgl))));
					{	/* Eval/evaluate_types.scm 69 */
						long BgL_arg1629z00_904;

						{	/* Eval/evaluate_types.scm 69 */
							long BgL_res2304z00_2283;

							BgL_res2304z00_2283 =
								BGL_CLASS_INDEX(BGl_ev_andz00zz__evaluate_typesz00);
							BgL_arg1629z00_904 = BgL_res2304z00_2283;
						}
						{	/* Eval/evaluate_types.scm 69 */
							BgL_objectz00_bglt BgL_objz00_2284;

							BgL_objz00_2284 = ((BgL_objectz00_bglt) BgL_new1073z00_903);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2284, BgL_arg1629z00_904);
					}}
					{	/* Eval/evaluate_types.scm 69 */
						BgL_objectz00_bglt BgL_auxz00_5032;

						BgL_auxz00_5032 = ((BgL_objectz00_bglt) BgL_new1073z00_903);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_5032, BFALSE);
					}
					return BgL_new1073z00_903;
				}
			}
		}
	}



/* &lambda1626 */
	BgL_ev_andz00_bglt BGl_z62lambda1626z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3553, obj_t BgL_args1072z00_3554)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 69 */
			{
				obj_t BgL_args1072z00_897;

				BgL_args1072z00_897 = BgL_args1072z00_3554;
				{	/* Eval/evaluate_types.scm 69 */
					BgL_ev_andz00_bglt BgL_new1228z00_2275;

					{	/* Eval/evaluate_types.scm 69 */
						BgL_ev_andz00_bglt BgL_new1227z00_2276;

						BgL_new1227z00_2276 =
							((BgL_ev_andz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_andz00_bgl))));
						{	/* Eval/evaluate_types.scm 69 */
							long BgL_arg1627z00_2277;

							{	/* Eval/evaluate_types.scm 69 */
								long BgL_res2303z00_2279;

								BgL_res2303z00_2279 =
									BGL_CLASS_INDEX(BGl_ev_andz00zz__evaluate_typesz00);
								BgL_arg1627z00_2277 = BgL_res2303z00_2279;
							}
							{	/* Eval/evaluate_types.scm 69 */
								BgL_objectz00_bglt BgL_objz00_2280;

								BgL_objz00_2280 = ((BgL_objectz00_bglt) BgL_new1227z00_2276);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2280, BgL_arg1627z00_2277);
						}}
						{	/* Eval/evaluate_types.scm 69 */
							BgL_objectz00_bglt BgL_auxz00_5039;

							BgL_auxz00_5039 = ((BgL_objectz00_bglt) BgL_new1227z00_2276);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5039, BFALSE);
						}
						BgL_new1228z00_2275 = BgL_new1227z00_2276;
					}
					((((BgL_ev_listz00_bglt) CREF(
									((BgL_ev_listz00_bglt) BgL_new1228z00_2275)))->BgL_argsz00) =
						((obj_t) BgL_args1072z00_897), BUNSPEC);
					return BgL_new1228z00_2275;
				}
			}
		}
	}



/* &<anonymous:1620> */
	BgL_ev_orz00_bglt BGl_z62zc3anonymousza31620ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3555, obj_t BgL_new1070z00_3556)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 68 */
			{
				BgL_ev_orz00_bglt BgL_new1070z00_885;

				BgL_new1070z00_885 = ((BgL_ev_orz00_bglt) BgL_new1070z00_3556);
				((((BgL_ev_listz00_bglt) CREF(
								((BgL_ev_listz00_bglt) BgL_new1070z00_885)))->BgL_argsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1070z00_885;
			}
		}
	}



/* &lambda1618 */
	BgL_ev_orz00_bglt BGl_z62lambda1618z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3557)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 68 */
			{

				{	/* Eval/evaluate_types.scm 68 */
					BgL_ev_orz00_bglt BgL_new1069z00_883;

					BgL_new1069z00_883 =
						((BgL_ev_orz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_orz00_bgl))));
					{	/* Eval/evaluate_types.scm 68 */
						long BgL_arg1619z00_884;

						{	/* Eval/evaluate_types.scm 68 */
							long BgL_res2302z00_2272;

							BgL_res2302z00_2272 =
								BGL_CLASS_INDEX(BGl_ev_orz00zz__evaluate_typesz00);
							BgL_arg1619z00_884 = BgL_res2302z00_2272;
						}
						{	/* Eval/evaluate_types.scm 68 */
							BgL_objectz00_bglt BgL_objz00_2273;

							BgL_objz00_2273 = ((BgL_objectz00_bglt) BgL_new1069z00_883);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2273, BgL_arg1619z00_884);
					}}
					{	/* Eval/evaluate_types.scm 68 */
						BgL_objectz00_bglt BgL_auxz00_5051;

						BgL_auxz00_5051 = ((BgL_objectz00_bglt) BgL_new1069z00_883);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_5051, BFALSE);
					}
					return BgL_new1069z00_883;
				}
			}
		}
	}



/* &lambda1616 */
	BgL_ev_orz00_bglt BGl_z62lambda1616z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3558, obj_t BgL_args1068z00_3559)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 68 */
			{
				obj_t BgL_args1068z00_877;

				BgL_args1068z00_877 = BgL_args1068z00_3559;
				{	/* Eval/evaluate_types.scm 68 */
					BgL_ev_orz00_bglt BgL_new1226z00_2264;

					{	/* Eval/evaluate_types.scm 68 */
						BgL_ev_orz00_bglt BgL_new1225z00_2265;

						BgL_new1225z00_2265 =
							((BgL_ev_orz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_orz00_bgl))));
						{	/* Eval/evaluate_types.scm 68 */
							long BgL_arg1617z00_2266;

							{	/* Eval/evaluate_types.scm 68 */
								long BgL_res2301z00_2268;

								BgL_res2301z00_2268 =
									BGL_CLASS_INDEX(BGl_ev_orz00zz__evaluate_typesz00);
								BgL_arg1617z00_2266 = BgL_res2301z00_2268;
							}
							{	/* Eval/evaluate_types.scm 68 */
								BgL_objectz00_bglt BgL_objz00_2269;

								BgL_objz00_2269 = ((BgL_objectz00_bglt) BgL_new1225z00_2265);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2269, BgL_arg1617z00_2266);
						}}
						{	/* Eval/evaluate_types.scm 68 */
							BgL_objectz00_bglt BgL_auxz00_5058;

							BgL_auxz00_5058 = ((BgL_objectz00_bglt) BgL_new1225z00_2265);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5058, BFALSE);
						}
						BgL_new1226z00_2264 = BgL_new1225z00_2265;
					}
					((((BgL_ev_listz00_bglt) CREF(
									((BgL_ev_listz00_bglt) BgL_new1226z00_2264)))->BgL_argsz00) =
						((obj_t) BgL_args1068z00_877), BUNSPEC);
					return BgL_new1226z00_2264;
				}
			}
		}
	}



/* &<anonymous:1604> */
	BgL_ev_listz00_bglt
		BGl_z62zc3anonymousza31604ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3560,
		obj_t BgL_new1066z00_3561)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 66 */
			{
				BgL_ev_listz00_bglt BgL_new1066z00_853;

				BgL_new1066z00_853 = ((BgL_ev_listz00_bglt) BgL_new1066z00_3561);
				((((BgL_ev_listz00_bglt) CREF(BgL_new1066z00_853))->BgL_argsz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1066z00_853;
			}
		}
	}



/* &lambda1602 */
	BgL_ev_listz00_bglt BGl_z62lambda1602z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3562)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 66 */
			{

				{	/* Eval/evaluate_types.scm 66 */
					BgL_ev_listz00_bglt BgL_new1065z00_851;

					BgL_new1065z00_851 =
						((BgL_ev_listz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_listz00_bgl))));
					{	/* Eval/evaluate_types.scm 66 */
						long BgL_arg1603z00_852;

						{	/* Eval/evaluate_types.scm 66 */
							long BgL_res2300z00_2261;

							BgL_res2300z00_2261 =
								BGL_CLASS_INDEX(BGl_ev_listz00zz__evaluate_typesz00);
							BgL_arg1603z00_852 = BgL_res2300z00_2261;
						}
						{	/* Eval/evaluate_types.scm 66 */
							BgL_objectz00_bglt BgL_objz00_2262;

							BgL_objz00_2262 = ((BgL_objectz00_bglt) BgL_new1065z00_851);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2262, BgL_arg1603z00_852);
					}}
					{	/* Eval/evaluate_types.scm 66 */
						BgL_objectz00_bglt BgL_auxz00_5069;

						BgL_auxz00_5069 = ((BgL_objectz00_bglt) BgL_new1065z00_851);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_5069, BFALSE);
					}
					return BgL_new1065z00_851;
				}
			}
		}
	}



/* &lambda1600 */
	BgL_ev_listz00_bglt BGl_z62lambda1600z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3563, obj_t BgL_args1064z00_3564)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 66 */
			{
				obj_t BgL_args1064z00_845;

				BgL_args1064z00_845 = BgL_args1064z00_3564;
				{	/* Eval/evaluate_types.scm 66 */
					BgL_ev_listz00_bglt BgL_new1222z00_2253;

					{	/* Eval/evaluate_types.scm 66 */
						BgL_ev_listz00_bglt BgL_new1221z00_2254;

						BgL_new1221z00_2254 =
							((BgL_ev_listz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_listz00_bgl))));
						{	/* Eval/evaluate_types.scm 66 */
							long BgL_arg1601z00_2255;

							{	/* Eval/evaluate_types.scm 66 */
								long BgL_res2299z00_2257;

								BgL_res2299z00_2257 =
									BGL_CLASS_INDEX(BGl_ev_listz00zz__evaluate_typesz00);
								BgL_arg1601z00_2255 = BgL_res2299z00_2257;
							}
							{	/* Eval/evaluate_types.scm 66 */
								BgL_objectz00_bglt BgL_objz00_2258;

								BgL_objz00_2258 = ((BgL_objectz00_bglt) BgL_new1221z00_2254);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2258, BgL_arg1601z00_2255);
						}}
						{	/* Eval/evaluate_types.scm 66 */
							BgL_objectz00_bglt BgL_auxz00_5076;

							BgL_auxz00_5076 = ((BgL_objectz00_bglt) BgL_new1221z00_2254);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5076, BFALSE);
						}
						BgL_new1222z00_2253 = BgL_new1221z00_2254;
					}
					((((BgL_ev_listz00_bglt) CREF(BgL_new1222z00_2253))->BgL_argsz00) =
						((obj_t) BgL_args1064z00_845), BUNSPEC);
					return BgL_new1222z00_2253;
				}
			}
		}
	}



/* &lambda1610 */
	obj_t BGl_z62lambda1610z62zz__evaluate_typesz00(obj_t BgL_envz00_3565,
		obj_t BgL_oz00_3566, obj_t BgL_vz00_3567)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 66 */
			{	/* Eval/evaluate_types.scm 66 */
				BgL_ev_listz00_bglt BgL_oz00_3784;

				BgL_oz00_3784 = ((BgL_ev_listz00_bglt) BgL_oz00_3566);
				return
					((((BgL_ev_listz00_bglt) CREF(BgL_oz00_3784))->BgL_argsz00) =
					((obj_t) BgL_vz00_3567), BUNSPEC);
			}
		}
	}



/* &lambda1609 */
	obj_t BGl_z62lambda1609z62zz__evaluate_typesz00(obj_t BgL_envz00_3568,
		obj_t BgL_oz00_3569)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 66 */
			return
				(((BgL_ev_listz00_bglt) CREF(
						((BgL_ev_listz00_bglt) BgL_oz00_3569)))->BgL_argsz00);
		}
	}



/* &<anonymous:1578> */
	BgL_ev_ifz00_bglt BGl_z62zc3anonymousza31578ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3570, obj_t BgL_new1062z00_3571)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 62 */
			{
				BgL_ev_ifz00_bglt BgL_new1062z00_797;

				BgL_new1062z00_797 = ((BgL_ev_ifz00_bglt) BgL_new1062z00_3571);
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5084;

					{	/* Eval/evaluate_types.scm 62 */
						obj_t BgL_classz00_2242;

						BgL_classz00_2242 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2243;

							BgL__ortest_1376z00_2243 = BGL_CLASS_NIL(BgL_classz00_2242);
							if (CBOOL(BgL__ortest_1376z00_2243))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_5084 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2243);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_5084 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2242));
								}
						}
					}
					((((BgL_ev_ifz00_bglt) CREF(BgL_new1062z00_797))->BgL_pz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5084), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5092;

					{	/* Eval/evaluate_types.scm 62 */
						obj_t BgL_classz00_2244;

						BgL_classz00_2244 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2245;

							BgL__ortest_1376z00_2245 = BGL_CLASS_NIL(BgL_classz00_2244);
							if (CBOOL(BgL__ortest_1376z00_2245))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_5092 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2245);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_5092 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2244));
								}
						}
					}
					((((BgL_ev_ifz00_bglt) CREF(BgL_new1062z00_797))->BgL_tz00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5092), BUNSPEC);
				}
				{
					BgL_ev_exprz00_bglt BgL_auxz00_5100;

					{	/* Eval/evaluate_types.scm 62 */
						obj_t BgL_classz00_2246;

						BgL_classz00_2246 = BGl_ev_exprz00zz__evaluate_typesz00;
						{	/* Llib/object.scm 673 */
							obj_t BgL__ortest_1376z00_2247;

							BgL__ortest_1376z00_2247 = BGL_CLASS_NIL(BgL_classz00_2246);
							if (CBOOL(BgL__ortest_1376z00_2247))
								{	/* Llib/object.scm 673 */
									BgL_auxz00_5100 =
										((BgL_ev_exprz00_bglt) BgL__ortest_1376z00_2247);
								}
							else
								{	/* Llib/object.scm 673 */
									BgL_auxz00_5100 =
										((BgL_ev_exprz00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2246));
								}
						}
					}
					((((BgL_ev_ifz00_bglt) CREF(BgL_new1062z00_797))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_auxz00_5100), BUNSPEC);
				}
				return BgL_new1062z00_797;
			}
		}
	}



/* &lambda1576 */
	BgL_ev_ifz00_bglt BGl_z62lambda1576z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3572)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 62 */
			{

				{	/* Eval/evaluate_types.scm 62 */
					BgL_ev_ifz00_bglt BgL_new1061z00_795;

					BgL_new1061z00_795 =
						((BgL_ev_ifz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_ifz00_bgl))));
					{	/* Eval/evaluate_types.scm 62 */
						long BgL_arg1577z00_796;

						{	/* Eval/evaluate_types.scm 62 */
							long BgL_res2298z00_2239;

							BgL_res2298z00_2239 =
								BGL_CLASS_INDEX(BGl_ev_ifz00zz__evaluate_typesz00);
							BgL_arg1577z00_796 = BgL_res2298z00_2239;
						}
						{	/* Eval/evaluate_types.scm 62 */
							BgL_objectz00_bglt BgL_objz00_2240;

							BgL_objz00_2240 = ((BgL_objectz00_bglt) BgL_new1061z00_795);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2240, BgL_arg1577z00_796);
					}}
					{	/* Eval/evaluate_types.scm 62 */
						BgL_objectz00_bglt BgL_auxz00_5113;

						BgL_auxz00_5113 = ((BgL_objectz00_bglt) BgL_new1061z00_795);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_5113, BFALSE);
					}
					return BgL_new1061z00_795;
				}
			}
		}
	}



/* &lambda1574 */
	BgL_ev_ifz00_bglt BGl_z62lambda1574z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3573, obj_t BgL_p1058z00_3574, obj_t BgL_t1059z00_3575,
		obj_t BgL_e1060z00_3576)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 62 */
			{
				BgL_ev_exprz00_bglt BgL_p1058z00_787;
				BgL_ev_exprz00_bglt BgL_t1059z00_788;
				BgL_ev_exprz00_bglt BgL_e1060z00_789;

				BgL_p1058z00_787 = ((BgL_ev_exprz00_bglt) BgL_p1058z00_3574);
				BgL_t1059z00_788 = ((BgL_ev_exprz00_bglt) BgL_t1059z00_3575);
				BgL_e1060z00_789 = ((BgL_ev_exprz00_bglt) BgL_e1060z00_3576);
				{	/* Eval/evaluate_types.scm 62 */
					BgL_ev_ifz00_bglt BgL_new1214z00_2231;

					{	/* Eval/evaluate_types.scm 62 */
						BgL_ev_ifz00_bglt BgL_new1213z00_2232;

						BgL_new1213z00_2232 =
							((BgL_ev_ifz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_ifz00_bgl))));
						{	/* Eval/evaluate_types.scm 62 */
							long BgL_arg1575z00_2233;

							{	/* Eval/evaluate_types.scm 62 */
								long BgL_res2297z00_2235;

								BgL_res2297z00_2235 =
									BGL_CLASS_INDEX(BGl_ev_ifz00zz__evaluate_typesz00);
								BgL_arg1575z00_2233 = BgL_res2297z00_2235;
							}
							{	/* Eval/evaluate_types.scm 62 */
								BgL_objectz00_bglt BgL_objz00_2236;

								BgL_objz00_2236 = ((BgL_objectz00_bglt) BgL_new1213z00_2232);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2236, BgL_arg1575z00_2233);
						}}
						{	/* Eval/evaluate_types.scm 62 */
							BgL_objectz00_bglt BgL_auxz00_5120;

							BgL_auxz00_5120 = ((BgL_objectz00_bglt) BgL_new1213z00_2232);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5120, BFALSE);
						}
						BgL_new1214z00_2231 = BgL_new1213z00_2232;
					}
					((((BgL_ev_ifz00_bglt) CREF(BgL_new1214z00_2231))->BgL_pz00) =
						((BgL_ev_exprz00_bglt) BgL_p1058z00_787), BUNSPEC);
					((((BgL_ev_ifz00_bglt) CREF(BgL_new1214z00_2231))->BgL_tz00) =
						((BgL_ev_exprz00_bglt) BgL_t1059z00_788), BUNSPEC);
					((((BgL_ev_ifz00_bglt) CREF(BgL_new1214z00_2231))->BgL_ez00) =
						((BgL_ev_exprz00_bglt) BgL_e1060z00_789), BUNSPEC);
					return BgL_new1214z00_2231;
				}
			}
		}
	}



/* &lambda1594 */
	obj_t BGl_z62lambda1594z62zz__evaluate_typesz00(obj_t BgL_envz00_3577,
		obj_t BgL_oz00_3578, obj_t BgL_vz00_3579)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 62 */
			{	/* Eval/evaluate_types.scm 62 */
				BgL_ev_ifz00_bglt BgL_oz00_3787;
				BgL_ev_exprz00_bglt BgL_vz00_3788;

				BgL_oz00_3787 = ((BgL_ev_ifz00_bglt) BgL_oz00_3578);
				BgL_vz00_3788 = ((BgL_ev_exprz00_bglt) BgL_vz00_3579);
				return
					((((BgL_ev_ifz00_bglt) CREF(BgL_oz00_3787))->BgL_pz00) =
					((BgL_ev_exprz00_bglt) BgL_vz00_3788), BUNSPEC);
			}
		}
	}



/* &lambda1593 */
	BgL_ev_exprz00_bglt BGl_z62lambda1593z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3580, obj_t BgL_oz00_3581)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 62 */
			return
				(((BgL_ev_ifz00_bglt) CREF(
						((BgL_ev_ifz00_bglt) BgL_oz00_3581)))->BgL_pz00);
		}
	}



/* &lambda1588 */
	obj_t BGl_z62lambda1588z62zz__evaluate_typesz00(obj_t BgL_envz00_3582,
		obj_t BgL_oz00_3583, obj_t BgL_vz00_3584)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 62 */
			{	/* Eval/evaluate_types.scm 62 */
				BgL_ev_ifz00_bglt BgL_oz00_3790;
				BgL_ev_exprz00_bglt BgL_vz00_3791;

				BgL_oz00_3790 = ((BgL_ev_ifz00_bglt) BgL_oz00_3583);
				BgL_vz00_3791 = ((BgL_ev_exprz00_bglt) BgL_vz00_3584);
				return
					((((BgL_ev_ifz00_bglt) CREF(BgL_oz00_3790))->BgL_tz00) =
					((BgL_ev_exprz00_bglt) BgL_vz00_3791), BUNSPEC);
			}
		}
	}



/* &lambda1587 */
	BgL_ev_exprz00_bglt BGl_z62lambda1587z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3585, obj_t BgL_oz00_3586)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 62 */
			return
				(((BgL_ev_ifz00_bglt) CREF(
						((BgL_ev_ifz00_bglt) BgL_oz00_3586)))->BgL_tz00);
		}
	}



/* &lambda1583 */
	obj_t BGl_z62lambda1583z62zz__evaluate_typesz00(obj_t BgL_envz00_3587,
		obj_t BgL_oz00_3588, obj_t BgL_vz00_3589)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 62 */
			{	/* Eval/evaluate_types.scm 62 */
				BgL_ev_ifz00_bglt BgL_oz00_3793;
				BgL_ev_exprz00_bglt BgL_vz00_3794;

				BgL_oz00_3793 = ((BgL_ev_ifz00_bglt) BgL_oz00_3588);
				BgL_vz00_3794 = ((BgL_ev_exprz00_bglt) BgL_vz00_3589);
				return
					((((BgL_ev_ifz00_bglt) CREF(BgL_oz00_3793))->BgL_ez00) =
					((BgL_ev_exprz00_bglt) BgL_vz00_3794), BUNSPEC);
			}
		}
	}



/* &lambda1582 */
	BgL_ev_exprz00_bglt BGl_z62lambda1582z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3590, obj_t BgL_oz00_3591)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 62 */
			return
				(((BgL_ev_ifz00_bglt) CREF(
						((BgL_ev_ifz00_bglt) BgL_oz00_3591)))->BgL_ez00);
		}
	}



/* &<anonymous:1560> */
	BgL_ev_littz00_bglt
		BGl_z62zc3anonymousza31560ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3592,
		obj_t BgL_new1056z00_3593)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 60 */
			{
				BgL_ev_littz00_bglt BgL_new1056z00_763;

				BgL_new1056z00_763 = ((BgL_ev_littz00_bglt) BgL_new1056z00_3593);
				((((BgL_ev_littz00_bglt) CREF(BgL_new1056z00_763))->BgL_valuez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1056z00_763;
			}
		}
	}



/* &lambda1558 */
	BgL_ev_littz00_bglt BGl_z62lambda1558z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3594)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 60 */
			{

				{	/* Eval/evaluate_types.scm 60 */
					BgL_ev_littz00_bglt BgL_new1055z00_761;

					BgL_new1055z00_761 =
						((BgL_ev_littz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_littz00_bgl))));
					{	/* Eval/evaluate_types.scm 60 */
						long BgL_arg1559z00_762;

						{	/* Eval/evaluate_types.scm 60 */
							long BgL_res2296z00_2213;

							BgL_res2296z00_2213 =
								BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00);
							BgL_arg1559z00_762 = BgL_res2296z00_2213;
						}
						{	/* Eval/evaluate_types.scm 60 */
							BgL_objectz00_bglt BgL_objz00_2214;

							BgL_objz00_2214 = ((BgL_objectz00_bglt) BgL_new1055z00_761);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2214, BgL_arg1559z00_762);
					}}
					{	/* Eval/evaluate_types.scm 60 */
						BgL_objectz00_bglt BgL_auxz00_5150;

						BgL_auxz00_5150 = ((BgL_objectz00_bglt) BgL_new1055z00_761);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_5150, BFALSE);
					}
					return BgL_new1055z00_761;
				}
			}
		}
	}



/* &lambda1555 */
	BgL_ev_littz00_bglt BGl_z62lambda1555z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3595, obj_t BgL_value1054z00_3596)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 60 */
			{
				obj_t BgL_value1054z00_755;

				BgL_value1054z00_755 = BgL_value1054z00_3596;
				{	/* Eval/evaluate_types.scm 60 */
					BgL_ev_littz00_bglt BgL_new1210z00_2205;

					{	/* Eval/evaluate_types.scm 60 */
						BgL_ev_littz00_bglt BgL_new1209z00_2206;

						BgL_new1209z00_2206 =
							((BgL_ev_littz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_littz00_bgl))));
						{	/* Eval/evaluate_types.scm 60 */
							long BgL_arg1557z00_2207;

							{	/* Eval/evaluate_types.scm 60 */
								long BgL_res2295z00_2209;

								BgL_res2295z00_2209 =
									BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00);
								BgL_arg1557z00_2207 = BgL_res2295z00_2209;
							}
							{	/* Eval/evaluate_types.scm 60 */
								BgL_objectz00_bglt BgL_objz00_2210;

								BgL_objz00_2210 = ((BgL_objectz00_bglt) BgL_new1209z00_2206);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2210, BgL_arg1557z00_2207);
						}}
						{	/* Eval/evaluate_types.scm 60 */
							BgL_objectz00_bglt BgL_auxz00_5157;

							BgL_auxz00_5157 = ((BgL_objectz00_bglt) BgL_new1209z00_2206);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5157, BFALSE);
						}
						BgL_new1210z00_2205 = BgL_new1209z00_2206;
					}
					((((BgL_ev_littz00_bglt) CREF(BgL_new1210z00_2205))->BgL_valuez00) =
						((obj_t) BgL_value1054z00_755), BUNSPEC);
					return BgL_new1210z00_2205;
				}
			}
		}
	}



/* &lambda1567 */
	obj_t BGl_z62lambda1567z62zz__evaluate_typesz00(obj_t BgL_envz00_3597,
		obj_t BgL_oz00_3598, obj_t BgL_vz00_3599)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 60 */
			{	/* Eval/evaluate_types.scm 60 */
				BgL_ev_littz00_bglt BgL_oz00_3796;

				BgL_oz00_3796 = ((BgL_ev_littz00_bglt) BgL_oz00_3598);
				return
					((((BgL_ev_littz00_bglt) CREF(BgL_oz00_3796))->BgL_valuez00) =
					((obj_t) BgL_vz00_3599), BUNSPEC);
			}
		}
	}



/* &lambda1566 */
	obj_t BGl_z62lambda1566z62zz__evaluate_typesz00(obj_t BgL_envz00_3600,
		obj_t BgL_oz00_3601)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 60 */
			return
				(((BgL_ev_littz00_bglt) CREF(
						((BgL_ev_littz00_bglt) BgL_oz00_3601)))->BgL_valuez00);
		}
	}



/* &<anonymous:1526> */
	BgL_ev_globalz00_bglt
		BGl_z62zc3anonymousza31526ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3602,
		obj_t BgL_new1052z00_3603)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 55 */
			{
				BgL_ev_globalz00_bglt BgL_new1052z00_707;

				BgL_new1052z00_707 = ((BgL_ev_globalz00_bglt) BgL_new1052z00_3603);
				((((BgL_ev_globalz00_bglt) CREF(BgL_new1052z00_707))->BgL_locz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_globalz00_bglt) CREF(BgL_new1052z00_707))->BgL_namez00) =
					((obj_t) BGl_symbol2704z00zz__evaluate_typesz00), BUNSPEC);
				((((BgL_ev_globalz00_bglt) CREF(BgL_new1052z00_707))->BgL_modz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1052z00_707;
			}
		}
	}



/* &lambda1521 */
	BgL_ev_globalz00_bglt BGl_z62lambda1521z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3604)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 55 */
			{

				{	/* Eval/evaluate_types.scm 55 */
					BgL_ev_globalz00_bglt BgL_new1051z00_705;

					BgL_new1051z00_705 =
						((BgL_ev_globalz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_globalz00_bgl))));
					{	/* Eval/evaluate_types.scm 55 */
						long BgL_arg1525z00_706;

						{	/* Eval/evaluate_types.scm 55 */
							long BgL_res2294z00_2197;

							BgL_res2294z00_2197 =
								BGL_CLASS_INDEX(BGl_ev_globalz00zz__evaluate_typesz00);
							BgL_arg1525z00_706 = BgL_res2294z00_2197;
						}
						{	/* Eval/evaluate_types.scm 55 */
							BgL_objectz00_bglt BgL_objz00_2198;

							BgL_objz00_2198 = ((BgL_objectz00_bglt) BgL_new1051z00_705);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2198, BgL_arg1525z00_706);
					}}
					{	/* Eval/evaluate_types.scm 55 */
						BgL_objectz00_bglt BgL_auxz00_5173;

						BgL_auxz00_5173 = ((BgL_objectz00_bglt) BgL_new1051z00_705);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_5173, BFALSE);
					}
					return BgL_new1051z00_705;
				}
			}
		}
	}



/* &lambda1519 */
	BgL_ev_globalz00_bglt BGl_z62lambda1519z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3605, obj_t BgL_loc1048z00_3606, obj_t BgL_name1049z00_3607,
		obj_t BgL_mod1050z00_3608)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 55 */
			{
				obj_t BgL_loc1048z00_697;
				obj_t BgL_name1049z00_698;
				obj_t BgL_mod1050z00_699;

				BgL_loc1048z00_697 = BgL_loc1048z00_3606;
				BgL_name1049z00_698 = BgL_name1049z00_3607;
				BgL_mod1050z00_699 = BgL_mod1050z00_3608;
				{	/* Eval/evaluate_types.scm 55 */
					BgL_ev_globalz00_bglt BgL_new1202z00_2189;

					{	/* Eval/evaluate_types.scm 55 */
						BgL_ev_globalz00_bglt BgL_new1200z00_2190;

						BgL_new1200z00_2190 =
							((BgL_ev_globalz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_globalz00_bgl))));
						{	/* Eval/evaluate_types.scm 55 */
							long BgL_arg1520z00_2191;

							{	/* Eval/evaluate_types.scm 55 */
								long BgL_res2293z00_2193;

								BgL_res2293z00_2193 =
									BGL_CLASS_INDEX(BGl_ev_globalz00zz__evaluate_typesz00);
								BgL_arg1520z00_2191 = BgL_res2293z00_2193;
							}
							{	/* Eval/evaluate_types.scm 55 */
								BgL_objectz00_bglt BgL_objz00_2194;

								BgL_objz00_2194 = ((BgL_objectz00_bglt) BgL_new1200z00_2190);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2194, BgL_arg1520z00_2191);
						}}
						{	/* Eval/evaluate_types.scm 55 */
							BgL_objectz00_bglt BgL_auxz00_5180;

							BgL_auxz00_5180 = ((BgL_objectz00_bglt) BgL_new1200z00_2190);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5180, BFALSE);
						}
						BgL_new1202z00_2189 = BgL_new1200z00_2190;
					}
					((((BgL_ev_globalz00_bglt) CREF(BgL_new1202z00_2189))->BgL_locz00) =
						((obj_t) BgL_loc1048z00_697), BUNSPEC);
					((((BgL_ev_globalz00_bglt) CREF(BgL_new1202z00_2189))->BgL_namez00) =
						((obj_t) BgL_name1049z00_698), BUNSPEC);
					((((BgL_ev_globalz00_bglt) CREF(BgL_new1202z00_2189))->BgL_modz00) =
						((obj_t) BgL_mod1050z00_699), BUNSPEC);
					return BgL_new1202z00_2189;
				}
			}
		}
	}



/* &lambda1547 */
	obj_t BGl_z62lambda1547z62zz__evaluate_typesz00(obj_t BgL_envz00_3609,
		obj_t BgL_oz00_3610, obj_t BgL_vz00_3611)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 55 */
			{	/* Eval/evaluate_types.scm 55 */
				BgL_ev_globalz00_bglt BgL_oz00_3799;

				BgL_oz00_3799 = ((BgL_ev_globalz00_bglt) BgL_oz00_3610);
				return
					((((BgL_ev_globalz00_bglt) CREF(BgL_oz00_3799))->BgL_locz00) =
					((obj_t) BgL_vz00_3611), BUNSPEC);
			}
		}
	}



/* &lambda1546 */
	obj_t BGl_z62lambda1546z62zz__evaluate_typesz00(obj_t BgL_envz00_3612,
		obj_t BgL_oz00_3613)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 55 */
			return
				(((BgL_ev_globalz00_bglt) CREF(
						((BgL_ev_globalz00_bglt) BgL_oz00_3613)))->BgL_locz00);
		}
	}



/* &lambda1542 */
	obj_t BGl_z62lambda1542z62zz__evaluate_typesz00(obj_t BgL_envz00_3614,
		obj_t BgL_oz00_3615, obj_t BgL_vz00_3616)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 55 */
			{	/* Eval/evaluate_types.scm 55 */
				BgL_ev_globalz00_bglt BgL_oz00_3802;
				obj_t BgL_vz00_3803;

				BgL_oz00_3802 = ((BgL_ev_globalz00_bglt) BgL_oz00_3615);
				BgL_vz00_3803 = BgL_vz00_3616;
				return
					((((BgL_ev_globalz00_bglt) CREF(BgL_oz00_3802))->BgL_namez00) =
					((obj_t) BgL_vz00_3803), BUNSPEC);
			}
		}
	}



/* &lambda1541 */
	obj_t BGl_z62lambda1541z62zz__evaluate_typesz00(obj_t BgL_envz00_3617,
		obj_t BgL_oz00_3618)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 55 */
			return
				(((BgL_ev_globalz00_bglt) CREF(
						((BgL_ev_globalz00_bglt) BgL_oz00_3618)))->BgL_namez00);
		}
	}



/* &lambda1536 */
	obj_t BGl_z62lambda1536z62zz__evaluate_typesz00(obj_t BgL_envz00_3619,
		obj_t BgL_oz00_3620, obj_t BgL_vz00_3621)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 55 */
			{	/* Eval/evaluate_types.scm 55 */
				BgL_ev_globalz00_bglt BgL_oz00_3805;

				BgL_oz00_3805 = ((BgL_ev_globalz00_bglt) BgL_oz00_3620);
				return
					((((BgL_ev_globalz00_bglt) CREF(BgL_oz00_3805))->BgL_modz00) =
					((obj_t) BgL_vz00_3621), BUNSPEC);
			}
		}
	}



/* &lambda1535 */
	obj_t BGl_z62lambda1535z62zz__evaluate_typesz00(obj_t BgL_envz00_3622,
		obj_t BgL_oz00_3623)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 55 */
			return
				(((BgL_ev_globalz00_bglt) CREF(
						((BgL_ev_globalz00_bglt) BgL_oz00_3623)))->BgL_modz00);
		}
	}



/* &<anonymous:1494> */
	BgL_ev_varz00_bglt BGl_z62zc3anonymousza31494ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3624, obj_t BgL_new1046z00_3625)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 51 */
			{
				BgL_ev_varz00_bglt BgL_new1046z00_646;

				BgL_new1046z00_646 = ((BgL_ev_varz00_bglt) BgL_new1046z00_3625);
				((((BgL_ev_varz00_bglt) CREF(BgL_new1046z00_646))->BgL_namez00) =
					((obj_t) BGl_symbol2704z00zz__evaluate_typesz00), BUNSPEC);
				((((BgL_ev_varz00_bglt) CREF(BgL_new1046z00_646))->BgL_effz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_ev_varz00_bglt) CREF(BgL_new1046z00_646))->BgL_typez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				return BgL_new1046z00_646;
			}
		}
	}



/* &lambda1492 */
	BgL_ev_varz00_bglt BGl_z62lambda1492z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3626)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 51 */
			{

				{	/* Eval/evaluate_types.scm 51 */
					BgL_ev_varz00_bglt BgL_new1045z00_644;

					BgL_new1045z00_644 =
						((BgL_ev_varz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_varz00_bgl))));
					{	/* Eval/evaluate_types.scm 51 */
						long BgL_arg1493z00_645;

						{	/* Eval/evaluate_types.scm 51 */
							long BgL_res2292z00_2171;

							BgL_res2292z00_2171 =
								BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00);
							BgL_arg1493z00_645 = BgL_res2292z00_2171;
						}
						{	/* Eval/evaluate_types.scm 51 */
							BgL_objectz00_bglt BgL_objz00_2172;

							BgL_objz00_2172 = ((BgL_objectz00_bglt) BgL_new1045z00_644);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2172, BgL_arg1493z00_645);
					}}
					{	/* Eval/evaluate_types.scm 51 */
						BgL_objectz00_bglt BgL_auxz00_5206;

						BgL_auxz00_5206 = ((BgL_objectz00_bglt) BgL_new1045z00_644);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_5206, BFALSE);
					}
					return BgL_new1045z00_644;
				}
			}
		}
	}



/* &lambda1490 */
	BgL_ev_varz00_bglt BGl_z62lambda1490z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3627, obj_t BgL_name1042z00_3628, obj_t BgL_eff1043z00_3629,
		obj_t BgL_type1044z00_3630)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 51 */
			{
				obj_t BgL_name1042z00_636;
				obj_t BgL_eff1043z00_637;
				obj_t BgL_type1044z00_638;

				BgL_name1042z00_636 = BgL_name1042z00_3628;
				BgL_eff1043z00_637 = BgL_eff1043z00_3629;
				BgL_type1044z00_638 = BgL_type1044z00_3630;
				{	/* Eval/evaluate_types.scm 51 */
					BgL_ev_varz00_bglt BgL_new1193z00_2163;

					{	/* Eval/evaluate_types.scm 51 */
						BgL_ev_varz00_bglt BgL_new1192z00_2164;

						BgL_new1192z00_2164 =
							((BgL_ev_varz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_varz00_bgl))));
						{	/* Eval/evaluate_types.scm 51 */
							long BgL_arg1491z00_2165;

							{	/* Eval/evaluate_types.scm 51 */
								long BgL_res2291z00_2167;

								BgL_res2291z00_2167 =
									BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00);
								BgL_arg1491z00_2165 = BgL_res2291z00_2167;
							}
							{	/* Eval/evaluate_types.scm 51 */
								BgL_objectz00_bglt BgL_objz00_2168;

								BgL_objz00_2168 = ((BgL_objectz00_bglt) BgL_new1192z00_2164);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2168, BgL_arg1491z00_2165);
						}}
						{	/* Eval/evaluate_types.scm 51 */
							BgL_objectz00_bglt BgL_auxz00_5213;

							BgL_auxz00_5213 = ((BgL_objectz00_bglt) BgL_new1192z00_2164);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5213, BFALSE);
						}
						BgL_new1193z00_2163 = BgL_new1192z00_2164;
					}
					((((BgL_ev_varz00_bglt) CREF(BgL_new1193z00_2163))->BgL_namez00) =
						((obj_t) BgL_name1042z00_636), BUNSPEC);
					((((BgL_ev_varz00_bglt) CREF(BgL_new1193z00_2163))->BgL_effz00) =
						((obj_t) BgL_eff1043z00_637), BUNSPEC);
					((((BgL_ev_varz00_bglt) CREF(BgL_new1193z00_2163))->BgL_typez00) =
						((obj_t) BgL_type1044z00_638), BUNSPEC);
					return BgL_new1193z00_2163;
				}
			}
		}
	}



/* &lambda1512 */
	obj_t BGl_z62lambda1512z62zz__evaluate_typesz00(obj_t BgL_envz00_3631,
		obj_t BgL_oz00_3632, obj_t BgL_vz00_3633)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 51 */
			{	/* Eval/evaluate_types.scm 51 */
				BgL_ev_varz00_bglt BgL_oz00_3808;
				obj_t BgL_vz00_3809;

				BgL_oz00_3808 = ((BgL_ev_varz00_bglt) BgL_oz00_3632);
				BgL_vz00_3809 = BgL_vz00_3633;
				return
					((((BgL_ev_varz00_bglt) CREF(BgL_oz00_3808))->BgL_namez00) =
					((obj_t) BgL_vz00_3809), BUNSPEC);
			}
		}
	}



/* &lambda1511 */
	obj_t BGl_z62lambda1511z62zz__evaluate_typesz00(obj_t BgL_envz00_3634,
		obj_t BgL_oz00_3635)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 51 */
			return
				(((BgL_ev_varz00_bglt) CREF(
						((BgL_ev_varz00_bglt) BgL_oz00_3635)))->BgL_namez00);
		}
	}



/* &<anonymous:1507> */
	obj_t BGl_z62zc3anonymousza31507ze3ze1zz__evaluate_typesz00(obj_t
		BgL_envz00_3636)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 51 */
			return BBOOL(((bool_t) 0));
		}
	}



/* &lambda1506 */
	obj_t BGl_z62lambda1506z62zz__evaluate_typesz00(obj_t BgL_envz00_3637,
		obj_t BgL_oz00_3638, obj_t BgL_vz00_3639)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 51 */
			{	/* Eval/evaluate_types.scm 51 */
				BgL_ev_varz00_bglt BgL_oz00_3811;

				BgL_oz00_3811 = ((BgL_ev_varz00_bglt) BgL_oz00_3638);
				return
					((((BgL_ev_varz00_bglt) CREF(BgL_oz00_3811))->BgL_effz00) =
					((obj_t) BgL_vz00_3639), BUNSPEC);
			}
		}
	}



/* &lambda1505 */
	obj_t BGl_z62lambda1505z62zz__evaluate_typesz00(obj_t BgL_envz00_3640,
		obj_t BgL_oz00_3641)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 51 */
			return
				(((BgL_ev_varz00_bglt) CREF(
						((BgL_ev_varz00_bglt) BgL_oz00_3641)))->BgL_effz00);
		}
	}



/* &lambda1499 */
	obj_t BGl_z62lambda1499z62zz__evaluate_typesz00(obj_t BgL_envz00_3642,
		obj_t BgL_oz00_3643, obj_t BgL_vz00_3644)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 51 */
			{	/* Eval/evaluate_types.scm 51 */
				BgL_ev_varz00_bglt BgL_oz00_3814;

				BgL_oz00_3814 = ((BgL_ev_varz00_bglt) BgL_oz00_3643);
				return
					((((BgL_ev_varz00_bglt) CREF(BgL_oz00_3814))->BgL_typez00) =
					((obj_t) BgL_vz00_3644), BUNSPEC);
			}
		}
	}



/* &lambda1498 */
	obj_t BGl_z62lambda1498z62zz__evaluate_typesz00(obj_t BgL_envz00_3645,
		obj_t BgL_oz00_3646)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 51 */
			return
				(((BgL_ev_varz00_bglt) CREF(
						((BgL_ev_varz00_bglt) BgL_oz00_3646)))->BgL_typez00);
		}
	}



/* &<anonymous:1481> */
	BgL_ev_exprz00_bglt
		BGl_z62zc3anonymousza31481ze3ze1zz__evaluate_typesz00(obj_t BgL_envz00_3647,
		obj_t BgL_new1040z00_3648)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 49 */
			return ((BgL_ev_exprz00_bglt) BgL_new1040z00_3648);
		}
	}



/* &lambda1479 */
	BgL_ev_exprz00_bglt BGl_z62lambda1479z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3649)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 49 */
			{

				{	/* Eval/evaluate_types.scm 49 */
					BgL_ev_exprz00_bglt BgL_new1039z00_622;

					BgL_new1039z00_622 =
						((BgL_ev_exprz00_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_ev_exprz00_bgl))));
					{	/* Eval/evaluate_types.scm 49 */
						long BgL_arg1480z00_623;

						{	/* Eval/evaluate_types.scm 49 */
							long BgL_res2290z00_2145;

							BgL_res2290z00_2145 =
								BGL_CLASS_INDEX(BGl_ev_exprz00zz__evaluate_typesz00);
							BgL_arg1480z00_623 = BgL_res2290z00_2145;
						}
						{	/* Eval/evaluate_types.scm 49 */
							BgL_objectz00_bglt BgL_objz00_2146;

							BgL_objz00_2146 = ((BgL_objectz00_bglt) BgL_new1039z00_622);
							BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2146, BgL_arg1480z00_623);
					}}
					{	/* Eval/evaluate_types.scm 49 */
						BgL_objectz00_bglt BgL_auxz00_5237;

						BgL_auxz00_5237 = ((BgL_objectz00_bglt) BgL_new1039z00_622);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_5237, BFALSE);
					}
					return BgL_new1039z00_622;
				}
			}
		}
	}



/* &lambda1477 */
	BgL_ev_exprz00_bglt BGl_z62lambda1477z62zz__evaluate_typesz00(obj_t
		BgL_envz00_3650)
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 49 */
			{

				{	/* Eval/evaluate_types.scm 49 */
					BgL_ev_exprz00_bglt BgL_new1191z00_618;

					{	/* Eval/evaluate_types.scm 49 */
						BgL_ev_exprz00_bglt BgL_new1190z00_619;

						BgL_new1190z00_619 =
							((BgL_ev_exprz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_exprz00_bgl))));
						{	/* Eval/evaluate_types.scm 49 */
							long BgL_arg1478z00_620;

							{	/* Eval/evaluate_types.scm 49 */
								long BgL_res2289z00_2141;

								BgL_res2289z00_2141 =
									BGL_CLASS_INDEX(BGl_ev_exprz00zz__evaluate_typesz00);
								BgL_arg1478z00_620 = BgL_res2289z00_2141;
							}
							{	/* Eval/evaluate_types.scm 49 */
								BgL_objectz00_bglt BgL_objz00_2142;

								BgL_objz00_2142 = ((BgL_objectz00_bglt) BgL_new1190z00_619);
								BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2142, BgL_arg1478z00_620);
						}}
						{	/* Eval/evaluate_types.scm 49 */
							BgL_objectz00_bglt BgL_auxz00_5244;

							BgL_auxz00_5244 = ((BgL_objectz00_bglt) BgL_new1190z00_619);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5244, BFALSE);
						}
						BgL_new1191z00_618 = BgL_new1190z00_619;
					}
					return BgL_new1191z00_618;
				}
			}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zz__evaluate_typesz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 15 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zz__evaluate_typesz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 15 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_typesz00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate_types.scm 15 */
			BGl_modulezd2initializa7ationz75zz__typez00(((long) 77607588),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 373318193),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 162724851),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__tvectorz00(((long) 135276775),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 128218210),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 258585428),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__bignumz00(((long) 6519932),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 438451175),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 443936801),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 317260169),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 441709255),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 1041382),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__threadz00(((long) 316564000),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 359798486),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)
					249410258),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)
					247617611),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)
					268155843),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)
					198620800),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)
					473309430),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 459519430),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 460263214),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 97251556),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)
					47127928), BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)
					317842797),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)
					228151370),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 509771705),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 162479995),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
			return BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)
					116655667),
				BSTRING_TO_STRING(BGl_string2383z00zz__evaluate_typesz00));
		}
	}

#ifdef __cplusplus
}
#endif
